local This = {}
local AABB = require("ffi").metaclass("AABB", This)
cc.AABB = AABB

function This:createByCenter(center, halfWidth, halfHeight)
    return AABB(center.x - halfWidth, center.y - halfHeight, center.x + halfWidth, center.y + halfHeight)
end

function This.__tostring(aabb)
    return string.format("aabb:(%g, %g), (%g, %g)", aabb.minX, aabb.minY, aabb.maxX, aabb.maxY)
end

function This:isContainsPoint(point)
    if point.x >= self.minX and point.x <= self.maxX and point.y >= self.minY and point.y <= self.maxY then
        return true
    end
    return false
end

function This:isContainsXY(x, y)
    if x >= self.minX and x <= self.maxX and y >= self.minY and y <= self.maxY then
        return true
    end
    return false
end

function This:isIntersectAABB(aabb)
    if self.minX <= aabb.maxX and self.minY <= aabb.maxY and aabb.minX <= self.maxX and aabb.minY <= self.maxY then
        return true
    end
    return false
end

function This:isIntersect(minX, minY, maxX, maxY)
    if self.minX <= maxX and self.minY <= maxY and minX <= self.maxX and minY <= self.maxY then
        return true
    end
    return false
end