--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"Base.BaseModel")
local MapMissionConfig = require("Metadatas.MapMissionConfig")
local GuideManager = require("Guide.GuideManager")
local ViewUtil = require("UI.ViewUtil")

function This:init(info)
	self.m_id = info.id
	self.m_config = MapMissionConfig[self.m_id]
	self.m_progress = info.num or 0
	self.m_state = info.state or 0
	self.m_type = info.type or 0
end

function This:getId()
	return self.m_id
end

function This:getType()
	return self.m_type
end

function This:getName()
	return self.m_config.name
end

function This:getDesc()
	return self.m_config.des
end

function This:getMaxProgress()
	return self.m_config.progress
end

function This:getProgress()
	return math.min(self.m_progress,self.m_config.progress)
end

function This:getGongXun()
	return self.m_config.gongxun
end

function This:setView(view)
	self.m_view = view
end

function This:getConfig()
	return self.m_config
end

function This:setProgress(progress)
	self.m_progress = progress
	if self.m_view then
		self.m_view:refresh()
	end
end

function This:getState()
	return self.m_state
end

function This:setState(state)
	self.m_state = state
	if self.m_view then
		self.m_view:refresh()
	end
end

function This:updateInfo(info)
	self.m_type = info.type
	self.m_progress = info.num
	self.m_state = info.state
	if self.m_view then
		self.m_view:refresh()
	end
end

function This:getRewardList()
	local itemList = {}
	for i , info in ipairs(self.m_config.reward) do
		table.insert(itemList,{id = info[1], num = info[2]})
	end
	-- table.insert(itemList,{id = 106, num = self.m_config.jifen})
	table.insert(itemList,{id = 120, num = self.m_config.gongxun})
	return itemList
end

function This:triggerAncGuider()
	if self.m_config.guide_data and self.m_config.guide_data ~= "" then
		GuideManager:triggerAncGuider(self.m_config.guide_data)
	elseif self.m_config.panel then
		local panel = self.m_config.panel
		ViewUtil:jumpToPanel(panel.name,panel.arg)
	end
end

--endregion
