--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"Dialog")
local MapMissionBoxConfig = require("Metadatas.MapMissionBoxConfig")
local AchieveManager = require("Achieve.AchieveManager")
local ItemNode = require("UI.ItemNode")

function This:initNode(info)
	self.m_index = info.index
	local csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/TaskBattlefieldBox.csb")
	self.m_csNode = csNode
	self:addChild(csNode)
	csNode:setToCenter()
	config = MapMissionBoxConfig[self.m_index]
	csNode.title:setString(self.m_config.name)
	local gongxun  = AchieveManager:getGongXun()
	local hasRecieve = AchieveManager:isBoxReward(self.m_index)
	csNode.condition:setVisible(gongxun < self.m_config.gongxun)
	csNode.yilingqu:setVisible(hasRecieve)
	csNode.lingqu:setVisible(gongxun >= self.m_config.gongxun and not hasRecieve)
	csNode.condition:setString(string.format(Serialize[60083],self.m_config.gongxun))

	local rewardList = self.m_config.reward
	local count = #rewardList
	local scrollView = csNode.scrollView
	local itemtipslist = csNode.itemtipslist
	if count <= 4 then
		local w = 5
		for i , info in ipairs(rewardList) do
			local node = ItemNode:create(info[1],info[2])
			node:setAnchorPoint(0,0)
			node:setPositionX(w)
			w = w + node:getContentWidth() + 10
			itemtipslist:addChild(node)
		end
		itemtipslist:setPositionX(- w / 2)
		itemtipslist:setVisible(true)
		scrollView:setVisible(false)
	else
		scrollView:removeAllChildren()
		scrollView.m_direction = "right"
		for i , info in ipairs(rewardList) do
			local item = ItemNode:create(info[1], info[2])
			item:setAnchorPoint(0.5,0.5)
			local w , h = item:getContentSize()
			scrollView:pushBackCustomItem(item, w, h ,0.5)
		end
		itemtipslist:setVisible(false)
		scrollView:setVisible(true)
	end
end

function This:initTouchEvent()
	self.m_csNode.close:setTouchEnded(function()
		self:close()
	end)
	self.m_csNode.lingqu:setTouchEnded(function()
		AchieveManager:onGetBoxRewardRequest(self.m_index)
	end)
end

function This:onEnter()
	super.onEnter(self)
	AchieveManager:addObserver(self)
end

function This:onExit()
	super.onExit(self)
	AchieveManager:removeObserver(self)
end

function This:onAchieveBoxReward(index)
	if self.m_index == index then
		self:close()
	end
end


--endregion
