--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"Dialog")
local DailyAchieveManager = require("Achieve.DailyAchieveManager")
local AchieveManager = require("Achieve.AchieveManager")
local MatchManager = require("Match.MatchManager")

local GamePlayer = require("Player.GamePlayer")
local TabName = 
{
	kDaily = "daily",
    kMain = "main",
	kWeekly = "weekly",
	kGongXun = "gongxun",
	kCrusade = "crusade",
	kBox = "box",
}

function This:initNode(info)
	self.m_csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/TaskUI.csb")
	self:addChild(self.m_csNode)
	self.m_csNode:setToCenter()

	self:addTabButton(TabName.kDaily, self.m_csNode.daily, function()
        self:openTabNode("Achieve.DailyTabNode")
    end)

    self:addTabButton(TabName.kWeekly, self.m_csNode.weekly, function()
        self:openTabNode("Achieve.WeeklyTabNode")
    end)
	self:addTabButton(TabName.kBox,self.m_csNode.box,function ()
		local crusadeData = DailyAchieveManager:getCrusadeData()
		local levelLimit = crusadeData:getCrusadeConfigNum(AchieveCrusadeLimitType.kBoxOpenLevel)
		if levelLimit>GamePlayer:getLevel() then
			g_scene:showTips(string.format(Serialize["achieve_MainPanel_1_c"],levelLimit))
			return false
		end
		MatchManager:onGetBoxInfoRequest()
		-- AchieveManager:onGetAchieveInfoRequest(AchieveType.kZhengJi)
		self:openTabNode("Achieve.TaskContendBoxPanel")
	end)
	local box = self.m_csNode.box
	local crusadeData = DailyAchieveManager:getCrusadeData()
	local levelLimit = crusadeData:getCrusadeConfigNum(AchieveCrusadeLimitType.kBoxOpenLevel)
	box.suo:setVisible(levelLimit>GamePlayer:getLevel())

    local crusade = self.m_csNode.crusade
	self:addTabButton(TabName.kCrusade, crusade, function()
		local crusadeData = DailyAchieveManager:getCrusadeData()
		local levelLimit = crusadeData:getCrusadeConfigNum(AchieveCrusadeLimitType.kOpenLevel)
		if levelLimit>GamePlayer:getLevel() then
			g_scene:showTips(string.format(Serialize["achieve_MainPanel_1_c"],levelLimit))
			return false
		end
        self:openTabNode("Achieve.CrusadeTabNode")
    end)
    crusade:setVisible(true)
    local crusadeData = DailyAchieveManager:getCrusadeData()
	local levelLimit = crusadeData:getCrusadeConfigNum(AchieveCrusadeLimitType.kOpenLevel)
    crusade.suo:setVisible(levelLimit>GamePlayer:getLevel() )--开启等级


	local tab = TabName.kWeekly
	if info and info.tab then
		tab = info.tab
	end
	self:selectTabButton(tab)
end

function This:initTouchEvent()
	self.m_csNode.close:setTouchEnded(function()
		self:close()
	end)
end

function This:onEnter()
	super.onEnter(self)
	DailyAchieveManager:addObserver(self)
end

function This:onExit()
	super.onExit(self)
	DailyAchieveManager:removeObserver(self)
end



--endregion
