--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"Base.BaseModel")
local MapAchieve = require("Achieve.MapAchieve")
local MainAchieve = require("Achieve.MainAchieve")
local TianXiaAchieve = require("Achieve.TianXiaAchieve")
local GamePlayer = require("Player.GamePlayer")
local EventDispatcher = require("EventDispatcher")
local MapMissionBoxConfig = require("Metadatas.MapMissionBoxConfig")
local RoleMissionConfig = require("Metadatas.RoleMissionConfig")
local MeritoriousMissionConfig = require("Metadatas.MeritoriousMissionConfig")
local BoxMissionConfig = require("Metadatas.BoxMissionConfig")
local WeekGiftConfig = require("Metadatas.WeekGiftConfig")
local MonthGiftConfig = require("Metadatas.MonthGiftConfig")

local Application = require("cc.Application")
local Socket = require("Net.Socket")
local MainChapterConfig = require("Metadatas.MainChapterConfig")
local RoleLevelConfig = require("Metadatas.RoleLevelConfig")
local GongXunAchieve = require("Achieve.GongXunAchieve")
local GameUtil = require("Util.GameUtil")
local ActivityUtil = require("Activity.ActivityUtil")
local MeritoriousMissionBoxConfig = require("Metadatas.MeritoriousMissionBoxConfig")
local PopDialogManager = require("UI.PopDialogManager")
local LegionWarPrestigeMissionConfig = require("Metadatas.LegionWarPrestigeMissionConfig")
local WeiWangAchieve = require("Achieve.WeiWangAchieve")
local JunTuanAchieve = require("Achieve.JunTuanAchieve")
local ZhengJiAchieve = require("Achieve.ZhengJiAchieve")
local GiftDayAchieve = require("Achieve.GiftDayAchieve")
local GiftWeekAchieve = require("Achieve.GiftWeekAchieve")
local GiftMonthAchieve = require("Achieve.GiftMonthAchieve")
local LimitedTimePreferentialAchieve = require("Achieve.LimitedTimePreferentialAchieve")
local LegionWarLegionMissionConfig = require("Metadatas.LegionWarLegionMissionConfig")
local GameMapManager = require("Map.GameMapManager")
local EntrantManager = require("LegionEntrant.EntrantManager")
local MatchManager = require("Match.MatchManager")

AchieveState = 
{
	kHaseFinish = 1, --已完成
	kUpdating = 2, --进行中
	kHaseReward = 3, --已领奖
	kGiveUp = 4, --一放弃
}

AchieveType = 
{
	kMainLine = 1, --主线
	kMapMission = 2, --战局
	kTianXiaDaShi = 3, --天下大势
	kOpenTask = 4, --开服任务
	kWeekly = 5, --周活跃
	kChapter = 6, --篇章
	kGongXun = 7, --功勋
	kFamilyActive = 8, --军团活跃
	kJunTuanDaShi = 9, --军团大势（军团战任务）
	kWeiWang = 10, --威望（个人）
	kTouMingZhuang = 11, --投名状任务
	kZhengJi = 12,--政绩
	kLimitedTimePreferential = 13, --推送任务（限时礼包文档）
	kNobility = 14, --爵位（在NoblityManager中）
	kDayGift = 15,--每日推送充值
	kWeekGift = 16,--每周推送充值
	kMonthGift =18,--每月礼包
}

AchieveManageType = {
	[AchieveType.kMainLine] = true,
	[AchieveType.kMapMission] = true,
	[AchieveType.kTianXiaDaShi] = nil,
	[AchieveType.kOpenTask] = nil,
	[AchieveType.kWeekly] = false,
	[AchieveType.kChapter] = true,
	[AchieveType.kGongXun] = true,
	[AchieveType.kWeiWang] = true,
	[AchieveType.kLimitedTimePreferential] = true,
	[AchieveType.kJunTuanDaShi] = true,
	[AchieveType.kFamilyActive] = false,
	[AchieveType.kZhengJi] = true,
	[AchieveType.kDayGift] = true,
	[AchieveType.kWeekGift] = true,
	[AchieveType.kMonthGift] = true,
}

RewardState =
{
	kNotFinish = 1, --未完成
	kCanReward = 2, --可领奖
	kHasReward = 3, --已领取
}

kMapMissionRefreshCD = 3600
kMapMissionMaxCount = 20
kMapMissionRefreshCostPerMinutes = 0.2
kFirstWinAchieveId = 99999
kSpecialAchieveId = 99999
function This:init()
	super.init(self)
	self.m_mapAchieves = {}
	self.m_txdsAchieves = {}
	self.m_mainAchieves = {}
	self.m_chapterAchieves = {}
	self.m_chapters = {}
	self.m_gongxunAchieves = {}
	self.m_zhengJiAchieves = {}
	self.m_mapMissionLastRefreshTime = 0
	self.m_mapMissionFinishTimes = 0
	self.m_mapFeats = 0  --功勋值
	self.m_gongxun = 0
	self.m_txdsId = 0
	self.m_txdsStartTime = 0
	self.m_mapBoxIsReward = {}
	self.m_gongxunBoxIsReward = {}
	self.m_curGongXunAchieves = {}
	self.m_isUpdating = false
	self:initListener()
	self.m_escape = 0
	self.m_maxGongxun = 0
	for i , info in ipairs(MeritoriousMissionBoxConfig) do
		if info.gongxun > self.m_maxGongxun then
			self.m_maxGongxun = info.gongxun
		end
	end
	self.m_weiWangAchieves = {}
	self.m_weiWang = 0
	self.m_weiWangBoxIsReward = {}
	self.m_curWeiWangAchieves = {}
	self.m_maxWeiWang = self.m_maxGongxun
	self.m_limitedTimePreferentials = {}
	self.m_dayGiftAchieves ={}
	self.m_monthGiftAchieves ={}
	self.m_weekGiftAchieves ={}
	self.m_isHaveGiftDayBox = false

	self.m_jtdsAchieves = {}
	self.m_jtdsId = 0
	self.m_jtdsStartTime = 0
	self.m_jtdsEndTime = 0
end

function This:initListener()
	EventDispatcher:addListener(self,11900,self.onGetAchieveInfoReply)
	EventDispatcher:addListener(self,11901,self.onAchieveChangeNotify)
	EventDispatcher:addListener(self,11902,self.onGetRewardReply)
	EventDispatcher:addListener(self,11905,self.onGetBoxRewardReply)
	EventDispatcher:addListener(self,11904,self.onGiveUpMapAchieveReply)
	EventDispatcher:addListener(self,11907,self.onRecieveChapterRewardReply) 
	EventDispatcher:addListener(self,11908,self.onGetGongXunBoxRewardReply)
	EventDispatcher:addListener(self, 11910, self.onGetWeiWangBoxRewardReply)
	EventDispatcher:addListener(self,"player_attr_changed",self.onPlayerAttrChanged)
	EventDispatcher:addListener(self,"terr_build_level_changed",self.onTerrBuildLevelChanged)
	EventDispatcher:addListener(self,"day_passed_delay_31s",self.onDayPassed)
	EventDispatcher:addListener(self, 11911, self.onGetGiftDayBoxReply)
end

function This:getAchieve(type,id)
	local acheves = self:getAllAchieves(type)
	if acheves then
		return  acheves[id]
	end
	return nil
end

-- function This:removeAllAcheves(type)
-- 	local temAchieveList = self:getAllAchieves(type)
-- 	if temAchieveList then
-- 		for _,achieve in pairs(temAchieveList) do
-- 			local id = achieve:getId()
-- 			self:removeAchieve(id, type)
-- 		end
-- 	end
-- end

function This:getAllAchieves(type)
	if type == AchieveType.kMainLine then
		return self.m_mainAchieves
	elseif type == AchieveType.kTianXiaDaShi then
		return self.m_txdsAchieves
	elseif type == AchieveType.kGongXun then
		return self.m_gongxunAchieves
	elseif type == AchieveType.kWeiWang then
		return self.m_weiWangAchieves
	elseif type == AchieveType.kLimitedTimePreferential then
		return self.m_limitedTimePreferentials
	elseif type == AchieveType.kJunTuanDaShi then
		return self.m_jtdsAchieves
	elseif type == AchieveType.kZhengJi then
		return self.m_zhengJiAchieves
	elseif type == AchieveType.kDayGift then
		return self.m_dayGiftAchieves
	elseif type == AchieveType.kMonthGift then
		return self.m_monthGiftAchieves
	elseif type == AchieveType.kWeekGift then
		return self.m_weekGiftAchieves
	end
end

function This:getAchieveWithSort(type)
	local achieveList = {}
	local achieves = self:getAllAchieves(type)
	local func = ActivityUtil.isSpecialAchieve
	for i , achieve in pairs(achieves) do
		local id = achieve:getId()
		if not func(id) then
			table.insert(achieveList, achieve)
		end
	end
	table.sort(achieveList,function(a,b)
		return a:getId() < b:getId()
	end)
	return achieveList
end

function This:addAchieve(info)
	local function crateAchieve()
		local achieve = nil
		if info.type == AchieveType.kTianXiaDaShi then
			achieve = TianXiaAchieve:create(info)
			self.m_txdsAchieves[info.id] = achieve
		elseif info.type == AchieveType.kMainLine then
			achieve = MainAchieve:create(info)
			self.m_mainAchieves[info.id] = achieve
		elseif info.type == AchieveType.kGongXun then
			achieve = GongXunAchieve:create(info)
			self.m_gongxunAchieves[info.id] = achieve
		elseif info.type == AchieveType.kWeiWang then
			achieve = WeiWangAchieve:create(info)
			self.m_weiWangAchieves[info.id] = achieve
		elseif info.type == AchieveType.kLimitedTimePreferential then
			achieve = LimitedTimePreferentialAchieve:create(info)
			self.m_limitedTimePreferentials[info.id] = achieve
		elseif info.type == AchieveType.kJunTuanDaShi then
			achieve = JunTuanAchieve:create(info)
			self.m_jtdsAchieves[info.id] = achieve
		elseif info.type == AchieveType.kZhengJi then
			achieve = ZhengJiAchieve:create(info)
			self.m_zhengJiAchieves[info.id] = achieve
		elseif info.type == AchieveType.kDayGift then
			achieve = GiftDayAchieve:create(info)
			self.m_dayGiftAchieves[info.id] = achieve
		elseif info.type == AchieveType.kMonthGift then
			achieve = GiftMonthAchieve:create(info)
			self.m_monthGiftAchieves[info.id] = achieve
		elseif info.type == AchieveType.kWeekGift then
			achieve = GiftWeekAchieve:create(info)
			self.m_weekGiftAchieves[info.id] = achieve
		end
		return achieve
	end
	
	local achieve = self:getAchieve(info.type, info.id)
	if achieve then
		achieve:updateInfo(info)
	else
		achieve = crateAchieve()
	end
	self:notifyObservers("onAddAchieve",achieve)
	return achieve
end

function This:removeAchieve(id,type)
	local mission = nil
	if type == AchieveType.kTianXiaDaShi then
		mission = self.m_txdsAchieves[id]
		self.m_txdsAchieves[id] = nil
	elseif type == AchieveType.kMainLine then
		mission = self.m_mainAchieves[id]
		self.m_mainAchieves[id] = nil
	elseif type == AchieveType.kGongXun then
		mission = self.m_gongxunAchieves[id]
		self.m_gongxunAchieves[id] = nil
	elseif type == AchieveType.kWeiWang then
		mission = self.m_weiWangAchieves[id]
		self.m_weiWangAchieves[id] = nil
	elseif type == AchieveType.kLimitedTimePreferential then
		mission = self.m_limitedTimePreferentials[id]
		self.m_limitedTimePreferentials[id] = nil
	elseif type == AchieveType.kZhengJi then
		mission = self.m_zhengJiAchieves[id]
		self.m_zhengJiAchieves[id] = nil
	elseif type == AchieveType.kDayGift then
		mission = self.m_dayGiftAchieves[id]
		self.m_dayGiftAchieves[id] = nil
	elseif type == AchieveType.kMonthGift then
		mission = self.m_monthGiftAchieves[id]
		self.m_monthGiftAchieves[id] = nil
	elseif type == AchieveType.kWeekGift then
		mission = self.m_weekGiftAchieves[id]
		self.m_weekGiftAchieves[id] = nil
	end
	if mission then
		self:notifyObservers("onRemoveAchieve",mission)
	end
end

function This:hasAchieveFinish( type )
	local achieves = self:getAllAchieves(type)
	for i , achieve in pairs(achieves) do
		if achieve:getState() == AchieveState.kHaseFinish then
			return true
		end
	end
	return false
end

function This:updateAchieve(info)
	local achieve = self:getAchieve(info.type,info.id)
	if achieve then
		achieve:updateInfo(info)
		self:notifyObservers("onUpdateAchieve",achieve)
	end
end

function This:getTxdsStartTime()
	return self.m_txdsStartTime
end

--获取地图时间，最好只在地图里调用
function This:getWarStarOrEndTime(isEndTime)
	local mapType = GameMapManager:getMapType()
	if not mapType then
		return 0
	end
	local res = EntrantManager:getFightTime(mapType)
	if isEndTime then
		res = EntrantManager:getFightTime(mapType,EntrantState.kFinish)
	end
	return res
end

--军团大势是否结束
function This:getJtdsIsEnd()
	local res = false
	local curTime = GamePlayer:getServerTime()
	local mapStarTime = self.m_jtdsStartTime
	if mapStarTime>0 then
		local endTime = self.m_jtdsEndTime
		if curTime-mapStarTime>endTime then
			res = true
		end
	end
	return res
end

--军团大势是否可以领取奖励
function This:canJtdsReward()
	return self:hasAchieveFinish( AchieveType.kJunTuanDaShi )
end

function This:getTxdsCurIndex(typeId)
	if typeId and typeId == AchieveType.kJunTuanDaShi then
		return self.m_jtdsId
	end
	return self.m_txdsId
end

function This:isHaveGiftDayBox()
	return self.m_isHaveGiftDayBox
end

function This:isBoxReward(index)
	return self.m_mapBoxIsReward[index]
end

function This:isCanRewardBox(index)
	return self.m_mapFeats >= MapMissionBoxConfig[index].gongxun
end

function This:getGongXun(typeId)
	if typeId and typeId == AchieveType.kWeiWang then
		return self.m_weiWang
	end
	return self.m_gongxun
end

function This:getMaxGongXun(typeId)
	if typeId and typeId == AchieveType.kWeiWang then
		return self.m_maxWeiWang
	end
	return self.m_maxGongxun
end


function This:isCanRewardGongXunBox(index)
	if not self.m_gongxunBoxIsReward[index] then
		return self.m_gongxun >= MeritoriousMissionBoxConfig[index].gongxun
	end
	return false
end

function This:selectAchieve(type,selector)
	local result = {}
	local achieves = self:getAllAchieves(type)
	for i , achieve in pairs(achieves) do
		if not selector or selector and selector(achieve) then
			table.insert(result,achieve)
		end
	end
	return result
end

function This:getRecommendMainAchieve()
	local typeAchieve , recommend = nil , nil
	for typeId , achieveList in pairs(self.m_mainTypeAchieves) do
		local achieve = self:getAchieve(AchieveType.kMainLine,typeId)
		if achieve:getState() == AchieveState.kHaseReward and (not typeAchieve or achieve:getId() < typeAchieve:getId()) then
			typeAchieve = achieve
		end
	end

	if typeAchieve then
		local typeId = typeAchieve:getId()
		for id , achieve in ipairs(self.m_mainTypeAchieves[typeId]) do
			if achieve:getState() ~= AchieveState.kHaseReward and (not recommend and achieve:getId() < recommend:getId()) then
				recommend = achieve
			end
		end
	end
	return typeAchieve, recommend
end

function This:updateCurMainAchieve()
	local mainAchieve , subAchieve = nil, nil
	for id , achieveList in pairs(self.m_mainTypeAchieves) do
		local achieve = self:getAchieve(AchieveType.kMainLine,id)
		if achieve:getState() ~= AchieveState.kHaseReward then
			if not mainAchieve or achieve:getId() < mainAchieve:getId() then
				mainAchieve = achieve
			end
		end
	end
	if mainAchieve then
		local typeId = mainAchieve:getId()
		local achieveList = self:getMainSubAchieve(typeId)
		if #achieveList > 0 then
			subAchieve = achieveList[1]
		else
			subAchieve = mainAchieve
		end
	end
	if self.m_typeMainAchieve ~= mainAchieve and mainAchieve and mainAchieve:getChapterTitle() ~= "" then
		self:notifyObservers("onChapterOpen",mainAchieve)
	end
	self.m_typeMainAchieve = mainAchieve
	self.m_typeSubAchieve = subAchieve
end

function This:getCurMainAchieve()
	return self.m_typeMainAchieve
end

function This:getCurMainSubAchieve()
	return self.m_typeSubAchieve
end

function This:getAllMainAchieves()
	return self.m_mainTypeAchieves
end

function This:getMainSubAchieveWithoutSort(typeId)
	return self.m_mainTypeAchieves[typeId] or {}
end

function This:getMainSubAchieve(typeId)
	local result = {}
	local achieves = self:getAllAchieves(AchieveType.kMainLine)
	for i , achieve in pairs(achieves) do
		if achieve:getState() ~= AchieveState.kHaseReward and achieve:getAchieveTypeId() > 0 and achieve:getAchieveTypeId() <= typeId then
			table.insert(result,achieve)
		end
	end
	table.sort(result,function(a,b)
		local as = a:getState()
		local bs = b:getState()
		if as == AchieveState.kHaseFinish and bs ~= AchieveState.kHaseFinish then
			return true
		end
		if as == AchieveState.kHaseFinish and bs == AchieveState.kHaseFinish and a:getId() < b:getId() then
			return true
		end
		if as == AchieveState.kUpdating and bs == AchieveState.kHaseReward then
			return true
		end
		if as == AchieveState.kUpdating and bs == AchieveState.kUpdating and a:getId() < b:getId() then
			return true
		end
		if as == AchieveState.kHaseReward and bs == AchieveState.kHaseReward and a:getId() < b:getId() then
			return true
		end
		return false
	end)
	return result
end

function This:updateGongXunAchieve(gongxunAchieves,configList,gongxunCallback,typeId)
	local achieveList = {}
	local minIds = {}
	for i , achieve in pairs(gongxunAchieves) do--查找最小Id
		local id = achieve:getId()
		local key = math.floor(id / 1000)
		if typeId == AchieveType.kWeiWang then
			key = achieve:getSlotNum()
		end
		if not minIds[key] or minIds[key]:getId() > id then
			minIds[key] = achieve
		end
	end

	local func = ActivityUtil.isSpecialAchieve
	for key , achieve in pairs(minIds) do
		local curId = achieve:getId()
		if not configList[curId] then
			print(string.format("功勋任务%s是空的",tostring(curId)))
		end
		while configList[curId] and configList[curId].next_id > 0 and achieve:getState() == AchieveState.kHaseReward do
			curId = configList[curId].next_id
			achieve = gongxunCallback(curId)
		end
		if not func(curId) and achieve:getState() ~= AchieveState.kHaseReward then
			table.insert(achieveList,achieve)
		end
	end
	return achieveList
end

function This:getCurGongXunAchieveWithSort(typeId)
	local result = {}
	local achieves = self.m_curGongXunAchieves
	if typeId and typeId == AchieveType.kWeiWang then
		achieves = self.m_curWeiWangAchieves
	end
	for i , achieve in ipairs(achieves) do
		table.insert(result, achieve)
	end
	table.sort(result,function(a,b)
		return a:getId() < b:getId()
	end)
	return result
end

function This:getCurGongXunAchieves()
	return self.m_curGongXunAchieves
end


function This:getWeiWangBoxList()
	return self.m_weiWangBoxIsReward
end

--重置威望部分数据
function This:resetWeiWangBoxData(weiWangData)
	self.m_weiWangBoxIsReward = self.m_weiWangBoxIsReward or {}
	if weiWangData and weiWangData.box_info then
		for i , boxData in ipairs(weiWangData.box_info) do
			self.m_weiWangBoxIsReward[boxData.id] = boxData.is_get
		end
	end
	self.m_weiWang = weiWangData.weiwang or self.m_weiWang or 0
end

--是否领取过宝箱
function This:hasWeiWangBoxReward(confBoxId)
	local res =true
	if confBoxId then
		res = self.m_weiWangBoxIsReward[confBoxId]
	end
	return res
end

--威望是否可以领取宝箱
function This:canWeiWangReward()
	local res = false
	for confBoxId, boxisReceived in ipairs(self.m_weiWangBoxIsReward) do
		if not boxisReceived then
			return true,confBoxId
		end
	end
	for i , achieve in pairs(self.m_curWeiWangAchieves) do
		if achieve:getState() == AchieveState.kHaseFinish then
			return true
		end
	end
	return res,0
end

function This:hasGongXunBoxReward(index)
	if index then
		return self.m_gongxunBoxIsReward[index]
	else
		for i , _ in ipairs(MeritoriousMissionBoxConfig) do
			if not self.m_gongxunBoxIsReward[i] then
				return false
			end
		end
		return true
	end
end

function This:canGongXunReward()
	for i , config in ipairs(MeritoriousMissionBoxConfig) do
		if self.m_gongxun >= config.gongxun and not self.m_gongxunBoxIsReward[i] then
			return true
		end
	end
	for i , achieve in pairs(self.m_curGongXunAchieves) do
		if achieve:getState() == AchieveState.kHaseFinish then
			return true
		end
	end
	return false
end

function This:showTxdsWarming()
	local achieve = self:getAchieve(AchieveType.kTianXiaDaShi, self.m_txdsId)
	if achieve then
		local achieveLevel = achieve:getFuncLevel()
		if achieveLevel <= 0 then
			achieve = self:getAchieve(AchieveType.kTianXiaDaShi, self.m_txdsId - 1)
            if not achieve then
                achieve = self:getAchieve(AchieveType.kTianXiaDaShi, self.m_txdsId + 1)
            end
            if achieve then
                achieveLevel = achieve:getFuncLevel()
            end
		end

		if achieveLevel > 0 then
			local param = {simple = Serialize["achieve_txds_level_warming"], notips = "TianXiaDaShi", width = 430}
			PopDialogManager:addPopDialog({
				name = "UI.CostConfirmPanel",
				arg = param,
				level = DialogLevel.kThrLevel,
				onlyone = true,
			})
		end
	end
end

function This:isValidAchieveType( atype )
	return AchieveManageType[atype]
end

--------------------------------------------
--获取任务信息
function This:onGetAchieveInfoRequest(type)
	if type == AchieveType.kGongXun then
		print("请求功勋任务数据...", AchieveType.kGongXun)
	end
	if type then
		Socket:sendAndLock(11900,{type = type})
	else
		Socket:send(11900,{type = AchieveType.kMapMission})
		Socket:send(11900,{type = AchieveType.kTianXiaDaShi})
		Socket:send(11900,{type = AchieveType.kChapter})
		Socket:send(11900,{type = AchieveType.kGongXun})
		Socket:send(11900,{type = AchieveType.kWeiWang})
		Socket:send(11900,{type = AchieveType.kJunTuanDaShi})
		Socket:send(11900,{type = AchieveType.kZhengJi})
		Socket:send(11900,{type = AchieveType.kWeekGift})
		Socket:send(11900,{type = AchieveType.kDayGift})
		Socket:send(11900,{type = AchieveType.kMonthGift})
	end
	self.m_isGettingInfo = true
end

function This:onGetAchieveInfoReply(msg)
	if not self:isValidAchieveType(msg.achievement.type) then
		return 
	end
	print_r(msg)
	local tmp = {}
	for i , info in ipairs(msg.achievement.progress_list) do
		tmp[info.id] = info	
	end
	local typeId =  msg.achievement.type
	-- print(".ljkljl"..msg.achievement.type)
	if typeId == AchieveType.kMainLine then
		self.m_mainTypeAchieves = {}
		for i , info in ipairs(msg.achievement.progress_list) do
			local achieve = self:addAchieve(info)
			local typeId = achieve:getAchieveTypeId()
			if typeId > 0 then
				self.m_mainTypeAchieves[typeId] = self.m_mainTypeAchieves[typeId] or {}
				table.insert(self.m_mainTypeAchieves[typeId],achieve)
			end
			tmp[info.id] = nil
		end
		self:updateCurMainAchieve()
	end

	if typeId == AchieveType.kTianXiaDaShi then
		self.m_txdsId = msg.achievement.tianxia_arg.tianxia_id
		self.m_txdsStartTime = msg.achievement.tianxia_arg.tianxia_start_time
		for i , info in pairs(msg.achievement.progress_list) do
			local achieve = self:addAchieve(info)
			if self.m_txdsId == info.id then
				achieve:setStartTime(self.m_txdsStartTime)
			end
			tmp[info.id] = nil
		end
	end

	if typeId == AchieveType.kJunTuanDaShi then
		
		self.m_jtdsStartTime = self:getWarStarOrEndTime()
		local acheveDataList ={}
		for i,info in ipairs(msg.achievement.progress_list) do
			acheveDataList[info.id]= info
			tmp[info.id] = nil
		end
		local jtdsEndTime =0
		local selectProgressId= msg.achievement.group_arg.map_mission_list
			table.sort(selectProgressId,function(a,b)
			return a < b
		end)
		self.m_jtdsId =0
		for i,configId in ipairs(selectProgressId) do
			local info = acheveDataList[configId]
			if info then
				local achieve = self:addAchieve(info)
				 if achieve:checkTaskIsOpen() and self.m_jtdsId ==0 and info.state ~= AchieveState.kHaseReward then
				 	self.m_jtdsId = configId
					achieve:setStartTime(self.m_jtdsStartTime)
				 end
				 local configData = LegionWarLegionMissionConfig[configId]
				 if configData and configData.time_limit >jtdsEndTime then
				 	jtdsEndTime = configData.time_limit
				 end
			end
		end
		self.m_jtdsEndTime = jtdsEndTime
		
	end
	if typeId == AchieveType.kGongXun then
		self.m_gongxunBoxIsReward = {}
		for i , id in ipairs(msg.achievement.gongxun_arg.reward_box_id) do
			self.m_gongxunBoxIsReward[id] = true
		end
		self.m_gongxun = msg.achievement.gongxun_arg.gongxun
		for i , info in ipairs(msg.achievement.progress_list) do
			self:addAchieve(info)
			tmp[info.id] = nil
		end
		local function gongxunCallback(curId)
			return self:getAchieve(AchieveType.kGongXun,curId)
		end
		local achieveList = self:updateGongXunAchieve(self.m_gongxunAchieves,MeritoriousMissionConfig,gongxunCallback,typeId)
		self.m_curGongXunAchieves = achieveList
	end
	
	if typeId == AchieveType.kWeiWang then

		local acheveDataList ={}
		for i,info in ipairs(msg.achievement.progress_list) do
			acheveDataList[info.id]= info
			tmp[info.id] = nil
		end

		local selectProgressId= msg.achievement.role_arg.map_mission_list
			table.sort(selectProgressId,function(a,b)
			return a < b
		end)
		local selectProgressData = {}
		for i,configId in ipairs(selectProgressId) do
			local info = acheveDataList[configId]
			if info then
				local achieve = self:addAchieve(info)
				 table.insert(selectProgressData,info)
			end
		end

		self:resetWeiWangBoxData(msg.achievement.role_arg)

		
		local function gongxunCallback(curId)
			return self:getAchieve(AchieveType.kWeiWang,curId)
		end
		local achieveList = self:updateGongXunAchieve(self.m_weiWangAchieves,LegionWarPrestigeMissionConfig,gongxunCallback,typeId)
		self.m_curWeiWangAchieves = achieveList
	end
	local function addMyAchieves(progressList,idList)
		local temIdList = idList or {}
		local idKeyList ={}
		for _,id in ipairs(temIdList) do
			idKeyList[id]= id
		end
		for _,info in pairs(progressList) do
			local id = info.id
			if (idList and idKeyList[id]) or not idList then
				local achieve = self:addAchieve(info)
			end
			tmp[id] = nil
		end
	end
	if typeId == AchieveType.kLimitedTimePreferential then
		addMyAchieves(msg.achievement.progress_list)
	end

	if typeId == AchieveType.kDayGift then
		-- self.m_dayGiftAchieves ={}
		local rewardState = msg.achievement.recharge_arg.day_reward or 1
		self.m_isHaveGiftDayBox = rewardState ==0
		addMyAchieves(msg.achievement.progress_list,msg.achievement.recharge_arg.mission_list)
	end
	local function tConvertKey(idList)
		local res = {}
		for _,key in pairs(idList) do
			res[key] = key
		end
		return res
	end

	local function getIdList(config,complete_list,reward_list,myLv)
		local completeKey= tConvertKey(complete_list)
		local rewardKey = tConvertKey(reward_list)
		local configKey = {}
		for item1,itemD in pairs(config) do
			local type1 = itemD.type
			local order = itemD.order
			if not configKey[type1] then
				configKey[type1] = {}
			end
			local typeList = configKey[type1]
			typeList[order]= itemD
		end
		local res ={}
		for type1,list in ipairs(configKey) do
			local allCount = #list
			for index,itemD in ipairs(list) do
				local id = itemD.id
				if not rewardKey[id] or allCount ==index then
					table.insert(res,id)
					break
				end
			end
		end
		return res
	end
	
	local tmpAchievement= msg.achievement
	if typeId == AchieveType.kWeekGift then
		local idList = getIdList(WeekGiftConfig,tmpAchievement.complete_list,tmpAchievement.reward_list,GamePlayer:getLevel())
    	addMyAchieves(msg.achievement.progress_list,idList)
	end
	if typeId == AchieveType.kMonthGift then
		local idList = getIdList(MonthGiftConfig,tmpAchievement.complete_list,tmpAchievement.reward_list,GamePlayer:getLevel())
    	addMyAchieves(msg.achievement.progress_list,idList)
	end
	if typeId == AchieveType.kZhengJi then
		self.m_zhengJiAchieves = {}
		addMyAchieves(msg.achievement.progress_list,msg.achievement.zhengji_arg.mission_list)
	end

	for i , id in ipairs(msg.achievement.complete_list) do
		local achieve = self:getAchieve(typeId,id)
		if achieve then
			achieve:setState(AchieveState.kHaseFinish)
		end
	end
	for i , id in ipairs(msg.achievement.reward_list) do
		local achieve = self:getAchieve(typeId,id)
		if achieve then
			achieve:setState(AchieveState.kHaseReward)
		end
	end
	for i , info in pairs(tmp) do
		self:removeAchieve(info.id,typeId)
	end

	self.m_isGettingInfo = false
	self:notifyObservers("onRefreshAchieve", typeId)

	if msg.achievement.type == AchieveType.kMainLine then
		EventDispatcher:dispatcher("main_achieve_refresh")
	elseif msg.achievement.type == AchieveType.kGongXun then
		EventDispatcher:dispatcher("gongxun_achieve_refresh")
	elseif msg.achievement.type == AchieveType.kTianXiaDaShi then
		EventDispatcher:dispatcher("txds_achieve_refresh")
	elseif msg.achievement.type == AchieveType.kZhengJi then
		EventDispatcher:dispatcher("zhengji_achieve_refresh")
	elseif typeId == AchieveType.kDayGift or typeId == AchieveType.kWeekGift or typeId == AchieveType.kMonthGift then
		EventDispatcher:dispatcher("activity_gift_state_changed")
	end
end

function This:onAchieveChangeRequest(achieve)
	if g_setting.isNetTest and achieve:getProgress() < achieve:getMaxProgress() then
		local progress = achieve:getProgress() + 1
		local state = AchieveState.kUpdating
		if progress >= achieve:getMaxProgress() then
			state = AchieveState.kHaseFinish
		end
		self:onAchieveChangeNotify({progress_list = {{id = achieve:getId(), num = progress, state = state}}})
	end
end

--任务变化通知
function This:onAchieveChangeNotify(msg)
	local chapterList, txdsList, mainList, gongxunList,limitedTimePreferentialList,zhengjiList,giftDayWeekList = {}, {}, {}, {},{},{},{}
	local hasTxdsFinish = false
	for i , info in ipairs(msg.progress_list) do
		local achieve = self:getAchieve(info.type,info.id)
		if achieve then
			achieve:updateInfo(info)
			if achieve:getType() == AchieveType.kTianXiaDaShi then
				table.insert(txdsList,achieve)
				if not hasTxdsFinish then
					hasTxdsFinish = achieve:getState() == AchieveState.kHaseFinish
				end
			elseif achieve:getType() == AchieveType.kMainLine then
				table.insert(mainList,achieve)
			elseif achieve:getType() == AchieveType.kGongXun then
				table.insert(gongxunList,achieve)
			elseif achieve:getType() == AchieveType.kLimitedTimePreferential then
				table.insert(limitedTimePreferentialList,achieve)
			elseif achieve:getType() == AchieveType.kZhengJi then
				table.insert(zhengjiList,achieve)
			elseif achieve:getType() == AchieveType.kDayGift or achieve:getType() == AchieveType.kWeekGift or achieve:getType() == AchieveType.kMonthGift then
				table.insert(giftDayWeekList,achieve)
			end
		end
	end

	if #txdsList > 0 then
		self:notifyObservers("onAchieveChanged",AchieveType.kTianXiaDaShi,txdsList)
		EventDispatcher:dispatcher("txds_achieve_changed",txdsList)
	end
	if #mainList > 0 then
		self:updateCurMainAchieve()
		self:notifyObservers("onAchieveChanged",AchieveType.kMainLine,mainList)
		EventDispatcher:dispatcher("main_achieve_changed",mainList)
	end
	if #gongxunList > 0 then
		self:notifyObservers("onAchieveChanged",AchieveType.kGongXun,gongxunList)
		EventDispatcher:dispatcher("gongxun_achieve_changed",gongxunList)
	end

	if #zhengjiList > 0 then
		self:notifyObservers("onAchieveChanged",AchieveType.kZhengJi,zhengjiList)
		EventDispatcher:dispatcher("zhengji_achieve_refresh",zhengjiList)
	end

	if #limitedTimePreferentialList > 0 then
		self:notifyObservers("onAchieveChanged",AchieveType.kLimitedTimePreferential,limitedTimePreferentialList)
		EventDispatcher:dispatcher("activity_pushgift_state_changed")
	end
	if #giftDayWeekList>0 then
		self:notifyObservers("onAchieveChanged",AchieveType.kDayGift,giftDayWeekList)
		EventDispatcher:dispatcher("activity_gift_state_changed")
	end

	if hasTxdsFinish then
		local effectTxds = GameUtil:createEffect("TianXiaDaShi", false, g_scene)
        g_scene:addChild(effectTxds)	
        effectTxds:setLocalZOrder(g_scene:getMaxLocalZOrder() + 1)
	end
end

--领取奖励
function This:onGetRewardRequest(achieve)
	Socket:sendAndLock(11902,{type = achieve:getType(), id = achieve:getId()})
end

function This:onGetRewardReply(msg)
	if not self:isValidAchieveType(msg.type) then
		return 
	end
	local function gongXunFun(achieve,config,configId)
		if achieve then
			achieve:setState(AchieveState.kHaseReward)
		end
		local config = config[configId]
		if config then 
			local itemList = config.reward
			g_scene:showReward(itemList)
		end
		EventDispatcher:dispatcher("gongxun_achieve_changed",{achieve})
	end
	local function showMyReward(achieve)
			local itemList = achieve:getRewardList()
			g_scene:showReward(itemList)
	end
	if msg.err_code == 0 then
		local achieve = self:getAchieve(msg.type, msg.id)
		if msg.type == AchieveType.kGongXun then
			self.m_gongxun = msg.gongxun
			gongXunFun(achieve,MeritoriousMissionConfig,msg.id)
		elseif msg.type == AchieveType.kMainLine then
			showMyReward(achieve)
			EventDispatcher:dispatcher("main_achieve_changed",{achieve})
		elseif msg.type == AchieveType.kWeiWang then
			gongXunFun(achieve,LegionWarPrestigeMissionConfig,msg.id)
		elseif msg.type == AchieveType.kLimitedTimePreferential  then
			showMyReward(achieve)
		elseif msg.type == AchieveType.kWeekGift or msg.type == AchieveType.kDayGift or msg.type == AchieveType.kMonthGift then
			showMyReward(achieve)
			if achieve:getNextId()~=0 and (msg.type == AchieveType.kDayGift or msg.type == AchieveType.kWeekGift or msg.type == AchieveType.kMonthGift ) then
				self:removeAchieve(achieve:getId(), msg.type)
			end

			EventDispatcher:dispatcher("activity_gift_state_changed")
		elseif msg.type == AchieveType.kZhengJi then	
			-- self:onGetAchieveInfoRequest(AchieveType.kZhengJi)
			achieve:setState(AchieveState.kHaseReward)
			EventDispatcher:dispatcher("gongxun_achieve_changed",{achieve})
			MatchManager:onGetBoxInfoRequest()
		end
		self:notifyObservers("onGetAchieveReward",achieve)
		EventDispatcher:dispatcher("achieve_change")
	else
		g_scene:handleErrorCode(msg.err_code)
	end
end

function This:onGetGongXunBoxRewardRequest(index,type)
	Socket:sendAndLock(11908,{box_id = index,type=type})
end

function This:onGetGongXunBoxRewardReply(msg)
	if msg.err_code == 0 then
		local function gongXunFun(configs,configId)
			local rewardList = configs[configId].reward
			g_scene:showReward(rewardList)
			self:notifyObservers("onGetGongXunBoxReward",configId)
			EventDispatcher:dispatcher("gongxun_box_reward",configId)
		end
		self.m_gongxunBoxIsReward[msg.box_id] = true
		gongXunFun(MeritoriousMissionBoxConfig,msg.box_id)
		-- local rewardList = MeritoriousMissionBoxConfig[msg.box_id].reward
		-- g_scene:showReward(rewardList)
		-- self:notifyObservers("onGetGongXunBoxReward",msg.box_id)
		-- EventDispatcher:dispatcher("gongxun_box_reward",msg.box_id)
	else
		g_scene:handleErrorCode(msg.err_code)
	end
end
	
function This:onGetWeiWangBoxRewardRequest(confBoxId)
	Socket:sendAndLock(11910,{box_id = confBoxId})
end

function This:onGetWeiWangBoxRewardReply( msg )
    if msg.err_code == 0 then
        g_scene:showReward(msg.reward_list or {})
        self:resetWeiWangBoxData(msg.role_arg or {})
        self:notifyObservers("onGetWeiWangBoxReward")
    else
        g_scene:handleErrorCode(msg.err_code)
    end
end
	
function This:onGetGiftDayBoxRequest()
	Socket:sendAndLock(11911)
end

function This:onGetGiftDayBoxReply( msg )
    if msg.err_code == 0 then
    	self.m_isHaveGiftDayBox = false
    	g_scene:showReward(msg.reward_list or {})
        EventDispatcher:dispatcher("activity_gift_state_changed")
        self:notifyObservers("onGetGiftDayBox")
    else
        g_scene:handleErrorCode(msg.err_code)
    end
end
--玩家属性变化

function This:onPlayerAttrChanged(info)
	if info.attrId == PlayerAttr.exp and self.m_txdsId and self.m_txdsId > 0 then
		local level = GamePlayer:getLevel()
		if level < kMaxLevel and info.new / RoleLevelConfig[level + 1].exp > 1 then
			self:showTxdsWarming()
		end
	end
end

--官府等级变化
function This:onDayPassed()
	self:onGetAchieveInfoRequest()
end

function This:update(dt)
	super.update(self,dt)
	self.m_escape = self.m_escape + dt
	if self.m_escape >= 1.0 then
		self.m_escape = self.m_escape - 1
		local leftTime = self:getMapMissionLeftRefreshTime()
		if self.m_mapMissionLastRefreshTime > 0 and leftTime <= 0 and not self.m_isGettingInfo then
			self:onGetAchieveInfoRequest(AchieveType.kMapMission)
		end
		self:notifyObservers("onUpdateAchieveCD",leftTime)
	end
end

--endregion
