--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"cc.Node")
local AchieveManager = require("Achieve.AchieveManager")
local ItemNode = require("UI.ItemNode")

function This:init(achieve)
	self.m_achieve = achieve
	self.m_csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/BattlefieldItem.csb")
	self:addChild(self.m_csNode)
	local w , h = self.m_csNode.bg:getContentSize()
	self:setContentSize(w,h)

	self.m_csNode.title:setString(achieve:getName())
	self.m_csNode.desc:setString(achieve:getDesc())
	self.m_csNode.scrollview:setDirection("horizontal")
	self.m_csNode.scrollview.m_direction = "right"
	self:initReward()
	self:setCascadeOpacityEnabled(true)

	local config = self.m_achieve:getConfig()
	local color = QualityColor[config.quality]
	self.m_csNode.title:setColor(color.r,color.g,color.b)
end

function This:initTouchEvent()
	self.m_csNode.taskfinish_0:setTouch({
		onEnded = function()
			AchieveManager:onGiveUpMapAchieveRequest(self.m_achieve:getId())
		end,
		isContainer = true,
		isScale = false
	})
	self.m_csNode.taskfinish:setTouch({
		onEnded = function()
			AchieveManager:onGetRewardRequest(self.m_achieve)
		end,
		isContainer = true,
		isScale = false
	})
	self.m_csNode.icon:setTouch({
		onEnded = function()
			AchieveManager:onAchieveChangeRequest(self.m_achieve)
		end,
		isContainer = true,
		isScale = false
	})
	self.m_csNode.scrollview:setSwallowTouch(false)
end

function This:initReward()
	local itemList = self.m_achieve:getRewardList()
	for i , info in ipairs(itemList) do
		local item = ItemNode:create(info.id,info.num)
		local w , h = item:getContentSize()
		item:setAnchorPoint(0.5,0.5)
		self.m_csNode.scrollview:pushBackCustomItem(item,w,h,0.5)
	end
end

function This:refresh()
	local state = self.m_achieve:getState()
	self.m_csNode.giveuo:setVisible(state == AchieveState.kGiveUp)
	self.m_csNode.notfinish:setVisible(state == AchieveState.kUpdating)
	self.m_csNode.taskfinish_0:setVisible(state == AchieveState.kHaseFinish)
	self.m_csNode.taskfinish:setVisible(state == AchieveState.kHaseFinish)
	self.m_csNode.hasreward:setVisible(state == AchieveState.kHaseReward)
	local progress = math.min(self.m_achieve:getProgress(),self.m_achieve:getMaxProgress())
	self.m_csNode.num:setString(string.format("%d/%d",progress,self.m_achieve:getMaxProgress()))
	self.m_csNode.renwujindu:setPercent(self.m_achieve:getProgress() / self.m_achieve:getMaxProgress() * 100)
end

function This:onEnter()
	super.onEnter(self)
	self:refresh()
	self:initTouchEvent()
	self.m_achieve:setView(self)
end

function This:onExit()
	super.onExit(self)
	self.m_achieve:setView(nil)
end



--endregion
