--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"cc.Node")
local ItemUtil = require("Bag.ItemUtil")
local AchieveManager = require("Achieve.AchieveManager")
local ViewUtil = require("UI.ViewUtil")

function This:init(achieve)
	self.m_achieve = achieve
	self.m_csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/ChapterMainItem.csb")
	self:addChild(self.m_csNode)
	self:refreshInfo()
end

function This:refreshInfo()
	self.m_csNode.content:setString(self.m_achieve:getDesc())
	local state = self.m_achieve:getState()
	local progress , total = self.m_achieve:getProgress()
	if state == AchieveState.kUpdating then
		self.m_csNode.renwujindu:setPercent(progress / total * 100)
		self.m_csNode.jindu:setString(string.format("%d/%d",progress,total))
	else
		self.m_csNode.renwujindu:setPercent(100)
		self.m_csNode.jindu:setString(string.format("%d/%d",total,total))
	end
	
	local rewardList = self.m_achieve:getRewardList()
	self.m_csNode.num:setString(rewardList[1].num)
	self.m_csNode.icon:setImage(ItemUtil.getIconImage(rewardList[1].id))

	
	self.m_csNode.goto:setVisible(state == AchieveState.kUpdating)
	self.m_csNode.receive:setVisible(state == AchieveState.kHaseFinish)
	self.m_csNode.received:setVisible(state == AchieveState.kHaseReward)
end

function This:onEnter()
	super.onEnter(self)
	self:initTouchEvent()
end

function This:initTouchEvent()
	self.m_csNode.goto:setTouch({
		onEnded = function()
			local panelInfo = self.m_achieve:getGotoPanel()
			if panelInfo and panelInfo.name ~= "" then
				if self.m_gotoHandler then
					self.m_gotoHandler(self.m_achieve)
				end
			end
		end,
		isContainer = true
	})
	self.m_csNode.receive:setTouch({
		onEnded = function()
			AchieveManager:onGetRewardRequest(self.m_achieve)
		end,
		isContainer = true
	})
end

function This:setGotoHandler(handler)
	self.m_gotoHandler = handler
end

function This:setModel(achieve)
	self.m_achieve = achieve
	self:refreshInfo()
end

function This:getBgContentSize()
	return self.m_csNode.desBG:getContentSize()
end

function This:getModel()
	return self.m_achieve
end

--endregion
