--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"Dialog")
local AchieveManager = require("Achieve.AchieveManager")
local ItemNode = require("UI.ItemNode")
local ChapterAchieveView = require("Achieve.ChapterAchieveView")
local ViewUtil = require("UI.ViewUtil")
local GuideManager = require("Guide.GuideManager")

function This:initNode()
	self.m_csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/ChapterMain.csb")
	self:addChild(self.m_csNode)
	self.m_csNode:setToCenter()

	self.m_chaper = AchieveManager:getCurChapter()
	self:refreshInfo()
	self:refreshItems()
end

function This:refreshInfo()
	self.m_csNode.title:setString(self.m_chaper:getName())
	self.m_csNode.name:setString(self.m_chaper:getTitle())
	self.m_csNode.describe:setString(self.m_chaper:getDesc())
	local progress , total = self.m_chaper:getProgress()
	self.m_csNode.jindu1:setString(string.format("(%d/%d)",progress,total))

	local rewardList = self.m_chaper:getRewardList()
	for i , info in ipairs(rewardList) do
		local node = ItemNode:create(info.id,info.num)
		node:setAnchorPoint(0.5,0.5)
		self.m_csNode["reward"..i]:removeAllChildren()
		self.m_csNode["reward"..i]:addChild(node)
	end
	for i = 1 , 4 do
		self.m_csNode["reward"..i]:setVisible(#rewardList >= i)
	end

	local chapterProgress , chapterTotal = AchieveManager:getChapterProgress()
	self.m_csNode.jindu2:setString(string.format(Serialize[60099],chapterProgress,chapterTotal))
	if not self.m_chaper:isFinish() then
		self.m_csNode.Collectall:setGrayShader()
	else
		self.m_csNode.Collectall:clearShader()
	end
end

function This:refreshItems()
	local achieveList = self.m_chaper:getAchieveList()
	local itemList = self.m_csNode.ScrollView:getItemList()

	for i = #itemList, #achieveList + 1, -1 do
		self.m_csNode.ScrollView:removeItem(i)
	end

	for i , view in ipairs(itemList) do
		if i <= #achieveList then
			view:setModel(achieveList[i])
		end
	end

	for i = #itemList + 1 , #achieveList do
		local achieve = achieveList[i]
		local view = ChapterAchieveView:create(achieve)
		view:setGotoHandler(function(ac)
			self:close()
			ac:triggerAncGuider()
		end)
		local w , h = view:getBgContentSize()
		self.m_csNode.ScrollView:pushBackCustomItem(view, w, h, 0.5)
	end
end

function This:initTouchEvent()
	self.m_csNode.Collectall:setTouchEnded(function()
		if self.m_chaper:isFinish() then
			AchieveManager:onRecieveChapterRewardRequest(self.m_chaper:getId())
		else
			g_scene:showTips(Serialize[60100])
		end
	end)
	self.m_csNode.close:setTouchEnded(function()
		self:close()
	end)
end

function This:refreshAchieveView(achieve)
	local itemList = self.m_csNode.ScrollView:getItemList()
	for i , view in ipairs(itemList) do
		if view:getModel() == achieve then
			view:refresh()
		end
	end	
end

function This:onEnter()
	super.onEnter(self)
	AchieveManager:addObserver(self)
end

function This:onExit()
	super.onExit(self)
	AchieveManager:removeObserver(self)
end

function This:onAchieveChanged(achieveType)
	if achieveType == AchieveType.kChapter then
		self:refreshInfo()
		self:refreshItems()
	end
end

function This:onGetAchieveReward(achieve)
	if achieve:getType() == AchieveType.kChapter then
		self:refreshItems()
	end
end

function This:onReceiveChapterReward(chapter)
	if self.m_chaper == chapter then
		self:close()
	end
end

--endregion
