-- @Author: zheng
-- @Date:   2018-12-08 16:10:51
-- @Last Modified by:   zheng
-- @Last Modified time: 2018-12-12 17:44:15
-- @File Name: CrusadeFinish.lua

local This , super = class(...,"Dialog")
-- local FamilyManager = require("Official.FamilyManager")
local HeroManager = require("Hero.HeroManager")
local ArenaHeroView = require("Arena.ArenaHeroView")
This.fileName = "MenuScene/NodeUI/TaskCrusadeFinish.csb"

function This:initNode(info)
    local fileName = info.fileName or This.fileName
    self.m_csNode = cc.Node:createFromCSFile(fileName)
    self.m_csNode:setToCenter()
    self:addChild(self.m_csNode)

    self.m_cardNodes={}
    self.m_heroNodeList = info.heroNodeList
    if self.m_heroNodeList and fileName == This.fileName then
        local heroXList ={}
        self.m_maxHeroNum = 5
        for uiIndex = 1 , self.m_maxHeroNum do
            local heros = self.m_csNode.heros
            local view = ArenaHeroView:create(nil)
            local item1 = heros["hero"..uiIndex]
            item1:addChild(view)
            self.m_cardNodes[uiIndex] = view
			view:setVisible(false)
            heroXList[uiIndex] = item1:getPositionX()
        end
        self.m_heroOffsetX = (heroXList[2]-heroXList[1])/2
        self:refreshHeroList()
    end

    self.m_numList = info.numList
    self.m_numListName = info.numListName or "tipNode"
    if self.m_numList then
        self:refreshLabel()
    end

    self:refreshProgress(info.progressNum)

    self.m_btnCallBack = info.btnCallBack
end

function This:initTouchEvent()
    self.m_csNode.button1:setTouchEnded(function()
        self:close()
    end)
    self.m_csNode.button2:setTouchEnded(function()
        if self.m_btnCallBack then
            self.m_btnCallBack()
        end
        self:close()
    end)
end

function This:refreshProgress(progressNum)
    local progressBg = self.m_csNode.processBG
    if progressNum and progressNum>0 and progressBg then
        progressBg.process:setPercent(progressNum)
    end
end

function This:refreshLabel()
    local numList = self.m_numList
    if numList then
        local labelParent = self.m_csNode[self.m_numListName]
        if labelParent then
            labelParent:setVisible(true)
            for labelIndex,labelStr in ipairs(numList) do
                local item1 = labelParent["number"..labelIndex]
                if item1 then
                    item1:setString(labelStr)
                end
            end
        end
    end
end

function This:refreshHeroList()
    local heroList = self.m_heroNodeList
    if not heroList then
        return
    end
    local heros = self.m_csNode.heros
    local uiNodes = self.m_cardNodes
    for heroIndex,heroId in ipairs(heroList) do
        local heroUi = uiNodes[heroIndex]
        local hero = HeroManager:getHero(heroId)--getHeroByUid(cardList[i])
        local info = {id = hero:getUid(), level = hero:getLevel(), star = hero:getStarLv() * 5 + hero:getPhase(), heroId = hero:getId(),awake = hero:isAwakeFull()}
        if heroUi then
            heroUi:setVisible(true)
            heroUi:setModel(info)
        end
    end
    local heroNum = self.m_maxHeroNum
    local heroOffsetNum = heroNum - #heroList
    if heroOffsetNum~=0 then
        heros:setPositionX(heroOffsetNum*self.m_heroOffsetX)
    end
end
