-- @Author: zheng
-- @Date:   2018-12-10 10:35:28
-- @Last Modified by:   zheng
-- @Last Modified time: 2018-12-26 14:06:41
-- @File Name: CrusadeHeroItemView.lua

local This , super = class(...,"NodeUI")
local GameUtil = require("Util.GameUtil")
local ItemUtil = require("Bag.ItemUtil")

This.fileName = "MenuScene/NodeUI/TaskCrusadeHeroItem.csb"

function This:initNode(info)
    
    self:setContentSize(100,100)
    -- self:setAnchorPoint(0,0)
    self:initSomeData(info)
end

function This:initSomeData(info)
    self.m_hero = info.hero
    self.m_isSelect = info.isSelected or false
    self.m_attrId = info.attrId
    self.m_attrValue = info.attrValue or 0
    self.m_attrStr = info.attrStr or ""
    self.m_btnCallBack = info.btnCallBack
    self.m_gouFun = info.gouFun
    self:refresh()
end

function This:refresh()
    local heroId = self.m_hero:getId()
    self.hero:setImage(GameUtil:getItemIcon(heroId))
    self.iconbg:setImage(ItemUtil.getQualityImage(heroId))
    local attrNum = self.m_hero:getAttr(self.m_attrId)
    if attrNum<self.m_attrValue then
        self.value:setStringWithColor(string.format("<New11>%s  %d",self.m_attrStr,attrNum))
    else
        self.value:setString(string.format("%s  %d",self.m_attrStr,attrNum))
    end
    self.biaoqian:setVisible(self.m_isSelect or false)

    local gouVisible = false
    if self.m_gouFun then
        gouVisible = self.m_gouFun(heroId) or false
    end
    self:refreshGou(heroId,gouVisible)

    self.zhezhao:setVisible(attrNum<self.m_attrValue or self.m_isSelect )
end

function This:refreshGou(heroId,gouVisible)
    if not heroId then
       heroId = self.m_hero:getId() 
    end
    if self.m_hero:getId() == heroId then
        self.gou:setVisible(gouVisible or false)
    end
end

function This:initTouchEvent()
    self:setTouch({
        isContainer = isContainer or false,
        isDynamic = true,
        isSwallow = false,
        isScale = false,
        sizeNode = self.hero,
        onEnded = function()
            -- self:btnClickCallback()
            -- handler(self.m_heroId)
            local attrNum = self.m_hero:getAttr(self.m_attrId)
            if attrNum<self.m_attrValue then
                g_scene:showTips(Serialize["achieve_CrusadeHero_2"])
                return false
            end
            if self.m_isSelect then
                g_scene:showTips(Serialize["achieve_CrusadeHero_3"])
                return false
            end
            local gou = self.gou
            if gou:isVisible() then
                g_scene:showTips(Serialize["achieve_CrusadeHero_1"])
            else
                if self.m_btnCallBack then
                    local info = {heroId = self.m_hero:getId(),itemNode = self}
                    self.m_btnCallBack(info)
                end
            end
        end
    })
end

function This:setModel(info)
    local id1= info.hero:getId()
    local id2 = self.m_hero:getId()
    if id1 ~= id2 then
        self:initSomeData(info)
    end
end