--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"Base.BaseModel")
local MissionConfig = require("Metadatas.MissionConfig")
local Application = require("cc.Application")
local GamePlayer = require("Player.GamePlayer")



function This:init(info)
	super.init(self,info)
	self.m_id = info.id
	self.m_endTime = info.totalSecond + info.startTime
	self.m_state = info.state
	self.m_config = MissionConfig[self.m_id]
	if self.m_state == DailyAchieveState.kUpdating and GamePlayer:getServerTime() < self.m_endTime then
		self:startUpdate()
	end
end

function This:getId()
	return self.m_id
end

function This:getName()
	return self.m_config.title
end

function This:getDesc()
	return self.m_config.desc
end

function This:getState()
	return self.m_state
end

function This:getQuality()
	return self.m_config.quality
end

function This:getProgress()
	if self.m_state == DailyAchieveState.kUpdating then
		local leftTime = self:getLeftTime()
		return math.max(0,1 - leftTime / (self.m_config.minute * 60))
	elseif self.m_state == DailyAchieveState.kFinish then
		return 1
	end
	return 0
end

function This:getMaxLeftTime()
	return self.m_config.minute * 60
end

function This:getLeftTime()
	local curTime = GamePlayer:getServerTime()
	return math.max(0,self.m_endTime - curTime)
end

function This:startUpdate()
	self.m_escape = 0
	Application:addToUpdateList(self)
end

function This:endUpdate()
	Application:removeFromUpdateList(self)
end

function This:updateInfo(info)
	self.m_endTime = info.totalSecond + info.startTime
	if self.m_state == DailyAchieveState.kUpdating and info.state ~= DailyAchieveState.kUpdating then
		self:endUpdate()
	elseif self.m_state ~= DailyAchieveState.kUpdating and info.state == DailyAchieveState.kUpdating then
		self:startUpdate()
	end
	self.m_state = info.state
end

function This:getRewardList()
	local result= {}
	for i , info in ipairs(self.m_config.reward) do
		table.insert(result,{id = info[1],num = info[2]})
	end
	return result
end

function This:update(dt)
	self.m_escape = self.m_escape + dt
	if self.m_escape >= 1 then
		self.m_escape = self.m_escape - 1
		local leftTime = self:getLeftTime()
		if leftTime >= 0 then
			self:notifyObservers("onAchieveUpdate",leftTime)
		else
			self:notifyObservers("onAchieveUpdate",0)
			self:endUpdate()
		end
	end
end

--endregion
