--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"cc.Node")
local ItemNode = require("UI.ItemNode")
local DailyAchieveManager = require("Achieve.DailyAchieveManager")
local GameUtil = require("Util.GameUtil")

function This:init(achieve)
	self.m_achieve = achieve
	self.m_RewardCount = 0
	self.m_csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/TaskItem.csb")
	self:addChild(self.m_csNode)
	local w , h = self.m_csNode.desBG:getContentSize()
	self:setContentSize(w,h)
	self.m_csNode:setPosition(w/2,h/2)
	self:setAnchorPoint(0.5,0.5)

end

function This:initNode()
	self.m_csNode.title:setString(self.m_achieve:getName())
	self.m_csNode.desc:setString(self.m_achieve:getDesc())
	local quality = self.m_achieve:getQuality()
	self.m_csNode.quality:setImage("MenuScene/taskqulity" .. quality .. ".png")
	local color = QualityColor[quality]
    self.m_csNode.title:setColor(color.r,color.g,color.b)
    self:refreshReward()
end

function This:refreshReward()
	local curRewardCount = self.m_RewardCount
    self.m_RewardCount = 0
	local rewardList = self.m_achieve:getRewardList()
	for i, info in ipairs(rewardList) do
		local itemNode = self.m_csNode["reward"..i]
		if not itemNode then
			local node = self.m_csNode["item"..i]
			itemNode = ItemNode:create(info.id,info.num)
			itemNode:setAnchorPoint(0.5,0.5)
			node:addChild(itemNode)
		else
			itemNode:init(info.id,info.num)
			itemNode:setVisible(true)
		end
		self.m_RewardCount = self.m_RewardCount + 1
	end

	for i = self.m_RewardCount, curRewardCount do
		itemNode:setVisible(false)
	end
end

function This:refresh()
	local state = self.m_achieve:getState()
	self.m_csNode.tasksituation1:setVisible(state ~= DailyAchieveState.kUpdating)
	self.m_csNode.tasksituation2:setVisible(state == DailyAchieveState.kUpdating)
	self.m_csNode.tasksituation1.taskbegin:setVisible(state == DailyAchieveState.kNotStart)
	self.m_csNode.tasksituation1.taskfinish:setVisible(state == DailyAchieveState.kFinish)

	if state == DailyAchieveState.kNotStart then
		local leftTime = self.m_achieve:getMaxLeftTime()
		self:setTime(GameUtil:formatTime(Serialize["H_M_S"],leftTime))
	end
	if state == DailyAchieveState.kUpdating then
		self.m_csNode.tasksituation2.processBG.process:setPercent(self.m_achieve:getProgress() * 100)
	end
end

function This:refreshProgress()
	self.m_csNode.tasksituation2.processBG.process:setPercent(self.m_achieve:getProgress() * 100)
end

function This:initTouchEvent()
	self.m_csNode.tasksituation1.taskbegin:setTouch({
		onEnded = function()
			self:btnCallbackBegin()
		end,
		isContainer = true
	})
	self.m_csNode.tasksituation1.taskfinish:setTouch({
		onEnded = function()
			self:btnCallbackFinish()
		end,
		isContainer = true
	})
	self.m_csNode.tasksituation2.accelerate:setTouch({
		onEnded = function()
			self:btnCallbackAccelerate()
		end,
		isContainer = true
	})
end

function This:setTime(str)
	self.m_csNode.tasksituation1.taskbegin.time:setString(str)
end

function This:btnCallbackBegin()
	if not DailyAchieveManager:isCanStartAchieve() then
		g_scene:showTips(Serialize[60111])
		return
	end
	DailyAchieveManager:onStartDailyAchieveRequest(self.m_achieve:getId())
end

function This:btnCallbackFinish()
	DailyAchieveManager:onGetDailyAchieveRewardRequest(self.m_achieve:getId())
end

function This:btnCallbackAccelerate()
	local leftTime = self.m_achieve:getLeftTime()
	if leftTime > 5 then 
		local cost = DailyAchieveManager:getRefreshCost(leftTime, false)
		local panel = g_scene:openDialog("UI.CostConfirmPanel", {cost = cost, desc = Serialize[60112], note = GameUtil:formatTime(Serialize["H_M_S"],leftTime)})
		panel:setOkHandler(function ()
			DailyAchieveManager:onFinishAchieveFastlyRequest(self.m_achieve:getId())
		end)
	elseif leftTime > 0 then
		g_scene:showTips(Serialize[60102])
	end
end
function This:onEnter()
	super.onEnter(self)
	self:initNode()
	self:refresh()
	self:initTouchEvent()
	self.m_achieve:addObserver(self)
end

function This:onExit()
	super.onExit(self)
	self.m_achieve:removeObserver(self)
end

function This:setModel(achieve)
	if self.m_achieve ~= achieve then
		self.m_achieve:removeObserver(self)
		self.m_achieve = achieve
		self.m_achieve:addObserver(self)
		self:initNode()
		self:refresh()
	else
		self:refresh()
	end
end

function This:onAchieveUpdate(leftTime)
	self:refreshProgress()
end



--endregion
