-- @Author: zheng
-- @Date:   2018-12-06 20:24:52
-- @Last Modified by:   zheng
-- @Last Modified time: 2018-12-12 17:18:21
-- @File Name: GameCrusadeItem.lua
local CrusadeConfig = require("Metadatas.CrusadeConfig")
local This , super = class(...,"Achieve.DailyAchieve")
local Application = require("cc.Application")
local GamePlayer = require("Player.GamePlayer")
local DailyAchieveManager = require("Achieve.DailyAchieveManager")

-----------------------------------------------------------parentStart
function This:init(info)
   self.m_observers = {}

   self.m_id = info.id
   self.m_config = CrusadeConfig[self.m_id] 

   self.m_endTime = info.start_time + info.need_time
   self.m_state = info.state
   self.m_HeroList = info.heroid_list
   if self.m_state == DailyAchieveState.kUpdating and GamePlayer:getServerTime() < self.m_endTime then
        self:startUpdate()
   end
end

function This:updateInfo(info)
    self.m_endTime = info.start_time + info.need_time
    self.m_HeroList = info.heroid_list
    if self.m_state == DailyAchieveState.kUpdating and info.state ~= DailyAchieveState.kUpdating then
        self:endUpdate()
    elseif self.m_state ~= DailyAchieveState.kUpdating and info.state == DailyAchieveState.kUpdating then
        self:startUpdate()
    end
    self.m_state = info.state
end

function This:endUpdate()
	Application:removeFromUpdateList(self)
	DailyAchieveManager:onGetCrusadeInfoRequest()
end


function This:getDesc()
    return self.m_config.introduction
end

function This:getMaxLeftTime()
    return self.m_config.second
end

function This:getProgress()
    if self.m_state == DailyAchieveState.kUpdating then
        local leftTime = self:getLeftTime()
        return math.max(0,1 - leftTime / self:getMaxLeftTime())
    elseif self.m_state == DailyAchieveState.kFinish then
        return 1
    end
    return 0
end

function This:getRewardList()
  return self.m_config.reward
end
-----------------------------------------------------------parentEnd

function This:setState(state)
  if state then
    self.m_state = state
  end
end

--快速完成
function This:fastEnd()
    self.m_state = DailyAchieveState.kFinish
end

--任务描述两行
function This:getDesc2()
    return self.m_config.desc
end

--加速消耗
function This:getAccelerateMoney()
    return self.m_config.acceleratemoney
end

--任务需要武将数量
function This:getHeroNum()
    return self.m_config.heronum
end

--英雄属性限制类型
function This:getHeroAttr()
    local attrId = self.m_config.attribute
    local attrNum = self.m_config.value
    local name = AttrName[attrId]
    return attrId,attrNum,name
end

function This:setHeroList(HeroList)
  self.m_HeroList = HeroList
end

function This:getHeroList()
  return self.m_HeroList or {}
end

-- TaskCrusade
-- TaskCrusadeFinish
-- TaskCrusadeHero
-- TaskCrusadeHeroItem
-- TaskCrusadeProblem
-- TaskCrusadeItem

-- TaskItem
-- TaskUi