-- @Author: zheng
-- @Date:   2019-05-14 16:54:02
-- @Last Modified by:   zheng
-- @Last Modified time: 2020-03-24 14:29:41
-- @File Name: GiftDayTabItemView.lua
-- local ItemNode = require("UI.ItemNode")
local GameUtil = require("Util.GameUtil")
local This , super = class(...,"NodeUI")

This.fileNames = "MenuScene/NodeUI/GiftMainDay.csb"
local AchieveManager = require("Achieve.AchieveManager")
local SdkManager = require("Sdk.SdkManager")

function This:initNode(info)
    self.m_achieve = info.achieve
    self.m_acheveType = info.acheveType
    self.m_isLock = info.isLock
    self.m_isLast = info.isLast
    local fileName =This.fileNames
    local w2,h2 = 20,0
    -- if AchieveType.kWeekGift == self.m_acheveType then
    --     fileName = "MenuScene/NodeUI/GiftMainWeek.csb"
    -- else
        self.m_isLock = false
    -- end
    self.m_csNode = cc.Node:createFromCSFile(fileName)
    self:addChild(self.m_csNode)
    local jsjiantouan = self.m_csNode.jsjiantouan
    if jsjiantouan then
         w2,h2 = 40,0
    end
    local w, h = self.m_csNode.bg:getContentSize()
    self:setContentSize(w+w2,h)

    self:refresh()
end

function This:refresh()
    local data = self.m_achieve
    if data then
        local islock = self.m_isLock
        local isLast = self.m_isLast
        local rewards = data:getRewardList()
        local price = data:getPrice()
        local yuanBaoNum = data:getYuanBaoNum()
        local giftNum = data:getGiftNum()
        local csNode = self.m_csNode
        local desNode1 = csNode.desNode1
        csNode.title:setString(data:getName())
        desNode1.num1:setString(yuanBaoNum)
        desNode1.num2:setString(giftNum)
        GameUtil:resetScoolItemNode(csNode.scrollview,rewards,nil,nil,nil,3)
        local state = data:getState()
        -- local isFinish = state == AchieveState.kHaseFinish

        local buttonList = csNode.buttonList
        local button = buttonList.button
        local lingQuBtn = buttonList.button1

        button.num:setString(price)
        lingQuBtn:setVisible(state == AchieveState.kHaseFinish)
        button:setVisible(state == AchieveState.kUpdating)
        buttonList.yilingqu:setVisible(state == AchieveState.kHaseReward)

        buttonList:setVisible(not islock)
        csNode.jiesuotips:setVisible(islock)
        -- if AchieveType.kWeekGift == self.m_acheveType then
        --     csNode.xuanzhong:setVisible(not islock and state == AchieveState.kUpdating)
        --     local jsjiantouanVisible = state == AchieveState.kUpdating
        --     if isLast then
        --         jsjiantouanVisible = false
        --         csNode.jsjiantou:setVisible(false)
        --     end
        --     desNode1:setVisible(not isLast)
        --     csNode.desNode2:setVisible(isLast)
        --     csNode.jsjiantouan:setVisible(jsjiantouanVisible)
        -- end
    end
end

function This:initTouchEvent()
    local buttonList = self.m_csNode.buttonList
    buttonList.button:setTouch({
        onEnded = function()
            print("buy")
            local achieve = self.m_achieve
            if achieve then
                local buyId = achieve:getBuyId()
                SdkManager:onApplyBillIDRequest(buyId)
            end
        end,
        isDynamic = true,
        isScale = false
    })

    buttonList.button1:setTouch({
        onEnded = function()
        --领  取
        print("lingqu")
        AchieveManager:onGetRewardRequest(self.m_achieve)
            
        end,
        isDynamic = true,
        isScale = false
    })
end

function This:onEnter()
    super.onEnter(self)
    AchieveManager:addObserver(self)
end

function This:onExit()
    super.onExit(self)
    AchieveManager:removeObserver(self)
end

function This:onGetAchieveReward(achieve)
    if achieve:getType()== self.m_acheveType and achieve:getId()== self.m_achieve:getId() then
        -- if AchieveType.kWeekGift == self.m_acheveType then
        --     self:refresh()
        -- else
            local achieveId = self.m_achieve:getNextId()
            if achieveId~=0 then
                local temAchieve= AchieveManager:getAchieve(self.m_acheveType,achieveId)
                if temAchieve then
                    self.m_achieve = temAchieve
                end
            end
            self:refresh()
        -- end
    end
end

function This:onAchieveChanged(typeId,list)
    for _,achieve in ipairs(list) do
        if achieve:getType()== self.m_acheveType then
            if achieve:getId()== self.m_achieve:getId() then
                self:refresh()
            end
            -- if AchieveType.kWeekGift == self.m_acheveType then
            --    local previousId = self.m_achieve:getPreviousId()
            --    local temAchieve= AchieveManager:getAchieve(self.m_acheveType,previousId)
            --     if temAchieve and temAchieve:getState() == AchieveState.kHaseFinish then
            --        -- self.m_achieve = temAchieve
            --        self.m_isLock= false
            --         self:refresh()
            --     end
            -- end
        end
    end
end

function This:onRefreshAchieve(typeId)
    if typeId== self.m_acheveType then
        self:refresh()
    end
end
