-- @Author: zheng
-- @Date:   2019-05-14 20:39:11
-- @Last Modified by:   zheng
-- @Last Modified time: 2020-03-24 17:40:48
-- @File Name: GiftMainPanel.lua

GiftMainPanelTabName ={
    kDayGift= 1,
    kWeekGift=2,
    kMonthGift=3,
    kCount =4,
}
local GameUtil = require("Util.GameUtil")
local This , super = class(...,"Dialog")
local AchieveManager = require("Achieve.AchieveManager")
local GiftDayTabNode = require("Achieve.GiftDayTabNode")
This.fileName = "MenuScene/NodeUI/GiftMain.csb"
function This:initNode(info)
    -- if info then
    --    self.m_family = info.family
    -- end
    local csNode = cc.Node:createFromCSFile(This.fileName)
    csNode:setToCenter()
    self:addChild(csNode)
    self.m_csNode = csNode
    local function ceateTab(count)
        local temCount = count or 1
        local node = cc.Node:createFromCSFile("MenuScene/NodeUI/GiftMainPaging.csb")
        local bg = node.Node_1.tep1
        local x,y = bg:getContentSize()
        node:setContentSize(x, y*count)
        return node  
    end
    local tabCount = 2
    local rootNode = ceateTab(tabCount)
    local w, h = rootNode:getContentSize()
    csNode.buttonList:pushNode(rootNode, w, h)
    local tabNode = rootNode.Node_1
    self.m_tabNode = tabNode

    local tabNames =self:getTabList()
    -- for tabKey = 1, GiftMainPanelTabName.kCount do
    for index,tabKey in ipairs(tabNames) do
        local item = tabNode["tep"..index]
        self:addTabButton(tabKey, item, function()
            self:openTabNode(tabKey)
            -- self:createTabNode(tabKey)
            self:lightTabButton(tabKey)
            self.m_selectIndex = tabKey
--            self:refresh()
        end)
    end
    self.m_selectIndex = tabNames[1]
    self:selectTabButton(self.m_selectIndex)

    self.m_inited = true
    -- self:getData()
    -- self:refresh()
    self:refreshDot()
end

function This:onOpen()
    if self.m_tabButtons then
        for name,button in pairs(self.m_tabButtons) do
            if not button.m_touch then
                button:setTouch({
                    onEnded = function ()
                        self:selectTabButton(name)
                    end,
                    isSwallow = false,
                    isContainer = true,
                })
            end
        end
    end
    super.onOpen(self)
end

function This:getTabList()
    return {GiftMainPanelTabName.kDayGift,GiftMainPanelTabName.kWeekGift,GiftMainPanelTabName.kMonthGift}
end

function This:refreshDot()
    local tabNode = self.m_tabNode
	local tabNames = self:getTabList()
    for index,tabKey in ipairs(tabNames) do
        local item1 = tabNode["tep"..index]
        local isHaveRed = self:isHaveRed(tabKey)
        if item1 then
            GameUtil:refreshRedDot(item1, isHaveRed)
        end
    end
end

function This:isHaveRed(tabType)
    if tabType == GiftMainPanelTabName.kDayGift then
        return AchieveManager:hasAchieveFinish(AchieveType.kDayGift) or AchieveManager:isHaveGiftDayBox()
    elseif tabType == GiftMainPanelTabName.kWeekGift then
        return AchieveManager:hasAchieveFinish(AchieveType.kWeekGift)
    elseif tabType == GiftMainPanelTabName.kMonthGift then
        return AchieveManager:hasAchieveFinish(AchieveType.kMonthGift)
    end
    return false
end


function This:createTabNode(name)
    -- print(name)
    if GiftMainPanelTabName.kDayGift == name or GiftMainPanelTabName.kWeekGift then
        return GiftDayTabNode:create({tabType = name})
    end
end

function This:refresh()
    -- local node =self:createTabNode(self.m_selectIndex)
    -- if node then
    --     node:refresh()
    -- end
end

function This:initTouchEvent()
 --    item1:setTouchEnded(function()
	-- 	self:btnCallBack(btnType)
	-- end,item1.bg)
    
 --    self.zhengduo:setTouch({
 --            isScale = false,
 --            isDynamic = true,
 --            isContainer = true,
 --            onEnded = function()
 --                 self:close()
 --            end
 --        })
	
	local csNode = self.m_csNode
    csNode.close:setTouchEnded(function()
        self:close()
    end)
end

function This:onEnter()
    super.onEnter(self)
    AchieveManager:addObserver(self)
end

function This:onExit()
    super.onExit(self)
    AchieveManager:removeObserver(self)
end


function This:onGetAchieveReward(achieve)
   self:refreshDot()
end

function This:onAchieveChanged(typeId,list)
    self:refreshDot()
end

function This:onRefreshAchieve(typeId)
    self:refreshDot()
end

function This:onGetGiftDayBox()
   self:refreshDot() 
end
