--region *.lua
--Date
--此文件由[BabeLua]插件自动生成
-- GongXunAchievePanel

local This , super = class(...,"Dialog")
local MeritoriousMissionBoxConfig = require("Metadatas.MeritoriousMissionBoxConfig")
local AchieveManager = require("Achieve.AchieveManager")
local GongXunAchieveView = require("Achieve.GongXunAchieveView")
local RewardShowPanel = require("UI.RewardShowPanel")
local CommonBox = require("UI.CommonBox")
This.fileName = "MenuScene/NodeUI/TaskMeritoriousBg.csb"
function This:initNode()
	self.m_csNode = cc.Node:createFromCSFile(This.fileName)
	self:addChild(self.m_csNode)
	self.m_csNode:setToCenter()
	self:getData()
	self.m_csNode.title:setString(self.m_txtTitle)
	self.m_csNode.tip:setString(self.m_txtTip)
	self:initBox()
	self:refresh()
end

function This:initBox()
	local config = {desc = self.m_txtDesc}
	for i = 1 , 4 do
		config[i] = MeritoriousMissionBoxConfig[i].gongxun
	end
	self.m_boxNode = CommonBox:create(config)
	self.m_csNode.box:addChild(self.m_boxNode)
	
	self.m_boxNode:setClickHandler(function(index, isFinish, isReward)
		local hasReward = self:hasGongXunBoxReward(index)
		local gongxun = self:getGongXun()
		local state = 0
		if hasReward then
			state = RewardState.kHasReward
		elseif gongxun < MeritoriousMissionBoxConfig[index].gongxun then
			state = RewardState.kNotFinish
		else
			state = RewardState.kCanReward
		end
		local panel = g_scene:openDialog("UI.RewardShowPanel",{
			title = MeritoriousMissionBoxConfig[index].name,
			state = state,
			text = string.format(self.m_txtTextFormat,MeritoriousMissionBoxConfig[index].gongxun)
		})
			
		local rewardList = {}
		for i , info in ipairs(MeritoriousMissionBoxConfig[index].reward) do
			table.insert(rewardList,{id = info[1],num = info[2]})
		end
		panel:setRewardList(rewardList)
		panel:setHandler(function()
			self:btnBoxCallBack(index)
			panel:close()
		end)
	end)
end

function This:initTouchEvent()
	self.m_csNode.help:setTouchEnded(function()
		g_scene:openDialog("UI.HelpTips",{text = self.m_txtHelpTip,node = self.m_csNode.help})
	end)
	self.m_csNode.close:setTouchEnded(function()
		self:close()
	end)
end

function This:onEnter()
	super.onEnter(self)
	AchieveManager:addObserver(self)
end

function This:onExit()
	super.onExit(self)
	AchieveManager:removeObserver(self)
end

function This:getAchieveItemView(achieve)
	local view = GongXunAchieveView:create(achieve)
	view:setGotoHandler(function(ac)
	    if ac:hasGuider() then
			local panel = g_scene:getDialog(self.m_panelName)
			panel:close()
			ac:triggerAncGuider()
	    else
	        g_scene:openDialog("UI.ConfirmPanel", {richText = ac:getWarming()})
	    end
	end)
	return view
end

function This:refreshRewardBox()
	local rewardList = {}
	local gongxun = self:getGongXun()
	for i = 1 , 4 do
		rewardList[i] = self:hasGongXunBoxReward(i)
	end
	self.m_boxNode:setValue(gongxun,rewardList)
end

function This:refresh()
	self:refreshRewardBox()
	local gongxun = self:getGongXun()
	local maxGongXun = self:getMaxGongXun()
	if gongxun >= maxGongXun then
		self.m_csNode.scrollView:removeAllChildren()
		self.m_csNode.tip:setVisible(true)
	else
		local achieveList = self:getCurGongXunAchieveWithSort()
		local itemList = self.m_csNode.scrollView:getItemList()
		for i = #itemList , #achieveList + 1 , -1 do
			self.m_csNode.scrollView:removeItem(i)
		end
		for i , achieve in ipairs(achieveList) do
			if itemList[i] then
				itemList[i]:setModel(achieve)
			else
				local view = self:getAchieveItemView(achieve)
				local w , h = view:getContentSize()
				self.m_csNode.scrollView:pushBackCustomItem(view,w,h,0.5)
			end
		end
		self.m_csNode.tip:setVisible(false)
	end
end

function This:onRefreshAchieve()
	self:refresh()
end

function This:onGetAchieveReward()
	self:refresh()
end

function This:onAchieveChanged(achieveType)
	self:refresh()
end

function This:onGetGongXunBoxReward()
	self:refresh()
end

function This:getMaxGongXun()
	return AchieveManager:getMaxGongXun()
end

function This:getCurGongXunAchieveWithSort()
	return AchieveManager:getCurGongXunAchieveWithSort()
end

function This:hasGongXunBoxReward(index)
	return AchieveManager:hasGongXunBoxReward(index)
end

function This:getGongXun()
	return AchieveManager:getGongXun()
end

function This:btnBoxCallBack(index)
	AchieveManager:onGetGongXunBoxRewardRequest(index)
end

function This:getData()
	self.m_txtTitle = Serialize["achieve_GongXun_1"]
	self.m_txtTip = Serialize["achieve_GongXun_3"]
	self.m_txtDesc = Serialize["achieve_GongXun_2_c"]..":"
	self.m_txtTextFormat = Serialize["achieve_GongXun_4"].."%d"
	self.m_txtHelpTip = Serialize["gongxun_task_help"]
	self.m_panelName = "GongXunAchievePanel"
end

--endregion
