--region *.lua
--Date
--此文件由[BabeLua]插件自动生成
-- GongXunAchieveView
local This , super = class(...,"cc.Node")
local ItemNode = require("UI.ItemNode")
local AchieveManager = require("Achieve.AchieveManager")

function This:init(achieve)
	self.m_achieve = achieve
	self.m_csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/TaskMeritoriousItem.csb")
	self:addChild(self.m_csNode)
	self.m_csNode.scrollview:setDirection("horizontal")
	self.m_csNode.scrollview.m_direction = "right"
	self:setCascadeOpacityEnabled(true)
	local w , h = self.m_csNode.bg:getContentSize()
	self:setContentSize(w,h)
	self.m_csNode:setPosition(w/2,h/2)
	self:setAnchorPoint(0.5,0.5)
	self:getData()
	self.m_csNode.text:setString(self.m_txtText)
end

function This:onEnter()
	super.onEnter(self)
	self:refresh()
	self:refreshReward()
	self:initTouchEvent()
	self.m_achieve:setView(self)
end

function This:onExit()
	super.onExit(self)
	self.m_achieve:setView(nil)
end

function This:refresh()
	self.m_csNode.title:setString(self.m_achieve:getName())
	self.m_csNode.desc:setString(self.m_achieve:getDesc())
	self.m_csNode.renwubar:setPercent(self.m_achieve:getProgress() / self.m_achieve:getMaxProgress() * 100)
	self.m_csNode.num:setString(string.format("%d/%d",self.m_achieve:getProgress(),self.m_achieve:getMaxProgress()))
	local state = self.m_achieve:getState()
	local hasGuider = self.m_achieve:hasGuider()
	self.m_csNode.allfinish:setVisible(state == AchieveState.kHaseReward and not self.m_achieve:hasNextAchieve())
	self.m_csNode.goto:setVisible(state == AchieveState.kUpdating and hasGuider)
	self.m_csNode.help:setVisible(state == AchieveState.kUpdating and not hasGuider)
	self.m_csNode.taskfinish:setVisible(state == AchieveState.kHaseFinish)
	self.m_csNode.num1:setString(self.m_achieve:getGongXun())
end

function This:refreshReward()
	self.m_csNode.scrollview:removeAllItems()
	local itemList = self.m_achieve:getRewardList()
	for i , info in ipairs(itemList) do
		local item = ItemNode:create(info.id,info.num)
		local w , h = item:getContentSize()
		item:setAnchorPoint(0.5,0.5)
		self.m_csNode.scrollview:pushBackCustomItem(item,w,h,0.5)
	end
end

function This:initTouchEvent()
	self.m_csNode.taskfinish:setTouch({
		onEnded = function()
			self:btnBoxCallBack()
		end,
		isScale = false,
		isContainer = true
	})
	self.m_csNode.goto:setTouch({
		onEnded = function()
			if self.m_gotoHandler then
				self.m_gotoHandler(self.m_achieve)
			end
		end,
		isScale = false,
		isContainer = true
	})
	self.m_csNode.help:setTouch({
		onEnded = function()
			if self.m_gotoHandler then
				self.m_gotoHandler(self.m_achieve)
			end
		end,
		isScale = false,
		isContainer = true
	})
	self.m_csNode.scrollview:setSwallowTouch(false)
end

function This:setGotoHandler(handler)
	self.m_gotoHandler = handler
end

function This:setModel(achieve)
	if self.m_achieve ~= achieve then
		self.m_achieve = achieve
		self:refresh()
		self:refreshReward()
	else
		self:refresh()
	end
end

function This:btnBoxCallBack()
	AchieveManager:onGetRewardRequest(self.m_achieve)
end

function This:getData()
	self.m_txtText = Serialize["achieve_GongXun_2_c"]..":"
end
--endregion
