--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"NodeUI")
local MeritoriousMissionBoxConfig = require("Metadatas.MeritoriousMissionBoxConfig")
local AchieveManager = require("Achieve.AchieveManager")
local GongXunAchieveView = require("Achieve.GongXunAchieveView")
local RewardShowPanel = require("UI.RewardShowPanel")

local BoxImage = 
{
	[1] = {
		"MenuScene/boxLock1.png",
		"MenuScene/boxGet1.png",
	},
	[2] = {
		"MenuScene/boxLock2.png",
		"MenuScene/boxGet2.png",
	},
	[3] = {
		"MenuScene/boxLock3.png",
		"MenuScene/boxGet3.png",
	},
	[4] = {
		"MenuScene/boxLock4.png",
		"MenuScene/boxGet4.png",
	}
}

function This:initNode()
	self.m_csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/TaskMeritoriousBg.csb")
	self:addChild(self.m_csNode)
	self.m_maxGongXun = 0
	for i = 1, 4 do
		local gongxun = MeritoriousMissionBoxConfig[i].gongxun
		self.m_csNode["bg"..i].text:setString(gongxun)
		if self.m_maxGongXun < gongxun then
			self.m_maxGongXun = gongxun
		end
	end
	self:refresh()
end

function This:initTouchEvent()
	for i = 1 , 4 do
		self.m_csNode["boxLock"..i]:setTouchEnded(function()
			local hasReward = AchieveManager:hasGongXunBoxReward(i)
			local gongxun = AchieveManager:getGongXun()
			local state = 0
			if hasReward then
				state = RewardState.kHasReward
			elseif gongxun < MeritoriousMissionBoxConfig[i].gongxun then
				state = RewardState.kNotFinish
			else
				state = RewardState.kCanReward
			end
			local panel = g_scene:openDialog("UI.RewardShowPanel",{
				title = MeritoriousMissionBoxConfig[i].name,
				state = state,
				text = string.format(Serialize[60131],MeritoriousMissionBoxConfig[i].gongxun)
			})
			
			local rewardList = {}
			for i , info in ipairs(MeritoriousMissionBoxConfig[i].reward) do
				table.insert(rewardList,{id = info[1],num = info[2]})
			end
			panel:setRewardList(rewardList)
			panel:setHandler(function()
				AchieveManager:onGetGongXunBoxRewardRequest(i)
				panel:close()
			end)
		end)
	end
	self.m_csNode.help:setTouchEnded(function()
		g_scene:openDialog("UI.HelpTips",{text = Serialize[60132],node = self.m_csNode.help})
	end)
end

function This:onEnter()
	super.onEnter(self)
	AchieveManager:addObserver(self)
end

function This:onExit()
	super.onExit(self)
	AchieveManager:removeObserver(self)
end

function This:getAchieveItemView(achieve)
	local view = GongXunAchieveView:create(achieve)
	view:setGotoHandler(function(ac)
		local panel = g_scene:getDialog("AchieveMainPanel")
		panel:close()
		ac:triggerAncGuider()
	end)
	return view
end

function This:refreshRewardBox()
	local gongxun = AchieveManager:getGongXun()
	for i = 1 , 4 do
		if AchieveManager:hasGongXunBoxReward(i) then
			self.m_csNode["boxLock"..i]:setImage(BoxImage[i][2])
		else
			self.m_csNode["boxLock"..i]:setImage(BoxImage[i][1])
		end
	end
end

function This:refresh()
	local gongxun = AchieveManager:getGongXun()
	self.m_csNode.weekvitality:setString(gongxun)
	self.m_csNode.jindubg.jindutiao:setPercent(gongxun / self.m_maxGongXun * 100)
	self:refreshRewardBox()

	local achieveList = AchieveManager:getAchieveWithSort(AchieveType.kGongXun)
	local itemList = self.m_csNode.scrollView:getItemList()
	for i = #itemList , #achieveList + 1 , -1 do
		self.m_csNode.scrollView:removeItem(i)
	end
	for i , achieve in ipairs(achieveList) do
		if itemList[i] then
			itemList[i]:setModel(achieve)
		else
			local view = self:getAchieveItemView(achieve)
			local w , h = view:getContentSize()
			self.m_csNode.scrollView:pushBackCustomItem(view,w,h,0.5)
		end
	end
end

function This:onRefreshAchieve()
	self:refresh()
end

function This:onGetAchieveReward()
	self:refresh()
end

function This:onAchieveChanged()
	self:refresh()
end

function This:onGetGongXunBoxReward()
	self:refresh()
end

--endregion
