-- @Author: superm
-- @Date:   2017-11-28 16:01:39
-- @Last Modified by:   zheng
-- @Last Modified time: 2018-11-20 17:40:30
-- @File Name: JunTuanAchieve.lua
-- @Description: 

local This , super = class(...,"Achieve.TianXiaAchieve")
local LegionWarLegionMissionConfig = require("Metadatas.LegionWarLegionMissionConfig")

local AchieveManager = require("Achieve.AchieveManager")
local GamePlayer = require("Player.GamePlayer")


function This:init(info)
	self.m_id = info.id
	self.m_config = LegionWarLegionMissionConfig[self.m_id]
	self.m_progress = info.num or 0
	self.m_state = info.state or 0
	self.m_type = info.type or 0
	self.m_startTime = -1
end

function This:getFuncReward()
	local config = {{0,0}}--= self.m_config.func

	local itemMap = {[1] = 1015}
	local itemList = {}
	local count = 0
	for i , info in ipairs(config) do
		local itemId = itemMap[info[1]]
		if itemId then
			count = count + 1
			table.insert(itemList,{id = itemId, num = info[2]})
		end
	end
    return itemList, count
end

function This:checkTaskIsOpen()
	local jtdsStartTime = AchieveManager:getWarStarOrEndTime()
	local timeLimit = self.m_config.time_limit
	local res =false
	local curTime = GamePlayer:getServerTime()
	local offsetTime = curTime-jtdsStartTime
	if jtdsStartTime and offsetTime<timeLimit then
		res = true
	end
	return res
end

function This:getJiFen()
	return self.m_config.jifen or 0
end
