-- @Author: zheng
-- @Date:   2018-11-14 17:56:16
-- @Last Modified by:   zheng
-- @Last Modified time: 2018-11-17 17:24:38
-- @File Name: LegionWarSpecificActivityPanel.lua

local This , super = class(...,"Dialog")
This.fileName = "LegionScene/NodeUI/LegionWarSpecificActivity.csb"
local AchieveManager = require("Achieve.AchieveManager")
local GamePlayer = require("Player.GamePlayer")

function This:initNode(info)
    self.m_csNode = cc.Node:createFromCSFile(This.fileName)
    self.m_csNode:setToCenter()
    self:addChild(self.m_csNode)
    self.m_escape = 0
    self.m_map = info.map
    self:refreshTime()
    self:refreshLegion()
end

function This:initTouchEvent()
	self.m_csNode.bg:setTouchEnded(function()
        self:close()
    end)
end

function This:onEnter()
	super.onEnter(self)
	self.m_map:addObserver(self)
end

function This:onExit()
    super.onExit(self)
	self.m_map:removeObserver(self)
end

function This:refreshTime()
    local function formatTime(time)
            local day = math.floor(time / 86400)
            time = time % 86400
            local hour = math.floor(time / 3600)
            time = time % 3600
            local minue = math.floor(time / 60)
            time = time % 60
            local second = time
            return day,hour,minue,second
      end
      local function floorNum(num)
          if not num then
              return 0,0
          end
          local a =math.floor(num/10)
          local b = num%10
          return a,b
      end
    local timeFormat = "MenuScene/num_%d.png"
    local timeNodeCount =3
    if not self.m_timeNodes then
         local timeNodes ={}
         local timeNode = self.m_csNode.time
         for itemIndex=1,timeNodeCount do
             local item1 = timeNode["item"..itemIndex]
             timeNodes[itemIndex]={item1.bg1.num,item1.bg2.num}
         end
         if timeNodes[1] then
             self.m_timeNodes = timeNodes
         end
    end

    if self.m_timeNodes then
      local curTime = GamePlayer:getServerTime()
      local mapEndTime = AchieveManager:getWarStarOrEndTime(true)
        -- local curTime = 1542335434
        -- local mapEndTime = 1545062400
        local offsetTime = mapEndTime-curTime
        local tiems ={00,00,00}
        if offsetTime>0 then
            local day,hour,minue,second = formatTime(offsetTime)
            if day>0 then
                hour= hour+ day*24
                if hour>99 then
                  hour =99
                end
            end
            tiems ={hour,minue,second}
        end
        for itemIndex,itemNodes in ipairs(self.m_timeNodes) do
            local ten,one = floorNum(tiems[itemIndex])
            itemNodes[1]:setImage(string.format(timeFormat,ten))
            itemNodes[2]:setImage(string.format(timeFormat,one))
        end
    end
end

function This:refreshLegion()
    if self.m_map then
        local str = self.m_map:getLuoyangOwnerName()
        self.m_csNode.text3:setString(string.format( Serialize[60137],str))
    end
end

function This:onGetLuoYangBuffStateChange()
    self:refreshLegion()
end

function This:update(dt)
    super.update(self,dt)
    self.m_escape = self.m_escape + dt
    if self.m_escape < 1 then
        return
    end
    self.m_escape = self.m_escape - 1
    self:refreshTime()
end