-- @Author: zheng
-- @Date:   2019-01-29 15:38:45
-- @Last Modified by:   zheng
-- @Last Modified time: 2019-02-27 15:03:30
-- @File Name: LimitedTimePreferentialPanel.lua

local GameUtil = require("Util.GameUtil")
local SdkManager = require("Sdk.SdkManager")
local AchieveManager = require("Achieve.AchieveManager")
local NewActivityManager = require("NewActivity.NewActivityManager")
-- local PushGiftConfig = require("Metadatas.PushGiftConfig")

local This , super = class(...,"Dialog")
-- local FamilyManager = require("Official.FamilyManager")
This.fileName = "MenuScene/NodeUI/LimitedTimePreferential.csb"
function This:initNode(info)
    -- if info then
    --    self.m_family = info.family
    -- end
    self.m_achieve = info.achieve
    self.m_activityId = info.activityId
    self.m_activity = NewActivityManager:getActivity(self.m_activityId) 
    self.m_achieveType = self.m_achieve:getType()
    self.m_csNode = cc.Node:createFromCSFile(This.fileName)
    self.m_csNode:setToCenter()
    self:addChild(self.m_csNode)
    self.m_escape = 0
--    self:getData()
    self:refreshTime()
    self:refresh()

end

function This:refresh()
    local achieve = self.m_achieve
    local yuanBaoNum = achieve:getYuanBaoNum()
    local price = achieve:getPrice()
    local reward = achieve:getRewardList()
    local state = achieve:getState()
    local imageName = achieve:getImageName()

    local csNode = self.m_csNode
    local btnPriceTxt = csNode.Recharge.text
    
    csNode.push:setImage(string.format("MenuScene/%s.png",imageName))

    btnPriceTxt:setString(string.format(Serialize["achieve_TimePreferential_3_c"],price))
    GameUtil:resetScoolItemNode(csNode.scrollView,reward)
    csNode.Recharge:setVisible(state == AchieveState.kUpdating)
    csNode.lingqu:setVisible(state == AchieveState.kHaseFinish)

end

function This:initTouchEvent()
    
	local csNode = self.m_csNode
    csNode.close:setTouchEnded(function()
        self:close()
    end)
    csNode.Recharge:setTouchEnded(function()--购买
        local achieve = self.m_achieve
        if achieve then
            local buyId = achieve:getBuyId()
            SdkManager:onApplyBillIDRequest(buyId)
        end
    end)

	csNode.lingqu:setTouchEnded(function()--领 取
        AchieveManager:onGetRewardRequest(self.m_achieve)
    end)
end

function This:onEnter()
    super.onEnter(self)
    AchieveManager:addObserver(self)
end

function This:onExit()
    super.onExit(self)
    AchieveManager:removeObserver(self)
end

function This:refreshTime()
    local tiemTxt = self.m_csNode.time
    -- local str = GameUtil:formatTime(Serialize["H_M_S"],0)
    local achieve = self.m_achieve
    local activity = self.m_activity
    if achieve and activity then
        local duration = achieve:getDuration()
        local str,leftTime = activity:getLeftTime(duration)
        tiemTxt:setString(str)
        -- if leftTime <=0 then
        --     self:close()
        -- end
    end
end

function This:update(dt)
    super.update(self,dt)
    self.m_escape = self.m_escape + dt
    if self.m_escape > 1 then
        self.m_escape = self.m_escape - 1
        self:refreshTime()
    end
end

-- function This:getData()
-- 	self.m_config = PushGiftConfig[103]
-- end


function This:onGetAchieveReward(achieve)
    local temAchieve = self.m_achieve
    if achieve and temAchieve then
        local achieveId = achieve:getId()
        local achieveType = achieve:getType()
        local temId = temAchieve:getId()
        local temType = self.m_achieveType
        if achieveId == temId and temType == achieveType then
           local nextAchieveId,isHaveNext = temAchieve:getNextAchiveId()
           local activity = self.m_activity
           if isHaveNext then
               self.m_achieve = AchieveManager:getAchieve(temType, nextAchieveId)
               if self.m_achieve then
                   self:refresh()
               end
           else
               self:close()
           end
           if activity then
               activity:setCurentAchieveId(nextAchieveId)
               activity:notifyObservers("onGetActivityPushGiftInfo", activity:getId())
           end
        end
    end
end

function This:onAchieveChanged()
    self:refresh()
end
