--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"Base.BaseModel")
local RoleMissionConfig = require("Metadatas.RoleMissionConfig")
local GuideManager = require("Guide.GuideManager")
local ViewUtil = require("UI.ViewUtil")

function This:init(info)
	self.m_id = info.id
	self.m_type = info.type or 0
	self.m_config = RoleMissionConfig[self.m_id]
	self.m_progress = info.num or 0
	self.m_state = info.state or 0
end

function This:getId()
	return self.m_id
end

function This:getType()
	return self.m_type
end

function This:getProgress()
	return self.m_progress
end

function This:getState()
	return self.m_state
end

function This:setState(state)
	self.m_state = state
end

function This:setView(view)
	self.m_view = view
end

function This:setProgress(progress)
	self.m_progress = progress
end

function This:getName()
	return self.m_config.name
end

function This:getDesc()
	return self.m_config.des
end

function This:getDetailDesc()
	return self.m_config.des2
end

function This:getMaxProgress()
	return self.m_config.progress
end

function This:updateInfo(info)
	self.m_state = info.state
	self.m_progress = info.num or 0
end

function This:getAchieveTypeId()
	return RoleMissionConfig[self.m_id].front_id
end

function This:getRewardList()
	local itemList = {}
	for i , info in ipairs(self.m_config.reward) do
		table.insert(itemList,{id = info[1], num = info[2]})
	end
	return itemList
end

function This:hasGuider()
    if self.m_config.guide_data and self.m_config.guide_data ~= "" then
    	return true
    end

    if self.m_config.panel and self.m_config.panel ~= "" then
    	return true
    end
    return false
end

function This:getWarming()
    return self.m_config.warming  
end

function This:getGotoPanel()
	return self.m_config.panel
end

function This:triggerAncGuider()
	if self.m_config.guide_data ~= "" then
		GuideManager:triggerAncGuider(self.m_config.guide_data)
	elseif self.m_config.panel ~= "" then
		local panelName = self.m_config.panel.name
		if panelName == "System.BuyPowerMain" and require("System.SystemManager"):getPowerIsFull() then
    		g_scene:showTips(Serialize["System_SystemManager_1"])
    		return true
		end
		ViewUtil:jumpToPanel(panelName,self.m_config.panel.arg)
	end
    return false
end

function This:getGuideSession()
	return self.m_config.guide
end

function This:getChapterTitle()
	return self.m_config.des_title
end

function This:isCycleCheck()
	return self.m_config.guide_check >= 1
end

--endregion
