--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"Dialog")
local MainAchieveView = require("Achieve.MainAchieveView")
local AchieveManager = require("Achieve.AchieveManager")
local ItemNode = require("UI.ItemNode")

function This:initNode()
	self.m_csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/RoleMissionMain.csb")
	self:addChild(self.m_csNode)
	self.m_csNode:setToCenter()
	self.m_viewList = {}
	for i = 1 , 4 do
		local view = MainAchieveView:create()
		self.m_csNode["task"..i]:addChild(view)
		table.insert(self.m_viewList,view)
		view:setSelectHandler(function()
			self:selectAchieveView(view)
		end)
	end
	self.m_mainView = MainAchieveView:create()
	self.m_csNode.task6:addChild(self.m_mainView)
	self.m_mainView:setSelectHandler(function()
		self:selectAchieveView(self.m_mainView)
	end)
	self.m_rewardNodeList = {}
end

function This:initTouchEvent()
	self.m_csNode.close:setTouchEnded(function()
		self:close()
	end)
	self.m_csNode.goto:setTouchEnded(function()
		self:close()
		local achieve = self.m_curSelectView:getModel()
		achieve:triggerAncGuider()
	end)
	self.m_csNode.taskfinish:setTouchEnded(function()
		local achieve = self.m_curSelectView:getModel()
		AchieveManager:onGetRewardRequest(achieve)
	end)
end

function This:onEnter()
	super.onEnter(self)
	self:refreshItem()
	AchieveManager:addObserver(self)
end

function This:onExit()
	super.onExit(self)
	AchieveManager:removeObserver(self)
end

function This:updateAchieveInfo(achieve)
	self.m_csNode.title:setString(achieve:getName())
	
	if achieve:getState() == AchieveState.kHaseFinish then
		self.m_csNode.target:setColor(184,228,97)  --已完成
		self.m_csNode.target:setStringWithColor(string.format("<New9>%s (%d/%d)",achieve:getDesc(),achieve:getProgress(),achieve:getMaxProgress()))
	else
		self.m_csNode.target:setColor(254,0,0) --未完成
		self.m_csNode.target:setStringWithColor(string.format("<New11>%s (%d/%d)",achieve:getDesc(),achieve:getProgress(),achieve:getMaxProgress()))
	end
	self.m_csNode.describe:setStringWithColor(achieve:getDetailDesc(),465)
	local rewardList = achieve:getRewardList()

	for i = 1 , 4 do
		self.m_csNode["item"..i]:setVisible(i <= #rewardList)
		if i <= #rewardList then
			local info = rewardList[i]
			local node = self.m_rewardNodeList[i]
			if node then
				node:initItem(info.id,info.num)
			else
				node = ItemNode:create(info.id,info.num)
				node:setAnchorPoint(0.5,0.5)
				self.m_csNode["item"..i]:addChild(node)
				self.m_rewardNodeList[i] = node
			end
		end
	end
	self.m_csNode.goto:setVisible(achieve:getState() ~= AchieveState.kHaseFinish)
	self.m_csNode.taskfinish:setVisible(achieve:getState() == AchieveState.kHaseFinish)
end

function This:selectAchieveView(view)
	if self.m_curSelectView ~= view then
		if self.m_curSelectView then
			self.m_curSelectView:setIsSelected(false)
		end
		self.m_curSelectView = view
		self.m_curSelectView:setIsSelected(true)
		local achieve = self.m_curSelectView:getModel()
		self:updateAchieveInfo(achieve)
	end
end

function This:refreshItem()
	local mainAchieve = AchieveManager:getCurMainAchieve()
	self.m_mainView:setModel(mainAchieve)
	local achieveList = {}
	if mainAchieve then
		achieveList = AchieveManager:getMainSubAchieve(mainAchieve:getId())
	end
	for i , view in ipairs(self.m_viewList) do
		if i <= #achieveList then
			view:setModel(achieveList[i])
			if view:isSelected() then
				self:updateAchieveInfo(achieveList[i])
			end
		else
			if view:isSelected() then
				self.m_curSelectView = nil
			end
			view:setModel()
		end
	end

	if self.m_mainView:isSelected()  then
		if self.m_mainAchieve == mainAchieve or #achieveList <= 0 then
			self:updateAchieveInfo(mainAchieve)
		else
			self:selectAchieveView(self.m_viewList[1])
		end
	elseif not self.m_curSelectView then
		if self.m_viewList[1]:getModel() then
			self:selectAchieveView(self.m_viewList[1])
		else
			self:selectAchieveView(self.m_mainView)
		end
	end
	self.m_mainAchieve = mainAchieve
end

function This:isMainAchieveSelected()
	local achieve = self.m_curSelectView:getModel()
	return self.m_mainAchieve == achieve
end

function This:onGetAchieveReward(achieve)
	self:refreshItem()
end

--endregion
