--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"NodeUI")
local AchieveManager = require("Achieve.AchieveManager")
local Timer = require("Timer")
local MainAchieveView = require("Achieve.MainAchieveView")
local ViewUtil = require("UI.ViewUtil")

function This:initNode()
	self.m_csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/TaskThread.csb")
	self:addChild(self.m_csNode)
	self.m_timer = Timer:create(self)
	self:refreshItems()
end

function This:refreshItems()
	self.m_timer:removeAllTimer()
	self.m_csNode.scrollView:removeAllItems()
	local achieveList = AchieveManager:getAchieveWithSort(AchieveType.kMainLine)
	for i , achieve in ipairs(achieveList) do
		self.m_timer:setTimer(i * 0.01,function()
			local view = MainAchieveView:create(achieve)
			local w , h = view:getContentSize()
			view:setAnchorPoint(0.5,0.5)
			view:setGotoHandler(function (ac)
				local panel = g_scene:getDialog("AchieveMainPanel")
				panel:close()
				ac:triggerAncGuider()
			end)
			self.m_csNode.scrollView:pushBackCustomItem(view,w,h,0.5)
		end)
	end
end

function This:onEnter()
	super.onEnter(self)
	self:scheduleUpdate()
	AchieveManager:addObserver(self)
end

function This:onExit()
	super.onExit(self)
	AchieveManager:removeObserver(self)
end

function This:onGetAchieveReward()
	self:refreshItems()
end


--endregion
