-- @Author: Su
-- @Date:   2019-01-30 17:14:30
-- @Last Modified by:   Su
-- @Last Modified time: 2019-01-30 17:14:30
-- @File Name: TaskContendBoxTaskItem.lua

local This , super = class(...,"NodeUI")
local GamePlayer = require("Player.GamePlayer")
local GuideManager = require("Guide.GuideManager")
local AchieveManager = require("Achieve.AchieveManager")
local ViewUtil = require("UI.ViewUtil")

local MatchManager = require("Match.MatchManager")
local TaskContendBoxItem = require("Achieve.TaskContendBoxItem")
-- local BoxMissionConfig = require("Metadatas.BoxMissionConfig")

This.fileName = "MenuScene/NodeUI/TaskContendBoxTask.csb"

function This:initData( info )
    self.m_achieve = info.achieve
    self.m_id = self.m_achieve:getId()
    self.m_config = self.m_achieve:getConfig()
    self:refresh()
end

function This:refresh()
    local color = QualityColor[self.m_config.quality]
    self.title:setColor(color.r,color.g,color.b)

    local text = string.format( "(%d/%d)",self.m_achieve:getProgress(),self.m_config.progress)
    self.title:setString(self.m_config.name)
    self.desc:setString(self.m_config.des..text)
    -- self.jidutiao.num:setString(string.format( "%d/%d",self.m_achieve:getProgress(),self.m_config.progress))
    -- self.jidutiao.jindu:setScaleX(self.m_achieve:getProgress()/self.m_config.progress)

    local state = self.m_achieve:getState()
	local hasGuider = self.m_achieve:hasGuider()
    self.goto:setVisible(state == AchieveState.kUpdating and hasGuider)
    self.wenhao:setVisible(state == AchieveState.kUpdating and not hasGuider)
    self.lingqu:setVisible(state == AchieveState.kHaseFinish)
    self.yilingqu:setVisible(state == AchieveState.kHaseReward)
    if state == AchieveState.kHaseReward then
        self.dian:setImage("MenuScene/dian8.png")
    else
        self.dian:setImage("MenuScene/dian7.png")
    end
end

function This:initTouchEvent()
    if self.goto then
        self.goto:setTouch({
            onEnded = function()
                local panel = g_scene:getDialog("AchieveMainPanel")
				panel:close()
                self:triggerAncGuider()
            end,
            isScale = false,
            isContainer = true
        })
    end
    if self.wenhao then
        self.wenhao:setTouch({
            onEnded = function()
                g_scene:openDialog("UI.ConfirmPanel", {richText = self.m_config.warming})
            end,
            isScale = false,
            isContainer = true
        })
    end
    if self.lingqu then
        self.lingqu:setTouch({
            onEnded = function()
                local boxList = MatchManager:getAllBox()
                if #boxList < 6 then 
                    AchieveManager:onGetRewardRequest(self.m_achieve)
                else
                    g_scene:showTips(Serialize[60157])
                end
            end,
            isScale = false,
            isContainer = true
        })
    end
end

function This:onEnter()
	super.onEnter(self)
	-- AchieveManager:addObserver(self)
end

function This:onExit()
	super.onExit(self)
	-- AchieveManager:removeObserver(self)
end


function This:triggerAncGuider()
	if self.m_config.guide_data and self.m_config.guide_data ~= "" then
		GuideManager:triggerAncGuider(self.m_config.guide_data)
	elseif self.m_config.panel then
		local panel = self.m_config.panel
		ViewUtil:jumpToPanel(panel.name,panel.arg)
	end
end

-- function This:onGetAchieveReward()
-- 	self:refresh()
-- end

-- function This:onAchieveChanged(type)
--     if type == AchieveType.kZhengJi then
--         self:refresh()
--     end
-- end

