-- @Author: superm
-- @Date:   2017-11-28 16:01:39
-- @Last Modified by:   superm
-- @Last Modified time: 2017-12-04 18:50:11
-- @File Name: TianXiaAchieve.lua
-- @Description: 

local This , super = class(...,"Achieve.MapAchieve")
local TianxiaMissionConfig = require("Metadatas.TianxiaMissionConfig")
local GamePlayer = require("Player.GamePlayer")

function This:init(info)
	self.m_id = info.id
	self.m_config = TianxiaMissionConfig[self.m_id]
	self.m_progress = info.num or 0
	self.m_state = info.state or 0
	self.m_type = info.type or 0
	self.m_startTime = -1
end

function This:getIndex()
    return self.m_id % 100
end

function This:getDesc()
	return self.m_config.des1
end

function This:getTargetDesc()
	return self.m_config.des2
end

function This:setStartTime( value )
    self.m_startTime = value
end

function This:hasStarted()
	return self.m_startTime > 0
end

function This:getLeftTime()
	if self.m_startTime > 0 then
		local endTime = self.m_startTime + self.m_config.time_limit
		local leftTime = endTime - GamePlayer:getServerTime()
		return leftTime > 0 and leftTime or 0
	end
	return 0
end

function This:getFuncReward()
	local config = self.m_config.func

	local itemMap = {[1] = 1015}
	local itemList = {}
	local count = 0
	for i , info in ipairs(config) do
		local itemId = itemMap[info[1]]
		if itemId then
			count = count + 1
			table.insert(itemList,{id = itemId, num = info[2]})
		end
	end
    return itemList, count
end

function This:getFuncLevel()
	local config = self.m_config.func
	for _, info in ipairs(config) do
		 return info[2]
	end
    return 0
end