-- @Author: superm
-- @Date:   2017-11-28 19:33:14
-- @Last Modified by:   zheng
-- @Last Modified time: 2018-11-21 18:52:26
-- @File Name: TianXiaAchievePanel.lua
-- @Description: 

local This , super = class(...,"Dialog")
local AchieveManager = require("Achieve.AchieveManager")
local TianXiaAchieveView = require("Achieve.TianXiaAchieveView")
local UpdateLayer = require("Rank.RankListLayer")
This.fileName = "MenuScene/NodeUI/GreatEventsBg.csb"

function This:initNode()
	self:getData()
	AchieveManager:onGetAchieveInfoRequest(self.m_uiType)
	self.m_csNode = cc.Node:createFromCSFile(This.fileName)
	self:addChild(self.m_csNode)
	self.m_csNode:setToCenter()

	self.m_listLayer = UpdateLayer:create({
        itemWidth = 710,
        itemHeight = 200,
        spaceX = 0,
        spaceY = 2,
        scrollView = self.m_csNode.scrollView,
    })
    
    self.m_listLayer:setAnchorPoint(0.5,0)
    local w , h = self.m_listLayer:getContentSize()
    self.m_csNode.scrollView:pushBackCustomItem(self.m_listLayer, w, h, 0)
    self.m_listLayer:setCascadeOpacityEnabled(true)
    
    self.m_csNode.title:setString(self.m_panelTitle)
end

function This:refresh()
	local achieveList = AchieveManager:getAchieveWithSort(self.m_uiType)
	local selectIndex = 0
	for achieveIndex,achieve in ipairs(achieveList) do
		local aState = achieve:getState()
		if aState ==AchieveState.kHaseFinish or aState ==AchieveState.kUpdating then
			local temId =achieve:getIndex()
			if selectIndex ==0 then
				selectIndex = temId
			elseif temId<selectIndex then
				selectIndex = temId
			end
		end
	end
	if selectIndex ==0 then
		selectIndex =1
	end
    self.m_listLayer:setDataList(achieveList, function(achieve, index)
        return self:createItem(achieve)
    end,nil,selectIndex)

	-- self.m_csNode.scrollView:removeAllItems()
	-- local achieveList = AchieveManager:getAchieveWithSort(self.m_uiType)
	-- for i , achieve in ipairs(achieveList) do
	-- 	self:setTimer(i * 0.1, function()
	-- 		local view = TianXiaAchieveView:create(achieve)
	-- 		local w , h = view:getContentSize()
	-- 		self.m_csNode.scrollView:pushBackCustomItem(view, w, h)
	-- 	end, "TianXiaAchieveView" .. i)
	-- end
end

function This:initTouchEvent()
	self.m_csNode.close:setTouchEnded(function()
		self:close()
	end)
end

function This:onEnter()
	super.onEnter(self)
	AchieveManager:addObserver(self)
end

function This:onExit()
	AchieveManager:removeObserver(self)
	super.onExit(self)
end

function This:onRefreshAchieve()
	self:refresh()
end

function This:onGetAchieveReward(achieve)
	if achieve:getType() == self.m_uiType then
		local itemList = achieve:getRewardList()
		g_scene:showReward(itemList)
		achieve:setState(AchieveState.kHaseReward)
	end
end

function This:createItem(achieve)
	return TianXiaAchieveView:create(achieve)
end

function This:getData()
	self.m_uiType = AchieveType.kTianXiaDaShi
	self.m_panelTitle = Serialize["achieve_TianXia_1"]
end