-- @Author: superm
-- @Date:   2017-10-27 15:01:17
-- @Last Modified by:   superm
-- @Last Modified time: 2018-01-27 15:33:37
-- @File Name: WeeklyAchieve.lua
-- @Description: 活跃任务

local This , super = class(...,"Achieve.MainAchieve")
local WeekMissionConfig = require("Metadatas.WeekMissionConfig")

function This:init(info)
	self.m_id = info.id 						-- 配置表主键，前后端通信使用
	self.m_index = info.index
	self.m_config = WeekMissionConfig[self.m_id]
	self.m_progress = info.num or 0
	self.m_state = info.state or 0
	self.m_type = info.type or 0
end

function This:getProgress()
	return math.min(self.m_progress,self.m_config.progress)
end

function This:getVitality()
	return self.m_config.vitality_num
end

function This:getConfig()
	return self.m_config
end

function This:setProgress(progress)
	self.m_progress = progress
	if self.m_view then
		self.m_view:refresh()
	end
end

function This:setState(state)
	self.m_state = state
	if self.m_view then
		self.m_view:refresh()
	end
end

function This:updateInfo(info)
	self.m_type = info.type
	self.m_progress = info.num
	self.m_state = info.state
	if self.m_view then
		self.m_view:refresh()
	end
end