-- @Author: superm
-- @Date:   2017-10-30 21:22:21
-- @Last Modified by:   zheng
-- @Last Modified time: 2019-03-06 15:03:11
-- @File Name: WeeklyAchieveBoxPanel.lua
-- @Description: 

local This , super = class(...,"Dialog")
local VitalityManager = require("Achieve.VitalityManager")
local ItemNode = require("UI.ItemNode")

function This:initNode(info)
	self.m_type = info.type
	self.m_index = info.index
	self.m_config = info.config
	local csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/TaskBattlefieldBox.csb")
	self.m_csNode = csNode
	self:addChild(csNode)
	csNode:setToCenter()
	csNode.title:setString(self.m_config.name)

	local rewardList = self.m_config.reward
	local count = #rewardList
	local scrollView = csNode.scrollView
	local itemtipslist = csNode.itemtipslist
	if count <= 4 then
		local w = 5
		for i , info in ipairs(rewardList) do
			local node = ItemNode:create(info[1],info[2])
			node:setAnchorPoint(0,0.5)
			node:setPositionX(w)
			w = w + node:getContentWidth() + 10
			itemtipslist:addChild(node)
		end
		itemtipslist:setPositionX(- w / 2)
		itemtipslist:setVisible(true)
		scrollView:setVisible(false)
	else
		scrollView:removeAllChildren()
		scrollView.m_direction = "right"
		for i , info in ipairs(rewardList) do
			local item = ItemNode:create(info[1], info[2])
			item:setAnchorPoint(0.5,0.5)
			local w , h = item:getContentSize()
			scrollView:pushBackCustomItem(item, w, h ,0.5)
		end
		itemtipslist:setVisible(false)
		scrollView:setVisible(true)
	end

	self:refreshNote(info)
end

function This:refreshNote(info)
	local vitality  = info.vitality
	local hasRecieve = false
	if vitality < self.m_config.vitality then
		if self.m_type == VitalityBoxType.kDaily then
			self.m_csNode.condition:setString(string.format(Serialize[60166], self.m_config.vitality))
		else
			self.m_csNode.condition:setString(string.format(Serialize[60167], self.m_config.vitality))
		end
	else
		if self.m_type == VitalityBoxType.kDaily then
			hasRecieve = VitalityManager:isDailyBoxReward(self.m_index, AchieveType.kWeekly)
		else
			hasRecieve = VitalityManager:isBoxReward(self.m_index, AchieveType.kWeekly)
		end
	end

	self.m_csNode.condition:setVisible(vitality < self.m_config.vitality)
	self.m_csNode.yilingqu:setVisible(hasRecieve)
	self.m_csNode.lingqu:setVisible(vitality >= self.m_config.vitality and not hasRecieve)
end

function This:initTouchEvent()
	self.m_csNode.close:setTouchEnded(function()
		self:close()
	end)
	self.m_csNode.lingqu:setTouchEnded(function()
		VitalityManager:onGetBoxRewardRequest(self.m_index, self.m_type)
	end)
end

function This:onEnter()
	super.onEnter(self)
	VitalityManager:addObserver(self)
end

function This:onExit()
	super.onExit(self)
	VitalityManager:removeObserver(self)
end

function This:onGetBoxReward(index, boxType)
	if self.m_index == index then
		self:close()
	end
end