-- @Author: zheng
-- @Date:   2018-11-01 15:58:00
-- @Last Modified by:   zheng
-- @Last Modified time: 2018-11-17 16:45:48
-- @File Name: WeiWangAchievePanel.lua
local AchieveManager = require("Achieve.AchieveManager")
local LegionWarMissionBoxConfig = require("Metadatas.LegionWarMissionBoxConfig")

local CommonBox = require("UI.CommonBox")
local This , super = class(...,"Achieve.GongXunAchievePanel")

This.panelType = AchieveType.kWeiWang

-- local boxIndex,weiWangLimit,reward,name =self:getBoxRewardData(self.m_boxIdList[index])
function This:getBoxRewardData(confBoxId)
	local configData = LegionWarMissionBoxConfig[confBoxId]
	if confBoxId and configData then
		return configData.box,configData.prestige_num,configData.reward,configData.name
	end
	return nil,nil,nil,nil
end

function This:initBox()
	AchieveManager:onGetAchieveInfoRequest(This.panelType)
	local config = {desc = self.m_txtDesc}
	local boxList = AchieveManager:getWeiWangBoxList()
	self.m_boxIdList ={}
	for confBoxId,boxisReceived in pairs(boxList) do
		local boxIndex,weiWangLimit =self:getBoxRewardData(confBoxId)
		config[boxIndex]= weiWangLimit
		self.m_boxIdList[boxIndex]= confBoxId
	end
	self.m_boxNode = CommonBox:create(config)
	self.m_csNode.box:addChild(self.m_boxNode)
	self.m_boxNode:setClickHandler(function(index, isFinish, isReward)
		local hasReward = self:hasGongXunBoxReward(index)
		local gongxun = self:getGongXun()
		local boxIndex,weiWangLimit,reward,name =self:getBoxRewardData(self.m_boxIdList[index])
		local state = 0
		if hasReward then
			state = RewardState.kHasReward
		elseif gongxun < weiWangLimit then
			state = RewardState.kNotFinish
		else
			state = RewardState.kCanReward
		end
		local panel = g_scene:openDialog("UI.RewardShowPanel",{
			title = name,
			state = state,
			text = string.format(self.m_txtTextFormat,gongxun)
		})
			
		local rewardList = {}
		for i , info in ipairs(reward) do
			table.insert(rewardList,{id = info[1],num = info[2]})
		end
		panel:setRewardList(rewardList)
		panel:setHandler(function()
			self:btnBoxCallBack(index)
			panel:close()
		end)
	end)
end

function This:getMaxGongXun()
	return AchieveManager:getMaxGongXun(This.panelType)
end

function This:getCurGongXunAchieveWithSort()
	return AchieveManager:getCurGongXunAchieveWithSort(This.panelType)
end

function This:hasGongXunBoxReward(index)
	local confBoxId = self.m_boxIdList[index]
	return AchieveManager:hasWeiWangBoxReward(confBoxId)
end

function This:getGongXun()
	return AchieveManager:getGongXun(This.panelType)
end

function This:btnBoxCallBack(index)
	local confBoxId = self.m_boxIdList[index]
	AchieveManager:onGetWeiWangBoxRewardRequest(confBoxId)
end

function This:getData()
	self.m_txtTitle = Serialize["achieve_WeiWang_1"]
	self.m_txtTip = Serialize["achieve_WeiWang_3"]
	self.m_txtDesc = Serialize["achieve_WeiWang_2_c"]..":"
	self.m_txtTextFormat = Serialize["achieve_WeiWang_4"].."%d"
	self.m_txtHelpTip = Serialize["achieve_WeiWang_5"]
	self.m_panelName = "WeiWangAchievePanel"
end

function This:onGetWeiWangBoxReward()
	self:refresh()
	-- self:initBox()
end

function This:onRefreshAchieve()
	self:refresh()
	-- self:initBox()
end
-- if typeId and typeId == AchieveType.kWeiWang then
-- 		achieves = self.m_curWeiWangAchieves
-- 	end

-- gongxun
-- self.m_gongxunAchieves = {}
-- self.m_gongxun = 0
-- self.m_gongxunBoxIsReward = {}
-- self.m_curGongXunAchieves = {}
-- self.m_maxGongxun = 0

-- WeiWang
-- self.m_weiWangAchieves = {}
-- self.m_weiWang = 0
-- self.m_weiWangBoxIsReward = {}
-- self.m_curWeiWangAchieves = {}
-- self.m_maxWeiWang = self.m_maxGongxun

-- AchieveType.kWeiWang

