--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This = class(...)
local Vec = require("Vec")

function This:create(...)
	local p = {}
	setmetatable(p,self)
	p:init(...)
	return p
end

function This:init(info)
	assert(info.bx and info.by and info.ex and info.ey and info.time)
	self.m_bp = Vec(info.bx,info.by)
	self.m_ep = Vec(info.ex,info.ey)
	self.m_time = info.time
	self.m_av = -info.av or -10 --加速度（垂直向下）
	self.m_node = info.arrowNode
	self.m_nodeAngle = info.nodeAngle or 0

	self.m_vx = (self.m_ep.x - self.m_bp.x) / self.m_time
	self.m_vy = ((self.m_ep.y - self.m_bp.y) - (0.5 * self.m_av * self.m_time * self.m_time)) / self.m_time
	self.m_prePoint = Vec(self.m_bp.x,self.m_bp.y)
	self.m_curPoint = Vec(self.m_bp.x,self.m_bp.y)
	self.m_escape = 0
end 

function This:isFinish()
	return self.m_escape >= self.m_time
end

function This:getCurPoint()
	return self.m_curPoint
end

function This:update(dt)
	if self.m_escape <= self.m_time then
		self.m_escape = self.m_escape + dt

		self.m_curPoint.x = self.m_bp.x + self.m_vx * self.m_escape
		self.m_curPoint.y = self.m_bp.y + self.m_vy * self.m_escape + 0.5 * self.m_av * self.m_escape * self.m_escape
		
		if self.m_node then
			self.m_node:setPosition(self.m_curPoint.x,self.m_curPoint.y)
			local dp = Vec(self.m_curPoint.x-self.m_prePoint.x,self.m_curPoint.y - self.m_prePoint.y)
			local degree = dp:getDegree()
			self.m_node:setRotation(-(degree-self.m_nodeAngle))
		end
		self.m_prePoint.x = self.m_curPoint.x
		self.m_prePoint.y = self.m_curPoint.y
	else
		assert(true)
	end
end

--endregion
