--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This = class(...)
local SlideAction = require("Action.SlideAction")
local DragAction = require("Action.DragScale")
local TouchAllListener = require("cc.TouchAllListener")

function This:create(info)
	local o = {}
	setmetatable(o,self)
	o:init(info)
	return o
end

function This:init(info)
	self.m_node = info.node
	self.m_slideAction = SlideAction:create(info)
	self.m_dragAction = DragAction:create(info)	
	self.m_touchList = {}
	self.m_isEnable = true
	self:initListener()
end

function This:initListener()
	self.m_allListener = TouchAllListener:create({
		onMoved = function(_,touchList)
			self:onTouchesMoved(touchList)
		end,
		onEnded = function(_,touchList)
			self:onTouchesEnded(touchList)
		end,
		onBegan = function(_,touchList)
			self:onTouchesBegan(touchList)
		end
	})
	self.m_node:addEventListener(self.m_allListener)
end

function This:clear()
	
end

function This:setTouchEnable(isEnable)
	self.m_isEnable = isEnable
end

function This:setSlideHandler(handler)
	self.m_slideAction:setSlideHandler(handler)
end

function This:setScaleHandler(handler)
	self.m_dragAction:setScaleHandler(handler)
end

function This:onTouchesBegan(touchList)
	if self.m_node[0] == 0 then
		return;
	end
	if not self.m_isEnable then
		return 
	end

	for i , touch in pairs(touchList) do
		self.m_touchList[touch.id] = touch	
	end
	
	if table.count(self.m_touchList) > 1 then
		self.m_slideAction:setEnable(false)
		self.m_dragAction:setEnable(true)
	else
		self.m_slideAction:setEnable(true)
		self.m_dragAction:setEnable(false)
	end	
	self.m_slideAction:onTouchBegan(touchList[1])
	self.m_dragAction:onTouchesBegan(touchList)
end

function This:onTouchesMoved(touchList)
	if self.m_node[0] == 0 then
		return
	end
	if not self.m_isEnable then
		return 
	end

	if #touchList > 1 then
		self.m_dragAction:onTouchesMoved(touchList)
	else
		self.m_slideAction:onTouchMoved(touchList[1])
	end
end

function This:onTouchesEnded(touchList)
	if self.m_node[0] == 0 then
		return
	end
	if not self.m_isEnable then
		return 
	end

	for i , touch in pairs(touchList) do
		self.m_touchList[touch.id] = nil
	end
	self.m_slideAction:onTouchEnded(touchList[1])
	self.m_dragAction:onTouchesEnded(touchList)
end

function This:update(dt)
	if self.m_isEnable then
		self.m_dragAction:update(dt)
		self.m_slideAction:update(dt)
	end
end

--endregion
