-- @Author: superm
-- @Date:   2019-01-21 17:14:42
-- @Last Modified by:   superm
-- @Last Modified time: 2019-03-02 22:56:56
-- @File Name: ActBoxModel.lua
-- @Description: 

local This, super = class(..., "Activity.ActivityBaseModel")
local ActivityManager = require("Activity.ActivityManager")

function This:getCondition()
	local cond = self.m_config.ulock
	if type(cond) ~= "number" then
		local ctype = cond[1]
		if ctype >= 1 then
            return {1, true}
		end
	else
		return {2, cond}
	end
end

function This:isNotLockedBy( cond1, cond2 )
    if not self.m_config then
        return false
    end

    local switch = {
        [1] = function(arg, index)  
            return self:getCurNum(index) == arg
        end,  
        [2] = function(arg, index)  
            local queue = self:getQueue()
            if queue then
                local number = queue:getCurNum(index) or 0
                return number >= arg 
            else
                return false
            end
        end
    }  
      
    local fSwitch = switch[cond1] --switch func  
      
    if fSwitch then --key exists  
        local result = fSwitch(cond2, self:getId()) --do func  
        return result
    else
        return false
    end 
end

function This:getIconIamge()
    return self.m_config.icon
end

function This:getLimitNum()
	local cond = self.m_config.ulock
	if type(cond) == "table" then
		local ctype, ret = unpack(cond)
		return ret, ctype <= 1
	elseif cond > 0 then
		return cond, true
	end
end

function This:isLockedByCond()
    if self:isLocked() then
        local cond = self.m_config.ulock
        if type(cond) == "table" then
            local ctype, ret = unpack(cond)
            if ctype > 1 then
                return ret >= 0
            end
        end
    end
end

function This:getRewardLimitNum()
    return self.m_leftRewardLimitNum or 0
end

function This:setRewardLimitNum( num )
    self.m_leftRewardLimitNum = num
end

function This:requestPickUp()
    if self:isOpening() then
        ActivityManager:onPickupNewActRewardRequest(self:getQueueConfigSubCmd(), self:getType(), self:getId())
        return true
    end
    return false
end

function This:requestUnlock()
    if self:isLocked() then
        ActivityManager:onUnlockActRequest(self:getQueueConfigOtherCmd(), self:getType(), self:getId())
        return true
    end
    return false
end

function This:getQueueCreateDays()
    local queue = self:getQueue()
    if queue then
        return queue:getActivityCreateDays() or 0 
    else
        return 0
    end
end