-- @Author: superm
-- @Date:   2018-08-07 10:54:58
-- @Last Modified by:   superm
-- @Last Modified time: 2018-09-18 16:36:43
-- @File Name: ActDailyTaskQueueModel.lua
-- @Description: 


local This , super = class(..., "Activity.ActOpenTaskQueueModel")
local ActDailyTaskModel = class( This._NAME .. ".ActDailyTaskModel", super._NAME .. ".ActOpenTaskModel")

function ActDailyTaskModel:isValid()
    local queue = self:getQueue()
    if not self:isSpecial() and queue then
		local day = queue:getActivityCreateDays()
        return self.m_config.open_num == day
	end
end

function This:initBeforeUpdateState( info, createHandler )
    if not createHandler then
        createHandler = function( actQueueId, activityIndex, actCfg, queue )
            local activity = ActDailyTaskModel:create({type = actQueueId, id = activityIndex, config = actCfg})
            activity:setQueue(queue)
            return activity
        end
    end

    if info.initing and createHandler then
        self.m_objects = {}
        self.m_eobjects = {}
        local queueId = self:getId()
        local originLevel = self:getOriginalLevel()
        local typeName = self:getTypeName()
        local config = require("Metadatas." .. typeName .. "Config")
        local actConfigList = {}
        for cfgIndex, cfg in pairs(config) do
            if self:isSuitable(cfg, queueId, originLevel) then
                local act = createHandler(self:getId(), cfgIndex, cfg, self)
                self.m_objects[act:getId()] = act
                table.insert(actConfigList, cfg)
            end
        end

        local finishHandler = self.initGroupsInfo
        if finishHandler and actConfigList then
            finishHandler(self, actConfigList)
        end
    end
end

function This:getUITypeName(index)
    if self:getFreshMode() == ActFreshMode.kHappy then
        return "NewActivity.ActivityNewYearUI"
    else
        return "Activity.ActivityOneGroupUI"
    end
end

function This:getCSFileName()
    local name = self.m_config.csfile
    if name then
        return "MenuScene/NodeUI/" .. name .. ".csb"
    end
end

function This:getSubCSFileName()
    local name = self.m_config.csfile
    if name then
        return "MenuScene/NodeUI/" .. name .. "Item.csb"
    end 
end