-- @Author: superm
-- @Date:   2018-01-20 17:03:01
-- @Last Modified by:   superm
-- @Last Modified time: 2019-04-09 16:02:37
-- @File Name: ActExchangeHeroQueueModel.lua
-- @Description: 


local This , super = class(..., "Activity.ActivityQueueBaseModel")
local ActExchangeHeroExchangeModel = class( This._NAME .. ".ActExchangeHeroExchangeModel", "Activity.ActivityExchangeModel")

function ActExchangeHeroExchangeModel:getCondition()
	if self.m_exchangeConfig then
		local ret = {}
		for i,v in ipairs(self.m_exchangeConfig.need_item) do
			table.insert(ret, {5, v})
		end
	    return ret
	end
end

-------------------------------------------------------
function This:getExchangeCreator()
    return ActExchangeHeroExchangeModel
end

function This:hasExchangeBehaviour()
    return true
end

function This:hasPickupBehaviour()
    return false
end

function This:getAllExchangeObjectState(update)
	if update then
		local record, backup
		self.m_allExchangeObejectState = nil
		for id, act in pairs(self.m_eobjects) do
            act:updateState()
	    	if act:isOpening() then
                record = act
	    		self.m_allExchangeObejectState = true
	    		break
            elseif not backup and act:isLocked() then
                backup = act
	    	end
		end

        if not record and not backup then
            self.m_allExchangeObejectState = false
        end
	end
    return self.m_allExchangeObejectState
end

function This:getCSFileName()
    return "MenuScene/NodeUI/ActivityAssassins.csb"
end

function This:showTimer()
    return true
end