-- @Author: superm
-- @Date:   2017-11-04 15:27:36
-- @Last Modified by:   superm
-- @Last Modified time: 2019-04-09 15:59:08
-- @File Name: ActFirstPayQueueModel.lua
-- @Description: 首充

local This , super = class(..., "Activity.ActivityQueueBaseModel")
local ActFirstPayModel = class( This._NAME .. ".ActFirstPayModel", "Activity.ActivityBaseModel")

function ActFirstPayModel:updateState(isInit, info)
    local continue = not self:isCompleted()
    if isInit then
        self:initSelf(info)
        continue = true
    end

    if not continue then
        return
    end

    local ret = false
    local queue = self:getQueue()
    if queue then
        ret = queue:getCurNum() 
    end
    self.m_state = ret and ActObjectState.kNormal or ActObjectState.kLocked
end

function This:initBaseData( info )
    super.initBaseData( self, info )
    self.m_allObejectState = nil
end

function This:initBeforeUpdateState( info, createHandler )
	if not createHandler then
		createHandler = function( actQueueId, activityIndex, actCfg, queue )
			local activity = ActFirstPayModel:create({type = actQueueId, id = activityIndex, config = actCfg})
			activity:setQueue(queue)
			return activity
		end
	end

	super.initBeforeUpdateState( self, info, createHandler )
end

function This:selfUpdateInfo(info, createHandler)
	if info.is_reward then
		for _, act in pairs(self.m_objects) do
            if act then
                act:setCompleted()
            end
		end 
	end
end

function This:getAllObjectState(update)
    if update and self.m_curNum then
        self.m_allObejectState = false
        for id, act in pairs(self.m_objects) do
            if act:isOpening() then
                self.m_allObejectState = true
                break
            end
        end
    end
    return self.m_allObejectState
end

function This:setCurNum(info)
	self.m_curNum = info.is_pay or false
end

function This:getProgressByIndex(index)
    return self:getCurNum(index)
end

function This:getCurNum(index)
	return self.m_curNum 
end

function This:getCSFileName()
    return "MenuScene/NodeUI/FirstCharge.csb"
end