-- @Author: superm
-- @Date:   2017-11-04 18:09:47
-- @Last Modified by:   zheng
-- @Last Modified time: 2018-07-11 15:33:04
-- @File Name: ActGroupRechargeQueueModel.lua
-- @Description: 团购有礼

local This , super = class(..., "Activity.ActivityQueueBaseModel")
local ActGroupRechargeModel = class( This._NAME .. ".ActGroupRechargeModel", "Activity.ActivityBaseModel")
local ActivityManager = require("Activity.ActivityManager")

function ActGroupRechargeModel:getCondition()
	return {{2, self.m_config.num}, {2, self.m_config.Recharge_amount}}
end

function ActGroupRechargeModel:getLimitNum()
    return tostring(self.m_config.num)
end

function ActGroupRechargeModel:getCurDescNum()
    local curNum = self:getQueue():getCurNum(1)
    local limitNum = self.m_config.num
    if limitNum <= curNum then
        return tostring(limitNum)
    else
        return tostring(curNum)
    end
end

function ActGroupRechargeModel:requestPickUp()
    if self:isOpening() then
        ActivityManager:onPickupActRewardRequest(self:getQueueConfigType(), self:getType(), self:getId())
        return true
    end

    local curNum = self:getQueue():getCurNum(1)
    local limitNum = self.m_config.num
    if limitNum <= curNum then
    	local num = self.m_config.Recharge_amount - self:getQueue():getCurNum(2)
    	g_scene:showTips(string.format(Serialize["activity_ActGroup_1"], num))
	end
    return false
end

function This:initBeforeUpdateState( info, createHandler )
	if not createHandler then
		createHandler = function( actQueueId, activityIndex, actCfg, queue )
			local activity = ActGroupRechargeModel:create({type = actQueueId, id = activityIndex, config = actCfg})
			activity:setQueue(queue)
			return activity
		end
	end

	super.initBeforeUpdateState( self, info, createHandler )
end

function This:initGroupsInfo( config )
	self:getGroupNameList( config, "num", function ( value )
		return string.format(Serialize["activity_ActGroup_2"], value) 
	end )
end

function This:setCurNum(info)
    self.m_curNumArr = {}
	self.m_curNumArr[1]= info.recharge_role_num 
	self.m_curNumArr[2]= info.recharge_price
end

function This:getCurNum(index)
	if self.m_curNumArr then
		return self.m_curNumArr[index or 1]
	end
	return 0
end

function This:getPayNum()
	if self.m_curNumArr then
		return self.m_curNumArr[index or 2]
	end
	return 0
end

function This:getUITypeName()
    return "Activity.ActivityBaseTabsUI"
end

function This:showTimer()
    return true
end