-- @Author: superm
-- @Date:   2017-11-04 17:43:45
-- @Last Modified by:   superm
-- @Last Modified time: 2018-02-07 10:32:22
-- @File Name: ActGrowJijinQueueModel.lua
-- @Description: 成长基金

local This , super = class(..., "Activity.ActivityQueueBaseModel")
local ActGrowJijinModel = class( This._NAME .. ".ActGrowJijinModel", "Activity.ActivityBaseModel")
local GamePlayer = require("Player.GamePlayer")

function ActGrowJijinModel:getCondition()
	return {{1 , self.m_config.level}, {2, self.m_config.pay_num}}
end

function ActGrowJijinModel:getLimitNum()
    return tostring(self.m_config.level)
end

function ActGrowJijinModel:getCurDescNum()
    local curNum = self:getCurNum()
    local limitNum = self.m_config.level
    if limitNum <= curNum then
        return tostring(limitNum)
    else
        return tostring(curNum)
    end
end

function ActGrowJijinModel:getCurNum(index)
    return GamePlayer:getLevel()
end

function This:initBeforeUpdateState( info, createHandler )
	if not createHandler then
		createHandler = function( actQueueId, activityIndex, actCfg, queue )
			local activity = ActGrowJijinModel:create({type = actQueueId, id = activityIndex, config = actCfg})
			activity:setQueue(queue)
			return activity
		end
	end

	super.initBeforeUpdateState( self, info, createHandler )
end

function This:setCurNum(info)
	self.m_curNum = info.pay_num
end

function This:getCurNum(index)
	return self.m_curNum 
end

function This:getPayNum()
	return self.m_curNum 
end