-- @Author: superm
-- @Date:   2018-10-27 11:47:52
-- @Last Modified by:   zheng
-- @Last Modified time: 2019-05-20 15:32:08
-- @File Name: ActSimpleQueueModel.lua
-- @Description: 

local This , super = class(..., "Activity.ActivityQueueBaseModel")
local AdrewardConfig = require("Metadatas.AdrewardConfig")
local ActivityUIRuleConfig = require("Metadatas.ActivityUIRuleConfig")
local GamePlayer = require("Player.GamePlayer")
function This:isInited()
    return true
end

function This:isDirty()
    return false
end

function This:isAllwaysDirty()
    return false
end

function This:initBaseData( info )
	if info then
		super.initBaseData(self, info)
	end
    self.m_allObejectState = false
    self.m_isCanGetCard = 0
    self.m_isAlreadyHaveCard = 0
    self.m_uiconfig = ActivityUIRuleConfig
end

function This:initBeforeUpdateState(info, createHandler)
end

function This:getConfigList()
end

function This:needBuy()
	return false
end

function This:getAllObjectState(update)
    if self.m_objects  then
        
    end
    if not self:getIsAlreadyHaveCard() and not GamePlayer:checkChanelId(GamePlayerChanelId.k51Gamer) then
        return true
    end
    return false
    -- return nil
end

function This:getUITypeName()
    return "Activity.ActivityPhoneCardUI"
end

function This:getCSFileName()
    local name = self.m_config.csfile
    if name then
        return "MenuScene/NodeUI/" .. name .. ".csb"
    end
end

function This:getSubCSFileName()
    local name = self.m_config.csfile
    if name then
        return "MenuScene/NodeUI/" .. name .. "Item.csb"
    end 
end

function This:openCardShopUrl(param, index,urlDelayTime)
    if not index or index <= 0 then return end

    local config
    if self.m_uiconfig then
        config = self.m_uiconfig[index]
        if not config then return end
    end
    local url = config.url
    if url then
        -- "serverId=%d&roleId=%d&gameCode=%d"
        local paramList = {}
        for name, value in pairs(param) do
            table.insert(paramList, name .. "=" .. value)
        end
        local paramstr = table.concat(paramList, '&')
        local str = url .. paramstr
        if not os.isWin32 then
            print(str)
            g_scene:openDialog("Activity.ActivityPhoneCardURLPanel",{url = str,urlDelayTime = urlDelayTime})
            -- os.native_call("openUrl", url .. paramstr)
        else
            str = "start iexplore.exe \""..str .."\""
            print(str)
            os.execute(str)
        end
        -- if not os.isWin32 then
        --     os.native_call("openUrl", url .. paramstr)
        -- else
        --     os.execute("start iexplore.exe \"" .. url .. paramstr)
        -- end
    end 
end


function This:getReward()
    return AdrewardConfig[1].reward
end

--是否可以领取
function This:setIsCanGetCard(isCanGetCard)
    self.m_isCanGetCard = isCanGetCard
end

function This:getIsCanGetCard()
    return self.m_isCanGetCard ==1
end
--是否已经领取过

function This:setIsAlreadyHaveCard(isAlreadyHaveCard)
    self.m_isAlreadyHaveCard = isAlreadyHaveCard
end

function This:getIsAlreadyHaveCard()
    return self.m_isAlreadyHaveCard ==1
end



