-- @Author: superm
-- @Date:   2019-01-21 11:04:22
-- @Last Modified by:   superm
-- @Last Modified time: 2019-04-09 16:19:32
-- @File Name: ActSpringFestivalBoxQueueModel.lua
-- @Description: 春节活动宝箱的数据模型

local This , super = class(..., "Activity.ActivityQueueBaseModel")
local ActBoxModel = require("Activity.ActBoxModel")

function This:initBeforeUpdateState( info, createHandler )
    self.m_selfEscape = 0
    if not createHandler then
        createHandler = function( actQueueId, activityIndex, actCfg, queue )
            local activity = ActBoxModel:create({type = actQueueId, id = activityIndex, config = actCfg})
            activity:setQueue(queue)
            return activity
        end
    end

    super.initBeforeUpdateState( self, info, createHandler )
end

function This:getItemName()
    return "Activity.ActivityBoxView", "MenuScene/NodeUI/ActivitySpringFestivalDailyItem.csb"
end

function This:getUITypeName()
	if self.m_uiconfig then
		local name = self.m_uiconfig.source
		if name then
			return name
		end
	end
    return "Activity.ActivityNewSpringUI"
end

function This:getCSFileName()
    return "MenuScene/NodeUI/ActivitySpringFestivalDailyReward.csb"
end

function This:getHelpTips()
    return "activity_newspring_box_help_tips"
end

function This:selfUpdateInfo(info, createHandler)
    if info.reward_id_list or info.ulock_list then
        for _, act in pairs(self.m_objects) do
            if act then
                act:setState(ActObjectState.kLocked)
            end
        end

        if info.ulock_list then
            for _, activityId in ipairs(info.ulock_list) do
                local act = self.m_objects[activityId]
                if act then
                    act:setRewardNumber(0)
                    act:setRewardLimitNum(0)
                    act:setCompleted()
                end
            end
        end

        if info.reward_times_list then
            for index, activityId in ipairs(info.reward_id_list) do
                local act = self.m_objects[activityId]
                local count = info.reward_times_list[index] or 0
                if act and count > 0 then
                    act:setOpening()
                    act:setRewardLimitNum(count)
                end
            end
        else
            for _, activityId in ipairs(info.reward_id_list) do
                local act = self.m_objects[activityId]
                if act then
                    act:setOpening()
                end
            end
        end
    end
end

function This:setCurNum(info)
    if info.ulock_list then
        self.m_curNumArr = {}
        for _, actId in ipairs(info.ulock_list) do
            self.m_curNumArr[ actId ] = true
        end
    end
    self.m_curNum = info.recharge_num
end

function This:getCurNum(index)
    if not self.m_curNumArr then
        return false
    end
    return self.m_curNumArr[index or 1]
end

function This:getPayNum()
    return self.m_curNum or 0
end

function This:showTimer()
    return true
end