-- @Author: superm
-- @Date:   2019-01-23 16:59:14
-- @Last Modified by:   superm
-- @Last Modified time: 2020-01-14 14:29:50
-- @File Name: ActSpringFestivalFuQueueModel.lua
-- @Description: 春节活动

local This , super = class(..., "Activity.ActivityQueueBaseModel")
local ActBoxModel = require("Activity.ActBoxModel")
local ActivityManager = require("Activity.ActivityManager")
local DepotManager = require("Depot.DepotManager")
local ArgConfig = require("Metadatas.ArgConfig")

function This:initBeforeUpdateState( info, createHandler )
    self.m_selfEscape = 0
    if not createHandler then
        createHandler = function( actQueueId, activityIndex, actCfg, queue )
            local activity = ActBoxModel:create({type = actQueueId, id = activityIndex, config = actCfg})
            activity:setQueue(queue)
            return activity
        end
    end

    super.initBeforeUpdateState( self, info, createHandler )
end

function This:getItemName()
    return "Activity.ActivityBoxView", "MenuScene/NodeUI/ActivitySpringFestivalFuItem.csb"
end

function This:getUITypeName()
	if self.m_uiconfig then
		local name = self.m_uiconfig.source
		if name then
			return name
		end
	end
    return "Activity.ActivityNewSpringUI"
end

function This:getCSFileName()
    return "MenuScene/NodeUI/ActivitySpringFestivalFu.csb"
end

function This:getHelpTips()
    return "activity_newspring_wish_help_tips"
end

function This:getConfigSubCmd()
    return self.m_config.subcmd
end

function This:getConfigOtherCmd()
    return self.m_config.othercmd
end

function This:selfUpdateInfo(info, createHandler)
    if info.reward_id_list then
        if info.reward_id_list then
            for index, activityId in ipairs(info.reward_id_list) do
                local act = self.m_objects[activityId]
                if act then
                    act:setCompleted()
                end
            end
        end
    end
end

function This:setCurNum(info)
    self.m_curNum = info.current_bless
end

function This:getCurDescNum()
    return DepotManager:getItemOrResCount(ArgConfig.activity_54_cost_item.arg[1])  
end

function This:requestUnlock()
    ActivityManager:onUnlockActRequest(self:getConfigOtherCmd())
    return true
end

function This:showTimer()
    return true
end