-- @Author: superm
-- @Date:   2017-11-04 15:54:24
-- @Last Modified by:   superm
-- @Last Modified time: 2019-04-09 16:18:33
-- @File Name: ActTotalLoginQueueModel.lua
-- @Description: 累计登陆

local This , super = class(..., "Activity.ActivityQueueBaseModel")
local ActTotalLoginModel = class( This._NAME .. ".ActTotalLoginModel", "Activity.ActivityBaseModel")

function ActTotalLoginModel:getCondition()
	return self.m_config.day
end

function ActTotalLoginModel:getLimitNum()
    return tostring(self:getCondition())
end

function ActTotalLoginModel:getCurDescNum()
    local curNum = self:getQueue():getCurNum()
    local limitNum = self:getCondition()
    if limitNum <= curNum then
        return tostring(limitNum)
    else
        return tostring(curNum)
    end
end

function ActTotalLoginModel:updateState(isInit, info)
    local continue = not self:isCompleted()
    if isInit then
        self:initSelf(info)
        continue = true
    end

    if not continue then
        return
    end
    
    local ret = false
    local queue = self:getQueue()
    if queue then
        ret = queue:getCurNum() >= self:getCondition()
    end
    self.m_state = ret and ActObjectState.kNormal or ActObjectState.kLocked
end

function This:initBeforeUpdateState( info, createHandler )
	if not createHandler then
		createHandler = function( actQueueId, activityIndex, actCfg, queue )
			local activity = ActTotalLoginModel:create({type = actQueueId, id = activityIndex, config = actCfg})
			activity:setQueue(queue)
			return activity
		end
	end

	super.initBeforeUpdateState( self, info, createHandler )
end

function This:setCurNum(info)
	self.m_curNum = info.days
end

function This:getCurNum(index)
	return self.m_curNum or 0
end

function This:showTimer()
    return self:getFreshMode() > ActFreshMode.kNormal
end
