-- @Author: superm
-- @Date:   2017-11-04 17:59:15
-- @Last Modified by:   superm
-- @Last Modified time: 2019-04-09 16:18:25
-- @File Name: ActTotalPayQueueModel.lua
-- @Description: 累计充值

local This, super = class(..., "Activity.ActivityQueueBaseModel")
local ActTotalPayModel = class( This._NAME .. ".ActTotalPayModel", "Activity.ActivityBaseModel")

function ActTotalPayModel:getCondition()
	return self.m_config.Recharge_amount
end

function ActTotalPayModel:getLimitNum()
    return tostring(self:getCondition())
end

function ActTotalPayModel:getCurDescNum()
    local curNum = self:getQueue():getCurNum()
    local limitNum = self:getCondition()
    if limitNum <= curNum then
        return tostring(limitNum)
    else
        return tostring(curNum)
    end
end

function ActTotalPayModel:updateState(isInit, info)
    local continue = not self:isCompleted()
    if isInit then
        self:initSelf(info)
        continue = true
    end

    if not continue then
        return
    end

    local ret = false
    local queue = self:getQueue()
    if queue then
        ret = (queue:getCurNum() or 0)  >= self:getCondition()
    end
    self.m_state = ret and ActObjectState.kNormal or ActObjectState.kLocked
end

function This:initBeforeUpdateState( info, createHandler )
	if not createHandler then
		createHandler = function( actQueueId, activityIndex, actCfg, queue )
			local activity = ActTotalPayModel:create({type = actQueueId, id = activityIndex, config = actCfg})
			activity:setQueue(queue)
			return activity
		end
	end

	super.initBeforeUpdateState( self, info, createHandler )
end

function This:setCurNum(info)
	self.m_curNum = info.pay_num
end

function This:getCurNum(index)
	return self.m_curNum or 0
end

function This:getPayNum()
	return self.m_curNum 
end

function This:showTimer()
    local mode = self:getFreshMode()
    return mode > ActFreshMode.kNormal and mode ~= ActFreshMode.kFestive
end

function This:getUITypeName()
    if self:getFreshMode() == ActFreshMode.kFestive then
        return "NewActivity.ActivityNewYearUI"
    else
        return super.getUITypeName(self)
    end
end

function This:getOriginalLevel()
    return self.m_originalLevel
end

function This:setOriginalLevel(value)
    self.m_originalLevel = value
end