-- @Author: superm
-- @Date:   2017-11-04 18:05:46
-- @Last Modified by:   superm
-- @Last Modified time: 2017-11-10 14:35:27
-- @File Name: ActUplevelQueueModel.lua
-- @Description: 

local GamePlayer = require("Player.GamePlayer")
local This , super = class(..., "Activity.ActivityQueueBaseModel")
local ActUplevelModel = class( This._NAME .. ".ActUplevelModel", "Activity.ActivityBaseModel")

function ActUplevelModel:getCurNum(index)
    return GamePlayer:getLevel()
end

function ActUplevelModel:getCondition()
	return self.m_config.Recharge_lv
end

function ActUplevelModel:getLimitNum()
    return tostring(self:getCondition())
end

function ActUplevelModel:getCurDescNum()
    local curNum = self:getCurNum()
    local limitNum = self:getCondition()
    if limitNum <= curNum then
        return tostring(limitNum)
    else
        return tostring(curNum)
    end
end

function ActUplevelModel:updateState(isInit, info)
    local continue = not self:isCompleted()
    if isInit then
        self:initSelf(info)
        continue = true
    end

    if not continue then
        return
    end

    local ret = self:getCurNum() >= self:getCondition()
    self.m_state = ret and ActObjectState.kNormal or ActObjectState.kLocked
end

function This:initBeforeUpdateState( info, createHandler )
	if not createHandler then
		createHandler = function( actQueueId, activityIndex, actCfg, queue )
			local activity = ActUplevelModel:create({type = actQueueId, id = activityIndex, config = actCfg})
			activity:setQueue(queue)
			return activity
		end
	end

	super.initBeforeUpdateState( self, info, createHandler )
    if info.reward_list then
		for _, activityId in ipairs(info.reward_list) do
			local act = self.m_objects[activityId]
            if act then
                act:setCompleted()
            end
		end
	end
end