-- @Author: superm
-- @Date:   2017-11-06 13:10:44
-- @Last Modified by:   zheng
-- @Last Modified time: 2020-07-09 11:18:30
-- @File Name: ActivityBaseTabsUI.lua
-- @Description: 带标签页的活动

local This, super = class(..., "Activity.ActivityBaseUI")
local EventDispatcher = require("EventDispatcher")
local GameUtil = require("Util.GameUtil")

function This:initNode()
	self.m_groupCount = self.m_activity:getGroupListCount()
	self:addActivitySubTab()
	super.initNode(self)
	if self.m_activity:showTimer() then
		self.m_csNode.time:setString(Serialize[60212] .. GameUtil:formatTime(Serialize["activity_BaseTabs_1_c"], self.m_activity:getLeftTime()))
	end
end

function This:onEnter()
    super.onEnter(self)
	if self.m_tabButtons then
        for _, button in pairs(self.m_tabButtons) do
            if button.m_touch then
            	button.m_touch.isAlpha = false
            end
        end
    end

	if self.m_activity:showTimer() then
		self.m_activity:addObserver(self)
	end 
    EventDispatcher:dispatcher("activity_tabs_ui_open", self)
end

function This:onExit()
	self.m_activity:removeObserver(self)
    super.onExit(self)
end

function This:addActivitySubTab()
    local csNode = self.m_csNode
	local nameList = self.m_activity:getGroupNameList()
	local w, h = csNode.biaoqianbg:getContentSize()
	csNode.biaoqianbg:setContentSize(self.m_groupCount * 110.2 , h)
	for i=1, self.m_groupCount do
		if i > 1 then
			csNode["xian" .. (i -1)]:setVisible(true)
		end
		csNode["tep" .. i]:setVisible(true)
		csNode["hongdian" .. i]:setVisible(true)
		csNode["text" .. i]:setVisible(true)
		csNode["text" .. i]:setString(nameList[i])
		csNode["tep" .. i].text:setString(nameList[i])
		csNode["suo" .. i]:setVisible(false)
	    self:addTabButton(tostring(i), csNode["tep" .. i], function()
	    	if self.m_curTabIndex == i then
	    		return false
	    	end
	        self:refreshItemList(i)
	        self.m_curTabIndex = i
	        return true
	    end)
	end
	csNode.biaoqianbg:setVisible(true)
	local svWeight , svHeight = csNode.scrollView:getContentSize()
	csNode.scrollView:setContentSize(svWeight , svHeight - h)
	self:selectTabButton(tostring(1)) 
end

function This:refreshListView()
	self:refreshItemList( self.m_curTabIndex )
end

function This:refreshItemList( index )
	if self.m_curTabIndex == nil then
		return 
	end
    local groupList = self.m_activity:getGroupListBy( index )
    self:refreshItemListByData(groupList)
end

function This:lightTabButton(name)
    self.m_selectTabButton = name
    if self.m_tabButtons then
        for k,node in pairs(self.m_tabButtons) do
            if k == name then
                node:setOpacity(255)
            else
                node:setOpacity(0)
            end
        end
    end
end

function This:updateQueueTime( info )
    self.m_csNode.time:setString(Serialize[60212] .. GameUtil:formatDTime(Serialize["activity_BaseTabs_1_c"] ,info.time))
end