-- @Author: superm
-- @Date:   2017-12-14 20:51:15
-- @Last Modified by:   superm
-- @Last Modified time: 2019-04-09 16:10:26
-- @File Name: ActivityGiveHeroPanel.lua
-- @Description: 送赵云

local This, super = class(...,"Dialog")
local ActivityManager = require("Activity.ActivityManager")
-- local ItemNode = require("UI.ItemNode")

function This:initData(info)
	self.m_queue = info and info.queue
	self.m_firstIn = info and info.param
	self.m_inited = false
end

function This:initNode()
    self.m_inited = true
 	self.m_csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/ActivityCome.csb")
    self.m_csNode:setToCenter()
    self:addChild(self.m_csNode)
end

function This:onEnter()
    super.onEnter(self)
    ActivityManager:addObserver(self)
    self.m_csNode:playCSAnimation("Start",false,function()
    	self:refreshUI()
    end)
end

function This:onExit()
	self.m_queue:removeObserver(self)
    ActivityManager:removeObserver(self)
    super.onExit(self)
end

function This:initTouchEvent()
    self.m_csNode.waitbutton:setTouchEnded(function()
        self:close()
    end)

    self.m_csNode.lingqu:setTouchEnded(function()
		self.m_queue:requestPickUp()
    end)
end

function This:refreshBtn()
	local curNum = self.m_queue:getCurDescNum()
	if curNum then
		self.m_csNode.time:setVisible(true)
		self.m_csNode.timebg:setVisible(true)
		self.m_csNode.wait:setVisible(true)
		self.m_csNode.time:setString(Serialize[60212] .. curNum)

		self.m_csNode.lingqu:setVisible(false)
		self.m_csNode.lingqu:setOpacity(0)
	else
		self.m_csNode.time:setVisible(false)
		self.m_csNode.timebg:setVisible(false)
		self.m_csNode.wait:setVisible(false)
		self.m_csNode.lingqu:setVisible(true)
		self.m_csNode.lingqu:setOpacity(255)
	end
end

function This:refreshUI()
	if self.m_inited then
		if not self.m_firstIn then
			self.m_csNode.waitbutton:setVisible(false)
			self.m_csNode.waitbutton:setOpacity(0)
    		self:refreshBtn()
    	else
			self.m_csNode.waitbutton:setVisible(true)
			self.m_csNode.waitbutton:setOpacity(255)
			self.m_csNode.time:setVisible(false)
			self.m_csNode.timebg:setVisible(false) 
    	end
	end
end

function This:refresh()
    local curNum = self.m_queue:getCurDescNum()
	self.m_csNode.time:setString(Serialize[60212] .. curNum)
end

function This:onPickupActReward(actQueueId, id, act)
	if self.m_queue:getId() ~= actQueueId then
		return
	end
	
    act:setCompleted()

	local itemList = act:getRewardList(1)
    if itemList and #itemList > 0 then
        g_scene:showReward(itemList)
    end
    ActivityManager:notifyActState(self.m_queue, false)
	self:close()
end

function This:onTouchMask()
	if self.m_csNode.time:isVisible() then
		self:close()
	end
end

