-- @Author: superm
-- @Date:   2018-03-07 14:41:20
-- @Last Modified by:   superm
-- @Last Modified time: 2019-04-09 16:10:49
-- @File Name: ActivityImpactChampionUI.lua
-- @Description: 冲冠活动页面

local ActivityImpactChampionUI = class(..., "Activity.ActivityTimerUI")
local This , super = class( ActivityImpactChampionUI._NAME .. ".ActivityImpactChampionItemView", "Activity.ActivityItemView")
local ItemNode = require("UI.ItemNode")

function This:initCsNode()
    self.m_csNode = cc.Node:createFromCSFile(self.m_activity:getUIFileName())
    self:addChild(self.m_csNode)
    local w , h = self.m_csNode.bg:getContentSize()
    self:setContentSize(w, h)
end

function This:initStateUI()
    local csNode = self.m_csNode
    csNode.finish:setVisible(false)
    csNode.condition:setString(self.m_activity:getDesc())
end

function This:setItemEnable(enable)
    local csNode = self.m_csNode
    local isLocked = self:isLocked()
    csNode.already:setVisible(not isLocked)
    csNode.number:setVisible(isLocked)
    if csNode.finish then
        local finish = self.m_activity:isFinish()
        if isLocked or (finish and not enable) then
            csNode.finish:setVisible(finish)
            if finish then
                csNode.button:setVisible(false)
                csNode.pickuptext:setVisible(false)
                return
            end
        end
    end

    super.setItemEnable(self, enable)
end

function This:refreshStateUI()
	self.m_csNode.number:setString(self.m_activity:getLeftRewardNumber())
end

function This:refreshItemUI()
    local csNode = self.m_csNode
    local rewardList = self.m_activity:getRewardList()
    local w = 0
    local itemNode = csNode.rewardlist
    if itemNode then
        for i , info in ipairs(rewardList) do
            local itemId, num = info[1], info[2]
            local node = itemNode["node" .. i]
            if not node then
                node = ItemNode:create(itemId, num)
                itemNode["node" .. i] = node
                node:setCascadeOpacityEnabled(true)
                node:setAnchorPoint(0,0.5)
                itemNode:addChild(node)
            else
                node:init(itemId, num)
            end
            node:setPositionX(w)
            w = w + node:getContentWidth() + 10
        end
        itemNode:setPositionX(csNode.rewardbg:getPositionX() - w * itemNode:getScaleX() / 2)
    end

    self:initStateUI()
end

function ActivityImpactChampionUI:getNewItemView( ... )
    return This:create( ... )
end