-- @Author: superm
-- @Date:   2018-01-06 11:53:44
-- @Last Modified by:   superm
-- @Last Modified time: 2019-04-09 16:11:02
-- @File Name: ActivityInvestmentPlanItemView.lua
-- @Description: 投资活动项

local This , super = class(..., "Activity.ActivityItemView")
This.csfileName = "MenuScene/NodeUI/ActivityInvestmentItem.csb"

local ItemNode = require("UI.ItemNode")

function This:refreshItemUI()
    local csNode = self.m_csNode
    local rewardList = self.m_activity:getRewardList()
    local count = #rewardList
    for i, info in ipairs(rewardList) do
    	local itemId, num = info[1], info[2]
    	local itemNode = csNode["reward" .. tostring(i)]
    	if itemNode then
    		itemNode:setVisible(true)
    		local node = itemNode.node
			if not node then
		        node = ItemNode:create(itemId, num)
		        node:setAnchorPoint(0.5, 0.5)
		        itemNode:addChild(node)
		        itemNode.node = node
	    else
		        node:init(itemId, num)
		    end
    	end
    end

    for i=count + 1, 7 do
    	local itemNode = csNode["reward" .. tostring(i)]
    	if itemNode then
    		itemNode:setVisible(false)
    	end
    end

    csNode.condition:setString(self.m_activity:getDesc())
end

function This:refreshStateUI()
end