-- @Author: superm
-- @Date:   2018-03-07 21:23:17
-- @Last Modified by:   superm
-- @Last Modified time: 2018-08-07 15:28:28
-- @File Name: ActivityMonthlyCardUI.lua
-- @Description: 

local ActivityMonthlyCardUI = class(..., "Activity.ActivityBaseUI")

local This , super = class(ActivityMonthlyCardUI._NAME .. ".ActivityMonthlyCardItemView", "Activity.ActivityItemView")
This.csfileName = "MenuScene/NodeUI/ActivityCard.csb"


function This:initStateUI()
    local csNode = self.m_csNode
    csNode.condition:setString(self.m_activity:getDesc())
    csNode.cardtext:setString(self.m_activity:getContextDesc())
    csNode.card:setImage(self.m_activity:getTypeDesc())
    csNode.pic:setVisible(self.m_activity:getId() == 3)
end

function This:setItemEnable(enble)
    local csNode = self.m_csNode
    if self:isLocked() then
        csNode.button:setVisible(true)
        csNode.cur:setVisible(false)
        csNode.tianshu:setVisible(false)
        csNode.button.text:setString(string.format(Serialize[60219],self.m_activity:getCost()))
        if csNode.pickuptext then 
            csNode.pickuptext:setVisible(false)
        end
    else
        csNode.cur:setVisible(true)
        csNode.tianshu:setVisible(true)
        csNode.button.text:setString(Serialize["activity_MonthlyCard_1"])
        csNode.button:setVisible(enble)

        if csNode.pickuptext then 
            csNode.pickuptext:setVisible(not enble)
        end
    end
end

function This:refreshItemUI()
    self:initStateUI()
end

function This:refreshStateUI()
    local curNum = self.m_activity:getCurDescNum()
    if self.m_activity:isCompleted() then
        curNum = curNum - 1
        if curNum < 0 then
            curNum = 0
        end
    end
    self.m_csNode.cur:setString(curNum)
end

function ActivityMonthlyCardUI:refresh()
    if self.m_inited then
        self:refreshListView()
    end
end

function ActivityMonthlyCardUI:initNode()
    local csNode = self.m_csNode

    self.m_curViews = super.getAllViews(self.m_activity:getId())
    csNode.act_title:setVisible(true)
    csNode.chongzhi:setVisible(false)
    csNode.bg1:setVisible(false)
    csNode.button:setVisible(false)
    csNode.act_title:setImage("MenuScene/act_title_" .. tostring(self.m_activity:getTitleType()) .. ".jpg")
    csNode.time:setVisible(self.m_activity:showTimer())
    self:refreshListView()
end

function ActivityMonthlyCardUI:getNewItemView( ... )
    return This:create( ... )
end

function ActivityMonthlyCardUI:onBuyMonthlyReply( actQueueId, actId, queue )
    if actQueueId and actQueueId > 0 and self.m_activity:getId() == actQueueId then
        self:refresh()
        -- g_scene:resume()
    end
end