-- @Author: superm
-- @Date:   2017-12-22 15:18:55
-- @Last Modified by:   superm
-- @Last Modified time: 2019-03-04 16:52:38
-- @File Name: ActivityOnlineTimePanel.lua
-- @Description: 
local This, super = class(...,"Dialog")
local ItemNode = require("UI.ItemNode")

function This:initNode(info)
	self.m_queue = info and info.queue
	self.m_state = info and info.param

    self.m_csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/MatchingLevelBox.csb")
    self:addChild(self.m_csNode)
    self.m_csNode:setToCenter()

	self.m_csNode.title:setString(self.m_queue:getName())
	self.m_csNode.left:setVisible(false)
	self.m_csNode.right:setVisible(false)
	self.m_csNode.condition:setString(Serialize["activity_OnlineTime_1"])
	self.m_csNode.condition:setVisible(not self.m_state)
	self.m_csNode.button:setVisible(self.m_state)
    self:refreshItemList()
end

function This:initTouchEvent()
    self.m_csNode.close:setTouchEnded(function()
        self:close()
    end)

    self.m_csNode.button:setTouchEnded(function()
    	if self.m_queue then
            self.m_queue:requestPickUp()
    	end
    end)
end

function This:refresh()
end

function This:refreshBtn()
	if not self.m_state then
		self.m_state = true
		self.m_csNode.condition:setVisible(false)
		self.m_csNode.button:setVisible(true)
	end
end

function This:refreshItemList()
	local scrollView = self.m_csNode.scrollView
	scrollView:removeAllChildren()
	scrollView.m_direction = "right"
	local rewardList = self.m_queue:getCurRewardList()
	if rewardList then
		for i , info in ipairs(rewardList) do
			local item = ItemNode:create(info[1], info[2])
			item:setAnchorPoint(0.5,0.5)
			local w , h = item:getContentSize()
			scrollView:pushBackCustomItem(item, w, h ,0.5)
		end
	else
		self:close()
    end
end