-- @Author: superm
-- @Date:   2018-01-18 21:12:10
-- @Last Modified by:   superm
-- @Last Modified time: 2018-08-07 12:54:05
-- @File Name: ActivityOpenTaskItemView.lua
-- @Description: 

local This , super = class(..., "Activity.ActivityItemView")
This.csfileName = "MenuScene/NodeUI/ActivitySevenDaysTask.csb"

function This:initTouchEvent()
    if not self.m_inited then
    	super.initTouchEvent(self)
        local csNode = self.m_csNode
        csNode.goto:setTouch({
            getRect = function (touch)
                local rect = touch.sizeNode:getBoundingBox()
                return rect
            end,
            onEnded = function()
                self:onGotoBtnClick()
            end,
            isContainer = true,
            isDynamic = true,
            isScale = false,
        })  

        csNode.tanhao:setTouch({
            getRect = function (touch)
                local rect = touch.sizeNode:getBoundingBox()
                return rect
            end,
		    onEnded = function()
                self:onGotoBtnClick()
            end,
            isContainer = true,
            isDynamic = true,
            isScale = false,
        })  
        self.m_inited = true
    end
end


function This:initStateUI()
	-- self:refreshStateUI()
end

function This:refreshStateUI()
    local curNum = self.m_activity:getWholeDescNum()
    self.m_csNode.condition:setString(self.m_activity:getDesc() .. curNum)
    -- self:setItemEnable(self.m_activity:isOpening())
end

function This:setItemEnable(enble)
    local csNode = self.m_csNode
    if self:isLocked() then
        csNode.button:setVisible(false)
        local hasGuider = self.m_activity:hasGuider()
        csNode.goto:setVisible(hasGuider)
        csNode.tanhao:setVisible(not hasGuider)
        csNode.pickuptext:setVisible(false)
    else
        csNode.button:setVisible(enble)
        csNode.goto:setVisible(false)
        csNode.tanhao:setVisible(false)
        csNode.pickuptext:setVisible(not enble)
    end
end

function This:onGotoBtnClick()
    if self.m_activity:hasGuider() then
        if self.m_dialog then
            self.m_dialog:close()
            self.m_dialog = nil
        end
        
        self.m_activity:triggerAncGuider()
    else
        self.m_dialog:openDialog("UI.ConfirmPanel", {richText = self.m_activity:getWarming()})
    end
end