-- @Author: zheng
-- @Date:   2019-04-25 15:23:53
-- @Last Modified by:   zheng
-- @Last Modified time: 2019-06-20 09:40:53
-- @File Name: ActivityPhoneCardUI.lua
local LoginUtil = require("Login.LoginUtil")
local This, super = class(..., "Activity.ActivityBaseUI")
local GameUtil = require("Util.GameUtil")
local GamePlayer = require("Player.GamePlayer")
local ActivityManager = require("Activity.ActivityManager")
function This:initNode()
    -- super.initNode(self)
    local myActivity = self.m_activity
    local csNode = self.m_csNode
    local reward = myActivity:getReward()
    GameUtil:resetScoolItemNode(csNode.scrollview,reward)
    self:refresh()
end
function This:refresh()
    super.refresh(self)
    local csNode = self.m_csNode
    local yilingqu = csNode.yilingqu
    local myActivity = self.m_activity
    local lingQuBtn = csNode.lingqu
    if yilingqu and lingQuBtn then
        local isHaveCard = myActivity:getIsCanGetCard()
        local isAlreadyHaveCard = myActivity:getIsAlreadyHaveCard()
        local isGray = false
        if not isAlreadyHaveCard then
            isGray = not isHaveCard
        end
        GameUtil:btnGray(lingQuBtn,isGray) 
        yilingqu:setVisible(isAlreadyHaveCard)
        lingQuBtn:setVisible(not isAlreadyHaveCard)
    end
end

function This:initTouchEvent()
    local csNode = self.m_csNode
    csNode.lingqu:setTouchEnded(function()
        local myActivity = self.m_activity
        local isHaveCard = myActivity:getIsCanGetCard()
        local isAlreadyHaveCard = myActivity:getIsAlreadyHaveCard()
        if isHaveCard and not isAlreadyHaveCard then
            ActivityManager:onGetPhoneCardRequest(1)
        end
    end)

    csNode.look:setTouchEnded(function()--查看详情
        local myActivity = self.m_activity
        local playerId = GamePlayer:getPlayerID()
        local userCodeId = GamePlayer:getUserCode()
        local LoginManager = require("Login.LoginManager")
        local server = LoginManager:getLoginServer()
        local index = server:getId()
            local param = {
                serverId = index,
                roleId = GameUtil:int64ToString(playerId),
                gameCode = 1,
                userCode=userCodeId,
            }
            local censoringNum = LoginUtil.getPackageId() or 0
            local dataParam = "891l5qu7EX%2fnw6RgLwXwEUOfPg6dvZl8QSIcOD6Xue4%3d"
            if censoringNum== 0 then
                dataParam = "891l5qu7EX%2fnw6RgLwXwEUcI4mrer%2fOG"
            end
            param.data = dataParam

        myActivity:openCardShopUrl(param,7,3)
    end)
end

function This:onGetPhoneCard()
   -- local ActivityManager = require("Activity.ActivityManager")
   -- self.m_activity = ActivityManager:getActivityQueue(NewActivityType.kPhoneCardAd)
    self:refresh()
end
