-- @Author: superm
-- @Date:   2018-01-22 16:04:05
-- @Last Modified by:   superm
-- @Last Modified time: 2019-04-09 16:12:25
-- @File Name: ActivityPreviewPanel.lua
-- @Description: 预览活动奖励面板

local This, super = class(..., "Dialog")
local ItemNode = require("UI.ItemNode")

function This:initData(info)
	self.m_itemList = info.reward
	self.m_title = info.title
	self.m_rewardType = info.rtype
	self.m_filename = info.filename or "ActivitySevenDaysReward"
	self.m_inited = false
end

function This:initNode()
 	self.m_csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/" .. self.m_filename .. ".csb")
    self.m_csNode:setToCenter()
    self:addChild(self.m_csNode)
    if self.m_title then
    	self.m_csNode.title:setString(self.m_title)
    end
    self:refreshItemList()
    self.m_inited = true
end

function This:refreshItemList()
	local node = self.m_csNode
	local count = 0
	if self.m_itemList then
		if not self.m_rewardType or self.m_rewardType <= 0 then
			for id, num in pairs(self.m_itemList) do
		        local itemNode = node["Node" .. (count + 1)]
		        if itemNode and num > 0 then
					count = count + 1
		            if not itemNode.node then
		                itemNode.node = ItemNode:create(id, num)
		                itemNode.node:setAnchorPoint(0.5, 0.5)
		                itemNode:addChild(itemNode.node)
		            else
		                itemNode.node:init(id, num)
		            end
		        end
		    end    
		else
			for index, itemInfo in ipairs(self.m_itemList) do
		        local itemNode = node["Node" .. (count + 1)]
		        if itemNode then
					count = count + 1
					local id, num = itemInfo[1], itemInfo[2] 
		            if not itemNode.node then
		                itemNode.node = ItemNode:create(id, num)
		                itemNode.node:setAnchorPoint(0.5, 0.5)
		                itemNode:addChild(itemNode.node)
		            else
		                itemNode.node:init(id, num)
		            end
		        end
		    end  			
		end   	
    end
end

function This:onTouchMask()
	self:close()
end