-- @Author: superm
-- @Date:   2019-03-02 17:58:20
-- @Last Modified by:   superm
-- @Last Modified time: 2019-04-09 16:15:04
-- @File Name: ActivitySecondWeekBaseUI.lua
-- @Description: 次周活動

local This, super = class(..., "Activity.ActivityBaseUI")
local ActivitySecondWeekItemView = require("Activity.ActivitySecondWeekItemView")
local DepotManager = require("Depot.DepotManager")
local ActivityManager = require("Activity.ActivityManager")

function This:getNewItemView( ... )
    return ActivitySecondWeekItemView:create( ... )
end

function This:refreshListView()
    super.refreshListView(self)
    self:refreshResourceNode()
end

function This:refreshResourceNode()
    local csNode = self.m_csNode
    if csNode.resvalue1 then
    	csNode.resvalue1:setString(DepotManager:getItemOrResCount(kSecondWeekKeyItemId1))
    end
    if csNode.resvalue2 then
    	csNode.resvalue2:setString(DepotManager:getItemOrResCount(kSecondWeekKeyItemId2))
    end
    if csNode.rechargevalue then
    	csNode.rechargevalue:setString(self.m_activity:getCurNum())
    end
    if csNode.rankvalue then
    	local rank = self.m_activity:getCurRank()
    	local rankDesc
    	if rank > 0 then
    		rankDesc = rank
    	else
    		rankDesc = Serialize[60238]
    	end
    	csNode.rankvalue:setString(rankDesc)
    end
end

function This:onPickupActReward(actQueueId, id, act)
	if actQueueId ~= 57 and actQueueId ~= 58 then
		return
	end
    self.m_activity = ActivityManager:getActivityQueueByInfo({activity_id = actQueueId},ActRequestMode.kNormal)
	local view = self.m_curViews[id]
	if view then
		view:showRewardList()
		self:refreshListView()
	end
end