-- @Author: superm
-- @Date:   2019-03-02 21:43:46
-- @Last Modified by:   superm
-- @Last Modified time: 2019-04-09 16:15:25
-- @File Name: ActivitySecondWeekExchangeItemView.lua
-- @Description: 次周活動兌換

local This , super = class(..., "Activity.ActivitySecondWeekItemView")

local ItemNode = require("UI.ItemNode")
local ItemUtil = require("Bag.ItemUtil")
local DepotManager = require("Depot.DepotManager")

function This:onEnter()
    super.onEnter(self)
    DepotManager:addObserver(self)
end

function This:onExit()
    DepotManager:removeObserver(self)
    super.onExit(self)
end

function This:refreshItemUI()
	super.refreshItemUI(self)
    local csNode = self.m_csNode
    local needItemList = self.m_activity:getNeedItemList()
    local str = Serialize[60240]
    local itemDescList = {}
    for i, info in ipairs(needItemList) do
    	local itemId, num = info[1], info[2]
    	table.insert(itemDescList, ItemUtil.getName(itemId) .."：".. num)
    end
    str = str .. table.concat(itemDescList, "、")
    csNode.cost:setString(str)
end

function This:refreshStateUI()
    local csNode = self.m_csNode
    self:setItemEnable(self.m_activity:isOpening())
    csNode.times:setString(self.m_activity:getWholeDescNum())
end

function This:onPickUpBtnClick()
    if self.m_activity then
        self.m_activity:requestExchange()
    end
end

function This:itemUpdate()
    if self.m_activity then
        self.m_activity:updateState()
    end
    self:refresh()
end