-- @Author: superm
-- @Date:   2019-03-02 16:34:18
-- @Last Modified by:   superm
-- @Last Modified time: 2019-03-03 05:15:23
-- @File Name: ActivitySecondWeekItemView.lua
-- @Description: 

local This , super = class(..., "Activity.ActivityItemView")
local ItemNode = require("UI.ItemNode")
local GameUtil = require("Util.GameUtil")

function This:initCsNode()
    local index = self.m_selection or ""
	self.csfileName = string.format("MenuScene/NodeUI/PlayerCompeteItem%s.csb", tostring(index))
    print(self.csfileName)
	super.initCsNode(self)
end

function This:refreshItemUI()
    local rewardList = self.m_activity:getRewardList()
    local csNode = self.m_csNode
    local count = #rewardList

	local scrollView = self.m_csNode.scrollView
	scrollView:removeAllItems()
	scrollView:setDirection("horizontal")
	scrollView.m_direction = "right"

    for i, info in ipairs(rewardList) do
    	local itemId, num = info[1], info[2]
        local item = ItemNode:create(itemId, num)
        item:setAnchorPoint(0.5, 0.5)
		local w , h = item:getContentSize()
		scrollView:pushBackCustomItem(item,w,h,0.5)
    end

    self:initStateUI()
end

function This:initStateUI()
    local csNode = self.m_csNode
    csNode.condition:setString(self.m_activity:getDesc(), 250)
end

function This:refreshStateUI()
    local csNode = self.m_csNode
    if csNode.jindu then
        csNode.jindu:setString(self.m_activity:getWholeDescNum())
    end

    if csNode.num and csNode.name then
        local name, value = self.m_activity:getHighestDesc()
        if name and value then
            csNode.num:setString(value)
            csNode.name:setString(name)
        else
            csNode.num:setString(Serialize[60243])
            csNode.name:setString(Serialize[60243])
        end
    end
end
