-- @Author: superm
-- @Date:   2018-02-09 15:22:17
-- @Last Modified by:   superm
-- @Last Modified time: 2019-03-19 14:42:32
-- @File Name: ActivityUtil.lua
-- @Description: 6L+Z6YeM5aSp5aSp5Yqg54+t77yM6K+05aSa5piv57Sv

local This = class(...)
local ActivityUIRuleConfig = require("Metadatas.ActivityUIRuleConfig")


ActTrailerState = {
    kInvalid = 0,  
    kNotOpen = 1,  --未開啓
    kUpdating = 2,  --未開啓
}

ActObjectState = {
    kNormal = 0,    --能领取
    kLocked = 1,    --不能领取
    kCompleted = 2,    --已领取
    kInvalid = 3,    --未開啓
}

ActRequestMode = {
    kNone = 0,
    kNormal = 1,
    kForce = 2,
    kRequestInDirty = 3,
}

ActType = {
    kFirstPay = 12000,
    kTotalLogin = 12001,
    kGrowJijin = 12002,
    kTotalPay = 12003,
    kUplevel = 12006,
    kOnlineTime = 12005,
    kGroupRecharge = 12007,
    kOpenTask = 12008,
    kInvestmentPlan = 12011,
    kAddOffice = 12012,
    kTongQueTai = 12013,
    kLimitRecruit = 12015,
    kLimitRecharge = 12019,
    kPrizeDraw = 12021,
    kImpactChampion = 12022,
    kMonthlyCard = 12023,
    kSpringBox = 12041,
    kSpringWish = 12044,
    kSeceondWeek = 12048,
}

ActFreshMode = {
    kNormal = 1,
    kTimeLimit = 2,
    kCrossZoom = 3,
    kHappy = 4,
    kIdle = 11,
    kFestive = 12,
    kSeceondWeek = 13,
}

ActDirtyReasonType = {
    kNormal = 0,
    kAllWays = 1,
    kRecharge = 2,
    kTime = 4,
    kDay = 8,
    kLevel = 16,
    kRankLevel = 32,
    kItemUpdate = 64,
    kCostDiamond = 128,
}

ActResType = {
    kCostText = 1, --显示消费信息（默认显示充值信息）
    kTimeLimitPic = 2, --显示限时信息
    kNotShowPay = 4, --关闭显示充值信息
    kNotShowDesc = 8, --关闭显示具体描述
    kNotShowPayDetail = 16, --
    kNotShowTitle = 32, --关闭显示具体描述
    kNext = 64, --预留占用
}

kActRookieOpenLevel = 13
kActRookieOpenGuideId = 25

ActFormula = {
    kInvestmentPlanCostGold = function()
        return 3000
    end,
    kInvestmentPlanCostGoins = function()
        return 300000
    end,
}

ActivityImpactType = {
    kLevel = 17,
    kRank = 18,
}

kFirstWinAchieveIdList = {99999, 99998}

function This:getUIConfigList( actid )
    local ret
    local configList = table.ifilter(ActivityUIRuleConfig, function (id, config )
        return config.act_id == actid and config.valid > 0
    end)

    if #configList > 0 then
        ret = {}
        for _, config in ipairs(configList) do
            ret[config.priority] = config
        end
    end
    return ret
end

function This:getUIStrList( actid )
    local ret
    local configList = table.ifilter(ActivityUIRuleConfig, function (id, config )
        return config.act_id == actid and config.valid > 0
    end)

    if #configList > 0 then
        ret = {}
        for i, config in ipairs(configList) do
            if config.ui_type then
                ret[i] = tostring(actid) .. "@" .. tostring(config.priority)
            else
                ret[i] = tostring(actid)
            end
        end
    end
    return ret 
end

function This.isSpecialAchieve(id)
    for _, achieveId in ipairs(kFirstWinAchieveIdList) do
        if achieveId == id then
            return true
        end
    end
end