-- @Author: Su
-- @Date:   2019-05-15 11:12:05
-- @Last Modified by:   Su
-- @Last Modified time: 2019-05-15 11:12:05
-- @File Name: AnimalsTurnTableMainPanel.lua
-- @Description: 

local This, super = class(..., "Dialog")

local ActivityName = {
    [1] = "kAnimalTable",
    [2] = "kAnimalStore"
}

function This:initNode()
    self.m_csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/AnimalsTurnTableMain.csb")
    self:addChild(self.m_csNode)
    self.m_csNode:setToCenter()

    local csNode = self.m_csNode
    self.m_tabNode =cc.Node:createFromCSFile("MenuScene/NodeUI/AnimalsTurnTablePaging.csb")
    csNode:addChild(self.m_tabNode)

    self.m_tabIndex = 1
    self:addTabButton(ActivityName[1],self.m_tabNode.tep1,function ()
        self.m_tabIndex = 1
        self:openTabNode("NewActivity.AnimalsTurnTableNode",self.m_tabIndex)
    end)
    self:addTabButton(ActivityName[2],self.m_tabNode.tep2,function ()
        self.m_tabIndex = 2
        self:openTabNode("GodBeast.AnimalsTurnTableExchangeNode",self.m_tabIndex)

    end)
    self:selectTabButton(ActivityName[self.m_tabIndex])
end

function This:onEnter()
    super.onEnter(self)
	self:refresh()
end

function This:onExit()
    super.onExit(self)
end

function This:refresh()
    
end

function This:initTouchEvent()
    self.m_csNode.close:setTouchEnded(function()
        if not self.m_animalNode:getIsAnimation() then
            self:close()
        end
    end)
end


function This:getTabNodeData(name)
    return {tab = self.m_tabIndex,name=ActivityName[self.m_tabIndex]}
end

function This:openTabNode(name,index)
    if not self.m_tabNodes or not self.m_tabNodes[index] or not self:isNodeHasCreat(index) then
        self.m_animalNode = self:addTabNode(name,index)
    end
    if self.m_selectTabName then
        local lastNode = self.m_tabNodes[self.m_selectTabName]
        if lastNode then
            self:onTabNodeSwitchOut(lastNode, self.m_selectTabName)
        end
    end
    self.m_selectTabName = name
    local curTabNode = self.m_tabNodes[index]
    if curTabNode then
        self:onTabNodeSwitchIn(curTabNode, name)
    end
    for k,tabNode in pairs(self.m_tabNodes) do
        tabNode:setVisible(tabNode:getTabIndex() == curTabNode:getTabIndex())
    end
    return self.m_tabNodes[name]
end

function This:addTabNode(name,index)
    if not self.m_tabNodes then
        self.m_tabNodes = {}
    end
    if self:isNodeHasCreat(index) then
        return
    end
    
	local node = self:createTabNode(name)
    node.m_owner = self
    self:addChild(node)
    self.m_tabNodes[index] = node
    return node
end

function This:isNodeHasCreat(index)
    local isCreate = false
    for _,tabNode in pairs(self.m_tabNodes) do
        if index == tabNode:getTabIndex() then
            isCreate = true
            break
        end
    end
    return isCreate
end