-- @Author: Su
-- @Date:   2019-07-31 14:30:05
-- @Last Modified by:   zheng
-- @Last Modified time: 2020-04-16 14:47:09
-- @File Name: RedHeroTurnTableMainPanel.lua
-- @Description: 

local RedHeroTurnTableNode = require("NewActivity.RedHeroTurnTableNode")
local RedShopExchangeTab = require("Activity.RedShopTab")
local This, super = class(..., "Dialog")

local ActivityName = {
    kRedHeroTable =1,
    kRedShop =2,
}

function This:initNode()
    self.m_csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/RedHeroTurnTableMain.csb")
    self:addChild(self.m_csNode)
    self.m_csNode:setToCenter()
    for index,tabKey in pairs(ActivityName) do
        local item = self.m_csNode["tep"..tabKey]
        self:addTabButton(tabKey, item, function()
            self:openTabNode(tabKey)
            self:lightTabButton(tabKey)
            self.m_selectIndex = tabKey
        end)
    end
    self.m_selectIndex = ActivityName.kRedHeroTable
    self:selectTabButton(self.m_selectIndex)
end

function This:initTouchEvent()
    local csNode = self.m_csNode
    csNode.close:setTouchEnded(function()
        self:close()
    end)
end

function This:createTabNode(name)
    -- print(name)
    if ActivityName.kRedHeroTable == name then
        return RedHeroTurnTableNode:create()
    else
        return RedShopExchangeTab:create()
    end
end

function This:onEnter()
    super.onEnter(self)
end

function This:onExit()
    super.onExit(self)
end