-- @Author: zheng
-- @Date:   2020-04-16 11:21:28
-- @Last Modified by:   zheng
-- @Last Modified time: 2020-04-17 15:38:44
-- @File Name: RedShopTab.lua

local GameUtil = require("Util.GameUtil")
local ItemUtil = require("Bag.ItemUtil")
local DepotManager = require("Depot.DepotManager")

local This , super = class(...,"NodeUI")
-- local FamilyManager = require("Official.FamilyManager")
local NewActivityManager = require("NewActivity.NewActivityManager")
local AnimalsExchangeItem = require("GodBeast.AnimalsExchangeItem")
This.fileName = "MenuScene/NodeUI/RedHeroTurnTableShop.csb"
function This:initNode(info)
    self:getActivity()
    self:refresh()
end
function This:getActivity()
    if not self.m_activity then
        self.m_activity = NewActivityManager:getActivity(NewActivityType.kRedHeroTable)
        self.m_id = self.m_activity:getShopMoney()
        self.m_shopList = self.m_activity:getShopList()
    end
end

function This:refreshMonety()
    local id = self.m_id
    if id then
        self.textname:setString(ItemUtil.getName(id))
        self.text1:setString(DepotManager:getItemCount(id))
    end
end

function This:refresh()
    self:refreshMonety()
    self:refreshItem()
end

function This:refreshItem()
    local scrollView = self.scrollView
    local shopList = self.m_shopList
    if shopList then
        for _,id in pairs(shopList) do
            if id ~= self.m_id then
                local item = AnimalsExchangeItem:create({slot = id,red = true})
                local w,h = item:getContentSize()
                scrollView:pushNode(item,w,h,2)
            end
        end
    end
end

function This:initTouchEvent()
    self.help:setTouchEnded(function()
        g_scene:openDialog("UI.HelpTips",{text = Serialize["activity_RedShop_1"],node = self.help})
    end)

end

function This:onEnter()
    -- self:getActivity()
    self.m_activity:addObserver(self)
    super.onEnter(self)
end

function This:onExit()
    super.onExit(self)
    self.m_activity:removeObserver(self)
end
This.onExchangeRequest = This.refreshMonety

