--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"Stage.EmbattleHeroPanel")
local GamePlayer = require("Player.GamePlayer")
local ArenaManager = require("Arena.ArenaManager")
local HeroManager = require("Hero.HeroManager")

function This:initNode(info)
	self.m_isDefender = info.isDefender
	self.m_battleHandler = info.battleHandler
	self.m_basePlayer = info.player
	super.initNode(self,info)
end

function This:initBaseInfo()
	self.m_csNode.bg3.totalhp:setString("0")
	self.m_csNode.bg3.cost:setString("0")
	self.m_csNode.diban2:setVisible(false)
	self.m_csNode.time:setVisible(false)
	self.m_csNode.text100:setVisible(false)
	self.m_csNode.bg3.name:setString(GamePlayer:getRoleName())
	if self.m_isDefender then
		self.m_csNode.Battlebutton.text:setString(Serialize["Arena_EmbattlePanel_1"])
		self.m_csNode.title:setString(Serialize["Arena_EmbattlePanel_2"])
		self.m_csNode.bg3.consume:setString(Serialize["Arena_EmbattlePanel_3"])
		self.m_csNode.bg3.tagettext:setString(Serialize["Arena_EmbattlePanel_4"])
		self.m_csNode.bg3.taget:setString(Serialize["Arena_EmbattlePanel_5"])
	else
		self.m_csNode.title:setString(Serialize["Arena_EmbattlePanel_6"])
		self.m_csNode.bg3.tagettext:setString(Serialize["Arena_EmbattlePanel_7"])
		self.m_csNode.bg3.consume:setString(Serialize["Arena_EmbattlePanel_8"])
		self.m_csNode.Battlebutton.text:setString(Serialize["Arena_EmbattlePanel_9"])
		self.m_csNode.bg3.taget:setString(self.m_basePlayer:getName())
	end
end

function This:getHeroSource()
	return ArenaManager:getDefenderCardIds()
end

function This:getFightPower()
	local total = 0
	for i , info in pairs(self.m_heros) do
		if info.heroId then
			local hero = HeroManager:getHero(info.heroId)
			local power = hero:getFightPower()
			print(string.format("heroId = %d, power = %f",info.heroId,power))
			total = total + math.floor(power)
		end
	end
	print(string.format("power = %d",total))
	return total
end

function This:refreshBaseInfo()
	local power = self:getFightPower()
	self.m_csNode.bg3.cost:setString(string.format("%d",power))
	local hp = self:getTotalHp()
	self.m_csNode.bg3.totalhp:setString(string.format("%d",hp))
end

function This:gotoBattle(heroList, isOnceKey)
end

function This:onConfirmBtnClick()
	local tmp = {0,0,0,0,0,0}
	local bHave = false
	for pos , info in pairs(self.m_heros) do
		local hero = HeroManager:getHero(info.heroId)
		tmp[pos] = hero:getUid()
		bHave = true
	end
	if self.m_isDefender then
		if not bHave  then
			g_scene:showTips(Serialize["Arena_EmbattlePanel_10"])
			return
		end
		ArenaManager:onSetCardListRequest(tmp)
	else
		if not bHave  then
			g_scene:showTips(Serialize["Arena_EmbattlePanel_11"])
			return
		end
		if self.m_battleHandler then
			self.m_battleHandler(tmp)
		end
	end
	self:close()
end

--endregion
