--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"cc.Node")
local HeroConfig = require("Metadatas.HeroConfig")
local ItemUtil = require("Bag.ItemUtil")

function This:init(info)
	self.m_csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/ArenaMainHero.csb")
	self:addChild(self.m_csNode)
	self:setModel(info)
end

function This:refresh()
	local config = HeroConfig[self.m_heroId]
	if config then
		self.m_csNode.icon:setImage(ItemUtil.getIconImage(self.m_heroId))
		self.m_csNode.iconbg:setImage(ItemUtil.getQualityImage(self.m_heroId))
		local star = math.floor(self.m_star / 5)
		for i = 1 , 5 do
			self.m_csNode["star"..i]:setVisible(star >= i)
		end
		self.m_csNode.icon:setVisible(true)
		self.m_csNode.iconbg:setVisible(true)
		self.m_csNode.toumingdi:setVisible(star > 0)
	else
		self.m_csNode.icon:setVisible(false)
		for i = 1 , 5 do
			self.m_csNode["star"..i]:setVisible(false)
		end
		self.m_csNode.iconbg:setVisible(false)
		self.m_csNode.toumingdi:setVisible(false)
	end
	self:createEffect()
end

function This:createEffect()
    local function createAnim( parent,anmStr )
        local GameUtil = require("Util.GameUtil")
        local effect1 = GameUtil:createEffect(anmStr,true)
        parent:addChild(effect1)
        return effect1
    end
    local node = self.m_csNode.anim
    node:removeAllChildren()
    if self.m_awake then
    	local effect = createAnim(node,"JueXing3")
		-- effect:setAngle(180)
	else
		node:removeAllChildren()
    end
end

function This:setModel(info)
	if info then
		self.m_id = info.id
		self.m_level = info.level
		self.m_star = info.star
		self.m_heroId = info.heroId
		self.m_awake = info.awake
	else
		self.m_heroId = 0
		self.m_id = 0
		self.m_awake = false
	end

	self:refresh()
end

--endregion
