-- @Author: superm
-- @Date:   2018-03-31 18:52:51
-- @Last Modified by:   superm
-- @Last Modified time: 2018-07-18 13:51:25
-- @File Name: ArenaPlayerInfoPanel.lua
-- @Description: 

local This , super = class(...,"Dialog")
local ArenaManager = require("Arena.ArenaManager")
local HeroConfig = require("Metadatas.HeroConfig")
local GameUtil = require("Util.GameUtil")
local HeroUtil = require("Hero.HeroUtil")
local ArenaHeroView = require("Arena.ArenaHeroView")

function This:initData( player )
    self.m_player = player
	self.m_cardNodes = {}
end

function This:initNode()
	self.m_csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/ArenaMainRankingItemDetails.csb")
	self:addChild(self.m_csNode)
	self.m_csNode:setToCenter()
	
	self.m_csNode.name:setString(self.m_player:getName())
	self.m_csNode.level:setString(tostring(self.m_player:getLevel()))
	GameUtil:setPlayerIconNodeImage(self.m_csNode.pic.icon, self.m_player:getIcon())
	self.m_csNode.fightnum:setString(Serialize[60287] .. tostring(self.m_player:getPower()))

	local groupName = self.m_player:getGroupName()
	if groupName ~= "" then
		self.m_csNode.family:setString(Serialize[60288] .. groupName)
	else
		self.m_csNode.family:setString(Serialize["Arena_PlayerInfo_1"])
	end
	
	self:refreshIndexNode()
	self:refreshCardList()
end

function This:initTouchEvent()
	if not self.m_inited then
		self.m_csNode.close:setTouchEnded(function()
			self:close()
		end)
		self.m_inited = true
	end
end

function This:refreshIndexNode()
	local rankIndex = self.m_player:getRankIndex()
	self.m_csNode.rank:setVisible(rankIndex > 3 or rankIndex <= 0)
	if rankIndex > 3 then
		self.m_csNode.rank:setString(string.format(Serialize["Arena_PlayerInfo_2"],rankIndex))
	elseif rankIndex <= 0 then
		self.m_csNode.rank:setString(Serialize["Arena_HelpTips_1_c"])
	end

	self.m_csNode.top:setVisible(rankIndex > 0 and rankIndex < 4)
	if rankIndex > 0 and rankIndex < 4 then
		self.m_csNode.top:setImage(string.format("MenuScene/top%d.png",rankIndex))
	end
	self.m_csNode.fightnum:setString(string.format(Serialize["Arena_PlayerInfo_3"],self.m_player:getPower()))
end

function This:refreshCardList()
	local cardList = self.m_player:getCardList()
	for i = 1 , 6  do
		if not self.m_cardNodes[i] then
			local view = ArenaHeroView:create(cardList[i])
			self.m_csNode["hero"..i]:addChild(view)
			self.m_cardNodes[i] = view
		else
			self.m_cardNodes[i]:setModel(cardList[i])
		end
	end
end