
--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"cc.Node")
local GameUtil = require("Util.GameUtil")
local ArenaManager = require("Arena.ArenaManager")
local MatchManager = require("Match.MatchManager")
local GamePlayer = require("Player.GamePlayer")

function This:init(player)
	self.m_player = player
	self.m_csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/ArenaMainItem.csb")
	self:addChild(self.m_csNode)
end

function This:refresh()
	if self.m_player then
		local icon = self.m_csNode.infonode.icon
		GameUtil:setPlayerIconNodeImage(icon, self.m_player:getIcon())
		GameUtil:setPlayerEffectNodeTo(icon, self.m_player:getEffect())

		self.m_csNode.infonode.level:setString(self.m_player:getLevel())
		self.m_csNode.infonode.name:setString(self.m_player:getName())
		self.m_csNode.infonode.ranknum:setString(string.format("%d",self.m_player:getRankIndex()))
		self.m_csNode.infonode.fightnum:setString(string.format("%d",self.m_player:getPower()))
		self.m_csNode.infonode.rank:setString(string.format("%s",MatchManager:getRankName(self.m_player:getRank())))
		self.m_csNode.infonode:setVisible(true)
	else
		self.m_csNode.infonode:setVisible(false)
	end
end

function This:initTouchEvent()
	self.m_csNode.infonode.challenge:setTouchEnded(function()
		local time = ArenaManager:getLeftChallengeCd()
		if time <= 0 then
			if not ArenaManager:hasDefendCards() then
				g_scene:showTips(Serialize["Arena_PlayerView_1"])
				return
			end
			local leftTimes = ArenaManager:getLeftChallengeTimes()
			if leftTimes <= 0 then
				g_scene:showTips(Serialize["Arena_PlayerView_2"])
				return
			end
			local panel = g_scene:openDialog("Arena.ArenaEmbattlePanel",{
				isDefender = false,
				battleHandler = function(tmp)
					local id = self.m_player:getId()
					local rankIndex = self.m_player:getRankIndex()
					ArenaManager:onChallengeArenaRequest(id,rankIndex,tmp)
				end,
				player = self.m_player
			})
		else
			local cost = math.ceil(time/kCostClearChallengeCD)
			GamePlayer:costDiamond({
				cost = cost,
				okHandler = function()
					ArenaManager:onClearChallengeCDRequest()
				end,
				desc = Serialize["Arena_PlayerView_3"]
			})
		end
	end)
	self.m_csNode.infonode.icon:setTouchEnded(function()
		g_scene:openDialog("Arena.ArenaPlayerInfoPanel",self.m_player)
	end)
end

function This:onEnter()
	super.onEnter(self)
	self:refresh()
	self:initTouchEvent()
end

function This:setChallengeHandler(handler)
	self.m_challengeHandler = handler
end

function This:setModel(player)
	self.m_player = player
	self:refresh()
end

--endregion
