-- @Author: superm
-- @Date:   2018-03-31 18:52:32
-- @Last Modified by:   zheng
-- @Last Modified time: 2018-07-12 16:14:17
-- @File Name: ArenaRankListItemView.lua
-- @Description: 

local This, super = class(..., "Rank.RankOfficeItemView")
This.fileName = "MenuScene/NodeUI/ArenaMainRankingItem.csb"

local GamePlayer = require("Player.GamePlayer")
local GameUtil = require("Util.GameUtil")

function This:refresh(info)
	super.refresh(self, info)
	if self.m_rankItem and self.m_rankItem.role_id > 0 then
		self.m_player = true
		self.m_selfInfo = self.m_rankItem.role_id == GamePlayer:getPlayerID()
	else
		self.m_player = false
		self.m_selfInfo = false
	end
end

function This:initTouchEvent()
    if not self.m_inited then
        self.see:setTouch({
		    onEnded = function()
                self:onViewClick()
            end,
         	isContainer = true,
        	isSwallow = false,
            isScale = false,
        })  
        self.m_inited = true
    end
end

function This:refreshIcon( new, old )
	local icon = self.pic.icon
	if new then
		GameUtil:setPlayerIconNodeImage(icon, new.icon)
		GameUtil:setPlayerEffectNodeTo(icon, new.effect)
	else
		GameUtil:setPlayerIconNodeImage(icon, GamePlayer:getIcon())
		GameUtil:setPlayerEffectNodeTo(icon, GamePlayer:getEffect())
	end
end

function This:refreshName( info )
    self.name:setString( (info and info.name) or GamePlayer:getRoleName() )
    self.fightnum:setString( Serialize[60291] .. (info and info.power) or 0 )
end

function This:refreshLevelInfo(new, old)
	self:refreshIcon(new, old)
	if new or old then
		if old then
			if old.level ~= new.level then
				self.level:setString("Lv." .. new.level)
			end
		else
			self.level:setString("Lv." .. new.level)
		end
	else
		self.level:setString("Lv."..GamePlayer:getLevel())
	end
end

function This:refreshFamilyInfo( info )
end

function This:onViewClick()
    if self.m_rankItem then
    	if self.m_player then
    		if not self.m_selfInfo then
                local player = require("Player.BasePlayer"):create(self.m_rankItem)
	    		g_scene:openDialog("Arena.ArenaPlayerInfoPanel", player)
	    	else
    			g_scene:showTips(Serialize["Arena_RankList_1"])
	    	end
	    else
    		g_scene:showTips(Serialize["Arena_RankList_2"])
	    end
    end
end
