--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"Dialog")
local ItemNode = require("UI.ItemNode")
local MenuScene = require("Home.MenuScene")
local ArenaManager = require("Arena.ArenaManager")

function This:initNode(info)
	self.m_csNode = cc.Node:createFromCSFile("GameScene/NodeUI/ArenaWin.csb")
	self:addChild(self.m_csNode)
	self.m_csNode:setToCenter()

	cc.Audio:playEffect("Win.mp3")				
	if info.maxRank > 0 then
		self.m_csNode.paiming:setString(string.format(Serialize["Arena_FailedPanel_1_c"],info.maxRank))
	else
		self.m_csNode.paiming:setString(Serialize["Arena_FailedPanel_2_c"])
	end
	self.m_csNode.high:setVisible(info.curRank <= info.maxRank)
	self.m_csNode.highbg:setVisible(info.curRank <= info.maxRank)
	self.m_csNode.youjian:setVisible(info.curRank <= info.maxRank)
	self.m_csNode.dangqianpaiming:setString(string.format(Serialize["Arena_FailedPanel_3_c"],info.curRank))
	self.m_csNode.changetext:setString(string.format(Serialize["Arena_VictoryPanel_1"],info.oldRank - info.curRank))
	local count = 0
	for i , item in ipairs(info.rewardList) do
		if item.id == 102 then
			count = item.num
			table.remove(info.rewardList,i)
			break
		end
	end
	self.m_rewardList = info.rewardList
	if count > 0 then
		self.m_csNode.jiangli:setString(string.format(Serialize["Arena_VictoryPanel_2"],count))
	else
		self.m_csNode.jiangli:setVisible(false)
	end

	self:initAnimation()
	self:initItmes()

	local offsetRank = 0
	if info.oldMaxRank > 0 then
		offsetRank = info.oldMaxRank - info.maxRank
	end

	if offsetRank > 0 then
		self.m_rankUpInfo = {
			diamond = count,
			offsetRank = offsetRank,
			maxRank = info.maxRank,
		}
	end
end

function This:getItemNode(itemId,itemNum)
	local node = ItemNode:create(itemId,itemNum)
	node:setCascadeOpacityEnabled(true)
	node:setAnchorPoint(0.5,0.5)
	return node
end

function This:initItmes()
	local initX = 0
	for i , info in ipairs(self.m_rewardList) do
		if  i <= 2 then
			local node = self:getItemNode(info.id,info.num)
			self.m_csNode["reward"..i]:addChild(node)
		end
	end
end

function This:initAnimation()
	self.m_csNode.continue:setScale(0.66)
	local seqence1 = cc.Sequence(cc.FadeTo(0.4,64),cc.FadeTo(0.4,255))
	local seqence2 = cc.Sequence(cc.ScaleTo(0.4,0.68),cc.ScaleTo(0.4,0.66))
	self.m_csNode.continue:runAction(cc.RepeatForever(cc.Spawn(seqence1,seqence2)))
end

function This:onTouchMask()
	cc.SceneManager:switchTo("Home.MenuScene")

	if ArenaManager:isArenaOpened() then
		local parameter = nil
		if self.m_rankUpInfo then
			parameter = {name = "Arena.ArenaRankUpReawrdPanel", arg=self.m_rankUpInfo}
		end
		MenuScene:addDelayDialog({name = "Arena.ArenaPanel", arg = { subview = parameter }})
	end
end


--endregion
