

local This , super = class(...,"NodeUI")


function This:initData(data)
    self.m_data = data
end

function This:initNode(data)
    self.m_csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/kingWayArrayInfoItem.csb")
    self:addChild(self.m_csNode)

    local w, h = self.m_csNode.xuanzhong:getContentSize()
    self:setContentSize(w, h)
    self:refresh()
end

function This:setModel(data)
    self.m_data = data
    self:refresh()
end

function This:refresh()
    local data = self.m_data
    local csNode = self.m_csNode

    csNode.number:setString(data.lv)
    csNode.zhanli:setString(data.fightPower)
    csNode.xuanzhong:setVisible(data.lv == data.curLv)

    local attrList = data.attrList
    for i=1, 3 do
    	local node = csNode[string.format("text%d", i)]
    	local text = attrList[i]
    	if text then
    		node:setStringWithColor(text)
    		node:setVisible(true)
    	else
    		node:setVisible(false)
    	end
    end
end