

local This , super = class(..., "NodeUI")
local ArenaHeroView = require("Arena.ArenaHeroView")


function This:initNode(info)
    local csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/kingWayArrayArrangementItem.csb")
    self:addChild(csNode)
    self.m_csNode = csNode

    local scale = 0.85
    csNode:setScale(scale)
        
    local w, h = csNode.bg:getContentSize()
    w = w*scale
    h = h*scale

    self:setAnchorPoint(0.5, 0.5)
    self:setContentSize(w, h)

    self:setModel(info)
end

function This:initTouchEvent()
    if not self.m_inited then
        self.m_inited = true

        self.m_csNode.bg:setTouch({
           	isScale = false,
	    	isDynamic = true,
			isSwallow = false,
            onEnded = function ()
                if type(self.m_clickCb) == "function" then
            		self.m_clickCb(self)
            	end 
            end,
        })
    end
end

function This:setClick(func)
	self.m_clickCb = func
end

function This:setModel(info)
	self.m_hero = info.hero
	self.m_armyTact = info.armyTact
	self:refresh()
end

function This:getHero()
	return self.m_hero
end

function This:getArmyTact()
	return self.m_armyTact
end

function This:refresh()
	local csNode = self.m_csNode
	local hero = self.m_hero

	if not self.m_heroNode then
		self.m_heroNode = ArenaHeroView:create({
			heroId = hero:getId(),
			level = hero:getLevel(),
			star = hero:getTotalPhase(),
			awake = hero:isAwakeFull(),
		})
		csNode.item:addChild(self.m_heroNode)
	else
		self.m_heroNode:setModel({
			heroId = hero:getId(),
			level = hero:getLevel(),
			star = hero:getTotalPhase(),
			awake = hero:isAwakeFull(),
		})
	end

	if self.m_armyTact then
		local config = self.m_armyTact:getConfig()
		csNode.xuanzhong.lbArray:setString(config.icon_word)
		csNode.xuanzhong:setVisible(true)
	else
		csNode.xuanzhong:setVisible(false)
	end
end