

local This , super = class(...,"cc.Node")

function This:init(info)
	self.m_armyTact = info
	self.m_isSelect = false
	self:initNode()
end

function This:initNode()
	local csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/KingWayArrayMenuBtn.csb")
	self:addChild(csNode)
	self.m_csNode = csNode

    local w, h = csNode.normal:getContentSize()
    self:setContentSize(w, h)

	self:refresh()
end

function This:initTouchEvent()
    if not self.m_inited then
        self.m_inited = true

        self:setTouch({
            isScale = false,
            onEnded = function ()
                if type(self.m_clickCb) == "function" then
            		self.m_clickCb(self)
            	end 
            end,
        })
    end
end

function This:setClick(func)
	self.m_clickCb = func
end

function This:onEnter()
	super.onEnter(self)
	self:initTouchEvent()
end

function This:setModel(info)
	self.m_armyTact = info
	self:refresh()
end

function This:getModel()
	return self.m_armyTact
end

function This:refresh()
	if not self.m_armyTact then
		return
	end

	local csNode = self.m_csNode
	local armyTact = self.m_armyTact
	local name = armyTact:getConfig().name
	local queue = armyTact:getQueue()
	local maxNum = armyTact:getSlotNum()

	csNode.normal:setVisible(not self.m_isSelect)
	csNode.normal.text:setString(name)
	csNode.normal.num:setString( string.format("(%d/%d)", #queue, maxNum) )

	csNode.light:setVisible(self.m_isSelect)
	csNode.light.text:setString(name)
	csNode.light.num:setString( string.format("(%d/%d)", #queue, maxNum) )

	csNode.lock:setVisible( armyTact:isLock() )
end

function This:setSelect(isSelect)
	if self.m_isSelect == isSelect then
		return
	end

	self.m_isSelect = isSelect

	local csNode = self.m_csNode
	csNode.normal:setVisible(not isSelect)
	csNode.light:setVisible(isSelect)
end