

local This , super = class(...,"NodeUI")
local GameUtil = require("Util.GameUtil")


function This:initData(data)
    self.m_data = data
    self.m_clickCb = nil
    self.m_isSelect = false
    self.m_isCheckRedDot = true
end

function This:initNode(data)
    local csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/kingWayArrayHero.csb")
    self:addChild(csNode)
    self.m_csNode = csNode

    local w, h = csNode.bg:getContentSize()
    csNode:setPosition(w/2, h/2)
    self:setContentSize(w, h)

    self:refresh()
end

function This:initTouchEvent()
    if not self.m_inited then
        self.m_inited = true

        self.m_csNode.bg:setTouch({
            isDynamic = true, 
            isContainer = true,
            isScale = false,
            onEnded = function ()
                if type(self.m_clickCb) == "function" then
                	self.m_clickCb(self)
               	end 
            end,
        })
    end    
end

function This:setModel(data)
    self.m_data = data
    self:refresh()
end

function This:getModel()
	return self.m_data
end

function This:refresh()
    local data = self.m_data
    local csNode = self.m_csNode
    local config = data:getConfig()
	local isLock = data:isLock()

    csNode.text:setString(config.name, AppText:isChinese() and 24 or nil)
    csNode.zhen:setImage(config.icon_name)    
    csNode.select:setVisible(self.m_isSelect)
    csNode.jie:setString( string.format(Serialize[60306], data:getStage()) )
    csNode.lv:setString( string.format(Serialize[60307], data:getLevel()) )
    csNode.panLock.lbLock:setString( data:getLockStr() )
    csNode.panLock:setVisible(isLock)
    csNode.jie:setVisible(not isLock)
    csNode.lv:setVisible(not isLock)

    self:refreshRedDot()
end

function This:setSelect(isSelect)
	self.m_isSelect = isSelect
	self.m_csNode.select:setVisible(self.m_isSelect)
end

function This:setClick(func)
	self.m_clickCb = func
end

function This:refreshRedDot()
    if self.m_isCheckRedDot then
        local isShow = self.m_data:isCanUpLevel() or self.m_data:isCanUpStage()
        local w, h = self.m_csNode.bg:getContentSize()
        GameUtil:refreshRedDot(self.m_csNode, isShow, {w/2-10, h/2-10})
    else
        GameUtil:refreshRedDot(self.m_csNode, false)
    end
end

function This:setCheckRedDot(isCheck)
    self.m_isCheckRedDot = isCheck
    self:refreshRedDot()
end