-- @Author: su
-- @Date:   2018-12-26 10:14:07
-- @Last Modified by:   zheng
-- @Last Modified time: 2019-01-02 16:02:23
-- @File Name: ArmsAwaKenPanel.lua
-- @Desc: 

local This , super = class(...,"Dialog")
local GameUtil = require("Util.GameUtil")
local HeroManager = require("Hero.HeroManager")
local DepotManager = require("Depot.DepotManager")

function This:initData(info)
    self.m_awakeSoilderId = info.awakeSoilderId
    self.m_hero = HeroManager:getHero(info.heroId)
    self.m_awakeSoilder = self.m_hero:getAwakeSoilder(self.m_awakeSoilderId)
    
    self.m_detailIdList = self.m_awakeSoilder:getNextConfig().unlock_arm
    self.m_detailConfig = {}
    self.m_detailConfig[1] = self.m_awakeSoilder:getDetailsConfig(self.m_detailIdList[1])
    self.m_detailConfig[2] = self.m_awakeSoilder:getDetailsConfig(self.m_detailIdList[2])
end

function This:initNode(info)
    self.m_csNode = cc.Node:createFromCSFile("GameScene/NodeUI/HeroArmsAwaKen.csb")
    self.m_csNode:setToCenter()
    self:addChild(self.m_csNode)

    self:refresh()
end

function This:onEnter()
    super.onEnter(self)
    DepotManager:addObserver(self)
end

function This:onExit()
    super.onExit(self)
    DepotManager:removeObserver(self)
end

function This:refresh()
    local function refreshDetailItem( node,model )
        node.name:setString(model.arm_name)
        node.name2:setString(model.arm_skill_name)
        node.desc:setString(model.skill_des, AppText:isChinese() and 258 or 600)
        -- node.tejiitem:setImage( string.format("Icons/Skill/%d.png",model.arm_skill_icon))--GameUtil:getSkillIcon(model.arm_skill_icon))
        node.tejiitem:setImage( GameUtil:getSkillIcon(model.arm_skill_icon))
        node.bingzhong:setImage( "Icons/Arm/"..model.arm_card..".png")
    end
    for detailIndex,detailId in ipairs(self.m_detailConfig) do
        local item1 = self.m_csNode["item"..detailIndex]
        refreshDetailItem(item1,detailId)
    end
    self.m_cost = self.m_awakeSoilder:getNeed()
    GameUtil:resetScoolItemNode(self.m_csNode.scrollview,self.m_cost,nil,true,30)
end

function This:initTouchEvent()
    local node = self.m_csNode
    node.close:setTouchEnded(function ()
        self:close()
    end)
    node.buy:setTouchEnded(function ()
        g_scene:openDialog("Awake.ArmsBuyPanel", {})  
    end)
    node.jiesuo:setTouchEnded(function ()
        if not GameUtil:checkNeedItem(self.m_csNode.scrollview) then
            local cardId = self.m_hero:getUid()
            local forceType = self.m_awakeSoilder:getId()
            HeroManager:onGetForceAwakeRequest(cardId,forceType)
            self:close()
        end
    end)
    for detailIndex,detailId in ipairs(self.m_detailConfig) do
        local item1 = self.m_csNode["item"..detailIndex]
        item1.tejiitem:setTouchEnded(function ()
           local res,level = self.m_awakeSoilder:getAwakeSkillDesc(self.m_detailIdList[detailIndex])
           g_scene:openDialog("Fabao.FabaoSkillInfoPanel", {
               skillName = self.m_detailConfig[detailIndex].arm_skill_name,
               skillDescriptionList = res,
               highlightIndex = level,
           })
       end)
        item1.bingzhong:setTouchEnded(function ()
            local info ={heroId= self.m_hero:getId(),detailId =self.m_detailIdList[detailIndex] ,
            awakeSoilderId = self.m_awakeSoilder:getId()}
           g_scene:openDialog("Awake.ArmsDetailsPanel",info)
       end)

    end

end

function This:onReceiveUniversalStoreItemInfo()
    self:refresh()
end