-- @Author: zheng
-- @Date:   2018-12-27 18:02:53
-- @Last Modified by:   superm
-- @Last Modified time: 2019-01-03 00:17:47
-- @File Name: ArmsBuyPanel.lua

local ArmPackageConfig = require("Metadatas.ArmPackageConfig")
local ItemShopConfig = require("Metadatas.ItemShopConfig")
local HeroManager = require("Hero.HeroManager")
local DepotManager = require("Depot.DepotManager")
local This , super = class(...,"Dialog")
-- local AwakeArmsManager = require("Awake.AwakeArmsManager")
local ShopMappingConfig = require("Metadatas.ShopMappingConfig")
-- local GameUtil = require("Util.GameUtil")
-- local HeroManager = require("Hero.HeroManager")
local ItemNode = require("UI.ItemNode")
local ItemUtil = require("Bag.ItemUtil")

This.fileName = "GameScene/NodeUI/HeroArmsBuy.csb"

function This:initData()
    DepotManager:onGetUniversalStoreItemInfoRequest(2)
    self.m_config = {}
    self.m_armsBuyInfo = {}
    local idlist = ShopMappingConfig[2].shop_id
    local index = 0
    for _,id in ipairs(idlist) do
        index = index + 1
        self.m_config[index] = ItemShopConfig[id]
        self.m_config[index].id = index
    end
end

function This:initNode(info)
    self.m_csNode = cc.Node:createFromCSFile(This.fileName)
    self.m_csNode:setToCenter()
    self:addChild(self.m_csNode)
    -- self:getData()
    self:refresh()
end


function This:refresh()
    self:refreshBaseInfo()
    self:refreshScroolView()
end

function This:initTouchEvent()
    local normal = self.m_csNode.normal
    self.m_csNode.beijing.closebg:setTouchEnded(function()
        self:close()
    end)

    local allCost = self:getAllCost()
    for index,config in ipairs(allCost) do
        local button = self.m_csNode["item"..index].button
        button:setTouchEnded(function()
            print(index)
            local data = self:getBuyInfo()

            local itemData = config
            local price = self:getCostMoney(index,data)
            local name = ItemUtil.getName(itemData.item_id)
            local num = itemData.num
            g_scene:openDialog("UI.CostConfirmPanel", {
            -- fileName = "MenuScene/NodeUI/ActivityHappyRewardVoucher.csb",
            cost = price,
            notips = "ChallengeStageManager",
            -- text1 = Serialize[60057],
            desc = string.format(Serialize[60326],num, name) ,
            okHandler = function(build)
                -- HeroManager:onBuyArmsRequest(ShopMappingConfig[2].id,ShopMappingConfig[2].shop_id[index])
                DepotManager:onBuyItemInUniversalStoreRequest(ShopMappingConfig[2].id,ShopMappingConfig[2].shop_id[index])
            end } )
        end)
    end
end

function This:onEnter()
    super.onEnter(self)
    HeroManager:addObserver(self)
    DepotManager:addObserver(self)
end

function This:onExit()
    super.onExit(self)
    HeroManager:removeObserver(self)
    DepotManager:removeObserver(self)
end

function This:refreshBaseInfo()
    
end

function This:creatItemNode(parent,key,needNum)
    local name = "ItemNode"
    local node = parent:getChildByName(name)
    if not node then
        node = ItemNode:create(key, needNum)
        node:setAnchorPoint(0.5, 0.5)
        parent:addChild(node)
        node:setName(name)
    end
   node:initItem(key,needNum)
   return node
end

function This:refreshScroolView()

    local function refreshItems(node,costModel)
        local data = self:getBuyInfo()
        local itemNum = costModel.num
        local itemId = costModel.item_id
        local discountNum = self:getDiscount(costModel.id,data)
        local price = self:getCostMoney(costModel.id,data)
        local costId =  costModel.cost_id
        local itemNode = self:creatItemNode( node.itemParent,itemId,itemNum)
        node.name:setString(itemNode:getItemName())

        local discountNode = node.discountNode
        local discountVisible = false
        if discountNum<10 then
            discountVisible = true
            discountNode.discount:setString(discountNum..Serialize[60327])
        end
        discountNode:setVisible(discountVisible)

        node.yuanbao:setImage(ItemUtil.getIconImage(costId))
        node.number:setString(price)
        node.button:setTag(costModel.id)
        -- node.button:setTag(price)
    end
    local allCost = self:getAllCost()

    for costIndex,costModel in ipairs(allCost) do
        local item1 = self.m_csNode["item"..costIndex]
        refreshItems(item1,costModel)
    end
end

function This:getAllCost()
    return self.m_config
end

function This:getCostMoney(id,list)
    local res = self.m_config[id].price
    if not list[1] or not list[1][id] then
        return res[1]
    end
    local index = list[1][id]
    local num = table.count(res)
    if index >= num then
        index = num
    end
    return res[index]
end

function This:getDiscount(id,list)
    local res = self.m_config[id].discount
    if not list[1] or not list[1][id] then
        return res[1]
    end
    local index = list[1][id]
    local num = table.count(res)
    if index >= num then
        index = num
    end
    return res[index]
end

function This:setBuyInfo( buyInfo)
	local index = 1
    local re = buyInfo.count_list
    local ne = buyInfo.index_list
    local ret = {{},{}}

    for _, configId in pairs(ShopMappingConfig[2].shop_id) do
		for count, data in ipairs(ne) do
            if data == configId then
                ret[1][index] = re[count] + 1
            end
        end
        index = index + 1
    end
    ret[2] = ne
    self.m_armsBuyInfo = ret
end

function This:getBuyInfo()
	return self.m_armsBuyInfo or {}
end

function This:onReceiveUniversalStorePurchaseResult( msg )
    DepotManager:onGetUniversalStoreItemInfoRequest(2)
    local config = ItemShopConfig[msg.buy_index]
    local reward ={{config.item_id,config.num}}
    g_scene:showReward(reward)
end

function This:onReceiveUniversalStoreItemInfo( msg )
    self:setBuyInfo(msg.buy_info)
    self:refresh()
end