-- @Author: zheng
-- @Date:   2018-07-21 15:09:36
-- @Last Modified by:   zheng
-- @Last Modified time: 2020-07-09 10:45:57
-- @File Name: AwakStarPanel.lua
-- 星位升级界面，点击星位的界面
-- TroopAdjustPanel.lua
local ItemNode = require("UI.ItemNode")
local This , super = class(...,"Dialog")
local HeroManager = require("Hero.HeroManager")
This.fileName = "MenuScene/NodeUI/WakeStar.csb"
local strList ={
    Lv = Serialize[60312],
    needTip =Serialize[60334],
}
function This:initNode(info)
    self.m_heroId = info.heroId
    self.m_starIndex = info.starIndex --点击的星位id,(1_20)
    self.m_paragraphSelect = info.paragraphSelect --现在是第几阶段 
    self.m_csNode = cc.Node:createFromCSFile(This.fileName)
    self.m_csNode:setToCenter()
    self:addChild(self.m_csNode)
    self:refreshAwakeData()

    self.m_offsetPercentx= 0.05
    self.m_curentPercent = 0
    local slideNode = self.m_csNode.luckNode.slider
    slideNode:setSilderHandler(function(percent)
        print(percent)
        if percent>=(self.m_curentPercent+self.m_offsetPercentx ) or percent<=(self.m_curentPercent-self.m_offsetPercentx ) then
            local temLuckNum = self:checkLuckNum(percent)
            self:refreshSlider(temLuckNum)
        end
        if percent<=self.m_minLuck then
            return self.m_minLuck
        end
        -- self:refresh()
        return percent--self.m_curHp / self.m_maxHeroHp
    end)
    self.m_curentPercent = self.m_minLuck
    slideNode:setPercent(self.m_minLuck)
    self.m_luckText = self.m_csNode.luckNode.text

    --星位进度条
    self.m_progressTimer = self:getProgress( self.m_csNode.xing,self.m_csNode.xing.jindu )
    --星位名字和进度文字
    self.m_progressTxtNum = self.m_csNode.xingname
    -- --幸运值进度条
    -- self.m_perfectTimer = self.m_csNode.manjiyincang.jindu.jindutiao
    -- -- 幸运值数字
    -- self.m_perfectTxtNum = self.m_csNode.manjiyincang.jindu.numberluck
    self:initAttr()
    self:refresh()
end

function This:refreshStarName(  )
    local hero_id = self.m_heroId
    local starDatas = self.m_starDatas
    local paragraph = self.m_paragraph
    local paragraphSelect = self.m_paragraphSelect
    local fulllevel = self.m_fulllevel
    local myUtil = self.m_util
    local starId = self.m_starId
    local curentStarLv = self.m_curentStarLv
    local maxStarLv = self.m_maxStarLv
    local nextStarLv = self.m_nextStarLv
    local starName = myUtil:getStarInfo(starId).name
    local str = string.format("%s(%d/%d)",starName,curentStarLv,maxStarLv)
    local percent = myUtil:getStarMaxLevel(starId,curentStarLv)
    self.m_progressTxtNum:setString(str)
    self.m_progressTimer:setPercent(percent)
    self:refreshAttr()
    self:refreshUpdataNeed()
end

function This:getStarId(  )
    local paragraphStarList = self.m_util:getParagraphStarList(self.m_heroId,self.m_paragraphSelect)
    local starId = paragraphStarList[self.m_starIndex]
    return starId
end

function This:refreshUpdataNeed()
	
    local heroId = self.m_heroId
    local starDatas = self.m_starDatas
    local paragraph = self.m_paragraph
    local paragraphSelect = self.m_paragraphSelect
    local fulllevel = self.m_fulllevel
    local curentStarLv = self.m_curentStarLv
    local nextStarLv = self.m_nextStarLv
    local maxStarLv = self.m_maxStarLv
    local myUtil = self.m_util
    local starId = self.m_starId
    if curentStarLv ==0 then
        curentStarLv = 1
    end
    local manjiyincang = self.m_csNode.manjiyincang
    local luckNode = self.m_csNode.luckNode
    if curentStarLv ==maxStarLv then
        manjiyincang:setVisible(false)
        -- luckNode:setVisible(false)
    else
        manjiyincang:setVisible(true)
        -- luckNode:setVisible(true)
        local updateNeed = myUtil:getAwakeStarNeed(heroId, starId, nextStarLv)
        
        local curentPercent = self.m_curentPercent 
        local updateNeed2 = {}
        for itemId,itemValue in pairs(updateNeed) do
            -- itemValue= 200
            local temValue = itemValue*curentPercent
            updateNeed2[itemId]= string.ceilOrFloor(temValue,true)
        end
        self:refreshItemNode(manjiyincang,updateNeed2)
    end

end

function This:refreshAttr()
    local heroId = self.m_heroId
    local starDatas = self.m_starDatas
    local paragraph = self.m_paragraph
    local paragraphSelect = self.m_paragraphSelect
    local fulllevel = self.m_fulllevel
    local curentStarLv = self.m_curentStarLv
    local nextStarLv = self.m_nextStarLv
    local maxStarLv = self.m_maxStarLv
    local myUtil = self.m_util
    local starId = self.m_starId
    local attr = self._m_attr
    local maxLevelAttr = myUtil:getStarAccumulateAttr(heroId, starId, nextStarLv)
    local curentLevelAttr = table.clone(maxLevelAttr)
    if curentStarLv~= 0 then
        curentLevelAttr = myUtil:getStarAccumulateAttr(heroId, starId, curentStarLv)
    else
        for k,v in pairs(curentLevelAttr) do
            curentLevelAttr[k]=0
        end
    end
    local attrs ={curentLevelAttr,maxLevelAttr}
    local LvList ={curentStarLv,nextStarLv}
    for i,v in ipairs(attr) do
        local attrStr = self:getAttrStr(attrs[i])
        self.m_util:resetScoolSize(v.scrollView,118,132,attrStr) 
        local lvStr= string.format(strList.Lv,LvList[i])
        v.lv:setString(lvStr)
        local attrVisible = true
        if i>1 then --控制面板2是否显示
            if curentStarLv == maxStarLv then 
                attrVisible = false
            end
            v:setVisible(attrVisible)
            self.m_csNode.manji:setVisible(not attrVisible)
        end
    end
end

function This:initAttr(  )
    local attr ={}
    for i=1,2 do
        local item = self.m_csNode["shuxing"..i]
        item.lv = item:getChildByName("level1")
		attr[i]= item
    end
    self._m_attr =attr
end

function This:getAttrStr( srcTable )
    local myUtil = self.m_util
    return myUtil:convertDataToStr(srcTable)
end

function This:checkNeedItem( node )
    local name = "ItemNode"
    for i=1,2 do
        local item = node["item"..i]
        if item then
            local itemNode = item:getChildByName(name)
            local needNum =itemNode.needNum
            local total1 = itemNode:getItemCount()
            if needNum> total1 then
                local name = itemNode:getItemName() 
                g_scene:showTips(string.format(strList.needTip,name))
                return true
            end
        end
    end
    return false
end

function This:refreshItemNode( node,scrTable )
    local count = 1
    for k,v in pairs(scrTable) do
        local item = node["item"..count]
        self:creatItemNode(item,k,v)
        count = count+1
    end
end

function This:creatItemNode(parent,key,needNum)
    print(key,"creatItemNode",needNum)
    local name = "ItemNode"
    local node = parent:getChildByName(name)
    if not node then
        node = ItemNode:create(key, 1,true)
        node:setAnchorPoint(0.5, 0.5)
        parent:addChild(node)
        node:setName(name)
    end
    node.needNum = needNum
   node:showNeedNum(needNum)
end

function This:getProgress( parent,sprite )
	local progressTimer = cc.ProgressTimer:create(sprite)
    parent:addChild(progressTimer)
    progressTimer:setScaleY(-1)
    local w , h = parent:getContentSize()
    progressTimer:setPosition(w/2,h/2)
    return progressTimer
end

function This:refresh(  )
    self:refreshAwakeData()
    self:refreshStarName()
    self:refreshSlider()
end

function This:initTouchEvent()
    local csNode = self.m_csNode
    local luckNode = csNode.luckNode
    csNode.beijing.close:setTouchEnded(function()
        -- self:createEffect(5)
		self:close()
	end)
    csNode.manjiyincang.button:setTouchEnded(function()
        if self:checkNeedItem( csNode.manjiyincang ) then
            return
        end
        local hero = self:getHeroData()
        local uid = hero:getUid()
        local starId = self.m_starId
        HeroManager:onGetUpdateStarLevelRequest(uid,starId,self.m_curentPercent*100)
		print("升级按钮","uid",uid,"starId",starId)
	end)
    csNode.manjiyincang.wenhao:setTouchEnded(function()
        g_scene:openDialog("UI.HelpTips", {text = Serialize["Awake_StarPanel_1"],node = self.m_csNode.manjiyincang.wenhao})
    end)

    luckNode.Minbutton:setTouchEnded(function()
        local checkLuckNum = self.m_curentPercent-self.m_offsetPercentx
        if checkLuckNum<self.m_minLuck then
            checkLuckNum = self.m_minLuck
        end
        self:refreshSlider(checkLuckNum)
        luckNode.slider:setPercent(checkLuckNum)
    end)
    luckNode.Maxbutton:setTouchEnded(function()
        local checkLuckNum = self.m_curentPercent+self.m_offsetPercentx
        if checkLuckNum>1 then
            checkLuckNum = 1
        end
        self:refreshSlider(checkLuckNum)
        luckNode.slider:setPercent(checkLuckNum)
    end)

end

function This:checkLuckNum(luckNum)
    -- self.m_curentPercent
    local percent = self.m_offsetPercentx--%5
    local minLuck = self.m_minLuck
    local offset = luckNum-minLuck
    if offset<=0 then
        return minLuck
    else
		local temCount = offset/percent
        local temValue = math.ceil(temCount)--向上取整
        local temLuckNum= percent*temValue+minLuck
        if temLuckNum>1 then
            temLuckNum = 1
        end
        return temLuckNum
    end
end

function This:refreshSlider(slideNum)
    if slideNum then
        self.m_curentPercent = slideNum
    end
    local minLuck = self.m_minLuck
    local curentPercent= self.m_curentPercent
    print("refreshSlider%"..curentPercent*100)
    local minLuckPercent = minLuck*100
    local luckOffsetPercent = (curentPercent-minLuck)*100
    local str = "<New13>"..Serialize["Awake_StarPanel_2"]..":"..minLuckPercent.."%+<New9>"..
    luckOffsetPercent.."%<New13>(<New11>"..Serialize["Awake_StarPanel_3"].."<New13>)"
    -- local str = string.format("<New13>%s:%d%%+<New9>%d%%<New13>(<New11>%s<New13>)",
    --         Serialize["Awake_StarPanel_2"],minLuckPercent,luckOffsetPercent,
    --         Serialize["Awake_StarPanel_3"])
    self.m_luckText:setStringWithColor(str)
    self:refreshUpdataNeed()
end

-- 觉醒星位升级刷新
function This:onGetUpdateStarLevel( isSucess )
    self:refresh()
    if isSucess then
        self.m_curentPercent = self.m_minLuck
        self:refreshSlider()
        local slideNode = self.m_csNode.luckNode.slider
        slideNode:setPercent(self.m_minLuck)
        
        local heroId = self.m_heroId
        local starDatas = self.m_starDatas
        local myUtil = self.m_util
        local starId = self.m_starId
        local curentStarLv = self.m_curentStarLv
        local maxLevelAttr = myUtil:getStarAccumulateAttr(heroId, starId, curentStarLv)
        local attrCount = table.count(maxLevelAttr)
        self:createEffect(attrCount)
    end
end

function This:createEffect(attrCount)
    if not attrCount then
        return
    end
    local function createAnim( parent,anmStr )
        local GameUtil = require("Util.GameUtil")
        local effect1 = GameUtil:createEffect(anmStr)
        parent:addChild(effect1)
        return effect1
    end
    local node = self.m_csNode.anim
    node:removeAllChildren()
    local offsetY= -21.44
    local attrYs = {1,3,5}
    if attrCount>=5 then
    elseif attrCount>=3 then
        attrYs = {attrYs[1],attrYs[2]}
    else--if  then
        attrYs = {attrYs[1]}
    end
    for i,v in ipairs(attrYs) do
        local effects = createAnim( node,"ShuXing" )
        local y= (v-1)*offsetY
        effects:setPositionY(y)
    end

end

function This:onEnter()
    super.onEnter(self)
    HeroManager:addObserver(self)
end

function This:onExit()
    super.onExit(self)
    HeroManager:removeObserver(self)
end

function This:refreshAwakeData()
    local hero = self:getHeroData()
    self.m_util = hero:getAwake()
    local starDatas,paragraph,fulllevel = self.m_util:getAwakeInfor()
    self.m_starDatas = starDatas
    self.m_paragraph = paragraph
    self.m_fulllevel = fulllevel

    local starId = self:getStarId()
    local curentStarLv = self.m_util:getStarLevel( starDatas,starId )
    local maxStarLv = self.m_util:getStarMaxLevel( starId )
    local nextStarLv = curentStarLv+1
    if nextStarLv >= maxStarLv then
         nextStarLv = maxStarLv
    end 
    self.m_minLuck = self.m_util:getInitLuck(self.m_heroId,starId,nextStarLv)
    self.m_starId = starId
    self.m_curentStarLv = curentStarLv
    self.m_maxStarLv = maxStarLv
    self.m_nextStarLv = nextStarLv
    -- self.m_minLuck = 0.5
end

function This:getHeroData()
    return HeroManager:getHero(self.m_heroId)
end