-- @Author: zheng
-- @Date:   2018-07-19 10:55:11
-- @Last Modified by:   zheng
-- @Last Modified time: 2018-09-06 11:39:26
-- @File Name: AwakTabPanel.lua
--入口
local This, super = class(..., "Dialog")
local HeroManager = require("Hero.HeroManager")
local HeroConfig = require("Metadatas.HeroConfig")
local txtColor ={
    wake = cc.ColorList.New1,
    normal = cc.ColorList.New3,
}
local strList ={
	perfect1 = Serialize[60337],
	perfect2 = Serialize[60338],
	updateStar =Serialize[60339],
	awake= "%s▪%s",
	switch = Serialize[60340],
	perfect = Serialize[60341],
}
This.fileName = "MenuScene/NodeUI/Wake.csb"

function This:initNode(info)
	local heroId= info.heroId
	self.m_csNode = cc.Node:createFromCSFile(This.fileName)
    self.m_csNode:setToCenter()
    self:addChild(self.m_csNode)
	self:initStarlevel()
	self:initPerfect()
	self:setModel(heroId)
end
  
-- 刷新武将数据
function This:setModel(heroId)
	if self.m_heroId ~= heroId then
		self.m_heroId = heroId
		self:refreshAwakeData()
		local paragraph =1
		for i=1,self.m_paragraph do
			local lockParagraph ,lockStr = self.m_util:getParagraphUnlockLimit(i)
			paragraph=i
			if lockParagraph then
				paragraph= i-1
				break
			end
		end
		if paragraph<1 then
			paragraph =1
		end
	    self.m_paragraphSelect = paragraph
	    self:refresh()
	end
end

function This:refresh()
	self:refreshAwakeData()
	self:refreshStarLevel()
	self:refreshperfect()
	self:refreshAttr()
	self:refreshBtn()
	local titleTxt = self.m_csNode.jinengname
	local desTXt = self.m_csNode.jinenginfo
	local widthLimit = 177
	local heightLimit =139
	local title,desc = self.m_util:getAwakeTitle(self.m_heroId,self.m_paragraphSelect)
	titleTxt:setString(title)
    self.m_util:resetScoolSize2(self.m_csNode.scrollView1,widthLimit,heightLimit,desc)
    local awake = self:getIsAwak(  )
	self.m_util:resetScoolColor2( self.m_csNode.scrollView1,{txtColor.wake,txtColor.normal},awake )
end

--请求觉醒刷新
function This:onGetAwake(  )
    self:refreshAwakeData()
    local lockParagraph ,lockStr = self.m_util:getParagraphUnlockLimit()
    if not lockParagraph then
    	self.m_paragraphSelect = self.m_paragraph
	end	
	self:refresh()
end

-- 觉醒星位升级刷新
function This:onGetUpdateStarLevel( isSucess )
	if isSucess then
    	self:refresh()
	end
end

function This:refreshStarLevel(  )
	local heroId = self.m_heroId
	local starDatas = self.m_starDatas
	local paragraphSelect = self.m_paragraphSelect
	local fulllevel = self.m_fulllevel
	local myUtil = self.m_util
	local xingWei = self.m_xingWei
	self.m_csNode.beijing.pianzhangbg:setImage(string.format("MenuScene/xingtu%d.jpg",paragraphSelect))
	for i,v in ipairs(xingWei) do
		v:setVisible(i==paragraphSelect)
	end
	local line = xingWei[paragraphSelect].lines
	local stars = xingWei[paragraphSelect].stars
	local locakStars ,curentStarLevel = myUtil:isStarUnlockList(heroId,starDatas,paragraphSelect)
	local paragraphStarList = myUtil:getParagraphStarList(heroId,paragraphSelect)
	for i,v in ipairs(paragraphStarList) do--某一阶段包含的星位列表
		local starLv = curentStarLevel[v]
		local jinduNum = myUtil:getStarMaxLevel( v, starLv)
		local itemStar = stars[i]
		itemStar.jindu:setPercent(jinduNum)
		itemStar.waiquan:setVisible(jinduNum==100)
		itemStar.wanchengline:setVisible(jinduNum==100)
		local activation = locakStars[v]
		itemStar.jihuoline:setVisible(activation)
		if i>1 then
			local line = line[i-1]
			line:setVisible(activation)
		end
	end
	local paragraphData = myUtil:getParagraphInfor(heroId,paragraphSelect)
	local paragraphName = paragraphData.stage_name
	local stageCountName = paragraphData.stage_count_name
	self:modifyWeakName(string.format(strList.awake,stageCountName,paragraphName))
end

function This:initStarlevel( )
	local xingWei={}
	local function getxingWeis(node,maXCount)
		local lines ={}
		local lineCount = maXCount-1
		for i=1,lineCount do
			local item = node["xingline"..i]
			lines[i]= item
		end
		local stars = {}
		for i=1,maXCount do
			local item = node["xing"..i]
			item.jindu = self:getProgress( item,item["jindu"] )
			stars[i]= item
		end
		node.lines = lines
		node.stars = stars 
	end
	local limitTable= {5,7,8}
	for i=1,AwakdValue.ParagraphLimit do
		local node = self.m_csNode["xingwei"..i]
		getxingWeis(node,limitTable[i])
		xingWei[i]=node
	end
	self.m_xingWei =xingWei
end

function This:refreshperfect(  )
	local heroId = self.m_heroId
	local starDatas = self.m_starDatas
	local paragraphSelect = self.m_paragraphSelect
	local fulllevel = self.m_fulllevel
	local myUtil = self.m_util
	local wanmeidu = self.m_wanmeidu
	local perfect ,arrsResult,arrs = myUtil:calculationPerFect(heroId,starDatas,paragraphSelect)
	local txtStr = wanmeidu.txts
	local stars =wanmeidu.stars
	local perfectList = myUtil:getParagraphInfor(heroId,paragraphSelect).perfect--完美度列表
	local perfectArg = myUtil:getParagraphInfor(heroId,paragraphSelect).perfect_arg--完美度属性
	for i,v in ipairs(perfectList) do
		local perfectItem = perfectArg[i]
		local temFormat = strList.perfect2
		local color = {r=136, g=152, b=190}
		if i<= #arrs then
			color = {r=184, g=228, b=97}
			temFormat = strList.perfect1
		end
		local txt =txtStr[i]
		local name,desc = myUtil:getAttrStr(perfectItem[1],perfectItem[2])
		local str = string.format(temFormat,v*100,name,desc)
		txt:setString(str)
		txt:setColor(color.r,color.g,color.b)
		stars[i]:setVisible(i<=#arrs )
	end
	wanmeidu.jindutiao:setPercent(perfect*100)
	local temDian ={}
	local dianOffset = 0.1
	local dian = 0
	for i=1,10 do
		dian = dian+dianOffset
		temDian[i]= dian
	end
	local dians = wanmeidu.dians
	for i,v in ipairs(temDian) do
		dians[i]:setVisible(perfect>=v)
	end
	local awake = self:getIsAwak()
	local isAdd = false
	if not awake and perfect == 1 then
		isAdd = true
	end
	self:createEffect(isAdd)
end

function This:createEffect(isAdd)
    local function createAnim( parent,anmStr )
        local GameUtil = require("Util.GameUtil")
        local effect1 = GameUtil:createEffect(anmStr,true)
        parent:addChild(effect1)
        return effect1
    end
    local node = self.m_csNode.dian.kongdiandi10.kongdian.anim
    node:removeAllChildren()
    if isAdd then
    	createAnim( node,"JueXing4" )
    end
end

function This:initPerfect(  )
	local wanmeidu ={}
	local txts = {}
	local dians = {}
	local stars ={}
	for i=1,3 do
		local item = self.m_csNode["wanmeidu"..i]
		txts[i]= item
		local item2 = self.m_csNode["xiaoxing"..i] 
		stars[i]= item2
	end
	local starX = -283
	local XOffset = 389/10
	for i=1,10 do
		local item = self.m_csNode.dian["kongdiandi"..i]
		local x = starX+XOffset*i
		if i==10 then
			x= x-8
		end
		item:setPositionX(x)
		dians[i]= item.kongdian
	end
	wanmeidu.txts = txts
	wanmeidu.jindutiao = self.m_csNode.jindu.jindutiao
	wanmeidu.dians = dians
	wanmeidu.stars = stars
	self.m_wanmeidu = wanmeidu
end

function This:refreshAttr(  )
	local hero_id = self.m_heroId
	local starDatas = self.m_starDatas
	local paragraph = self.m_paragraph
	local paragraphSelect = self.m_paragraphSelect
	local fulllevel = self.m_fulllevel
	local myUtil = self.m_util
	local awake = self:getIsAwak(  )
	local curentAttr =myUtil:getParagraphCurrentAttr(hero_id, starDatas,paragraphSelect,awake)
	local allAttr = myUtil:getParagraphData(hero_id, paragraphSelect )
	for k,v in pairs(allAttr) do
		allAttr[k]=0
	end
	myUtil:tableAdd(curentAttr,allAttr)
	local desc = myUtil:convertDataToStr(allAttr,true)
	self:resetAttrs(  desc )
end


function This:resetAttrs(  str )
	local node = self.m_csNode.scrollView
	self.m_util:resetScoolSize2(node,177,139,str)
end

function This:getProgress( parent,sprite )
	local progressTimer = cc.ProgressTimer:create(sprite)
    parent:addChild(progressTimer)
    progressTimer:setScaleY(-1)
    local w , h = parent:getContentSize()
    progressTimer:setPosition(w/2,h/2)
    return progressTimer
end

function This:getIsAwak(  )
    self:refreshAwakeData()
    local isUpdatae = false
    if self.m_fulllevel or self.m_paragraph> self.m_paragraphSelect then
        isUpdatae = true
    end
    return isUpdatae
end

function This:starCallBack(index)
	print("starCAllBack",index)
	local hero_id = self.m_heroId
	local starDatas = self.m_starDatas
	local paragraphSelect = self.m_paragraphSelect
	local fulllevel = self.m_fulllevel
	local myUtil = self.m_util

	local locakStars ,curentStarLevel = myUtil:isStarUnlockList(hero_id,starDatas,paragraphSelect)
	local paragraphStarList = myUtil:getParagraphStarList(hero_id,paragraphSelect)
	local starId = paragraphStarList[index] 
	if locakStars[starId] then
		g_scene:openDialog("Awake.AwakStarPanel",{heroId = self.m_heroId,starIndex = index,paragraphSelect = paragraphSelect})
	else
		local starLimit = myUtil:getStarInfo(starId).unlock_Paragraphlevel
		g_scene:showTips(string.format(strList.updateStar,starLimit))
	end
end

function This:refreshBtn(  )
	self.m_csNode.beijing.jiantou1:setVisible(self.m_paragraphSelect~=1)
	self.m_csNode.beijing.jiantou2:setVisible(self.m_paragraphSelect~=3)
end

function This:initTouchEvent()
	self.m_csNode.beijing.txt_bg:setTouchEnded(function()
		print("look")
		g_scene:openDialog("Awake.AwakeInfoPanel",{heroId = self.m_heroId,showAwake = true})
	end)
	self.m_csNode.beijing.close:setTouchEnded(function()
		self:close()
	end)
	self.m_csNode.beijing.jiantou1:setTouchEnded(function()
		print("left")
		if self.m_paragraphSelect>1 then
			self.m_paragraphSelect = self.m_paragraphSelect -1
			self:refresh()
		end
	end)
	self.m_csNode.beijing.jiantou2:setTouchEnded(function()
		print("right")
		if self.m_paragraph < (self.m_paragraphSelect +1) then
			g_scene:showTips(strList.switch)
			return
		end
		local lockParagraph ,lockStr = self.m_util:getParagraphUnlockLimit(self.m_paragraphSelect+1)
	    if lockParagraph then
	       g_scene:showTips(lockStr) 
	       return
	    end
		if self.m_paragraphSelect<AwakdValue.ParagraphLimit then
			self.m_paragraphSelect = self.m_paragraphSelect +1
			self:refresh()
		end
	end)
	self.m_csNode.dian.kongdiandi10:setTouchEnded(function()
		if not self.m_csNode.dian.kongdiandi10.kongdian:isVisible() then
			g_scene:showTips(strList.perfect)
			return
		end
		g_scene:openDialog("Awake.AwakeUpPanel",{heroId = self.m_heroId,paragraphSelect = self.m_paragraphSelect})
	end)
	self.m_csNode.wenhaoxin:setTouchEnded(function()
		g_scene:openDialog("UI.HelpTips", {text = Serialize["Awake_TabPanel_1"],node = self.m_csNode.wenhaoxin})
	end)
	for phase,v in ipairs(self.m_xingWei) do
		for index,v1 in pairs(v.stars) do
			v1:setTouchEnded(function()
				self:starCallBack(index)
			end)
		end
	end
end


function This:onEnter()
	super.onEnter(self)
	HeroManager:addObserver(self)
end

function This:onExit()
	super.onExit(self)
	HeroManager:removeObserver(self)
end



--觉醒七煞
function This:modifyWeakName(txt)
	if txt then
		self.m_csNode.wakechoice.name:setString(txt)
	end
end

function This:onGetCardAwakeInfo(star, level)
	local list = { }

	return list
end

function This:refreshAwakeData()
	local hero = self:getHeroData()
	self.m_util = hero:getAwake(  )
	local starDatas,paragraph,fulllevel = self.m_util:getAwakeInfor()
	self.m_starDatas = starDatas
	self.m_paragraph = paragraph
	self.m_fulllevel = fulllevel
end

function This:getHeroData()
	return HeroManager:getHero(self.m_heroId)
end
