-- @Author: zheng
-- @Date:   2018-07-23 14:50:35
-- @Last Modified by:   zheng
-- @Last Modified time: 2018-09-06 11:39:26
-- @File Name: AwakeInfoItemView.lua
local HeroManager = require("Hero.HeroManager")
local This , super = class(...,"NodeUI")
local txtColor ={
    wake = cc.ColorList.New1,
    normal = cc.ColorList.New3,
    wake2 = cc.ColorList.New9,
    normal2 = {r=144,g=152,b=166},
}
This.fileName = "MenuScene/NodeUI/WakeInfoList.csb"

function This:initNode(info)
    self.m_heroId = info.heroId
    self.m_paragraphSelect = info.paragraph
    self.m_showAwake = info.showAwake
    self:refreshAwakeData()
    self:refresh()
end

function This:refresh(  )
    local awake = self:getIsAwak(  )
	self.tu:setImage(string.format("MenuScene/xingtuxiao%d.png",self.m_paragraphSelect))
	local attrs = self.m_util:getParagraphData(self.m_heroId,self.m_paragraphSelect)
	local strs ,lineCount = self.m_util:convertDataToStr(attrs)
	self.m_util:resetScoolSize(self.scrollView,180,118,strs,lineCount)
	local colors = {txtColor.normal2,txtColor.normal2}
	if awake and self.m_showAwake then
		colors = {txtColor.wake2,txtColor.wake2}
	end
	self:resetScoolColor( self.scrollView,colors )
	local lineTxture ="Common/line12.png"
	self:resetScroolLine( self.scrollView,lineCount,lineTxture,110 )
	local paragraphName = self.m_util:getParagraphInfor(self.m_heroId,self.m_paragraphSelect).stage_name
	self.name:setString(paragraphName)
	local widthLimit = 194
	local heightLimit =56
	local title,desc = self.m_util:getAwakeTitle(self.m_heroId,self.m_paragraphSelect)
    self.jinengname:setString(title)
    self.m_util:resetScoolSize2(self.scrollView2,widthLimit,heightLimit,desc)
	self.m_util:resetScoolColor2( self.scrollView2,{txtColor.wake,txtColor.normal},awake )
end

function This:getIsAwak(  )
    self:refreshAwakeData()
    local isUpdatae = false
    if self.m_fulllevel or self.m_paragraph> self.m_paragraphSelect then
        isUpdatae = true
    end
    if not self.m_showAwake then
    	isUpdatae = false
    end
    return isUpdatae
end

function This:resetScoolColor( node,colors )
	if node and node.txt then
		if node.txt then
			for i,v in ipairs(node.txt) do
				local color = colors[i]
				v:setColor(color.r,color.g,color.b)
			end
		end
	end
end

function This:resetScroolLine( node,lineCount,lineTxture,heightLimit )
	if node and node.txt then
		local txt = node.txt[1]
		local w ,h = txt:getContentSize()
		h= h*txt:getScaleY()
		local offsetHeight = h/lineCount
		if h <heightLimit then
			h = heightLimit
		end
		local function resetLine( lines,index,y )
			local line = lines[i]
			if not line then
				line = cc.Sprite:create(lineTxture)
				line:setAnchorPoint(0, 0.5)
				node:addChild(line)
			end
			line:setPositionY(y)
			lines[index]= line
		end
		local lines =node.lines
		if lines then
			for k,v in pairs(lines) do
				lines:setVisible(false)
			end
		end
		lines ={}
		if lineCount==1 then
			resetLine(lines,1,h-offsetHeight)
		else
			for i=1,lineCount-1 do
				resetLine(lines,i,h-offsetHeight*i)
			end
		end
		node.lines = lines
	end
end
function This:refreshAwakeData()
	local hero = self:getHeroData()
	self.m_util = hero:getAwake(  )
	local starDatas,paragraph,fulllevel = self.m_util:getAwakeInfor()
	self.m_starDatas = starDatas
	self.m_paragraph = paragraph
	self.m_fulllevel = fulllevel
end

function This:getHeroData()
	return HeroManager:getHero(self.m_heroId)
end