-- @Author: zheng
-- @Date:   2018-07-21 15:43:29
-- @Last Modified by:   zheng
-- @Last Modified time: 2018-09-06 11:39:26
-- @File Name: AwakeUpOverPanel.lua
local HeroManager = require("Hero.HeroManager")
local This , super = class(...,"Dialog")
local ViewUtil = require("UI.ViewUtil")
This.fileName = "MenuScene/NodeUI/WakeUpOver.csb"
This.isQuickExit = true

function This:initNode(info)
    self.m_heroId = info.heroId
    self.m_paragraphSelect = info.paragraph
    self.m_csNode = cc.Node:createFromCSFile(This.fileName)
    self.m_csNode:setToCenter()
    self:addChild(self.m_csNode)
    self.m_csNode.over:setVisible(false)
    ViewUtil:blinkView(self.m_csNode.over, true)
	self:refresh()
end

function This:initTouchEvent()
   self.m_csNode.bg:setTouchEnded(function()
   		print("close AwakeUpOver")
		 self:close()
	end)
end

function This:refresh(  )
    self:refreshAwakeData()
    self.m_csNode.icon:setImage(string.format("MenuScene/xingtuxiao%d.png",self.m_paragraphSelect))
    self.m_csNode.wordjuexing:setImage(string.format("MenuScene/wordjuexing%d.png",self.m_paragraphSelect))
	local attr2,attr1 = self.m_util:getParagraphAccumulateAttr(self.m_heroId,self.m_paragraphSelect)
    local attrs = {attr1,attr2}
    for i,v in ipairs(attrs) do
        local strs ,lineCount = self.m_util:convertDataToStr(v)
        local item = self.m_csNode["shuxing"..i]
    	self.m_util:resetScoolSize(item.scrollView,165,119,strs)
    end
    local title,desc = self.m_util:getAwakeTitle(self.m_heroId,self.m_paragraphSelect)
    self.m_csNode.jinengname:setString(title)
    self.m_util:resetScoolSize2(self.m_csNode.scrollView1,357,55,desc) 
end

function This:refreshAwakeData()
    local hero = self:getHeroData()
    self.m_util = hero:getAwake(  )
    local starDatas,paragraph,fulllevel = self.m_util:getAwakeInfor()
    self.m_starDatas = starDatas
    self.m_paragraph = paragraph
    self.m_fulllevel = fulllevel
end

function This:getHeroData()
    return HeroManager:getHero(self.m_heroId)
end

function This:close()
    super.close(self)
    local lockParagraph ,lockStr = self.m_util:getParagraphUnlockLimit()
    if lockParagraph then
       g_scene:showTips(lockStr) 
    end
end