-- @Author: zheng
-- @Date:   2018-07-21 15:11:44
-- @Last Modified by:   zheng
-- @Last Modified time: 2019-08-02 11:07:03
-- @File Name: AwakeUpPanel.lua
-- 某个阶段完所有星位觉醒后，觉醒消耗 点击技的界面
local ItemNode = require("UI.ItemNode")
local HeroUtil = require("Hero.HeroUtil")
local This , super = class(...,"Dialog")
local HeroManager = require("Hero.HeroManager")
This.fileName = "MenuScene/NodeUI/WakeUp.csb"
local txtColor ={
    wake = cc.ColorList.New1,
    normal = {r=144,g=152,b=166},
}
local strList ={
    needTip =Serialize[60334],
}
function This:initNode(info)
    self.m_heroId = info.heroId
    self.m_paragraphSelect = info.paragraphSelect --现在是第几阶段 
    self.m_csNode = cc.Node:createFromCSFile(This.fileName)
    self.m_csNode:setToCenter()
    self:addChild(self.m_csNode)
	self:initAttr(  )    
    local isUpdatae = self:getIsAwak(  )
    self:refresh( isUpdatae )
end

function This:initTouchEvent()
   self.m_csNode.beijing.close:setTouchEnded(function()
		self:close()
	end)
   self.m_csNode.manjiyincang.button:setTouchEnded(function()
        if self:checkNeedItem( self.m_csNode.manjiyincang ) then
            return
        end
        local hero = self:getHeroData()
        local uid = hero:getUid()
        HeroManager:onGetAwakeRequest(uid)
	end)
   self.m_csNode.manjiyincang.exchange:setTouchEnded(function()
        local hero = HeroManager:getHero(self.m_heroId)
        local quality = hero:getQuality()
        if quality<Quality.kPurple or hero:isRed() then
            g_scene:showTips(Serialize["Awake_UpPanel_1"])
            return
        end
        g_scene:openDialog("Hero.PieceExchangePanel",hero)
    end)
end

function This:createEffect()
    local function createAnim( parent,anmStr )
        local GameUtil = require("Util.GameUtil")
        local effect1 = GameUtil:createEffect(anmStr)
        parent:addChild(effect1)
        return effect1
    end
    local node = self.m_csNode.jueXingAnim
    node:setVisible(true)
    local hero = node.hero
    if hero then
        local heroData = self:getHeroData()
        local quality = heroData:getQuality()
        hero.heroqulitybg:setImage(QualityBgFile[quality])
        hero.bg:setImage(QualityFrameFile[quality])
        hero.icon:setImage(heroData:getIcon())
    end
    hero:setScale(0.1)
    hero:setOpacity(255)
    local centerChild = createAnim(node.center,"JueXing1")
    hero:setCascadeOpacityEnabled(true)
    local spawn1 = cc.ScaleTo(0.2,1.7)
    local spawn2 = cc.FadeOut(1.0 )
    local seq1 = cc.Sequence(spawn1,cc.CallFunc(function ()
        createAnim( node.point,"JueXing2" )
    end),cc.DelayTime(1.5),spawn2,cc.CallFunc(function ()
        node:setVisible(false)
        node.point:removeAllChildren()
        node.center:removeAllChildren()
        g_scene:openDialog("Awake.AwakeUpOverPanel",{heroId = self.m_heroId,paragraph = self.m_paragraphSelect})
    end))
    hero:runAction(seq1)
    self:refreshAwak(hero)
end

function This:refreshAwak(node)
    local hero = HeroManager:getHero(self.m_heroId)
    local heroEffect = false
    if hero:isAwaken() then
        node.xingdian:setVisible(true)
        local curentLv = hero:getAwakeLevel()
        if curentLv==0 then
            node.xingdian.light:setVisible(false)
        else
            node.xingdian.light:setVisible(true)
            for i=1,AwakdValue.ParagraphLimit do
                local item = node.xingdian.light["dian"..i]
                item:setVisible(curentLv>=i)
            end
        end
        heroEffect = hero:isAwakeFull()
    else
        node.xingdian:setVisible(false)
    end

end

function This:refreshAttr( isUpdate )
    local heroId = self.m_heroId
    local starDatas = self.m_starDatas
    local paragraph = self.m_paragraph
    local paragraphSelect = self.m_paragraphSelect
    local fulllevel = self.m_fulllevel
    local myUtil = self.m_util
    local attr = self._m_attr
    local awakeAttrs ,needitem = myUtil:getParagraphAwakeInfor(heroId, paragraphSelect )
    -- local awakeAttrs2 = table.clone(awakeAttrs) 
    local attr2,attr1 = self.m_util:getParagraphAccumulateAttr(self.m_heroId,self.m_paragraphSelect)
    local attrVisible = true
    if isUpdate then--如果成功升级
        attrVisible = false
        attr1 =  table.clone(attr2) 
    -- else
    --     for k,v in pairs(awakeAttrs2) do
    --         awakeAttrs2[k]= 0
    --     end
    end
    local attrs = {attr1,attr2}
    -- local attrs ={awakeAttrs2,awakeAttrs}
    for i,v in ipairs(attr) do
        local attrStr = self:getAttrStr(attrs[i])
        self.m_util:resetScoolSize(v.scrollView,145,119,attrStr) 
        if i>1 then --控制面板2是否显示
            v:setVisible(attrVisible)
            self.m_csNode.manji:setVisible(not attrVisible)
            self.m_csNode.manjiyincang:setVisible(attrVisible)
            self:refreshItemNode(self.m_csNode.manjiyincang,needitem)
        end
    end
end

function This:refreshItemNode( node,scrTable )
    local count = 1
    for k,v in pairs(scrTable) do
        local item = node["item"..count]
        self:creatItemNode(item,k,v)
        count = count+1
    end
end

function This:checkNeedItem( node )
    local name = "ItemNode"
    for i=1,2 do
        local item = node["item"..i]
        if item then
            local itemNode = item:getChildByName(name)
            local needNum =itemNode.needNum
            local total1 = itemNode:getItemCount()
            if needNum> total1 then
                local name = itemNode:getItemName() 
                g_scene:showTips(string.format(strList.needTip,name))
                return true
            end
        end
    end
    return false
end

function This:creatItemNode(parent,key,needNum)
    local name = "ItemNode"
    local node = parent:getChildByName(name)
    if not node then
        node = ItemNode:create(key, 1,true)
        node:setAnchorPoint(0.5, 0.5)
        parent:addChild(node)
        node:setName(name)
    end
    node.needNum = needNum
   node:showNeedNum(needNum)
end

function This:getIsAwak(  )
    self:refreshAwakeData()
    local isUpdatae = false
    if self.m_fulllevel or self.m_paragraph> self.m_paragraphSelect then
        isUpdatae = true
    end
    return isUpdatae
end

function This:initAttr(  )
    local attr ={}
    for i=1,2 do
        local item = self.m_csNode["shuxing"..i]
        attr[i]= item
    end
    self._m_attr =attr
end

function This:getAttrStr( srcTable )
    local myUtil = self.m_util
    return myUtil:convertDataToStr(srcTable)
end

--请求觉醒刷新
function This:onGetAwake(  )
     self:refresh(true)
    self:createEffect()
end

function This:onExchangePiece(piece_id,num)
    self:refresh(false)
end

function This:refresh( isUpdate )
    self.m_csNode.icon:setImage(string.format("MenuScene/xingtuxiao%d.png",self.m_paragraphSelect))
    self:refreshAwakeData()
    self:refreshAttr( isUpdate )

    local widthLimit = 357
    local heightLimit =55
    local title,desc = self.m_util:getAwakeTitle(self.m_heroId,self.m_paragraphSelect)
    self.m_csNode.jinengname:setString(title)
    self.m_util:resetScoolSize2(self.m_csNode.scrollView1,widthLimit,heightLimit,desc)
    local awake = self:getIsAwak(  )
    self.m_util:resetScoolColor2( self.m_csNode.scrollView1,{txtColor.wake,txtColor.normal},awake )
    local paragraphName = self.m_util:getParagraphInfor(self.m_heroId,self.m_paragraphSelect).stage_name
    self.m_csNode.beijing.title:setString(paragraphName)
end

function This:onEnter()
    super.onEnter(self)
    HeroManager:addObserver(self)
end

function This:onExit()
    super.onExit(self)
    HeroManager:removeObserver(self)
end

function This:refreshAwakeData()
    local hero = self:getHeroData()
    self.m_util = hero:getAwake(  )
    local starDatas,paragraph,fulllevel = self.m_util:getAwakeInfor()
    self.m_starDatas = starDatas
    self.m_paragraph = paragraph
    self.m_fulllevel = fulllevel
end

function This:getHeroData()
    return HeroManager:getHero(self.m_heroId)
end