-- @Author: zheng
-- @Date:   2019-05-09 15:46:27
-- @Last Modified by:   zheng
-- @Last Modified time: 2019-07-13 16:57:13
-- @File Name: GameLordEquipBreak.lua

local This , super = class(..., "Awake.GameLordEquipLv")
local GameUtil = require("Util.GameUtil")
local GamePlayer = require("Player.GamePlayer")
local HeroManager = require("Hero.HeroManager")
local LordEquipManager = require("Awake.LordEquipManager")

local LordEquipSlotBreachConfig = require("Metadatas.LordEquipSlotBreachConfig")

function This:init(id)
    self.m_id = id
    self.m_config = LordEquipSlotBreachConfig[id]
end


function This:getRate()
    return self.m_config.coefficient
end

function This:getAttr()
    -- local attrRate = self.m_config.coefficient
    -- local temAttr = super.getAttr(self)
    -- for key,v in pairs(temAttr) do
    --     temAttr[key] = (1+attrRate)*v
    -- end
    -- return temAttr
    return {}
end

--装备符文个数
function This:getEquipNum()
   return self.m_config.equip_num
end

function This:getDes()
   return self.m_config.des
end

function This:isCanUp()
    local tipStrs = {
        [LorderEquipTip.kLevel] = string.format(Serialize["Awake_EquipBreak_1_c"],self:getLvLimit()),
        [LorderEquipTip.kNeed] = Serialize["activity_AssassinsPanel_1_c"],
    }
    local temCanUp,tipStr,tipCode = super.isCanUp(self,true)
    if tipCode == LorderEquipTip.kEmpty then
        local conditionList = self:getBreakLimit()
        for _,limitConfig in pairs(conditionList) do
            local pos ,limitValue= limitConfig[1],limitConfig[2]
            local posData = LordEquipManager:getPos(pos)
            if posData then
                local curentLv = posData:getLv()
                if limitValue>curentLv then
                    tipCode = LorderEquipTip.kCondition
                    tipStrs[tipCode]= string.format(posData:getName()..Serialize["Awake_EquipBreak_2"],limitValue)
                    break
                end
            end
        end
        return tipCode==LorderEquipTip.kEmpty ,tipStrs[tipCode] or "",tipCode
    else
        return temCanUp,tipStrs[tipCode],tipCode
    end
end