-- @Author: zheng
-- @Date:   2019-05-09 15:46:27
-- @Last Modified by:   zheng
-- @Last Modified time: 2019-07-16 14:25:10
-- @File Name: GameLordEquipInscriptionAttr.lua

local This = class(...)
local GameUtil = require("Util.GameUtil")
-- local GamePlayer = require("Player.GamePlayer")
-- local HeroManager = require("Hero.HeroManager")
local LordEquipManager = require("Awake.LordEquipManager")
-- local DepotManager = require("Depot.DepotManager")

local InscriptionAttributeValueConfig = require("Metadatas.InscriptionAttributeValueConfig")
local ItemConfig = require("Metadatas.ItemConfig")
function This:create(...)
    local chapter = setmetatable({},self)
    chapter:init(...)
    return chapter
end

function This:init(id)
    self.m_id = id
    self.m_config = InscriptionAttributeValueConfig[id]
end

function This:getId()
    return self.m_id
end

function This:getPos()
    return self.m_config.solt
end

function This:getAttrType()
    return self.m_config.type
end

function This:getMaxQuality()
    return 5
end

function This:getMinMaxStr()
    if not self.m_minStr then
        local minQuality ,maxQuality = 1,self:getMaxQuality()
        local minStr = LordEquipManager:getInscriptionAttr(self:getPos(),self:getAttrType(),minQuality):getMinStr()
        local maxStr = LordEquipManager:getInscriptionAttr(self:getPos(),self:getAttrType(),maxQuality):getMaxStr()
        self.m_minStr = minStr.."~"..maxStr
    end
    return self.m_minStr
end

function This:getMinStr()
   local name ,value = GameUtil:getAttrStr(self:getAttrType(),self:getMinAttr(),true) 
   return value,name
end

function This:getMaxStr()
   local name ,value = GameUtil:getAttrStr(self:getAttrType(),self:getMaxAttr(),true) 
   return value ,name
end

function This:getMinAttr()
    return self.m_config.min_range
end

function This:getMaxAttr()
    return self.m_config.max_range
end

function This:getQuality()
    return self.m_config.quality
end

