-- @Author: zheng
-- @Date:   2019-05-09 15:46:27
-- @Last Modified by:   zheng
-- @Last Modified time: 2019-07-13 16:56:06
-- @File Name: GameLordEquipLv.lua
local This = class(...)
local GameUtil = require("Util.GameUtil")
local GamePlayer = require("Player.GamePlayer")
local HeroManager = require("Hero.HeroManager")
local DepotManager = require("Depot.DepotManager")
local LordEquipManager = require("Awake.LordEquipManager")

local LordEquipSlotStrengthenConfig = require("Metadatas.LordEquipSlotStrengthenConfig")
function This:create(...)
    local chapter = setmetatable({},self)
    chapter:init(...)
    return chapter
end

function This:init(id)
    self.m_id = id
    self.m_config = LordEquipSlotStrengthenConfig[id]
end

function This:getId()
    return self.m_id
end

function This:getPos()
    return self.m_config.solt_id
end

function This:getPosData()
    return LordEquipManager:getPos(self:getPos())
end

function This:getAttr()
    return GameUtil:convertData(self.m_config.attribute)
end

function This:getLv()
   return self.m_config.level 
end

function This:getBreakLimit()
   return self.m_config.condition
end

function This:getLvLimit()
   return self.m_config.need_level
end

function This:isCanUp(condition)
    local tipStrs = {
        [LorderEquipTip.kLevel] = string.format(Serialize["greater_player_level"],self:getLvLimit()),
        [LorderEquipTip.kNeed] = Serialize["activity_AssassinsPanel_1_c"],
    }
    local tipCode = LorderEquipTip.kEmpty
    if self:getLvLimit()>GamePlayer:getLevel() then
        tipCode = LorderEquipTip.kLevel
    elseif not DepotManager:getItemOrResEnought(self:getCost()) then
        tipCode = LorderEquipTip.kNeed
    elseif not condition then
        local posData = self:getPosData()
        if posData and self:getBreakLimit()>posData:getBreakLv() then
            tipCode = LorderEquipTip.kCondition
        end
    end
    return tipCode==LorderEquipTip.kEmpty ,tipStrs[tipCode] or "",tipCode
end

function This:getAttrScore()
    if not self.m_score then
        self.m_score = HeroManager:getAttrKeyFightPower(self:getAttr())
    end
    return self.m_score
end

function This:getCost()
    return self.m_config.cost
end
