-- @Author: zheng
-- @Date:   2018-07-21 15:38:29
-- @Last Modified by:   zheng
-- @Last Modified time: 2018-09-06 11:39:26
-- @File Name: KingWaySucessPanel.lua

local This , super = class(...,"Dialog")
local GameKingWayManager = require("Awake.GameKingWayManager")
local GamePlayer = require("Player.GamePlayer")
local GameUtil = require("Util.GameUtil")

This.fileName = "MenuScene/NodeUI/KingWaySuccess.csb"

local strList={
	full =Serialize[60356],
	lockStr =Serialize[60357],
}
function This:initNode(info)
    self.m_csNode = cc.Node:createFromCSFile(This.fileName)
    self.m_csNode:setToCenter()
    self:addChild(self.m_csNode)
	self:refresh()
   
end

function This:initTouchEvent()
	self.m_csNode.close:setTouchEnded(function()
		self:close()
	end)    
end

function This:refresh(  )
	self:getData()

	local data = self.m_data
	GameUtil:setPlayerFeltNodeResource(self.m_csNode.picture, data:getPlayerTexture())
	local colorStr ,title = data:getTitle(true)
	self.m_csNode.text1:setString(string.format("%s%s",strList.lockStr,title))
	self.m_csNode.text2:setString(data:getDes(),430)
	local nextData ,haveNext= GameKingWayManager:getNexKingWay(data)
	self.m_csNode.value1.name:setString(data:getName())
	self.m_csNode.value2.name:setString(nextData:getName())
	if not haveNext then
		self.m_csNode.value2.name:setString(strList.full)
	end
	local lvAttr,allAttr,isPasse = self:getCurentBreakAtrr2(data)
	local allStr = data:convertDataToStr(allAttr)
	local lvStr = data:convertDataToStr(lvAttr)
	data:resetScoolSize(self.m_csNode.scrollView,159,100 ,lvStr)
	data:resetScoolSize(self.m_csNode.scrollView1,159,100 ,allStr)
end


function This:getCurentBreakAtrr2(kingData)
	local res ={}
	local id = kingData:getId()
	local isPasse = kingData:isPassed()
	local kingWays = GameKingWayManager:getKingData()
	if kingData:isCanPo() then
		local res2 = {}
		for kingIndex=1,id do
			local kingWay = kingWays[kingIndex]
			if kingWay then
				if kingIndex<id then
					local item = kingWay:getAttr()
					kingWay:tableAdd(item, res)
				else
					res2 = table.clone(res)
					local item = kingWay:getAttr()
					kingWay:tableAdd(item, res2)

					item =kingWay:getCurentAtrr()
					kingWay:tableAdd(item, res)
					break
				end
			end
		end
		return res,res2,isPasse
	end
	return res,res,isPasse
end

function This:getData()
	local data = GameKingWayManager:getKingWay()
	if not data:isPassed() then
		data = GameKingWayManager:getPreKingWay( data )
	end
	self.m_data = data
end