-- @Author: zheng
-- @Date:   2018-07-21 15:38:29
-- @Last Modified by:   zheng
-- @Last Modified time: 2019-07-11 17:07:57
-- @File Name: KingWayTab.lua

local This , super = class(...,"NodeUI")

-- This.fileName = "MenuScene/NodeUI/KingWay.csb"
local GameKingWayManager = require("Awake.GameKingWayManager")
local KingWayValuePanel = require("Awake.KingWayValuePanel")

local KingWaySucessPanel = require("Awake.KingWaySucessPanel")
local ItemNode = require("UI.ItemNode")
local GameUtil = require("Util.GameUtil")

local strList={
	lvStr =Serialize[60359],
	needTip =Serialize[60334],
	lockLimit =Serialize[60360],
	lockUp =Serialize[60361],
	full =Serialize[60356],
	Lv1 =Serialize[60362],
	Lv2 =Serialize[60363],
	Lv3 =Serialize[60364],
	upLimit= Serialize[60365],
	full2 =Serialize[60353]
}

local btnTypes={
	kbuttonjihuo = 1,
	kbuttontupo = 2,
	kbuttonshengji = 3,
	kbuttonyijianshengji = 4,
}

function This:initNode(node)
    -- self.m_csNode = cc.Node:createFromCSFile(This.fileName)
    -- self.m_csNode:setToCenter()
    -- self:addChild(self.m_csNode)
    self.m_csNode = node.m_csNode.king
    self:getData()
    self.m_btnList ={}

    self:initSelectIndex(  )
    self.m_canTuoPo = true
	--  self:refresh()
	self:scheduleUpdate()
end

function This:initSelectIndex(  )
	self.m_selectIndex = self.m_data:getLvMaxCanLock( )
end

function This:onEnter()
	super.onEnter(self)
	GameKingWayManager:addObserver(self)
end

function This:onExit()
	super.onExit(self)
	GameKingWayManager:removeObserver(self)
end

function This:initTouchEvent()
	local function checkRequest( type,index,notCheckLv )
		local data = self.m_data
		local selectIndex = self.m_selectIndex
		if data:isLock() then
			g_scene:showTips(string.format(strList.upLimit,data:getPlayerLevelLimit()))
			return 
		end

		if self:checkNeedItem( self.m_csNode.xiaohao ) then
            return
        end

		if not notCheckLv and selectIndex>1 and not data:getlvCanUpdate(selectIndex) then
			local name = data:getLvName(selectIndex-1,1)
			g_scene:showTips(string.format("%s%s",strList.lockUp,name))
		end
		
       GameKingWayManager:onGetKingWayRequest(type,index)
	end
	local csNode = self.m_csNode
	-- csNode.close:setTouchEnded(function()
	-- 	self:close()
	-- end)
	csNode.wenhao:setTouchEnded(function()
		g_scene:openDialog("UI.HelpTips", {text = Serialize["Awake_KingWayPanel_1"],node = self.m_csNode.wenhao})
	end)
	csNode.buttonzonglan:setTouchEnded(function()
		g_scene:openDialog("Awake.KingWayValuePanel")
	end)
	csNode.xiaohao.buttonjihuo:setTouchEnded(function()
		checkRequest(1,self.m_selectIndex)
	end)
	csNode.xiaohao.buttontupo:setTouchEnded(function()
		if not self.m_canTuoPo then
			return
		end
		self.m_canTuoPo = false
		checkRequest(3,self.m_selectIndex,true)
	end)
	csNode.xiaohao.buttonshengji:setTouchEnded(function()
		checkRequest(1,self.m_selectIndex)
	end)
	csNode.xiaohao.buttonyijianshengji:setTouchEnded(function()
		checkRequest(2,self.m_selectIndex)
	end)
	local node = self.m_csNode.hero.btnNode
	for kingType=1,KingWayType.kSheng do
		local item = node["xiaoyuan"..kingType]
		item:setTouchEnded(function()
			self:btnCallBack(kingType)
		end)
	end
end

function This:btnCallBack(KingWay)
	local data = self.m_data
	local isCanPo = data:isCanPo()
	local selectIndex = self.m_selectIndex
	if isCanPo then
		
	else
		local maxCanLock = data:getLvMaxCanLock()
		if maxCanLock>=KingWay then
			self.m_selectIndex = KingWay
			self:refresh()
		else
			local name = data:getLvName(maxCanLock,1)
			g_scene:showTips(string.format("%s%s",strList.lockLimit,name))
		end
	end
end

function This:refreshItemNode( node,scrTable )
    local count = 1
    for i=1,2 do
        local item = node["item"..i]
        item:setVisible(false)
    end
    for k,itemConfig in ipairs(scrTable) do
        local item = node["item"..count]
        if type(itemConfig) == "number" then
        	item:setVisible(false)
        else
        	item:setVisible(true)
        	self:creatItemNode(item,itemConfig[1],itemConfig[2])
        end
        count = count+1
    end
end

function This:checkNeedItem( node )
    local name = "ItemNode"
    for i=1,2 do
        local item = node["item"..i]
        if item and item:isVisible() then
            local itemNode = item:getChildByName(name)
            local needNum =itemNode.needNum
            local total1 = itemNode:getItemCount()
            if needNum> total1 then
                local name = itemNode:getItemName() 
                g_scene:showTips(string.format(strList.needTip,name))
                return true
            end
        end
    end
    return false
end

function This:creatItemNode(parent,key,needNum)
    local name = "ItemNode"
    local node = parent:getChildByName(name)
    if not node then
        node = ItemNode:create(key, 1,true)
        node:setAnchorPoint(0.5, 0.5)
        parent:addChild(node)
        node:setName(name)
    end
   node:initItem(key,1,true) 
   node.needNum = needNum
   node:showNeedNum(needNum)
end

function This:setVisible(isVisible)
	super.setVisible(self,isVisible)
	self.m_csNode:setVisible(isVisible)
end

function This:refresh()
	self:getData()
	self:refreshTxtNode()
	self:refreshNeed()
	self:refreshChapter()
end

function This:refreshTxtNode()
	local data = self.m_data
	local isCanPo = data:isCanPo()
	local info1 = self.m_csNode.info1
	local info2 = self.m_csNode.info2
	if isCanPo then
		info1:setVisible(false)
		info2:setVisible(true)
		local str1,str2 = data:getTitle(true)
		info2.text1:setString(str1)
		info2.text2:setString(data:getDes())
		info2.value1.name:setString(data:getName())
		-- local allAttr,lvAttr = data:getAttr()
		local lvAttr,allAttr,isPasse = GameKingWayManager:getCurentBreakAtrr()
		local allStr = data:convertDataToStr(allAttr)
		local lvStr = data:convertDataToStr(lvAttr)
		data:resetScoolSize(info2.scrollView,159,100 ,lvStr)
		data:resetScoolSize(info2.scrollView2,159,100 ,allStr)
		local nextData ,haveNext= GameKingWayManager:getNexKingWay()
		info2.scrollView2:setVisible(true)
		if haveNext then
			info2.value2.name:setString(nextData:getName())
		else
			info2.value2.name:setString(strList.full)
		end
		if isPasse then
			info2.scrollView2:setVisible(false)
		end
	else
		info1:setVisible(true)
		info2:setVisible(false)
		local selectIndex = self.m_selectIndex
		local curent,nextLv = data:getLvCurrent( selectIndex )
		local lvDes = data:getLvDes(selectIndex,nextLv)
		info1.titlelittle1:setImage(KingImage[selectIndex])
		info1.text:setString(lvDes,484)
		info1.value1.info:setString(string.format(strList.lvStr,curent))
		info1.value2.info:setString(string.format(strList.lvStr,nextLv))

		local allLvPass = data:getLvIsPass(selectIndex)
		local nextAttr = data:getLvAccumulateAttr(selectIndex,nextLv)
		local curentAttr = table.clone(nextAttr)
		if curent==0 then
			for k,v in pairs(curentAttr) do
            	curentAttr[k]=0
	        end
		else
			curentAttr = data:getLvAccumulateAttr(selectIndex,curent)
		end

		local curentStr = data:convertDataToStr(curentAttr)
		if allLvPass then
			info1.value2.info:setString(strList.full2)
			info1.scrollView2:setVisible(false)
		else
			info1.value2.info:setVisible(true)
			info1.scrollView2:setVisible(true)
			local nextStr = data:convertDataToStr(nextAttr)
			data:resetScoolSize(info1.scrollView2,173,99 ,nextStr)
		end
		data:resetScoolSize(info1.scrollView,173,99 ,curentStr)
	end
end

function This:refreshNeed()
	local data = self.m_data
	local isCanPo = data:isCanPo()
	local xiaohao = self.m_csNode.xiaohao
	local function btnvisible( visibleTable )
		for btnType=1,4 do
			local node = nil
			local visible = false
			if visibleTable[btnType] then
				visible = true
			end
			if btnTypes.kbuttonjihuo == btnType then
				node = xiaohao.buttonjihuo
			elseif btnTypes.kbuttontupo == btnType then
				node = xiaohao.buttontupo
			elseif btnTypes.kbuttonshengji == btnType then
				node = xiaohao.buttonshengji
			elseif btnTypes.kbuttonyijianshengji == btnType then
				node = xiaohao.buttonyijianshengji
			end
			node:setVisible(visible)
		end
	end
	xiaohao:setVisible(true)
	if isCanPo then
		local res ={}
		res[btnTypes.kbuttontupo]=1
		btnvisible(res)
		local needitem = data:getNeed()
		self:refreshItemNode(xiaohao,needitem)
		local nextData ,haveNext= GameKingWayManager:getNexKingWay()
		if nextData:isPassed() then
			xiaohao:setVisible(false)
		end
		xiaohao.titlelittle4:setString(strList.Lv3)
	else
		local selectIndex = self.m_selectIndex
		local lock = data:getLvIsLock(selectIndex)
		if lock then
			local res ={}
			res[btnTypes.kbuttonjihuo]=1
			btnvisible(res)
			local needitem = data:getLvNeed( selectIndex ,1 )
			self:refreshItemNode(xiaohao,needitem)
			xiaohao.titlelittle4:setString(strList.Lv1)
		else
			xiaohao.titlelittle4:setString(strList.Lv2)
			local res ={}
			res[btnTypes.kbuttonshengji]=1
			res[btnTypes.kbuttonyijianshengji]=1
			btnvisible(res)
			local curent,nextLv = data:getLvCurrent( selectIndex )
			local allLvPass = data:getLvIsPass(selectIndex)
			if allLvPass then
				xiaohao:setVisible(false)
			else
				local needitem = data:getLvNeed(selectIndex,nextLv)
				self:refreshItemNode(xiaohao,needitem)
			end
		end
	end
end

function This:refreshChapter()
	local data = self.m_data
	local isCanPo = data:isCanPo()
	GameUtil:setPlayerFeltNodeResource(self.m_csNode.hero.icon, data:getPlayerTexture(),false)
	local isAdd = isCanPo
	if data:isPassed() then
		isAdd = false
	end
	self:tuPoAction( isAdd )
	self.m_csNode.jie:setString(data:getName())
	local xiaoYuanTxture ={	"MenuScene/yuanbg4_1.png","MenuScene/yuanbg4_3.png","MenuScene/yuanbg4_2.png",}
	local maxCanLv= data:getLvMaxCanLock( )
	local node = self.m_csNode.hero.btnNode
	for kingType=1,KingWayType.kSheng do
		local item = self.m_btnList[kingType]
		if not item then
			item = node["xiaoyuan"..kingType]
			self.m_btnList[kingType]= item
			local x,y = item:getPosition()
			item.x = x
			item.y = y
		end
		item:setVisible(true)
		item.text:setVisible(true)
		item:setPosition(item.x, item.y)
		local lv = item.lv
		local lock = data:getLvIsLock(kingType)
		local curentLv =  data:getLvCurrent(kingType)
		local maxLv = data:getLvMaxLv(kingType)
		local allLvPass = data:getLvIsPass(kingType)
		lv:setVisible(kingType<=maxCanLv)
		if isCanPo or allLvPass then
			lv:setVisible(false)
		else
			lv.number:setString(curentLv)
			lv.jiantou:setVisible(data:getlvCanUpdate(kingType))
		end
		local texture = xiaoYuanTxture[1]
		local isLight = false
		if allLvPass then
			texture = xiaoYuanTxture[3]
			isLight = true
		elseif lock  then
			if maxCanLv == kingType then
				texture = xiaoYuanTxture[2]	
			else
				texture = xiaoYuanTxture[1]
			end
		else
			texture = xiaoYuanTxture[2]
		end
		item:setImage(texture)
		item.light:setVisible(isLight)
	end
end

function This:tuPoAction( isAdd )
	local node = self.m_csNode.hero.btnNode
	node:stopAllActions()
	node:setRotation(0)
	if isAdd then
		self.m_isUpdating = true
		self.m_csNode.hero.btnNode2:setVisible(true)
		node:runAction(cc.RepeatForever(cc.RotateBy(5,360)))
	end
end

function This:createWeakEffect( node,isAdd )
	local function createAnim( parent,anmStr )
        local GameUtil = require("Util.GameUtil")
        local effect1 = GameUtil:createEffect(anmStr)
        local scale =1
        effect1:setScale(scale)
        local x = 50
        local y = 0
        effect1:setPosition(x,y)
        parent:addChild(effect1)
        return effect1
    end
    local effectName = "WangHuiJu"
    node:removeAllChildren()
    if isAdd then
    	local effect = createAnim( node,effectName )
    end
end

function This:tuPoStop(  )
	local node = self.m_csNode.hero.btnNode
	local anim = self.m_csNode.hero.anim
	for kingType=1,KingWayType.kSheng do
		local item = self.m_btnList[kingType]
		local animTime =2
		local actionTime = 0.3
		if kingType==1 then
			self:createWeakEffect( anim,true )
			item:runAction(cc.Sequence(cc.DelayTime(animTime-actionTime),
				cc.CallFunc(function ()
				cc.Audio:playEffect("zhuanpan.mp3")
			end),
				cc.MoveTo(actionTime,0,0), cc.CallFunc(function ()
				self.m_csNode.hero.btnNode2:setVisible(false)
				self.m_isUpdating = false
				node:stopAllActions()
				item:setVisible(false)
			end)
			,cc.DelayTime(animTime-actionTime),cc.CallFunc(function ()
				self:createWeakEffect( anim,false )
				item:setVisible(false)
				self:getData()
				self:initSelectIndex(  )
				self:refresh()
				self.m_canTuoPo = true
				g_scene:openDialog("Awake.KingWaySucessPanel")
			end)))
		else
			item:runAction(cc.Sequence(cc.DelayTime(animTime-actionTime),cc.MoveTo(actionTime,0,0), cc.CallFunc(function ()
				item:setVisible(false)
			end)))
		end
		
	end
end

function This:resetTxtPos(  )
	local node = self.m_csNode.hero.btnNode
	local node2 = self.m_csNode.hero.btnNode2
	for kingType=1,KingWayType.kSheng do
		local item = self.m_btnList[kingType]
		item.text:setVisible(false)
		local x,y = item.text:getPosition()
		local d,f =item:convertToWorldSpace(x,y)
		x,y = node2:convertToNodeSpace(d, f)
		local item2= node2["text"..kingType]
		item2:setPosition(x, y)
	end
end

function This:update(dt)
	super.update(self,dt)
	if self.m_isUpdating then
		self:resetTxtPos(  )
	end
end

function This:getData()
	self.m_data = GameKingWayManager:getKingWay()
end

function This:onGetKingWay(isTuoPo)
	if isTuoPo then
		self:tuPoStop(  )
	else
		self:refresh()
	end
end

function This:onGetKingInfo(  )
	self:refresh()
end
