-- @Author: zheng
-- @Date:   2018-07-21 15:38:29
-- @Last Modified by:   zheng
-- @Last Modified time: 2018-09-01 14:53:53
-- @File Name: KingWayValuePanel.lua

local This , super = class(...,"Dialog")

local GameKingWayManager = require("Awake.GameKingWayManager")

This.fileName = "MenuScene/NodeUI/KingWayValue.csb"

function This:initNode(info)
    self.m_csNode = cc.Node:createFromCSFile(This.fileName)
    self.m_csNode:setToCenter()
    self:addChild(self.m_csNode)
    self:refresh()
   
end

function This:initTouchEvent()
   
	self.m_csNode.close:setTouchEnded(function()
		self:close()
	end)    
end

function This:refresh()
	self:getData()
    local lineTxture ="Common/line12.png"

	local data = self.m_data
    local allAttr =GameKingWayManager:getAllAttr()
	local curentAttr = GameKingWayManager:getCurentAtrr()
	local allDesc,lineCount1 = data:convertDataToStr(allAttr)
	for k,v in pairs(allAttr) do
		allAttr[k]=0
	end
	data:tableAdd(curentAttr,allAttr)
	local desc = data:convertDataToStr2(allAttr,true)
	self:resetScoolSize(self.m_csNode.scrollView1,260,233 ,{desc,allDesc[2]})

    local str,lineCount2 = self:getDes()
    self:resetScoolSize2(self.m_csNode.scrollView,268,233 ,str)

    self:resetScroolLine( self.m_csNode.scrollView1,lineCount1,lineTxture,233,260 )

    self:resetScroolLine( self.m_csNode.scrollView,lineCount2,lineTxture,233,268 )
end

function This:getDes(  )
	local str =""
	local kingData = GameKingWayManager:getKingData()
	local passStr =""
	local normalStr =""
    local count =0
	for i,kingWay in ipairs(kingData) do
        count = count +1
		local title = kingWay:getTitle()
		if kingWay:isPassed() then
            passStr = passStr .. title .. "\n" .. "<New9>".. kingWay:getDes().."\n"
		else
            normalStr = normalStr .. title .. "\n" .. "<New3>".. kingWay:getDes().."\n"
		end
	end
	if passStr == "" then
		str = "<New3>"..normalStr
	elseif normalStr == "" then
		str = "<New9>"..passStr
	else
		str = "<New9>"..passStr.."<New3>"..normalStr
	end
	return str,count*2
end

function This:resetScoolSize(node,widthLimit,_height ,texts)
    if node and not node.txt then
    	local txt ={}
    	for i=1,2 do
    		local item = node["txt"..i]
    		txt[i]= item
    	end
      	node.txt =txt
    end
    if not _height or not node or not node.txt  then
        return
    end
    local txt =node.txt
    for i,v in ipairs(txt) do
    	if i==1 then
    		v:setStringWithColor(texts[i])
    	else
    		v:setString(texts[i])
    	end
    end
    local height = 0

    local texRule1 = txt[1]
    local w ,h = texRule1:getContentSize()
    h = h*texRule1:getScaleY()
    height = height + h
    if height < _height then
        height = _height
    end
    for i,v in ipairs(txt) do
    	v:setPositionY(height)
    end
    node:setInnerContainerSize(widthLimit,height)
end

function This:resetScoolSize2(node,widthLimit,_height ,text)
    if node and not node.txt then
        node.txt = node:getChildByName("txt")
    end
    if not _height or not node or not node.txt  then
        return
    end
    local height = 0
    local texRule1 = node.txt
    texRule1:setStringWithColor(text,widthLimit)
    local w ,h = texRule1:getContentSize()
    h = h*texRule1:getScaleY()
    height = height + h
    if height < _height then
        height = _height
    end
    texRule1:setPositionY(height)
    node:setInnerContainerSize(widthLimit,height)
end

function This:resetScroolLine( node,lineCount,lineTxture,heightLimit,lineWidth )
    if node and node.txt then
        local txt = node.txt[1] or node.txt
        local w ,h = txt:getContentSize()
        h= h*txt:getScaleY()
        local offsetHeight = h/lineCount
        if h <heightLimit then
            h = heightLimit
        end
        local function resetLine( lines,index,y )
            local line = lines[i]
            if not line then
                line = cc.Sprite:create(lineTxture)
                line:setAnchorPoint(0, 0.5)
                node:addChild(line)
            end
            line:setPositionY(y)
            local w ,h = line:getContentSize()
            line:setScaleX(lineWidth/w)
            lines[index]= line
        end
        local lines =node.lines
        if lines then
            for k,v in pairs(lines) do
                lines:setVisible(false)
            end
        end
        lines ={}
        if lineCount==1 then
            resetLine(lines,1,h-offsetHeight)
        else
            for i=1,lineCount-1 do
                resetLine(lines,i,h-offsetHeight*i)
            end
        end
        node.lines = lines
    end
end

function This:getData()
	self.m_data = GameKingWayManager:getKingWay()
end