
LordEquipMakePanelTabName ={
    kSkillCombine    = 1,--技能融合
    kMingWenMake     = 2,--铭文打造
    kCount       = 2,
}
local GameUtil = require("Util.GameUtil")
local This , super = class(...,"Dialog")

local ItemUtil = require("Bag.ItemUtil")
local ItemNode = require("UI.ItemNode")
local TerrBlackSmithPanel = require("Territory.TerrBlackSmithPanel")
local LordEquipMakeNode = require("Awake.LordEquipMakeNode")
local TerrBuildManager = require("Territory.TerrBuildManager")


function This:initNode(build,tabType)

    self.m_build = build or TerrBuildManager:getBuildByType(TerrBuildType.kTieJiangPu)
    local csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/BlackSmithShop.csb")
    csNode:setToCenter()
    self:addChild(csNode)
    self.m_csNode = csNode
    for tabKey = 1, LordEquipMakePanelTabName.kCount do
        local item = csNode["tep"..tabKey]
        self:addTabButton(tabKey, item, function()
            self:openTabNode(tabKey)
            self:lightTabButton(tabKey)
            self.m_selectIndex = tabKey
            self:refresh()
        end)
    end


    self.mSkillCombine = TerrBlackSmithPanel:create(build)
    self.m_csNode:addChild(self.mSkillCombine)

    self.mEquipMake = LordEquipMakeNode:create(build)
    self.m_csNode:addChild(self.mEquipMake)    

    self.m_tabNodes = {self.mSkillCombine,self.mEquipMake}
    self.m_selectIndex = tabType or LordEquipMakePanelTabName.kSkillCombine
    self:selectTabButton(self.m_selectIndex)

    self:refresh()

    self:refreshDot()
end


function This:refreshDot()
    local tabNode = self.m_csNode
--    local tabNames = self:getTabList()
    for tabKey = 1, LordEquipMakePanelTabName.kCount do
        local item1 = tabNode["tep"..tabKey]
        local isHaveRed = self:isHaveRed(tabKey)
        if item1 then
            GameUtil:refreshRedDot(item1, isHaveRed)
        end
    end
end


function This:refresh()
    for tabIndex,tabNode in ipairs(self.m_tabNodes) do
        local isRefresh = self.m_selectIndex == tabIndex
        tabNode:setVisible(isRefresh)
        if isRefresh then
            tabNode:refresh()
        end
    end

end

function This:isHaveRed(tabType)
    return false
end


function This:createTabNode(name)

end


function This:initTouchEvent()
    local csNode = self.m_csNode
    csNode.closebg.close:setTouchEnded(function()
        self:close()
    end)
end
