-- @Author: zheng
-- @Date:   2019-07-03 16:42:15
-- @Last Modified by:   zheng
-- @Last Modified time: 2019-07-19 16:46:59
-- @File Name: LordEquipMasterContrastPanel.lua

local This , super = class(...,"Dialog")
-- This.fileName = "MenuScene/NodeUI/MythicalAnimalsAdd.csb"
local LordEquipManager = require("Awake.LordEquipManager")
local LordEquipMasterContrastTab = require("Awake.LordEquipMasterContrastTab")
LordEquipMasterContrastPanelTabType ={
    kOneHave  = 1,--只显示某个位置的装备
    kOneEmpty = 2,--只显示当前装备
    kTwoHave  = 3,--显示当前装备和某个位置的比较
}
function This:initNode(info)
    self.m_csNode = cc.Node:create()
    self:addChild(self.m_csNode)
    -- self.m_csNode:setToCenter()

    local equipId =info.equipId
    local posEquipId = info.posEquipId
    local posX = 195
    local tabType = LordEquipMasterContrastPanelTabType.kOneHave

    if equipId and posEquipId then
        tabType = LordEquipMasterContrastPanelTabType.kTwoHave
    elseif equipId then
        tabType = LordEquipMasterContrastPanelTabType.kOneEmpty
    end

    local temInfo = {tabType = tabType,index = 1,equipId = posEquipId or equipId ,closeHandle = function ()
        self:close()
    end}
    if tabType == LordEquipMasterContrastPanelTabType.kTwoHave then
        temInfo.posEquipId = posEquipId
        self:getTab(temInfo,-posX)
        temInfo = {tabType = tabType,index = 2,equipId = equipId ,closeHandle = function ()
            self:close()
        end}
        temInfo.equipId = equipId
        temInfo.posEquipId = posEquipId
        self:getTab(temInfo,posX)
    else
        self:getTab(temInfo,0)
    end
    self.m_tabType = tabType
end

function This:onTouchMask() -- 对话框之外区域的点击事件
    -- if self.m_tabType == LordEquipMasterContrastPanelTabType.kOneHave then
        self:close()
    -- end
end

function This:getTab(info,posX)
    local node = LordEquipMasterContrastTab:create(info)
    node:setPosition(posX,0)
    self.m_csNode:addChild(node)
end
