-- @Author: zheng
-- @Date:   2019-07-03 16:45:26
-- @Last Modified by:   zheng
-- @Last Modified time: 2019-11-22 14:30:24
-- @File Name: LordEquipMasterContrastTab.lua
local LordEquipResonanceConfig = require("Metadatas.LordEquipResonanceConfig")
local This , super = class(...,"NodeUI")
-- local FamilyManager = require("Official.FamilyManager")
This.fileNames = "MenuScene/NodeUI/LordEquipMasterContrast.csb"
local LordEquipManager = require("Awake.LordEquipManager")
local GameUtil = require("Util.GameUtil")
local GamePlayer = require("Player.GamePlayer")
local ItemUtil = require("Bag.ItemUtil")

function This:initNode(info)
    self.m_tabType = info.tabType
    self.m_equipId = info.equipId
    self.m_index  = info.index
    self.m_posEquipId = info.posEquipId
    self.m_closeHandle = info.closeHandle
    local fileName= "MenuScene/NodeUI/LordEquipMasterContrast1.csb"
    local equipData = LordEquipManager:getBagItemWithUid(self.m_equipId,true)
    self.m_isHaveSuit = equipData:isHaveSuit()
    if self.m_isHaveSuit then
        fileName= This.fileNames
    end
    
    local csNode = cc.Node:createFromCSFile(fileName)
    csNode:setToCenter()
    self:addChild(csNode)
    self.m_csNode = csNode
    self:refresh()
end

function This:refresh()
    local ishaveSuit = self.m_isHaveSuit
    local csNode = self.m_csNode
    local index = self.m_index
    local tabType = self.m_tabType
    local equipId = self.m_equipId
    local posEquipId = self.m_posEquipId
    local equipData = LordEquipManager:getBagItemWithUid(equipId,true)
    local posData = LordEquipManager:getPos(equipData:getPos())
    local nextBaseAttr = nil
    local score = posData:getAttrScore(equipData:getId())
    local nextScore = score

    local yizhuangbeiVisible = false
    local xiexiaVisible = false
    local okVisible = false
    local replaceVisible = false
    if tabType == LordEquipMasterContrastPanelTabType.kOneEmpty then
        replaceVisible = true
        okVisible = true
        csNode.replace.text3:setString(Serialize["Awake_MasterContrast_5"])
    elseif tabType == LordEquipMasterContrastPanelTabType.kOneHave then
        okVisible = true
        xiexiaVisible = true
    elseif tabType == LordEquipMasterContrastPanelTabType.kTwoHave and index ==2 then
        replaceVisible = true
        okVisible = true
        yizhuangbeiVisible = index ==1
        local posEquipData = posData:getEquipData(posEquipId)
        nextBaseAttr = posEquipData:getAttr()
        nextScore = posData:getAttrScore(posEquipData:getId())
    end
    if replaceVisible then
        replaceVisible = GamePlayer:getLevel()>=equipData:getLvLimit()
    end
    -- 已装备
    csNode.yizhuangbei:setVisible(yizhuangbeiVisible)
    -- 卸  下
    csNode.unload:setVisible(xiexiaVisible)
    -- 确定
    csNode.quedingbutton:setVisible(false)
    -- 替  换
    csNode.replace:setVisible(replaceVisible)

    GameUtil:creatItemNode(csNode.item,{equipData:getId()})
    -- GameUtil:creatItemNode(csNode.item,{1110})
    csNode.equipname:setString(equipData:getName())
    csNode.equipname:setColorByID("Q".. equipData:getQuality())
    csNode.buwei:setString(string.format("%s：%s",Serialize["Awake_MasterContrast_3"],posData:getName()))
    csNode.lv:setString(string.format(Serialize["Awake_MasterContrast_4"],equipData:getLvLimit()))
    local listView = csNode.ListView
    local pingfenNode=listView.pingfen
    self:refreshAttrItem(pingfenNode,{pingfenNode.property1:getString(),score,score-nextScore},1)
    local baseAttr = equipData:getAttr(nil,posData:getLv())
    self:refreshAttr(listView.jichu,baseAttr,table.clone(nextBaseAttr or baseAttr))
    local qianghuaAttr =posData:getAttr(nil,posData:getLv())
    self:refreshAttr(listView.qianghua,qianghuaAttr,table.clone(qianghuaAttr or {}))
    if ishaveSuit then
        local taozhuang = listView.taozhuang
        local nameList,desList,maxNum,curentNum = self:getStr()
        GameUtil:resetTexts(taozhuang,nameList,true) 
        GameUtil:resetTexts(taozhuang.des,desList,true)
        taozhuang.title:setString(string.format("%s(%d/%d)",Serialize["Awake_MasterContrast_2"],curentNum,maxNum))
    end
    listView.jieshao.text:setStringWithColor(equipData:getDesc(),290)
    local function refreshItem(node,index,inscriptionUid)
        local bg1,icon1 = node["item"..index],node["tu"..index]
        if inscriptionUid and inscriptionUid~=0 then
            local itemId = LordEquipManager:getBagItemWithUid(inscriptionUid):getId()
            bg1:setImage(ItemUtil.getQualityImage(itemId))
            icon1:setImage(ItemUtil.getIconImage(itemId))
        end
        icon1:setVisible(inscriptionUid and inscriptionUid~=0)
    end
    local mingwenNode = listView.mingwen
    for index=1,3 do
        refreshItem(mingwenNode,index,self:getInscriptionItem(index))
    end

end

function This:getInscriptionItem(index)
    local equipId = self.m_equipId
    local equipData = LordEquipManager:getBagItemWithUid(equipId,true)
    local posData = LordEquipManager:getPos(equipData:getPos())
    local inscriptionUid = posData:getInscriptionKeyItem(index)
    return inscriptionUid,posData
end

function This:initTouchEvent()
    local function requestServer(equipId)
        local equipData = LordEquipManager:getBagItemWithUid(self.m_equipId,true)
        LordEquipManager:onModifyLordEquipRequest(equipData:getPos(),equipId)
        if self.m_closeHandle then
            self.m_closeHandle()
        end
    end
    local csNode = self.m_csNode
    csNode.bg:setTouch({
            onEnded = function()            
                
            end,
            isScale = false,
            -- isDynamic = true,
            isSwallow = true,
        })
    csNode.unload:setTouchEnded(function()
        requestServer(0)
    end)
	csNode.replace:setTouchEnded(function()
        local equipId = self.m_equipId
        local equipData = LordEquipManager:getBagItemWithUid(equipId,true)
        local posData = LordEquipManager:getPos(equipData:getPos())
        if posData:isLock() then
            g_scene:showTips(Serialize["Awake_MasterContrast_6"])
        else
            requestServer(self.m_equipId)
        end
    end)
    local listView = csNode.ListView
    local mingwenNode = listView.mingwen
    for index=1,3 do
        local bg = mingwenNode["item"..index]
        bg:setTouch({
            onEnded = function()            
                local inscriptionUid,posData= self:getInscriptionItem(index)
                if inscriptionUid and inscriptionUid ~=0  then
                    local inscriptionData = LordEquipManager:getBagItemWithUid(inscriptionUid)
                    g_scene:openDialog("Awake.LordEquipMasterNameplate",{itemId = inscriptionData:getId(),inScriptItemid = inscriptionUid,m_selectPos = posData:getPos()})
                    -- g_scene:openDialog("Awake.LordEquipMasterNameplate",{ node= self, itemId = itemId, itemType =itemType,inScriptItemid = self.m_inScriptItemid,m_selectPos = self.m_selectPos,m_equipMakeSelectPos = self.m_equipMakeSelectPos,equipId = self.m_cur_equipId,isReplace = true})
                end
            end,
            isScale = false,
            isDynamic = true,
            isSwallow = true,
        })
    end
end

function This:refreshAttrItem(node,info,index)
    local name = node["property"..index]
        if name then
            local jiantou =node["jiantou"..index]
            local value = node["property"..index.."num"]
            local nodes ={name,value,jiantou}
            if info[1] then
                for index,nodeView in ipairs(nodes) do
                    local value = info[index]
                    local isVisible = true
                    if index==3 then
                        local path = "GameScene/sj_jiantou.png"
                        local scale = 0.7
                        if value == 0 then
                            isVisible = false
                        elseif value<= 0 then
                            path = "WarScene/jiantou2.png"
                            scale = 0.45
                        end
                        if isVisible then
                            nodeView:setScale(scale)
                            nodeView:setImage(path)
                        end
                    else
                        nodeView:setString(value)
                    end
                    nodeView:setVisible(isVisible)
                end
            else
                for _,nodeView in pairs(nodes) do
                    nodeView:setVisible(false)
                end
            end
        end
end

function This:refreshAttr(node,nextAttr,curentAttr,recommendCount)
    
    local offsetValue = {}
    for id,value in pairs(nextAttr) do
        if not curentAttr[id] then
            curentAttr[id] =0
        end
		local curentValue= curentAttr[id] or 0
        offsetValue[id]= math.floor(value)-math.floor(curentValue)
    end
    local count= 0
    for key,_ in pairs(curentAttr) do
        local name ,value = GameUtil:getAttrStr(key,nextAttr[key])
        local info= {name,"+"..math.floor(nextAttr[key]),offsetValue[key]or 0}
        count = count +1
        -- info[3]= 1
        self:refreshAttrItem(node,info,count)
    end
    local maxCount = recommendCount or 3
    local temCount = count+1
    if temCount <=maxCount then
        for index=temCount,maxCount do
            self:refreshAttrItem(node,{},index)
        end
    end
end

function This:getStr()
    local nameList = {}
    local desList = {}
    local ishaveSuit = self.m_isHaveSuit
    -- local equipData = LordEquipManager:getEquip(self.m_equipId)
    local equipData = LordEquipManager:getBagItemWithUid(self.m_equipId,true)
    if ishaveSuit and equipData then
        local conditionList = equipData:getSuitCondition()
        local attrInfors,haveSuits,count = equipData:getSuitInfo()
        for _,equipId in ipairs(conditionList) do
            local equipData = LordEquipManager:getEquip(equipId)
            local str = "<New3>"..equipData:getName()
            if haveSuits[equipId] then
                str = "<New7>"..equipData:getName()
            end
            table.insert(nameList,str)
        end
        local function getAttrStr(attr)
            local str = ""
            for index,item1 in ipairs(attr) do
                local name,value = GameUtil:getAttrStr(item1[1],item1[2])
                str = str.. name..value
            end
            return str
        end
        for numLimit,numAttr in pairs(attrInfors) do
            local attrStr = getAttrStr(numAttr)
            local str1 = numLimit..Serialize["Awake_MasterContrast_1"]
            if count>=numLimit then
                str1 = "<New1>"..str1 ..attrStr .. Serialize["Awake_AwakeSoilser_1_c"]
            else
                str1 = "<New3>"..str1 ..attrStr .. Serialize["Awake_AwakeSoilser_3_c"]
            end
            table.insert(desList,str1)
        end
        return nameList,desList,#conditionList,count
    end
    return nameList,desList,0,0
end
