-- @Author: zheng
-- @Date:   2019-06-26 17:08:50
-- @Last Modified by:   zheng
-- @Last Modified time: 2020-07-09 11:20:11
-- @File Name: LordEquipMasterRightNode.lua
local LordEquipManager = require("Awake.LordEquipManager")
local GameUtil = require("Util.GameUtil") 
local This = class(...)

function This:create(...)
    local o = {}
    setmetatable(o,self)
    o:init(...)
    return o
end

function This:init(info)
    self.m_csNode = info.node
    self.m_tabType = info.tabType
    self:refresh()
end

function This:refresh()
    self:getData()
    local tabType = self.m_tabType
    local csNode = self.m_csNode
    local curentAttr,curentLv,desc = LordEquipManager:getStrengthenLv()
    local nextAttr,nextLv,desc = LordEquipManager:getStrengthenLv(curentLv+1)
    local isFull = not nextLv
    self:refreshAttr(csNode.curent,curentAttr)
    -- if not isFull then
        self:refreshAttr(csNode.next,nextAttr)
    -- end
    if isFull then
        desc = Serialize[60353]
        GameUtil:hideNodeList(csNode, {"titletext2","titlebg2","txt2","next"})
    end
    local titleT ={curentLv,nextLv}
    GameUtil:resetTexts(csNode,titleT,false,#titleT)
    csNode.text:setString(desc)
    csNode.qianghua:setVisible(not isFull)
end

function This:refreshAttr(node,attr)
    local attrStrs = {}
    for itemKey,itemValue in pairs(attr) do
        local name,desc = GameUtil:getAttrStr(itemKey, itemValue)
        local str = name..desc
        table.insert(attrStrs,str)
    end
    local isHave = #attrStrs>0
    if isHave then
        GameUtil:resetTexts(node,attrStrs,false,5)
    end
end

function This:getData()
    
end
