-- @Author: zheng
-- @Date:   2019-07-09 10:33:36
-- @Last Modified by:   zheng
-- @Last Modified time: 2019-07-16 14:25:26
-- @File Name: LordEquipNameAttributeNode.lua
local LordEquipManager = require("Awake.LordEquipManager")
local GameUtil = require("Util.GameUtil")
local This , super = class(...,"NodeUI")
-- local FamilyManager = require("Official.FamilyManager")
This.fileName = "MenuScene/NodeUI/LordEquipMasterNameplateAttribute.csb"
function This:initNode(info)
   self.m_attrs = info.attr
   self.m_pos  = info.pos
   self:refreshScroolView()
end

function This:refresh()

end

function This:refreshScroolView()
    self.scrollView:removeAllItems()
    local posStrs = self:getPosStr()
    for id,minMaxStr in pairs(posStrs) do
        local attrNum = 0
        local myAttr = self.m_attrs[id]
        if myAttr then
            attrNum = myAttr[2]
        end
        local name,value = GameUtil:getAttrStr(id,attrNum,true)
        local txtStrs ={name,minMaxStr,Serialize[60386],value}
        if attrNum== 0 then
            txtStrs = {name,minMaxStr,Serialize[60387]}
        end
        local view = self:getAchieveView(txtStrs)
        local w , h = view:getContentSize()
        self.scrollView:pushBackCustomItem(view,w,h,0.5)
    end
end

function This:getPosStr()
    if not self.m_posStr then
        local posStr = {}
        local posAttrs = LordEquipManager:getInscriptionAttr(self.m_pos)
        for _,attrT in pairs(posAttrs) do
            local attrItem = attrT[1]
            local minMaxStr = attrItem:getMinMaxStr()
            posStr[attrItem:getAttrType()]= minMaxStr
        end
        self.m_posStr = posStr
    end
	return self.m_posStr
end

function This:getAchieveView(info)
    local node = cc.Node:createFromCSFile("MenuScene/NodeUI/LordEquipMasterNameplateAttributeItem.csb")
    local bg = node.bg
    local w,h = bg:getContentSize()
    node:setContentSize(w,h)
    GameUtil:resetTexts(bg,info,false,4)
	return node
end

function This:initTouchEvent()
    self.bg:setTouch({
            onEnded = function()            
                
            end,
            isScale = false,
            isDynamic = true,
            isSwallow = true,
        })
end