-- @Author: zheng
-- @Date:   2019-06-26 15:19:12
-- @Last Modified by:   zheng
-- @Last Modified time: 2020-04-08 14:48:12
-- @File Name: LordEquipPanel.lua
local LordEquipManager = require("Awake.LordEquipManager")
local GameUtil = require("Util.GameUtil")
local This , super = class(...,"Dialog")
-- local AchieveManager = require("Achieve.AchieveManager")
local LordOverviewTab = require("Awake.LordOverviewTab")
local LordInscriptionTab = require("Awake.LordInscriptionTab")
This.fileName = "MenuScene/NodeUI/LordEquip.csb"
function This:initNode(info)
    local csNode = cc.Node:createFromCSFile(This.fileName)
    csNode:setToCenter()
    self:addChild(csNode)
    self.m_csNode = csNode
    for tabKey = 1, LordEquipPanelTabName.kCount do
        local item = csNode["tep"..tabKey]
        self:addTabButton(tabKey, item, function()
            self:openTabNode(tabKey)
            self:lightTabButton(tabKey)
            self.m_selectIndex = tabKey
            -- self.m_tabNodes[tabKey]:refresh()
        end)
    end
    self.m_selectIndex = LordEquipPanelTabName.kOverview
    if info and info.tabs then
        self.m_selectIndex = info.tabs
    end
    self:selectTabButton(self.m_selectIndex)
    LordEquipManager:onGetInforRequest()
    self:refreshDot()
end


function This:refreshDot()
    local tabNode = self.m_csNode
--    local tabNames = self:getTabList()
    for tabKey = 1, LordEquipPanelTabName.kCount do
        local item1 = tabNode["tep"..tabKey]
        local isHaveRed = self:isHaveRed(tabKey)
        if item1 then
            GameUtil:refreshRedDot(item1, isHaveRed)
        end
    end
end

function This:isHaveRed(tabType)
    if table.contain({LordEquipPanelTabName.kOverview,LordEquipPanelTabName.kStrengthen,LordEquipPanelTabName.kUp,LordEquipPanelTabName.kInscription}, tabType) then
        return LordEquipManager:isHaveRedTabType(tabType)
    end
    return false
end


function This:createTabNode(name)
    -- -- print(name)
    -- if LordEquipPanelTabName.kOverview == name or LordEquipPanelTabName.kStrengthen == name or LordEquipPanelTabName.kUp == name then
    --     return LordOverviewTab:create({tabType = name})
    -- elseif LordEquipPanelTabName.kInscription == name then
    --     return LordInscriptionTab:create({tabType = name})
    -- end
     return LordOverviewTab:create({tabType = name,
        closeFun = function ()
            self:close()
        end})
end


function This:initTouchEvent()
    local csNode = self.m_csNode
    csNode.close:setTouchEnded(function()
        self:close()
    end)
end
This.onModifyLordEquip = This.refreshDot
This.onGetInfor = This.refreshDot
This.onEquipUp = This.refreshDot
This.onUpPosBreak = This.refreshDot
This.onUpPosLv = This.refreshDot
function This:onEnter()
    super.onEnter(self)
    LordEquipManager:addObserver(self)
end

function This:onExit()
    super.onExit(self)
    LordEquipManager:removeObserver(self)
end
