-- @Author: zheng
-- @Date:   2019-06-28 15:24:41
-- @Last Modified by:   zheng
-- @Last Modified time: 2020-04-08 17:29:20
-- @File Name: LordOverviewItemView.lua

local This , super = class(...,"NodeUI")
local GameUtil = require("Util.GameUtil")
local GamePlayer = require("Player.GamePlayer")
This.fileName = "MenuScene/NodeUI/LordEquipAllBagItem.csb"
local LordEquipManager = require("Awake.LordEquipManager")
local ItemUtil = require("Bag.ItemUtil")

function This:setModel( achieve, index )
    if achieve then
        self.m_data = achieve
        self.m_myIndex = index
    end
    self:refresh()
end

function This:initNode(equipData,index,isEquipMake)
    self.isEquipMake = isEquipMake
    self.m_data = equipData
    self.m_myIndex = index
    local w,h = self.scale.choseTouch:getContentSize()
    w,h=92,94
    -- self:setAnchorPoint(0.5, 0.5)
    self:setContentSize(w,h)
    self:refresh()
end

function This:refresh()

    local scaleNode = self.scale
    local isNew = false
    if self.isEquipMake then
        self:updateSelectState()
        isNew = LordEquipManager:inscriptHaveRed(self.m_data:getSolt(),self.m_data:getUid())
        local equipId = self.m_data.m_config.id
        scaleNode.item1.bg:setImage(ItemUtil.getQualityImage(equipId))
        scaleNode.item1.icon:setImage(ItemUtil.getIconImage(equipId))
        -- node:setTouchEnable(false)
        scaleNode.zhezhaohong:setVisible(false)
    else
        local equipData = LordEquipManager:getEquipDataWithBagItem(self.m_data,true)
        self:updateSelectState()
        local equipId = equipData:getId()
        -- local node = GameUtil:creatItemNode(scaleNode.item1,{equipData:getId()})
        scaleNode.item1.bg:setImage(ItemUtil.getQualityImage(equipId))
        scaleNode.item1.icon:setImage(ItemUtil.getIconImage(equipId))
        -- node:setTouchEnable(false)
        scaleNode.zhezhaohong:setVisible(equipData:isLock())
    end
    scaleNode.banner:setVisible(isNew)
end

function This:initTouchEvent()
    local scaleNode = self.scale
    scaleNode.choseTouch:setTouch({
        onEnded = function()
            if self.m_btnHandle then
                self.m_btnHandle(self)
            end
        end,
        isSwallow = false,
        -- isSwallow = true,
        isDynamic = true,
        isScale = false,
        isAlpha = false
    })
end

function This:setBtnHandle(btnclick)
    self.m_btnHandle = btnclick
end

function This:getMyIndex()
   return self.m_myIndex 
end

function This:getUid()
    return self.m_data:getUid()
end


function This:getId()
    return self.m_data.id
end

function This:getType()
    return self.m_data.m_config.itype
end

function This:setSelect(selectIndex)
    self.m_selectIndex = selectIndex
    self:updateSelectState()
end

function This:updateSelectState()
    if self.m_selectIndex then        
        self.scale.choose:setVisible(self.m_selectIndex == self.m_myIndex)
    end
end