-- @Author: zheng
-- @Date:   2019-06-26 17:08:50
-- @Last Modified by:   zheng
-- @Last Modified time: 2020-04-18 16:16:32
-- @File Name: LordOverviewTab.lua
local LordEquipManager = require("Awake.LordEquipManager")
local LordOverviewItemView = require("Awake.LordOverviewItemView")
local ItemUtil = require("Bag.ItemUtil")
local GameUtil = require("Util.GameUtil")
local GamePlayer = require("Player.GamePlayer")
local UpdateLayer = require("Rank.RankPageListLayer")
local ItemNode = require("UI.ItemNode")     
local DepotManager = require("Depot.DepotManager")                             
local LordEquipSlotUnlockConfig = require("Metadatas.LordEquipSlotUnlockConfig")
local LordEquipSlotBreachConfig = require("Metadatas.LordEquipSlotBreachConfig")
local GameLordEquipBreak = require("Awake.GameLordEquipBreak")
local GameLordEquipPos = require("Awake.GameLordEquipPos")
local InscriptionConfig = require("Metadatas.InscriptionConfig")
local ItemConfig = require("Metadatas.ItemConfig")
local AttributeHelper = require("Battle.AttributeHelper")
local HeroManager = require("Hero.HeroManager")
local Hero = require("Hero.Hero")

local This , super = class(...,"NodeUI")
This.fileName = "MenuScene/NodeUI/LordEquipAll.csb"
function This:initNode(info)
    local tabType = info.tabType
    self.m_closeFun = info.closeFun
    self.m_isHaveRed = true
    self.m_isCanZhuangBeiTip = true
    self.m_type = tabType
    self.m_selectIndex = 0
    self.m_selectEquipIndex = 0
    self.m_selectPos = 1
    self.m_equipMakeSelectPos = 0
    self.m_isEquipMake = false
    self.m_inScriptItemid = 0
    self.m_cur_equipId = 0
    self.m_cur_InScriptIDList = {}
    self.m_cur_InScriptTypeList = {}
    self.m_posHasOpenList = {}
    self.m_cur_InScriptUIDList = {}
    local fileName = "MenuScene/NodeUI/LordEquipAllBag.csb"
    if tabType == LordEquipPanelTabName.kStrengthen or LordEquipPanelTabName.kUp == tabType then
        fileName = "MenuScene/NodeUI/LordEquipAllBreach.csb"
    elseif tabType == LordEquipPanelTabName.kInscription then
        fileName = "MenuScene/NodeUI/LordEquipInscription.csb"
        self.m_isEquipMake = true
    end
    self.m_rightNode = cc.Node:createFromCSFile(fileName)
    self:addChild(self.m_rightNode)
    self:getData()
    self:initUpdateLayer()
    
    self:refresh()
end

function This:initUpdateLayer()
    local scrollView = self.m_rightNode.scrollView
    if scrollView then
         self.m_listLayer = UpdateLayer:create({
            itemWidth = 80,
            itemHeight = 80,
            spaceX = 8,
            spaceY = 0,
            column = 4,
            scrollView = scrollView,
            dataCounter = function ()
                return #self.m_configlist
            end,
         viewCreator =  function(index, node)
                local item = self.m_configlist[index]
                if item then
                    if not node then
                        return self:getScroolItem(item,index)
                    else
                        node:setModel(item, index)
                    end
                end
            end,
--            hint = self.m_selectIndex,
        })
        self.m_listLayer:setCascadeOpacityEnabled(true)
        self.m_listLayer:setAnchorPoint(0.5, 0)
        local w , h = self.m_listLayer:getContentSize()
        scrollView:pushBackCustomItem(self.m_listLayer, w, h, 0)
    end
end
-- MenuScene.LordEquipPanel.m_csNode.LordOverviewTab.item5.bg

function This:refreshCommon()
    local tabType = self.m_type
    local qianghua = self.qianghua
    local pingfen = self.pingfen
    GameUtil:setPlayerFeltNodeResource(self.zhugong, GamePlayer:getIcon(),false)
    local qianghuaVisible = tabType == LordEquipPanelTabName.kStrengthen
        local selectPos = self.m_selectPos
        local pingfenNum =0
        local maxPos = LordEquipManager:getMaxPos()
         for pos=1, maxPos do
            local posData = LordEquipManager:getPos(pos)
            local isLock = posData:isLock()
            if not isLock then
                pingfenNum = pingfenNum+posData:getAttrScore()
            end
            local posNode = self["item"..pos]
            local equipData = posData:getEquipData()
            local equipId = posData:getNormalEquipId()
            if equipData then
                equipId = equipData:getId()
            end
            posNode.bg:setImage(ItemUtil.getQualityImage(equipId))
            posNode.icon:setImage(ItemUtil.getIconImage(equipId))
            GameUtil:btnGray(posNode.icon,not equipData)
            GameUtil:btnGray(posNode.bg,not equipData)
            local isCanzhuangBei = false
            local lock = posNode.lock
            local unLock = posNode.unlock
            if isLock then
                lock.jiesuo:setString(string.format("%d%s",posData:getLvLimit(),Serialize["Awake_OverviewTab_1"]))
            else
                local tip= unLock.tip
                local breakLv = posData:getBreakLv()
                local lv = posData:getLv()
                local bgd1Visible ,bgd2Visible = false,false
                
                local lv1Node , lv2Node,lv3Node = unLock.lv1,unLock.lv2,unLock.lv3
                lv1Node:setVisible(false)
                lv2Node:setVisible(false)
                lv3Node:setVisible(false)

                local lvVisible = lv>0
                local tuPoVisible = false
                local lvNode = lv1Node
                local isCanUp = posData:isCanUp()
                local isCanBreak =posData:isCanBreak()
                local isCanzhuangBei = not posData:getEquipUid() and (self.m_configlist and #self.m_configlist>0 or false)
                isCanzhuangBei = not posData:getEquipUid() and #posData:getAllMyTypeEquipBagItem()>0 and self.m_isCanZhuangBeiTip
                local ketuPoVisible ,keqianghuavisible ,kezhuangbeivisible =false,false,false
                if self:checkMyType(LordEquipPanelTabName.kStrengthen) then
                    ketuPoVisible = isCanBreak
                    keqianghuavisible = isCanUp
                    lvNode = lv2Node
                    bgd1Visible = lvVisible or isCanUp
                elseif self:checkMyType(LordEquipPanelTabName.kOverview) then
                    bgd2Visible = isCanzhuangBei
                    kezhuangbeivisible = isCanzhuangBei
                elseif self:checkMyType(LordEquipPanelTabName.kInscription) then
                    lv = breakLv
                    lvVisible = breakLv>0
                    lvNode = lv3Node
                    bgd1Visible = lvVisible
                    tuPoVisible = lvVisible
                else
                    lvVisible = false
                end

                lvNode:setString("+"..lv)
                lvNode:setVisible(lvVisible)
                unLock.tupo:setVisible(tuPoVisible)
                
                tip.bgdi:setVisible(bgd1Visible)
                tip.bgdi2:setVisible(bgd2Visible)
                tip.ketupo:setVisible( ketuPoVisible)
                tip.keqianghua:setVisible(keqianghuavisible)
                tip.kezhuangbei:setVisible(kezhuangbeivisible)
                tip:setVisible(ketuPoVisible or kezhuangbeivisible or keqianghuavisible  or bgd1Visible)
            end
            local isHaveRed = LordEquipManager:isHaveRedTabType(tabType,pos) and self.m_isHaveRed
            if tabType == LordEquipPanelTabName.kStrengthen or isCanzhuangBei then
                isHaveRed = false
            end
            GameUtil:refreshRedDot(posNode.icon, isHaveRed)
            local isChose = pos == selectPos and self:isCanSelectLeft() and not isLock
            unLock.choose:setVisible(isChose)
            -- posNode.zhezhaohong:setVisible(not posData:getEquipUid())
            lock:setVisible(isLock)
            unLock:setVisible(not isLock)
        end
    if pingfen then
        pingfen.numpingfen:setString(pingfenNum)
        pingfen:setVisible(tabType == LordEquipPanelTabName.kOverview or tabType == LordEquipPanelTabName.kStrengthen )--先屏蔽
    end
    if qianghua then
        qianghua:setVisible(qianghuaVisible)
    end
end

function This:refreshRight(attrEffect)
    local tabType = self.m_type
    local selectPos = self.m_selectPos
    local posData = LordEquipManager:getPos(selectPos)
    local equipData = posData:getEquipData()

    local haveNode = self.m_rightNode.have
    local up = nil
    local lv = nil
    local breach = nil
    local needNode = nil
    local curentTxt = nil
    local nextTxt = nil
    local itemParents =nil
    local itemNode1 = nil

    if haveNode then
        up = haveNode.up
        lv = haveNode.lv
        breach = haveNode.breach
        needNode = haveNode.need
        curentTxt = haveNode.curent
        nextTxt = haveNode.next
        itemParents ={haveNode.item2,haveNode.item3}
    end
    local breachVisible,upVisible,lvVisible,isFull,isHave = false,false,false,false,true
    
    if haveNode then
        itemNode1 = haveNode.item1
    end
    if tabType == LordEquipPanelTabName.kUp then
        if not equipData or (equipData and #equipData:getUpNeed()==0) then
            isHave = false
        else
            itemNode1:setVisible(false)
            upVisible = true
            local targetEquipData = equipData:getUpTargetData()
            local items ={equipData,targetEquipData}
            for index,equipd in ipairs(items) do
                GameUtil:creatItemNode(itemParents[index],{equipd:getId()})
            end
            curentTxt:setString("")
            nextTxt:setString("")
            curentTxt = up.curent
            nextTxt = up.next
            self:createScrollView(false,attrEffect,equipData:getAttr(),targetEquipData:getAttr(),haveNode)
            curentTxt:setColorByID("Q".. equipData:getQuality())
            nextTxt:setColorByID("Q".. targetEquipData:getQuality())
            curentTxt:setString(equipData:getName())
            nextTxt:setString(targetEquipData:getName())
            GameUtil:resetScoolItemNode(needNode.scrollView2,equipData:getUpNeed(),nil,true,40,1)
            needNode.up:setVisible(true)
        end
    elseif tabType == LordEquipPanelTabName.kStrengthen then--强化

        local equipData = posData:getEquipData()
        local equipId = posData:getNormalEquipId()
        if equipData then
            equipId = equipData:getId()
        end
        itemNode1.bg:setImage(ItemUtil.getQualityImage(equipId))
        itemNode1.icon:setImage(ItemUtil.getIconImage(equipId))
        GameUtil:btnGray(itemNode1.icon,not equipData)
        GameUtil:btnGray(itemNode1.bg,not equipData)
        local lvNum = posData:getLv()
        local breakLv = posData:getBreakLv()
        local lvData = posData:getEquipLv()
        local nextLvData = posData:getEquipLv(lvNum+1)
        local breakData = posData:getBreak()
        isFull = not posData:getBreak(breakLv+1) and not nextLvData
        local curentNum = lvNum 
        local curentAttr,nextAttr,needs = posData:getAttr(nil,lvNum),{},{}
        local isLv = lvData:getBreakLimit() == breakLv
        if isLv then
            nextAttr = posData:getAttr(nil,lvNum+1)
            needs = lvData:getCost()
            lvVisible = true
        else
            breachVisible = true
            curentNum = breakLv
            nextAttr = posData:getAttr(nil,nil,breakLv+1)
            needs = breakData:getCost()
            breach.tips:setString(breakData:getDes())
        end
        needNode.lv:setVisible(isLv)
        needNode.breach:setVisible(not isLv)
        self:createScrollView(isFull,attrEffect,curentAttr,nextAttr,haveNode)
        if isFull then
            nextTxt:setString(Serialize["Awake_OverviewTab_5_c"])
        else
            GameUtil:resetScoolItemNode(needNode.scrollView2,needs,nil,true,40,1)
            nextTxt:setString(curentNum+1)
        end
        curentTxt:setString(curentNum)
        haveNode.need:setVisible(not isFull)
    elseif tabType == LordEquipPanelTabName.kInscription then--铭文
        self.m_rightNode.change:setVisible(false)
        if equipData then
            local equipData = posData:getEquipData()
            local equipId = posData:getNormalEquipId()
            if posData then
                self.m_rightNode.wuqi.icon:setVisible(true)
                equipId = equipData:getId()
                self.m_cur_equipId = equipId
                -- local itemNode = ItemNode:create(equipId, nil, false, true)
                -- itemNode:setAnchorPoint(0.5, 0.5)
                -- self.m_rightNode.wuqi.icon:addChild(itemNode)
                GameUtil:creatItemNode(self.m_rightNode.wuqi.icon,{equipId})
            end
        else
            local equipId = posData:getNormalEquipId()
            -- local itemNode = ItemNode:create(equipId, nil, false, false,true)
            -- itemNode:setAnchorPoint(0.5, 0.5)
            -- self.m_rightNode.wuqi.icon:addChild(itemNode)
            -- GameUtil:creatItemNode(self.m_rightNode.wuqi.icon,{equipId})
            self.m_cur_equipId = 0
            self.m_rightNode.wuqi.icon:setVisible(false)
        end
        local alBasterList = LordEquipManager:getAlabasterList(self.m_selectPos)
        for i=1,3 do
            self.m_posHasOpenList[i] = self.m_posHasOpenList[i] or 0
            self.m_rightNode["mingwen"..i]:setVisible(false)
        end

        self:toGetBreakLv()

       

       local posData = LordEquipManager:getPos(self.m_selectPos)
        local inscriptionUid = 0
        for i=1,3 do
            inscriptionUid = posData:getInscriptionKeyItem(i)
            if equipData and inscriptionUid~=0 then
                local msg = {}
                local item = DepotManager:getItemByUid(inscriptionUid)
                msg.uid = inscriptionUid
                if item then
                    msg.item_id = item:getId()
                    msg.itemType = item:getType()
                end
                msg.index = i
                -- for i,v in ipairs(self.m_configlist) do
                --     if v._id == inscriptionUid then
                --         table.remove(self.m_configlist,i)
                --     end
                -- end
                self:toRefreshInScription(msg)
            else
                if self.m_rightNode["mingwen"..i] then
                    self.m_cur_InScriptIDList[i] = 0
                    self.m_rightNode["mingwen"..i].icon:setVisible(false)
                end
            end
        end
        self:refreshScroolView()

        self:toRfreshParams()

    end
    if haveNode then
        haveNode.shangxian:setVisible(isFull)
        haveNode:setVisible(isHave)
    end
    if self.m_rightNode.locktxt then
        self.m_rightNode.locktxt:setVisible(not isHave)
    end
    if up then
        up:setVisible(upVisible)
    end
    if lv then
        lv:setVisible(lvVisible)
    end
    if breach then
        breach:setVisible(breachVisible)
    end

end

function This:toRfreshParams()

    for heroId ,heroData in pairs(HeroManager:getAllHero()) do
        local playerHero = HeroManager:getHero(heroId)
        local hero = Hero:create({
            heroId = heroId,
            level = playerHero:getLevel(),
            starLv = playerHero:getStarLv(),
            quality = playerHero:getQuality(),
            deputy = table.clone(playerHero:getDeputyWithPos())
        })
        if hero then
            hero:updateInscription()
        end
        -- posTable[pos] = hero
        -- heroTable[heroId] = hero
    end
end

function This:toGetBreakLv()
    local gameLordEquipPos = LordEquipManager:getPos(self.m_selectPos)
    local breaklv = gameLordEquipPos:getBreakLv()
    
    local key = self.m_selectPos * 10000 + breaklv
    local gameLordEquipBreak = GameLordEquipBreak:create(key)

    local hasInScriptsNum = gameLordEquipBreak:getEquipNum()

    local tEquipSlotBreachConfig = nil
    local tEquipSlotBreachConfig2 = nil
    local index = 0
    local index2 = 0

    local tNewSlotList = {}
    for i,v in pairs(LordEquipSlotBreachConfig) do
        if v.solt_id == self.m_selectPos then
            table.insert(tNewSlotList,v)
        end
    end

    table.sort(tNewSlotList,function(a,b)
        return a.id < b.id
    end)

    for i,v in ipairs(tNewSlotList) do
        if v.solt_id == self.m_selectPos then
            if v.equip_num == 2 then
                index = i
                tEquipSlotBreachConfig = v
                break
            end
        end
    end
    for i,v in pairs(tNewSlotList) do
        if v.solt_id == self.m_selectPos then
            if v.equip_num == 3 then
                index2 = i
                tEquipSlotBreachConfig2 = v
                break
            end
        end
    end

    for i=1,tEquipSlotBreachConfig.equip_num do
        self.m_rightNode["mingwen"..i]:setVisible(true)
        if (breaklv < tEquipSlotBreachConfig.level and i == 2) then
            -- self.m_rightNode["mingwen"..i].text:setString(Serialize[60393]..tEquipSlotBreachConfig.level .. Serialize[60394])
             self.m_posHasOpenList[i] = 0
             self.m_rightNode["mingwen"..i].text:setString(string.format(Serialize[60379],tEquipSlotBreachConfig.level))
        elseif tEquipSlotBreachConfig2 and breaklv < tEquipSlotBreachConfig2.level and i == 3 then
             self.m_posHasOpenList[i] = 0
             self.m_rightNode["mingwen"..i].text:setString(string.format(Serialize[60379],tEquipSlotBreachConfig2.level))
        else
            self.m_posHasOpenList[i] = 1
            self.m_rightNode["mingwen"..i].text:setString("")
        end
    end
end

function This:createScrollView(isFull,attrEffect,curentAttr,nextAttr,node)
    local scrollView1= node.scrollView1
    scrollView1:removeAllItems()
    
    local function createItemView(info)
        local node = cc.Node:createFromCSFile("MenuScene/NodeUI/MythicalAnimalsMeInfoLvValue.csb")
        local bg = node.bg
        local strCount = #info
        for index=1,4 do
            local str = info[index]
            local txt =bg["txt"..index]
            if txt then
                txt:setString(str)
                txt:setVisible(index<=strCount)
            end
        end
        for index=1,2 do
            local jiantou =bg["jiantou"..index]
            jiantou:setVisible(not isFull)
        end
        local x,y = bg:getContentSize()
        node:setContentSize(x, y)
        return node 
    end
    local offsetValue = {}
    if not isFull then
        for id,value in pairs(nextAttr) do
            local curentValue= curentAttr[id] or 0
            if not curentAttr[id] then
                curentAttr[id] =0
            end
            offsetValue[id]= math.floor(value)-math.floor(curentValue)
        end
    end
    -- local keys ={}
    local count= 0
    for key,_ in pairs(curentAttr) do
        local name ,value = GameUtil:getAttrStr(key,curentAttr[key])
        local info= {name,math.floor(curentAttr[key]),math.floor(nextAttr[key] or 0),string.format("(%d)",offsetValue[key]or 0)}
        if isFull then
            info[3]=nil
            info[4]=nil
        end
        local item = createItemView(info)
        -- local scale = 0.9
        -- item:setScale(scale)
        local w , h = item:getContentSize()
        scrollView1:pushBackCustomItem(item,w,h,0.5)
        count = count +1
    end
    if count>4 then
        count =4
    end
    if attrEffect then
        GameUtil:createAttrEffect(node.anim,count,nil,count)
    end
end

function This:initTouchEvent()
 --    item1:setTouchEnded(function()
    --  self:btnCallBack(btnType)
    -- end,item1.bg)
    
 --    self.zhengduo:setTouch({
 --            isScale = false,
 --            isDynamic = true,
 --            isContainer = true,
 --            onEnded = function()
                 -- self:close()
 --            end
 --        })
    self.wenhao:setTouchEnded(function()
        g_scene:openDialog("UI.HelpTips", {text = Serialize["Awake_OverviewTab_6"],node = self.wenhao})
    end)
    if self.pingfen then
        self.pingfen.icongongming:setTouchEnded(function()
            g_scene:openDialog("Awake.LordEquipMasterPanel")
        end)
        self.qianghua:setTouchEnded(function()
             if GamePlayer:checkOpenlvLimit(50,nil,true) then
                 return false
             end
            LordEquipManager:onOneKeyBreakRequest()
        end)
    end

    local rightNode = self.m_rightNode
    local haveNode = rightNode.have
    if rightNode and rightNode.zhuangbei then
        rightNode.zhuangbei:setTouchEnded(function()--一键装备

        end)
        rightNode.fenjie:setTouch({
            isScale = false,
            isDynamic = true,
            -- isContainer = true,
            onEnded = function()
                 g_scene:openDialog("Bag.RecyclePanel",{groupIndx =2,selectSubIndex = 5})
                 if  self.m_closeFun then
                    self.m_closeFun()
                end
            end
        })
        -- rightNode.fenjie:setTouchEnded(function()--前往分解
        --     g_scene:openDialog("Bag.RecyclePanel")
        -- end)
        -- rightNode.fenjie:setTouchEnded(function()--前往分解
        --     g_scene:openDialog("Bag.RecyclePanel")
        -- end)
    end

    if rightNode then
        if rightNode.change then

            for i=1,3 do
                self.m_rightNode["mingwen"..i].choose:setVisible(false)
            end

            --todo
            for i=1,3 do

                self.m_rightNode["mingwen"..i]:setTouch(
                    {
                        onEnded = function()
                            self:rightChooseRHandler(i)
                        end,
                        isScale = false,
                    }
                )
            end

            if self.m_inScriptItemid then

                rightNode.change:setTouchEnded(function()--卸下
                    LordEquipManager:onModifyLordEquipInScriptionRequest(0,self.m_selectPos,self.m_equipMakeSelectPos)
                end)

            else

            end
        end
        if rightNode.make then
            rightNode.make:setTouchEnded(function()--前往打造
                -- g_scene:openDialog("Awake.LordEquipMakePanel",{build = false,tabType = 2})
                 g_scene:openDialog("Awake.LordEquipMakePanel")
                 local dialog = g_scene:getDialog("LordEquipMakePanel")
                 dialog:selectTabButton(2)

            end)
        end
    end

    if rightNode and haveNode then
        local function checkPos()
            return self.m_selectPos ~=0
        end
        local needNode = haveNode.need
        --强  化
        needNode.lv.button:setTouchEnded(function()
            local posData= LordEquipManager:getPos(self.m_selectPos)
            local temCanUp,tipStr = posData:isCanUp(true)
            if checkPos() then
                if temCanUp then
                    LordEquipManager:onUpPosLvRequest(self.m_selectPos)
                elseif tipStr then 
                    g_scene:showTips(tipStr)
                end
            end
        end)
        --突  破
        needNode.breach.button:setTouchEnded(function()
            local posData= LordEquipManager:getPos(self.m_selectPos)
            local temCanUp,tipStr = posData:isCanBreak()
            if checkPos() then
                if temCanUp then
                    LordEquipManager:onUpPosBreakRequest(self.m_selectPos)
                else
                    g_scene:showTips(tipStr)
                end
            end
        end)
        --进  阶
        needNode.up.button:setTouchEnded(function()
            if checkPos() then
                local posData= LordEquipManager:getPos(self.m_selectPos)
                local equipUid = posData:getEquipUid()
                if equipUid then
                   LordEquipManager:onEquipUpRequest(equipUid) 
                end
            end
        end)
    end
    local maxPos = LordEquipManager:getMaxPos()
    for pos=1, maxPos do
        local posNode = self["item"..pos]
        posNode.bg:setTouch({
        onEnded = function()
            if self.m_type == LordEquipPanelTabName.kInscription then
                self:getData(pos)
            end
            if self:isCanSelectLeft() then
                self:leftChoseCallBack(pos)
            end
            if self.m_type == LordEquipPanelTabName.kOverview then
                local posData = LordEquipManager:getPos(pos)
                local equipUid = posData:getEquipUid()
                if equipUid then
                    g_scene:openDialog("Awake.LordEquipMasterContrastPanel",{posEquipId = posData:getEquipUid()})
                end
            end
            -- local posData = LordEquipManager:getPos(pos)
            -- local lvNum = posData:getLv()
            -- local breakLv = posData:getBreakLv()
            -- local isFull = not posData:getBreak(breakLv+1) and not posData:getEquipLv(lvNum+1)
            -- print("lv,",lvNum)
            -- print("breaklv,",breakLv)
            -- if isFull then
            --     print("isFull")
            -- else
            --     print("notIsFull")
            -- end
            -- posData:isCanUp()
            -- posData:isCanBreak()
        end,
        -- isSwallow = false,
        -- isDynamic = true,
        isScale = false,
        -- isAlpha = false
    })
    end

    if self.m_rightNode.info then
        self.m_rightNode.info:setTouchEnded(function()
            g_scene:openDialog("Bag.RecyclePanel",{groupIndx =2,selectSubIndex = 6})
            -- self:close()
            if  self.m_closeFun then
                self.m_closeFun()
            end
        end)
    end
end

function This:rightChooseRHandler(selectPos)
    
    for i=1,3 do
        self.m_rightNode["mingwen"..i].choose:setVisible(false)
    end
    self.m_rightNode["mingwen"..selectPos].choose:setVisible(true)

    self.m_equipMakeSelectPos = selectPos 

    if self.m_cur_equipId ~= 0 and self.m_cur_InScriptIDList[selectPos] ~= 0 and #self.m_cur_InScriptIDList > 0 then
        if self.m_posHasOpenList[selectPos] and self.m_posHasOpenList[selectPos] == 1 then
            if self.m_cur_InScriptIDList[selectPos] and self.m_cur_InScriptTypeList[selectPos] and self.m_cur_InScriptUIDList[selectPos] then
                g_scene:openDialog("Awake.LordEquipMasterNameplate",{node= self, itemId = self.m_cur_InScriptIDList[selectPos], itemType =self.m_cur_InScriptTypeList[selectPos],inScriptItemid = self.m_cur_InScriptUIDList[selectPos],
                    m_selectPos = self.m_selectPos,m_equipMakeSelectPos = self.m_equipMakeSelectPos,equipId = self.m_cur_equipId,isReplace = true,isPutOut = true})
            end
        else
            self.m_rightNode.change:setVisible(false)
        end
    end
end

function This:toRefreshInScription(msg,pos)

    local index = msg.index
    local item_id = msg.item_id
    local uid = msg.uid
    local itemType = msg.itemType

    local function hideItem()
        if self.m_rightNode["mingwen"..index] then
            self.m_cur_InScriptIDList[index] = 0
            self.m_cur_InScriptTypeList[index] = 0
            self.m_cur_InScriptUIDList[index] = 0
            self.m_rightNode["mingwen"..index].icon:setVisible(false)
        end
    end
    if msg.item_id then
        if item_id == 0 then
            hideItem()
        else
            if self.m_rightNode["mingwen"..index] then
                self.m_rightNode["mingwen"..index]:setVisible(true)
                self.m_rightNode["mingwen"..index].icon:setVisible(true)
                self.m_cur_InScriptIDList[index] = self.m_cur_InScriptIDList[index] or 0
                self.m_cur_InScriptIDList[index] = msg.item_id
                self.m_cur_InScriptTypeList[index] = self.m_cur_InScriptTypeList[index] or 0
                self.m_cur_InScriptTypeList[index] = itemType
                self.m_cur_InScriptUIDList[index] = self.m_cur_InScriptUIDList[index] or 0
                self.m_cur_InScriptUIDList[index] = uid
            end

            -- local itemNode = ItemNode:create(msg.item_id,nil,false,true)
            -- itemNode:setAnchorPoint(0.5,0.5)
            if self.m_rightNode["mingwen"..index] then
                self.m_rightNode["mingwen"..index].text:setString("")
                GameUtil:creatItemNode(self.m_rightNode["mingwen"..index].icon,{msg.item_id})
                -- self.m_rightNode["mingwen"..index].icon:addChild(itemNode)
            end
        end
    else
        print("没有道具id======")
        hideItem()
    end
end

function This:leftChoseCallBack(selectPos)
    local posData = LordEquipManager:getPos(selectPos)
    if posData then
        if posData:isLock() then
            g_scene:showTips(string.format(Serialize["achieve_MainPanel_1_c"],posData:getLvLimit()))
            return
        end
        self.m_selectPos = selectPos
        local maxPos = LordEquipManager:getMaxPos()
        for pos=1, maxPos do
            local posNode = self["item"..pos]
            posNode.unlock.choose:setVisible(pos ==selectPos)
        end
        self:refreshRight()
    end

end

function This:isCanSelectLeft()
    return self.m_type and self.m_type~= LordEquipPanelTabName.kOverview
end

function This:refreshLeft()
    
end

function This:refresh(attrEffect)
    self:refreshCommon()
    local tabType = self.m_type
    if tabType == LordEquipPanelTabName.kOverview then
        self:refreshScroolView()
    else
        self:refreshRight(attrEffect)
    end
end

function This:refreshScroolView()
    self.m_listLayer:setDataList()
    self:refreshSelectState()
end

function This:refreshSelectState(refreshId)
    local viewList = self.m_listLayer:getAllViews()
    for _,item in pairs(viewList) do
        item:setSelect(self.m_selectEquipIndex)
        -- if refreshId and refreshId == item:getId() then
        --     self:refreshCommon()
        -- end
    end
end

function This:getScroolItem(data,index)
    local selectIndex = self.m_selectIndex
    local view = LordOverviewItemView:create(data,index,self.m_isEquipMake)
    view:setSelect(selectIndex)
    view:setBtnHandle(function (selectView)

        local selectViewIndex = selectView:getMyIndex()
        if self.m_selectEquipIndex ~= selectViewIndex then
            self.m_selectEquipIndex = selectViewIndex
            self:refreshSelectState(selectViewIndex)
        end
        if not self.m_isEquipMake then
            local equipUid = selectView:getUid()
            local equipData = LordEquipManager:getBagItemWithUid(equipUid,true)
            local posData = LordEquipManager:getPos(equipData:getPos())
            g_scene:openDialog("Awake.LordEquipMasterContrastPanel",{equipId = equipUid ,posEquipId = posData:getEquipUid()})
        else
            self.m_inScriptItemid = selectView:getUid()
            LordEquipManager:removeRedItem(self.m_selectPos,self.m_inScriptItemid)
            local itemId = selectView:getId()
            local itemType = selectView:getType()
            g_scene:openDialog("Awake.LordEquipMasterNameplate",{ node= self, itemId = itemId, itemType =itemType,inScriptItemid = self.m_inScriptItemid,m_selectPos = self.m_selectPos,m_equipMakeSelectPos = self.m_equipMakeSelectPos,equipId = self.m_cur_equipId,isReplace = true})
            selectView:refresh()
        end
    end)
    return view
end


function This:onEnter()
    super.onEnter(self)
    LordEquipManager:addObserver(self)
end

function This:onExit()
    super.onExit(self)
    LordEquipManager:removeObserver(self)
end

function This:getData(pos)

    if self.m_type == LordEquipPanelTabName.kInscription then
        self.m_isEquipMake = true
        self.m_configlist = LordEquipManager:getInscriptionWithSolt(pos or self.m_selectPos)
    else
        self.m_configlist =LordEquipManager:getAllEquipBagItemWithSort(true)
    end
end

function This:checkMyType(tabType)
    return tabType and tabType == self.m_type
end

--主公装备穿戴、卸载
function This:onModifyLordEquip(equipuid)
    if self:checkMyType(LordEquipPanelTabName.kOverview) then
        -- if equipuid ~=0 then
        -- end
           self.m_selectEquipIndex = 0
           self:refreshSelectState(self.m_selectEquipIndex) 
    end
   self:getData()
   self:refresh()
end
    -- optional int32 err_code = 1;
    -- optional int64 item_id = 2;     // 传0表示卸载
    -- optional int32 pos = 3;
    -- optional int32 index = 4;   
function This:onModifyLordEquipInScription(msg)
    local alBasterList = LordEquipManager:getAlabasterList(msg.pos)
    local posData = LordEquipManager:getPos(self.m_selectPos)
    local inscriptionUid = 0

    if msg.item_id == 0 then
        if self.m_rightNode["mingwen"..msg.index] then
            self.m_rightNode["mingwen"..msg.index].icon:setVisible(false)
        end
        self:getData()
        self:refresh()
    else
        for i=1,3 do
            inscriptionUid = posData:getInscriptionKeyItem(i)
            if inscriptionUid then
                local msg = {}
                local item = DepotManager:getItemByUid(inscriptionUid)
                msg.uid = inscriptionUid
                if item then
                    msg.item_id = item:getId()
                    msg.itemType = item:getType()
                end
                msg.index = i
                self:toRefreshInScription(msg)
                for i,v in ipairs(self.m_configlist) do
                    if v._id == inscriptionUid then
                        table.remove(self.m_configlist,i)
                    end
                end
            else
                if self.m_rightNode["mingwen"..i] then
                    self.m_rightNode["mingwen"..i].icon:setVisible(false)
                end
            end
        end
    end
    -- self:refreshScroolView()
end

function This:onUpPosLv()
    if self:checkMyType(LordEquipPanelTabName.kStrengthen) then
        self:refresh(true)
    else
        self:refresh()
    end
end

function This:onUpPosBreak()
    self:onUpPosLv()
end

function This:onEquipUp()
    if self:checkMyType(LordEquipPanelTabName.kUp) then
        self:refresh()
    else
        self:refresh()
    end
end

function This:onGetInfor()
    self:getData()
   self:refresh() 
end

