--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This, super = BaseClass(...)
local ItemConfig = require("Metadatas.ItemConfig")
local LordEquipConfig = require("Metadatas.LordEquipConfig")
local LordEquipManager = require("Awake.LordEquipManager")

function This:__init(data)
	if data then
        self._id			= data.id           --uid

        self.id             = data.type_id      --item id
        self.grid_id        = data.grid_id  
	    self.num			= data.num		    --物品堆叠数量
        self.create_time    = data.create_time
	    self.equip_card_id  = data.equip_card_id
	    self.strength_level = data.strength_level
	    self.process        = data.process
        self.m_isLocked     = data.lock or false
        if self.id > 0 then
            self.m_config = ItemConfig[self.id]
        end
    else
        self:Clear()
    end
end

function This:__delete()
	self:Clear()
end

function This:Clear()
	self._id			= 0     --id

    self.id             = 0     --typeid     
    self.grid_id        = 0  
	self.num			= 0		--物品堆叠数量
    self.create_time    = 0
	self.equip_card_id  = 0
	self.strength_level = 0
	self.process        = 0
    self.m_config       = nil
end

function This:updateInfo( data )
    if data.type_id and data.type_id ~= self:getId() then
        self:resetId(data.type_id)
    end
    self.grid_id        = data.grid_id  
    self.num            = data.num          --物品堆叠数量
    self.create_time    = data.create_time
    self.equip_card_id  = data.equip_card_id
    self.strength_level = data.strength_level
    self.process        = data.process
    self.m_isLocked     = data.lock or false
end


function This:getType()
    return  self.m_config.itype
end

function This:getComment()
    return  self.m_config.comment
end

function This:getItemGetWays()
    return  self.m_config.get_way
end

function This:getName()
    return  self.m_config.name
end

function This:getPrice()
    return  self.m_config.price
end

function This:getQuality()
    return  self.m_config and self.m_config.quality or 1
end

function This:getPriceMoneyType()
    return  self.m_config.mtype
end 
    
function This:getTargetCost()
    return 0
end
    
function This:getTargetId()
    return 0
end

function This:getCount()
    return self.num
end

function This:setCount(num)
    self.num = num
end

function This:getUid()
    return self._id
end

function This:getId()
    return self.id
end

function This:isVisible()
    return true
end

function This:canBeSold()
    return self.m_config.mtype > 0
end

function This:canReborn()
    return false
end

function This:isEquip()
    return false
end

function This:isSpall()
    return false
end

function This:isLordEquip()
    return false
end

function This:isRune()
    return false
end

function This:isPlan()
    return false
end

function This:isPassiveSkill()
    return false
end

function This:isInscriptionBooks()
    return false
end

function This:isInscription()
    return false
end

function This:isFabao()
    return false
end

function This:isPack()
    return false
end

function This:isFaBaoItemReturnConfig()
    return false
end

function This:isEquipped()
end

function This:resetId( id )
    self.id         = id
    self.m_config   = ItemConfig[self.id] 
end

function This:canUsed( showWarming )
    return true
end

function This:isEquipToEquip() --符文是否装上装备
	local list = LordEquipManager:getAllBasterList()
	if list and table.count(list) > 0 then
		for _,data in pairs(list) do
            for i=1,2 do
                if data.item_uid_list[i] == self:getUid() then
                    return true
                end
            end
		end
	end
	return false
end

function This:isLocked() --铭文是否上锁
    return self.m_isLocked or false
end

function This:setLocked()
    --self.m_isLocked = not self.m_isLocked
end

function This:checkCommonType(itype)
    if self.m_config then
        return self.m_config.itype == itype
    end
    return false
end

function This:getEquipCardId()
    return self.equip_card_id
end
