-- @Author: superm
-- @Date:   2017-11-25 13:21:06
-- @Last Modified by:   superm
-- @Last Modified time: 2019-03-01 21:27:15
local This, super = BaseClass(..., "Bag.BaseItemModel")
local ItemUtil = require("Bag.ItemUtil")
local LordEquipManager = require("Awake.LordEquipManager")

function This:canUsed( showWarming )
	if not self:isVisible() then
		return false
	end

	if not self.m_canUsedPlace then
	    local state, codeList = ItemUtil.canUsed(self:getId())

	    local tmpCodeList = nil
	    if type(codeList) == "table" then
	    	tmpCodeList = #codeList
	    elseif type(codeList) == "number" then
	    	tmpCodeList = codeList
	    end

	    if state and tmpCodeList >= 3 then 
	    	canUsedSate = true
	    	self.m_canUsedPlace = ItemUsageType.kInEverywhere
	        return true
	    elseif state and tmpCodeList > 0 then
	        local hasInWorldCode = table.find(codeList, function ( index, code )
	            return ItemUsageType.kInWorld == code or ItemUsageType.kInCity == code
	        end)
	        local hasInTerritory = table.find(codeList, function ( index, code )
	            return ItemUsageType.kInTerritory == code
	        end)

	        if hasInWorldCode then
	        	self.m_canUsedPlace = ItemUsageType.kInWorld
	            if g_scene:getType() == SceneType.kWorldScene then
	                return true
	            elseif not hasInTerritory then
	            	if showWarming then
	                	g_scene:showTips(Serialize["bag_PropsItem_1_c"])
	                end
	            end
	        end

	        if hasInTerritory then
	        	self.m_canUsedPlace = ItemUsageType.kInTerritory
	            if g_scene:getType() == SceneType.kHomeScene then
	                return true
		        elseif not hasInWorldCode then
	            	if showWarming then
			            g_scene:showTips(Serialize["bag_PropsItem_2_c"])
			        end
		        end
            end
	    elseif not state and tmpCodeList > 0 then
	    	self.m_canUsedPlace = ItemUsageType.kNone
        	if showWarming then
		        g_scene:showTips(Serialize["bag_PropsItem_3_c"])
			end
	    end 
    	return false

    else
    	if self.m_canUsedPlace == ItemUsageType.kInEverywhere then
    		return true
    	elseif self.m_canUsedPlace == ItemUsageType.kNone then
    		if showWarming then
	        	g_scene:showTips(Serialize["bag_PropsItem_3_c"])
	        end
	        return false
    	elseif self.m_canUsedPlace == ItemUsageType.kInWorld then
            if g_scene:getType() == SceneType.kWorldScene then
                return true
            elseif not hasInTerritory then
	    		if showWarming then
	                g_scene:showTips(Serialize["bag_PropsItem_1_c"])
	            end
            end
    	elseif self.m_canUsedPlace == ItemUsageType.kInTerritory then
            if g_scene:getType() == SceneType.kHomeScene then
                return true
	        elseif not hasInWorldCode then
	    		if showWarming then
		            g_scene:showTips(Serialize["bag_PropsItem_2_c"])
		        end
	        end
	    end
        return false
	end
end

function This:isPack()
    return self:getType() == ItemCommonType.kPropPack 
end

function This:isPassiveSkill()
    return ItemUtil.isPassiveSkill(self:getId())
end

function This:isInscriptionBooks()
	return ItemUtil.isInscriptionBooks(self:getId())
end

function This:isInscription()
	return ItemUtil.isInscription(self:getId())
end

function This:isVisible()
    return ItemUtil.isItemVisible(self:getId())
end