-- @Author: superm
-- @Date:   2018-12-30 17:36:06
-- @Last Modified by:   superm
-- @Last Modified time: 2018-12-30 18:39:21
-- @File Name: RecycleHeroChoosePanel.lua
-- @Description: 

local This , super = class(...,"Stage.StageSelectHeroPanel")
local RecycleHeroItemView = require("Bag.RecycleHeroItemView")
local RankPageListLayer = require("Rank.RankPageListLayer")

function This:initNode(info)
	self.m_spaceX = info.spaceX
	self.m_pickHeros = info.pick
	self.m_haveSelectHeros = info.haveSelected or {}
	self.m_csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/RebornChooseHero.csb")
	self:addChild(self.m_csNode)
	self.m_csNode:setToCenter()

	self.m_selectHandler = info.selectHandler
	local heros = self:getHeroList()
	self.m_count = #heros

	local totalWidth = self.m_csNode.scrollView:getContentWidth()
	self.m_layerLayer = RankPageListLayer:create({
		itemWidth = 80,
		itemHeight = 80,
        spaceX = self.m_spaceX - 2,
        spaceY = 5,
        column = math.floor(totalWidth / (78 + self.m_spaceX)),
        scrollView = self.m_csNode.scrollView,
		dataCounter = function ()
	        return self.m_count
        end,
        viewCreator =  function(index, node)
        	if self.m_count < index then
        		return
        	end

        	local hero = heros[index]
	        if hero then
		        if not node then
					local view = self:getHeroView(hero, index)
					view:setSelectHandler(function(id)
						if self.m_pickHeros and not self.m_pickHeros[id] then
							g_scene:showTips(Serialize[60413])
					    	return 
						end

						if self.m_selectHandler then
							self.m_selectHandler(id)
						end
						self:close()
					end)
			        return view
			    else
		        	node:setModel(hero, index)
		        end
		    end
	    end,
    })

	self.m_layerLayer:setAnchorPoint(0.5,0)
	local w , h = self.m_layerLayer:getContentSize()
	self.m_csNode.scrollView:pushBackCustomItem(self.m_layerLayer, w, h,0)
	self.m_layerLayer:setDataList()
end

function This:getHeroView(hero)
	local maxHp = hero:getAttr(AttrType.kMaxHp)
	local param = {maxHp = maxHp, hp = maxHp}
	if self.m_pickHeros then
		param.mask = function ( heroId )
			if not self.m_pickHeros then
				return true
			end
		    return self.m_pickHeros[heroId]
		end
	end
	local node = RecycleHeroItemView:create({
		hero = hero,
		isSwallow = false,
		isContanier = true,
		isShowCeng = false,
	})
	return node
end