-- @Author: superm
-- @Date:   2018-12-30 17:15:22
-- @Last Modified by:   superm
-- @Last Modified time: 2018-12-30 18:44:49
-- @File Name: RecycleHeroItemView.lua
-- @Description: 

local This , super = class(...,"NodeView")
local GameUtil = require("Util.GameUtil")
local HeroConfig = require("Metadatas.HeroConfig")
local ItemUtil = require("Bag.ItemUtil")

This.csfileName = "LegionScene/NodeUI/LegionTroopEditItem.csb"

function This:initData(info)
	self.m_hero = info.hero
	self.m_isInAllTeam = false
	self.m_isInCurTeam = false
	self.m_isSwallow = info.isSwallow or false
	self.m_isContanier = info.isContanier or false
	self.m_selectHandler = info.handler
	self.m_isShowCeng = info.isShowCeng
	if self.m_isShowCeng == nil then
		self.m_isShowCeng = true
	end
    self.m_inited = false
    local csNode = cc.Node:createFromCSFile(self.csfileName)
    self:addChild(csNode)
    self.m_csNode = csNode
end

function This:initNode(info)
	self.m_csNode.xuanzhong:setVisible(false)
end

function This:refresh()
	local csNode = self.m_csNode
	if self.m_hero then
		local heroId = self.m_hero:getId()
		csNode.hero:setImage(ItemUtil.getIconImage(heroId))
		csNode.bg1:setImage(ItemUtil.getQualityImage(heroId))

		local star = self.m_hero:getStarLv()
		for i = 1 , 5 do
			csNode["star"..i]:setVisible(star >= i)
		end
		csNode.hero:setVisible(true)
		csNode.level:setVisible(true)
		csNode.starbg:setVisible(star > 0)
		csNode.level:setString(self.m_hero:getLevel())
		csNode.ceng:setVisible(self.m_isShowCeng)
	end
end

function This:initTouchEvent()
	local csNode = self.m_csNode
	csNode.bg1:setTouch({
		onEnded = function()
			if self.m_selectHandler and self.m_hero then
				local ret, errorStr = self.m_selectHandler(self.m_hero)
				if ret then
					self:close()
					return
				elseif errorStr then
					g_scene:showTips(errorStr)
				end
			end
		end,
		isDynamic = self.m_isContanier,
		isContanier = self.m_isContanier,
		isSwallow = self.m_isSwallow,
		isScale = false
	})
end

function This:onEnter()
	super.onEnter(self)
	self:refresh()
end

function This:onEixt()
	super.onExit(self)
end

function This:setSelectHandler(handler)
	self.m_selectHandler = handler
end

function This:setModel(hero)
	if self.m_hero ~= hero then
		self.m_hero = hero
		self:refresh()
	end
end

function This:getModel()
	return self.m_hero
end