-- @Author: superm
-- @Date:   2018-12-27 11:40:33
-- @Last Modified by:   zheng
-- @Last Modified time: 2019-12-20 17:28:18
-- @File Name: RecyclePanel.lua
-- @Description: 

local This, super = class(..., "Dialog")
local DepotManager = require("Depot.DepotManager")
local TerrTabGroupBehaviour = require("Territory.TerrTabGroupBehaviour")

local tabNames = {"Reborn", "Sell"}
local tabSubNames = {"Hero", "Equip", "Fabao", "EquipSpall", "PrincipalEquip", "Mwen", "Tactics"}

function This:initData(info)

end

function This:getSubParam( pnode, count )
    local subParam = {
        tabs = {
            isDynamic = true,
            isScale = false,
            names = tabSubNames,
            count = count,
            pnode = pnode,
            nodes = {
                use_regular_prefix = "tep",
                use_indice = true,
                use_pindice = true,
                default = 1,
            },
            height = 49,
            func = function ( sindex, name, index )
                if self.m_subtabIndex == sindex and self.m_tabIndex == index then
                    return false
                end
                self.m_tabIndex = index
                self.m_subtabIndex = sindex
                -- print(sindex, index)
                self:selectTab(name .. index)
                return true
            end,
        }
    }
    return subParam
end

function This:initNode(info)
    local csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/Reborn.csb")
    self.m_csNode = csNode
    csNode:setToCenter()
    self:addChild(csNode)

    local tabNode = csNode.tabs
    local param = {
        inner_height = 255,
        tabs = {
            isDynamic = true,
            isScale = false,
            count = 2,
            names = tabNames,
            pnode = tabNode,
            nodes = {
                use_regular_prefix = "tep",
                use_indice = true,
                subtabs = { self:getSubParam(tabNode, 3), self:getSubParam(tabNode, 7) },
                default = 1,
                select_default = true,
            },
            height = 73,
        },
    }
    local groupIndx = 1
    local selectSubIndex =1
    if info and info.groupIndx then
        groupIndx = info.groupIndx
        selectSubIndex = info.selectSubIndex
    end
    local group = TerrTabGroupBehaviour:create(param)
    group:selectTabButton(groupIndx)
    local subGroup = group:getSubGroup(groupIndx)
    subGroup:selectTabButton(selectSubIndex)
end

function This:initTouchEvent()
    self.m_csNode.close:setTouchEnded(function()
        if self.m_runningAniantion then
            return false
        end
        self:close()
    end)
end

function This:onEnter()
    super.onEnter(self)
    DepotManager:addObserver(self)
end

function This:onExit()
    DepotManager:removeObserver(self)
    super.onExit(self)
end

function This:refresh()

end

function This:getTabNodeData()
    --boby  
end

function This:onTabNodeSwitchOut( node )
    if node then
        node:refresh()
    end
end

function This:createTabNode(name)
    -- print(name)
    if self.m_tabIndex == 1 then
        uiName = "Bag.RecycleOneNode"
    else
        uiName = "Bag.RecycleMultiNode"
    end
    local tabNode = require(uiName):create({ 
        ttype= self.m_subtabIndex ,
        closeFun = function ()
            self:close()
        end
    })
    return tabNode
end

function This:selectTab(name)
    self:openTabNode(name)
end
