-- RuneItemModel.lua
local This, super = BaseClass(..., "Bag.BaseItemModel")
local GameUtil = require("Util.GameUtil")
local ItemUtil = require("Bag.ItemUtil")
local AttributeLibraryConfig = require("Metadatas.AttributeLibraryConfig")

function This:__init(data)
    super.__init(self, data)
    self:updateRuneSkill(data)
end

function This:updateRuneSkill(data)
    local attrs ={}
    local temAttr = data.msgrunestone_info
    local skillIdList = {}
    if data and temAttr then
        local attrIdKey = temAttr.atr_id_list
        for _,id in ipairs(attrIdKey) do
           local configItem = AttributeLibraryConfig[id]
           if configItem then
               local attritem = GameUtil:convertData(configItem.attribute)
               attrs = GameUtil:tableAdd(attritem,attrs)
           end
        end
        skillIdList = temAttr.skill_list
        
        -- for index,key in ipairs(attrKey) do
        -- 	attrs[key] = attrValue[index] or 0
        -- end
    end
    self.m_attr = attrs 
    self.m_skillIdList = skillIdList
    
end

function This:updateInfo(data)
    super.updateInfo(self,data)
    self:updateRuneSkill(data)
end

function This:getAttr()
	return self.m_attr
end

function This:getSkillIds()
    return self.m_skillIdList
end

function This:Clear()
    super.Clear(self)
    self.m_attr = {}
    self.m_skillIdList ={}
end

function This:getIcon()
    return ItemUtil.getIconImage(self:getId())
end

function This:setIsActive(isActive,hero)
    -- local attrs =self:getAttr()
    -- if isActive then
    --     hero:addAttrs( attrs,true )
    -- else
    --     hero:reduceAttrs( attrs,true )
    -- end
end

function This:addHero(hero)
    
end

function This:removeHero(hero)

end

function This:getEquipCardUid()
    return self.equip_card_id
end

function This:isRune()
    return true
end

function This:isEquipped()
    return self.equip_card_id>0
end

function This:isFaBaoItemReturnConfig()
    return true
end