--region *.lua
--Date
--此文件由[BabeLua]插件自动生成


local This, super = BaseClass(..., "Bag.BaseItemModel")
local HeroManager = require("Hero.HeroManager")
local GodBeastManager = require("GodBeast.GodBeastManager")
local ItemUtil = require("Bag.ItemUtil")

function This:__init(data)
    super.__init(self, data)
    if data then
        local targetItemType = self:getTargetItemType()
        if targetItemType == ItemCommonType.kEquip then
            self.m_productType = ItemType.kEquipSpall
        elseif targetItemType == ItemCommonType.kHero then
            self.m_productType = ItemType.kHeroSpall
        else
            self.m_productType = ItemType.kPropsSpall
        end
    end
end

function This:Clear()
    super.Clear(self)
    self.m_productType = 0
end

function This:isSpall()
    return true
end

function This:getTargetItemType(id)
    return ItemUtil.getType(self:getTargetId())    
end

function This:getProductType()
    return self.m_productType
end

function This:isHeroSpall()
    return self:getProductType() == ItemType.kHeroSpall
end

function This:isEquipSpall()
    return self:getProductType() == ItemType.kEquipSpall
end

function This:getTargetId()
    local targetCfg = ItemUtil.getTargetInfo(self.id)
    if targetCfg then
        local _, targetItem = next(targetCfg)
        if targetItem then
            return targetItem[1]
        end
    end
    return 0
end

function This:getTargetCost()
    local needCfg = ItemUtil.getTargetCost(self.id)
    local _id, needItemNum = 0, 0
    if needCfg then
        local _, needItem = next(needCfg)
        if needItem then
            _id, needItemNum = unpack(needItem)
        end
    end
    return needItemNum
end

function This:getSynthesizeCost()
    return self:getTargetCost()
end

function This:canUsed( showWarming )
    if self.m_requestForce then
        return false, self.m_requestForce
    else
        self.m_requestForce = self:isHeroSpall() and HeroManager:isGotHero(self:getTargetId())
        if not self.m_requestForce then --排除神兽碎片
            self.m_requestForce = ItemUtil.isAnimalSpall(self:getId()) and GodBeastManager:isGotHero(self:getTargetId())
            -- if self.m_requestForce then--是否获得
            --     return false,false
            -- end
        end
        if self.m_requestForce then
            return false, self.m_requestForce
        end
    end

    if self.num == self.m_requestNum then
        return self.m_synthesizeState, self.m_requestForce
    else
        self.m_requestNum = self.num or 0
        self.m_requestForce = self:isHeroSpall() and HeroManager:isGotHero(self:getTargetId())
        if not self.m_requestForce then --排除神兽碎片
            self.m_requestForce = ItemUtil.isAnimalSpall(self:getId()) and GodBeastManager:isGotHero(self:getTargetId())
        end
        if not self.m_requestForce then 
            self.m_synthesizeState = self:getSynthesizeCost() <= self.num
        else
            self.m_synthesizeState = false
        end
        return self.m_synthesizeState, self.m_requestForce
    end
end

--endregion