--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This = class(...)

function This:create()
	local l = {}
	setmetatable(l,self)
	l:init()
	return l
end

local index = 0
function This:init()
	index = 0
	self.m_key = {}
	self.m_nodes = {}
	self.m_header = {}
	self.m_tail = {}
	self.m_header.nex = self.m_tail
	self.m_tail.pre = self.m_header
	self.m_size = 0
end

function This:getSize()
	return self.m_size
end

function This:addNode(node,key)
	key = key or node
	if not self.m_key[key] then
		index = index + 1
		local t = {node = node, nex = self.m_tail, pre = self.m_tail.pre , index = index, key = key }
		self.m_tail.pre.nex = t
		self.m_tail.pre = t
		self.m_key[key] = t
		self.m_size = self.m_size + 1
	end
end

function This:getPreNode(key)
	local node = self.m_key[key]
	if node then
		local preNode = node.pre
		if preNode and preNode ~= self.m_header then
			return preNode.node
		end
	end
end

function This:getNode(key)
	if self.m_key[key] then
		return self.m_key[key].node
	end
end

function This:hasNode(node)
	return self.m_key[node] ~= nil
end

function This:removeNode(node)
	local n = self.m_key[node]
	if n then
		local nex = n.nex
		n.nex.pre = n.pre
		n.pre.nex = n.nex
		self.m_key[node] = nil
		self.m_size = self.m_size - 1
		return nex
	end
end

function This:swapNode(aNode,bNode)
	local a = self.m_key[aNode]
	local b = self.m_key[bNode]
	if a and b then
		local pre = nil
		local nex = nil
		local A = nil
		local B = nil
		if a.nex == b then
			pre = a.pre
			nex = b.nex
			A = a
			B = b
		elseif b.nex == a then
			pre = b.pre
			nex = a.nex
			A = b
			B = a
		else
			pre = a.pre
			nex = b.nex
			A = a
			B = b
		end
		a.pre.nex = a.nex
		a.nex.pre = a.pre
		b.pre.nex = b.nex
		b.nex.pre = b.pre
		A.nex = nex
		A.pre = nex.pre
		nex.pre.nex = A
		nex.pre = A
		B.nex = pre.nex
		B.pre = pre
		pre.nex.pre = B
		pre.nex = B
	end
end

function This:getFrontNode()
	if self.m_header.nex ~= self.m_tail then
		return self.m_header.nex.node
	end
end

function This:getBackNode()
	if self.m_tail.pre ~= self.m_header then
		return self.m_tail.pre.node
	end
end

function This:getNodeList(selector)
	local list = {}
	local curNode = self.m_header.nex
	while curNode and curNode ~= self.m_tail do
		if selector then
			if selector(curNode.node) then
				table.insert(list,curNode.node)
			end
		else
			table.insert(list,curNode.node)
		end
		curNode = curNode.nex
	end
	return list
end

function This:removeNodeBySelector(selector)
	local curNode = self.m_header.nex
	while curNode and curNode ~= self.m_tail do
		if selector and selector(curNode.node) then
			curNode = self:removeNode(curNode)
		else
			curNode = curNode.nex
		end
	end
end

function This:getNextIterator()
	local node = self.m_header.nex
	local function next()
		if node ~= self.m_tail then
			local tmp = node
			node = node.nex
			return tmp.key, tmp.node
		else
			return nil
		end
	end
	return next
end

function This:clear()
	index = 0
	self.m_header.nex = self.m_tail
	self.m_tail.pre = self.m_header
	self.m_key = {}
end

function This:update(dt,second)
	local curNode = self.m_header.nex
	while curNode and curNode ~= self.m_tail do
		if curNode.node.update then
			--print("index = ",curNode.index)
			--保护调用
            local ret, err = pcall(function ()
                curNode.node:update(dt)
            end)
            if not ret then
                logError(err)
            end
		end
		-- if second and curNode.node.updateSecond then
		-- 	--print("index = ",curNode.index)
		-- 	--保护调用
  --           local ret, err = pcall(function ()
  --               curNode.node:updateSecond(dt)
  --           end)
  --           if not ret then
  --               logError(err)
  --           end
		-- end
		curNode = curNode.nex
	end
end



--endregion
