--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

__alloc_tbl = __alloc_tbl or {}

--保存类类型的虚表
__class__ = __class__ or {}

function BaseClass(...)
	-- 理论上可直接用 BaseClass(name, super) 的形式
	-- 为保证父类已初始化(已require) 这里用BaseClass(...)形式以进行检查
	local arg = {...}
	local name = arg[1]
	local base = arg[2]
    local super = base and require(base) or nil
	if (#arg >= 2 and (base == nil or super == nil)) then
		Log.err("BaseClass is nil!", debug.traceback())
		error("BaseClass is nil!")
		return
	end


	-- 生成一个类类型
	local class_type = {}
	package.loaded[name] = class_type
	-- 在创建对象的时候自动调用
	class_type.__init = false
	class_type.__delete = false
	class_type.__before_delete = false
	class_type.super = super
	class_type.New = function(...)
		-- 生成一个类对象
		local obj = {}
		obj._class_type = class_type

		if _DEBUG_MEM and not LuaMemMonitor.IsIgnore(class_type) then
			__alloc_tbl[obj] = debug.traceback("", 2)
		end

		-- 在初始化之前注册基类方法
		setmetatable(obj, { __index = __class__[class_type] })

		-- 调用初始化方法
		do
			local create 
			create = function(c, ...)
				if c.super then
					create(c.super, ...)
				end
				if c.__init then
					c.__init(obj, ...)
				end
			end

			create(class_type, ...)
		end

		-- 注册一个delete方法
		obj.DeleteMe = function(self)
            -- 检查内存
			if _DEBUG_MEM and not LuaMemMonitor.IsIgnore(self._class_type) then
				if not __alloc_tbl[self] then
					Log.err("[ERROR] ALREADY DELETED !!" .. debug.traceback("", 2))
				end
				__alloc_tbl[self] = nil
			end

			local now_super = self._class_type 
			while now_super ~= nil do
				if now_super.__before_delete then
					now_super.__before_delete(self)
				end
				now_super = now_super.super
			end

			local now_super = self._class_type 
			while now_super ~= nil do	
				if now_super.__delete then
					now_super.__delete(self)
				end
				now_super = now_super.super
			end
		end

		return obj
	end

	local vtbl = {}
	__class__[class_type] = vtbl
 
	setmetatable(class_type, {__newindex =
		function(t,k,v)
			vtbl[k] = v
		end
		, 
		__index = vtbl, --For call parent method
	})
 
	if super then
		setmetatable(vtbl, {__index =
			function(t,k)
				local ret = __class__[super][k]
				--do not do accept, make hot update work right!
				--vtbl[k] = ret
				return ret
			end
		})
	end
 

	local function getClassName(moduleName)
	    local lastName = moduleName
	    string.gsub(moduleName, "([^%.]+)" , function (name)
	        lastName = name
	    end)
	    return lastName
	end

	local fileName = name
	class_type._THIS = class_type
    class_type._MNAME = fileName -- module name
    class_type._NAME = getClassName(fileName)
	return class_type, super
end

-- 是否对象实例
function __is_object(obj)
	return type(obj) == "table" and obj._class_type ~= nil
end

-- 获取类名
_reflect_class_name = {}
function __nameOfClass(class_type)
	if _reflect_class_name[class_type] then
		return _reflect_class_name[class_type]
	end

	for k, v in pairs(_G) do
		if class_type == v then
			_reflect_class_name[class_type] = k
			return k
		end
	end

	return nil
end

function __classname(obj)
	if type(obj) ~= "table" or not obj._class_type then return nil end

	return __nameOfClass(obj._class_type)
end

-- 判断类继承关系
function __is_inherit_from(class_type, class_name)
	local cur_class = class_type
	while cur_class ~= nil do
		if __nameOfClass(cur_class) == class_name then
			return true
		end
		cur_class = cur_class.super
	end

	return false
end

-- 判断对象是否指定类(或派生类)的实例
function __is_instance(obj, class_name)
	if type(obj) ~= "table" or not obj._class_type then return false end

	return __is_inherit_from(obj._class_type, class_name)
end

--endregion
