--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"cc.Node")
local WorldMapManager = require("World.WorldMapManager")
local GameUtil = require("Util.GameUtil")

function This:init(army, index, playMode)
	self.m_army = army
	self.m_index = index
	self.m_playMode = playMode
    self.m_csNode = cc.Node:createFromCSFile("GameScene/NodeUI/TeamList.csb")
	self:addChild(self.m_csNode)
	local box = self.m_csNode.bg:getBoundingBox()
	self:setContentSize(box.width,box.height)
	self:setAnchorPoint(0.5, 0.5)
	self.m_csNode:setPosition(box.width/2,box.height/2)

	self:refresh()
end

function This:refresh()
	local role
	local mode = self.m_playMode
	if mode == PlayMode.kWorld then
		role = WorldMapManager:getRole(self.m_army:getOwnerId())
	elseif mode == PlayMode.kWarfare or mode == PlayMode.kWarSingleMultiQueue then
		role = self.m_army
	end

	if role == nil then
		assert(false)
	end
	self.m_csNode.name:setString(role:getName())
	self.m_csNode.team:setString(string.format(Serialize["Battle_ArmyItem_1"],self.m_index))
	self.m_csNode.numeber:setString(string.format(Serialize["Battle_ArmyItem_2"],self.m_army:getTotalHp()))
	--self.m_csNode.numeber:setPositionX(self.m_csNode.name:getContentWidth() + self.m_csNode.name:getPositionX())
end

function This:getArmy()
	return self.m_army
end

function This:setArmy(army,index)
	self.m_index = index
	if self.m_army ~= army then
		self.m_army = army
		self:refresh()
	end
end


--endregion
