--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"Base.BaseModel")
local BattlePlayer = require("Battle.BattlePlayer")
local WorldMapManager = require("World.WorldMapManager")
local Application = require("cc.Application")
local GameUtil = require("Util.GameUtil")

function This:init()
	super.init(self)
	self.m_battleId = 0
	self.m_battleResult = 0
	self.m_cityId = 0
	self.m_attackerInfo = {}
	self.m_defenderInfo = {}

	self.m_startTime = 0
	self.m_endTime = 0
	self.m_prepareRound = {}
	self.m_battleRound = {}
	self.m_attackerHeros = {}
	self.m_defenderHeros = {}
	self.m_roundIndex = 0

	self.m_defenceQueue = {}
	self.m_attackQueue = {}

	self.m_newReportIdList = {}
	self.m_isInBattle = false

	self.m_mapInfoId = 1
	BattlePlayer:init()
end

function This:clear()
	print("清理战斗数据...")
	self.m_battleId = 0
	self.m_battleResult = 0
	self.m_cityId = 0
	self.m_attackerInfo = {}
	self.m_defenderInfo = {}
	self.m_playMode = 0

	self.m_startTime = 0
	self.m_endTime = 0
	self.m_prepareRound = {}
	self.m_battleRound = {}
	self.m_attackerHeros = {}
	self.m_defenderHeros = {}
	self.m_roundIndex = 0

	self.m_defenceQueue = {}
	self.m_attackQueue = {}

	self.m_newReportIdList = {}
	self.m_mapInfoId = 1
	self.m_isInBattle = false
	BattlePlayer:clear()
end

function This:addObserver(observer)
	super.addObserver(self,observer)
end

function This:setBattleId(id)
	self.m_battleId = id
end

function This:getBattleId()
	return self.m_battleId
end

function This:setBattleResult(result)
	print(string.format("设置战斗结果:%d",result))
	self.m_battleResult = result
end

function This:getBattleResult()
	return self.m_battleResult
end

function This:getStartTime()
	return self.m_startTime
end

function This:setStartTime(startTime)
	print("设置战斗起始时间：" .. startTime)
	self.m_startTime = startTime
end

function This:getEndTime()
	return self.m_endTime
end

function This:setEndTime(endTime)
	print("设置战斗结束时间：" .. endTime)
	self.m_endTime = endTime
end

function This:getCityId()
	return self.m_cityId
end

function This:setCityId(cityId)
	self.m_cityId = cityId
end

function This:setDefenceQueue(queue)
	self.m_defenceQueue = {}
	for i , army in ipairs(queue) do
		if army:getOwnerId() > 0 then
			table.insert(self.m_defenceQueue,army)
		end
	end
end

function This:getDefenceQueue()
	local tmp = {}
	for i , army in ipairs(self.m_defenceQueue) do
		if army:getId() ~= self.m_defenderInfo.armyId then
			table.insert(tmp,army)
		end
	end
	return tmp
end

function This:setAttackQueue(queue)
	self.m_attackQueue = {}
	for i , army in ipairs(queue) do
		if army:getOwnerId() > 0 then
			table.insert(self.m_attackQueue,army)
		end
	end
end

function This:getAttackQueue()
	local tmp = {}
	for i , army in ipairs(self.m_attackQueue) do
		if army:getId() ~= self.m_attackerInfo.armyId then
			table.insert(tmp,army)
		end
	end
	return tmp
end

function This:setAttackerInfo(info)
	local t = {}
	t.id = info.id
	t.level = info.level
	t.name = info.name
	t.icon = info.icon
	t.speed = info.speed
	t.initHp = info.force_num_init
	t.leftHp = info.force_num_result
	t.reward = info.reward_list
	t.armyId = info.object_id
	t.drumData = info.drum_data[1]
	self.m_attackerInfo = t
end

function This:getAttackerInfo()
	return self.m_attackerInfo
end

function This:setDefenderInfo(info)
	local t = {}
	t.id = info.id
	t.level = info.level
	t.name = AppText:getServerText(info.name)
	t.icon = info.icon
	t.speed = info.speed
	t.initHp = info.force_num_init
	t.leftHp = info.force_num_result
	t.reward = info.reward_list
	t.armyId = info.object_id
	t.drumData = info.drum_data[1]
	self.m_defenderInfo = t
end

function This:getDefenderInfo()
	return self.m_defenderInfo
end

function This:addRoundData(index,actionList)
	print(string.format("第%d回合数据",index))
	local list = {}
	for i , action in ipairs(actionList) do
		local t = {}
		t.id = action.card_id
		t.heroId = action.card_type
		t.ownerId = action.owner_id
		t.isEnemy = (t.ownerId ~= self.m_attackerInfo.id)
		t.skillId = action.skill_id
		t.buffId = action.buff_id
		t.actionResult = action.action_result
		t.startTime = action.time
		print(string.format("	{id:%d, heroId:%d, isEnemy:%s, skillId:%d, buffId:%d, result:%d , time = %f}",t.id,t.heroId,t.isEnemy,t.skillId,t.buffId,t.actionResult,action.time - self.m_startTime * 1000))
		t.effect = {}
		for j , effect in ipairs(action.effect_list) do
			local e = {}
			e.effectId = effect.effect_id
			e.effectResult = effect.effect_result
			e.target = {}
			for k , target in ipairs(effect.target) do
				local g = {}
				g.skillId = t.skillId
				g.buffId = t.buffId
				g.id = target.target_card_id
				g.heroId = target.target_card_type
				g.ownerId = target.target_owner_id 
				g.isEnemy = (g.ownerId ~= self.m_attackerInfo.id)
				g.effectId = effect.effect_id
				g.effectValue = target.effect_value 
				g.effectFinalValue = target.effect_value_final
				g.effectResult = target.effect_result
				g.hp = target.target_card_force_num
				g.additionalValue = target.additional_effect_value --附加伤害（爵位）
				print(string.format("		{id:%d, heroId:%d, isEnemy:%s, effectId:%d, effectValue:%d, finalValue:%d, result:%d, hp:%d}",g.id,g.heroId,g.isEnemy,g.effectId,g.effectValue,g.effectFinalValue,g.effectResult,g.hp))
				g.behavior = {}
				for l , behavior in ipairs(target.anti) do
					local b = {}
					b.id = behavior.target_card_id
					b.heroId = behavior.target_card_type
					b.ownerId = behavior.target_owner_id
					b.isEnemy = (b.ownerId ~= self.m_attackerInfo.id)
					b.effectId = behavior.effect_id
					b.effectValue = behavior.effect_value
					b.effectResult = behavior.effect_result
					b.hp = behavior.target_card_force_num
					b.sourceId = behavior.source_card_id
					b.sourceHeroId = behavior.source_card_type
					b.sourceOwnerId = behavior.source_owner_id
					b.sourceIsEnemy = (b.sourceOwnerId ~= self.m_attackerInfo.id)
					b.additionalValue = behavior.additional_effect_value --附加伤害（爵位）
					print(string.format("			{id:%d, heroId:%d, isEnemy:%s, effectId:%d, effectValue:%d, result:%d, hp:%d, sourceId:%d, sourceHeroId:%d, sourceIsEnemy:%s}",b.id,b.heroId,b.isEnemy,b.effectId,b.effectValue,b.effectResult,b.hp,b.sourceId,b.sourceHeroId,b.sourceIsEnemy))
					table.insert(g.behavior,b)
				end
				table.insert(e.target,g)
			end
			table.insert(t.effect,e)
		end
		table.insert(list,t)
	end
	self.m_battleRound[index] = list
end

function This:getRoundData(index)
	if index <= #self.m_battleRound then
		return self.m_battleRound[index]
	end
end

function This:addAttackerHero(heroInfo)
	local t = {}
	t.heroId = heroInfo.card_type
	t.level = heroInfo.level
	t.hp = heroInfo.force_num
	t.ownerId = heroInfo.owner_id
	t.pos = heroInfo.init_pos
	t.anger = heroInfo.init_anger
    t.star = heroInfo.star_level
	t.quality = heroInfo.quality
	t.forceType = heroInfo.force_type
	t.forceLv = heroInfo.force_type_level
	t.fight_card_type = heroInfo.fight_card_type
	t.isEnemy = false
	self.m_attackerHeros[t.pos] = t
end

function This:setAttackerHeroAttrList(pos,idList,valueList)
	self.m_attackerHeros[pos].attrList = {}
	for i , attrId in ipairs(idList) do
		assert(valueList[i])
		self.m_attackerHeros[pos].attrList[attrId] = valueList[i]
	end
end

function This:getAttackerHero()
	return self.m_attackerHeros
end

function This:addDefenderHero(heroInfo)
	local t = {}
	t.heroId = heroInfo.card_type
	t.level = heroInfo.level
	t.hp = heroInfo.force_num
	t.ownerId = heroInfo.owner_id
	t.pos = heroInfo.init_pos
	t.anger = heroInfo.init_anger
	t.star = heroInfo.star_level
	t.quality = heroInfo.quality
	t.forceType = heroInfo.force_type
	t.forceLv = heroInfo.force_type_level
	t.fight_card_type = heroInfo.fight_card_type
	t.isEnemy = true
	self.m_defenderHeros[t.pos] = t
end

function This:setDefenderHeroAttrList(pos,idList,valueList)
	self.m_defenderHeros[pos].attrList = {}
	for i , attrId in ipairs(idList) do
		self.m_defenderHeros[pos].attrList[attrId] = valueList[i]
	end
end

function This:getDefenderHero()
	return self.m_defenderHeros
end

------------------------------------------------------------
function This:haveNextBattle()
	return #self.m_newReportIdList > 0
end

function This:addBattle(cityId,reportId,defenceQueue,attackQueue)
	if self.m_playMode ~= PlayMode.kWorld then
		return
	end

	if self.m_isInBattle and self.m_cityId == cityId then
		print("-------BattleDataManager:addBattle------------",cityId,reportId)
		
		if self.m_battleId == reportId then
			local str = Serialize[60468]
			self.m_defenceQueue = {}
			for i , army in ipairs(defenceQueue) do
				table.insert(self.m_defenceQueue,army)
				str = str .. army:getId() .. ","
			end
			str = str .. Serialize[60469]
			self.m_attackQueue = {}
			for i , army in ipairs(attackQueue) do
				table.insert(self.m_attackQueue,army)
				str = str .. army:getId() .. ","
			end
			print(string.format("更新战报:%d,%s",reportId,str))
			self:notifyObservers("onBattleQueueChanged")
			return
		end

		for i , battleQueue in ipairs(self.m_newReportIdList) do
			if battleQueue.reportId == reportId then
				local str = Serialize[60468]
				battleQueue.defenceQueue = {}
				for i , army in ipairs(defenceQueue) do
					table.insert(battleQueue.defenceQueue,army)
					str = str .. army:getId() .. ","
				end
				str = str .. Serialize[60469]
				battleQueue.attackQueue = {}
				for i , army in ipairs(attackQueue) do
					table.insert(battleQueue.attackQueue,army)
					str = str .. army:getId() .. ","
				end
				print(string.format("更新战报:%d,%s",reportId,str))
				self:notifyObservers("onBattleQueueChanged")
				return
			end
		end

		local str = Serialize[60468]
		local tmp = {cityId = cityId,reportId = reportId}
		tmp.defenceQueue = {}
		for i , army in ipairs(defenceQueue) do
			table.insert(tmp.defenceQueue,army)
			str = str .. army:getId() .. ","
		end
		str = str .. Serialize[60469]
		tmp.attackQueue = {}
		for i , army in ipairs(attackQueue) do
			table.insert(tmp.attackQueue,army)
			str = str .. army:getId() .. ","
		end
		table.insert(self.m_newReportIdList,tmp)
		print(string.format("新增战报:%d,%s",reportId,str))
		self:notifyObservers("onBattleQueueChanged")
	end
end

function This:addBattleForWarfare(reportId, defenceQueue, attackQueue, report)
	local mode = self.m_playMode or 0
    if  mode ~= 0 and mode ~= PlayMode.kWarfare and mode ~= PlayMode.kWarSingleMultiQueue then
    	return
    end

	if not self.m_isInBattle and self.m_cityId == 0 then
		print("-------BattleDataManager:addBattle------------",cityId,reportId)
		
		if self.m_battleId == reportId then
			local str = Serialize[60468]
			self.m_defenceQueue = {}
			for i , army in ipairs(defenceQueue) do
				table.insert(self.m_defenceQueue,army)
				str = str .. army:getId() .. ","
			end
			str = str .. Serialize[60469]
			self.m_attackQueue = {}
			for i , army in ipairs(attackQueue) do
				table.insert(self.m_attackQueue,army)
				str = str .. army:getId() .. ","
			end
			print(string.format("更新战报:%d,%s",reportId,str))
			self:notifyObservers("onBattleQueueChanged")
			return
		end

		for i , battleQueue in ipairs(self.m_newReportIdList) do
			if battleQueue.reportId == reportId then
				local str = Serialize[60468]
				battleQueue.defenceQueue = {}
				for i , army in ipairs(defenceQueue) do
					table.insert(battleQueue.defenceQueue,army)
					str = str .. army:getId() .. ","
				end
				str = str .. Serialize[60469]
				battleQueue.attackQueue = {}
				for i , army in ipairs(attackQueue) do
					table.insert(battleQueue.attackQueue,army)
					str = str .. army:getId() .. ","
				end
				print(string.format("更新战报:%d,%s",reportId,str))
				self:notifyObservers("onBattleQueueChanged")
				return
			end
		end

		local str = Serialize[60468]
		local tmp = {cityId = 0,reportId = reportId, report = report}
		tmp.defenceQueue = {}
		for i , army in ipairs(defenceQueue) do
			table.insert(tmp.defenceQueue,army)
			str = str .. army:getId() .. ","
		end
		str = str .. Serialize[60469]
		tmp.attackQueue = {}
		for i , army in ipairs(attackQueue) do
			table.insert(tmp.attackQueue,army)
			str = str .. army:getId() .. ","
		end
		table.insert(self.m_newReportIdList,tmp)
		print(string.format("新增本地战报:%d,%s",reportId,str))
		self:notifyObservers("onBattleQueueChanged")
	end
end

function This:prepareBattle(isImmediate,playMode,mapInfoId)
	self.m_playMode = playMode
	BattlePlayer:prepare(isImmediate,playMode,mapInfoId or 1)
	BattlePlayer:setAttackerInfo(self.m_attackerInfo)
	BattlePlayer:setDefenderInfo(self.m_defenderInfo)
	BattlePlayer:setBattleTime(self.m_startTime,self.m_endTime)
	BattlePlayer:deducteBattle(self.m_battleRound,self.m_attackerHeros,self.m_defenderHeros,isImmediate)	
end

function This:startBattle()
	BattlePlayer:startPlay(self.m_startTime,self.m_endTime)
	self.m_isInBattle = true
end

function This:isWaitNextBattle()
	if self.m_cityId and self.m_cityId > 0 then
		local city = WorldMapManager:getCity(self.m_cityId)
		if city:getState() == CityState.kInFighting then
			return true
		end
	end
	return false
end

function This:nextBattle()
	local mode = self.m_playMode
    if not BattlePlayMultiReport[mode] then
		self:exitBattle()
		return
	end

	local function initNextBattle()
		local tmp = self.m_newReportIdList[1]
		self.m_cityId = tmp.cityId
		self.m_battleId = tmp.reportId
		self.m_defenceQueue = tmp.defenceQueue
		self.m_attackQueue = tmp.attackQueue
		self.m_attackerHeros = {}
		self.m_defenderHeros = {}
		self.m_battleRound = {}
		self.m_offlineReport = tmp.report
		table.remove(self.m_newReportIdList,1)
	end  
	for i, tmp in ipairs(self.m_newReportIdList) do
		print("城池Id:" .. tmp.cityId)
		print("战报Id:" .. tmp.reportId)
		print("使用离线战报:" .. tostring(tmp.report ~= nil))
	end
	if #self.m_newReportIdList > 0 then
		BattlePlayer:pauseBattle()
		initNextBattle()
		local mode = self.m_playMode
		local offline = mode == PlayMode.kWarfare or mode == PlayMode.kWarSingleMultiQueue
		local loadView = g_scene:openDialog("Battle.BattleLoadingView",{reportId = self.m_battleId, offline = self.m_offlineReport})
		loadView:setFinishHandler(function(reportId)
			self:continueBattle()
			self:notifyObservers("onLoadBattleFinish",reportId)
		end)
	elseif self:isWaitNextBattle() then
		BattlePlayer:pauseBattle()
		local loadView = g_scene:openDialog("Battle.BattleLoadingView",{})
		loadView:setFinishHandler(function(reportId)
			self:continueBattle()
			self:notifyObservers("onLoadBattleFinish",reportId)
		end)
		local function checkNextBattle()
			if #self.m_newReportIdList > 0 then
				initNextBattle()
				loadView:setReportId(self.m_battleId)
				return true
			elseif not self:isWaitNextBattle() then
				self:exitBattle()
				return true
			end
		end
		local t = {}
		t.update = function (dt)
			if checkNextBattle() then
				Application:removeFromUpdateList(t)
			end
		end
		Application:addToUpdateList(t)
	else
		self:exitBattle()
	end
end

function This:continueBattle()
	BattlePlayer:setAttackerInfo(self.m_attackerInfo)
	BattlePlayer:setDefenderInfo(self.m_defenderInfo)
	BattlePlayer:deducteBattle(self.m_battleRound,self.m_attackerHeros,self.m_defenderHeros,false)
	BattlePlayer:continuePlay(self.m_startTime,self.m_endTime)
	self.m_isInBattle = true
end

function This:exitBattle(isSkip)
	if not isSkip then
		BattlePlayer:exitBattle()
		self.m_isInBattle = false
		if self.m_battleResult == BattleResult.kAttackerVictory then
			self:notifyObservers("onBattleVictory")
		else
			self:notifyObservers("onBattleFailed")
		end
		self:clear()
	else
		BattlePlayer:exitBattle()
		self:notifyObservers("onBattleSkip",self.m_battleResult)
	end
end

