--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This = class(...)
local SkillCommon = require("Skill.SkillCommon")
local SkillSpecial = require("Skill.SkillSpecial")
local SkillAwaken = require("Skill.SkillAwaken")
local SkillMonster = require("Skill.SkillMonster")
local SkillConfig = require("Metadatas.SkillConfig")
local AttrBuff = require("Skill.AttrBuff")
local ActionEffect = require("Skill.ActionEffect")
local AttributeHelper = require("Battle.AttributeHelper")
local Timer = require("Timer")
local BattlePlayer = require("Battle.BattlePlayer")
local ArmConfig = require("Metadatas.ArmConfig")
local SkillQiJinQiChu = require("Skill.SkillQiJinQiChu")
local EffectTimeConfig = require("Metadatas.EffectTimeConfig")
local LianJiBuff = require("Skill.LianJiBuff")
local BuffConfig = require("Metadatas.BuffConfig")
local SkillPassive = require("Skill.SkillPassive")
local FuHuoBuff = require("Skill.FuHuoBuff")
local MythicalAnimalsAttributeConfig = require("Metadatas.MythicalAnimalsAttributeConfig")

TroopsState =
{
	kFree = 1,
	kForward = 2,
	kAttack = 3,
	kBack = 4,
	kDead = 5,
}

SpecialSkill = 
{
	kQiJinQiChu = 1005, -- 赵云七进七出
}

function This:create(info)
	local o = {}
	setmetatable(o,self)
	o:init(info)
	return o
end

function This:init(info)
	self.m_heroId = info.heroId
	self.m_isEnemy = info.isEnemy
	self.m_index = info.pos
    self.m_star = info.star
    self.m_quality = info.quality
    self.m_soilderId = info.forceType or 0
	self.m_soilderLv = info.forceLv
	self.m_attr = AttributeHelper:create()
	self.m_attr:setAttr(AttrType.kHp,info.hp)
	self.m_attr:setAttr(AttrType.kMaxHp,info.hp)
	self.m_attr:setAttr(AttrType.kAngerValue,info.anger)
	self.m_attr:setAllAttr(info.attrList)
	self.m_fight_card_type = info.fight_card_type

	self.m_id = self.m_isEnemy and 100 + self.m_index or self.m_index
	self.m_y = (self.m_index - 1) % 3 + 1
	local tmp = math.floor((self.m_index - 1) / 3 + 1)
	self.m_x = self.m_isEnemy and tmp or -tmp

	self.m_buffs = {}
	self.m_action = nil
	self.m_view = nil

	self.m_state = TroopsState.kFree
end

function This:getId()
	return self.m_id
end

function This:getHeroId()
	return self.m_heroId
end

function This:getHeroQuality()
	if self.m_quality <= 0 then
		return Quality.kGreen
	end
	return self.m_quality
end

function This:getIndex()
	return self.m_index
end

function This:isEnemy()
	return self.m_isEnemy
end

function This:setView(view)
	self.m_view = view
end

function This:getView()
	return self.m_view
end

function This:getXY()
	return self.m_x, self.m_y
end

function This:getState()
	return self.m_state
end

function This:setState(state)
	self.m_state = state
end

function This:getStar()
	return self.m_star
end

function This:getSkill()
	return self.m_skill
end

function This:setSkill(skill)
	self.m_skill = skill
end

function This:getSoilderId()
	return self.m_soilderId
end

function This:isMonster()
	return self.m_fight_card_type
end

function This:setAction(action)
	self.action = action
end

function This:getAction()
	return self.action
end

function This:getSoilderConfigId()
	local soilderId = self.m_soilderId > 0 and self.m_soilderId or 1
	local soilderLv = self.m_soilderLv > 0 and self.m_soilderLv or 1
	local key = soilderId * 1000 + soilderLv
	return key
end

function This:isAlive()
	return self.m_state ~= TroopsState.kDead
end

function This:setAttr(attrId,value)
	return self.m_attr:setAttr(attrId,value)
end

function This:getAttr(attrId)
	return self.m_attr:getAttr(attrId)
end

function This:addAttr(attrId,value,final,effect)
	local newValue = 0
	if final then
		newValue = self.m_attr:setAttr(attrId,final)
	else
		newValue = self.m_attr:addAttr(attrId,value)
	end

	if attrId == AttrType.kHp and self.m_view then
		self.m_view:showAddHp(value,effect)
	end
	if self.m_soilderId == SoilderType.kSapperCar and attrId == AttrType.kAngerValue then
		assert(true)
	end
	if attrId == AttrType.kAngerValue and self.m_view then
		self.m_view:refreshAnger()
	end
	return newValue
end

function This:reduceAttr(attrId,value,final,effectType,effect)
	local newValue = 0
	if final then
		if value < 0 then
			assert(true)
		end
		local oldValue = self.m_attr:getAttr(attrId)
		newValue = self.m_attr:setAttr(attrId,final)
		if oldValue < newValue then
			assert(true)
		end
		value = oldValue - newValue
	else
		newValue = self.m_attr:reduceAttr(attrId,value)
	end

	if attrId == AttrType.kHp then
		if self.m_view then
			if value > 0 then
				self.m_view:showReduceHp(value,effectType,effect)
			end
		end
		if newValue <= 0 then
			self:dead()
		end
	end

	if attrId == AttrType.kAngerValue and self.m_view then
		self.m_view:refreshAnger()
	end
	return newValue
end

function This:resurgence()
	self.m_attr:setAttr(AttrType.kHp,0)
	self.m_action = nil
	self.m_view = nil
	self.m_state = TroopsState.kFree
end

function This:getBuffs()
	return self.m_buffs
end

function This:lostEffect(effect)
	print("效果失效...")
	if effect.effectResult == 1 then
		print("无法普通攻击")
	elseif effect.effectResult == 2 then
		print("无法释放技能")
	elseif effect.effectResult == 3 then
		print("找不到目标")
	elseif effect.effectResult == 4 then  --无敌
		if self.m_view then
			self.m_view:showImmune()
		end
	end
end

function This:lostAction(action)
	if action.actionResult == 1 then
		print("无法普通攻击")
	elseif action.actionResult == 2 then
		print("无法释放技能")
	elseif action.actionResult == 3 then
		print("找不到目标")
	end
end

function This:applyEffect(effect,troops,hitEndHandler)
	if BattlePlayer:isPlaying() or BattlePlayer:isInPrepare() then
		local action = ActionEffect:create()
		action:work(effect,troops,hitEndHandler)
	end
end

function This:checkKeZhi(attacker)
	local soilderId = attacker:getSoilderId()
	if attacker:isEnemy() ~= self:isEnemy() and  SoilderKeZhi[soilderId] == self:getSoilderId() and self.m_view then
		self.m_view:showKeZhi()
	end
end

function This:forward(x,y,endHandler)
	local finishHandler = function()
		self.m_forwordEndTime = os.clock()
		if endHandler then 
			endHandler() 
		end
	end
	BattlePlayer:onTroopsForward(self,self.m_skill)
	self.m_state = TroopsState.kForward
	if self.m_view then
		self.m_view:forward(x,y,finishHandler)
	else
		finishHandler()
	end
end


function This:attack(targetList,hitHandler,hitEndHandler)
	local finishHandler = function ()
		if hitEndHandler then
			hitEndHandler()
		end
	end
	if self.m_view and self.m_skill:getId() <= 1 then
		self.m_view:attack(hitHandler,finishHandler,targetList)
	else
		hitHandler()
		finishHandler()
	end
	BattlePlayer:onTroopsAttack(self)
end

function This:hitted(effect,troops,hitEndHandler)
	local isBuckle = EffectTimeConfig[effect.effectId].if_buckle
	if self.m_view and isBuckle > 0 then
		self.m_view:hitted()
	end
	self:applyEffect(effect,troops,hitEndHandler)
	if effect.effectResult == 0 then
		self:checkKeZhi(troops)
	end
	BattlePlayer:onTroopsHitted(self)
end

local isFirstWrite = true
function This:back(isNeedBack,endHandler)
	local finishHandler = function ()
		self.m_state = TroopsState.kFree
		BattlePlayer:onTroopsBack(self)
		if endHandler then
			endHandler()
		end
		--[[if os.isWin32 then
			local backEndTime = os.clock()
			local total = ( backEndTime - self.m_attacStartkTime) * 1000
			local active = ( self.m_activeEndTime - self.m_attacStartkTime) * 1000
			local forward = (self.m_forwordEndTime - self.m_attacStartkTime) * 1000
			local attack = (self.m_attackEndTime - self.m_forwordEndTime) * 1000
			local back = (backEndTime - self.m_attackEndTime) * 1000
			local str = string.format(Serialize[60473],self.m_heroId,self.m_skill:getId(),total,active,forward,attack,back)
			local writePath = cc.FileUtils:getWritablePath()
 			writePath = writePath .. "Data/skilltime.txt"
 			local file = nil
 			if isFirstWrite then
 				file = io.open(writePath,"w+")
				isFirstWrite = false
 			else
 				file = io.open(writePath,"a+")
 			end
 			if file then
 				file:write(str.."\n")
 				io.close(file)
 			end
		end]]
	end
	self.m_state = TroopsState.kBack
	local view = self:getView()
	if isNeedBack and view then
		view:back(finishHandler)
	else
		finishHandler()
	end	
end

function This:dead()
	local function deadEndHandler()
		BattlePlayer:removeTroops(self)
	end
	self.m_state = TroopsState.kDead
	print(string.format("部队%d死亡",self.m_id))
	for i, buff in pairs(self.m_buffs) do
		buff:disappear()
	end
	if self.m_view then
		self.m_view:dead(deadEndHandler)
	else
		deadEndHandler()
	end
	BattlePlayer:onTroopsDead(self)
end

function This:castSkill(skillId,effectList,result,action)
	if result == ActionResult.kTakeEffect then
		print(string.format("部队%d(%d)释放技能%d...",self.m_id,self.m_heroId,skillId))
		--self.m_attr:print()
		
		if skillId == 1 then
			self.m_skill = SkillCommon:create()
		elseif SkillConfig[skillId].skill_type == 0 then
			self.m_skill = SkillSpecial:create(skillId)
		elseif SkillConfig[skillId].skill_type == 1 then
			self.m_skill = SkillAwaken:create(skillId)
		elseif SkillConfig[skillId].skill_type == 2 then
			self.m_skill = SkillPassive:create(skillId)
		end

		if MythicalAnimalsAttributeConfig[self.m_heroId] and SkillConfig[skillId].skill_type ~= 2 and skillId ~= 1000 then
			self.m_skill = SkillMonster:create(skillId)
		elseif MythicalAnimalsAttributeConfig[self.m_heroId] and SkillConfig[skillId].skill_type ~= 2 and skillId == 1000 then
			self.m_skill = SkillPassive:create(skillId)
		end

		self.m_skill:setTroops(self)
		self:setAction(action)

		self.m_state = TroopsState.kAttack
		local function activeHandler()
			self.m_activeEndTime = os.clock()
			self.m_skill:work(effectList)
		end
		self.m_attacStartkTime = os.clock()
		self.m_forwordEndTime = self.m_attacStartkTime
		self.m_skill:active(activeHandler)
		BattlePlayer:onSkillActived(self,self.m_skill,effectList)
	else
		print(string.format("技能失效,失效ID:%d",result))
	end
end

function This:generateBuff(effect)
	local buffId = effect.effectValue
	if self:isAlive() and not self.m_buffs[buffId] then
		local buff = nil
		local effectType = EffectTimeConfig[BuffConfig[buffId].effect_id].effect_type
		if effectType == EffectType.kLianJi then
			buff = LianJiBuff:create(buffId)
		elseif effectType == EffectType.kFuHuo then
			buff = FuHuoBuff:create(buffId)
		else
			buff = AttrBuff:create(buffId)
		end
		print(string.format("部队%d,BUFF:%d出现,是否持续:%s...",self.m_id, buffId,tostring(buff:isContinuous())))
		buff:setTroops(self)
		buff:appear(effect)
		self.m_buffs[buffId] = buff
	end
end

function This:updateBuff(buffId,effectList,result)
	local buff = self.m_buffs[buffId]
	if buff == nil then
		print(string.format("找不到部队%d身上的BUFF:%d",self.m_id,buffId))
		return
	end
	if result == ActionResult.kBuffDisappear then
		print(string.format("部队%d,BUFF:%d消失...",self.m_id,buffId))
		buff:disappear()
		self.m_buffs[buffId] = nil
	elseif result == ActionResult.kTakeEffect then
		print(string.format("部队%d,BUFF:%d生效...",self.m_id,buffId))
		buff:work(self,effectList)
		BattlePlayer:onBuffActived(self,buff,effectList)
	elseif result == ActionResult.kTargetWuDi or result == ActionResult.kNoTarget then
		print(string.format("部队%d,BUFF:%d失效...",self.m_id,buffId))
	end
end

function This:performAction(action)
	self.m_action = action
	if action.skillId > 0 then
		if action.actionResult == 0 then
			self:castSkill(action.skillId, action.effect, action.actionResult,action)
		else
			self:lostAction(action)
		end
	else	
		self:updateBuff(action.buffId, action.effect, action.actionResult)
	end
end


--endregion
