--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This = class(...)

TargetSearchType=
{
	kOtherSideSingle = 1,  --敌方单体
	kOtherSideAll = 2,  --地方所有
	kOtherSideFrontRow = 3,  --敌方前排
	kOtherSideVertical = 4, --敌方竖排
	kOtherSideBackRow = 5, --地方后排
	kOtherSideRandomOne = 6, --随机一个
	kOtherSideRandomTwo = 7, --随机两个
	kOtherSideRandomThree = 8, --随机三个
	kOtherSideMinHp = 9, --敌方血量最少的
	kOtherSideMaxHp = 10, --敌方血量最多的
	kSelfSideMyself = 11, --自己
	kSelfSideMinHp = 12 , --己方血量最少的
	kSelfSideMaxHp = 13 , --己方血量最多的
	kSelfSideAll = 14, --己方全体
	kSelfSideBackRow = 15, --己方后排
	kSelfSideVertical = 16, --己方竖排
	kSelfSideFrontRow = 17, --己方前排
	kOtherSideMaxPower = 18, --敌方武力最高
	kOtherSideMinPower = 19, --敌方武力最低
	kOtherSideMaxIntelligence = 20, --敌方最高智力
	kOtherSideMinIntelligence = 21, --敌方最低智力
	kSelfSideMaxPower = 22, --我方武力最高
	kSelfSideMaxIntelligence = 23, --我方智力最高
}

local function otherSideSingle(x,y,gameScene)  --单体
	local isEnmey = x > 0 and true or false
	local troops = gameScene:getAllTroops(not isEnmey)
	local minDist = 0xff
	local target = nil
	for i , tp in pairs(troops) do
		if tp:isAlive() then
			local dist = math.abs(tp:getX()-x)  + math.abs(tp:getY()-y)
			if dist < minDist then
				minDist = dist
				target = tp
			elseif dist == minDist then
				if target:getY() ~= y and (tp:getY() == y or tp:getY() > target:getY()) then
					target = tp
				end
			end
		end
	end
	return {target} 
end

local function otherSideAll(x,y,gameScene)  --说有
	local isEnmey = x > 0 and true or false
	local troops = gameScene:getAllTroops(not isEnmey)
	local result = {}
	for i , tp in pairs(troops) do
		if tp:isAlive() then
			table.insert(result,tp)
		end
	end
	return result 
end

local function otherSideFrontRow(x,y,gameScene)  --横排
	local isEnmey = x > 0 and true or false
	local troops = gameScene:getAllTroops(not isEnmey)
	local result = {}
	for i , tp in pairs(troops) do
		if tp:isAlive() then
			local x = math.abs(tp:getX())
			result[x] = result[x] or {}
			table.insert(result[x],tp)
		end
	end
	local index = 0xfffff
	for i , r in pairs(result) do
		if i < index then
			index = i
		end
	end
	return result[index] or {} 
end

local function otherSideVertical(x,y,gameScene)  --竖排
	local isEnmey = x > 0 and true or false
	local troops = gameScene:getAllTroops(not isEnmey)
	local result = {}
	for i , tp in pairs(troops) do
		if tp:isAlive() then
			local y = tp:getY()
			result[y] = result[y] or {}
			table.insert(result[y],tp)
		end
	end
	if result[y] then
		return result[y]
	else
		local minDist , index = 0xff, nil
		for i , r in pairs(result) do
			local dist = math.abs(i - y)
			if dist < minDist then
				minDist = dist
				index = i
			elseif dist == minDist and i > index then
				index = i
			end
		end
		return result[index] or {} 
	end
end

local function otherSideBackRow(x,y,gameScene)  --后排
	local isEnmey = x > 0 and true or false
	local troops = gameScene:getAllTroops(not isEnmey)
	local result = {}
	for i , tp in pairs(troops) do
		if tp:isAlive() then
			local x = math.abs(tp:getX())
			result[x] = result[x] or {}
			table.insert(result[x],tp)
		end
	end
	local index = 0
	for i , r in pairs(result) do
		if i > index then
			index = i
		end
	end
	return result[index] or {} 
end

local function otherSideRandom(troops,n)
	local temp = {}
	for i , tp in pairs(troops) do
		if tp:isAlive() then
			table.insert(temp,tp)
		end
	end
	if #temp <= n then
		return temp
	end

	local result = {}
	while n > 0 do
		local index = math.random(1,#temp)
		table.insert(result,temp[index])
		table.remove(temp,index)
		n = n - 1
	end
	return result
end

local function otherSideRandomOne(x,y,gameScene) --随机一个
	local isEnmey = x > 0 and true or false
	local troops = gameScene:getAllTroops(not isEnmey)
	return otherSideRandom(troops,1)
end

local function otherSideRandomTwo(x,y,gameScene) --随机两个
	local isEnmey = x > 0 and true or false
	local troops = gameScene:getAllTroops(not isEnmey)
	return otherSideRandom(troops,2)
end

local function otherSideRandomThree(x,y,gameScene)  --随机三个
	local isEnmey = x > 0 and true or false
	local troops = gameScene:getAllTroops(not isEnmey)
	return otherSideRandom(troops,3)
end

local function otherSideMinHp(x,y,gameScene) --敌方血量最少
	local isEnmey = x > 0 and true or false
	local troops = gameScene:getAllTroops(not isEnmey)
	local target , minHp = nil , 0xfffffff
	for i , tp in pairs(troops) do
		if tp:isAlive() then
			local hp = tp:getAttr(AttrType.kHp)
			if hp < minHp then
				minHp = hp
				target = tp
			end
		end
	end
	return {target}
end

local function otherSideMaxHp(x,y,gameScene) --敌方血量最多的
	local isEnmey = x > 0 and true or false
	local troops = gameScene:getAllTroops(not isEnmey)
	local target , maxHp = nil , 0
	for i , tp in pairs(troops) do
		if tp:isAlive() then
			local hp = tp:getAttr(AttrType.kHp)
			if hp > maxHp then
				maxHp = hp
				target = tp
			end
		end
	end
	return {target}
end

local function myself(x,y,gameScene)  --自己
	local isEnmey = x > 0 and true or false
	local troops = gameScene:getAllTroops(isEnmey)
	for i , tp in pairs(troops) do
		if tp:getX() == x and tp:getY() == y then
			return {tp}
		end
	end
	return {}
end

local function selfSideMinHp(x,y,gameScene)  --己方血量最少的
	local isEnmey = x > 0 and true or false
	local troops = gameScene:getAllTroops(isEnmey)
	local target , minHp = nil, 0xffffff
	for i , tp in pairs(troops) do
		if tp:isAlive() then
			local hp = tp:getAttr(AttrType.kHp)
			if hp < minHp then
				target = tp
				minHp = hp
			end
		end
	end
	return {target}
end

local function selfSideMaxHp(x,y,gameScene) --己方血量最多的
	local isEnmey = x > 0 and true or false
	local troops = gameScene:getAllTroops(isEnmey)
	local target , maxHp = nil , 0
	for i , tp in pairs(troops) do
		if tp:isAlive() then
			local hp = tp:getAttr(AttrType.kHp)
			if hp > maxHp then
				target = tp
				maxHp = hp
			end
		end
	end
	return {target}
end

local function selfSideAll(x,y,gameScene)  --己方全体
	local isEnmey = x > 0 and true or false
	local troops = gameScene:getAllTroops(isEnmey)
	local result = {}
	for i, tp in pairs(troops) do
		if tp:isAlive() then
			table.insert(result,tp)
		end
	end
	return result
end

local function selfSideBackRow(x,y,gameScene) --己方后排
	local isEnmey = x > 0 and true or false
	local troops = gameScene:getAllTroops(isEnmey)
	local result = {}
	for i , tp in pairs(troops) do
		if tp:isAlive() then
			local x = math.abs(tp:getX())
			result[x] = result[x] or {}
		end
	end

	local index = 0
	for i , tp in pairs(result) do
		if math.abs(i) > math.abs(index) then
			index = i
		end
	end
	if result[index] then
		return result[index]
	end
	return result
end

local function selfSideVertical(x,y,gameScene)  --己方竖排
	local isEnmey = x > 0 and true or false
	local troops = gameScene:getAllTroops(isEnmey)
	local result = {}
	for i , tp in pairs(troops) do
		if tp:isAlive() then
			local y = tp:getY()
			result[y] = result[y] or {}
			table.insert(result[y],tp)
		end
	end

	if result[y] then
		return result[y]
	else
		local index , minDist = 0 , 0xffff
		for i , tp in pairs(result) do
			local dist = math.abs(i - y)
			if dist < minDist  then
				index = i
				minDist = dist
			elseif dist == minDist and i > index then
				index = i
			end
		end
		if result[index] then
			return result[index]
		end
	end
	return result
end	

local function selfSideFrontRow(x,y,gameScene) --己方前排
	local isEnmey = x > 0 and true or false
	local troops = gameScene:getAllTroops(isEnmey)
	local result = {}
	for i , tp in pairs(troops) do
		if tp:isAlive() then
			local x = tp:getX()
			result[x] = result[x] or {}
			table.insert(result[x],tp)
		end
	end
	local index = 0xffff
	for i , r in pairs(result) do
		if math.abs(i) < math.abs(index) then
			index = i
		end
	end
	if result[index] then
		return result[index]
	end
	return result
end


local function getMaxAttrValueTroops(isEnmey,attrId,gameScene)
	local troops = gameScene:getAllTroops(isEnmey)
	local target = nil
	for i ,  tp in pairs(troops) do
		if target == nil then
			target = tp
		elseif tp:isAlive() and tp:getAttr(attrId) > target:getAttr(attrId) then
			target = tp
		end
	end
	return {target}
end

local function getMinAttrValueTroops(isEnmey,attrId,gameScene)
	local troops = gameScene:getAllTroops(isEnmey)
	local target = nil
	for i ,  tp in pairs(troops) do
		if target == nil then
			target = tp
		elseif tp:isAlive() and tp:getAttr(attrId) < target:getAttr(attrId) then
			target = tp
		end
	end
	return {target}
end

local function otherSideMaxPower(x, y,gameScene) --敌方武力最高
	local isEnmey = x > 0 and true or false
	return getMaxAttrValueTroops(not isEnmey,AttrType.kPower,gameScene)
end

local function otherSideMinPower(x,y,gameScene) --敌方武力最低
	local isEnmey = x > 0 and true or false
	return getMinAttrValueTroops(not isEnmey,AttrType.kPower,gameScene)
end

local function otherSideMaxIntelligence(x,y,gameScene) --敌方最高智力
	local isEnmey = x > 0 and true or false
	return getMaxAttrValueTroops(not isEnmey,AttrType.kIntelligence,gameScene)
end

local function otherSideMinIntelligence(x,y,gameScene) --敌方最低智力
	local isEnmey = x > 0 and true or false
	return getMinAttrValueTroops(not isEnmey,AttrType.kIntelligence,gameScene)
end

local function selfSideMaxPower(x,y,gameScene) --我方武力最高
	local isEnmey = x > 0 and true or false
	return getMaxAttrValueTroops(isEnmey,AttrType.kPower,gameScene)
end

local function selfSideMaxIntelligence(x,y,gameScene) --我方智力最高
	local isEnmey = x > 0 and true or false
	return getMaxAttrValueTroops(isEnmey,AttrType.kIntelligence,gameScene)
end

function This:create()
	local s = {}
	setmetatable(s,self)
	s:init()
	return s
end

function This:init()
	self.m_func = {}
	self.func = 
	{
		[TargetSearchType.kOtherSideSingle] = otherSideSingle,
		[TargetSearchType.kOtherSideAll] = otherSideAll,
		[TargetSearchType.kOtherSideFrontRow] = otherSideFrontRow, 
		[TargetSearchType.kOtherSideVertical] = otherSideVertical,
		[TargetSearchType.kOtherSideBackRow] = otherSideBackRow, 
		[TargetSearchType.kOtherSideRandomOne] = otherSideRandomOne, 
		[TargetSearchType.kOtherSideRandomTwo] = otherSideRandomTwo,
		[TargetSearchType.kOtherSideRandomThree] = otherSideRandomThree, 
		[TargetSearchType.kOtherSideMinHp] = otherSideMinHp, 
		[TargetSearchType.kOtherSideMaxHp] = otherSideMaxHp, 
		[TargetSearchType.kSelfSideMyself] = myself, 
		[TargetSearchType.kSelfSideMinHp] = selfSideMinHp ,
		[TargetSearchType.kSelfSideMaxHp] = selfSideMaxHp , 
		[TargetSearchType.kSelfSideAll] = selfSideAll, 
		[TargetSearchType.kSelfSideBackRow] = selfSideBackRow, 
		[TargetSearchType.kSelfSideVertical] = selfSideVertical, 
		[TargetSearchType.kSelfSideFrontRow] = selfSideFrontRow, 
		[TargetSearchType.kOtherSideMaxPower] = otherSideMaxPower,
		[TargetSearchType.kOtherSideMinPower] = otherSideMinPower,
		[TargetSearchType.kOtherSideMaxIntelligence] = otherSideMaxIntelligence,
		[TargetSearchType.kOtherSideMinIntelligence] = otherSideMinIntelligence,
		[TargetSearchType.kSelfSideMaxPower] = selfSideMaxPower,
		[TargetSearchType.kSelfSideMaxIntelligence] = selfSideMaxIntelligence
	}
end

function This:search(searchId,x,y,gameScene)
	if self.func[searchId] then
		return self.func[searchId](x,y,gameScene)
	end
	assert(false,"can not find the search func,the search id is wrong")
	return {}
end


--endregion
