--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"Battle.TroopsView")
local ArrowNode = require("Obj.ArrowNode")

function This:castArrow()
	local callbackCount , callbackTotal = 0 , 0
	local w , h = self:getContentSize()
	local x , y = self:getPosition()
	for j = 1 , self:getSoilderCount() do
		local ax , ay = self:getSoilderAttackFormat(j)
		self.m_soilders[j]:setPosition(ax , ay)
		local bx , by = x + ax , y + ay

		if self.m_attackTarget == nil then
			assert(false)
		end

		local view = self.m_attackTarget:getView()
		-- local ex , ey = view:getPosition()
		local ex,ey = cc.visible.center.x,cc.visible.center.y
		if view then
			ex , ey = view:getPosition()
		else
			-- print("")
			local model = self:getModel()
			if model then
				local sceneConfig = self.m_scene:getMapConfig()
				local id = model:getId()
				if id and sceneConfig.troop[id] then

					print("id=============="..id .. ">>>>>>>>>>>>>>===="..sceneConfig.troop[id].x.."<<<<<<<<<<<>>>>>>>>>======="..sceneConfig.troop[id].y)

					local posX,posY = cc.visible.center.x + sceneConfig.troop[id].x - 480 , cc.visible.center.y + sceneConfig.troop[id].y - 270
					ex , ey = posX,posY
				end
			end
		end
		ex , ey = ex - x + bx , ey - y + by
		local node = cc.Sprite:create("WarScene/Buttlet.png")
		node:setAnchorPoint(0.5,0.5)
		local time = kGongBingComAttackTime -- math.abs(ex - bx) / 800
		local arrowNode = ArrowNode:create({
			bx = bx,
			by = by,
			ex = ex,
			ey = ey,
			time = time,
			av = 2100,
			node = node
		})
		callbackCount = callbackCount + 1
		arrowNode:setEndHandler(function ()
			callbackCount = callbackCount - 1
			if callbackCount <= 0 then
				if self.m_hitHandler then
					self.m_hitHandler()
					self.m_hitHandler = nil
				end
				if self.m_attackEndHandler then
					self.m_attackEndHandler()
					self.m_attackEndHandler = nil
				end
				self.m_scene:shake(5,5,0.05)
				self.m_attackTarget = nil
			end
			local cx , cy = self:getSoilderStandFormat(j)
			self.m_soilders[j]:setPosition(cx, cy)
		end)
		self.m_scene:addEffect(arrowNode)
	end
	callbackTotal = callbackCount
end

function This:attack(hitHandler,attackEndHandler,targetList)
	self.m_attackTarget = targetList[1]
	if self.m_attackTarget and self.m_attackTarget:isEnemy() ~= self.m_model:isEnemy() then
		super.attack(self,hitHandler,attackEndHandler,targetList)
	else
		hitHandler()
		attackEndHandler()
	end
end

function This:onAnimationEvent(animationName,eventName)
    if animationName == StateName.ATTACK and eventName == EventName.FIRE then
		self.m_model.m_forwardEndTime = os.clock()
		self:castArrow()
		local soilderId = self.m_model:getSoilderId()
		cc.Audio:playEffect(SoilderAttackSound[soilderId])
    end
end

function This:onAnimationComplete(animationName,eventName)
	if animationName == StateName.ATTACK then
		self:playAnimation(StateName.STAND,true)
	elseif animationName == StateName.HITTED then
		self:playAnimation(StateName.STAND,true)
	end
end

--endregion
