--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"Battle.TroopsView")
local ArrowNode = require("Obj.ArrowNode")
local GameUtil = require("Util.GameUtil")

function This:castArrow()
	local callbackCount, callbackTotal = 0,0
	local function arrowEndHandler ()
		callbackCount = callbackCount - 1
		local bomoEffect = nil
		bomoEffect = GameUtil:createEffect("Bomb2",true,nil,{
			onAnimationComplete = function (_,animationName,animationEvent)
				if callbackCount <= 0 then
					if self.m_attackEndHandler then
						self.m_attackEndHandler()
						self.m_attackEndHandler = nil
					end
					self.m_attackTarget = nil
				end
				bomoEffect:removeFromParent()
			end,
			onAnimationEvent = function (_,animationName,animationEvent)
				if animationEvent == "Fire" then
					if self.m_hitHandler then
						self.m_hitHandler(callbackTotal,callbackTotal - callbackCount)
						self.m_hitHandler = nil
					end
					self.m_scene:shake(5,10,0.1)
				end
			end
		})
		local targetView = self.m_attackTarget:getView()
		local ex , ey = targetView:getHittedPoinit()
		bomoEffect:setPosition(ex,ey)
		self.m_scene:addEffect(bomoEffect)
	end
	local x , y = self:getPosition()
	for j = 1 , self:getSoilderCount() do
		local ax , ay = self:getSoilderStandFormat(j)
		local bx , by = x + ax , y + ay

		if not self.m_attackTarget then
			arrowEndHandler()
		end

		local view = self.m_attackTarget:getView()
		-- local ex , ey = view:getPosition()

		local ex,ey = cc.visible.center.x,cc.visible.center.y
		if view then
			ex , ey = view:getPosition()
		end
		
		ex , ey = ex - x + bx , ey - y + by

		local node = GameUtil:createEffect("ChuFa5",true,nil,nil,self.m_attackTarget:isEnemy())
		local time = kCheBingComAttackTime --math.abs(ex - bx) / 800
		local arrowNode = ArrowNode:create({
			bx = bx,
			by = by,
			ex = ex,
			ey = ey,
			time = time,
			delay = (j-1) * 0.1,  --炮弹发射间隔
			av = 7000,
			node = node
		})
		callbackCount = callbackCount + 1
		arrowNode:setEndHandler(arrowEndHandler)
		self.m_scene:addEffect(arrowNode)
	end
	callbackTotal = callbackCount
end

function This:attack(hitHandler,attackEndHandler,targetList)
	self.m_attackTarget = targetList[1]
	if self.m_attackTarget and self.m_attackTarget:isEnemy() ~= self.m_model:isEnemy() then
		super.attack(self,hitHandler,attackEndHandler,targetList)
	else
		hitHandler()
		attackEndHandler()
	end
end

function This:onAnimationEvent(animationName,eventName)
    if animationName == StateName.ATTACK and eventName == EventName.FIRE then
		self.m_model.m_forwardEndTime = os.clock()
		self:castArrow()
		local soilderId = self.m_model:getSoilderId()
		cc.Audio:playEffect(SoilderAttackSound[soilderId])
    end
end

function This:onAnimationComplete(animationName,eventName)
	if animationName == StateName.ATTACK then
		self:playAnimation(StateName.STAND,true)
	elseif animationName == StateName.HITTED then
		self:playAnimation(StateName.STAND,true)
	end
end

--endregion
