--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"Battle.TroopsActor")
local Timer = require("Timer")

BehaviorType =
{
	kNone = 1,
	kCrit = 2,
	kDodge = 3,
	kPenetrate = 4,
	kImmuneDamage = 5,
}

function This:init(info)
	super.init(self,info)
	self.m_playAttackData = {}
	self.m_playHittedData = {}
	self.m_view = nil
	self.m_state = TroopsState.STAND
	self.m_timer = Timer:create(self)
end

function This:setView(view)
	self.m_view = view
end

function This:getView()
	return self.m_view
end

 function This:crit()
	print(self.m_id, "暴击...")
	self.m_gameScene:onTroopsCrit(self)
end

function This:dodge()
	print(self.m_id, "闪避...")
	if self.m_view then
		self.m_view:showDodge()
	end
	self.m_gameScene:onTroopsDodge(self)
end

function This:penetrate()
	print(self.m_id, "识破...")
	if self.m_view then
		self.m_view:showPenetrate()
	end
	self.m_gameScene:onTroopsPenetrate(self)
end

function This:immuneDamage()
	print(self.m_id, "免疫伤害...")
	self.m_gameScene:onTroopsImmuneDamage(self)
end

function This:immuneDebuff()
	print(self.m_id, "免疫debuff...")
	if self.m_view then
		self.m_view:showImmune()
	end
	self.m_gameScene:onTroopsImmuneDebuff(self)
end

function This:commonAttackFailed()
	print("普攻失败...")
end

function This:skillCastFailed()
	print("技能释放失败...")
end

function This:getPlayAttackData()
	return self.m_playAttackData
end

function This:setPlayAttackData(data)
	self.m_playAttackData = data
end

function This:getPlayHittedData()
	return self.m_playHittedData
end

function This:setPlayHittedData(data)
	self.m_playHittedData = data
end

function This:getSkillTargets(searchId)
	local targets = {}
	local attackData = self.m_playAttackData
	for i , info in pairs(attackData.hitters) do
		local hitter = self.m_gameScene:getTroopsById(info.id)
		table.insert(targets,hitter)
	end
	return targets
end

function This:getSkillBuffs()
	local buffs = {}
	for i , info in pairs(self.m_playAttackData.buffs) do
		table.insert(buffs,info.id)
	end
	return buffs
end

function This:getBuffTargets(buffId)
	local targets = {}
	local attackData = self.m_playAttackData
	for i , info in pairs(attackData.buffs) do
		if info.id == buffId then
			for k , targetId in pairs(info.targets) do
				local target = self.m_gameScene:getTroopsById(targetId)
				table.insert(targets,target)
			end
		end
	end
	return targets
end

-------------------------------------------------------

function This:checkSkill()
	if self.m_playAttackData.skillId == self.m_skills[0]:getId() then
		return self.m_skills[0]
	end
	if self.m_playAttackData.skillId == self.m_skills[1]:getId() then
		return self.m_skills[1]
	end
end

function This:useSkill(skill)
	if skill then
		self.m_gameScene:onTroopsActiveSkill(self,skill)
		print(string.format("部队%d激活技能%d(0表示普攻)",self.m_id,skill:getId()))
		skill:active(function ()
			skill:work()
		end)
		self.m_curSkill = skill
	else
		local finishHandler = function()
			self.m_state = TroopsState.STAND
			self.m_gameScene:onTroopsBackEnd(self)
		end
		self.m_view:hitted(0,finishHandler)
	end
end

function This:forward(x, y, endHandler)
	if x == nil or y == nil then
		if endHandler then endHandler() end
		return
	end

	local finishHandler = function()
		self.m_gameScene:onTroopsForwardEnd(self)
		self.m_state = TroopsState.STAND
		if endHandler then 
			endHandler() 
		end
	end
	self.m_state = TroopsState.FORWARD
	self.m_view:forward(x,y,finishHandler)
end

function This:attack(target,hitHandler,attackEndHandler)
	local finishHandler = function ()
		self.m_state = TroopsState.STAND
		self.m_gameScene:onTroopsAttackEnd(self)
		if attackEndHandler then
			attackEndHandler()
		end
	end

	self.m_state = TroopsState.ATTACK
	self.m_gameScene:onTroopsAttack(self,target)
	self.m_view:attack(hitHandler,finishHandler)
end

function This:checkCrit()
	local attackData = self:getPlayAttackData()
	if attackData.behavior == BehaviorType.kCrit then
		return true
	end
	return false
end

function This:checkHitted(damageType)  --检查是否被技能命中
	if self.m_attribute:IsImmuneDamage() then
		self:immuneDamage()
		return false
	else
		if damageType == DamageType.kPhyDamage then
			if self.m_playHittedData.behavior == BehaviorType.kDodge then
				self:dodge()
				return false
			end
		elseif damageType == DamageType.kMagicDamage then
			if self.m_playHittedData.behavior == BehaviorType.kPenetrate then
				self:penetrate()
				return false
			end
		end
	end
	return true
end

function This:hitted(damage,damageType,endHandler,isCrit)
	local isHitted , finalDamage, leftHp = self:getHitted(damage,damageType)
	if leftHp > 0 then
		local finishHandler = function()
			self.m_state = TroopsState.STAND
			self.m_gameScene:onTroopsHittedEnd(self)
			if hitEndHandler then
				hitEndHandler()
			end
		end
		if isHitted and damage > 0 then
			self.m_view:hitted(finalDamage,finishHandler,isCrit)
		else
			finishHandler()
		end
	else
		self:dead(finalDamage + leftHp)
		if endHandler then
			endHandler()
		end
	end
end

function This:back(isToOrigin,endHandler)
	local finishHandler = function ()
		self.m_state = TroopsState.STAND
		self.m_gameScene:onTroopsBackEnd(self)
		if endHandler then
			endHandler()
		end
	end
	self.m_state = TroopsState.BACK
	if isToOrigin then
		local view = self:getView()
		if view then
			view:back(finishHandler)
		end
	else
		finishHandler()
	end
end

function This:dead(damage,deadEndHandler)
	local finishHandler = function ()
		self:removeSkills()
		self:removeAllBuffs()
		self.m_gameScene:onTroopsDeadEnd(self)
		if deadEndHandler then
			deadEndHandler()
		end
	end
	print(string.format("部队%d死亡",self.m_id))
	self.m_state = TroopsState.DEAD
	self.m_gameScene:onTroopsDead(self,damage)
	self.m_view:dead(damage,finishHandler)
end

function This:update(dt)
	self.m_timer:update(dt)
	for id, skill in pairs(self.m_skills) do
		skill:update(dt)
	end
	for id , buff in pairs(self.m_buffs) do
		buff:update(dt)
	end
end

--endregion
