--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"Battle.TroopsView")
local ArrowNode = require("Obj.ArrowNode")
local Timer = require("Timer")
local BattlePlayer = require("Battle.BattlePlayer")
local BattleSceneConfig = require("Metadatas.BattleSceneConfig")
local BattleSoilderConfig = require("Metadatas.BattleSoilderConfig")

function This:init(troop)
	self.m_scene = g_scene
	self.m_model = troop
	self.m_soilders = {}
	self.m_timer = Timer:create(self)
	self.m_effectNodes = {}
	local mapInfoId = BattlePlayer:getMapInfoId()
	local soilderId = BattleSceneConfig[mapInfoId].soilder[5]
	self.m_config = BattleSoilderConfig[soilderId]
end

function This:initCharactor()
	self.m_soilderNode = cc.Node:create()
	self:addChild(self.m_soilderNode)
	self.m_soilderNode:setCascadeOpacityEnabled(true)
	local id = self.m_model:getId()

	for i , info in ipairs(self.m_config.stand_format) do
		local skeletonNode = cc.SkeletonNode:createCharacter("GongBing4")
		skeletonNode:scheduleUpdate()
		skeletonNode:playAnimation(StateName.STAND, true)
		if i == kWallSoilderCount then
			skeletonNode:setAnimationListener(self)
		end
		
		skeletonNode:setFlippedX(true)
		skeletonNode:setPosition(info.x, info.y)
		skeletonNode:setAnchorPoint(0.5,0.5)
		skeletonNode:setScale(info.scale)

		self.m_soilderNode:addChild(skeletonNode)
		self.m_soilders[i] = skeletonNode
	end
end

function This:getHittedPoinit()
	return self:getPosition()
end

function This:getSoilderConfigPosition()
	return self:getPosition()
end

function This:getAttackPoint(attackerView)
	local x , y = self:getPosition()
	return x - self.m_config.attack_point.x, y + self.m_config.attack_point.y
end

function This:refresh()
	
end

function This:refreshAnger()

end

function This:attack(target,attackEndHandler)
	self.m_attackEndHandler = attackEndHandler
	self.m_target = target
	self:playAnimation(StateName.ATTACK,false)
end

function This:castArrow()
	local callbackCount = 0
	local function arrowEndHandler ()
		callbackCount = callbackCount - 1
		assert(self.m_attackEndHandler)
		if callbackCount <= 0 and self.m_attackEndHandler then
			self.m_attackEndHandler()
			self.m_target = nil
			self.m_attackEndHandler = nil
		end
	end
	local x , y = self:getPosition()
	for i , target in pairs(self.m_target) do
		local index = target:getIndex()
		for j = 1 , 9 do
			local bx = WallSoilderPosition[index].x + x - ((j % 1.5 == 0) and 5 * j or -5 * j)
			local by = WallSoilderPosition[index].y + y + ((j % 1.5 == 0) and 5 * j or -5 * j)
			local view = target:getView()
			local ex = view:getPositionX() -  ((j % 1.5 == 0) and 3 * j or -3 * j)
			local ey = view:getPositionY() +  ((j % 1.5 == 0) and 3 * j or -3 * j)
			local node = cc.Sprite:create("WarScene/Buttlet.png")
			node:setScale(0.75)
			local arrow = ArrowNode:create({
				bx = bx,
				by = by,
				ex = ex,
				ey = ey,
				time = kWallSoilderComAttackTime,
				av = 5000,
				node = node
			})
			callbackCount = callbackCount + 1
			arrow:setEndHandler(arrowEndHandler)
			self.m_scene:addEffect(arrow)
		end
	end
end

function This:onAnimationEvent(animationName,eventName)
    if animationName == StateName.ATTACK and eventName == EventName.FIRE then
		self:castArrow()
		cc.Audio:playEffect("Atk_Gong.mp3")
    end
end

function This:onAnimationComplete(animationName,eventName)
	if animationName == StateName.ATTACK then
		self:playAnimation(StateName.STAND,true)
	elseif animationName == StateName.HITTED then
		self:playAnimation(StateName.STAND,true)
	end
end

--endregion
