-- @Author: Su
-- @Date:   2019-07-16 17:33:33
-- @Last Modified by:   Su
-- @Last Modified time: 2019-07-16 17:33:33
-- @File Name: BossBtn.lua
-- @Description: 

local This, super = class(..., "Home.MenuButton")
local PrincipalBossManager = require("Boss.PrincipalBossManager")
local GamePlayer = require("Player.GamePlayer")

function This:init(config)
    super.init(self, config)
    self.m_isOpen = true
end

function This:initTouchEvent()
    self:setTouch({
		onEnded = function()
	        g_scene:openDialog("Boss.PrincipalBossPanel", {}) 
		end,
		isScale = false
	})
end

function This:addCustomListener()
    super.addCustomListener(self)
    PrincipalBossManager:addObserver(self)
end

function This:removeCustomListener()
	PrincipalBossManager:removeObserver(self)
    super.removeCustomListener(self)
end

function This:getDefaultVisible()
    return GamePlayer:getLevel() >= 55 
end
