-- @Author: Su
-- @Date:   2019-06-29 15:20:32
-- @Last Modified by:   Su
-- @Last Modified time: 2019-06-29 15:20:32
-- @File Name: ItemBuyPanel.lua
-- @Desc: BOSS

local This, super = class(...,"Dialog")
local DepotManager = require("Depot.DepotManager")
local ItemNode = require("UI.ItemNode")
local PrincipalBossManager = require("Boss.PrincipalBossManager")
local ItemUtil = require("Bag.ItemUtil")
local ArgConfig = require("Metadatas.ArgConfig")


function This:initNode(info)
    self.m_itemId = info.itemId or 306
    self.m_costId = info.costId or 102
    self.m_count = 0
    self.m_buyNum = 1
    self.m_buyTimes = PrincipalBossManager:getExclusiveBossChallegeTime()
    self.m_csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/ItemBuy.csb")
    self.m_csNode:setToCenter()
    self:addChild(self.m_csNode)
    self:refresh()
end

function This:refresh()
    local node = self.m_csNode
    node.pieceicon:setVisible(false)
    node.equiplevel:setVisible(false)

    node.name:setString(ItemUtil.getName(self.m_itemId))
    node.count:setString(DepotManager:getItemCount(self.m_itemId))

    local price = 0
    for i=self.m_buyTimes+1,self.m_buyTimes + self.m_buyNum do
        price = price + self:getPrice(i)
    end
    self.m_nowPrice = price

    node.price:setString(price)
    node.sellcount:setString(self.m_buyNum)
    node.sellcount_0:setString(Serialize[60495])
    node.text11:setString(Serialize[60496])
    node.icon:setImage(ItemUtil.getIconImage(self.m_itemId))
    -- local newPrice = 0

    if self.m_buyNum <=1 then
        node.reduce:setGrayShader()
    else
        node.reduce:clearShader()
    end
    -- local price = self.m_nowPrice + self:getPrice(self.m_buyNum+self.m_buyTimes +1)
    -- if not DepotManager:isItemOrResEnough(self.m_costId,price) then
    --     node.increase:setGrayShader()
    -- else
    --     node.reduce:clearShader()
    -- end

end

function This:onEnter()
    super.onEnter(self)
end

function This:onExit()
    super.onExit(self)
end

function This:initTouchEvent()
    self.m_csNode.close:setTouchEnded(function()
        self:close()
    end)

    self.m_csNode.reduce:setTouchEnded(function()
        if self.m_buyNum <=1 then
            return
        end
        self.m_buyNum = self.m_buyNum - 1
        self:refresh()
    end)

    self.m_csNode.increase:setTouchEnded(function()
        local price = self.m_nowPrice + self:getPrice(self.m_buyNum+self.m_buyTimes +1)
        if not DepotManager:isItemOrResEnough(self.m_costId,price) then
            return
        end
        self.m_buyNum = self.m_buyNum + 1
        self:refresh()

    end)

    self.m_csNode.jia10:setTouchEnded(function()
        local price = self.m_nowPrice
        for i = self.m_buyNum+self.m_buyTimes,self.m_buyNum+1+self.m_buyTimes + 10 do
            price = price + self:getPrice(i)
        end
        if not DepotManager:isItemOrResEnough(self.m_costId,price) then
            g_scene:showTips(Serialize[60153])
            return
        end
        self.m_buyNum = self.m_buyNum + 10
        self:refresh()
    end)

    self.m_csNode.sellbotton:setTouchEnded(function()
        
        PrincipalBossManager:onBuyChallegeOrderRequest(self.m_itemId,self.m_buyNum)
        self:close()
    end)

end

function This:getPrice(num)
    local priceList = ArgConfig.exclusive_boss_item_cost.arg
    if num < priceList[2][1] then
        return priceList[1][2]
    elseif priceList[2][1] <= num and num < priceList[3][1] then
        return priceList[2][2]
    elseif priceList[3][1] <= num and num < priceList[4][1] then
        return priceList[3][2]
    else
        return priceList[4][2]
    end
end