-- @Author: Su
-- @Date:   2019-06-29 15:20:32
-- @Last Modified by:   Su
-- @Last Modified time: 2019-06-29 15:20:32
-- @File Name: PrincipalBossRankPanel.lua
-- @Desc: BOSS

local This, super = class(...,"Dialog")
local PrincipalBossManager = require("Boss.PrincipalBossManager")
local PrincipalBossRankItem = require("Boss.PrincipalBossRankItem")

function This:initNode(info)
    if info then 
        self.m_bossId = info.id
    end

    self.m_csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/KingBossHurt.csb")
    self.m_csNode:setToCenter()
    self:addChild(self.m_csNode)
end

function This:onEnter()
    super.onEnter(self)
    PrincipalBossManager:addObserver(self)
    PrincipalBossManager:onGetBossRankRequest(self.m_bossId)
end

function This:onExit()
	super.onExit(self)
	PrincipalBossManager:removeObserver(self)
    
end

function This:refresh()
    local node = self.m_csNode
    local rankInfo = PrincipalBossManager:getSelfRankInfo(self.m_bossId)
    -- node.me.name:setVisible(rankInfo~=nil)
    -- node.me.number_0:setVisible(rankInfo~=nil)
    -- node.me.weishangbang:setVisible(rankInfo == nil)
    node.me.hurt02:setString(Serialize[60529])
    node.me.name02:setString(Serialize[60243])
    if rankInfo and rankInfo.level then
        node.me.level03:setString(rankInfo.rank)
        node.me.level02:setString(string.format( "Lv%d",rankInfo.level))
        node.me.name02:setString(rankInfo.role_name)
        node.me.hurt02:setString(string.format( Serialize[60530],rankInfo.value))
    else
        node.me.level03:setString(Serialize[60243])
        node.me.level02:setString(Serialize[60243])

    end

    local ScrollView = node.FetterScrollView
    -- ScrollView:setAnchorPoint(0.5,0.5)
    ScrollView:removeAllItems()
    local rankList = PrincipalBossManager:getRankList(self.m_bossId)
    for _,rankInfo in ipairs(rankList) do
        local item = PrincipalBossRankItem:create(rankInfo)
        local w,h = item:getSize()
        item:setAnchorPoint(0.5,0.5)
        ScrollView:pushBackCustomItem(item,w,h,0.5)
        -- local x,y = item:getPosition()
        -- item:setPosition(x+130,y)
    end
end

function This:initTouchEvent()
    self.m_csNode.beijing.close:setTouchEnded(function()
        self:close()
    end)

end
function This:onGetBossRankInfo()
    self:refresh()
end