-- @Author: Su
-- @Date:   2019-07-11 16:57:32
-- @Last Modified by:   Su
-- @Last Modified time: 2019-07-11 16:57:32
-- @File Name: PrincipalRewardPanel.lua
-- @Description: 

local This , super = class(...,"Dialog")
local ItemNode = require("UI.ItemNode")
local GameUtil = require("Util.GameUtil")
local PrincipalBossManager = require("Boss.PrincipalBossManager")
local PrincipalRewardItemView = require("Boss.PrincipalRewardItemView")

function This:initNode(info)
    self.m_csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/TeamWarIntegral.csb")
    self:addChild(self.m_csNode)
    self.m_csNode:setToCenter()
    self:refresh()
    self:initItemList()
end

function This:onEnter()
    super.onEnter(self)
    PrincipalBossManager:addObserver(self)

end

function This:onExit()
    super.onExit(self)
	PrincipalBossManager:removeObserver(self)
end

function This:refresh()
    local node = self.m_csNode
    node.title:setString(Serialize[60534])
    node.tips1:setVisible(false)
    node.tips2:setVisible(false)
    node.numberjifen:setString(string.format( Serialize[60535],PrincipalBossManager:getWholeBossChallegeTime() ))
end

function This:initItemList()
    local node = self.m_csNode.scrollView
    node:setSwallowTouch(false)
    node:removeAllItems()
    local itemList =PrincipalBossManager:getBoxList()
    for i,itemData in ipairs(itemList) do
        local item = PrincipalRewardItemView:create(itemData)
        local w,h = item:getSize()
        node:pushBackCustomItem(item,w,h,0.5)
    end
end

function This:initTouchEvent()
    self.m_csNode.closebg:setTouchEnded(function ()
        self:close()
    end)
end

function This:onReceiveWholeBossBox()
    self:refresh()
    self:initItemList()

end