--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This = class(...)
local GameUtil = require("Util.GameUtil")
local GamePlayer = require("Player.GamePlayer")
local MatchingRoomConfig = require("Metadatas.MatchingRoomConfig")

--[[ChatType = 
{
	kNormal = 0, --普通请求
	kFriend = 1, --好友请求、回应..
}]]

function This:create(info)
	local c = {}
	setmetatable(c,self)
	c:init(info)
	return c
end
function This:init(info)
	if info.type == ChatType.kAddFriend then
		if info.from_role.id == GamePlayer:getPlayerID() then
			info.content = string.format(Serialize["chat_Chat_1"],info.to_role.name)
		else
			info.content = string.format(Serialize["chat_Chat_2"],info.from_role.name)
		end
		self.m_content = info.content
	elseif info.type == ChatType.kRefuseAdd then
		if info.from_role.id == GamePlayer:getPlayerID() then
			info.content = string.format(Serialize["chat_Chat_3"],info.to_role.name)
		else
			info.content = string.format(Serialize["chat_Chat_4"],info.from_role.name)
		end
		self.m_content = info.content
	elseif info.type == ChatType.kAgreeAdd then
		if info.from_role.id == GamePlayer:getPlayerID() then
			info.content = string.format(Serialize["chat_Chat_5"],info.to_role.name)
		else 
			info.content = string.format(Serialize["chat_Chat_6"],info.from_role.name)
		end
		self.m_content = info.content
	elseif info.type == ChatType.kShareReport then
		self.m_reportId = tonumber(info.content)
		self.m_content = Serialize["chat_Chat_7"]
	elseif info.type == ChatType.kApplyGroup then
		self.m_joinGroupInfo = loadstring("return " .. info.content)()
		self.m_content = string.format(Serialize["chat_Chat_8"],self.m_joinGroupInfo.groupName)
	elseif info.type == ChatType.kApplyMatch then
		self.m_joinMatchRoom = loadstring("return " .. info.content)()
		local str = ""
		local matchType = self.m_joinMatchRoom.matchType or 1
		local levMin, levMax = MatchingRoomConfig[matchType].Minlevel , MatchingRoomConfig[matchType].Maxlevel
		if levMin and levMin > 0 and levMax and levMax > 0 then
			str = string.format(Serialize["chat_Chat_9"], levMin, levMax)
		end
		self.m_content = string.format(Serialize[60582] .. str )
		print(self.m_content)
	elseif info.type == ChatType.kVoice then
		self.m_voiceInfo = loadstring("return" .. info.content)()
		self.m_content = string.format(Serialize["chat_Chat_10"])
	elseif info.type == ChatType.kApplyTeamWarfare or info.type == ChatType.kApplyTower then
		local ret = false
		local copyName, fieldName
		if info.type == ChatType.kApplyTeamWarfare then
			copyName = Serialize[60583]
			fieldName = "m_joinWarfareTeam"
		elseif info.type == ChatType.kApplyTower then
			copyName = Serialize[60584]
			fieldName = "m_joinTowerTeam"
		end
		
		if info.content then
			local func = loadstring("return " .. info.content)
			if func then
				if fieldName then
					local team = func()
					self[fieldName] = team
				end
				
				if team and team.war_full_name then
					self.m_content = Serialize[60585] .. copyName .. "：" .. team.war_full_name .. "]"
					ret = true
				end
			end
		end
		if not ret then
			self.m_content = Serialize[60585] .. copyName .. "]"
		end
	else
		self.m_content = info.content
	end
	
	self.m_fromRole = info.from_role
	self.m_channel = info.channel

	if self.m_fromRole.id == 0 and info.channel == ChatChannelType.kSystem then
		self.m_channel = ChatChannelType.kSystem
	end
	self.m_sendTime = info.time
	self.m_type = info.type
	self.m_toRole = info.to_role
	self.m_pos = info.pos  --0-聊天框；1-跑马灯和聊天框；2-跑马灯; 3-皇帝专属跑马
	self.m_id = string.format("%s-%d",GameUtil:int64ToString(self.m_fromRole.id) ,self.m_sendTime)
	if info.chatId then
		self.m_chatId = info.chatId
	end
end

function This:getId()
	return self.m_id
end 

function This:getChatId()
	return self.m_chatId or 0
end

function This:getFromRole()
	return self.m_fromRole
end

function This:getToRole()
	return self.m_toRole
end

function This:getContent()
	return self.m_content
end

function This:getSendTime()
	return self.m_sendTime
end

function This:getChannel()
	return self.m_channel
end

function This:getChatType()
	return self.m_type
end

function This:isNeedBroadCast()
	return self.m_pos > 0 
end

function This:isEmperExclusive()
	return self.m_pos > 2 
end

function This:isNotShowInChatList()
    return self.m_pos > 1
end

function This:getFromRoleVip()
	return self.m_fromRole.vip_list
end

function This:getFromRoleRankLv()
	local level = self.m_fromRole.cur_rank_level
	return level > 0 and level or 1
end

function This:getReportId()
	return self.m_reportId
end

function This:getJoinGroupChatInfo()
	if self.m_type == ChatType.kApplyGroup then
		return self.m_joinGroupInfo
	end
end

function This:getJoinMatchRoomInfo()
	if self.m_type == ChatType.kApplyMatch then
		return self.m_joinMatchRoom
	end
end

function This:getJoinWarfareTeamInfo()
	if self.m_type == ChatType.kApplyTeamWarfare then
		return self.m_joinWarfareTeam
	elseif self.m_type == ChatType.kApplyTower then
		return self.m_joinTowerTeam
	end
end

function This:getVoiceInfo()
	if self.m_type == ChatType.kVoice then
		return self.m_voiceInfo
	end
end

--endregion
