--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"cc.Node")
local GameUtil = require("Util.GameUtil")
local GamePlayer = require("Player.GamePlayer")
local MatchConfig = require("Metadatas.MatchingConfig")
local ConfirmPanel = require("UI.ConfirmPanel")
local ReportManager = require("Report.ReportManager")
local FamilyManager = require("Family.FamilyManager")
local RoomRole = require("Match.RoomRole")
local MatchManager = require("Match.MatchManager")
local VoiceChat = require("VoiceChat")
local LoginManager = require("Login.LoginManager")
local EntrantManager = require("LegionEntrant.EntrantManager")

function This:init(chat)
	self.m_chat = chat
	if self.m_chat:getFromRole().id ~= 0 then
		self:initWorldContent()
	else
		self:initSystemContent()
	end
	--[[local w , h = self:getContentSize()
	self.m_layer = cc.LayerColor:create(cc.Color(255,0,0,64))
	self.m_layer:setContentSize(w,h)
	self:addChild(self.m_layer)
	self:setCascadeOpacityEnabled(true)]]
end

function This:initWorldContent()
	self.m_csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/WorldChatContent.csb")
	self:addChild(self.m_csNode)
	self:refresh()
end

function This:refresh()
	local chatType = self.m_chat:getChatType()
	if chatType == ChatType.kShareReport 
		or chatType == ChatType.kApplyGroup 
		or chatType == ChatType.kApplyMatch 
		or chatType == ChatType.kApplyTeamWarfare 
		or chatType == ChatType.kApplyTower 
		or chatType == ChatType.kVoice 
	then
		self.m_csNode.content.text:setStringWithColor(self.m_chat:getContent(),180)
	else
		self.m_csNode.content.text:setString(self.m_chat:getContent(),220)
	end

	local rankLv = self.m_chat:getFromRoleRankLv()
	local serverName = LoginManager:getServerAreaName(areId,false)
	-- local str = string.format("<A0>%s<B1>[%s] <A0>%s",serverName,MatchConfig[rankLv].rank_level,self.m_chat:getFromRole().name)
	local str = string.format("<B1>[%s] <A0>%s",MatchConfig[rankLv].rank_level,self.m_chat:getFromRole().name)
	self.m_csNode.content.rank:setStringWithColor(str)
    local icon = self.m_csNode.header.icon
	local fromRole = self.m_chat:getFromRole()
	GameUtil:setPlayerIconNodeImage(icon, fromRole.icon)
	-- GameUtil:setPlayerTitleNodeTo(icon, fromRole.title, fromRole.vip_list)
	GameUtil:setPlayerEffectNodeTo(icon, fromRole.effect)

	GameUtil:setPlayerTitleWithImgNode(fromRole.title,self.m_csNode.header.vipbg,self.m_csNode.header.vip)

	local txBgWidth , txBgHeight = self.m_csNode.content.bg:getContentSize()
	local scalex , scaley = self.m_csNode.content.bg:getScale()

	local txWidth , txHeight = self.m_csNode.content.text:getContentSize()
	scalex , scaley = self.m_csNode.content.text:getScale()
	txWidth , txHeight = txWidth * scalex, txHeight * scaley

	local icBgWith , icBgHeight = self.m_csNode.header.iconbg:getContentSize()
	if txHeight > txBgHeight then
		self.m_csNode.content.bg:setContentSize(txBgWidth,txHeight+10)
		local w = icBgWith + txBgWidth
		local h = icBgHeight + txHeight - txBgHeight + 12
		self:setContentSize(w,h)
		self.m_csNode:setPositionY(h)
	else
		local w = icBgWith + txBgWidth+ 5
		local h = icBgHeight + 5
		self:setContentSize(w,h)
		self.m_csNode:setPositionY(h)
	end
end

function This:initSystemContent()
	local content = self.m_chat:getContent()
	local str = string.format(Serialize["chat_ChatView_1"],GameUtil:formatDate(Serialize["H_M"],self.m_chat:getSendTime()),content)
	
	local label = cc.Label:createNormalTTF("",14)
	label:setStringWithColor(str, 130)
	
	local w , h = label:getContentSize()
	label:setPosition(w/2,h/2)
	self:setContentSize(w,h)
	self:addChild(label)
end

function This:onEnter()
	super.onEnter(self)
end

function This:onExit()
	super.onExit(self)
end

function This:getChat()
	return self.m_chat
end

function This:setChat(chat)
	if self.m_chat ~= chat then
		self.m_chat = chat
		self:refresh()
	end
end

function This:setRight(total)
	if self.m_chat:getFromRole().id == 0  then
		return
	end
	self.m_csNode.content.bg:setImage("GameScene/liaotiankuang2.png")

	local width , height = self:getContentSize()
	total = total or width
	self:setContentSize(total,height)

	local icBgWith , icBgHeight = self.m_csNode.header.iconbg:getContentSize()
	self.m_csNode.header:setPositionX(total - icBgWith)
	self.m_csNode.content:setPositionX(total - width - icBgWith + 10)

	self.m_csNode.content.rank:setAnchorPoint(1,1)
	self.m_csNode.content.rank:setPositionX(width - 10)

	if self.m_layer then
		self.m_layer:setContentSize(total,height)
	end
end	

function This:setTouch()
	if self.m_chat:getFromRole().id == 0 then
		return
	end

	local csNode = self.m_csNode
	local contentTxtNode = csNode.content.text
	local chatType = self.m_chat:getChatType()
	csNode.header.icon:setTouch({
		onEnded = function()
			local fromId = self.m_chat:getFromRole().id
			if fromId ~= GamePlayer:getPlayerID() then
				local friendPanel = g_scene:getDialog("RoleInfoPanel")
				if friendPanel then
					g_scene:showTips(Serialize[60591])
					return
				end
				g_scene:openDialog("Player.RoleInfoPanel",{id = self.m_chat:getFromRole().id})
			else
				g_scene:showTips(Serialize["chat_ChatView_2"])
			end
		end,
		isContainer = true,
		isScale = false
	})

	if chatType == ChatType.kShareReport then
		contentTxtNode:setTouch({
			onEnded = function()
				local reportId = self.m_chat:getReportId()
				ReportManager:onGetBattleSimpleReportRequest(reportId)
			end,
			isContainer = true,
			isScale = false
		})
	elseif chatType == ChatType.kApplyGroup then
		contentTxtNode:setTouch({
			onEnded = function()
				local groupInfo = self.m_chat:getJoinGroupChatInfo()
				FamilyManager:openInvitePanel( groupInfo )
			end,
			isContainer = true,
			isScale = false
		})
	elseif chatType == ChatType.kApplyMatch then
		contentTxtNode:setTouch({
			onEnded = function()
				local info = self.m_chat:getJoinMatchRoomInfo()
				local role = RoomRole:create(info.role)
				if role:getId() == GamePlayer:getPlayerID() then
					g_scene:showTips(Serialize["chat_ChatView_3"])
					return
				end

				if GamePlayer:isInKingMap() then
					g_scene:showTips(Serialize[60592])
					return
				end

				if EntrantManager:isJoinKingWar() then
					g_scene:showTips(Serialize[60593])
					return
				end

				g_scene:openDialog("Match.InviteMatchPopPanel",{
					role = role,
					relation = info.relation,
					time = 30
				})
			end,
			isContainer = true,
			isScale = false
		})
	elseif chatType == ChatType.kApplyTeamWarfare or chatType == ChatType.kApplyTower then
		contentTxtNode:setTouch({
			onEnded = function()
				local info = self.m_chat:getJoinWarfareTeamInfo()
				if not info then print("info is empty") return end
				g_scene:openDialog("Warfare.InviteWarfarePopPanel",{
					teamInfo = info,
					teamType = info.team_type,
					time = 30
				})
			end,
			isContainer = true,
			isScale = false
		})
	end
end


--endregion
