--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"Chat.ChatView")
local GameUtil = require("Util.GameUtil")
local GamePlayer = require("Player.GamePlayer")
local MatchConfig = require("Metadatas.MatchingConfig")
local ConfirmPanel = require("UI.ConfirmPanel")
local ReportManager = require("Report.ReportManager")
local FamilyManager = require("Family.FamilyManager")
local RoomRole = require("Match.RoomRole")
local MatchManager = require("Match.MatchManager")
local VoiceChat = require("VoiceChat")

function This:init(chat)
	self.m_chat = chat
	self.m_csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/WorldChatVioce.csb")
	self:addChild(self.m_csNode)
	self:refresh()
end

function This:refresh()
	local rankLv = self.m_chat:getFromRoleRankLv()
	local str = string.format("<B1>[%s] <A0>%s",MatchConfig[rankLv].rank_level,self.m_chat:getFromRole().name)
	self.m_csNode.content.rank:setStringWithColor(str)
    local icon = self.m_csNode.header.icon
    local fromRole = self.m_chat:getFromRole()
	GameUtil:setPlayerIconNodeImage(icon, fromRole.icon)
    -- GameUtil:setPlayerTitleNodeTo(icon, fromRole.title, fromRole.vip_list)
	GameUtil:setPlayerEffectNodeTo(icon, fromRole.effect)
	GameUtil:setPlayerTitleWithImgNode(fromRole.title,self.m_csNode.header.vipbg,self.m_csNode.header.vip)

	-- self.m_csNode.header.vip:setVisible(false)
	-- self.m_csNode.header.vipbg:setVisible(false)

	local info = self.m_chat:getVoiceInfo()
	local w , h = self.m_csNode.content.vioce:getContentSize()
	local w1 = (info.size or 1024) / 30720 * 200
	w1 = math.min(200, math.max(60,w1))
	self.m_csNode.content.vioce:setContentSize(w1,h)

	self:setContentSize(220,65)
	self.m_csNode:setPositionY(65)
end

function This:showPlayVoice(isShow)
	if isShow then
		local index = 0
		self.m_csNode.content.bofang1:runAction(cc.RepeatForever(cc.Sequence(
			cc.DelayTime(0.3),
			cc.CallFunc(function()
				for i = 1 , 3 do
					self.m_csNode.content["bofang"..i]:setVisible(index >= i)
				end
				index = (index + 1) % 4
			end)
		)))
		cc.Audio:pauseBackground()
	else
		cc.Audio:resumeBackground()
		self.m_csNode.content.bofang1:stopAllActions()
		for i = 1 , 3 do
			self.m_csNode.content["bofang"..i]:setVisible(true)
		end
	end
end

function This:setPlayHandler(playHandler)
	self.m_playHandler = playHandler
end

function This:setTouch()
	if self.m_chat:getChatType() == ChatType.kVoice then
		self.m_csNode.content.vioce:setTouch({
			onEnded = function()
				local info = self.m_chat:getVoiceInfo()
				VoiceChat:playVoice(info.voiceId)
				if self.m_playHandler then
					self.m_playHandler(self)
				end
				self:showPlayVoice(true)
			end,
			isContainer = true,
			isScale = false
		})

	end

	self.m_csNode.header.icon:setTouch({
		onEnded = function()
			local fromId = self.m_chat:getFromRole().id
			if fromId ~= GamePlayer:getPlayerID() then
				g_scene:openDialog("Player.RoleInfoPanel",{id = self.m_chat:getFromRole().id})
			else
				g_scene:showTips(Serialize["chat_VoiceView_1"])
			end
		end,
		isContainer = true,
		isScale = false
	})
end

function This:setRight(total)
	super.setRight(self,total)
	local w = 200
	local rect = self.m_csNode.content.vioce:getBoundingBox()
	self.m_csNode.content.vioce:setPositionX(w - rect.width)
	for i = 1 , 3 do
		local sp = self.m_csNode.content["bofang"..i]
		sp:setFlippedX(true)
		sp:setPositionX(w - 6 * i)
	end
end	


--endregion
