local function findModule(moduleName)
    local t = _G
    string.gsub(moduleName, "([^%.]+)" , function (name)
        t[name] = t[name] or {}
        t = t[name]
    end)
    return t
end

local function getClassName(moduleName)
    local lastName = moduleName
    string.gsub(moduleName, "([^%.]+)" , function (name)
        lastName = name
    end)
    return lastName
end

-- if os.isWin32 then
--     local oldRequire = require
--     local loadedList = {}
--     _G.require = function (name)
--         if loadedList[name] then
--             logError("loop require")
--         end
--         loadedList[name] = 1
--         local ret = oldRequire(name)
--         loadedList[name] = nil
--         return ret
--     end
-- end


function class(name, base)
    local classObj = {}
    package.loaded[name] = classObj
    local baseClass
    if base then
        baseClass = require(base)
        for k,v in pairs(baseClass) do
            classObj[k] = v
        end
        classObj.super = baseClass
        setmetatable(classObj, baseClass)
        -- if isClone then
        --     for k,v in pairs(baseClass) do
        --         classObj[k] = v
        --     end
        -- else
        --     setmetatable(classObj, baseClass)
        --     classObj.super = baseClass
        -- end
    end

    local fileName = name
    classObj.__index = classObj
	classObj._THIS = classObj
    classObj._MNAME = fileName -- module name
    classObj._NAME = getClassName(fileName)
    return classObj, baseClass 
end

-- function isInstance(instance, classType)
--     local meta = instance.__index
--     while meta do
--         if meta == classType then
--             return true
--         end
--         meta = meta.super
--     end
--     return false
-- end