-- @Author: zheng
-- @Date:   2019-08-12 16:09:01
-- @Last Modified by:   zheng
-- @Last Modified time: 2019-09-04 11:20:11
-- @File Name: BetsBuyItemView.lua
local CompetitionManager = require("Competition.CompetitionManager")
local This , super = class(...,"NodeUI")
-- local FamilyManager = require("Official.FamilyManager")
This.fileName = "GameScene/NodeUI/CompetitionMyBetsItem.csb"
local BetsBuyItemViewBetState ={
    kbeforeFight = 1,
    -- kFight = 2,
    kFightWin = 2,
    kFightFail = 3,
}
function This:setModel( achieve, index )
    if achieve then
        self.m_data = achieve
        self.m_myIndex = index
    end
    self:refresh()
end

function This:initNode(info)
    local w,h = self.weixuanzhong:getContentSize()
    self:setContentSize(w,h)
    self:setAnchorPoint(0.5, 0.5)
    -- self:getData()
    self:refresh()
end

function This:refresh()
    -- local curent = CompetitionManager:getCurentBetNum()
    local data = self.m_data
    if data and data.role_name then
        
        local max = CompetitionManager:getMaxBetBuyNum()
        local betTypeNames ={
          [CompetitionManagerBetState.kjueSaiCompetition] = Serialize[60597],
          [CompetitionManagerBetState.kBanjueSaiCompetition] = Serialize[60598],
          [CompetitionManagerBetState.kSiQiangCompetition] = Serialize[60599],
          [CompetitionManagerBetState.kBaQiangCompetition] = Serialize[60600],
        }
        local betNum = data.betNum
        local jifen1,name1 = CompetitionManager:getSucessBetReturn(betNum)
        local jifen2,name2 = CompetitionManager:getFailBetReturn(betNum)
        local betState = data.betState
        self.name:setString(data.role_name)
        self.leixing:setString(betTypeNames[data.betType])--八强、四强、半决、决赛
        self.daoju:setString(betNum)
        self.jifen1:setString(string.format("%s%s",jifen1,name1))
        self.jifen2:setString(string.format("%s%s",jifen2,name2))
        local limitVisible,zhuweiVisible,cuowuVisible,zhengqueVisible = false,false,false,false
        if betState == BetsBuyItemViewBetState.kbeforeFight  then
            local battleType = CompetitionManager:getBateState()
            if battleType and battleType == data.betType then
                local temBetNum = CompetitionManager:getCurentBetNum()
                limitVisible = temBetNum>= max
                zhuweiVisible = not limitVisible
                if limitVisible then
                    self.limit:setString(Serialize[60601])
                end
            else
                self.limit:setString(Serialize[60602])
                limitVisible = true
            end
        -- elseif betState == BetsBuyItemViewBetState.kFight  then
        elseif betState == BetsBuyItemViewBetState.kFightWin  then
            zhengqueVisible = true
        elseif betState == BetsBuyItemViewBetState.kFightFail  then
            cuowuVisible = true
        end
        self.zhuwei:setVisible(zhuweiVisible)
        self.limit:setVisible(limitVisible)
        self.cuowu:setVisible(cuowuVisible)
        self.zhengque:setVisible(zhengqueVisible)
    end
end

function This:initTouchEvent()
    self.zhuwei:setTouch({
        isContainer = true,
        onEnded = function()
            if CompetitionManager:checkIsCanBuy() then
                local info = {betInfo = self.m_data}
                g_scene:openDialog("Competition.BetsBuyPanel",info)
            end
        end,
        isScale = false, 
        isDynamic = true, 
    })
end
