-- @Author: zheng
-- @Date:   2019-08-12 16:09:01
-- @Last Modified by:   zheng
-- @Last Modified time: 2019-09-04 11:15:53
-- @File Name: BetsBuyPanel.lua

local This , super = class(...,"Dialog")
local CompetitionManager = require("Competition.CompetitionManager")
This.fileName = "GameScene/NodeUI/CompetitionMyBetsBuy.csb"
function This:initNode(info)
    if info then
       -- self.m_family = info.family
       local betInfo = info.betInfo
        self.m_roleId = info.id
        self.m_roleName = info.name
        self.m_battleIndex = info.battleIndex
        self.m_teamIndex = info.teamIndex
        if betInfo then
            self.m_roleId = betInfo.role_id
            self.m_roleName = betInfo.role_name
            self.m_battleIndex = betInfo.battle_index
            self.m_betType = betInfo.betType
            self.m_teamIndex = betInfo.team_index
            self.m_orderId = betInfo.order_id
        end
    end 
    self.m_useCount = 1
    self.m_max = CompetitionManager:getMaxBetBuyNum()- CompetitionManager:getCurentBetNum()
    local csNode = cc.Node:createFromCSFile(This.fileName)
    csNode:setToCenter()
    self:addChild(csNode)
    self.m_csNode = csNode
    csNode.text:setStringWithColor(string.format(Serialize[60604],self.m_roleName or ""))
    self:refresh()
end

function This:refresh()
    local csNode = self.m_csNode
    local userCount = self.m_useCount
    csNode.changecount:setString(userCount)--数量
    csNode.number:setString(CompetitionManager:getBetOneCost(userCount))--元宝
    local jifen1,name1 =CompetitionManager:getSucessBetReturn(userCount) 
    local jifen2,name2 =CompetitionManager:getFailBetReturn(userCount)
    csNode.tip:setStringWithColor(string.format(Serialize[60605],jifen1,name1,jifen2,name2))
end

function This:initTouchEvent()
	local csNode = self.m_csNode
    csNode.closebg:setTouchEnded(function()
        self:close()
    end)
    csNode.addten:setTouchEnded(function()--+10
        self:updateUseCount(self.m_useCount+10)
    end)
    csNode.reduceten:setTouchEnded(function()---10
        self:updateUseCount(self.m_useCount-10)
    end)
    csNode.increase:setTouchEnded(function()--add
        self:updateUseCount(self.m_useCount+1)
    end)
    csNode.reduce:setTouchEnded(function()
        self:updateUseCount(self.m_useCount-1)
    end)
	csNode.Button:setTouchEnded(function()
        local battleType = CompetitionManager:getBateState()
        if not battleType then
            g_scene:showTips(Serialize[60606])
            return
        end
        if self.m_useCount>0 then
            CompetitionManager:onBetPlayerRequest(self.m_battleIndex,battleType,self.m_teamIndex,self.m_useCount,self.m_roleId,self.m_roleName,self.m_orderId)
            self:close()
        end
    end)

end

function This:updateUseCount(userCount)
    if userCount<1 then
        userCount = 1
    end
    if userCount>self.m_max then
        userCount = self.m_max
    end
   self.m_useCount = userCount
   self:refresh()
end

function This:onEnter()
    super.onEnter(self)
    CompetitionManager:addObserver(self)
end

function This:onExit()
    super.onExit(self)
    CompetitionManager:removeObserver(self)
end

-- function This:getData()
	
-- end