-- @Author: zheng
-- @Date:   2019-08-12 16:09:01
-- @Last Modified by:   zheng
-- @Last Modified time: 2019-09-04 19:26:34
-- @File Name: BetsInfoPanel.lua

local CompetitionManager = require("Competition.CompetitionManager")
local GameUtil = require("Util.GameUtil")
local UpdateLayer = require("Rank.RankPageListLayer")
local BetsBuyItemView = require("Competition.BetsBuyItemView")
local This , super = class(...,"Dialog")
This.fileName = "GameScene/NodeUI/CompetitionMyBets.csb"
function This:initNode(info)
    CompetitionManager:onGetBatInfoRequest(info.serverType,true)
    self.m_csNode = cc.Node:createFromCSFile(This.fileName)
    self.m_csNode:setToCenter()
    self:addChild(self.m_csNode)
    self:getData()
    self:initUpdateLayer()
    self:refresh()
end

function This:refresh()
    self.m_listLayer:setDataList()
end

function This:initUpdateLayer()
    local scrollView = self.m_csNode.scrollView
    if scrollView then
         self.m_listLayer = UpdateLayer:create({
            itemWidth = 770,
            itemHeight = 51,
            spaceX = 0,
            spaceY = 0,
            scrollView = scrollView,
            dataCounter = function ()
                return #self.m_configlist
            end,
         viewCreator =  function(index, node)
                local item = self.m_configlist[index]
                if item then
                    if not node then
                        return self:getScroolItem(item,index)
                    else
                        node:setModel(item, index)
                    end
                end
            end,
--            hint = self.m_selectIndex,
        })
        self.m_listLayer:setCascadeOpacityEnabled(true)
        self.m_listLayer:setAnchorPoint(0.5, 0)
        local w , h = self.m_listLayer:getContentSize()
        scrollView:pushBackCustomItem(self.m_listLayer, w, h,0,0)
    end
end

function This:getScroolItem(item,index)
    local view = BetsBuyItemView:create(item,index)
    return view 
end

function This:getData()
    self.m_configlist = CompetitionManager:getBetInfo()
    table.sort(self.m_configlist,function (a,b)
        return a.cur_time>b.cur_time
    end)
end

function This:initTouchEvent()
    local csNode = self.m_csNode
    csNode.close:setTouchEnded(function()
        self:close()
    end)
--    csNode.shop:setTouchEnded(function()

--    end)
--    csNode.button:setTouchEnded(function()--一键领取

--    end)
end

function This:onBetPlayer()
    self:getData()
    self:refresh()
end
This.onGetBatInfo = This.onBetPlayer
function This:onEnter()
    super.onEnter(self)
    CompetitionManager:addObserver(self)
end

function This:onExit()
    super.onExit(self)
    CompetitionManager:removeObserver(self)
end