-- @Author: Su
-- @Date:   2019-08-24 15:17:05
-- @Last Modified by:   Su
-- @Last Modified time: 2019-08-24 15:17:05
-- @File Name: CompetitionAllBattleInfoItem.lua
-- @Description: 

local This , super = class(..., "NodeView")
local GameUtil = require("Util.GameUtil")
local CompetitionManager = require("Competition.CompetitionManager")

local text ={
    [2] = Serialize[60597],
    [4] = Serialize[60613],
    [8] = Serialize[60614],
    [16] = Serialize[60615],
}

function This:initData(info)
    local csNode = cc.Node:createFromCSFile("GameScene/NodeUI/CompetitionAllBattleInfoItem.csb")
    self.m_csNode = csNode
    self:addChild(csNode)

    self.m_data = info
    self:refresh()
    --self:initTouchEvent()
end

function This:refresh()
    local node= self.m_csNode
    node.leixing:setString(text[self.m_data.type*2])
    if self.m_data then
        node.descleft:setVisible(self.m_data.isShow)
        node.leixing:setVisible(self.m_data.isShow)
        node.name1:setString(self.m_data.role1.roleData.name)
        node.num1:setString(self.m_data.role1.roleData.winCount)
        GameUtil:setPlayerIconNodeImage(node.pic1.icon, self.m_data.role1.roleData.icon)

        node.name2:setString(self.m_data.role2.roleData.name)
        node.num2:setString(self.m_data.role2.roleData.winCount)
        GameUtil:setPlayerIconNodeImage(node.pic2.icon, self.m_data.role2.roleData.icon)
    end

end

function This:initTouchEvent()
    self.m_csNode.videotape:setTouch({
        onEnded = function()
            CompetitionManager:onGetTeamFightShortReportDataRequest(self.m_data.role1.roleData.index,self.m_data.type,self.m_data.competionType)
        end,
        isScale = false, 
        isDynamic = true, 
        isContainer  = true,
    })
end