-- @Author: Su
-- @Date:   2019-08-24 15:17:05
-- @Last Modified by:   zheng
-- @Last Modified time: 2019-09-05 16:28:33
-- @File Name: CompetitionAllBattleInfoPanel.lua
-- @Description: 
local This, super = class(..., "Dialog")
local CompetitionManager = require("Competition.CompetitionManager")
local CompetitionAllBattleInfoItem = require("Competition.CompetitionAllBattleInfoItem")

local TabName = {
    kAll = 1,
    kBaQiang = 2,
    kSiQiang = 3,
    kBanJueSai = 4,
    kJueSai = 5
}

function This:initNode(info)
    local csNode = cc.Node:createFromCSFile("GameScene/NodeUI/CompetitionAllBattleInfo.csb")
	self.m_csNode = csNode

    self:addChild(csNode)
    csNode:setToCenter()
    self.m_tabIndex = 1
    self.m_type = info.type
	self:addTabButton(TabName.kAll , self.m_csNode.tab1,function()
		self:onSelectTab(TabName.kAll)
    end)

    self:addTabButton(TabName.kBaQiang , self.m_csNode.tab2,function()
		self:onSelectTab(TabName.kBaQiang)
    end)

    self:addTabButton(TabName.kSiQiang , self.m_csNode.tab3,function()
		self:onSelectTab(TabName.kSiQiang)
    end)

    self:addTabButton(TabName.kBanJueSai , self.m_csNode.tab4,function()
		self:onSelectTab(TabName.kBanJueSai)
    end)

    self:addTabButton(TabName.kJueSai , self.m_csNode.tab5,function()
		self:onSelectTab(TabName.kJueSai)
    end)
    self:selectTabButton(TabName.kAll)
end

function This:onEnter()
    super.onEnter(self)
	CompetitionManager:addObserver(self)

end

function This:onExit()
    CompetitionManager:removeObserver(self)
	super.onExit(self)
end

function This:initTouchEvent()
	self.m_csNode.close:setTouchEnded(function()
		self:close()
	end)
end

function This:onSelectTab(tab)
    local battleIndex = CompetitionManager:getBattleIndex()
    if battleIndex == 0 then
        battleIndex = 1
    end
	if tab == TabName.kAll then
        local reportList=CompetitionManager:getBattleRank(battleIndex)

		self:refreshReportItems(reportList,true)
	elseif tab == TabName.kBaQiang then
		local reportList = CompetitionManager:getBattleInfoWithFightType(battleIndex,16)
		self:refreshReportItems(reportList,false)
	elseif tab == TabName.kSiQiang then
		local reportList = CompetitionManager:getBattleInfoWithFightType(battleIndex,8)
        self:refreshReportItems(reportList,false)
    elseif tab == TabName.kBanJueSai then
		local reportList = CompetitionManager:getBattleInfoWithFightType(battleIndex,4)
        self:refreshReportItems(reportList,false)
    elseif tab == TabName.kJueSai then
		local reportList = CompetitionManager:getBattleInfoWithFightType(battleIndex,2)
		self:refreshReportItems(reportList,false)
	end
end

function This:refreshReportItems(reportList,isAll)
	self.m_csNode.ScrollView:removeAllItems()
    self.m_timer:removeAllTimer()
    local function addScroolItem(dataList)
       for j = 1,#dataList/2 do
           local role1 = dataList[j*2-1].roleData
           local role2 = dataList[j*2].roleData
           local winCount = dataList[j*2-1].count
           local winCount2 =dataList[j*2].count
           if winCount < winCount2 then
               role1 = dataList[j*2].roleData
               role2 = dataList[j*2-1].roleData
               winCount = dataList[j*2].count
               winCount2 = dataList[j*2-1].count
           end
           if not role1 or not role2 then
               break
           end
           local roleData1 ={roleData ={id =role1.id,name =role1.name,icon = role1.icon,index =dataList[j*2-1].index,winCount =winCount}}
           local roleData2 ={roleData ={id =role2.id,name =role2.name,icon = role2.icon,index =dataList[j*2].index,winCount =winCount2}}
           if role1.id > 0 and role2.id > 0 and winCount > 0 then
               local view = CompetitionAllBattleInfoItem:create({role1=roleData1,role2=roleData2,type =#dataList/2,isShow = isAll,competionType = self.m_type })
               self.m_csNode.ScrollView:pushBackCustomItem(view,820,140,0.35)
           end

       end 
    end
    if not isAll then
        addScroolItem(reportList)
    else
        local selectRes ={2,4,8,16}
        for _,index in ipairs(selectRes) do
            local dataList= reportList[index]
            if dataList then
               addScroolItem(dataList.rank) 
            end
        end

    end
end

function This:getTeamShortReportInfo(reportList)
    g_scene:openDialog("Competition.CompetitionBattleInfoPanel", {reportList =reportList,type = self.m_type})
end