-- @Author: Su
-- @Date:   2019-08-23 15:17:05
-- @Last Modified by:   Su
-- @Last Modified time: 2019-08-23 15:17:05
-- @File Name: CompetitionIngPanel.lua
-- @Description: 

local This, super = class(..., "Dialog")
local GamePlayer = require("Player.GamePlayer")
local CompetitionManager = require("Competition.CompetitionManager")


function This:initNode()
    local csNode = cc.Node:createFromCSFile("GameScene/NodeUI/Competition.csb")
	self.m_csNode = csNode

    self:addChild(csNode)
    csNode:setToCenter()


    local cNode = cc.Node:createFromCSFile("GameScene/NodeUI/CompetitionIng.csb")
    self.m_csNode:addChild(cNode)
    self.m_FightNode = cNode

    self.m_escape = 0
    self:refresh()
    self:initFightNode()
end

function This:initRankString(index)
    local node = self.m_FightNode
    for i = 1,index do
        node["play"..index.."_"..i].xuwei:setVisible(true)
        node["play"..index.."_"..i].player:setVisible(false)
        node["play"..index.."_"..i].jingcai:setVisible(false)
        node["play"..index.."_"..i].zhandouzhong:setVisible(false)
    end

end

function This:initFightNode()
    local node = self.m_FightNode
    self:initRankString(16)
    self:initRankString(8)
    self:initRankString(4)
    self:initRankString(2)
    node.play1.xuwei:setVisible(true)
    node.play1.player:setVisible(false)
end

function This:setRankString(index,rankList)
    local node = self.m_FightNode
    for i , roleData in ipairs(rankList) do
        if roleData then
            node["play"..index.."_"..i].player:setVisible(true)
            node["play"..index.."_"..i].player.name:setString(roleData.name)
            node["play"..index.."_"..i].player.number:setString(roleData.winCount)
        else
            node["play"..index.."_"..i].player:setVisible(false)
            node["play"..index.."_"..i].xuwei:setVisible(true)
        end 

    end
end

function This:refresh()
    local node = self.m_FightNode
    local stage = 4
    local rankList16 = CompetitionManager:getCompetionRankList16()
    local rankList8 = CompetitionManager:getCompetionRankList8()
    local rankList4 = CompetitionManager:getCompetionRankList4()
    local rankList2 = CompetitionManager:getCompetionRankList2()
    local rankChamTion = CompetitionManager:getCompetionChamtion()

    self:setRankString(16,rankList16)
    self:setRankString(8,rankList8)
    self:setRankString(4,rankList4)
    self:setRankString(2,rankList2)
    if rankChamTion.name then
        node.play1.player.name:setString(rankChamTion.name)
        node.play1.player.number:setString("0")
        node.play1.xuwei:setVisible(false)
        node.play1.player:setVisible(true)
    else
        node.play1.xuwei:setVisible(true)
        node.play1.player:setVisible(false)
    end

    node.zhanqu:setVisible(stage >= CompetitionState.kCrossWaitFight)
    node.genghuan:setVisible(stage >= CompetitionState.kCrossWaitFight)
end

function This:onEnter()
    super.onEnter(self)
    self:scheduleUpdate()
    -- CompetitionManager:onGetSelfInfoRequest()
    CompetitionManager:addObserver(self)
end

function This:onExit()
    super.onExit(self)
    self:unscheduleUpdate()
    CompetitionManager:removeObserver(self)
end

function This:initTouchEvent()
	self.m_csNode.close:setTouchEnded(function()
		self:close()
    end)
    local function setClick(index)
        local node = self.m_FightNode

    end

    local node = self.m_FightNode

    node.buzhen:setTouchEnded(function ()
        g_scene:openDialog("Competition.CompetitionDefenseFightPanel",{})
    end)
end

function This:update(dt)
	self.m_escape = self.m_escape + dt
	if self.m_escape > 1 then
		self.m_escape = self.m_escape - 1
		self:refreshTime()
	end
end