-- @Author: Su
-- @Date:   2019-08-13 15:17:05
-- @Last Modified by:   zheng
-- @Last Modified time: 2019-09-05 17:06:19
-- @File Name: CompetitionMainPanel.lua
-- @Description: 
local This, super = class(..., "Dialog")
local GamePlayer = require("Player.GamePlayer")
local CompetitionManager = require("Competition.CompetitionManager")
local CompetitionTimeConfig = require("Metadatas.CompetitionTimeConfig")
local GameUtil = require("Util.GameUtil")

CompetitionState = {
    kSignUp = 1,                --报名阶段
    kSelection = 2,             --分组阶段
    kArray = 3,                 --海选编队阶段
    kWaitFight = 4,             --海选阶段
    kBaQiangCompetition =5,     --八强竞猜阶段
    kBaQiangArray = 6,          --八强编队阶段
    kBaQiang = 7 ,              --八强阶段
    kSiQiangCompetition =8,     --四强竞猜阶段
    kSiQiangArray = 9,          --四强编队阶段
    kSiQiang = 10 ,             --四强阶段
    kBanjueSaiCompetition = 11, --半决赛竞猜阶段
    kBanjueSaiArray = 12,       --半决赛编队阶段
    kBanjueSai = 13,            --半决赛阶段
    kjueSaiCompetition = 14,    --决赛竞猜阶段
    kjueSaiArray = 15,          --决赛编队阶段
    kjueSai = 16,               --决赛阶段
    kbutton = 17,               --按钮持续时间
}

-- local nowStage = 5

function This:initNode(info)
    local csNode = cc.Node:createFromCSFile("GameScene/NodeUI/Competition.csb")
	self.m_csNode = csNode

    self:addChild(csNode)
    csNode:setToCenter()

    local node = cc.Node:createFromCSFile("GameScene/NodeUI/CompetitionSignUp.csb")
    self.m_csNode:addChild(node)
    self.m_SignNode = node

    local cNode = cc.Node:createFromCSFile("GameScene/NodeUI/CompetitionIng.csb")
    self.m_csNode:addChild(cNode)
    self.m_FightNode = cNode

    self.m_escape = 0
    self.m_shuaXin = 0
    if info and info.type then
        self.m_type = info.type or 1
    else
        self.m_type = 1
    end
    CompetitionManager:setServerType(self.m_type)
    self.m_stage = CompetitionManager:getNowStage(self.m_type)

    self:refresh()
    self:initFightNode()
end

function This:initFightNode()
    local node = self.m_FightNode
    self:initRankString(16)
    self:initRankString(8)
    self:initRankString(4)
    self:initRankString(2)
    node.play1_1.xuwei:setVisible(true)
    node.play1_1.player:setVisible(false)
    node.play1_1.zhandouzhong:setVisible(false)
end

function This:setRankString(index,rankList)
    local node = self.m_FightNode
    for i , role in ipairs(rankList) do
        if role and role.roleData and role.roleData.id > 0 then
            node["play"..index.."_"..i].player:setVisible(true)
            node["play"..index.."_"..i].xuwei:setVisible(false)
            node["play"..index.."_"..i].zhandouzhong:setVisible(false)
            node["play"..index.."_"..i].player.name:setString(role.roleData.name)
            node["play"..index.."_"..i].player.number:setString(tostring(role.count))
            if role.winId and role.winId == role.roleData.id then--isWin
                if node["play"..index.."_"..i].line1 then
                    node["play"..index.."_"..i].line1:setImage("Common/line94.png")
                else
                    node["play"..index.."_"..i].line2:setImage("Common/line96.png")
                end
                if index == 2 then
                    node.linezuo:setVisible(i == 1 and self.m_stage == 17)
                    node.lineyou:setVisible(i == 2 and self.m_stage == 17)
                end
            else
                if node["play"..index.."_"..i].line1 then
                    node["play"..index.."_"..i].line1:setImage("Common/line93.png")
                else
                    node["play"..index.."_"..i].line2:setImage("Common/line95.png")
                end
            end
        else
            node["play"..index.."_"..i].player:setVisible(false)
            node["play"..index.."_"..i].xuwei:setVisible(true)
            if index == 2 then
                node.linezuo:setVisible(false)
                node.lineyou:setVisible(false)
            end
            if node["play"..index.."_"..i].line1 then
                node["play"..index.."_"..i].line1:setImage("Common/line93.png")
            else
                node["play"..index.."_"..i].line2:setImage("Common/line95.png")
            end
        end 

    end
end

function This:initRankString(index)
    local node = self.m_FightNode
    for i = 1,index do
        node["play"..index.."_"..i].xuwei:setVisible(true)
        node["play"..index.."_"..i].player:setVisible(false)
        node["play"..index.."_"..i].jingcai:setVisible(false)
        node["play"..index.."_"..i].zhandouzhong:setVisible(false)
    end

end

function This:refresh()
    self:refreshTime()
    local node = self.m_SignNode
    -- local stage = nowStage
    self.m_stage = CompetitionManager:getNowStage(self.m_type)
    local stage = self.m_stage
    local isSignUp = CompetitionManager:getIsSignUp() == 1
    node:setVisible(stage<=CompetitionState.kWaitFight)
    node.baoming:setVisible(stage == CompetitionState.kSignUp or stage == CompetitionState.kCrossSignUp )
    node.baoming.button:setVisible(not isSignUp)
    node.baoming.yibaoming:setVisible(isSignUp)

    node.haixuan:setVisible(stage == CompetitionState.kSelection or stage == CompetitionState.kWaitFight)

    node.buzhen:setVisible(stage == CompetitionState.kArray)
    node.mingdan:setVisible(false)
    if self.m_type == 2 then
        self.m_csNode.beijing.title:setString(Serialize[60628])
    end

    node = self.m_FightNode
    node:setVisible(stage>CompetitionState.kWaitFight)
    if stage < CompetitionState.kSiQiangCompetition then
        node.zhanbao.zhanbao:setString(Serialize[60629])
    else
        node.zhanbao.zhanbao:setString(Serialize[60630])
    end
    if stage <= CompetitionState.kWaitFight then
        return
    end
    self.m_csNode.beijing.diban:setImage("GameScene/bgywzb2.jpg")
    local battleIndex =CompetitionManager:getBattleIndex()
    if battleIndex == 0 then
        battleIndex = 1
    end
    node.zhanqu:setString(string.format(Serialize[60631],battleIndex))
    node.zhanqu:setVisible(CompetitionManager:isCrossSever() and self.m_type ~= 1 )
    node.bgzhanqu:setVisible(CompetitionManager:isCrossSever() and self.m_type ~= 1)
    node.genghuan:setVisible(CompetitionManager:isCrossSever() and self.m_type ~= 1)
    local rankList16 = CompetitionManager:getBattleInfoWithFightType(battleIndex,16)
    local rankList8 = CompetitionManager:getBattleInfoWithFightType(battleIndex,8)
    local rankList4 = CompetitionManager:getBattleInfoWithFightType(battleIndex,4)
    local rankList2 = CompetitionManager:getBattleInfoWithFightType(battleIndex,2)
    local rankChamTion = CompetitionManager:getBattleInfoWithFightType(battleIndex,1)

    self:setRankString(16,rankList16)
    self:setRankString(8,rankList8)
    self:setRankString(4,rankList4)
    self:setRankString(2,rankList2)
    node.play1_1.player.number:setVisible(false)
    if #rankChamTion > 0 and  rankChamTion[1].roleData.id > 0 then
        node.play1_1.player.name:setString(rankChamTion[1].roleData.name)
        node.play1_1.player.number:setString("0")
        node.play1_1.player:setVisible(true)
        node.play1_1.zhandouzhong:setVisible(false)
        node.winnode.line2:setImage("Common/line96.png")
    else
        node.play1_1.player:setVisible(false)
        node.winnode.line2:setImage("Common/line95.png")

    end
    if stage < CompetitionState.kSiQiangCompetition then
        for i=1, 8 do
            node["play8_"..i].jingcai:setVisible(stage == CompetitionState.kBaQiangCompetition)
            node["play8_"..i].zhandouzhong:setVisible(stage == CompetitionState.kBaQiang)
            node["play8_"..i].xuwei:setVisible(stage ~= CompetitionState.kBaQiangCompetition and stage ~= CompetitionState.kBaQiang)
        end
    end
    if stage < CompetitionState.kBanjueSaiCompetition then
        for i = 1,4 do
            node["play4_"..i].jingcai:setVisible(stage == CompetitionState.kSiQiangCompetition)
            node["play4_"..i].zhandouzhong:setVisible(stage == CompetitionState.kSiQiang)
            node["play4_"..i].xuwei:setVisible(stage ~= CompetitionState.kSiQiangCompetition and stage ~= CompetitionState.kSiQiang)
        end
    end
    if stage < CompetitionState.kjueSaiCompetition then
        for i = 1,2 do
            node["play2_"..i].jingcai:setVisible(stage == CompetitionState.kBanjueSaiCompetition)
            node["play2_"..i].zhandouzhong:setVisible(stage == CompetitionState.kBanjueSai)
            node["play2_"..i].xuwei:setVisible(stage ~= CompetitionState.kBanjueSaiCompetition and stage ~= CompetitionState.kBanjueSai)
        end
    end
    -- if stage <= CompetitionState.kbutton then
        node.play1_1.jingcai:setVisible(stage == CompetitionState.kjueSaiCompetition)
        node.play1_1.zhandouzhong:setVisible(stage == CompetitionState.kjueSai) -- and not rankChamTion.name)
        node.play1_1.xuwei:setVisible(stage ~= CompetitionState.kjueSaiCompetition and stage < CompetitionState.kjueSai)
    -- end
end

function This:onEnter()
    super.onEnter(self)
    CompetitionManager:onGetSelfInfoRequest()
    local stage = self.m_stage
    if stage > CompetitionState.kWaitFight then
        CompetitionManager:onGetBatInfoRequest(self.m_type)
        if CompetitionManager:getBattleIndex() == 0 or self.m_type == 1 then
            CompetitionManager:onGetTeamFightDataRequest(1,self.m_type)
        else
            CompetitionManager:onGetTeamFightDataRequest(CompetitionManager:getBattleIndex(),self.m_type)
        end
    end
    CompetitionManager:addObserver(self)
end

function This:onExit()
    super.onExit(self)
    CompetitionManager:removeObserver(self)
end

function This:initTouchEvent()
	self.m_csNode.close:setTouchEnded(function()
		self:close()
    end)
    
    self.m_csNode.shuaxin:setTouchEnded(function()
        if self.m_shuaXin < 30 then
            return
        end
        self.m_shuaXin = 0
        self.m_stage = CompetitionManager:getNowStage(self.m_type)
        self:initFightNode()
        CompetitionManager:onGetSelfInfoRequest()
        local stage = self.m_stage
        if stage > CompetitionState.kWaitFight then
            CompetitionManager:onGetBatInfoRequest(self.m_type)
            -- if CompetitionManager:getIsSignUp() == 1 then
            --     CompetitionManager:onGetTeamFightDataRequest(CompetitionManager:getBattleIndex(),self.m_type)
            if CompetitionManager:getBattleIndex() == 0 then
                CompetitionManager:onGetTeamFightDataRequest(1,self.m_type)
            else
                CompetitionManager:onGetTeamFightDataRequest(CompetitionManager:getBattleIndex(),self.m_type)
            end
        end
    end)

    self.m_csNode.shop:setTouchEnded(function()
        g_scene:openDialog("Store.CompetitionShopPanel", {})
    end)

    local node = self.m_SignNode
    node.baoming.button:setTouchEnded(function ()
        -- g_scene:showTips(Serialize[60632])
        g_scene:openDialog("Competition.CompetitionDefenseFightPanel",{})

    end)

    -- node.mingdan.button:setTouchEnded(function ()
    --     g_scene:showTips(Serialize[60633])
    --     g_scene:openDialog("Competition.CompetitionNamelistPanel",{})
    -- end)

    node.buzhen.button:setTouchEnded(function ()
        -- g_scene:showTips(Serialize[60634])
        if CompetitionManager:getIsSignUp() == 0 then
            g_scene:showTips(Serialize[60635])
            return
        end
        g_scene:openDialog("Competition.CompetitionDefenseFightPanel",{})        
    end)

    node.guize:setTouchEnded(function ()
        -- g_scene:showTips(Serialize[60636])
        g_scene:openDialog("Competition.CompetitionRulePanel",{})
    end)

    local function setClick(index)
        local node = self.m_FightNode
        for i = 1,index do
            node["play"..index.."_"..i].jingcai.number:setTouchEnded(function ()
                local battleIndex =CompetitionManager:getBattleIndex()
                if battleIndex == 0 then
                    battleIndex = 1
                end
                local rankList16 = CompetitionManager:getBattleInfoWithFightType(battleIndex,index*2)
                if #rankList16 == 0 then
                    return
                end
                local role1 = rankList16[i*2-1].roleData
                local role2 = rankList16[i*2].roleData
                if not role1 or not role2 then
                    return
                end
                local roleData1 ={roleData ={id =role1.id,name =role1.name,icon = role1.icon,index =rankList16[i*2-1].index}}
                local roleData2 ={roleData ={id =role2.id,name =role2.name,icon = role2.icon,index =rankList16[i*2].index}}
                if  role1.id == 0 or role2.id == 0 then
                    g_scene:showTips(Serialize[60637])
                    return
                end
                if role1.id == GamePlayer:getPlayerID() or role2.id == GamePlayer:getPlayerID() then
                    g_scene:showTips(Serialize[60638])
                    return
                end
                g_scene:openDialog("Competition.BetsPanel",{playerDatas ={roleData1,roleData2}})
            end)
            node["play"..2*index.."_"..i*2-1].player.name:setTouchEnded(function()
                local battleIndex =CompetitionManager:getBattleIndex()
                if battleIndex == 0 then
                    battleIndex = 1
                end
                local rankList16 = CompetitionManager:getBattleInfoWithFightType(battleIndex,index*2)
                local role1 = rankList16[i*2-1].roleData
                if role1.id and role1.id > 0 then
                    g_scene:openDialog("Player.RoleInfoPanel",{id = role1.id})
                end
            end)
            node["play"..2*index.."_"..i*2].player.name:setTouchEnded(function()
                local battleIndex =CompetitionManager:getBattleIndex()
                if battleIndex == 0 then
                    battleIndex = 1
                end
                local rankList16 = CompetitionManager:getBattleInfoWithFightType(battleIndex,index*2)
                local role2 = rankList16[i*2].roleData
                if role2.id and role2.id > 0 then
                    g_scene:openDialog("Player.RoleInfoPanel",{id = role2.id})
                end
            end)
        end
    end

    node = self.m_FightNode
    setClick(8)
    setClick(4)
    setClick(2)
    setClick(1)

    node["play1_1"].player.name:setTouchEnded(function()
        local battleIndex =CompetitionManager:getBattleIndex()
        if battleIndex == 0 then
            battleIndex = 1
        end
        local rankList16 = CompetitionManager:getBattleInfoWithFightType(battleIndex,1)
        local role1 = rankList16[1].roleData
        if role1.id and role1.id > 0 then
            g_scene:openDialog("Player.RoleInfoPanel",{id = role1.id})
        end
    end)

    node.buzhen:setTouchEnded(function ()
        if CompetitionManager:getIsSignUp() ~= 1 then
            g_scene:showTips(Serialize[60639])
            return
        end
        if self.m_stage ~= CompetitionState.kBaQiangArray and self.m_stage ~=CompetitionState.kSiQiangArray and self.m_stage ~=CompetitionState.kBanjueSaiArray and self.m_stage ~= CompetitionState.kjueSaiArray then
            g_scene:showTips(Serialize[60640])
            return
        end

        g_scene:openDialog("Competition.CompetitionDefenseFightPanel",{})
    end)

    node.jingcai:setTouchEnded(function ()
        g_scene:openDialog("Competition.BetsInfoPanel",{serverType =self.m_type})     
    end)

    node.zhanbao:setTouchEnded(function ()
        if self.m_stage < CompetitionState.kSiQiangCompetition then
            -- node.zhanbao.zhanbao:setString(Serialize[60629])
            local battleIndex =CompetitionManager:getBattleIndex()
            if battleIndex == 0 then
                battleIndex = 1
            end
            CompetitionManager:onGetTeamInfoRequest(battleIndex)
            g_scene:openDialog("Competition.CompetitionResultPanel",{}) 
        else
            g_scene:openDialog("Competition.CompetitionAllBattleInfoPanel",{type = self.m_type})   
        end    
    end)

    node.wenhao:setTouchEnded(function ()
        g_scene:openDialog("Competition.CompetitionRulePanel",{})
    end)

    node.zhanqu:setTouchEnded(function ()
        CompetitionManager:onGetWarZoneRequest()
        g_scene:openDialog("Competition.CompetitionReplaceServerPanel",{})
        
    end)


end

function This:onSignUp()
    self:refresh()
end

function This:onGetSelfCompetitionInfo()
    self:refresh()
end

function This:onGetFightInfoWithBattleIndex()
    self:refresh()
end

function This:battlIndexChange()
    self:initFightNode()
    CompetitionManager:onGetSelfInfoRequest()
    local stage = self.m_stage
    if stage > CompetitionState.kWaitFight then
        CompetitionManager:onGetBatInfoRequest(self.m_type)
        -- if CompetitionManager:getIsSignUp() == 1 then
        --     CompetitionManager:onGetTeamFightDataRequest(CompetitionManager:getBattleIndex(),self.m_type)
        if CompetitionManager:getBattleIndex() == 0 then
            CompetitionManager:onGetTeamFightDataRequest(1,self.m_type)
        else
            CompetitionManager:onGetTeamFightDataRequest(CompetitionManager:getBattleIndex(),self.m_type)
        end
    end
end

function This:refreshTime()
    local node = self.m_SignNode
    local curTime = GamePlayer:getServerTime()
    local leftTime = CompetitionManager:getStageLeftTime()
    if leftTime <= 0 then
        leftTime = 0
    end
    -- print("kjjkjjkkkkupdata",leftTime)
    local stage = self.m_stage
    local foramtStr = CompetitionManager:getNowStageFormat()
    local timeStr = string.format( foramtStr,GameUtil:getFormatDtimeStr(leftTime))
    node.baoming.text:setString(timeStr)
    node.mingdan.text:setString(timeStr)
    node.buzhen.text:setString(timeStr)
    node.haixuan.text:setString(timeStr)

    if self.m_type==1 and CompetitionManager:isCrossSever() then
        leftTime =CompetitionManager:getStageByIndex(117).endTime - curTime
        if leftTime <= 0 then
            leftTime = 0
        end
        timeStr = string.format(CompetitionManager:getStageFarmatByIndex(117),GameUtil:getFormatDtimeStr(leftTime))
    end
    self.m_FightNode.time:setString(timeStr)
end

function This:update(dt)
    super.update(self,dt)
    self.m_escape = self.m_escape + dt
    self.m_shuaXin = self.m_shuaXin + dt
	if self.m_escape > 1 then
		self.m_escape = self.m_escape - 1
		self:refreshTime()
	end
end