-- @Author: Su
-- @Date:   2019-08-24 15:17:05
-- @Last Modified by:   zheng
-- @Last Modified time: 2019-09-05 15:03:17
-- @File Name: CompetitionMyBattleInfoPanel.lua
-- @Description:

local This, super = class(...,"Dialog")
local CompetitionManager = require("Competition.CompetitionManager")
local CompetitionBattleInfoItem = require("Competition.CompetitionBattleInfoItem")

local reportName = {
    [1] = "kFirstReport",
    [2] = "kSecondReport",
    [3] = "kThirstReport",
}

function This:initNode()
    self.m_csNode = cc.Node:createFromCSFile("GameScene/NodeUI/CompetitionMyBattleInfo.csb")
    self.m_csNode:setToCenter()
    self:addChild(self.m_csNode)
    self.m_reportList = {{},{},{}}
    self.m_itemList={}
    self.m_tabIndex = 1
    for i = 1,3 do
        self:addTabButton(reportName[i],self.m_csNode["tab"..i],function ()
            self.m_tabIndex = i
            self:refreshReportList()  
        end)
    end
    self:selectTabButton(reportName[1])
end

function This:onEnter()
    super.onEnter(self)
    CompetitionManager:addObserver(self)
end

function This:onExit()
    super.onExit(self)
    CompetitionManager:removeObserver(self)
end

function This:refreshReportList()
    local height = 180
    local scrollView = self.m_csNode.ScrollView
    local data = self.m_reportList[self.m_tabIndex]
    if data and data.report_list then
        for i , v in ipairs(data.report_list) do
            local item = self.m_itemList[i]
            if not item then
                item = CompetitionBattleInfoItem:create(v,i)
                item:hide()
                -- item:setPosition(0, height * (1 - i))
                scrollView:pushBackCustomItem(item,934,180,0.5)
            else
                item:setData(v,i)
                item:setVisible(true)
            end
            self.m_itemList[i] = item
        end
        local start,max = (#data.report_list+1),#self.m_itemList
        if max>=start then
            for i=start,max do
                local item = self.m_itemList[i]
                item:setVisible(false)
            end
        end
    end
end

function This:initTouchEvent()
	self.m_csNode.close:setTouchEnded(function()
		self:close()
	end)
end

function This:onGetRoleReportListData(reportList)
    self.m_reportList = reportList
    self:refreshReportList()
end