-- @Author: zheng
-- @Date:   2019-08-12 16:09:01
-- @Last Modified by:   zheng
-- @Last Modified time: 2019-08-26 10:06:27
-- @File Name: CompetitionReplaceServerPanel.lua

local CompetitionManager = require("Competition.CompetitionManager")
local GameUtil = require("Util.GameUtil")
local UpdateLayer = require("Rank.RankPageListLayer")
local CompetitionReplaceServerItemView = require("Competition.CompetitionReplaceServerItemView")
local This , super = class(...,"Dialog")
This.fileName = "GameScene/NodeUI/CompetitionReplaceServer.csb"
function This:initNode(info)
    self.m_csNode = cc.Node:createFromCSFile(This.fileName)
    self.m_csNode:setToCenter()
    self:addChild(self.m_csNode)
    self.m_serverMax = 0
    -- self:getData()
    self:initUpdateLayer()
    self:refresh()
end

function This:refresh()
    self.m_listLayer:setDataList()
end

function This:initUpdateLayer()
    local scrollView = self.m_csNode.ScrollView
    if scrollView then
         self.m_listLayer = UpdateLayer:create({
            itemWidth = 130,
            itemHeight = 40,
            spaceX = 5,
            spaceY = 5,
            column = 5,
            scrollView = scrollView,
            dataCounter = function ()
                return self.m_serverMax
            end,
         viewCreator =  function(index, node)
                local item = index
                -- local item = self.m_configlist[index]
                -- if item then
                    if not node then
                        return self:getScroolItem(item,index)
                    else
                        node:setModel(item, index)
                    end
                -- end
            end,
--            hint = self.m_selectIndex,
        })
        self.m_listLayer:setCascadeOpacityEnabled(true)
        self.m_listLayer:setAnchorPoint(0.5, 0)
        local w , h = self.m_listLayer:getContentSize()
        scrollView:pushBackCustomItem(self.m_listLayer, w, h, 0)
    end
end

function This:getScroolItem(data,index)
    local view = CompetitionReplaceServerItemView:create({data = data,closeFun = function (...)
        CompetitionManager:setNowBattleIndex(index)
        self:close()
    end})
    return view 
end

-- function This:getData()
--     self.m_serverMax = 100
--     -- local item1 = {name = "jack",level =55,score =463,rank = 0}
--     -- self.m_configlist = {item1,item1,item1,item1,item1,item1,item1,item1}
-- end

function This:onGetCrossServer(count)
    self.m_serverMax = count
    self:refresh()
end

function This:initTouchEvent()
    local csNode = self.m_csNode
    csNode.close:setTouchEnded(function()
        self:close()
    end)
end

-- function This:onBetPlayer()
--     self:getData()
--     self:refresh()
-- end

function This:onEnter()
    super.onEnter(self)
    CompetitionManager:addObserver(self)
end

function This:onExit()
    super.onExit(self)
    CompetitionManager:removeObserver(self)
end