-- @Author: zheng
-- @Date:   2019-08-13 16:56:46
-- @Last Modified by:   zheng
-- @Last Modified time: 2019-09-03 11:27:59
-- @File Name: HonorItemView.lua
local GameUtil = require("Util.GameUtil")
local This , super = class(...,"NodeUI")
local CompetitionManager = require("Competition.CompetitionManager")
This.fileName = "MenuScene/NodeUI/KingPalaceCompetitionItem.csb"

function This:initNode( achieve, index )
    local w,h = self.bg:getContentSize()
    local w2,h2 = self.chenghaobg:getContentSize()
    self:setContentSize(w,h+h2/2)
    self.m_data = achieve
    self.m_myIndex = index
    self:refresh()
end

function This:refresh(temData)
    if temData then
       self.m_data =  temData
    end
    local data = self.m_data
    if data.role_name then
        self.name:setString(data.role_name)
        GameUtil:setPlayerFeltNodeResource(self.icon,data.icon)
        GameUtil:btnGray(self.xin,data.reward_count==1)
    end
end

function This:onSupportPlayer(rewardType,honorInfo)
    local data = self.m_data
    if self.m_myIndex == rewardType and data.role_id== honorInfo.role_id then
        self.m_data = honorInfo
        self:refrsh()
    end
end

function This:onEnter()
    super.onEnter(self)
    CompetitionManager:addObserver(self)
end

function This:onExit()
    super.onExit(self)
    CompetitionManager:removeObserver(self)
end

function This:initTouchEvent()
    self.xin:setTouch({
        isContainer = self.m_myIndex ==2,
        onEnded = function()
            local data = self.m_data
            if data.reward_count ==0 then
                CompetitionManager:onSupportPlayerRequest(data.role_id,self.m_myIndex)
            end
        end,
        isScale = false, 
        isDynamic = true, 
    })
end

function This:onSupportPlayer(rewardType,info)
    if rewardType == self.m_myIndex and info.role_id == self.m_data.role_id then
       self:refresh() 
    end
end
