-- @Author: zheng
-- @Date:   2019-08-13 16:52:09
-- @Last Modified by:   zheng
-- @Last Modified time: 2019-09-05 16:57:46
-- @File Name: HonorTab.lua


local This , super = class(...,"NodeUI")
local CompetitionManager = require("Competition.CompetitionManager")
local GameUtil = require("Util.GameUtil")
local UpdateLayer = require("Rank.RankPageListLayer")
local HonorItemView = require("Competition.HonorItemView")
This.fileName = "MenuScene/NodeUI/KingPalaceCompetition.csb"

function This:initNode(info)
    CompetitionManager:onHonorInfoRequest()
    -- self.m_csNode = cc.Node:createFromCSFile(This.fileName)
    -- -- self.m_csNode:setToCenter()
    -- self:addChild(self.m_csNode)
   -- self:getData()
   -- self:refresh()
end


function This:getScroolItem(item,index)
    local view = HonorItemView:create(item,index)
    return view 
end

function This:getData()
    self.m_myServerWiner = CompetitionManager:getHonors()
    self.m_configlist = CompetitionManager:getOtherHonors()
end

function This:refreshMeInfo()
    local myWiner = self.m_myServerWiner
    local myWinerView = self.winer1.winer
    if myWiner and myWiner.role_id and myWiner.role_id ~=0 then
        if not myWinerView then
            myWinerView = self:getScroolItem(myWiner,1)
            self.winer1:addChild(myWinerView)
            self.winer1.winer= myWinerView
        else
            myWinerView:refresh(myWiner)
        end
    else
        myWiner = nil
    end
    self.noone1:setVisible(not myWiner)
    
end

function This:refreshOtherInfo()
    local otherServerWiner =self.m_configlist
    self.noone2:setVisible(#otherServerWiner==0)
    self:refreshScrollView()
end

function This:refresh()
    self:refreshMeInfo()
    self:refreshOtherInfo()
end

function This:refreshScrollView()
    local scrollView = self.scrollView
    scrollView:removeAllItems()
    scrollView:setDirection("horizontal")
    scrollView.m_direction = "right"
    for index, data in ipairs(self.m_configlist) do
        local view = self:getScroolItem(data,2)
        -- view:setAnchorPoint(0.5,0.5)
        local w , h = view:getContentSize()
        scrollView:pushBackCustomItem(view, w, h)
    end  
end

function This:initTouchEvent()
 --    item1:setTouchEnded(function()
	-- 	self:btnCallBack(btnType)
	-- end,item1.bg)
    
 --    self.zhengduo:setTouch({
 --            isScale = false,
 --            isDynamic = true,
 --            isContainer = true,
 --            onEnded = function()
 --                 self:close()
 --            end
 --        })
	
	local wenhao = self.wenhao
    if wenhao then
        wenhao:setTouchEnded(function()
            local text = Serialize["Competition_HonorTab_1"]
            g_scene:openDialog("UI.HelpTips", {text = text,node = wenhao})
        end)
    end
end

function This:onEnter()
    super.onEnter(self)
    CompetitionManager:addObserver(self)
end

function This:onExit()
    super.onExit(self)
    CompetitionManager:removeObserver(self)
end

function This:onHonorInfo()
    self:getData()
    self:refreshMeInfo()
end

function This:onHonorInfos()
    self:getData()
    self:refreshOtherInfo() 
end

-- function This:getData()
	
-- end