-- @Author: Su
-- @Date:   2019-11-13 15:17:05
-- @Last Modified by:   Su
-- @Last Modified time: 2019-11-13 15:17:05
-- @File Name: CrossServerBossDefenseItem.lua
-- @Description: 跨服boss
local This , super = class(...,"NodeUI")
local PeakContestTeamItemView = require("PeakContest.PeakContestTeamItemView")
local HeroManager = require("Hero.HeroManager")
local CrossServerBossManager = require("CrossServerBoss.CrossServerBossManager")

function This:initNode(info)
    local csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/CrossServerBossDefenseItem.csb")
    self.m_csNode = csNode
    
    self:addChild(csNode)
    -- csNode:setToCenter()

    self.m_cardList = info.cardList
    self.m_id = info.id
    self.m_isSelect = false
    self.m_bossConfig = CrossServerBossManager:getBossConfig()
    CrossServerBossManager:setIsUseGold(self.m_id,self.m_isSelect)
    self:initItem()
end

function This:getSize()
    local w,h = self.m_csNode.bg:getContentSize()
    return w,h
end

function This:initItem()
    if self.m_cardList then
        local width = 80
        for i = 1,6 do
            local hero = HeroManager:getHeroByUid(self.m_cardList[i])
            local awake = false
            if hero then
                awake = hero:isAwakeFull()
            end
            local item = PeakContestTeamItemView:create(hero,i,nil,awake)
			item:setPosition(width * (i - 3.5), 0 )
			item:setScale(0.78)
            self.m_csNode.troop:addChild(item)
        end
    end
    self.m_csNode.select.selected:setVisible(self.m_isSelect)
    self.m_csNode.troopBtn.dui:setString(string.format( Serialize[60676],self.m_id))
end

function This:getIsSelect()
    return self.m_isSelect
end

function This:refresh()
    self.m_csNode.select.selected:setVisible(self.m_isSelect)
    CrossServerBossManager:setIsUseGold(self.m_id,self.m_isSelect)
end

function This:initTouchEvent()
    self.m_csNode.select:setTouch({
        isScale = false, 
        isDynamic = true, 
        isContainer  = true,	
        isSwallow = false,
        onEnded =function() 
            if not self.m_isSelect then
                g_scene:openDialog("UI.CostConfirmPanel",{
                fileName = "MenuScene/NodeUI/CrossServerBossProblem.csb",
                notips = Serialize[60677],
                cost = self.m_bossConfig.buff_price,
                okHandler = function()
                    self.m_isSelect = not self.m_isSelect
                    self:refresh()
                end})
            else
                self.m_isSelect = not self.m_isSelect
                self:refresh()
            end
    end})

end