-- @Author: Su
-- @Date:   2019-11-13 15:17:05
-- @Last Modified by:   Su
-- @Last Modified time: 2019-11-13 15:17:05
-- @File Name: CrossServerBossDefensePanel.lua
-- @Description: 跨服boss

local This, super = class(..., "Dialog")
local CrossServerBossDefenseItem = require("CrossServerBoss.CrossServerBossDefenseItem")
local CrossServerBossManager = require("CrossServerBoss.CrossServerBossManager")

function This:initNode(info)
    local csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/CrossServerBossDefense.csb")
    self.m_csNode = csNode
    
    self:addChild(csNode)
    csNode:setToCenter()

    self.m_cardList = info.cardList
    self:initItem()
end

function This:initItem()
    if self.m_cardList then
        local scrollView = self.m_csNode.scrollView
        -- scrollView:removeAllChildren()
        scrollView:setDirection("vertical")
        for i,cardList in ipairs(self.m_cardList) do
            local item = CrossServerBossDefenseItem:create({cardList = cardList,id = i})
			item:setAnchorPoint(0.5,0.5)
			local w , h = item:getSize()
			scrollView:pushBackCustomItem(item, 660, 90 ,0.5)


        end

    end

end

function This:initTouchEvent()
    self.m_csNode.replace:setTouchEnded(function ()
        self:close()
        g_scene:openDialog("CrossServerBoss.CrossServerBossArrayPanel")
    end)

    self.m_csNode.close:setTouchEnded(function()
        self:close()
    end)

    self.m_csNode.change:setTouchEnded(function()
        local boss = CrossServerBossManager:getBoss()
        CrossServerBossManager:onFightBossRequest(boss:getId(),self.m_cardList)
        self:close()
    end)
end
