-- @Author: Su
-- @Date:   2019-09-17 11:30:53
-- @Last Modified by:   zheng
-- @Last Modified time: 2020-07-09 11:44:46
-- @File Name: CrossServerBossRewardPanel.lua
-- @Description: 

local This, super = class(..., "Dialog")
local CrossServerBossManager = require("CrossServerBoss.CrossServerBossManager")
local CrossServerBossRewardConfig = require("Metadatas.CrossServerBossRewardConfig")
local CrossServerBossRewardListItem = require("CrossServerBoss.CrossServerBossRewardListItem")
local GamePlayer = require("Player.GamePlayer")

function This:initNode(info)
    local csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/CrossServerBossReward.csb")
    self.m_csNode = csNode
    
    self:addChild(csNode)
    csNode:setToCenter()

    self:refresh()
end

function This:refresh()
    local node = self.m_csNode
    local itemNum = table.count(CrossServerBossRewardConfig)
    for i=101,100+itemNum do
        local item = CrossServerBossRewardListItem:create(CrossServerBossRewardConfig[i])
        -- item:setAnchorPoint(0.5,0.5)
        local w,h = item:getSize()
        node.scrollView:pushBackCustomItem(item,w,h,0.5)
    end
    local hurtList = CrossServerBossManager:getHurtList()
    local hasHurtList = false
    for i,hurtData in ipairs(hurtList) do
        hurtData.rank=i
        if GamePlayer:getPlayerID() == hurtData.role_id then
            node.me.number:setString(string.format(Serialize[60698],hurtData.rank))
            hasHurtList = true
        end
    end
    if not hasHurtList then
        node.me.number:setString(Serialize["family_BuildNode_7"])
    end
end

function This:initTouchEvent()

    self.m_csNode.beijing.closebg:setTouchEnded(function()
        self:close() 
    end)

end
