-- @Author: superm
-- @Date:   2018-05-18 10:54:21
-- @Last Modified by:   zheng
-- @Last Modified time: 2019-10-10 10:39:28
-- @File Name: DepotRuneTabNode.lua
-- @Description: 

local GameUtil = require("Util.GameUtil")
local RuneSkillConfig = require("Metadatas.RuneSkillConfig")
local This, super = class(..., "Depot.DepotBaseTabNode")
local DepotManager = require("Depot.DepotManager")
local RuneManager = require("Equip.RuneManager")
local RunePreviewItemView = require("Equip.RunePreviewItemView")
-- function This:isRune()
--     return false
-- end

function This:getDepotItemList()
    return RuneManager:getAllHaveBagRunesWithSort(true)
end

function This:refreshInfoUI(visible)
    if self.m_item and not self.m_item:isRune() then
    	return
    end
    self.m_csParentNode.xian1:setVisible(false)
    super.refreshInfoUI( self, visible )
    self:refreshCommon(self.m_csNode.fushi.have,self:getSelectedItem())
end

function This:refreshItemUI(visible)
	super.refreshItemUI(self, visible)
end

function This:refreshDescUI(visible)
	super.refreshDescUI(self, visible)
    if not visible then
        return
    end
end

function This:refreshButtonUI(visible)
    
end

function This:refreshCommon(node,data)
    if node.skilltext1 then
        local function refreshAttrItem(node1,info,index)
           local name = node["property"..index]
            if name then
                local value = node["property"..index.."num"]
                local nodes ={name,value}
                if info[1] then
                    for index,nodeView in ipairs(nodes) do
                        local value = info[index]
                        nodeView:setString(value)
                        nodeView:setVisible(true)
                    end
                else
                    for _,nodeView in pairs(nodes) do
                        nodeView:setVisible(false)
                    end
                end
            end 
        end
        local function refreshSkill(node1,info,index,skillId)
            local desNode = node["skillneirong"..index]
            if desNode then
                local name = node["skilltext"..index]
                local item1 = node["item"..index]
                local nodes ={desNode,name,item1}
                for _,itemNode in ipairs(nodes) do
                    itemNode:setVisible(info)
                end
                if info then
                    desNode:setString(info[1],387)
                    name:setString(info[2])
                    name:setColorByID("Q".. info[3])
                    local temInfo = {skillId =skillId}
                    if item1.itemNode then
                        item1.itemNode:refresh(temInfo)
                    else
                        local view = RunePreviewItemView:create(temInfo)
                        item1:addChild(view)
                        view:resetPosToCenter()
                        item1.itemNode = view
                    end
                end
            end 
        end

        local attrKeyValues = data:getAttr()
        local count= 0
        for key,value in pairs(attrKeyValues) do
            local name ,value = GameUtil:getAttrStr(key,value)
            local info= {name,value}
            count = count +1
            refreshAttrItem(node,info,count)
        end
        local maxCount = 2
        local temCount = count+1
        if temCount <=maxCount then
            for index=temCount,maxCount do
                refreshAttrItem(node,{},index)
            end
        end

        count= 0
        local skillIdList = data:getSkillIds()
        for index,skillId in pairs(skillIdList) do
            local skillItem = RuneSkillConfig[skillId]
            if skillItem then
                local quality = RuneSkillQualityConvert[skillItem.quality]
                local info ={skillItem.dec_1,skillItem.title,quality}
                refreshSkill(node,info,index,skillId)
                count = index
            end
        end
        local temCount = count+1
        maxCount = 2
        if temCount <=maxCount then
            for index=temCount,maxCount do
                refreshSkill(node,nil,index)
            end
        end
        local emptyTip = node.empty_tip
        if emptyTip then
            emptyTip:setVisible(#skillIdList == 0)
        end
    end
    local node1 = self.m_csNode.fushi
    GameUtil:refreshItemInfo(self.m_runeId or data:getId(),node1.fabao,node1.fabaoname,node1.text1,387)

end