-- @Author: superm
-- @Date:   2018-05-18 10:54:21
-- @Last Modified by:   superm
-- @Last Modified time: 2018-05-19 11:21:51
-- @File Name: DepotSpallTabNode.lua
-- @Description: 

local This, super = class(..., "Depot.DepotBaseTabNode")
local DepotManager = require("Depot.DepotManager")

function This:isProps()
    return false
end

function This:isSpall()
    return true
end

function This:isEquip()
    return false
end

function This:getDepotItemList()
    return DepotManager:getSpallItemList()
end

function This:refreshInfoUI(visible)
    if self.m_item and not self.m_item:isSpall() then
    	return
    end
    super.refreshInfoUI( self, visible )
end

function This:refreshItemUI(visible)
	super.refreshItemUI(self, visible)
    self.m_csNode.backpack.pieceicon:setVisible(visible)
end

function This:refreshDescUI(visible)
	super.refreshDescUI(self, visible)
    self.m_csNode.backpack.spalltxt:setVisible(visible)
    self.m_csNode.backpack.spall:setVisible(visible)
    if not visible then
        return
    end
    self.m_csNode.backpack.spall:setString(self.m_item:getCount() .. "/" .. self.m_item:getSynthesizeCost())
end

function This:refreshButtonUI(visible)
    self.m_csNode.backpack.sell:setVisible(visible)
    self.m_csNode.backpack.synthesis:setVisible(visible)
    self.m_csNode.backpack.spallnote:setVisible(false)
    self.m_csNode.backpack.spalllacknote:setVisible(false)
    if not visible then
        return
    end

    local state, isGotHero = self.m_item:canUsed()
    if not state then
        self.m_csNode.backpack.synthesis:setGrayShader()
        if isGotHero then
            self.m_csNode.backpack.spallnote:setVisible(true)
        else
            self.m_csNode.backpack.spalllacknote:setVisible(true)
        end
    else
        self.m_csNode.backpack.synthesis:clearShader()
    end
end