-- @Author: superm
-- @Date:   2018-02-26 10:57:59
-- @Last Modified by:   zheng
-- @Last Modified time: 2018-07-13 14:51:22
-- @File Name: ItemSynthesizeUI.lua
-- @Description: 

local This, super = class(..., "Depot.ItemUseUI")
local DepotManager = require("Depot.DepotManager")

function This:initNode()
    super.initNode(self)
    if self.m_item:isSpall() then
    	self.m_csNode.usebotton.text:setString(Serialize["depot_ItemSynthesize_1"])
    end
end

function This:initUseButtonTouchEvent()
    self.m_csNode.usebotton:setTouchEnded(function()
        if self.m_useCount > 0 then
            if self.m_item:isSpall() then
				DepotManager:synthesizeSpall(self.m_item, self.m_useCount)
            elseif self.m_item:isPlan() then
            	self.m_item:useAsPlan(self.m_useCount)
            else
            	DepotManager:useItem(self.m_item, self.m_useCount)
            end
            self:close()
        end
    end)
end

function This:updateUseCount(count)
	if self.m_item:isSpall() then
		local itemNum, itemSynthesizeUseNum = self.m_item:getCount(), self.m_item:getSynthesizeCost()
		local maxSynthesizeUseNum = math.modf(itemNum / itemSynthesizeUseNum);

	    count = math.min(count, maxSynthesizeUseNum)
	    count = math.max(count, 1)
	    if count ~= self.m_useCount then
	        self.m_useCount = count
	        self.m_csNode.usecount:setString(self.m_useCount)
	    end
	else
		super.updateUseCount(self, count)
	end
end