local This, super = class(..., "Dialog")
This.openSound = "open_box.mp3"

function This:initNode(info)
    self.m_csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/Reward.csb")
    self.m_csNode:setToCenter()
    self:addChild(self.m_csNode)
    self.m_allowTouch = false
    self.m_reward = info.reward
    self.m_isCompleteCount = info.isCompleteCount
    self.m_deltaY = info.deltaY or 0
    self.m_csNode.continue:setVisible(false)
end

function This:onTouchMask()
    if self.m_allowTouch then
        self:close()
    end
end

function This:onOpen()
    super.onOpen(self)
    local count = #self.m_reward
    local width = 77
    local deltaX = -0.5 * (count - 1) * width
    for index, itemInfo in ipairs(self.m_reward) do
        local itemNode = require("UI.ItemNode"):create(itemInfo.id or itemInfo[1], itemInfo.count or itemInfo[2], self.m_isCompleteCount)
        self.m_csNode.reward:addChild(itemNode)
        itemNode:showName()
        itemNode:setIsShowQualityEffect(true)
        itemNode:setOpacity(0)
        itemNode:setScale(0.1)
        itemNode:setPosition(deltaX, self.m_deltaY)
        itemNode:runAction(cc.Sequence(cc.DelayTime(index * 0.1), cc.Spawn(cc.FadeIn(0.2), cc.ScaleTo(0.3, 1, "BackOut"))))
        deltaX = deltaX + width
    end

    self:setTimer(0.3 + count * 0.1, function ()
        self.m_csNode.continue:runActionByID("ZoomInOut")
        self.m_allowTouch = true
    end)

    --local effect2 = cc.SkeletonNode:createPlayOnceEffect("HuoDe1")
    --effect2:setScale(math.min(1 +  count * 0.2, 2))
    --self.m_csNode:addChild(effect2)
end