-- @Author: Su
-- @Date:   2019-11-27 15:30:53
-- @Last Modified by:   Su
-- @Last Modified time: 2019-11-27 15:30:53
-- @File Name: BattleDrumGodHammerPanel.lua
-- @Description: 

local This, super = class(...,"Dialog")
local DrumManager = require("Drum.DrumManager")
local BattleDrumGodHammerColumnItem = require("Drum.BattleDrumGodHammerColumnItem")
local DrumHammerConfig = require("Metadatas.DrumHammerConfig") 

function This:initNode(info)
    self.m_csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/BattleDrumGodHammer.csb")
    self.m_csNode:setToCenter()
    self:addChild(self.m_csNode)
    self.m_DrumId = DrumManager:getDrumLevel()
    self.m_pos = info.pos
    self:initView()
end

function This:initView()
    local node= self.m_csNode
    local scrollview = node.scroll
    for i,data in ipairs(DrumHammerConfig) do
        data.pos = self.m_pos
        local item = BattleDrumGodHammerColumnItem:create(data)
        item:setAnchorPoint(0.5,0.5)
        local w,h =item:getSize()
        scrollview:pushBackCustomItem(item,w,h,0.5)
    end
end

function This:initTouchEvent()
    local node = self.m_csNode
    node.iconclose:setTouchEnded(function()
        self:close()
    end)
end