-- @Author: Su
-- @Date:   2019-11-28 16:45:40
-- @Last Modified by:   Su
-- @Last Modified time: 2019-11-28 16:45:40
-- @File Name: BattleDrumHammerSelectionPanel.lua

local This , super = class(...,"Dialog")
local GameUtil = require("Util.GameUtil")
local RoleChangePlayerItemChoiceItemView = require("Player.RoleChangePlayerItemChoiceItemView")
local DepotManager = require("Depot.DepotManager")

This.fileName = "MenuScene/NodeUI/BattleDrumHammerSelection.csb"

function This:initNode(info)

    self.m_csNode = cc.Node:createFromCSFile(This.fileName)
    self.m_csNode:setToCenter()
    self:addChild(self.m_csNode)

    self.m_itemData = info.itemData
    self:refresh()
end

function This:refresh()
    local node = self.m_csNode
    node.day:setVisible(false)
    node.bgbtn:setVisible(false)
    local item = RoleChangePlayerItemChoiceItemView:create(self.m_itemData)
    item:setScale(1.2)
    item:setBtnHandle(function (view)
        local csNode = self.m_csNode
        csNode.text:setVisible(false)
        csNode.bgbtn:setVisible(true)
        local viewList = csNode.iconhammer:getChildren()
        for index,item in ipairs(viewList) do
            if view:getId() == item:getId() then
                item:setSelect(true)
                self.m_selectIndex = index
            else
                item:setSelect(false)
            end
        end
    end)
    node.iconhammer:addChild(item)
end

function This:initTouchEvent()
    local node = self.m_csNode
    node.close:setTouchEnded(function()
        self:close()
    end)

    node.bgbtn:setTouchEnded(function()
        local itemId = self.m_itemData[1]
        if itemId and DepotManager:getItemCount(itemId)>0 then
            local item1 = DepotManager:getItem(itemId)
            DepotManager:useItem(item1, 1, 0) 
        else
            g_scene:showTips(Serialize[60731])
        end
        self:close()
    end)
end