-- @Author: Su
-- @Date:   2019-11-27 15:30:53
-- @Last Modified by:   Su
-- @Last Modified time: 2019-11-27 15:30:53
-- @File Name: BattleDrumLightCirclePanel.lua
-- @Description: 

local This, super = class(...,"Dialog")
local DrumManager = require("Drum.DrumManager")
local DrumHaloConfig = require("Metadatas.DrumHaloConfig")
local BattleDrumLightCircleText = require("Drum.BattleDrumLightCircleText")

function This:initNode()
    self.m_csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/BattleDrumLightCircle.csb")
    self.m_csNode:setToCenter()
    self:addChild(self.m_csNode)

    self.m_DrumId = DrumManager:getDrumLevel()
    self:initView()
end

function This:initView()
    local scroll = self.m_csNode.scroll
    for i,haloData in ipairs(DrumHaloConfig) do
        local strItem = BattleDrumLightCircleText:create(haloData)
        strItem:setAnchorPoint(0.5,0.5)
        local w,h =strItem:getContentSize()
        scroll:pushBackCustomItem(strItem,w,h+10,0.5)
    end
end

function This:initTouchEvent()
    local node = self.m_csNode
    node.close:setTouchEnded(function()
        self:close()
    end)

end
