-- @Author: Su
-- @Date:   2019-12-06 10:50:53
-- @Last Modified by:   Su
-- @Last Modified time: 2019-12-06 10:50:53
-- @File Name: BattleDrumLightCircleText.lua
-- @Description: 

local This , super = class(...,"NodeUI")
local DrumManager = require("Drum.DrumManager")
This.fileName = "MenuScene/NodeUI/BattleDrumLightCircleText.csb"

local ColorClass = {
    White   = {255, 255, 255},
    Yellow = {255, 255, 0},
    Gray = {77, 77, 77}
}

function This:initNode(info)
    self.m_data = info
    self:refresh()
end

function This:refresh()
    local attrubite = self.m_data.halo
    self.m_DrumId = DrumManager:getDrumLevel()
    local DrumId,isMax = DrumManager:getNextHaloLimitLevel(self.m_data.id)
    self.unlockdec:setVisible(self.m_DrumId < self.m_data.drum_id)
    self.drumstar:setVisible(self.m_DrumId >= self.m_data.drum_id)
    self.drumstar:setImage(self.m_data.halo_star)
    self.level:setString(self.m_data.halo_name)
    self.unlockdec:setString(self.m_data.halo_des)
    for i,attr in ipairs(attrubite) do
        self["effect"..i]:setString(string.format("%s",AttrName[attr[1]]))
        self["num"..i]:setString(string.format("+%d",attr[2]))
        self["num"..i]:setAnchorPoint(0, 0.5)
        if not isMax then
            if self.m_DrumId >= DrumId then
                self["effect"..i]:setColor(ColorClass.White[1],ColorClass.White[2],ColorClass.White[3])
                self["num"..i]:setColor(ColorClass.White[1],ColorClass.White[2],ColorClass.White[3])
            elseif self.m_DrumId < self.m_data.drum_id then
                self["effect"..i]:setColor(ColorClass.Gray[1],ColorClass.Gray[2],ColorClass.Gray[3])
                self["num"..i]:setColor(ColorClass.Gray[1],ColorClass.Gray[2],ColorClass.Gray[3])
            elseif self.m_DrumId >= self.m_data.drum_id and self.m_DrumId < DrumId then
                self["effect"..i]:setColor(ColorClass.Yellow[1],ColorClass.Yellow[2],ColorClass.Yellow[3])
                self["num"..i]:setColor(ColorClass.Yellow[1],ColorClass.Yellow[2],ColorClass.Yellow[3])
            end
        else
            if self.m_DrumId >= self.m_data.drum_id then
                self["effect"..i]:setColor(ColorClass.Yellow[1],ColorClass.Yellow[2],ColorClass.Yellow[3])
                self["num"..i]:setColor(ColorClass.Yellow[1],ColorClass.Yellow[2],ColorClass.Yellow[3])
            else
                self["effect"..i]:setColor(ColorClass.Gray[1],ColorClass.Gray[2],ColorClass.Gray[3])
                self["num"..i]:setColor(ColorClass.Gray[1],ColorClass.Gray[2],ColorClass.Gray[3])
            end
        end

    end
    if not isMax then
        if self.m_DrumId >= DrumId  then
            self.level:setColor(ColorClass.White[1],ColorClass.White[2],ColorClass.White[3])
            self.unlockdec:setColor(ColorClass.White[1],ColorClass.White[2],ColorClass.White[3])
        elseif self.m_DrumId < self.m_data.drum_id then
            self.level:setColor(ColorClass.Gray[1],ColorClass.Gray[2],ColorClass.Gray[3])
            self.unlockdec:setColor(ColorClass.Gray[1],ColorClass.Gray[2],ColorClass.Gray[3])
        elseif self.m_DrumId >= self.m_data.drum_id and self.m_DrumId < DrumId then
            self.level:setColor(ColorClass.Yellow[1],ColorClass.Yellow[2],ColorClass.Yellow[3])
            self.unlockdec:setColor(ColorClass.Yellow[1],ColorClass.Yellow[2],ColorClass.Yellow[3])
        end
    else
        if self.m_DrumId >= self.m_data.drum_id then
            self.level:setColor(ColorClass.Yellow[1],ColorClass.Yellow[2],ColorClass.Yellow[3])
            self.unlockdec:setColor(ColorClass.Yellow[1],ColorClass.Yellow[2],ColorClass.Yellow[3])
        else
            self.level:setColor(ColorClass.Gray[1],ColorClass.Gray[2],ColorClass.Gray[3])
            self.unlockdec:setColor(ColorClass.Gray[1],ColorClass.Gray[2],ColorClass.Gray[3])
        end
    end

end

function This:getContentSize()
    local w,h = self.kuang:getContentSize()
    return w,h
end