-- @Author: Su
-- @Date:   2019-11-27 15:30:53
-- @Last Modified by:   Su
-- @Last Modified time: 2019-11-27 15:30:53
-- @File Name: BattleDrumPreviewPanel.lua
-- @Description: 

local This, super = class(...,"Dialog")
local DrumManager = require("Drum.DrumManager")
local DrumAttributeTxt =require("Drum.DrumAttributeTxt")

function This:initNode()
    self.m_csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/BattleDrumPreview.csb")
    self.m_csNode:setToCenter()
    self:addChild(self.m_csNode)

    self.m_selectId = DrumManager:getDrumLevel()
    self.m_DrumId = DrumManager:getDrumLevel()
    self.m_strItemList = {}
    self:initView()
end

function This:initView()
    local node = self.m_csNode
    local drumConfig = DrumManager:getNowDrumConfig()
    node.drumname:setImage(drumConfig.drum_icon)
    node.bgdrumname:setImage(drumConfig.drum_icon3)
    node.level:setImage(drumConfig.drum_icon2)
    node.drumlevel:setVisible(false)
    node.level:setVisible(self.m_selectId ~= DrumManager:getMaxDrum())
    node.leftbtn:setVisible(self.m_selectId ~= 1)
    node.rightbtn:setVisible(self.m_selectId ~= DrumManager:getMaxDrum())
    local scrollView = node.scrollView
    local index = 1
    for i,attribute in pairs(drumConfig.attribute) do
        local str = string.format( "%s",AttrName[attribute[1]])
        local value = string.format( "+%d", attribute[2] )
        local item = DrumAttributeTxt:create({text = str,num = value, isGreen = false})
        item:setAnchorPoint(0.5,0.5)
        self.m_strItemList[index] = item
        index = index + 1
        scrollView:pushBackCustomItem(item,191,28,0.5)
    end

end

function This:refresh(id)
    if id < 1 or id == self.m_selectId or id > DrumManager:getMaxDrum() then
        return
    end
    self.m_selectId = id
    local node = self.m_csNode
    local drumConfig = DrumManager:getDrumConfigById(id)
    node.drumname:setImage(drumConfig.drum_icon)
    node.bgdrumname:setImage(drumConfig.drum_icon3)
    node.level:setImage(drumConfig.drum_icon2)
    node.level:setVisible(self.m_selectId ~= DrumManager:getMaxDrum())
    node.currentlevel:setVisible(self.m_selectId == self.m_DrumId)
    node.bgcurrentlevel:setVisible(self.m_selectId == self.m_DrumId)
    node.leftbtn:setVisible(self.m_selectId ~= 1)
    node.rightbtn:setVisible(self.m_selectId ~= DrumManager:getMaxDrum())
    local index = 1
    for i,attribute in pairs(drumConfig.attribute) do
        local str = string.format("%s",AttrName[attribute[1]])
        local value = string.format( "+%d", attribute[2] )
        self.m_strItemList[index]:refreshData({text = str,num = value,isGreen = id > self.m_DrumId})
        index = index + 1
    end


end

function This:initTouchEvent()
    local node = self.m_csNode
    node.close:setTouchEnded(function()
        self:close()
    end)

    node.leftbtn:setTouchEnded(function()
        self:refresh(self.m_selectId - 1)
    end)

    node.rightbtn:setTouchEnded(function()
        self:refresh(self.m_selectId + 1)
    end)



end