-- @Author: Su
-- @Date:   2019-12-05 20:30:53
-- @Last Modified by:   Su
-- @Last Modified time: 2019-12-05 20:30:53
-- @File Name: BattleDrumRankRewardPanel.lua
-- @Description: 

local This, super = class(...,"Dialog")
local DrumManager = require("Drum.DrumManager")
local ItemNode = require("UI.ItemNode")
local DrumRankConfig = require("Metadatas.DrumRankConfig")

function This:initNode(info)
    self.m_csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/BattleDrumRankReward.csb")
    self.m_csNode:setToCenter()
    self:addChild(self.m_csNode)
    self.m_rank = info.rank
    self:refresh()
end

function This:refresh()
    local rewardConfig
    for i,rankReward in ipairs(DrumRankConfig) do
        if self.m_rank >= rankReward.rank[1] then
            rewardConfig = rankReward.reward
        end
    end
    for i,info in ipairs(rewardConfig) do
        local node = ItemNode:create(info[1],info[2])
        node:setAnchorPoint(0.5,0.5)
        self.m_csNode["item"..i]:addChild(node)
    end
end

function This:initTouchEvent()
    self.m_csNode.closebg:setTouchEnded(function()
        self:close()
    end)
end