-- @Author: superm
-- @Date:   2018-01-04 20:09:49
-- @Last Modified by:   superm
-- @Last Modified time: 2018-01-04 21:00:22
-- @File Name: EquipChooseItemView.lua
-- @Description: 

local This , super = class(..., "UI.ItemNode")
local EquipManager = require("Equip.EquipManager")
local FabaoManager = require("Fabao.FabaoManager")

function This:init(type, uid, handler)
    self.m_inited = false
	self.m_type = type
    self.m_uid = uid
    self.m_handler = handler

	self:setDataForSuper()
end

function This:setDataForSuper()
	if self.m_type == ItemCommonType.kEquip then
		local equip = EquipManager:getEquip(self.m_uid)
		super.init(self, equip:getEquipId(), nil, false, false)
		self:setToEquip(equip:getStrengthLv(),equip:getLevel())
	elseif self.m_type == ItemCommonType.kFaBao then
		local fabao = FabaoManager:getFabao(self.m_uid)
		super.init(self, fabao:getItemId(), nil, false, false)
		self:setToFabao(fabao:getLevel(), fabao:getJinglianDegree(), fabao:getStarLevel())
	else
		error("error!")
	end
end

function This:initNode()
    self:refresh()
end

function This:onEnter()
	super.onEnter(self)
    if not self.m_inited then
		self:setTouch({
			isContainer = true,
			isDynamic = true,
			isSwallow = false,
			sizeNode = self.qualitybg,
			onEnded = function ()	
				if self.m_handler then
					self.m_handler(self.m_uid)
				end
			end,
			isScale = false
		})
        self.m_inited = true
	end
end

function This:setModel(uid)
	if uid ~= self.m_uid then
		self.m_uid = uid

		self:setDataForSuper()
	end
end