--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"Dialog")
local UpdateLayer = require("UI.UpdateLayer")
local EquipManager = require("Equip.EquipManager")
local FabaoManager = require("Fabao.FabaoManager")
local EquipConfig = require("Metadatas.EquipConfig")
local EquipChooseItemView = require("Equip.EquipChooseItemView")
local FabaoUtil = require("Fabao.FabaoUtil")

function This:initNode(info)
	if info.type then
		self.m_type = info.type
	else
		self.m_type = ItemCommonType.kEquip
	end
	self:initByInfo(info)
	self.m_csNode = cc.Node:createFromCSFile("GameScene/NodeUI/EquipChooseList.csb")
	self:addChild(self.m_csNode)
	self.m_csNode:setToCenter()

	self.m_layerLayer = UpdateLayer:create({
		itemWidth = 80,
		itemHeight = 80,
        spaceX = 2,
        spaceY = 5,
        column = 5,
        scrollView = self.m_csNode.equipScrollView,
	})

	self.m_layerLayer:setAnchorPoint(0.5,0)
	local w , h = self.m_layerLayer:getContentSize()
	self.m_csNode.equipScrollView:pushBackCustomItem(self.m_layerLayer, w, h,0)
	self.m_layerLayer:setDataList(self.m_equips, function(equipUid, index)
		return self:getEquipNode(equipUid, index)
	end)

	if info.emptyHint then
		self.m_csNode.text:setString(info.emptyHint)
	else
		if self.m_type == ItemCommonType.kFaBao then
			self.m_csNode.text:setString(Serialize[60750])
		end
	end

	self.m_csNode.text:setVisible(#self.m_equips <= 0)
end

function This:initByInfo( info )
	-- assert(info.pos)
	self.m_selectHandler = nil
	self.m_pos = info.pos
	if info.type then
		self.m_type = info.type
	else
		self.m_type = ItemCommonType.kEquip
	end
	if self.m_type == ItemCommonType.kFaBao then
		local fabaoList = {}
		for _, fabaoUid in ipairs(FabaoManager:getUnequippedFabaoUidList(self.m_pos)) do
			if info.filter then
				if info.filter(fabaoUid) then
					table.insert(fabaoList, fabaoUid)
				end
			else
				table.insert(fabaoList, fabaoUid)
			end
		end
		table.sort(fabaoList, function(left, right)
			return FabaoUtil.fabaoSortFunc(FabaoManager:getFabao(left):asItem(), FabaoManager:getFabao(right):asItem())
		end)
		self.m_equips = fabaoList
	else
		self.m_equips = EquipManager:getEquipUnWeared(self.m_pos)
	end
end

function This:getEquipNode(uid)
	local node = EquipChooseItemView:create(self.m_type, uid, function(uid)
		if self.m_selectHandler then
			self.m_selectHandler(uid)
		end
		self:close()
	end)
	node:setScale(0.92)
	return node
end

function This:setSelectHandler(handler)
	self.m_selectHandler = handler
end

function This:initTouchEvent()
	self.m_csNode.gobuy:setTouchEnded(function()
		print("去购买...")
		self:close()
	end)
end

function This:onTouchMask()
	self:close()
end

--endregion
