-- @Author: ZYY
-- @Date:   2018-08-25 17:58:29
-- @Last Modified by: ZYY
-- @Last Modified time: 2018-09-13 09:55:54
-- @File Name: EquipClearMasterItemView.lua
-- @Desc: 强化共鸣装备Item
local This , super = class(...,"NodeUI")
local ItemUtil = require("Bag.ItemUtil")
local FoundationAttributeConfig = require("Metadatas.FoundationAttributeConfig")
local ItemNode = require("UI.ItemNode")
This.fileName = "GameScene/NodeUI/EquipClearMasterItem.csb"

local MasterSubTabType = {
	Strength = 1,	--强化
	Clear = 2,		--洗炼
}

function This:initNode(equip,select)
	self.m_equip = equip
	self.m_select = select
	self.m_id = equip:getEquipId()
end

function This:refresh()
	self.qianghua.name:setString(ItemUtil.getName(self.m_id))
	if not self.equipItem then 
		self.equipItem = ItemNode:create(self.m_id)
		self.equipItem:setScale(0.75)
		self.equipItem:setAnchorPoint(0.5,0.5)
		self.item:addChild(self.equipItem)
	else
		self.m_itemNode:initItem(self.m_id)
	end
	if self.m_select == MasterSubTabType.Strength then 
		local lv = self.m_equip:getStrengthLv()
		local level = self.m_equip:getLevel()
		self.equipItem:setToEquip(lv,level)
		-- self.qianghua.lv:setString( "+" .. lv)
		-- self.qianghua.lv:setVisible(true)
		self.qianghua.proLv:setString( lv .. "/10")
		self.qianghua.jindutiao:setPercent(lv / 10 * 100)
	elseif self.m_select == MasterSubTabType.Clear then 
		local clearList = self.m_equip:getClearList()
		local star = 0
		local maxStar = 0
		for _, v in pairs(clearList) do 
		    local attr = FoundationAttributeConfig[v]
		    star = star + attr.star_level
		    local maxId = v
		    for i = v + 1, #FoundationAttributeConfig do 
		        if FoundationAttributeConfig[i].equip_type == attr.equip_type and FoundationAttributeConfig[i].attribute_type == attr.attribute_type then 
		            maxId = i
		        else
		            break
		        end
		    end
		    maxStar = maxStar + FoundationAttributeConfig[maxId].star_level
		end
		self.equipItem:setToNormal()
		-- self.qianghua.lv:setVisible(false)
		self.qianghua.proLv:setString( star .. "/".. maxStar)
		self.qianghua.jindutiao:setPercent(star / maxStar * 100)
	end
end

function This:onEnter()
	super.onEnter(self)
	self:refresh()
end

function This:onExit()
	super.onExit(self)
end

function This:initTouchEvent()

end

function This:setData(equip,select)
	self.m_equip = equip 
	self.m_select = select
	self.m_id = equip:getEquipId()
	self:refresh()
end