-- @Author: ZYY
-- @Date:   2018-08-20 15:44:17
-- @Last Modified by:   superm
-- @Last Modified time: 2019-01-02 10:30:19
-- @File Name: EquipClearMasterPanel.lua
-- @Desc: 装备大师界面

local This, super = class(...,"Dialog")
local EquipManager = require("Equip.EquipManager")
local HeroManager = require("Hero.HeroManager")
local EquipClearMasterItemView = require("Equip.EquipClearMasterItemView")
local EquipClearMasterValueNode = require("Equip.EquipClearMasterValueNode")
local GamePlayer = require("Player.GamePlayer")

function This:initNode(info)
    self.m_csNode = cc.Node:createFromCSFile("GameScene/NodeUI/EquipClearMaster.csb")
    self.m_csNode:setToCenter()
	self:addChild(self.m_csNode)
	self.m_Node = EquipClearMasterValueNode:create()
	self.m_csNode.nodeAttr:addChild(self.m_Node)	

	if info.tabType then
		self.m_select = info.tabType
	end
	print_tmp(info)
	self.m_heroId = info.heroId
    self.m_select = self.m_select or EquipClearMasterSubTabType.Strength
	self.m_equipUidList = {}
	self.m_equipItemList = {}
	local hero = HeroManager:getHero(self.m_heroId)
	self.heroUid = hero:getUid()
	for i = EquipPos.kWeapons , EquipPos.kHorse do
		local uid = hero:getEquipUid(i)
		if uid and uid > 0 then 
			table.insert(self.m_equipUidList,uid)
		end
	end
	self:refresh()
	self:selectSubTabButton(self.m_select)
	self.m_csNode.tab2.suo:setVisible(GamePlayer:getLevel() < ClearOpenLevel)
end

function This:refresh()
	for i , uid in ipairs(self.m_equipUidList) do 
		local itemNode = self.m_equipItemList[i]
		local equip = EquipManager:getEquip(uid)
		if not itemNode then
			local itemNode = EquipClearMasterItemView:create(equip,self.m_select)
			itemNode:setPosition(0, -(i - 1) * 100)
			self.m_csNode.nodeEquip:addChild(itemNode)
		else
			itemNode:setData(equip,self.m_select)
		end 			
	end
end

function This:updateEquipMasterAttr(attr)
	if attr.type == EquipMasterType.Strength then 
		self.m_csNode.titleType:setString(Serialize[60754])
		self.m_csNode.title1:setString(Serialize[60755])
	elseif attr.type == EquipMasterType.Clear then 
		self.m_csNode.titleType:setString(Serialize[60756])
		self.m_csNode.title1:setString(Serialize[60757])
	end
	self.m_Node:setNodeData(attr)
	self:refresh()
end

function This:initTouchEvent()
	self.m_csNode.close:setTouchEnded(function()
		self:close()
	end)
	for i , Type in pairs(EquipClearMasterSubTabType) do 
		self.m_csNode["tab"..Type]["normal"]:setTouchEnded(function()
	    	if Type == EquipClearMasterSubTabType.Clear and GamePlayer:getLevel() < ClearOpenLevel then 
	    		g_scene:showTips(Serialize[60758]..ClearOpenLevel ..Serialize[60759])
	    		return false
	    	end			
			self.m_select = Type
			self:selectSubTabButton(Type)
		end)
	end
end

function This:selectSubTabButton(selectType)
	for i, Type in pairs(EquipClearMasterSubTabType) do
		if selectType == Type then 
			self.m_csNode["tab"..Type]["normal"]:setVisible(false)
			self.m_csNode["tab"..Type]["light"]:setVisible(true)
		else
			self.m_csNode["tab"..Type]["normal"]:setVisible(true)
			self.m_csNode["tab"..Type]["light"]:setVisible(false)
		end
	end
	EquipManager:onReqEquipMaster(self.heroUid,self.m_select)
end

function This:onEnter()
	super.onEnter(self)
	EquipManager:addObserver(self)
	self:refresh()
end

function This:onExit()
	EquipManager:removeObserver(self)
	super.onExit(self)
end
