-- @Author: ZYY
-- @Date:   2018-08-25 17:21:30
-- @Last Modified by: ZYY
-- @Last Modified time: 2018-09-01 14:59:52
-- @File Name: EquipClearMasterValueNode.lua
-- @Desc: 洗炼大师子界面
local This , super = class(...,"NodeUI")
local GameUtil = require("Util.GameUtil")
local ReinforcementImpactConfig = require("Metadatas.ReinforcementImpactConfig")
local AffinationImpactConfig = require("Metadatas.AffinationImpactConfig")
This.fileName = "GameScene/NodeUI/EquipClearMasterValue.csb"

EquipMasterType = {
	Strength = 1 ,
	Clear = 2,
}

TitleName = {
	[1] = { text = Serialize[60762], level = Serialize[60763] ,config = ReinforcementImpactConfig},
	[2] = { text = Serialize[60756], level = Serialize[60764] ,config = AffinationImpactConfig,},
}

function This:initNode()
	self.m_type = 1
	self.m_id = 0
end

function This:refresh()
	if self.m_id == 0  or self.m_id == #TitleName[self.m_type].config then 
		self.info:setVisible(false)
		self.jihuo:setVisible(true)
		self:updateNoActivation()
	else
		self.info:setVisible(true)
		self.jihuo:setVisible(false)		
		self:updateActivation()
	end

end

function This:updateNoActivation()
	local info
	local typeName = TitleName[self.m_type]
	local function setTextColor(colorId)
		self.jihuo.num.title:setColorByID(colorId)
		self.jihuo.num.level:setColorByID(colorId)
		self.jihuo.num.text1:setColorByID(colorId)
		self.jihuo.num.text2:setColorByID(colorId)
		self.jihuo.num.text3:setColorByID(colorId)
		self.jihuo.num.text4:setColorByID(colorId)
		self.jihuo.num.attr1:setColorByID(colorId)
		self.jihuo.num.attr2:setColorByID(colorId)
		self.jihuo.num.attr3:setColorByID(colorId)
		self.jihuo.num.attr4:setColorByID(colorId)
	end
	if self.m_id == 0 then 
		info = typeName.config[1]
		self.jihuo.num.title:setString(string.format(Serialize[60765],typeName.text))
		self.jihuo.num.level:setString(string.format(typeName.level,info.level_min))
		for i = 1 , 5 do 
			if i > info.number then
				self.jihuo.num["attr"..i]:setVisible(false)
				self.jihuo.num["text"..i]:setVisible(false)
				break
			end
			self.jihuo.num["attr"..i]:setVisible(true)
			self.jihuo.num["text"..i]:setVisible(true)
			local text,num = GameUtil:getAttrStr(info["Attribute"..i][1],info["Attribute"..i][2])
			self.jihuo.num["attr"..i]:setString(info["Attribute"..i][2])
			self.jihuo.num["text"..i]:setString(text)
		end	
		setTextColor("New8")
	else 
		info = typeName.config[#typeName.config]
		self.jihuo.num.title:setString(string.format(Serialize[60766],typeName.text,self.m_id))
		self.jihuo.num.level:setString(string.format(typeName.level,info.level_min))
		for i = 1 , 5 do 
			if i > info.number then
				self.jihuo.num["attr"..i]:setVisible(false)
				self.jihuo.num["text"..i]:setVisible(false)
				break
			end
			self.jihuo.num["attr"..i]:setVisible(true)
			self.jihuo.num["text"..i]:setVisible(true)
			local text,num = GameUtil:getAttrStr(info["Attribute"..i][1],info["Attribute"..i][2])
			self.jihuo.num["attr"..i]:setString(info["Attribute"..i][2])
			self.jihuo.num["text"..i]:setString(text)
		end	
		setTextColor("A1")
	end
end

function This:updateActivation()
	local typeName = TitleName[self.m_type]
	local info1 = typeName.config[self.m_id]
	local info2 = typeName.config[self.m_id + 1]
	self.info.num1.title:setString(string.format(Serialize[60767],typeName.text,self.m_id))
	self.info.num1.level:setString(string.format(typeName.level,info1.level_min))
	self.info.num2.title:setString(string.format(Serialize[60767],typeName.text,self.m_id + 1))
	self.info.num2.level:setString(string.format(typeName.level,info2.level_min))
	for i = 1 , 5 do 
		if i > info1.number then
			self.info.num1["attr"..i]:setVisible(false)
			self.info.num1["text"..i]:setVisible(false)
			self.info.num2["attr"..i]:setVisible(false)
			self.info.num2["text"..i]:setVisible(false)
			break
		end
		local text,num = GameUtil:getAttrStr(info1["Attribute"..i][1],info1["Attribute"..i][2])
		self.info.num1["attr"..i]:setString(info1["Attribute"..i][2])
		self.info.num1["text"..i]:setString(text)
		self.jihuo.num["text"..i]:setString(text)
		text,num = GameUtil:getAttrStr(info2["Attribute"..i][1],info2["Attribute"..i][2])
		self.info.num2["attr"..i]:setString(info2["Attribute"..i][2])
		self.info.num2["text"..i]:setString(text)
		self.jihuo.num["text"..i]:setString(text)
	end	
end


function This:onEnter()
	super.onEnter(self)
	self:refresh()
end

function This:onExit()
	super.onExit(self)
end

function This:initTouchEvent()

end

function This:setNodeData(attr)
	self.m_type = attr.type
	self.m_id = attr.strength_id
	self:refresh()
end