-- @Author: ZYY
-- @Date:   2018-08-27 20:49:24
-- @Last Modified by: ZYY
-- @Last Modified time: 2018-09-01 16:47:57
-- @File Name: EquipClearProblemPanel.lua
-- @Desc: 5星提醒窗口
local This, super = class(...,"Dialog")
local StarColorConfig = require("Metadatas.StarColorConfig")

local TipsValue = {}

function This:initNode(info)
    self.m_csNode = cc.Node:createFromCSFile("GameScene/NodeUI/EquipClearProblem.csb")
    self.m_csNode:setToCenter()
	self:addChild(self.m_csNode)
	self.m_noTipsKey = info.notips
	self.m_okHandler = info.okHandler
	self.m_type = info.type
	local quality = StarColorConfig[ClearOpenTipsLevel].star_color
	self.m_csNode.clear.star:setImage(string.format("Common/star%d.png",quality + 1)) 
	self.m_csNode.clear.text:setString(string.format(Serialize[60779],ClearOpenTipsLevel))
	self:refresh()
end

function This:refresh()
	if self.m_type == 1 then 
		self.m_csNode.clear:setVisible(true)
		self.m_csNode.shengjie:setVisible(false)
	elseif self.m_type == 2 then 
		self.m_csNode.clear:setVisible(false)
		self.m_csNode.shengjie:setVisible(true)
	end
end

function This:initTouchEvent()
	self.m_csNode.cancelButton:setTouchEnded(function()
		if self.m_cancelHandler then
			self.m_cancelHandler()
		end
		self:close()
	end)

	self.m_csNode.confirmButton:setTouchEnded(function()
		if self.m_okHandler then
			self.m_okHandler()
		end	
		if self.m_noTipsValue then
			TipsValue[self.m_noTipsKey] = true
		end
		self:close()
	end)

	if self.m_csNode.kuang then
		self.m_csNode.kuang:setTouchEnded(function()
	        local visible = self.m_csNode.gou:isVisible()
	        self.m_csNode.gou:setVisible(not visible)
	        self.m_noTipsValue = not visible
		end)
	end

	self.m_csNode.close:setTouchEnded(function()
		if self.m_cancelHandler then
			self.m_cancelHandler()
		end
		self:close()
	end)
end

function This:onTouchMask()

end


function This:onEnter()
	if self:existNoTipsKey(self.m_noTipsKey) then
    	if self.m_okHandler then
	        self.m_okHandler(true)
        end	
		self:close()
	end 
	super.onEnter(self)
end

function This:existNoTipsKey(str)
    if TipsValue[str] then
    	return true
    end
end
