-- @Author: ZYY
-- @Date:   2018-08-23 17:55:08
-- @Last Modified by:   zheng
-- @Last Modified time: 2019-01-23 11:44:58
-- @File Name: EquipClearStonePanel.lua
-- @Desc: 洗炼石购买界面

local This, super = class(...,"Dialog")
local EquipManager = require("Equip.EquipManager")
local GamePlayer = require("Player.GamePlayer")
local AffinationStoreConfig = require("Metadatas.AffinationStoreConfig")
local GameUtil = require("Util.GameUtil")

local maxNum = 5 --总购买次数
local itemNum = 3 --物品个数
function This:initNode()
    self.m_csNode = cc.Node:createFromCSFile("GameScene/NodeUI/EquipClearStone.csb")
    self.m_csNode:setToCenter()
    self.m_buyTimeList = {}
	self:addChild(self.m_csNode)
	EquipManager:onReqStoneData()
	self:refresh()
end

function This:refresh()
	for i = 1 , itemNum do 
		local item1 = self.m_csNode["item"..i]
		local data = AffinationStoreConfig[i]
		local discount = data.discount
		local rewards = data.reward
		local discountNode = item1.discount_node
		discountNode:setVisible(discount ~=10)
		for itemIndex,itemConfig in ipairs(rewards) do
			local icon = item1["icon"..itemIndex]
			GameUtil:creatItemNode(icon,itemConfig)
			local txt = discountNode["discount"..itemIndex]	
			txt:setString(discount .. Serialize[60327])
		end
        item1["button"]["text"]:setString(data.price)
	end
	self.m_csNode.money.num:setString(GamePlayer:getDiamond())
end

function This:initTouchEvent()
	self.m_csNode.beijing.closebg:setTouchEnded(function()
		self:close()
	end)
	self.m_csNode.money.add:setTouchEnded(function ()
		g_scene:openDialog("System.RechargeMainUI")
	end)

	for i = 1, itemNum do 
		self.m_csNode["item"..i].button:setTouchEnded(function()
			if self.m_buyTimeList[i] and self.m_buyTimeList[i] <= 0 then 
				g_scene:showTips(Serialize[60781])
			else
				EquipManager:onReqStoneBuy(i)
			end
		end)		
	end
end

function This:onTouchMask()

end

function This:updateBuyNumber(buyList)
	for i , v in pairs(buyList) do 
		local t = v.buy_type
		if AffinationStoreConfig[t].limit_frequency == 0 then 
			self.m_csNode["item"..t].xiangou:setVisible(false)
		else
			local num = AffinationStoreConfig[t].limit_frequency - v.buy_time
			if num < 0 then 
				num = 0
			end
			self.m_buyTimeList[t] = num
			self.m_csNode["item"..t].xiangou:setVisible(true)
			self.m_csNode["item"..t].xiangou:setString(string.format(Serialize[60782],num,AffinationStoreConfig[t].limit_frequency))
		end
	end
end

function This:onEnter()
	super.onEnter(self)
	GamePlayer:addObserver(self)
	EquipManager:addObserver(self)
	self:refresh()
end

function This:onExit()
	EquipManager:removeObserver(self)
	GamePlayer:removeObserver(self)
	super.onExit(self)
end

function This:onPlayerAttrChanged(attrId)
	if attrId == PlayerAttr.diamond then
		self:refresh()
	end
end