--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"UI.HelpTips")
local EquipManager = require("Equip.EquipManager")
local ItemNode = require("UI.ItemNode")
local HeroManager = require("Hero.HeroManager")
local AffinationFactorConfig = require("Metadatas.AffinationFactorConfig")
local FoundationAttributeConfig = require("Metadatas.FoundationAttributeConfig")
local StarColorConfig = require("Metadatas.StarColorConfig")
local GamePlayer = require("Player.GamePlayer")

function This:initNode(info)
	assert(info.equipUid and info.pos and info.heroId and info.node)
	self.m_equipUid = info.equipUid
	self.m_pos = info.pos
	self.m_heroId = info.heroId
	self.m_csNode = cc.Node:createFromCSFile("GameScene/NodeUI/EquipTips.csb")
	self:addChild(self.m_csNode)
	self.m_csNode:setToCenter()
	self:refreshAttr()

	-- self.m_csNode.fabao
	--[[local worldx , worldy = info.node:convertToWorldSpace(0,0)
	local selfw, selfh = self.m_csNode:getContentSize()
	local nodew, nodeh = info.node:getContentSize()
	local x , y = self:getFixScreenPosition(worldx,worldy,nodew,nodeh,selfw,selfh)
	self.m_csNode:setPosition(x,y)]]
end

function This:refreshAttr()
	local equip = EquipManager:getEquip(self.m_equipUid)
	local curLv = equip:getStrengthLv()    
	local level = equip:getLevel()
	local eItem = equip:getItem()
	local config = equip:getConfig()
	self.m_csNode.equipname:setString(config.name)
	self.m_csNode.strengthen:setVisible(false)
	if eItem and eItem:canUsedForStrength() then
		-- self.m_csNode.strengthenbotton:clearShader()
		self.m_csNode.strengthenbotton:setVisible(true)
		self.m_csNode.clearbotton:setVisible(false)
	else
		self.m_csNode.strengthenbotton:setVisible(false)
		self.m_csNode.clearbotton:setVisible(true)
		-- self.m_csNode.strengthenbotton:setGrayShader()
	end

	if self.m_itemNode == nil then
        local itemNode = ItemNode:create(equip:getEquipId())
        itemNode:setAnchorPoint(0.5,0.5)
		itemNode:setToEquip(curLv,level)
		self.m_csNode.fabao:addChild(itemNode)
		self.m_itemNode = itemNode
    else
        self.m_itemNode:initItem(equip:getEquipId())
		self.m_itemNode:setToEquip(curLv,level)
    end
	--升阶按钮
	-- if eItem and eItem:canUsedForAscend() then
	-- 	self.m_csNode.ascend:clearShader()
	-- else
	-- 	self.m_csNode.ascend:setGrayShader()
	-- end

	local attr = equip:getAddAttr()
	for i , info in ipairs(attr) do
		self.m_csNode["jishushuxing"]["property"..i]:setString(AttrName[info.attrId])
		self.m_csNode["jishushuxing"]["property"..i.."num"]:setString(string.format("+%d",info.value))
	end
	for i = #attr + 1 , 3 do
		self.m_csNode["jishushuxing"]["property"..i]:setVisible(false)
		self.m_csNode["jishushuxing"]["property"..i.."num"]:setVisible(false)
	end
	self.m_csNode.equipdes:setString(config.desp, AppText:isEnglish() and (320/self.m_csNode.equipdes:getScale()) or nil)
	local equipId = equip:getEquipId()
	EquipManager:onReqSeeEquipClearData(self.m_equipUid,equipId)

	local levelAttr = equip:getUpLevelAttr()
	local index = 1
	for id , value in pairs(levelAttr) do
		self.m_csNode.upvalue["name"..index]:setString(AttrName[id])
		self.m_csNode.upvalue["num"..index]:setString(string.format("+%d",value)) 

		self.m_csNode.upvalue["name"..index]:setVisible(true)
		self.m_csNode.upvalue["num"..index]:setVisible(true)
		index = index + 1
	end
	for i=index,3 do
		self.m_csNode.upvalue["name"..i]:setVisible(false)
		self.m_csNode.upvalue["num"..i]:setVisible(false)
	end


	self.m_csNode.tips:setVisible(GamePlayer:getLevel() < ClearOpenLevel)
	self.m_csNode.clear:setVisible(GamePlayer:getLevel() >= ClearOpenLevel)
end

function This:initTouchEvent()
	local equip = EquipManager:getEquip(self.m_equipUid)
	self.m_csNode.strengthenbotton:setTouchEnded(function()
		if equip:getItem():canUsedForStrength(true) then
			g_scene:openDialog("Equip.EquipStrengthPanel",{equipUid = self.m_equipUid, heroId = self.m_heroId, equipType = equip:getWearPos()})
		end
	end)
	
	self.m_csNode.clearbotton:setTouchEnded(function()
		if GamePlayer:getLevel() < ClearOpenLevel then 
			g_scene:showTips(string.format(Serialize[60796],ClearOpenLevel))
			return 
		end
		g_scene:openDialog("Equip.EquipStrengthPanel",{equipUid = self.m_equipUid, subTab = "Clear", heroId = self.m_heroId, equipType = equip:getWearPos()})
	end)
	-- self.m_csNode.ascend:setTouchEnded(function()
	-- 	if equip:getItem():canUsedForAscend(true) then
	-- 		g_scene:openDialog("Equip.EquipStrengthPanel",{equipUid = self.m_equipUid, heroId = self.m_heroId, subTab = "Ascend", equipType = equip:getWearPos()})
	-- 	end
	-- end)
	
	self.m_csNode.replace:setTouchEnded(function()
		local dialog = g_scene:openDialog("Equip.EquipChoosePanel",{pos = self.m_pos})
		dialog:setSelectHandler(function(equipUid)
			HeroManager:onUpdateEquipRequest(self.m_heroId,self.m_pos,equipUid)
		end)
		self:close()
	end)
	self.m_csNode.unload:setTouchEnded(function()
		HeroManager:onUpdateEquipRequest(self.m_heroId,self.m_pos,0)
		self:close()
	end)
end

function This:onEnter()
	super.onEnter(self)
	EquipManager:addObserver(self)
end

function This:onExit()
	super.onExit(self)
	EquipManager:removeObserver(self)
end

function This:onStrengthLevel(equipUid)
	if self.m_equipUid == equipUid then
		self:refreshAttr()
	end
end

function This:onEquipUpLevel(equipUid)
	if self.m_equipUid == equipUid then
		self:refreshAttr()
	end
end

function This:onEquipUpgradeQuality(equipUid)
	self:onStrengthLevel(equipUid)
end


function This:updateEquipClearAttribute(uid,attributeList)
	if self.m_equipUid ~= uid then return end 
    self.attributeList = {}
    for i ,v in pairs(attributeList) do 
        self.attributeList[v.index] = v.wash_id
    end
    local equip = EquipManager:getEquip(uid)
    local lv = equip:getStrengthLv()
    local fator = AffinationFactorConfig[lv].fator
    for i = 1 , 4 do
    	local attrNode = self.m_csNode.clear["attr"..i]
    	local starNode = self.m_csNode.clear["star"..i]

        if self.attributeList[i] then 
            local washId = self.attributeList[i]
		    local attr = FoundationAttributeConfig[washId] 
		    local star = attr.star_level
		    local desc = attr.attribute_desc
		    local quality = StarColorConfig[star].star_color
		    if star < 10 then
		        attrNode:setString(string.format(" %d     ：%s",star,desc))
		    else
		        attrNode:setString(string.format("%d    ：%s",star,desc))
		    end
		    attrNode:setColorByID("Q"..quality)
		    starNode:setImage(string.format("Common/star%d.png",quality + 1)) 
		    starNode:setVisible(true)
            -- attrNode:setPositionX(-75)

            local w = attrNode:getBoundingBox().width
            attrNode:setPositionX(-w/2)
            starNode:setPositionX(-w/2 + 32)
        else
            if i <= fator then 
            	self.m_csNode.clear["attr"..i]:setString(Serialize[60770])
            else
                local openLv = 1
                for _, v in ipairs(AffinationFactorConfig) do 
                    if v.fator == i then 
                        openLv = v.id
                        break
                    end
                end
                attrNode:setString(string.format(Serialize[60772],openLv))
            end
            attrNode:setColorByID("New8")
            --attrNode:setPositionX(-54)
            starNode:setVisible(false)

            local w = attrNode:getBoundingBox().width
            attrNode:setPositionX(-w/2)
        end
    end	
end
--endregion
