-- @Author: Su
-- @Date:   2019-01-19 17:06:02
-- @Last Modified by:   zheng
-- @Last Modified time: 2019-12-30 16:36:49
-- @File Name: EquipUpLevelNode.lua
-- @Desc: 
local This , super = class(...,"NodeUI")
local EquipManager = require("Equip.EquipManager")
local FabaoUtil = require("Fabao.FabaoUtil")
local ItemNode = require("UI.ItemNode")
local GameUtil = require("Util.GameUtil")
local ItemUtil = require("Bag.ItemUtil")
local DepotManager = require("Depot.DepotManager")
local GamePlayer = require("Player.GamePlayer")
local EquipLevelUpConfig = require("Metadatas.EquipLevelUpConfig")
This.fileName = "GameScene/NodeUI/EquipUpgrade.csb"

local kMaxUpLevel = 100 --装备可升级最大等级

function This:initData(dialog)
    self.m_dialog = dialog 
    self.m_limitLevel = GamePlayer:getLevel()
end

function This:initNode(  )
    self.m_continuousUpgradeLevel = false
    self.gouxuan:setVisible(self.m_continuousUpgradeLevel)
    self.weigouxuan:setVisible(not self.m_continuousUpgradeLevel)
end

function This:refresh()
    self.m_equipUid = self:getEquipUid()
    self.m_equip = EquipManager:getEquip(self.m_equipUid)
    if self.m_equipUid and self.m_equipUid > 0 then
        self:refreshAttr()    
        self:setVisible(true)
    else
        self:setVisible(false)
        return 
    end    
    -- local equipId = self.m_equip:getEquipId()
    -- self.selectAttr = 1
	-- EquipManager:onReqSeeEquipClearData(self.m_equipUid,equipId,3)
    -- self:updateTick()
    -- self:updateCost()
    -- self:updateArrow(0)
end

function This:getEquipUid()
    return self.m_dialog:getEquipUid()
end

function This:getEquipHeroId()
    return self.m_dialog:getEquipHeroId()
end

function This:refreshAttr()
    local equip = EquipManager:getEquip(self:getEquipUid())
	local curLv = equip:getStrengthLv()    
	local level = equip:getLevel()
    local curAttr = equip:getUpLevelAttr(level)
    -- 消耗道具
    local items, itemTypeCount = self:getCostItems()
    -- if level==kMaxUpLevel then
    --     items ={}
    --     itemTypeCount= 0
    -- end
    self:setCostItems(items, itemTypeCount)
    -- 装备
    if self.m_itemNode == nil then
        local itemNode = ItemNode:create(equip:getEquipId())
        itemNode:setAnchorPoint(0.5,0.5)
		itemNode:setToEquip(curLv,level)
		self.EquipItem:addChild(itemNode)
		self.m_itemNode = itemNode
    else
        self.m_itemNode:initItem(equip:getEquipId())
		self.m_itemNode:setToEquip(curLv,level)
    end
    -- 属性
    self.level.text:setString(level..Serialize[60187])
    local incrementalLevel = 1
    if self.m_continuousUpgradeLevel then
        incrementalLevel = 10
    end
    local TargetLevel = level+incrementalLevel
    if TargetLevel > kMaxUpLevel then
        TargetLevel = kMaxUpLevel
        incrementalLevel = kMaxUpLevel-level
    end
    self.level2:setVisible(level < kMaxUpLevel)
    local newAttr = equip:getUpLevelAttr(level+incrementalLevel)
    if level ==kMaxUpLevel then
        newAttr ={}
    end
    self.level2.text:setString(TargetLevel..Serialize[60187])

    local index = 1
    for id,num in pairs(curAttr) do
        self.before["property"..index]:setVisible(true)
        self.before["property"..index.."num"]:setVisible(true)

        self.before["property"..index]:setString(AttrName[id])
        self.before["property"..index.."num"]:setString(string.format("+%d",num))
        index = index + 1
    end
    for i = index , 3 do
        self.before["property"..i]:setVisible(false)
        self.before["property"..i.."num"]:setVisible(false)
    end
    index = 1
    for id, num in pairs(newAttr) do
        self.after["property"..index]:setVisible(true)
        self.after["property"..index.."num"]:setVisible(true)

        self.after["property"..index]:setString(AttrName[id])
        self.after["property"..index.."num"]:setString(string.format("+%d",num))
        index = index + 1
    end
    for i = index , 3 do
        self.after["property"..i]:setVisible(false)
        self.after["property"..i.."num"]:setVisible(false)
    end
end

function This:onEnter()
	super.onEnter(self)
	EquipManager:addObserver(self)
	self:refresh()
end

function This:onExit()
	EquipManager:removeObserver(self)
    super.onExit(self)
end

function This:initTouchEvent()
    self.ascendbotton:setTouch({
        onEnded = function()
            local equip = self.m_equip
            local incrementalLevel = 1
            if self.m_continuousUpgradeLevel then
                incrementalLevel = 10
            end
            if equip:getLevel() + incrementalLevel >= self.m_limitLevel then
                incrementalLevel = self.m_limitLevel - equip:getLevel()
            end
            -- 检查装备等级
            if equip:getLevel() >= kMaxUpLevel then
                g_scene:showTips(Serialize[60798]) -- TODO 国际化
                return
            end

            -- 检查玩家等级
            if equip:getLevel() >= self.m_limitLevel then
                g_scene:showTips(Serialize[60799]) -- TODO 国际化
                return
            end

            -- 检查物品数量
            local items = self:getCostItems()
            for itemId, needCount in pairs(items) do
                if DepotManager:getItemOrResCount(itemId, {itemUid = 0}) < needCount then
                    g_scene:showTips(Serialize[60714] .. ItemUtil.getName(itemId)..Serialize[60800]) -- TODO 国际化
                    return
                end
            end

            -- 发送装备升级请求
            EquipManager:onEquipUpLevelRequest(self.m_equipUid,incrementalLevel)
            -- FabaoManager:onUpgradeFabaoLevelRequest(fabao:getUid(), incrementalLevel)
        end,
        isScale = false,
        isDynamic = true,
        isSwallow = false,
    })

        -- 连升10级勾选
    self.gouxuan:setTouch({
        onEnded = function()
            self:setContinuousUpgradeLevel(false)
            local items, itemTypeCount = self:getCostItems()
            self:setCostItems(items, itemTypeCount)
            self:refreshAttr()
        end,
        isScale = false,
        isDynamic = true,
        isSwallow = false,
    })
    self.weigouxuan:setTouch({
        onEnded = function()
            self:setContinuousUpgradeLevel(true)
            local items, itemTypeCount = self:getCostItems()
            self:setCostItems(items, itemTypeCount)
            self:refreshAttr()
        end,
        isScale = false,
        isDynamic = true,
        isSwallow = false,
    })

end

function This:getCostItems()
    local incrementalLevel = 1
    if self.m_continuousUpgradeLevel then
        incrementalLevel = 10
    end
    local level1 = self.m_equip:getLevel()
    local targetLevel = level1+incrementalLevel
    local items = {}
    local count = 0
    if level1>=100 then
        return items,count
    end
    if targetLevel > kMaxUpLevel then
        targetLevel = kMaxUpLevel
    end
    for level = level1,targetLevel - 1 do
        local config = EquipLevelUpConfig[self.m_equip:getWearPos()*1000 + level].cost
        for _,item in pairs(config) do
            local itemId = item[1]
            local itemCount = item[2]
            local originalCount = items[itemId]
            if not originalCount then
                originalCount = 0
                count = count + 1
            end
            items[itemId] = originalCount + itemCount
        end
    end
    return items, count
end

function This:setCostItems(items, itemTypeCount)
    local viewCount, tw = itemTypeCount, 0
    local offsetX = 60 / viewCount
    local itemWidth
    local itemsNode = self.itemtipslist
    itemsNode:setVisible(true)
    itemsNode:removeAllChildren()
    for itemId, neededCount in pairs(items) do
        local itemNode = ItemNode:create(itemId, neededCount, true)
        itemNode:setAnchorPoint(0,0.5)
        itemNode:showNeedNum(neededCount)
        itemsNode:addChild(itemNode)
        if not itemWidth then
            itemWidth = itemNode:getContentWidth()
        end
        itemNode:setPositionX(tw)
        tw = tw + itemWidth + offsetX + 30
    end
    itemsNode:setPosition( 200 - tw / 2, -100 )
end

function This:setContinuousUpgradeLevel(yes)
    self.m_continuousUpgradeLevel = yes
    self.gouxuan:setVisible(self.m_continuousUpgradeLevel)
    self.weigouxuan:setVisible(not self.m_continuousUpgradeLevel)
end

function This:onEquipUpLevel()
    cc.Audio:playEffect("Recruit_Change.mp3")
    for i = 1,3 do
        self.effect["effect"..i]:removeAllChildren()
        if self["m_effect"..i] then
            self["m_effect"..i] = nil
        end
        self["m_effect"..i] = GameUtil:createEffect("ShuXing")
        self["m_effect"..i]:setScale(0.5)
        self.effect["effect"..i]:addChild(self["m_effect"..i])
    end
end