-- @Author: zheng
-- @Date:   2019-09-12 15:28:10
-- @Last Modified by:   zheng
-- @Last Modified time: 2019-10-29 13:52:50
-- @File Name: RuneManager.lua
local HeroUtil = require("Hero.HeroUtil")
local ItemUtil = require("Bag.ItemUtil")
local GamePlayer = require("Player.GamePlayer")
local RuneItemModel = require("Bag.RuneItemModel")
local ArgConfig = require("Metadatas.ArgConfig")
KMaxRuneQualityRuneManager =6
RuneSkillQualityConvert ={
    [Quality.kWhite] = Quality.kBlue,
    [Quality.kGreen] = Quality.kOrange,
    [Quality.kBlue] = Quality.kRed,
}
RuneSkillStart = {
    kBag =1,
    kHeroPanel =2,
    kMakeRune =3,
}
local RuneSoltConfig = require("Metadatas.RuneSoltConfig")
local PassiveSkillTakeConfig = require("Metadatas.PassiveSkillTakeConfig")
local RuneSynthesisConfig = require("Metadatas.RuneSynthesisConfig")
local ItemReturnConfig = require("Metadatas.ItemReturnConfig")
local RuneSkillConfig = require("Metadatas.RuneSkillConfig")

local DepotManager = require("Depot.DepotManager")
local This , super = class(..., "Base.BaseModel")
local GameUtil = require("Util.GameUtil")

local GamePlayer = require("Player.GamePlayer")
local HeroManager = require("Hero.HeroManager")
local EventDispatcher = require("EventDispatcher")
local Socket = require("Net.Socket")
function This:init()
    super.init(self)
    self:initListener()
    self.m_heroSkill ={}
end

function This:initListener()
	EventDispatcher:addListener(self, 10461, self.onRuneModifyReply)--符石穿戴
	EventDispatcher:addListener(self, 10462, self.onRuneMakeReply)--符石合成
	EventDispatcher:addListener(self, 10463, self.onRuneResetReply)--重铸
	EventDispatcher:addListener(self, 10464, self.onRuneSaveReply)--重铸结果选择
    EventDispatcher:addListener(self, 10465, self.onUnlockRuneSoltReply)--解锁槽位
    EventDispatcher:addListener(self, 10466, self.onGetRuneMakeValueRewardReply)--领取熔炼奖励
end

function This:removeListener()
    EventDispatcher:removeListener(self,10461)--符石穿戴
    EventDispatcher:removeListener(self,10462)--符石合成
    EventDispatcher:removeListener(self,10463)--重铸
    EventDispatcher:removeListener(self,10465)--解锁槽位
    EventDispatcher:removeListener(self,10464)--重铸结果选择
    EventDispatcher:removeListener(self,10466)--领取熔炼奖励
end

function This:getAllHaveBagRunesWithSort(isSort)
    local res = {}
    local allRones = self:getAllHaveBagRunes()
    for _,equip in ipairs(allRones) do
        if not equip:isEquipped() then
            table.insert(res,equip)
        end
    end
    if isSort then
       table.sort(res,function(a,b)
            local aQualityNum,bQualityNum  =a:getQuality(),b:getQuality()
            local score= aQualityNum>bQualityNum

            return score
        end) 
    end
    return res
end

function This:runeSell(runeItem,closeFun)
    if not runeItem or not runeItem:isRune() then
        return
    end
    local itemId = runeItem:getId()
    local config = ItemReturnConfig[itemId]
    if config and config.return_id then
        local reward = config.return_id[1]
        if reward then
            local itemName = ItemUtil.getName(reward[1])
            g_scene:openDialog("UI.CostConfirmPanel", {
                simple = Serialize[60803]..reward[2]..Serialize[60804]..itemName.."?", 
                okHandler = function()
                    DepotManager:onSellItemNewRequest({runeItem:getUid()}, ItemOperation.kSell)
                    if closeFun then
                        closeFun()
                    end
                end 
            })
        end
    end
end

function This:getRuneSkillItem()
    local res ={}
    for tabKey = 1, 3 do
        res[tabKey]= {}
    end
    for _,configItem in pairs(RuneSkillConfig) do
        local quality = configItem.quality
        local resItem = res[quality]
        if resItem then
            if configItem.if_rare==1 then
                table.insert(resItem,1,configItem)
            else
                table.insert(resItem,configItem)
            end
        end
    end
    return res
end

-- getRuneConfigInfo(runeId,"rare_item")
function This:getAllHaveBagRunes()
    return DepotManager:getItemListByType(ItemCommonType.kRune)
end

function This:getRuneConfigInfo(runeId,key)
    local runeItem = RuneSynthesisConfig[runeId]
    if runeItem then
        return runeItem[key]
    end
    return {}
end

function This:resetHero(hero)
    local uid = hero:getUid()
    if self.m_heroSkill[uid] then
        -- hero:reduceAttrs(self.m_heroSkill[uid].backAttr,true)
        self.m_heroSkill[uid] ={skillKey ={},backAttr = {}}
    else
        self.m_heroSkill[uid] ={skillKey ={},backAttr = {}}
    end
end

function This:addHeroSkill(hero,skillId)
    local uid = hero:getUid()
    local psvSkill = HeroManager:getPsvSkill(skillId)
    if psvSkill then
        local skillType = psvSkill:getType()
        local quality = psvSkill:getQuality()
        local skillInfo = self.m_heroSkill[uid].skillKey
        if not skillInfo[skillType] then
            skillInfo[skillType] ={}
        end
        skillInfo[skillType][quality]= true
    end
end

function This:updateHeroSkillAttr(hero)
    if not self.m_skillQualityKey then
        local res ={}
        for skillId,item1 in pairs(PassiveSkillTakeConfig) do
            local quality = item1.quality
            if quality>0 then
                local skillType = item1.type
                if not res[skillType] then
                   res[skillType] = {} 
                end
                local qualityList = res[skillType]
                qualityList[quality]= skillId
            end
        end
        self.m_skillQualityKey = res
    end
    local function getSkillAttr(skillId)
        local res = {}
        local psvSkill = HeroManager:getPsvSkill(skillId)
        if not psvSkill then
            return res,0
        end
        local temAttr = psvSkill:getAttrKeyList()
        if psvSkill:isHaveRate() then
            for attrId,value in pairs(temAttr) do
                res[attrId]= value*hero:getLevel()
            end
            temAttr = res
        end
        return temAttr,psvSkill:getFightPowerFactor()
    end

    local factor = 0

    local skillAttrList = {}
    local uid = hero:getUid()
    local skillInfo = self.m_heroSkill[uid].skillKey
    for skillType,skillQualityKey in pairs(skillInfo) do
        local skillIds = self.m_skillQualityKey[skillType]
        for quality = 3 , 1 , -1 do
            local haveSkill =skillQualityKey[quality]
            if haveSkill then
                local skillId = skillIds[quality]
                if skillId then
                    local attrs,temFactor = getSkillAttr(skillId)
                    factor = factor + temFactor
                    skillAttrList[skillId] = attrs
                    break
                end
            end
        end
    end
    local res = {}
    for skillId,temAttr in pairs(skillAttrList) do
       res = GameUtil:tableAdd(temAttr,res)
    end
    hero:addAttrs(res,true)
    hero:setPsvSkillFactor(factor)
    hero:updateFightPower()
end

function This:getMaxSolt()
    if not self.m_maxSolt then
        self.m_maxSolt =1
        for _,item in pairs(RuneSoltConfig) do
            if item.slot_id>self.m_maxSolt then
                self.m_maxSolt = item.slot_id
            end
        end
    end
    return self.m_maxSolt
end
    
function This:onGetRuneMakeValueRewardRequest()
    Socket:sendAndLock(10466)--领取熔炼奖励
end

function This:onGetRuneMakeValueRewardReply( msg )
    if msg.err_code == 0 then
        local rewards = ArgConfig.rune_melting_max_return_item.arg
        if #rewards>0 then
            g_scene:showReward(rewards)
        end
        local temValue = GamePlayer:getPlayerAttrWithType(PlayerAttr.runnestone_composite_return)- msg.cost_value or 0
        GamePlayer:mofifyPlayerAttr(PlayerAttr.runnestone_composite_return,temValue)
        self:notifyObservers("onGetRuneMakeValueReward")
    else
        g_scene:handleErrorCode(msg.err_code)
    end
end
function This:onUnlockRuneSoltRequest(heroUid,pos)
    Socket:sendAndLock(10465,{card_id = heroUid, pos = pos})--解锁槽位
end

function This:onUnlockRuneSoltReply( msg )
    if msg.err_code == 0 then
        local hero = HeroManager:getHeroByUid(msg.card_id)
        local solt = hero:getRuneByPos(msg.pos)
        solt:setIsUnlock(true)
        self:notifyObservers("onUnlockRuneSolt",solt)
    else
        g_scene:handleErrorCode(msg.err_code)
    end
end

function This:onRuneSaveRequest(uid,isChose)
	Socket:sendAndLock(10464,{item_uid = uid,choose = isChose,})--重铸结果选择
end

function This:onRuneSaveReply( msg )
    if msg.err_code == 0 then
        local rune = DepotManager:getItemByUid(msg.item_uid)
        local heroUid = rune:getEquipCardUid()
        if heroUid>0 then
            HeroManager:calcSaintFightPower() 
        end
        self:notifyObservers("onRuneSave",rune)
    else
        g_scene:handleErrorCode(msg.err_code)
    end
end

function This:onRuneResetRequest(uid,isUse)
	Socket:sendAndLock(10463,{item_uid = uid,is_use_specialitem = isUse,})--重铸
end

function This:onRuneResetReply( msg )
    if msg.err_code == 0 then
        local rune = RuneItemModel.New(msg.item_preview)
        self:notifyObservers("onRuneReset",rune)
    else
        g_scene:handleErrorCode(msg.err_code)
    end
end
function This:onRuneMakeRequest(uidList)
	Socket:sendAndLock(10462,{material_list = uidList,})--符石合成
end

function This:onRuneMakeReply( msg )
    if msg.err_code == 0 then
        local temValue = GamePlayer:getPlayerAttrWithType(PlayerAttr.runnestone_composite_return)+ msg.add_value or 0
        GamePlayer:mofifyPlayerAttr(PlayerAttr.runnestone_composite_return,temValue)
        self:notifyObservers("onRuneMake",msg)
    else
        g_scene:handleErrorCode(msg.err_code)
    end
end
function This:onRuneModifyRequest(uid,cardId,pos)
	Socket:sendAndLock(10461,{item_uid = uid,card_id = cardId,pos = pos,})--符石穿戴
end

function This:onRuneModifyReply( msg )
    if msg.err_code == 0 then
        HeroManager:calcSaintFightPower()
        self:notifyObservers("onRuneModify")
    else
        g_scene:handleErrorCode(msg.err_code)
    end
end