-- @Author: zheng
-- @Date:   2019-09-18 18:16:05
-- @Last Modified by:   zheng
-- @Last Modified time: 2019-10-12 15:30:42
-- @File Name: RunePreviewItemView.lua
local RuneSkillConfig = require("Metadatas.RuneSkillConfig")
local RuneManager = require("Equip.RuneManager")
local This , super = class(...,"NodeUI")
local ItemUtil = require("Bag.ItemUtil")
-- local FamilyManager = require("Official.FamilyManager")
This.fileName = "GameScene/NodeUI/HeroSkillLookItem.csb"
function This:initNode(info)
    self.m_skillId = info.skillId
    local w,h = self.bg:getContentSize()
    self:setContentSize(w,h)
    self:refresh()
end

function This:refresh(info)
    if info then
        self.m_skillId = info.skillId
    end
    local skillId = self.m_skillId

    local skillItem = RuneSkillConfig[skillId]
    local quality = RuneSkillQualityConvert[skillItem.quality]
    local bgStr = "MenuScene/itemQuality" .. quality .. ".png"
    local iconStr = "Icons/Item/".. skillItem.icon .. ".png"
    self.bg:setImage(bgStr)
    self.icon:setImage(iconStr)
    local ifRare = skillItem.if_rare==1
    self.xiyou:setVisible(ifRare)
end

function This:resetPosToCenter()
    -- local w,h = self:getContentSize()
    self:setPosition(-41,-41)
end

function This:onEnter()
    super.onEnter(self)
    g_scene:handleHelpTips(self, function ()
        local skillId = self.m_skillId
        local skillItem = RuneSkillConfig[skillId]

        local strCommon = skillItem.dec_1
        local strName = skillItem.title
        local strGetWays = skillItem.dec_2
        local quality = RuneSkillQualityConvert[skillItem.quality]

        return {fileName = "UI.ItemTips", itemId = skillId, itemType = ItemCommonType.kSpall,strCommon = strCommon,strName = strName,strGetWays = strGetWays,quality = quality}
    end)
end
