-- @Author: zheng
-- @Date:   2019-09-11 14:45:36
-- @Last Modified by:   zheng
-- @Last Modified time: 2019-10-21 15:02:53
-- @File Name: RunePreviewPanel.lua
local RuneSkillConfig = require("Metadatas.RuneSkillConfig")
local RunePreviewItemView = require("Equip.RunePreviewItemView")
local RuneManager = require("Equip.RuneManager")
local This , super = class(...,"Dialog")
local ItemNode = require("UI.ItemNode")

This.fileName = "GameScene/NodeUI/HeroSkillLook.csb"
local TabNameCount =3
function This:initNode(info)
    if info then
       self.m_family = info.family
    end
    self.m_csNode = cc.Node:createFromCSFile(This.fileName)
    self.m_csNode:setToCenter()
    self:addChild(self.m_csNode)
    for tabKey = 1, TabNameCount do
        local item = self.m_csNode["tep"..tabKey]
        self:addTabButton(tabKey, item, function()
            self:lightTabButton(tabKey)
            self.m_selectIndex = tabKey
            self:refresh()
        end)
    end
    self.m_selectIndex = 1
    self:selectTabButton(self.m_selectIndex)
    self:refresh()
end


function This:refresh()
    self:getData()
    local function createItemView(model)
        local node = RunePreviewItemView:create(model)
        node:setAnchorPoint(0.5,0.5)
        return node
    end
    local scrollview = self.m_csNode.ScrollView
    scrollview:removeAllItems()
    local rewards = self.m_tabList[self.m_selectIndex]
    for i, model in ipairs(rewards) do
        local view = createItemView({skillId = model.passive_id})
        local w,h = view:getContentSize()
        scrollview:pushNode(view, w, h, 6) 
    end
end

function This:initTouchEvent()
	self.m_csNode.close:setTouchEnded(function()
        self:close()
    end)
end


function This:getData()
    if self.m_tabList then
        return
    end
    self.m_tabList = RuneManager:getRuneSkillItem()
end

