-- @Author: zheng
-- @Date:   2019-09-10 15:20:24
-- @Last Modified by:   zheng
-- @Last Modified time: 2019-10-23 10:22:10
-- @File Name: RuneSkillPanel.lua

local RuneSkillConfig = require("Metadatas.RuneSkillConfig")
local SkillLibraryConfig = require("Metadatas.SkillLibraryConfig")
local RuneSynthesisConfig = require("Metadatas.RuneSynthesisConfig")
local This , super = class(...,"Dialog")
local ItemUtil = require("Bag.ItemUtil")
local GameUtil = require("Util.GameUtil")
local RuneManager = require("Equip.RuneManager")
local HeroManager = require("Hero.HeroManager")
This.fileName = "GameScene/NodeUI/HeroSkillRune.csb"
local RunePreviewItemView = require("Equip.RunePreviewItemView")
function This:initNode(info)
    self.m_csNode = cc.Node:createFromCSFile(info.fileName or This.fileName)
    self.m_csNode:setToCenter()
    self:addChild(self.m_csNode)
    self.m_data = info.data

    self.m_runeId = info.runeId
    self.m_closeFun = info.closeFun
    if self.m_data then
        self.m_runeId = self.m_data:getId()
    end

    self.m_solt = info.solt
    self.m_type =info.type
    -- self:getData()
    self:refresh()
end

function This:checkType(type1)
    return self.m_type == type1
end

function This:refresh()
    local csNode = self.m_csNode
    local runeId = nil
    -- GameUtil:refreshItemInfo(runeId,csNode.tubiao,csNode.equipname,csNode.equipdes,387)
    self:refreshCommon(csNode,self.m_data)
    if self:checkType(RuneSkillStart.kHeroPanel) then
        csNode.offno.text1:setString(Serialize[60809])
        csNode.fenjie.text1:setString(Serialize[60810])
    end
end

function This:refreshCommon(node,data,txtLimit)
    if node.skilltext1 then
        local function refreshAttrItem(node1,info,index)
           local name = node["property"..index]
            if name then
                local value = node["property"..index.."num"]
                local nodes ={name,value}
                if info[1] then
                    for index,nodeView in ipairs(nodes) do
                        local value = info[index]
                        nodeView:setString(value)
                        nodeView:setVisible(true)
                    end
                else
                    for _,nodeView in pairs(nodes) do
                        nodeView:setVisible(false)
                    end
                end
            end 
        end
        local function refreshSkill(node1,info,index,skillId)
            local desNode = node["skillneirong"..index]
            if desNode then
                local name = node["skilltext"..index]
                local item1 = node["item"..index]
                local nodes ={desNode,name,item1}
                for _,itemNode in ipairs(nodes) do
                    itemNode:setVisible(info)
                end
                if info then
                    desNode:setString(info[1],txtLimit or 387)
                    name:setString(info[2])
                    name:setColorByID("Q".. info[3])
                    local temInfo = {skillId =skillId}
                    if item1.itemNode then
                        item1.itemNode:refresh(temInfo)
                    else
                        local view = RunePreviewItemView:create(temInfo)
                        item1:addChild(view)
                        view:resetPosToCenter()
                        item1.itemNode = view
                    end
                end
            end 
        end

        local attrKeyValues = data:getAttr()
        local count= 0
        for key,value in pairs(attrKeyValues) do
            local name ,value = GameUtil:getAttrStr(key,value)
            local info= {name,value}
            count = count +1
            refreshAttrItem(node,info,count)
        end
        local maxCount = 2
        local temCount = count+1
        if temCount <=maxCount then
            for index=temCount,maxCount do
                refreshAttrItem(node,{},index)
            end
        end

        count= 0
        local skillIdList = data:getSkillIds()
        for index,skillId in pairs(skillIdList) do
            local skillItem = RuneSkillConfig[skillId]
            if skillItem then
                local quality = RuneSkillQualityConvert[skillItem.quality] or 0
                local info ={skillItem.dec_1,skillItem.title,quality}
                refreshSkill(node,info,index,skillId)
                count = index
            end
        end
        local temCount = count+1
        maxCount = 2
        if temCount <=maxCount then
            for index=temCount,maxCount do
                refreshSkill(node,nil,index)
            end
        end
        
        local emptyTip = node.empty_tip
        if emptyTip then
            emptyTip:setVisible(#skillIdList == 0)
        end
    elseif node.suiji1 then
        local runeItem = RuneSynthesisConfig[self.m_runeId or data:getId()]
        if runeItem then
            node.suiji2:setString(runeItem.des)
            node.suiji1:setString(string.format(Serialize["equip_RuneSkill_1"],runeItem.attribute_num))
            local weight = runeItem.skill_combination_weigh
            local str = ""
            local qulityStr = {Serialize[60811],Serialize[60812],Serialize[60813]}
            local allLength = #weight
            for index,item1 in ipairs(weight) do
                str= str .. index .."."
                local qualityList = SkillLibraryConfig[item1[1]].skill_combination
                for index2,quality in ipairs(qualityList) do
                    if index2>1 then
                        str= str.."+"
                    end
                    str= str..qulityStr[quality]
                end
                if not allLength ~= index then
                    str = str.."\n"
                end
            end
            GameUtil:resetScoolSize2(node.scrollView2,460,120,str)
        end
    end

    GameUtil:refreshItemInfo(self.m_runeId or data:getId(),node.tubiao,node.equipname,node.equipdes,387)

end

function This:initTouchEvent()

    local function closeFun()
        self:close()
    end
    local csNode = self.m_csNode
    csNode.bg:setTouch({
            onEnded = function()            
                
            end,
            isScale = false,
            isAlpha = false,
            isSwallow = true,
        })
    if csNode.hecheng then
        csNode.hecheng:setTouchEnded(function()
            g_scene:openDialog("Equip.RuneMakePanel")
            closeFun()
        end)
        csNode.chongzhu:setTouchEnded(function()
            local info = {before = self.m_data}
            g_scene:openDialog("Equip.RuneResetPanel",info)
            closeFun()
        end)
        csNode.fenjie:setTouchEnded(function()
            if self:checkType(RuneSkillStart.kHeroPanel) then
                g_scene:openDialog("Equip.RuneWearPanel",{solt = self.m_solt})
                self:close()
            else
                RuneManager:runeSell(self.m_data,function ()
                    self:close()
                end)
            end
        end)
        csNode.offno:setTouchEnded(function()
            if self:checkType(RuneSkillStart.kHeroPanel) then
                local hero = self.m_solt:getHero()
                RuneManager:onRuneModifyRequest(0,hero:getUid(),self.m_solt:getIndex())
            else
                g_scene:openDialog("Hero.HeroListPanel")
            end
            self:close()
            if self.m_closeFun then
                self.m_closeFun()
            end
        end)
        csNode.look:setTouchEnded(function()
            g_scene:openDialog("Equip.RunePreviewPanel")
        end)
    end
end

function This:onTouchMask() -- 对话框之外区域的点击事件
    self:close()
end

function This:onEnter()
    super.onEnter(self)
    RuneManager:addObserver(self)
end

function This:onExit()
    super.onExit(self)
    RuneManager:removeObserver(self)
end

function This:onRuneSave(rune)
    if not self.m_data or (self.m_data and self.m_data:getUid()~= rune:getUid()) then
        return
    end
    self.m_data =  rune
    self:refresh()
end
-- function This:getData()
	
-- end