-- @Author: zheng
-- @Date:   2019-09-25 10:13:53
-- @Last Modified by:   zheng
-- @Last Modified time: 2019-10-10 20:59:53
-- @File Name: RuneWearItemView.lua

local RuneSkillConfig = require("Metadatas.RuneSkillConfig")
local RuneManager = require("Equip.RuneManager")
local GameUtil = require("Util.GameUtil")
local ItemUtil = require("Bag.ItemUtil")
local ItemNode = require("UI.ItemNode")
local This , super = class(...,"NodeUI")
-- local FamilyManager = require("Official.FamilyManager")
This.fileName = "GameScene/NodeUI/HeroSkillRuneChooseList.csb"

function This:setModel( data, index )
    if data then
        self.m_data = data
    end
    -- self.xuanzhong:setVisible(selectIndex == self.m_myIndex)
    self:refresh()
end

function This:initNode(info)
    local w,h = self.bg:getContentSize()
    self:setContentSize(w,h)
    self.m_data = info.data
    self:refresh()
end

function This:getSkillIds()
    return self.m_data:getSkillIds()
end

function This:getAttrNames()
    local attrs = self.m_data:getAttr()
    local skillIds = self:getSkillIds()
    local res1,res2 ={},{}
    for key,value in pairs(attrs) do
        local name,valueStr = GameUtil:getAttrStr( key,value)
        local str = "<New1>" .. name .. " " .. "<New9>" .. valueStr
        table.insert(res1,str)
    end
    for _,id in ipairs(skillIds) do
        local quality,strCommon,strName,strGetWays = self:getSkillItem(id)
        table.insert(res2,string.format("<Q%d>[%s]",quality,strName))
    end
    return res1,res2
end

function This:refresh()
    local data = self.m_data
    local runeId = data:getId()
    local attrName,jinengName = self:getAttrNames()
    for index=1,2 do
        local attrStr = attrName[index]
        local jinengStr = jinengName[index]
        local shuxing= self["shuxing"..index]
        shuxing:setVisible(attrStr)
        shuxing:setStringWithColor(attrStr)

        local jineng = self["jineng"..index]
        jineng:setVisible(jinengStr)
        jineng:setStringWithColor(jinengStr)
        
    end
    local node = self.item1
    if not node.itemNode then
        local itemNode = ItemNode:create(runeId, nil, false, false)
        itemNode:setAnchorPoint(0.5, 0.5)
        node:addChild(itemNode)
        node.itemNode = itemNode
    else
        node.itemNode:initItem(runeId, nil, false,false)
    end 
end

function This:getRuneId()
    return self.m_data:getUid()
end

function This:getSkillItem(skillId)
    local skillItem = RuneSkillConfig[skillId]
    local quality = RuneSkillQualityConvert[skillItem.quality]
    local strCommon = skillItem.dec_1
    local strName = skillItem.title
    local strGetWays = skillItem.dec_2
    return quality,strCommon,strName,strGetWays
end

function This:initTouchEvent()
    self.offno:setTouch({
        isScale = false, 
        isDynamic = true, 
        isSwallow = false,
        onEnded = function()
            print("点击")
            if self.m_btnHandle then
                self.m_btnHandle(self)
            end
        end
    }) 
    for index=1,2 do
        local jineng = self["jinengdi"..index]
        -- jineng:setTouch({
        -- isScale = false, 
        -- isDynamic = true, 
        -- isSwallow = false,
        -- onEnded = function()
            if skillId then
            end
                g_scene:handleHelpTips(jineng, function ()
                    local skillIds = self:getSkillIds()
                    local skillId = skillIds[index]
                    if skillId then
                        local quality,strCommon,strName,strGetWays = self:getSkillItem(skillId)
                        return {fileName = "UI.ItemTips", itemId = skillId, itemType = ItemCommonType.kSpall,strCommon = strCommon,strName = strName,strGetWays = strGetWays,quality = quality}
                    else
                        return nil
                    end
                end)
            
    --     end
    -- }) 
    end
end

function This:setBtnHandle(btnclick)
    self.m_btnHandle = btnclick
end