-- @Author: zheng
-- @Date:   2019-09-25 10:13:09
-- @Last Modified by:   zheng
-- @Last Modified time: 2019-10-10 10:06:42
-- @File Name: RuneWearPanel.lua
local RuneManager = require("Equip.RuneManager")
local RuneWearItemView = require("Equip.RuneWearItemView")
local UpdateLayer = require("Rank.RankPageListLayer")
local This , super = class(...,"Dialog")
This.fileName = "GameScene/NodeUI/HeroSkillRuneChoose.csb"
function This:initNode(info)
    if info then
       self.m_solt = info.solt
    end
    self.m_csNode = cc.Node:createFromCSFile(This.fileName)
    self.m_csNode:setToCenter()
    self:addChild(self.m_csNode)
    self:getData()
    self:initUpdateLayer()
    self:refresh()
end

function This:initUpdateLayer()
    local scrollView = self.m_csNode.scrollview
    if scrollView then
         self.m_listLayer = UpdateLayer:create({
            itemWidth = 530,
            itemHeight = 80,
            spaceX = 0,
            spaceY = 2,
            -- column = 4,
            scrollView = scrollView,
            dataCounter = function ()
                return #self.m_configlist
            end,
         viewCreator =  function(index, node)
                local item = self.m_configlist[index]
                if item then
                    if not node then
                        return self:getScroolItem(item,index)
                    else
                        node:setModel(item, index)
                    end
                end
            end,
        })
        self.m_listLayer:setCascadeOpacityEnabled(true)
        -- self.m_listLayer:setAnchorPoint(0.5, 0)
        local w , h = self.m_listLayer:getContentSize()
        scrollView:pushBackCustomItem(self.m_listLayer, w, h, 0)
    end
end

function This:getScroolItem(data,index)
   local view = RuneWearItemView:create({data= data,index= index})
   view:setBtnHandle(function (selectView)
        local hero = self.m_solt:getHero()
        RuneManager:onRuneModifyRequest(selectView:getRuneId(),hero:getUid(),self.m_solt:getIndex())
        self:close()
    end)
   return view 
end

function This:refresh()
   self.m_listLayer:setDataList() 
end

function This:initTouchEvent()
    local csNode = self.m_csNode
    csNode.close:setTouchEnded(function()
        self:close()
    end)
end

function This:getData()
    self.m_configlist = RuneManager:getAllHaveBagRunesWithSort(true)
end