-- @Author: superm
-- @Date:   2019-11-29 19:54:42
-- @Last Modified by:   superm
-- @Last Modified time: 2019-12-10 15:58:47
-- @File Name: ExpeditionEvent.lua
-- @Description: 

local This, super = class(..., "Base.BaseModel")
local RemainsEventConfig = require("Metadatas.RemainsEventConfig")
local RemainsQuestionBankConfig = require("Metadatas.RemainsQuestionBankConfig")
local RemainsCaveConfig = require("Metadatas.RemainsCaveConfig")
local RemainsPushConfig = require("Metadatas.RemainsPushConfig")
local ExpeditionUtil = require("Expedition.ExpeditionUtil")

function This:init(info)
	super.init(self)
	if info then
    	self:updateInfo( info )
    end
end

function This:updateInfo( param )
	self.m_id = param.index
	self.m_type = param.type
	self.m_state = param.state > 0
	self.m_levelId = param.level_id 
	self.m_config = RemainsEventConfig[self.m_type]
    if self.m_content then
        print( "清除内容" )
        self.m_content = nil
    end
end

function This:getImage()
    return string.format("Icons/Item/%d.png", self.m_config.icon)
end

function This:setData(info)
    self:updateInfo( info )
end

function This:setState(state)
	self.m_state = state > 0
end

function This:getState()
    return self.m_state
end

function This:getId()
    return self.m_id
end

function This:getLevelId()
    return self.m_levelId
end

function This:getType()
    return self.m_type
end

function This:getName()
    return self.m_config.name
end

function This:setContent( data )
	local content = ExpeditionUtil:createEventContent(self.m_type, data, self.m_content)
    self.m_content = content
end

function This:getContent()
    return self.m_content
end

