-- @Author: Su
-- @Date:   2019-12-10 16:58:10
-- @Last Modified by:   Su
-- @Last Modified time: 2019-12-10 16:58:10
-- @File Name: ExpeditionEventStoreItem.lua
-- @Description: 

local This , super = class(..., "NodeView")
local RemainsBusinessmanConfig = require("Metadatas.RemainsBusinessmanConfig") 
local ItemUtil = require("Bag.ItemUtil")
local ItemNode = require("UI.ItemNode")
local ExpeditionManager = require("Expedition.ExpeditionManager")
local StoreManager = require("Store.StoreManager")
local DepotManager = require("Depot.DepotManager")

function This:initData(info)
    self.m_data = info.item
    self.m_event = info.event
    self.m_csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/RuinsShopItem.csb")
    self:addChild(self.m_csNode)

    self:refresh()
end

function This:refresh()

    local node = self.m_csNode
    local itemData = RemainsBusinessmanConfig[self.m_data.id]
    node.name:setString(ItemUtil.getName(itemData.shop_item[1]))
    node.condition:setVisible(false)
    node.unlock.purchased:setVisible(itemData.buy_limit - self.m_data.buy_times <= 0)
    node.unlock.buybutton:setVisible(itemData.buy_limit - self.m_data.buy_times > 0)
    node.unlock.tongguan:setString(string.format( Serialize[60840],itemData.buy_limit - self.m_data.buy_times ,itemData.buy_limit))
    node.unlock.yuanbao:setImage(ItemUtil.getIconImage(itemData.cost_item[1]))
    node.unlock.price:setString(itemData.cost_item[2])
    if not self.m_item then
        local item = ItemNode:create(itemData.shop_item[1],itemData.shop_item[2])
        item:setAnchorPoint(0.5,0.5)
        self.m_item = item
        node.unlock.item:addChild(item)
    end
end

function This:getItemRewardByPos(pos)
    local itemData = RemainsBusinessmanConfig[self.m_data.id]
    if pos == itemData.position then
        return itemData.shop_item[1],itemData.shop_item[2]
    end
end

function This:updateInfo(info)
    self.m_data = info.item
    self.m_event = info.event
    self:refresh()
end

function This:initTouchEvent()
    local node = self.m_csNode
    node.unlock.buybutton:setTouch({
        isScale = false, 
        isDynamic = true, 
        onEnded = function()
            local itemData = RemainsBusinessmanConfig[self.m_data.id]
            if itemData.buy_limit - self.m_data.buy_times <= 0 then
                return
            end
            if not DepotManager:isItemOrResEnough(itemData.cost_item[1],itemData.cost_item[2]) then
                g_scene:showTips(Serialize[60841])
                return
            end

            ExpeditionManager:onBuyExpStoreItemRequest(self.m_event:getLevelId(), self.m_event:getId(), itemData.position)
        end
    })
end