-- @Author: superm
-- @Date:   2019-12-04 15:41:06
-- @Last Modified by:   superm
-- @Last Modified time: 2019-12-11 19:30:16
-- @File Name: ExpeditionEventView.lua
-- @Description: 

local This, super = class(...,"cc.Node")
local ccSprite = cc.Sprite

function This:init(event)
	self.m_event = event
	local icon = ccSprite:create(event:getImage())
	self:addChild(icon)
	self.m_icon = icon
	icon:setScale(0.5)
end

function This:onEnter()
    super.onEnter(self)
    self:initTouchEvent()
	self:refresh()
end

function This:onExit( param )
    super.onExit(self)
end

function This:initTouchEvent()
    self.m_icon:setTouch({
        onEnded = function()
        	if self.m_event:getType() == ExpEventTarget.kTreasure then
                g_scene:openDialog("Expedition.ExpeditionTreasurePanel",{event = self.m_event})
	        elseif self.m_event:getType() == ExpEventTarget.kMystery then
        		g_scene:openDialog("Expedition.ExpeditionEventStorePanel",{event = self.m_event})
        	else
				g_scene:openDialog("Expedition.ExpeditionEventPanel", {
					event = self.m_event
				})
        	end

        end,
        isDynamic = true
    })
end

function This:refresh()
    
end
