-- @Author: superm
-- @Date:   2019-11-22 14:55:20
-- @Last Modified by:   superm
-- @Last Modified time: 2019-12-11 19:52:20
-- @File Name: ExpeditionHeroSlot.lua
-- @Description: 

local This, super = class(..., "Base.BaseModel")
local HeroManager = require("Hero.HeroManager")

function This:init(info)
	super.init(self)
	if not info then
		self.m_heroUid = 0
		self.m_hpPercent = 0
	else
	    self:updateInfo(info)
	end
end

function This:getHero()
    return self.m_hero
end

function This:getImageId()
	if self.m_hero then
    	return self.m_hero:getId()
    end
    return 0
end

function This:getFightPower()
	if self.m_hero then
    	return self.m_hero:getFightPower()
    end
    return 0
end

function This:setHp(value)
    self.m_hpPercent = value
end

function This:getHp()
    return self.m_hpPercent
end

function This:getHeroUid()
    return self.m_heroUid
end

function This:isDead()
    return self.m_hpPercent <= 0
end

function This:isInjured()
    return self.m_hpPercent > 0 and self.m_hpPercent < 1
end

function This:isFullHp()
    return self.m_hpPercent >= 1
end

function This:updateInfo(param)
	self.m_hpPercent = param.hp
	local uid = param.id
	self.m_hero = HeroManager:getHeroByUid(uid)
	self.m_heroUid = uid
end

function This:getMaxHpValue()
    return math.floor(self.m_hero:getAttr(AttrType.kMaxHp))
end
