-- @Author: superm
-- @Date:   2019-11-22 16:37:35
-- @Last Modified by:   superm
-- @Last Modified time: 2019-12-10 19:25:05
-- @File Name: ExpeditionHeroSlotView.lua
-- @Description: 

local This, super = class(..., "NodeView")
local ItemUtil = require("Bag.ItemUtil")

function This:initData(info)
	if info then
	    self.m_slot = info.slot
	    self.m_touchable = info.touch
		self.m_isSwallow = info.isSwallow or false
		self.m_isContanier = info.isContanier or false
	end
    self.m_csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/RuinsMainHero.csb")
    self:addChild(self.m_csNode)
    local w , h = self.m_csNode.bg1:getContentSize()
    self:setContentSize(w , h)
	self.m_isInAllTeam = false
end

function This:onEnter()
    super.onEnter(self)
	self:refresh()
end

function This:onExit()
    super.onExit(self)
end

function This:initNode()

end

function This:initTouchEvent()
	if self.m_touchable and not self.m_inited then
		self.m_csNode.bg1:setTouch({
			onEnded = function()
				if not self.m_isInAllTeam then
					if self.m_selectHandler and self.m_slot then
						self.m_selectHandler(self.m_slot)
						self:refreshSelectState()
					end
				else
					g_scene:showTips(Serialize[60848])
				end
			end,
			isDynamic = self.m_isContanier,
			isContanier = self.m_isContanier,
			isSwallow = self.m_isSwallow,
			isScale = false	
		})
		self.m_inited = true
	end
end
function This:refreshSelectState()
	local csNode = self.m_csNode
	if self.m_slot then
		self.m_isInAllTeam = self.m_checkHandler and self.m_checkHandler(self.m_slot)
		csNode.zhezhaohei:setVisible(self.m_isInAllTeam)
		csNode.gou:setVisible(self.m_isInAllTeam)
	else
		csNode.zhezhaohei:setVisible(false)
		csNode.gou:setVisible(false)
	end
end

function This:refresh()
	local csNode = self.m_csNode
	local isEmpty = true
	if self.m_slot then
		local heroId = self.m_slot:getImageId()
		if heroId > 0 then
			csNode.hero:setVisible(true)
			csNode.hero:setImage(ItemUtil.getIconImage(heroId))
			csNode.bg1:setImage(ItemUtil.getQualityImage(heroId))
		end

		local hero = self.m_slot:getHero()
		if hero then
			isEmpty = false
			local star = hero:getStarLv()
			for i = 1 , 5 do
				csNode["star"..i]:setVisible(star >= i)
			end
			csNode.name:setVisible(false)
			csNode.textbg:setVisible(false)
			csNode.level:setVisible(true)
			csNode.level:setString("Lv." .. hero:getLevel())
			csNode.starbg:setVisible(star > 0)

			local showHpNode, hideHpNode = csNode.xuetiaolv, csNode.xuetiaohong
			if not self.m_slot:isDead() then
				local hpp = self.m_slot:getHp()
				if hpp <= 0.2 then
					showHpNode, hideHpNode = hideHpNode, showHpNode
				end
				csNode.xuetiaodi:setVisible(true)
				showHpNode:setVisible(true)
				hideHpNode:setVisible(false)
				showHpNode:setPercent(hpp * 100)
				csNode.zhenwang:setVisible(false)
				csNode.zhezhaohong:setVisible(false)
			else
				csNode.xuetiaodi:setVisible(false)
				showHpNode:setVisible(false)
				hideHpNode:setVisible(false)
				csNode.zhenwang:setVisible(true)
				csNode.zhezhaohong:setVisible(true)
			end
		else
			csNode.name:setVisible(true)
			csNode.textbg:setVisible(true)
			csNode.name:setString(self.m_slot:isBoss() and Serialize[60849] or Serialize[60849])
		end
	end

	if isEmpty then
		csNode.starbg:setVisible(false)
		for i = 1 , 5 do
			csNode["star"..i]:setVisible(false)
		end
		csNode.level:setVisible(false)
		csNode.xuetiaodi:setVisible(false)
		csNode.xuetiaolv:setVisible(false)
		csNode.xuetiaohong:setVisible(false)
		csNode.zhenwang:setVisible(false)
		csNode.zhezhaohong:setVisible(false)
	end
	self:refreshSelectState()
end

function This:setModel( slot )
    if self.m_slot ~= slot then
    	self.m_slot = slot
    end
    self:refresh()
end

function This:setSelectHandler(shandler, chandler)
	self.m_selectHandler = shandler
	self.m_checkHandler = chandler
end



