-- @Author: superm
-- @Date:   2019-11-22 15:05:04
-- @Last Modified by:   superm
-- @Last Modified time: 2019-12-03 14:44:13
-- @File Name: ExpeditionStore.lua
-- @Description: 

local This, super = class(..., "Store.StoreCommonModel")
local RemainsBusinessmanConfig = require("Metadatas.RemainsBusinessmanConfig") 
local StoreManager = require("Store.StoreManager")
local ArgConfig = require("Metadatas.ArgConfig")

local kMaxRefreshCostCount = 100

-- remains_shop_refresh_cost arg={{10,50},{50,100},{100,200}}

function This:getUITypeName()
    return "Store.StoreRuinsUI"
end

function This:requestRefresh()
    if self.m_refreshFreeTime <= 0 then
        if self:isCostEnoughBy(1) then
            --item
            StoreManager:onRefreshCommonStoreRequest( self.m_storeType )
        else
            local nextTime = self.m_refreshChargedTime + 1
            if nextTime > kMaxRefreshCostCount then
                nextTime = kMaxRefreshCostCount
            end
            local cost = self:getPrice(nextTime)
            local panel = g_scene:openDialog("UI.CostConfirmPanel", {
                cost = cost,
                notips = "StoreCommon" .. tostring(self:getId()) .. tostring(cost),
                desc = Serialize[60860], 
                okHandler = function(build)
                    StoreManager:onRefreshCommonStoreRequest( self.m_storeType )
                end } )
        end
    else
        --free
        StoreManager:onRefreshCommonStoreRequest( self.m_storeType )
    end
end


function This:getPrice(num)
    local priceList = ArgConfig.remains_shop_refresh_cost.arg
    if num <= priceList[1][1] then
        return priceList[1][2]
    elseif priceList[1][1] < num and num <= priceList[2][1] then
        return priceList[2][2]
    elseif priceList[2][1] < num and num < priceList[3][1] then
        return priceList[3][2]
    else
        return priceList[3][2]
    end
end
