-- @Author: Su
-- @Date:   2019-12-04 11:58:10
-- @Last Modified by:   Su
-- @Last Modified time: 2019-12-04 11:58:10
-- @File Name: ExpeditionStoreItem.lua
-- @Description: 

local This , super = class(..., "NodeView")
local RemainsBusinessmanConfig = require("Metadatas.RemainsBusinessmanConfig") 
local ItemUtil = require("Bag.ItemUtil")
local ItemNode = require("UI.ItemNode")
local ExpeditionManager = require("Expedition.ExpeditionManager")
local StoreManager = require("Store.StoreManager")

This.fileName = "MenuScene/NodeUI/RuinsShopItem.csb"

-- function This:initData(info)
--     self.m_data = info
--     self.m_csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/RuinsShopItem.csb")
--     self:addChild(self.m_csNode)

--     self:refresh()
-- end
function This:initData(slot)
    self.m_inited = false
    self.m_slot = slot
    local w , h = self.bg:getContentSize()
    self:setContentSize(w,h)
    self:initNode()
    self:initTouchEvent()
end

function This:initNode()
    self.m_slot:updateState()
    self:refreshItemUI()
    self:setItemEnable(not self.m_slot:isMaxTime())
end

function This:refreshItemUI()
    local node = self
    --local itemData = RemainsBusinessmanConfig[self.m_data.id]
    node.name:setString(ItemUtil.getName(self.m_slot:getItemId()))
    node.condition:setVisible(false)
    node.unlock.tongguan:setVisible(false)
    node.unlock.tongguan:setString(string.format(Serialize[60862],50,50))
    node.unlock.yuanbao:setImage(self.m_slot:getPriceImage())
    node.unlock.price:setString(self.m_slot:getPrice())
    if not self.m_item then
        local item = ItemNode:create(self.m_slot:getItemId(),self.m_slot:getItemNum())
        item:setAnchorPoint(0.5,0.5)
        self.m_item = item
        node.unlock.item:addChild(item)
    else
        self.m_item:initItem(self.m_slot:getItemId(),self.m_slot:getItemNum())
    end

end

function This:setItemEnable(enble)
    if self:isLocked() then
        if self.condition then
            self.condition:setVisible(true)
            self:refreshConditionUI()
        end

        if self.kong then
            self.unlock:setVisible(false)
            self.kong:setVisible(true)
        end
    else
        if self.condition then
            self.condition:setVisible(false)
        end
        if self.kong then
            self.unlock:setVisible(true)
            self.kong:setVisible(false)
        end
        self.unlock.buybutton:setVisible(enble)
        self.unlock.purchased:setVisible(not enble)
    end
end

function This:isLocked()
    return false
end

function This:getReward()
    return self.m_slot:getItemId(),self.m_slot:getItemNum()
end

function This:isPurchased()
    return false
end

function This:onEnter()
    -- super.onEnter(self)
    StoreManager:addObserver(self)
end

function This:onExit()
    StoreManager:removeObserver(self)
    -- super.onExit(self)
end

function This:getContentSize()
    local w,h = self.bg:getContentSize()
    return w,h
end

function This:initTouchEvent()
    local node = self
    node.unlock.buybutton:setTouch({
        isScale = false, 
        isDynamic = true, 
        onEnded = function()
            -- ExpeditionManager:onBuyExpStoreItemRequest(self.m_data.id)
            self.m_slot:requestBuy()
        end
    })
end

function This:refresh()
    self.m_slot:updateState()
    self:refreshItemUI()
    self:setItemEnable(not self.m_slot:isMaxTime())
end

function This:refreshWhenBought( storeType, slotId )
    if self.m_slot:getStoreType() == storeType and self.m_slot:getId() == slotId then
        self:refresh()
        local itemId = self.m_slot:getItemId()
        if ItemUtil.getType(itemId) == ItemCommonType.kGameRes then
            g_scene:showReward({{id = itemId, num = self.m_slot:getItemNum()}})
        end
    end
end

function This:updateInfo(info)
    self.m_data = info
    self.m_itemData = RemainsBusinessmanConfig[self.data.config_id]

    self:refresh()
end

function This:onBuyCommonStoreItem( storeType, slotId )
    self:refreshWhenBought( storeType, slotId )
end

function This:onBuyExpStoreItem(shop_item_id)

end