-- @Author: Su
-- @Date:   2019-12-11 14:39:19
-- @Last Modified by:   Su
-- @Last Modified time: 2019-12-11 14:39:19
-- @File Name: ExpeditionSuperAwardsItem.lua
-- @Description: 

local This , super = class(..., "NodeView")
local ItemNode = require("UI.ItemNode")
local ExpeditionManager = require("Expedition.ExpeditionManager")

function This:initData(info)

    local csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/RuinsSuperAwardsItem.csb")
    self:addChild(csNode)
    self.m_csNode = csNode
    self.m_data = info.itemdata
    self.m_superData = info.superData
    self.m_event = info.event
    self:refresh()
end

function This:refresh()
    local node = self.m_csNode
    local list = self.m_superData.list
    local costGold = self.m_superData.cost
    node.num:setString(string.format( "%d/%d",costGold,self.m_data.yuanbao_cost ))
    if not self.m_item then
        local item = ItemNode:create(self.m_data.reward[1][1],self.m_data.reward[1][2])
        item:setAnchorPoint(0.5,0.5)
        node.item:addChild(item)
        self.m_item = item
    end
    local isReceive = false
    for _,id in pairs(list) do
        if id == self.m_data.id then
            isReceive = true
        end
    end
    node.button:setVisible(not isReceive)
    node.yilingqu:setVisible(isReceive)
    if costGold < self.m_data.yuanbao_cost then
        node.button:setGrayShader()
    else
        node.button:clearShader()
    end
end

function This:initTouchEvent()
    local node = self.m_csNode
    node.button:setTouch({
        isScale = false, 
        isDynamic = true, 
        onEnded = function()
            local costGold = self.m_superData.cost
            if costGold < self.m_data.yuanbao_cost then
                return
            end
            ExpeditionManager:onPickStorePrizeRequest(self.m_event:getLevelId(), self.m_event:getId(),self.m_data.id)
        end
    })

end

function This:updateInfo(info)
    self.m_data = info.itemdata
    self.m_superData = info.superData
    self.m_event = info.event
    self:refresh()
end

function This:getContentSize()
    local w,h = self.m_csNode.bg:getContentSize()
    return w,h
end