-- @Author: Su
-- @Date:   2019-12-11 14:39:19
-- @Last Modified by:   Su
-- @Last Modified time: 2019-12-11 14:39:19
-- @File Name: ExpeditionSuperAwardsPanel.lua
-- @Description: 

local This, super = class(..., "Dialog")
local ExpeditionManager = require("Expedition.ExpeditionManager")
local RemainsSuperPrizeConfig = require("Metadatas.RemainsSuperPrizeConfig")
local ExpeditionSuperAwardsItem = require("Expedition.ExpeditionSuperAwardsItem")

function This:initNode(info)
    local csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/RuinsSuperAwards.csb")
    csNode:setToCenter()
    self:addChild(csNode)
    self.m_csNode = csNode
    self.m_event = info.event
    self.m_itemList = {}
    self:refreshItemList()
end

function This:onEnter()
    super.onEnter(self)
    ExpeditionManager:addObserver(self)
end

function This:onExit()
    super.onExit(self)
    ExpeditionManager:removeObserver(self) 
end

function This:refreshItemList()
    local scrollView = self.m_csNode.ScrollView
    self.m_content= self.m_event:getContent()
    local data = self.m_content:getStoreData()
    local superData = {list = data.super_reward_list,cost = data.gold_cost}
    for i,itemInfo in ipairs(RemainsSuperPrizeConfig) do
        if not self.m_itemList[i] then
            local item = ExpeditionSuperAwardsItem:create({itemdata =itemInfo,superData =superData,event=self.m_event})
            item:setAnchorPoint(0.5,0.5)
            local w , h = item:getContentSize()
            scrollView:pushNode(item,w,h,2)
            self.m_itemList[i] = item
        else
            self.m_itemList[i]:updateInfo({itemdata =itemInfo,superData =superData,event=self.m_event })
        end

    end
end

function This:initTouchEvent()
    self.m_csNode.close:setTouchEnded(function()
        self:close()
    end)
end

function This:onGetExpStoreInfo()
    self:refreshItemList()
end

function This:onPickStorePrize(id)
    local reward = RemainsSuperPrizeConfig[id].reward
    g_scene:showReward(reward)
end