-- @Author: superm
-- @Date:   2019-12-03 11:57:06
-- @Last Modified by:   superm
-- @Last Modified time: 2019-12-09 20:16:49
-- @File Name: ExpeditionTreasure.lua
-- @Description: 
local RemainsTreasureConfig = require("Metadatas.RemainsTreasureConfig")
local ArgConfig = require("Metadatas.ArgConfig")
local This, super = class(..., "Base.BaseModel")
local DepotManager = require("Depot.DepotManager")

function This:init(info)
	super.init(self)
	self.m_boxInfo ={}
	self.m_boxOpenNum = 0
	self:updataeInfo(info)
end

function This:updataeInfo(info)
	if info and info.box_id_list then
		self.m_boxOpenNum =0
		local boxId = info.box_id_list or {}
		local boxState = info.box_state_list or {}
		local rewardId = info.reward_id_list or {}
		local rewardState = info.reward_state_list or {}
		for index,id in ipairs(boxId) do
			local boxItem ={}
			boxItem.boxId = id
			boxItem.boxState = boxState[index] ==1
			boxItem.rewardId = rewardId[index]
			boxItem.reward = self:getReward(boxItem.rewardId)--RemainsTreasureConfig[boxItem.rewardId].treasure
			boxItem.rewardState = rewardState[index] ==1
			self.m_boxInfo[id]= boxItem
			if boxItem.boxState then
				self.m_boxOpenNum = self.m_boxOpenNum +1
			end
		end
	end
end

function This:getReward(rewardId)
	local item1 = RemainsTreasureConfig[rewardId]
	if item1 then
		return item1.treasure
	end
	return nil
end

function This:getBoxInfo(index)
	if index then
		return self.m_boxInfo[index] or {}
	end
	return self.m_boxInfo[index]
end

function This:getIsFree()
	local maxOpenNum = self:getMaxOpenNum()
    local leftOpenNum= maxOpenNum - self:getOpenNum()
    return leftOpenNum == maxOpenNum,leftOpenNum
end

function This:getOpenNum()
	return self.m_boxOpenNum
end

function This:getMaxOpenNum()
	return ArgConfig.remains_treasure_opentimes.arg[1]
end

function This:getFreeTime()
	return ArgConfig.remains_treasure_opentimesfree.arg[1]
end

function This:getNeedKey()
	return ArgConfig.remains_treasure_key.arg[1]
end


function This:getNeedLeftNum()
	return DepotManager:getItemCount(self:getNeedKey())
end

function This:checkNeed()
	return DepotManager:getItemOrResEnought({{self:getNeedKey(),1}},true)
end

-- function This:removeEvent(eventId)
	
-- end

