-- @Author: superm
-- @Date:   2019-12-03 11:58:19
-- @Last Modified by:   zheng
-- @Last Modified time: 2019-12-17 12:11:23
-- @File Name: ExpeditionTreasurePanel.lua
-- @Description: 


local GameUtil = require("Util.GameUtil")
local ExpeditionManager = require("Expedition.ExpeditionManager")
local ItemUtil = require("Bag.ItemUtil")
local This , super = class(...,"Dialog")
local boxNum =6
This.fileName = "MenuScene/NodeUI/RuinsTreasureHouse.csb"
function This:initNode(info)
    self.m_event = info.event
	self.m_levelId = self.m_event:getLevelId()
	self.m_eventIndex = self.m_event:getId()
    self.m_state = self.m_event:getState()
    self.m_csNode = cc.Node:createFromCSFile(This.fileName)
    self.m_csNode:setToCenter()
    self:addChild(self.m_csNode)
    ExpeditionManager:onGetEventInfoRequest(self.m_event:getLevelId(), self.m_event:getId())
end

function This:refresh()
    local csNode = self.m_csNode
    local function refreshBoxState(boxInfo,index)
    	local itemNode = csNode["box"..index]
    	if itemNode then
            GameUtil:createBoxEffect(not boxInfo.boxState,itemNode,3,boxInfo.boxState)
    	end
    end
    local function refreshRewardState(boxInfo,index)
    	local itemNode = csNode["item"..index]
    	if itemNode then
	    	GameUtil:creatItemNode(itemNode.item,boxInfo.reward)
	    	itemNode.yiyongyou:setVisible(boxInfo.rewardState)
    	end
    end
    local data =ExpeditionManager:getBoxExpedition()
    if data then
    	for index=1,boxNum do
    		local boxInfo = data:getBoxInfo(index)
    		refreshBoxState(boxInfo,index)
    		refreshRewardState(boxInfo,index)
    	end
    	local costNode = csNode.cost
    	local isFree, leftOpenNum= data:getIsFree()
    	local txtStr = Serialize[60869]
    	if not isFree then
    		txtStr = string.format(Serialize[60870],leftOpenNum)
    		costNode.num:setString(string.format("%d/1",data:getNeedLeftNum()))
            local needKey = data:getNeedKey()
            costNode.icon:setImage(ItemUtil.getIconImage(needKey))
            if leftOpenNum ==0 then
                isFree = true
            end
    	end

    	csNode.shengyu:setString(txtStr)
    	costNode:setVisible(not isFree)
    end

end

function This:initTouchEvent()
    local csNode = self.m_csNode
    csNode.close:setTouchEnded(function()
        self:close()
    end)
    for index=1,boxNum do
    	local box = csNode["box"..index]
    	box:setTouchEnded(function()
            local data =ExpeditionManager:getBoxExpedition()
            local isFree, leftOpenNum= data:getIsFree()
            if leftOpenNum == 0 then
                g_scene:showTips(Serialize[60871])
                return false
            end
            local boxInfo = data:getBoxInfo(index)
            if boxInfo.boxState then
                g_scene:showTips(Serialize[60872])
                return false 
            end
            if isFree or data:checkNeed() then
	           ExpeditionManager:onOpenTreasureBoxRequest(self.m_levelId, self.m_eventIndex, index)
            end
	    end)

    end
    
end

function This:onEnter()
    super.onEnter(self)
    ExpeditionManager:addObserver(self)
end

function This:onExit()
    super.onExit(self)
    ExpeditionManager:removeObserver(self)
end

function This:onQuestionEvent()
	self:refresh()
end
This.onGetTreasureBoxInfo = This.refresh