---
---
--- Created by aid.
--- DateTime: 2018/12/28 10:31
---
local This , super = class(...,"cc.Node")
local ItemUtil = require("Bag.ItemUtil")
local ItemNode = require("UI.ItemNode")
local FabaoUtil = require("Fabao.FabaoUtil")

function This:init()
    self:initNode()
    self:initTouchEvent()
end

function This:initNode()
    self.m_csNode = cc.Node:createFromCSFile("GameScene/NodeUI/TreasureBookItem.csb")
    self:addChild(self.m_csNode)
end

function This:initTouchEvent()
    self.m_csNode.bg:setTouch({
        onEnded = function()
            if self.m_onClickListener then
                self.m_onClickListener(self.m_index)
            end
        end,
        isContainer = true,
        isScale = false
    })
end

function This:onEnter()
    super.onEnter(self)
end

function This:onExit()
    super.onExit(self)
end

function This:setFabaoItemId(index, itemId, typeStr, selectedIndex)
    self.m_index = index
    self.m_itemId = itemId

    -- 法宝图标
    if not self.m_fabaoItemView then
        self.m_fabaoItemView = ItemNode:create(itemId, nil, nil, false)
        self.m_fabaoItemView:setAnchorPoint(0.5, 0.5)
        self.m_csNode.item:addChild(self.m_fabaoItemView)
    else
        self.m_fabaoItemView:init(itemId)
    end
    self.m_fabaoItemView:setToFabao(
            FabaoUtil.getFabaoMaxLevel(itemId),
            FabaoUtil.getFabaoMaxRefineDegree(itemId),
            FabaoUtil.getFabaoMaxStarLevel(itemId)
    )

    -- 法宝名
    self.m_csNode.name:setString(ItemUtil.getName(self.m_itemId))
    self.m_csNode.name:setColorByID("Q".. ItemUtil.getQuality(self.m_itemId))
    -- 法宝类型
    self.m_csNode.name_0:setString(typeStr)

    -- 选中状态
    self:setToBeSelected(selectedIndex == index)
end

function This:setToBeSelected(bool)
    self.m_csNode.xuanzhong:setVisible(bool)
end

function This:getIndex()
    return self.m_index
end

function This:setOnClickListener(listener)
    self.m_onClickListener = listener
end

function This:getContentSize()
    return self.m_csNode.xuanzhong:getContentSize()
end