---
---
--- Created by aid.
--- DateTime: 2018/12/18 10:42
---
local This , super = class(...,"cc.Node")
local ItemUtil = require("Bag.ItemUtil")
local FabaoManager = require("Fabao.FabaoManager")

--data的格式为：
-- {
--     itemId = self.m_item:getId(), -- 法宝的物品id
--     jinglianDegree = fabao:getJinglianDegree(), -- 法宝的精炼程度（注意：不是精炼进度）
--     level = fabao:getLevel(), -- 法宝等级
--     starCount = fabao:getStarLevel(), -- 法宝星级
-- }
function This:init()
    self:initNode()
    self:initTouchEvent()
end

function This:initNode()
    self.m_csNode = cc.Node:createFromCSFile("GameScene/NodeUI/TreasureItem.csb")
    self:addChild(self.m_csNode)
end

function This:initTouchEvent()
end

function This:onEnter()
    super.onEnter(self)
end

function This:onExit()
    super.onExit(self)
end

function This:setData(data)
    self.m_data = data

    -- 图标
    self.m_csNode.Treaure:setImage(ItemUtil.getIconImage(self.m_data.itemId))
    self.m_csNode.fabaobg:setImage(ItemUtil.getQualityImage(self.m_data.itemId))
    -- 精炼程度
    if self.m_data.jinglianDegree > 0 then
        self.m_csNode.jinglian:setString("+"..self.m_data.jinglianDegree)
    elseif self.m_data.jinglianDegree == 0 then
        self.m_csNode.jinglian:setString("+0")
    else
        error("error!")
    end
    -- 等级
    self.m_csNode.dengji:setString(self.m_data.level)
    -- 星数
    self.m_csNode.xingshu:setString(self.m_data.starCount)
end

function This:setFabao(fabaoUid)
    local fabao = FabaoManager:getFabao(fabaoUid)
    self:setData({
        itemId = fabao:getItemId(),
        jinglianDegree = fabao:getJinglianDegree(),
        level = fabao:getLevel(),
        starCount = fabao:getStarLevel(),
    })
end

function This:getContentSize()
    return self.m_csNode.fabaobg:getContentSize()
end