---
---
--- Created by aid.
--- DateTime: 2018/12/24 15:51
---
local This , super = class(...,"Dialog")
local SkillConfig = require("Metadatas.SkillConfig")
local MagicWeaponStartConfig = require("Metadatas.MagicWeaponStartConfig")

function This:initData(arguments)
    super.initData(self, arguments)
    self.m_skillName = arguments.skillName
    self.m_skillDescriptionList = arguments.skillDescriptionList
    self.m_highlightIndex = arguments.highlightIndex
end


function This:initNode()
    self.m_csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/HeroArmsInfo.csb")
    self:addChild(self.m_csNode)
    self.m_csNode:setToCenter()

    -- 技能名
    self.m_csNode.name:setString(self.m_skillName)

    -- 技能的各级描述
    self.m_csNode.scrollView.m_itemMargin = {10, 10}
    local rootNode = cc.Node:createFromCSFile("MenuScene/NodeUI/HeroArmsInfoValue.csb")
    local containerNode = rootNode.bg

    local width, _ = containerNode:getContentSize()
    local height = 0
    local count = #self.m_skillDescriptionList
    for index = 0, count-1 do
        local textColor = "<A5>" -- 未激活条目的颜色
        if (count-index) <= self.m_highlightIndex then
            textColor = "<New9>" -- 激活条目的颜色
        end

        local label = cc.Label:createNormalTTF("", 18)
        label:setStringWithColor(textColor..self.m_skillDescriptionList[(count-index)], width)
        label:setAnchorPoint(0, 0)
        label:setPosition(15, height)
        containerNode:addChild(label)
        local _, labelHeight = label:getContentSize()
        height = height + labelHeight
        if index ~= (count-1) then
            height = height + 10
        end
    end
    containerNode:setContentSize(width, height)
    self.m_csNode.scrollView:pushNode(rootNode, width, height, 1)
end

function This:onEnter()
    super.onEnter(self)
end

function This:onExit()
    super.onExit(self)
end

function This:initTouchEvent()
end

function This:onTouchMask() -- 对话框之外区域的点击事件
    self:close()
end