---
---
--- Created by aid.
--- DateTime: 2018/12/24 14:40
---
local This , super = class(...,"cc.Node")
local FabaoManager = require("Fabao.FabaoManager")
--local MagicWeaponLevelConfig = require("Metadatas.MagicWeaponLevelConfig")
--local MagicWeaponRefineConfig = require("Metadatas.MagicWeaponRefineConfig")
local MagicWeaponStartConfig = require("Metadatas.MagicWeaponStartConfig")
--local SkillConfig = require("Metadatas.SkillConfig")
local GameUtil = require("Util.GameUtil")
local FabaoUtil = require("Fabao.FabaoUtil")

function This:init()
    self:initData()
    self:initNode()
    self:initTouchEvent()
end

function This:initData()
    self.m_fabaoItemId = nil
    self.m_fabaoStarLevel = nil
end

function This:initNode()
    self.m_csNode = cc.Node:createFromCSFile("GameScene/NodeUI/SpecialSkill.csb")
    self:addChild(self.m_csNode)
end

function This:initTouchEvent()
    --
    self.m_csNode.iconbg:setTouch({
        onEnded = function()
            if FabaoUtil.hasSkillOnFabao(self.m_fabaoItemId, self.m_fabaoStarLevel) then
                local skillId = FabaoUtil.getFabaoSkillId(self.m_fabaoItemId, self.m_fabaoStarLevel)
                local skillDescriptionList, highlightIndex = FabaoUtil.getSkillDescriptionList(self.m_fabaoItemId, skillId, self.m_hideActivationState)
                g_scene:openDialog("Fabao.FabaoSkillInfoPanel", {
                    skillName = FabaoUtil.getSkillName(skillId),
                    skillDescriptionList = skillDescriptionList,
                    highlightIndex = highlightIndex,
                })
            else
                g_scene:showTips(Serialize[60909])
            end
        end,
        isScale = false,
        isDynamic = true,
        isSwallow = false,
    })

end

function This:onEnter()
    super.onEnter(self)
end

function This:onExit()
    super.onExit(self)
end

function This:showFabaoSkill()
    local skillConfig = MagicWeaponStartConfig[self.m_fabaoItemId*1000+self.m_fabaoStarLevel]
    local skillId = skillConfig.skill
    local skillIconId = skillConfig.skill_icon
    if skillId == 0 then
        -- 没有技能
        self.m_csNode.level:setVisible(false)
        self.m_csNode.lvbg:setVisible(false)
        self.m_csNode.icon:setVisible(false)
        self.m_csNode.suo:setVisible(true)
    else
        -- 有技能
        self.m_csNode.icon:setImage(GameUtil:getSkillIcon(skillIconId))
        self.m_csNode.level:setString(string.format("LV.%s", skillId%10)) -- 策划规定，技能id的最后一位作为该技能的等级:)

        self.m_csNode.level:setVisible(true)
        self.m_csNode.lvbg:setVisible(true)
        self.m_csNode.icon:setVisible(true)
        self.m_csNode.suo:setVisible(false)
    end
end

function This:setFabao(fabaoUid)
    local fabao = FabaoManager:getFabao(fabaoUid)
    self.m_fabaoItemId = fabao:getItemId()
    self.m_fabaoStarLevel = fabao:getStarLevel()
    self:showFabaoSkill()
end

function This:setFabaoData(fabaoItemId, starLevel)
    self.m_fabaoItemId = fabaoItemId
    self.m_fabaoStarLevel = starLevel
    self:showFabaoSkill()
end

function This:hideActivationState()
    self.m_hideActivationState = true
end