-- @Author: zheng
-- @Date:   2018-09-10 15:28:14
-- @Last Modified by:   zheng
-- @Last Modified time: 2018-09-12 16:53:39
-- @File Name: FamilyAdminisPanel.lua

local This , super = class(...,"Dialog")
local FamilyManager = require("Family.FamilyManager")
local FamiltApplyListView = require("Family.FamiltApplyListView")
This.fileName = "MenuScene/NodeUI/FamilyAdminis.csb"
FamilyAdminisTabName = 
{
    ktep1 = 1,
    ktep2 = 2,
    ktep3 = 3,
    ktep4 = 4,
    ktep5 = 5,
}

function This:initNode(info)
    if info then
       self.m_family = info.family
    end
    self.m_csNode = cc.Node:createFromCSFile(This.fileName)
    self:addChild(self.m_csNode)
    self.m_csNode:setToCenter()
    self.m_TabNode = FamiltApplyListView:create({family = self.m_family})
    self:addChild(self.m_TabNode)
    for tabKey=1,FamilyAdminisTabName.ktep5 do
		local item = self.m_csNode.biaoqian["tep"..tabKey]
		self:addTabButton(tabKey,item,function()
			if self.m_inited then
				self:lightTabButton(tabKey)
				self.m_selectIndex = tabKey
			end
			self:refresh(  )
	    end)
	end
	self.m_selectIndex = FamilyAdminisTabName.ktep1
	self:selectTabButton(self.m_selectIndex)
	self:refresh(  )
	self.m_inited = true
end

-- function This:initData( queue, dialog )
--     self.m_activity = queue
--     self.m_dialog = dialog
-- end
function This:initTouchEvent()
   self.m_csNode.close:setTouchEnded(function()
        self:close()
    end)
end

function This:refresh()
	self.m_TabNode:setType(self.m_selectIndex)
end

function This:onEnter()
    super.onEnter(self)
    FamilyManager:addObserver(self)
end

function This:onExit()
    super.onExit(self)
    FamilyManager:removeObserver(self)
end
function This:onMemberKickOff()
    local hasFamily = FamilyManager:hasFamily()
    if not hasFamily then
        self:close()
    end
end