-- @Author: superm
-- @Date:   2017-12-16 18:03:42
-- @Last Modified by:   zheng
-- @Last Modified time: 2018-11-13 15:55:46
-- @File Name: FamilyApplyItemView.lua
-- @Description: 


local This , super = class(..., "NodeView")
This.fileName = "MenuScene/NodeUI/FamiltApplyListItem.csb"

local MatchingConfig = require("Metadatas.MatchingConfig")

function This:init(request, index)
    self.m_inited = false
    self.m_request = request
    self.m_listIndex = index
    local w , h = self.bg:getContentSize()
    h=44
    self:setContentSize(w, h)
end

function This:initNode()
	self:refresh()
end

function This:initTouchEvent()
    if not self.m_inited then
        self.sure:setTouch({
		    onEnded = function()
                self:onBuyBtnClick(true)
            end,
            isContainer = true,
        })  

        self.refuse:setTouch({
		    onEnded = function()
                self:onBuyBtnClick(false)
            end,
            isContainer = true,
        })  

        self.txt_bg:setTouch({
            onEnded = function ()
                g_scene:openDialog("Player.RoleInfoPanel",{id = self.m_request:getId()})
            end,
            isContainer = true,
        })
        self.m_inited = true
    end
end

function This:onEnter()
    super.onEnter(self)
end

function This:onExit()
    super.onExit(self)
end

function This:refresh()
    self:refreshItemUI()
end

function This:refreshItemUI()
    self.name:setString(self.m_request:getName())
    self.level:setString("Lv." .. self.m_request:getLevel())

    local rankLevel = self.m_request:getRankLv() or 1
    self.marquis:setString(MatchingConfig[rankLevel].rank_level)
    self.marquisicon:setImage(RankIconImage[rankLevel] or RankIconImage[1])
end

function This:onBuyBtnClick(result)
    if self.m_request then
        self.m_request:requestApplyApproval(result)
    end
end

--endregion