-- @Author: superm
-- @Date:   2017-12-13 21:20:59
-- @Last Modified by:   superm
-- @Last Modified time: 2018-10-23 15:02:59
-- @File Name: FamilyBaseModel.lua
-- @Description: 

local This , super = class(..., "Base.BaseModel")

function This:init( info )
    self.m_isDirty = false
    
    self.m_level = info.level
    self.m_score = info.jifen
    self.m_icon = info.icon
    self.m_loong = info.loong
    self.m_all_power = info.all_power
    self:doInit( info )
end

function This:getId()
    return self.m_id
end

function This:getName()
    return self.m_name or ""
end

function This:getScore()
    return self.m_score or 0
end

function This:getLevel()
    return self.m_level or 1
end

function This:increaseLevel()
    self.m_level = ( self.m_level or 1 ) + 1
    if self.m_level >= kFamilyMaxLevel then
        self.m_level = kFamilyMaxLevel
    end
end

function This:getIcon()
    return self.m_icon or ""
end

function This:updateBaseInfo( info )
    self.m_isDirty = false
    self.m_level = info.level
    self.m_score = info.jifen
    self.m_icon = info.icon
    self.m_loong = info.loong
    self.m_all_power = info.all_power
end


function This:getLoong()
    return self.m_loong or 0
end

function This:getAllPower()
    return self.m_all_power or 0
end

function This:setDirty( value )
    self.m_isDirty = value
end

function This:isDirty()
    return self.m_isDirty
end

function This:setView( view )
    self.m_view = view
end

function This:getView()
    return self.m_view
end

function This:notifyView( funcName, ... )
    if self.m_view then
        self.m_view[funcName](self.m_view, ...)
    end
end


