-- @Author: ZYY
-- @Date:   2018-07-05 21:02:06
-- @Last Modified time: 2018-07-16 20:49:59
-- @Desc: 军团分红人物列表
local This , super = class(...,"NodeUI")
local GameUtil = require("Util.GameUtil")
local ItemUtil = require("Bag.ItemUtil")
local FamilyUtil = require("Family.FamilyUtil")
local FamilyBuildManager = require("Family.FamilyBuildManager")
local FamilyPowerConfig = require("Metadatas.FamilyPowerConfig")
local FamilyManager = require("Family.FamilyManager")

This.fileName = "MenuScene/NodeUI/FamilyBonusList.csb"

function This:initNode(member)
    self.m_member = member or {}
end

function This:updateView()
	local level = (self.m_member.level or 0) % 100
    self.zhiwei:setString(FamilyPowerConfig[level].title)
    local item_str = ""
    local count = #self.m_member.office
    for i , v in ipairs(self.m_member.office) do 
    	local name = ItemUtil.getName(v[1])
    	local num = v[2]
    	local str = name .. "x" .. num
        if AppText:isEnglish() then
            if i == count then
                item_str = item_str .. str
            else
                item_str = item_str .. str .. "\n"
            end
        else
        	if i == 1 then 
        		item_str = str
        	else	
        		if i % 2 ~= 0 then 
        			item_str = string.format("%s\n%s",item_str,str)
        		else
        			item_str = string.format("%s、%s",item_str,str)
        		end
        	end
        end
    end
    self.item:setString(item_str)
    self:updateColor() 
end

function This:updateColor()
    local level = (self.m_member.level or 0) % 100
    local my_level = FamilyManager:getMyFamily():getSelfMemberInfo():getTitle()
    if my_level == level then 
        self.zhiwei:setColor(184,228,97)
        self.item:setColor(184,228,97)
    else
        self.zhiwei:setColor(250,194,83)
        self.item:setColor(255,239,209)
    end
end


function This:onEnter()
	super.onEnter(self)
	self:updateView()
end

function This:onExit()
	super.onExit(self)
end

function This:initTouchEvent()
end

function This:setModel( member)
	if self.m_member.level ~= member.level then  
		self.m_member = member
		self:updateView()
	end
end
