-- @Author: superm
-- @Date:   2018-07-11 16:17:51
-- @Last Modified by:   zheng
-- @Last Modified time: 2020-07-09 11:57:46
-- @File Name: FamilyBossRankItemView.lua
-- @Description: 

local This, super = class(..., "NodeView")
This.fileName = "MenuScene/NodeUI/FamilyRanking.csb"
local FamilyManager = require("Family.FamilyManager")
local GamePlayer = require("Player.GamePlayer")

local GameUtil = require("Util.GameUtil")

function This:init(info, index)
	if info then
		self.m_id = info.id
		self.m_name = info.name
		self.m_damage = info.damage
		self.m_seconds = info.seconds
		self.m_isFamily = info.family
		self.m_rankId = info.myRankId
		self.m_isInContainer = true
	else
		self.m_isInContainer = false
	end

	self.m_index = index or 0

	local w , h = self.xuanzhong:getContentSize()
	self:setContentSize(w,h)
	self:setCascadeOpacityEnabled(true)
end

function This:initNode()
	if not self.m_isInContainer then
		self.m_id = 0
		self.m_name = ""
		self.m_damage = 0
		self.m_seconds = 0
		self.m_isFamily = true
	end
    self:refresh()
end

function This:setModel( info, index )
	if self.m_index ~= index or self.m_id ~= info.id then
		self.m_id = info.id
		self.m_name = info.name
		self.m_damage = info.damage
		self.m_seconds = info.seconds
		self.m_index = index
		self.m_isFamily = info.family
		self.m_myRankId = info.myRankId
		self:refresh()
	end
end

function This:setDefaultModel(isFamily)
	local info
	if isFamily then
		info = {
			id = FamilyManager:getMyFamilyId(),
			name = FamilyManager:getMyFamilyName(),
			damage = 0,
			seconds = 0,
			family = true,
		}
	else
		info = {
			id = FamilyManager:getMyFamilyId(),
			name = GamePlayer:getRoleName(),
			damage = 0,
			seconds = 0,
			family = false
		}
	end
	self:setModel( info, 0 )
	self:setVisible(true)
end


function This:refresh()
	self:refreshIndexNode()
	self.xuanzhong:setVisible(self.m_id == self.m_myRankId)
	self.weixuanzhong:setVisible(true)
	self.name:setString(self.m_name)
	if not self.m_isFamily then
		self.hurt:setVisible(true)
		self.hurt:setString(self.m_damage)
	else
		self.hurt:setVisible(false)
	end

	if self.time then
		local personalMode = not self.m_isFamily
		self.time:setVisible(not personalMode)
		self.weitongguang:setVisible(not personalMode)
		if not personalMode then
			local visible = self.m_seconds > 0
			self.time:setVisible(visible)
			self.weitongguang:setVisible(not visible)
			if visible then
				self.time:setString(GameUtil:formatTime(Serialize["H_M_S"], self.m_seconds))
			end
		end
	end
end

function This:refreshIndexNode()
	self.m_index = self.m_index or 0
	local topVisible = self.m_index < 4 and self.m_index > 0
	self.rank:setVisible(not topVisible)
	self.top:setVisible(topVisible)
	if topVisible then
		self.top:setImage("MenuScene/top" .. self.m_index .. ".png")
	elseif self.m_index > 0 then
		self.rank:setString(tostring(self.m_index))
	else
		self.rank:setString(Serialize[60238])
	end 
end
