-- @Author: su
-- @Date:   2018-12-07 17:20:19
-- @Last Modified by:   su
-- @Last Modified time: 2018-12-07 17:20:19
-- @File Name: FamilyDonateReward.lua
-- @Description: 


local This,super = class(...,"Dialog")
local ItemNode = require("UI.ItemNode") 
local FamilyManager = require("Family.FamilyManager")
local FamilyRatingManager = require("FamilyRating.FamilyRatingManager")
local ContributeBoxConfig = require("Metadatas.ContributeBoxConfig")


function This:initNode(info)
    self.m_csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/PeakContestChallengeBoxReward.csb")
    self.m_csNode:setToCenter()
    self:addChild(self.m_csNode)
    local node = self.m_csNode.scrollView
    node:setDirection("horizontal")
    node.m_direction = "right"
    for _,data in pairs(self.m_data.reward) do
        local itemView = ItemNode:create(data[1],data[2])
        itemView:setAnchorPoint(0.5,0.5)
        local w,h = itemView:getContentSize()
        node:pushBackCustomItem(itemView,w,h,1.5-(#self.m_data.reward-2)*0.5)
    end
    self:refresh()
end

function This:initData( info )
    self.m_id = info.key
    self.m_data = self:getDataById(self.m_id)
    self.m_state = self:getState()
end

function This:refresh( )
    local node = self.m_csNode
    node.title:setString(self.m_data.name)
    node.condition:setString(string.format(Serialize[60953],self.m_data.frequency))
    node.condition:setVisible(self.m_state==FamilyDonateRewardState.kNoReward)
    node.lingqu:setVisible(self.m_state == FamilyDonateRewardState.kCanRecive)
    node.yilingqu:setVisible(self.m_state == FamilyDonateRewardState.kHasRecive)
end

function This:initTouchEvent()
    local csNode = self.m_csNode
    csNode.close:setTouchEnded(function ()
        self:close()
    end)
    csNode.lingqu:setTouchEnded(function ()
        FamilyRatingManager:onDonateRewardRequest(self.m_id)
        self:close()
    end)
end

function This:onEnter()
    super.onEnter(self)
    FamilyManager:addObserver(self)
    FamilyRatingManager:addObserver(self)
end

function This:onExit()
    FamilyManager:removeObserver(self)
    FamilyRatingManager:removeObserver(self)
    super.onExit(self)
end

-------------------------------------------------------------------
function This:getDataById( id )
    -- local data 
    -- for _,box in pairs(ContributeBoxConfig) do
    --     if box.id == id then
    --         data = box
    --     end
    -- end
    return ContributeBoxConfig[id] or {}
end

function This:getState()
    local state = FamilyDonateRewardState.kNoReward
    local num = FamilyManager:getDonateTimes() 
    local score = FamilyManager:getMyFamily():getDonationScore()
    if num >= self.m_data.frequency and score>= self.m_data.score then
        state = FamilyDonateRewardState.kCanRecive
    end
    local res = FamilyManager:getDonatineRewardRecord()
    for _,data in ipairs(res)do
        if self.m_id == data then
            state = FamilyDonateRewardState.kHasRecive
            break
        end
    end
    return state
end