﻿-- @Author: superm
-- @Date:   2017-12-15 10:24:58
-- @Last Modified by:   superm
-- @File Name: FamilyInfoTabNode.lua
-- @Description: 所属家族的信息分页
local This, super = class(..., "NodeUI")
This.fileName = "MenuScene/NodeUI/Family.csb"


local GameUtil = require("Util.GameUtil")
local UpdateLayer = require("UI.UpdateLayer")
local FamilyManager = require("Family.FamilyManager")
local FamilyBuildManager = require("Family.FamilyBuildManager")
local FamilyRatingManager = require("FamilyRating.FamilyRatingManager")

local ChatManager = require("Chat.ChatManager")
local MemberListNode = require("Family.MemberListNode")
local FamilyBuildNode = require("Family.FamilyBuildNode")
local FamilyStoreNode = require("Family.FamilyStoreNode")
local FamilyTaskNode = require("Family.FamilyTaskNode")
local FamilyAffairsNode = require("Family.FamilyAffairsNode")
-- local FamilyPlanTipsNode = require("Family.FamilyPlanTipsNode")
local VitalityManager = require("Achieve.VitalityManager")
local RankManager = require("Rank.RankManager")
local FamilyBossManager = require("FamilyBoss.FamilyBossManager")
local FamilyGradeNode = require("FamilyRating.FamilyGradeNode")
local FamilyScienceNode = require("Family.FamilyScienceNode")
local ArrayManager = require("Hero.ArrayManager")
local Signals = require("SignalSystem.Signals")
local SignalSystem = require("SignalSystem.SignalSystem")
local SubscriberConfig = require("Metadatas.SubscriberConfig")
local DepotManager = require("Depot.DepotManager")
local ContributeConfig = require("Metadatas.ContributeConfig")
local ContributeBoxConfig = require("Metadatas.ContributeBoxConfig")
local GamePlayer = require("Player.GamePlayer")

local TabName = {
	kMember = "member",
	kBuilding = "build",
	kShop = "shop",
	kActive = "active",
	kJunXian = "junxian",
	kNeiWu = "neiwu",
    kjunxian = "junxian",
    kScience = "keji"
}

function This:initNode(info)
    self.m_myRank = 0
    local tab = info and info.tab
	self:addTabButton(TabName.kMember,self.biaoqian.chengyuan,function()
        FamilyManager:onGetMyFamilyInfoRequest()
        print("TabName.kMember")
        self.inform:setVisible(true)
        self:openTabNode(TabName.kMember)
    end)
    self:addTabButton(TabName.kBuilding,self.biaoqian.jianzhu,function()
        print("TabName.kBuilding")
        self.inform:setVisible(false)
        self:openTabNode(TabName.kBuilding)
    end)
    self:addTabButton(TabName.kShop,self.biaoqian.shangdian,function()
        local build = FamilyBuildManager:getBuildByType(FamilyBuildType.kShangDian)
        if build:getLevel() <= 0 then
            g_scene:showTips(Serialize["family_InfoTab_1"])
            return false
        end

        if not build:isNormal() then
            g_scene:showTips(Serialize["family_BuildNode_1_c"])
            return false
        end

        self.m_storeTabRedDot:setVisible(false)
        cc.FileUtils:saveToLua({time = GamePlayer:getServerTime()},"FamilyStoreTabRedDotLastClickTime")

        self.inform:setVisible(false)
        self:openTabNode(TabName.kShop)
    end)
    self:addTabButton(TabName.kActive,self.biaoqian.huoyue,function()
        self.inform:setVisible(false)
        self:openTabNode(TabName.kActive)
    end)
    self:addTabButton(TabName.kJunXian,self.biaoqian.junxian,function()
        FamilyRatingManager:onGetRatingInfoRequest()
        FamilyManager:onGetMyFamilyInfoRequest()
        self.inform:setVisible(true)
        self:openTabNode(TabName.kjunxian)
    end)
    self:addTabButton(TabName.kNeiWu,self.biaoqian.neiwu,function()
        print("TabName.kNeiWu")
        self.inform:setVisible(true)
        self:openTabNode(TabName.kNeiWu)
    end)

    self:addTabButton(TabName.kScience,self.biaoqian.keji,function()
        FamilyRatingManager:onScienceRequest()
        local build = FamilyBuildManager:getBuildByType(FamilyBuildType.kJunJiChu)
        if build:getLevel() <= 0 then
            g_scene:showTips(Serialize["family_InfoTab_1_a"])
            return false
        end
        print("TabName.kScience")
        self.inform:setVisible(true)
        self:openTabNode(TabName.kScience)
    end)

    self.inform.xinxi.numberjtpm:setString(Serialize[60238])
	self:selectTabButton(tab or TabName.kMember)

    -- 建筑标签的红点
    self.m_buildingTabRedDot = GameUtil:createRedDotTo(self.biaoqian.jianzhu)
    local redDotWidth, redDotHeight = self.m_buildingTabRedDot:getContentSize()
    local width, height = self.biaoqian.jianzhu.normalbg:getContentSize()
    self.m_buildingTabRedDot:setPosition(width/2-redDotWidth/2, height/2-redDotHeight/2)

    -- 活跃标签的红点
    self.m_vitalityTabRedDot = GameUtil:createRedDotTo(self.biaoqian.huoyue)
    local redDotWidth, redDotHeight = self.m_vitalityTabRedDot:getContentSize()
    local width, height = self.biaoqian.huoyue.normalbg:getContentSize()
    self.m_vitalityTabRedDot:setPosition(width/2-redDotWidth/2, height/2-redDotHeight/2)

    -- 内务标签的红点
    self.m_affairsTabRedDot = GameUtil:createRedDotTo(self.biaoqian.neiwu)
    local redDotWidth, redDotHeight = self.m_affairsTabRedDot:getContentSize()
    local width, height = self.biaoqian.neiwu.normalbg:getContentSize()
    self.m_affairsTabRedDot:setPosition(width/2-redDotWidth/2, height/2-redDotHeight/2)
    self.m_affairsTabRedDot:setVisible(false)

    -- 祭祀按钮特效
    local parentNode = self.inform.xinxi.jiahao.shizi
    self.m_addButtonEffectNode = GameUtil:createEffect("WuSheng1", true, self)
    local width, height = parentNode:getContentSize()
    self.m_addButtonEffectNode:setPosition(width/2, height/2)
    parentNode:addChild(self.m_addButtonEffectNode)
    self.m_addButtonEffectNode:setVisible(false)

    -- 商店标签的红点
    self.m_storeTabRedDot = GameUtil:createRedDotTo(self.biaoqian.shangdian)
    local redDotWidth, redDotHeight = self.m_storeTabRedDot:getContentSize()
    local width, height = self.biaoqian.shangdian.normalbg:getContentSize()
    self.m_storeTabRedDot:setPosition(width/2-redDotWidth/2, height/2-redDotHeight/2)

    local build = FamilyBuildManager:getBuildByType(FamilyBuildType.kShangDian)
    local lastTime = cc.FileUtils:loadLuaFile("FamilyStoreTabRedDotLastClickTime")
    if not lastTime then
        lastTime = {time = 0}
    end
    if not (build:getLevel() > 0 and build:isNormal()) then
        self.m_storeTabRedDot:setVisible(false)
    else
        if GameUtil.isNeedDailyUpdate(lastTime.time, GamePlayer:getServerTime(), 21, 30) then
            self.m_storeTabRedDot:setVisible(true)
        else
            self.m_storeTabRedDot:setVisible(false)
        end
    end

    self.m_inited = false
    FamilyRatingManager:onGetRatingInfoRequest()
    FamilyManager:onGetMyFamilyInfoRequest()
    self:refreshRed()
end

function This:createTabNode(tabName)
	if tabName == TabName.kMember then
		return MemberListNode:create({family = self.m_family})
    elseif tabName == TabName.kBuilding then
        return FamilyBuildNode:create({family = self.m_family})
    elseif tabName == TabName.kShop then
        return FamilyStoreNode:create({family = self.m_family})
	elseif tabName == TabName.kActive then
        return FamilyTaskNode:create({family = self.m_family})
    elseif tabName == TabName.kNeiWu then 
        return FamilyAffairsNode:create({family = self.m_family})
    elseif tabName == TabName.kjunxian then 
        return FamilyGradeNode:create({family = self.m_family})
    elseif tabName == TabName.kScience then
        return FamilyScienceNode:create({family = self.m_family})
	end
end

function This:onTabNodeSwitchIn(node, name)
    if name == TabName.kBuilding then
        FamilyBuildManager:onGetFamilyBuildInfoRequest()
    elseif name == TabName.kNeiWu then
        FamilyManager:onGetMyFamilyInfoRequest()
        if FamilyBuildManager:isInNormalState() then
            FamilyManager:onFamilyBonusStateRequest()
        end
    elseif name == TabName.kMember then
        self:getSelfRankInfo()
        FamilyManager:onGetMyFamilyInfoRequest()
        FamilyBuildManager:onGetFamilyBuildInfoRequest()
    elseif name == TabName.kActive then
        VitalityManager:onGetFamilyTaskInfoRequest()      
    elseif name == TabName.kShop then
        if node then
            node:refresh(true)
        end
    elseif name == TabName.kScience then
        FamilyRatingManager:onScienceRequest()
    end
end

function This:refreshRed()
    local redDotWidth, redDotHeight = self.m_storeTabRedDot:getContentSize()
    local width, height = self.biaoqian.shangdian.normalbg:getContentSize()
    GameUtil:refreshRedDot(self.biaoqian.keji,FamilyRatingManager:scienceHaveReward(),{width/2-redDotWidth/2, height/2-redDotHeight/2},1.0)
    GameUtil:refreshRedDot(self.biaoqian.junxian,FamilyRatingManager:ratingHaveReward(),{width/2-redDotWidth/2, height/2-redDotHeight/2},1.0)
    
end

function This:initTouchEvent()
    if not self.m_inited then
		self.inform.guanli:setTouchEnded(function()
            local panel = g_scene:openDialog("Family.FamilyAdminisPanel", {family = self.m_family})
                panel:addCloseCallback(function ()
                if FamilyManager:isDirty() then
                    FamilyManager:onGetMyFamilyInfoRequest()
                end
            end)
		end)
    	self.inform.xuanyan.changename1:setTouchEnded(function()
    		if not self.m_family then
    			return
    		end

            local panel = g_scene:openDialog("Family.FamilyCreatePanel",{
                descMaxLength = 500,
                title = Serialize["family_InfoTab_2"],
                defaultName = self.m_family:getName(),
                defaultDesc = self.m_family:getDescription(),
                inputDescOnly = true,
            })
            panel:setRenameHandler(function(name, desc)
    		    self.m_family:requestChangeDesc(desc)
            end)
    	end)

    	self.inform.xinxi.changename:setTouchEnded(function()
    		if not self.m_family then
    			return
    		end

            local panel = g_scene:openDialog("Family.FamilyCreatePanel",{
                cost = kFamilyRenameCost,
                nameMaxLength = 7,
                title = Serialize["family_InfoTab_3"],
                defaultName = self.m_family:getName(),
                defaultDesc = self.m_family:getDescription(),
                inputNameOnly = true,
            })
            panel:setRenameHandler(function(name, desc)
    		    self.m_family:requestRename(name)
            end)
    	end)

        --四个感叹号提示
        local tipTables = {Serialize["family_statue_help"],Serialize["family_funds_help"],
                        Serialize["family_InfoTab_11"],Serialize["family_InfoTab_12"],Serialize["family_InfoTab_13"]}
        local xinxi = self.inform.xinxi
        for itemIndex,tipStr in ipairs(tipTables) do
            local item1 = xinxi["gantanhao"..itemIndex]
            item1:setTouchEnded(function ()
                g_scene:openDialog("UI.HelpTips", {text = tipStr,node = item1})
            end)
        end

        self.inform.xinxi.jiahao:setTouchEnded(function ()
            g_scene:openDialog("Family.FamilyDonatePanel", self.m_family)
        end)

        self.inform.xinxi.jttubiao:setTouchEnded(function ()  
            -- g_scene:openDialog("Store.CompetitionShopPanel", {})  

        end)
        self.m_inited = true
    end
end

local function checkItemWhetherEnough()
    local enough = false
    for _, item in pairs(SubscriberConfig) do
        local itemId = item.id
        local neededCount = item.number
        if DepotManager:getItemOrResCount(itemId, {itemUid = 0}) >= neededCount then
            enough = true
            break
        end
    end
    return enough
end

function This:onEnter()
	super.onEnter(self)
    FamilyManager:addObserver(self)
    RankManager:addObserver(self)
    FamilyRatingManager:addObserver(self)
    FamilyBuildManager:addObserver(self)
    
    -- 屏蔽军团boss预告
    -- g_scene.m_timer:setTimer(0.5,function()
    --     local tipState = FamilyBossManager:getTipState()
    --     if tipState then
    --         return
    --     end

    --     local chapter = FamilyBossManager:getChapter()
    --     if chapter:isPreviewTime() then
    --         g_scene:openDialog("FamilyBoss.FamilyBossComePanel",chapter)
    --     end
    -- end,"showBossPreview")

    self.m_signalHandlers = {
        [Signals.FamilyPanelBuildTabRedDot] = function(data)
            self.m_buildingTabRedDot:setVisible(g_redDot:checkAllFamilyBuilding())
            self:refreshRed()
        end,
        [Signals.FamilyPanelVitalityTabRedDot] = function(data)
            self.m_vitalityTabRedDot:setVisible(g_redDot:checkFamilyVitality())
        end,
        [Signals.FamilyPanelAffairsTabRedDot] = function(data)
            local bonus = g_redDot:checkFamilyAffairsBonus()
            local boss = g_redDot:checkFamilyAffairsBoss()
            local aboss = g_redDot:checkLegionAboss()
            self.m_affairsTabRedDot:setVisible(bonus or boss or aboss)
        end,
        [Signals.FamilyPanelSacrifice] = function(data)
            local show = false
            --
            local leftTimes = kFamilyDonateTimes - FamilyManager:getDonateTimes()
            if leftTimes <0 then
                leftTimes = 0
            end
            for _, config in ipairs(ContributeConfig) do
                local costId, costNum = unpack(config.upcost[1])
                local ownedCount = DepotManager:getItemOrResCount(costId, {itemUid = 0})
                if ownedCount >= costNum and leftTimes > 0 then
                    show = true
                    break
                end
            end
            --
            local num = FamilyManager:getDonateTimes()
            local family = FamilyManager:getMyFamily()
            if family then
                local score = family:getDonationScore()
                for _, config in ipairs(ContributeBoxConfig) do
                    local state = FamilyDonateRewardState.kNoReward
                    if num >= config.frequency and score>= config.score then
                        state = FamilyDonateRewardState.kCanRecive
                    end
                    local res = FamilyManager:getDonatineRewardRecord()
                    for _,data in ipairs(res)do
                        if config.id == data then
                            state = FamilyDonateRewardState.kHasRecive
                            break
                        end
                    end
                    if state == FamilyDonateRewardState.kCanRecive then
                        show = true
                        break
                    end
                end
            end

            if show then
                self.m_addButtonEffectNode:setVisible(true)
            else
                self.m_addButtonEffectNode:setVisible(false)
            end
        end,
    }
    SignalSystem.addSignalHandlers(self.m_signalHandlers)
    SignalSystem.distributeSignal(Signals.FamilyPanelBuildTabRedDot)
    SignalSystem.distributeSignal(Signals.FamilyPanelVitalityTabRedDot)
    SignalSystem.distributeSignal(Signals.FamilyPanelAffairsTabRedDot)
    SignalSystem.distributeSignal(Signals.FamilyPanelSacrifice)
end

function This:onExit()
    self.m_isClose = true
    SignalSystem.removeSignalHandlers(self.m_signalHandlers)
    RankManager:clearInfo()
    RankManager:removeObserver(self)
    FamilyManager:removeObserver(self)
    FamilyRatingManager:removeObserver(self)
    FamilyBuildManager:removeObserver(self)
    super.onExit(self)
end

function This:refresh()
	if self.m_inited then
		self:refreshInfoView()
	end
end

function This:refreshBuildInfo()
    local function updateLabel(textNode)
        local color, str
        if FamilyBuildManager:isInNormalState() then
            color = {r=187, g=228, b=97}
            str = Serialize["family_DonatePanel_1"]
        else 
            color = {r=255, g=0, b=0}
            -- Serialize[60957],
            str = Serialize["family_InfoTab_maintain"]            
        end
        textNode:setColor(color.r,color.g,color.b)
        textNode:setString(str)
    end
    updateLabel(self.inform.xinxi.zhengchang)
    self.inform.xinxi.level:setString("Lv." .. FamilyBuildManager:getBuildingLevel(FamilyBuildType.kYiShiTing))
    self.inform.xinxi.numberjtzj:setString(GameUtil:formatCount(self.m_family:getFunds()))
end

function This:refreshInfoView()
    self.inform.xinxi.jtmingzi:setString(self.m_family:getName())
    self.inform.xinxi.level:setString("Lv." .. self.m_family:getLevel())
    self.inform.xinxi.numbersliz:setString(GameUtil:formatCount(self.m_family:getScore()))

    self.inform.xinxi.numberlm:setString(self.m_family:getLoong())
    self.inform.xinxi.numberjtzzl:setString(self.m_family:getAllPower())

    self.inform.xinxi.numberjtrs:setString(self.m_family:getMemberPeple())
    self.inform.xinxi.leader:setString(self.m_family:getLeaderName())
    self.inform.xuanyan.xuanyanneirong2:setString(self.m_family:getDescription(),465)

    local data = self.m_family:getRatingData()
    local rankScore = data:getRankScoreModel()
    self.inform.xinxi.jttubiao:setImage(rankScore:getIcon())

    local selfMember = self.m_family:getSelfMemberInfo()
    if selfMember then

        self.inform.xuanyan.changename1:setVisible(selfMember:hasPower(FamilyPower.kChangeDesc))
        self.inform.xinxi.changename:setVisible(selfMember:hasPower(FamilyPower.kRename))
    end

    self:refreshBuildInfo()
end

---------------------------------------------------------------------------------------
function This:onGetMyFamilyInfo(family)
    if self.m_isClose then
        return
    end
    
    if not self.m_family or self.m_family:getId() ~= family:getId() then
	    self.m_family = family
    end
	self:refresh()
    SignalSystem.distributeSignal(Signals.FamilyPanelAffairsTabRedDot)
end

function This:onFamilyRename()
    if self.inform.xinxi.jtmingzi:getString() ~= self.m_family:getName() then
        g_scene:showTips(Serialize["family_InfoTab_7"])
        self.inform.xinxi.jtmingzi:setString(self.m_family:getName())
    elseif self.inform.xinxi.xuanyanneirong2:getString() ~= self.m_family:getDescription() then
        g_scene:showTips(Serialize["family_InfoTab_8"])
        self.inform.xinxi.xuanyanneirong2:setString(self.m_family:getName())
    end
end

function This:onSubmitApplyFilter(ret)
    if ret then
        local ret = false
        if self.inform.xinxi.jtmingzi:getString() ~= self.m_family:getName() then
            self.inform.xinxi.jtmingzi:setString(self.m_family:getName())
            ret = true
        end
        if not ret then
            g_scene:showTips(Serialize["family_InfoTab_8"])
        else
            g_scene:showTips(Serialize["family_InfoTab_9"])
        end
        self.inform.xuanyan.xuanyanneirong2:setString(self.m_family:getDescription(), 340)
    end
end

function This:onFamilyUpgrade()
    self:refreshBuildInfo()
end

function This:onScienceResearch()
    self:refreshBuildInfo()
end

function This:onGetFamilyBuildInfo()
    self:refresh()
end

function This:onMemberKickOff()
    self:refreshBuildInfo()
end

function This:onFamilyDonate()
    self:onTabNodeSwitchIn(nil, TabName.kMember)
end

function This:getSelfRankInfo()
    if self.m_myRank <= 0 then
        RankManager:onGetRankInfoRequest(RankType.Family, false, 1)
    end
    return self.m_selfRankInfo
end

function This:onGetRankInfo( rtype, info,  selfRank)
    if RankType.Family == rtype then
        self.m_myRank = selfRank
        if self.m_myRank > 0 then
            self.inform.xinxi.numberjtpm:setString(self.m_myRank)
        else
            self.inform.xinxi.numberjtpm:setString(Serialize[60238])
        end
    end
end


function This:onRatingUp()
    self:refresh()
    self:refreshRed()

end

function This:onGetRatingReward()
    self:refreshRed()
end

function This:onUpgradeFamilyBuild()
    self:refreshRed()
end

function This:onChangeState()
    self:refreshRed()
    
end

function This:onScienceResearch()
    self:refreshRed()
end

function This:onScienceUp(id)
    self:refreshRed()
end

function This:onGetRatingInfo()
    self:refreshRed()
    
end