-- @Author: superm
-- @Date:   2018-02-27 15:22:57
-- @Last Modified by:   zheng
-- @Last Modified time: 2018-11-13 15:57:58
-- @File Name: FamilyInvitePopPanel.lua
-- @Description: 

local This , super = class(...,"Dialog")
local GameUtil = require("Util.GameUtil")
local FamilyManager = require("Family.FamilyManager")
local MatchingConfig = require("Metadatas.MatchingConfig")

function This:initNode(info)
	self.m_roleName = info.roleName
	self.m_roleLevel = info.level
	self.m_roleIcon = info.icon
	self.m_roleRank = info.rank
	self.m_inviteFamilyId = info.groupId
	self.m_inviteFamilyName = info.groupName
	self.m_csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/TeamMatchingInvitationPopup.csb")
	self:addChild(self.m_csNode)
	self.m_csNode:setToCenter()

	GameUtil:setPlayerIconNodeImage(self.m_csNode.icon, self.m_roleIcon)
	self.m_csNode.name:setString(self.m_roleName)
	self.m_csNode.office:setString(MatchingConfig[self.m_roleRank].rank_level)
	self.m_csNode.level:setString(string.format("Lv.%d", self.m_roleLevel))
	self.m_csNode.text:setString(Serialize["family_InvitePop_1"])
	self.m_csNode.type:setString(self.m_inviteFamilyName)
	self.m_csNode:setScale(0)
	self.m_escape = 0
	self.m_totalTime = info.time or 10
	self.m_csNode.time:setString(string.format(Serialize["family_InvitePop_2_c"],self.m_totalTime))
end

function This:initTouchEvent()
	self.m_csNode.close:setTouch({
		onEnded = function()
			self:close()
		end,
		isDynamic = true
	})
	self.m_csNode.cancel:setTouch({
		onEnded = function()
			self:close()
		end,
		isDynamic = true
	})
	self.m_csNode.confirm:setTouch({
		onEnded = function()
			FamilyManager:onSubmitApplyingRequest(self.m_inviteFamilyId)
			self:close()
		end,
		isDynamic = true
	})
end

function This:onEnter()
	super.onEnter(self)
	self:scheduleUpdate()
end

function This:runOpenAnimation()
	self.m_csNode:runAction(cc.Sequence(
		cc.ScaleTo(0.5,1.0,"ElasticInOut"),
		cc.CallFunc(function()
			self:onOpen()
		end)
	))
end

function This:update(dt)
	super.update(self,dt)
	self.m_escape = self.m_escape + dt
	if self.m_escape > 1 then
		self.m_escape = self.m_escape - 1
		self.m_totalTime = self.m_totalTime - 1
		if self.m_totalTime <= 0 then
			self:close()
		else
			self.m_csNode.time:setString(string.format(Serialize["family_InvitePop_2_c"],self.m_totalTime))
		end
	end
end
