-- @Author: superm
-- @Date:   2017-12-16 10:44:24
-- @Last Modified by:   zheng
-- @Last Modified time: 2019-05-22 16:07:28
-- @File Name: FamilyJoinRequestPanel.lua
-- @Description: 

local This , super = class(..., "Dialog")
local MatchingConfig = require("Metadatas.MatchingConfig")
local FamilyUtil = require("Family.FamilyUtil")
local ListLayer = require("UI.ListLayer")
local DailyAchieveManager = require("Achieve.DailyAchieveManager")

function This:initNode(info)
    self.m_family = info.family
    if self.m_family then
    	info.defaultLevel = self.m_family:getConditionValue(1)
	    info.defaultRankLev = self.m_family:getConditionValue(2)
		info.defaultAuto = self.m_family:getAutoJoin() 	
	end

    self.m_rankLevel = FamilyUtil:NVL(info.defaultRankLev, 0)
   	self.m_level = FamilyUtil:NVL(info.defaultLevel, 0)
	self.m_isAuto = FamilyUtil:NVL(info.defaultAuto, true)

	self.m_csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/FamilyJoinRequest.csb")
	self.m_csNode:setToCenter()
	self:addChild(self.m_csNode)
    self.m_inited = true

	self.m_csNode.level:setString( FamilyUtil:NVL(info.defaultLevel, "") )
	self.m_csNode.gou:setVisible(  self.m_isAuto )
	self.m_csNode.office:setString( self.m_rankLevel > 0 and MatchingConfig[self.m_rankLevel].rank_level or "")

	self:initListLayer()
end

function This:initListLayer()
	self.m_listLayer = ListLayer:create({
		itemWidth =  130,
		itemHeight =  30,
		frameCount = kMaxMatchRankLv + 1,
		spaceX = 0,
		spaceY = 0,
        scrollView = self.m_csNode.select.scrollView,
	})

	local w , h = self.m_listLayer:getContentSize()
	self.m_listLayer:setAnchorPoint(0.5, 1)
	self.m_csNode.select.scrollView:pushBackCustomItem(self.m_listLayer, w, h)
	for i=1, kMaxMatchRankLv do
		local name = MatchingConfig[i].rank_level
		local bg = cc.Scale9Sprite:create("GameScene/xialakuangbiaoti.png")
		bg:setContentSize(130, 31)
		local text = cc.Label:createWithTTF("Fonts/Normal.ttf", name, 15)
		text:setPosition(65 , 16)
		bg:addChild(text)
		bg:setTouch({
			onEnded = function()
				self.m_csNode.select:setVisible(false)
				self.m_rankLevel = i
				self.m_csNode.office:setString( name )
			end,
			isContainer = true,
			isScale = false,
		})
		self.m_listLayer:pushNode(bg)		
	end
    self.m_csNode.select.scrollView:scrollToTop(0.3)
end

function This:initTouchEvent()
	self.m_csNode.close:setTouchEnded(function()
		self:close()
	end)

	self.m_csNode.arrow:setTouchEnded(function()
		local visible = self.m_csNode.select:isVisible()
		self.m_csNode.select:setVisible(not visible)
	end)

	self.m_csNode.officebg:setTouch({
			onEnded = function()
				local visible = self.m_csNode.select:isVisible()
				self.m_csNode.select:setVisible(not visible)
			end,
			isScale = false,
		})

	self.m_csNode.goubg:setTouch({
		onEnded = function()
			self.m_isAuto = not self.m_isAuto
			self.m_csNode.gou:setVisible(self.m_isAuto)
		end,
		isScale = false,
	})

	self.m_csNode.save:setTouchEnded(function()
		-- local crusadeData =DailyAchieveManager:getCrusadeData()
		-- local joinLimit = crusadeData:getCrusadeConfigNum("join_group_level")
		local lvLimit = DailyAchieveManager:getArgConfigLv("join_group_level")
		local levelStr = self.m_csNode.level:getString()
		if string.len(levelStr) <= 0 then
			self.m_level = lvLimit
		else
			local tmplevel = FamilyUtil:checkIsNum(levelStr ,100)
			if tmplevel and tmplevel >= lvLimit then
				self.m_level = tmplevel
			else
				g_scene:showTips(string.format(Serialize["family_JoinRequest_1"],lvLimit))
				return
			end
		end

		self.m_family:requestChangeRequestion(self.m_level, self.m_rankLevel, self.m_isAuto)
		self:close()
	end)
end

function This:onTouchMask()
	self.m_csNode.select:setVisible(false)
end

