-- @Author: superm
-- @Date:   2017-12-15 20:38:09
-- @Last Modified by:   zheng
-- @Last Modified time: 2018-07-07 15:25:39
-- @File Name: FamilyLevelUpPanel.lua
-- @Description: 

local This , super = class(..., "Dialog")
local FamilyManager = require("Family.FamilyManager")

function This:initNode(family)
    self.m_family = family
	self.m_csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/FamilyLevelUp.csb")
	self.m_csNode:setToCenter()
	self:addChild(self.m_csNode)
    self.m_inited = true
end

function This:initTouchEvent()
	self.m_csNode.close:setTouchEnded(function()
		self:close()
	end)

	self.m_csNode.levelup:setTouchEnded(function()
		if self:isLocked() then
			g_scene:showTips(Serialize["family_LevelUp_1"])
			return
		end
		self.m_family:requestUpgrade()

	end)
end

function This:onEnter()
    super.onEnter(self)
    FamilyManager:addObserver(self)
    self:refreshConditionNode()
end

function This:onExit()
    FamilyManager:removeObserver(self)
    super.onExit(self)
end

function This:refreshConditionNode()
	if not self.m_family:isMaxLevel() then
        local canUpgrade = not self:isLocked()
		self.m_csNode.full:setVisible(false)
		self:colorCondText(self.m_csNode, 1, canUpgrade, Serialize["family_LevelUp_2"], tostring(self.m_family:getNextLevelCond()))
        if not canUpgrade then
            self.m_csNode.levelup:setGrayShader()
        end
    else
        self.m_csNode.levelup:setVisible(false)
		self.m_csNode.full:setVisible(true)
		self:hideCondText( self.m_csNode )
	end
end

function This:isLocked()
    return self.m_family:isLevelUpLocked()
end

function This:hideCondText( node, index )
    if not index then
        index = 1
        node.condition:setVisible( false )
        node.bg4:setVisible( false )
    end
    node["condition" .. index]:setVisible( false )
    node["unfinish" .. index]:setVisible( false )
    node["finish" .. index]:setVisible( false )
end

function This:colorCondText( node, index, value, text1, text2  )
    node["condition" .. index]:setStringWithColor( "<A5>" .. text1 .. "<A0>" .. (value and " : <A1>" or " : <R0>") .. text2)
    node["condition" .. index]:setVisible( true )
    node["unfinish" .. index]:setVisible( not value )
    node["finish" .. index]:setVisible( value )
end

function This:onFamilyUpgrade()
    self:close() 
end

