-- @Author: superm
-- @Date:   2017-12-14 14:34:46
-- @Last Modified by:   superm
-- @Last Modified time: 2019-09-27 15:04:23
-- @File Name: FamilyList.lua
-- @Description: 

local This, super = class(..., "Base.UpdateList")

function This:init()
	super.init(self)
end

function This:addNode(node,key)
	super.addNode(self, node, key)
	self.m_nodes[self.m_size] = node
	self.m_key[key].index = self.m_size
end

function This:removeNode(key)
	local node = self.m_key[key]
	if node then
		local index = node.index
		local ret = node.node
		local nex = super.removeNode(self, key)
		table.remove(self.m_nodes, index)
		while nex do
			nex.index = index 
			index = index + 1
			nex = nex.nex
		end
		return nex, ret
	end
end

function This:clear()
	self.m_header = {}
	self.m_tail = {}
	super.clear(self)
	self.m_size = 0
	local ret = self.m_nodes
	self.m_nodes = {}
	return ret
end

function This:updateAllNodeList(dataList, keyHandler, handler)
	local oldKeys = self.m_key
	self:clear()
	for _, data in pairs(dataList) do
		local key = keyHandler(data)
		local node = oldKeys[key]
		local ret 
		if node then
			ret = node.node
		end
		handler(key, ret, data)
	end
end

function This:getAllNodeList()
    return self.m_nodes
end