﻿-- @Author: zheng
-- @Date:   2018-07-04 11:34:28
-- @Last Modified by:   zheng
-- @Last Modified time: 2018-07-12 15:08:25
-- FamilyMailPanel


local This , super = class(..., "Dialog")
local FamilyManager = require("Family.FamilyManager")
local GameUtil = require("Util.GameUtil")

function This:initNode()
    self.m_csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/FamilyMail.csb")
    self:addChild(self.m_csNode)
    self.m_csNode:setToCenter()
    self.m_escape = 0
    self.m_timeLimit = 300
    self:updateSendBtn()
end

function This:initTouchEvent()
    self.m_csNode.close:setTouchEnded(function()
        self:close()
    end)

    self.m_csNode.fasong:setTouchEnded(function()
        if not self:isCanSend() then
            g_scene:showTips(Serialize["family_MailPanel_2"])
        end
        local name, desc
        name = self.m_csNode.inputName.name:getString()
        local len = string.utf8Len(name)
        local nilStr = Serialize["family_MailPanel_1"]
        if len <= 0 then
            g_scene:showTips(nilStr)
            return
        elseif len < 2 then
            g_scene:showTips(Serialize["tip_1_c"])
            return
        elseif len > 7 then
            g_scene:showTips(Serialize["tip_2_c"]) 
            return
        elseif GameUtil:checkInvalidAscill(name) then
            g_scene:showTips(Serialize["tip_3_c"])
            return
        end

        desc = self.m_csNode.inputDesc.declaration:getString()
        local len = string.utf8Len(desc)
        if len <= 0 then
            g_scene:showTips(nilStr)
            return
        elseif len < 1 then
            g_scene:showTips(Serialize["tip_5_c"])
            return
        elseif len > 50 then
            g_scene:showTips(Serialize["tip_4_c"]) 
            return
        elseif GameUtil:checkInvalidAscill(desc, true) then
            g_scene:showTips(Serialize["tip_3_c"])
            return
        end
        
        self:setSendMailTime()
        FamilyManager:onFamilySendMailRequest(name,desc)
        self:updateSendBtn()

    end)

end

function This:onEnter()
    super.onEnter(self)
    FamilyManager:addObserver(self)
end

function This:onExit()
    FamilyManager:removeObserver(self)
    super.onExit(self)
end
function This:setSendMailTime()
   FamilyManager:setSendMailTimes(os.time())
end

function This:getSendMailTime()
   return FamilyManager:getSendMailTimes()
end

function This:getPassTime()
   local res = self.m_timeLimit
   local lastTime = self:getSendMailTime()
   local curent = os.time()
   if lastTime then
       res = curent - lastTime
   end
   return res 
end

function This:isCanSend()
   local res = true
   local escape = self:getPassTime()
   if escape<self.m_timeLimit then
       res = false
   end
   return res
end

function This:updateSendBtn()
    local str = Serialize["family_MailPanel_3"]
    if not self:isCanSend() then
        local leftTime = self.m_timeLimit - self:getPassTime()
        str = string.format(Serialize["chat_ChatPanel_12_c"],leftTime)
        self.m_csNode.fasong:setGrayShader()
    else
        self.m_csNode.fasong:clearShader()
    end
    self.m_csNode.fasong.fasongyoujian:setString(str)
end
function This:update(dt)
    super.update(self,dt)
    self.m_escape = self.m_escape + dt
    if self.m_escape < 1 then
        return
    end
    self.m_escape = self.m_escape - 1
    self:updateSendBtn()
    
end

function This:onFamilySendMail()
    g_scene:showTips(Serialize["family_MailPanel_4"])
    self:setSendMailTime()
    self:close()
end