-- @Author: superm
-- @Date:   2017-12-21 04:11:00
-- @Last Modified by:   superm
-- @Last Modified time: 2019-01-02 17:20:44
-- @File Name: FamilyMemberItemView.lua
-- @Description: 


local This , super = class(..., "NodeView")
This.fileName = "MenuScene/NodeUI/FamilyPeopleList.csb"

local FamilyManager = require("Family.FamilyManager")
local MatchingConfig = require("Metadatas.MatchingConfig")
local GameUtil = require("Util.GameUtil")
local GamePlayer = require("Player.GamePlayer")

function This:init(member, index)
    self.m_inited = false
    self.m_member = member
    self.m_listIndex = index
    local w , h = self.bg:getContentSize()
    self:setContentSize(w, h)
end

function This:initNode()
	self:refresh()
end

function This:initTouchEvent()
    if not self.m_inited then
        self:setTouch({
		    onEnded = function(touch, point)
                if self.m_member and self.m_selectHandler then
                    self.m_selectHandler(self.m_member, point)
                end
            end,
            isScale = false,
            isAlpha = false,
            isContainer = true,
        })    
        self.m_inited = true
    end
end

function This:onEnter()
    super.onEnter(self)
    self.m_member:setView(self)
end

function This:onExit()
    self.m_member:setView(nil)
    super.onExit(self)
end

function This:setModel( member, index )
    if self.m_member:getId() ~= member:getId() or self.m_listIndex ~= index then
	    self.m_listIndex = index
        self.m_member:setView(nil)
        self.m_member = member
        self.m_member:setView(self)    
    end
    self:refresh()
end

function This:refresh()
    self:refreshItemUI()
end

function This:refreshItemUI()
    self:refreshSelected()
   -- GameUtil:setPlayerIconNodeImage(self.touxiang.icon, self.m_member:getIcon())
    self.name:setString(self.m_member:getName())
    self.level:setString("Lv." .. self.m_member:getLevel())
    self.position:setString(self.m_member:getTitleDesc())
    self.number1:setString(self.m_member:getContribution())
    self.number2:setString(self.m_member:getVitality())
    self.number3:setString(self.m_member:getScore())
    self:setOnlineDesc(self.time1, self.m_member:getLaseOnlineTime())
    self.junxian:setString(self.m_member:getMilitaryDesc())
    -- local rankLevel = self.m_member:getRankLv()
    -- if not rankLevel or rankLevel <= 0 then
    --     rankLevel = 1
    -- end

    if GamePlayer:getPlayerID() == self.m_member:getId() then
        self.name:setColor(184, 229, 97)
        self.level:setColor(184, 229, 97)
        self.position:setColor(184, 229, 97)
        self.number1:setColor(184, 229, 97)
        self.number2:setColor(184, 229, 97)
        self.number3:setColor(184, 229, 97)
    else
        self.name:setColor(153, 204, 255)
        self.level:setColor(153, 204, 255)
        self.position:setColor(153, 204, 255)
        self.number1:setColor(255, 255, 153)
        self.number2:setColor(255, 255, 153)
        self.number3:setColor(255, 255, 153)
    end
end

function This:refreshSelected()
    local selected =  false
    if self.m_valueHandler then
        selected = self.m_valueHandler(self.m_member)
    end
    self.bg:setVisible(not selected and self.m_listIndex % 2 == 1)
    self.bgsel:setVisible(selected)
end

function This:setSelectHandler( handler )
    self.m_selectHandler = handler
end

function This:setValueHandler( handler )
    self.m_valueHandler = handler
end

function This:setOnlineDesc(node, startTime)
    if startTime < 0 then
        node:setString(Serialize[60971])
        return 
    end

    local dt = GamePlayer:getServerTime() - startTime
    if dt < 60 then
        node:setString(Serialize["family_MemberItem_2"])
    elseif dt < 3600 then
        node:setString(math.floor(dt / 60) .. Serialize[60972])
    elseif dt < 86400 then
        node:setString(math.floor(dt / 3600) .. Serialize[60973])
    elseif dt < 86400 * 30 then
        node:setString(math.floor(dt / 86400) .. Serialize[60974])
    elseif dt < 86400 * 30 * 12 then
        node:setString(math.floor(dt / 86400 / 30) .. Serialize[60975])
    else
        node:setString(Serialize["family_MemberItem_1"])
        -- local date = os.date("*t", startTime)
        -- node:setString(date.year .. Serialize[60976] .. date.month .. Serialize[60977] .. date.day .. Serialize[60978])
    end
end