-- @Author: superm
-- @Date:   2017-12-14 20:50:55
-- @Last Modified by:   superm
-- @Last Modified time: 2018-07-10 16:09:01
-- @File Name: FamilyPanel.lua
-- @Description:  

local This , super = class(..., "Dialog")
local FamilyManager = require("Family.FamilyManager")
local FamilyListTabNode = require("Family.FamilyListTabNode")
local FamilyInfoTabNode = require("Family.FamilyInfoTabNode")

local TabName = 
{
	kHasNoFamily = "List",
	kHasFamily = "Info",
}

function This:initData()
	self.m_inited = false
end

function This:initNode(info)
    self.m_inited = true
	self.m_csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/FamilyMain.csb")
	self.m_csNode:setToCenter()
	self:addChild(self.m_csNode)
	self.m_curTabNode = nil
	if not FamilyManager:hasFamily() then
		self.m_curTabNode = FamilyListTabNode:create()
		self.m_curTabName = TabName.kHasNoFamily
	else
		self.m_curTabNode = FamilyInfoTabNode:create({
			tab = info and info.tab
		})
		self.m_curTabName = TabName.kHasFamily
	end
	self.m_csNode:addChild(self.m_curTabNode) 
end

function This:onEnter()
    super.onEnter(self)
    FamilyManager:addObserver(self)
    if not FamilyManager:saveFamilyRecord() then
		self:openDialog("Family.FamilyFirstJoinPanel")
    end
end

function This:onExit()
    FamilyManager:removeObserver(self)
    super.onExit(self)
end

function This:initTouchEvent()
	self.m_csNode.close:setTouchEnded(function()
		self:close()
	end)
end

function This:onGetFamilyInfoChange()
    local hasFamily = FamilyManager:hasFamily()
    local node = self.m_curTabNode
	if hasFamily and self.m_curTabName ~= TabName.kHasFamily then
		g_scene:showTips(Serialize["family_Panel_1"])
        self.m_curTabNode = nil
		node:setVisible(false)
        node:runAction(cc.Sequence(cc.DelayTime(0.3), cc.RemoveAction()))
		node = FamilyInfoTabNode:create(self)
		self.m_curTabName = TabName.kHasFamily
		self.m_csNode:addChild(node)
        self.m_curTabNode = node

    elseif not hasFamily and self.m_curTabName ~= TabName.kHasNoFamily then
        self.m_curTabNode = nil
		node:setVisible(false)
        node:runAction(cc.Sequence(cc.DelayTime(0.3), cc.RemoveAction()))
		node = FamilyListTabNode:create()
		self.m_curTabName = TabName.kHasNoFamily
		self.m_csNode:addChild(node)
        self.m_curTabNode = node
	end
end





