-- @Author: ZYY
-- @Date:   2018-07-12 10:50:43
-- @Last Modified by: ZYY
-- @Last Modified time: 2018-09-03 11:43:31
-- @File Name: FamilyRecommendHeroPanel.lua
-- @Desc: 
local This, super = class(...,"Dialog")
local ArenaHeroView = require("Arena.ArenaHeroView")

function This:initNode(stage)
	self.m_stage = stage
    self.m_csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/FamilyRecommendHero.csb")
    self.m_csNode:setToCenter()
	self:addChild(self.m_csNode)
	self.m_viewList = {}
	self:refresh()
end

function This:refresh()
	local heroList = self.m_stage:getHeroRecommand()
	for i, heroId in ipairs(heroList) do 
		local view = self.m_viewList[i]
		if not view then 
			view = ArenaHeroView:create({
				heroId = heroId,
				level = 1,
				star = 1,
			})
			view:setScale(0.8)
			self.m_csNode["hero"..i]:addChild(view)
		else
			view:setModel({heroId = heroId,level = 1,star = 1})
		end
		self.m_viewList[i] = view
	end
end

function This:initTouchEvent()

end

function This:onTouchMask()
	self:close()
end

function This:onFamilyDonate()
    self:refresh()
end