﻿-- @Author: zheng
-- @Date:   2018-07-06 14:23:04
-- @Last Modified by:   zheng
-- @Last Modified time: 2020-01-08 18:06:52
-- @File Name: FamilyRuleItemView.lua

local This , super = class(...,"cc.Node")
local ItemNode = require("UI.ItemNode")

function This:init(data)
    self.m_csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/FamilyRuleReward.csb")
    self:addChild(self.m_csNode)
    local w,h = self.m_csNode.diguang:getContentSize()
    local minIndex = data.LegionMinRank or data.MinRank
    local maxIndex = data.LegionMaxRank or data.MaxRank
    self.m_lineOffset = 32
    self.m_rankData = data
    self.m_minIndex = minIndex
    self.m_maxIndex = maxIndex
    if minIndex == 1 then
        local offsetY = self.m_lineOffset
        self:setAnchorPoint(0.5,(h/2+27)/(h+27))
        h = h + 27
    else
		self:setAnchorPoint(0.5,0.5)
    end
    self:setContentSize(w,h)
	self.m_csNode:setPosition(w/2,h/2)
	self:refresh()
end

function This:refresh()
	self:refreshRank()
	self:refreshReward()
end
function This:refreshRank()
	local data = self.m_rankData
	local minIndex = self.m_minIndex
    local maxIndex = self.m_maxIndex
    if minIndex == 1 then
        if data.MinRank then
            self.m_csNode.jutanpaiming:setString(Serialize["family_RuleItem_1"])
        end
    else
    	self.m_csNode.jutanpaiming:setVisible(false)
        local offsetY = self.m_lineOffset
        self.m_csNode.line:setPositionY(self.m_csNode.line:getPositionY()-offsetY)
    end
    if minIndex>0 and minIndex<4 then
        self.m_csNode.top:setImage(string.format("MenuScene/top%d.png",minIndex))
    else
        self.m_csNode.rank:setVisible(true)
        self.m_csNode.top:setVisible(false)
        local str = string.format("%d~%d",minIndex,maxIndex)
        if minIndex == maxIndex then
        	str = string.format("%d",minIndex)
        end
        if maxIndex == -1 then
        	str = string.format(Serialize[60987],minIndex) --Serialize["family_RuleItem_2"]
        end
        self.m_csNode.rank:setString(str)
    end
end
function This:refreshReward()
	local rankList = self.m_rankData.reward
	for i, info in ipairs(rankList) do
    	local itemId, num = info[1], info[2]
    	local itemNode = self.m_csNode["item" .. tostring(i)]
    	if itemNode then
    		itemNode:setScale(0.7)
    		itemNode:setVisible(true)
	        local node = ItemNode:create(itemId, num)
	        node:setAnchorPoint(0.5, 0.5)
	        itemNode:addChild(node)
    	end
    end
end
