﻿-- @Author: zheng
-- @Date:   2018-07-04 11:34:56
-- @Last Modified by:   superm
-- @Last Modified time: 2018-07-24 19:28:14
-- @File Name: FamilyRulePanel.lua
--

local This , super = class(..., "Dialog")
local FamilyManager = require("Family.FamilyManager")
local PersonalBossRankConfig = require("Metadatas.PersonalBossRankConfig") -- 个人排名奖励表
local LegionBossRankConfig = require("Metadatas.LegionBossRankConfig") -- 军团排名奖励表
local LegionStagePrepareConfig = require("Metadatas.LegionStagePrepareConfig") -- 关卡定义表
local FamilyRuleItemView = require("Family.FamilyRuleItemView")

local TabName = 
{
    kTxt = 1,
    --kAwardList = 2,
}
local RankType = 
{
    kPersonal = 1,
    kLegion = 2,
}

function This:initNode()
    self.m_csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/FamilyRule.csb")
    self:addChild(self.m_csNode)
    self.m_csNode:setToCenter()
    self:addTabButton(TabName.kTxt,self.m_csNode.tep1,function()
        local visibles = false
        self.m_csNode.scrollView:setVisible(visibles)
        self.m_csNode.txt_node:setVisible(not visibles)
        self:refreshTxtNode()
    end)

    for index = 1, #LegionStagePrepareConfig/3 do
        if index == 1 then
            TabName["kAwardList"..index] = TabName.kTxt + 1
        else
            TabName["kAwardList"..index] = TabName["kAwardList"..(index-1)] + 1
        end

        local id = TabName["kAwardList"..index]
        self:addTabButton(id, self.m_csNode["tep"..id], function()
            local visibles = true
            self.m_csNode.scrollView:setVisible(visibles)
            self.m_csNode.txt_node:setVisible(not visibles)
            self:refreshScrollView(id)
        end)
    end


    self:selectTabButton(TabName.kTxt)
    self.m_inited = false
end

function This:initTouchEvent()

    self.m_csNode.beijing.close:setTouchEnded(function()
        self:close()
    end)
end

function This:refreshTxtNode()
    local widthLimit = 573
    local function createTxt(node)

        if not node or node.txt then
            return
        end
        local txt = node:getChildByName("txt")
        txt:setAnchorPoint( 0,1 )
        node.txt = txt
    end
    local function resetSize(node,_height )
        if not _height or not node or not node.txt  then
            return
        end
        local height = 0

        local texRule1 = node.txt

        local w ,h = texRule1:getContentSize()
        height = height + h
        texRule1:setPositionY(height)
        if height < _height then
            height = _height
            texRule1:setPositionY(height)
        end
        node:setInnerContainerSize(widthLimit,height)
    end
    local function updateStr(node,str)
        if not node or not node.txt  then
            return
        end
        local txt = node.txt
        txt:setString(str,widthLimit)
    end
    local function updateView(node,height,str)
        createTxt(node)
        updateStr(node,str)
        resetSize(node,height )
    end
    updateView(self.m_csNode.txt_node.rule1.scrollView,295,Serialize["family_RulePanel_1"])
    updateView(self.m_csNode.txt_node.rule2.scrollView,92,Serialize["family_RulePanel_2"])
end

function This:refreshScrollView(kAwardList)
    local scrollView = self.m_csNode.scrollView
    scrollView:removeAllItems()

    local function additems(rankType)
        local config
        if rankType == RankType.kLegion then
            config = LegionBossRankConfig
        elseif rankType == RankType.kPersonal then
            config = PersonalBossRankConfig
        else
            error("error!")
        end

        local base
        if kAwardList == TabName.kAwardList1 then
            base = 0
        elseif kAwardList == TabName.kAwardList2 then
            base = 100
        else
            error("error!")
        end

        local data = {}
        for i = base+1, base+100-1 do
            if not config[i] then break end
            table.insert(data, config[i])
        end

        for i,v in ipairs(data) do
            local view = self:getScrollItem(v)
            local w , h = view:getContentSize()
            scrollView:pushBackCustomItem(view,w,h,0.5)
        end
    end
    additems(RankType.kLegion)
    self:runAction(cc.Sequence(cc.DelayTime(0.1),cc.CallFunc(function()
        additems(RankType.kPersonal)
    end)))
end

function This:getScrollItem(itemData)
    local view = FamilyRuleItemView:create(itemData)
    return view
end
