-- @Author: su
-- @Date:   2018-12-13 17:30:07
-- @Last Modified by: ZYY
-- @Last Modified time: 2018-12-25 15:20:50
-- @File Name: FamilyScienceAddPanel.lua
-- @Desc: 

local This , super = class(...,"Dialog")
local FamilyManager = require("Family.FamilyManager")
local FamilyRatingManager = require("FamilyRating.FamilyRatingManager")
local TechnologyAdditionConfig = require("Metadatas.TechnologyAdditionConfig")
local GameUtil = require("Util.GameUtil")

local jiantouPosition = -70--策划用修改箭头y坐标

function This:initData( info )
    self.m_scienceData = FamilyRatingManager:getScienceData()
end

function This:initNode( info )
    self.m_csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/FamilyScienceAdd.csb")
    self.m_csNode:setToCenter()
    self:addChild(self.m_csNode)
    self:refresh()
end

function This:refresh()
    self.m_level = self.m_scienceData:getScienceAddLevel()
    self.m_nextLevel = self.m_scienceData:getScienceNextAddLevel()
    local buDengji = self.m_scienceData:getScienceLevelByType(FamilyScienceType.kBu)
    local qiDengji = self.m_scienceData:getScienceLevelByType(FamilyScienceType.kQi)
    local gongDengji = self.m_scienceData:getScienceLevelByType(FamilyScienceType.kGong)
    local cheDengji = self.m_scienceData:getScienceLevelByType(FamilyScienceType.kChe)
    local level = self.m_scienceData:getScienceLimitLevelByAddLevel(self.m_nextLevel)
    local state,text = self.m_scienceData:getScienceAddState()
    self.m_csNode.bu.num:setString(buDengji.."/"..level)
    self.m_csNode.qi.num:setString(qiDengji.."/"..level)
    self.m_csNode.gong.num:setString(gongDengji.."/"..level)
    self.m_csNode.che.num:setString(cheDengji.."/"..level)
    local index 
    if self.m_level == 0 then
        index = 1
    else
        index = self.m_level
    end
    self.m_csNode.text1:setStringWithColor(TechnologyAdditionConfig[index].text1)
    self.m_csNode.text2:setStringWithColor(TechnologyAdditionConfig[index].text2)
    local node = self.m_csNode.xiayiceng
    local cNode = self.m_csNode.halt
    local attributeNum = self.m_scienceData:getAttributeNum()
    for i=1,4 do
        local text,num = self.m_scienceData:getAttributeByIndex(i, self.m_level)
        local nextText,nextNum = self.m_scienceData:getAttributeByIndex(i, self.m_nextLevel)
        node["value"..i].name:setStringWithColor(string.format( "<A1>%s",text))
        node["value"..i].num:setStringWithColor(string.format( "<A1>%s",num))
        node["nextvalue"..i].name:setStringWithColor(string.format( "<Gray>%s",nextText))
        node["nextvalue"..i].num:setStringWithColor(string.format( "<Gray>%s",nextNum))
        cNode["value"..i].name:setStringWithColor(string.format(self:getColorText(),nextText))
        cNode["value"..i].num:setStringWithColor(string.format(self:getColorText(),nextNum))
        if i >attributeNum then
            node["value"..i]:setVisible(false)
            node["nextvalue"..i]:setVisible(false)
            cNode["value"..i]:setVisible(false)
        end
    end
    self.m_csNode.text3:setVisible(math.min(buDengji,qiDengji,gongDengji,cheDengji) > level )
    node:setVisible(self.m_level ~= 0 and self.m_level ~= self.m_nextLevel )
    cNode:setVisible(self.m_level == 0 or self.m_level == self.m_nextLevel)
    self.m_csNode.jiantou:setVisible(self.m_level ~= 0 and self.m_level ~= self.m_nextLevel)
    self.m_csNode.jiantou:setPositionY(jiantouPosition)

end

function This:initTouchEvent()
    local node = self.m_csNode
    node.close:setTouchEnded(function ()
        self:close()
    end)
end

function This:getColorText()
    if self.m_level == self.m_nextLevel then
        return "<A1>%s"
    else
        return "<Gray>%s"
    end
end