-- @Author: su
-- @Date:   2018-12-11 10:20:07
-- @Last Modified by:   su
-- @Last Modified time: 2018-12-11 10:20:07
-- @File Name: FamilyScienceNode.lua
-- @Desc: 

local This , super = class(...,"NodeUI")
local FamilyManager = require("Family.FamilyManager")
local GameUtil = require("Util.GameUtil")
local FamilyRatingManager = require("FamilyRating.FamilyRatingManager")

This.fileName = "MenuScene/NodeUI/FamilyScience.csb"

function This:initData(info)
    self.m_family = info.family
    self:refreshRed()
end

function This:onEnter()
    super.onEnter(self)
    FamilyManager:addObserver(self)
    FamilyRatingManager:addObserver(self)
end

function This:onExit()
    super.onExit(self)
    FamilyManager:removeObserver(self)
    FamilyRatingManager:removeObserver(self)
end

function This:initTouchEvent()
    self.add:setTouchEnded(function ()
        g_scene:openDialog("Family.FamilyScienceAddPanel",{family = self.m_family})
    end)
    self.research:setTouchEnded(function ()
        g_scene:openDialog("Family.FamilyScienceResearchPanel",{family = self.m_family})
    end)
    self.bu.kuang:setTouchEnded(function ()
        g_scene:openDialog("Family.FamilyScienceUpPanel",{family = self.m_family,tab = FamilyScienceTab.kBuBing})
    end)
    self.qi.kuang:setTouchEnded(function ()
        g_scene:openDialog("Family.FamilyScienceUpPanel",{family = self.m_family,tab = FamilyScienceTab.kQiBing})
    end)
    self.gong.kuang:setTouchEnded(function ()
        g_scene:openDialog("Family.FamilyScienceUpPanel",{family = self.m_family,tab = FamilyScienceTab.kGongBing})
    end)
    self.che.kuang:setTouchEnded(function ()
        g_scene:openDialog("Family.FamilyScienceUpPanel",{family = self.m_family,tab = FamilyScienceTab.kCheBing})
    end)

end

function This:refreshRed()
    GameUtil:refreshRedDot(self.research,FamilyRatingManager:scienceResearchRed(),{70,70})
    GameUtil:refreshRedDot(self.bu,FamilyRatingManager:scienceUpRed(self:getDataList(FamilyScienceTab.kBuBing)),{30,30})
    GameUtil:refreshRedDot(self.qi,FamilyRatingManager:scienceUpRed(self:getDataList(FamilyScienceTab.kQiBing)),{30,30})
    GameUtil:refreshRedDot(self.gong,FamilyRatingManager:scienceUpRed(self:getDataList(FamilyScienceTab.kGongBing)),{30,30})
    GameUtil:refreshRedDot(self.che,FamilyRatingManager:scienceUpRed(self:getDataList(FamilyScienceTab.kCheBing)),{30,30})
end

function This:getDataList( tab )
    local scienceData = FamilyRatingManager:getScienceData()
    local itemIdList = scienceData:getScienceIds(tab)
    local itemDataList = {}
    for _,id in ipairs (itemIdList) do
        table.insert(itemDataList,scienceData:getStage(id))
    end
    return itemDataList
end

function This:onScienceResearch()
    self:refreshRed()
end

function This:onScienceUp()
    self:refreshRed()    
end

function This:onUpgradeFamilyBuild()
    self:refreshRed()
end

function This:onChangeState()
    self:refreshRed()
end

function This:onDonatineRewardRecordChange()
    self:refreshRed()
end

function This:itemUpdate(itemList)
    if itemList and #itemList then
        self:refreshRed()
    end
end