-- @Author: su
-- @Date:   2018-12-11 11:30:07
-- @Last Modified by: ZYY
-- @Last Modified time: 2018-12-14 15:56:02
-- @File Name: FamilyScienceResearchPanel.lua
-- @Desc: 

local This , super = class(...,"Dialog")
local GameUtil = require("Util.GameUtil")
local FamilyManager = require("Family.FamilyManager")
local FamilyRatingManager = require("FamilyRating.FamilyRatingManager")
-- local TechnologyResearchConfig = require("Metadatas.TechnologyResearchConfig")
local FamilyScienceResearchList = require("Family.FamilyScienceResearchList")

function This:initNode(info)
    self.m_csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/FamilyScienceResearch.csb")
    self.m_csNode:setToCenter()
    self:addChild(self.m_csNode)
    self:refreshItemList(FamilyScienceTab.kBuBing)
    self:refreshRed()
end

function This:initData(info)
    self.m_family = info.family
    self.m_itemList = {}
end

function This:initTouchEvent()
    self.m_csNode.close:setTouchEnded(function ()
        self:close()
    end)
    self.m_csNode.bu.bg2:setTouchEnded(function ()
        self:refreshItemList(FamilyScienceTab.kBuBing)
    end)
    self.m_csNode.qi.bg2:setTouchEnded(function ()
        self:refreshItemList(FamilyScienceTab.kQiBing)
    end)
    self.m_csNode.gong.bg2:setTouchEnded(function ()
        self:refreshItemList(FamilyScienceTab.kGongBing)
    end)
    self.m_csNode.che.bg2:setTouchEnded(function ()
        self:refreshItemList(FamilyScienceTab.kCheBing)
    end)
end

function This:refreshItemList(Tab)
    self:refreshButtn(Tab)
    self.m_itemList = self:getDataList(Tab)
    local scrollView = self.m_csNode.scrollView
    scrollView:removeAllItems()
    for _,item in ipairs (self.m_itemList) do
        local node = FamilyScienceResearchList:create({data =item ,family= self.m_family})
        local w,h = node.bg1:getContentSize()
        scrollView:pushBackCustomItem(node,w,h)
    end
end

function This:refreshButtn(Tab)
    self.m_csNode.bu.bg1:setVisible(Tab == FamilyScienceTab.kBuBing)
    self.m_csNode.qi.bg1:setVisible(Tab == FamilyScienceTab.kQiBing)
    self.m_csNode.gong.bg1:setVisible(Tab == FamilyScienceTab.kGongBing)
    self.m_csNode.che.bg1:setVisible(Tab == FamilyScienceTab.kCheBing)
end

function This:refreshRed()
    GameUtil:refreshRedDot(self.m_csNode.bu,FamilyRatingManager:scienceResearchRed(self:getDataList(FamilyScienceTab.kBuBing)),{50,20},0.9)--FamilyRatingManager:scienceResearchRed(self:getDataList(FamilyScienceTab.kBuBing)))
    GameUtil:refreshRedDot(self.m_csNode.qi,FamilyRatingManager:scienceResearchRed(self:getDataList(FamilyScienceTab.kQiBing)),{50,20},0.9)--FamilyRatingManager:scienceResearchRed(self:getDataList(FamilyScienceTab.kBuBing)))
    GameUtil:refreshRedDot(self.m_csNode.gong,FamilyRatingManager:scienceResearchRed(self:getDataList(FamilyScienceTab.kGongBing)),{50,20},0.9)--FamilyRatingManager:scienceResearchRed(self:getDataList(FamilyScienceTab.kBuBing)))
    GameUtil:refreshRedDot(self.m_csNode.che,FamilyRatingManager:scienceResearchRed(self:getDataList(FamilyScienceTab.kCheBing)),{50,20},0.9)
end

function This:getDataList(tab)
    local scienceData = FamilyRatingManager:getScienceData()
    local itemIdList = scienceData:getScienceIds(tab)
    local itemDataList = {}
    for _,id in ipairs (itemIdList) do
        table.insert(itemDataList,scienceData:getChapter(id))
    end
    -- for _,config in pairs(TechnologyResearchConfig) do
    --     if tab < config.id and config.id <tab + 100 then
    --         table.insert(itemDataList, config)
    --     end
    -- end
    -- --table.sort(itemDataList)
    return itemDataList
end

function This:onEnter()
    super.onEnter(self)
    FamilyRatingManager:addObserver(self)
end

function This:onExit()
    FamilyRatingManager:removeObserver(self)
    super.onExit(self)
end

function This:onScienceResearch()
    self:refreshRed()
end

function This:onUpgradeFamilyBuild()
    self:refreshRed()
end

function This:onChangeState()
    self:refreshRed()
    
end
