-- @Author: su
-- @Date:   2018-12-11 19:30:07
-- @Last Modified by: ZYY
-- @Last Modified time: 2018-12-15 10:34:54
-- @File Name: FamilyScienceUpPanel.lua
-- @Desc: 

local This , super = class(...,"Dialog")
local FamilyManager = require("Family.FamilyManager")
local FamilyRatingManager = require("FamilyRating.FamilyRatingManager")
local TechnologyUpgradeConfig = require("Metadatas.TechnologyUpgradeConfig")
local FamilyScienceUpListItem = require("Family.FamilyScienceUpListItem")
local ItemUtil = require("Bag.ItemUtil")
local GamePlayer = require("Player.GamePlayer")
local DepotManager = require("Depot.DepotManager")


local text = {
    Serialize[61004],
    Serialize[61005],
    Serialize[61006],
    Serialize[61007],
}


function This:initNode(info)
    self.m_csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/FamilyScienceUp.csb")
    self.m_csNode:setToCenter()
    self:addChild(self.m_csNode)
    local scrollView = self.m_csNode.scrollView
    scrollView:removeAllItems()
    for _,itemData in ipairs(self.m_itemDataList) do
        local node = FamilyScienceUpListItem:create({data = itemData})
        local w,h = node.bg1:getContentSize()
        scrollView:pushBackCustomItem(node,w,h)
    end
    self:refresh()
end

function This:initData(info)
    self.m_itemDataList = self:getDataList(info.tab)
    self.m_tab = info.tab

end

function This:refresh()
    local costType = self.m_itemDataList[1].m_config.upgrade_cost[2][2]
    local num = DepotManager:getItemOrResCount(costType)
    local image = ItemUtil.getIconImage(costType)
    self.m_csNode.zijin:setImage(image) 
    self.m_csNode.text_0:setString(num)
    self.m_csNode.beijing.title:setString(text[self.m_tab])
end


function This:onEnter()
	super.onEnter(self)
    FamilyRatingManager:addObserver(self)    
end

function This:onExit()
    FamilyRatingManager:removeObserver(self)
    super.onExit(self)    
end

function This:initTouchEvent()
    self.m_csNode.close:setTouchEnded(function ()
        self:close()
    end)
    self.m_csNode.wenhao:setTouchEnded(function ()
        g_scene:openDialog("UI.HelpTips",{text = Serialize["family_ScienceUp_1"],node = self.m_csNode.wenhao})
    end)
end

function This:getDataList(tab)
    local scienceData = FamilyRatingManager:getScienceData()
    local itemIdList = scienceData:getScienceIds(tab)
    local itemDataList = {}
    for _,id in ipairs (itemIdList) do
        table.insert(itemDataList,scienceData:getStage(id))
    end
    return itemDataList
end

function This:itemUpdate(itemList)
    if itemList and #itemList > 0 then
        self:refresh()
    end
end

function This:onScienceUp(id)
    self:refresh()
end

function This:onScienceResearch()
    self:refresh()
end