-- @Author: superm
-- @Date:   2018-07-03 11:54:20
-- @Last Modified by:   superm
-- @Last Modified time: 2018-07-03 16:22:59
-- @File Name: FamilySelectedSection.lua
-- @Description: 

local This , super = class(...)

function This:create()
    local ret = {}
    setmetatable(ret,self)
    ret:init()
    return ret    
end

function This:init()
	self:clear()
end

function This:select( key, info )
	self.m_selectedList[key] = info
end

function This:setValue( key, field, value )
    local info = self.m_selectedList[key]
    if not info then
	    info = {}
	    self.m_selectedList[key] = info
	end
	local oldvalue = info[field]
	info[field] = value
	return oldvalue
end

function This:getValue( key, field, default )
    local ret = default
    local info = self.m_selectedList[key]
    if info then
    	ret = info[field] or default
    end
    return ret
end

function This:unselect( key )
	self.m_selectedList[key] = {}
end

function This:clear()
    self.m_selectedList = {}
end

