---
---
--- Created by aid.
--- DateTime: 2018/10/26 16:33
---
local This, Super = class(..., "NodeUI")
This.fileName = "MenuScene/NodeUI/FamilyStore.csb"
local StoreFamilyContributionUI = require("Store.StoreFamilyContributionUI")
local FamilyShareStoreUI = require("Store.StoreFamilyShareUI")
local FamilyLevelStoreUI = require("Store.StoreFamilyLevelUI")

local TabName = {
    kContributionStore = "ContributionStore",
    KShareStore = "ShareStore",
    KLevelStore = "LevelStore",
}

function This:initNode()
    -- 贡献商店
    self:addTabButton(TabName.kContributionStore, self.tep1, function()
        print("TabName.kContributionStore")
        self:openTabNode(TabName.kContributionStore)
    end)
    -- 共享商店
    self:addTabButton(TabName.KShareStore, self.tep2, function()
        print("TabName.KShareStore")
        self:openTabNode(TabName.KShareStore)
    end)
    -- 等级商店
    self:addTabButton(TabName.KLevelStore, self.tep3, function()
        print("TabName.KLevelStore")
        self:openTabNode(TabName.KLevelStore)
    end)

    -- 默认打开贡献商城
    self:selectTabButton(TabName.kContributionStore)
end

function This:onTabNodeSwitchIn(node, name)
    -- TODO
    if name == TabName.kContributionStore then
        node:refresh(true) -- TODO
    end
end

function This:createTabNode(tabName)
    if tabName == TabName.kContributionStore then
        return StoreFamilyContributionUI:create({family = self.m_family})
    elseif tabName == TabName.KShareStore then
        return FamilyShareStoreUI:create({family = self.m_family})
    elseif tabName == TabName.KLevelStore then
        return FamilyLevelStoreUI:create({family = self.m_family})
    else
        error("error!")
    end
end

function This:initTouchEvent()
    -- TODO

end

function This:initData(info)
    if info then
        self.m_family = info.family
    end
end

function This:refresh(check)
    -- TODO
end