-- @Author: superm
-- @Date:   2017-12-25 10:41:57
-- @Last Modified by:   superm
-- @Last Modified time: 2020-10-30 16:37:36
-- @File Name: FamilyUtil.lua
-- @Description: 

local This = class(...)
local FamilyPowerConfig = require("Metadatas.FamilyPowerConfig")
local LegionBuildingConfig = require("Metadatas.LegionBuildingConfig")
local FamilyLevelConfig = require("Metadatas.FamilyLevelConfig")
FamilyTitle = {
	kNone          = 0, 
	kMengZhu       = 1, --军团长
	kFuMengZhu     = 2, --副团长
	kZhangLao      = 3, --虎翼将军
	kJingYing      = 4, --都尉
	kChengYuan     = 5, --成员
	kCanJiang      = 6, --都护参将
	kGuangLuDaFu   = 7, --光禄大夫
	kJiaoWei       = 8, --长水校尉
	kZhongShuCheng = 9, --中书丞
}
FamilyRatingTitle = { 
	kJunZu    = 1, --军卒
	kWuZhang  = 2, --伍长
	kYaMen    = 3, --牙门将
	kYuLin    = 4, --羽林校尉
	kZhongWei = 5, --中郎将
	kZhengXi  = 6, --征西将军
	kWeiJiang = 7, --卫将军
	kPiaoQi   = 8, --骠骑将军
	kDaJiang  = 9, --大将军
}

FamilyPower = {
	kAgreeApplying  			 = "agree", 		        		 -- 审批
	kKickOff        			 = "out",							 -- 踢人
	kDismiss        			 = "dissolution", 		    		 -- 解散
	kRename         			 = "change_name", 		    		 -- 改名
	kChangeDesc     			 = "change_declaration",    		 -- 改宣言
	kUpgrade        			 = "level_up", 						 -- 升级
	kAppoint        			 = "appoint", 						 -- 委任
	
	kOpenShop       			 = "open_shop",			    		 -- 开启商店
	kOpenStage      			 = "open_stage",					 -- 开启副本
	kUnlockBuild    			 = "lock_building", 	    		 -- 解锁建筑
	kUpgradeBuild   			 = "up_building", 		    		 -- 升级建筑
	kSendMail       			 = "sendmail", 			    		 -- 发送邮件
	kRelieve        			 = "relieve", 						 -- 解除低维护权限
	kInherit        			 = "successor", 					 -- 军团长离线超过3天那些职位拥有继承权限
	kResearch       			 = "research", 		        		 -- 研究权限
	kCdTime         			 = "cd_time", 			    		 -- 秒计策CD权限
	kReceiptor      			 = "receiptor", 		    		 -- 领取计策权限
	kBidders        			 = "bidders", 			    		 -- 竞拍权限
	kEnroll         			 = "enroll", 			    		 -- 报名权限
	kDeclareMwar    			 = "declare_war", 		    		 -- 宣战权限
	kPromotion      			 = "promotion", 		    		 -- 晋升权限
	kAppointMilitary			 = "appoint_military",      		 -- 委任军衔权限
	kSelect 					 = "select",                		 -- 投名状权限
	kLegionWarChangeCity		 = "legion_war_change_city",      	 -- 改造城池权限
	klegionTechnologyLevelUp 	 = "legion_technology_level_up",     -- 军团战研究科技
	kTechnology 	 			 = "Technology",     				 -- 研究科技权限1

}

FamilyBuildType = {
	kYiShiTing = 1,		--议事厅
	kShangDian = 2,		--商店
	kShangHui = 3,		--商会	
	kJunJiChu = 4,		--军机处
}

FamilyPrerogativeType = {
	kPeopleNum = 1001, -- 军团人数上限
	kFundsDividend = 1002, -- 军团分红功能
	kStoreContrbQuality = 1003, -- 贡献商店品质
	kStoreContrbSlotNum = 1004, -- 贡献商店槽位
	kStoreFundsQuality = 1005, -- 资金商店品质
	kStoreFundsSlotNum = 1006, -- 资金商店槽位
	kFamilyDonateAddition = 1007, -- 捐献军团资金加成
	kFamilyScience = 1009, -- 军团科技
}

function This:getMemberNumLimitByLevel( level )
    local id = 10100 + level
    local config = LegionBuildingConfig[id]
    local field = FamilyPrerogativeType.kPeopleNum
    local ret = FamilyLevelConfig[level].limit
    if config then
        for _, info in ipairs(config.routine_prerogative) do
            if info[1] == field then
                ret = ret + info[2]
            end
        end
    end
    return ret
end

function This:checkIsNum( str, maxValue )
	if string.match(str,"%d+") == str then
		local ret = tonumber(str) 
		if ret <= maxValue then
	    	return ret
	    end 
   	end
end

function This:NVL(var, default_value)
	if var == nil then
		return default_value
	else
		return var
	end
end

function This:NVLstr(var, default_value)
	if var == nil or var == "" then
		return default_value
	else
		return var
	end
end

function This:getValueMap(t, map)
	local ret = map or {}
	for _, v in ipairs(t) do
		ret[v] = true
	end
	return ret
end

function This:getTitleDesc(title)
    if title > 0 then
        return FamilyPowerConfig[title].title
    end
end

kFamilyMaxLevel = 99				--军团 等級上限（2018/7/18之前为3，之后无上限）
kFamilyCreatCost = 500				--军团 创建消耗元宝
kFamilyRenameCost = 200 			--军团 发送邀请时间间隔=
kFamilyInviteSendApplyCD = 300 		--军团 发送邀请时间间隔=
kFamilyDonateTimes = 3 				--军团 捐献上限
kFamilyHeadOfflineTime = 86400*3 	--军团长离线是否超过3天，虎翼将军以上可以发起继承
kFamilyHeadOfflineTime2 = 86400*7 	--军团长离线是否超过7天，所有成员可以发起继承