-- @Author: zheng
-- @Date:   2018-10-20 15:22:20
-- @Last Modified by: ZYY
-- @Last Modified time: 2018-12-14 16:24:08
-- @File Name: GameResearchChapter.lua

local TechnologyResearchConfig = require("Metadatas.TechnologyResearchConfig")
local TechnologyUpgradeConfig = require("Metadatas.TechnologyUpgradeConfig")
local FamilyBuildManager = require("Family.FamilyBuildManager")

local This = class(...)

function This:create(id)
    local Morality = {}
    setmetatable(Morality,This)
    Morality:init(id)
    return Morality
end

function This:init(id)
    self.m_id = id
    self.m_config = TechnologyResearchConfig[self.m_id]
    self.m_additionConfig = self:tableFormat(TechnologyUpgradeConfig[self.m_id].attribute)
end

function This:getId()
    return self.m_id
end

function This:getLimitLevel()
    return FamilyBuildManager:getPrerogativeValue(FamilyBuildType.kJunJiChu,FamilyPrerogativeType.kFamilyScience)
end

function This:getMilitaryLimitLevel()
    local upCondition =FamilyBuildManager:getBuildByType(FamilyBuildType.kJunJiChu):getConditions()
    if #upCondition ~= 0 then
        return upCondition[1][2]
    else
        return 0
    end
end

function This:getMilitaryLevel()
    return FamilyBuildManager:getBuildingLevel(FamilyBuildType.kJunJiChu)
end

function This:setLevel(level)
    self.m_level = level
end

function This:getLevel()
    return self.m_level or 0
end

function This:setType( type )
    self.m_type = type
end

function This:getType( )
    return self.m_type or 0
end

function This:getNextLevel()
    local level = self:getLevel()
    if level == table.count(self.m_config.Research_cost) then
        return level
    else
        return level + 1
    end
end

function This:getNextCost()
    local level = self:getNextLevel()
    return self.m_config.Research_cost[level][3]
end

function This:getLevelandNextCost(level)
    if not level then
        level = self:getLevel()
    end
    local costs = self.m_config.Research_cost
    return costs[level],costs[level+1]
end

function This:getImage()
    return self.m_config.image
end

function This:getText()
    return self.m_config.text
end

function This:getAddition()
    local level = self:getLevel()
	local addition = self.m_additionConfig
	if level ~=0 then
		return addition[level][2]
	else
		return 0
	end
end

function This:tableFormat( list )
	local res = {}
	for index,data in pairs(list) do
		res[index]={data[2],data[3]}
	end
	return res
end

function This:resetAddtion()
    self:setLevel(0)
end