-- @Author: zheng
-- @Date:   2018-10-20 15:22:20
-- @Last Modified by: ZYY
-- @Last Modified time: 2018-12-15 11:05:09
-- @File Name: GameResearchStage.lua

local TechnologyUpgradeConfig = require("Metadatas.TechnologyUpgradeConfig")
local TechnologyStructureConfig = require("Metadatas.TechnologyStructureConfig")
-- local FamilyBuildManager = require("Family.FamilyBuildManager")

-- local ItemNode = require("UI.ItemNode")
-- local GameUtil = require("Util.GameUtil")
-- local GamePlayer = require("Player.GamePlayer")

local This = class(...)

function This:create(id)
    local Morality = {}
    setmetatable(Morality,This)
    Morality:init(id)
    return Morality
end

function This:init(id)
    self.m_id = id
    self.m_config = TechnologyUpgradeConfig[self.m_id]
	self.m_additionConfig = self:tableFormat(self.m_config.attribute)
end

function This:getId()
    return self.m_id
end

function This:getId()
    return self.m_id
end

function This:setLevel(level)
    self.m_level = level
end

function This:getLevel()
    return self.m_level or 0
end

function This:getCostType()
	return self.m_config.upgrade_cost[1][2]
end

function This:getNextLevel( )
	local level = self:getLevel()
	if level == #self.m_config.upgrade_cost then
		return level
	else
		return level + 1
	end
end

function This:getNextCost( level )
	if not level then
		level = self:getLevel()
	end
	local costs = self.m_config.upgrade_cost
	if costs[level+1] == nil then
		return costs[level][3]
	else
		return costs[level+1][3]
	end
end

function This:getIconID()
	local cost = self.m_config.upgrade_cost[1][2]
	return cost
end

function This:getAttribute( level )
	if not level then
		level = self:getLevel()
	end
	local costs = self.m_config.attribute
	return costs[level],costs[level+1]
end

function This:getImage()
	return self.m_config.image
end

function This:getText()
	return self.m_config.text
end

function This:getName()
	return self.m_config.name
end

function This:setType( type )
	self.m_type = type
end

function This:getType( )
	return self.m_type or 0
end

function This:getLimitLevel()
	local level = self:getLevel()
	if level == #self.m_config.level then
		return self.m_config.level[level][2]
	else
		return self.m_config.level[level+1][2]
	end
end

function This:getAddition()
	local level = self:getLevel()
	local addition = self.m_additionConfig
	if level ~=0 then
		return addition[level][2]
	else
		return 0
	end
end

function This:getAddtiionId()
	local addition = self.m_additionConfig
	return addition[1][1]
end


function This:tableFormat( list )
	local res = {}
	for index,data in pairs(list) do
		res[index]={data[2],data[3]}
	end
	return res
end