--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"NodeView")
local RankPageListLayer = require("Rank.RankPageListLayer")
local FamilyMemberItemView = require("Family.FamilyMemberItemView")
local FamilyManager = require("Family.FamilyManager")

function This:initData(info)
	if info then
		self.m_family = info.family
	end
    self.m_inited = false
    self.m_csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/FamilyPeople.csb")
    self:addChild(self.m_csNode)
end

function This:initNode(info)
    self.m_listLayer = RankPageListLayer:create({
        itemWidth = 614,
        itemHeight = 51,
        spaceX = 0,
        spaceY = 4,
        scrollView = self.m_csNode.ScrollView,
		dataCounter = function ()
	        return #self.m_memberList
        end,
        viewCreator =  function(index, node)
        	if not self.m_memberList then
        		return
        	end

        	local member = self.m_memberList[index]
	        if member then
		        if not node then
					local itemNode = FamilyMemberItemView:create(member, index)
					itemNode:setSelectHandler(function (data, pos)
						g_scene:openDialog("Family.MemberControlPanel", {
							family = self.m_family,
							data = data,
							pos = pos,
						})

						if self.m_lastSelectedId then
							self.m_selectSection:setValue(self.m_lastSelectedId, "select", false)
							local view = self.m_selectSection:setValue(self.m_lastSelectedId, "selectView", nil)
							if view then
								view:refreshSelected()
							end
						end
						self.m_lastSelectedId = data:getId()

						self.m_selectSection:setValue(data:getId(), "select", true)
						self.m_selectSection:setValue(data:getId(), "selectView", itemNode)
						itemNode:refreshSelected()
					end)
					itemNode:setValueHandler(function ( data ) 
						return self.m_selectSection:getValue(data:getId(), "select")
					end)
					return itemNode
			    else
		        	node:setModel(member, index)
		        end
		    end
	    end
    })
    
    self.m_listLayer:setAnchorPoint(0.5,0)
    local w , h = self.m_listLayer:getContentSize()
    self.m_csNode.ScrollView:pushBackCustomItem(self.m_listLayer, w, h, 0)
    self.m_listLayer:setCascadeOpacityEnabled(true)
end

function This:refreshMemberList()
	if self.m_family then
		if not self.m_selectSection then
			self.m_selectSection = self.m_family:getSelectSection()
		end
		self.m_memberList = self.m_family:getMemberList()
		self.m_listLayer:setDataList()

		self.m_selectSection:clear()
	end
end

function This:onEnter()
	super.onEnter(self)
	FamilyManager:addObserver(self)
end

function This:onExit()
	FamilyManager:removeObserver(self)
	super.onExit(self)
end

function This:onGetMyFamilyInfo(family)
	self.m_family = family
	self:refreshMemberList()
end

--endregion
