

local This , super = class(...,"Stage.EmbattleHeroPanel")
local FamilyManager = require("Family.FamilyManager")
local FamilyBossManager = require("FamilyBoss.FamilyBossManager")
local HeroManager = require("Hero.HeroManager")

function This:initNode(info)
	self.m_onConfirm = info.onConfirm
	self.m_chapter = FamilyBossManager:getChapter()
	super.initNode(self,info)
end

function This:initBaseInfo()
	self.m_csNode.bg3.tagettext:setString(Serialize[60919])
	self.m_csNode.bg3.taget:setString(self.m_chapter:getName())
	self.m_csNode.bg3.name:setString(FamilyManager:getMyFamilyName())
	self.m_csNode.bg3.totalhp:setString("0")
	self.m_csNode.bg3.consume:setString(Serialize[60509])
	self.m_csNode.bg3.cost:setString(self.m_chapter:getMaxHp())
	self.m_csNode.text100:setVisible(false)
	self.m_csNode.time:setVisible(false)
	self.m_csNode.diban2:setVisible(false)
end

function This:getHeroSource()
	local heroList = self.m_chapter:getCanEmbattleHeroList()
	local result = {}
	local num = math.min(6,#heroList)
	for pos = 1 , num do
		result[pos] = heroList[pos]:getId()
	end
	return result
end

function This:getAllHeroList()
	return self.m_chapter:getCanEmbattleHeroList()
end

function This:refreshBaseInfo()
	local hp = self:getTotalHp()
	self.m_csNode.bg3.totalhp:setString(string.format("%d",hp))
end

function This:openSelectPanel()
	local haveSelected = {}
	for i , info in pairs(self.m_heros) do
		haveSelected[info.heroId] = true
	end
	local panel = g_scene:openDialog("FamilyBoss.FamilyBossSelectHeroPanel",{
		haveSelected = haveSelected, 
		ins = self.m_chapter
	})
	return panel
end

function This:gotoBattle(heroList, isOnceKey)
	
end

function This:onConfirmBtnClick()
	local tmp = {0,0,0,0,0,0}
	local bHave = false
	local count = 0
	for pos , info in pairs(self.m_heros) do
		local hero = HeroManager:getHero(info.heroId)
		tmp[pos] = hero:getUid()
		count = count + 1
	end
	if count < 6  then
		g_scene:showTips(Serialize[61028])
		return
	end
	if self.m_onConfirm then
		self.m_onConfirm(tmp)
	end
	self:close()
end
