

local This, super = class(...,"Dialog")
local HeroManager = require("Hero.HeroManager")
local ArenaHeroView = require("Arena.ArenaHeroView")
local PopDialogManager = require("UI.PopDialogManager")
local FamilyBossManager = require("FamilyBoss.FamilyBossManager")
local HeroConfig = require("Metadatas.HeroConfig")  
local MythicalAnimalsAttributeConfig = require("Metadatas.MythicalAnimalsAttributeConfig")

function This:initNode(info)
	self.m_battleInfo = info
	self.m_damage = info.damage
	self.m_cardIdList = {}

	for i , info in ipairs(info.report.attack.card_list) do
		local isAnimal = MythicalAnimalsAttributeConfig[info.card_type]
		if not isAnimal then
			table.insert(self.m_cardIdList,{
				heroId = info.card_type,
				level = info.level,
				star = info.star_level
			})
		end
	end

    self.m_csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/FamilyBossOver.csb")
    self.m_csNode:setToCenter()
    self.m_itemList = {}
	self:addChild(self.m_csNode)
	self:initItemViewList()
	self:initAnimation()
end

function This:initItemViewList()
	for i , info in ipairs(self.m_cardIdList) do 
		local item = self.m_itemList[i]
		if not item then 
			if HeroConfig[info.heroId] then
				item = ArenaHeroView:create(info)
				item:setScale(0.8)
				if item then
					if self.m_csNode["item"..i] then
						self.m_csNode["item"..i]:addChild(item)
						self.m_itemList[i] = item
					end
				end
			end
		end
	end
	self.m_csNode.bencishanghai:setString(Serialize[61040]..self.m_damage)
end

function This:initTouchEvent()

end

function This:initAnimation()
	self.m_csNode.continue:setScale(0.66)
	local seqence1 = cc.Sequence(cc.FadeTo(0.4,64),cc.FadeTo(0.4,255))
	local seqence2 = cc.Sequence(cc.ScaleTo(0.4,0.68),cc.ScaleTo(0.4,0.66))
	self.m_csNode.continue:runAction(cc.RepeatForever(cc.Spawn(seqence1,seqence2)))
end

function This:onTouchMask()
	local chapter = FamilyBossManager:getChapter()
	if chapter:isActive() then
		PopDialogManager:addPopDialog({scene = "MenuScene", name = "FamilyBoss.FamilyBossPanel", arg = {}, level = DialogLevel.kForLevel})
	end
	cc.SceneManager:switchTo("Home.MenuScene")
end
