

local This, super = class(..., "NodeUI")
local ItemNode = require("UI.ItemNode")


function This:initData(info)
	self.m_title = info.title
	self.m_minRank = info.minRank
	self.m_maxRank = info.maxRank
	self.m_reward = info.reward or {}
end

function This:initNode(info)
	local csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/LegionBossRankReward.csb")
    self:addChild(csNode)
    self.m_csNode = csNode

    local bgBox = csNode.bg:getBoundingBox()
    local w, h = bgBox.width, bgBox.height

    -- 标题
    local isTitle = (type(self.m_title) == "string") and (self.m_title ~= "")
    if isTitle then
        local titleBox = csNode.titleBg:getBoundingBox()
    	local tw, th = titleBox.width, titleBox.height
    	self:setContentSize(w, h + th)
    	csNode.titleBg.lbTitle:setString(self.m_title)
    	csNode.titleBg:setVisible(true)
    else
    	self:setContentSize(w, h)
    	csNode.titleBg:setVisible(false)
    end
    
    -- 排名
    local isRank = self.m_minRank and self.m_maxRank
    if isRank then
    	if self.m_minRank == self.m_maxRank then
    		local rank = self.m_minRank
    		if rank >= 1 and rank <= 3 then
    			csNode.top:setVisible(true)
    			csNode.top:setImage(string.format("MenuScene/top%d.png", rank))
    			csNode.rank:setString("")
    		else
    			csNode.top:setVisible(false)
    			csNode.rank:setString( string.format(Serialize[60698], rank) )
    		end
    	else
    		csNode.top:setVisible(false)
    		if self.m_maxRank == -1 then
    			csNode.rank:setString( string.format(Serialize[61058], self.m_minRank) )
    		else
    			csNode.rank:setString( string.format(Serialize[61059], self.m_minRank, self.m_maxRank) )
    		end
    	end
    else
    	csNode.top:setVisible(false)
    	csNode.rank:setVisible(false)
    end

    -- 奖励
    local x = 0
    for i, info in ipairs(self.m_reward) do
    	local id, num = info[1], info[2]
	    local node = ItemNode:create(id, num)
	    node:setAnchorPoint(0.5, 0.5)
	    node:setScale(0.7)
	    node:setPosition(x, 0)
	    csNode.item:addChild(node)
	    x = x + 100
    end
end