

local This , super = class(..., "Dialog")
local PersonalBossRankConfig = require("Metadatas.PersonalBossRankConfig")
local LegionBossRankConfig = require("Metadatas.LegionBossRankConfig")
local LegionBossInstanceConfig = require("Metadatas.LegionBossInstanceConfig")
local FamilyBossRewardPreviewNode = require("FamilyBoss.FamilyBossRewardPreviewNode")


function This:initData(info)
	self.m_selectIdx = 0
end

function This:initNode(info)
    local csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/LegionBossRewardPreview.csb")
    csNode:setToCenter()
    self:addChild(csNode)
    self.m_csNode = csNode

    local list = {csNode.tep1, csNode.tep2}
    for i, node in ipairs(list) do
	    self:addTabButton(i, node, function ()
	    	self.m_selectIdx = i
	    	self:refresh()    
	    end)
    end
    csNode.tep2:setVisible(false)

    self:selectTabButton(1)
end

function This:initTouchEvent()
	local csNode = self.m_csNode

	csNode.beijing.close:setTouchEnded(function()
		self:close()
	end)

end

function This:refresh()
	local scrollView = self.m_csNode.ScrollView
    scrollView:removeAllItems()
	self.m_timer:removeAllTimer()

	local list = {}	
	self:getCanYuRewardData(list)
	self:getPersonalRewardData(list)
	self:getLegionRewardData(list)

	for i, data in ipairs(list) do
		self:setTimer(0.02*(i-1), function ()
			local node = FamilyBossRewardPreviewNode:create(data)
			local w, h = node:getContentSize()
			node:setAnchorPoint(0.5, 0.5)
        	scrollView:pushBackCustomItem(node, w, h, 0.5, 15)
		end)
	end
end

-- 参与奖励
function This:getCanYuRewardData(list)
	local dict = {
		[1] = 1,
		[2] = 4,
	}
	local id = 1
	local reward = LegionBossInstanceConfig[id].reward
	table.insert(list, {title = Serialize[61061], reward = reward})
end

-- 个人排名奖励
function This:getPersonalRewardData(list)
	local dict = {
		[1] = 1,
		[2] = 101,
	}
	local id = 1 -- dict[self.m_selectIdx] or 1
	local index = 1

	while PersonalBossRankConfig[id] do
		local config = PersonalBossRankConfig[id]
		local t = {
			minRank = config.min_rank,
			maxRank = config.max_rank,
			reward = config.reward
		}
		if index == 1 then
			t.title = Serialize[61062]
		end
		table.insert(list, t)

		id = id + 1
		index = index + 1
	end
end

-- 军团排名奖励
function This:getLegionRewardData(list)
	local dict = {
		[1] = 1,
		[2] = 101,
	}
	local id = 1 -- dict[self.m_selectIdx] or 1
	local index = 1

	while LegionBossRankConfig[id] do
		local config = LegionBossRankConfig[id]
		local t = {
			minRank = config.min_rank,
			maxRank = config.max_rank,
			reward = config.reward
		}
		if index == 1 then
			t.title = Serialize[61063]
		end
		table.insert(list, t)

		id = id + 1
		index = index + 1		
	end		
end