-- @Author: zheng
-- @Date:   2018-10-30 11:48:49
-- @Last Modified by:   zheng
-- @Last Modified time: 2018-12-15 17:12:21
-- @File Name: FamilWarlordItemView.lua

local This , super = class(...,"NodeUI")
local FamilyRatingManager = require("FamilyRating.FamilyRatingManager")
local FamilyManager = require("Family.FamilyManager")
local GameUtil = require("Util.GameUtil")
local EntrantManager = require("LegionEntrant.EntrantManager")

This.fileName = "LegionScene/NodeUI/LegionAdvancedTaskList.csb"

local panelFile = {5,4,3} -- 底板标签

local WarlordRewardState ={-- 投名状奖励状态
    kType1 = 1, -- 可领取
    kType2 = 2, -- 不可领取
    kType3 = 3  -- 已领取
}

function This:initData(info)
    -- if info.warType then
    --     self.m_warId = 2
    -- else
    --     self.m_warId = 1
    -- end
    self.m_warId= info.warType
end

function This:initNode(info)
    local w , h = self.bg1:getContentSize()
    self:setContentSize(w,h)
    self.m_warId= info.warType
    self:refresh(info.data)
end

function This:refresh(data)
    if data then
        self.m_data = data
    end

    if self.m_data then
        local factor_text = self.m_data.factor_text
        local task_text = self.m_data.task_text
        self.title:setString(factor_text)
        self.info:setString(task_text,240)
        self.castId = self.m_data.id
    end
    local ratingData = FamilyRatingManager:getRatingData()
    local castId, ifReceiveState = ratingData:getCastId()
    local state = ratingData:getCastRewardState()
    self.m_ratingData = ratingData
    self.m_state = state
    local file = string.format( "LegionScene/qizhi%d.png",panelFile[self.m_data.factor])
    self.bg1:setImage(file)
    self.jindunum:setVisible(self.castId == castId)
    self.jindunum:setString(string.format( "%d/%d",FamilyRatingManager:getCastNameProgress(),self.m_data.progress))

    local boxFileLock = string.format( "MenuScene/boxLock%d.png",self.m_data.factor)
    local boxFileGet = string.format( "MenuScene/boxGet%d.png",self.m_data.factor)

    if ifReceiveState then  --如果已领取投名状
        print("self.castId"..self.castId.." "..castId)
        if self.castId ~= castId then
            self.zhezhao:setVisible(true)
            --self.yixuanze:setVisible(true)
        end
        self.button:setVisible(false)
    end
    if state == WarlordRewardState.kType1 and self.castId == castId then
        self.box:setImage(boxFileGet)
        GameUtil:createBoxEffect(self.m_state==WarlordRewardState.kType1 and self.castId == castId ,self.box,self.m_data.factor)
    elseif state == WarlordRewardState.kType3 and self.castId == castId then
        self.box:setImage(boxFileGet)
        self.box:setGrayShader()
    else
        self.box:setImage(boxFileLock)
    end
end

function This:initTouchEvent()	
	self.box:setTouchEnded(function()
        local function btnCallBack()
            if self.m_state == WarlordRewardState.kType1 then                
                FamilyRatingManager:onCastRewardRequest(self.m_warId)
            else
                g_scene:showTips(Serialize[61067])
            end
        end
        local reward = self.m_data.reward
        local info ={title = Serialize["family_achieveReward"],rewards = reward,--{{102,70},{112,70},{113,70},{121,70}},
        receive = self.m_state == WarlordRewardState.kType3 ,isGray=self.m_state== WarlordRewardState.kType2,btnCallBack =btnCallBack}--wenhaoStr =Serialize["family_GradeNode_3"] }        
        g_scene:openDialog("FamilyRating.FamilyRatingWeeklyRewardPanel",info)
    end)

    self.button:setTouchEnded(function()
        -- 军团战
        if not self:checkPower() then
            g_scene:showTips(Serialize[61068])
            return
        end

        local lwData = EntrantManager:getLegionWarData()
        local state = lwData:getState()
        if state <= KingWarBtnState.kSignUp then
            g_scene:showTips(Serialize[61069])
            return
        end

        if state >= KingWarBtnState.kFight then
            g_scene:showTips(Serialize[61070])
            return
        end

        if lwData:getFightFlag() ~= 1 then
            g_scene:showTips(Serialize[61071])
            return
        end

        g_scene:openDialog("FamilyRating.FamilWarlordConfirm",{text = self.m_data.factor_text,id = self.m_data.id})
    end)
end

function This:checkPower()
    local title = FamilyManager:getMySelfTitle()
    return title == FamilyTitle.kMengZhu or title == FamilyTitle.kFuMengZhu
end