-- @Author: zheng
-- @Date:   2018-10-30 11:32:25
-- @Last Modified by:   zheng
-- @Last Modified time: 2018-12-15 17:12:55
-- @File Name: FamilWarlordPanel.lua

local FamilyRatingManager = require("FamilyRating.FamilyRatingManager")
local This,super = class(...,"Dialog")
local EntrantManager = require("LegionEntrant.EntrantManager")
local StoreManager = require("Store.StoreManager")

local LegionAdvancedTaskConfig = require("Metadatas.LegionAdvancedTaskConfig")
local FamilWarlordItemView = require("FamilyRating.FamilWarlordItemView")

local fileName ="LegionScene/NodeUI/LegionAdvancedTask.csb"

function This:initNode(info)
    self.m_csNode = cc.Node:createFromCSFile(fileName)
    self:addChild(self.m_csNode)
    self.m_csNode:setToCenter()
    self.m_uiNodes ={}
    for i=1,3 do
        local item1 = self.m_csNode["reward"..i]
        local configData = self.m_configdatas[i]
        local node = FamilWarlordItemView:create({data = configData,warType = info.warType})
        item1:addChild(node)
        table.insert(self.m_uiNodes,node)
    end
    if info.warType == 2 then
        self.m_csNode.title:setString(Serialize[61073]) 
    end
    self:refreshTaskList()
end

function This:initData(info )
    -- EntrantManager:onGetEntrantInfoRequest()
    self.m_ratingData = FamilyRatingManager:getRatingData()
    local function getData(id)
        local res
        for k,v in pairs(LegionAdvancedTaskConfig) do
            if id == v.id then
                res = v
            end
        end
        return res
    end
    local doc = self.m_ratingData:getTaskIdList(info.warType)
    self.m_configdatas = {}
    for _,taskId in pairs(doc) do
        table.insert(self.m_configdatas,getData(taskId))
    end
end


function This:initTouchEvent()

    self.m_csNode.closebg:setTouchEnded(function()
        self:close()
    end)
    self.m_csNode.wenhao:setTouchEnded(function()
        g_scene:openDialog("UI.HelpTips",{text = Serialize["family_Warlord_1"],node = self.m_csNode.wenhao})
    end)
end

function This:refreshTaskList()
    for uiIndex,uiNode in pairs(self.m_uiNodes) do
        uiNode:refresh()
    end
    
end

function This:onEnter()
    super.onEnter(self)
    FamilyRatingManager:addObserver(self)
end

function This:onExit()
    FamilyRatingManager:removeObserver(self)
    super.onExit(self)
end


function This:onSetCast()
    self:refreshTaskList()
end

function This:onCastReward()
    self:refreshTaskList()
end