-- @Author: zheng
-- @Date:   2018-10-25 10:18:13
-- @Last Modified by:   zheng
-- @Last Modified time: 2018-11-15 20:14:41
-- @File Name: FamilyRatingMilitaryPanel.lua
local LegionMilitaryConfig = require("Metadatas.LegionMilitaryConfig")

local This , super = class(...,"Dialog")

local fileNames ={
        "MenuScene/NodeUI/FamilyMilitaryRank.csb",
        "MenuScene/NodeUI/FamilyMilitaryRankList.csb",
    }

function This:initNode(info)
    self.m_csNode = cc.Node:createFromCSFile(fileNames[1])
    self.m_csNode:setToCenter()
    self:addChild(self.m_csNode)
    self.m_csNode.scrollView:setDirection("horizontal")
    self.m_csNode.scrollView.m_direction = "right"
    self.m_csNode.scrollView:setSwallowTouch(false)
    if info then
       self.m_family = info.family
       self:getData()
       self:refresh()
    end
end



function This:refresh()
    local scroolView = self.m_csNode.scrollView
    scroolView:removeAllItems()
    local function createItemView(id)
        local data = self.m_data
        local node = cc.Node:createFromCSFile(fileNames[2])
        local w , h = node.bg1:getContentSize()
        node:setContentSize(w,h)
        local selfMember = self.m_family:getSelfMemberInfo()        
        local name ,desc = data:getMilitaryNameAndDesc(id,selfMember:getMilitary())
        node.zhiwei:setString(name)
        
        node.scrollView:setDirection("vertical")
        
        node.scrollView:setSwallowTouch(false)

        data:resetScoolSize2(node.scrollView,164,210,desc)
        return node
    end
    local configCount = #LegionMilitaryConfig
    for configId=configCount,1,-1 do
        local item = createItemView(configId)
        local w , h = item:getContentSize()
        scroolView:pushBackCustomItem(item,w,h,0.5)
    end
end

function This:initTouchEvent()
	self.m_csNode.close:setTouchEnded(function()
        self:close()
    end)
end


function This:getData()
	self.m_data = self.m_family:getRatingData()
end
