-- @Author: zheng
-- @Date:   2018-10-24 16:30:34
-- @Last Modified by:   zheng
-- @Last Modified time: 2018-12-15 17:13:44
-- @File Name: FamilyRatingRewardItemView.lua

local FamilyRatingManager = require("FamilyRating.FamilyRatingManager")

local This , super = class(...,"NewActivity.ActivityHappyTurnDayItemView")

This.fileName = "MenuScene/NodeUI/FamilyRewardList.csb"
function This:onPickUpBtnClick()
    if self:isOpening() then
        local uiType = self.m_config.uiType
        local ratingData = FamilyRatingManager:getRatingData()
        local havaPower = self:isHavePower()
        if not havaPower then
            return 
        end
        FamilyRatingManager:onGetRatingRewardRequest(uiType,self.m_config.id)
    end
end

function This:isHavePower()
    local ratingData = FamilyRatingManager:getRatingData()
    local uiType = self.m_config.uiType
    return ratingData:getSeasonOrPersonRewardInfo(uiType)--,uiStrs[uiType] or ""
end

function This:refresh(data)
    if data then
        self.m_config = data
    end
    local uiType = self.m_config.uiType
    self.juntuan:setVisible(false)
    self.person:setVisible(false)
    local node = self.juntuan
    local labelNode = node
    if uiType == FamilyRatingRewardType.kType3 then--个人
        node = self.person
        labelNode = node.jifen
    end
    node:setVisible(true)
    labelNode:setString(self.m_config.min or self.m_config.name)
    if self:isHavePower() then
        self:setItemEnable(self:isOpening())
    else
        self:setItemEnable(false)
    end
end

function This:isOpening()
    return self.m_config and self.m_config.state == FamilyRatingBoxState.kOpen
end

function This:isLocked()
    return self.m_config and self.m_config.state == FamilyRatingBoxState.kLock
end

