-- @Author: zheng
-- @Date:   2018-10-24 15:35:25
-- @Last Modified by:   zheng
-- @Last Modified time: 2018-12-15 17:15:11
-- @File Name: FamilyRatingRewardPanel.lua
local FamilyRatingManager = require("FamilyRating.FamilyRatingManager")

local FamilyRatingRewardItemView = require("FamilyRating.FamilyRatingRewardItemView")

local This , super = class(...,"NewActivity.ActivityHappyTurnDayPanel")


function This:addManager(  )
    FamilyRatingManager:addObserver(self)
end

function This:removeManager(  )
    FamilyRatingManager:removeObserver(self)
end

function This:initNode(info)
    self.m_itemViews = {}
    self.m_csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/FamilyReward.csb")
    self:addChild(self.m_csNode)
    self:initCustomUi()
    self.m_csNode:setToCenter()
    if info then
    	self.m_family = info.family
    	self:getData()
    	self.m_panelType = info.types
    end
	self:onGetTurnBox()
end

function This:initTouchEvent()
	super.initTouchEvent(self)

    self.m_csNode.wenhao:setTouchEnded(function()
        g_scene:openDialog("UI.HelpTips", {text = self.m_helpStr,node = self.m_csNode.wenhao})
    end)
end

function This:createItemView( data )
    return FamilyRatingRewardItemView:create(data)
end

function This:onGetTurnBox()
	local data = self.m_data
    local temReward = data:getSeasonOrPersonalRewards(self.m_panelType)
	local rewardList = {}
    for id,reward in pairs(temReward) do
        if reward and reward.reward and #reward.reward>0 then
            table.insert(rewardList,reward)
        end
    end
    local titleStr = Serialize["family_RatingReward_3"]
    self.m_helpStr = Serialize["family_RatingReward_1"]
    local personScoreVisible = false
    local personLabel = self.m_csNode.junwei
	if self:isType(FamilyRatingRewardType.kType3) then--个人
        personScoreVisible = true
        titleStr = Serialize["family_RatingReward_4"]
        self.m_helpStr = Serialize["family_RatingReward_2"]
        personLabel:setString(string.format("%s:%d",Serialize["family_RatingReward_5"],data:getPersonScore()))
	end
    self.m_csNode.title:setString(titleStr)
    personLabel:setVisible(personScoreVisible)
    if rewardList then
    	self.m_itemDataList = rewardList
    	self:refreshRewardList()
    end
end

function This:isType(checkType)
	local res = false
	if self.m_panelType == checkType then
		res = true
	end
	return res
end

function This:getData()
	self.m_data = self.m_family:getRatingData()
end

function This:onGetRatingReward(  )--领取奖励
    self:onGetTurnBox()
end