-- @Author: zheng
-- @Date:   2018-10-26 11:12:14
-- @Last Modified by:   zheng
-- @Last Modified time: 2018-12-21 16:26:46
-- @File Name: FamilyRatingWeeklyRewardPanel.lua

local This , super = class(...,"Dialog")

This.fileName = "MenuScene/NodeUI/FamilyWeeklyReward.csb"

function This:initNode(info)
    
    local fileName = This.fileName
    local title = info.title
    local rewards = info.rewards
    local receive = info.receive--是否已经领取
    local wenhaoStr = info.wenhaoStr
    local btnCallBack = info.btnCallBack
    local isGray = info.isGray--是否达到领取条件
    local emptyRewardStr = info.emptyRewardStr
    if info.fileName then
        fileName = info.filename
    end
    self.m_wenhaoStr = wenhaoStr
    self.m_btnCallBack = btnCallBack
    self.m_csNode = cc.Node:createFromCSFile(fileName)
    self.m_csNode:setToCenter()
    self:addChild(self.m_csNode)
    if title then
        self.m_csNode.title:setString(title)
    end
    local function createItemView(model)
        local ItemNode = require("UI.ItemNode")
        local node = ItemNode:create(model[1],model[2])
        node:setAnchorPoint(0.5,0.5)
        return node
    end
    
    self.m_csNode.scrollView:setDirection("horizontal")
    self.m_csNode.scrollView.m_direction = "right"
    for i,itemConfig in ipairs(rewards) do
        local item = createItemView(itemConfig)
        local scale = 0.9
        item:setScale(scale)
        local w , h = item:getContentSize()
        self.m_csNode.scrollView:pushBackCustomItem(item,w*scale,h,0.5)
    end

    self.m_csNode.yilingqu:setVisible(receive)
    if receive then
        self.m_csNode.lingqu:setVisible(false)
    end

    local wenHaoVisible = false
    if wenhaoStr then
        wenHaoVisible = true
    end
    if isGray then
        self.m_csNode.lingqu:setGrayShader()
    end
    local wenhao = self.m_csNode.wenhao
    if wenhao then
        wenhao:setVisible(wenHaoVisible)
    end

    local emptyLabel = self.m_csNode.empty_tip
    local emptyVisible = false
    if #rewards ==0 then
        self.m_csNode.lingqu:setVisible(false)
        if emptyRewardStr then
            emptyVisible = true
            emptyLabel:setString(emptyRewardStr)
        end
    end
    emptyLabel:setVisible(emptyVisible)
    
end

function This:initTouchEvent()
    self.m_csNode.close:setTouchEnded(function()
        self:close()
    end)
	self.m_csNode.lingqu:setTouchEnded(function()
        if self.m_btnCallBack then
            self.m_btnCallBack()
        end
        self:close()
    end)
    local wenhao = self.m_csNode.wenhao
    if wenhao then
        wenhao:setTouchEnded(function()
            local text = self.m_wenhaoStr or ""
            g_scene:openDialog("UI.HelpTips", {text = text,node = wenhao})
        end)
    end
end