-- @Author: zheng
-- @Date:   2018-12-14 16:12:51
-- @Last Modified by:   zheng
-- @Last Modified time: 2018-12-17 10:34:32
-- @File Name: GameRankScore.lua
local LegionRankScoreConfig = require("Metadatas.LegionRankScoreConfig")
local GameUtil = require("Util.GameUtil")
local This = class(...)

function This:create()
    local o = {}
    setmetatable(o,This)
    return o
end

function This:init(id)
    self.m_curentId = id
    self.m_id = id
    if id==0 then
        self.m_id = 1
    end
    self.m_config = LegionRankScoreConfig[self.m_id]
end

function This:getCurentId()
    return self.m_curentId
end

function This:getId()
    return self.m_id
end

function This:getName(id)
    return GameUtil:getConfigItem(self.m_config,"name",id,LegionRankScoreConfig,"")
end

function This:getIcon(id)
    return GameUtil:getConfigItem(self.m_config,"icon",id,LegionRankScoreConfig,"")
end

function This:getMinScore(id)
    return GameUtil:getConfigItem(self.m_config,"min",id,LegionRankScoreConfig,0)
end

function This:getMaxScore(id)
    return GameUtil:getConfigItem(self.m_config,"max",id,LegionRankScoreConfig,0)
end

function This:getRewardList(id)
    return GameUtil:getConfigItem(self.m_config,"reward",id,LegionRankScoreConfig,{})
end

function This:getDesc(id)
    return GameUtil:getConfigItem(self.m_config,"text",id,LegionRankScoreConfig,"")
end

function This:getLockDesc(id)
    return GameUtil:getConfigItem(self.m_config,"lock_text",id,LegionRankScoreConfig,"")
end

--评级效果描述
function This:getImpact(id)
    local impact = GameUtil:getConfigItem(self.m_config,"impact",id,LegionRankScoreConfig,{})
    return GameUtil:convertData(impact)
end

--是否可以晋升
function This:checkCanUp(junweiNum)
    local res =false
    local temId = self:getCurentId()
    local id = temId+1
    local junWei = junweiNum
    local idMin = self:getMinScore(id)
    res = junWei>=idMin
    if idMin ==0 and temId~= 0 then
        res = false
    end
    return res
end

--是否已经晋升
function This:checkIdPass(id)
    if id then
        local temId = self:getCurentId()
        return temId>=id
    end
    return false
end

function This:checkId(id)
    local temId = id or self:getCurentId()
    return math.max(1, temId)
end