--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"Dialog")
local WorldMapManager = require("World.WorldMapManager")
local ForeignView = require("Foreign.ForeignView")
local GamePlayer = require("Player.GamePlayer")
local ConfirmPanel = require("UI.ConfirmPanel")

function This:initNode()
	self.m_csNode = cc.Node:createFromCSFile("GameScene/NodeUI/Diplomatic.csb")
	self:addChild(self.m_csNode)
	self.m_csNode:setToCenter()
	self.m_listView = self.m_csNode.diplomaticitem
	self.m_items = {}
	self:initListItem()
end

function This:initTouchEvent()
	self.m_csNode.surrenderbutton:setTouchEnded(function()
		print("投降...")
		local panel = g_scene:openDialog("UI.ConfirmPanel")
		panel:setString(Serialize["foreign_RelationPanel_1"])--是否花费一枚“投降令”提前投降(提前投降可能会影响到您在本局获得的成就和奖励)
		panel:setOkHandler(function()
			WorldMapManager:onSurrenderRequest()
		end)
	end)
	self.m_csNode.close:setTouchEnded(function()
		self:close()
	end)
	self.m_csNode.help:setTouchEnded(function()
		g_scene:openDialog("UI.HelpTips",{text=Serialize["Diplomatic_help_tips"],node = self.m_csNode.help})
	end)
end

function This:onEnter()
	super.onEnter(self)
	WorldMapManager:addObserver(self)
end

function This:onExit()
	super.onExit(self)
	WorldMapManager:removeObserver(self)
end

function This:initListItem()
	self.m_listView:removeAllItems()
	local tmpList = WorldMapManager:getRoleForcesList()
	for i , list in ipairs(tmpList) do
		for id , role in ipairs(list) do
			local item = ForeignView:create(role)
			self.m_listView:pushBackCustomItem(item,580,95,1.0)
			self.m_items[role:getId()] = item
		end
	end
end

function This:onApplyStateChanged()
	for i , view in pairs(self.m_items) do
		view:refresh()
	end 	
end

function This:onRelationChanged()
	self:initListItem()
end

function This:onMapRoleChanged()
	for i , view in pairs(self.m_items) do
		view:refresh()
	end 
end

--endregion
