--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This, super = class(...,"cc.Node")
local GamePlayer = require("Player.GamePlayer")
local WorldMapManager = require("World.WorldMapManager")
local GameUtil = require("Util.GameUtil")
local MatchingConfig = require("Metadatas.MatchingConfig")
local LoginManager = require("Login.LoginManager")

local RelationImage =
{
	[RelationType.kJun] = "Common/zhugong.png",
	[RelationType.kChen] = "Common/shucheng.png",
	[RelationType.kTongMeng] = "Common/tongmeng.png",
    [RelationType.kTongPao] = "Common/shucheng.png",
}

function This:init(role)
	self.m_role = role
	self.m_csNode = cc.Node:createFromCSFile("GameScene/NodeUI/DiplomaticItem.csb")
	self:addChild(self.m_csNode)
	local w , h = self.m_csNode.bg:getContentSize()
	self:setContentSize(w,h)
	self:setAnchorPoint(0.5,1.0)
end

function This:onEnter()
	super.onEnter(self)
	self:initNode()
	self:initTouchEvent()
	self:refresh()
	self.m_csNode:setCascadeOpacityEnabled(true)
end

function This:onExit()
	super.onExit(self)
end

function This:initNode()
	self.m_csNode.name:setString(self.m_role:getName())
	self.m_csNode.level:setString(string.format(Serialize["foreign_ForeignView_1_c"],self.m_role:getLevel()))	
	local cityList = self.m_role:getCitys()
	self.m_csNode.city:setString(string.format(Serialize["foreign_ForeignView_2"],#cityList))
	local icon = self.m_csNode.icon
	GameUtil:setPlayerIconNodeImage(icon, self.m_role:getIcon())
	GameUtil:setPlayerEffectNodeTo(icon, self.m_role:getEffect())
end

function This:showRecvRequest(recvType,isProtected)
	self.m_csNode.relationship:setVisible(false)
	self.m_csNode.monarchbutton:setVisible(false)
	self.m_csNode.vassalbutton:setVisible(false)
	self.m_csNode.leaguebutton:setVisible(false)
	self.m_csNode.getletter:setVisible(true)
	if isProtected and recvType == RelationType.kChen then
		self.m_csNode.getletter.lettername:setImage("GameScene/lettername3.png")
	elseif isProtected and recvType == RelationType.kJun then
		self.m_csNode.getletter.lettername:setImage("GameScene/lettername2.png")
	elseif recvType == RelationType.kTongMeng then
		self.m_csNode.getletter.lettername:setImage("GameScene/lettername1.png")
	end
end

function This:showSendRequest(sendType,isProtected)
	if sendType == RelationType.kJun then
		self.m_csNode.monarchbutton:setVisible(isProtected)
		self.m_csNode.vassalbutton:setVisible(false)
		self.m_csNode.getletter:setVisible(false)
		self.m_csNode.relationship:setVisible(false)
		self.m_csNode.leaguebutton:setVisible(false)
		self.m_csNode.monarchbutton.text:setImage("GameScene/waijiaotext6.png")
	elseif sendType == RelationType.kChen then
		self.m_csNode.monarchbutton:setVisible(false)
		self.m_csNode.vassalbutton:setVisible(isProtected)
		self.m_csNode.getletter:setVisible(false)
		self.m_csNode.relationship:setVisible(false)
		self.m_csNode.leaguebutton:setVisible(false)
		self.m_csNode.vassalbutton.text:setImage("GameScene/waijiaotext4.png")
	elseif sendType == RelationType.kTongMeng then
		self.m_csNode.monarchbutton:setVisible(false)
		self.m_csNode.vassalbutton:setVisible(false)
		self.m_csNode.getletter:setVisible(false)
		self.m_csNode.relationship:setVisible(false)
		self.m_csNode.leaguebutton:setVisible(true)
		self.m_csNode.leaguebutton.text:setImage("GameScene/waijiaotext5.png")
	end
end

function This:showIdentifyNoRelation()  --有身份无关系状态
	self.m_csNode.relationship:setVisible(false)
	self.m_csNode.monarchbutton:setVisible(false)
	self.m_csNode.vassalbutton:setVisible(false)
	self.m_csNode.leaguebutton:setVisible(false)
	self.m_csNode.getletter:setVisible(false)
end

function This:showNoIdentifyNoRelation(mainRole,sendList,isProtected)  --无身份无关系
	self.m_csNode.relationship:setVisible(false)
	local collRequestCount = 0
	local masterRequestCount = 0
	local allyRequestCount = 0

	for i , rt in pairs(sendList) do
		if rt == RelationType.kChen then
			collRequestCount = collRequestCount + 1
		elseif rt == RelationType.kJun then
			masterRequestCount = masterRequestCount + 1
		elseif rt == RelationType.kTongMeng then
			allyRequestCount = allyRequestCount + 1
		end
	end

	local totalRequest = collRequestCount + masterRequestCount + allyRequestCount
	local mainIdentify = mainRole:getIdentity()
	local roleIdentify = self.m_role:getIdentity()

	local isShowMaster = isProtected and totalRequest <= 0 and mainIdentify <= 0 and (roleIdentify <= 0 or roleIdentify == RelationType.kJun) and #self.m_role:getColleague() < 2
	self.m_csNode.monarchbutton:setVisible(isShowMaster)
	self.m_csNode.monarchbutton.text:setImage("GameScene/waijiaotext1.png")
	
	local isShowCollea = isProtected and (masterRequestCount+allyRequestCount) <=0 and collRequestCount + #mainRole:getColleague() < 2 and (mainIdentify <= 0 or mainIdentify == RelationType.kJun) and self.m_role:getIdentity() <= 0 
	self.m_csNode.vassalbutton:setVisible(isShowCollea)
	self.m_csNode.vassalbutton.text:setImage("GameScene/waijiaotext3.png")

	local isShowAlly = totalRequest <= 0 and mainRole:getIdentity() <= 0 and self.m_role:getIdentity() <= 0
	self.m_csNode.leaguebutton:setVisible(isShowAlly)
	self.m_csNode.leaguebutton.text:setImage("GameScene/waijiaotext2.png")
	self.m_csNode.getletter:setVisible(false)	
end

function This:showRelation(relation) --有关系
	self.m_csNode.monarchbutton:setVisible(false)
	self.m_csNode.vassalbutton:setVisible(false)
	self.m_csNode.leaguebutton:setVisible(false)
	self.m_csNode.getletter:setVisible(false)
	self.m_csNode.relationship:setVisible(true)
	local str = ""
	if relation == RelationType.kChen or relation == RelationType.kTongPao then
		str = Serialize["foreign_ForeignView_3"]
		local master = self.m_role:getMaster()
		local role = WorldMapManager:getRole(master)
		str = str .. "\n	  " .. role:getName()
	elseif relation == RelationType.kJun then
		str = Serialize["foreign_ForeignView_4"]
		local colleague = self.m_role:getColleague()
		for i , id in ipairs(colleague) do
			local role = WorldMapManager:getRole(id)
			str = str .. "\n	  " .. role:getName()
		end
	elseif relation == RelationType.kTongMeng then
		str = Serialize["foreign_ForeignView_5"]
		local ally = self.m_role:getAlly()
		local role = WorldMapManager:getRole(ally)
		str = str .. "\n	  "..role:getName()
	end		
	self.m_csNode.relationship.text:setString(str)
end

function This:getRecvRequest()
	local mainRole = WorldMapManager:getMainRole()
	local recvtList = mainRole:getRecvRequest()
	local recvType = recvtList[self.m_role:getId()]
	return recvType
end

function This:getSendRequest()
	local mainRole = WorldMapManager:getMainRole()
	local sendList = mainRole:getSendRequest()
	local sendType = sendList[self.m_role:getId()]
	return sendType
end

function This:showIdentify(playerId, identify, relation)
	if self.m_role:getId() == playerId then
		self.m_csNode.shucheng:setVisible(identify == RelationType.kChen)
		self.m_csNode.zhugong:setVisible(identify == RelationType.kJun)
		self.m_csNode.tongmeng:setVisible(identify == RelationType.kTongMeng)
	else
		self.m_csNode.shucheng:setVisible(relation == RelationType.kChen or relation == RelationType.kTongPao)
		self.m_csNode.zhugong:setVisible(relation == RelationType.kJun)
		self.m_csNode.tongmeng:setVisible(relation == RelationType.kTongMeng)
	end
end

function This:isShowIdentify(mainRole,identify,relation,isProtected)
	if identify > 0 then
		local colleague = self.m_role:getColleague()
		local roleIdentify =  self.m_role:getIdentity()
		if roleIdentify == RelationType.kJun and  #colleague < 2 and mainRole:getIdentity() <= 0 then
			return false
		end
		return true
	end
	return false
end

function This:refresh()
	local csNode = self.m_csNode
	local relation = self.m_role:getRelationWithMe()
	local identify = self.m_role:getIdentity()
	local playerId = GamePlayer:getPlayerID()
	local mainRole = WorldMapManager:getMainRole()
	local recvtList = mainRole:getRecvRequest()
	local recvType = recvtList[self.m_role:getId()]
	local sendList = mainRole:getSendRequest()
	local sendType = sendList[self.m_role:getId()]

	local isProtected = WorldMapManager:isInProtected()
	print_r({playerId=playerId, identify=identify, relation=relation})
	self:showIdentify(playerId, identify, relation)
	if recvType and recvType > 0 then
		print("recvType = ",recvType)
		self:showRecvRequest(recvType, isProtected)
	elseif sendType and sendType > 0 then
		print("sendType = ",sendType)
		self:showSendRequest(sendType, isProtected)
	elseif self:isShowIdentify(mainRole, identify, relation, isProtected) then  
		print("relation = ", identify)
		self:showRelation(identify)
	elseif (relation <= 0 and self.m_role:getId() ~= playerId) then 
		print("identify = ", identify, "relation = ", relation)
		self:showNoIdentifyNoRelation(mainRole, sendList, isProtected)
	else
		self:showIdentifyNoRelation()
	end
	if self.m_role:getGroupId() > 0 then
		csNode.family:setString(self.m_role:getGroupName())
	else
		csNode.family:setString(Serialize["Arena_PlayerInfo_1"])
	end
	local rank = self.m_role:getRankLv()
	rank = rank > 0 and rank or 1
	csNode.officer:setString(MatchingConfig[rank].rank_level)
	csNode.level:setString(string.format(Serialize["foreign_ForeignView_1_c"],self.m_role:getLevel()))	
	local serverName = LoginManager:getServerAreaName(self.m_role:getServerId(),true)
	csNode.qufu:setString(serverName)

	-- 皇帝战
	if GamePlayer:isInKingMap() then
		csNode.monarchbutton:setVisible(false)
		csNode.vassalbutton:setVisible(false)
		csNode.leaguebutton:setVisible(false)
		csNode.getletter:setVisible(false)
	end
end

function This:onApplyRelation(relation, str1, str2)
	local mainRole = WorldMapManager:getMainRole()
	local sendList = mainRole:getSendRequest()
	local sendType = sendList[self.m_role:getId()]
	if sendType and sendType == relation then
		local panel = g_scene:openDialog("UI.ConfirmPanel")
		panel:setString(str1)
		panel:setOkHandler(function()
			WorldMapManager:onReleationApplyRequest(self.m_role:getId(), 0)
		end)
	else
		local panel = g_scene:openDialog("UI.ConfirmPanel")
		panel:setString(str2)
		panel:setOkHandler(function()
			if WorldMapManager:isInProtected() then
				WorldMapManager:onReleationApplyRequest(self.m_role:getId(), relation)
			elseif sendType == RelationType.kChen or sendType == RelationType.kJun then
				g_scene:showTips(Serialize["foreign_ForeignView_6_c"])
			else
				WorldMapManager:onReleationApplyRequest(self.m_role:getId(), relation)
			end
		end)
	end	
end

function This:initTouchEvent()
	self.m_csNode.monarchbutton:setTouch({
		onEnded = function()
			local str1 = string.format(Serialize["foreign_ForeignView_7"],self.m_role:getName())
			local str2 = string.format(Serialize["foreign_ForeignView_8"],self.m_role:getName())
			self:onApplyRelation(RelationType.kJun,str1,str2)
		end,
		isContainer = true
	})

	self.m_csNode.vassalbutton:setTouch({
		onEnded = function()
			local str1 = string.format(Serialize["foreign_ForeignView_9"],self.m_role:getName())
			local str2 = string.format(Serialize["foreign_ForeignView_10"],self.m_role:getName())
			self:onApplyRelation(RelationType.kChen,str1,str2)
		end,
		isContainer = true
	})

	self.m_csNode.leaguebutton:setTouch({
		onEnded = function()
			local str1 = string.format(Serialize["foreign_ForeignView_11"],self.m_role:getName())
			local str2 = string.format(Serialize["foreign_ForeignView_12"],self.m_role:getName())
			self:onApplyRelation(RelationType.kTongMeng,str1,str2)
		end,
		isContainer = true
	})

	self.m_csNode.getletter.letterbutton:setTouch({
		onEnded = function()
			local mainRole = WorldMapManager:getMainRole()
			local recvList = mainRole:getRecvRequest()
			local recvType = recvList[self.m_role:getId()]
			assert(recvType)
			local str = ""
			if recvType == RelationType.kChen then
				str = string.format(Serialize["foreign_ForeignView_13"],self.m_role:getName())
			elseif recvType == RelationType.kJun then
				str = string.format(Serialize["foreign_ForeignView_14"],self.m_role:getName())
			elseif recvType == RelationType.kTongMeng then
				str = string.format(Serialize["foreign_ForeignView_15"],self.m_role:getName())
			end
			 
			local panel = g_scene:openDialog("UI.ConfirmPanel")
			panel:setString(str)
			panel:setBtnString(Serialize["foreign_ForeignView_16"],Serialize["foreign_ForeignView_17"])
			panel:setOkHandler(function()
				if WorldMapManager:isInProtected() then
					WorldMapManager:onRelationResponseRequest(self.m_role:getId(),1)
				elseif recvType == RelationType.kTongMeng then
					WorldMapManager:onRelationResponseRequest(self.m_role:getId(),1)
				else
					g_scene:showTips(Serialize["foreign_ForeignView_6_c"])
				end
			end)
			panel:setCancelHandler(function()
				WorldMapManager:onRelationResponseRequest(self.m_role:getId(),2)
			end)
		end,
		isContainer = true
	})
	self.m_csNode.icon:setTouch({
		onEnded = function()
			g_scene:openDialog("Player.RoleInfoPanel",{id = self.m_role:getId()})
		end,
		isContainer = true,
		isScale = false
	})
end

--endregion
