--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"Base.BaseModel")
local FriendManager = require("Friend.FriendManager")
local GamePlayer = require("Player.GamePlayer")

function This:init(info)
	super.init(self)
	self.m_id = info.id
	self.m_name = info.name
	self.m_icon = info.icon
	self.m_title = info.title
	self.m_effect = info.effect
	self.m_level = info.level or 1
	self.m_rank = info.cur_rank_level or 1
	self.m_vipList = info.vip_list or {}
	self.m_isOnline = info.isOnline or false
	self.m_isFriend = info.isFriend or false
	self.m_isRecvInvite = info.isRecvInvite or false
	self.m_isSendInvite = info.isSendInvite or false
	self.m_isBlack = info.isBlack or false
	self.m_msgList = {}
	self.m_lastChatTime = 0
	self.m_lastInviteTime = 0
end

function This:getId()
	return self.m_id
end

function This:getName()
	return self.m_name
end

function This:getIcon()
	return self.m_icon
end

function This:getTitle()
	return self.m_title
end

function This:getEffect()
	return self.m_effect
end

function This:getLevel()
	return self.m_level
end

function This:getRankLv()
	return self.m_rank
end

function This:getVipList()
	return self.m_vipList
end

function This:isOnline()
	return self.m_isOnline
end

function This:setIsOnline(isOnline)
	self.m_isOnline = isOnline
end

function This:isFriend()
	return self.m_isFriend
end

function This:setIsFriend(isFriend)
	self.m_isFriend = isFriend
end

function This:hasRecvInvite()
	return self.m_isRecvInvite
end

function This:setIsRecvInvite(isRecv)
	self.m_isRecvInvite = isRecv
end

function This:hasSendInvite()
	return self.m_isSendInvite
end

function This:setIsSendInvite(isSend)
	self.m_isSendInvite = isSend
end

function This:isBlackFriend()
	return self.m_isBlack
end

function This:setIsBlackFriend(isBlack)
	self.m_isBlack = isBlack
end

function This:addChatMessage(chat)
	local isInsert = false
	for i , ct in ipairs(self.m_msgList) do
		if ct:getId() == chat:getId() then
			return
		end
		if chat:getSendTime() < ct:getSendTime() then
			table.insert(self.m_msgList,i,chat)
			isInsert = true
			break
		end
	end

	if not isInsert then
		table.insert(self.m_msgList,chat)
	end
	if self.m_lastChatTime < chat:getSendTime() then
		self.m_lastChatTime = chat:getSendTime()
	end
end

function This:getChatMessage()
	return self.m_msgList
end

function This:getChatMessageCount()
	return #self.m_msgList
end

function This:removeChatMessage()
	self.m_msgList = {}
	self.m_lastChatTime = 0
end

function This:isHasChatMessage()
	return #self.m_msgList > 0
end

function This:recordLastInviteTime()
    self.m_lastInviteTime =  GamePlayer:getServerTime()
end

function This:getLeftInviteCD()
	if self.m_lastInviteTime <= 0 then
		return 0
	end

	local offset = self.m_lastInviteTime + kFamilyInviteSendApplyCD - GamePlayer:getServerTime()
	if offset <= 0 then
		return 0
	end
    return offset
end

function This:getLastSendTime()
	return self.m_lastChatTime
end

function This:updateInfo(info)
	assert(self.m_id == info.id)
	self.m_name = info.name
	self.m_icon = info.icon
	self.m_title = info.title
	self.m_effect = info.effect
	self.m_level = info.level or 1
	self.m_isOnline = info.isOnline or false
	self.m_isFriend = info.isFriend or false
	self.m_isRecvInvite = info.isRecvInvite or false
	self.m_isSendInvite = info.isSendInvite or false
	self.m_isBlack = info.isBlack or false
end

--endregion
