--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"Dialog")
local FriendView = require("Friend.FriendView")
local ChatView = require("Chat.ChatView")
local FriendManager = require("Friend.FriendManager")
local GamePlayer = require("Player.GamePlayer")
local ChatManager = require("Chat.ChatManager")
local ViewUtil = require("UI.ViewUtil")
local VoiceChat = require("VoiceChat")
local ChatManager = require("Chat.ChatManager")
local VoiceChatManager = require("VoiceChat")
local GameUtil = require("Util.GameUtil")
local VoiceView = require("Chat.VoiceView")
local MatchManager = require("Match.MatchManager")
local ArgConfig = require("Metadatas.ArgConfig")
local EventDispatcher = require("EventDispatcher")

FriendTabName = 
{
	kZuiJin = "zuijin",
	kFriend = "friend",
	kBlack = "black",
}

local ChatMode = 
{
	kText = 1,
	kVoice = 2,
	kTranslate = 3,
	kCount = 2
}

function This:initNode(info)
	self.m_csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/FriendMain.csb")
	self:addChild(self.m_csNode)
	self.m_csNode:setToCenter()
	self.m_curSelectTab = ""
	self.m_friendViews = {}
	self.m_csNode.request:setVisible(false)
	self.m_csNode.send_chat:setVisible(false)

	self:addTabButton(FriendTabName.kZuiJin,self.m_csNode.tab1,function()
		self:selectTab(FriendTabName.kZuiJin)
	end)
	self:addTabButton(FriendTabName.kFriend,self.m_csNode.tab2,function()
		self:selectTab(FriendTabName.kFriend)
	end)
	self:addTabButton(FriendTabName.kBlack,self.m_csNode.tab3,function()
		self:selectTab(FriendTabName.kBlack)
	end)
	if info then
		self.m_defaultFriendId =  info.defaultFriendId
	end
	self:selectTabButton((info and info.tabIndex) or FriendTabName.kZuiJin)
	self.m_escape = 0
	self:refreshSendBtn()
	self.m_mode = ChatMode.kText
	self:refreshMode()
end

function This:initTouchEvent()
	local function checkPlayerLv()
		local lv = ArgConfig.talk_level.arg[1] or 1
		local result = GamePlayer:getLevel()< lv
		if result then
			local str = string.format(Serialize["chat_ChatPanel_14"],lv)
			g_scene:showTips(str)
		end
		return result
	end
	self.m_csNode.close:setTouchEnded(function()
		self:close()
	end)
	self.m_csNode.add:setTouchEnded(function()
		g_scene:openDialog("Friend.SearchPanel")
	end)

	self.m_csNode.request.agree:setTouchEnded(function()
		self:onAgreeBtnClicked()
	end)
	self.m_csNode.request.disagree:setTouchEnded(function()
		self:onDisagreeBtnClicked()
	end)
	self.m_csNode.send_chat.send:setTouchEnded(function()
		if checkPlayerLv() then
			return false
		end
		-- if GamePlayer:getLevel() < kChatLevelLimit then
			-- g_scene:showTips(string.format(Serialize[61093]))--kChatLevelLimit
		-- elseif MatchManager:getRankLv() < kChatRankLimit then
		-- 	g_scene:showTips(string.format(Serialize[61094],MatchManager:getRankName(kChatRankLimit)))--kChatLevelLimit
		if self.m_escape > 0 then
			local str = string.format(Serialize["friend_ChatPanel_6_c"], math.ceil(self.m_escape))
			g_scene:showTips(str)
		else
			self:onSendBtnClicked()
		end
	end)
	self.m_csNode.send_chat.change:setTouchEnded(function()
		if checkPlayerLv() then
			return false
		end
		-- if GamePlayer:getLevel() >= kChatLevelLimit and MatchManager:getRankLv() >= kChatRankLimit then
			self.m_mode = self.m_mode % ChatMode.kCount + 1
			self:refreshMode()
		-- else
		-- 	g_scene:showTips(Serialize[61095])
		-- end
	end)
	self.m_csNode.send_chat.talk:setTouch({
		onBegan = function()
			local playerId = GamePlayer:getPlayerID()
			local str = GameUtil:int64ToString(playerId)
			self.m_isRecordingVoice = true
			if self.m_mode == ChatMode.kVoice then
				VoiceChatManager:recordVoice(str)
			elseif self.m_mode == ChatMode.kTranslate then
				VoiceChatManager:speechText()
			end
			self:refreshMode()
			g_scene:showVoiceState(VoiceState.kRecording)
			if self.m_playView then
				self.m_playView:showPlayVoice(false)
				self.m_playView = nil
			end
		end,
		onEnded = function()
			self.m_isRecordingVoice = false
			if self.m_mode == ChatMode.kVoice then
				VoiceChatManager:stopRecord()
			elseif self.m_mode == ChatMode.kTranslate then
				VoiceChatManager:stopSpeech()
			end
			self:refreshMode()
			g_scene:showVoiceState(VoiceState.kNone)
		end,
		onCanceled = function()
			if self.m_mode == ChatMode.kTranslate then
				VoiceChatManager:cancelRecord()
			else
				VoiceChatManager:cancelSpeech()
			end
			self.m_isRecordingVoice = false
			self:refreshMode()
			g_scene:showVoiceState(VoiceState.kNone)
		end,
		onMoved = function(_,touchPoint)
			local rect = self.m_csNode.send_chat.talk.speak:getBoundingBox()
			if not rect:isContainsPoint(touchPoint) then
				g_scene:showVoiceState(VoiceState.kCancel)
			else
				g_scene:showVoiceState(VoiceState.kRecording)
			end
		end,
		sizeNode = self.m_csNode.send_chat.talk.speak,
		isScale = false
	})
end

function This:onEnter()
	super.onEnter(self)
	FriendManager:addObserver(self)
	ChatManager:addObserver(self)
	VoiceChatManager:setRecordCallback(function(voiceId,size)
		ChatManager:onSendVoiceRequest(ChatChannelType.kPrivate, voiceId,size,self.m_curFriend:getId())
	end)
	VoiceChatManager:setPlayCallback(function()
		if self.m_playView then
			self.m_playView:showPlayVoice(false)
		end
		self.m_playView = nil
	end)
	VoiceChatManager:setSpeechCallback(function(msg)
		FriendManager:onSendChatMessageRequest(self.m_curFriend:getId(), msg)
	end)
	FriendManager:onInitFriendInfoRequest()

	EventDispatcher:addListener(self,"ios_keyboard_show",self.onIosKeyboardShow)
    EventDispatcher:addListener(self,"ios_keyboard_hide",self.onIosKeyboardHide)	
end

function This:onExit()
	super.onExit(self)
	FriendManager:removeObserver(self)
	ChatManager:removeObserver(self)
	VoiceChatManager:setRecordCallback(nil)
	VoiceChatManager:setPlayCallback(nil)
	VoiceChatManager:setSpeechCallback(nil)
	EventDispatcher:removeListener(self, "ios_keyboard_show")
    	EventDispatcher:removeListener(self, "ios_keyboard_hide")	
end

function This:onIosKeyboardShow(height)
    if not self.m_originY then
        self.m_originY = self.m_csNode:getPositionY()
    end
    self.m_csNode:setPositionY(self.m_originY + height + 55)
end

function This:onIosKeyboardHide()
    self.m_csNode:setPositionY(self.m_originY)
end

function This:update(dt)
	super.update(self,dt)
	if self.m_escape > 0 then
		self.m_escape = self.m_escape - dt
		self:refreshSendBtn()
		if self.m_escape <= 0 then
			self:unscheduleUpdate()
		end
	end
end

function This:refreshSendBtn()
	if self.m_escape > 0 then
		self.m_csNode.send_chat.send:setGrayShader()
		local str = string.format(Serialize["chat_ChatPanel_12_c"], math.ceil(self.m_escape))
		self.m_csNode.send_chat.send.text:setString(str)
	else
		-- if GamePlayer:getLevel() < kChatLevelLimit or MatchManager:getRankLv() < kChatRankLimit then
		-- 	self.m_csNode.send_chat.send:setGrayShader()
		-- elseif GamePlayer:getLevel() >= kChatLevelLimit then
			self.m_csNode.send_chat.send:resetToNormalShader()
		-- end
		self.m_csNode.send_chat.send.text:setString(Serialize["chat_ChatPanel_13_c"])
	end
end

function This:refreshMode()
	self.m_csNode.send_chat.change.yuyin:setVisible(self.m_mode == ChatMode.kVoice)
	self.m_csNode.send_chat.change.wenzi:setVisible(self.m_mode == ChatMode.kText)
	self.m_csNode.send_chat.change.fanyi:setVisible(self.m_mode == ChatMode.kTranslate)

	self.m_csNode.send_chat.editor:setVisible(self.m_mode == ChatMode.kText)
	self.m_csNode.send_chat.talk:setVisible(self.m_mode ~= ChatMode.kText)
	self.m_csNode.send_chat.talk.speak:setVisible(not self.m_isRecordingVoice)
	self.m_csNode.send_chat.talk["end"]:setVisible(self.m_isRecordingVoice)
	
	if self.m_mode == ChatMode.kVoice then
		self.m_csNode.send_chat.talk.speak.text:setString(Serialize["chat_ChatPanel_10_c"])
	elseif self.m_mode == ChatMode.kTranslate then
		self.m_csNode.send_chat.talk.speak.text:setString(Serialize["chat_ChatPanel_11_c"])
	end
	self.m_csNode.send_chat.send:setVisible(self.m_mode == ChatMode.kText)
end

function This:selectTab(tab)
	if self.m_curSelectTab ~= tab then
		self.m_curSelectTab = tab
		self:refreshItems()
		if not self.m_defaultFriendId then
			self:selectFriend(self.m_friendList[1])
		end
	end
end

function This:getFriendList()
	if self.m_curSelectTab == FriendTabName.kZuiJin then
		return FriendManager:getChatFriendList()
	elseif self.m_curSelectTab == FriendTabName.kFriend then
		return FriendManager:getFriendList()
	elseif self.m_curSelectTab == FriendTabName.kBlack then
		return FriendManager:getBlackFriend()
	end
end

function This:getFriendView(friend)
	local view = FriendView:create(friend,self.m_curSelectTab)
	view:setAnchorPoint(0,0)
	view:setSelectHandler(function()
		self:selectFriend(friend)
	end)
	return view
end

function This:refreshItems()
	self.m_friendList = self:getFriendList()
	local scrollview = self.m_csNode.playerScrollView
	scrollview:removeAllItems()
	self.m_timer:removeAllTimer() 
	self.m_friendViews = {}
	self.m_curView = nil

	local height = 0
	local isHaveDefultFriend = false
	local allFrindSize = #self.m_friendList
	-- local curentIndex = allFrindSize
	local curentIndex = nil
	for i , friend in ipairs(self.m_friendList) do
		local view = self:getFriendView(friend)
		local w , h = view:getContentSize()
		height = h
		-- print(curentIndex,"  akk   ",i,"   ",friend:getName())
		scrollview:pushBackCustomItem(view,w,h,0.5)	
		local friendId = friend:getId()
		-- if curentIndex ==i then
			-- print("kkk",i)
		if self.m_defaultFriendId and self.m_defaultFriendId == friendId then
			self.m_curFriend = friend
			isHaveDefultFriend = true
			curentIndex = i
		end
		-- view:setIsSelected(false)
		if self.m_curFriend and self.m_curFriend:getId() == friend:getId() then
			self.m_curView = view
			self.m_curView:setIsSelected(true)
		end
		self.m_friendViews[friend:getId()] = view
	end
	if isHaveDefultFriend then
		height =height+5
		local temCurent = allFrindSize-curentIndex-1    --9  1
		if curentIndex ==1 then
			temCurent =temCurent-0.2
		end
		if temCurent>=(allFrindSize-3) then
			temCurent =allFrindSize-3.5
		end
		print(temCurent,"temCurent",allFrindSize)
		if temCurent<0 then
			temCurent = 0
		end

		local temY = -temCurent*height
		print(temY)
		scrollview:setInnerContainerPosition(0, temY)
		local temFrinend = self.m_curFriend
		self.m_curFriend = nil
		self:selectFriend(temFrinend)
	end
end

function This:refreshNodeVisible()
	self.m_csNode.request:setVisible(self.m_curSelectTab == FriendTabName.kZuiJin and self.m_curFriend and self.m_curFriend:hasRecvInvite())
	self.m_csNode.send_chat:setVisible(self.m_curFriend and (self.m_curSelectTab == FriendTabName.kZuiJin or self.m_curSelectTab == FriendTabName.kFriend))
end

function This:selectFriend(friend)
	if not friend then
		self.m_csNode.contentScrollView:removeAllItems()
		self.m_curFriend = nil
	else
		if self.m_curSelectTab == FriendTabName.kBlack then
			self.m_csNode.contentScrollView:removeAllItems()
			self.m_curFriend = nil
		elseif not self.m_curFriend or self.m_curFriend:getId() ~= friend:getId() then
			self.m_curFriend = friend
			FriendManager:readFriendChatMessage(friend:getId())
			if self.m_curView then
				self.m_curView:setIsSelected(false)
			end
			self.m_curView = self.m_friendViews[friend:getId()]
			self.m_curView:setIsSelected(true)
			self:refreshChat()
		end
	end
	self:refreshNodeVisible()
end

function This:addChatView(chat)
	local view = nil
	if chat:getChatType() == ChatType.kVoice then
		view = VoiceView:create(chat)
		view:setPlayHandler(function(playView)
			self.m_playView =playView 
		end)
	else
		view = ChatView:create(chat)
	end

	view:setAnchorPoint(0.5,0.5)
	local listWidth , listHeight = self.m_csNode.contentScrollView:getContentSize()
	if chat:getFromRole().id == GamePlayer:getPlayerID() then
		view:setRight(listWidth)
	end
	view:setTouch()
	local w , h = view:getContentSize()
	self.m_csNode.contentScrollView:pushBackCustomItem(view,w,h,0.5)
end

function This:refreshChat()
	if self.m_curFriend:isBlackFriend() then
		return
	end
	self.m_csNode.contentScrollView:removeAllItems()
	self.m_chatList = self.m_curFriend:getChatMessage()
	for i , chat in ipairs(self.m_chatList) do
		self:addChatView(chat)
	end
	self.m_csNode.contentScrollView:jumpToBottom()
end

function This:onAgreeBtnClicked()
	FriendManager:onRespondApplyRequest(self.m_curFriend:getId(),1)
end

function This:onDisagreeBtnClicked()
	FriendManager:onRespondApplyRequest(self.m_curFriend:getId(),2)
end

function This:onSendBtnClicked()
	if self.m_curFriend then
		local str = self.m_csNode.send_chat.editor.text:getString()
		FriendManager:onSendChatMessageRequest(self.m_curFriend:getId(), str)
		self.m_isRequesting = true
	end
end

---------------------------------------------------

function This:onAddChatMessage(chat)
	if self.m_curSelectTab == FriendTabName.kZuiJin then
		if not self.m_curFriend then
			self:refreshItems()
			self:selectFriend(self.m_friendList[1])
		elseif self.m_curFriend:getId() == chat:getFromRole().id or self.m_curFriend:getId() == chat:getToRole().id then
			self:addChatView(chat)
			self.m_csNode.contentScrollView:jumpToBottom()
			FriendManager:readFriendChatMessage(self.m_curFriend:getId())
		else
			self:refreshItems()
		end
		self:refreshNodeVisible()
	elseif self.m_curSelectTab == FriendTabName.kFriend then
		if not self.m_curFriend then
			self:refreshItems()
			self:selectFriend(self.m_friendList[1])
		elseif self.m_curFriend:getId() == chat:getFromRole().id or self.m_curFriend:getId() == chat:getToRole().id then
			self:addChatView(chat)
			self.m_csNode.contentScrollView:jumpToBottom()
			FriendManager:readFriendChatMessage(self.m_curFriend:getId())
		else
			self:refreshItems()
		end
	end
end

function This:onSendChat()
	if self.m_isRequesting then
		self.m_escape = kChatCDTime
		self:scheduleUpdate()
		self.m_csNode.send_chat.editor.text:setString("")
		self.m_isRequesting = false
	end
end

function This:onDeleteChatMessage(id)
	if self.m_curFriend and self.m_curFriend:getId() == id then
		self.m_curFriend = nil
		self:refreshItems()
		self:selectFriend(self.m_friendList[1])
	else
		self:refreshItems()
	end
end

function This:onFriendStateChanged()
	local itemList = self.m_csNode.playerScrollView:getItemList()
	for i , view in ipairs(itemList) do
		view:refresh()
	end
end

function This:onAddRecvReqeust(friend)
	if self.m_curFriend == friend then
		self:refreshNodeVisible()
	end
end

function This:onRemoveRecvRequest(friend)
	if self.m_curFriend == friend then
		self:refreshNodeVisible()
	end
end

function This:onAddFriend(friend)
	if self.m_curSelectTab == FriendTabName.kFriend then
		self:refreshItems()
		if not self.m_curFriend then
			self:selectFriend(self.m_friendList[1])
		end
	end
end

function This:onRemoveFriend(friend)
	if self.m_curSelectTab == FriendTabName.kFriend then
		if self.m_curFriend:getId() == friend:getId() then
			self.m_curFriend = nil
			self:refreshItems()
			self:selectFriend(self.m_friendList[1])
		else
			self:refreshItems()
		end
	end
end

function This:onAddBlackFriend(friend)
	self:refreshItems()
end

function This:onRemoveBlackFriend(friend)
	self:refreshItems()
end

function This:onFriendChanged()
	local itemList = self.m_csNode.playerScrollView:getItemList()
	for i , view in ipairs(itemList) do
		view:refresh()
	end	
end

This.onRefreshFriendUi = This.onAddFriend
--endregion
