--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"cc.Node")
local GameUtil = require("Util.GameUtil")
local FriendManager = require("Friend.FriendManager")
local RedDot = require("RedDot.RedDot")
local RedDotManager = require("RedDot.RedDotManager")

function This:init(friend,tabName)
	self.m_friend = friend
	self.m_tabName = tabName
	self.m_csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/FriendDetailListItem.csb")
	self:addChild(self.m_csNode)
	local w , h = self.m_csNode.bg:getContentSize()
	self:setContentSize(w,h)
	self:initInfo()
	self:setIsSelected(false)
	self:setCascadeOpacityEnabled(true)
end

function This:initInfo()
	self.m_csNode.name:setString(self.m_friend:getName())
	local icon = self.m_csNode.icon
	GameUtil:setPlayerIconNodeImage(icon, self.m_friend:getIcon())
	-- GameUtil:setPlayerTitleNodeTo(icon, self.m_friend:getTitle(), self.m_friend:getVipList())
	GameUtil:setPlayerEffectNodeTo(icon, self.m_friend:getEffect())
	GameUtil:setPlayerTitleWithImgNode(self.m_friend:getTitle(),self.m_csNode.chenghaobg,self.m_csNode.chenghao)

	self.m_csNode.listButton:setTouch({
		onEnded = function()
			self:showMenu()
		end,
		isDynamic = true,
	})
	self:refresh()
end

function This:getNodePath()
	local str = self:getName()
	local parent = self:getParent()
	while parent do
		str = parent:getName() .. "." .. str
		parent = parent:getParent()
	end
	return str
end

function This:initRedDot()
	local id = "friend_view_" .. self.m_friend:getId()
	local config = {
		id = id,
		node_path = self:getNodePath(),
		name = string.format(Serialize["friend_FriendView_1"],self.m_friend:getId()),
		node_events = {},
		events = {"friend_chat_changed"},
		check_func = {
			func = function()
				return FriendManager:haveFriendNoReadChatMessage(self.m_friend:getId()) or 
				FriendManager:haveRecvRequest(self.m_friend:getId())
			end
		},
		father = 0, -- 主界面好友红点ID
	}
	self.m_reddot = RedDotManager:addDynamicRedDot(config)
end

function This:onEnter()
	super.onEnter(self)
	self:initRedDot()
end

function This:onExit()
	super.onExit(self)
	RedDotManager:removeChild(self.m_reddot)
end

function This:refresh()
	if not self.m_friend:isFriend() and not self.m_friend:isBlackFriend() then
		self.m_csNode.relation:setString(Serialize["friend_AddFriend_2_c"])
		self.m_csNode.icon:setGrayShader()
		self.m_csNode.relation:setColor(255,255,255)
	elseif self.m_friend:isFriend() then
		if self.m_friend:isOnline() then
			self.m_csNode.relation:setString(Serialize["friend_FriendView_2"])
			self.m_csNode.relation:setColor(184,228,97)
			self.m_csNode.icon:resetToNormalShader()
		else
			self.m_csNode.relation:setString(Serialize["friend_FriendView_3"])
			self.m_csNode.icon:setGrayShader()
			self.m_csNode.relation:setColor(255,255,255)
		end
	else
		self.m_csNode.relation:setString(Serialize["friend_FriendView_4"])
		self.m_csNode.icon:setGrayShader()
		self.m_csNode.relation:setColor(255,255,255)
	end
	self:refreshRedDot()
end

function This:refreshRedDot()
	self.m_csNode.hongdian:setVisible(FriendManager:haveFriendNoReadChatMessage(self.m_friend:getId()) or 
		FriendManager:haveRecvRequest(self.m_friend:getId()))
end

function This:setIsSelected(isSelect)
	if isSelect then
		self.m_csNode.bg:setImage("MenuScene/diban3.png")
		self:refreshRedDot()
	else
		self.m_csNode.bg:setImage("MenuScene/diban4.png")
	end
end

function This:getModel()
	return self.m_friend
end

function This:showMenu()
	g_scene:openDialog("Friend.MenuView",{friend = self.m_friend,tabName = self.m_tabName})
end

function This:setSelectHandler(handler)
	self.m_csNode:setTouch({
		onEnded = function()
			if handler then
				handler(self.m_friend)
			end
		end,
		isContainer = true,
		isScale = false,
	})
end

--endregion
