--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"Dialog")

local FriendManager = require("Friend.FriendManager")
local ConfirmPanel = require("UI.ConfirmPanel")
local ChatManager = require("Chat.ChatManager")
local FamilyManager = require("Family.FamilyManager")

function This:initNode(info)
	self.m_friend = info.friend
	self.m_tabName = info.tabName
	self.m_csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/FriendListMore.csb")
	self:addChild(self.m_csNode)
	self.m_csNode:setToCenter()
	self.m_csNode.text1:setVisible(self.m_friend:isFriend())
	self.m_csNode.text4:setVisible(not self.m_friend:isFriend() and not self.m_friend:isBlackFriend())
	self.m_csNode.text5:setVisible(self.m_friend:isBlackFriend())

    self.m_isRequesting = false
    self.m_targetHadFamily = false
	self.m_escape = self.m_friend:getLeftInviteCD()
	if self.m_escape <= 0 then
		self:refreshSendBtn()
	end
end

function This:initTouchEvent()
	self.m_csNode.observe:setTouchEnded(function()
		g_scene:openDialog("Player.RoleInfoPanel",{id = self.m_friend:getId()})
	end)

	self.m_csNode.challenge:setTouchEnded(function()
		
	end)

	self.m_csNode.delete:setTouchEnded(function()
		if self.m_tabName == FriendTabName.kFriend then
			local panel = g_scene:openDialog("UI.ConfirmPanel")
			panel:setString(Serialize["friend_MenuView_1"])
			panel:setOkHandler(function()
				FriendManager:onDeleteFriendRequest(self.m_friend:getId())
			end)
		elseif self.m_tabName == FriendTabName.kBlack then
			FriendManager:onRemoveBlackFriendRequest(self.m_friend:getId())
		else
			FriendManager:onDeleteHistoryRequest(self.m_friend:getId())
		end
	end)
	self.m_csNode.invitation:setTouchEnded(function()
		if self.m_escape > 0 then
			g_scene:showTips(string.format(Serialize["family_InfoTab_6_c"], math.ceil(self.m_escape)))
			return			
		end

		if not self.m_friend:isFriend() then
			g_scene:showTips(Serialize["friend_MenuView_2"])
			return
		end

		if FamilyManager:hasFamily() then
			if not self.m_targetHadFamily then
				local id, name = FamilyManager:getMyFamilyId(), FamilyManager:getMyFamilyName()
				ChatManager:onApplyJoinGroupRequest(id,name,ChatChannelType.kPrivate,self.m_friend:getId())
				self.m_isRequesting = true
			else
				g_scene:handleErrorCode(12202)
			end
		else
			g_scene:showTips(Serialize["friend_MenuView_3"])
		end
	end)
end

function This:onTouchMask()
	self:close()
end

function This:onEnter()
	super.onEnter(self)
	FriendManager:addObserver(self)
	ChatManager:addObserver(self)
end

function This:onExit()
	ChatManager:removeObserver(self)
	FriendManager:removeObserver(self)
	super.onExit(self)
end

function This:onDeleteFriend()
	self:close()
end

function This:onDeleteChatMessage()
	self:close()
end

function This:onRemoveBlack()
	self:close()
end

function This:onInviteFamily(msg)
	if msg and msg.type == ChatType.kApplyGroup and self.m_isRequesting then
		self.m_isRequesting = false
		self.m_friend:recordLastInviteTime()
		self.m_escape = kChatCDTime
		self:close()
	end
end

function This:update(dt)
	super.update(self,dt)
	if self.m_escape > 0 then
		self.m_escape = self.m_escape - dt
		self:refreshSendBtn()
		if self.m_escape <= 0 then
			self:unscheduleUpdate()
		end
	end
end

function This:refreshSendBtn()
	if not self.m_friend:isFriend() or not FamilyManager:hasFamily() then
		self.m_csNode.invitation:setGrayShader()
	else
		if self.m_escape > 0 then
			self.m_csNode.invitation:setGrayShader()
			local str = string.format(Serialize["chat_ChatPanel_12_c"], math.ceil(self.m_escape))
			self.m_csNode.text6:setString(str)
		else
			self.m_csNode.invitation:clearShader()
			self.m_csNode.text6:setString(Serialize["friend_MenuView_4"])
		end
	end
end


--endregion
