--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"Dialog")
local FriendManager = require("Friend.FriendManager")
local GameUtil = require("Util.GameUtil")

function This:initNode()
	self.m_csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/FriendRecomm.csb")
	self:addChild(self.m_csNode)
	self.m_csNode:setToCenter()
end

function This:initTouchEvent()
	self.m_csNode.close:setTouchEnded(function()
		self:close()
	end)

	self.m_csNode.search:setTouchEnded(function()
		local str = self.m_csNode.editor:getString()
		FriendManager:onSearchPlayerRequest(str)
	end)
end

function This:onEnter()
	super.onEnter(self)
	FriendManager:addObserver(self)
end

function This:onExit()
	super.onExit(self)
	FriendManager:removeObserver(self)
end

function This:getFriendNode(friend)
	local node = cc.Node:createFromCSFile("MenuScene/NodeUI/FriendRecommListItem.csb")
	GameUtil:setPlayerIconNodeImage(node.icon, friend:getIcon())

	node.name:setString(friend:getName())
	node.relation:setString(friend:isFriend() and Serialize["friend_AddFriend_1_c"] or Serialize["friend_AddFriend_2_c"])
	node.add:setTouch({
		onEnded = function()
			if not friend:isFriend() then
				FriendManager:onApplyAddFriendRequest(friend:getId())
			else
				g_scene:showTips("alreadyIsFriend")
			end
		end,
		isContainer = true
	})
	return node
end

function This:refreshItems(friendList)
	self.m_csNode.scrollView:removeAllItems()
	for i , friend in ipairs(friendList) do
		local node = self:getFriendNode(friend)
		local w , h = node.bg:getContentSize()
		self.m_csNode.scrollView:pushBackCustomItem(node,w,h,0.5)
	end
	if #friendList <= 0 then
		g_scene:showTips(Serialize["friend_SearchPanel_1"])
	end
end

function This:onSearchPlayer(friendList)
	self:refreshItems(friendList)
end

--endregion
