

local This, super = class(..., "Dialog")
local GameUtil = require("Util.GameUtil")
local GamePlayer = require("Player.GamePlayer")
local HeroManager = require("Hero.HeroManager")

This.kTabPower = "tep2"
This.kTabFunction = "tep1"


function This:initData(info)
	self.m_initSelectTab = info and info.tab or self.kTabPower
end

function This:initNode(info)
    self.m_csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/ZuiQiangZhanLiPromote.csb")
    self:addChild(self.m_csNode)
    self.m_csNode:setToCenter()

    self.m_tabNodeParent = self.m_csNode.panNode

    local list = {self.kTabPower, self.kTabFunction}
    for i, name in ipairs(list) do
		self:addTabButton(name, self.m_csNode[name], function ( ... )
			return self:onTabButtonSelect(name)
		end)
	end
end

function This:initTouchEvent()
	if not self.m_inited then
		self.m_inited = true

		self.m_csNode.closebg:setTouchEnded(function()
        	self:close()
    	end)
		
	end
end

function This:onEnter()
    super.onEnter(self)
    self:selectTabButton(self.m_initSelectTab)
end

function This:onExit()
    super.onExit(self)
end

function This:onTabButtonSelect(name)
	self:openTabNode(name)
	return true
end

function This:createTabNode(name)
	if name == self.kTabPower then
		return require("Function.StrongestPowerView"):create()
	elseif name == self.kTabFunction then
		return require("Function.FunctionNoticeView"):create()
	end
end

function This:onTabNodeSwitchIn(node, name)
	local title = self.m_csNode.beijing.title

	if name == self.kTabPower then
		title:setString(Serialize[61100])
	elseif name == self.kTabFunction then
		title:setString(Serialize[61101])
	end
end