

local This, super = class(...,"Dialog")
local FunctionNoticeConfig = require("Metadatas.FunctionNoticeConfig")
local FunctionNoticeManager = require("Function.FunctionNoticeManager")


function This:initData(params)
	params = params or {}
	self.m_id = params.id or 1
end

function This:initNode(params)
    self.m_csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/FunctionNotice.csb")
    self:addChild(self.m_csNode)
    self.m_csNode:setToCenter()

    self:refresh()
end

function This:onTouchMask(touchListener,location)
	self:close()
end

function This:refresh()
	local config = FunctionNoticeConfig[self.m_id]
	local csNode = self.m_csNode
	local tips = FunctionNoticeManager:getOpenTips(self.m_id)

	csNode.tubiao:setImage(config.icon)
	csNode.name:setString(config.name)
	csNode.tips:setStringWithColor(string.format("<Q5>%s<A1>【%s】<Q5>，%s", tips, config.name, config.desc), 220)
end
