

local This , super = class(...,"NodeUI")
local UpdateLayer = require("UI.UpdateLayer")
local FunctionNoticeItemView = require("Function.FunctionNoticeItemView")
local FunctionNoticeManager = require("Function.FunctionNoticeManager")
local GameUtil = require("Util.GameUtil")
local GamePlayer = require("Player.GamePlayer")
local HeroManager = require("Hero.HeroManager")


function This:initData(info)

end

function This:initNode(info)
    self.m_csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/ZuiQiangZhanLiPromoteNotice.csb")
    self:addChild(self.m_csNode)

	local scrollView = self.m_csNode.scrollView1
	scrollView:setDirection("vertical")

    self.m_listLayer = UpdateLayer:create({
        itemWidth = 478,
        itemHeight = 105,
        spaceX =0,
        spaceY =5,
        scrollView = scrollView
    })

    self.m_listLayer:setCascadeOpacityEnabled(true)
    self.m_listLayer:setAnchorPoint(0.5, 0)
    local w, h = self.m_listLayer:getContentSize()
    scrollView:pushBackCustomItem(self.m_listLayer, w, h, 0)
end

function This:onEnter()
    super.onEnter(self)
    self:refresh()
    HeroManager:addObserver(self)
    FunctionNoticeManager:addObserver(self)
end

function This:onExit()
    HeroManager:removeObserver(self)
    FunctionNoticeManager:removeObserver(self)
    super.onExit(self)
end

function This:refresh()
    self:refreshRoleInfo()
    self:refreshList()
end

function This:refreshRoleInfo()
    local player = self.m_csNode.player
    local saintInfo = HeroManager:getSaintInfo()
    local power, cardList = saintInfo:getStrongestGroup()
    player.numberzhanli:setString(power)
    player.name:setString(GamePlayer:getRoleName())
    GameUtil:setPlayerFeltNodeResource(player.renwutu, GamePlayer:getIcon())    
end

function This:refreshList()
    local list = FunctionNoticeManager:getFunctionList()
    local createFunc = function (data, i)
        return FunctionNoticeItemView:create(data)
    end
    self.m_listLayer:setDataList(list, createFunc)    
end

function This:onSaintStrongPowerChange(oldvalue, strongPower)
    self:refreshRoleInfo()
end

function This:onSystemOpenRewardSuccess(data)
    self:refreshList()
end