

local This, super = class(...,"Dialog")
local FunctionNoticeConfig = require("Metadatas.FunctionNoticeConfig")
local FunctionNoticeManager = require("Function.FunctionNoticeManager")


function This:initData(params)
	params = params or {}
	self.m_id = params.id or 1
end

function This:initNode(params)
    local csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/FunctionTurnOn.csb")
    self:addChild(csNode)
    self.m_csNode = csNode

    csNode:setToCenter()

    self.m_finger = cc.Node:createFromCSFile("Common/NodeUI/Finger.csb")
    self.m_finger:setPosition( csNode.button:getPosition() )
    csNode:addChild(self.m_finger)

    self:refresh()
end

function This:onEnter()
    super.onEnter(self)
    self.m_finger:playCSAnimation()
end

function This:initTouchEvent()
	if not self.m_inited then
        self.m_inited = true

        self.m_csNode.button:setTouchEnded(function()
        	local id = self.m_id
        	self:close()
            FunctionNoticeManager:gotoFunction(id)
        end)
    end
end

function This:refresh()
	local config = FunctionNoticeConfig[self.m_id]
	local csNode = self.m_csNode
	local tips = FunctionNoticeManager:getOpenTips(self.m_id)

	csNode.tubiao:setImage(config.icon)
	csNode.tips:setStringWithColor(string.format(Serialize[61112], config.name), 220)
end
