

local This, super = class(...,"Dialog")
local ItemNode = require("UI.ItemNode")



function This:initData(params)
	params = params or {}
	self.m_title 		= params.title or ""
	self.m_state 		= params.state or 0 -- 0不可领取，1可领取
	self.m_text 		= params.text or ""
	self.m_reward 		= params.reward or {} --{{id,num}, {id,num} ...}
	self.m_onBtnClick 	= params.onBtnClick
end

function This:initNode(info)
    local csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/MatchingLevelBox.csb")
    self:addChild(csNode)
    csNode:setToCenter()
    self.m_csNode = csNode

	csNode.left:setVisible(false)
	csNode.right:setVisible(false)
	csNode.title:setString(self.m_title)
	csNode.condition:setString(self.m_text)
	csNode.condition:setVisible(self.m_state == 0)
	csNode.button:setVisible(self.m_state == 1)

    self:refresh()
end

function This:initTouchEvent()
	local csNode = self.m_csNode
	
    csNode.close:setTouchEnded(function()
        self:close()
    end)

    csNode.button:setTouchEnded(function()
    	if self.m_state == 1 then
    		if type(self.m_onBtnClick) == "function" then
    			self.m_onBtnClick()
    		end 
    		self:close()
    	end
    end)
end

function This:refresh()
	local scrollView = self.m_csNode.scrollView
	scrollView:removeAllChildren()
	scrollView.m_direction = "right"

	for i , info in ipairs(self.m_reward) do
		local item = ItemNode:create(info[1], info[2])
		item:setAnchorPoint(0.5,0.5)
		local w , h = item:getContentSize()
		scrollView:pushBackCustomItem(item, w, h ,0.5)
	end
end
