
local This , super = class(...,"NodeUI")
local GameUtil = require("Util.GameUtil")
local EquipManager = require("Equip.EquipManager")
local GamePlayer = require("Player.GamePlayer")
local HeroManager = require("Hero.HeroManager")
local ArenaHeroView = require("Arena.ArenaHeroView")


function This:initData(data)
    self.m_data = data
end

function This:initNode(data)
    local csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/ZuiQiangZhanLiPromoteHeroItem.csb")
    self:addChild(csNode)
    self.m_csNode = csNode

    local w, h = csNode.bg:getContentSize()
    self:setContentSize(w, h)
    csNode:setPosition(w/2, h/2) 

    csNode.button.shengji:setString(Serialize[61115])

    self:setCascadeOpacityEnabled(true)
end

function This:initTouchEvent()
    if not self.m_inited then
        self.m_inited = true

        self.m_csNode.button:setTouch({
            isDynamic = true, 
            isContainer  = true,
            onEnded = function ()
                if type(self.m_onBtnClick) == "function" then
                    self.m_onBtnClick(self.m_data)
                end
            end,
        })
    end
end

function This:onEnter()
    super.onEnter(self)
    self:refresh()
end

function This:setModel(data)
    self.m_data = data
    self:refresh()
end

function This:refresh()
    local data = self.m_data
    local csNode = self.m_csNode

    csNode.tubiao:setImage(data.icon)
    csNode.name:setString(data.name)
    csNode.jindu:setPercent(data.progress)
    csNode.progress:setString( string.format("%.2f%%", data.progress) )
end

function This:setBtnClick(func)
    self.m_onBtnClick = func
end

