
local This = class(...)

DaYanStartGroupIndex = 65
-- 渠道ID
ChannelMainId = {
	kChuangYu = 1001, --创娱
	k51Gamer = 1002, --51gamer
	kMuZhi = 1003, --拇指
	kDaYan = 1004, --大雁
}

-- 游戏ID
ChannelGameId = {
	kZhenLong = 1, --真龙天子
	kBaiLong = 2, --百龙争霸
	kReXue = 3, --热血王座
}

-- PFID
ChannelPFId = {
	kMuZhiIos = 38,
	kMuZhiIos1 = 39, --自己的
	kMuZhiIos2 = 40, 	
}

-- 渠道格式化ID
ChannelFormatId = {
	kMuZhiIos = string.format("%s-%s-%s", ChannelMainId.kMuZhi, ChannelGameId.kBaiLong, ChannelPFId.kMuZhiIos),
	kMuZhiIos1 = string.format("%s-%s-%s", ChannelMainId.kMuZhi, ChannelGameId.kBaiLong, ChannelPFId.kMuZhiIos1),
	kMuZhiIos2 = string.format("%s-%s-%s", ChannelMainId.kMuZhi, ChannelGameId.kBaiLong, ChannelPFId.kMuZhiIos2),	
}


function This:init()
	local ServerConfig = require("Net.ServerConfig")

	self.m_mainId = ServerConfig.channelId
	self.m_gameId = ServerConfig.gameId
	self.m_pfId = "0"

	if not os.isWin32 and not os.isIosSimulator then
		self.m_mainId = os.native_call("getChannelId")
		self.m_gameId = os.native_call("getGameId")
		self.m_pfId = os.native_call("getPfId")
	end

	if self.m_pfId and self.m_pfId ~= "0" then
		self.m_formatId = string.format("%s-%s-%s", self.m_mainId, self.m_gameId, self.m_pfId)
	else
		self.m_formatId = string.format("%s-%s", self.m_mainId, self.m_gameId)
	end
end

function This:getFormatId()
	return self.m_formatId
end

function This:checkFormatId(formatId)
	return self.m_formatId == formatId
end

function This:checkMainId(mainId)
	return tonumber(self.m_mainId) == mainId
end

function This:checkGameId(gameId)
	return tonumber(self.m_gameId) == gameId
end

function This:checkPfId(pfId)
	return tonumber(self.m_pfId) == pfId
end

