local This = class(...)
local isDirty = false
local obj = {
    isOpenMusic = g_setting.isOpenMusic,
    isOpenSound = g_setting.isOpenSound,
}
setmetatable(obj, This)

local function setDirty()
    isDirty = true
    cc.Application:addToUpdateList(This)
end

function This:update(delta)
    cc.Application:removeFromUpdateList(This)
    obj:save()
end

function This:load()
    local setting = cc.FileUtils:loadLuaFile("GameSetting")
    if setting then
        table.copy(self, setting)
    end
end

function This:save()
    if isDirty then
        cc.FileUtils:saveToLua(self, "GameSetting")
        isDirty = false
    end
end

function This:set(k, v)
    if self[k] ~= v then
        self[k] = v
        setDirty()
    end
end

function This:get(k)
	return self[k]
end

function This:setPet(k, v)
    if self.pet[k] ~= v then
        self.pet[k] = v
        setDirty()
    end
end

obj:load()
return obj