-- @Author: Su
-- @Date:   2019-12-27 11:42:41
-- @Last Modified by:   zheng
-- @Last Modified time: 2020-04-16 14:52:11
-- @File Name: AnimalsExchangeItem.lua

local This , super = class(..., "NodeView")
local ItemUtil = require("Bag.ItemUtil")
local ItemNode = require("UI.ItemNode")
local GameUtil = require("Util.GameUtil")
This.fileName = "MenuScene/NodeUI/QualifyingShopItem.csb"

function This:initData(info)
    self.m_inited = false
    self.m_itemId = info.slot
    self.m_isRed =  info.red
    local w , h = self.bg:getContentSize()
    self:setContentSize(w,h)
end

function This:onEnter()
    super.onEnter(self)
end

function This:onExit()
    super.onExit(self)
end


function This:initNode()
    self:refreshItemUI()
end

function This:refreshItemUI()
    local node = self.unlock.item.node
    local itemId = self.m_itemId
    if not node then
        node = ItemNode:create(itemId)
        node:setAnchorPoint(0.5, 0.5)
        self.unlock.item:addChild(node)
        self.unlock.item.node = node
    else
        node:init(itemId)
    end
    GameUtil:refreshItemInfo(itemId,nil,self.name)
    self.unlock.num:setVisible(false)
    self.unlock.yuanbao:setVisible(false)
    self.unlock.price:setVisible(false)
    self.unlock.purchased:setVisible(false)
    self.unlock.buybutton.text:setString(Serialize[61124])
end

function This:initTouchEvent()
    self.unlock.buybutton:setTouch({
        onEnded = function()
            g_scene:openDialog("GodBeast.AnimalsExchangePanel",{id = self.m_itemId,red= self.m_isRed})
        end,
        isContainer = true,
    })    
end