-- @Author: Su
-- @Date:   2019-12-27 11:42:41
-- @Last Modified by:   zheng
-- @Last Modified time: 2020-04-16 12:58:27
-- @File Name: AnimalsTurnTableExchangeNode.lua

local This , super = class(...,"NodeUI")
local NewActivityManager = require("NewActivity.NewActivityManager")
local GodBeastManager = require("GodBeast.GodBeastManager")
local ItemUtil = require("Bag.ItemUtil")
local ArgConfig = require("Metadatas.ArgConfig")
local DepotManager = require("Depot.DepotManager")
local AnimalsExchangeItem = require("GodBeast.AnimalsExchangeItem")

function This:initNode(info)
	self.m_csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/AnimalsTurnTableExchange.csb")
    self:addChild(self.m_csNode)
    self.m_csNode:setToCenter()

    self.m_activity = NewActivityManager:getActivity(NewActivityType.kAnimalTable)
    self.m_itemId = self.m_activity:getLuckBestReward() + 1000
    self.m_tabIndex = info.tab

    self:refreshItem()
    self:refresh()
end

function This:onEnter()
    super.onEnter(self)
    if not self.m_activity then
        self.m_activity = NewActivityManager:getActivity(NewActivityType.kAnimalTable)
    end
	self.m_activity:addObserver(self)
end

function This:onExit()
	super.onExit(self)
	self.m_activity:removeObserver(self)
end


function This:refresh()
    self.m_csNode.textname:setString(ItemUtil.getName(self.m_itemId))
    self.m_csNode.text1:setString(DepotManager:getItemCount(self.m_itemId))
end

function This:refreshItem()
    local scrollView = self.m_csNode.scrollView
    local itemList = ArgConfig.animals_exchange_list.arg
    for _,id in pairs(itemList) do
        if id ~= self.m_itemId then
            local item = AnimalsExchangeItem:create({slot = id})
            local w,h = item:getContentSize()
            scrollView:pushNode(item,w,h,2)
        end

    end
end

function This:initTouchEvent()
	self.m_csNode.help:setTouchEnded(function()
		g_scene:openDialog("UI.HelpTips",{text = Serialize[61133],node = self.m_csNode.help})
    end)
    
end

function This:getTabIndex()
    return self.m_tabIndex
end

function This:getIsAnimation()
    return false
end

function This:onExchangeAnimal()
    self:refresh()
end