-- @Author: zheng
-- @Date:   2019-05-09 15:46:27
-- @Last Modified by:   zheng
-- @Last Modified time: 2019-07-26 16:02:31
-- @File Name: GameBeastStar.lua

local This = class(...)
local MythicalAnimalsStarConfig = require("Metadatas.MythicalAnimalsStarConfig")
local SkillConfig = require("Metadatas.SkillConfig")
local DepotManager = require("Depot.DepotManager")
local GodBeastManager = require("GodBeast.GodBeastManager")

function This:create(...)
    local chapter = setmetatable({},self)
    chapter:init(...)
    return chapter
end

function This:init(id)
    self.m_id = id
    -- self.m_stages = {}
    self.m_config = MythicalAnimalsStarConfig[id]
    -- self.m_totalStar = 0
    -- self.m_starReward = {false,false,false}
    -- self.m_maxStar = 0
    -- self.m_preChapter = nil
    -- self.m_nexChapter = nil
    -- self:initVisitInfo()
end

function This:getBeastType()--神兽类型
    return self.m_config.type
end

function This:getStar()--星级
    return self.m_config.star
end

function This:getAttrParameter()--星级比值
    return self.m_config.attribute
end

function This:getSkillId()--星级技能ID
    return self.m_config.skill_id
end

function This:getSkillIcon()
    local iconId = self.m_config.skill_icon or 1
    local icon = string.format("Icons/Skill/%s.png", iconId)
    return icon
end

function This:getUpNeed()--升星消耗
    return self.m_config.star_up_cost
end

function This:getNeedLv()--初始怒气值
    return self.m_config.need_level
end

function This:getDesc()--特性
    return self.m_config.characteristic
end
--获取技能描述
function This:getSkillDes()
    local skillId = self:getSkillId()
    local skill = SkillConfig[skillId]
    if skill then
        return skill.name,skill.desp
    end
    return "",""
end

function This:isCanUp()
    return DepotManager:getItemOrResEnought(self:getUpNeed()) and GodBeastManager:getBeast(self:getBeastType()):getLv() >= self.m_config.need_level
end

function This:getCustomDesc()--特性
    return self.m_config.characteristic
end

function This:getCustomDesc1()--激活后的特性
    return self.m_config.characteristic1
end
