-- @Author: zheng
-- @Date:   2019-05-09 15:05:41
-- @Last Modified by:   zheng
-- @Last Modified time: 2019-08-30 17:20:22
-- @File Name: MythicalAnimalsAddPanel.lua

local This , super = class(...,"Dialog")
local GameUtil = require("Util.GameUtil")
This.fileName = "MenuScene/NodeUI/MythicalAnimalsAdd.csb"

local GodBeastManager = require("GodBeast.GodBeastManager")
function This:initNode(info)
    self.m_csNode = cc.Node:createFromCSFile(This.fileName)
    self.m_csNode:setToCenter()
    self:addChild(self.m_csNode)
    self:refresh()
end

function This:refresh()
--    local beastId = self.m_beastId
--    local data = GodBeastManager:getBeast(beastId)
--    if data then
        local allBeast = GodBeastManager:getUpBestList()
        local beastCount = 0
        for _,beastId in pairs(allBeast) do
            if beastId and beastId>0 then
                beastCount = beastCount +1
            end
        end
        local csNode = self.m_csNode
        local have = csNode.have
        if beastCount>0 then
            local scrollView = have.scrollView
            scrollView:removeAllItems()
            local attts = GodBeastManager:getCurentAtrr()
            for id,value in pairs(attts) do
                local name,attrrValue = GameUtil:getAttrStr( id,value,true )
                local str = name..attrrValue
                local info ={des= str}
                local item = self:createItemView(info)
                local w , h = item:getContentSize()
                scrollView:pushBackCustomItem(item,w,h,0.5)
            end
        end
        have:setVisible(beastCount>0)
--    end
end

function This:createItemView(info)
    local node = cc.Node:createFromCSFile("MenuScene/NodeUI/MythicalAnimalsAddItem.csb")
    local bg = node.bg
    local des = info.des
    node.value:setString(des)
    local x,y = bg:getContentSize()
    node:setContentSize(x, y)
    return node 
end

function This:onTouchMask() -- 对话框之外区域的点击事件
    self:close()
end