
local This , super = class(...,"NodeUI")
local GodBeastManager = require("GodBeast.GodBeastManager")


function This:initData(data, index)
    self.m_data = data
    self.m_index = index
    self.m_skeName = ""
    self.m_skeNode = nil
end

function This:initNode(data)
    local csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/MythicalAnimalsBookItem.csb")
    self:addChild(csNode)
    self.m_csNode = csNode

    local w, h = self.m_csNode.bg:getContentSize()
    self:setContentSize(w, h)

    self:setTimer(0.01 * self.m_index, function ( ... )
        self:refresh()
    end)
end

function This:initTouchEvent()
  
end

function This:onEnter()
    super.onEnter(self)
    -- self:refresh()
end

function This:setModel(data)
    self.m_data = data
    self:refresh()
end

function This:getModel()
    return self.m_data
end

function This:refresh()
    local data = self.m_data
    local csNode = self.m_csNode
    local config = data.config

    csNode.name:setImage( string.format("Icons/Animals/%s.png", config.name_picture ) )

    local skeName = config.path

    if self.m_skeName ~= skeName then
        self.m_skeName = skeName

        if self.m_skeNode then
            self.m_skeNode:removeFromParent(true)
            self.m_skeNode = nil
        end

        local offset = config.book_offset
        self.m_skeNode = self:createSkeNode(skeName)
        self.m_skeNode:setPosition(offset[1], offset[2])
        csNode.animals:addChild(self.m_skeNode)
    end

    if data.isHave then
        self.m_skeNode:setColor(255, 255, 255)
    else
        self.m_skeNode:setColor(150, 150, 150)
    end      
end

function This:createSkeNode(name)
    local skeNode = cc.SkeletonNode:createCharacter(name)
    skeNode:scheduleUpdate()
    skeNode:playAnimation("animation2", true)
    skeNode:setCascadeOpacityEnabled(true)
    return skeNode
end

function This:setClick(func)
    self.m_clickCb = func
end

function This:onClick()
    if type(self.m_clickCb) == "function" then
        self.m_clickCb(self)
    end
end

function This:setSelect(isSelect)

end