


local This , super = class(...,"Dialog")
local MythicalAnimalsAttributeConfig = require("Metadatas.MythicalAnimalsAttributeConfig")
local GodBeastManager = require("GodBeast.GodBeastManager")
local MythicalAnimalsBookItemView = require("GodBeast.MythicalAnimalsBookItemView")
local ListVirtualLayer = require("UI.ListVirtualLayer")
local MythicalAnimalsBookListView = require("GodBeast.MythicalAnimalsBookListView")

function This:initData(info)
	local list = {}
	local have = {}

	for _, id in ipairs(GodBeastManager.m_allHaveChaptersId) do
		have[id] = true
	end

	for _, v in pairs(MythicalAnimalsAttributeConfig) do
        if v.exhibition == 1 then
    		local t = {}
    		t.id = v.id
    		t.config = v
    		t.isHave = (have[v.id] and true) or false
    		table.insert(list, t)
        end
	end

	table.sort(list, function (a, b)
		return a.id < b.id
	end)

	self.m_list = list
end

function This:initNode(info)
    local csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/MythicalAnimalsBook.csb")
    self:addChild(csNode)
    csNode:setToCenter()
    self.m_csNode = csNode

    self.m_container = MythicalAnimalsBookListView:create({
        width = 840,
        height = 490,
        space = 0,
        maxScale = 1.0,
        minScale = 0.75,
        initSpeed = 600,
    })
    self.m_container:setAnchorPoint(0.5, 0.5)
    self.m_container:setPosition( csNode.center:getPosition() )
    csNode:addChild(self.m_container)

    for idx, data in ipairs(self.m_list) do
        local node = MythicalAnimalsBookItemView:create(data, idx)
        node:setClick(function (item)
            local model = item:getModel()
            g_scene:openDialog("GodBeast.MythicalAnimalsDetailsPanel", {id = model.id, list = self.m_list})
        end)
        self.m_container:addItemNode(node)
    end
    self.m_container:setItemToCenter(1)

end

function This:initTouchEvent()
    if not self.m_inited then
        self.m_inited = true
        local csNode = self.m_csNode

        csNode.close:setTouchEnded(function()
        	self:close()
    	end)

        csNode.jiantou1:setTouchEnded(function ()
            self.m_container:setPreItemToCenter()
        end)

        csNode.jiantou2:setTouchEnded(function ()
            self.m_container:setNexItemToCenter()
        end)        
    end 
end

function This:refresh()

end