


local This, super = class(..., "Dialog")
local GameUtil = require("Util.GameUtil")
local GodBeastManager = require("GodBeast.GodBeastManager")
local MythicalAnimalsAttributeConfig = require("Metadatas.MythicalAnimalsAttributeConfig")


function This:initData(info)
	self.m_id = info.id
	self.m_isGot = info.isGot
	self.m_skeAnimal = nil
	self.m_closeEnabled = false
	self.m_effects = {}
end

function This:initNode(info)
    local csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/MythicalAnimalsGet.csb")
    self:addChild(csNode)
    csNode:setToCenter()
    self.m_csNode = csNode

	cc.Audio:playEffect("Animalsget.mp3")
    local config = MythicalAnimalsAttributeConfig[self.m_id]
    csNode.titlebg:setVisible(false)
    csNode.name:setVisible(false)
    csNode.name:setImage( string.format("Icons/Animals/%s.png", config.name_picture ) )

	local skeNode = cc.SkeletonNode:createCharacter(config.path)
	skeNode:scheduleUpdate()
	skeNode:playAnimation("animation2", true)
	skeNode:setScale(0.75)
	skeNode:setCascadeOpacityEnabled(true)
	skeNode:setVisible(false)
	csNode.animal:addChild(skeNode)
	self.m_skeAnimal = skeNode

	if self.m_isGot then
		local label = cc.Label:createNormalTTF(Serialize[61143], 16)
		label:setColor(184,228,97,255)
		--label:setPosition(0, 20)
		skeNode:addChild(label)
	end

	self.m_co = coroutine.create(function ()
		local eff = cc.SkeletonNode:createEffect("SS_HuoDe")
		eff:scheduleUpdate()
		eff:playAnimation("animation",false)
		eff:setAnimationListener({
			onAnimationEvent = function (_, animationName, eventName)
				if eventName == "Fire1" then
					coroutine.resume(self.m_co)
				end
			end
		})
		csNode.effect:addChild(eff)
		table.insert(self.m_effects, eff)

		coroutine.yield()
		self:finish()
	end)
	coroutine.resume(self.m_co)
	
end

function This:finish()
	self.m_co = nil
	self.m_csNode.titlebg:setVisible(true)
	self.m_csNode.name:setVisible(true)
	self.m_skeAnimal:setVisible(true)
	self:setTimer(0.3, function ()
		self.m_closeEnabled = true
	end)
end

function This:refresh()

end

function This:initTouchEvent()
    if not self.m_inited then
    	self.m_inited = true

        local csNode = self.m_csNode

        csNode.bg:setTouch({
            isScale = false,
            isAlpha = false,
            onEnded = function ()
            	if self.m_co then
            		for i, eff in ipairs(self.m_effects) do
            			eff:removeFromParent(true)
            		end
            		self.m_effects = {}
            		self:finish()
            		return
            	end

            	if self.m_closeEnabled then
            		self:close()
            	end
            end,
        })
    end
end

function This:onEnter()
    super.onEnter(self)
end

function This:onExit()
    super.onExit(self)
end
