-- @Author: zheng
-- @Date:   2019-05-09 11:02:05
-- @Last Modified by:   zheng
-- @Last Modified time: 2019-10-28 10:17:10
-- @File Name: MythicalAnimalsItemInfoPanel.lua


local This , super = class(...,"Dialog")
local GodBeastManager = require("GodBeast.GodBeastManager")
This.fileName = "MenuScene/NodeUI/MythicalAnimalsItemInfo.csb"
-- local ItemNode = require("UI.ItemNode")
 local GameUtil = require("Util.GameUtil")
 local ItemUtil = require("Bag.ItemUtil")
function This:initNode(info)
  --父类，MythicalAnimalsMeInfoPane 用到了

    if info then
       self.m_selectPos = info.selectPos
    else
      self.m_selectPos = 1
    end
    -- self.m_selectPos = 1
    self.m_csNode = cc.Node:createFromCSFile(self.fileName)
    self.m_csNode:setToCenter()
    self:addChild(self.m_csNode)
    self:refresh(self.m_selectPos)
end

function This:refreshCommon(data)
    local function checkBool(index)
        local res = false
        if index then
            res = true
        end
        return res
    end
   local csNode = self.m_csNode
   local left = self:getLeft()
   local right = self:getRight()
   csNode.jiantou1:setVisible(checkBool(left))
   csNode.jiantou2:setVisible(checkBool(right))

   local starCount = data:getStarLv()
   for index=1,5 do
       local star = csNode["star"..index]
       star.light:setVisible(index<=starCount)
   end

   local name = data:getName()
   csNode.name:setString(name)
   csNode.name:setColorByID("Q".. ItemUtil.getQuality(data:getId()))
   -- csNode.title1:setString(name)
   GodBeastManager:createEffectCharacter(csNode.animal,data:getId())
end

function This:refresh(pos)
    local temPos = pos or self.m_selectPos
    local data = GodBeastManager:getBeastPos(temPos)
   if data then
       self:refreshCommon(data)
       local csNode = self.m_csNode
       local attrStr =data:getAttrStr()
       local lv = data:getLv()
       local listView = csNode.ListView
       local shuxing = listView.shuxing
       
       for index=1,10 do
          local txt = shuxing["text"..index]
          if txt then
              local str = attrStr[index]
              txt:setStringWithColor(str)
              txt:setVisible(str)
          end
       end
       shuxing.level:setString(string.format("Lv.%d",lv))
       local star = data:getStar()
       local skillName,skillDes = star:getSkillDes()
       local jineng = listView.jineng
       jineng.skill_icon:setImage(star:getSkillIcon())
       jineng.skillname:setString(skillName)
      -- GameUtil:creatItemNode(jineng.item,{star:getSkillId()})

       jineng.skill:setStringWithColor(skillDes,220)
       -- local itemNode = ItemNode:create(skill:getId())
       -- itemNode:setAnchorPoint(0.5,0.5)
       -- itemNode:setScale(0.7)
       listView.texing.text:setStringWithColor(data:getCustomDescs(),310)
       listView.jianjie.text:setString(data:getDesc(),500)
       
       GameUtil:refreshRedDot(shuxing.button1,data:isCanUpLv())
       GameUtil:refreshRedDot(shuxing.button2,data:isCanUpStar())

   end

end

function This:initTouchEvent()
	
	local csNode = self.m_csNode
    csNode.close:setTouchEnded(function()
        self:close()
    end)
    csNode.jiantou1:setTouchEnded(function()
        --left
        local pos = self:getLeft()
        if pos then
            self.m_selectPos = pos
            self:refresh(pos)
        end
    end)
    csNode.jiantou2:setTouchEnded(function()
        --right 
        local pos = self:getRight()
        if pos then
            self.m_selectPos = pos
            self:refresh(pos)
        end
    end)
    if csNode.button1 then
        local function getBeastId()
            local data = GodBeastManager:getBeastPos(self.m_selectPos)
            return data:getId()
        end
        csNode.button1:setTouchEnded(function()--更换
             g_scene:openDialog("GodBeast.MythicalAnimalsReplacePanel",{selectPos =self.m_selectPos})
             -- self:close()
        end)
        csNode.button2:setTouchEnded(function()--卸下
            --  g_scene:openDialog("GodBeast.MythicalAnimalsReplacePanel")
            GodBeastManager:onGetModifyBeastRequest(0,self.m_selectPos)
            self:close()
        end)
        local shuxing = csNode.ListView.shuxing
        --升 级
        shuxing.button1:setTouch({
            isScale = false, 
            isDynamic = true, 
            onEnded = function()
              g_scene:openDialog("GodBeast.MythicalAnimalsMeInfoPane",{tabType = GodBeastManagerTabType.kLv,beastId =getBeastId()})
            end
        })
        --升 星
        shuxing.button2:setTouch({
            isScale = false, 
            isDynamic = true, 
            onEnded = function()
             g_scene:openDialog("GodBeast.MythicalAnimalsMeInfoPane",{tabType = GodBeastManagerTabType.kStar,beastId =getBeastId()})
              
            end
        })
        --查看详情
        csNode.ListView.jineng.info:setTouch({
            isScale = false, 
            isDynamic = true, 
            isContainer  = true,
            onEnded = function()
              g_scene:openDialog("GodBeast.MythicalAnimalsSkillPanel",{beastId =getBeastId()})
            end
        })
    end


end

function This:onEnter()
    super.onEnter(self)
    GodBeastManager:addObserver(self)
end

function This:onExit()
    super.onExit(self)
    GodBeastManager:removeObserver(self)
end

function This:getRight()
    local result =false
    local max = GodBeastManager:getMaxPos()
    for pos=(self.m_selectPos+1),max do
        if GodBeastManager:getBeastPos(pos) then
           return pos 
        end
    end
    return result
end

function This:getLeft()
    local result =false
    for pos = (self.m_selectPos-1) , 1 , -1 do
        if GodBeastManager:getBeastPos(pos) then
           return pos 
        end
    end
    return result
end

function This:checkRefresh(beastId)
    local temPos = self.m_selectPos
    -- local data = GodBeastManager:getBeastPos(temPos)
    local _have, pos = GodBeastManager:isHavePos(beastId)
    if beastId and temPos and pos then
        self:refresh()
    end
end

function This:onGetUpdateBeast(beastId)
    self:checkRefresh(beastId)
end

function This:onGetModifyBeast(beastId)
    self:checkRefresh(beastId)
end
