-- @Author: Su
-- @Date:   2019-05-10 16:13:21
-- @Last Modified by:   zheng
-- @Last Modified time: 2019-10-25 18:42:30
-- @File Name: MythicalAnimalsItemView.lua

local This , super = class(..., "NodeView")
local GodBeastManager = require("GodBeast.GodBeastManager")
local GamePlayer = require("Player.GamePlayer")
local GameUtil = require("Util.GameUtil")
function This:initData(info)
    self.m_beast = info.animal
    self.m_pos = info.pos
    self.m_csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/MythicalAnimalsItem.csb")
    self:addChild(self.m_csNode)
    -- self.m_csNode:setToCenter()
    self:refresh()
end

function This:initNode(info)
end

function This:onEnter()
	super.onEnter(self)
	GodBeastManager:addObserver(self)
end

function This:onExit()
	super.onExit(self)
	GodBeastManager:removeObserver(self)
end

function This:refresh()
    local data  = self.m_beast
    local csNode = self.m_csNode
    local have = csNode.have
    local suo = csNode.suo
    
    -- csNode.animals:setVisible(self.m_beast)
    -- csNode.bg2:setVisible(self.m_beast)
    -- csNode.lv:setVisible(self.m_beast)
    -- csNode.name:setVisible(self.m_beast)
    -- csNode.titlebg:setVisible(self.m_beast)
    -- csNode.weishu:setVisible(self.m_beast)
    have:setVisible(data)
    suo:setVisible(not data)
    if data then
        for i=1,5 do
            have["star"..i]:setVisible(self.m_beast)
        end
        local starLv = data:getStarLv()
        have.lv:setString(string.format( Serialize[60312],data:getLv()))
        have.name:setImage(data:getNamePic())
        for i = 1,5 do
            have["star"..i].light:setVisible(starLv >= i)
        end
        have.weishu:setString(self.m_pos)
        GodBeastManager:createEffectCharacter(have.animals,data:getId())
        GameUtil:refreshRedDot(have.lvbg,data:isCanUpLv())
        GameUtil:refreshRedDot(have.bg2,data:isCanUpStar())
    else
        local lockLv = GodBeastManager:getPosLevelLimit(self.m_pos)
        local isLocked = not self:getIsLocked()
        suo.suolian:setVisible(isLocked)
        suo.text:setVisible(isLocked)

        suo.text:setString(string.format(Serialize[60304],lockLv))
        suo.text2:setVisible(not isLocked)
    end

end

function This:initTouchEvent()
    local csNode = self.m_csNode
    csNode.bg:setTouch({
        isScale = false, 
        isDynamic = true, 
        -- isContainer  = true,    
        onEnded = function()
        if not self:getIsLocked() then
            local nobilityLevel = GodBeastManager:getPosLevelLimit(self.m_pos)
            g_scene:showTips(string.format(Serialize["achieve_MainPanel_1_c"],nobilityLevel))
            return
        end
        if self.m_beast then
            -- g_scene:openDialog("GodBeast.MythicalAnimalsItemInfoPanel",{selectPos =1})
            -- g_scene:showTips(Serialize[61146])
            g_scene:openDialog("GodBeast.MythicalAnimalsItemInfoPanel",{selectPos =self.m_pos})
            -- g_scene:openDialog("GodBeast.MythicalAnimalsMeInfoPane",{tabType = GodBeastManagerTabType.kLv,beastId =self.m_beast:getId()})
        else
            g_scene:openDialog("GodBeast.MythicalAnimalsReplacePanel",{selectPos =self.m_pos})

        end
    end})

end

function This:getSize()
    local w, h = self.m_csNode.bg1:getContentSize()
    return w,h
end

function This:getIsLocked()--是否解锁
    return GamePlayer:getLevel() >= GodBeastManager:getPosLevelLimit(self.m_pos)
end

function This:onGetUpdateBeast(beastId)
    local animal = GodBeastManager:getBeastPos(self.m_pos)
    self.m_beast = animal
    self:refresh()
end

function This:onGetUpLv()
    self:refresh()
end

function This:onGetModifyBeast()
    local animal = GodBeastManager:getBeastPos(self.m_pos)
    self.m_beast = animal
    self:refresh()
end

function This:onGetInfor()
    self:onGetModifyBeast()
end
