-- @Author: zheng
-- @Date:   2019-05-10 17:40:25
-- @Last Modified by:   zheng
-- @Last Modified time: 2019-08-30 17:20:51
-- @File Name: MythicalAnimalsMeInfoLvTab.lua
 local GameUtil = require("Util.GameUtil")

local This , super = class(...,"NodeUI")
local GodBeastManager = require("GodBeast.GodBeastManager")
local DepotManager = require("Depot.DepotManager")
This.fileName = "MenuScene/NodeUI/MythicalAnimalsMeInfoLv.csb"
local GamePlayer = require("Player.GamePlayer")
function This:initNode(info)
    -- self.m_needScroolView = self.cailiao.shengxing.scrollView2
    -- self:getData()
    self:setToCenter()
    self:refresh(info.beastData)
end

function This:refresh(info,attrEffect)
    if info then
        self.m_beastData = info
    end
    local data =info or self.m_beastData
    local curentLv =data:getLv()
    local maxLv = GodBeastManager:getMaxLv(data:getLv(),true)
    local nextMaxLv = maxLv
    local xiangqing = self.xiangqing
    local cailiao = self.cailiao
    xiangqing.curent:setString(string.format("%d",curentLv))
    if nextMaxLv then
        xiangqing.next:setString(string.format("%d",curentLv+1))
        local needs = GodBeastManager:getLvUpNeed()
        for index,config in ipairs(needs) do
            local item1=cailiao.shengxing["item"..index]
            local jingyan =cailiao.shengxing["jingyan"..index]
            if item1 then
                 GameUtil:creatItemNode(item1,{config[1],1},true)
                 -- GameUtil:creatItemNode(item1,{config[1],DepotManager:getItemCount(config[1])},true)
            end
            if jingyan then
                jingyan:setString(Serialize[61148]..config[2])
            end
        end
        -- GameUtil:resetScoolItemNode(self.m_needScroolView,GodBeastManager:getLvUpNeed(),nil,true)

    else
        xiangqing.next:setString(Serialize["Awake_OverviewTab_5_c"])
        nextMaxLv = false
    end
    self:createScrollView(not nextMaxLv,attrEffect)
--    xiangqing.next:setVisible(nextMaxLv)
    cailiao.shangxian:setVisible(not nextMaxLv)
    cailiao.shengxing:setVisible(nextMaxLv)
end

function This:createScrollView(isFull,attrEffect)
    local scrollView1= self.xiangqing.scrollView1
    scrollView1:removeAllItems()
    
    local function createItemView(info)
        local node = cc.Node:createFromCSFile("MenuScene/NodeUI/MythicalAnimalsMeInfoLvValue.csb")
        local bg = node.bg
        local strCount = #info
        for index=1,4 do
            local str = info[index]
            local txt =bg["txt"..index]
            if txt then
                txt:setString(str)
                txt:setVisible(index<=strCount)
            end
        end
        for index=1,2 do
            local jiantou =bg["jiantou"..index]
            jiantou:setVisible(not isFull)
        end
        local x,y = bg:getContentSize()
        node:setContentSize(x, y)
        return node 
    end
    local data = self.m_beastData
    local curentLv = data:getLv()
    local curentAttr = data:getAttr(curentLv,nil,true)
    local offsetValue = {}
    local nextAttr = data:getAttr(curentLv+1,nil,true)
    if not isFull then
        for id,value in pairs(nextAttr) do
            local curentValue= curentAttr[id] or 0
            if not curentValue then
                curentAttr[id] =0
            end
            offsetValue[id]= math.floor(value)-math.floor(curentValue)
        end
    end
    -- local keys ={}
    local count= 0
    for key,_ in pairs(curentAttr) do
        local name ,value = GameUtil:getAttrStr(key,curentAttr[key],true)
        local info= {name,math.floor(curentAttr[key]),math.floor(nextAttr[key] or 0),string.format("(%d)",offsetValue[key]or 0)}
        if isFull then
            info[3]=nil
            info[4]=nil
        end
        local item = createItemView(info)
        -- local scale = 0.9
        -- item:setScale(scale)
        local w , h = item:getContentSize()
        scrollView1:pushBackCustomItem(item,w,h,0.5)
        count = count +1
    end
    if attrEffect then
        GameUtil:createAttrEffect(self.xiangqing.anim,count,nil,5)
    end
end

function This:initTouchEvent()
 --    item1:setTouchEnded(function()
	-- 	self:btnCallBack(btnType)
	-- end,item1.bg)
    
 --    self.zhengduo:setTouch({
 --            isScale = false,
 --            isDynamic = true,
 --            isContainer = true,
 --            onEnded = function()
 --                 self:close()
 --            end
 --        })
	
	self.cailiao.shengxing.button1:setTouchEnded(function()
        local lv =GamePlayer:getLevel()
        local needLv = GodBeastManager:getMaxLv(self.m_beastData:getLv(),true)
        if lv<needLv then
            g_scene:showTips(string.format(Serialize[60309],needLv))
            return false
        end
        -- if not GameUtil:checkNeedItem(self.m_needScroolView) then
            GodBeastManager:onGetUpLvRequest(self.m_beastData:getId())
        -- end
    end)
end

-- function This:onEnter()
--     super.onEnter(self)
--     -- FamilyManager:addObserver(self)
-- end

-- function This:onExit()
--     super.onExit(self)
--     -- FamilyManager:removeObserver(self)
-- end

-- -- function This:getData()
	
-- -- end