-- @Author: zheng
-- @Date:   2019-05-10 17:40:25
-- @Last Modified by:   zheng
-- @Last Modified time: 2019-05-20 17:53:26
-- @File Name: MythicalAnimalsMeInfoStarTab.lua
 local GameUtil = require("Util.GameUtil")

local This , super = class(...,"NodeUI")
local GodBeastManager = require("GodBeast.GodBeastManager")

-- This.fileName = "MenuScene/NodeUI/MythicalAnimalsMeInfoLv.csb"
This.fileName = "MenuScene/NodeUI/MythicalAnimalsMeInfoStar.csb"
function This:initNode(info)
    self.m_needScroolView = self.cailiao.shengxing.scrollView2
    -- self:getData()
    self:setToCenter()
    self:refresh(info.beastData)
end

function This:refresh(info,attrEffect)
    if info then
        self.m_beastData = info
    end
    local data =info or self.m_beastData
    local curentLv =data:getStarLv()
    local maxLv = data:getMaxStarLv()
    local nextMaxLv = maxLv>curentLv
    local xiangqing = self.xiangqing
    local cailiao = self.cailiao
    local star_node = xiangqing.star_node

    local function updateItem(index,txts,full)
        local item1 = xiangqing["item"..index]
        if item1 then
            item1.curent:setString(txts[1])
            item1.next:setString(txts[2])
            item1.next:setVisible( full)
            item1.jiantou:setVisible( full)
        end
    end
    local nextLv= -1
    if nextMaxLv then
        local star = data:getStar(curentLv)
        GameUtil:resetScoolItemNode(self.m_needScroolView,star:getUpNeed(),nil,true,nil,3)
        nextLv =curentLv+1
        local lv =data:getLv()
        cailiao.shengxing.num1:setString(string.format("%d/%d",lv,star:getNeedLv()))
    else
        nextMaxLv = false
    end


    local starLv = data:getStarLv()
    local fullStar = starLv==5
    if not fullStar then
        local nextStar = starLv+1
        local str = data:getStar(nextStar):getDesc()
        star_node.xiaoguo:setStringWithColor(str,320)
        star_node.jihuo:setString(string.format(Serialize[61151],nextStar))
    end
    star_node.jihuo:setVisible(not fullStar)
    star_node.xiaoguo:setVisible(not fullStar)
    star_node.all:setVisible(fullStar)

    local upList = {}
    local lvList ={curentLv,nextLv}
    for index,lv in ipairs(lvList) do
        if lv>=0 then
            local star1= data:getStar(lv)
            local radio = star1:getAttrParameter()
            local str = radio*100 .."%"
            upList[index]= str
        else
            upList[index]= ""
        end
    end
    updateItem(1,lvList,nextMaxLv)
    updateItem(2,upList,nextMaxLv)
    
    if attrEffect then
        GameUtil:createAttrEffect(xiangqing.anim,2)
    end
    self:createScrollView(not nextMaxLv)
    cailiao.shangxian:setVisible(not nextMaxLv)
    cailiao.shengxing:setVisible(nextMaxLv)
end

function This:createScrollView(isFull)
    
end

function This:initTouchEvent()
 --    item1:setTouchEnded(function()
	-- 	self:btnCallBack(btnType)
	-- end,item1.bg)
    
 --    self.zhengduo:setTouch({
 --            isScale = false,
 --            isDynamic = true,
 --            isContainer = true,
 --            onEnded = function()
 --                 self:close()
 --            end
 --        })
	
	self.cailiao.shengxing.button1:setTouchEnded(function()
        local data = self.m_beastData
        local curentLv =data:getStarLv()
        local star = data:getStar()
        local needLv = star:getNeedLv()
        if data:getLv()<needLv then
            g_scene:showTips(string.format(Serialize[61152],needLv))
            return false
        end
        -- if not GameUtil:checkNeedItem(self.m_needScroolView) then
            GodBeastManager:onGetUpStarRequest(data:getId())
        -- end
    end)
end

-- function This:onEnter()
--     super.onEnter(self)
--     -- FamilyManager:addObserver(self)
-- end

-- function This:onExit()
--     super.onExit(self)
--     -- FamilyManager:removeObserver(self)
-- end

-- -- function This:getData()
	
-- -- end