-- @Author: Su
-- @Date:   2019-05-10 18:00:21
-- @Last Modified by:   zheng
-- @Last Modified time: 2019-05-17 16:16:32
-- @File Name: MythicalAnimalsMePanel.lua

local This , super = class(...,"Dialog")
local GodBeastManager = require("GodBeast.GodBeastManager")
local MythicalAnimalsMeItem = require("GodBeast.MythicalAnimalsMeItem")
local DepotManager = require("Depot.DepotManager")


local TabName = {
    kAnimal = "animal",
    kAnimalSpall = "animalSpall"
}

function This:initNode(info)

    self.m_csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/MythicalAnimalsMe.csb")
    self.m_csNode:setToCenter()
    self:addChild(self.m_csNode)

    self.m_scrollView = self.m_csNode.scrollView
    self:addTabButton(TabName.kAnimal,self.m_csNode.tep1,function()
        print("神兽")
        self:selectTabButton(TabName.kAnimal)
        
    end)

    self:addTabButton(TabName.kAnimalSpall,self.m_csNode.tep2,function()
        print("神兽碎片")
        self:selectTabButton(TabName.kAnimalSpall)
    end)

    self:selectTabButton(TabName.kAnimal)
end

function This:selectTabButton(tab)
    self:lightTabButton(tab)
    self.m_csNode.tips:setVisible(false)
    self.m_animalViewList = {}
    self.m_scrollView:removeAllItems()
    self.m_scrollView:setDirection("vertical")

    if tab == TabName.kAnimal then
        local idList = GodBeastManager:getAllHaveBeastsIdWithSort()
        if #idList == 0 then
            self.m_csNode.tips:setString(Serialize[61155])
            self.m_csNode.tips:setVisible(true)
            return
        end
    -- local animalList = {}
        for _, animalId in pairs(idList) do
            local animal = GodBeastManager:getBeast(animalId)
            -- table.insert(animalList,animal)
            local view = MythicalAnimalsMeItem:create({animal = animal})
            local w,h = view:getSize()
            view:setAnchorPoint(0,0)
            self.m_scrollView:pushBackCustomItem(view,w,h,0.5)
            table.insert(self.m_animalViewList,view)
        end
    else
        local idList =DepotManager:getAnimalSpallItemList()
        for _, animalSpallItem in pairs(idList) do
            local isHave = GodBeastManager:isHaveBeast(animalSpallItem:getId()-1000) 
            local view = MythicalAnimalsMeItem:create({item = animalSpallItem,isHave = isHave})
            local w,h = view:getSize()
            view:setAnchorPoint(0,0)
            self.m_scrollView:pushBackCustomItem(view,w,h,0.5)
            table.insert(self.m_animalViewList,view)
        end
        if #self.m_animalViewList == 0 then
            self.m_csNode.tips:setString(Serialize[61156])
            self.m_csNode.tips:setVisible(true)
        end
    end
end

function This:onEnter()
    super.onEnter(self)
    DepotManager:addObserver(self)
    GodBeastManager:addObserver(self)
end

function This:onExit()
    DepotManager:removeObserver(self)
    GodBeastManager:removeObserver(self)
    super.onExit(self)

end

function This:initTouchEvent()
	local csNode = self.m_csNode
    csNode.close:setTouchEnded(function()
        self:close()
    end)
end

function This:onGetMadeBeast()
    self:selectTabButton(TabName.kAnimalSpall)
end