-- @Author: zheng
-- @Date:   2019-05-09 10:53:21
-- @Last Modified by:   zheng
-- @Last Modified time: 2019-07-08 18:02:55
-- @File Name: MythicalAnimalsPanel.lua

local This , super = class(...,"Dialog")
local ItemConfig = require("Metadatas.ItemConfig")
local GodBeastManager = require("GodBeast.GodBeastManager")
local NobilityManager = require("Nobility.NobilityManager")
local GamePlayer = require("Player.GamePlayer")

local MythicalAnimalsItemView = require("GodBeast.MythicalAnimalsItemView")
local MythicalAnimalsPositionConfig = require("Metadatas.MythicalAnimalsPositionConfig")
-- local FamilyManager = require("Official.FamilyManager")
This.fileName = "MenuScene/NodeUI/MythicalAnimals.csb"


function This:initNode(info)
    -- if info then
    --    self.m_family = info.family
    -- end
    GodBeastManager:onGetInforRequest()
    self.m_csNode = cc.Node:createFromCSFile(This.fileName)
    self.m_csNode:setToCenter()
    self:addChild(self.m_csNode)
    local maxPos = #MythicalAnimalsPositionConfig
    -- local scrollView = self.m_csNode.scrollView
    -- scrollView:setDirection("horizontal")
    -- scrollView.m_direction = "right"
    -- self.m_animalViewList = {}
    -- scrollView:removeAllItems()
    -- local scale = 0.8
    -- for i=1,maxPos do
    --     local beast = GodBeastManager:getBeastPos(i)
    --     local view = MythicalAnimalsItemView:create({animal = beast,pos = i})
    --     local w , h = view:getSize()
    --     view:setAnchorPoint(0,0)
    --     view:setScale(scale)
    --     scrollView:pushBackCustomItem(view,w,h*scale-350,0)
    --     self.m_animalViewList[i]=view
    -- end
    local csNode = self.m_csNode
    for index=1,maxPos do
        local item1= csNode["pos"..index]
        if item1 then
            local beast = GodBeastManager:getBeastPos(index)
            local view = MythicalAnimalsItemView:create({animal = beast,pos = index})
            item1:addChild(view)
        end

    end
    self:refresh()
end

function This:refresh()

end

function This:initTouchEvent()
	local csNode = self.m_csNode
    csNode.close:setTouchEnded(function()
        self:close()
    end)
    csNode.my:setTouchEnded(function()
        g_scene:openDialog("GodBeast.MythicalAnimalsMePanel")
    end)
    csNode.shop:setTouchEnded(function()
        local level = GamePlayer:getLevel()
        if level < 60 then
            g_scene:showTips(Serialize[61158])
            return
        end
        g_scene:openDialog(unpack({"Store.StoreMainPanel", {tabs = StoreType.kAnimalShop}}))
    end)
    csNode.book:setTouchEnded(function()
        g_scene:openDialog("GodBeast.MythicalAnimalsBookPanel")
    end)
	csNode.add:setTouchEnded(function()
        g_scene:openDialog("GodBeast.MythicalAnimalsAddPanel")
    end)
    csNode.wenhao:setTouchEnded(function()
        local text = Serialize["GodBeast_MythicalAnimals_1"]
            g_scene:openDialog("UI.HelpTips", {text = text,node = csNode.wenhao})
    end)
end

function This:onEnter()
    super.onEnter(self)
    -- FamilyManager:addObserver(self)
end

function This:onExit()
    super.onExit(self)
    -- FamilyManager:removeObserver(self)
end

-- function This:getData()
	
-- end