-- @Author: zheng
-- @Date:   2019-05-09 11:51:48
-- @Last Modified by:   zheng
-- @Last Modified time: 2020-07-09 11:47:04
-- @File Name: MythicalAnimalsReplaceItemView.lua

local This , super = class(...,"NodeUI")
local GodBeastManager = require("GodBeast.GodBeastManager")
local ItemNode = require("UI.ItemNode")
local ItemUtil = require("Bag.ItemUtil")

-- local FamilyManager = require("Official.FamilyManager")
--This.fileName = "MenuScene/NodeUI/MythicalAnimalsReplaceItem.csb"
function This:initNode(info)
    if info then
       self.m_family = info.family
    end
    if info.animal then
        self.m_animal = info.animal
        self.m_pos = info.pos
    end
     self.m_csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/MythicalAnimalsReplaceItem.csb")
     self:addChild(self.m_csNode)
    -- self:getData()
    self:refresh()
end

function This:refresh()
    local csNode = self.m_csNode
    if not self.m_animalItem then
        local itemNode= ItemNode:create(self.m_animal:getId())
        itemNode:setAnchorPoint(0.5,0.5)

        csNode.item:addChild(itemNode)
        self.m_animalItem = itemNode
    end
    -- if self.m_animal then
        csNode.itemName:setString(self.m_animal:getName())
        csNode.itemName:setColorByID("Q".. ItemUtil.getQuality(self.m_animal:getId()))
        csNode.lv:setString(string.format(Serialize[60312],self.m_animal:getLv()))
        -- csNode.biaoqian:setVisible(GodBeastManager:isHavePos(self.m_animal:getId()))
        local starLv = self.m_animal:getStarLv()
        for i = 1,5 do
            csNode["star"..i].light:setVisible(starLv >= i)
        end
    -- end
end

function This:initTouchEvent()
 --    item1:setTouchEnded(function()
	-- 	self:btnCallBack(btnType)
	-- end,item1.bg)
    
 --    self.zhengduo:setTouch({
 --            isScale = false,
 --            isDynamic = true,
 --            isContainer = true,
 --            onEnded = function()
 --                 self:close()
 --            end
 --        })
	
	-- self.m_csNode.closebutton:setTouchEnded(function()
    --     self:close()
    -- end)
    local csNode = self.m_csNode
    csNode.button:setTouch({
        isScale = false,
        isDynamic = true,
        isContainer = true,
        onEnded = function()
            GodBeastManager:onGetModifyBeastRequest(self.m_animal:getId(),self.m_pos)
        end
    })
end

function This:onEnter()
    super.onEnter(self)
    -- FamilyManager:addObserver(self)
end

function This:onExit()
    super.onExit(self)
    -- FamilyManager:removeObserver(self)
end

function This:getSize()
    local w,h = self.m_csNode.bg:getContentSize()
    return w,h
end
-- function This:getData()
	
-- end