-- @Author: zheng
-- @Date:   2019-05-09 11:49:26
-- @Last Modified by:   zheng
-- @Last Modified time: 2019-05-20 16:35:11
-- @File Name: MythicalAnimalsReplacePanel.lua

local This , super = class(...,"Dialog")
This.fileName = "MenuScene/NodeUI/MythicalAnimalsReplace.csb"
local GodBeastManager = require("GodBeast.GodBeastManager")
local MythicalAnimalsReplaceItemView = require("GodBeast.MythicalAnimalsReplaceItemView")

function This:initNode(info)
    -- if info then
    --    self.m_family = info.family
    -- end
    self.m_csNode = cc.Node:createFromCSFile(This.fileName)
    self.m_csNode:setToCenter()
    self:addChild(self.m_csNode)
    -- self:getData()
    self.m_pos = info.selectPos

    self.m_animalViewList = {}
    local scrollView = self.m_csNode.scrollView
    scrollView:setDirection("vertical")
    local animalList = GodBeastManager:getAllHaveBeastsIdWithSort()
    for _,animalId in pairs(animalList) do
        if not GodBeastManager:isHavePos(animalId) then
            local animal = GodBeastManager:getBeast(animalId)
            local view = MythicalAnimalsReplaceItemView:create({animal = animal,pos = self.m_pos})
            local w,h = view:getSize()
            view:setAnchorPoint(0,0)
            scrollView:pushBackCustomItem(view,w,h,0.5)
            table.insert(self.m_animalViewList,view)
        end
    end
    local tips = self.m_csNode.tips
    -- if #animalList == 0 then
    --     -- g_scene:showTips("无可上阵神兽")
    -- end
    tips:setVisible(#self.m_animalViewList == 0)
    self:refresh()
end

function This:refresh()

end

function This:initTouchEvent()
 --    item1:setTouchEnded(function()
    --  self:btnCallBack(btnType)
    -- end,item1.bg)
    
 --    self.zhengduo:setTouch({
 --            isScale = false,
 --            isDynamic = true,
 --            isContainer = true,
 --            onEnded = function()
 --                 self:close()
 --            end
 --        })
    
    local csNode = self.m_csNode
    csNode.close:setTouchEnded(function()
        self:close()
    end)
end

function This:onEnter()
    --super.onEnter(self)
    GodBeastManager:addObserver(self)
end

function This:onExit()
    --super.onExit(self)
    GodBeastManager:removeObserver(self)
end


function This:onGetModifyBeast()
    self:close()
end
-- function This:getData()
	
-- end