-- @Author: zheng
-- @Date:   2019-05-09 11:59:57
-- @Last Modified by:   zheng
-- @Last Modified time: 2019-05-18 21:30:48
-- @File Name: MythicalAnimalsSkillPanel.lua

local This , super = class(...,"Dialog")

This.fileName = "MenuScene/NodeUI/MythicalAnimalsSkill.csb"

local GodBeastManager = require("GodBeast.GodBeastManager")
function This:initNode(info)
    -- if info then
    --    self.m_family = info.family
    -- end
    super.initNode(self, info)
    self.m_csNode = cc.Node:createFromCSFile(This.fileName)
    self.m_csNode:setToCenter()
    self:addChild(self.m_csNode)
    local beastId = info.beastId
    self.m_beastId = beastId
    -- self:getData()
    self:refresh()
end

function This:refresh()
    local beastId = self.m_beastId
    local data = GodBeastManager:getBeast(beastId)
    if data then
        local scrollView = self.m_csNode.scrollView
        scrollView:removeAllItems()
        local maxStar = data:getMaxStarLv()
        for index=0,maxStar do
            local star = data:getStar(index)
            if star then
                local name,des= star:getSkillDes()
                local info ={index= string.format(Serialize["GodBeast_SkillPanel_1"],index),des= des}
                local item = self:createItemView(info)
                local w , h = item:getContentSize()
                scrollView:pushBackCustomItem(item,w,h,0.5)
            end
        end
    end
end

function This:createItemView(info)
    local node = cc.Node:createFromCSFile("MenuScene/NodeUI/MythicalAnimalsSkillItem.csb")
    local bg = node.bg
    local index =info.index
    local des = info.des
    node.title:setString(index)
    node.text1:setStringWithColor(des,290)
    local x,y = bg:getContentSize()
    node:setContentSize(x, y)
    return node 
end

function This:initTouchEvent()
 --    item1:setTouchEnded(function()
    --  self:btnCallBack(btnType)
    -- end,item1.bg)
    
 --    self.zhengduo:setTouch({
 --            isScale = false,
 --            isDynamic = true,
 --            isContainer = true,
 --            onEnded = function()
 --                 self:close()
 --            end
 --        })
    
    -- local csNode = self.m_csNode
    -- csNode.close:setTouchEnded(function()
    --     self:close()
    -- end)
end

function This:onEnter()
    super.onEnter(self)
    GodBeastManager:addObserver(self)
end

function This:onExit()
    super.onExit(self)
    GodBeastManager:removeObserver(self)
end

function This:onTouchMask() -- 对话框之外区域的点击事件
    self:close()
end
-- function This:getData()
    
-- end