--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"Guide.GuideAncBase")
local HeroManager = require("Hero.HeroManager")

local AdSG = 
{
	kFinishGuide = 0,
	kClickMenuHeroBtnGuide = 1, --引导点击封地武将按钮
	kClickWorldHeroBtnGuide = 2, --引导点击世界武将按钮
	kClickDeputyTabBtn = 3, --引导点击军团按钮
	kClickAddDeputyPos1 = 4, --引导点击第一个位置的副将按钮
	kClickAddDeputyPos2 = 5, --引导点击第二个位置的副将按钮
	kSelectDeputyGuide = 6, --引导点击选择副将
	kInterrupt = 7, 
	kListPanelGuide = 8, 
}

local NodePath = 
{
	[AdSG.kClickMenuHeroBtnGuide] = "MenuScene.sceneUI.m_csNode.panel_btns.hero",
	[AdSG.kClickWorldHeroBtnGuide] = "WorldScene.sceneUI.m_csNode.panel_btns.hero",
	[AdSG.kClickDeputyTabBtn] = "MenuScene.HeroPanel.m_csNode.teb4",
	[AdSG.kClickAddDeputyPos1] = "MenuScene.HeroPanel.m_csNode.LegionTabNode.m_csNode.need1",
	[AdSG.kClickAddDeputyPos2] = "MenuScene.HeroPanel.m_csNode.LegionTabNode.m_csNode.need2",
}

function This:init(info)
	self.m_events = {"dialog_close","dialog_open","list_finish","deputy_changed"}
	super.init(self,info)
end

function This:initGuide()
	super.initGuide(self)
	self.m_view:setTouchHandler(function()
		if self.m_view then
			local panel = g_scene:getTopDialog()
			if panel and panel:getName() == "HeroPanel" and panel:getCurSelectTab() ~= "legion" then
				g_scene:setTimer(0,function()
					self:update()
				end,"add_deputy_guide")
			end
		end
	end)
end

function This:getState()
	if g_scene:getName() ~= "MenuScene" and g_scene:getName() ~= "WorldScene" then
		return
	end

	local function checkDeputy(hero)
		local deputys = hero:getDeputyWithPos()
		if deputys[1] <= 0 and hero:isUnlockAtDeputyPos(1) then
			return true
		end
		if deputys[2] <= 0 and hero:isUnlockAtDeputyPos(2) then
			return true
		end
		return false
	end

	local panel = g_scene:getTopDialog()
	if not panel or panel[0] == 0 then
		if self.m_view:getClickCount() > 0 then
			return AdSG.kFinishGuide
		else
			if g_scene:getName() == "MenuScene" then
				return AdSG.kClickMenuHeroBtnGuide
			elseif g_scene:getName() == "WorldScene" then
				return AdSG.kClickWorldHeroBtnGuide
			end
		end
	elseif panel:getName() == "HeroListPanel" then
		local function selectItem(view)
			local w , h = panel.m_csNode.heroList:getContentSize()
			local x , y = view:getPosition()
			local w1 , h1 = panel.m_csNode.heroList:getInnerContainerSize()
			local x1 , y1 = panel.m_csNode.heroList:getInnerContainerPosition()
			local ny = math.min(0, math.max(h - h1,h/2 - y))
			panel.m_csNode.heroList:setInnerContainerPosition(x1, ny)
		end
		local listLayer = panel.m_listLayer
		if next(listLayer.m_views) == nil then
			return AdSG.kInterrupt
		end
		for i , view in ipairs(listLayer.m_views) do
			if view:isVisible() then
				local heroId = view.m_heroId
				local hero = HeroManager:getHero(heroId)
				if checkDeputy(hero) then
					self.m_heroId = heroId
					self.m_heroListView = view
					selectItem(view)
					return AdSG.kListPanelGuide
				end
			end
		end
		return AdSG.kInterrupt
	elseif panel:getName() == "HeroPanel" then
		if self.m_heroId and panel.m_heroId == self.m_heroId then
			if panel:getCurSelectTab() ~= "legion" then
				return AdSG.kClickDeputyTabBtn
			else
				local hero = HeroManager:getHero(self.m_heroId)
				local deputys = hero:getDeputyWithPos()
				if deputys[1] <= 0 and hero:isUnlockAtDeputyPos(1) then
					return AdSG.kClickAddDeputyPos1
				end
				if deputys[2] <= 0 and hero:isUnlockAtDeputyPos(2) then
					return AdSG.kClickAddDeputyPos2
				end
			end 
		end
	elseif panel:getName() == "LegionSelectPanel" then
		local hero = HeroManager:getHero(self.m_heroId)
		local recommend = panel.m_csNode.recommend:getChildren()
		for i , view in ipairs(recommend) do
			local heroId = view.m_heroId
			if hero:isCanAddDeputy(heroId) then
				self.m_deputyNode = view
				return AdSG.kSelectDeputyGuide
			end
		end
		if next(panel.m_listLayer.m_views) == nil then
			return AdSG.kInterrupt
		end
		local function selectItem(view)
			local w , h = panel.m_csNode.ScrollView:getContentSize()
			local x , y = view:getPosition()
			local w1 , h1 = panel.m_csNode.ScrollView:getInnerContainerSize()
			local x1 , y1 = panel.m_csNode.ScrollView:getInnerContainerPosition()
			local ny = math.min(0, math.max(h - h1,h/2 - y))
			panel.m_csNode.ScrollView:setInnerContainerPosition(x1, ny)
		end
		for i , view in ipairs(panel.m_listLayer.m_views) do
			if view:isVisible() then
				local heroId = view.m_heroId
				if hero:isCanAddDeputy(heroId) then
					self.m_deputyNode = view
					return AdSG.kSelectDeputyGuide
				end
			end
		end
	end
end

function This:getNode(state)
	if NodePath[state] then
		return self:getNodeByPath(NodePath[state])
	elseif state == AdSG.kListPanelGuide then
		if self.m_heroListView and self.m_heroListView[0] ~= 0 then
			return self.m_heroListView
		end
	elseif state == AdSG.kSelectDeputyGuide then
		if self.m_deputyNode and self.m_deputyNode[0] ~= 0 then
			return self.m_deputyNode
		end
	end
end

function This:update(state)
	if not state then
		state = self:getState()
	end
	if state then
		if state == 0 then
			self:finish()
		else
			local node = self:getNode(state)
			self.m_view:setNode(node)
		end
	else
		self:cancel()
	end
end

--endregion
