--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This, super = class(...,"Guide.GuideAncBase")
local WorldMapManager = require("World.WorldMapManager")
local EventDispather = require("EventDispatcher")
local GuideAncView = require("Guide.GuideAncView")
local UseJiceGuide = require("Guide.UseJiceGuide")

local AsSG = 
{
	kClickArmyListGuiding = 2, --行军列表
	kArmySpeedUpGuiding = 3, --行军列表界面
	kInterrupt = 4, --中断状态
	kFinishGuide = 5, --
}

local NodePath = 
{
	[AsSG.kClickArmyListGuiding] = "WorldScene.sceneUI.m_csNode.march.bg",
}

function This:init(info)
	self.m_fromCity = info.fromCity
	self.m_toCity = info.toCity
	self.m_upCount = 0
	self.m_events = {"march_army_start","march_army_changed","dialog_open","dialog_close"}
	super.init(self,info)
end

function This:start()
	local node = g_scene.m_worldUI.m_csNode.march
	if not node:isVisible() then
		g_scene:showTips(Serialize["guide_ArmySpeed_1"])
		self:cancel()
	else
		super.start(self)
	end
end

function This:getState()
	if g_scene:getName() ~= "WorldScene" then
		return
	end
	local node = g_scene.m_worldUI.m_csNode.march
	if not node:isVisible() then
		if self.m_view:getClickCount() > 0 then
			return AsSG.kFinishGuide
		end
		return
	end

	if self.m_isFinish then
		return AsSG.kFinishGuide
	end

	local panel = g_scene:getTopDialog()
	if not panel or panel[0] == 0 then
		if self.m_view:getClickCount() <= 0 then
			return AsSG.kClickArmyListGuiding
		else
			return AsSG.kFinishGuide
		end
	else
		if panel:getName() == "MarchArmyListPanel" then
			local item = self:selectItem()
			if item then
				return AsSG.kArmySpeedUpGuiding
			end
		elseif panel:getName() == "UsePlanPanel" or panel:getName() == "PlanShopPanel" then
			if not self.m_useJiceGuide then
				self.m_useJiceGuide = UseJiceGuide:create({
					father = self,
					dir = self.m_dir,
					jice = JiCeType.kXingJunJiaSu,
					city = self.m_cityId
				})
				self.m_useJiceGuide:start()
			end
			return AsSG.kInterrupt
		end
	end
end

function This:isRunning()
	if self.m_useJiceGuide then
		return self.m_useJiceGuide:isRunning()
	else
		return self.m_view and self.m_view:isVisible()
	end
end

function This:next()
	if self.m_useJiceGuide then
		self.m_useJiceGuide = nil
	end
	self.m_isFinish = true
end

function This:getNode(state)
	if state == AsSG.kClickArmyListGuiding then
		return self:getNodeByPath(NodePath[state])
	elseif state == AsSG.kArmySpeedUpGuiding then
		return self:selectItem()
	end
end

function This:update(state)
	if not state then
		state = self:getState()
	end
	if state then
		if state == AsSG.kFinishGuide then
			self:finish()
		else
			local node = self:getNode(state)
			self.m_view:setNode(node)
		end
	else
		self:cancel()
	end
end

function This:selectItem()
	local panel = g_scene:getTopDialog()
	if not panel or panel:getName() ~= "MarchArmyListPanel" then
		return
	end

	local function moveItemToCenter(item)
		local w , h = panel.m_csNode.ScrollView:getContentSize()
		local x , y = item:getPosition()
		local w1 , h1 = panel.m_csNode.ScrollView:getInnerContainerSize()
		local x1,  y1 = panel.m_csNode.ScrollView:getInnerContainerPosition()
		local nx = math.min( math.max(-w1+w,w/2 - x), 0)
		panel.m_csNode.ScrollView:setInnerContainerPosition(nx,y1)
	end

	local itemList = panel.m_csNode.ScrollView:getItemList()
	if self.m_fromCity and self.m_toCity then
		for i , item in ipairs(itemList) do
			local army = item.m_army
			if self.m_fromCity == army:getFromCity() and self.m_toCity == army:getToCity() then
				moveItemToCenter(item)
				return item.m_csNode.accelerate
			end
		end
	else
		local maxEndTime , target = 0
		for i , item in ipairs(itemList) do
			local army = item.m_army
			local leftTime = army:getLeftTime()
			local leftSpUp = kMaxSpeedUpTime - army:getSpeedUpTime()
			if leftSpUp > 0 and leftTime > 0 and maxEndTime < leftTime then
				maxEndTime = leftTime
				moveItemToCenter(item)
				target = item.m_csNode.accelerate
			end
		end
		return target
	end
end

--endregion
