--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"Guide.GuideAncBase")
local GuideManager = require("Guide.GuideManager")

local CsSG = 
{
	kFinishGuide = 0,
	kMenuSceneGuide = 1, --封地指引
	kWorldSceneGuide = 2, --世界场景
	kSubGuide = 3, --子指引
	kMatchPanelGuide = 4, --排位赛指引
}

local NodePath = 
{
	[CsSG.kMenuSceneGuide] = "MenuScene.sceneUI.m_csNode.paiwei",
	[CsSG.kWorldSceneGuide] = "WorldScene.sceneUI.m_csNode.goto",
	[CsSG.kMatchPanelGuide] = "MenuScene.MatchPanel.m_csNode.singlebattle",
}

function This:init(info)
	self.m_fromScene = info.fromScene or g_scene:getName()
	self.m_toScene = info.toScene
	self.m_subData = info.sub
	self.m_events = {"world_scene_enter","menu_scene_enter","dialog_open"}
	super.init(self,info)
	self.m_isCrossScene = true
end

function This:update(state)
	if not state then
		state = self:getState()
	end
	if state then
		if state == 0 then
			self:finish()
		elseif state ==  CsSG.kSubGuide then
			
		else
			local node = self:getNode(state)
			self.m_view:setNode(node)
		end
	else
		self:cancel()
	end
end

function This:getState()
	if g_scene:getName() == self.m_toScene then
		if not self.m_subGuider then
			self.m_subGuider = GuideManager:getAncGuider(self.m_subData)
			self.m_subGuider:start()
		end
		return CsSG.kSubGuide
	elseif g_scene:getName() == self.m_fromScene then
		if self.m_subGuider then
			return
		end
		if self.m_fromScene == "MenuScene" then
			local panel = g_scene:getTopDialog()
			if panel  then
				if panel:getName() == "MatchPanel" then
					return CsSG.kMatchPanelGuide
				else
					return
				end
			end
			return CsSG.kMenuSceneGuide
		elseif self.m_fromScene == "WorldScene" then
			local panel = g_scene:getTopDialog()
			if panel then
				return
			end
			if g_scene:getShowMode() ~= ShowMode.kNormal then
				return
			end
			if self.m_subGuider then
				return
			end
			return CsSG.kWorldSceneGuide
		end 
	end
end

function This:getNode(state)
	if NodePath[state] then
		return self:getNodeByPath(NodePath[state])
	end
end

function This:next()
	if self.m_subGuider then
		self.m_subGuider = nil
	end
	self:finish()
end

function This:cancel()
	local subGuider = self.m_subGuider
	if subGuider then
		self.m_subGuider = nil
		subGuider:cancel()
		super.cancel(self)
	else
		super.cancel(self)
	end
end


--endregion
