--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"Guide.GuideAncBase")
local WorldMapManager = require("World.WorldMapManager")
local SelectCityGuide = require("Guide.SelectCityGuide")

local CbSG = 
{
	kSelectCity = 1, --选定城池
	kClickCityBtnGuide = 2, --选择城池按钮
	kCreateMingju = 3, --创建民居
	kCreateLongtian = 4, --创建农田
	kCreateJishi = 5, --创建集市
	kFinishGuide = 6, 
	kSelectPos = 7,
}

local NodePath = 
{
	[CbSG.kCreateJishi] = "WorldScene.BuildCreatePanel.m_csNode.shopmostbutton",
	[CbSG.kCreateLongtian] = "WorldScene.BuildCreatePanel.m_csNode.croplandmostbutton",
	[CbSG.kCreateMingju] = "WorldScene.BuildCreatePanel.m_csNode.dessss",
}

function This:init(info)
	self.m_cityId = info.city
	self.m_buildType = info.type
	self.m_num = info.num or 10

	if not self.m_cityId then
		local city = self:getCity()
		if city then
			self.m_cityId = city:getCityId()
		end
	end

	if self.m_cityId then
		self.m_city = WorldMapManager:getCity(self.m_cityId)
	end

	self.m_events = {"dialog_open","dialog_close","city_nemu_open","enter_city","exit_city","city_create_build"}
	super.init(self,info)
end

function This:getState()
	if g_scene:getName() ~= "WorldScene" then
		return
	end

	if not self.m_cityId then
		g_scene:showTips(Serialize["guide_CityBuild_1"])
		return
	end

	if g_scene:getShowMode() == ShowMode.kBuild then
		local cityUI = g_scene.m_worldUI.m_cityUI
		if table.count(cityUI.m_builds) < self.m_num then
			local panel = g_scene:getTopDialog()
			if panel and panel:getName() == "BuildCreatePanel" then
				if self.m_buildType == BuildType.kDwelling then
					return CbSG.kCreateMingju
				elseif self.m_buildType == BuildType.kFarmland then
					return CbSG.kCreateLongtian
				elseif self.m_buildType == BuildType.kMarket then
					return CbSG.kCreateJishi
				end
				return
			elseif panel then
				return CbSG.kFinishGuide
			else
				return CbSG.kSelectPos
			end
		else
			return CbSG.kFinishGuide
		end
	elseif g_scene:getShowMode() == ShowMode.kNormal then
		local cityView = g_scene:getCityView(self.m_cityId)
		if cityView.m_menu then
			return CbSG.kClickCityBtnGuide
		elseif self.m_view:getClickCount() > 0 then
			return CbSG.kFinishGuide
		else
			if not self.m_cityGuider then
				self.m_cityGuider = SelectCityGuide:create({
					city = self.m_cityId,
					bFrom = true,
					dir = self.m_dir,
					father = self
				})
				self.m_cityGuider:start()
			end
			return CbSG.kSelectCity
		end
	end
end

function This:getCity()
	local citys = WorldMapManager:getAllCity()
	local result = {}
	for i , city in pairs(citys) do
		if city:isMy() then
			local builds = city:getAllBuild()
			if table.count(builds) < 10 then
				table.insert(result,city)
			end
		end
	end
	if #result > 0 then
		local index = math.random(1,#result)
		return result[index]
	end
end

function This:getNode(state)
	if NodePath[state] then
		return self:getNodeByPath(NodePath[state])
	end
	if state == CbSG.kClickCityBtnGuide then
		local cityView = g_scene:getCityView(self.m_cityId)
		return cityView.m_menu.ownclick.gototown
	elseif state == CbSG.kSelectPos then
		local builds = g_scene.m_worldUI.m_cityUI.m_builds
		for i = BuildPos.kBuild1, BuildPos.kBuild10 do
			if not builds[i] then
				return g_scene.m_worldUI.m_cityUI.m_csNode["click"..i]
			end
		end
	end
end

function This:update(state)
	if not state then
		state = self:getState()
	end
	if state then
		if state == CbSG.kFinishGuide then
			self:finish()
		elseif state ~= CbSG.kSelectCity then
			local node = self:getNode(state)
			self.m_view:setNode(node)
		end
	else
		self:cancel()
	end
end

function This:cancel()
	super.cancel(self)
	if self.m_cityGuider then
		self.m_cityGuider:cancel()
		self.m_cityGuider = nil
	end
end

function This:next()
	if self.m_cityGuider then
		self.m_cityGuider = nil
	end
end

function This:isRunning()
	if self.m_cityGuider then
		return self.m_cityGuider:isRunning()
	else
		return self.m_view and self.m_view:isVisible()
	end
end

--endregion
