--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"Guide.GuideAncBase")
local WorldMapManager = require("World.WorldMapManager")
local SelectCityGuide = require("Guide.SelectCityGuide")

local CbSG = 
{
	kFinishGuide = 0,	
	kSelectBuild = 1,	--选择建筑
	kGuideUpgrade = 2,  --引导升级
	kClickCityBtnGuide = 3, --点击城市按钮
	kSelectCity = 4, --选择城市
}

local NodePath = 
{
	[CbSG.kGuideUpgrade] = "WorldScene.BuildLvUpPanel.m_csNode.bulidinglevelup.batchlevelupbutton",
}

function This:init(info)
	self.m_cityId = info.city
	if not self.m_cityId then
		local city = self:getCity()
		if city then
			self.m_cityId = city:getCityId()
		end
	end
	if self.m_cityId then
		self.m_city = WorldMapManager:getCity(self.m_cityId)
	end
	self.m_events = {"dialog_open","dialog_close","city_nemu_open","enter_city","exit_city", "build_upgrade_start"}
	super.init(self,info)
end

function This:getCity()
	local citys = WorldMapManager:getAllCity()
	local result = {}
	for i , city in pairs(citys) do
		if city:isMy() then
			local builds = city:getAllBuild()
			if table.count(builds) > 1 then
				table.insert(result,city)
			end
		end
	end
	if #result > 0 then
		local index = math.random(1,#result)
		return result[index]
	end
end

function This:getBuild()
	local minLvBuild = nil
	for i = BuildPos.kBuild1 , BuildPos.kBuild10 do
		local build = self.m_city:getBuild(i)
		if build and build:isCanUpgrade() then
			if not minLvBuild or build:getLevel() < minLvBuild:getLevel() then
				minLvBuild = build
			end 
		end
	end
	return minLvBuild
end

function This:getState()
	if g_scene:getName() ~= "WorldScene" then
		return
	end

	if not self.m_cityId then
		g_scene:showTips(Serialize["guide_CityBuild_2"])
		return
	end

	if g_scene:getShowMode() == ShowMode.kBuild then
		local panel = g_scene:getTopDialog()
		if not panel then
			local cityUI = g_scene.m_worldUI.m_cityUI
			local minBuild = self:getBuild()
			if not minBuild then
				return
			else
				return CbSG.kSelectBuild
			end
		else
			return CbSG.kGuideUpgrade
		end
	elseif g_scene:getShowMode() == ShowMode.kNormal then
		local cityView = g_scene:getCityView(self.m_cityId)
		if cityView.m_menu then
			return CbSG.kClickCityBtnGuide
		elseif self.m_view:getClickCount() > 0 then
			return CbSG.kFinishGuide
		else
			if not self.m_cityGuider then
				self.m_cityGuider = SelectCityGuide:create({
					city = self.m_cityId,
					bFrom = true,
					dir = self.m_dir,
					father = self
				})
				self.m_cityGuider:start()
			end
			return CbSG.kSelectCity
		end
	end
end

function This:getNode(state)
	if NodePath[state] then
		return self:getNodeByPath(NodePath[state])
	end
	if state == CbSG.kClickCityBtnGuide then
		local cityView = g_scene:getCityView(self.m_cityId)
		return cityView.m_menu.ownclick.gototown
	elseif state == CbSG.kSelectBuild then
		local builds = g_scene.m_worldUI.m_cityUI.m_builds
		local build = self:getBuild()
		return builds[build:getPos()].m_csNode.building
	end
end

function This:update(state)
	if not state then
		state = self:getState()
	end
	if state then
		if state == CbSG.kFinishGuide then
			self:finish()
		elseif state ~= CbSG.kSelectCity then
			local node = self:getNode(state)
			self.m_view:setNode(node)
		end
	else
		self:cancel()
	end
end

function This:next()
	if self.m_cityGuider then
		self.m_cityGuider = nil
	end
end

function This:cancel()
	super.cancel(self)
	if self.m_cityGuider then
		self.m_cityGuider:cancel()
		self.m_cityGuider = nil
	end
end

function This:isRunning()
	if self.m_cityGuider then
		return self.m_cityGuider:isRunning()
	else
		return self.m_view and self.m_view:isVisible()
	end
end

--endregion
