--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"Guide.GuideAncBase")
local SelectCityGuide = require("Guide.SelectCityGuide")
local TroopPanelGuide = require("Guide.TroopPanelGuide")
local FightPanelGuide = require("Guide.FightPanelGuide")
local HpTransPanelGuide = require("Guide.HpTransPanelGuide")
local ArmySpeedUpGuide = require("Guide.ArmySpeedUpGuide")
local EventDispatcher = require("EventDispatcher")
local Path = require("World.Path")
local WorldMapManager = require("World.WorldMapManager")

local CfSG = 
{
	kSelectFromCity = 1, --选择触发城市
	kTroopPanelGuide = 2, --部队界面指引
	kSelectToCity = 3, --目标城市指引
	kFightPanelGuide = 4, --出征界面指引
	kHpTransPanelGuide = 5, --兵力运输
	kArmySpeedUpGuide = 6, --行军加速
}

function This:init(info)
	self.m_fromCity = info.fromCity
	self.m_toCity = info.toCity
	self.m_isUseZbmm = info.bUseZbmm or false
	self.m_isFight = info.bFight or false
	self.m_state = CfSG.kSelectFromCity
	super.init(self,info)

	if g_scene:getName() ~= "WorldScene" then
		self:cancel()
		return
	end

	if self.m_fromCity then
		local city = WorldMapManager:getCity(self.m_fromCity)
		if not city:isMy() then
			g_scene:showTips(string.format(Serialize["guide_CityFight_1"],city:getName()))
			self:cancel()
			return
		end
	end

	if not self.m_fromCity then
		local citys = WorldMapManager:getAllCity()
		for i , city in pairs(citys) do
			if city:isMyMainCity() then
				self.m_fromCity = city:getCityId()
				break
			end
		end
	end
	if not self.m_toCity then
		if self.m_isFight then
			self.m_toCity = self:getToCity(false)
		else
			self.m_toCity = self:getToCity(true)
		end
	end
	
	if not self.m_toCity then
		self:cancel()
	end
end

function This:getToCity(bOur)
	local path = Path:create()
	local fromCity = WorldMapManager:getCity(self.m_fromCity)
	local cityList = path:getAroundCity(fromCity,true)
	local result = {}
	for i , city in pairs(cityList) do
		if bOur and city:isOur() then
			table.insert(result,city:getCityId())
		elseif not bOur and not city:isOur() then
			table.insert(result,city:getCityId())
		end
	end
	local index = math.random(1,#result)
	return result[index]
end

function This:isRunning()
	if self.m_guider then
		return self.m_guider:isRunning()
	end
end

function This:start()
	if not self.m_toCity then
		g_scene:showTips(Serialize["guide_CityFight_2"])
		return
	end
	if self.m_isFight then
		local city = WorldMapManager:getCity(self.m_toCity)
		if city:isFighting() then
			g_scene:focuseCity(self.m_toCity,nil,true)
			g_scene:showTips(Serialize["guide_CityFight_3"])
			return
		end
		local armys = WorldMapManager:getAllMarchArmy()
		for i , army in pairs(armys) do
			if army:getFromCity() == self.m_fromCity and army:getToCity() == self.m_toCity then
				g_scene:focuseCity(self.m_toCity,nil,true)
				g_scene:showTips(Serialize["guide_CityFight_4"])
				return
			end
		end
	end
	
	if g_scene:getName() == "WorldScene" then
		local cityView = g_scene:getCityView(self.m_fromCity)
		if cityView.m_menu then
			self.m_state = CfSG.kTroopPanelGuide
		end
		self.m_guider = self:getGuideEntry()
		self.m_guider:start()
	end
end

function This:next()
	if self.m_guider then
		self.m_guider:clear()
		self.m_guider = nil
	end
	if self.m_state == CfSG.kSelectFromCity then
		self.m_state = CfSG.kTroopPanelGuide
		self.m_guider = self:getGuideEntry()
		self.m_guider:start()
	elseif self.m_state == CfSG.kTroopPanelGuide then
		self.m_state = CfSG.kSelectToCity
		self.m_guider = self:getGuideEntry()
		self.m_guider:start()
	elseif self.m_state == CfSG.kSelectToCity then
		local panel = g_scene:getTopDialog()
		if panel and panel:getName() == "TroopEmbattlePanel" then
			self.m_state = CfSG.kFightPanelGuide
			self.m_guider = self:getGuideEntry()
			self.m_guider:start()
		elseif panel and panel:getName() == "TroopHpTransPanel" then
			self.m_state = CfSG.kHpTransPanelGuide 
			self.m_guider = self:getGuideEntry()
			self.m_guider:start()
		end
	elseif self.m_state == CfSG.kArmySpeedUpGuide then
		self:cancel()
	end
end

function This:cancel()
	super.cancel(self)
	if self.m_guider then
		self.m_guider:cancel()
		self.m_guider = nil
	end
	if self.m_cancelHandler then
		self.m_cancelHandler()
	end
end

function This:getGuideEntry()
	if self.m_state == CfSG.kSelectFromCity then
		return SelectCityGuide:create({
			city = self.m_fromCity,
			dir = 0,
			bFrom = true,
			father = self
		})
	elseif self.m_state == CfSG.kTroopPanelGuide then
		return TroopPanelGuide:create({
			city = self.m_fromCity,
			bUseZbmm = self.m_isUseZbmm,
			bFight = self.m_isFight,
			father = self,
		})
	elseif self.m_state == CfSG.kSelectToCity then
		local isFight = self.m_isFight
		local city = WorldMapManager:getCity(self.m_toCity)
		--[[if isFight and city:isOur() then
			self.m_toCity = self:getToCity(false)
		elseif not isFight and not city:isOur() then
			self.m_toCity = self:getToCity(true)
		end]]
		return SelectCityGuide:create({
			city = self.m_toCity,
			dir = 0,
			bFrom = false,
			bFight = isFight,
			father = self
		})
	elseif self.m_state == CfSG.kFightPanelGuide then
		return FightPanelGuide:create({
			father = self
		})
	elseif self.m_state == CfSG.kHpTransPanelGuide then
		return HpTransPanelGuide:create({
			father = self,
			city = self.m_fromCity,
			dir = self.m_dir
		})
	elseif self.m_state == CfSG.kArmySpeedUpGuide then
		return ArmySpeedUpGuide:create({
			father = self,
			fromCity = self.m_fromCity,
			toCity = self.m_toCity,
			dir = self.m_dir
		})
	end
end

function This:setCancelHandler(handler)
	self.m_cancelHandler = handler
end

--endregion
