--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"Guide.GuideAncBase")
local GuideManager = require("Guide.GuideManager")

local CbSG = 
{
	kFinishGuide = 0,
	kGuideBtn = 1,
}

function This:init(info)
	self.m_isShowBottomBtn = info.isShowBottomBtn
	self.m_isShowTopBtn = info.isShowTopBtn
	self.m_pathList = info.path
	self.m_index = 1
	self.m_events = {"dialog_open","dialog_close"}
	super.init(self,info)
end

function This:initGuide()
	super.initGuide(self)
	self.m_view:setTouchHandler(function()
		if self.m_view then
			self.m_view:setNode(nil)
			self.m_index = self.m_index + 1
			g_scene.m_timer:setTimer(0,function()
				self:update()
			end,"click_btn_guide")
		end
	end)
end

function This:start()
	local delay = 0

	if self.m_isShowBottomBtn then
		GuideManager:showHomeBottomButton()
		delay = 0.5
	end
	if self.m_isShowTopBtn then
		GuideManager:showHomeTopButton()
		delay = 0.6
	end

	if delay > 0 then
		g_scene.m_timer:setTimer(delay, function()
			super.start(self)
		end,"click_btn_guide_0")
	else
		super.start(self)
	end

end

function This:getState()
	if self.m_index > #self.m_pathList then
		return CbSG.kFinishGuide
	end
	local path = self.m_pathList[self.m_index]
	local node , isVisible = self:getNodeByPath(path)
	if node and isVisible then
		if node:getName() == "WorldScene" or node:getName() == "MenuScene" then
			local panel = node:getTopDialog()
			if panel then
				return
			end
		end
		if self.m_view:getClickCount() <= #self.m_pathList then
			return CbSG.kGuideBtn
		else
			return CbSG.kFinishGuide
		end
	end
end

function This:getNode(state)
	return self:getNodeByPath(self.m_pathList[self.m_index])
end


--endregion
