--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"Guide.GuideAncBase")
local HeroManager = require("Hero.HeroManager")
local DepotManager = require("Depot.DepotManager")
local GamePlayer = require("Player.GamePlayer")

local CsSG = 
{
	kFinishGuide = 0,
	kClickMenuHeroBtnGuide = 1, --引导点击封地武将按钮
	kClickWorldHeroBtnGuide = 2, --引导点击世界武将按钮
	kClickSoilderTabBtn = 3, --引导点击兵种tab按钮
	kClickHeroPanelPeiYangBtn = 4, --引导点击武将界面培养按钮
	kClickSoilderPeiYangBtn = 5, --引导培养界面培养按钮
	kHeroListPanelGuide = 6, --武将列表界面指引
	kInterrupt = 7,
}

local NodePath = {
	[CsSG.kClickMenuHeroBtnGuide] = "MenuScene.sceneUI.m_csNode.panel_btns.hero",
	[CsSG.kClickWorldHeroBtnGuide] = "WorldScene.sceneUI.m_csNode.panel_btns.hero",
	[CsSG.kClickSoilderTabBtn] = "MenuScene.HeroPanel.m_csNode.teb3",
	[CsSG.kClickHeroPanelPeiYangBtn] = "MenuScene.HeroPanel.m_csNode.SoilderTabNode.m_csNode.culture",
	[CsSG.kClickSoilderPeiYangBtn] = "MenuScene.SoilderTrainPanel.m_csNode.cost.culture",
}

function This:init(info)
	self.m_events = {"dialog_close","dialog_open","list_finish"}
	super.init(self,info)
end

function This:initGuide()
	super.initGuide(self)
	self.m_view:setTouchHandler(function()
		if self.m_view then
			local panel = g_scene:getTopDialog()
			if not panel then
				return
			end
			if panel:getName() == "HeroPanel" and panel:getCurSelectTab() ~= "armType" or panel:getName() == "SoilderTrainPanel" then
				g_scene:setTimer(0,function()
					self:update()
				end,"cultivate_soilder_anc_guide")
			end
		end
	end)
end

function This:getState()
	if g_scene:getName() ~= "MenuScene" and g_scene:getName() ~= "WorldScene" then
		return
	end

	local function checkSoilder(hero)
		local soilder = hero:getCurSoilder()
		if soilder and soilder:isUnlock() then
			local costList = soilder:getTrainCost()
			if GamePlayer:costGlod({cost = costList[1].num}) then
				if DepotManager:getItemCount(costList[2].id) >= costList[2].num then
					return true
				end
			end
		end
		return false
	end

	local panel = g_scene:getTopDialog()
	if not panel or panel[0] == 0 then
		if self.m_view:getClickCount() > 0 then
			return CsSG.kFinishGuide
		else
			if g_scene:getName() == "MenuScene" then
				return CsSG.kClickMenuHeroBtnGuide
			elseif g_scene:getName() == "WorldScene" then
				return CsSG.kClickWorldHeroBtnGuide
			end
		end
	elseif panel:getName() == "HeroListPanel" then
		local function selectItem(view)
			local w , h = panel.m_csNode.heroList:getContentSize()
			local x , y = view:getPosition()
			local w1 , h1 = panel.m_csNode.heroList:getInnerContainerSize()
			local x1 , y1 = panel.m_csNode.heroList:getInnerContainerPosition()
			local ny = math.min(0, math.max(h - h1,h/2 - y))
			panel.m_csNode.heroList:setInnerContainerPosition(x1, ny)
		end
		local listLayer = panel.m_listLayer
		if next(listLayer.m_views) == nil then
			return CsSG.kInterrupt
		end
		for i , view in ipairs(listLayer.m_views) do
			if view:isVisible() then
				local heroId = view.m_heroId
				local hero = HeroManager:getHero(heroId)
				if checkSoilder(hero) then
					self.m_heroId = heroId
					selectItem(view)
					return CsSG.kHeroListPanelGuide
				end
			end
		end
	elseif panel:getName() == "HeroPanel" then
		if panel:getCurSelectTab() ~= "armType" then
			return CsSG.kClickSoilderTabBtn
		else
			return CsSG.kClickHeroPanelPeiYangBtn
		end
	elseif panel:getName() == "SoilderTrainPanel" then
		if self.m_heroId then
			local hero = HeroManager:getHero(self.m_heroId)
			if checkSoilder(hero) then
				if self.m_view:getClickCount() < 8 then
					return CsSG.kClickSoilderPeiYangBtn
				end
			end
		end
	end
end

function This:getNode(state)
	if NodePath[state] then
		return self:getNodeByPath(NodePath[state])
	elseif state == CsSG.kHeroListPanelGuide then
		local panel = g_scene:getTopDialog()
		local listLayer = panel.m_listLayer
		if self.m_heroId then
			for i , view in ipairs(listLayer.m_views) do
				if view:isVisible() and view.m_heroId == self.m_heroId then
					return view
				end
			end
		end
	end
end

function This:update(state)
	if not state then
		state = self:getState()
	end
	if state then
		if state == 0 then
			self:finish()
		else
			local node = self:getNode(state)
			self.m_view:setNode(node)
		end
	else
		self:cancel()
	end
end

--endregion
