
--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , usper = class(...,"Base.BaseModel")
local EventDispatcher = require("EventDispatcher")
local GuideAncView = require("Guide.GuideAncView")
local GuideUtil = require("Guide.GuideUtil")

function This:init(info)
	self.m_dir = info.dir or 0
	self.m_father = info.father
	self.m_isCrossScene = bCrossScene
	self.m_events = self.m_events or {}
	self.m_guideState = -1
	self:initGuide()
end

function This:initGuide()
	for i , event in ipairs(self.m_events) do
		EventDispatcher:addListener(self,event,function()
			self:update()
		end)
	end
	self.m_view = GuideAncView:create({
		dir = self.m_dir,
		model = self
	})
	self.m_view:setTouchHandler(function()
		if self.m_view then
			self.m_view:setNode(nil)
		end
	end)
	g_scene:addChild(self.m_view,1000)
end

function This:isCrossScene()
	return self.m_isCrossScene
end

function This:isRunning()
	if self.m_view and self.m_view[0] ~= 0  then
		local isVisible = self.m_view:isVisible()
		return isVisible
	end
end

function This:checkView()
	if self.m_view and self.m_view[0] == 0 then
		self.m_view = nil
	end
end

function This:start()
	local state = self:getState()
	if state then
		self:update(state)
	end
	EventDispatcher:dispatcher("anc_guide_changed")
end

function This:getNode(state)

end

function This:getNodeByPath(path)
	if path then
		local node , isVisible = GuideUtil:getNodeByPath(path,true)
		if not node or not isVisible then
			return 
		end
		return node , isVisible
	end
end	

function This:getState()

end

function This:update(state)
	if not self.m_view or self.m_view[0] == 0 then
		self:cancel()
		return
	end
	if not state then
		state = self:getState()
	end
	if state then
		if state == 0 then
			self:finish()
		else
			local node = self:getNode(state)
			self.m_view:setNode(node)
		end
	else
		self:cancel()
	end
	self.m_guideState = state
end

function This:clear()
	if self.m_view and self.m_view[0] ~= 0 then
		self.m_view:removeFromParent()
		self.m_view = nil
	end
	for i , event in ipairs(self.m_events) do
		EventDispatcher:removeListener(self,event)
	end
end

function This:cancel()
	self:clear()
	if self.m_father then
		local father = self.m_father
		self.m_father = nil
		father:cancel()
	end
	if self.m_cancelHandler then
		self.m_cancelHandler()
		self.m_cancelHandler = nil
	end
	EventDispatcher:dispatcher("anc_guide_changed",self)
end

function This:finish()
	self:clear()
	if self.m_father then
		self.m_father:next()
		self.m_father = nil
	end
	EventDispatcher:dispatcher("anc_guide_changed",self)
end

function This:setCancelHandler(handler)
	self.m_cancelHandler = handler
end

--endregion
