--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"cc.Node")
local Timer = require("Timer")
local EventDispatcher = require("EventDispatcher")

function This:init(info)
	self.m_node = info.node
	self.m_dir = info.dir or 0
	self.m_model = info.model
	self.m_isSlide = false

	self.m_finger = cc.Node:createFromCSFile("Common/NodeUI/FingerClick.csb")
	self.m_finger:setRotation(-self.m_dir)
    self:addChild(self.m_finger)
	self.m_clickCount = 0
	self.m_timer = Timer:create(self)
end

function This:onEnter()
	super.onEnter(self)
	self.m_finger:playCSAnimation()
	self:initTouchEvent()
	self:scheduleUpdate()
	print("------------------生成非强制引导View")
end

function This:onExit()
	super.onExit(self)
	print("------------------删除非强制引导View")
end

function This:initTouchEvent()
	self.m_listener = cc.TouchListener:create({
		onBegan = function()
			return true
		end,
		onEnded = function()
			self:refresh()
			self.m_clickCount = self.m_clickCount + 1
			if self.m_touchHandler then
				self.m_touchHandler()
			end			
		end,
		onMoved = function()
			self:refresh()
		end,
		isSwallow = false
	})
	self:addEventListener(self.m_listener)
	self:refresh()
end

function This:setIsSlide(bSlide)
	if self.m_isSlide and not bSlide then
		self.m_finger:removeFromParent()
		self.m_finger = cc.Node:createFromCSFile("Common/NodeUI/FingerClick.csb")
		self.m_finger:setRotation(-self.m_dir)
		self:addChild(self.m_finger)
		self.m_finger:playCSAnimation()
	elseif not self.m_isSlide and bSlide then
		self.m_finger:removeFromParent()
		self.m_finger = cc.Node:createFromCSFile("Common/NodeUI/FingerSlide.csb")
		self.m_finger:setRotation(-self.m_dir)
		self:addChild(self.m_finger)
		self.m_finger:playCSAnimation()
	end
end

function This:getClickCount()
	return self.m_clickCount
end

function This:refresh()
	if self.m_node and self.m_node[0] ~= 0 and self.m_node:isVisible() then
		self:setVisible(true)
		local rect = self.m_node:getBoundingBox()
		local x , y = rect:getCenterXY()
		self.m_finger:setPosition(x,y)

		if self.m_listener then
			self.m_listener:setEnabled(true)
		end

		if self.m_lightBoxSprite and self.m_lightBoxSprite[0] ~= 0 then
			self.m_lightBoxSprite:removeFromParent()
			self.m_lightBoxSprite = nil
		end
		self:highLightRect(rect)
	else
		self:setVisible(false)
		if self.m_listener then
			self.m_listener:setEnabled(false)
		end
		if self.m_lightBoxSprite and self.m_lightBoxSprite[0] ~= 0 then
			self.m_lightBoxSprite:removeFromParent()
			self.m_m_lightBoxSprite = nil
		end
	end
end

function This:setTouchHandler(handler)
	self.m_touchHandler = handler
end

function This:addUpdateHandler(handler)
	self.m_updateHandler = handler
end

function This:setNode(node)
	if self.m_node ~= node then
		self.m_node = node
		self:refresh()
		EventDispatcher:dispatcher("anc_guide_changed")		
	end
end

function This:highLightRect(targetRect)
    local lightBoxSprite = cc.Scale9Sprite:create("Common/Guide/gaoliangkuang.png")
    lightBoxSprite:setContentSize(cc.visible.width, cc.visible.height)
    self:addChild(lightBoxSprite)
    local width, height = lightBoxSprite:getContentSize()
    local rect = cc.Rect(targetRect)
    rect:centerExtend(25, 25)
    local anchorY = rect.y / (height - rect:getMaxY() + rect.y)
    local anchorX = rect.x / (width - rect:getMaxX() + rect.x)

    lightBoxSprite:setPosition(width * 0.5, height * 0.5)
    lightBoxSprite:applyAnchorPoint(anchorX, anchorY)
    --lightBoxSprite:setOpacity(0)
    lightBoxSprite:runAction(cc.Sequence(cc.Spawn(cc.FadeOut(0.5), cc.SizeTo(0.4, rect.width, rect.height, "CubicIn")),  cc.CallFunc(function()
		self.m_lightBoxSprite:removeFromParent()
		self.m_lightBoxSprite = nil
	end)))
	self.m_lightBoxSprite = lightBoxSprite
end

function This:update(dt)
	self.m_timer:update(dt)
	if self.m_updateHandler then
		self.m_updateHandler()
	end
end

--endregion
