--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"Guide.GuideUnit")
local AchieveManager = require("Achieve.AchieveManager")
local GuideUnitConfig = require("Metadatas.GuideUnitConfig")

function This:init(info)
	self.m_id = info.unitId
	self.m_father = info.father
	self.m_index = info.index
	self.m_isRunning = false
	self.m_config = GuideUnitConfig[self.m_id]
	self.m_checkEventList = {"dialog_open","dialog_close","main_achieve_changed","menu_scene_enter","world_scene_enter"}

	self.m_achieve = AchieveManager:getAchieve(AchieveType.kMainLine,self.m_config.arg.achieveId)
	if self.m_config.arg.check_event then
		for i , event in ipairs(self.m_config.arg.check_event) do
			table.insert(self.m_checkEventList,event)
		end
	end
	self:initGuide()
end

function This:guide()
	local panel = g_scene:openDialog("Achieve.ChapterOpenPanel",self.m_achieve)
	local closeFunc = panel.close
	panel.close = function()
		self:finish()
		closeFunc(panel)
	end
	if self.m_config.arg.guide_func then
		self.m_config.arg.guide_func()
	end
	local GuideManager = require("Guide.GuideManager")
	GuideManager:cancelAncGuider()
	self.m_isRunning = true
end

function This:check()
	if not super.check(self) then
		return false
	end
	if self.m_isRunning then
		return false
	end
	return true
end

--endregion
