--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"Guide.GuideUnit")
local GuideFingerView = require("Guide.GuideFingerView")
local EventDispatcher = require("EventDispatcher")
local GuideUtil = require("Guide.GuideUtil")

function This:initGuide()
	for i , event in ipairs(self.m_checkEventList) do
		EventDispatcher:addListener(self,event,function()
			print(string.format("收到检测事件%s",event))
			if not self:isRunning() and self:check() then
				self:guide()
			elseif self:isRunning() and self:isCanSkip() then
				self:finish()
			end
		end)
	end
end

function This:check()
	local checkHandler = function()
		if not self:isRunning() and g_scene._NAME == "WorldScene" and g_scene:isInit() then
			if g_scene:getTopDialog() ~= nil then
				return false
			end
			local cityUI = g_scene:getUi():getCityUI()
			if cityUI and cityUI:isVisible() then
				return false
			end

			if self.m_config.arg.check_func then
				return self.m_config.arg.check_func()
			end
			return true
		end
		return false
	end
	local result = checkHandler()
	if not result and (self.m_isRunning or self:isCanSkip()) then
		self:finish()
	end
	return result
end

function This:guide()
	self.m_isRunning = true
	local cityId = self.m_config.arg.city
	local function doGuide()
		local node = g_scene:getCityView(cityId)
		self.m_view = GuideFingerView:create({
			node = node.m_csNode.city,
			model = self,
			isForce = self.m_config.is_force == 1,
			dir = self.m_config.arg.dir,
		})	
		--print("---------------------create view GuideFingerView",self:getId())
		g_scene:addChild(self.m_view)	
	end
	g_scene:focuseCity(cityId,function()
		doGuide()
	end)
	local GuideManager = require("Guide.GuideManager")
	GuideManager:cancelAncGuider()
end

--endregion
