--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"cc.Node")
local EventDispathcer = require("EventDispatcher")

function This:init(info)
	self.m_isForce = info.isForce
	self.m_node = info.node
	self.m_model = info.model
	self.m_dir = info.dir or 0
	self.m_offset = info.offset or {x = 0, y = 0}
	self.m_fingerEvent = info.fingerEvent

	self:setCascadeOpacityEnabled(true)
	local rect = self.m_node:getBoundingBox()
	if rect.width == 0 or rect.height == 0 then
		local width , height = 60,60
		self.m_touchRect = cc.Rect(rect.x - width/2,rect.y - height/2,width,height)
	else
		self.m_touchRect = rect
	end

	if self.m_isForce then
		local layer = cc.LayerColor:create(cc.Color(0,0,0,118))

        local drawNode = cc.DrawNode:create()
        local clippingNode = cc.ClippingNode:create(drawNode)
        clippingNode:setInverted(true)
        clippingNode:addChild(layer)

        self:addChild(clippingNode)
        self.m_drawNode = drawNode
		self.m_drawNode:drawSolidRect(self.m_touchRect, cc.Color.WHITE)
	end

	local tips = self.m_model:getSessionTips()
	--tips = {text = "dddd", x = 400, y = 400}
	if tips then
		local node = cc.Node:createFromCSFile("MenuScene/NodeUI/ChapterTips.csb")
		local box = node.bg:getBoundingBox()

		node.word:setStringWithColor(tips.text, box.width-20)
		local w , h = node.bg:getContentSize()
		local sw , wh = node.word:getContentSize()
		local textRc = node.word:getBoundingBox()
		node.bg:setContentSize(w , textRc.height > h and textRc.height or h)
		node:setPosition(tips.x,tips.y)

		local x, y = node.bg:getPosition()
		box = node.bg:getBoundingBox()
		node.word:setAnchorPoint(0.5, 0.5)
		node.word:setPosition(x - box.width/2 - 20, y + box.height/2)

		self:addChild(node)
	end
end

function This:clearTouch()
	if self.m_btnOnEnded then
		self.m_node.m_touch.onEnded = self.m_btnOnEnded
		self.m_btnOnEnded = nil
		if self.m_isForce then
			if g_scene.m_lockGuide > 0 then
				g_scene.m_lockGuide = g_scene.m_lockGuide - 1
			end
			self.m_node.m_touch.m_unlock = 0	
		end
	end
end

function This:initTouchEvent()
	if not self.m_node.m_touch then
		print("button 设置错误，请检查配置表")
		assert(false)
	end
	self.m_isFinish = false
	self.m_btnOnEnded = self.m_node.m_touch.onEnded
	self.m_node.m_touch.onEnded = function(touch,point)
		if self.m_btnOnEnded then
			self.m_btnOnEnded(touch,point)
		end
		self.m_isFinish = true
		self:clearTouch()
		self.m_model:finish()
	end

	if self.m_isForce and g_scene.m_lockGuide <= 0 then
		g_scene.m_lockGuide = g_scene.m_lockGuide + 1
		self.m_node.m_touch.m_unlock = 1
	end
end

function This:onEnter()
	super.onEnter(self)
	self:showFinger()
	self:initTouchEvent()
	self:initFingerEvent()
end

function This:onExit()
	super.onExit(self)
	self:clearTouch()
	self:removeFingerEvent()
end

function This:highLightRect(targetRect)
    local lightBoxSprite = cc.Scale9Sprite:create("Common/Guide/gaoliangkuang.png")
    lightBoxSprite:setContentSize(cc.visible.width, cc.visible.height)
    self:addChild(lightBoxSprite)
    local width, height = lightBoxSprite:getContentSize()
    local rect = cc.Rect(targetRect)
    rect:centerExtend(50, 50)
    local anchorY = rect.y / (height - rect:getMaxY() + rect.y)
    local anchorX = rect.x / (width - rect:getMaxX() + rect.x)

    lightBoxSprite:setPosition(width * 0.5, height * 0.5)
    lightBoxSprite:applyAnchorPoint(anchorX, anchorY)
    lightBoxSprite:setOpacity(0)
    lightBoxSprite:runAction(cc.Sequence(cc.Spawn(cc.FadeIn(0.2), cc.SizeTo(0.3, rect.width, rect.height, "CubicIn")), cc.DelayTime(0.2), cc.FadeOut(0.4), cc.RemoveAction()))
    if self.m_drawNode then
        self.m_drawNode:clear()
        self.m_drawNode:drawSolidRect(targetRect, cc.Color.WHITE)
    end
end

function This:showFinger()
    if not self.m_finger then
        self.m_finger = cc.Node:createFromCSFile("Common/NodeUI/Finger.csb")
        self.m_finger:playCSAnimation()
		self.m_finger:setRotation(-self.m_dir)
        self:addChild(self.m_finger)
    end
	if self.m_touchRect then
		local x , y = self.m_touchRect:getCenterXY()
		self.m_finger:setPosition(x + self.m_offset.x,y + self.m_offset.y)
	else
		self.m_finger:setPosition(self.m_node:convertToNodeSpaceAR(self.m_offset.x, self.m_offset.y))
	end
end

function This:disappear()
	print("---------disappear------------",self.m_model:getId())
	self:clearTouch()
	self:runAction(cc.Sequence(cc.FadeOut(0.3), cc.RemoveAction()))
end

function This:initFingerEvent()
	if not self.m_fingerEvent then
		return
	end

	for i, event in ipairs(self.m_fingerEvent) do
		EventDispathcer:addListener(self, event, function(obj, isShow)
			print(string.format("收到手指事件%s", event, tostring(isShow)))
			
			if event == "guide_finger_visible" then
				self:setVisible(isShow)
				return
			end
		end)
	end
end

function This:removeFingerEvent()
	if not self.m_fingerEvent then
		return
	end

	for i , event in ipairs(self.m_fingerEvent) do
		EventDispathcer:removeListener(self,event)
	end	
end