--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"Base.BaseModel")
local GuideEntry = require("Guide.GuideEntry")
local EventDispatcher = require("EventDispatcher")
local Socket = require("Net.Socket")
local GuideEntryConfig = require("Metadatas.GuideEntryConfig")
local GamePlayer = require("Player.GamePlayer")
local SdkManager = require("Sdk.SdkManager")
local TerrBuildLvUpGuide = require("Guide.TerrBuildLvUpGuide")
local CityFightGuide = require("Guide.CityFightGuide")
local ArmySpeedUpGuide = require("Guide.ArmySpeedUpGuide")
local CityBuildGuide = require("Guide.CityBuildGuide")
local HeroUpgradeGuide = require("Guide.HeroUpgradeGuide")
local ClickBtnGuide = require("Guide.ClickBtnGuide")
local CityBuildUpgradeGuide = require("Guide.CityBuildUpgradeGuide")
local ChangeSceneGuide = require("Guide.ChangeSceneGuide")
local HeroStarUpGuide = require("Guide.HeroStarUpGuide")
local CultivateSoilderGuide = require("Guide.CultivateSoilderGuide")
local AddDeputyGuide = require("Guide.AddDeputyGuide")
local WearEquipGuide = require("Guide.WearEquipGuide")
local StrengthEquipGuide = require("Guide.StrengthEquipGuide")
local TerrBuildGuide = require("Guide.TerrBuildGuide")
local HeroSuMingGuide = require("Guide.HeroSuMingGuide")
local HeroEquipClearGuide = require("Guide.HeroEquipClearGuide")


g_guideUtil = require("Guide.GuideUtil")

GuideNodeVisible = 
{
	MiniMapTotoBtn = 13,
	WorldBattleBox = 13,
	ForeignBtn = 13,
	JiCeBtn = 0,
	ZhaoBingMaiMaBtn = 7,
}

local kMaxGuideStepIndex = 10000

AncGuideType =   --非强制指引类型
{
	kTerrBuildLvUp = 1, --封地建筑升级指引
	kCityFightGuide = 2, --城市出征指引
	kArmySpeedUpGuide = 3, --指引加速
	kCityBuildGuide = 4, --城池建设
	kHeroUpdateGuide = 5, --武将升级
	kClickBtnGuide = 6, --点击按钮指引
	kCityBuildUpgrade = 7, --
	kChangeSceneGuide = 8, --场景转换
	kHeroUpstarGuide = 9, --武将升星
	kTrainSoilderGuide = 10, --培养兵种
	kAddDeputyGuide = 11, --添加副将
	kWearEquipGuide = 12, --穿戴装备
	kStrengthEquipGuide = 13, --强化装备
	kTerrBuildGuide = 14, --封地建筑指引
	kHeroSuMingGuide = 15, --英雄宿命
	kHeroEquipClearGuide = 16, --英雄洗练
}

function This:init()
	super.init(self)
	self.m_entryList = {}
	self.m_entryIndex = 1
	self.m_unitIndex = 1
	self.m_guideEntry = nil
	self.m_saveData = cc.FileUtils:loadLuaFile("Guide") or {entry_index = 1, unit_index = 1}
	self:initListener()
end

function This:initListener()
	EventDispatcher:addListener(self,11400,self.onUpdateGuideProgressReply)
	EventDispatcher:addListener(self,11401,self.onGetGuideDataNotify)
end

function This:isInGuide()
	return self.m_guideEntry ~= nil
end

function This:hasGuiderRunning()
	if self.m_guideEntry and self.m_guideEntry:isRunning() then
		return true
	end
	if self.m_ancGuide then
		return true
	end
	return false
end

function This:hasAncGuider()
	return self.m_ancGuide and self.m_ancGuide:isRunning()
end

function This:getGuideStep()
	if self.m_guideEntry then
		return self.m_guideEntry:getId()
	end
	return kMaxGuideStepIndex
end

function This:getCurGuideEntry()
	return self.m_guideEntry
end

function This:pauseGuide()
	if self.m_guideEntry then
		self.m_guideEntry:pause()
	end
end

function This:resumeGuide()
	if self.m_guideEntry then
		self.m_guideEntry:resume()
	end
end

function This:setProgress(entryIndex,unitIndex,isSave)
	if not g_setting.isGuide then
		return
	end
	if GuideEntryConfig[entryIndex] then
		print(string.format("开始执行步骤，enetryIndex = %d, unitIndex = %d",entryIndex,GuideEntryConfig[entryIndex].unit_list[unitIndex]))
		if not self.m_guideEntry or self.m_guideEntry:getId() ~= entryIndex then
			if self.m_guideEntry then
				self.m_guideEntry:clear()
			end	
			self.m_guideEntry = GuideEntry:create(entryIndex)
			self.m_guideEntry:setIndex(unitIndex)
		else
			self.m_guideEntry:setIndex(unitIndex)
		end
	elseif self.m_guideEntry then
		self.m_guideEntry:clear()
		self.m_guideEntry = nil
		self:notifyObservers("onGuideFinish")
		EventDispatcher:dispatcher("guide_finish")
	end
	self.m_saveData.entry_index = entryIndex
	self.m_saveData.unit_index = unitIndex
	if false then
		cc.FileUtils:saveToLua(self.m_saveData,"Guide")
	end
end

function This:getProgress()
	return self.m_saveData.entry_index , self.m_saveData.unit_index
end

function This:getAncGuider(guideData)
	--guideData = {id = AncGuideType.kStrengthEquipGuide}
	local guider = nil
	if guideData.id == AncGuideType.kTerrBuildLvUp then
		guider = TerrBuildLvUpGuide:create(guideData)
	elseif guideData.id == AncGuideType.kCityFightGuide then
		guider = CityFightGuide:create(guideData)
	elseif guideData.id == AncGuideType.kArmySpeedUpGuide then
		guider = ArmySpeedUpGuide:create(guideData)
	elseif guideData.id == AncGuideType.kCityBuildGuide then
		guider = CityBuildGuide:create(guideData)
	elseif guideData.id == AncGuideType.kHeroUpdateGuide then
		guider = HeroUpgradeGuide:create(guideData)
	elseif guideData.id == AncGuideType.kClickBtnGuide then
		guider = ClickBtnGuide:create(guideData)
	elseif guideData.id == AncGuideType.kCityBuildUpgrade then
		guider = CityBuildUpgradeGuide:create(guideData)
	elseif guideData.id == AncGuideType.kChangeSceneGuide then
		guider = ChangeSceneGuide:create(guideData)
	elseif guideData.id == AncGuideType.kHeroUpstarGuide then
		guider = HeroStarUpGuide:create(guideData)
	elseif guideData.id == AncGuideType.kTrainSoilderGuide then
		guider = CultivateSoilderGuide:create(guideData)
	elseif guideData.id == AncGuideType.kAddDeputyGuide then
		guider = AddDeputyGuide:create(guideData)
	elseif guideData.id == AncGuideType.kWearEquipGuide then
		guider = WearEquipGuide:create(guideData)
	elseif guideData.id == AncGuideType.kStrengthEquipGuide then
		guider = StrengthEquipGuide:create(guideData)
	elseif guideData.id == AncGuideType.kTerrBuildGuide then
		guider = TerrBuildGuide:create(guideData)
	elseif guideData.id == AncGuideType.kHeroSuMingGuide then
		guider = HeroSuMingGuide:create(guideData)
	elseif guideData.id == AncGuideType.kHeroEquipClearGuide then
		guider = HeroEquipClearGuide:create(guideData)
	end
	assert(guider)
	return guider
end

function This:triggerAncGuider(guideData)
	if self.m_guideEntry and self.m_guideEntry:isRunning() then
		return
	end
	local guider = self.m_ancGuide
	if guider then
		guider:cancel()
	end
	self.m_ancGuide = self:getAncGuider(guideData)
	self.m_ancGuide:setCancelHandler(function()
		if self.m_ancGuide then
			local guider = self.m_ancGuide
			self.m_ancGuide = nil
			guider:cancel()
		end
	end)
	self.m_ancGuide:start()
end

function This:cancelAncGuider()
	if self.m_ancGuide  then
		if self.m_ancGuide:isCrossScene() then
			self.m_ancGuide:checkView()
		else
			self.m_ancGuide:cancel()
			self.m_ancGuide = nil
		end
	end
end

function This:skipGuide()
	local entryIndex , unitIndex = self.m_saveData.entry_index, self.m_saveData.unit_index
	if self.m_guideEntry and entryIndex > 0 and unitIndex > 0 then
		self.m_isSkiping = true
		self:onUpdateGuideProgressRequest(entryIndex,unitIndex)
	else
		self.m_isSkiping = false
	end
end

function This:checkSkip()
	if self.m_isSkiping then
		local timer = g_scene.m_timer
		timer:setTimer(0.5,function()
			self:skipGuide()
		end,"skip_guide")
	end
end

function This:playSound(sound)
	if sound ~= "" then
		if self.m_soundId then
			cc.Audio:stopEffect(self.m_soundId)
		end
		self.m_soundId = cc.Audio:playEffect(sound,false)
	end
end

-----------------------------------------------
function This:onUpdateGuideProgressRequest(enetryIndex,unitIndex)
	print(string.format("更新进度：enetryIndex = %d, unitIndex = %d , socket.m_maskKey = %s",enetryIndex,unitIndex,tostring(Socket.m_maskKey)))
	Socket:sendAndLock(11400,{enetry_index = enetryIndex, unit_index = unitIndex})
end

function This:onUpdateGuideProgressReply(msg)
	print(string.format("返回数据：Socket.m_maskKey = %s",tostring(Socket.m_maskKey)))
	if msg.err_code ~= 0 then
		g_scene:handleErrorCode(msg.err_code)
	elseif self.m_guideEntry then
		if self.m_guideEntry:getIndex() >= self.m_guideEntry:getMaxIndex() then
			self:setProgress(self.m_guideEntry:getId() + 1,1)
		else
			self:setProgress(self.m_guideEntry:getId(), self.m_guideEntry:getIndex() + 1)
		end
		self:notifyObservers("onGuideNextStep",self.m_guideEntry)
		EventDispatcher:dispatcher("guide_next_step")
	end
	SdkManager:submitPlayerInfo("noviceProcess")
	if os.isWin32 then
		self:checkSkip()
	end
end

function This:onGetGuideDataNotify(msg)
	local enetryIndex = msg.enetry_index == 0 and 1 or msg.enetry_index
	local unitIndex = msg.unit_index
	if GuideEntryConfig[enetryIndex] then
		local endIndex = GuideEntryConfig[enetryIndex].end_type
		print(string.format("endIndex = %d, unitIndex = %d",endIndex,unitIndex))
		if unitIndex >= endIndex then
			enetryIndex = GuideEntryConfig[enetryIndex].next_guide
			unitIndex = 1     
		else
			unitIndex = 1
		end
	else
		enetryIndex = kMaxGuideStepIndex
		unitIndex = 1
	end
	--self:setProgress(18,1)
	self:setProgress(enetryIndex,unitIndex)
end

function This:showHomeBottomButton()
	self:notifyObservers("showBottomButton")
end

function This:showHomeTopButton()
	self:notifyObservers("showTopButton")
end

function This:showRecommend()
	self:notifyObservers("showRecommend")
end

--endregion
