--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This, super = class(...,"cc.Node")
local HeroConfig  = require("Metadatas.HeroConfig")
local GamePlayer = require("Player.GamePlayer")
local DynamicScreenshot = require("cc.DynamicScreenshot")
local DefaultIcon = 
{
	[1] = "Icons/Player/quanshen1.png",
	[2] = "Icons/Player/quanshen2.png",
	[3] = "Icons/Player/quanshen3.png",
	[4] = "Icons/Player/quanshen4.png",
	[5] = "Icons/Player/quanshen5.png",
	[6] = "Icons/Player/quanshen6.png",
}

function This:init(info)
	self.m_isForce = info.isForce
	self.m_model = info.model
	self.m_dir = info.dir
	self.m_heroId = info.heroId or 1
	self.m_name = info.name or Serialize["guide_SessionView_1"]
	self.m_desp = info.desp or ""
	self.m_text = info.text or ""
	self.m_isRemoving = false
	if not info.icon then
		self.m_icon = DefaultIcon[GamePlayer:getIcon()]
	else
		self.m_icon = info.icon or "Common/Guide/zynpc.png"
	end

	--if self.m_dir == "left" then
	self.m_csNode = cc.Node:createFromCSFile("Common/NodeUI/GuideTips.csb")
	--[[elseif self.m_dir == "right" then
		self.m_csNode = cc.Node:createFromCSFile("Common/NodeUI/GuideTips1.csb")
	else
		print("会话缺少方向...")
	end]]

    self:addChild(self.m_csNode)
	self.m_csNode:recoveryToFixedWidth("left","bottom")

	if self.m_csNode.name then
		self.m_csNode.name:setString(self.m_name)
	end
	if self.m_csNode.weicheng then 
		self.m_csNode.weicheng:setString(self.m_desp,10)
	end
    self.m_csNode.text:setStringWithColor(self.m_text, 500)
	self.m_csNode.manicon:setImage(self.m_icon)
	if not info.icon then
		self.m_csNode.manicon:setScale(0.85)
	end

    self.m_allowTouch = false

	self:setCascadeOpacityEnabled(true)
	self:setOpacity(0)
	self:runAction(cc.Sequence(cc.FadeIn(0.3), cc.CallFunc(function()
		self.m_allowTouch = true
	end)))

	local layer = cc.LayerColor:create(cc.Color(0,0,0,118))
	self:addChild(layer,-1)

	--layer:setCascadeOpacityEnabled(false)

	--[[self.m_screenNode = cc.RenderTexture:create(cc.visible.width,cc.visible.height,1)
	self.m_screenNode:setPosition(cc.visible.center.x,cc.visible.center.y)
	self:addChild(self.m_screenNode,-1)
	self.m_screenNode:setShaderByID("Blur1")]]
end

function This:initTouchEvent()
	self:addTouchListener({
        isSwallow = true,
        onBegan = function (touch, point)
           return true
        end, 
		onEnded = function(touch)
			self:onTouchMask()
		end,
		isDynamic = true,
    })
end

function This:onEnter()
	super.onEnter(self)
	self:initTouchEvent()
	self.m_csNode:playCSAnimation(nil,false)
end

function This:onExit()
	super.onExit(self)
	self.m_isRemoving = true
	self:unscheduleUpdate()
end

function This:onTouchMask()
	if self.m_isFinish then
		return 
	end
    if self.m_allowTouch then
		self.m_isFinish = true
		self.m_model:finish()
    end
end

function This:disappear()
	--self.m_screenNode:clear()
	--self.m_screenNode:removeFromParent()
	--self:removeFromParent()
	print("开始删除指引view ",self.m_model:getId())
	self:runAction(cc.Sequence(cc.FadeOut(0.3),cc.CallFunc(function()
		self:removeFromParent()
		print("结束删除指引view ", self.m_model:getId())
	end)))
end

function This:update(dt)
	--[[if self.m_isRemoving then
		return 
	end
	self:setVisible(false)
	self.m_screenNode:clear()
	self.m_screenNode:beginRender()
	g_scene:visit()
	self.m_screenNode:endRender()
	self:setVisible(true)]]
end

--endregion
