--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"Guide.GuideAncBase")
local HeroManager = require("Hero.HeroManager")
local EquipManager = require("Equip.EquipManager")
local GamePlayer = require("Player.GamePlayer")
local DepotManager = require("Depot.DepotManager")

local SeSG = 
{
	kFinishGuide = 0,
	kClickMenuHeroBtnGuide = 1, 
	kClickWorldHeroBtnGuide = 2,
	kHeroListPanelGuide = 3,
	kWearEquipPos1 = 4, 
	kWearEquipPos2 = 5,
	kWearEquipPos3 = 6, 
	kOpenStrengthPanel = 7, 
	kClickClearBtn = 8,

	kInterrupt = 10,
}

local NodePath = 
{
	[SeSG.kClickMenuHeroBtnGuide] = "MenuScene.sceneUI.m_csNode.panel_btns.hero",
	[SeSG.kClickWorldHeroBtnGuide] = "WorldScene.sceneUI.m_csNode.panel_btns.hero",
	[SeSG.kWearEquipPos1] = "MenuScene.HeroPanel.m_csNode.GrowTabNode.m_csNode.weaponslot",
	[SeSG.kWearEquipPos2] = "MenuScene.HeroPanel.m_csNode.GrowTabNode.m_csNode.clothesslot",
	[SeSG.kWearEquipPos3] = "MenuScene.HeroPanel.m_csNode.GrowTabNode.m_csNode.horseslot",
	[SeSG.kOpenStrengthPanel] = "MenuScene.EquipTips.m_csNode.strengthenbotton",
	[SeSG.kClickClearBtn] = "MenuScene.EquipStrengthPanel.m_csNode.tep3",
}

function This:init(info)
	self.m_events = {"dialog_close","dialog_open","list_finish","hero_equip_changed"}
	super.init(self,info)
end

function This:initGuide()
	super.initGuide(self)
	self.m_view:setTouchHandler(function()
		if self.m_view then
			self.m_view:setNode(nil)
			local state = self:getState()
			if state == SeSG.kClickClearBtn then
				self:finish()
			end
		end
	end)
end

function This:getState()
	if g_scene:getName() ~= "MenuScene" and g_scene:getName() ~= "WorldScene" then
		return
	end

	-- local function checkStrength(equip)
	-- 	if equip:getPlayerLvLimit() < GamePlayer:getLevel() then
	-- 		local itemList = equip:getCostItemList()
	-- 		for i , info in ipairs(itemList) do
	-- 			if DepotManager:getItemCount(info.id) < info.num then
	-- 				return false
	-- 			end
	-- 		end
	-- 		return true
	-- 	end
	-- 	return false
	-- end

	-- local function checkEquip(hero)
	-- 	for i = EquipPos.kWeapons, EquipPos.kHorse do
	-- 		if hero:isWearEquip(i) then
	-- 			return i
	-- 		end
	-- 	end
	-- end

	local function isWearEquip(hero)
		for i = EquipPos.kWeapons, EquipPos.kHorse do
			if hero:isWearEquip(i) then
				return true
			end
		end
	end

	local panel = g_scene:getTopDialog()
	if not panel or panel[0] == 0 then
		if self.m_view:getClickCount() > 0 then
			return SeSG.kFinishGuide
		else
			if g_scene:getName() == "MenuScene" then
				return SeSG.kClickMenuHeroBtnGuide
			elseif g_scene:getName() == "WorldScene" then
				return SeSG.kClickWorldHeroBtnGuide
			end
		end
	elseif panel:getName() == "HeroListPanel" then
		local function selectItem(view)
			local w , h = panel.m_csNode.heroList:getContentSize()
			local x , y = view:getPosition()
			local w1 , h1 = panel.m_csNode.heroList:getInnerContainerSize()
			local x1 , y1 = panel.m_csNode.heroList:getInnerContainerPosition()
			local ny = math.min(0, math.max(h - h1,h/2 - y))
			panel.m_csNode.heroList:setInnerContainerPosition(x1, ny)
		end

		local listLayer = panel.m_listLayer
		for i , view in ipairs(listLayer.m_views) do
			if view:isVisible() then
				local heroId = view.m_heroId
				local hero = HeroManager:getHero(heroId)
				if isWearEquip(hero) then
					self.m_heroId = heroId
					self.m_heroView = view
					selectItem(view)
					return SeSG.kHeroListPanelGuide
				end
			end
		end

		return SeSG.kInterrupt
	elseif panel:getName() == "HeroPanel" then
		if self.m_heroId == panel.m_heroId then
			local hero = HeroManager:getHero(self.m_heroId)
			for i = EquipPos.kWeapons , EquipPos.kHorse do
				if hero:isWearEquip(i) then
					return SeSG["kWearEquipPos"..i]
				end
			end
			return SeSG.kInterrupt
		end
	elseif panel:getName() == "EquipTips" then
		return SeSG.kOpenStrengthPanel
	elseif panel:getName() == "EquipStrengthPanel" then
		return SeSG.kClickClearBtn
	elseif panel:getName() == "ItemTips" then
		return SeSG.kInterrupt
	end
end

function This:getNode(state)
	if NodePath[state] then
		return self:getNodeByPath(NodePath[state])
	elseif state == SeSG.kHeroListPanelGuide then
		if self.m_heroView and self.m_heroView[0] ~= 0 then
			return self.m_heroView
		end
	end
end

--endregion
