--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"Guide.GuideAncBase")
local DepotManager = require("Depot.DepotManager")
local UniversalConfig = require("Metadatas.UniversalConfig")
local HeroManager = require("Hero.HeroManager")

local HsSG = 
{
	kFinishGuide = 0,
	kClickMenuHeroBtnGuide = 1, --引导点击封地武将按钮
	kClickWorldHeroBtnGuide = 2, --引导点击世界武将按钮
	kClickListPanelGuide = 3, --引导点击listPanel武将
	kUpgradeStarBtn = 4, --引导点击升星按钮
	kClickExchangeBtn = 5 , --引导点击兑换按钮
	kPieceExchangeGuide = 6, --碎片兑换指引
	kExchangeNumGuide = 7, --碎片兑换数目指引
	kInterrupt = 8, 
	kUpgradePhaseBtn = 9, --
}

local NodePath = 
{
	[HsSG.kClickMenuHeroBtnGuide] = "MenuScene.sceneUI.m_csNode.panel_btns.hero",
	[HsSG.kClickWorldHeroBtnGuide] = "WorldScene.sceneUI.m_csNode.panel_btns.hero",
	[HsSG.kExchangeNumGuide] = "MenuScene.PieceExchangePanel.m_csNode.Max",
	[HsSG.kPieceExchangeGuide] = "MenuScene.PieceExchangePanel.m_csNode.exchange",
	[HsSG.kUpgradePhaseBtn] = "MenuScene.HeroPanel.m_csNode.GrowTabNode.m_csNode.Star.stairsupbutton",
	[HsSG.kClickExchangeBtn] = "MenuScene.HeroPanel.m_csNode.GrowTabNode.m_csNode.exchange",
	[HsSG.kUpgradeStarBtn] = "MenuScene.HeroPanel.m_csNode.GrowTabNode.m_csNode.Star.starupbotton",
}

function This:init(info)
	self.m_heroId = info.hero
	self.m_events = {"dialog_close","dialog_open","list_finish"}
	super.init(self,info)
end

function This:initGuide()
	super.initGuide(self)
	self.m_view:setTouchHandler(function()
		if self.m_view then
			local panel = g_scene:getTopDialog()
			if panel and panel:getName() == "PieceExchangePanel" then
				self.m_view:setNode(nil)
				g_scene.m_timer:setTimer(0,function()
					self:update()
				end,"hero_star_up_anc_guide")
			end
		end
	end)
end

function This:getState()
	local function checkUpstar(heroId)
		local hero = HeroManager:getHero(heroId)
		local phase = hero:getPhase()
		local quality = hero:getQuality()
		local quaStarConfig = hero:getNextQualityStarConfig()
		local itemId = 121

		local isCanUpPhase = false
		local isCanUpStar = false
		local isCanExChange = false

		if hero:getLevel() >= quaStarConfig.level_limit then
			if phase < 4 then
				local cost = quaStarConfig.stone_cost
				local num = DepotManager:getItemCount(113)
				if num >= cost then
					isCanUpPhase = true
				end
			else
				local cost = quaStarConfig.debris_cost
				local price = UniversalConfig[itemId * 100 + quality].exchange_count
				local count = DepotManager:getItemCount(itemId)
				local num = DepotManager:getItemCount(10000 + heroId)
				isCanUpStar = num >= cost

				local total = math.floor(count / price) + num
				if total >= cost then
					isCanExChange = true
				end
			end
		end
		return isCanUpPhase , isCanUpStar, isCanExChange
	end
	
	if g_scene:getName() ~= "MenuScene" and g_scene:getName() ~= "WorldScene" then
		return
	end
	local panel = g_scene:getTopDialog()
	if not panel or panel[0] == 0 then
		if self.m_view:getClickCount() > 0 then
			return HsSG.kFinishGuide
		else
			if g_scene:getName() == "MenuScene" then
				return HsSG.kClickMenuHeroBtnGuide
			elseif g_scene:getName() == "WorldScene" then
				return HsSG.kClickWorldHeroBtnGuide
			end
		end
	elseif panel:getName() == "HeroListPanel" then
		local function selectItem(view)
			local w , h = panel.m_csNode.heroList:getContentSize()
			local x , y = view:getPosition()
			local w1 , h1 = panel.m_csNode.heroList:getInnerContainerSize()
			local x1 , y1 = panel.m_csNode.heroList:getInnerContainerPosition()
			local ny = math.min(0, math.max(h - h1,h/2 - y))
			panel.m_csNode.heroList:setInnerContainerPosition(x1, ny)
		end
		local listLayer = panel.m_listLayer
		for i , view in ipairs(listLayer.m_views) do
			if view:isVisible() then
				local heroId = view.m_heroId
				local isCanUpPhase , isCanUpStar , isCanExchange = checkUpstar(heroId)
				if isCanUpPhase or isCanUpStar or isCanExchange then
					self.m_heroId = heroId
					selectItem(view)
					return HsSG.kClickListPanelGuide
				end
			end
		end	
		return HsSG.kInterrupt
	elseif panel:getName() == "HeroPanel" then
		local tab = panel:getCurSelectTab()
		if tab == "equip" and self.m_heroId then
			local isCanUpPhase , isCanUpStar , isCanExchange = checkUpstar(self.m_heroId) 
			if isCanUpPhase then
				return HsSG.kUpgradePhaseBtn
			elseif isCanUpStar then
				return HsSG.kUpgradeStarBtn				
			elseif isCanExchange then
				return HsSG.kClickExchangeBtn
			end
		end 
	elseif panel:getName() == "PieceExchangePanel" then
		if panel.m_curCount <= 0 then
			return HsSG.kExchangeNumGuide
		else
			return HsSG.kPieceExchangeGuide
		end
	end
end

function This:getNode(state)
	if NodePath[state] then
		return self:getNodeByPath(NodePath[state])
	elseif state == HsSG.kClickListPanelGuide then
		local panel = g_scene:getTopDialog()
		local listLayer = panel.m_listLayer
		if self.m_heroId then
			for i , view in ipairs(listLayer.m_views) do
				if view:isVisible() and view.m_heroId == self.m_heroId then
					return view
				end
			end
		end
	end
end

function This:update(state)
	if not state then
		state = self:getState()
	end
	if state then
		if state == 0 then
			self:finish()
		else
			local node = self:getNode(state)
			self.m_view:setNode(node)
		end
	else
		self:cancel()
	end
end

--endregion
