

--武将宿命引导

local This , super = class(...,"Guide.GuideAncBase")
local HeroManager = require("Hero.HeroManager")
local GamePlayer = require("Player.GamePlayer")
local HeroLevelExpConfig = require("Metadatas.HeroLevelExpConfig")
local ClickBtnGuide = require("Guide.ClickBtnGuide")

local HuSG = 
{
	kClickMenuHeroBtnGuide = 1, --引导点击封地武将按钮
	kClickListPanelGuide = 2, --引导点击listPanel武将
	kHeroPanelClickGuide = 3,
	kClickJiHuoGuide = 4,
	kFinishGuide = 10,
}

local NodePath = 
{
	[HuSG.kClickMenuHeroBtnGuide] = "MenuScene.sceneUI.m_csNode.panel_btns.hero",
	[HuSG.kClickJiHuoGuide] = "MenuScene.FateInfoPanel.m_csNode.jihuobutton",
}

function This:init(info)
	self.m_heroId = info.hero
	self.m_events = {"update_hero_state","dialog_close","dialog_open","list_finish"}

	super.init(self,info)
end

function This:getState()
	if g_scene:getName() ~= "MenuScene" and g_scene:getName() ~= "WorldScene" then
		return
	end

	if self.m_guideState == HuSG.kClickJiHuoGuide then
		return HuSG.kFinishGuide
	end

	local panel = g_scene:getTopDialog()
	if not panel or panel[0] == 0 then
		if self.m_view:getClickCount() > 0 then
			return HuSG.kFinishGuide
		end
		return HuSG.kClickMenuHeroBtnGuide
		
	elseif panel:getName() == "HeroListPanel" then
		if HeroManager:getHeroGotCount() > 0 then
			return HuSG.kClickListPanelGuide
		end
		return HuSG.kFinishGuide

	elseif panel:getName() == "HeroPanel" then
		if not self.m_clickGuider then
			local path = {
				"MenuScene.HeroPanel.m_csNode.teb5",
				"MenuScene.HeroPanel.m_csNode.FateTabNode.m_csNode.scrollView.scrollNode0.m_csNode.chakan",
			}
			self.m_clickGuider = ClickBtnGuide:create({
				path = path,
				dir = self.m_dir,
				father = self
			})
			self.m_clickGuider:start()
		end
		return HuSG.kHeroPanelClickGuide

	elseif panel:getName() == "FateInfoPanel" then
		if self.m_guideState == HuSG.kClickJiHuoGuide then
			return HuSG.kFinishGuide
		end

		local fate = panel.m_fate
		local level = fate:getLevel()
		local totalLev = panel.m_totalLev 

        if level <= 0 then
        	if fate:canActivate() then
            	return HuSG.kClickJiHuoGuide
            end
        else
            if level < totalLev and fate:canUpgrade() then
                return HuSG.kClickJiHuoGuide
            end
        end

        return HuSG.kFinishGuide
	end

end

function This:getNode(state)
	if NodePath[state] then
		return self:getNodeByPath(NodePath[state])
	elseif state == HuSG.kClickListPanelGuide then
		local panel = g_scene:getTopDialog()
		local listLayer = panel.m_listLayer		
		for i , view in ipairs(listLayer.m_views) do
			if view:isVisible() then
				return view
			end
		end
	end
end

function This:update(state)
	if not state then
		state = self:getState()
	end
	if state == HuSG.kFinishGuide then
		self:finish()
	elseif state ~= HuSG.kHeroPanelClickGuide then
		local node = self:getNode(state)
		self.m_view:setNode(node)
	end
	self.m_guideState = state
end

function This:next()
	if self.m_clickGuider then
		self.m_clickGuider = nil
	end
end

function This:cancel()
	super.cancel(self)
	if self.m_clickGuider then
		self.m_clickGuider:cancel()
		self.m_clickGuider = nil
	end
end

function This:isRunning()
	if self.m_clickGuider then
		return self.m_clickGuider:isRunning()
	else
		return self.m_view and self.m_view:isVisible()
	end
end

