--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"Guide.GuideAncBase")
local HeroManager = require("Hero.HeroManager")
local GamePlayer = require("Player.GamePlayer")
local HeroLevelExpConfig = require("Metadatas.HeroLevelExpConfig")

local HuSG = 
{
	kClickMenuHeroBtnGuide = 1, --引导点击封地武将按钮
	kClickWorldHeroBtnGuide = 2, --引导点击世界武将按钮
	kClickListPanelGuide = 3, --引导点击listPanel武将
	kClickUpgradeBtn = 4, --点击升级按钮
	kFinishGuide = 5,
}

local NodePath = 
{
	[HuSG.kClickMenuHeroBtnGuide] = "MenuScene.sceneUI.m_csNode.panel_btns.hero",
	[HuSG.kClickWorldHeroBtnGuide] = "WorldScene.sceneUI.m_csNode.panel_btns.hero",
	[HuSG.kClickUpgradeBtn] = "WorldScene.HeroPanel.m_csNode.GrowTabNode.m_csNode.levelupbotton"
}

function This:init(info)
	self.m_heroId = info.hero
	self.m_events = {"update_hero_state","dialog_close","dialog_open","list_finish"}
	super.init(self,info)
end

function This:getState()
	if g_scene:getName() ~= "MenuScene" and g_scene:getName() ~= "WorldScene" then
		return
	end

	local panel = g_scene:getTopDialog()
	if not panel or panel[0] == 0 then
		if self.m_view:getClickCount() > 0 then
			return HuSG.kFinishGuide
		else
			if g_scene:getName() == "MenuScene" then
				return HuSG.kClickMenuHeroBtnGuide
			elseif g_scene:getName() == "WorldScene" then
				return HuSG.kClickWorldHeroBtnGuide
			end
		end
	elseif panel:getName() == "HeroListPanel" then
		if self.m_heroId and self.m_oldLevel then
			local hero = HeroManager:getHero(self.m_heroId)
			if self.m_oldLevel < hero:getLevel() then
				return HuSG.kFinishGuide
			end
		end
		local function selectItem(view)
			local w , h = panel.m_csNode.heroList:getContentSize()
			local x , y = view:getPosition()
			local w1 , h1 = panel.m_csNode.heroList:getInnerContainerSize()
			local x1 , y1 = panel.m_csNode.heroList:getInnerContainerPosition()
			local ny = math.min(0, math.max(h - h1,h/2 - y))
			panel.m_csNode.heroList:setInnerContainerPosition(x1, ny)
		end
		local listLayer = panel.m_listLayer
		for i , view in ipairs(listLayer.m_views) do
			if view:isVisible() then
				local heroId = view.m_heroId
				local hero = HeroManager:getHero(heroId)
				if hero:getLevel() < GamePlayer:getLevel() then
					if HeroLevelExpConfig[hero:getLevel() + 1].exp <= GamePlayer:getReserveExp() then
						self.m_heroId = heroId
						self.m_oldLevel = hero:getLevel()
						selectItem(view)
						return HuSG.kClickListPanelGuide
					end
				end
			end
		end	
	elseif panel:getName() == "HeroPanel" then
		local hero = HeroManager:getHero(panel.m_heroId)
		if hero:getLevel() < GamePlayer:getLevel() then
			if HeroLevelExpConfig[hero:getLevel() + 1].exp <= GamePlayer:getReserveExp() then
				local node = panel:getTabNode("equip")
				if node and node.m_csNode.levelupbotton and node.m_csNode.levelupbotton:isVisible() then
					return HuSG.kClickUpgradeBtn
				end			
			end
		end
	end
end

function This:getNode(state)
	if NodePath[state] then
		return self:getNodeByPath(NodePath[state])
	elseif state == HuSG.kClickListPanelGuide then
		local panel = g_scene:getTopDialog()
		local listLayer = panel.m_listLayer
		if self.m_heroId then
			for i , view in ipairs(listLayer.m_views) do
				if view:isVisible() and view.m_heroId == self.m_heroId then
					return view
				end
			end
		end
	end
end

function This:update(state)
	if not state then
		state = self:getState()
	end
	if state == HuSG.kFinishGuide then
		self:finish()
	else
		local node = self:getNode(state)
		self.m_view:setNode(node)
	end
end

--endregion
