--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"Guide.GuideAncBase")
local WorldMapManager = require("World.WorldMapManager")
local EventDispatcher = require("EventDispatcher")
local GuideAncView = require("Guide.GuideAncView")

local HtGS = 
{
	kSlippageGuiding = 2, --滑动
	kDetermineGuiding = 3, --确定
	kFinishGuide = 4,
}

local NodePath = 
{
	[HtGS.kDetermineGuiding] = "WorldScene.TroopHpTransPanel.m_csNode.confirmbutton",
	[HtGS.kSlippageGuiding] = "WorldScene.TroopHpTransPanel.m_csNode.hpbg",
}

function This:init(info)
	self.m_cityId = info.city
	self.m_city = WorldMapManager:getCity(self.m_cityId)
	self.m_panelName = "TroopHpTransPanel"
	self.m_events = {"dialog_open","dialog_close"}
	super.init(self,info)
end

function This:getState()
	if g_scene:getName() ~= "WorldScene" then
		return
	end
	local panel = g_scene:getTopDialog()
	if panel and panel:getName() == self.m_panelName then
		if panel.m_hp > 0 then
			return HtGS.kDetermineGuiding
		else
			return HtGS.kSlippageGuiding
		end
	elseif not panel then
		if self.m_view:getClickCount() > 0 then
			return HtGS.kFinishGuide
		end
	end
end

function This:getNode(state)
	return self:getNodeByPath(NodePath[state])
end

function This:update(state)
	if not state then
		state = self:getState()
	else
		if state == HtGS.kFinishGuide then
			self:finish()
		elseif state == HtGS.kSlippageGuiding then
			local node = self:getNode(state)
			self.m_view:setIsSlide(true)
			self.m_view:setNode(node)
		else
			local node = self:getNode(state)
			self.m_view:setIsSlide(false)
			self.m_view:setNode(node)
		end
	end
end


--endregion
