--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"Guide.GuideAncBase")
local WorldMapManager = require("World.WorldMapManager")
local GuideAncView = require("Guide.GuideAncView")
local EventDispatcher = require("EventDispatcher")

local ScSG = 
{
	kMovingMap = 1, --移动地图
	kClickGuiding = 2, --指引点击
	kFinishGuiding = 3, --完成指引
}

function This:init(info)
	self.m_cityId = info.city
	self.m_isFrom = info.bFrom or false
	self.m_isFight = info.bFight or false
	self.m_city = WorldMapManager:getCity(self.m_cityId)
	if self.m_isFrom then
		self.m_events = {"city_state_changed","city_nemu_open"}
	else
		self.m_events = {"city_state_changed","city_nemu_open","dialog_open"}
	end
	self.m_isClicked = false 
	super.init(self,info)
end

function This:start()
	self.m_view:setTouchHandler(function()
		if self.m_view then
			self.m_view:setNode(nil)
			self.m_isClicked = true
			g_scene.m_timer:setTimer(0,function()
				--self:update()
			end,"scg_timer")
		end
	end)

	self.m_isMoving = true
	g_scene:focuseCity(self.m_cityId,function()
		self.m_isMoving = false
		self:update()
	end,true)
end

function This:getState()
	if g_scene:getName() ~= "WorldScene" then
		return
	end

	if self.m_isFight and self.m_city:isMy() then
		return
	end
	if not self.m_isFight and not self.m_city:isMy() then
		return
	end

	if self.m_isMoving then
		return ScSG.kMovingMap
	end

	local panel = g_scene:getTopDialog()
	local cityView = g_scene:getCityView(self.m_cityId)

	if (not self.m_view or self.m_view:getClickCount() >= 1) and self.m_isFrom  then
		if not cityView.m_menu  then
			return
		else
			return ScSG.kFinishGuiding
		end
	end
	
	if self.m_isFrom and not panel and cityView.m_menu then
		if not self.m_view or self.m_view:getClickCount() <= 1 then
			return ScSG.kFinishGuiding
		end
	elseif not self.m_isFrom and panel and (panel:getName() == "TroopEmbattlePanel" or panel:getName() == "TroopHpTransPanel") then
		return ScSG.kFinishGuiding
	else
		if self.m_isClicked then
			return ScSG.kFinishGuiding
		else
			if not panel then
				return ScSG.kClickGuiding
			end
		end
	end
end

function This:getNode(state)
	if state == ScSG.kClickGuiding then
		local cityView = g_scene:getCityView(self.m_cityId)
		return cityView.m_csNode.city
	end
end

function This:update(state)
	if not state then
		state = self:getState()
	end
	if not state  then
		self:cancel()
		return
	end
	if state == ScSG.kClickGuiding then
		local node = self:getNode(state)
		self.m_view:setNode(node)
	elseif state == ScSG.kFinishGuiding then
		self:finish()
	end
end

--endregion
