

--封地建筑功能指引

local This , super = class(...,"Guide.GuideAncBase")
local GuideUnitConfig = require("Metadatas.GuideUnitConfig")
local TerrBuildManager = require("Territory.TerrBuildManager")
local TerrBuild = require("Territory.TerrBuild")
local GuideAncView = require("Guide.GuideAncView")
local EventDispatcher = require("EventDispatcher")

local TbSG = 
{
	kMovingToCenter = 1, --移动到中心
	kClickBuildGuiding= 2, --指引点击建筑
	kClickGongNengBtn = 3, --点击功能按钮
	kFinishGuide = 4,
}

function This:init(info)
	self.m_type = info.type
	self.m_pos = info.pos
	self.m_state = 0
	self.m_events = {"dialog_open","dialog_close","menu_scene_enter"}
	self.m_build = TerrBuildManager:getBuildByType(self.m_type,self.m_pos)
	self.m_isMoving = false
	self.m_isFocused = false

	super.init(self,info)
end

function This:initGuide()
	super.initGuide(self)
	self.m_view:setTouchHandler(function()
		if self.m_view then
			self.m_view:setNode(nil)
			g_scene.m_timer:setTimer(0,function()
				if self.m_view then
					local state = self:getState()
					if state == TbSG.kClickGongNengBtn then
						self:update(state)
					end
				end
			end,"terr_build_guide")
		end
	end)
end

function This:getState()
	if g_scene:getName() ~= "MenuScene" then
		return
	end

	local panel = g_scene:getTopDialog()
	if not panel then
		if not self.m_isFocused then
			if not self.m_isMoving then	
				self.m_isMoving = true
				g_scene:focuseBuildByType(self.m_type,self.m_pos,function()
					self.m_isMoving = false
					self.m_isFocused = true
					self:update()
				end,true)
			end
			if self.m_isFocused then
				return TbSG.kClickBuildGuiding
			else
				return TbSG.kMovingToCenter
			end
		else
			local buildView = self.m_build:getView() 
			if buildView and buildView.m_csNode.GongNeng:isVisible() then
				return TbSG.kClickGongNengBtn
			else
				if self.m_view:getClickCount() <= 0 then
					return TbSG.kClickBuildGuiding
				else
					return TbSG.kFinishGuide
				end
			end
		end
	else
		return TbSG.kFinishGuide
	end
end

function This:getNode(state)
	if state == TbSG.kClickBuildGuiding then
		return g_scene:getBuildNode(self.m_type,self.m_pos)
	elseif state == TbSG.kClickGongNengBtn then
		local buildView = self.m_build:getView()
		if buildView then
			return buildView.m_csNode.GongNeng.bg2
		end
	end
end

function This:update(state)
	if not state then
		state = self:getState()
	end
	if state then
		if state == TbSG.kFinishGuide then
			self:finish()
		else
			local node = self:getNode(state)
			self.m_view:setNode(node)
		end
	else
		self:cancel()
	end
end

--endregion
