--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"Guide.GuideAncBase")
local GuideUnitConfig = require("Metadatas.GuideUnitConfig")
local TerrBuildManager = require("Territory.TerrBuildManager")
local TerrBuild = require("Territory.TerrBuild")
local GuideAncView = require("Guide.GuideAncView")
local EventDispatcher = require("EventDispatcher")

local TbSG = 
{
	kMovingToCenter = 2, --移动到中心
	kClickBuildGuiding= 3, --指引点击建筑
	kClickLvUpGuiding = 4, 
	kBuildInSpeedUp = 7, --加速中
	kBuildInNotOpen = 8,  --等级不足
	kBuildResNotEnough = 9, --资源不足
	kFinishGuide = 5,
	kInterrupt = 6,
	kClickGongNengBtn = 10, --点击功能按钮
}

local NodePath = 
{
	[TbSG.kBuildInNotOpen] = "MenuScene.TerrBuildUpgradePanel.m_csNode.goto1",
	[TbSG.kBuildResNotEnough] = "MenuScene.TerrBuildUpgradePanel.m_csNode.open.goto2",
	[TbSG.kClickLvUpGuiding] = "MenuScene.TerrBuildUpgradePanel.m_csNode.open.levelup",
}

function This:init(info)
	self.m_type = info.type
	self.m_pos = info.pos
	self.m_state = TbSG.kWaitingTrigger
	self.m_events = {"dialog_open","dialog_close","menu_scene_enter","terr_build_level_changed","terr_build_upgrade_start"}
	super.init(self,info)
	self.m_build = TerrBuildManager:getBuildByType(self.m_type,self.m_pos)
	self.m_curLevel = self.m_build:getLevel()
	self.m_isMoving = false
	self.m_isFocused = false
end

function This:initGuide()
	super.initGuide(self)
	self.m_view:setTouchHandler(function()
		if self.m_view then
			self.m_view:setNode(nil)
			g_scene.m_timer:setTimer(0,function()
				if self.m_view then
					local state = self:getState()
					if state == TbSG.kClickGongNengBtn then
						self:update(state)
					end
				end
			end,"terr_build_up_guide")
		end
	end)
end

function This:getState()
	if g_scene:getName() ~= "MenuScene" then
		return
	end

	if self.m_build:getLevel() > self.m_curLevel then
		return TbSG.kFinishGuide
	end

	local panel = g_scene:getTopDialog()
	if not panel then
		if not self.m_isFocused then
			if not self.m_isMoving then	
				self.m_isMoving = true
				g_scene:focuseBuildByType(self.m_type,self.m_pos,function()
					self.m_isMoving = false
					self.m_isFocused = true
					self:update()
				end,true)
			end
			if self.m_isFocused then
				return TbSG.kClickBuildGuiding
			else
				return TbSG.kMovingToCenter
			end
		else
			local buildView = self.m_build:getView() 
			if buildView and buildView.m_csNode.GongNeng:isVisible() then
				return TbSG.kClickGongNengBtn
			else
				if self.m_view:getClickCount() <= 0 then
					return TbSG.kClickBuildGuiding
				elseif self.m_build:isUpgrading() then
					if self.m_build:getType() == TerrBuildType.kGuanfu then
						local isInFreeTime = self.m_build:isInFreeTime()
						print("self.m_build:isInFreeTime() = ",tostring(isInFreeTime))
					end
					if self.m_build:isInFreeTime() then
						return TbSG.kBuildInSpeedUp
					else
						return TbSG.kFinishGuide
					end
				else
					return TbSG.kFinishGuide
				end
			end
		end
	else
		if panel:getName() == "TerrBuildUpgradePanel" then
			if not panel:isVisible() then
				return TbSG.kInterrupt
			end

			if self.m_build:isUpgrading() then
				if self.m_build:isInFreeTime() then
					return TbSG.kBuildInSpeedUp
				else
					return TbSG.kFinishGuide
				end
			elseif not self.m_build:isOpening()  then
				return TbSG.kBuildInNotOpen
			elseif not self.m_build:isQualified() then
				return TbSG.kBuildResNotEnough
			else
				return TbSG.kClickLvUpGuiding
			end
		
			if panel and not self.m_panelVisibleHandler then
				self.m_panelVisibleHandler = panel.setVisible
				self.m_panel = panel
				panel.setVisible = function(_,b)
					self.m_panelVisibleHandler(panel,b)
					self:update()
				end
			end
		end
	end
end

function This:getNode(state)
	if NodePath[state] then
		return self:getNodeByPath(NodePath[state])
	elseif state == TbSG.kBuildInSpeedUp then
		return g_scene:getBuildNode(self.m_type,self.m_pos)
	elseif state == TbSG.kClickBuildGuiding then
		return g_scene:getBuildNode(self.m_type,self.m_pos)
	elseif state == TbSG.kClickGongNengBtn then
		local buildView = self.m_build:getView()
		if buildView then
			return buildView.m_csNode.GongNeng.bg1
		end
	end
end

function This:update(state)
	if not state then
		state = self:getState()
	end
	if state then
		if state == TbSG.kFinishGuide then
			self:finish()
		else
			local node = self:getNode(state)
			self.m_view:setNode(node)
		end
	else
		self:cancel()
	end
end

function This:cancel()
	super.cancel(self)
	if self.m_panelVisibleHandler and self.m_panel then
		self.m_panel.setVisible = self.m_panelVisibleHandler
		self.m_panelVisibleHandler = nil
		self.m_panel = nil
	end
end

--endregion
