--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"Guide.GuideAncBase")
local EventDispatcher = require("EventDispatcher")
local WorldMapManager = require("World.WorldMapManager")
local GuideAncView = require("Guide.GuideAncView")
local UseJiceGuide = require("Guide.UseJiceGuide")
local PlanShopUtil = require("PlanShop.PlanShopUtil")
local GuideUtil = require("Guide.GuideUtil")

local TgSG = 
{
	kSelectTroopBtn = 1, --等待选择城池部队按钮
	kUseZbmmJiCe = 2, --等待选择使用招兵买马计策
	kAddHpOneKey = 3, --等待一键补兵
	kTransportHp = 4, --兵力运输
	kSelectFight = 5, --选择出征
	kInterrupt = 6, --中断
	kFinishGuide = 7, --完成
}

local NodePath = 
{
	[TgSG.kSelectTroopBtn] = "WorldScene.mapLayer.m_menu.ownclick.troops",
	[TgSG.kSelectFight] = "WorldScene.TroopPanel.m_csNode.battlebutton",
	[TgSG.kAddHpOneKey] = "WorldScene.TroopPanel.m_csNode.creepsbutton",
	[TgSG.kTransportHp] = "WorldScene.TroopPanel.m_csNode.transportationbutton",
	[TgSG.kUseZbmmJiCe] = "WorldScene.TroopPanel.m_csNode.buytroopsbutton",
}

function This:init(info)
	self.m_cityId = info.city
	self.m_isUseZbmm = info.bUseZbmm or false
	self.m_isFight = info.bFight
	self.m_events = {"dialog_open","dialog_close","city_state_changed","city_nemu_open","update_hero_state","add_troop_hp"}
	self.m_city = WorldMapManager:getCity(self.m_cityId)
	super.init(self,info)
end

function This:update(state)
	if not state then
		state = self:getState()
	end
	if state then
		if state == TgSG.kFinishGuide then
			self:finish()
		else
			local node = self:getNode(state)
			self.m_view:setNode(node)
		end
	else
		self:cancel()
	end
end

function This:getState()
	if g_scene:getName() ~= "WorldScene" then
		return
	end

	if not self.m_city:isMy() or self.m_city:isFighting() then
		return
	end

	if self.m_useJiceGuide then
		return TgSG.kInterrupt
	end

	local panel = g_scene:getTopDialog()
	if not panel then
		if g_scene.m_menu and g_scene.m_menu.ownclick then
			return TgSG.kSelectTroopBtn
		elseif g_scene:getShowMode() == ShowMode.kSelect then
			return TgSG.kFinishGuide
		end
		return
	end

	if panel and panel:getName() == "TroopPanel" then
		local troopList = panel.m_troopList
		if not troopList then
			return TgSG.kInterrupt
		end

		local total , maxTotal , count = 0 ,0 , 0
		local minHp
		local num = math.min(#troopList,6)

		for i = 1, num do
			local troop = troopList[i]
			total = total + troop:getHp()
			maxTotal = maxTotal + troop:getMaxHp()
			count = count + 1
		end

		if not self.m_isFight then
			if self.m_city:getReserveHp() >= 500  then
				return TgSG.kTransportHp
			elseif self.m_city:getReserveHp() <=500 then
				return TgSG.kUseZbmmJiCe
			end
		else
			if #troopList <= 0 then
				return
			end
			if total / maxTotal >= 0.8 then
				return TgSG.kSelectFight
			elseif self.m_city:getReserveHp() >= 10000 then
				return TgSG.kAddHpOneKey
			else
				return TgSG.kUseZbmmJiCe
			end
		end
	end

	if panel and (panel:getName() == "UsePlanPanel" or panel:getName() == "PlanShopPanel") then
		if not self.m_useJiceGuide then
			self.m_useJiceGuide = UseJiceGuide:create({
				father = self,
				dir = self.m_dir,
				jice = JiCeType.kZhaoBinMaima,
				city = self.m_cityId
			})
			self.m_useJiceGuide:update()
		end
		return TgSG.kInterrupt
	end
end

function This:getNode(state)
	local path = NodePath[state]
	if path then
		local node , isVisible = GuideUtil:getNodeByPath(path)
		if not node or not isVisible then
			return 
		end
		return node
	end
end

function This:next()
	if self.m_useJiceGuide then
		self.m_useJiceGuide = nil
	end
	self:update()
end

--endregion
