--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"Guide.GuideAncBase")
local EventDispather = require("EventDispatcher")
local GuideAncView = require("Guide.GuideAncView")
local WorldMapManager = require("World.WorldMapManager")
local PlanShopManager = require("PlanShop.PlanShopManager")
local DepotManager = require("Depot.DepotManager")
local PlanShopUtil = require("PlanShop.PlanShopUtil")

local UjSG = 
{
	kUsePanelGuide = 2, --使用计策界面使用按钮
	kYanJiuPanelGuide = 3, --计策研究界面
	kFinishGuide = 4,
}

local NodePath = 
{
	[UjSG.kUsePanelGuide] = "WorldScene.UsePlanPanel.m_csNode.use_btn",
}

function This:init(info)
	self.m_jiceId = info.jice
	self.m_events = {"dialog_open","dialog_close"}
	super.init(self,info)
end

function This:getState()
	if g_scene:getName() ~= "WorldScene" then
		return
	end

	local panel = g_scene:getTopDialog()
	if panel and panel:getName() == "UsePlanPanel" then
		return UjSG.kUsePanelGuide
	elseif panel and panel:getName() == "PlanShopPanel" then
		local item = self:getJiceItem()
		if item:isLocked() then
			return
		end
		local w, h = panel.m_csNode.scrollView:getContentSize()
		local w1 , h1 = panel.m_csNode.scrollView:getInnerContainerSize()
		local x , y = item:getPosition()
		local x1 , y1 = panel.m_csNode.scrollView:getInnerContainerPosition()
		panel.m_csNode.scrollView:setInnerContainerPosition(x1, math.max( h/2 - y,h1 - h))
		return UjSG.kYanJiuPanelGuide
	else
		if self.m_view:getClickCount() > 0 then
			return UjSG.kFinishGuide
		end
	end
end

function This:getNode(state)
	if state == UjSG.kUsePanelGuide then
		return self:getNodeByPath(NodePath[state])
	elseif state == UjSG.kYanJiuPanelGuide then
		return self:getJiceItem()
	end
end


function This:update(state)
	if not state then
		state = self:getState()
	end
	if state then
		if state == UjSG.kFinishGuide then
			self:finish()
		elseif state == UjSG.kYanJiuPanelGuide then
			local item = self:getNode(state)
			self.m_view:setNode(item.m_csNode.button)
		else
			local node = self:getNode(state)
			self.m_view:setNode(node)
		end
	else
		self:cancel()
	end
end

function This:getJiceItem()
	local panel = g_scene:getTopDialog()
	if panel and panel:getName() == "PlanShopPanel" then
		local itemList = panel.m_csNode.scrollView:getItemList()
		for i, item in ipairs(itemList) do
			if item.planId == self.m_jiceId then
				return item
			end
		end
	end
end

--endregion
