--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"Guide.GuideAncBase")
local HeroManager = require("Hero.HeroManager")

local WeSG = 
{
	kFinishGuide = 0,
	kClickMenuHeroBtnGuide = 1, 
	kClickWorldHeroBtnGuide = 2,
	kHeroListPanelGuide = 3,
	kWearEquipPos1 = 4, 
	kWearEquipPos2 = 5,
	kWearEquipPos3 = 6, 
	kSelectEquipGuide = 7, 
	kInterrupt = 10,
}

local NodePath = 
{
	[WeSG.kClickMenuHeroBtnGuide] = "MenuScene.sceneUI.m_csNode.panel_btns.hero",
	[WeSG.kClickWorldHeroBtnGuide] = "WorldScene.sceneUI.m_csNode.panel_btns.hero",
	[WeSG.kWearEquipPos1] = "MenuScene.HeroPanel.m_csNode.GrowTabNode.m_csNode.weaponslot",
	[WeSG.kWearEquipPos2] = "MenuScene.HeroPanel.m_csNode.GrowTabNode.m_csNode.clothesslot",
	[WeSG.kWearEquipPos3] = "MenuScene.HeroPanel.m_csNode.GrowTabNode.m_csNode.horseslot"
}

function This:init(info)
	self.m_events = {"dialog_close","dialog_open","list_finish","hero_equip_changed"}
	super.init(self,info)
end

function This:getState()
	if g_scene:getName() ~= "MenuScene" and g_scene:getName() ~= "WorldScene" then
		return
	end

	local function checkEquip(hero)
		for i = EquipPos.kWeapons, EquipPos.kHorse do
			if not hero:isWearEquip(i) then
				return i
			end
		end
	end

	local panel = g_scene:getTopDialog()
	if not panel or panel[0] == 0 then
		if self.m_view:getClickCount() > 0 then
			return WeSG.kFinishGuide
		else
			if g_scene:getName() == "MenuScene" then
				return WeSG.kClickMenuHeroBtnGuide
			elseif g_scene:getName() == "WorldScene" then
				return WeSG.kClickWorldHeroBtnGuide
			end
		end
	elseif panel:getName() == "HeroListPanel" then
		local function selectItem(view)
			local w , h = panel.m_csNode.heroList:getContentSize()
			local x , y = view:getPosition()
			local w1 , h1 = panel.m_csNode.heroList:getInnerContainerSize()
			local x1 , y1 = panel.m_csNode.heroList:getInnerContainerPosition()
			local ny = math.min(0, math.max(h - h1,h/2 - y))
			panel.m_csNode.heroList:setInnerContainerPosition(x1, ny)
		end
		local listLayer = panel.m_listLayer
		for i , view in ipairs(listLayer.m_views) do
			if view:isVisible() then
				local heroId = view.m_heroId
				local hero = HeroManager:getHero(heroId)
				if checkEquip(hero) then
					self.m_heroId = heroId
					self.m_heroView = view
					selectItem(view)
					return WeSG.kHeroListPanelGuide
				end
			end
		end
		return WeSG.kInterrupt
	elseif panel:getName() == "HeroPanel" then
		if panel.m_heroId == self.m_heroId then
			local hero = HeroManager:getHero(self.m_heroId)
			if not hero:isWearEquip(EquipPos.kWeapons) then
				return WeSG.kWearEquipPos1
			elseif not hero:isWearEquip(EquipPos.kClothes) then
				return WeSG.kWearEquipPos2
			elseif not hero:isWearEquip(EquipPos.kHorse) then
				return WeSG.kWearEquipPos3
			end
		end
	elseif panel:getName() == "EquipChoosePanel" then
		if next(panel.m_layerLayer.m_views) ~= nil then
			self.m_equipView = panel.m_layerLayer.m_views[1]
			return WeSG.kSelectEquipGuide
		end
		return WeSG.kInterrupt
	end
end

function This:getNode(state)
	if NodePath[state] then
		return self:getNodeByPath(NodePath[state])
	elseif state == WeSG.kHeroListPanelGuide then
		if self.m_heroView and self.m_heroView[0] ~= 0 then
			return self.m_heroView
		end
	elseif state == WeSG.kSelectEquipGuide then
		if self.m_equipView and self.m_equipView[0] ~= 0 then
			return self.m_equipView
		end
	end
end


--endregion
