--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"Dialog")
local HeroManager = require("Hero.HeroManager")
local GamePlayer = require("Player.GamePlayer")
local HeroSetCollocationData = require("Hero.HeroSetCollocationData")

function This:initNode(hero)
	self.m_hero = hero
	self.m_data = HeroSetCollocationData:create(self.m_hero)
	self.m_csNode = cc.Node:createFromCSFile("GameScene/NodeUI/HeroCollocation.csb")
	self:addChild(self.m_csNode)
	self.m_csNode:setToCenter()
	self.m_attrPoint = {
		self.m_hero:getAttrPoint(AttrType.kPower),
		self.m_hero:getAttrPoint(AttrType.kIntelligence),
		self.m_hero:getAttrPoint(AttrType.kChiefValue),
		self.m_hero:getAttrPoint(AttrType.kDfs)
	}
	self.m_leftPoint = self.m_hero:getLeftAttrPointCount()
	self.m_lastIndex = 1
	self.m_addPoint = {0,0,0,0}
	if self.m_leftPoint ~= 0 then
		self.m_addPointMaxLuck = {1,1,1,1}
	else
		self.m_addPointMaxLuck = {0,0,0,0}
	end
	self.m_offsetPercentx = 1/self.m_leftPoint
	self.m_attrId = {AttrType.kPower,AttrType.kIntelligence,AttrType.kChiefValue,AttrType.kDfs}
	for i = 1,4 do
		local slideNode = self.m_csNode["item"..i].slider
		slideNode:setSilderHandler(function (percent)
			print(percent)
			self.m_lastIndex = i
			if percent >= self.m_offsetPercentx or percent <= self.m_addPointMaxLuck[i] - self.m_offsetPercentx then
				local temLuckNum = self:checkLuckNum(percent)
				self:refreshSlider(temLuckNum,i)
			end
			if percent >= self.m_addPointMaxLuck[i] then
				return self.m_addPointMaxLuck[i]
			end
			if percent < 0 then
				return 0
			end

			return percent
		end)
		slideNode:setPercent(0)
	end
	self:refresh()
end

function This:initTouchEvent()
	self.m_csNode.close:setTouchEnded(function()
		self:close()
	end)
	self.m_csNode.wash:setTouchEnded(function()
		if self.m_hero:getAllAttrPoint() == 0 then
			g_scene:showTips(Serialize[61194])
			return
		end
		local leftTime = HeroManager:getLeftAttrPointClearTime()
		if leftTime > 0 then
			HeroManager:onClearAttrPointRequest(self.m_hero)
		else
			GamePlayer:costDiamond({title = Serialize[61195],desc = Serialize[61195],cost = kBuyAttrPointCost, okHandler = function()
				HeroManager:onClearAttrPointRequest(self.m_hero)
			end})
		end
	end)
	self.m_csNode.sure:setTouchEnded(function()
		local total = self.m_addPoint[1] + self.m_addPoint[2] + self.m_addPoint[3] + self.m_addPoint[4]
		if self.m_leftPoint < 0 then
			self:reduceAttrPoint(self.m_lastIndex)
			print("最后index"..self.m_lastIndex)
			return
		end
		if total > 0  then
			HeroManager:onAddAttrPointRequest(self.m_hero,self.m_attrPoint)
		end
	end)

	self.m_csNode.setting:setTouchEnded(function()
		g_scene:openDialog("Hero.HeroSetCollocationPanel",{hero = self.m_hero,data = self.m_data})
	end)

	self.m_csNode.recommend:setTouchEnded(function ()
		self.m_attrPoint = {
			self.m_hero:getAttrPoint(AttrType.kPower),
			self.m_hero:getAttrPoint(AttrType.kIntelligence),
			self.m_hero:getAttrPoint(AttrType.kChiefValue),
			self.m_hero:getAttrPoint(AttrType.kDfs)
		}

		local addPoint = self.m_data:getAddPoint()
		self.m_leftPoint = self.m_hero:getLeftAttrPointCount()
		local line = math.modf(self.m_leftPoint/4)
		print("整数"..line)
		local mod = math.mod(self.m_leftPoint,4)
		print("余数"..mod)
		for i = 1 ,4 do
			self.m_addPoint[i] = line*addPoint[i]
			self.m_attrPoint[i] = self.m_attrPoint[i] + line*addPoint[i]
			self.m_leftPoint = self.m_leftPoint - line*addPoint[i]
			if mod > 0 then
				local value
				if mod >= addPoint[i] then
					value = addPoint[i]
				else
					value = mod
				end
				self.m_addPoint[i] = self.m_addPoint[i] + value
				self.m_attrPoint[i] = self.m_attrPoint[i] + value
				self.m_leftPoint = self.m_leftPoint - value
				mod = mod - value
			end
		end
		self:refreshSliderUI()
		self:refresh()
	end)

	for i = 1, 4 do
		self.m_csNode["item"..i].addlight:setTouch({
			onEnded = function()
				self:addAttrPoint(i)
			end,
			isScale = false,
		})
		self.m_csNode["item"..i].jianlight:setTouch({
			onEnded = function()
				self:reduceAttrPoint(i)
			end,
			isScale = false,
		})
	end

	self.m_csNode.tips:setTouchEnded(function()
		g_scene:openDialog("UI.HelpTips",{text = Serialize["attr_point_help_tips"],node = self.m_csNode.tips})
	end)
end

function This:onEnter()
	super.onEnter(self)
	HeroManager:addObserver(self)
end

function This:onExit()
	super.onExit(self)
	HeroManager:removeObserver(self)
end

function This:refreshItem(index)
	local attrId = self.m_attrId[index]
	local value = self.m_hero:getAttr(attrId)
	local itemNode = self.m_csNode["item"..index]

	local value2 = value + self.m_addPoint[index] 
	itemNode.value1:setString(string.format("%.1f",value2))
	itemNode.num:setString(string.format("+%.1f",self.m_addPoint[index]))

	local attrId = AttrType.kMaxHp
	local attrValue1 = self.m_hero:getAttr(attrId)
	local attrValue2 = kChielfToMaxHpRatio*self.m_addPoint[3] + attrValue1
	self.m_csNode.num8:setString(string.format("%d",attrValue2))
	self.m_csNode.num8_0:setString(string.format("+%d",kChielfToMaxHpRatio*self.m_addPoint[3]))

	attrId = AttrType.kPhyAttack
	attrValue1 = self.m_hero:getAttr(attrId)
	attrValue2 = kPowerToAttackRatio*self.m_addPoint[1] + attrValue1
	self.m_csNode.num3:setString(string.format("%d",attrValue2))
	self.m_csNode.num3_0:setString(string.format("+%d",kPowerToAttackRatio*self.m_addPoint[1]))


	attrId = AttrType.kPhyDefence
	attrValue1 = self.m_hero:getAttr(attrId)
	attrValue2 = kDfsToDefenceRatio*self.m_addPoint[4] + attrValue1
	self.m_csNode.num4:setString(string.format("%d",attrValue2))
	self.m_csNode.num4_0:setString(string.format("+%d",kDfsToDefenceRatio*self.m_addPoint[4]))


	attrId = AttrType.kMagicAttack
	attrValue1 = self.m_hero:getAttr(attrId)
	attrValue2 = kIntelligenceToAttackRatio*self.m_addPoint[2] + attrValue1
	self.m_csNode.num5:setString(string.format("%d",attrValue2))
	self.m_csNode.num5_0:setString(string.format("+%d",kIntelligenceToAttackRatio*self.m_addPoint[2]))


	attrId = AttrType.kMagicDefence
	attrValue1 = self.m_hero:getAttr(attrId)
	attrValue2 = kIntelligenceToDefenceRatio*self.m_addPoint[2] + attrValue1
	self.m_csNode.num7:setString(string.format("%d",attrValue2))
	self.m_csNode.num7_0:setString(string.format("+%d",kIntelligenceToDefenceRatio*self.m_addPoint[2]))


	-- itemNode.num:setString(string.format("+%d",self.m_addPoint[index]))
	if self.m_addPoint[index] <= 0 then
		itemNode.jianlight:setGrayShader()
	else
		itemNode.jianlight:clearShader()
	end
	if self.m_leftPoint <= 0 then
		itemNode.addlight:setGrayShader()
	else
		itemNode.addlight:clearShader()
	end

	local total = self.m_addPoint[1] + self.m_addPoint[2] + self.m_addPoint[3] + self.m_addPoint[4]
	if total > 0 then
		self.m_csNode.sure:clearShader()
	else
		self.m_csNode.sure:setGrayShader()
	end
end

function This:refresh()
	local point = self.m_hero:getAllAttrPoint()
	local leftPoint = self.m_hero:getLeftAttrPointCount()
	if self.m_leftPoint >= 0 then
		self.m_csNode.num:setString(self.m_leftPoint)
	else
		self.m_csNode.num:setString(0)
	end
	self.m_csNode.num2:setString(point + leftPoint -self.m_leftPoint)
	for i , attrId in ipairs(self.m_attrId) do
		self:refreshItem(i)
	end
	local leftTime = HeroManager:getLeftAttrPointClearTime()
	if leftTime > 0 then
		self.m_csNode.freetime:setStringWithColor(string.format(Serialize[61196],leftTime))
		self.m_csNode.price:setVisible(false)
		self.m_csNode.yuanbao:setVisible(false)
	else
		self.m_csNode.freetime:setVisible(false)
		self.m_csNode.price:setVisible(true)
		self.m_csNode.yuanbao:setVisible(true)
		self.m_csNode.price:setString(kBuyAttrPointCost)
	end
end

function This:addAttrPoint(index)
	if self.m_leftPoint > 0 then
		self.m_addPoint[index] = self.m_addPoint[index] + 1
		self.m_attrPoint[index] = self.m_attrPoint[index] + 1
		self.m_leftPoint = self.m_leftPoint - 1
		 local leftValue = self.m_hero:getLeftAttrPointCount()
		 local num = self.m_addPoint[index]/leftValue
		 self.m_csNode["item"..index].slider:setPercent(num,true)
		--self:refreshSliderUI()
		self:refresh()
	end
end

function This:reduceAttrPoint(index)
	if self.m_addPoint[index] > 0 then
		self.m_addPoint[index] = self.m_addPoint[index] - 1
		self.m_attrPoint[index] = self.m_attrPoint[index] - 1
		self.m_leftPoint = self.m_leftPoint + 1
		 local leftValue = self.m_hero:getLeftAttrPointCount()
		 local num = self.m_addPoint[index]/leftValue
		 print("sss "..num)
		 self.m_csNode["item"..index].slider:setPercent(num,true)
		--self:refreshSliderUI()
		self:refresh()
	end
end

function This:refreshSliderUI()
	local leftValue = self.m_hero:getLeftAttrPointCount()
	if leftValue == 0 then
		leftValue = 1
	end
	for i=1,4 do
		local num = self.m_addPoint[i]/leftValue
		self.m_csNode["item"..i].slider:setPercent(num,true)
	end
end

function This:recommendAttrPoint()
	local id = self.m_hero:getId()
	if self.m_leftPoint > 0 then

		self:refresh()
	end
end

function This:onAddAttrPoint(heroId)
	if self.m_hero:getId() == heroId then
		self.m_addPoint = {0,0,0,0}
		self.m_leftPoint = self.m_hero:getLeftAttrPointCount()
		self.m_addPointMaxLuck = {1,1,1,1}
		if self.m_leftPoint == 0 then
			self.m_offsetPercentx = 0
		else
			self.m_offsetPercentx = 1/self.m_leftPoint
		end
		self:refresh()
		self:refreshSliderUI()
		g_scene:showTips(Serialize[61197])
	end
end

function This:onClearAttrPoint(heroId)
	if self.m_hero:getId() == heroId then
		self.m_attrPoint = {
			self.m_hero:getAttrPoint(AttrType.kPower),
			self.m_hero:getAttrPoint(AttrType.kIntelligence),
			self.m_hero:getAttrPoint(AttrType.kChiefValue),
			self.m_hero:getAttrPoint(AttrType.kDfs)
		}
		self.m_leftPoint = self.m_hero:getLeftAttrPointCount()
		self.m_addPoint = {0,0,0,0}
		self.m_addPointMaxLuck = {1,1,1,1}
		if self.m_leftPoint == 0 then
			self.m_offsetPercentx = 0
		else
			self.m_offsetPercentx = 1/self.m_leftPoint
		end
		self:refresh()
		self:refreshSliderUI()
		g_scene:showTips(Serialize[61198])
	end
end

function This:checkLuckNum(luckNum)
	if luckNum <= 0 then
		return 0
	else
		local temCount = luckNum/self.m_offsetPercentx
		local temValue = math.floor(temCount)
		local temLuckNum = temValue*self.m_offsetPercentx
		if temLuckNum > 1 then
			temLuckNum = 1
		end
		return temLuckNum
	end
end

function This:refreshSlider(num,index)
	local leftValue = self.m_hero:getLeftAttrPointCount()
	local value = leftValue*num
	value= math.floor(value)
	local oldValue = self.m_addPoint[index]
	for i =1,4 do
		if i == index then
			leftValue = leftValue - value
		else
			leftValue = leftValue - self.m_addPoint[i]
		end
	end
	if leftValue >= 0 then
		self.m_leftPoint = leftValue
		self.m_addPoint[index]=value
		self.m_attrPoint[index] = self.m_attrPoint[index] + value - oldValue
	
		for i = 1,4 do
			if self.m_hero:getLeftAttrPointCount() > 0 then
				self.m_addPointMaxLuck[i] = self:checkLuckNum((self.m_leftPoint + self.m_addPoint[i])/self.m_hero:getLeftAttrPointCount())
			else
				self.m_addPointMaxLuck[i] = 0
			end
		end
	end
	self:refresh()
end

--endregion
