-- @Author: su
-- @Date:   2018-12-20 10:28:20
-- @Last Modified by: su
-- @Last Modified time: 2018-12-20 10:28:20
-- @File Name: ArrayManager.lua

local This , super = class(..., "Base.BaseModel")
local EventDispatcher = require("EventDispatcher")
local Socket = require("Net.Socket")
local GameArrayData = require("Hero.GameArrayData")
local HeroManager = require("Hero.HeroManager")


CountryArrayTab={
    kQingLong   = 1,
    kBaiHu      = 2,
    kZhuQue     = 3,
    kXuanWu     = 4 
}


function This:init()
	super.init(self)
    self:initListener()

end

function This:initListener()
    EventDispatcher:addListener(self, 13600, self.onGetArrayInfoReply)
    EventDispatcher:addListener(self, 13601, self.onActivationReply)
end

function This:removeListener()
    EventDispatcher:removeListener(self,13600)
    EventDispatcher:removeListener(self,13601)
end

function This:updateAllHeroArrayAttr()
    HeroManager:updateArrayAttr(self:getArrayAttr())
end

function This:getArrayData()
    if not self.m_arrayData then
        self.m_arrayData = GameArrayData:create(0)
    end
    return self.m_arrayData
end

function This:getArrayAttr()
    local ArrayData = self:getArrayData()
    return ArrayData:getArrayAttr()
end

function This:onGetArrayInfoRequest()
    Socket:sendAndLock(13600,{})
end

function This:onGetArrayInfoReply( msg )
    -- if msg.err_code == 0 then
    local ArrayData = self:getArrayData()
    ArrayData:setTroopsIdList(msg.id)
    self:notifyObservers("onGetArrayInfo")
    EventDispatcher:dispatcher("array_change")
    self:updateAllHeroArrayAttr()    
    -- else
    --     g_scene:handleErrorCode(msg.err_code)
    -- end
end

function This:onActivationRequest( id )
    Socket:sendAndLock(13601,{id = id})
end


function This:onActivationReply( msg )
    if msg.err_code == 0 then
        local ArrayData = self:getArrayData()
        ArrayData:updateTroopsIdList(msg.id)
        self:notifyObservers("onActivationArray")
        EventDispatcher:dispatcher("array_change")
        self:updateAllHeroArrayAttr()
    else
        g_scene:handleErrorCode(msg.err_code)
    end
end