--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This, super = class(...,"cc.Node")
local HeroManager = require("Hero.HeroManager")
local StarUpConfig = require("Metadatas.StarUpConfig")
local SkillConfig = require("Metadatas.SkillConfig")
local EquipManager = require("Equip.EquipManager")

function This:init(heroId)
	self.m_heroId = heroId
	self.m_csNode = cc.Node:createFromCSFile("GameScene/NodeUI/HeroAttribute.csb")
	self:addChild(self.m_csNode)
	self.m_starNode = {}
	self:initAttr()
end

function This:initAttr()
	local hero = HeroManager:getHero(self.m_heroId)
	self.m_csNode.ListView.info.name:setString(hero:getName())

	local starAttr = hero:getStarAttr()
	local starAttrNode = self.m_csNode.ListView.starAttr
	for i , id in ipairs(starAttr) do
		starAttrNode["star" .. i .. "name"]:setStringWithColor(string.format("<A1>%s:<A2>%s",StarUpConfig[id].name,StarUpConfig[id].desc))
	end
	starAttrNode.wakenskillname:setVisible(false)
	starAttrNode.star5tips_0:setVisible(false)
end

function This:refreshStarAttr()
	local hero = HeroManager:getHero(self.m_heroId)
	local starAttrNode = self.m_csNode.ListView.starAttr
	local initY = 0
	for i = 5, 1 , -1 do
		local tipsNode = starAttrNode["star" .. i .. "tips"]
		local nameNode = starAttrNode["star" .. i .. "name"]
		if hero:getStarLv() < i then
			tipsNode:setVisible(true)
			tipsNode:setPositionY(initY)
			initY = initY + tipsNode:getContentHeight()
		else
			tipsNode:setVisible(false)
		end
		nameNode:setPositionY(initY)
		initY = initY + nameNode:getContentHeight()
	end

	local w , h = starAttrNode:getContentSize()
	starAttrNode:setContentSize(w , initY)

	local x , y = starAttrNode:getPosition()
	self.m_csNode.ListView.info:setPositionY(y + initY)
	local totalH = y + initY + self.m_csNode.ListView.info:getContentHeight()
	w , h = self.m_csNode.ListView:getInnerContainerSize()
	self.m_csNode.ListView:setInnerContainerSize(w,totalH)
	
end

--[[function This:initAttr()
	local hero = HeroManager:getHero(self.m_heroId)
	self.m_csNode.ListView.info.name:setString(hero:getName())

	local starAttr = hero:getStarAttr()
	local starAttrNode = self.m_csNode.ListView.starAttr
	self.m_fontScale = 1
	for i, id in pairs(starAttr) do
		self.m_starNode[i]={}
		self.m_starNode[i].name = starAttrNode["star"..i.."name"]
		self.m_starNode[i].name:setString(StarUpConfig[id].name.."：")
		self.m_starNode[i].name:setAnchorPoint(0,1.0)

		self.m_starNode[i].desp =  cc.Label:createNormalTTF("",16)  
		self.m_starNode[i].desp:setStringWithColor(StarUpConfig[id].desc)
		self.m_starNode[i].desp:setAnchorPoint(0,0)
		starAttrNode:addChild(self.m_starNode[i].desp)

		self.m_starNode[i].tips = starAttrNode["star"..i.."tips"]
		self.m_starNode[i].starId = id
	end
	local skillId = hero:getSkillId()
	self.m_skillNode = {}
	self.m_skillNode.name = starAttrNode["wakenskillname"]
	self.m_skillNode.name:setString(SkillConfig[skillId].name..":")
	self.m_skillNode.name:setAnchorPoint(0,1.0)
	self.m_skillNode.tips = starAttrNode["star5tips_0"]
	self.m_skillNode.desp = cc.Label:createNormalTTF("",16) 
	self.m_skillNode.desp:setStringWithColor(SkillConfig[skillId].desp)
	self.m_skillNode.desp:setAnchorPoint(0,0)
	starAttrNode:addChild(self.m_skillNode.desp)
	self.m_skillNode.name:setVisible(false)
	self.m_skillNode.tips:setVisible(false)
	self.m_skillNode.desp:setVisible(false)
end]]

function This:onEnter()
	super.onEnter(self)
	HeroManager:addObserver(self)
	EquipManager:addObserver(self)
end

function This:onExit()
	super.onExit(self)
	HeroManager:removeObserver(self)
	EquipManager:removeObserver(self)
end

function This:setModel(heroId)
	if self.m_heroId ~= heroId then
		self.m_heroId = heroId
		for i , info in ipairs(self.m_starNode) do
			info.desp:removeFromParent()
		end
		self.m_starNode = {}
		self.m_skillNode.desp:removeFromParent()
		self:initAttr()
		self:refreshBaseAttr()
	end
end

function This:refresh()
	self:refreshStarAttr()
	self:refreshBaseAttr()
	self.m_csNode.ListView:doLayout()
end

function This:refreshBaseAttr()
	local hero = HeroManager:getHero(self.m_heroId)
	local attrNode = self.m_csNode.ListView.attr
	local attrIds = {AttrType.kPhyAttack,AttrType.kPhyDefence,AttrType.kMagicAttack,AttrType.kMagicDefence,
	AttrType.kAngerValue,AttrType.kCritRatio,AttrType.kDodge,AttrType.kPenetrate,
	AttrType.kPhyAttAddRatio,AttrType.kPhyDefAddRatio,AttrType.kMagicAttAddRatio,AttrType.kMagicDefAddRatio,
	AttrType.kBothAttAddRatio,AttrType.kBothDefAddRatio,AttrType.kPhyDamageAddRatio,AttrType.kPhyDamageReduceRatio,
	AttrType.kMagicDamageAddRatio,AttrType.kMagicDamageReduceRatio,AttrType.kBothDamageAddRatio,AttrType.kBothDamageReduceRatio,
	AttrType.kMaxHpRatio,AttrType.kDefenceCritRatio,AttrType.kDefencePenetrate,AttrType.kDefenceDodge,
	AttrType.kBurstBonus, AttrType.kBurstRelief,
	AttrType.kAdditionalPhyDamage, AttrType.kAdditionalPlanDamage, AttrType.kAdditionalPhyDamageReduce,
	AttrType.kAdditionalPlanDamageReduce, AttrType.kAdditionalPhyDamageAddRatio, AttrType.kAdditionalPlanDamageAddRatio,
	}

	for i , attrId in ipairs(attrIds) do
		local nameNode = attrNode["text"..i]
		if AttrInfo[attrId].valueType == ValueType.kPercent then
			nameNode:setStringWithColor(string.format("<A1>%s：<A2>%.2f%%",AttrName[attrId],hero:getAttr(attrId)*100))
		else
			nameNode:setStringWithColor(string.format("<A1>%s：<A2>%d",AttrName[attrId],math.floor(hero:getAttr(attrId))))
		end
	end
end

function This:onUpgradeStarLv(heroId)
	if self.m_heroId == heroId then
		self:refresh()
	end
end

function This:onUpgradeLevel(heroId)
	if self.m_heroId == heroId then
		self:refresh()
	end
end

function This:onUpgradeQuality(heroId)
	if self.m_heroId == heroId then
		self:refresh()
	end
end

function This:onDeputyChanged(heroId)
	if self.m_heroId == heroId then
		self:refresh()
	end
end

function This:onEquipChanged(heroId)
	if self.m_heroId == heroId then
		self:refresh()
	end
end 

function This:onUpdateEquip(uid)
	local equip = EquipManager:getEquip(uid)
	local heroId = equip:getHeroId()
	if self.m_heroId == heroId then
		self:refresh()
	end
end

--endregion
