-- @Author: su
-- @Date:   2018-12-25 10:02:20
-- @Last Modified by: su
-- @Last Modified time: 2018-12-25 10:02:20
-- @File Name: CountryArrayResonatePanel.lua

local This,super = class(...,"Dialog")
local ArrayManager = require("Hero.ArrayManager")


local ArrayBoxPic = {
    "MenuScene/zhenfaql.png",
    "MenuScene/zhenfabh.png",
    "MenuScene/zhenfazq.png",
    "MenuScene/zhenfaxw.png",
}


function This:initData( info ) 
    self.m_arrayData = ArrayManager:getArrayData()

end

function This:initNode( info )
    self.m_csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/CountryArrayResonate.csb")
    self.m_csNode:setToCenter()
    self:addChild(self.m_csNode)
    self:refresh()
end

function This:refresh()
    local node = self.m_csNode
    local addLevel = self.m_arrayData:getAddLevel()
    local nextAddLevel = self.m_arrayData:getNextAddLevel()
    local ShuStageNum = self.m_arrayData:getSoulNum(CountryArrayTab.kQingLong)
    local ShuStageNeedNum = self.m_arrayData:getAddStageNum(CountryArrayTab.kQingLong,nextAddLevel)
    local WeiStageNum = self.m_arrayData:getSoulNum(CountryArrayTab.kBaiHu)
    local WeiStageNeedNum = self.m_arrayData:getAddStageNum(CountryArrayTab.kBaiHu,nextAddLevel)
    local WuStageNum = self.m_arrayData:getSoulNum(CountryArrayTab.kZhuQue)
    local WuStageNeedNum = self.m_arrayData:getAddStageNum(CountryArrayTab.kZhuQue,nextAddLevel)
    local QunStageNum = self.m_arrayData:getSoulNum(CountryArrayTab.kXuanWu)
    local QunStageNeedNum = self.m_arrayData:getAddStageNum(CountryArrayTab.kXuanWu,nextAddLevel)
    local color1,color2 = self:getColor(ShuStageNum >= ShuStageNeedNum)
    node.shu.num:setStringWithColor(string.format("%s%d%s/%d",color1,ShuStageNum,color2,ShuStageNeedNum))
    node.shu.icon:setImage(ArrayBoxPic[1])
    node.shu.zhezhao:setVisible(ShuStageNum < ShuStageNeedNum)

    color1,color2 = self:getColor(WeiStageNum >= WeiStageNeedNum)
    node.wei.num:setStringWithColor(string.format("%s%d%s/%d",color1,WeiStageNum,color2,WeiStageNeedNum))
    node.wei.icon:setImage(ArrayBoxPic[2])
    node.wei.zhezhao:setVisible(WeiStageNum < WeiStageNeedNum)

    color1,color2 = self:getColor(WuStageNum >= WuStageNeedNum)
    node.wu.num:setStringWithColor(string.format("%s%d%s/%d",color1,WuStageNum,color2,WuStageNeedNum))
    node.wu.icon:setImage(ArrayBoxPic[3])
    node.wu.zhezhao:setVisible(WuStageNum < WuStageNeedNum)

    color1,color2 = self:getColor(QunStageNum >= QunStageNeedNum)
    node.qun.num:setStringWithColor(string.format("%s%d%s/%d",color1,QunStageNum,color2,QunStageNeedNum))
    node.qun.icon:setImage(ArrayBoxPic[4])
    node.qun.zhezhao:setVisible(QunStageNum < QunStageNeedNum)

    node.notactive:setVisible(addLevel == 0)
    node.notopen:setVisible(addLevel == nextAddLevel)

    node = self.m_csNode.value
    local nodeNum = self.m_arrayData:getMaxResonanceNum()
    for i = 1,5 do
        node["value"..i]:setVisible(addLevel ~= 0 )
        node["nextvalue"..i]:setVisible(addLevel ~= nextAddLevel)
        if i > nodeNum then
            node["value"..i]:setVisible(false)
            node["nextvalue"..i]:setVisible(false)
        end
        local text,num = self.m_arrayData:getAddArg(i,addLevel)
        local nextText,nextNum = self.m_arrayData:getAddArg(i,nextAddLevel)
        node["value"..i].name:setStringWithColor(string.format( "<A1>%s",text))
        node["value"..i].num:setStringWithColor(string.format( "<A1>%s",num))

        node["nextvalue"..i].name:setStringWithColor(string.format( "<A0>%s",nextText))
        node["nextvalue"..i].num:setStringWithColor(string.format( "<A0>%s",nextNum))
    end
end

function This:initTouchEvent()
    local node = self.m_csNode
    node.close:setTouchEnded(function ()
        self:close()
    end)
end


function This:getColor(state)
    local color1,color2
    if state then
        color1 = "<A1>"
        color2 = "<A1>"
    else
        color1 = "<R0>"
        color2 = "<A0>"
    end
    return color1,color2
end