-- @Author: su
-- @Date:   2018-12-31 16:52:20
-- @Last Modified by: su
-- @Last Modified time: 2018-12-31 16:52:20
-- @File Name: CountryValuePanel.lua

local This,super = class(...,"Dialog")
local ArrayManager = require("Hero.ArrayManager")
local GameUtil = require("Util.GameUtil")


function This:initData( info )
    self.m_arrayData = ArrayManager:getArrayData()
    self.m_coutryId = info.coutryId
end

function This:initNode( info )
    self.m_csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/CountryValue.csb")
    self.m_csNode:setToCenter()
    self:addChild(self.m_csNode)
    self:refresh()
end

function This:refresh()
    local node = self.m_csNode.value
    local des = self.m_arrayData:getDes(self.m_coutryId)
    local maxDes = self.m_arrayData:getMaxDes(self.m_coutryId)
    local index = 0
    for addtionId,addtionNum in pairs(maxDes) do
        index = index + 1
        local text,num = self.m_arrayData:getConditionalArg({addtionId,addtionNum})
        local num2 = des[addtionId] or 0
        node["value"..index].name:setString(text)
        node["value"..index].num1:setString(num2)
        node["value"..index].num2:setString(addtionNum)
    end
    if index < 5 then
        for i=index+1,5 do
            node["value"..i]:setVisible(false)
        end
    end
end

function This:initTouchEvent()
    local node = self.m_csNode
    node.close:setTouchEnded(function ()
        self:close()
    end)
end