-- @Author: superm
-- @Date:   2018-09-15 14:30:55
-- @Last Modified by:   zheng
-- @Last Modified time: 2019-08-09 11:03:19
-- @File Name: FateConditionItemType.lua
-- @Description: 
-- local HeroUtil = require("Hero.HeroUtil")
local HeroUtil = require("Hero.HeroUtil")
local EquipManager = require("Equip.EquipManager")
local FabaoManager = require("Fabao.FabaoManager")
local ItemUtil = require("Bag.ItemUtil")

FateConditionItemType ={
    equipLv         = 1,--装备等级
    equipStrengthen = 2,--装备强化
    fabaoLv         = 3,--法宝等级
    fabalRefineLv   = 4,--法宝精炼等级
    fabaoStarLv     = 5,--法宝星级
}
local This, super = class(..., "Hero.FateCondition")


function This:getName()
    return ItemUtil.getName(self:getItemId())
end

function This:getValue()
    local phase = -1
    if self:checkType(FateCondType.kEquip) then
        local equipData = self:getEquip()
        if equipData then
            if self:checkLvType(FateEquipType.kLv) then
                phase = equipData:getLevel()
            elseif self:checkLvType(FateEquipType.kStrengthen) then
                phase = equipData:getStrengthLv()
            end
        end
    elseif self:checkType(FateCondType.kFabao) then
        local equipData = self:getFabao()
        if equipData then
            if self:checkLvType(FateFabaoType.kLv) then
                phase = equipData:getLevel()
            elseif self:checkLvType(FateFabaoType.kRefineLv) then
                phase = equipData:getJinglianDegree()
            elseif self:checkLvType(FateFabaoType.kStarlv) then
                phase = equipData:getStarLevel()
            end
        end
    end
    return phase
end

function This:isItemType()
    return true
end

function This:getItemId()
    return self.m_heroOrOtherId
end

function This:getItemData()
    if self:checkType(FateCondType.kEquip) then
        return self:getEquip()
    end
    return self:getFabao(itemId)
end

function This:getFabao(itemId)
    local temItemId = itemId or self:getItemId()
    local heroData = self:getHero()
    if heroData and temItemId then
        for pos=1,FabaoPos.kMax do
            local uid = heroData:getFabaoUid(pos) or 0
            local fabao = FabaoManager:getFabao(uid)
            if fabao and fabao:getItemId()==temItemId then
                return fabao
            end
        end
    end
    return nil
end

function This:getEquip(itemId)
    local temItemId = itemId or self:getItemId()
    local heroData = self:getHero()
    if heroData and temItemId then
        for pos=1,EquipPos.kMax do
            local uid = heroData:getEquipUid(pos) or 0
            local fabao = EquipManager:getEquip(uid)
            if fabao and fabao:getEquipId()==temItemId then
                return fabao
            end
        end
    end
    return nil
end


