-- @Author: superm
-- @Date:   2018-09-12 16:30:55
-- @Last Modified by:   zheng
-- @Last Modified time: 2019-08-09 11:04:10
-- @File Name: FateHeroView.lua
-- @Description: 

local This , super = class(...,"NodeView")
local HeroConfig = require("Metadatas.HeroConfig")
local ItemUtil = require("Bag.ItemUtil")
local HeroManager = require("Hero.HeroManager")

function This:initData(fcond)
    self.m_inited = false
    self.m_fateCond = fcond
    self.m_hero = self.m_fateCond:getHero()
    self.m_fate = self.m_fateCond:getFate()
	self.m_csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/FatalismItem.csb")
    self:addChild(self.m_csNode)
    local w, h = self.m_csNode.bg:getContentSize()
    self:setContentSize(w, h + 38)
end

function This:initNode()
	self:refresh()
end

function This:onEnter()
	super.onEnter(self)
	if self.m_fate then
		self.m_fate:addObserver(self)
	end
end

function This:onExit()
	if self.m_fate then
		self.m_fate:removeObserver(self)
	end
	super.onExit(self)
end

function This:refresh()
	local function colorCondText( node, value, str )
		if value then
			node:setString(str)
		else
			node:setStringWithColor("<R0>" .. str)
		end
	end

	local csNode = self.m_csNode
	local heroId = self.m_hero:getId()
	local fateCond = self.m_fateCond
	if fateCond:isItemType() then
		heroId = fateCond:getItemId()
	end
	local function heroNodeVisible()
		csNode.hero:setVisible(true)
		csNode.bg:setVisible(true)
		csNode.name:setVisible(true)
		csNode.arms:setVisible(false)
		csNode.bingzhong:setVisible(false)
		csNode.name:setColorByID("Q".. ItemUtil.getQuality(heroId))
	end
	csNode.hero:setImage(ItemUtil.getIconImage(heroId))
	csNode.bg:setImage(ItemUtil.getQualityImage(heroId))

	local isGot = self.m_hero:isGot()
	local soilderList  = self.m_fateCond:getSoilderInfo()
	local heroStar, heroLevel
	if fateCond:isItemType() then
		heroNodeVisible()
		csNode.name:setString(ItemUtil.getName(heroId))
		local equipData = fateCond:getItemData()
        local itemLvValue = fateCond:getValue()
		if equipData then
			if fateCond:checkLvType(FateFabaoType.kStarlv) then
				heroStar = itemLvValue
			end
		end

		local temLvIndex = 1
		if fateCond:checkType(FateCondType.kEquip) then
			if fateCond:checkLvType(FateEquipType.kLv) then
				temLvIndex =2
			end
		elseif fateCond:checkType(FateCondType.kFabao) then
			if fateCond:checkLvType(FateFabaoType.kLv) then
				temLvIndex =2
			end
		end
		local lvNode = csNode["lv"..temLvIndex]
		local addStr = ""
		if lvNode and itemLvValue and itemLvValue>0 and not heroStar then
			if temLvIndex and temLvIndex==1 then
				addStr = "+"
			end
			lvNode:setString(addStr..itemLvValue)
			lvNode:setVisible(true)
		end
		isGot = equipData
	elseif not soilderList then
		if isGot then
			if self.m_fateCond:isStarType() then
				heroStar = self.m_hero:getStarLv()
			elseif self.m_fateCond:isLevelType() then
				heroLevel = self.m_fateCond:getValue()
			end
		end
		csNode.name:setString(self.m_hero:getName())
		heroNodeVisible()
	else
		csNode.hero:setVisible(false)
		csNode.bg:setVisible(false)
		csNode.name:setVisible(false)
		csNode.arms:setVisible(true)
		csNode.bingzhong:setVisible(true)
		local soilder = soilderList[1]
		csNode.bingzhong:setString(soilder:getName())
		csNode.arms:setImage(SoilderIcon[soilder:getId()])
		if not isGot or self.m_fateCond:getValue() <= 0 then
			csNode.arms:setGrayShader()
		else
        	csNode.arms:clearShader()
		end
	end

	if heroStar then
		for i = 1 , 5 do
			csNode["star"..i]:setVisible(heroStar >= i)
		end
		csNode.toumingdi:setVisible(true)
	else
		for i = 1 , 5 do
			csNode["star"..i]:setVisible(false)
		end
		csNode.toumingdi:setVisible(false)
	end

	csNode.level:setVisible(heroLevel)
	if heroLevel then
		colorCondText(csNode.level, true, "Lv." .. heroLevel)
	end
	csNode.huihua:setVisible(not isGot)
end

function This:setModel(fcond)
	self.m_fateCond = fcond
    self.m_hero = self.m_fateCond:getHero()
    local fate = self.m_fateCond:getFate()
    if self.m_fate ~= fate then
    	self.m_fate:removeObserver(self)
    	self.m_fate = fate
    	if fate then
    		fate:addObserver(self)
    	end
    end
	self:refresh()
end

function This:onRefreshHero(heroId)
	if heroId and heroId == self.m_hero:getId() then
    	self:refresh()
    end
end