--region *.lua
--Date
--此文件由[BabeLua]插件自动生成
-- GameFetter.lua
local This = class(...)
local HeroConfig = require("Metadatas.HeroConfig")
local FetterConfig = require("Metadatas.FetterConfig")
local HeroManager = require("Hero.HeroManager")

function This:create(...)
	local fetter = {}
	setmetatable(fetter,self)
	fetter:init(...)
	return fetter
end

function This:init(heroId,id)
	self.m_heroId = heroId
	self.m_id = id
	self.m_config = FetterConfig[self.m_id]
	self.m_heros = {}
	for i , id in pairs(self.m_config.heros) do
		self.m_heros[id] = false
	end
	self.m_heros[heroId] = true
	self.m_isActive = false
	self.m_attrValue = 0
end

function This:isRed()
	return false
end

function This:getId()
	return self.m_id
end

function This:getName()
	return self.m_config.name
end

function This:isContain(heroId)
	return self.m_heros[heroId] ~= nil
end

function This:isActive()
	return self.m_isActive
end

function This:reset()
	for i , id in pairs(self.m_config.heros) do
		self.m_heros[id] = false
	end
	self.m_attrValue = 0
	self.m_heros[heroId] = true
	self.m_isActive = false
end

function This:isCanActive()
	for i , ret in pairs(self.m_heros) do
		if ret == false then
			return false
		end
	end
	return true
end

function This:active()
	local hero = HeroManager:getHero(self.m_heroId)
	local value = hero:getAttr(self.m_config.attr_id)
	self.m_attrValue =  value * (1 + self.m_config.percent) + self.m_config.value
	self.m_isActive = true
end

function This:unActive()
	self.m_attrValue = 0
	self.m_isActive = false
end

function This:getAttrId()
	return self.m_config.attr_id
end

function This:getAttrValue()
	return self.m_attrValue
end

function This:addFetterWithHero(heroTable)
	for heroId, _ in pairs(self.m_heros) do
		if heroTable[heroId] then
			self.m_heros[heroId] = true
		end
	end
	if not self.m_isActive and self:isCanActive() then
		self:active()
	end 
end

function This:addHero(heroId)
	if self.m_heros[heroId] == false then
		self.m_heros[heroId] = true
	end
	if not self.m_isActive and self:isCanActive() then
		self:active()
	end
end

function This:removeHero(heroId)
	if self.m_heros[heroId] == true then
		self.m_heros[heroId] = false
	end
	if self.m_isActive and not self:isCanActive() then
		self:unActive()
	end
end

--endregion
