--region *.lua
--Date
--此文件由[BabeLua]插件自动生成
-- GameRedFetter.lua
local This = class(...,"Hero.GameFetter")
-- local HeroConfig = require("Metadatas.HeroConfig")
local RedFetterConfig = require("Metadatas.RedFetterConfig")
local HeroManager = require("Hero.HeroManager")
local GameUtil = require("Util.GameUtil")

function This:init(heroId,id)
	self.m_heroId = heroId
	self.m_id = id
	self.m_config = RedFetterConfig[self.m_id]
	self.m_heros = {}
	self.m_isActive = false
	self.m_attrValue = 0
--	self:addHero(self.m_heroId)
end

function This:isRed()
	return false
end

function This:isContain(heroId)
	local hero = HeroManager:getHero(heroId)
	local temCountry = hero:getCountry()
	local temQuality = hero:getQuality()
	local qualityList = self.m_config.quality or {}
	local haveQuality = table.contain(qualityList, temQuality)

	local contryList = self.m_config.country or {}
	local haveCountry = table.contain(contryList, temCountry)
	if not haveCountry or not haveQuality then
		return false
	end
	return true
end

function This:reset()
	self.m_attrValue = 0
	self.m_isActive = false
	self.m_heros = {}
	-- self:addHero(self.m_heroId)
end

function This:isCanActive()
	if not self.m_heros[self.m_heroId] then
		self:addHero(self.m_heroId)
	end
	local count =0
	for i , ret in pairs(self.m_heros) do
		count = count+1
	end
	local temCount = self.m_config.num
	return count>=temCount
end

function This:active()
	self.m_isActive = true
end

function This:unActive()
	self.m_isActive = false
end

function This:getFetterAttr()
	if not self.m_isActive then
		return {}
	end
	return GameUtil:convertData(self.m_config.attribute)
end

function This:addFetterWithHero(heroTable)
	for heroId, _ in pairs(heroTable) do
		if self:isContain(heroId) then
			self.m_heros[heroId] = true
		end
	end
	if not self.m_isActive and self:isCanActive() then
		self:active()
	end 
end

function This:addHero(heroId)
	if self:isContain(heroId) then
		self.m_heros[heroId] = true
	end
	if not self.m_isActive and self:isCanActive() then
		self:active()
	end
end

function This:removeHero(heroId)
	if self.m_heros[heroId] == true then
		self.m_heros[heroId] = nil
	end
	if self.m_isActive and not self:isCanActive() then
		self:unActive()
	end
end