--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"cc.Node")
local GamePlayer = require("Player.GamePlayer")
local HeroLevelExpConfig = require("Metadatas.HeroLevelExpConfig")
local HeroManager = require("Hero.HeroManager")
local HeroConfig = require("Metadatas.HeroConfig")
local EquipChoosePanel = require("Equip.EquipChoosePanel")
local EquipManager = require("Equip.EquipManager")
local FabaoManager = require("Fabao.FabaoManager")
local EquipTips = require("Equip.EquipTips")
local DepotManager = require("Depot.DepotManager")
local ItemNode = require("UI.ItemNode")
local ArgConfig = require("Metadatas.ArgConfig")

function This:init(heroId)
	self.m_heroId = heroId
	self.m_csNode = cc.Node:createFromCSFile("GameScene/NodeUI/HeroGrow.csb")
	self:addChild(self.m_csNode)

	self.m_isMultiUpgrade = HeroManager:isMultiUpgrade()
	self.m_csNode.weixuanzhong.xuanzhong:setVisible(self.m_isMultiUpgrade)
	local hero = HeroManager:getHero(self.m_heroId)
	local star = hero:getStarLv()
	if star >= kMaxStarLv then
		if hero:isAwaken() then
			HeroManager:onGetCardAwakeInfoRequest(hero:getUid())
		end
		self:refreshAwakeBtn(hero:isAwaken())
	end
end

function This:initTouchEvent()
	self.m_csNode.levelupbotton:setTouchEnded(function ()
		if not self.m_isMultiUpgrade then 
			HeroManager:onUpgradeLevelRequest(self.m_heroId)
		else
			HeroManager:onUpgradeMultiLevelRequest(self.m_heroId)
		end
	end)

    self.m_csNode.weixuanzhong:setTouchEnded(function()
        if not self.m_runningAniantion then
            local visible = self.m_csNode.weixuanzhong.xuanzhong:isVisible()
            if self.m_isMultiUpgrade == visible then 
                self.m_isMultiUpgrade = not visible
                HeroManager:setIsMultiUpgrade(self.m_isMultiUpgrade)
                self.m_csNode.weixuanzhong.xuanzhong:setVisible(self.m_isMultiUpgrade)
            end
        end
    end)

	self.m_csNode.Star.starupbotton:setTouch({
		onEnded = function()
			local hero = HeroManager:getHero(self.m_heroId)
			local star = hero:getStarLv()
			if star >= kMaxStarLv then
				if hero:isAwaken() then
					g_scene:openDialog("Awake.AwakTabPanel",{heroId = self.m_heroId})
				end
			else
				local quaStarConfig = hero:getNextQualityStarConfig()
				local itemId = hero:getId() + 10000
				if DepotManager:getItemCount(itemId) < quaStarConfig.debris_cost then
					g_scene:showTips(string.format(Serialize[61264],hero:getName()))
					return
				end
				HeroManager:onUpgradeStarLvRequest(self.m_heroId)
			end
		end,
		isDynamic = true,
	})

	self.m_csNode.Star.stairsupbutton:setTouchEnded(function()
		local hero = HeroManager:getHero(self.m_heroId)
		local quaStarConfig = hero:getNextQualityStarConfig()
		local itemId = 113  --升星石
		if hero:getLevel() < quaStarConfig.level_limit then
			local sp = hero:getStarLv() * 5 + hero:getPhase() + 1
			g_scene:showTips(string.format(Serialize[61265],quaStarConfig.level_limit,math.floor(sp / 5), sp % 5))
			return
		end
		if DepotManager:getItemCount(itemId) < quaStarConfig.stone_cost then
			g_scene:showTips(string.format(Serialize[61266]))
			return
		end
		HeroManager:onUpgradeStarLvRequest(self.m_heroId)
	end)
	self.m_csNode.weaponslot:setTouch({
		onEnded = function()
			self:onEquipPosClicked(EquipPos.kWeapons,self.m_csNode.weaponslot)
		end,
		isScale = false
	})
	self.m_csNode.clothesslot:setTouch({
		onEnded = function()
			self:onEquipPosClicked(EquipPos.kClothes,self.m_csNode.clothesslot)
		end,
		isScale = false
	})
	self.m_csNode.horseslot:setTouch({
		onEnded = function()
			self:onEquipPosClicked(EquipPos.kHorse,self.m_csNode.horseslot)
		end,
		isScale = false
	})
	self.m_csNode.fabao:setTouch({
		onEnded = function()
			self:onFabaoPosClicked(FabaoPos.kFirst, self.m_csNode.fabao)
		end,
		isScale = false
	})
	self.m_csNode.collocation:setTouchEnded(function()
		local hero = HeroManager:getHero(self.m_heroId)
		g_scene:openDialog("Hero.AllotAttrPointPanel",hero)
	end)
	self.m_csNode.exchange:setTouch({
		onEnded = function()
			local hero = HeroManager:getHero(self.m_heroId)
			local quality = hero:getQuality()
			if quality<Quality.kPurple or hero:isRed() then
			    g_scene:showTips(Serialize["Awake_UpPanel_1"])
			    return
			end
			g_scene:openDialog("Hero.PieceExchangePanel",hero)
		end,
		isDynamic = true
	})

	-- 英文版才有，属性介绍
	if self.m_csNode.underline then
		self.m_csNode.underline.propdetail:setTouchEnded(function()
			g_scene:openDialog("Hero.EnglishAttrTipsPanel")
		end)
	end
end

function This:setModel(heroId)
	if self.m_heroId ~= heroId then
		self.m_heroId = heroId
		self:refresh()
		local hero = HeroManager:getHero(self.m_heroId)
		local star = hero:getStarLv()
		self:refreshAwakeBtn(hero:isAwaken() and star >= kMaxStarLv)
	end
end

function This:refresh()
	self:refreshLevel()
	self:refreshGrowAttr()
	self:refreshEquipment()
	self:refreshStar()
	self:refreshEquipment()
end

function This:refreshLevel()
	local hero = HeroManager:getHero(self.m_heroId)
	local reserveExp = GamePlayer:getReserveExp()
	self.m_csNode.storageexp:setString(tonumber(reserveExp))
	local nextLevel = hero:getLevel() + 1
	if nextLevel > kMaxLevel then
		self.m_csNode.expfull:setVisible(true)
		self.m_csNode.exp:setVisible(false)
        self.m_csNode.expbg:setVisible(false)
        self.m_csNode.levelupbotton:setVisible(false)
	else
		self.m_csNode.exp:setString("0/"..HeroLevelExpConfig[nextLevel].exp)
		self.m_csNode.expfull:setVisible(false)
        self.m_csNode.expbg:setVisible(true)
		self.m_csNode.exp:setVisible(true)
        self.m_csNode.levelupbotton:setVisible(true)
	end
end

function This:refreshAwakeBtn( isAwake )
	local y= -282
	if isAwake then
		y=-255
		-- self.m_csNode.exchange:setVisible(not isAwake)
	end
	self.m_csNode.Star.starupbotton:setPositionY(y)
end

function This:refreshStar()
	local hero = HeroManager:getHero(self.m_heroId)
	local star = hero:getStarLv()
	local phase = hero:getPhase()

	for i = 1, 5 do
		self.m_csNode.Star["star"..i]:setVisible(star >= i)
	end
	for i = 1 , 5 do
		self.m_csNode.Star["piecebar"..i]:setVisible(phase >= i)
	end

	self.m_csNode.Star.Startext:setStringWithColor(string.format("<B1>%s<PetPhase2>%s：",StarName[star],PhaseName[phase]))
	if star >= kMaxStarLv then
		if hero:isAwaken() then
			self.m_csNode.Star.starupbotton.text:setString(Serialize[61267])
			self.m_csNode.Star.starupbotton:setVisible(true)
			self.m_csNode.Star.piecebg:setVisible(false)
			self.m_csNode.Star.stairsupbutton:setVisible(false)
		else
			self.m_csNode.Star.starupbotton:setVisible(false)
			self.m_csNode.Star.stairsupbutton:setVisible(false)
			self.m_csNode.Star.piecebg:setVisible(false)
			self.m_csNode.exchange:setVisible(false)
		end
		self:refreshAwakeBtn(hero:isAwaken())
		for i = 1 , 5 do
			self.m_csNode.Star["piecebar"..i]:setVisible(true)
		end
	else
		local quaStarConfig = hero:getNextQualityStarConfig()
		local itemId , cost = 0, 0
		if quaStarConfig.stone_cost > 0 then
			itemId = 113  --升星石
			cost = quaStarConfig.stone_cost
			local num = DepotManager:getItemCount(itemId)
			if phase >= kMaxStarLv - 1 then
				self.m_csNode.Star.piece:setStringWithColor(string.format(Serialize[61268],num,cost))
			else
				self.m_csNode.Star.piece:setStringWithColor(string.format(Serialize[61269],num,cost))
			end
		else
			itemId = hero:getId() + 10000
			cost = quaStarConfig.debris_cost
			local num = DepotManager:getItemCount(itemId)
			if phase >= kMaxStarLv - 1 then
				self.m_csNode.Star.piece:setStringWithColor(string.format(Serialize[61270],num,cost))
			else 
				self.m_csNode.Star.piece:setStringWithColor(string.format(Serialize[61271],num,cost))
			end
		end

		self.m_csNode.Star.piecebg:setVisible(true)
		if phase >= kMaxStarLv - 1 then
			self.m_csNode.Star.starupbotton.text:setString(Serialize[61272])
			self.m_csNode.Star.starupbotton:setVisible(true)
			self.m_csNode.Star.stairsupbutton:setVisible(false)
			self.m_csNode.suipian:setImage("MenuScene/suipian.png")
			self.m_csNode.suipian:setScale(1)
		else
			self.m_csNode.Star.stairsupbutton.text:setString(Serialize[61273])
			self.m_csNode.Star.stairsupbutton:setVisible(true)
			self.m_csNode.Star.starupbotton:setVisible(false)
			self.m_csNode.suipian:setImage("Icons/Item/113.png")
			self.m_csNode.suipian:setScale(0.50)
		end
	end
	self.m_csNode.exchange:setVisible(star < kMaxStarLv)
	self.m_csNode.Star.piece:setVisible(star < kMaxStarLv)
end

function This:refreshEquipment()
	local image = "MenuScene/3003.png"
	local hero = HeroManager:getHero(self.m_heroId)
	local nodeKey = {"weaponslot","clothesslot","horseslot"}
	-- 武器，衣服，战马
	for i = EquipPos.kWeapons , EquipPos.kHorse do
		local equipUid = hero:getEquipUid(i)
		local node = self.m_csNode[nodeKey[i]]
		if equipUid and equipUid > 0 then
			local equip = EquipManager:getEquip(equipUid)
			if equip then
				if not node.itemNode then
					local itemNode = ItemNode:create(equip:getEquipId())
					itemNode:setAnchorPoint(0.5,0.5)
					itemNode:setToEquip(equip:getStrengthLv(),equip:getLevel())
					node.icon:addChild(itemNode)
					node.itemNode = itemNode
				else
					node.itemNode:initItem(equip:getEquipId())
					node.itemNode:setToEquip(equip:getStrengthLv(),equip:getLevel())
				end
			end
		else
			if node.itemNode then
				node.itemNode:removeFromParent()
				node.itemNode = nil
			end
		end
	end
	-- 法宝
	nodeKey = {"fabao"}
	for i = FabaoPos.kFirst, FabaoPos.kMax do
		local fabaoNode = self.m_csNode[nodeKey[i]]
		local fabaoUid = hero:getFabaoUid(i)
		local fabao
		if fabaoUid and fabaoUid > 0 then
			fabao = FabaoManager:getFabao(fabaoUid)
		end

		if fabao then
			if not fabaoNode.itemNode then
				local itemNode = ItemNode:create(fabao:getItemId())
				itemNode:setAnchorPoint(0.5,0.5)
				itemNode:setToFabao(fabao:getLevel(), fabao:getJinglianDegree(), fabao:getStarLevel())
				fabaoNode.icon:addChild(itemNode)
				fabaoNode.itemNode = itemNode
			else
				fabaoNode.itemNode:initItem(fabao:getItemId())
				fabaoNode.itemNode:setToFabao(fabao:getLevel(), fabao:getJinglianDegree(), fabao:getStarLevel())
			end
		else
			if fabaoNode.itemNode then
				fabaoNode.itemNode:removeFromParent()
				fabaoNode.itemNode = nil
			end
		end
	end
end

function This:refreshGrowAttr()
	local hero = HeroManager:getHero(self.m_heroId)
	self.m_csNode.chief:setString(string.format("%d",hero:getAttr(AttrType.kChiefValue)))
	local growChief = hero:getChiefGrowValue()
	self.m_csNode.chiefgrowth:setString(string.format("(+%.2f)",growChief))

	self.m_csNode.power:setString(string.format("%d",hero:getAttr(AttrType.kPower)))
	local growPower = hero:getPowerGrowValue()
	self.m_csNode.powergrowth:setString(string.format("(+%.2f)",growPower))

	self.m_csNode.Intelligence:setString(string.format("%d",hero:getAttr(AttrType.kIntelligence)))
	local growIntelligence = hero:getIntelligenceGrowValue()
	self.m_csNode.Intelligencegrowth:setString(string.format("(+%.2f)",growIntelligence))

	self.m_csNode.defense:setString(string.format("%d",hero:getAttr(AttrType.kDfs)))
	local growDfs = hero:getDfsGrowValue()
	self.m_csNode.dfsgrow:setString(string.format("(+%.2f)",growDfs))
	self.m_csNode.collocation:setVisible(hero:getLevel() > 50)

	self.m_csNode.speed:setString(string.format("%.2f",hero:getAttr(AttrType.kFirst)))
end

function This:onEnter()
	super.onEnter(self)
	self:refresh()
	self:initTouchEvent()
	HeroManager:addObserver(self)
	EquipManager:addObserver(self)
	FabaoManager:addObserver(self)
end

function This:onExit()
	super.onExit(self)
	HeroManager:removeObserver(self)
	EquipManager:removeObserver(self)
	FabaoManager:removeObserver(self)
end

function This:onEquipPosClicked(pos,node)
	local hero = HeroManager:getHero(self.m_heroId)
	local isWear = hero:isWearEquip(pos)
	if not isWear then
		self:chooseEquip(pos)
	else
		self:showEquipTips(pos,node)
	end
end

function This:chooseEquip(pos)
	local panel = g_scene:openDialog("Equip.EquipChoosePanel",{pos = pos})
	panel:setSelectHandler(function(uid)
		HeroManager:onUpdateEquipRequest(self.m_heroId,pos,uid)
	end)
end

function This:showEquipTips(pos,node)
	local hero = HeroManager:getHero(self.m_heroId)
	local equipUid = hero:getEquipUid(pos)
	g_scene:openDialog("Equip.EquipTips",{pos = pos,equipUid = equipUid,heroId = self.m_heroId,node = node})
end

function This:onFabaoPosClicked(pos)
	local hero = HeroManager:getHero(self.m_heroId)
	local heroUid = hero:getUid()
	local fabaoUid, fabaoId
	if hero:isWearFabao(pos) then
		fabaoUid = hero:getFabaoUid(pos)
		local fabao = FabaoManager:getFabao(fabaoUid)
		if fabao then
			fabaoId = fabao:getItemId()
		end
	end

	if not fabaoId then
		local neededPlayerLevel = ArgConfig.fabao_open_level.arg[1]
		if GamePlayer:getLevel() < neededPlayerLevel then
			g_scene:showTips(tostring(neededPlayerLevel) .. Serialize[60917])
		else
			local panel = g_scene:openDialog("Equip.EquipChoosePanel",{pos = pos, type = ItemCommonType.kFaBao})
			panel:setSelectHandler(function(uid)
				HeroManager:onEquipFabaoRequest(heroUid, uid)
			end)
		end
	else
		g_scene:openDialog("Fabao.FabaoTips",{
			itemId = fabaoId,
			heroUid = heroUid,
			fabaoUid = fabaoUid,
			pos = pos,
		})
	end
end

-------------------------------------------------------

function This:onUpgradeLevel(heroId)
	if self.m_heroId == heroId then
		self:refreshLevel()
		self:refreshGrowAttr()
	end
end

function This:onUpgradeStarLv(heroId)
	if self.m_heroId == heroId then
		self:refreshStar()
		self:refreshGrowAttr()
	end
end

function This:onUpgradeQuality(heroId)
	if self.m_heroId == heroId then
		self:refreshStar()
		self:refreshGrowAttr()
	end
end

function This:onStrengthLevel(equipUid)
	local equip = EquipManager:getEquip(equipUid)
	if equip and equip:getHeroId() == self.m_heroId then
		self:refreshEquipment()
		self:refreshGrowAttr()
	end 
end

function This:onEquipUpLevel(equipUid)
	local equip = EquipManager:getEquip(equipUid)
	if equip and equip:getHeroId() == self.m_heroId then
		self:refreshEquipment()
		self:refreshGrowAttr()
	end 
end

function This:onEquipUpgradeQuality(equipUid)
	self:onStrengthLevel(equipUid)
end

function This:onEquipChanged(heroId)
	if heroId == self.m_heroId then
		self:refreshEquipment()
		self:refreshGrowAttr()
	end 
end

function This:onUnequippedFabaosChanged()
	self:refreshEquipment()
end

function This:onAddAttrPoint(heroId)
	if self.m_heroId == heroId then
		self:refreshGrowAttr()
	end
end

function This:onClearAttrPoint(heroId)
	if self.m_heroId == heroId then
		self:refreshGrowAttr()
	end	
end

function This:onExchangePiece(itemId,num)
	self:refreshStar()
end

function This:onAttachSoilder(heroId,soilderId)
	self:refreshGrowAttr()
end

function This:onTrainSoilder(heroId, soilderId)
	self:refreshGrowAttr()
end

function This:onHeroReset(hero)
	if self.m_heroId == hero:getId() then
		self:refreshLevel()
		self:refreshGrowAttr()
		self:refreshStar()
	end
end
function This:onEquipPsvSkill(solt)
	if self.m_heroId == solt:getHero():getId() then
		self:refreshGrowAttr()
	end
end

function This:onFabaoDataChanged(fabaoUid)
	local hero = HeroManager:getHero(self.m_heroId)
	if hero:isWearFabao(FabaoPos.kFirst) then
		local fabao = FabaoManager:getFabao(hero:getFabaoUid(FabaoPos.kFirst))
		if fabao:getUid() == fabaoUid then
			self:refreshGrowAttr()
			self:refreshEquipment()
		end
	end
end

function This:onHeroInfoChanged(heroId)
	if self.m_heroId == heroId then
		self:refresh()
	end	
end
--endregion
