--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This = class(...)
local HeroConfig = require("Metadatas.HeroConfig")
local StarUpConfig = require("Metadatas.StarUpConfig")
local FetterConfig = require("Metadatas.FetterConfig")
local AttributeHelper = require("Battle.AttributeHelper")
local QualityStarConfig = require("Metadatas.QualityStarConfig")
local HeroLevelExpConfig = require("Metadatas.HeroLevelExpConfig")
local GamePlayer = require("Player.GamePlayer")
local HeroManager = require("Hero.HeroManager")
local EquipManager = require("Equip.EquipManager")
local RuneManager = require("Equip.RuneManager")
local FabaoManager = require("Fabao.FabaoManager")
local DepotManager = require("Depot.DepotManager")
local HeroUtil = require("Hero.HeroUtil")
local StageManager = require("Stage.GameStageManager")
local DrumManager = require("Drum.DrumManager")
-- local LegionPlusConfig = require("Metadatas.LegionPlusConfig")
local Soilder = require("Hero.Soilder")
local AwakeSoilser = require("Awake.AwakeSoilser")
local UniversalConfig = require("Metadatas.UniversalConfig")
local TerrBuildManager = require("Territory.TerrBuildManager")
local PsvSkillSolt = require("Hero.PsvSkillSolt")
local RuneSolt = require("Equip.RuneSolt")
local PassiveSkillConfig = require("Metadatas.PassiveSkillConfig")
local PassiveSkillTakeConfig = require("Metadatas.PassiveSkillTakeConfig")
local GameUtil = require("Util.GameUtil")
local TerrTechnManager = require("Territory.TerrTechnManager")
local HeroAwak = require("Awake.HeroAwak")
local GameKingWayManager = require("Awake.GameKingWayManager")
local ReinforcementImpactConfig = require("Metadatas.ReinforcementImpactConfig")
local AffinationImpactConfig = require("Metadatas.AffinationImpactConfig")
local FamilyRatingManager = require("FamilyRating.FamilyRatingManager")
local ArrayManager = require("Hero.ArrayManager")
local ArgConfig = require("Metadatas.ArgConfig")
local HeroRefine = require("HeroRefine.HeroRefine")
local NobilityManager = require("Nobility.NobilityManager")
local ArmyTacticalManager = require("ArmyTactical.ArmyTacticalManager")
local HeroTactics = require("HeroTactics.HeroTactics")

local ErrorCode = 
{
	kToLevelLimit = "to_level_limit",
	kExpNotEnough = "exp_not_enough",
	kToStarLimit = "to_star_limit",
	kPieceNoEnough = "piece_not_enough",
	kStarNotEnough = "star_not_enough",
	kToMaxQuality = "to_max_quality",
	kHasNoDeputyPos = "has_no_deputy_pos",
	kQualityNotEnough = "quality_not_enough",
	kQualityMoreBig = "quality_more_big",
	kHasNoDeputy = "has_no_deputy",
	kHaveGotDeputy = "have_got_deputy",
	kHaveNoHero = "have_no_hero",
	kHaveGotHero = "have_got_hero",
	kHaveBeDeputy = "have_be_deputy",
	kHaveBePrimary = "have_be_primary",
	kDeputyPos1Lock = "deputy_pos1_lock",
	kDeputyPos2Lock = "deputy_pos2_lock",
	kHaveNoEquip = "have_no_equip",
	kHaveWearEquip = "have_wear_equip",
	kEquipHaveWeard = "equip_have_weard",
	kEquipPosWrong = "equip_pos_wrong",
	kInStageEmbattle = "in_stage_embattle",
	kHeroState1 = "in_free",
	kHeroState2 = "in_march",
	kHeroState3 = "in_garrision",
	kHeroState4 = "in_fighting",
	kDataError = "data_error",
}

-- local print = print_r

function This:create(...)
	local hero = {}
	setmetatable(hero,self)
	hero:init(...)
	return hero
end

function This:init(info)
	self.m_uid = 0
	self.m_id = info.heroId or info.type_id
	self.m_config = HeroConfig[self.m_id]

	if self.m_config == nil then
		--assert(false)
	end

	local star = info.starLv or 0

	self.m_starLv =  math.floor(star / 5)
	self.m_phase = star % 5
	self.m_level = info.level or 1
	self.m_quality = info.quality or self.m_config.quality
	if info.state == 0 then
		--assert(false)
	end
	self.m_state = info.state or HeroState.kInFree
	self.m_primaryHero = info.primary or 0
	self.m_isGot = info.isGot or false
	self.m_cityId = 0

	self.m_attribute = AttributeHelper:create()
	self.m_backupAttr = {}
	self.m_equips = {0,0,0} -- 武器uid，衣服uid，战马uid
	self.m_fabaos = {0} -- 法宝uid
	self.m_deputyHeros = {0,0}
	self.m_deputyAttr = {}
	self.m_recommend = {}
	self.m_fetters = {}
	self.m_attrPoint = {
		[AttrType.kPower] = 0,
		[AttrType.kIntelligence] = 0,
		[AttrType.kChiefValue] = 0,
		[AttrType.kDfs] = 0,
	}
	self.m_attrPointCount = 0


	self.m_soilder = {}
	self.m_awakeSoilder ={}

	local soilderTypeList = {
		SoilderType.kShield,
		SoilderType.kCavalry,
		SoilderType.kArcher,
		SoilderType.kSapperCar,
	}
	for _, stype in ipairs(soilderTypeList) do
		local soilder = Soilder:create({id = stype})
		self.m_soilder[stype] = soilder
		local awakeSoilder = AwakeSoilser:create({id = stype,contry = self.m_config.country})
		self.m_awakeSoilder[stype] = awakeSoilder
		soilder:setAwake(awakeSoilder)
	end
	self.m_curSoilderId = 0

	self.m_psvSolt = {}
	self.m_psvSkillFactor = 0
	for i = 1, 6 do
		local solt = PsvSkillSolt:create({
			quality = self.m_quality,
			solt = i,
			hero = self
		})
		self.m_psvSolt[i] = solt
	end
	self.m_runeSolt ={}
	local runeSoldMax = RuneManager:getMaxSolt()
	for i = 1, runeSoldMax do
		local solt = RuneSolt:create({
			quality = self.m_quality,
			solt = i,
			hero = self
		})
		self.m_runeSolt[i] = solt
	end

	--觉醒部分
	self.m_awake = HeroAwak:create(self)

	--精进
	self.m_refine = HeroRefine:create(self)

	--战法
	self.m_tactics = HeroTactics:create(self)

	self:initAttr(info.equip or {},info.deputy or {})
end

function This:initAttr(equips,deputy)
	------------成长-----------------
	self.m_fightPower = 0
	self.m_growFactor = 0
	self:updateGrowFactor()
	self:initAttribute()

	----------装备--------------
	for pos , equipUid in pairs(equips) do
		self:initEquip(pos,equipUid)
	end

	----------军团---------------
	for i , id in pairs(self.m_config.legion) do
		self.m_recommend[id] = true
	end 
	self:setDeputy(deputy) 

	if self.m_primaryHero > 0 then
		local primary = HeroManager:getHero(self.m_primaryHero)
		primary:updateDeputy(self)
	end

	-----------羁绊-------------
	for i , fetterId in pairs(HeroConfig[self.m_id].fetter) do
		self.m_fetters[fetterId] = HeroManager:createFetter(self.m_id,fetterId)
	end

	self:initDependentAttr()
	self:updateFightPower()
end

function This:setHeroInfo(info)
	--print(string.format("old uid = %s, typeId = %d, new uid = %s",GameUtil:int64ToString(self.m_uid),self.m_id,GameUtil:int64ToString(info.id)))
	self.m_uid = info.id
	local star = info.starLv or 0
	self.m_starLv = math.floor(star / 5)
	self.m_phase = star % 5
	self.m_level = info.level or 1
	self.m_quality = info.quality or self.m_config.quality
	self.m_state = info.state or HeroState.kInFree
	self.m_primaryHero = info.primary or 0
	self.m_curSoilderId = 0
	self.m_attribute:setAttrDefault()
	self.m_backupAttr = {}
	self.m_deputyHeros = {0,0}
	self.m_attrPoint = {
		[AttrType.kPower] = 0,
		[AttrType.kIntelligence] = 0,
		[AttrType.kChiefValue] = 0,
		[AttrType.kDfs] = 0,
	}
	self.m_equips = {0,0,0} -- 武器uid，衣服uid，战马uid

	local firstFabao = self.m_fabaos[FabaoPos.kFirst]
	if firstFabao and firstFabao > 0 then
		print("magic_weapon_id:" .. info.magic_weapon_id)
		self:equipFabao(FabaoPos.kFirst,info.magic_weapon_id)
	end
	self.m_fabaos = {info.magic_weapon_id} -- 法宝uid
	self.m_attrPointCount = 0
	for i , soilder in pairs(self.m_soilder) do
		soilder:reset()
	end
	for i , soilder in pairs(self.m_awakeSoilder) do
		soilder:reset()
	end

	self:initAttr(info.equips or {},info.deputy or {})
	self:updateAttrPoint(info.point_list,info.remain_point)
	self:updateSoilders(info.force_type_list,info.force_type,info.awake_force_index)
	self:updateJiaoChangAttr()
	self:updateTechnAttr()
	self:updateAwakeInfo(info.awake)
	self:updateSaintAttr()
	self:updateWangDao()
	self:updateMingWang()
	self:updateDrum()
	self:updateRating()
	self:updateScience()
	self:updateArray()
	self:updateEquipClear()
	self:updateFateAttr()
	self:updatePsvSolt(info.skill_id_list,info.pos,info.runestone_id_list,info.runestone_pos_list)
	self:updateNobilityAttr()
	self:updateRefine(info.refinemen_info)
	self:updateArmyTacticalAttr()
	self:updateInscription()
	self:updateFateInfo(info.fatalism_list)
	self:updateTactics(info.tactics_info)
	print("updateTactics")

	if self:isWearFabao(FabaoPos.kFirst) then
		self:updateFabao(0, self:getFabaoUid(FabaoPos.kFirst)) -- TODO
	end
end

function This:getUid()
	return self.m_uid
end

function This:setUid(uid)
	self.m_uid = uid
end

function This:getId()
	return self.m_id
end

function This:isRed()
	return self:getQuality() ==Quality.kRed
end

function This:getAttribute()
	return self.m_attribute
end

function This:getLevel()
	return self.m_level
end

function This:getStarLv()
	return self.m_starLv
end

function This:getPhase()
	return self.m_phase
end

function This:getTotalPhase()
	return self.m_starLv * 5 + self.m_phase
end

function This:getQuality()
	return self.m_quality
end

function This:getQualityStarConfig()
	local key = self.m_quality * 1000 + self.m_starLv * 5 + self.m_phase
	return QualityStarConfig[key]
end

function This:getNextQualityStarConfig()
	local key = self.m_quality * 1000 + self.m_starLv * 5 + self.m_phase + 1
	return QualityStarConfig[key]
end

function This:getName()
	return self.m_config.name
end

function This:getSound()
	return self.m_config.sound 
end

function This:getCityId()
	return self.m_cityId
end

function This:setCityId(cityId)
	self.m_cityId = cityId
end

function This:getIcon()
	local icon = string.format("Hero/%d.png",self.m_config.icon)
	if cc.FileUtils:isFileExist(icon) then
		return icon
	end
	return "Hero/10031.png"
end

function This:getSkillId()
	if self:isAwakeFull() then
		return self:getAwakenSkillId()
	end
	return self.m_config.skill_id
end

function This:getLegionName()
	if self:isDeputy() then
		local leginName = HeroConfig[self.m_primaryHero].name
		return string.format(Serialize[61275],leginName)
	elseif self:isPrimary() then
		return string.format(Serialize[61275],self.m_config.name)
	end
end

function This:getCountry()
	return self.m_config.country
end

function This:getFightPower()
	return math.floor(self.m_fightPower)
end

function This:getState()
	return self.m_state
end

function This:setState(state)
	self.m_state = state
end

function This:isGot()	--是否已获取
	return self.m_isGot
end

function This:hasWearEquip()
	return self.m_equips[1] > 0 or self.m_equips[2] > 0 or self.m_equips[3] > 0
end

function This:isAwaken()	--是否可觉醒
	return self.m_config.is_awaken == 1
end

function This:getDeputyCount()	--获取副将数量
	local count  = 0
	if self.m_deputyHeros[1] and self.m_deputyHeros[1] > 0 then
		count = count + 1
	end
	if self.m_deputyHeros[2] and self.m_deputyHeros[2] > 0 then
		count = count + 1
	end
	if count > 0 then assert(self.m_primaryHero <= 0) end
	return count
end

function This:getDeputyWithPos()
	return self.m_deputyHeros
end

function This:getDeputyHeros()	--获取副将列表
	local result = {}
	for i , id in pairs(self.m_deputyHeros) do
		if id > 0 then
			table.insert(result,id)
		end
	end
	return result
end

function This:getPrimaryHero()
	return self.m_primaryHero
end

function This:setPrimaryHero(heroId)
	if heroId > 100000 then
		assert(false)
	end
	self.m_primaryHero = heroId
	if heroId > 0 then
		assert(self:getDeputyCount()<=0)
	end
end

function This:isPrimary()	--是否是装备副将的主武将
	return self.m_primaryHero <= 0 and self:getDeputyCount() > 0
end

function This:isDeputy()	--是否是装备在主武将的副将
	return self.m_primaryHero > 0 and self:getDeputyCount() <= 0
end

function This:isRecommended(heroId)
	return self.m_recommend[heroId]
end

function This:isFetterHero(heroId)
	for id , fetter in pairs(self.m_fetters) do
		if fetter:isContain(heroId) then
			return true
		end
	end
	return false
end

function This:getAttr(attrId)
	return self.m_attribute:getAttr(attrId)
end

function This:addAttr(attrId , value)
	if attrId == AttrType.kPowerGrowValue then
		value = self.m_level * value
	elseif attrId == AttrType.kIntelligenceGrowValue then
		value = self.m_level * value
	elseif attrId == AttrType.kChiefGrowValue then
		value = self.m_level * value
	elseif attrId == AttrType.kDfsGrowValue then
		value = self.m_level * value
	end
	-- if attrId ==103 and value>0 then
	-- 	print("add-->",value)
	-- end
	return self.m_attribute:addAttr(attrId,value)
end

function This:reduceAttr(attrId,value)
	if attrId == AttrType.kPowerGrowValue then
		value = self.m_level * value
	elseif attrId == AttrType.kIntelligenceGrowValue then
		value = self.m_level * value
	elseif attrId == AttrType.kChiefGrowValue then
		value = self.m_level * value
	elseif attrId == AttrType.kDfsGrowValue then
		value = self.m_level * value
	end
	-- if attrId ==103 and value>0 then
	-- 	print("remove-->",value)
	-- end
	return self.m_attribute:reduceAttr(attrId,value)
end

function This:addAttrs( attrTable ,removeUpdatePower)
	for attrId,value in pairs(attrTable) do
		self:addAttr(attrId,value)
	end
	if not removeUpdatePower then
		self:updateFightPower()
	end
end

function This:reduceAttrs(attrTable,removeUpdatePower)
	for attrId,value in pairs(attrTable) do
		self:reduceAttr(attrId,value)
	end
	if not removeUpdatePower then
		self:updateFightPower()
	end
end

function This:getStarAttr()
	return self.m_config.up_star
end

function This:getEquipUid(pos)
	return self.m_equips[pos]
end

function This:equipFabao(pos, fabaoUid)
	local currentFabaoUid = self.m_fabaos[pos]
	if not currentFabaoUid then return end

	self:updateFabao(currentFabaoUid, fabaoUid) -- TODO
	if currentFabaoUid == 0 and fabaoUid ~= 0 then
		-- 装备法宝
		FabaoManager:changeFabaoToEquipped(fabaoUid)
	elseif currentFabaoUid ~= 0 and fabaoUid ~= 0 then
		-- 更换法宝
		FabaoManager:changeFabaoToUnequipped(currentFabaoUid)
		FabaoManager:changeFabaoToEquipped(fabaoUid)
	elseif currentFabaoUid ~= 0 and fabaoUid == 0 then
		-- 卸下法宝
		FabaoManager:changeFabaoToUnequipped(currentFabaoUid)
	end
	self.m_fabaos[FabaoPos.kFirst] = fabaoUid
end

function This:getFabaoUid(pos)
	return self.m_fabaos[pos]
end

function This:isWearEquip(pos)
	return self.m_equips[pos] and self.m_equips[pos] > 0
end

function This:isWearFabao(pos)
	if not pos then
		error("error!")
		return false
	end
	return self.m_fabaos[pos] and self.m_fabaos[pos] > 0
end

function This:hasDeputy(heroId)
	for i , id in pairs(self.m_deputyHeros) do
		if id > 0 and heroId == id then
			return true
		end
	end
	return false
end

function This:getPowerGrowValue()
	return  self.m_config.power_growth * self.m_growFactor
end

function This:getChiefGrowValue()
	return  self.m_config.chief_growth * self.m_growFactor
end

function This:getIntelligenceGrowValue()
	return self.m_config.Intelligence_growth * self.m_growFactor
end

function This:getDfsGrowValue()
	return self.m_config.resist_growth * self.m_growFactor
end

function This:getFetters()
	return self.m_fetters
end

------属性点
function This:getAttrPointCount()
	return self.m_attrPointCount
end

function This:addAttrPoint(attrId)
	assert(self.m_attrPoint[attrId])
	self.m_attrPoint[attrId] = self.m_attrPoint[attrId] + 1
end

function This:getAttrPoint(attrId)
	return self.m_attrPoint[attrId]
end

function This:getAllAttrPoint()
	return self.m_attrPoint[AttrType.kPower] + self.m_attrPoint[AttrType.kIntelligence] + self.m_attrPoint[AttrType.kChiefValue] + self.m_attrPoint[AttrType.kDfs]
end

function This:removeAttrPoint(attrId)
	assert(self.m_attrPoint[attrId])
	self.m_attrPoint[attrId] = self.m_attrPoint[attrId] - 1
end

function This:getLeftAttrPointCount()
	return self.m_attrPointCount - (self.m_attrPoint[AttrType.kPower] + self.m_attrPoint[AttrType.kIntelligence] + self.m_attrPoint[AttrType.kChiefValue] + self.m_attrPoint[AttrType.kDfs])
end

function This:getSoilder(id)
	return self.m_soilder[id]
end

function This:updateAllSoilderAttr()
	for i , soilder in pairs(self.m_soilder) do
		soilder:updateAttr()
	end
	self:updateAllAwakeSoilderAttr()
end

function This:getAwakeSoilder(id)
	return self.m_awakeSoilder[id]
end

function This:updateAllAwakeSoilderAttr()
	for i , soilder in pairs(self.m_awakeSoilder) do
		soilder:updateAttr()
	end
end

-----------------------------------------------------------------

function This:initStarAddAttr()
	--print("星级属性初始化:")
	for lv = 1 , self.m_starLv do
		local upstarId = self.m_config.up_star[lv]
		local attrId = StarUpConfig[upstarId].attri_id
		local value = StarUpConfig[upstarId].value
		--print(string.format("%s = %f",AttrName[attrId],value))
		self.m_attribute:addAttr(attrId,value)
	end

	local config = self:getQualityStarConfig()
	local ratio = config.extra_ratio
	self:addAttr(AttrType.kPower,self.m_config.extra_attribute[1] * ratio)
	self:addAttr(AttrType.kIntelligence,self.m_config.extra_attribute[2] * ratio)
	self:addAttr(AttrType.kChiefValue,self.m_config.extra_attribute[3] * ratio)
	self:addAttr(AttrType.kDfs,self.m_config.extra_attribute[4] * ratio)
end

function This:initAttribute()
	--print(string.format("\n初始化武将%s",self:getName()));
	self.m_attribute:setAttrDefault()
	self:initStarAddAttr()
	self:updateGrowAttribute()
end

function This:initDependentAttr()
	self.m_attribute:addAttr(AttrType.kAngerValue,self.m_config.anger)
	--print(string.format("初始怒气值：%d",self.m_attribute:getAttr(AttrType.kAngerValue)))

	local maxHp = self.m_attribute:getAttr(AttrType.kMaxHp)
	self.m_attribute:addAttr(AttrType.kHp,maxHp)
	--print(string.format("初始兵力：%f",self.m_attribute:getAttr(AttrType.kHp)))
end

function This:initEquip(pos,equipUid)
	if not (pos >= EquipPos.kWeapons and pos <= EquipPos.kHorse) then
		print("initEquip fail")
		return
	end

	if self.m_equips[pos] <= 0 and equipUid > 0 then
		local equip = EquipManager:getEquip(equipUid)
        if equip then
		    equip:initHeroId(self:getId())
		    self.m_equips[pos] = equipUid
        else
            print(string.format("%s:%d不存在", self:getName(), pos))
        end
	end
end

function This:backupAttr()
	self.m_backupAttr = self.m_backupAttr or {}
	self.m_backupAttr.power = self.m_attribute:getAttr(AttrType.kPower)
	self.m_backupAttr.growPower = self:getPowerGrowValue()
	self.m_backupAttr.growAttrPower = self:calculateGrowAttr(self.m_config.power,self.m_quality,self.m_config.power_growth,self.m_level,self.m_growFactor)
	self.m_backupAttr.chief = self.m_attribute:getAttr(AttrType.kChiefValue)
	self.m_backupAttr.growChief = self:getChiefGrowValue()
	self.m_backupAttr.growAttrChief = self:calculateGrowAttr(self.m_config.chief,self.m_quality,self.m_config.chief_growth,self.m_level,self.m_growFactor)
	self.m_backupAttr.intelligence = self.m_attribute:getAttr(AttrType.kIntelligence)
	self.m_backupAttr.growIntelligence = self:getIntelligenceGrowValue()
	self.m_backupAttr.growAttrIntelligence = self:calculateGrowAttr(self.m_config.Intelligence,self.m_quality,self.m_config.Intelligence_growth,self.m_level,self.m_growFactor)
	

	self.m_backupAttr.dfs = self.m_attribute:getAttr(AttrType.kDfs)
	self.m_backupAttr.growDfs = self:getDfsGrowValue()
	self.m_backupAttr.growAttrDfs = self:calculateGrowAttr(self.m_config.resist,self.m_quality,self.m_config.resist_growth,self.m_level,self.m_growFactor)
	
	self.m_backupAttr.firstValue = self:getAttr(AttrType.kFirst)
	self.m_backupAttr.growFistValue = self:calculateGrowFristValue(self.m_level,self.m_starLv)

	self.m_backupAttr.growFactor = self.m_growFactor
	self.m_backupAttr.starLv = self.m_starLv
	self.m_backupAttr.level = self.m_level
	self.m_backupAttr.quality = self.m_quality
	self.m_backupAttr.fightPower = self.m_fightPower
	self.m_backupAttr.phase = self.m_phase

--[[
	self.m_backupAttr.juexing = self:updateAwakeInfo(nil, true) or {}
	self.m_backupAttr.jiaochang = {}
	local build = TerrBuildManager:getBuildByType(TerrBuildType.kJiaoChang)
	build:getBuildAtrrNum()
	self.m_backupAttr.taixueyuan = {}
	self.m_backupAttr.science = {}
	self.m_backupAttr.array = {}
	if self.m_curSoilderId > 0 then
		local attrsList = TerrTechnManager:getAllTechnAttrAdditionList()
		self.m_backupAttr.taixueyuan = attrsList[self.m_curSoilderId] or {}
	end	
	self.m_backupAttr.wusheng = {}
	local saintInfo = HeroManager:getSaintInfo()
	local level = saintInfo:getSaintLevel()
	if level > 0 then
		self.m_backupAttr.wusheng = saintInfo:getSaintAttrAdditionList(level)
	end
	self.m_backupAttr.wangdang = GameKingWayManager:getCurentAtrr()
	self.m_backupAttr.mingWang = GamePlayer:getMingWangAttr()
	self.m_backupAttr.rating = FamilyRatingManager:getRatingAttr()
	local attrsList = FamilyRatingManager:getScienceAttr()
	self.m_backupAttr.science = attrsList[self.m_curSoilderId] or {}
	attrsList = ArrayManager:getArrayAttr()
	self.m_backupAttr.array = attrsList[self:getCountry()] or {}
	--self.m_backupAttr.scienceAdd = FamilyRatingManager:getScienceAddAttr() or {}
	self.m_backupAttr.equipClear = self:updateEquipClear(true) or {}
	self.m_backupAttr.suming = self:updateFateAttr(true) or {}
	self.m_backupAttr.fabao = {}
]]

end

function This:getBackupAttr()
	return self.m_backupAttr
end

function This:updateGrowFactor()
	local key = self.m_quality * 1000 + (self.m_starLv * 5 + self.m_phase)
	local growFactor = QualityStarConfig[key].grow_factor
	--print(string.format("更新成长系数:%f->%f",self.m_growFactor,growFactor))
	self.m_growFactor = growFactor
end

function This:updateStarAddAttr(oldStarLv)
	for lv = oldStarLv+1 , self.m_starLv do
		local upstarId = self.m_config.up_star[lv]
		local attrId = StarUpConfig[upstarId].attri_id
		local value = StarUpConfig[upstarId].value
		self.m_attribute:addAttr(attrId,value)
	end

	local quaStarKey = self.m_quality * 1000 + self.m_starLv * 5 + self.m_phase
	local oldKey = quaStarKey - 1
	local ratio = QualityStarConfig[quaStarKey].extra_ratio
	if QualityStarConfig[oldKey] then
		ratio = ratio -  QualityStarConfig[oldKey].extra_ratio
	end
	
	self:addAttr(AttrType.kPower,self.m_config.extra_attribute[1] * ratio)
	self:addAttr(AttrType.kIntelligence,self.m_config.extra_attribute[2] * ratio)
	self:addAttr(AttrType.kChiefValue,self.m_config.extra_attribute[3] * ratio)
	self:addAttr(AttrType.kDfs,self.m_config.extra_attribute[4] * ratio)
end

function This:calculateGrowAttr(power,quality,growth,level,growFactor)
	return power * QualityFactor[quality] + growth * level * growFactor
end

function This:calculateGrowFristValue(level,star)
	return self.m_config.first + self.m_config.first_growth * level  + star * self.m_config.first_star_growth
end

function This:updateGrowAttribute()
	local oldPower = self.m_backupAttr.growAttrPower or 0
	local newPower = self:calculateGrowAttr(self.m_config.power,self.m_quality,self.m_config.power_growth,self.m_level,self.m_growFactor)
	--print(string.format("更新成长力量:%f->%f",oldPower,newPower))
	self.m_attribute:addAttr(AttrType.kPower,newPower - oldPower)

	local oldChief = self.m_backupAttr.growAttrChief or 0
	local newChief = self:calculateGrowAttr(self.m_config.chief,self.m_quality,self.m_config.chief_growth,self.m_level,self.m_growFactor)
	--print(string.format("更新成长统帅值:%f->%f",oldChief,newChief))
	self.m_attribute:addAttr(AttrType.kChiefValue, newChief - oldChief)

	local oldIntelligence = self.m_backupAttr.growAttrIntelligence or 0
	local newIntelligence = self:calculateGrowAttr(self.m_config.Intelligence,self.m_quality,self.m_config.Intelligence_growth,self.m_level,self.m_growFactor)
	--print(string.format("更新成长智力:%f->%f",oldIntelligence,newIntelligence))
	self.m_attribute:addAttr(AttrType.kIntelligence,newIntelligence - oldIntelligence)

	local oldResist = self.m_backupAttr.growAttrDfs or 0
	local newResist = self:calculateGrowAttr(self.m_config.resist,self.m_quality,self.m_config.resist_growth,self.m_level,self.m_growFactor)
	--print(string.format("更新御值：%f->%f",oldResist,newResist))
	self.m_attribute:addAttr(AttrType.kDfs,newResist - oldResist)

	local oldFirst = self.m_backupAttr.growFistValue or 0
	local newFirst = self:calculateGrowFristValue(self.m_level,self.m_starLv)
	--print(string.format("更新先手值:%f->%f",oldFirst,newFirst))
	self.m_attribute:addAttr(AttrType.kFirst,newFirst - oldFirst)
end

function This:updateJiaoChangAttr(attrs)
	if not attrs then
		local build = TerrBuildManager:getBuildByType(TerrBuildType.kJiaoChang)
		if build then
			attrs = build:getBuildAtrrNum() or {}
		end
	end
	
	self.m_backupAttr.jiaochang =  self.m_backupAttr.jiaochang or {}
	local addattrs = {}
	for attrId , value in pairs(attrs) do
		addattrs[attrId] = value - (self.m_backupAttr.jiaochang[attrId] or 0)
		self:addAttr(attrId,addattrs[attrId])
		self.m_backupAttr.jiaochang[attrId] = value
	end
	self:updateFightPower()
end

function This:updateTechnAttr(attrsList)
	if self.m_curSoilderId <= 0 then
		return
	end

	if not attrsList then
		attrsList = TerrTechnManager:getAllTechnAttrAdditionList()
	end

	local attrs = attrsList[self.m_curSoilderId]
	self.m_backupAttr.taixueyuan =  self.m_backupAttr.taixueyuan or {}
	for attrId, value in pairs(self.m_backupAttr.taixueyuan) do	 --清理之前的太学院兵种加成
		self:reduceAttr(attrId,value)
	end
	self.m_backupAttr.taixueyuan = {}
	local addattrs = {}
	for attrId , value in pairs(attrs) do
		addattrs[attrId] = value - (self.m_backupAttr.taixueyuan[attrId] or 0)
		self:addAttr(attrId,addattrs[attrId])
		self.m_backupAttr.taixueyuan[attrId] = value
	end
	self:updateFightPower()
end

function This:resetEmptyAttrs(curenttAttrs, backAtrs)
	local res = {}

	function countTable(t)
		local count = 0
		for k, v in pairs(t) do
			count = count + 1
		end
		return count
	end

	if curenttAttrs ~= nil and backAtrs ~= nil then
		local curentAttrCount = countTable(curenttAttrs)
		local backAtrsCount = countTable(backAtrs)
		if curentAttrCount == 0 then
			for attrId, attrValue in pairs(backAtrs) do
				res[attrId] = 0
			end
		elseif backAtrsCount > curentAttrCount then
			for attrId, attrValue in pairs(backAtrs) do
				if curenttAttrs[attrId] then
					res[attrId] = curenttAttrs[attrId]
				else
					res[attrId] = 0
				end
			end
		else
			res = curenttAttrs
		end
	end
	return res
end

function This:updateRating(attrs)
	if not attrs then
		attrs = FamilyRatingManager:getRatingAttr()
	end
	self.m_backupAttr.rating  = self.m_backupAttr.rating or {}
	attrs = self:resetEmptyAttrs(attrs,self.m_backupAttr.rating)
	local addattrs = {}
	for attrId , value in pairs(attrs) do
		addattrs[attrId] = value - (self.m_backupAttr.rating[attrId] or 0)
		self:addAttr(attrId,addattrs[attrId])
		self.m_backupAttr.rating[attrId] = value
	end
	self:updateFightPower()
end

function This:updateScience(attrsList)
	if self.m_curSoilderId <= 0 then
		return
	end
	if not attrsList then
		attrsList = FamilyRatingManager:getScienceAttr() or{}
	end
	local attrs = attrsList[self.m_curSoilderId]
	self.m_backupAttr.science = self.m_backupAttr.science or {}
	attrs = self:resetEmptyAttrs(attrs,self.m_backupAttr.science)
	local addattrs = {}
	for attrId , value in pairs(attrs) do
		addattrs[attrId] = value - (self.m_backupAttr.science[attrId] or 0)
		self:addAttr(attrId,addattrs[attrId])
		self.m_backupAttr.science[attrId] = value
	end
	self:updateFightPower()
end

function This:updateArray(attrsList)
	if not attrsList then
		attrsList = ArrayManager:getArrayAttr() or {}
	end
	local attrs =attrsList[self:getCountry()] or {}
	self.m_backupAttr.array = self.m_backupAttr.array or {}
	attrs = self:resetEmptyAttrs(attrs,self.m_backupAttr.array)
	local addattrs = {}
	for attrId , value in pairs(attrs) do
		addattrs[attrId] = value - (self.m_backupAttr.array[attrId] or 0)
		self:addAttr(attrId,addattrs[attrId])
		self.m_backupAttr.array[attrId] = value
	end
	self:updateFightPower()
end


function This:updateMingWang(attrs)
	if not attrs then
		attrs = GamePlayer:getMingWangAttr()
	end
	self.m_backupAttr.mingWang  = self.m_backupAttr.mingWang or {}
	attrs = self:resetEmptyAttrs(attrs,self.m_backupAttr.mingWang)
	local addattrs = {}
	for attrId , value in pairs(attrs) do
		addattrs[attrId] = value - (self.m_backupAttr.mingWang[attrId] or 0)
		self:addAttr(attrId,addattrs[attrId])
		self.m_backupAttr.mingWang[attrId] = value
	end
	self:updateFightPower()
end

function This:updateDrum(attrs)
	if not attrs then
		attrs = DrumManager:getDrumAttr() or {}
	end
	self.m_backupAttr.drum  = self.m_backupAttr.drum or {}

	do
		local result = {}
		local backAtrs = self.m_backupAttr.drum
		if attrs ~= nil and backAtrs ~= nil then
			local curentAttrCount = table.count(attrs)
			local backAtrsCount = table.count(backAtrs)
			if curentAttrCount == 0 then
				for attrId, attrValue in pairs(backAtrs) do
					result[attrId] = 0
				end
			elseif backAtrsCount > curentAttrCount then
				for attrId, attrValue in pairs(backAtrs) do
					if not attrs[attrId] then
						result[attrId] = 0
					else
						result[attrId] = attrs[attrId]
					end
				end
			else
				result = attrs
			end
		end
		attrs = result or {}
	end

	local addattrs = {}
	for attrId , value in pairs(attrs) do
		addattrs[attrId] = value - (self.m_backupAttr.drum[attrId] or 0)
		self:addAttr(attrId, addattrs[attrId])
		self.m_backupAttr.drum[attrId] = value
	end
	self:updateFightPower()
end

function This:updateWangDao( attrs )
	if not attrs then
		if not GameKingWayManager:isHaveKingWay() then
			return
		end
		attrs = GameKingWayManager:getCurentAtrr()
	end
	self.m_backupAttr.wangdang  = self.m_backupAttr.wangdang or {}
	local addattrs = {}
	for attrId , value in pairs(attrs) do
		addattrs[attrId] = value - (self.m_backupAttr.wangdang[attrId] or 0)
		self:addAttr(attrId,addattrs[attrId])
		self.m_backupAttr.wangdang[attrId] = value
	end
	self:updateFightPower()
end

function This:updateEquipClear(forCalc)
	if GamePlayer:getLevel() < MasterOpenLevel then 
		return 
	end
	local attrs = {}
	local clearLevel, minStrLev,minLev = 0, nil,nil
	for pos = 1 , EquipPos.kHorse do
		local equipUid = self.m_equips[pos]
		local equip
		if equipUid > 0 then 
			equip = EquipManager:getEquip(equipUid)
		end
		if equip then 
			if minStrLev then
				local curStrLev = equip:getStrengthLv()
				if minStrLev > 0 and curStrLev < minStrLev then
					minStrLev = curStrLev 
				end
			else
				minStrLev = equip:getStrengthLv()
			end
			if minLev then
				local curLev = equip:getLevel()
				if minLev > 0 and curLev < minLev then
					minLev = curLev
				end
			else
				minLev = equip:getLevel()
			end
			clearLevel = clearLevel + equip:getClearTotalLevel()
		else
			minStrLev = 0
			minLev = 0
		end
	end
	
	local function getAttrFromConfig(attrMap, level, config)
		if level and level > 0 then 
			local found
			for _, v in ipairs(config) do 
				if level >= v.level_min and level <= v.level_max then 
					found = v
					break
				end
			end
			if found then
				local attrMax = 4
				for i = 1 , attrMax do 
					local attrId ,value = found["Attribute"..i][1],found["Attribute"..i][2]
					attrMap[attrId] = attrMap[attrId] or 0
					attrMap[attrId] = attrMap[attrId] + value
				end
			end
		end
	end
	if minStrLev and minStrLev > 0 then 
		getAttrFromConfig(attrs, minStrLev, ReinforcementImpactConfig)
	end
	-- if minLev and minLev > 0 then
	-- 	for pos = 1,EquipPos.kHorse do
	-- 		local equipUid = self.m_equips[pos]
	-- 		local equip
	-- 		if equipUid > 0 then 
	-- 			equip = EquipManager:getEquip(equipUid)
	-- 		end
	-- 		if equip then 
	-- 			for id,value in pairs (equip:getUpLevelAttr(minLev)) do
	-- 				attrs[id] = attrs[id] or 0
	-- 				attrs[id] = attrs[id] + value
	-- 			end
	-- 		end
	-- 	end
	-- end
	if clearLevel > 0 then 
		getAttrFromConfig(attrs, clearLevel, AffinationImpactConfig)
	end
	if forCalc then return attrs end

	self.m_backupAttr.equipClear = self.m_backupAttr.equipClear or {}
	for attrId , value in pairs(self.m_backupAttr.equipClear ) do
		self:addAttr(attrId,-value)
	end
	for attrId , value in pairs(attrs) do
		self:addAttr(attrId,value)
	end
	self.m_backupAttr.equipClear = attrs
	self:updateFightPower()
end

-- 刷新法宝变化带来的武将属性改变，这些变化有：
-- 	穿上法宝，脱下法宝，装备中的法宝升级，装备中的法宝精炼，装备中的法宝升星
function This:updateFabao(originalFabaoUid, fabaoUid)
	self.m_backupAttr.fabao = self.m_backupAttr.fabao or {}
	if originalFabaoUid ~= 0 and fabaoUid ~= 0 then
		-- 更换法宝，法宝升级，法宝精炼，法宝升星
		for attrId, attrValue in pairs(self.m_backupAttr.fabao) do
			self:addAttr(attrId, -attrValue)
			self.m_backupAttr.fabao[attrId] = 0
		end
		local fabao = FabaoManager:getFabao(fabaoUid)
		for attrId, attrValue in pairs(fabao:getAllAdditionalAttributes()) do
			self:addAttr(attrId, attrValue)
			self.m_backupAttr.fabao[attrId] = attrValue
		end
	elseif originalFabaoUid ~= 0 and fabaoUid == 0 then
		-- 脱下法宝
		local fabao = FabaoManager:getFabao(originalFabaoUid)
		for attrId, attrValue in pairs(fabao:getAllAdditionalAttributes()) do
			self:addAttr(attrId, -attrValue)
			self.m_backupAttr.fabao[attrId] = (self.m_backupAttr.fabao[attrId] or 0) - attrValue
		end
	elseif originalFabaoUid == 0 and fabaoUid ~= 0 then
		-- 装备法宝
		local fabao = FabaoManager:getFabao(fabaoUid)
		if fabao then
			for attrId, attrValue in pairs(fabao:getAllAdditionalAttributes()) do
				self:addAttr(attrId, attrValue)
				self.m_backupAttr.fabao[attrId] = attrValue
			end
		else
			print_tmp("找不到此法宝" .. GameUtil:int64ToString(fabaoUid))
		end
	elseif originalFabaoUid == 0 and fabaoUid == 0 then
		return
	end

	self:updateFightPower()
end

function This:updateInscription(alabaster_list)
	-- self.m_backupAttr.inScription = self.m_backupAttr.inScription or {}
	local LordEquipManager = require("Awake.LordEquipManager")

	local attr_type_list = {}
	local attr_value_list = {}
	if self.m_backupAttr.inScription then
		for i,v in pairs(self.m_backupAttr.inScription) do
			for kk,vv in pairs(v) do
				self:reduceAttr(vv.key,vv.value)
			end
		end
	end
	self.m_backupAttr.inScription = {}
	if not alabaster_list then
		alabaster_list = LordEquipManager:toGetAlabsterList()
	end
 	for i,v in ipairs(alabaster_list) do
 		local item_uid_list = v.item_uid_list
 		local index_list = v.index_list
 		for ii,vv in ipairs(item_uid_list) do
 			local attrForServer = LordEquipManager:getInscriptionAttrForSerever(vv)
	     	for k,v in pairs(attrForServer["attr_type_list"]) do
	     		attr_type_list[v] = v
	     	end
	     	for k,v in pairs(attrForServer["attr_value_list"]) do
	     		-- attr_value_list[attrForServer["attr_type_list"][k]] = v 
	     		attr_value_list[attrForServer["attr_type_list"][k]] = attr_value_list[attrForServer["attr_type_list"][k]] or {}
	     		table.insert(attr_value_list[attrForServer["attr_type_list"][k]],{key = attrForServer["attr_type_list"][k] ,value = v})
	     	end
 		end
 	end

 	if attr_type_list and attr_value_list then
	 	for k,v in pairs(attr_value_list) do
	 		for kk,vv in pairs(v) do
		 		self:addAttr(vv.key,vv.value)
		 		self.m_backupAttr.inScription[vv.key] = self.m_backupAttr.inScription[vv.key] or {}
		 		table.insert(self.m_backupAttr.inScription[vv.key],{key = vv.key,value = vv.value})
	 		end
	 	end
	end
	self:updateFightPower()
end

function This:updateSaintAttr(attrs)
	if not attrs then
		local saintInfo = HeroManager:getSaintInfo()
		local level = saintInfo:getSaintLevel()
		if level <= 0 then
			return
		end
		attrs = saintInfo:getSaintAttrAdditionList(level)
	end
	
	self.m_backupAttr.wusheng = self.m_backupAttr.wusheng or {}
	local addattrs = {}
	for attrId , value in pairs(attrs) do
		addattrs[attrId] = value - (self.m_backupAttr.wusheng[attrId] or 0)
		self:addAttr(attrId,addattrs[attrId])
		self.m_backupAttr.wusheng[attrId] = value
	end
	self:updateFightPower()
end

function This:updateFateInfo(info)
	local temInfo = info or {}
	local fateInfo = HeroManager:getFateInfo()
	local function resetFateInfo()
		local res = nil
		local myFate = fateInfo:getFateByHero(self)
		if myFate then
			for _,fate1 in ipairs(myFate) do
				fate1:reset()
				HeroManager:updateFateAttr(fate1)
				res = fate1
			end
		end
		return res
	end

	local fate = nil
	if #temInfo>0 then
		resetFateInfo()
		for _,fateData in ipairs(temInfo) do
			local fate1 = fateInfo:updateFate(fateData,nil,self:getId())
			HeroManager:updateFateAttr(fate1)
			fate = fate1
		end
	else
		fate = resetFateInfo()
		-- local myFate = fateInfo:getFateByHero(self)
		-- if myFate then
		-- 	for _,fate1 in ipairs(myFate) do
		-- 		fate1:reset()
		-- 		fate = fate1
		-- 	end
		-- end
	end
	if fate then
		HeroManager:updateFateAttr(fate)
	end
	
end

function This:updateFateAttr(forCalc)
	local fidList = self.m_config.fatalism
	if not fidList or #fidList <= 0 then
		return
	end
	local fateInfo = HeroManager:getFateInfo()
	local attrs = fateInfo:getFateAttrAdditionList(self:getId())
	if forCalc then
		return attrs
	end
	
	self.m_backupAttr.suming = self.m_backupAttr.suming or {}
	local addattrs = {}
	for attrId , value in pairs(attrs) do
		addattrs[attrId] = value - (self.m_backupAttr.suming[attrId] or 0)
		self:addAttr(attrId,addattrs[attrId])
		self.m_backupAttr.suming[attrId] = value
	end
	self:updateFightPower()
end

function This:updateFightPower()
	local phyAtt = self.m_attribute:getAttr(AttrType.kPhyAttack)
	local phyDef = self.m_attribute:getAttr(AttrType.kPhyDefence)
	local magAtt = self.m_attribute:getAttr(AttrType.kMagicAttack)
	local magDef = self.m_attribute:getAttr(AttrType.kMagicDefence)
	local maxHp = self.m_attribute:getAttr(AttrType.kMaxHp)
	local crit = self.m_attribute:getAttr(AttrType.kCritRatio)
	local phyDmgAdd = self.m_attribute:getAttr(AttrType.kPhyDamageAddRatio)
	local dmgAdd = self.m_attribute:getAttr(AttrType.kBothDamageAddRatio)
	local magDmgAdd = self.m_attribute:getAttr(AttrType.kMagicDamageAddRatio)

	local phyDmgReduce = self.m_attribute:getAttr(AttrType.kPhyDamageReduceRatio)
	local magDmgReduce = self.m_attribute:getAttr(AttrType.kMagicDamageReduceRatio)
	local dmgReduce = self.m_attribute:getAttr(AttrType.kBothDamageReduceRatio)

	local dodge = self.m_attribute:getAttr(AttrType.kDodge)
	local penetrate = self.m_attribute:getAttr(AttrType.kPenetrate)
	local firstValue = self.m_attribute:getAttr(AttrType.kFirst)

	local additionalPhyDamage = self.m_attribute:getAttr(AttrType.kAdditionalPhyDamage)
	local additionalPlanDamage = self.m_attribute:getAttr(AttrType.kAdditionalPlanDamage)
	local additionalPhyDamageReduce = self.m_attribute:getAttr(AttrType.kAdditionalPhyDamageReduce)
	local additionalPlanDamageReduce = self.m_attribute:getAttr(AttrType.kAdditionalPlanDamageReduce)
	local additionalPhyDamageAddRatio = self.m_attribute:getAttr(AttrType.kAdditionalPhyDamageAddRatio)
	local additionalPlanDamageAddRatio = self.m_attribute:getAttr(AttrType.kAdditionalPlanDamageAddRatio)
	local burstBonus = self.m_attribute:getAttr(AttrType.kBurstBonus)
	local burstRelief = self.m_attribute:getAttr(AttrType.kBurstRelief)
	
	--local old = self.m_fightPower
	local allPhyDmgAdd = (phyDmgAdd + dmgAdd) - (phyDmgAdd + dmgAdd) * 0.34
	local allMagDmgAdd = (magDmgAdd + dmgAdd) - (magDmgAdd + dmgAdd) * 0.34
	local allReduce = phyDmgReduce + magDmgReduce

	local phyAttPower = phyAtt * (1 + crit * 1.5 * (1+burstBonus)) + phyAtt * allPhyDmgAdd + additionalPhyDamage * (1 + additionalPhyDamageAddRatio) -- 物理攻击部分
	local magAttPower = magAtt * (1 + allMagDmgAdd) * self.m_config.fight_coefficient + additionalPlanDamage * ( 1 + additionalPlanDamageAddRatio)-- 计策攻击部分
	local calcFator = (1 + 0.2 * firstValue / 100) * (1 + (self.m_psvSkillFactor or 0))
	self.m_fightPower = (
			0.0 + phyAttPower + magAttPower
			+ phyDef * (1 + phyDmgReduce + burstRelief) + additionalPhyDamageReduce -- 物理防御部分
			+ magDef * (1 + magDmgReduce) + additionalPlanDamageReduce -- 计策防御部分
			+ maxHp * 0.4 * (1 + (dodge + penetrate) / 2 + dmgReduce + allReduce / 2)
		) *  calcFator
	--print(string.format("物理攻击:%f,物理防御:%f,计策攻击:%f,计策防御:%f,最大血量:%f,暴击率:%f,物理伤害加成:%f,伤害加成:%f,计策伤害加成:%f,物理伤害减免:%f,计策伤害减免:%f,伤害减免:%f,闪避率:%f,识破率:%f,先手值:%f,计策系数:%f,被动计系数:%f",phyAtt,phyDef,magAtt,magDef,maxHp,crit,phyDmgAdd,dmgAdd,magDmgAdd,phyDmgReduce,magDmgReduce,dmgReduce,dodge,penetrate,firstValue,self.m_config.fight_coefficient,self.m_psvSkillFactor))
	--print(string.format("更新战力:%f->%f",old,self.m_fightPower))
	return self.m_fightPower
end

function This:setDeputy(deputy)
	--print(table.tostring(deputy))
	if not deputy or not deputy[1] then
		return
	end
	if deputy[3] then
		print("hero deputy > 2")
	end

	for i = 1,  2 do
		if deputy[i] > 0 and self.m_deputyHeros[i] <= 0 then
			local hero = HeroManager:getHero(deputy[i])
			self:addDeputy(hero,i)
		elseif deputy[i] <= 0 and self.m_deputyHeros[i] > 0 then
			local hero = HeroManager:getHero(self.m_deputyHeros[i])
			self:removeDeputy(hero,i)
		elseif deputy[i] > 0 and self.m_deputyHeros[i] > 0 and deputy[i] ~= self.m_deputyHeros[i] then
			local orignal = HeroManager:getHero(self.m_deputyHeros[i])
			local target = HeroManager:getHero(deputy[i])
			self:replaceDeputy(orignal,target,i)
		end
	end
	--print("setDeputy",self.m_id,table.tostring(self.m_deputyHeros))
end

function This:isUnlockAtDeputyPos(position)
	local quality = self:getQuality()
	local starLv = self:getStarLv()
	if self:isDeputy() then
		return false , ErrorCode.kHaveBeDeputy
	end
	if position == 1 then
		if not (quality >= Quality.kPurple and starLv >= 1) then
			return false , ErrorCode.kDeputyPos1Lock
		end
	elseif position == 2 then
		if not (quality >= Quality.kOrange and starLv >= 3) then
			return false, ErrorCode.kDeputyPos2Lock
		end
	end
	return true
end

function This:getDeputyAttrValue(heroId,attrId)
	if self.m_deputyAttr[heroId] then
		return self.m_deputyAttr[heroId][attrId] or 0
	end
	return 0
end

function This:isCanAddDeputy(deputyId)
	local quality = self.m_quality
	local starLv = self.m_starLv
	local deputyHero = HeroManager:getHero(deputyId)

	if not self:isGot() or not deputyHero:isGot() then
		return false , ErrorCode.kHaveNoHero
	end

	local state = deputyHero:getState()
	if state ~= HeroState.kInFree then
		return false , ErrorCode["kHeroState"..state]
	end

	if StageManager:isInEmbattle(deputyId) then
		return false, ErrorCode.kInStageEmbattle
	end

	if deputyHero:isDeputy() then
		return false, ErrorCode.kHaveBeDeputy
	end

	if deputyHero:isPrimary() then
		return false, ErrorCode.kHaveBePrimary
	end

	if self:hasDeputy(deputyId) then
		return false , ErrorCode.kHasNoDeputy
	end

	if deputyHero:getQuality() >= quality then
		return false , ErrorCode.kQualityMoreBig
	end

	if self:isRed() and deputyHero:getQuality() < quality-2 then
		return false , ErrorCode.kQualityNotEnough
	end

	if not((self:getQuality() >= Quality.kPurple and self:getStarLv() >= 1) or (self:getQuality() >= Quality.kOrange and self:getStarLv() >= 3)) then
		return false, ErrorCode.kDeputyPos2Lock
	end

	return true
end

function This:getOriginalAttr( attrType )
    if attrType == AttrType.kPower then
		return self:calculateGrowAttr(self.m_config.power,self.m_quality,self.m_config.power_growth,self.m_level,self.m_growFactor)
	elseif attrType == AttrType.kChiefValue then
		return self:calculateGrowAttr(self.m_config.chief,self.m_quality,self.m_config.chief_growth,self.m_level,self.m_growFactor)
	elseif attrType == AttrType.kIntelligence then
		return self:calculateGrowAttr(self.m_config.Intelligence,self.m_quality,self.m_config.Intelligence_growth,self.m_level,self.m_growFactor)
	elseif attrType == AttrType.kDfs then
		return self:calculateGrowAttr(self.m_config.resist,self.m_quality,self.m_config.resist_growth,self.m_level,self.m_growFactor)
	end
	return 0
end

function This:addDeputy(hero,pos)
	-- local attribute = hero:getAttribute()
	-- local star = hero:getStarLv()
	local id = hero:getId()

	-- local ratio = LegionPlusConfig[star].commonadd
	local ratio = ArgConfig["subordinate_inherit_rate"].arg[1]
	if self:isRecommended(id) then
		-- ratio = ratio + LegionPlusConfig[star].recommendadd
		ratio = ratio + ArgConfig["subordinate_recommend_rate"].arg[1]
	end

	self.m_deputyAttr[id] = {}
	-- local power = attribute:getAttr(AttrType.kPower) * ratio
	-- local chief = attribute:getAttr(AttrType.kChiefValue) * ratio
	-- local intelligence = attribute:getAttr(AttrType.kIntelligence) * ratio
	-- local dfs = attribute:getAttr(AttrType.kDfs) * ratio
	local power = hero:getOriginalAttr(AttrType.kPower) * ratio
	local newPower = self.m_attribute:addAttr(AttrType.kPower,power)
	--print(string.format("力量增加量:%f,最终力量为:%f",power,newPower))
	self.m_deputyAttr[id][AttrType.kPower] = power

	local chief = hero:getOriginalAttr(AttrType.kChiefValue) * ratio
	local newChief = self.m_attribute:addAttr(AttrType.kChiefValue,chief)
	--print(string.format("统帅值增加量:%f,最终统帅值:%f",chief,newChief))
	self.m_deputyAttr[id][AttrType.kChiefValue] = chief

	local intelligence = hero:getOriginalAttr(AttrType.kIntelligence) * ratio
	local newIntelligence = self.m_attribute:addAttr(AttrType.kIntelligence,intelligence)
	--print(string.format("智力增加值:%f,最终智力值:%f",intelligence,newIntelligence))
	self.m_deputyAttr[id][AttrType.kIntelligence] = intelligence

	local dfs = hero:getOriginalAttr(AttrType.kDfs) * ratio
	local newDfs = self.m_attribute:addAttr(AttrType.kDfs,dfs)
	--print(string.format("御增加值:%f,最终御值:%f",dfs,newDfs))
	self.m_deputyAttr[id][AttrType.kDfs] = dfs

	self:updateFightPower()
	self.m_deputyHeros[pos] = id
	hero:setPrimaryHero(self.m_id)
end

function This:isCanRemoveDeputy(deputyId)
	for i , id in pairs(self.m_deputyHeros) do
		if id == deputyId then
			return true
		end
	end
	return false , ErrorCode.kHasNoDeputy
end

function This:removeDeputy(hero,pos)
	assert(hero:getId() == self.m_deputyHeros[pos])
	local id = hero:getId()

	local power = self.m_deputyAttr[id][AttrType.kPower]
	local newPower = self.m_attribute:reduceAttr(AttrType.kPower,power)
	--print(string.format("力量减少量:%f,最终力量为:%f",power,newPower))

	local chief = self.m_deputyAttr[id][AttrType.kChiefValue]
	local newChief = self.m_attribute:reduceAttr(AttrType.kChiefValue,chief)
	--print(string.format("统帅值减少量:%f,最终统帅值:%f",chief,newChief))

	local intelligence = self.m_deputyAttr[id][AttrType.kIntelligence]
	local newIntelligence = self.m_attribute:reduceAttr(AttrType.kIntelligence,intelligence)
	--print(string.format("智力减少值:%f,最终智力值:%f",intelligence,newIntelligence))

	local dfs = self.m_deputyAttr[id][AttrType.kDfs]
	local newDfs = self.m_attribute:reduceAttr(AttrType.kDfs,dfs)
	--print(string.format("御减少值:%f,最终御值:%f",dfs,newDfs))

	self:updateFightPower()

	self.m_deputyAttr[id] = nil
	self.m_deputyHeros[pos] = 0
	hero:setPrimaryHero(0)
end

function This:replaceDeputy(orignal,target,pos)
	assert(self.m_deputyHeros[pos] == orignal:getId() and target)
	-- local originStar = orignal:getStarLv()
	-- local orignalRatio = LegionPlusConfig[originStar].commonadd
	-- local targetStar = target:getStarLv()
	-- local targetRatio = LegionPlusConfig[targetStar].commonadd
	local orignalRatio = ArgConfig["subordinate_inherit_rate"].arg[1]
	if self:isRecommended(orignal:getId()) then
		-- orignalRatio = orignalRatio + LegionPlusConfig[originStar].recommendadd
		orignalRatio = orignalRatio + ArgConfig["subordinate_recommend_rate"].arg[1]
	end

	local targetRatio = ArgConfig["subordinate_inherit_rate"].arg[1]
	if self:isRecommended(target:getId()) then
		-- targetRatio = targetRatio + LegionPlusConfig[targetStar].recommendadd
		targetRatio = targetRatio + ArgConfig["subordinate_recommend_rate"].arg[1]
	end

	self.m_deputyAttr[target:getId()] = {}
	local orignalPower = self.m_deputyAttr[orignal:getId()][AttrType.kPower]
	-- local targetPower = target:getAttr(AttrType.kPower) * targetRatio
	local targetPower = target:getOriginalAttr(AttrType.kPower) * targetRatio
	local newPower = self.m_attribute:addAttr(AttrType.kPower,targetPower - orignalPower)
	self.m_deputyAttr[orignal:getId()][AttrType.kPower] = nil
	self.m_deputyAttr[target:getId()][AttrType.kPower] = targetPower
	--print(string.format("力量增加量:%f,最终力量为:%f",targetPower - orignalPower,newPower))

	local originalChief = self.m_deputyAttr[orignal:getId()][AttrType.kChiefValue]
	-- local targetChief = target:getAttr(AttrType.kChiefValue) * targetRatio
	local targetChief = target:getOriginalAttr(AttrType.kChiefValue) * targetRatio
	local newChief = self.m_attribute:addAttr(AttrType.kChiefValue,targetChief - originalChief)
	self.m_deputyAttr[orignal:getId()][AttrType.kChiefValue] = nil
	self.m_deputyAttr[target:getId()][AttrType.kChiefValue] = targetChief
	--print(string.format("统帅值增加量:%f,最终统帅值:%f",targetChief - originalChief,newChief))

	local originalIntelligence = self.m_deputyAttr[orignal:getId()][AttrType.kIntelligence]
	-- local targetIntelligence = target:getAttr(AttrType.kIntelligence) * targetRatio
	local targetIntelligence = target:getOriginalAttr(AttrType.kIntelligence) * targetRatio
	local newIntelligence = self.m_attribute:addAttr(AttrType.kIntelligence,targetIntelligence - originalIntelligence)
	self.m_deputyAttr[orignal:getId()][AttrType.kIntelligence] = nil
	self.m_deputyAttr[target:getId()][AttrType.kIntelligence] = targetIntelligence
	--print(string.format("智力增加值:%f,最终智力值:%f",targetIntelligence - originalIntelligence,newIntelligence))

	local originalDfs = self.m_deputyAttr[orignal:getId()][AttrType.kDfs]
	-- local targetDfs = target:getAttr(AttrType.kDfs) * targetRatio
	local targetDfs = target:getOriginalAttr(AttrType.kDfs) * targetRatio
	local newDfs = self.m_attribute:addAttr(AttrType.kDfs,targetDfs - originalDfs)
	self.m_deputyAttr[orignal:getId()][AttrType.kDfs] = nil
	self.m_deputyAttr[target:getId()][AttrType.kDfs] = targetDfs
	--print(string.format("御增加值:%f,最终御值:%f",targetDfs - originalDfs,newDfs))

	self:updateFightPower()

	self.m_deputyHeros[pos] = target:getId()
	orignal:setPrimaryHero(0)
	target:setPrimaryHero(self.m_id) 
	self.m_deputyAttr[orignal:getId()] = nil
end

function This:updateDeputy(hero)
	local id = hero:getId()
	for i , heroId in pairs(self.m_deputyHeros) do
		if heroId == id then
			-- local attribute = hero:getAttribute()
			-- local ratio = LegionPlusConfig[hero:getStarLv()].commonadd
			-- if self:isRecommended(id) then
			-- 	ratio = ratio + LegionPlusConfig[hero:getStarLv()].recommendadd
			-- end
			local ratio = ArgConfig["subordinate_inherit_rate"].arg[1]
			if self:isRecommended(id) then
				ratio = ratio + ArgConfig["subordinate_recommend_rate"].arg[1]
			end

			local oldPower = self.m_deputyAttr[id][AttrType.kPower]
			-- local newPower = attribute:getAttr(AttrType.kPower) * ratio
			local newPower = hero:getOriginalAttr(AttrType.kPower) * ratio
			local power = self.m_attribute:addAttr(AttrType.kPower,newPower - oldPower)
			--print(string.format("力量增加量:%f,最终力量为:%f",newPower - oldPower,power))
			self.m_deputyAttr[id][AttrType.kPower] = newPower

			local oldChief = self.m_deputyAttr[id][AttrType.kChiefValue]
			-- local newChief = attribute:getAttr(AttrType.kChiefValue) * ratio
			local newChief = hero:getOriginalAttr(AttrType.kChiefValue) * ratio
			local chief = self.m_attribute:addAttr(AttrType.kChiefValue,newChief - oldChief)
			--print(string.format("统帅值增加量:%f,最终统帅值:%f",newChief - oldChief,chief))
			self.m_deputyAttr[id][AttrType.kChiefValue] = newChief

			local oldIntelligence = self.m_deputyAttr[id][AttrType.kIntelligence]
			-- local newIntelligence = attribute:getAttr(AttrType.kIntelligence) * ratio
			local newIntelligence = hero:getOriginalAttr(AttrType.kIntelligence) * ratio
			local intelligence = self.m_attribute:addAttr(AttrType.kIntelligence,newIntelligence - oldIntelligence)
			--print(string.format("智力增加值:%f,最终智力值:%f",newIntelligence - oldIntelligence,intelligence))
			self.m_deputyAttr[id][AttrType.kIntelligence] = newIntelligence

			local oldDfs = self.m_deputyAttr[id][AttrType.kDfs]
			-- local newDfs = attribute:getAttr(AttrType.kDfs) * ratio
			local newDfs = hero:getOriginalAttr(AttrType.kDfs) * ratio
			local dfs = self.m_attribute:addAttr(AttrType.kDfs,newDfs - oldDfs)
			--print(string.format("御增加值:%f,最终御值:%f",newDfs - oldDfs,dfs))
			self.m_deputyAttr[id][AttrType.kDfs] = newDfs
			self:updateFightPower()
			return
		end
	end
end

function This:isCanUpgradeLevel()
	if not self:isGot() then
		return false, ErrorCode.kHaveNoHero
	end
	local playerLevel = GamePlayer:getLevel()
	if self.m_level >= playerLevel then
		return false , ErrorCode.kToLevelLimit
	end
	local exp = GamePlayer:getReserveExp()
	if exp < HeroLevelExpConfig[self.m_level + 1].exp then
		return false, ErrorCode.kExpNotEnough
	end
	return true
end

function This:canUpgradeTenLevel()
	if not self:isGot() then
		return false, ErrorCode.kHaveNoHero
	end
	local playerLevel = GamePlayer:getLevel()
	if self.m_level >= playerLevel then
		return false , ErrorCode.kToLevelLimit
	end
	local exp = GamePlayer:getReserveExp()
	local needExp = HeroLevelExpConfig[self.m_level + 1].exp
	if exp < needExp then
		return false, ErrorCode.kExpNotEnough
	end

	local pvalue = self.m_level + kHeroMultiUpgradeLevelTime
	if pvalue >= playerLevel then
		pvalue = playerLevel
	end

	for i=self.m_level, pvalue do
		if exp < needExp then
			pvalue = i
			break
		else
			local nextConfig = HeroLevelExpConfig[i + 1]
			if nextConfig then
				needExp = needExp + nextConfig.exp
			end
		end
	end
	return true, pvalue - self.m_level
end

function This:upgradeLevel(level)
	--print(string.format("武将%s升级 %d->%d",self:getName(),self.m_level,level))
	self:backupAttr()
	local oldLevel = self.m_level
	self.m_level = level
	self:updateGrowFactor()
	self:updateGrowAttribute()
	self:updateFightPower()
	if self.m_primaryHero > 0 then
		local primary = HeroManager:getHero(self.m_primaryHero)
		primary:updateDeputy(self)
	end
	self:updateAttrPoint()
end

function This:isCanUpgradeStarLv()
	if not self:isGot() then
		return false, ErrorCode.kHaveNoHero
	end
	if self.m_starLv >= kMaxStarLv then
		return false, ErrorCode.kToStarLimit
	end
	return true
end

function This:upgradeStar(starLv)
	self:backupAttr()
	local oldSatr = self.m_starLv
	self.m_starLv = math.floor(starLv/5)
	self.m_phase = starLv % 5
	--print(string.format("武将%s升星 %d->%d", self:getName(), oldSatr, self.m_starLv))
	self:updateStarAddAttr(oldSatr,self.m_starLv)
	self:updateGrowFactor()
	self:updateGrowAttribute()
	self:updateFightPower()
	if self.m_primaryHero > 0 then
		local primary = HeroManager:getHero(self.m_primaryHero)
		primary:updateDeputy(self)
	end
end

function This:isCanUpgradeQuality()
	if not self:isGot() then
		return false, ErrorCode.kHaveNoHero
	end
	if self:isMaxQuality() then
		return false, ErrorCode.kToMaxQuality
	end
	if self.m_starLv < kMaxStarLv then
		return false, ErrorCode.kStarNotEnough
	end
	return true
end

function This:isMaxQuality()
    return self.m_quality >= self.m_config.maxquality
end

function This:upgradeQuality(quality)
	self:backupAttr()
	local oldQuality = self.m_quality
	self.m_quality = quality
	--print(string.format("武将%s进阶 %d->%d",self:getName(),oldQuality,self.m_quality))
	self:updateGrowFactor()
	self:updateGrowAttribute()
	self:updateFightPower()
	if self.m_primaryHero > 0 then
		local primary = HeroManager:getHero(self.m_primaryHero)
		primary:updateDeputy(self)
	end
end

function This:isCanRecruiteHero()
	if self:isGot() then
		return false, ErrorCode.kHaveGotHero
	end
	return true
end

function This:obtainHero()
	self.m_isGot = true
end

function This:setEquip(equip)
	for pos = 1 , EquipPos.kHorse do
		if self.m_equips[pos] <= 0 and equip[pos] > 0 then
			self:wearEquip(pos,equip[pos])
		elseif self.m_equips[pos] > 0 and equip[pos] <= 0 then
			self:unloadEquip(pos,self.m_equips[pos])
		elseif self.m_equips[pos] > 0 and equip[pos] > 0 and self.m_equips[pos] ~= equip[pos] then
			self:replaceEquip(pos,self.m_equips[pos] , equip[pos])
		end
	end
end

function This:wearEquip(pos,equipUid)
	assert(pos >= EquipPos.kWeapons and pos <= EquipPos.kHorse)
	if self.m_equips[pos] <= 0 and equipUid > 0 then
		local equip = EquipManager:getEquip(equipUid)
		if equip then
			equip:setHeroId(self:getId())
		else
			print("equipment not found, uid" .. GameUtil:int64ToString(equipUid))
		end
		self.m_equips[pos] = equipUid
		self:updateFightPower()
	end
end

function This:unloadEquip(pos,equipUid)
	assert(pos >= EquipPos.kWeapons and pos <= EquipPos.kHorse)
	if self.m_equips[pos] == equipUid then
		local equip = EquipManager:getEquip(equipUid)
		if equip then
			equip:setHeroId(0)
		else
			print("equipment not found, uid" .. GameUtil:int64ToString(equipUid))
		end
		self.m_equips[pos] = 0
		self:updateFightPower()
	end
end

function This:replaceEquip(pos,original,target)
	assert(pos >= EquipPos.kWeapons and pos <= EquipPos.kHorse)
	if self.m_equips[pos] == original then
		local oldEquip = EquipManager:getEquip(original)
		if oldEquip then
			oldEquip:setHeroId(0)
		else
			print("equipment not found, uid" .. GameUtil:int64ToString(orignal))
		end
		local newEquip = EquipManager:getEquip(target)
		if newEquip then
			newEquip:setHeroId(self:getId())
		else
			print("equipment not found, uid" .. GameUtil:int64ToString(target))
		end
		self.m_equips[pos] = target
		self:updateFightPower()
	end
end

function This:addFetterWithHero(heroTable)
	for fetterId , fetter in pairs(self.m_fetters) do
		if not fetter:isActive() then
			fetter:addFetterWithHero(heroTable)
			if fetter:isActive() then
				if fetter:isRed() then
					self:addAttrs(fetter:getFetterAttr())
				else
					self:addAttr(fetter:getAttrId(),fetter:getAttrValue())
				end
			end
		end
	end
end

function This:removeAllFetter()
	for fetterId , fetter in pairs(self.m_fetters) do
		if fetter:isActive() then
			if fetter:isRed() then
				self:reduceAttrs(fetter:getFetterAttr())
			else
				self:reduceAttr(fetter:getAttrId(),fetter:getAttrValue())
			end
		end
		fetter:reset()
	end
end

--属性点
function This:updateAttrPoint(pointList)
	if pointList then
		pointList[1] = pointList[1] or 0
		if self.m_attrPoint[AttrType.kPower] ~= pointList[1] then
			local add = pointList[1] - self.m_attrPoint[AttrType.kPower] 
			self:addAttr(AttrType.kPower,add)
			self.m_attrPoint[AttrType.kPower] = pointList[1]
		end
		pointList[2] = pointList[2] or 0
		if self.m_attrPoint[AttrType.kIntelligence] ~= pointList[2] then
			local add = pointList[2] - self.m_attrPoint[AttrType.kIntelligence] 
			self:addAttr(AttrType.kIntelligence,add)
			self.m_attrPoint[AttrType.kIntelligence] = pointList[2]
		end
		pointList[3] = pointList[3] or 0
		if self.m_attrPoint[AttrType.kChiefValue] ~= pointList[3] then
			local add = pointList[3] - self.m_attrPoint[AttrType.kChiefValue] 
			self:addAttr(AttrType.kChiefValue,add)
			self.m_attrPoint[AttrType.kChiefValue] = pointList[3]
		end
		pointList[4] = pointList[4] or 0
		if self.m_attrPoint[AttrType.kDfs] ~= pointList[4] then
			local add = pointList[4] - self.m_attrPoint[AttrType.kDfs] 
			self:addAttr(AttrType.kDfs,add)
			self.m_attrPoint[AttrType.kDfs] = pointList[4]
		end
		self:updateFightPower()
	end
	self.m_attrPointCount = self.m_level > 50 and (self.m_level - 50) * 4 or 0
end

----兵种
function This:setCurSoilder(soilderId)
	if self.m_curSoilderId ~= soilderId then
		if self.m_id == 10036 then
			assert(true)
		end
		self:setCurAwakeSoilder(soilderId)
		if self.m_curSoilderId > 0 then
			local soilder = self:getSoilder(self.m_curSoilderId)
			soilder:disattachHero(self)
		end
		self.m_curSoilderId = soilderId
		if self.m_curSoilderId > 0 then
			local soilder = self:getSoilder(self.m_curSoilderId)
			soilder:attachHero(self)
		end
		self:updateTechnAttr()
		self:updateFightPower()
	end
end

function This:getCurSoilder()
	if self.m_curSoilderId > 0 then
		return self:getSoilder(self.m_curSoilderId)
	end
end

----兵种觉醒
function This:setCurAwakeSoilder(soilderId)
	if self.m_curSoilderId ~= soilderId then
		if self.m_curSoilderId > 0 then
			local soilder = self:getAwakeSoilder(self.m_curSoilderId)
			soilder:disattachHero(self)
		end
		if soilderId > 0 then
			local soilder = self:getAwakeSoilder(soilderId)
			soilder:attachHero(self)
		end
	end
end

function This:getCurentAwakeSoilder()
	if self.m_curSoilderId > 0 then
		return self:getAwakeSoilder(self.m_curSoilderId)
	end
end

function This:updateSoilders(infoList, curSoilderId, forceId)
	for i , info in ipairs(infoList) do
		local soilderId = info.type
		local soilder = self:getSoilder(soilderId)
		if soilder then
			soilder:setAttrPoint(info.point_list)
			soilder:setPhase(info.level)
		end

		local awakeSoilder = self:getAwakeSoilder(soilderId)
		if awakeSoilder then
			awakeSoilder:setPhase(info.awake_level)
			if soilderId == curSoilderId then
				awakeSoilder:setSelectSkill(forceId)
			end
		end
	end

	if curSoilderId then
		self:setCurSoilder(curSoilderId)
	end
end

function This:updateSoilderAttrPoint(soilderId,pointList)
	local soilder = self:getSoilder(soilderId)
	soilder:setAttrPoint(pointList)
	self:updateFightPower()
end

function This:upgradeSolider(soilderId)
	local soilder = self:getSoilder(soilderId)
	soilder:setPhase(soilder:getPhase()+1)
end

--升级成功
function This:upgradeAwakeSolider(soilderId,selectSkill)
	local soilder = self:getAwakeSoilder(soilderId)
	soilder:setPhase(soilder:getPhase()+1)
	soilder:setSelectSkill(selectSkill)
end

function This:getTotalTrainCostList()  --获取总的培养消耗
	local result = {}
	local cost = self:getRebornReturn()

	for id , num in pairs(cost) do
		if num > 0 then
			table.insert(result,{id = id, num = num})
		end
	end
	return result
end

function This:getRebornReturn()
	local exp = 0
	local stone = 0
	local piece = 0

	local cost = {}
	for i = 1 , self.m_level do
		exp = exp + HeroLevelExpConfig[i].exp
	end
	cost[105] = exp

	local star = self.m_starLv * 5 + self.m_phase
	for i = 1 , star do
		local key = self.m_quality * 1000 + i
		stone = stone + QualityStarConfig[key].stone_cost
		piece = piece + QualityStarConfig[key].debris_cost
	end
	if stone > 0 then
		cost[113] = stone
	end
	if piece > 0 then
		if self:isRed() then
			cost[self:getId()+10000] = piece
		else
			--local key = 121 * 100 + self.m_quality
			--cost[121] = piece * UniversalConfig[key].exchange_count
			for i , config in pairs(UniversalConfig) do
				if config.quality == self.m_quality then
					cost[config.award_ID] = piece * config.exchange_count
					break
				end
			end
			
		end
	end
	
	for id , soilder in pairs(self.m_soilder) do
		local costKV = soilder:getTotalTrainCost()
		for id , num in pairs(costKV) do
			cost[id] = cost[id] or 0
			cost[id] = cost[id] + num
		end
	end

	for _ , soilder in pairs(self.m_awakeSoilder) do
		if soilder:hasAwake() then
			local costList = soilder:getTotalTrainCost()
			for costIndex , costItem in pairs(costList) do
				local id = costItem[1]
				local value = costItem[2]
				cost[id] = cost[id] or 0
				cost[id] = cost[id] + value
			end
		end
	end

	if self:isAwaken() then--统计觉醒消耗
		local temAwakeData = self:getAwakeData()
		local heroId = self:getId()
		local awake = self.m_awake
		awake:initData()
		local level = temAwakeData.level
		local curentLv = self:getAwakeLevel()
		for awakeLv=1,level do
			local temAttrs = awake:getParagraphCurrentBack(heroId,temAwakeData.starDatas,awakeLv,awakeLv<=curentLv)
			awake:tableAdd(temAttrs, cost)
		end
	end

	self.m_refine:getRebornReturn(cost)
	self.m_tactics:getRebornReturn(cost)

	return cost
end

function This:reset()
	for i , soilder in pairs(self.m_soilder) do
		soilder:reset()
	end
	for i , soilder in pairs(self.m_awakeSoilder) do
		soilder:reset()
	end
	
	local skillList,pos = self:getPosAndPsvIdList(self.m_psvSolt)
	local runelist,runePos = self:getPosAndPsvIdList(self.m_runeSolt)
	local info = {
		id = self.m_uid,
		star = 0,
		level = 1,
		primary = 0,
		deputy = {},
		force_type_list = {
			{type = SoilderType.kShield, level = 1,awake_level = 0, point_list = {0,0,0,0}},
			{type = SoilderType.kCavalry, level = 1,awake_level = 0, point_list = {0,0,0,0}},
			{type = SoilderType.kArcher, level = 1,awake_level = 0, point_list = {0,0,0,0}},
			{type = SoilderType.kSapperCar, level = 1,awake_level = 0, point_list = {0,0,0,0}},
		},
		force_type = SoilderType.kShield,
		point_list = {},
		equips = self.m_equips,
		skill_id_list = skillList,
		pos = pos,
		runestone_id_list = runelist,
		runestone_pos_list = runePos,
		awake = {star_list ={}, level =1, awake = false},
		magic_weapon_id = self.m_fabaos[FabaoPos.kFirst],
		awake_force_index = 0,
		refinemen_info = {
			level = 0,
			item_list = {},
		},
		fatalism_list = {},
		tactics_info = {
			tactics_pos_up = 1,
			tactics_pos_leve_list = {0, 0, 0, 0, 0},
			tactics_id_list = {0, 0, 0, 0, 0},
		},	
	}
	self.m_psvSoltLocked = nil
	self:setHeroInfo(info)
end

function This:check()
	local hasDeputy = false
	for i , deputyId in pairs(self.m_deputyHeros) do
		if deputyId > 0 then
			local deputy = HeroManager:getHero(deputyId)
			if deputy == nil then
				assert(false,string.format(Serialize[61276],deputyId))
			end

			if deputy:getPrimaryHero()~= self.m_id then
				assert(false,Serialize[61277])
			end

			hasDeputy = true
		end
	end

	if hasDeputy then
		assert(self.m_primaryHero <= 0 , Serialize[61278])
	end

	if self.m_primaryHero > 0 then
		local isFind = false
		local hero = HeroManager:getHero(self.m_primaryHero)
		local deputy = hero:getDeputyHeros()
		for i , id in pairs(deputy) do
			if id == self.m_id then
				isFind = true
				break
			end
		end
		if not isFind then
			assert(false,string.format(Serialize[61279],self.m_primaryHero,self.m_id))
		end
	end
end

function This:getRuneByPos(pos)
	return self.m_runeSolt[pos]
end

function This:getSoltByPos(pos)
	return self.m_psvSolt[pos]
end

function This:setPsvSlotLock(pos)
	self.m_psvSoltLocked = pos
end

function This:getPsvSlotLock()
    return self.m_psvSoltLocked
end

function This:getSoltByPsvSkillId(psvId)
	for i , solt in ipairs(self.m_psvSolt) do
		if solt:getPsvSkillId() == psvId then
			return solt
		end
	end
end

function This:setPsvSkillFactor(factor)
	self.m_psvSkillFactor = factor or self.m_psvSkillFactor
end

function This:updatePsvSolt(soltList,soltPos,runeList,runePos)
	RuneManager:resetHero(self)
	local skillList = {}
	for i , solt in pairs(self.m_psvSolt) do
		local psvSkill = solt:getPsvSkill()
		if psvSkill then
			psvSkill:resetHero(self)
		end
	end

	for i , psvId in ipairs(soltList) do
		local index = soltPos[i]
		local solt = self.m_psvSolt[index]
		if psvId > 0 then 
			table.insert(skillList,psvId)
			local psvSkill = HeroManager:getPsvSkill(psvId)
			if solt:getPsvSkillId() ~= psvId then
				solt:setPsvSkill(psvSkill)
			end
			if psvSkill then
				solt:setIsActive(true)
			else
				solt:setIsActive(false)
			end
		elseif not solt:isEmpty() then
			solt:removePsvSkill()
		end
		solt:setIsUnlock(true)
	end
	local function getAttr()
		local res ={}
		for i,runeUid in ipairs(runeList) do
			local index = runePos[i]
			local solt = self.m_runeSolt[index]
			local temAttr = solt:getAttr()
			res = GameUtil:tableAdd(temAttr,res)
		end
		return res
	end
	for i,runeUid in ipairs(runeList) do
		local index = runePos[i]
		local solt = self.m_runeSolt[index]

		local runeData = DepotManager:getItemByUid(runeUid)
		if runeUid > 0 then 
			solt:setPsvSkill(runeData)
		elseif not solt:isEmpty() then
			solt:removePsvSkill()
		end
		if runeData then
			local runeSkillList = runeData:getSkillIds()
			for _,skillId in ipairs(runeSkillList) do
				table.insert(skillList,skillId)
			end
		end
		solt:setIsUnlock(true)
	end

	local res1 =getAttr()
	self:addAttrs(res1)
	for _, skillId in ipairs(skillList) do
		RuneManager:addHeroSkill(self,skillId)
	end
	
	RuneManager:updateHeroSkillAttr(self)
	self:updateFightPower()
end

function This:resetPsvSlot()
	local skillList,pos = self:getPosAndPsvIdList(self.m_psvSolt)
	local runelist,runePos = self:getPosAndPsvIdList(self.m_runeSolt)
	self:updatePsvSolt(skillList,pos,runelist,runePos)
end

function This:getPosAndPsvIdList(psvSolts)
	local skillList = {}
	local pos = {}
	if psvSolts then
		for i , solt in ipairs(psvSolts) do
			if solt:isUnlock() then
				table.insert(skillList,solt:getPsvSkillId())
				table.insert(pos,i)
			end
		end
	end
	return skillList,pos
end

function This:resetEmptyPsvSlot()
    for i , solt in ipairs(self.m_psvSolt) do
        if solt:isUnlock() and solt:isEmpty() then
            solt:setIsUnlock(false)
        end
    end
    self:updateFightPower()
end

function This:isAwakeFull()
	local awakeData = self:getAwakeData()
	return awakeData.awake
end

function This:getAwake(  )
	return self.m_awake
end

function This:getAwakeData()
	if self.m_awakeData then
		return self.m_awakeData
	end
	return {starDatas ={},level =1,awake = false}
end

--获取当前完全觉醒了多少阶段返回值可能是0,1,2,3
function This:getAwakeLevel( )
	local awakeData = self:getAwakeData()
	if awakeData.awake then
		return awakeData.level
	else
		return (awakeData.level - 1)
	end	
end

function This:updateAwakeInfo( awakeData, forCalc )
	if self:isAwaken() then
		local function getAwakeAttrs( data )
			local heroId = self:getId()
			local awake = self.m_awake
			awake:initData()
			local level = data.level
			local curentLv = self:getAwakeLevel()
			local attrs = {}
			for awakeLv=1,level do
				local temAttrs = awake:getParagraphCurrentAttr(heroId, data.starDatas, awakeLv, awakeLv<=curentLv)
				awake:tableAdd(temAttrs, attrs)
			end
			return attrs
		end

		if not awakeData and forCalc then
			return getAwakeAttrs(self.m_awakeData)
		end

		if awakeData then
			local temAwakeData = {starDatas ={}, level = awakeData.level, awake = awakeData.awake}
			if awakeData.star_list then
				for _, v in pairs(awakeData.star_list) do
					local t = {star_id = v.star_id, star_level = v.star_level, star_lucky = v.star_lucky}
					temAwakeData.starDatas[v.star_id] = t
				end
			end
			self.m_awakeData = temAwakeData
		end
		
		local attrs = getAwakeAttrs(self.m_awakeData)
		self.m_backupAttr.juexing = self.m_backupAttr.juexing or {}
		local addattrs = {}
		for attrId , value in pairs(attrs) do
			addattrs[attrId] = value - (self.m_backupAttr.juexing[attrId] or 0)
			self:addAttr(attrId,addattrs[attrId])
			self.m_backupAttr.juexing[attrId] = value
		end

		self:updateFightPower()
	else
		self.m_awakeData = {starDatas ={}, level =1, awake = false}
	end
end

function This:updateAwakeStar( awakeStar )
	if awakeStar and awakeStar.star_id and self:isAwaken() then
		local t = {star_id = awakeStar.star_id,star_level = awakeStar.star_level,star_lucky =awakeStar.star_lucky}
		self.m_awakeData.starDatas[awakeStar.star_id] = t
		self:updateAwakeInfo()
	end
end

function This:getAwakenSkillId()
	return self.m_config.awaken_skill_id
end

function This:canReborn()
    return true
end

function This:onFightPowerTestRequest()
	--屏蔽测试战力功能
	--HeroManager:onFightPowerTestRequest(self:getUid(),self:getFightPower())
end

function This:getRefine()
	return self.m_refine
end

function This:updateRefine(data)
	local refine = self:getRefine()
	refine:updateInfo(data or {})
	self:updateRefineAttr()
end

function This:updateRefineAttr()
	local refine = self:getRefine()
	local attrs = refine:getTotalAttr()

	if self.m_backupAttr.refine then
		for attrId, value in pairs(self.m_backupAttr.refine) do
			self:reduceAttr(attrId, value)
		end
	end

	local backup = {}
	for attrId, value in pairs(attrs) do
		self:addAttr(attrId, value)
		backup[attrId] = value
	end
	self.m_backupAttr.refine = backup

	self:updateFightPower()	
end

function This:updateNobilityAttr(attrs)
	local id = NobilityManager:getNobility()
	if id <= 0 then
		return
	end

	if not attrs then
		attrs = NobilityManager:getNoblityAttr()
	end

	if self.m_backupAttr.nobility then
		for attrId, value in pairs(self.m_backupAttr.nobility) do
			self:reduceAttr(attrId, value)
		end
	end

	local backup = {}
	for attrId, value in pairs(attrs) do
		self:addAttr(attrId, value)
		backup[attrId] = value
	end
	self.m_backupAttr.nobility = backup

	self:updateFightPower()
end

function This:updateArmyTacticalAttr(attrs)
	if not attrs then
		attrs = ArmyTacticalManager:getAttr() or {}
	end

	if self.m_backupAttr.armyTactical then
		for attrId, value in pairs(self.m_backupAttr.armyTactical) do
			self:reduceAttr(attrId, value)
		end
	end

	local backup = {}
	for attrId, value in pairs(attrs) do
		self:addAttr(attrId, value)
		backup[attrId] = value
	end
	self.m_backupAttr.armyTactical = backup

	self:updateFightPower()	
end

-- 战法
function This:getTactics()
	return self.m_tactics
end

function This:updateTactics(data)
	local tactics = self:getTactics()
	tactics:updateInfo(data)
	self:updateTacticsAttr()
end

function This:updateTacticsAttr()
	local tactics = self:getTactics()
	local attrs = tactics:getTotalAttr()

	if self.m_backupAttr.tactics then
		for attrId, value in pairs(self.m_backupAttr.tactics) do
			self:reduceAttr(attrId, value)
		end
	end

	local backup = {}
	for attrId, value in pairs(attrs) do
		self:addAttr(attrId, value)
		backup[attrId] = value
	end
	self.m_backupAttr.tactics = backup

	self:updateFightPower()	
end