--region *.lua
--Date
--此文件由[BabeLua]插件自动生成
--HeroItemView.lua
local This , super = class(...,"cc.Node")
local HeroManager = require("Hero.HeroManager")
local HeroUtil = require("Hero.HeroUtil")
local CityConfig = require("Metadatas.CityConfig")
local EquipManager = require("Equip.EquipManager")
local FabaoManager = require("Fabao.FabaoManager")

function This:init(heroId)
	self.m_heroId = heroId
	self.m_csNode = cc.Node:createFromCSFile("GameScene/NodeUI/HeroListItem.csb")
	local w, h = self.m_csNode.bg:getContentSize()
	local scale = self.m_csNode.bg:getScale()
	w = w * scale
	h = h * scale
	self:setContentSize(w,h)
	self:addChild(self.m_csNode)
	self:initNode()
end

function This:refreshAwak()
	local hero = HeroManager:getHero(self.m_heroId)
	local heroEffect = false
	if hero:isAwaken() then
		self.m_csNode.xingdian:setVisible(true)
		local curentLv = hero:getAwakeLevel()
		if curentLv==0 then
			self.m_csNode.xingdian.light:setVisible(false)
		else
			self.m_csNode.xingdian.light:setVisible(true)
			for i=1,AwakdValue.ParagraphLimit do
				local item = self.m_csNode.xingdian.light["dian"..i]
				item:setVisible(curentLv>=i)
			end
		end
		heroEffect = hero:isAwakeFull()
	else
		self.m_csNode.xingdian:setVisible(false)
	end
	self:createWeakEffect( self.m_csNode.bg, heroEffect ,self.m_csNode.icon)
end

function This:createWeakEffect( node,isAdd,heroBg )
	local function createAnim( parent,anmStr )
        local GameUtil = require("Util.GameUtil")
        local effect1 = GameUtil:createEffect(anmStr, true)
        effect1:setScale(0.6)
        effect1:setPosition(60, 63.5)
        parent:addChild(effect1)
        return effect1
    end
    local effectName = "JueXing5"
    node:removeAllChildren()
    if isAdd then
    	local effect = createAnim( node,effectName )
    end
end

function This:initNode()
	self.m_isShowEquip = HeroManager:isShowEquip()

	local hero = HeroManager:getHero(self.m_heroId)
	local country = hero:getCountry()
	local quality = hero:getQuality()
	self.m_csNode.country:setString(CountryName[country])
	local color = SmallCardQualityColor[quality]
	self.m_csNode.country:setColor(color.r , color.g, color.b)

	self.m_csNode.name:setString(hero:getName(), AppText:isChinese() and 10 or nil)
	self.m_csNode.level:setString(hero:getLevel())
	if not hero:isDeputy() then
		self.m_csNode.state:setString(HeroStateDesp[hero:getState()])
	else
		self.m_csNode.state:setString(Serialize[61281])
	end
	
	self.m_csNode.heroqulitybg:setImage(QualityBgFile[quality])
	self.m_csNode.bg:setImage(QualityFrameFile[quality])
	self.m_csNode.icon:setImage(hero:getIcon())
	-- self.m_csNode.herofightbg:setImage(QualityFightPowerFrameFile[quality])

	local cityId = hero:getCityId()
	if cityId <= 0 then
		self.m_csNode.city:setVisible(false)
		self.m_csNode.citybg:setVisible(false)
	else
		self.m_csNode.city:setString(CityConfig[cityId].name)
	end

	local leginName = hero:getLegionName()
	if leginName then
		self.m_csNode.corps:setString(leginName)
		self.m_csNode.corps:setVisible(true)
		self.m_csNode.toumingdi:setVisible(true)
	else
		self.m_csNode.corps:setVisible(false)
		self.m_csNode.toumingdi:setVisible(false)
	end
	self.m_csNode.text:setString(math.floor(hero:getFightPower()))

	for i = 1, 5 do
		self.m_csNode["star"..i]:setVisible(hero:getStarLv() >= i)
	end

	self:refreshEquipment()
	self:refreshAwak()
end

function This:refresh()
	local hero = HeroManager:getHero(self.m_heroId)
	self.m_csNode.level:setString(hero:getLevel())

	local quality = hero:getQuality()
	self.m_csNode.heroqulitybg:setImage(QualityBgFile[quality])
	self.m_csNode.bg:setImage(QualityFrameFile[quality])

	local leginName = hero:getLegionName()
	if leginName then
		self.m_csNode.corps:setString(leginName)
		self.m_csNode.corps:setVisible(true)
	else
		self.m_csNode.corps:setVisible(false)
	end
	self.m_csNode.text:setString(math.floor(hero:getFightPower()))

	for i = 1, 5 do
		self.m_csNode["star"..i]:setVisible(hero:getStarLv() >= i)
	end

	self:refreshEquipment()
	self:refreshAwak()
end


function This:refreshEquipment()
	self.m_csNode.equipment:setVisible(self.m_isShowEquip)
	if not self.m_isShowEquip then
		return
	end

	local hero = HeroManager:getHero(self.m_heroId)
	local nodeKey = {"weaponslot","clothesslot","horseslot"}
	for i = EquipPos.kWeapons , EquipPos.kHorse do
		local equipUid = hero:getEquipUid(i)
		local node = self.m_csNode.equipment[nodeKey[i]]
		if node then
			if equipUid and equipUid > 0 then
				node.bg:setVisible(true)
            	node.icon:setVisible(true)
				node.level:setVisible(true)
				local equip = EquipManager:getEquip(equipUid)
				node.bg:setImage(equip:getQualityImage())
				node.icon:setImage(equip:getIcon())
				node.level:setString(equip:getStrengthLv())
			else
				node.bg:setVisible(false)
				node.icon:setVisible(false)
				node.level:setVisible(false)
			end
		end
	end
end


function This:setModel(hero)
	if self.m_heroId ~= hero:getId() then
		self.m_heroId = hero:getId()
		self:initNode()
	elseif self.m_isShowEquip ~= HeroManager:isShowEquip() then
		self.m_isShowEquip = HeroManager:isShowEquip()
		self:refreshEquipment()
		self:refreshAwak()
	end
end

function This:addListener(isContainer,selectHandler)
	self.m_csNode.bg:setTouch({
		isContainer = isContainer,
		isDynamic = true,
		onEnded = function ()	
			if selectHandler then
				selectHandler(self.m_heroId)
			end
		end,
		isScale = false
	})
end

function This:onEnter()
	super.onEnter(self)
	HeroManager:addObserver(self)
	EquipManager:addObserver(self)
	FabaoManager:addObserver(self)
end

function This:onExit()
	super.onExit(self)
	HeroManager:removeObserver(self)
	EquipManager:removeObserver(self)
	FabaoManager:removeObserver(self)
end

function This:onUpgradeLevel(heroId)
	local hero = HeroManager:getHero(self.m_heroId)
	if self.m_heroId == heroId or hero:hasDeputy(heroId) then
		self:refresh()
	end
end

function This:onUpgradeStarLv(heroId)
	local hero = HeroManager:getHero(self.m_heroId)
	if self.m_heroId == heroId or hero:hasDeputy(heroId) then
		self:refresh()
	end
end

function This:onUpgradeQuality(heroId)
	local hero = HeroManager:getHero(self.m_heroId)
	if self.m_heroId == heroId or hero:hasDeputy(heroId) then
		self:refresh()
	end
end

function This:onDeputyChanged(heroId)
	if self.m_heroId == heroId then
		self:refresh()
	end
end

function This:onEquipChanged(heroId)
	if self.m_heroId == heroId then
		self:refresh()
	else
		local hero = HeroManager:getHero(heroId)
		if hero:getPrimaryHero() == self.m_heroId then
			self:refresh()
		end
	end
end

function This:onStrengthLevel(uid)
	local equip = EquipManager:getEquip(uid)
	if equip:getHeroId() == self.m_heroId then
		self:refresh()
	else
		local heroId = equip:getHeroId()
		if heroId > 0 then
			local hero = HeroManager:getHero(heroId)
			if hero:getPrimaryHero() == self.m_heroId then
				self:refresh()
			end
		end
	end
end

function This:onEquipUpLevel(uid)
	local equip = EquipManager:getEquip(uid)
	if equip:getHeroId() == self.m_heroId then
		self:refresh()
	else
		local heroId = equip:getHeroId()
		if heroId > 0 then
			local hero = HeroManager:getHero(heroId)
			if hero:getPrimaryHero() == self.m_heroId then
				self:refresh()
			end
		end
	end
end

function This:onEquipUpgradeQuality(uid)
	self:onStrengthLevel(uid)
end

function This:onHeroReset(hero)
	if hero:getId() == self.m_heroId then
		self:refresh()
	end
end

function This:onEquipPsvSkill(solt)
	if self.m_heroId == solt:getHero():getId() then
		self:refresh()
	end
end

function This:onUpgradeSaintLev()
	self:refresh()
end

function This:onTransPsvSkill(sheroId, theroId)
	if self.m_heroId == sheroId or self.m_heroId == theroId then
		self:refresh()
	end
end

function This:onAddAttrPoint(heroId)
	if self.m_heroId == heroId then
		self:refresh()
	end
end

function This:onFabaoDataChanged(fabaoUid)
	local fabao = FabaoManager:getFabao(fabaoUid)
	if fabao:isEquipped() then
		local hero = HeroManager:getHeroByUid(fabao:getHeroUid())
		if hero:getId() == self.m_heroId then
			self:refresh()
		end
	end
end

function This:onRefineChanged()
	self:refresh()
end

function This:onTacticsChanged()
	self:refresh()
end

--endregion
