--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This, super = class(...,"Dialog")
local HeroManager = require("Hero.HeroManager")
local HeroItemView = require("Hero.HeroItemView")
local ListLayer = require("UI.ListLayer")
local GamePlayer = require("Player.GamePlayer")
local EventDispatcher = require("EventDispatcher")
local HeroListManager = require("List.HeroListManager")
local UpdateLayer = require("UI.UpdateLayer")
local GameUtil = require("Util.GameUtil")
local ViewUtil = require("UI.ViewUtil")

local curListSelectedIndex = 0

function This:initNode(info)
	self.m_csNode = cc.Node:createFromCSFile("GameScene/NodeUI/HeroList.csb")
	local w ,h = self.m_csNode.bg1:getContentSize()
	self.m_csNode:setToCenter(w,h)
	self:addChild(self.m_csNode)

	--[[local GLView = cc.Director:getOpenGLView()
	local scalex , scaley = GLView:getScaleX(),GLView:getScaleY()
	self:setScale(1/scalex)]]

	self.m_csNode.select:setSelected(true)
	self.m_isSelectDeputy = HeroManager:isShowDeputy()
	self.m_isSelectEquip = HeroManager:isShowEquip()
	self.m_saintInfo = HeroManager:getSaintInfo()

	local count = HeroManager:getHeroGotCount()
	self.m_csNode.count:setString(count)
	
	self.m_listLayer = UpdateLayer:create({
		itemWidth = 130,
		itemHeight = 150,
		itemCount = count,
		frameCount = count,
		column = 6,
		isDelayDelete = true,
		scrollView = self.m_csNode.heroList,
	})
	
	self.m_listLayer:setAnchorPoint(0.5,0)
	local w , h = self.m_listLayer:getContentSize()
	self.m_csNode.heroList:pushBackCustomItem(self.m_listLayer, w,h,0)
	self.m_listLayer:setCascadeOpacityEnabled(true)

	self.m_heroIndex = {}
	self.m_noDeputyHeros = {}
	self.m_allHeros = {}
	self.m_isShowDeputy = HeroManager:isShowDeputy()
	self.m_isShowEquip = HeroManager:isShowEquip()

	self.m_csNode.select.selected:setVisible(self.m_isShowDeputy)
	self.m_csNode.select1.selected:setVisible(self.m_isShowEquip)

	self:initHeroOrder()
	if GamePlayer:isInWorld() then
		HeroManager:onUpdateHeroStateRequest()
	else
		self:refreshItems()
	end
	self.m_csNode.queue_list:setVisible(false)
	self.m_isRequesting = true
	self:refreshHeroListBtns(false)
end

function This:initTouchEvent()
	self.m_csNode.close:setTouchEnded(function()
		self:close()
	end)
	self.m_csNode.recruite:setTouchEnded(function()
		self:onRecruiteBtnClicked()	
	end)

	self.m_csNode.select:setTouchEnded(function()
		self.m_isShowDeputy = not self.m_isShowDeputy
		self.m_csNode.select.selected:setVisible(self.m_isShowDeputy)
		HeroManager:setIsShowDeputy(self.m_isShowDeputy)
		self:refreshItems()
	end)

	self.m_csNode.select1:setTouchEnded(function()
		self.m_isShowEquip = not self.m_isShowEquip
		self.m_csNode.select1.selected:setVisible(self.m_isShowEquip)
		HeroManager:setIsShowEquip(self.m_isShowEquip)
		self:refreshItems()
	end)

	self.m_csNode.listbutton:setTouchEnded(function()
		g_scene:openDialog("List.ListDescPanel")
	end)
	
	self.m_csNode.listbtnxiala:setTouchEnded(function()
		local isVisible = not self.m_csNode.queue_list:isVisible()
		self:refreshHeroListBtns(isVisible)
	end)

	for i = 0 , 6 do
		self.m_csNode.queue_list["selectbg"..i]:setTouch({
			onEnded = function()
				curListSelectedIndex = i
				self:refreshItems()
				self:refreshHeroListBtns(false)
			end,
			isScale = false
		})
	end

	self.m_csNode.wusheng.button:setTouchEnded(function ()
		if self.m_saintInfo:canUpgradeSaintLev() then
			HeroManager:onUpgradeSaintLevRequest()
		end
		self:openDialog("Hero.SaintUpgradePanel")
	end)

	self.m_csNode.wusheng.box:setTouch({
		onEnded = function ()
			if self.m_saintInfo:hasSanitReward() then
				g_scene:openDialog("Hero.SaintBoxRewardPanel")
			else
				g_scene:showTips(Serialize[61283])
			end
		end,
		isAlpha = false,
	})

	self.m_csNode.book:setTouchEnded(function ()
		g_scene:openDialog("Recruit.HeroRecruitListPanel")
	end)
end

function This:initHeroOrder()
	self.m_noDeputyHeros = HeroManager:getNotDeputyHeros()
	table.sort(self.m_noDeputyHeros,function(a,b)
		if a:getQuality() > b:getQuality() then
			return true
		elseif a:getQuality() == b:getQuality() and a:getFightPower() > b:getFightPower() then
			return true
		elseif a:getQuality() == b:getQuality() and a:getFightPower() == b:getFightPower() and a:getId() < b:getId() then
			return true
		end
		return false
	end)
		
	self.m_allHeros = {}
	for i , hero in ipairs(self.m_noDeputyHeros) do
		table.insert(self.m_allHeros,hero)
		local deputy = hero:getDeputyHeros()
		for j , id in pairs(deputy) do
			local o = HeroManager:getHero(id)
			table.insert(self.m_allHeros,o)
		end
	end
end

function This:getHeroList()
	if curListSelectedIndex == 0 then
		if self.m_isShowDeputy then
			return self.m_allHeros
		else
			return self.m_noDeputyHeros
		end
	else
		local heroList = {}
		local queue = HeroListManager:getList(curListSelectedIndex)
		local list = queue:getHeroList()
		if not self.m_isShowDeputy then
			for i , heroId in ipairs(list) do
				local hero = HeroManager:getHero(heroId)
				if not hero:isDeputy() then
					table.insert(heroList,hero)
				end
			end
		else
			for i , heroId in ipairs(list) do
				local hero = HeroManager:getHero(heroId)
				table.insert(heroList,hero)
			end
		end
		return heroList
	end
end

function This:refreshItemsByQueueIndex(index)
	if curListSelectedIndex ~= index then
		curListSelectedIndex = index
		self:refreshItems()
	end
end

function This:getHeroItemView(hero)
	local view = HeroItemView:create(hero:getId())
	view:addListener(true,function(heroId)
		local heroList = {}
		for i , hero in ipairs(self.m_heroList) do
			table.insert(heroList,hero:getId())
		end
		g_scene:openDialog("Hero.HeroPanel",{heroId = heroId,heroList = heroList})
	end)
	view:setCascadeOpacityEnabled(true)
	return view
end

function This:refreshItems()
	self.m_heroList = self:getHeroList()
	self.m_listLayer:setDataList(self.m_heroList,function(model)
		return self:getHeroItemView(model)
	end)
	self:refreshSaintUI()
end

function This:refreshHeroCount()
	local count = HeroManager:getHeroGotCount()
	self.m_csNode.count:setString(count)
end

function This:refreshHeroListBtns(isShowBtn)
	if isShowBtn then
		self.m_csNode.queue_list:setVisible(true)
		for i = 1 , 6 do
			local queue = HeroListManager:getList(i)
			local node = self.m_csNode.queue_list["selectbg"..i]
			node:setVisible(queue:isOpen())
			node.teamname:setString(queue:getName())
		end
	else
		self.m_csNode.queue_list:setVisible(false)
	end
	
	if curListSelectedIndex == 0 then
		self.m_csNode.name:setString(Serialize[61284])
	else
		local queue = HeroListManager:getList(curListSelectedIndex)
		self.m_csNode.name:setString(queue:getName())
	end
end

function This:refreshSaintUpEffect()
	local cleanup = not self.m_saintInfo:canUpgradeSaintLev()
    if not cleanup and not self.m_effectSaintUp then
        self.m_effectSaintUp = GameUtil:createEffect("WuSheng1", true, self)
        local posx, posy = self.m_csNode.wusheng.jiantoudi:getPosition()
        self.m_effectSaintUp:setPosition(posx, posy)
        self.m_csNode.wusheng:addChild(self.m_effectSaintUp)         
    elseif cleanup and self.m_effectSaintUp then
        self.m_effectSaintUp:removeFromParent()
        self.m_effectSaintUp = nil
    end
end

function This:refreshSaintBoxEffect()
	local cleanup = not self.m_saintInfo:hasSanitRewardOpen()
    if not cleanup and not self.m_effectSaintBox then
        self.m_csNode.wusheng.box:setOpacity(0)
        self.m_effectSaintBox = GameUtil:createEffect("BaoXiang2", true, self)
        local posx, posy = self.m_csNode.wusheng.box:getPosition()
        self.m_effectSaintBox:setPosition(posx, posy)
        self.m_effectSaintBox:setScale(0.7)
        self.m_csNode.wusheng:addChild(self.m_effectSaintBox)    
    elseif cleanup and self.m_effectSaintBox then
        self.m_csNode.wusheng.box:setOpacity(255)
        self.m_effectSaintBox:removeFromParent()
        self.m_effectSaintBox = nil     
    end
end

function This:refreshSaintUI()
	local saintInfo = self.m_saintInfo
	local curProgress, curLevelValue = saintInfo:getSaintProgress()
	print(curProgress, curLevelValue)
	local saintPower = saintInfo:getSaintPower()
	local saintLevel = saintInfo:getSaintLevel()
    local targetLev = saintInfo:getTargetLevel()
    self.m_csNode.wusheng.number:setString(saintPower)
    self.m_csNode.wusheng.level:setString(saintLevel)
    if curLevelValue - curProgress > 0 then
    	self.m_csNode.wusheng.zhanlizhi:setString(tostring(curLevelValue - curProgress))
    elseif targetLev then
    	self.m_csNode.wusheng.zhanlizhi:setString(Serialize[61285])
    else
    	self.m_csNode.wusheng.zhanlizhi:setString(Serialize[60353])
    end
    if targetLev then
	    self.m_csNode.wusheng.box_jindu:setString(tostring(saintLevel) .. "/" .. tostring(targetLev))
	    self.m_csNode.wusheng.jindu2:setPercent(saintLevel / targetLev * 100)
    else
	    self.m_csNode.wusheng.box_jindu:setString(tostring(saintLevel) .. "/" .. tostring(saintLevel))
	    self.m_csNode.wusheng.jindu2:setPercent(100)
    end
    self.m_csNode.wusheng.jindu:setPercent(curProgress / curLevelValue * 100)

    self:refreshSaintUpEffect()
    self:refreshSaintBoxEffect()
    return saintPower
end

function This:onEnter()
	super.onEnter(self)
	HeroManager:addObserver(self)
	HeroListManager:addObserver(self)

	self:addListener("tactics_goto_get", function()
		self:close()
	end)
end

function This:onExit()
	HeroManager:removeObserver(self)
	HeroListManager:removeObserver(self)
	super.onExit(self)
end

----------------------------------------------------------

function This:onObtainHero()
	print("!!!!!!!!!!!!!!!!!!!!!!!")
	self:initHeroOrder()
	self:refreshItems()
	self:refreshHeroCount()
end

function This:onDeputyChanged()
	self:initHeroOrder()
	self:refreshItems()
	self:refreshHeroCount()
end

function This:onAddHero(hero)
	
end

function This:onRecruiteBtnClicked()
	
end

function This:onUpdateHeroState()
	if self.m_isRequesting then
		self:refreshItems()
		self.m_isRequesting = nil
	end
end

function This:onEditList(queue)
	if curListSelectedIndex == queue:getIndex() then
		self:refreshItems()
	end
end

function This:onSaintHeroInfoChange(oldvalue, power)
    self:refreshSaintUI()
    ViewUtil:startCountUp(self.m_csNode.wusheng.number, {startNum=oldvalue, endNum=power, interval=0.5})
end

function This:onPickupSaintLevReward()
    self:refreshSaintBoxEffect()
end

--endregion
