--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This = class(...)
local Hero = require("Hero.Hero")
local HeroConfig = require("Metadatas.HeroConfig")
local EventDispatcher = require("EventDispatcher")
local Socket = require("Net.Socket")
local Serialize = require("Serialize.Serialize")
local EquipManager = require("Equip.EquipManager")
local GameUtil = require("Util.GameUtil")
local IterateEvent = require("Event.IterateEvent")
local MatchManager = require("Match.MatchManager")
local GameKingWayManager = require("Awake.GameKingWayManager")
local GamePlayer = require("Player.GamePlayer")
local EventDispatcher = require("EventDispatcher")
local ResetHeroConfig = require("Metadatas.ResetHeroConfig")
local HeroPsvSkill = require("Hero.HeroPsvSkill")
-- local PassiveSkillConfig = require("Metadatas.PassiveSkillConfig")
local PassiveSkillTakeConfig = require("Metadatas.PassiveSkillTakeConfig")
local ChangeSkillConfig = require("Metadatas.ChangeSkillConfig")
local SaintInfo = require("Hero.SaintInfo")
local FateInfo = require("Hero.FateInfo")
local FamilyRatingManager = require("FamilyRating.FamilyRatingManager")
local ArrayManager = require("Hero.ArrayManager")
local PopDialogManager = require("UI.PopDialogManager")
local DepotManager = require("Depot.DepotManager")
local ArgConfig = require("Metadatas.ArgConfig")
local FetterConfig = require("Metadatas.FetterConfig")
local GameFetter = require("Hero.GameFetter")
local GameRedFetter = require("Hero.GameRedFetter")
local RuneManager = require("Equip.RuneManager")
local DrumManager = require("Drum.DrumManager")


HeroOwnedType =
{
	kPlayerSelf,  --玩家本身的
	kStageNpc,    --关卡的
	kOtherPlayer,  --其他玩家的
}

function This:init()
	self.m_heros = {}
	self.m_heroUid = {}
	self.m_npcHeros = {}
	self.m_observers = {}
	self.m_heroGotCount = 0
	self.m_psvSkills = {}
	self.m_armsBuyInfo = {}
	self.m_attrLeftPointClearTime = 0
	local tmp = cc.FileUtils:loadLuaFile("HeroData")
	self.m_isShowDeputy = tmp and (tmp.isShowDeputy or false)  or false
	self.m_isShowEquip = tmp and (tmp.isShowEquip or false)  or false
	self.m_isMultiUpgrade = tmp and (tmp.isMultiUpgrade or false)  or false
	self.m_saintInfo = SaintInfo:create()
	self.m_fateInfo = FateInfo:create()
	self.m_gRefineAttr = require("HeroRefine.GHeroRefineAttr"):create()
	self.m_gTacticsAttr = require("HeroTactics.GHeroTacticsAttr"):create()
	self:initListener()
	RuneManager:init()
end

function This:initListener()
	EventDispatcher:addListener(self,10400,self.onGetHeroGotInfoReply)
	EventDispatcher:addListener(self,10401,self.onUpdateLevelReply)
	EventDispatcher:addListener(self,10402,self.onUpgradeStarLvReply)
	EventDispatcher:addListener(self,10403,self.onUpgradeQualityReply)
	EventDispatcher:addListener(self,10404,self.onUpdateEquipReply)
	EventDispatcher:addListener(self,10405,self.onUpdateDeputyReply)
	EventDispatcher:addListener(self,11116,self.onUpdateHeroStateReply)
	EventDispatcher:addListener(self,10407,self.onAddHeroNotify)
	EventDispatcher:addListener(self,11100,self.onInitHeroStateNotify)
	EventDispatcher:addListener(self,10408,self.onAddAttrPointReply)
	EventDispatcher:addListener(self,10409,self.onClearAttrPointReply)

	EventDispatcher:addListener(self,10411,self.onTrainSoilderReply)
	EventDispatcher:addListener(self,10412,self.onUpPhaseSoilderReply)
	EventDispatcher:addListener(self,10413,self.onAttachSoilderReply)
	EventDispatcher:addListener(self,11207,self.onBattleSettlementNotify)
	EventDispatcher:addListener(self,10414,self.onExchangePiecesReply)
	EventDispatcher:addListener(self,10416,self.onResetHeroReply)
	EventDispatcher:addListener(self,10418,self.onEquipPsvSkillReply)
	EventDispatcher:addListener(self,10419,self.onUnlockPsvSoltReply)
	EventDispatcher:addListener(self,10420,self.onGetSaintHeroInfoReply)
	EventDispatcher:addListener(self,10421,self.onUpgradeSaintLevReply)
	EventDispatcher:addListener(self,10422,self.onPickupSaintLevRewardReply)
	EventDispatcher:addListener(self,10423,self.onTransPsvSkillReply)
	EventDispatcher:addListener(self,10437,self.onResetPsvSkillSlotReply)
	EventDispatcher:addListener(self,12300,self.onGetCardAwakeInfoReply)
	EventDispatcher:addListener(self,12301,self.onGetUpdateStarLevelReply)
	EventDispatcher:addListener(self,12302,self.onGetAwakeReply)
	-- EventDispatcher:addListener(self,13100,self.onGetFateInfoReply)
	EventDispatcher:addListener(self,13101,self.onActivateFateReply)
	EventDispatcher:addListener(self,10438,self.onReceiveFabaoWearStateChangedReply)
	EventDispatcher:addListener(self, 10443, self.onGetForceAwakeReply)
	EventDispatcher:addListener(self, 10444, self.onGetHeroPsvScoreReply)
	EventDispatcher:addListener(self, 10499, self.onFightPowerTestReply)
	EventDispatcher:addListener(self, 14200, self.onRefineMergeReply)
	EventDispatcher:addListener(self, 14201, self.onRefineWearReply)
	EventDispatcher:addListener(self, 14202, self.onRefineUpgradeReply)
	EventDispatcher:addListener(self, 14203, self.onRefineOneKeyWearReply)
	EventDispatcher:addListener(self, 14801, self.onTacticsWearReply)
	EventDispatcher:addListener(self, 14802, self.onTacticsOneKeyWearReply)
	EventDispatcher:addListener(self, 14803, self.onTacticsUpgradeStarReply)
	EventDispatcher:addListener(self, 14804, self.onTacticsUpgradeSlotReply)


	EventDispatcher:addListener(self,"day_passed_withoutnet", self.onDayPassNotify)
	EventDispatcher:addListener(self,"player_attr_changed", self.onRefreshAfterLevelUp)
end

function This:removeListener()
	EventDispatcher:removeListener(self,10438)
	EventDispatcher:removeListener(self, "player_attr_changed")
	EventDispatcher:removeListener(self,"day_passed")
	EventDispatcher:removeListener(self,10400)
	EventDispatcher:removeListener(self,10401)
	EventDispatcher:removeListener(self,10402)
	EventDispatcher:removeListener(self,10403)
	EventDispatcher:removeListener(self,10404)
	EventDispatcher:removeListener(self,10405)
	EventDispatcher:removeListener(self,11116)
	EventDispatcher:removeListener(self,10407)
	EventDispatcher:removeListener(self,11100)
	EventDispatcher:removeListener(self,10408)
	EventDispatcher:removeListener(self,10409)

	EventDispatcher:removeListener(self,10411)
	EventDispatcher:removeListener(self,10412)
	EventDispatcher:removeListener(self,10413)
	EventDispatcher:removeListener(self,10414)
	EventDispatcher:removeListener(self,10420)
	EventDispatcher:removeListener(self,10421)
	EventDispatcher:removeListener(self,10422)
	EventDispatcher:removeListener(self,10423)
	EventDispatcher:removeListener(self,10437)
	EventDispatcher:removeListener(self,12300)
	EventDispatcher:removeListener(self,12301)
	EventDispatcher:removeListener(self,12302)
	-- EventDispatcher:removeListener(self,13100)
	EventDispatcher:removeListener(self,13101)
	EventDispatcher:removeListener(self,10443)
	EventDispatcher:removeListener(self,10444)
	EventDispatcher:removeListener(self,10499)
	EventDispatcher:removeListener(self,14200)
	EventDispatcher:removeListener(self,14201)
	EventDispatcher:removeListener(self,14202)
	EventDispatcher:removeListener(self,14203)
	EventDispatcher:removeListener(self,14801)
	EventDispatcher:removeListener(self,14802)
	EventDispatcher:removeListener(self,14803)
	EventDispatcher:removeListener(self,14804)
end

function This:isRedHero(heroId)
	local hero = self:getHero(heroId)
	if hero then
		return hero:isRed()
	end
	return false
end

function This:createFetter(heroId,fetterId)
	if FetterConfig[fetterId] then
		return GameFetter:create(heroId,fetterId)
	else
		return GameRedFetter:create(heroId,fetterId)
	end
end

function This:addObserver(observer)
	for i , o in pairs(self.m_observers) do
		if o == observer then
			return 
		end
	end
	table.insert(self.m_observers,observer)
end

function This:removeObserver(observer)
	for i , o in pairs(self.m_observers) do
		if o == observer then
			table.remove(self.m_observers,i)
			return
		end
	end
end

function This:notifyObserver(funcName, ...)
	local tmp = {}
	for _, o in pairs(self.m_observers) do
		if o[funcName] then
			table.insert(tmp,o)
		end
	end

	for _, observer in pairs(tmp) do
		if observer[funcName] then
			observer[funcName](observer, ...)
		end
	end
end

function This:onGetHeroGotInfoRequest()
	Socket:sendAndLock(10400,{})
end

function This:onGetHeroGotInfoReply(msg)
	local heroWithDuptyList = {}
	local heroList = {}

	for _, info in ipairs(msg.hero_list) do
		local hero = self:getHero(info.type_id)
		if not hero:isGot() then
			hero:setUid(info.id)
			hero:obtainHero()
			self.m_heroGotCount = self.m_heroGotCount + 1
			self.m_heroUid[info.id] = hero
		end

		local count = 0
		for _ , id in pairs(info.deputy_id) do
			if id > 0 then
				count = count + 1
			end
		end

		if count > 0 then
			table.insert(heroWithDuptyList,info)
		else
			table.insert(heroList,info)
		end
	end

	local function initHeroWithData(list) 
		for _, info in ipairs(list) do
			self:updateHeroWithInfo(info)
		end
	end

	initHeroWithData(heroList)
	initHeroWithData(heroWithDuptyList)
	self:updateRefineAttr()
	self:updateTacticsAttr()
	self.m_attrLeftPointClearTime = msg.point_reset_times
	self.m_heroLeftResetTime = msg.card_reset_times
	self.m_heroResetTimesWithGold = msg.gold_reset_times
	self.m_psvTranFreeTimes = msg.skill_move_times or 0
    self.m_psvSkillResetTimes = msg.skill_pos_reset_times
	self:calcFateFightPower(true)
end

function This:updateHeroWithInfo(info, newHero)
	local heroId = info.type_id
	if heroId and heroId <= 0 then return end

	local hero = self:getHero(heroId)
	local deputy = {0,0}
	local equips = {0,0,0}

	for index , deputyId in ipairs(info.deputy_id or {}) do
		if deputyId > 0.1 then
			local deputyHero = self:getHeroByUid(deputyId)
			if deputyHero then
				local pos = info.deputy_pos[index]
				deputy[pos] = deputyHero:getId()
			end
		end
	end
	info.deputy = deputy

	for posIndex, pos in ipairs(info.equips_pos or {}) do
		equips[pos] = info.equips_id[posIndex]
	end
	if info.primary and info.primary > 0.1 then
		local hero = self:getHeroByUid(info.primary)
		if hero then
			info.primary = hero:getId()
		end
	end
	info.equips = equips

	if hero then
		hero:setHeroInfo(info)
	end
	if not newHero then
		self:notifyObserver("onHeroInfoChanged", heroId)
	end
end

function This:getHeroGotCount()
	return self.m_heroGotCount
end

function This:getAllHero()
	return self.m_heros
end

function This:getNotDeputyHeros()
	local heros = {}
	for id , hero in pairs(self.m_heros) do
		if hero:isGot() and  not hero:isDeputy() then
			table.insert(heros,hero)
		end
	end
	return heros
end

function This:getAllHeroGotWithSort(selector,isIdList)
	local heros = {}
	for id , hero in pairs(self.m_heros) do
		if hero:isGot() then
			if not selector then
				table.insert(heros,hero)
			elseif selector(hero) then
				table.insert(heros,hero)
			end
		end
	end
	table.sort(heros,function(a,b)
		if a:getQuality() > b:getQuality() then
			return true
		elseif a:getQuality() == b:getQuality() and a:getFightPower() > b:getFightPower() then
			return true
		elseif a:getQuality() == b:getQuality() and a:getFightPower() == b:getFightPower()and a:getId() < b:getId() then
			return true
		end
		return false
	end)
	if isIdList then
		for i , hero in ipairs(heros) do
			heros[i] = hero:getId()
		end
	end
	return heros
end

function This:isGotHero(id)
	local hero = self:getHero(id)
	return hero:isGot()
end

function This:getHeroByUid(uid)
	--print("getHeroByUid:" .. uid)
	local hero = self.m_heroUid[uid]
	return hero
end

function This:getHero(id)
	local hero = self.m_heros[id]
	if not hero then
		hero = Hero:create({heroId = id})
		self.m_heros[id] = hero
	end
	return hero
end

function This:addHero(hero)	
	local id = hero:getId()
	self.m_heros[id] = hero
	local uid = hero:getUid()
	self.m_heroUid[uid] = hero
	if not hero:isGot() then
		self.m_heroGotCount = self.m_heroGotCount + 1
		hero:obtainHero()
	end
	self:notifyObserver("onAddHero", hero)
end

function This:removeHero(id)
	local hero = self.m_heros[id]
	if hero then
		self.m_heros[id] = nil
		if hero:isGot() then
			self.m_heroGotCount = self.m_heroGotCount - 1
			local uid = hero:getUid()
			self.m_heroUid[uid] = nil
		end
		self:notifyObserver("onRemoveHero",hero)
	end
end

function This:getAttrKeyFightPower(attrKey,isFloat)
	local result = 0
	if attrKey then
		local phyAtt = attrKey[AttrType.kPhyAttack] or 0
		local phyDef = attrKey[AttrType.kPhyDefence] or 0
		local magAtt = attrKey[AttrType.kMagicAttack] or 0
		local magDef = attrKey[AttrType.kMagicDefence] or 0
		local maxHp = attrKey[AttrType.kMaxHp] or 0
		local crit = attrKey[AttrType.kCritRatio] or 0
		local phyDmgAdd = attrKey[AttrType.kPhyDamageAddRatio] or 0
		local dmgAdd = attrKey[AttrType.kBothDamageAddRatio] or 0
		local magDmgAdd = attrKey[AttrType.kMagicDamageAddRatio] or 0

		local phyDmgReduce = attrKey[AttrType.kPhyDamageReduceRatio] or 0
		local magDmgReduce = attrKey[AttrType.kMagicDamageReduceRatio] or 0
		local dmgReduce = attrKey[AttrType.kBothDamageReduceRatio] or 0

		local dodge = attrKey[AttrType.kDodge] or 0
		local penetrate = attrKey[AttrType.kPenetrate] or 0
		local firstValue = attrKey[AttrType.kFirst] or 0

		local additionalPhyDamage = attrKey[AttrType.kAdditionalPhyDamage] or 0
		local additionalPlanDamage = attrKey[AttrType.kAdditionalPlanDamage] or 0
		local additionalPhyDamageReduce = attrKey[AttrType.kAdditionalPhyDamageReduce] or 0
		local additionalPlanDamageReduce = attrKey[AttrType.kAdditionalPlanDamageReduce] or 0
		local additionalPhyDamageAddRatio = attrKey[AttrType.kAdditionalPhyDamageAddRatio] or 0
		local additionalPlanDamageAddRatio = attrKey[AttrType.kAdditionalPlanDamageAddRatio] or 0
		
		result = (
				phyAtt * (1+ crit * 1.5 + (phyDmgAdd + dmgAdd)*0.66) + additionalPhyDamage*(1+additionalPhyDamageAddRatio) -- 物理攻击部分
				+ magAtt * (1 + (magDmgAdd + dmgAdd) * 0.66) + additionalPlanDamage*(1+additionalPlanDamageAddRatio)-- 计策攻击部分
				+ phyDef * (1 + phyDmgReduce) + additionalPhyDamageReduce -- 物理防御部分
				+ magDef * (1 + magDmgReduce) + additionalPlanDamageReduce -- 计策防御部分
				+ maxHp * 0.4 * (1 + (dodge + penetrate) / 2  
				+ dmgReduce + (phyDmgReduce + magDmgReduce) / 2)
			) * (1+0.2*firstValue / 100) * 1
	end
	if isFloat then
		return result
	else
		return math.floor(result)
	end
end

function This:getLeftAttrPointClearTime()
	return self.m_attrLeftPointClearTime
end

function This:setIsShowDeputy(isShow)
	self.m_isShowDeputy = isShow
	cc.FileUtils:saveToLua({isShowDeputy = self.m_isShowDeputy, isShowEquip = self.m_isShowEquip, isMultiUpgrade = self.m_isMultiUpgrade},"HeroData")
end

function This:isShowDeputy()
	return self.m_isShowDeputy
end

function This:setIsShowEquip(isShow)
	self.m_isShowEquip = isShow
	cc.FileUtils:saveToLua({isShowDeputy = self.m_isShowDeputy, isShowEquip = self.m_isShowEquip, isMultiUpgrade = self.m_isMultiUpgrade},"HeroData")
end

function This:isShowEquip()
	return self.m_isShowEquip
end


function This:setIsMultiUpgrade(isShow)
	self.m_isMultiUpgrade = isShow
	cc.FileUtils:saveToLua({isShowDeputy = self.m_isShowDeputy, isShowEquip = self.m_isShowEquip, isMultiUpgrade = self.m_isMultiUpgrade},"HeroData")
end

function This:isMultiUpgrade()
	return self.m_isMultiUpgrade
end

function This:updateSoilderAttr(soilderId)
	for i , hero in pairs(self.m_heros) do
		if hero:isGot() then
			local soilder = hero:getSoilder(soilderId)
			soilder:updateAttr()
		end
	end
	self:notifyObserver("onUpdateSoilderAttr")
end

function This:updateAllSoilderAttr()
	for i , hero in pairs(self.m_heros) do
		if hero:isGot() then
			hero:updateAllSoilderAttr()
		end
	end
end

function This:isDeputyFuncOpen()
	if GamePlayer:getRoleCreateDays() >= kDeputyFuncOpenDay then
		return true
	end
	if MatchManager:getRankLv() >= kDeputyFuncOpenRank then
		return true
	end
	return false
end

function This:isSoilderFuncOpen()
	if GamePlayer:getRoleCreateDays() >= kSoilderFuncOpenDay then
		return true
	end
	if MatchManager:getRankLv() >= kSoilderFuncOpenRank then
		return true
	end
	return false
end

function This:isSkillFuncOpen()
	if GamePlayer:getRoleCreateDays() >= kSkillFuncOpenDay then
		return true
	end
	if MatchManager:getRankLv() >= kSkillFuncOpenRank then
		return true
	end
	return false
end

function This:isFateFuncOpen()
	if GamePlayer:getLevel() >= kFateFuncOpenLevel then
		return true
	end
	return false
end

function This:updateBuildAttr(build)
	if build:getType() == TerrBuildType.kJiaoChang then
		local attrs = build:getBuildAtrrNum()
		for id , hero in pairs(self.m_heros) do
			hero:updateJiaoChangAttr(attrs)
		end
		self:calcSaintFightPower()
	elseif build:getType() == TerrBuildType.kBingYing then
		self:calcSaintFightPower()
	end
end

function This:updateTechnAttr(attrsList)
	for id , hero in pairs(self.m_heros) do
		hero:updateTechnAttr(attrsList)
	end
	self:calcSaintFightPower()
end

function This:updateScienceAttr(attrsList)
	for id , hero in pairs(self.m_heros) do
		hero:updateScience(attrsList)
	end
	self:calcSaintFightPower()
end

function This:updateArrayAttr(attrsList)
	if not attrsList then
		attrsList= ArrayManager:getArrayAttr()
	end
	for _, hero in pairs(self.m_heros) do
		hero:updateArray(attrsList)
	end
	self:calcSaintFightPower()	
end
-- function This:updateScienceAdd(attrs)
-- 	for id , hero in pairs(self.m_heros) do
-- 		hero:updateScienceAdd(attrsList)
-- 	end
-- 	self:calcSaintFightPower()
-- end

function This:updateSaintAttr()
	local level = self.m_saintInfo:getSaintLevel()
	if level > 0 then
		local attrs = self.m_saintInfo:getSaintAttrAdditionList(level)
		for id , hero in pairs(self.m_heros) do
			hero:updateSaintAttr(attrs)
		end
	end
end

--刷新评级属性
function This:updateRating()
	local attrs = FamilyRatingManager:getRatingAttr()
	for id , hero in pairs(self.m_heros) do
		hero:updateRating(attrs)
	end
	self:calcSaintFightPower()
end

function This:updateMingWang()
	local attrs = GamePlayer:getMingWangAttr()
	for id , hero in pairs(self.m_heros) do
		hero:updateMingWang(attrs)
	end
	self:calcSaintFightPower()
end

function This:updateDrum()
	local attrs = DrumManager:getDrumAttr()
	for id , hero in pairs(self.m_heros) do
		hero:updateDrum(attrs)
	end
	self:calcSaintFightPower()
end

function This:updateWangDao()
	if GameKingWayManager:isHaveKingWay() then
		local attrs = GameKingWayManager:getCurentAtrr()
		for id , hero in pairs(self.m_heros) do
			hero:updateWangDao(attrs)
		end
		self:calcSaintFightPower()
	end
end

function This:updateFateAttr(fate,isUpdatae)
	local heroIdList
	if not fate then
		heroIdList = self.m_fateInfo:getAllHeroList()
	else
        heroIdList = fate:getOwnerHeroList()
	end

    if heroIdList then
        for _, heroId in ipairs(heroIdList) do
			local hero = self.m_heros[heroId]
			if hero and hero:isGot() then
				hero:updateFateAttr()
				self:notifyObserver("onAddAttrPoint", heroId)
			end
        end
    end
    if isUpdatae then
    	self:calcSaintFightPower()
    end
end

function This:getLeftHeroResetFreeTimes()
	return self.m_heroLeftResetTime
end

function This:isHeroResetFree()
	return self.m_heroLeftResetTime > 0 
end

function This:getHeroResetTimes()
    return self.m_heroResetTimesWithGold
end

function This:getHeroResetCost()
	if self.m_heroLeftResetTime > 0 then
		return 0
	else
		local key = self.m_heroResetTimesWithGold + 1
		if ResetHeroConfig[key] then
			return ResetHeroConfig[key].price
		end
		return ResetHeroConfig[kMaxHeroResetWithGold].price
	end
end

function This:getPsvSkill(id)
	if not self.m_psvSkills[id] then
		if PassiveSkillTakeConfig[id] then
			local skill = HeroPsvSkill:create(id)
			self.m_psvSkills[id] = skill
		end
	end
	return self.m_psvSkills[id]
end

function This:getLeftTransFreeTimes()
	local times = kMaxPsvTransFreeTimes - self.m_psvTranFreeTimes
	if times < 0 then
		times = 0
	end
    return times
end

-- 获得被动技能重置过的次数
function This:getHasResetPassvieSkillTimes()
    return self.m_psvSkillResetTimes
end

function This:getNextPsvSkillTransCost()
	local nextTime = self.m_psvTranFreeTimes or 0
	if self.m_psvTranFreeTimes <= 0 then
		return 0
	end

	local config = ChangeSkillConfig[nextTime]
	if not config then
		local maxIndex = #ChangeSkillConfig
		config = ChangeSkillConfig[maxIndex]
	end
    return config.price
end

function This:calcSaintFightPower(withoutCalc)
    return self.m_saintInfo:calcSaintFightPower(withoutCalc)
end

function This:getStrongestPower()
    return self.m_saintInfo:getStrongestPower()
end

function This:getSaintInfo()
	return self.m_saintInfo
end

function This:getFateInfo()
	return self.m_fateInfo
end

function This:calcFateFightPower(withoutCalc, hero)
    return self.m_fateInfo:calcFateFightPower(withoutCalc, hero)
end
------------------------------------------------
function This:onUpgradeLevelRequest(heroId)
	if not self.m_isMultiUpgrading then
		local hero = self:getHero(heroId)
		local result , errorCode = hero:isCanUpgradeLevel()
		if result then
			Socket:sendAndLock(10401, {id = hero:getUid(), card_level = 1})
		else
			g_scene:handleErrorCode(errorCode)
		end
	end
end

function This:onUpgradeMultiLevelRequest( heroId )
	if not self.m_isMultiUpgrading then
		local hero = self:getHero(heroId)
		local result, param = hero:canUpgradeTenLevel()
		if result then
			self.m_isMultiUpgrading = true
			Socket:send(10401,{id = hero:getUid(), card_level = param})
		else
			g_scene:handleErrorCode(param)
		end
	end
end

function This:onUpdateLevelReply(message)
	if message.err_code == 0 then
		if self.m_isMultiUpgrading then
			self.m_isMultiUpgrading = false
		end

		local hero = self:getHero(message.card.type_id)
		hero:upgradeLevel(message.card.level)
		self:notifyObserver("onUpgradeLevel",message.card.type_id)
		EventDispatcher:dispatcher("array_change")

		self:calcSaintFightPower()
		cc.Audio:playEffect("Hero_LvUp.mp3")
	else
		self.m_isMultiUpgrading = false
		g_scene:showTips(Serialize[message.err_code])
	end
end

function This:onUpgradeStarLvRequest(heroId)
	local hero = self:getHero(heroId)
	local result , errorCode = hero:isCanUpgradeStarLv()
	if result then
		Socket:sendAndLock(10402,{id = hero:getUid()})
	else
		g_scene:handleErrorCode(errorCode)
	end
end

function This:onUpgradeStarLvReply(message)
	if message.err_code == 0 then
		local hero = self:getHero(message.card.type_id)
		hero:upgradeStar(message.card.starLv)
		self:notifyObserver("onUpgradeStarLv",message.card.type_id)
		EventDispatcher:dispatcher("array_change")
		self:calcFateFightPower(false, hero)
		self:calcSaintFightPower()
		cc.Audio:playEffect("Hero_StarUp.mp3")
	else
		g_scene:handleErrorCode(message.err_code)
	end
end


function This:onUpgradeQualityRequest(heroId)
	local hero = self:getHero(heroId)
	local result ,errorCode = hero:isCanUpgradeQuality()
	if result then
		Socket:sendAndLock(10403,{heroId = hero:getUid()})
	else
		g_scene:handleErrorCode(errorCode)
	end
end


function This:onUpgradeQualityReply(message)
	if message.err_code == 0 then
		local hero = self:getHero(message.card.type_id)
		hero:upgradeQuality(message.card.quality)
		self:calcFateFightPower(false, hero)
		self:calcSaintFightPower()
		self:notifyObserver("onUpgradeQuality",message.card.type_id)
	else
		g_scene:handleErrorCode(message.err_code)
	end
end

function This:onUpdateDeputyRequest(heroId,pos,deputyId)
	local hero = self:getHero(heroId)
	local uid = hero:getUid()
	local deputyUid = 0
	if deputyId > 0 then
		local deputy = self:getHero(deputyId)
		deputyUid = deputy:getUid()
	end
	Socket:sendAndLock(10405,{id = uid,pos = pos,card_id = deputyUid})
end

function This:onUpdateDeputyReply(msg)
	if msg.err_code == 0 then
		local deputy = {0,0}
		for i = 1 , #msg.card.deputy_pos do
			local pos = msg.card.deputy_pos[i]
			local uid = msg.card.deputy_id[i]
			if uid > 0 then
				local hero = self:getHeroByUid(uid)
				if not hero then
					assert(false)
				end
				deputy[pos] = hero:getId()
			end
		end
		local hero = self:getHeroByUid(msg.card.id)
		hero:setDeputy(deputy)
		self:notifyObserver("onDeputyChanged",hero:getId())
		EventDispatcher:dispatcher("deputy_changed", hero)
		self:calcSaintFightPower()
	else
		g_scene:handleErrorCode(msg.err_code)
	end
end

function This:onUpdateEquipRequest(heroId,pos,equipUid)
	local hero = self:getHero(heroId)
	local uid = hero:getUid()
	Socket:sendAndLock(10404, {id = uid, pos = pos,equip_id = equipUid})
end

function This:onUpdateEquipReply(msg)
	if msg.err_code == 0 then
		local equips = {0,0,0}
		for i = 1 , #msg.card.equips_pos do
			local pos = msg.card.equips_pos[i]
			local uid = msg.card.equips_id[i]
			equips[pos] = uid
		end
		local hero = self:getHero(msg.card.type_id)
		hero:setEquip(equips)
		hero:updateEquipClear()
		self:updateHeroWithInfo(msg.card)
		self:notifyObserver("onEquipChanged",hero:getId())
		EventDispatcher:dispatcher("hero_equip_changed",hero)
		self:calcSaintFightPower()
	else
		g_scene:handleErrorCode(msg.err_code)
	end
end

function This:onEquipFabaoRequest(heroUid, fabaoUid)
	Socket:sendAndLock(10438, {item_id = fabaoUid, card_id = heroUid, is_equip = true})
end

function This:onTakeOffFabaoRequest(heroUid, fabaoUid)
	Socket:sendAndLock(10438, {item_id = fabaoUid, card_id = heroUid, is_equip = false})
end

function This:onReceiveFabaoWearStateChangedReply(msg)
	if msg.err_code ~= 0 then
		g_scene:handleErrorCode(msg.err_code)
		return
	end

	local hero = self:getHeroByUid(msg.card_id)
	local currentFabao = hero:getFabaoUid(FabaoPos.kFirst)
	--if currentFabao == msg.item_id then
	--	return
	--end
	hero:equipFabao(FabaoPos.kFirst, msg.item_id)
	self:notifyObserver("onEquipChanged", hero:getId()) -- 通知武将装备发生改变
	self:calcSaintFightPower()
end

---------------------------------------------------------------

function This:onRecruiteHeroRequest(heroId)
	local hero = self:getHero(heroId)
	local result , errorCode = hero:isCanRecruiteHero(heroId)
	if true then
		Socket:sendAndLock("Hero_recruiteHero",{heroId = heroId})
	else
		g_scene:handleErrorCode(errorCode)
	end
end

function This:onRecruiteHeroReply(message)
	if message.result then
		self:notifyObserver("onRecruiteHero",message.heroId)
	else
		g_scene:handleErrorCode(message.errorCode)
	end
end

function This:onUpdateHeroStateRequest()
	Socket:sendAndLock(11116,{})
end

function This:onUpdateHeroStateReply(msg)
	for i , info in pairs(msg.chagne_list) do
		local hero = self:getHeroByUid(info.id)
        if hero then
		    hero:setState(info.state)
		    hero:setCityId(info.city_id)
            -- print(string.format("武将%s状态更新为%s",hero:getName(),HeroStateDesp[info.state]))
        end
	end
	self:notifyObserver("onUpdateHeroState")
	EventDispatcher:dispatcher("update_hero_state")
end

function This:onInitHeroStateNotify(msg)
	for i , info in pairs(msg.card_state_list) do
		local hero = self:getHeroByUid(info.id)
		hero:setState(info.state)		
		hero:setCityId(info.city_id)
		--print(string.format("武将%s状态更新为%s",hero:getName(),HeroStateDesp[info.state]))
	end
end

function This:onBattleSettlementNotify(msg)
	for id , hero in pairs(self.m_heros) do
		hero:setState(HeroState.kInFree)
	end
end

--新增武将
function This:onAddHeroNotify(msg)
	local heros = {}
	local items = {}
	for i , info in ipairs(msg.hero_list) do
		local hero = self:getHero(info.type_id)
		local isGot = hero:isGot()
		self:updateHeroWithInfo(info, isGot)
		if not isGot then
			self:addHero(hero)
			table.insert(heros,hero)
			table.insert(items,{heroId = info.type_id, isGot = false})
		end
	end

	for i , info in ipairs(msg.item_list) do
		if info.id > 20000 and info.id < 30000 then
			table.insert(items,{heroId = info.id - 10000, isGot = true})
		end
	end

	if #items > 0 then
		g_scene:showCard(items)
	end
	if #heros > 0 then
		self:calcFateFightPower(true)
		self:calcSaintFightPower(true)
		self:notifyObserver("onObtainHero",heros)
		EventDispatcher:dispatcher("add_hero",heros)
	end
end

--英雄加点分配
function This:onAddAttrPointRequest(hero,pointList)
	Socket:sendAndLock(10408,{card_id = hero:getUid(), point_list = pointList})
end

function This:onAddAttrPointReply(msg)
	if msg.err_code == 0 then
		local hero = self:getHero(msg.card.type_id)
		hero:updateAttrPoint(msg.card.point_list,msg.card.remain_point,msg.card.last_reset_time)
		self:notifyObserver("onAddAttrPoint",msg.card.type_id)
		self:calcSaintFightPower()
	else
		g_scene:handleErrorCode(msg.err_code)
	end
end

--加点重置
function This:onClearAttrPointRequest(hero)
	Socket:sendAndLock(10409,{card_id = hero:getUid()})
end

function This:onClearAttrPointReply(msg)
	if msg.err_code == 0 then
		local hero = self:getHero(msg.card.type_id)
		hero:updateAttrPoint(msg.card.point_list,msg.card.remain_point)
		if self.m_attrLeftPointClearTime > 0 then
			self.m_attrLeftPointClearTime = self.m_attrLeftPointClearTime - 1
		end
		self:notifyObserver("onClearAttrPoint",msg.card.type_id)
		self:calcSaintFightPower()
	else
		g_scene:handleErrorCode(msg.err_code)
	end
end

--兵种培养
function This:onTrainSoilderRequest(heroUid,soilderId)
	if not self.m_isMultiTraining then
		Socket:sendAndLock(10411,{card_id = heroUid, type = soilderId, card_time = 1})
	end
end
function This:onMultiTrainSoilderRequest(heroUid,soilderId, time)
	if not self.m_isMultiTraining then
		self.m_isMultiTraining = true
		Socket:send(10411,{card_id = heroUid, type = soilderId, card_time = time})
	end
end

function This:onTrainSoilderReply(msg)
	if msg.err_code == 0 then
		if self.m_isMultiTraining then
			self.m_isMultiTraining = false
		end

		local hero = self:getHeroByUid(msg.card_id)
		hero:updateSoilderAttrPoint(msg.type,msg.point_list)
		self:notifyObserver("onTrainSoilder",hero:getId(),msg.type)
		self:calcFateFightPower(false, hero)
		self:calcSaintFightPower()
	else
		self.m_isMultiTraining = false
		g_scene:handleErrorCode(msg.err_code)
	end
end

--兵种进阶
function This:onUpPhaseSoilderRequest(heroUid,soilderId)
	Socket:sendAndLock(10412,{card_id = heroUid, type = soilderId})
end
function This:onUpPhaseSoilderReply(msg)
	if msg.err_code == 0 then
		local hero = self:getHeroByUid(msg.card_id)
		hero:upgradeSolider(msg.type)
		local awakeSoilder = hero:getCurentAwakeSoilder()
		if awakeSoilder then
			awakeSoilder:setSelectSkill(msg.awake_force_index)
		end
		self:notifyObserver("onUpPhaseSoilder",hero:getId(),msg.type)
		self:calcFateFightPower(false, hero)
		self:calcSaintFightPower()
	else
		g_scene:handleErrorCode(msg.err_code)
	end
end

--兵种转换
function This:onAttachSoilderRequest(heroUid, soilderId,forceId)
	Socket:sendAndLock(10413,{card_id = heroUid, type = soilderId,awake_force_index = forceId})
end	 

function This:onAttachSoilderReply(msg)
	if msg.err_code == 0 then
		local hero = self:getHeroByUid(msg.card_id)
		hero:setCurSoilder(msg.type)
		local soilder =  hero:getAwakeSoilder(hero.m_curSoilderId)
		soilder:setSelectSkill(msg.awake_force_index)
		FamilyRatingManager:updateAllHeroScienceAttr()
		local num = msg.awake_force_index
		if num == 0 then
			num = 1
		end
		local id = soilder:getConfig().unlock_arm[num]
		local detailConfig = soilder:getDetailsConfig(id)
		if detailConfig then
			g_scene:showTips(string.format( Serialize[61287],detailConfig.arm_name ))
		end
		self:notifyObserver("onAttachSoilder",hero:getId(),msg.type)
		self:calcFateFightPower(false, hero)
		self:calcSaintFightPower()
	else
		g_scene:handleErrorCode(msg.err_code)
	end
end

--万能碎片转换
function This:onExchangePiecesRequest(heroId,num)
	Socket:sendAndLock(10414,{card_type = heroId, num = num})
end

function This:onExchangePiecesReply(msg)
	if msg.err_code == 0 then
		self:notifyObserver("onExchangePiece",msg.piece_id,msg.num)
		
	else
		g_scene:handleErrorCode(msg.err_code)
	end
end

--武将重置

function This:onResetHeroRequest(heroId)
	local hero = self:getHero(heroId)
	Socket:sendAndLock(10416,{card_id = hero:getUid()})
end

function This:onResetHeroReply(msg)
	if msg.err_code == 0 then
		local hero = self:getHeroByUid(msg.card_id)
		hero:reset()
		self.m_heroLeftResetTime = msg.card_reset_times
		self.m_heroResetTimesWithGold = msg.gold_reset_times
		self:updateRefineAttr()
		g_scene:showTips(string.format(Serialize[61288],hero:getName()))
		self:notifyObserver("onHeroReset",hero)
		self:calcFateFightPower(true)
		self:calcSaintFightPower()
	else
		g_scene:handleErrorCode(msg.err_code)
	end
end

--请求被动技能信息
function This:onGetHeroPsvSkillInfoRequest()
	Socket:sendAndLock(10417,{not_used = 0})
end

function This:onGetHeroPsvSkillInfoReply(msg)
	if msg.err_code == 0 then
		for i , info in ipairs(msg.skill_list) do
			local psvSkill = self:getPsvSkill(info.skill_id)
		end
	else
		g_scene:handleErrorCode(msg.err_code)
	end
end

--装备被动技能
function This:onEquipPsvSkillRequest(itemId,heroUid, lockIndex)
	Socket:sendAndLock(10418,{card_id = heroUid, item_type_id = itemId, lock_pos = lockIndex})
end

function This:onEquipPsvSkillReply(msg)
	if msg.err_code == 0 then
		local hero = self:getHeroByUid(msg.card_id)
		local solt = hero:getSoltByPos(msg.skill_pos)
		self:notifyObserver("onEquipPsvSkill", solt)
		g_scene:showTips(string.format(Serialize[61289],hero:getName(),solt:getPsvSkill():getName()))
		self:onGetHeroPsvScoreRequest()
		self:calcSaintFightPower()
	else
		g_scene:handleErrorCode(msg.err_code)
	end
end

--解锁技能槽
function This:onUnlockPsvSoltRequest(heroUid,pos)
	Socket:sendAndLock(10419,{card_id = heroUid, skill_pos = pos})
end

function This:onUnlockPsvSoltReply(msg)
	if msg.err_code == 0 then
		local hero = self:getHeroByUid(msg.card_id)
		local solt = hero:getSoltByPos(msg.skill_pos)
		self:notifyObserver("onUnlockPsvSolt", solt)
	else
		g_scene:handleErrorCode(msg.err_code)
	end
end

function This:onGetSaintHeroInfoRequest()
	if not self.m_isSaintInfoUpdating then
		self.m_isSaintInfoUpdating = true
		Socket:sendAndLock(10420)
	end
end

function This:onGetSaintHeroInfoReply( msg )
	self.m_isSaintInfoUpdating = false
    if msg.err_code == 0 then
    	self.m_saintInfo:updateInfo(msg, true)
        self:notifyObserver("onGetSaintHeroInfo")
    else
        g_scene:handleErrorCode(msg.err_code)
    end
end

function This:onUpgradeSaintLevRequest(level)
	if not level then 
		level = 1 
	end
	Socket:sendAndLock(10421, {up_saint_level = level})
end

function This:onUpgradeSaintLevReply( msg )
    if msg.err_code == 0 then
    	self.m_saintInfo:updateInfo(msg, true)
        self:notifyObserver("onUpgradeSaintLev")
    else
        g_scene:handleErrorCode(msg.err_code)
    end
end

function This:onPickupSaintLevRewardRequest(rewardId)
	Socket:sendAndLock(10422, {saint_level_id = rewardId})
end

function This:onPickupSaintLevRewardReply( msg )
    if msg.err_code == 0 then
    	local reward = self.m_saintInfo:getRewardListById(msg.saint_level_id)
    	self.m_saintInfo:updateInfo(msg)
    	if reward then
    		g_scene:showReward(reward)
    	end
        self:notifyObserver("onPickupSaintLevReward")
    else
        g_scene:handleErrorCode(msg.err_code)
    end
end

-- 转移技能
function This:onTransPsvSkillRequest(sourceId, targetId)
	Socket:sendAndLock(10423, {source_cardID = sourceId, target_cardID = targetId})
end

function This:onTransPsvSkillReply( msg )
    if msg.err_code == 0 then
  		self.m_psvTranFreeTimes = self.m_psvTranFreeTimes + 1
		local shero = self:getHeroByUid(msg.source_cardID)
		local thero = self:getHeroByUid(msg.target_cardID)
        -- shero:resetPsvSlot()
        -- thero:resetPsvSlot()
        self:notifyObserver("onTransPsvSkill", shero:getId(), thero:getId())
		self:calcSaintFightPower()
    else
        g_scene:handleErrorCode(msg.err_code)
    end
end

function This:onResetPsvSkillSlotRequest(heroUid)
	Socket:sendAndLock(10437, {card_id = heroUid})
end

function This:onResetPsvSkillSlotReply( msg )
    if msg.err_code == 0 then
        self.m_psvSkillResetTimes = self.m_psvSkillResetTimes + 1
    	g_scene:showReward(msg.reward_list)
		local hero = self:getHeroByUid(msg.card_id)
        hero:resetEmptyPsvSlot()
        self:notifyObserver("onResetPsvSkillSlot", hero:getId())
		self:calcSaintFightPower()
    else
        g_scene:handleErrorCode(msg.err_code)
    end
end

function This:onDayPassNotify()
	local curTime = GamePlayer:getServerTime()
	local date = os.serverdate("*t",curTime)
	if date.wday == 2 then
		self.m_heroLeftResetTime = kMaxHeroResetFreeTimes 
		self.m_psvTranFreeTimes = kMaxPsvTransFreeTimes 
		self:notifyObserver("onClearHeroResetTime")
	end
end

function This:onRefreshAfterLevelUp(info)
    if info.attrId == PlayerAttr.level and info.old ~= info.new then
    	self:calcSaintFightPower(true)
    end
end

--请求卡牌的觉醒数据
function This:onGetCardAwakeInfoRequest(uid)
	Socket:sendAndLock(12300,{card_id = uid})
end

function This:onGetCardAwakeInfoReply( msg )
    if msg.err_code == 0 then
    	local uid = msg.card_id
    	if msg.awake and uid then
	        local hero = self:getHeroByUid(uid)
	        hero:updateAwakeInfo( msg.awake )
	        self:notifyObserver("onAddAttrPoint",hero:getId())
    	end
--        self:notifyObserver("onGetCardAwakeInfo")
    else
        g_scene:handleErrorCode(msg.err_code)
    end
end

-- 觉醒星位升级
function This:onGetUpdateStarLevelRequest(uid,starId,sucessRate)
	Socket:sendAndLock(12301,{card_id = uid,star_id= starId,success_rate= sucessRate})
end

function This:onGetUpdateStarLevelReply( msg )
    if msg.err_code == 0 then
    	local uid = msg.card_id
    	local starData = msg.star
    	if starData and uid then
    		local hero = self:getHeroByUid(uid)
	        hero:updateAwakeStar( starData )
        	self:notifyObserver("onAddAttrPoint",hero:getId())
			self:calcFateFightPower(false, hero)
	    	self:calcSaintFightPower()
    	end
    	local msgString =Serialize[61290]
    	if msg.succ then
    		msgString =Serialize[61291]
    		cc.Audio:playEffect("Recruit_Change.mp3")
    	end
		g_scene:showTips(msgString)
        self:notifyObserver("onGetUpdateStarLevel",msg.succ)
    else
        g_scene:handleErrorCode(msg.err_code)
    end
end

--请求觉醒
function This:onGetAwakeRequest(uid)
	Socket:sendAndLock(12302,{card_id = uid})
end

function This:onGetAwakeReply( msg )
    if msg.err_code == 0 then
        local uid = msg.card_id
    	if msg.awake and uid then
	        local hero = self:getHeroByUid(uid)
			hero:updateAwakeInfo( msg.awake )
			g_scene:showTips(Serialize[61292])
			self:calcFateFightPower(false, hero)
	        self:calcSaintFightPower()
			self:notifyObserver("onAddAttrPoint",hero:getId())
			EventDispatcher:dispatcher("array_change")
			
    	end
    	cc.Audio:playEffect("Recruit_Open.mp3")
        self:notifyObserver("onGetAwake")
    else
        g_scene:handleErrorCode(msg.err_code)
    end
end

-- function This:onGetFateInfoRequest()
-- 	Socket:sendAndLock(13100)
-- end

-- function This:onGetFateInfoReply( msg )
--     if msg then
--         self.m_fateInfo:updateInfo(msg)
--         self:notifyObserver("onGetFateInfo")
--     else
--         g_scene:handleErrorCode("")
--     end
-- end

function This:onActivateFateRequest(fateId,heroUid)
	Socket:sendAndLock(13101, {fatalism_id=fateId,card_id = heroUid})
end

function This:onActivateFateReply( msg )
    if msg.err_code == 0 then
        local fate = self.m_fateInfo:updateFate(msg.fatalism,msg.card_id)
        self:updateFateAttr(fate,true)
        self:notifyObserver("onActFateivate", fate)
    else
        g_scene:handleErrorCode(msg.err_code)
    end
end

function This:onGetForceAwakeRequest(cardId,forceType)
	Socket:sendAndLock(10443,{card_id = cardId,force_type = forceType})
end

function This:onGetForceAwakeReply( msg )
    if msg.err_code == 0 then
        local cardId = msg.card_id
        local forceType = msg.force_type
        local selectIndex = msg.awake_force_index
		local hero = self:getHeroByUid(cardId)
		g_scene:showTips(Serialize[61292])
        hero:upgradeAwakeSolider(forceType,selectIndex)
        self:notifyObserver("onGetForceAwake", hero)
        self:calcFateFightPower(false, hero)
		self:calcSaintFightPower()
    else
        g_scene:handleErrorCode(msg.err_code)
    end
end

function This:getHeroPsvScore()
    return self.m_psvSkillScore or 0
end

function This:onGetHeroPsvScoreRequest()
	Socket:send(10444, {})
end

function This:onGetHeroPsvScoreReply( msg )
	if msg then
        self.m_psvSkillScore = msg.score
        self:notifyObserver("onGetHeroPsvScore", self.m_psvSkillScore)
	else
		g_scene:handleErrorCode("")
	end
end

function This:onFightPowerTestRequest(id,value)
	Socket:send(10499, {card_id=id,fight_power = value})
end

function This:onFightPowerTestReply(msg)
	if msg.err_code == 0 then
		g_scene:showTips(Serialize[61293])
	else
        g_scene:handleErrorCode(msg.err_code)
	end

end

-----------------------------武将精进-----------------------------

function This:getGlobalRefineAttr()
	return self.m_gRefineAttr
end

function This:getRefineOpenServerDays()
	return ArgConfig["hero_refinementConfig_open_days"].arg[1]
end

function This:getRefineOpenLevel()
	return ArgConfig["hero_refinementConfig_open_level"].arg[1]
end

function This:isRefineFuncOpen()
	local lv = GamePlayer:getLevel()
	local day = GamePlayer:getOpenServerDays()
	local needLv = self:getRefineOpenLevel()
	local needDay = self:getRefineOpenServerDays()

	-- print( string.format("/// refine curLv = %s curDay = %s needLv = %s needDay = %s", lv, day, needLv, needDay) )

	if lv >= needLv and day >= needDay then
		return true
	end

	return false
end

function This:getRefineLockTips()
	local needLv = self:getRefineOpenLevel()
	local needDay = self:getRefineOpenServerDays()
	return string.format(Serialize[61294], needDay, needLv)
end

function This:getMaxRefineLv()
	if not self.m_maxRefineLv then
		local RefinemenNeedtItemConfig = require("Metadatas.RefinemenNeedtItemConfig")
		self.m_maxRefineLv = #RefinemenNeedtItemConfig
	end
	return self.m_maxRefineLv
end

--合成
function This:onRefineMergeRequest(item_type_id)
	Socket:sendAndLock(14200, {item_type_id = item_type_id})
end

function This:onRefineMergeReply(msg)
	if msg.err_code == 0 then
		self:notifyObserver("onRefineMergeReply", msg.item_type_id)
	else
        g_scene:handleErrorCode(msg.err_code)
	end
end

--装备
function This:onRefineWearRequest(hero_id, item_id, pos)
	local hero = self:getHero(hero_id)
	local heroUid = hero:getUid()
	
	local item = DepotManager:getItem(item_id)
	local itemUid = item:getUid()

	--print("onRefineWearRequest", heroUid, itemUid, pos)

	Socket:sendAndLock(14201, {hero_id = heroUid, item_id = itemUid, pos = pos})
end

function This:onRefineWearReply(msg)
	if msg.err_code == 0 then
		local hero = self:getHeroByUid(msg.hero_id)
		hero:updateRefine(msg.refinemen_info)
		self:calcSaintFightPower()
		self:notifyObserver("onRefineWearReply", hero)
		self:notifyObserver("onRefineChanged")
	else
        g_scene:handleErrorCode(msg.err_code)
	end	
end

--进阶
function This:onRefineUpgradeRequest(hero_id)
	local hero = self:getHero(hero_id)
	local heroUid = hero:getUid()
	--print("onRefineUpgradeRequest", heroUid)
	Socket:sendAndLock(14202, {hero_id = heroUid})
end

function This:onRefineUpgradeReply(msg)
	if msg.err_code == 0 then
		local hero = self:getHeroByUid(msg.hero_id)
		hero:updateRefine(msg.refinemen_info)
		self:updateRefineAttr()
		self:notifyObserver("onRefineUpgradeReply", hero)
		self:notifyObserver("onRefineChanged")
	else
        g_scene:handleErrorCode(msg.err_code)
	end		
end

--一键装备
function This:onRefineOneKeyWearRequest(hero_id)
	local hero = self:getHero(hero_id)
	local heroUid = hero:getUid()
	--print("onRefineOneKeyWearRequest", heroUid)
	Socket:sendAndLock(14203, {hero_id = heroUid})
end

function This:onRefineOneKeyWearReply(msg)
	if msg.err_code == 0 then
		local hero = self:getHeroByUid(msg.hero_id)
		hero:updateRefine(msg.refinemen_info)
		self:calcSaintFightPower()
		self:notifyObserver("onRefineOneKeyWearReply", hero)
		self:notifyObserver("onRefineChanged")
	else
        g_scene:handleErrorCode(msg.err_code)
	end		
end

function This:updateRefineAttr()
	for id , hero in pairs(self.m_heros) do
		if hero:isGot() then
			hero:updateRefineAttr()
		end
	end

	self:calcSaintFightPower()	
end

---------------------------战法----------------------------

function This:getGlobalTacticsAttr()
	return self.m_gTacticsAttr
end

-- 穿戴/卸载
function This:onTacticsWearRequest(itemUid, heroUid, pos)
	Socket:sendAndLock(14801, {item_uid = itemUid, card_id = heroUid, pos = pos})
end

function This:onTacticsWearReply(msg)
	-- print_tmp(msg)
	if msg.err_code == 0 then
		local hero = self:getHeroByUid(msg.card_id)
		hero:getTactics():updateWear(msg.pos, msg.item_uid)
		self:updateTacticsAttr()
		self:notifyObserver("onTacticsChanged")
	else
        g_scene:handleErrorCode(msg.err_code)
	end	
end

-- 一键穿戴/卸载
function This:onTacticsOneKeyWearRequest(itemUidList, heroUid)
	Socket:sendAndLock(14802, {item_uid_list = itemUidList, card_id = heroUid})
end

function This:onTacticsOneKeyWearReply(msg)
	-- print_tmp(msg)
	if msg.err_code == 0 then
		local hero = self:getHeroByUid(msg.card_id)
		hero:getTactics():updateOneKeyWear(msg.item_uid_list)
		self:updateTacticsAttr()
		self:notifyObserver("onTacticsChanged")
	else
        g_scene:handleErrorCode(msg.err_code)
	end		
end

-- 升星
function This:onTacticsUpgradeStarRequest(itemUid)
	-- print("onTacticsUpgradeStarRequest", GameUtil:int64ToString(itemUid))
	Socket:sendAndLock(14803, {item_id = itemUid})
end

function This:onTacticsUpgradeStarReply(msg)
	-- print_tmp(msg)
	if msg.err_code == 0 then
		local item = DepotManager:getItemByUid(msg.item_id)
		msg.card_id = item:getEquipCardId()

		if msg.card_id ~= 0 then
			local hero = self:getHeroByUid(msg.card_id)
			hero:getTactics():updateStarUp(msg.item_id)
			self:updateTacticsAttr()
		end
		self:notifyObserver("onTacticsChanged")
		self:notifyObserver("onTacticsUpgradeStarReply", msg.item_id)
	else
        g_scene:handleErrorCode(msg.err_code)
	end			
end

-- 精练
function This:onTacticsUpgradeSlotRequest(heroUid)
	Socket:sendAndLock(14804, {card_id = heroUid})
end

function This:onTacticsUpgradeSlotReply(msg)
	-- print_tmp(msg)
	if msg.err_code == 0 then
		local hero = self:getHeroByUid(msg.card_id)
		hero:getTactics():updateAllPosLv(msg.pos_level)
		hero:updateTacticsAttr()
		self:calcSaintFightPower()
		self:notifyObserver("onTacticsChanged")
	else
        g_scene:handleErrorCode(msg.err_code)
	end		
end

function This:updateTacticsAttr()
	for id , hero in pairs(self.m_heros) do
		if hero:isGot() then
			hero:updateTacticsAttr()
		end
	end

	self:calcSaintFightPower()	
end