--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"Dialog")
local HeroManager = require("Hero.HeroManager")
local StarUpConfig = require("Metadatas.StarUpConfig")
local SkillConfig = require("Metadatas.SkillConfig")
local AttrListNode = require("Hero.AttrListNode")
local GrowTabNode = require("Hero.GrowTabNode")
local SkillTabNode = require("Hero.SkillTabNode")
local LegionTabNode = require("Hero.LegionTabNode")
local FateTabNode = require("Hero.FateTabNode")
local HelpTips = require("UI.HelpTips")
local SoilderTabNode = require("Hero.SoilderTabNode")
local EquipManager = require("Equip.EquipManager")
local GameUtil = require("Util.GameUtil")
local MatchingConfig = require("Metadatas.MatchingConfig")
local MatchManager = require("Match.MatchManager")
local FabaoManager = require("Fabao.FabaoManager")
local Signals = require("SignalSystem.Signals")
local SignalSystem = require("SignalSystem.SignalSystem")
local HeroRefineTabNode = require("HeroRefine.HeroRefineTabNode")
local RuneManager = require("Equip.RuneManager")
local HeroTacticsTabNode = require("HeroTactics.HeroTacticsTabNode")
local EventDispatcher = require("EventDispatcher")

local TabName = 
{
	kEquip = "equip",
	kSkill = "skill",
	kArmType = "armType",
	kLegion = "legion",
	kFate = "fate",
	kRefine = "refine",
	kTactics = "tactics",
}
local TabNum = 7 -- 按钮有增加要修改


function This:initNode(info)
	self.m_heroId = info.heroId
	self.m_paramTab = info.tab
	self.m_openDialog = info.openDialog
	if info.heroList then
		self.m_heroList = info.heroList
	else
		self.m_heroList = HeroManager:getAllHeroGotWithSort(nil, true)
	end

	for i , heroId in ipairs(self.m_heroList) do
		if heroId == self.m_heroId then
			self.m_curIndex = i
			break
		end
	end

	self.m_csNode = cc.Node:createFromCSFile("GameScene/NodeUI/HeroMain.csb")
	self:addChild(self.m_csNode)
	self.m_csNode:setToCenter()
	self.m_csNode:setPosition(cc.visible.center.x,cc.visible.center.y)
	self.m_csNode.you:setVisible(self.m_curIndex < #self.m_heroList)
	self.m_csNode.zuo:setVisible(self.m_curIndex > 1)

	-- 左侧按钮
	self:initTab()

	-- 宿命标签上的红点
	self.m_fateRedDot = GameUtil:createRedDotTo(self.m_csNode.teb5)

	self:refreshFateRedDot()
	self:refreshRefineRedDot()
end

function This:initTouchEvent()
	self.m_csNode.close:setTouchEnded(function()
		self:close()
	end)

	self:addTabButton(TabName.kEquip,self.m_csNode.teb1,function()
		print(TabName.kEquip)
		self:openTabNode(TabName.kEquip)
		self.m_curTab = TabName.kEquip
	end)
	self:addTabButton(TabName.kSkill,self.m_csNode.teb2,function()
		print(TabName.kSkill)
		self:openTabNode(TabName.kSkill)
		self.m_curTab = TabName.kSkill
	end)
	self:addTabButton(TabName.kArmType,self.m_csNode.teb3,function()
		print(TabName.kArmType)
		if HeroManager:isSoilderFuncOpen() then
			self:openTabNode(TabName.kArmType)
			self.m_curTab = TabName.kArmType
			return true
		else
			g_scene:showTips(string.format(Serialize[61122],kSoilderFuncOpenDay,MatchingConfig[kSoilderFuncOpenRank].rank_level))
			return false
		end
	end)
	self:addTabButton(TabName.kLegion,self.m_csNode.teb4,function()
		print(TabName.kLegion)
		if HeroManager:isDeputyFuncOpen() then
			self:openTabNode(TabName.kLegion)
			self.m_curTab = TabName.kLegion
			return true
		else
			g_scene:showTips(string.format(Serialize[61122],kDeputyFuncOpenDay,MatchingConfig[kDeputyFuncOpenRank].rank_level))
			return false
		end
	end)
	self:addTabButton(TabName.kFate,self.m_csNode.teb5,function()
		print(TabName.kFate)
		if HeroManager:isFateFuncOpen() then
			self:openTabNode(TabName.kFate)
			self.m_curTab = TabName.kFate
			return true
		else
			g_scene:showTips(string.format(Serialize[61296],kFateFuncOpenLevel))
			return false
		end
	end)
	self:addTabButton(TabName.kRefine,self.m_csNode.teb6,function()
		print(TabName.kRefine)
		if HeroManager:isRefineFuncOpen() then
			self:openTabNode(TabName.kRefine)
			self.m_curTab = TabName.kRefine
			return true
		else
			g_scene:showTips( HeroManager:getRefineLockTips() )
			return false
		end
	end)	
	self:addTabButton(TabName.kTactics,self.m_csNode.teb7,function()
		print(TabName.kTactics)
		local isOpen, tips = self:isTacticsFuncOpen()
		if isOpen then
			self:openTabNode(TabName.kTactics)
			self.m_curTab = TabName.kTactics
			return true
		else
			g_scene:showTips(tips)
			return false
		end
	end)	


	self.m_csNode.help:setTouchEnded(function()
		self:openDialog("UI.HelpTips",{text = Serialize["hero_panel_help_tips"],node = self.m_csNode.help})
	end)

	self.m_csNode.you:setTouchEnded(function()
		if self.m_curIndex < #self.m_heroList then
			self.m_curIndex = self.m_curIndex + 1
			self:showHero(self.m_heroList[self.m_curIndex])
			self.m_csNode.zuo:setVisible(self.m_curIndex > 0)
			self.m_csNode.you:setVisible(self.m_curIndex < #self.m_heroList)
			self:refreshFateRedDot()
			self:refreshRefineRedDot()
			self:refreshTacticsTab()
		end
	end)

	self.m_csNode.zuo:setTouchEnded(function()
		if self.m_curIndex > 0 then
			self.m_curIndex = self.m_curIndex - 1
			self:showHero(self.m_heroList[self.m_curIndex])
			self.m_csNode.zuo:setVisible(self.m_curIndex > 1)
			self.m_csNode.you:setVisible(self.m_curIndex < #self.m_heroList)
			self:refreshFateRedDot()
			self:refreshRefineRedDot()
			self:refreshTacticsTab()
		end
	end)

	local showCard = true
	self.m_csNode.attrBtn:setTouchEnded(function()
		showCard = not showCard
		if showCard then
			self:showHeroCard()
		else
			self:showHeroAttr()
		end	
	end)

	self.m_csNode.reset:setTouchEnded(function()
		local rank = MatchManager:getRankLv()
		if MatchingConfig[rank] and MatchingConfig[rank].reset > 0 then
			local hero = HeroManager:getHero(self.m_heroId)
			g_scene:openDialog("Hero.ResetPanel",hero)
		else
			local openRank = MatchManager:getHeroResetOpenRankLv()
			g_scene:showTips(string.format(Serialize[60446],MatchingConfig[openRank].rank_level))
		end
	end)

	self:selectTabButton(self.m_paramTab or TabName.kEquip)
	self:showHeroCard()
end

function This:onEnter()
	super.onEnter(self)
	HeroManager:addObserver(self)
	EquipManager:addObserver(self)
	FabaoManager:addObserver(self)
	RuneManager:addObserver(self)

	self.m_signalHandlers = {}
	self.m_signalHandlers[Signals.HeroPanelFateTabRedDot] = function(data)
		self:refreshFateRedDot()
	end
	SignalSystem.addSignalHandlers(self.m_signalHandlers)

	if self.m_openDialog then
		g_scene:openDialog(self.m_openDialog.name, self.m_openDialog.arg)
	end

	self:addListener("tactics_goto_get", function()
		self:close()
	end)
end

function This:onExit()
	super.onExit(self)
	HeroManager:removeObserver(self)
	EquipManager:removeObserver(self)
	FabaoManager:removeObserver(self)
	RuneManager:removeObserver(self)

	SignalSystem.removeSignalHandlers(self.m_signalHandlers)
end

function This:onTabNodeSwitchIn(node,name)
	if node then
		node:setModel(self.m_heroId)
	end
end

function This:createTabNode(name)
	if name == TabName.kEquip then
		return GrowTabNode:create(self.m_heroId)
	elseif name == TabName.kSkill then
		return SkillTabNode:create(self.m_heroId)
	elseif name == TabName.kArmType then
		return SoilderTabNode:create(self.m_heroId)
	elseif name == TabName.kLegion then
		return LegionTabNode:create(self.m_heroId)
	elseif name == TabName.kFate then
		return FateTabNode:create(self.m_heroId)
	elseif name == TabName.kRefine then
		return HeroRefineTabNode:create(self.m_heroId)
	elseif name == TabName.kTactics then
		return HeroTacticsTabNode:create(self.m_heroId)
	end
end

local TmpQualityFrameFile = 
{
	[Quality.kGreen] = "MenuScene/bheroqulity1.png",
	[Quality.kBlue] = "MenuScene/bheroqulity2.png",
	[Quality.kPurple] = "MenuScene/bheroqulity3.png",
	[Quality.kOrange] = "MenuScene/bheroqulity4.png",
}

function This:refreshHeroCard()
	local hero = HeroManager:getHero(self.m_heroId)
	-- local sound = hero:getSound()
	-- if sound then
	-- 	cc.Audio:playEffect(sound)
	-- end
	self.m_cardNode.ability:setString(math.floor(hero:getFightPower()))
	local quality = hero:getQuality()

	self.m_cardNode.country:setString(CountryName[hero:getCountry()])
	local color = CardQualityColor[quality]
	self.m_cardNode.country:setColor(color.r , color.g, color.b)
	self.m_cardNode.name:setString(hero:getName(), AppText:isChinese() and 15 or nil)

	if os.isWin32 then
		self.m_cardNode.level:setString(hero:getLevel() .. "ID:" .. hero:getId())
	else
		self.m_cardNode.level:setString(hero:getLevel())
	end

	self.m_cardNode.qualitybg:setImage(QualityBgFile[quality])
	self.m_cardNode.icon:setImage(hero:getIcon())
	self.m_cardNode.quality:setImage(QualityBigFrameFile[quality])
	-- self.m_cardNode.herofightbg:setImage(QualityFightPowerFrameFile[quality])

	local starLv = hero:getStarLv()
	for i = 1, 5 do
		self.m_cardNode["star"..i]:setVisible(starLv>=i)
	end
	self.m_cardNode.hp:setString(math.floor(hero:getAttr(AttrType.kMaxHp)))
	self:refreshAwak(self.m_cardNode)
end

function This:showHeroSound()
	local hero = HeroManager:getHero(self.m_heroId)
	local sound = hero:getSound()
	if sound then
		self.m_soundId = cc.Audio:playEffect(sound)
	end
end

function This:stopHeroSound()
	local hero = HeroManager:getHero(self.m_heroId)
	local sound = hero:getSound()
	if sound then
		cc.Audio:stopEffect(self.m_soundId)
	end
end

function This:refreshAwak(node)
	local hero = HeroManager:getHero(self.m_heroId)
	local heroEffect = false
	if hero:isAwaken() then
		node.xingdian:setVisible(true)
		local curentLv = hero:getAwakeLevel()
		if curentLv==0 then
			node.xingdian.light:setVisible(false)
		else
			node.xingdian.light:setVisible(true)
			for i=1,AwakdValue.ParagraphLimit do
				local item = node.xingdian.light["dian"..i]
				item:setVisible(curentLv>=i)
			end
		end
		heroEffect = hero:isAwakeFull()
	else
		node.xingdian:setVisible(false)
	end

	self:createWeakEffect( node.quality, heroEffect ,node.icon)
end

function This:createWeakEffect( node,isAdd,heroBg )
	local function createAnim( parent,anmStr )
        local GameUtil = require("Util.GameUtil")
        local effect1 = GameUtil:createEffect(anmStr, true)
        local scale =1.3
        effect1:setScale(scale)
        local x = 142
        local y = 160
        effect1:setPosition(x,y)
        -- print("xy",x,"  ",y,"scale",scale)
        parent:addChild(effect1)
        return effect1
    end
    local effectName = "JueXing5"
    node:removeAllChildren()
    if isAdd then
    	local effect = createAnim( node,effectName )
    end
end

function This:showHeroCard()
	if self.m_cardNode == nil then
		self.m_cardNode = cc.Node:createFromCSFile("GameScene/NodeUI/HeroCard.csb")
		self.m_csNode.left:addChild(self.m_cardNode)
		--屏蔽测试战力功能
		-- self.m_cardNode.qualitybg:setTouchEnded(function()
		-- 	local hero = HeroManager:getHero(self.m_heroId)
		-- 	hero:onFightPowerTestRequest()
		-- end)
		self:refreshHeroCard()
		self:showHeroSound()
	end
	self.m_cardNode:setVisible(true)
	if self.m_attrNode then
		self.m_attrNode:setVisible(false)
	end
	self.m_csNode.attrBtn.text:setString(Serialize[61297])
end

function This:refreshHeroAttr()
	if self.m_attrNode then
		self.m_attrNode:refresh()
	end
end

function This:refreshFateRedDot()
	local isOpen = HeroManager:isFateFuncOpen()
	if not isOpen then
		self.m_fateRedDot:setVisible(false)
		return
	end

	local show = false
	local fateInfo = HeroManager:getFateInfo()
	local fateList = fateInfo:getFateByHero(HeroManager:getHero(self.m_heroId))
	for _, fate in ipairs(fateList) do
		local state
		local totalLev = 0

		local level = fate:getLevel()
		local config = fate:getConfig()
		if config and config.numeral then
			totalLev = #config.numeral
		end
		if level <= 0 then
			state = fate:canActivate(self.m_heroId)
		else
			if level >= totalLev then
				state = false
			else
				state = fate:canUpgrade(nil, self.m_heroId)
			end
		end
		if state then
			show = true
			break
		end
	end

	self.m_fateRedDot:setVisible(show)
end

function This:showHeroAttr()
	if self.m_attrNode == nil then
		self.m_attrNode = AttrListNode:create(self.m_heroId)
		self.m_csNode.left:addChild(self.m_attrNode)
		self:refreshHeroAttr()
	end
	self.m_attrNode:setVisible(true)
	if self.m_cardNode then
		self.m_cardNode:setVisible(false)
	end
	self.m_csNode.attrBtn.text:setString(Serialize[61298])
end

function This:showHero(heroId)
	if self.m_heroId ~= heroId then
		self:stopHeroSound()
	end
	self.m_heroId = heroId
	if self.m_attrNode then
		local isVisible = self.m_attrNode:isVisible()
		self.m_attrNode:removeFromParent()
		self.m_attrNode = AttrListNode:create(self.m_heroId)
		self.m_csNode.left:addChild(self.m_attrNode)
		self.m_attrNode:setVisible(isVisible)
	end
	self:refreshHeroCard()
	self:showHeroSound()
	self:refreshHeroAttr()
	local tab = self:getCurSelectTab()
	local node = self:getTabNode(tab)
	node:setModel(self.m_heroId)
end

-----------------------------------------------------------------------------

function This:onUpgradeStarLv(heroId)
	if self.m_heroId == heroId then
		self:refreshHeroCard()
		g_scene:openDialog("Hero.UpgradeStarPanel",{heroId = self.m_heroId})
	end
end

function This:onUpgradeLevel(heroId)
	if self.m_heroId == heroId then
		self:refreshHeroCard()
		self:refreshHeroAttr()
		self:refreshTacticsTab()
		local effect = nil
		effect = GameUtil:createEffect("KaPaiShengJi",false,nil,{
			onAnimationComplete = function()
				effect:removeFromParent()
			end
		})
		g_scene:showTips(Serialize[61257])
		local w , h = self.m_cardNode.quality:getContentSize()
		local x , y = self.m_cardNode.quality:convertToWorldSpace(w/2,h/2)
		effect:setPosition(x,y)
		self:addChild(effect)
	end
end

function This:onUpgradeQuality(heroId)
	if self.m_heroId == heroId then
		self:refreshHeroCard()
		self:openDialog("Hero.UpgradeQualityPanel",{heroId = self.m_heroId})
	end
end

function This:onDeputyChanged(heroId)
	if self.m_heroId == heroId then
		self:refreshHeroCard()
	end
end

function This:onEquipChanged(heroId)
	if self.m_heroId == heroId then
		self:refreshHeroCard()
		self:refreshFateRedDot()
	end
end

function This:onAddAttrPoint(heroId)
	if self.m_heroId == heroId then
		self:refreshHeroCard()
		self:refreshHeroAttr()
	end
end

function This:onClearAttrPoint(heroId)
	if self.m_heroId == heroId then
		self:refreshHeroCard()
		self:refreshHeroAttr()		
	end
end

function This:onTrainSoilder(heroId)
	if self.m_heroId == heroId then
		self:refreshHeroAttr()	
		self:refreshHeroCard()		
	end
end

function This:onUpPhaseSoilder(heroId)
	if self.m_heroId == heroId then
		self:refreshHeroAttr()	
		self:refreshHeroCard()		
	end
end

function This:onAttachSoilder(heroId)
	if self.m_heroId == heroId then
		self:refreshHeroAttr()	
		self:refreshHeroCard()	
	end	
end

function This:onUpdateSoilderAttr()
	self:refreshHeroAttr()	
	self:refreshHeroCard()	
end

function This:onStrengthLevel(uid)
	local equip = EquipManager:getEquip(uid)
	if equip:getHeroId() == self.m_heroId then
		self:refreshHeroAttr()
		self:refreshHeroCard()
	end
end

function This:onEquipUpLevel(uid)
	local equip = EquipManager:getEquip(uid)
	if equip:getHeroId() == self.m_heroId then
		self:refreshHeroAttr()
		self:refreshHeroCard()
	end
end

function This:onEquipUpgradeQuality(uid)
	self:onStrengthLevel(uid)
end

function This:onHeroReset(hero)
	if self.m_heroId == hero:getId() then
		self:refreshHeroAttr()
		self:refreshHeroCard()	
	end
end

function This:onGetForceAwake( ... )
    self:onHeroReset(...)
end

function This:onEquipPsvSkill(solt)
	if solt:getHero():getId() == self.m_heroId then
		self:refreshHeroAttr()
		self:refreshHeroCard()	
	end
end

function This:onTransPsvSkill(sheroId, theroId)
	if sheroId == self.m_heroId or theroId == self.m_heroId then
		self:refreshHeroAttr()
		self:refreshHeroCard()	
	end
end

function This:onUpgradeSaintLev()
	self:refreshHeroAttr()
	self:refreshHeroCard()	
end

function This:onFabaoDataChanged(fabaoUid)
	local fabao = FabaoManager:getFabao(fabaoUid)
	if fabao:isEquipped() then
		local hero = HeroManager:getHeroByUid(fabao:getHeroUid())
		if hero:getId() == self.m_heroId then
			self:refreshHeroAttr()
			self:refreshHeroCard()
		end
	end
end

function This:onPlayerAttrChanged(field, lastValue, value)
	if field == PlayerAttr.level and lastValue ~= value then
		self:refreshFateRedDot()
	end
end

function This:onRefineWearReply()
	self:refreshHeroAttr()
	self:refreshHeroCard()
	self:refreshRefineRedDot()
end

function This:onRefineUpgradeReply()
	self:refreshHeroAttr()
	self:refreshHeroCard()
	self:refreshRefineRedDot()
end

function This:onRefineOneKeyWearReply()
	self:refreshHeroAttr()
	self:refreshHeroCard()
	self:refreshRefineRedDot()
end

function This:refreshRefineRedDot()
	local isOpen = HeroManager:isRefineFuncOpen()
	if not isOpen then
		GameUtil:refreshRedDot(self.m_csNode.teb6, false)
		return
	end	

	local hero = HeroManager:getHero(self.m_heroId)
	local refine = hero:getRefine()
	local isShow = refine:isRedDot()
	GameUtil:refreshRedDot(self.m_csNode.teb6, isShow)
end
This.onRuneModify = This.onUpdateSoilderAttr


function This:initTab()
	local csNode = self.m_csNode
	local tabList = {}

	-- 记录最原始的位置
	for i=1, TabNum do
		local node = csNode[string.format("teb%d", i)]
		local x, y = node:getPosition()
		tabList[i] = {node = node, x = x, y = y}
	end
	table.sort(tabList, function (a, b)
		return a.y > b.y
	end)
	self.m_tabList = tabList

	-- 锁
	csNode.teb4.lock:setVisible(not HeroManager:isDeputyFuncOpen())
	csNode.teb3.lock:setVisible(not HeroManager:isSoilderFuncOpen())
	csNode.teb5.lock:setVisible(not HeroManager:isFateFuncOpen())
	csNode.teb6.lock:setVisible(not HeroManager:isRefineFuncOpen())	
	self:refreshTacticsTab(false)

	self:refreshTabPos()
end

-- tab按钮排序
function This:refreshTabPos()
	local idx = 1
	local tabList = self.m_tabList
	for _, info in ipairs(tabList) do
		local node = info.node
		if node:isVisible() then
			node:setPosition(tabList[idx].x, tabList[idx].y)
			idx = idx + 1
		end
	end
end

-- 战法
function This:isTacticsFuncOpen()
	local hero = HeroManager:getHero(self.m_heroId)
	local tactics = hero:getTactics()
	return tactics:isTacticsFuncOpen(), tactics:getTacticsLockTips()
end

function This:refreshTacticsTab(isRefreshPos)
	local csNode = self.m_csNode
	local hero = HeroManager:getHero(self.m_heroId)
	local tactics = hero:getTactics()

	csNode.teb7:setVisible( tactics:isHasTacticsSystem() )
	csNode.teb7.lock:setVisible(not tactics:isTacticsFuncOpen())	
	GameUtil:refreshRedDot(csNode.teb7, tactics:isRedDot())

	if isRefreshPos ~= false then
		self:refreshTabPos()
	end
end

function This:onTacticsChanged()
	self:refreshHeroAttr()
	self:refreshHeroCard()	
	self:refreshTacticsTab()
end

function This:onOpen()
    self.m_isOpen = true
    self:initTouchEvent()
    if self.m_tabButtons then
        for name,button in pairs(self.m_tabButtons) do
            if not button.m_touch then
                button:setTouch({
                	isDynamic = true,
                    onEnded = function ()
                        self:selectTabButton(name)
                    end
                })
            end
        end
    end
    if self.m_openCallback then
        for _, callback in ipairs(self.m_openCallback) do
            callback()
        end
    end
    EventDispatcher:dispatcher("dialog_open",self)
	self.name = "dialog"
	g_weakTable[tostring(self)] = self
end