--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"Base.BaseModel")
local PassiveSkillConfig = require("Metadatas.PassiveSkillConfig")
local PassiveSkillTakeConfig = require("Metadatas.PassiveSkillTakeConfig")
local ItemUtil = require("Bag.ItemUtil")
local HeroConfig = require("Metadatas.HeroConfig")
local DepotManager = require("Depot.DepotManager")
local HeroManager = require("Hero.HeroManager")

function This:init(id)
	self.m_id = id
	self.m_config = PassiveSkillConfig[id]
	self.m_config2 = PassiveSkillTakeConfig[id]
	self.m_heroUids = {}
	self.m_isActive = {}
	self.m_heroCount = 0
end

function This:getId()
	return self.m_id
end

function This:getType()
	return self.m_config2.type
end

function This:getSkillBookId()
	return self.m_id
end

function This:getSkillIcon()
	return ItemUtil.getIconImage(self.m_id)
end

function This:getIcon()
	return ItemUtil.getIconImage(self.m_id)
end

function This:getName()
	return ItemUtil.getName(self.m_id)
end

function This:getDescripe()
	return ItemUtil.getComment(self.m_id)
end

function This:getConfig()
	return self.m_config
end

function This:getHeroCount()
	return self.m_heroCount
end

function This:isCanEquiped(hero)
	if self.m_heroUids[hero:getUid()] then
		return false, Serialize[61300]
	end
	local isHas = false
	for i = 1, 4 do
		local solt = hero:getSoltByPos(i)
		if solt:isUnlock() then
			isHas = true
			break
		end
	end
	if not isHas then
		return false, Serialize[61301]
	end
	if DepotManager:getItemCount(self.m_id) <= 0 then
		return false, Serialize[61302]
	end

	if self.m_heroCount >= self:getMaxCanEquipNum() then
		return false, Serialize[61303]
	end
	return true
end

function This:getHerosEquiped()
	local result = {}
	for uid , _ in pairs(self.m_heroUids) do
		local hero = HeroManager:getHeroByUid(uid)
		table.insert(result,hero)
	end
	return result
end

function This:resetHero(hero)
	local uid = hero:getUid()
	self.m_isActive[uid] = nil
end

function This:setIsActive(isActive,hero)
	local uid = hero:getUid()
	if not self.m_isActive[uid] and isActive then
		-- local attrList = self:getAttrList()
		-- for i , info in ipairs(attrList) do
		-- 	if info.attrId == 7 then
		-- 		assert(true)
		-- 	end
		-- 	if self.m_config2.if_level == 1 then
		-- 		hero:addAttr(info.attrId, info.value * hero:getLevel())
		-- 	else
		-- 		hero:addAttr(info.attrId, info.value)
		-- 	end
		-- end
		self.m_isActive[uid] = true
	elseif self.m_isActive[uid] and not isActive then
		-- local attrList = self:getAttrList()
		-- for i , info in ipairs(attrList) do
		-- 	if info.attrId == 7 then
		-- 		assert(true)
		-- 	end
		-- 	if self.m_config2.if_level == 1 then
		-- 		hero:reduceAttr(info.attrId, info.value * hero:getLevel())
		-- 	else
		-- 		hero:reduceAttr(info.attrId, info.value)
		-- 	end
		-- end
		self.m_isActive[uid] = nil
	end
end

function This:addHero(hero)
	local uid = hero:getUid()
	if not self.m_heroUids[uid] then
		self.m_heroUids[uid] = true
		self.m_heroCount = self.m_heroCount + 1
	end
end

function This:removeHero(hero)
	local uid = hero:getUid()
	if self.m_heroUids[uid] then
		self.m_heroUids[uid] = nil
		self.m_heroCount = self.m_heroCount - 1
	end
end

function This:isHeroEquiped(heroUid)
	return self.m_heroUids[heroUid] ~= nil
end

function This:isOwned()
	return DepotManager:getItemCount(self.m_config.passive_id) > 0
end

function This:getAttrList()
	local result = {}
	for i , attrId in ipairs(self.m_config2.arg) do
		local value = self.m_config2.num[i]
		table.insert(result,{attrId = attrId, value = value})
	end
	return result
end


function This:isHaveRate()
	return self.m_config2.if_level == 1
end

function This:getAttrKeyList()
	if not self.m_attrListKey then
		local result = {}
		for i , attrId in ipairs(self.m_config2.arg) do
			local value = self.m_config2.num[i]
			result[attrId] = value
		end
		self.m_attrListKey = result
	end
	return self.m_attrListKey
end

function This:isAttrSame(skill)
	local config = skill:getConfig()
	if #config.arg ~= self.m_config2.arg then
		return false
	end
	for i , attrId in ipairs(self.m_config2.arg) do
		if attrId ~= config.arg[i] then
			return false
		end
	end
	return true
end

function This:isRecommand(heroId)
	for i , id in ipairs(HeroConfig[heroId].recommend_skill) do
		if id == self.m_id then
			return true
		end
	end
	return false
end

function This:getMaxCanEquipNum()
	return self.m_config.equipment_num
end

function This:getQuality()
	return self.m_config2.quality
end

function This:isLowLevel()
	return self.m_config2.quality == 1
end

function This:isHighLevel()
	return self.m_config2.quality == 2
end

function This:getFightPowerFactor()
	return self.m_config2.coefficient
end


--endregion
