-- @Author: Su
-- @Date:   2019-04-09 10:46:07
-- @Last Modified by:   Su-
-- @Last Modified time: 2019-04-09 10:46:07
-- @File Name: HeroSetCollocationPanel.lua
-- @Description: 

local This , super = class(...,"Dialog")

function This:initNode(info)
    self.m_hero = info.hero
    self.m_data = info.data
    self.m_csNode = cc.Node:createFromCSFile("GameScene/NodeUI/HeroSetCollocation.csb")
    self:addChild(self.m_csNode)
    self.m_csNode:setToCenter()
    
    self.m_leftPoint = 0
    self.m_addPoint = self.m_data:getAddPoint()
    self:refresh()
end

function This:initTouchEvent()
    local node = self.m_csNode
    node.quxiao:setTouchEnded(function()
        self:close()
    end)

    node.baocun:setTouchEnded(function()
        if self.m_leftPoint > 0 then
            return
        end
        self.m_data:setAddPoint(self.m_addPoint)
        self:close()
    end)

    node.tuijian:setTouchEnded(function()
        self.m_leftPoint = 0
        self.m_addPoint = self.m_data:getDefaultAddPoint()
        self:refresh()
    end)

    for i = 1, 4 do
		self.m_csNode["item"..i].addlight:setTouch({
			onEnded = function()
				self:addAttrPoint(i)
			end,
			isScale = false,
		})
		self.m_csNode["item"..i].jianlight:setTouch({
			onEnded = function()
				self:reduceAttrPoint(i)
			end,
			isScale = false,
		})
    end
end

function This:addAttrPoint(index)
    if self.m_leftPoint > 0 then
        self.m_addPoint[index] = self.m_addPoint[index] + 1
        self.m_leftPoint = self.m_leftPoint - 1
		self:refresh()        
    end
end

function This:reduceAttrPoint(index)
	if self.m_addPoint[index] > 0 then
		self.m_addPoint[index] = self.m_addPoint[index] - 1
		self.m_leftPoint = self.m_leftPoint + 1
		self:refresh()
	end
end

function This:refresh()
    for i=1,4 do
        local itemNode = self.m_csNode["item"..i] 
        itemNode.changecount:setString(self.m_addPoint[i])
        if self.m_addPoint[i] <= 0 then
            itemNode.jianlight:setGrayShader()
        else
            itemNode.jianlight:clearShader()
        end
        if self.m_leftPoint <= 0 then
            itemNode.addlight:setGrayShader()
        else
            itemNode.addlight:clearShader()
        end
    end
    if self.m_leftPoint > 0 then
        self.m_csNode.baocun:setGrayShader()
    else
        self.m_csNode.baocun:clearShader()
    end
end