--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"cc.Node")
local HeroManager = require("Hero.HeroManager")
local Serialize = require("Serialize.Serialize")
local StageManager = require("Stage.GameStageManager")

function This:init(primaryId,heroId)
	self.m_primaryId = primaryId
	self.m_heroId = heroId
	self.m_csNode = cc.Node:createFromCSFile("GameScene/NodeUI/HeroLegionTips.csb")
	local w , h = self.m_csNode.qualitybg:getContentSize()
	local scale = self.m_csNode.qualitybg:getScale()
	w = scale * w
	h = scale * h
	self:setContentSize(w,h)
	self:addChild(self.m_csNode)

	--local layer = cc.LayerColor:create(cc.Color(255,255,0,255))
	--layer:setContentSize(w, h)
	--self:addChild(layer)

	self:initAttr()
end

function This:initAttr()
	self:refreshAttr()
	self.m_csNode.close:setVisible(false)
end

function This:refreshAttr()
	local primary = HeroManager:getHero(self.m_primaryId)
	local hero = HeroManager:getHero(self.m_heroId)
	local quality = hero:getQuality()

	self.m_csNode.country:setString(CountryName[hero:getCountry()])
	local color = SmallCardQualityColor[quality]
	self.m_csNode.country:setColor(color.r , color.g, color.b)

	self.m_csNode.name:setString(hero:getName(), AppText:isChinese() and 10 or nil)
	self.m_csNode.level:setString(hero:getLevel())
	self.m_csNode.icon:setImage(hero:getIcon())
	self.m_csNode.quality:setImage(QualityFrameFile[quality])
	self.m_csNode.qualitybg:setImage(QualityBgFile[quality])
	-- self.m_csNode.herofightbg:setImage(QualityFightPowerFrameFile[quality])
	
	self.m_csNode.statebg:setVisible(false)

	self.m_csNode.isfetter:setVisible(primary:isFetterHero(self.m_heroId))
	for i = 1 , 5 do
		self.m_csNode["star"..i]:setVisible(hero:getStarLv() >= i)
	end
end

function This:showFlag()
	local primary = HeroManager:getHero(self.m_primaryId)
	local hero = HeroManager:getHero(self.m_heroId)
	local state = hero:getState()
	if primary:isRecommended(self.m_heroId) then
		self.m_csNode.statebg:setVisible(true)
		if hero:isDeputy() then
			self.m_csNode.statebg.state1:setString(Serialize[61335])
		elseif not hero:isGot() then
			self.m_csNode.statebg.state1:setString(Serialize[61336])
		elseif StageManager:isInEmbattle(self.m_heroId) then
			self.m_csNode.statebg.state1:setString(Serialize[61337])
		elseif hero:isPrimary() then
			self.m_csNode.statebg.state1:setString(Serialize[61338])
		elseif state ~= HeroState.kInFree then
			self.m_csNode.statebg.state1:setString(HeroStateDesp[state])
		else
			self.m_csNode.statebg:setVisible(false)
		end
	else
		self.m_csNode.statebg:setVisible(false)
	end
end

function This:initTouchEvent()
end

function This:refreshNode(heroId)
	self.m_heroId = heroId
	self:refreshAttr()
end

function This:setModel(hero)
	self.m_heroId = hero:getId()
	self:refreshAttr()
end

function This:onEnter()
	super.onEnter(self)
	self:initTouchEvent()
end

function This:onExit()
	super.onExit(self)
end

function This:setCancelHandler(handler)
	self.m_csNode.close:setVisible(true)
	self.m_csNode.close:setTouchEnded(function()
		if handler then
			handler(self.m_heroId)
		end
	end)
end

function This:setSelectHandler(handler,isRecommand)
	self:setTouch({
		isContainer = not isRecommand,
		isDynamic = true,
		onEnded = function ()
			handler(self.m_heroId)
		end,
		isScale = false
	})
end 

--endregion
