--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"Dialog")
local DepotManager = require("Depot.DepotManager")
local UniversalConfig = require("Metadatas.UniversalConfig")
local HeroManager = require("Hero.HeroManager")
local GameUtil = require("Util.GameUtil")
local ItemConfig = require("Metadatas.ItemConfig")
local ItemUtil = require("Bag.ItemUtil")

function This:initNode(hero)
	self.m_hero = hero
	self.m_csNode = cc.Node:createFromCSFile("GameScene/NodeUI/HeroExchange.csb")
	self:addChild(self.m_csNode)
	self.m_csNode:setToCenter()
	self.m_curCount = 0
	
	self.m_itemId = 121
	local quality = self.m_hero:getQuality()
	self.m_csNode.wannengbg.icon:setImage(ItemUtil.getIconImage(self.m_itemId))
	self.m_csNode.wannengbg.bg:setImage(ItemUtil.getQualityImage(self.m_itemId))
	local itemConfig = ItemConfig[self.m_itemId]
	self.m_csNode.wannengbg.name:setColor(QualityColor[itemConfig.quality].r, QualityColor[itemConfig.quality].g, QualityColor[itemConfig.quality].b)

	local pieceId = self.m_hero:getId() + 10000
	self.m_csNode.wujiangbg.icon:setImage(ItemUtil.getIconImage(pieceId))
	self.m_csNode.wujiangbg.bg:setImage(ItemUtil.getQualityImage(pieceId))
	self.m_csNode.wujiangbg.name:setString(self.m_hero:getName() .. Serialize[61345])
	self.m_csNode.wujiangbg.name:setColor(QualityColor[quality].r, QualityColor[quality].g, QualityColor[quality].b)
	self.m_price = UniversalConfig[self.m_itemId * 100 + quality].exchange_count 
	self.m_csNode.text:setString(string.format(Serialize[61346],self.m_price))
	self:refresh()
end

function This:refresh()
	local quality = self.m_hero:getQuality()
	self.m_totalCount = DepotManager:getItemCount(self.m_itemId)
	self.m_maxPieceCount = math.floor(self.m_totalCount / self.m_price)

	self.m_csNode.wannengbg.num:setString(string.format("%d/%d",self.m_curCount * self.m_price,self.m_totalCount))
	self.m_csNode.changecount:setString(self.m_curCount)
	self.m_csNode.wujiangbg.num:setString(self.m_curCount)
	if self.m_maxPieceCount <= 0 then
		self.m_csNode.exchange:setGrayShader()
	else
		self.m_csNode.exchange:resetToNormalShader()
	end
end

function This:initTouchEvent()
	self.m_csNode.close:setTouchEnded(function()
		self:close()
	end)
	self.m_csNode.reduce:setTouchEnded(function()
		if self.m_curCount > 0 then
			self.m_curCount = self.m_curCount - 1
			self:refresh()
		end
	end)
	self.m_csNode.increase:setTouchEnded(function()
		if self.m_maxPieceCount <= 0 then
			g_scene:showTips(Serialize[61130])
		elseif self.m_curCount < self.m_maxPieceCount then
			self.m_curCount = self.m_curCount + 1
			self:refresh()
		else
			g_scene:showTips(Serialize[61129])
		end
	end)

	self.m_csNode.jia10:setTouchEnded(function()
		if self.m_maxPieceCount <= 0 then
			g_scene:showTips(Serialize[61130])
		elseif self.m_curCount >= self.m_maxPieceCount then
			g_scene:showTips(Serialize[61129])
		elseif self.m_curCount + 10 > self.m_maxPieceCount then
			self.m_curCount = self.m_maxPieceCount
			--g_scene:showTips(Serialize[61130])
		else
			self.m_curCount = self.m_curCount + 10
		end
		self:refresh()
	end)

	self.m_csNode.Max:setTouchEnded(function()
		if self.m_maxPieceCount <= 0 then
			g_scene:showTips(Serialize[61130])
		elseif self.m_curCount >= self.m_maxPieceCount then
			g_scene:showTips(Serialize[61129])
		else
			self.m_curCount = self.m_maxPieceCount
		end
		self:refresh()
	end)


	self.m_csNode.exchange:setTouchEnded(function()
		if self.m_curCount > 0 then
			HeroManager:onExchangePiecesRequest(self.m_hero:getId(),self.m_curCount * self.m_price)
		elseif self.m_maxPieceCount > 0 then
			g_scene:showTips(Serialize[61131])
		else
			g_scene:showTips(Serialize[61347])
		end
	end)
end

function This:onEnter()
	super.onEnter(self)
	HeroManager:addObserver(self)
end

function This:onExit()
	super.onExit(self)
	HeroManager:removeObserver(self)
end

function This:onExchangePiece()
	local str = string.format(Serialize[61348],self.m_hero:getName(),self.m_curCount)
	g_scene:showTips(str)
	--self.m_curCount = 0
	--self:refresh()
	self:close()
end

--endregion
