--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"Dialog")
local ItemNode = require("UI.ItemNode")

function This:initNode(info)
	self.m_solt = info.slot
	self.m_isLearMode = info.learnMode
	self.m_psv = self.m_solt:getPsvSkill()
	self.m_csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/PassiveDescribe.csb")
	self:addChild(self.m_csNode)
	self.m_csNode:setToCenter()

	local itemView = ItemNode:create(self.m_psv:getId(), nil, nil, false)
	self.m_csNode.item:addChild(itemView)
	itemView:setPosition(-50, -50)
	self:refresh()
end

function This:refresh()
	self.m_csNode.title:setString(self.m_psv:getName())
	self.m_csNode.des:setString(self.m_psv:getDescripe(),530)
	local heroList = self.m_psv:getHerosEquiped()
	local total = self.m_psv:getMaxCanEquipNum()
	local str = Serialize[61350]
	for i , hero in ipairs(heroList) do
		str = str .. hero:getName()
		if i ~= #heroList then
			str = str .. "、"
		end
	end
	str = str .. string.format("(%d/%d)",#heroList,total)
	self.m_csNode.yizhuangbei:setString(str,620)
	self:refreshButton()
end

function This:initTouchEvent()
    if not self.m_inited then 
    	local csNode = self.m_csNode
    	if csNode.button then
    		csNode.button:setTouchEnded(function ()
				local isLocked, hasLock = self.m_solt:hasLuckyLock() 
    			if isLocked then
					g_scene:openDialog("UI.ConfirmPanel", {
                        richText = string.format(Serialize[61351], self.m_psv:getName()),
                        okHandler = function ()
    						self.m_solt:unlock()
    						self:close()
    						return
                        end
                    })
    			elseif not hasLock then
					g_scene:openDialog("UI.ConfirmPanel", {
                        richText = string.format(Serialize[61352], self.m_psv:getName()),
                        okHandler = function ()
    						self.m_solt:lock()
    						self:close()
    						return
                        end
                    })
    			end
    		end)
    	end
    	self.m_inited = false
    end
end

function This:refreshButton()
	if not self.m_isLearMode then return end
	local csNode = self.m_csNode
	if not csNode.button then
		return
	end
	
	local isLocked, hasLock = self.m_solt:hasLuckyLock()
	print_tmp({self.m_solt:getIndex(), self.m_solt:getHero():getPsvSlotLock(), isLocked})
	if isLocked then
		csNode.button:setVisible(true)
		csNode.tips:setVisible(false)
		csNode.button.text:setString(Serialize[60377])
	elseif hasLock then
		csNode.button:setVisible(false)
		csNode.tips:setVisible(true)
	else
		csNode.button:setVisible(true)
		csNode.tips:setVisible(false)	
		csNode.button.text:setString(Serialize[61353])
	end
end

function This:onTouchMask()
	self:close()
end

--endregion
