--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"Dialog")
local HeroManager = require("Hero.HeroManager")
local RankListLayer = require("Rank.RankListLayer")
local PsvHeroView = require("Hero.PsvHeroView")
local PsvSkillView = require("Hero.PsvSkillView")
local PassiveSkillConfig = require("Metadatas.PassiveSkillConfig")
local PassiveSkillTakeConfig = require("Metadatas.PassiveSkillTakeConfig")
local PsvSoltView = require("Hero.PsvSoltView")
local GameUtil = require("Util.GameUtil")
local DepotManager = require("Depot.DepotManager")
local GamePlayer = require("Player.GamePlayer")
local GameSetting = require("GameSetting")
local ItemUtil = require("Bag.ItemUtil")
local ItemNode = require("UI.ItemNode")
local ArgConfig = require("Metadatas.ArgConfig")

local TabName = 
{
	kCommon = 1,
	kHighLv = 2,
	kRecommand = 3,
}

This.IsShowLearnTips = {}

function This:initNode(info)
	HeroManager:onGetHeroPsvScoreRequest()
	self.m_lockSoldHeroId ={}
	self.m_curHero = info.hero
	self.m_isShowDeputy = true
	self.m_isShowHaveBook = false
	self.m_csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/HeroPassiveSkill.csb")
	self:addChild(self.m_csNode)
	self.m_csNode:setToCenter()

	self.m_heroList = self:getHeroList()
	self.m_listLayer = RankListLayer:create({
		itemWidth = 220,
		itemHeight = 52,
		itemCount = #self.m_heroList,
		frameCount = #self.m_heroList,
		column = 1,
		spaceX = 0,
		scrollView = self.m_csNode.hero.scrollview,
	})
	self.m_listLayer:setAnchorPoint(0.5,0)
	local w , h = self.m_listLayer:getContentSize()
	self.m_csNode.hero.scrollview:pushBackCustomItem(self.m_listLayer, w,h,0)
	self:refreshHeroViewList(self.m_heroList)

	self.m_csNode.book.gouxuan:setVisible(self.m_isShowHaveBook)

	self:addTabButton(TabName.kCommon, self.m_csNode.book.button1, function()
		self.m_tab = TabName.kCommon
		self.m_curSkill = nil
		if self.m_curSkillView then
			self.m_curSkillView:setSelect(false)
			self.m_curSkillView = nil
		end
		self:refreshSkillList()
	end)
	self:addTabButton(TabName.kHighLv, self.m_csNode.book.button2, function()
		self.m_tab = TabName.kHighLv
		self.m_curSkill = nil
		if self.m_curSkillView then
			self.m_curSkillView:setSelect(false)
			self.m_curSkillView = nil
		end
		self:refreshSkillList()
	end)
	self:addTabButton(TabName.kRecommand, self.m_csNode.book.button3, function()
		self.m_tab = TabName.kRecommand
		self.m_curSkill = nil
		if self.m_curSkillView then
			self.m_curSkillView:setSelect(false)
			self.m_curSkillView = nil
		end
		self:refreshSkillList()
	end)

	self.m_soltViewList = {}
	for i = 1, 6 do
		local solt = self.m_curHero:getSoltByPos(i)
		local soltView = PsvSoltView:create(solt, true)
		self.m_csNode.learn["skill"..i]:addChild(soltView)
		self.m_soltViewList[i] = soltView
	end
	self:selectTabButton(TabName.kRecommand)
end

function This:initTouchEvent()
	self.m_csNode.close:setTouchEnded(function()
		-- local isLocked, hasLock = solt:hasLuckyLock()
		-- if isLocked then
		-- 	local heroId = self.m_curHero:getId()
		-- 	self.m_lockSoldHeroId[heroId] = true
		-- end
		local function unlockSoild(heroId)
			local hero = HeroManager:getHero(heroId)
			if hero then
				for i , view in ipairs(self.m_soltViewList) do
					local solt = hero:getSoltByPos(i)
					solt:unlock()
				end
			end
		end
		for heroId,value in pairs(self.m_lockSoldHeroId) do
			unlockSoild(heroId)
		end
		self:close()
	end)
	self.m_csNode.hero.weigouxuan:setTouchEnded(function()
		self.m_isShowDeputy = not self.m_isShowDeputy
		if self.m_curHero:isDeputy() then
			local heroList = self:getHeroList()
			self.m_curHero = heroList[1]
			self.m_curHeroView:setSelect(false)
			self.m_curHeroView = nil
			self:refreshHeroViewList(heroList)
			self:refreshSkillList()
			self:refreshHeroSolt()
		else
			self:refreshHeroViewList()
		end
		self.m_csNode.hero.gouxuan:setVisible(self.m_isShowDeputy)
	end)
	self.m_csNode.book.weigouxuan:setTouchEnded(function()
		if self.m_isShowHaveBook and self.m_curSkill and self.m_curSkill:isOwned() then
			if self.m_curSkillView then
				self.m_curSkillView:setSelect(false)
			end
			self.m_curSkill = nil
			self.m_curSkillView = nil
		end
		self.m_isShowHaveBook = not self.m_isShowHaveBook
		self:refreshSkillList()
		self.m_csNode.book.gouxuan:setVisible(self.m_isShowHaveBook)
	end)
	self.m_csNode.learn.xuexibutton:setTouchEnded(function()
		if not self.m_curSkill then
			g_scene:showTips(Serialize[61356])
			return
		end
		local result , reason = self.m_curSkill:isCanEquiped(self.m_curHero)
		if not result then
			g_scene:showTips(reason)
			return
		end

		local lockIndex = self.m_curHero:getPsvSlotLock()
		local hasLuckLock = lockIndex and lockIndex > 0
		local tipsKey = hasLuckLock and "lock" or "unlock" 
		local costItem

		if hasLuckLock then
			costItem = self.m_skillLockItemInfo
			local itemId, count = unpack(costItem)
			local curLockItemNum = DepotManager:getItemOrResCount(itemId)
			if curLockItemNum < count then
				costItem = self.m_skillLockItemCostInfo
				itemId, count = unpack(costItem)
			end
			tips = string.format(Serialize[61357], count, ItemUtil.getName(itemId))
		end

		if self.IsShowLearnTips[tipsKey] ~= false then
			self:openDialog("Hero.PsvLearnTips",{
				hero = self.m_curHero,
				skill = self.m_curSkill,
				key = tipsKey,
				hasLuckLock = hasLuckLock,
				tips = tips,
				costItem = costItem,
			})
		else
			if not hasLuckLock then
				lockIndex = nil
			end
			HeroManager:onEquipPsvSkillRequest(self.m_curSkill:getId(), self.m_curHero:getUid(), lockIndex)
		end
	end)
	self.m_csNode.learn.wenhao:setTouchEnded(function()
		g_scene:openDialog("UI.HelpTips",{text = Serialize[61358],node = self.m_csNode.learn.wenhao})
	end)
end

function This:getPsvSkillList()
	local result = {}
	for i, config in pairs(PassiveSkillConfig) do
		local passiveId = config.passive_id
		local PassiveSkillTakeConfigItem = PassiveSkillTakeConfig[passiveId]
		if passiveId > 0 and PassiveSkillTakeConfigItem and PassiveSkillTakeConfigItem.quality > 0 then
			local skill = HeroManager:getPsvSkill(passiveId)
			if not self.m_isShowHaveBook  or (self.m_isShowHaveBook and skill:isOwned()) then 
				if self.m_tab == TabName.kCommon and config.quality==1 then
					table.insert(result,skill)
				elseif self.m_tab == TabName.kHighLv and config.quality==2 then
					table.insert(result,skill)
				elseif self.m_tab == TabName.kRecommand and skill:isRecommand(self.m_curHero:getId()) then
					table.insert(result,skill)
				end
			end
		end
	end
	local uid = self.m_curHero:getUid()
	table.sort(result,function(a,b)
		local aIsEquip = a:isHeroEquiped(uid)
		local bIsEquip = b:isHeroEquiped(uid)
		if aIsEquip and not bIsEquip then
			return true
		end
		local aIsOwned = a:isOwned()
		local bIsOwned = b:isOwned()
		if aIsEquip and bIsEquip and aIsOwned and not bIsOwned then
			return true
		end
		if aIsEquip and bIsEquip and aIsOwned and bIsOwned then
			return a:getQuality() < b:getQuality()
		end
		if aIsEquip and bIsEquip and not aIsOwned and not bIsOwned then
			return a:getQuality() < b:getQuality()
		end
		if not aIsEquip and not bIsEquip and aIsOwned and not bIsOwned then
			return true
		end
		if not aIsEquip and not bIsEquip and aIsOwned and bIsOwned then
			return a:getQuality() < b:getQuality()
		end
		if not aIsEquip and not bIsEquip and not aIsOwned and not bIsOwned then
			return a:getQuality() < b:getQuality()
		end 
		return false
	end)
	return result
end

function This:getHeroList()
	local list = HeroManager:getAllHeroGotWithSort(function(hero)
		if not hero:isDeputy() then
			return true
		end
		return false
	end)
	local tmp = {}
	if self.m_isShowDeputy then
		for i , hero in ipairs(list) do
			table.insert(tmp,hero)
			local deputy = hero:getDeputyHeros()
			for j , id in pairs(deputy) do
				local o = HeroManager:getHero(id)
				table.insert(tmp,o)
			end
		end
		return tmp
	end
	return list
end

function This:getHeroView(hero)
	local view = PsvHeroView:create(hero)
	view:setSelectHandler(function(o)
		self.m_curHero = o
		if self.m_curHeroView then
			self.m_curHeroView:setSelect(false)
		end
		self.m_curHeroView = view
		self.m_curHeroView:setSelect(true)

		self:refreshSkillList()
		self:refreshHeroSolt()
	end)
	view:setIsSelectHandler(function(o)
		if self.m_curHero == o then
			self.m_curHeroView = view
			return true
		end
		return false
	end)
	return view
end

function This:getSkillView(skill)
	local view = PsvSkillView:create(skill)
	view:setSelectHandler(function(k)
		if self.m_curSkillView then
			self.m_curSkillView:setSelect(false)
		end
		self.m_curSkillView = view
		self.m_curSkillView:setSelect(true)
		self.m_curSkill = k

		self:refreshHeroSolt()
	end)
	return view
end

function This:refreshHeroViewList(heroList)
	if heroList then
		self.m_heroList = heroList
	else
		self.m_heroList = self:getHeroList()
	end

	local index = 1
	for i , hero in ipairs(self.m_heroList) do
		if self.m_curHero == hero then
			index = i
			break
		end
	end
	
	self.m_listLayer:setDataList(self.m_heroList,function(hero)
		local view = self:getHeroView(hero)
		if hero == self.m_curHero then
			view:setSelect(true)
			self.m_curHeroView = view
		end
		return view
	end,nil, index)

	if not self.m_curHeroView then
		local view = self.m_listLayer:getViewByIndex(index)
		if view then
			view:setSelect(true)
			self.m_curHeroView = view
		end
	end
end

function This:refreshSkillList()
	local skillList = self:getPsvSkillList()
	local itemList = self.m_csNode.book.scrollview:getItemList()
	for i , skill in ipairs(skillList) do
		local view = itemList[i]
		if view then
			if view:getModel() ~= skill then
				view:setModel(skill)
			end
		else
			view = self:getSkillView(skill)
			self.m_csNode.book.scrollview:pushBackCustomItem(view,260,95,0.5)
		end
		view:setHero(self.m_curHero)
		if i == 1 and not self.m_curSkill then
			self.m_curSkill = skill
			view:setSelect(true)
			self.m_curSkillView = view
			self:refreshHeroSolt()
		end
	end
	
	for i = #itemList, #skillList + 1 , -1 do
		if itemList[i] == self.m_curSkillView then
			self.m_curSkill = nil
			self.m_curSkillView = nil
			self:refreshHeroSolt()
		end
		self.m_csNode.book.scrollview:removeItem(i)
	end
	if #skillList <= 0 then
		self:refreshHeroSolt()
	end
end

function This:refreshHeroSolt(hasAction)
	for i , view in ipairs(self.m_soltViewList) do
		local solt = self.m_curHero:getSoltByPos(i)
		view:setModel(solt)
		local isLocked, hasLock = solt:hasLuckyLock()
		if isLocked then
			local heroId = self.m_curHero:getId()
			self.m_lockSoldHeroId[heroId] = true
		end
	end

	if self.m_curSkill then
		local itemId = self.m_curSkill:getId()
		self.m_csNode.learn.bookicon:setImage(self.m_curSkill:getIcon())
		self.m_csNode.learn.bookicon:setVisible(true)

		local num = DepotManager:getItemCount(itemId)
		self.m_csNode.learn.miaoshu:setString(string.format("%d/1",num))
		if num > 0 then
			self.m_csNode.learn.miaoshu:setColor(255,255,255)
		else
			self.m_csNode.learn.xiaohao:setVisible(false)
			self.m_csNode.learn.miaoshu:setVisible(false)
		end
		self.m_csNode.learn.miaoshu:setVisible(true)
		local isHave = self.m_curSkill:isOwned()
		self.m_csNode.learn.weiyouyong_title:setVisible(not isHave)
		self.m_csNode.learn.xiaohao:setVisible(isHave)
		self.m_csNode.learn.miaoshu:setVisible(isHave)
	else
		self.m_csNode.learn.bookicon:setVisible(false)
		self.m_csNode.learn.miaoshu:setVisible(false)
		self.m_csNode.learn.xiaohao:setVisible(false)
		self.m_csNode.learn.weiyouyong_title:setVisible(false)
	end

	self:refreshScore()
	self:refreshLockState()
end

function This:refreshScore()
	local curPsvSillScore = HeroManager:getHeroPsvScore()
	if not self.m_maxPsvSillScore then
		self.m_maxPsvSillScore = ArgConfig["skill_jifen_limit"].arg[1]
	end
	local percent = curPsvSillScore / self.m_maxPsvSillScore
	local jinduNode = self.m_csNode.jindutiao
	jinduNode.jindutiao:setPercent(percent * 100)
	jinduNode.num:setString(string.format("%d/%d", curPsvSillScore, self.m_maxPsvSillScore))
end

function This:refreshLockState()
	local index = self.m_curHero:getPsvSlotLock()
	local visible = index and index > 0
	self.m_psvSlotLock = visible
	local bookNode = self.m_csNode.learn.lockbook
	bookNode:setVisible(visible)
	if not visible then
		return 
	end

	local lockItemInfo = self.m_skillLockItemInfo
	local itemId, count, costItemId, costNum 
	if not lockItemInfo then
		lockItemInfo = ArgConfig["skill_lock_item"].arg
		itemId, count = unpack(lockItemInfo)
		self.m_skillLockItemInfo = lockItemInfo
	else
		itemId, count = unpack(lockItemInfo)
	end

	local lockItemCostInfo = self.m_skillLockItemCostInfo
	if not lockItemCostInfo then
		local itemPriceInfo = ArgConfig["skill_lock_item_cost"].arg
		costItemId = itemPriceInfo[1]
		costNum = itemPriceInfo[2] * count
		lockItemCostInfo = {costItemId, costNum} 
		self.m_skillLockItemCostInfo = lockItemCostInfo
	else
		costItemId, costNum = unpack(lockItemCostInfo)
	end

	local itemNode = bookNode.itemNode
	if not itemNode then
	    itemNode = ItemNode:create(itemId, count)
	    bookNode:addChild(itemNode)
	    local w, h = itemNode:getContentSize()
	    itemNode:setPosition(- w / 2, - h / 2)
		bookNode.itemNode = itemNode
	end
	local curLockItemNum = itemNode:showNeedNum(count)	
	if curLockItemNum >= count then
		bookNode.icon:setVisible(false)
		bookNode.spend:setVisible(false)
	else
		bookNode.icon:setVisible(true)
		bookNode.spend:setVisible(true)
		bookNode.spend:setString(costNum)
		bookNode.spend:setColorByID(DepotManager:getItemOrResCount(costItemId) > costNum and "A1" or "R0")
	end
end

function This:onEnter()
	super.onEnter(self)
	HeroManager:addObserver(self)
	DepotManager:addObserver(self)
end

function This:onExit()
	super.onExit(self)
	HeroManager:removeObserver(self)
	DepotManager:removeObserver(self)
end

function This:onEquipPsvSkill(solt)
	self:refreshSkillList()
	local effect1 , effect2
	effect1 = GameUtil:createEffect("TiHuan1",false,nil,{
		onAnimationComplete = function()
			effect1:removeFromParent()
		end
	})
	local x , y = self.m_csNode.learn.bookicon:getPosition()
	effect1:setPosition(x,y)
	self.m_csNode.learn:addChild(effect1)

	local index = solt:getIndex()
	effect2 = GameUtil:createEffect("TiHuan2",false,nil,{
		onAnimationComplete = function()
			effect2:removeFromParent()
		end
	})
	self.m_csNode.learn["skill"..index]:addChild(effect2)
	self:refreshHeroSolt()
	self.m_soltViewList[index]:showAction()
end

function This:onUnlockPsvSolt()
	self:refreshSkillList()
	self:refreshHeroSolt()
end

function This:onTransPsvSkill()
	self:refreshSkillList()
	self:refreshHeroSolt()
end

function This:onLockPsvSkill(hero)
    if self.m_curHero:getId() == hero:getId() then
		self:refreshHeroSolt()
    end 
end
This.onUnlockPsvSkill = This.onLockPsvSkill

function This:onGetHeroPsvScore()
	self:refreshScore()
end

function This:itemUpdate(itemList)
    if itemList and #itemList > 0 then
        g_scene:showReward(itemList)
    end
end

--endregion
