--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"Dialog")
local GameSetting = require("GameSetting")
local GamePlayer = require("Player.GamePlayer")
local GameUtil = require("Util.GameUtil")
local HeroManager = require("Hero.HeroManager")
local PsvLearnPanel = require("Hero.PsvLearnPanel")
local DepotManager = require("Depot.DepotManager")

function This:initNode(info)
	self.m_hero = info.hero
	self.m_skill = info.skill
	self.m_key = info.key
	self.m_hasLuckLock = info.hasLuckLock
	self.m_costItem = info.costItem

	self.m_csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/LearnPassiveSkill.csb")
	self:addChild(self.m_csNode)
	self.m_csNode:setToCenter()
	
	self.m_csNode.learn:setStringWithColor(string.format(Serialize[61360],self.m_hero:getName(),self.m_skill:getName()),837)
	self.m_csNode.learn2:setString(self.m_skill:getDescripe(),600)
	self.m_isTips = false
	self.m_csNode.gouxuan:setVisible(self.m_isTips)
	local scale = self.m_csNode.tishi:getScale()
	scale = self.m_csNode.tips:getScale()
	self.m_csNode.tishi:runAction(cc.Blink(5, 5))
	self.m_csNode.tips:runAction(cc.Blink(5, 5))

	if self.m_hasLuckLock then
		local label = self.m_csNode.suoding
		label:setVisible(true)
		label:setString(info.tips)
	else
		self.m_csNode.suoding:setVisible(false)
	end
end

function This:initTouchEvent()
	self.m_csNode.weigouxuan:setTouchEnded(function()
		self.m_isTips = not self.m_isTips
		self.m_csNode.gouxuan:setVisible(self.m_isTips)
	end)

	self.m_csNode.cancelButton:setTouchEnded(function()
		self:close()
	end)

	self.m_csNode.confirmButton:setTouchEnded(function()
		if self.m_isTips then
			PsvLearnPanel.IsShowLearnTips[self.m_key] = false
		end
		local result , reason = self.m_skill:isCanEquiped(self.m_hero)
		if not result then
			g_scene:showTips(reason)
		else
			local lockIndex = self.m_hero:getPsvSlotLock()
			local hasLuckLock = lockIndex and lockIndex > 0
			if not hasLuckLock then
				lockIndex = nil
			end

			if self.m_hasLuckLock and self.m_costItem[1] == 102 then
				local ownedNumber = DepotManager:getItemOrResCount(self.m_costItem[1])
				if ownedNumber < self.m_costItem[2] then
					local panel = g_scene:openDialog("Territory.TerrCommonConfirmPanel")
					panel:setString(Serialize[61361])
					panel:setOkHandler(function()
						g_scene:openDialog("System.RechargeMainUI")
					end)
					return
				end
			end

			HeroManager:onEquipPsvSkillRequest(self.m_skill:getId(),self.m_hero:getUid(), lockIndex)
		end
		self:close()
	end)
end



--endregion
