---
---
--- Created by aid.
--- DateTime: 2018/10/31 17:58
---
local This , super = class(...,"Dialog")

local HeroManager = require("Hero.HeroManager")
local ItemNode = require("UI.ItemNode")

function This:initData(info)
    super.initData(self, info)
    self.heroUid = info.heroUid
    self.returnItems = info.returnItems
    self.needYuanBaoCount = info.needYuanBaoCount
end

function This:initNode(info)
    self.m_csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/PassvieResetPreview.csb")
    self:addChild(self.m_csNode)
    self.m_csNode:setToCenter()

    if self.needYuanBaoCount == 0 then
        self.m_csNode.yuanbao:setVisible(false)
        self.m_csNode.num:setVisible(false)
        self.m_csNode.mianfei:setVisible(true)
    else
        self.m_csNode.yuanbao:setVisible(true)
        self.m_csNode.num:setVisible(true)
        self.m_csNode.mianfei:setVisible(false)
        self.m_csNode.num:setString(tostring(self.needYuanBaoCount))
    end

    local index = 1
    for itemId, count in pairs(self.returnItems) do
        local item =  ItemNode:create(itemId, count)
        local width, _ = item:getContentSize()
        local x, y = item:getPosition()
        item:setAnchorPoint(0.5, 0.5)
        item:setPosition(x+width*(index-1)*0.8, y)
        item:setScale(0.8)
        self.m_csNode.item1:addChild(item)
        index = index + 1
    end

end

function This:initTouchEvent()

    -- 取消按钮
    self.m_csNode.button1:setTouchEnded(function()
        self:close()
    end)

    -- 确认按钮
    self.m_csNode.button2:setTouchEnded(function()
        HeroManager:onResetPsvSkillSlotRequest(self.heroUid)
        self:close()
    end)
end