--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"Base.BaseModel")
local PassiveSoltConfig = require("Metadatas.PassiveSoltConfig")
local DepotManager = require("Depot.DepotManager")
local HeroManager = require("Hero.HeroManager")

local UnlockType = {
	kLevel = 1,
	kStar = 2,
}

function This:init(info)
	self.m_quality = info.quality
	self.m_solt = info.solt
	self.m_hero = info.hero
	self.m_isUnlock = false
	self.m_isActive = false
	self.m_psvSkill = nil
	self:initCustom()
	if not self.m_config then
		print(string.format("没有 技能槽%d （品质%d,槽位%d）",id,self.m_quality,self.m_solt))
		assert(false)
	end
end

function This:initCustom()
	local id = self.m_quality * 100 + self.m_solt
	self.m_config = PassiveSoltConfig[id]
end

function This:setHero(hero)
	if not self.m_hero then
		self.m_hero = hero
	else
		assert(false)
	end
end

function This:getHero()
	return self.m_hero
end

function This:getQualit()
	return self.m_quality
end

function This:getIndex()
	return self.m_solt
end

function This:isUnlock()
	return self.m_isUnlock
end

function This:setIsUnlock(isUnlock)
	self.m_isUnlock = isUnlock
end

function This:isEmpty()
	return self.m_psvSkill == nil
end

function This:getPsvSkill()
	return self.m_psvSkill
end

function This:getPsvSkillId()
	if self.m_psvSkill then
		return self.m_psvSkill:getId()
	end
	return 0
end

function This:setIsActive(isActive)
	if self.m_psvSkill then
		self.m_psvSkill:setIsActive(isActive,self.m_hero)
	end
end

function This:isActive()
	return self.m_isActive
end

function This:setPsvSkill(skill)
	if self.m_psvSkill ~= skill then
    	self:unlock()
		if self.m_psvSkill then
			self.m_psvSkill:removeHero(self.m_hero)
			self.m_psvSkill:setIsActive(false,self.m_hero)
		end
		self.m_psvSkill = skill
		self.m_psvSkill:addHero(self.m_hero)
	end
end

function This:removePsvSkill()
    if self.m_psvSkill then
    	self:unlock()
    	local skill = self.m_psvSkill
    	self.m_psvSkill = nil
		skill:removeHero(self.m_hero)
		skill:setIsActive(false,self.m_hero)
    end
end

function This:isCanUnlock()
	local tmp = {Serialize[60012],Serialize[60013],Serialize[60014],Serialize[60015],Serialize[60016]}
	for i , info in ipairs(self.m_config.condition) do
		local unlockType = info[1]
		local value = info[2]
		if unlockType == UnlockType.kLevel and self.m_hero:getLevel() < value then
			return false, string.format(Serialize[61365],value)
		end
		
		if unlockType == UnlockType.kStar and self.m_hero:getTotalPhase() < value then
			return false, string.format(Serialize[61366],tmp[math.floor(value/5)])
		end
	end
	return true
end

function This:getUnlockCost()
	local result = {}
	local pieceId = self.m_hero:getId() + 10000
	if self.m_hero:isRed() then --红将特殊处理
		pieceId = 121
	else
		table.insert(result,{id = pieceId,num = self.m_config.need_card})
	end
	for i , info in ipairs(self.m_config.need_item) do
		table.insert(result, {id = info[1], num = info[2]})
	end
	return result
end

function This:isUnlockCostEnough()
	local itemList = self:getUnlockCost()
	for i , info in ipairs(itemList) do
		if DepotManager:getItemOrResCount(info.id) < info.num then
			return false
		end
	end
	return true
end

function This:lock()
	if self:isEmpty() then return end
    self.m_hero:setPsvSlotLock(self:getIndex())
    HeroManager:notifyObserver("onLockPsvSkill", self.m_hero)
end

function This:unlock()
	if self:isEmpty() then return end
    local index = self.m_hero:getPsvSlotLock()
	if index ~= self:getIndex() then return end
    self.m_hero:setPsvSlotLock(0)
    HeroManager:notifyObserver("onUnlockPsvSkill", self.m_hero)
end

function This:hasLuckyLock()
    local index = self.m_hero:getPsvSlotLock()
    return index == self:getIndex(), index and index > 0
end

function This:isPsvSkill()
	return true
end

function This:isRune()
	return false
end


--endregion
