--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"cc.Node")
local PassiveSkillConfig = require("Metadatas.PassiveSkillConfig")
local HeroManager = require("Hero.HeroManager")
local ItemNode = require("UI.ItemNode")
local DepotManager = require("Depot.DepotManager")

function This:init(skill)
	self.m_skill = skill
	self.m_config = PassiveSkillConfig[id]
	self.m_csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/PassiveItem.csb")
	self:addChild(self.m_csNode)
	self.m_csNode.xuanzhong:setVisible(false)
	local itemNode = ItemNode:create(skill:getId())
	itemNode:setAnchorPoint(0.5,0.5)
	itemNode:setScale(0.7)
	self.m_csNode.item1:addChild(itemNode)
	self.m_itemNode = itemNode
	self:refresh()
end

function This:initTouchEvent()
	self.m_csNode.bg1:setTouch({
		onEnded = function()
			if self.m_selectHandler then
				self.m_selectHandler(self.m_skill)
			end
		end,	
		isScale = false,
		isContainer = true
	})
end

function This:refresh()
	self.m_csNode.name:setString(self.m_skill:getName())
	local count = self.m_skill:getHeroCount()
	local maxCount = self.m_skill:getMaxCanEquipNum()
	self.m_csNode.zhuangbeishu:setString(string.format(Serialize[61368],maxCount))
	self.m_csNode.zhuangbeishu1:setString(string.format(Serialize[61369],count))
	if self.m_hero then
		local isLearn = self.m_skill:isHeroEquiped(self.m_hero:getUid())
		self.m_csNode.xuehui:setVisible(isLearn)
		local num = DepotManager:getItemCount(self.m_skill:getId())
		self.m_csNode.yongyou:setVisible(not isLearn and num > 0)
		self.m_csNode.tuijian:setVisible(self.m_skill:isRecommand(self.m_hero:getId()))
	else
		self.m_csNode.yongyou:setVisible(false)
		self.m_csNode.xuehui:setVisible(false)
		self.m_csNode.tuijian:setVisible(false)
	end
	local num = DepotManager:getItemCount(self.m_skill:getId())
	self.m_csNode.shuliang:setString(Serialize[61370] .. num)
end

function This:onEnter()
	super.onEnter(self)
	self:initTouchEvent()
end

function This:setHero(hero)
	self.m_hero = hero
	self:refresh()
end

function This:getModel()
	return self.m_skill
end

function This:setModel(skill)
	if skill ~= self.m_skill then
		self.m_skill = skill
		self.m_itemNode:initItem(self.m_skill:getId())
		self:refresh()
	end
end

function This:setSelect(isSelect)
	self.m_csNode.xuanzhong:setVisible(isSelect)
end

function This:setSelectHandler(handler)
	self.m_selectHandler = handler
end

--endregion
