--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"cc.Node")
local RuneManager = require("Equip.RuneManager")

function This:init(slot, learnMode)
	self.m_slot = slot
	self.m_isLearMode = learnMode
	self.m_csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/HeroPassiveItem.csb")
	self:addChild(self.m_csNode)

    self.canBeTouched = true
end

function This:initTouchEvent()
	self.m_csNode.skillbg:setTouch({
		onEnded = function()
            if not self.canBeTouched then return end

			local isUnlock = self.m_slot:isUnlock()
			if not isUnlock  then
				local can , reason = self.m_slot:isCanUnlock()
				if not can then
					g_scene:showTips(reason)
				else
					g_scene:openDialog("Hero.SoltUnlockPanel",self.m_slot)
				end
			elseif not self.m_noLearn then
				if self.m_slot:isRune() then
					if not self.m_slot:getPsvSkill() then
						g_scene:openDialog("Equip.RuneWearPanel",{solt = self.m_slot})
					else
						local info = {data = self.m_slot:getPsvSkill(),solt = self.m_slot,type =RuneSkillStart.kHeroPanel}
						g_scene:openDialog("Equip.RuneSkillPanel",info)
					end
				else
					local psvSkill = self.m_slot:getPsvSkill()
					if not psvSkill then
						local dialog = g_scene:getDialog("PsvLearnPanel")
						if not dialog then
							local hero = self.m_slot:getHero()
							g_scene:openDialog("Hero.PsvLearnPanel",{hero = hero})
						end
					else
						g_scene:openDialog("Hero.PsvDescripePanel", {slot = self.m_slot, learnMode = self.m_isLearMode})
					end
				end
			end
		end,
		isScale = false,
	})
end

function This:setTouchEnabled(ok)
    self.canBeTouched = ok
end

function This:refresh()
	local can = self.m_slot:isCanUnlock()
	local isUnlock = self.m_slot:isUnlock()
	local psvSkill = self.m_slot:getPsvSkill()
	local csNode = self.m_csNode
	csNode.lock:setVisible(not isUnlock)
	csNode.unlock:setVisible(not isUnlock and can)
	csNode.tianjiajineng:setVisible(isUnlock and not psvSkill)
	csNode.icon:setVisible(isUnlock and psvSkill)
	if self.m_isLearMode and isUnlock and psvSkill then
		local isLuckyLock, hasLock = self.m_slot:hasLuckyLock()
		csNode.suo:setVisible(not hasLock)
		csNode.suoding:setVisible(hasLock and isLuckyLock)
	else
		csNode.suo:setVisible(false)
		csNode.suoding:setVisible(false)
	end
	local quality =3
	if psvSkill then
		local icon = psvSkill:getIcon()
		csNode.icon:setImage(icon)
		quality = psvSkill:getQuality()
	end
	local img ="MenuScene/itemQuality" .. quality .. ".png"
	csNode.skillbg:setImage(img)
end	

function This:showAction()
	self.m_csNode.icon:setOpacity(0)
	self.m_csNode.icon:runAction(cc.FadeIn(0.3))
end

function This:showChosenEffect()
    if self.m_csNode.skillchoose then
		self.m_csNode.skillchoose:runActionByID("Blink1")
    end
end

function This:onEnter()
	super.onEnter(self)
	self:refresh()
	self:initTouchEvent()
end

function This:setModel(solt)
	if self.m_slot ~= solt then
		self.m_slot = solt
	end
	self:refresh()
end

function This:setNoLearn( value )
   self.m_noLearn = value
end

--endregion
