--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"Dialog")
local ItemNode = require("UI.ItemNode")
local HeroManager = require("Hero.HeroManager")
local DepotManager = require("Depot.DepotManager")
local ItemUtil = require("Bag.ItemUtil")
local GamePlayer = require("Player.GamePlayer")

function This:initNode(hero)
	self.m_hero = hero

	local csNode = cc.Node:createFromCSFile("GameScene/NodeUI/HeroReset.csb")
	self.m_csNode = csNode
	self:addChild(csNode)
	csNode:setToCenter()

	local costList = self.m_hero:getTotalTrainCostList()

	self.m_resetCardItemId = 123
	local cost = HeroManager:getHeroResetCost()
	local num = DepotManager:getItemCount(self.m_resetCardItemId)

	csNode.free:setVisible(cost <= 0)
	csNode.icon:setVisible(cost > 0)
	csNode.price:setVisible(cost > 0)
	csNode.price:setString(cost)
	if cost > 0 then
		if num > 0 then
			csNode.price:setString(string.format("1/%d",num))
			csNode.icon:setImage(ItemUtil.getIconImage(self.m_resetCardItemId))
		else
			csNode.price:setString(cost)
		end
	end
	self.m_costList = costList

	local function createItemView(model)
		local node = ItemNode:create(model.id,model.num)
		node:setAnchorPoint(0.5,0.5)
		return node
	end

    for i, model in ipairs(costList) do
        local view = createItemView(model)
        csNode.item.heroList:pushNode(view, 95, 85, 4) 
    end
end

function This:initTouchEvent()
	local csNode = self.m_csNode
	csNode.close:setTouchEnded(function()
		self:close()
	end)

	csNode.confirm:setTouchEnded(function()
		if self.m_hero:getState() ~= HeroState.kInFree then
			g_scene:showTips(Serialize[60447])
			return
		end
		if self.m_hero:getDeputyCount() > 0 then
			g_scene:showTips(Serialize[60448])
			return
		end
		for i = EquipPos.kWeapons , EquipPos.kHorse do
			if self.m_hero:isWearEquip(i) then
				g_scene:showTips(Serialize[60449])
				return
			end
		end
		if #self.m_costList <= 0 then
			g_scene:showTips(Serialize[60450])
			return
		end
		local cost = HeroManager:getHeroResetCost()
		local num = DepotManager:getItemCount(self.m_resetCardItemId)
		if cost > 0 and num <= 0 then
			GamePlayer:costDiamond({
				cost = cost,
				okHandler = function()
					HeroManager:onResetHeroRequest(self.m_hero:getId())
				end
			})
		else
			HeroManager:onResetHeroRequest(self.m_hero:getId())
		end
	end)

	csNode.help:setTouchEnded(function()
		self:openDialog("UI.HelpTips",{text = Serialize["hero_reset_help"], node = csNode.confirm})
	end)
end

function This:onEnter()
	super.onEnter(self)
	HeroManager:addObserver(self)
end

function This:onExit()
	super.onExit(self)
	HeroManager:removeObserver(self)
end

function This:onHeroReset()
	self:close()
end


--endregion
