-- @Author: superm
-- @Date:   2018-06-14 17:54:07
-- @Last Modified by:   superm
-- @Last Modified time: 2018-07-26 10:42:12
-- @File Name: SaintPowerUpEffectView.lua
-- @Description: 

local This , super = class(...,"Dialog")
local HeroManager = require("Hero.HeroManager")
local ViewUtil = require("UI.ViewUtil")
local GameUtil = require("Util.GameUtil")
This.noMask = true

function This:initNode(info)
	self.m_strongest = false
   	if info then
   		self.m_strongest = info.strong
   		self.m_startNum = info.oldvalue
   		self.m_endNum = info.power 
   		self.m_sainInfo = HeroManager:getSaintInfo()
   		if not self.m_endNum then
	   		if self.m_strongest then
	   			self.m_endNum = self.m_sainInfo:getSaintPower()
	   		else
	   			self.m_endNum = self.m_sainInfo:getStrongestPower()
	   		end
	   	end
    end

	self.m_csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/ZuiQiangZhanLi.csb")
	if not self.m_strongest then
		self.m_csNode.zuiqiangzhanli_title:setImage("GameScene/word_zongzhanli_1.png")
	end
    self:addChild(self.m_csNode)
    self.m_csNode:setToCenter()
    self.m_csNode.fightPower:setString(self.m_startNum)
    self.m_increased = self.m_startNum < self.m_endNum
    if self.m_increased then
    	self.m_csNode:setPositionY(self.m_csNode:getPositionY() - 100)
    	self.m_csNode.jiantou:setAngle(90)
    	self.m_csNode.jiantou:setImage("MenuScene/jiantou13.png")
   	else
    	self.m_csNode.jiantou:setAngle(-90)
    	self.m_csNode.jiantou:setImage("MenuScene/jiantou14.png")
   	end
end

function This:showViewEffect()
	if not self.m_isRunningEffect then
        self.m_isRunningEffect = true
		local param = {startNum=self.m_startNum, endNum=self.m_endNum, interval=0.5}
        
		local action = cc.Sequence(
			cc.Spawn(cc.FadeIn(0.07), cc.ScaleTo(0.07, 1)), 
			cc.DelayTime(0.2), 
			cc.Spawn(cc.FadeOut(2), cc.MoveBy(1, 0, self.m_increased and 60 or -60, "BackOut"), cc.CallFunc(function()
				ViewUtil:startCountUp(self.m_csNode.fightPower, param, function() 
					self.m_csNode:runAction(cc.Sequence(cc.DelayTime(0.4), cc.CallFunc(function() self:close() end)))
				end)
			end)))
		self.m_csNode:setOpacity(0)
		self.m_csNode:setScale(4)

	    self.m_effectSaintUp = GameUtil:createEffect("ZhanLi", true, self)
	    local posx, posy = self.m_csNode.bg:getPosition()
	    self.m_effectSaintUp:setPosition(posx, posy)
	    self.m_csNode:addChild(self.m_effectSaintUp)  
		self.m_csNode:runAction(action)
	end
end

function This:showPower( oldvalue, newvalue, strong )
    if g_scene then
    	local sceneType = g_scene:getType()
    	if sceneType == SceneType.kWorldScene or sceneType == SceneType.kHomeScene then
		    local param = {strong = strong, oldvalue=oldvalue, power=newvalue }
		    local node = self:create(param)
		    g_scene:addChild(node)
            node:showViewEffect()
    	end
    end
end

function This:showStrongPower( oldvalue, newvalue )
    self:showPower( oldvalue, newvalue, true )
end

function This:onEnter()
    super.onEnter(self)
    self:setLocalZOrder(g_scene:getMaxLocalZOrder() + 1)
end
