-- @Author: superm
-- @Date:   2018-06-11 19:21:50
-- @Last Modified by:   superm
-- @Last Modified time: 2018-06-14 17:03:10
-- @File Name: SaintUpgradePanel.lua
-- @Description: 

local This , super = class(...,"Dialog")
local HeroManager = require("Hero.HeroManager")

function This:initNode(info)
	self.m_runningAniantion = false

	self.m_csNode = cc.Node:createFromCSFile("GameScene/NodeUI/WuSheng.csb")
	self:addChild(self.m_csNode)
	self.m_csNode:setToCenter()

	self.m_saintInfo = HeroManager:getSaintInfo()
	self:refreshAttrListUI()
end

function This:refreshAttrListUI()
	local visible = self.m_saintInfo:isFullSaintLevel()
	local level = self.m_saintInfo:getSaintLevel()
	self.m_csNode.shengji:setVisible(not visible)
	self.m_csNode.manji:setVisible(visible)
	if not visible then
		self:refreshAttrUI(self.m_csNode.shengji.num1, level)
		self:refreshAttrUI(self.m_csNode.shengji.num2, level+1)
	else
		self:refreshAttrUI(self.m_csNode.manji, level, true)
	end
end

function This:initTouchEvent()
    self.m_csNode.closebg:setTouchEnded(function()
        if self.m_runningAniantion then
            return false
        end
        self:close()
    end)

   	self.m_csNode.help:setTouchEnded(function()
		g_scene:openDialog("UI.HelpTips",{text=Serialize["hero_saint_up_help_tips"],node = self.m_csNode.help})
	end)
end	

function This:refreshAttrUI( node, level, isFull )
	if not isFull then
		node.level:setString(level .. Serialize[60187] )
	else
		node.level:setString(Serialize[61386] .. level .. Serialize[60187] )
	end
	local attList = {AttrType.kPower, AttrType.kIntelligence, AttrType.kChiefValue, AttrType.kDfs}
	local valueList = self.m_saintInfo:getSaintAttrAdditionList(level)
	local nameList = {"valuewu","valuezhi","valuetong","valueyu"}
	for i, name in ipairs(nameList) do
		local value = valueList[attList[i]]
		node[name]:setString(value)
	end
	local desc = string.format(Serialize[61387], self.m_saintInfo:getSaintHeroNum())
	self.m_csNode.shuoming.shuoming1:setString(desc)
end
