--region *.lua
--Date
--此文件由[BabeLua]插件自动生成
-- SkillTabNode.lua
local This, super = class(...,"cc.Node")
local SkillConfig = require("Metadatas.SkillConfig")
local HeroManager = require("Hero.HeroManager")
local HeroConfig = require("Metadatas.HeroConfig")
local FetterConfig = require("Metadatas.FetterConfig")
local RedFetterConfig = require("Metadatas.RedFetterConfig")
local PsvSoltView = require("Hero.PsvSoltView")
local RuneManager = require("Equip.RuneManager")

function This:init(heroId)
	self.m_heroId = heroId
	self.m_csNode = cc.Node:createFromCSFile("GameScene/NodeUI/HeroSkill.csb")
	self:addChild(self.m_csNode)
	self.m_fettersDesc = {}
	self.m_soltViewList = {}
	self.m_runeViewList = {}
    local hero = HeroManager:getHero(self.m_heroId)
    for i = 1, 6 do
        local solt = hero:getSoltByPos(i)
        local view = PsvSoltView:create(solt)
        self.m_csNode["skill"..i]:addChild(view)
        self.m_soltViewList[i] = view
    end
    local runeSoldMax = RuneManager:getMaxSolt()
	for i = 1, runeSoldMax do
        local runeParent = self.m_csNode["skill2"..i]
        local solt = hero:getRuneByPos(i)
        local view2 = PsvSoltView:create(solt)
        runeParent:addChild(view2)
        self.m_runeViewList[i] = view2

	end
	self:refresh()
end

function This:refreshPassvieSkillSlot()
    for i = 1, 6 do
        self.m_soltViewList[i]:refresh()
        if self.m_runeViewList[i] then
        	self.m_runeViewList[i]:refresh()
        end
    end
end

function This:refresh()
	local csNode = self.m_csNode
	local hero = HeroManager:getHero(self.m_heroId)
	local skillId = hero:getSkillId()
	csNode.name:setString(SkillConfig[skillId].name..":")
	csNode.starupbotton:setVisible(hero:isAwaken() and hero:getStarLv() < kMaxStarLv)
	local skilldesp = csNode.skilldes
	local x , y = skilldesp:getPosition()
	skilldesp:setStringWithColor(string.format("<New3>%s",SkillConfig[skillId].desp),490)

	local enger = SkillConfig[skillId].anger_cost
	for i= 1,4 do
		csNode["energ"..i]:setVisible(enger >= i)
	end
	local fetters = HeroConfig[self.m_heroId].fetter
	local initY = csNode.bg:getPositionY() - 20
	for i , id in ipairs(fetters) do
		local nameNode = csNode["fettername"..i]
		local fetterItem = FetterConfig[id] or RedFetterConfig[id]
		nameNode:setStringWithColor(string.format("<A1>%s: <New3>%s",fetterItem.name,fetterItem.desc), (not AppText:isChinese()) and 500 or nil)
	end
	for i = 1 , 4 do
		local nameNode = csNode["fettername"..i]
		nameNode:setVisible(#fetters >= i)
	end
	self:refreshPassvieSkillSlot()
	csNode.Tips:setVisible(not HeroManager:isSkillFuncOpen())
	csNode.Tips1:setVisible(not HeroManager:isSkillFuncOpen())
end

function This:initTouchEvent()
	local csNode = self.m_csNode
	csNode.genghuanbutton:setTouchEnded(function()
		local hero = HeroManager:getHero(self.m_heroId)
		g_scene:openDialog("Hero.PsvLearnPanel",{hero = hero})
	end)
	csNode.wenhaoxin_1:setTouchEnded(function()
		g_scene:openDialog("UI.HelpTips",{text = Serialize[61389],node = csNode.wenhaoxin_1})
	end)

	csNode.zhuanyibutton:setTouchEnded(function()
		g_scene:openDialog("Hero.PsvTransPanel",{sourceId = self.m_heroId})
	end)

	csNode.starupbotton:setTouchEnded(function ()
		g_scene:openDialog("Awake.AwakeInfoPanel",{heroId = self.m_heroId,showAwake = true})
	end)
	-- 被动技能重置按钮
	csNode.chongzhibutton:setTouchEnded(function()
        g_scene:openDialog("Hero.PsvResetPanel", {heroId = self.m_heroId})
	end)
	local wenhao = csNode.wenhaoxin_2
    wenhao:setTouchEnded(function()
        local text = Serialize["hero_SkillTab_1"]
        g_scene:openDialog("UI.HelpTips", {text = text,node = wenhao})
    end)
end

function This:setModel(heroId)
	if self.m_heroId ~= heroId then
		self.m_heroId = heroId
		local hero = HeroManager:getHero(self.m_heroId)
		for i = 1, 6 do
			local solt = hero:getSoltByPos(i)
			self.m_soltViewList[i]:setModel(solt)
			if self.m_runeViewList[i] then
				local rune = hero:getRuneByPos(i)
				self.m_runeViewList[i]:setModel(rune)
			end
		end
		self:refresh()
	end
end

function This:onEnter()
	super.onEnter(self)
	HeroManager:addObserver(self)
	RuneManager:addObserver(self)
	self:initTouchEvent()
end

function This:onExit()
	super.onExit(self)
	HeroManager:removeObserver(self)
	RuneManager:removeObserver(self)
end

function This:onUpgradeLevel(heroId)
	if self.m_heroId == heroId then
		self:refreshPassvieSkillSlot()
	end
end

function This:onEquipPsvSkill()
	self:refreshPassvieSkillSlot()
end

function This:onUnlockPsvSolt()
    self:refreshPassvieSkillSlot()
end


function This:onTransPsvSkill()
    self:refreshPassvieSkillSlot()
end

function This:onResetPsvSkillSlot()
    self:refreshPassvieSkillSlot()
end

function This:onUpgradeStarLv()
	self:refresh()
end

function This:onUnlockRuneSolt()
	self:refreshPassvieSkillSlot()
end
This.onRuneModify = This.refreshPassvieSkillSlot
--endregion
