--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"cc.Node")
local HeroManager = require("Hero.HeroManager")
local GamePlayer = require("Player.GamePlayer")
local GameUtil = require("Util.GameUtil")
local StarUpConfig = require("Metadatas.StarUpConfig")
local DragSelectContainer = require("UI.DragSelectContainer")
local SoilderBtnView = require("Hero.SoilderBtnView")

function This:init(heroId)
	self.m_hero = HeroManager:getHero(heroId)
	self.m_csNode = cc.Node:createFromCSFile("GameScene/NodeUI/HeroArms.csb")
	self:addChild(self.m_csNode)
	local soilder = self.m_hero:getCurSoilder()
	self:selectSoilder(soilder)

	local w , h = self.m_csNode.tsbg:getContentSize()
	local x , y = self.m_csNode.tsbg:getPosition()
	self.m_csNode.tsbg:setVisible(false)

	self.m_container = DragSelectContainer:create({
		width = w+133,
		height = h+34,
		space = 10,
		maxScale = 1.2,
		minScale = 0.1,
		initSpeed = 300,
	})
	self.m_container:setPosition(x,y)
	self.m_csNode:addChild(self.m_container)

	local soilderList = {SoilderType.kShield,SoilderType.kCavalry,SoilderType.kArcher,SoilderType.kSapperCar}
	for i , soilderId in ipairs(soilderList) do
		local soilder = self.m_hero:getSoilder(soilderId)
		local view = SoilderBtnView:create(soilder)
		view:setSelectHandler(function()
			local sd = self.m_hero:getSoilder(soilderId)
			self:selectSoilder(sd)
		end)
		self.m_container:addItemNode(view)
		if self.m_soilder:getId() == soilderId then
			selectIndex = i
		end
	end
	self.m_container:setItemToCenter(selectIndex)
	self.m_container:setLocalZOrder(99)
end

function This:initTouchEvent()
	local bzsj = self.m_csNode.bzsj
	local bzjx = self.m_csNode.bzjx
	bzsj.zhuangbei:setTouchEnded(function()
		if self.m_hero:getState() ~= HeroState.kInFree then
			g_scene:showTips(Serialize[61393])
			return
		end
		local panel = g_scene:openDialog("UI.ConfirmPanel",{
			text = Serialize[61394],
		})
		panel:setOkHandler(function()
			HeroManager:onAttachSoilderRequest(self.m_hero:getUid(),self.m_soilder:getId())
		end)
	end)
	bzsj.culture:setTouchEnded(function()
		if bzsj.culture.text2:isVisible() then
			g_scene:openDialog("Awake.ArmsAwaKenPanel",{heroId = self.m_hero:getId(),awakeSoilderId = self.m_awakeSoilder:getId()})
			return	
		end
		if self.m_soilder:isToMaxAttrPoint() then
			g_scene:openDialog("Hero.SoilderUpgradePanel",{hero = self.m_hero,soilder = self.m_soilder})
		else
			g_scene:openDialog("Hero.SoilderTrainPanel",{hero = self.m_hero,soilder = self.m_soilder})
		end
	end)
	
	self.m_csNode.left:setTouchEnded(function()
		self.m_container:setPreItemToCenter()
	end)
	self.m_csNode.right:setTouchEnded(function()
		self.m_container:setNexItemToCenter()
	end)

	for i = 1 , 3 do
		g_scene:handleHelpTips(bzsj["tep"..i].icon,function()
			local featureList = self.m_soilder:getAttrFeatures()
			local nextFeatureList = self.m_soilder:getNextPhaseAttrFeatures()
			local featureId = featureList[i] <= 0 and nextFeatureList[i] or featureList[i]
			if featureId > 0 then
				local info = {}
				info.text = string.format("%s:\n%s",StarUpConfig[featureId].name,StarUpConfig[featureId].desc)
				return info
			end
		end) 
	end

	local awakeSoilder = self.m_awakeSoilder
	local nextSoilderConfig = awakeSoilder:getNextConfig()
	if not nextSoilderConfig then
		nextSoilderConfig = awakeSoilder:getConfig()
	end
	local detailIdList = nextSoilderConfig.unlock_arm
	self.m_gouXuanNodes = {}
	for detailIndex,detailId in ipairs(detailIdList) do
		-- local btn = bzjx["bz"..detailIndex]
		bzjx["bz"..detailIndex]:setTouchEnded(function()
			local info = {heroId= self.m_hero:getId(),detailId =self:getCurentDetailId(detailIndex) ,awakeSoilderId = self.m_awakeSoilder:getId()}
			g_scene:openDialog("Awake.ArmsDetailsPanel",info)
		end)
		bzjx["weigouxuan"..detailIndex]:setTouchEnded(function()
			self:setGouXuanState(detailIndex)
		end)
		self.m_gouXuanNodes[detailIndex] = bzjx["gouxuan"..detailIndex]
	end
	bzjx.juexing:setTouchEnded(function()
		g_scene:openDialog("Awake.ArmsAwakePanel",{heroId = self.m_hero:getId(),awakeSoilderId = self.m_awakeSoilder:getId()})
	end)
	bzjx.zhuangbei:setTouchEnded(function()
		local gouIndex = self:setGouXuanState(nil,true)
		-- local gouId = detailIdList[gouIndex]
		local selectSkillId =  self.m_awakeSoilder:getSelectSkill()
		-- if selectSkillId then
			
		-- end
		-- if selectSkillId == gouIndex then
		-- 	gouIndex = nil
		-- end
		HeroManager:onAttachSoilderRequest(self.m_hero:getUid(),self.m_soilder:getId(),gouIndex)
	end)
end

function This:getCurentDetailId(index)
	self:refreshAwakeSoilder()
	local awakeSoilder = self.m_awakeSoilder
	nextSoilderConfig = awakeSoilder:getConfig()
	local detailIdList = nextSoilderConfig.unlock_arm
	return detailIdList[index]
end

function This:setGouXuanState(index,isGet)
	if self.m_gouXuanNodes then
		local gouIndex = index
		for nodeIndex,gouNode in ipairs(self.m_gouXuanNodes) do
			if isGet then
				if gouNode:isVisible() then
					gouIndex = nodeIndex
				end
			else
				gouNode:setVisible(index == nodeIndex)
			end
		end
		return gouIndex
	end
end

function This:onEnter()
	super.onEnter(self)
	self:refresh()
	self:initTouchEvent()
	HeroManager:addObserver(self)
end

function This:onExit()
	super.onExit(self)
	HeroManager:removeObserver(self)
end

function This:setModel(heroId)
	if self.m_hero:getId() ~= heroId then
		self.m_hero = HeroManager:getHero(heroId)
		self.m_soilder = self.m_hero:getSoilder(self.m_soilder:getId())
		self:refresh()
		local soilderList = {SoilderType.kShield,SoilderType.kCavalry,SoilderType.kArcher,SoilderType.kSapperCar}
		local soilder = self.m_hero:getSoilder(soilderId)
		local nodeList = self.m_container:getItemList()
		for i , view in ipairs(nodeList) do
			local soilder = self.m_hero:getSoilder(soilderList[i])
			view:setModel(soilder)
		end
	end
end

function This:selectSoilder(soilder)
	if self.m_soilder ~= soilder then
		self.m_soilder = soilder
		local soilderId = soilder:getId()
		self.m_awakeSoilder = self.m_hero:getAwakeSoilder(soilderId)
		self:refresh()
	end
end

function This:refreshAwakeSoilder()
    local soilderId = self.m_awakeSoilder:getId()
	self.m_awakeSoilder = self.m_hero:getAwakeSoilder(soilderId)
end

function This:refresh()

	--单一兵种是否达到最大等级
	self:refreshAwakeSoilder()
	local awakeSoilder = self.m_awakeSoilder
	local lv = awakeSoilder:getPhase()
	local showAwakeSoilder = self.m_soilder:getPhase()==kSoilderMaxPhase--self.m_soilder:getPhase() >= kSoilderMaxPhase

	local bzsj = self.m_csNode.bzsj
	local bzjx = self.m_csNode.bzjx
	bzsj:setVisible(showAwakeSoilder and lv==0 or (not showAwakeSoilder) )
	bzjx:setVisible(showAwakeSoilder and lv>0)

	local function refreshbzsj()
		bzsj.name:setString(SoilderTypeName[self.m_soilder:getId()], AppText:isChinese() and 10 or nil)
		bzsj.light_34:setImage(string.format("Common/bingzhonglevel/%d.png",self.m_soilder:getPhase()))
		bzsj.introduce:setString(self.m_soilder:getDesc())
		
		local attrList = {AttrType.kPower, AttrType.kDfs, AttrType.kIntelligence, AttrType.kChiefValue}
		for i , attrId in ipairs(attrList) do
			local point = self.m_soilder:getAttr(attrId)
			bzsj["num"..i]:setString(point)
		end

		bzsj.unlock:setVisible(not self.m_soilder:isUnlock())
		bzsj.yizhuangbei:setVisible(self.m_soilder:isUnlock() and self.m_hero:getCurSoilder():getId() == self.m_soilder:getId())
		bzsj.zhuangbei:setVisible(self.m_soilder:isUnlock() and self.m_hero:getCurSoilder():getId() ~= self.m_soilder:getId())

		local featureList = self.m_soilder:getAttrFeatures()
		local nextFeatureList = self.m_soilder:getNextPhaseAttrFeatures()

		for i = 1 , 3 do
			local node = bzsj["tep"..i]
			if featureList[i] <= 0 and nextFeatureList[i] > 0 then
				local featureId = nextFeatureList[i]
				local image = GameUtil:getSkillIcon(StarUpConfig[featureId].icon)
				node.icon:setImage(image)
				node:setVisible(true)
				node.text:setVisible(true)
				node.level:setString(string.format("LV:%d",StarUpConfig[featureId].level or 1))
			elseif featureList[i] > 0 then
				local featureId = featureList[i]
				local image = GameUtil:getSkillIcon(StarUpConfig[featureId].icon)
				node.icon:setImage(image)
				node:setVisible(true)
				node.text:setVisible(false)
				node.level:setString(string.format("LV:%d",StarUpConfig[featureId].level or 1))
			else
				node:setVisible(false)
			end
		end

		if self.m_soilder:isFull() then
			bzsj.culture:setVisible(false)
		else
			bzsj.culture:setVisible(true)
			bzsj.culture.text2:setVisible(false)
			bzsj.culture.text:setVisible(true)
			if self.m_soilder:isToMaxAttrPoint() then
				bzsj.culture.text:setString(Serialize[61395])
			else
				bzsj.culture.text:setString(Serialize[61396])
			end
		end
		
		bzsj.price:setString(self.m_soilder:getRecruitCost())
		bzsj.condition:setVisible(not self.m_soilder:isUnlock() or self.m_soilder:getPhase() >= kSoilderMaxPhase)
		if not self.m_soilder:isUnlock() then
			bzsj.condition:setString(string.format(Serialize[61397],SoilderTypeName[self.m_soilder:getId()],self.m_soilder:getUnlockBarrackLevel()))
			bzsj.culture:setVisible(false)
		elseif self.m_soilder:getPhase() >= kSoilderMaxPhase then
			bzsj.condition:setString(string.format(Serialize[61398]))
			bzsj.culture:setVisible(false)
		end
	end

	if showAwakeSoilder then
		local nextSoilderConfig = awakeSoilder:getConfig()
		-- if not nextSoilderConfig then
		-- 	nextSoilderConfig = awakeSoilder:getConfig()
		-- end
		local detailIdList = nextSoilderConfig.unlock_arm
		if lv==0 then
			refreshbzsj()
			--兵种觉醒按钮判断
			local isShowJuexing = false
			if lv ==0 then
				bzsj.culture:setVisible(true)
				isShowJuexing= true
			end
			bzsj.culture.text2:setVisible(isShowJuexing)
			bzsj.culture.text:setVisible(not isShowJuexing)
		else
			bzsj.price:setString(self.m_soilder:getRecruitCost())
			bzjx.name:setString(SoilderTypeName[awakeSoilder:getId()], AppText:isChinese() and 10 or nil)
			bzjx.light_34:setImage(string.format("Common/bingzhonglevel/%d.png",lv))
			for detailIndex,detailId in ipairs(detailIdList) do
				local detailConfig = awakeSoilder:getDetailsConfig(detailId)
				bzjx["bzname"..detailIndex]:setString(detailConfig.arm_name)

				bzjx["bz"..detailIndex]:setImage(string.format("Icons/Arm/%d.png",detailConfig.arm_card))
				bzjx["bz"..detailIndex]:setTag(detailId)
				bzjx["cost"..detailIndex]:setString(detailConfig.arm_cost)
				local selectSkill = awakeSoilder:getSelectSkill()
				bzjx["gouxuan"..detailIndex]:setVisible(selectSkill == detailIndex)
			end
		end

	else
		refreshbzsj()
	end
	
end

function This:onTrainSoilder(heroId,soilderId)
	self:refresh()
end

function This:onUpPhaseSoilder(heroId,soilderId)
	self:refresh()
end

function This:onAttachSoilder(heroId,soilderId)
	self:refresh()
end

function This:onUpdateSoilderAttr()
	self:refresh()
end

function This:onHeroReset()
	self:refresh()
end

function This:onGetForceAwake()
    self:refresh()
end
--endregion
