--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"Dialog")
local ItemUtil = require("Bag.ItemUtil")
local DepotManager = require("Depot.DepotManager")
local HeroManager = require("Hero.HeroManager")
local RuneManager = require("Equip.RuneManager")
local HeroUtil = require("Hero.HeroUtil")

function This:initNode(solt)
	self.m_solt = solt
	self.m_hero = solt:getHero()
	self.m_csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/PassvieUnlock.csb")
	self:addChild(self.m_csNode)
	self.m_csNode:setToCenter()
	self:refresh()
end

function This:initTouchEvent()
	self.m_csNode.closebg.close:setTouchEnded(function()
		self:close()
	end)
	self.m_csNode.quxiao:setTouchEnded(function()
		self:close()
	end)
	self.m_csNode.duihuan:setTouchEnded(function()
		local hero = self.m_hero
        local quality = hero:getQuality()
        
        if quality<Quality.kPurple or hero:isRed() then
            g_scene:showTips(Serialize["Awake_UpPanel_1"])
            return
        end
		g_scene:openDialog("Hero.PieceExchangePanel",hero)
	end)
	self.m_csNode.queding:setTouchEnded(function()
		local can ,reason = self.m_solt:isCanUnlock()
		if can then
			if not self.m_solt:isUnlockCostEnough() then
				g_scene:showTips(Serialize[61407])
				return
			end
			if self.m_solt:isRune() then
				RuneManager:onUnlockRuneSoltRequest(self.m_hero:getUid(), self.m_solt:getIndex())
			else
				HeroManager:onUnlockPsvSoltRequest(self.m_hero:getUid(), self.m_solt:getIndex())
			end
			self:close()
		else
			g_scene:showTips(reason)
		end
	end)
end

function This:refresh()
	self.m_csNode.jiesuomiaoshu:setString(string.format(Serialize[61408],self.m_solt:getIndex()))
	local itemList = self.m_solt:getUnlockCost()
	for i , item in ipairs(itemList) do
		self.m_csNode["need"..i]:setString(ItemUtil.getName(item.id) .. ":")

		local num = DepotManager:getItemOrResCount(item.id)
		if ItemUtil.getType(item.id) ~= ItemCommonType.kGameRes then
			self.m_csNode["num"..i]:setString(tostring(num) .. "/" .. item.num )
		else
			self.m_csNode["num"..i]:setString(item.num)
		end
		if num >= item.num then
			self.m_csNode["num"..i]:setColor(255,255,255)
		else
			self.m_csNode["num"..i]:setColor(255,255,0)
		end
		self.m_csNode["yes"..i]:setVisible(num >= item.num)
		self.m_csNode["no"..i]:setVisible(num < item.num)
	end
	local isPeiece = ItemUtil.getItemCategory(itemList[1].id) == ItemType.kHeroSpall
	self.m_csNode.duihuan:setVisible(isPeiece and itemList[1].num > DepotManager:getItemCount(itemList[1].id))
	self.m_csNode.icon:setImage(self.m_hero:getIcon())
	self.m_csNode.quality:setImage(QualityBigFrameFile[self.m_hero:getQuality()])
	self.m_csNode.iconbg:setImage(QualityBgFile[self.m_hero:getQuality()])
end

function This:onEnter()
	super.onEnter(self)
	HeroManager:addObserver(self)
end

function This:onExit()
	super.onExit(self)
	HeroManager:removeObserver(self)
end

function This:onExchangePiece()
	self:refresh()
end

--endregion
