--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"Dialog")
local HeroManager = require("Hero.HeroManager")

function This:initNode(info)
	self.m_heroId = info.heroId
	self.m_csNode = cc.Node:createFromCSFile("GameScene/NodeUI/QualityUp.csb")
	self:addChild(self.m_csNode)
	self.m_csNode:setToCenter()
	self:initAttr()
	self:initHeroCard()
end

function This:initTouchEvent()
end	

function This:onTouchMask()
	self:close()
end

function This:initAttr()
	local hero = HeroManager:getHero(self.m_heroId)
	local backupAttr = hero:getBackupAttr()

	local preChief = backupAttr.chief
	local chief = hero:getAttr(AttrType.kChiefValue)
	self.m_csNode.before.chief:setString(math.floor(preChief))
	self.m_csNode.after.chief:setString(math.floor(chief))

	local preGrowChief = backupAttr.growChief
	local growChief = hero:getChiefGrowValue()
	self.m_csNode.before.chiefgrowth:setString(string.format("(+%.1f)",preGrowChief))
	self.m_csNode.after.chiefgrowth:setString(string.format("(+%.1f)",growChief))

	local prePower = backupAttr.power
	local power = hero:getAttr(AttrType.kPower)
	self.m_csNode.before.power:setString(math.floor(prePower))
	self.m_csNode.after.power:setString(math.floor(power))

	local preGrowPower = backupAttr.growPower
	local growPower = hero:getPowerGrowValue()
	self.m_csNode.before.powergrowth:setString(string.format("(+%.1f)",preGrowPower))
	self.m_csNode.after.powergrowth:setString(string.format("(+%.1f)",growPower))

	local preIntelligence = backupAttr.intelligence
	local intelligence = hero:getAttr(AttrType.kIntelligence)
	self.m_csNode.before.Intelligence:setString(math.floor(preIntelligence))
	self.m_csNode.after.Intelligence:setString(math.floor(intelligence))

	local preGrowIntell = backupAttr.growIntelligence
	local growIntelligence = hero:getIntelligenceGrowValue()
	self.m_csNode.before.Intelligencegrowth:setString(string.format("(+%.1f)",preGrowIntell))
	self.m_csNode.after.Intelligencegrowth:setString(string.format("(+%.1f)",growIntelligence))
end

function This:initHeroCard()
	local hero = HeroManager:getHero(self.m_heroId)
	self.m_csNode.before.country:setImage(CountryNameFile[hero:getCountry()])
	self.m_csNode.after.country:setImage(CountryNameFile[hero:getCountry()])

	self.m_csNode.before.name:setString(hero:getName(),10)
	self.m_csNode.after.name:setString(hero:getName(),10)

	self.m_csNode.before.level:setString(hero:getLevel())
	self.m_csNode.after.level:setString(hero:getLevel())

	local backupAttr = hero:getBackupAttr()

	self.m_csNode.before.quality:setImage(QualityFrameFile[backupAttr.quality])
	self.m_csNode.after.quality:setImage(QualityFrameFile[hero:getQuality()])
	self.m_csNode.before.icon:setImage(hero:getIcon())
	self.m_csNode.after.icon:setImage(hero:getIcon())
	self.m_csNode.before.qualitybg:setImage(QualityBgFile[backupAttr.quality])
	self.m_csNode.after.qualitybg:setImage(QualityBgFile[hero:getQuality()])
	 
	for i = 1 , 5 do
		self.m_csNode.before["star"..i]:setVisible(backupAttr.starLv >= i)
		self.m_csNode.after["star"..i]:setVisible(hero:getStarLv() >= i)
	end
end

--endregion
