--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"Dialog")
local HeroManager = require("Hero.HeroManager")
local HeroConfig = require("Metadatas.HeroConfig")
local StarUpConfig = require("Metadatas.StarUpConfig")
local GameUtil = require("Util.GameUtil")
local Timer = require("Timer")

function This:initNode(info)
	self.m_heroId = info.heroId
	self.m_csNode = cc.Node:createFromCSFile("GameScene/NodeUI/StarUpTips.csb")
	self:addChild(self.m_csNode)
	self.m_csNode:setToCenter()
	self.m_timer = Timer:create(self)
	self:initAttr()
end

function This:initAttr()
	local hero = HeroManager:getHero(self.m_heroId)
	local backupAttr = hero:getBackupAttr()
	
	local preStar = backupAttr.starLv
	local starLv = hero:getStarLv()
	for i = 1 , 5 do
		self.m_csNode.after["star"..i]:setVisible(preStar >= i)
	end

	self.m_csNode.bt.shengxingtitle:setVisible(preStar ~= starLv)
	self.m_csNode.bt.shengjietitle:setVisible(preStar == starLv)
	if preStar ~= starLv then
		self:initAction(hero:getStarLv())
	end

	local phase = hero:getPhase()
	for i = 1 , 5 do
		self.m_csNode.after["piecebar"..i]:setVisible(phase >= i)
	end
 
	local preChief = backupAttr.chief
	local chief = hero:getAttr(AttrType.kChiefValue)
	self.m_csNode.before.chief:setString(math.floor(preChief))
	self.m_csNode.after.chief:setString(math.floor(chief))
	
	local growChief = hero:getChiefGrowValue()
	self.m_csNode.after.chiefgrowth:setString(string.format("(+%.2f)",growChief))

	local prePower = backupAttr.power
	local power = hero:getAttr(AttrType.kPower)
	self.m_csNode.before.power:setString(math.floor(prePower))
	self.m_csNode.after.power:setString(math.floor(power))

	local growPower = hero:getPowerGrowValue()
	self.m_csNode.after.powergrowth:setString(string.format("(+%.2f)",growPower))

	local preIntelligence = backupAttr.intelligence
	local intelligence = hero:getAttr(AttrType.kIntelligence)
	self.m_csNode.before.Intelligence:setString(math.floor(preIntelligence))
	self.m_csNode.after.Intelligence:setString(math.floor(intelligence))

	local growIntelligence = hero:getIntelligenceGrowValue()
	self.m_csNode.after.Intelligencegrowth:setString(string.format("(+%.2f)",growIntelligence))

	local growDfs = hero:getDfsGrowValue()
	self.m_csNode.after.dfsgrowth:setString(string.format("(+%.2f)",growDfs))

	local preDfs = backupAttr.dfs
	local dfs = hero:getAttr(AttrType.kDfs)
	self.m_csNode.before.dfs:setString(math.floor(preDfs))
	self.m_csNode.after.dfs:setString(math.floor(dfs))
	
	if starLv > 0 then
		local starUpId = HeroConfig[self.m_heroId].up_star[starLv]
		local attrId = StarUpConfig[starUpId].attri_id
		self.m_csNode.textdes:setString(string.format(Serialize[61411],StarUpConfig[starUpId].desc,HeroConfig[self.m_heroId].first_star_growth))
	end 
	self.m_csNode.textdes:setVisible(preStar ~= starLv)
end

function This:initAction(star)
	self.m_timer:setTimer(3,function()
		local node = self.m_csNode.after["star"..star]
		local x , y = node:getPosition()

		local eff 
		eff = GameUtil:createEffect("ShengXing",false,nil,{
			onAnimationComplete = function()
				eff:removeFromParent()	
			end
		})
		eff:setPosition(x, y)
		self.m_csNode.after:addChild(eff)

		self:runAction(cc.Sequence(
			cc.DelayTime(0.3),
			cc.CallFunc(function()
				node:setVisible(true)
			end)
		))	
	end)
end

function This:runOpenAnimation()
	local node = self.m_csNode

	self.m_runAction = true
	node:playCSAnimation(nil,false,function()
		self.m_runAction = false
		for i = 1, 4 do
			local label = node["text" .. i]
			if label then label:setOpacity(255) end
		end
	end)
	self:onOpen()
end

function This:onTouchMask()
	if not self.m_runAction then
		self:close()
	end
end

function This:update(dt)
	super.update(self,dt)
	self.m_timer:update(dt)
end
--endregion
