
local This , super = class(...,"Dialog")
local HeroManager = require("Hero.HeroManager")
local HeroRefineMergePanel = require("HeroRefine.HeroRefineMergePanel")
local DepotManager = require("Depot.DepotManager")
local ItemUtil = require("Bag.ItemUtil")
local GameUtil = require("Util.GameUtil")



function This:initData(info)
	self.m_slot = info.slot
	self.m_fragment = info.fragment
	self.m_isNoTips = false
end

function This:initNode(info)
	local csNode = cc.Node:createFromCSFile("GameScene/NodeUI/HeroTrainProblem.csb")
	self:addChild(csNode)
	csNode:setToCenter()
	self.m_csNode = csNode

	csNode.gou:setVisible(self.m_isNoTips)

	local fId = self.m_fragment.id
	local itemId = self.m_fragment.itemId
	csNode.text1:setStringWithColor( string.format(Serialize[61416], self.m_fragment.needNum) )
	csNode.text2:setStringWithColor( string.format(Serialize[61417], ItemUtil.getQuality(itemId), ItemUtil.getName(itemId)) )
	csNode.pic:setImage( GameUtil:getItemIcon(fId) )

	local width = 0
	local list = {csNode.text1, csNode.pic}
	for i, node in ipairs(list) do
		local box = node:getBoundingBox()
		width = width + box.width
	end

	local x = 0 - width/2
	for i, node in ipairs(list) do
		node:setAnchorPoint(0, 0.5)
		node:setPosition(x, 85)
		x = x + node:getBoundingBox().width
	end

	csNode.lbNum:setString(string.format(Serialize[61418], ItemUtil.getName(fId), self.m_fragment.curNum)) 
end

function This:initTouchEvent()
	--取消
	self.m_csNode.button1:setTouchEnded(function()
		self:close()
	end)

	--确定
	self.m_csNode.button2:setTouchEnded(function()
		if self.m_isNoTips then
			HeroRefineMergePanel.IsExchangeTips = false
		end

		local itemId = self.m_slot:getConfigItem().id
		HeroManager:onRefineMergeRequest(itemId)
		self:close()
	end)


	self.m_csNode.kuang:setTouchEnded(function()
		self.m_isNoTips = not self.m_isNoTips
		self.m_csNode.gou:setVisible(self.m_isNoTips)
	end)
end



--endregion
