

-- 武将精进技能

local This , super = class(..., "Base.BaseModel")
local RefinementSkillAttributeConfig = require("Metadatas.RefinementSkillAttributeConfig")
local RefinementSkillTypeConfig = require("Metadatas.RefinementSkillTypeConfig")
local RefinementUnlockConfig = require("Metadatas.RefinementUnlockConfig")


function This:init(data)
	super.init(self)
	self.m_skillId = data.skillId
	self.m_country = data.country
	self.m_refineLv = data.refineLv
	self.m_index = data.index	
end

function This:getSkillId() 
	return self.m_skillId
end

function This:getSkillConfig()
	local id = self:getSkillId()
	return RefinementSkillTypeConfig[id]
end

function This:getUnlock()
	local config = RefinementUnlockConfig[self.m_country]
	local lv = config.need_level[self.m_index]
	local isUnlock = (self.m_refineLv >= lv)
	return isUnlock, lv
end

function This:getAttr()
	local ret = {}
	local config = self:getSkillConfig()

	if config then
		for i, v in ipairs(config.attribute) do
			ret[v[1]] = v[2]
		end
	end

	return ret
end

function This:getSkillIcon()
	local config = self:getSkillConfig()
	if config then
		local icon = string.format("Icons/Skill/%s.png", config.icon_id)
		if cc.FileUtils:isFileExist(icon) then
			return icon
		else
			print(string.format("找不到精进技能图标 %s",icon))
		end
	end
	return "Icons/Skill/101.png"
end

function This:getSkillAttrAddType()
	local config = self:getSkillConfig()
	return config.type
end