

local This, super = class(...,"Dialog")
local RefinementSkillTypeConfig = require("Metadatas.RefinementSkillTypeConfig")


HeroRefineSkillAddType = {
	Country1 = 1,
	Country2 = 2,
	Country3 = 3,
	Country4 = 4,
	Single = 5,
	All = 6,
}

local AddTypeAttrText = {
	[1] = Serialize[61428],
	[2] = Serialize[61429],
	[3] = Serialize[61430],
	[4] = Serialize[61431],
	[5] = Serialize[61432],
	[6] = Serialize[61433],
}


function This:initData(skill)
	self.m_skill = skill
end

function This:initNode(skill)
    local csNode = cc.Node:createFromCSFile("GameScene/NodeUI/HeroTrainSkillInfor.csb")
    self:addChild(csNode)
    csNode:setToCenter()
    self.m_csNode = csNode

    -- 背景触摸拦截
    csNode.bg:setTouch({
        onEnded = function()
            print("bg click")
        end,
        isScale = false,
        isAlpha = false,
    })

	self:refresh()
end

function This:onTouchMask()
	self:close()    
end

function This:refresh()
	local csNode = self.m_csNode
	local config = self.m_skill:getSkillConfig()

	-- 图标
	csNode.icon:setImage( self.m_skill:getSkillIcon() )

    -- 名字
    csNode.name:setString(config.name)

    -- 等级
    csNode.lv:setString(string.format("Lv.%d", config.level))

    -- 解锁
    local isUnlock, unlockLv = self.m_skill:getUnlock()
    csNode.jiesuo:setString( string.format(Serialize[61434], unlockLv) )
    csNode.jiesuo:setVisible(not isUnlock)
    
    -- 描述
    csNode.lbDesc:setString( self:getAttrDesc(config.id) )
    csNode.lbNext:setString( self:getAttrDesc(config.id+1) ) 
end

function This:getAttrDesc(id)
	local config = RefinementSkillTypeConfig[id]
	if not config then
		return Serialize[61435]
	end

	local attribute = config.attribute
	if #attribute == 0 then
		return Serialize[61436]
	end

	local desc = ""
	local count = #attribute
	local addText = AddTypeAttrText[config.type]

	for i, attr in ipairs(attribute) do
		local attrId = attr[1]
		local attrVal = attr[2]

		if AttrInfo[attrId].valueType == ValueType.kPercent then
			desc = desc .. string.format("%s %s +%.2f%%", addText, AttrName[attrId], attrVal*100)
		else
			desc = desc .. string.format("%s %s +%d", addText, AttrName[attrId], math.floor(attrVal))
		end

		if i < count then
			desc = desc .. "\n"
		end
	end

	return desc
end
