

local This , super = class(...,"cc.Node")

function This:init(skill)
	self.m_skill = skill
	self:initNode()
end

function This:initNode()
	local csNode = cc.Node:createFromCSFile("GameScene/NodeUI/HeroTrainSkill.csb")
	self:addChild(csNode)
	self.m_csNode = csNode

    local w, h = csNode.skillbg:getContentSize()
    csNode:setPosition(w/2, h/2)
    self:setContentSize(w, h)

	self:refresh()
end

function This:initTouchEvent()
    if not self.m_inited then

		self.m_csNode.skillbg:setTouch({
	        isScale = false, 
	        isDynamic = true, 
	        onEnded = function()
	        	g_scene:openDialog("HeroRefine.HeroRefineSkillInfoPanel", self.m_skill)
	        end
	    }) 

    end
end

function This:onEnter()
	super.onEnter(self)
	self:initTouchEvent()
end

function This:setModel(skill)
	self.m_skill = skill
	self:refresh()
end

function This:refresh()
	local csNode = self.m_csNode

	if not self.m_skill then
		csNode.icon:setVisible(false)
		csNode.dengji:setVisible(false)
		csNode.count:setVisible(false)
		csNode.lock:setVisible(false)
		return
	end

	local config = self.m_skill:getSkillConfig()
	if not config then
		return
	end

	local isUnlock, unlockLv = self.m_skill:getUnlock()
	csNode.icon:setVisible(true)
	csNode.icon:setImage( self.m_skill:getSkillIcon() )
	csNode.dengji:setString(string.format("Lv.%d", config.level))
	csNode.dengji:setVisible(isUnlock)
	csNode.count:setString(string.format(Serialize[61438], unlockLv))
	csNode.count:setVisible(not isUnlock)
	csNode.lock:setVisible(not isUnlock)

	if isUnlock then
		csNode.icon:clearShader()
	else
		csNode.icon:setGrayShader()
	end
end

