

local This , super = class(...,"cc.Node")
local GameUtil = require("Util.GameUtil")
local ItemUtil = require("Bag.ItemUtil")

function This:init(slot)
	self:initData(slot)
	self:initNode()
end

function This:initData(slot)
	self.m_slot = slot
	if slot then
		self.m_isCanWear = slot:isCanWear()
		self.m_isCanMerge = slot:isCanSlotMerge()
		self.m_isMaxRefineLv = slot:isMaxRefineLv()
		--print(string.format("%s: %s %s %s", slot:getId(), self.m_isCanWear, self.m_isCanMerge, self.m_isMaxRefineLv))
	end
end

function This:initNode()
	self.m_csNode = cc.Node:createFromCSFile("GameScene/NodeUI/HeroTrainItem.csb")
	self:addChild(self.m_csNode)

	self:refresh()
end

function This:initTouchEvent()
    if not self.m_inited then

		self.m_csNode.bg:setTouch({
	        isScale = false, 
	        isDynamic = true, 
	        onEnded = function()
	        	self:onSlotClick()
	        end
	    }) 
    end
end

function This:onEnter()
	super.onEnter(self)
	self:initTouchEvent()
end

function This:setModel(slot)
	self:initData(slot)
	self:refresh()
end

function This:refresh()
	local csNode = self.m_csNode
	
	if not self.m_slot or self.m_isMaxRefineLv then
		csNode.jiahao:setVisible(false)
		csNode.kezhuangbei:setVisible(false)
		csNode.kehecheng:setVisible(false)
		csNode.wu:setVisible(false)
		csNode.lbNum:setVisible(false)
		csNode.tuan:setVisible(false)
		return
	end

	local item = self.m_slot:getConfigItem()
	local curNum = self.m_slot:getItemNum()
	local needNum = item.num

	if self.m_isCanWear then
		csNode.jiahao:setVisible(true)
		csNode.kezhuangbei:setVisible(true)
		csNode.kehecheng:setVisible(false)
		csNode.wu:setVisible(false)
	elseif self.m_isCanMerge then
		csNode.jiahao:setVisible(true)
		csNode.kezhuangbei:setVisible(false)
		csNode.kehecheng:setVisible(true)
		csNode.wu:setVisible(false)
	else
		csNode.jiahao:setVisible(false)
		csNode.kezhuangbei:setVisible(false)
		csNode.kehecheng:setVisible(false)
		csNode.wu:setVisible(curNum <= 0)
	end

	csNode.tuan:setVisible(true)

	csNode.tuan:setImage( ItemUtil.getIconImage(item.id) )
	if curNum <= 0 then
		csNode.tuan:setGrayShader()
	else
		csNode.tuan:clearShader()
	end

	csNode.lbNum:setString(string.format("(%d/%d)", curNum, needNum))
	csNode.lbNum:setVisible(needNum > 1)
end

function This:onSlotClick()
	if not self.m_slot then
		return
	end

	if self.m_isMaxRefineLv then
		return
	end

	if self.m_isCanWear then
		g_scene:openDialog("HeroRefine.HeroRefineWearPanel", self.m_slot)
		return
	end

	if not self.m_slot:isWearFull() then
		g_scene:openDialog("HeroRefine.HeroRefineMergePanel", self.m_slot)
	end
end