

-- 战法全体属性

local This, super = class(...,"Base.BaseModel")


HeroTacticsSuitAddType = {
	Country1 = 1,
	Country2 = 2,
	Country3 = 3,
	Country4 = 4,
	Single = 5,
	All = 6,
}


function This:init()
	super.init(self)

	self.m_attr = {}
	self.m_record = {}
end

-- 国家属性
function This:getCountryAttr(id)
	return self.m_attr[id] or {}
end

-- 全体属性
function This:getTotalAttr()
    return self.m_attr[HeroTacticsSuitAddType.All] or {}
end

function This:getRecord(heroId)
	return self.m_record[heroId]
end

function This:updateHeroTacticsSuitAttr(heroId, addAttrs)
	local record = self:getRecord(heroId)
	if record then
		for addType, attrs in pairs(record) do
			if addType ~= HeroTacticsSuitAddType.Single then
				local addTypeTb = self.m_attr[addType]
				if addTypeTb then
					for id, val in pairs(attrs) do
						local num = (addTypeTb[id] or 0) - val
						if num < 0 then
							num = 0
						end
						addTypeTb[id] = num
					end
				end
			end
		end
	end
	self.m_record[heroId] = addAttrs

	for addType, attrs in pairs(addAttrs) do
		if addType ~= HeroTacticsSuitAddType.Single then
			if not self.m_attr[addType] then
				self.m_attr[addType] = {}
			end
			local addTypeTb = self.m_attr[addType]
			for id, val in pairs(attrs) do
				addTypeTb[id] = (addTypeTb[id] or 0) + val
			end
		end
	end	

	--print("updateHeroTacticsSuitAttr", heroId)
	--print(addAttrs)
end