

local This , super = class(...,"cc.Node")
local ItemNode = require("UI.ItemNode")


function This:init(info)
	self.m_skill = nil

	self:setAnchorPoint(0.5, 0.5)
	self:setContentSize(80, 80)
	self:refresh()
end

function This:initTouchEvent()
    if not self.m_inited then
    	self.m_inited = true

		self:setTouch({
	        isScale = false, 
	        isDynamic = true, 
	        onEnded = function()
	        	g_scene:openDialog("HeroTactics.HeroTacticsSkillPanel", {skill = self.m_skill})
	        end
	    })
    end
end

function This:onEnter()
	super.onEnter(self)
	self:initTouchEvent()
end

function This:setModel(skill)
	self.m_skill = skill
	self:refresh()
end

function This:refresh()
	if not self.m_skill then
		return
	end

	local config = self.m_skill:getSkillConfig()
	if not config then
		if self.m_itemNode then
			self.m_itemNode:setVisible(false)
		end
		return
	end

	-- 图片
	local heroId = self.m_skill:getHero():getId()
	if not self.m_itemNode then
		local node = ItemNode:create(heroId)
		local w, h = self:getContentSize()
		node:setTouchEnable(false)
		node:setScale(0.8)
		node:setAnchorPoint(0.5, 0.5)
		node:setPosition(w/2, h/2)
		self:addChild(node)
		self.m_itemNode = node
	else
		self.m_itemNode:setVisible(true)
		self.m_itemNode:setModel({id = heroId})
	end

	self.m_itemNode:setShowGray( not self.m_skill:isActivate() )
end