
-- 战法技能信息

local This, super = class(...,"Dialog")
local HeroConfig = require("Metadatas.HeroConfig")
local ItemNode = require("UI.ItemNode")


function This:initData(info)
	self.m_skill = info.skill
end

function This:initNode(info)
    local csNode = cc.Node:createFromCSFile("GameScene/NodeUI/HeroTacticsSkill.csb")
    self:addChild(csNode)
    csNode:setToCenter()
    self.m_csNode = csNode

    self:refresh()
end

function This:initTouchEvent()
    if not self.m_inited then
    	local csNode = self.m_csNode
    	self.m_inited = true

    	-- 关闭
        csNode.bg:setTouch({
            isScale = false,
            isAlpha = false,
            onEnded = function ()
                return
            end
        })

	end
end

function This:onTouchMask()
    self:close()
end	 

function This:refresh()
	local csNode = self.m_csNode
	local config = self.m_skill:getSkillConfig()
	if not config then
		return
	end

	-- 图片
	local heroId = self.m_skill:getHero():getId()
	if not self.m_itemNode then
		local node = ItemNode:create(heroId)
		node:setTouchEnable(false)
		node:setScale(0.8)
		node:setAnchorPoint(0.5, 0.5)
		node:setPosition( csNode.item:getPosition() )
		csNode:addChild(node)
		self.m_itemNode = node
	else
		self.m_itemNode:setModel({id = heroId})
	end

	-- 名字
	csNode.itemname:setString(config.name)

	-- 属性
	csNode.shuxing:setStringWithColor( self:getAttrDesc(config.arg) )

	-- 条件
	local condition = self.m_skill:getConditionConfig()
	csNode.condition:setString(string.format(Serialize[61467], condition.count, condition.star, QualityText[condition.quality]))
end

function This:getAttrDesc(attrList)
	local count = #attrList
	local attrDesc = ""

	for i, v in ipairs(attrList) do
		local attrId, attrVal = v[1], v[2]
	    if AttrInfo[attrId].valueType == ValueType.kPercent then
	        attrDesc = attrDesc .. string.format("<New1>%s <New9>+%.2f%%", AttrName[attrId], attrVal*100)
	    else
	        attrDesc = attrDesc .. string.format("<New1>%s <New9>+%d", AttrName[attrId], math.floor(attrVal))
	    end
	    if i < count then
	    	attrDesc = attrDesc .. "\n"
	    end
	end

	return attrDesc
end