

local This , super = class(...,"cc.Node")
local GameUtil = require("Util.GameUtil")
local ItemUtil = require("Bag.ItemUtil")
local ItemNode = require("UI.ItemNode")
local ViewUtil = require("UI.ViewUtil")


function This:init(info)
	self.m_csNode = info.node
	self.m_slot = nil
	self.m_showType = 0 --0战法，1精练
	self.m_isSelect = false
	self.m_itemNode = nil
	self.m_lineEffect = nil

	self.m_csNode.xuanzhong:setLocalZOrder(2)

	self:refresh()
end

function This:initTouchEvent()
    if not self.m_inited then
    	self.m_inited = true

		self.m_csNode.bg:setTouch({
	        isScale = false, 
	        isDynamic = true, 
	        onEnded = function()
	        	self:onSlotClick()
	        end
	    }) 
    end
end

function This:onSlotClick()
	local slot = self.m_slot
	if not slot then
		return
	end

	if self.m_showType ~= 0 then
		return
	end

	if slot:isWear() then
		g_scene:openDialog("HeroTactics.HeroTacticsInfoPanel", {slot = slot})
	else
		if slot:isUnlock() then
			g_scene:openDialog("HeroTactics.HeroTacticsChoosePanel", {slot = slot})
		else
			g_scene:showTips( string.format(Serialize[61365], slot:getUnlockLv()) )
		end
	end
end

function This:onEnter()
	super.onEnter(self)
	self:initTouchEvent()
	self.m_csNode.xuanzhong:runAction(cc.RepeatForever(cc.Sequence(cc.FadeOut(0.6),cc.FadeIn(0.6))))
end

function This:setModel(slot)
	self.m_slot = slot
	self:refresh()
end

function This:setShowTyle(style)
	self.m_showType = style
end

function This:setSelect(isSelect)
	self.m_isSelect = isSelect
	self.m_csNode.xuanzhong:setVisible(isSelect)
end

function This:refresh()
	if self.m_showType == 0 then
		self:showTacticsStyle()
	else
		self:showRefineStyle()
	end
end

-- 战法
function This:showTacticsStyle()
	local csNode = self.m_csNode
	local slot = self.m_slot
	local isHasData = (slot ~= nil)

	self:setNodeListVisible(csNode, {"lineBg", "line", "add", "suo", "lv", "qianghuanum", "xuanzhong"}, isHasData)

	if not isHasData then
		return
	end	

	if slot:isWear() then
		local item = slot:getItem()
		if not self.m_itemNode then
			local node = ItemNode:create(item:getId())
			node:setAnchorPoint(0.5, 0.5)
			node:setPosition(0, 1)
			node:setScale(0.87)
			node:setTouchEnable(false)
			csNode:addChild(node)
			self.m_itemNode = node
		else
			self.m_itemNode:setModel({id = item:getId()})
			self.m_itemNode:setVisible(true)
		end

		if not self.m_lineEffect then
			local w ,h = csNode.line:getContentSize()
			local effect = GameUtil:createEffect("FSHC_ShuSong", true)
			effect:setPosition(w/2, h/2)
        	csNode.line:addChild(effect)
        	self.m_lineEffect = effect	
		end
		csNode.line:setVisible( slot:isActivate() )
		self:setNodeListVisible(csNode, {"add", "suo", "lv", "qianghuanum", "xuanzhong"}, false)
	else
		local isUnlock = slot:isUnlock()
		csNode.add:setVisible(isUnlock)
		csNode.suo:setVisible(not isUnlock)
		csNode.lv:setVisible(not isUnlock)
		csNode.lv:setString( string.format(Serialize[60312], slot:getUnlockLv()) )
		
		if self.m_itemNode then
			self.m_itemNode:setVisible(false)
		end
		self:setNodeListVisible(csNode, {"line", "qianghuanum", "xuanzhong"}, false)
	end
end

-- 精练
function This:showRefineStyle()
	local csNode = self.m_csNode
	local slot = self.m_slot
	local isHasData = (slot ~= nil)

	self:setNodeListVisible(csNode, {"lineBg", "line", "add", "suo", "lv", "qianghuanum", "xuanzhong"}, isHasData)

	if not isHasData then
		return
	end

	if self.m_itemNode then
		self.m_itemNode:setVisible(false)
	end
	self:setNodeListVisible(csNode, {"lineBg", "line", "add", "suo", "lv"}, false)

	csNode.xuanzhong:setVisible(self.m_isSelect)	
	csNode.qianghuanum:setVisible(true)
	csNode.qianghuanum:setString( string.format("+%d", slot:getPosLv()) )
end

function This:setNodeListVisible(parent, list, visible)
	for i, name in ipairs(list) do
		local node = parent[name]
		if node then
			node:setVisible(visible)
		end
	end
end

