

local This , super = class(...,"NodeUI")


function This:initData(info)
	self.m_suit = info.suit
    self.m_list = info.list
end

function This:initNode(data)
    local csNode = cc.Node:createFromCSFile("GameScene/NodeUI/HeroTacticsSoulList.csb")
    self:addChild(csNode)
    self.m_csNode = csNode

    local w, h = csNode.bg:getContentSize()
    csNode:setPosition(w/2, h/2)
    self:setContentSize(w, h)
end

function This:initTouchEvent()

end

function This:onEnter()
    super.onEnter(self)
    self:refresh()
end

function This:setModel(info)
	self.m_suit = info.suit
    self.m_list = info.list
    self:refresh()
end

function This:refresh()
	local csNode = self.m_csNode
	local list = self.m_list

	local suitName = list[1].name
	local needQual = list[1].quality
	csNode.name:setStringWithColor( string.format(Serialize[61479], suitName, QualityText[needQual]) )

	local isActSuit = false
	for i, v in ipairs(list) do
		if v.isActivate then
			isActSuit = true
			break
		end
	end
	csNode.itemBg:setVisible(isActSuit)
	csNode.zhuangtai:setVisible(isActSuit)
	csNode.itemBgwei:setVisible(not isActSuit)
	csNode.zhuangtaiwei:setVisible(not isActSuit)

	local colorGray = isActSuit and "New3" or "Gray"

	for i=1, 4 do
		local label = csNode[string.format("text%d", i)]
		local info = list[i]
		if label and info then
			local colorTxt, colorNum = "New13", "New9"
			if not info.isActivate then
				colorTxt, colorNum = colorGray, colorGray
			end
			local condDesc = self:getConditionDesc(info.count, info.quality, info.star, colorTxt)
			local attrDesc = self:getAttrDesc(info.attrType, info.attrList, colorTxt, colorNum)
			label:setStringWithColor( string.format("%s    %s", condDesc, attrDesc) )
		end
	end

end

function This:getConditionDesc(count, quality, star, colorTxt)
	return string.format(Serialize[61480], colorTxt, count, star)
end

function This:getAttrDesc(attrType, attrList, colorTxt, colorNum)
	local typeText = self.m_suit:getAddTypeAttrText(attrType)
	local attrDesc = ""
	local count = #attrList

	for i, v in ipairs(attrList) do
		local attrId, attrVal = v[1], v[2]
	    if AttrInfo[attrId].valueType == ValueType.kPercent then
	        attrDesc = attrDesc .. string.format("<%s>%s<%s>+%.2f%%", colorTxt, AttrName[attrId], colorNum, attrVal*100)
	    else
	        attrDesc = attrDesc .. string.format("<%s>%s<%s>+%d", colorTxt, AttrName[attrId], colorNum, math.floor(attrVal))
	    end
	    if i < count then
	    	attrDesc = attrDesc .. "    "
	    end
	end

	return string.format("<%s>%s：%s", colorTxt, typeText, attrDesc)
end
