--region *.lua
--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"cc.Node")
local HeroManager = require("Hero.HeroManager")
local EquipManager = require("Equip.EquipManager")
local GamePlayer = require("Player.GamePlayer")
local GameUtil = require("Util.GameUtil")
local RoleLevelConfig = require("Metadatas.RoleLevelConfig")
local ChatManager = require("Chat.ChatManager")
local SystemManager = require("System.SystemManager")
local TerrBuildManager = require("Territory.TerrBuildManager")
local TerrBuildQueueView = require("Territory.TerrBuildQueueView")
local FriendManager = require("Friend.FriendManager")
local AchieveManager = require("Achieve.AchieveManager")
local VipManager = require("Vip.VipManager")
local ViewUtil = require("UI.ViewUtil")
local WarfareUtil = require("Warfare.WarfareUtil")
local EventDispatcher = require("EventDispatcher")
local MatchManager = require("Match.MatchManager")
local WorldMapManager = require("World.WorldMapManager")
local MarchDangerView = require("World.MarchDangerView")
local GuideManager = require("Guide.GuideManager")
local MenuBtnHelper = require("Home.MenuBtnHelper")
local PopDialogManager = require("UI.PopDialogManager")
local WarfareManager = require("Warfare.WarfareManager")
local FunctionNoticeManager = require("Function.FunctionNoticeManager")
local DepotManager = require("Depot.DepotManager")
local EntrantManager = require("LegionEntrant.EntrantManager")


function This:init()
    self.m_chatHistory = {}
	self.m_chatNodeList = {}
	self.m_escape = 0
end

function This:onEnter()
    super.onEnter(self)
	self:setName("sceneUI")
    self:initUI()
    self:initChat()
    self:refreshSunshineEffect(true)
	self:refresh()
	self:refreshGirlGuide()
	self:refreshRecommendAchieve()
	self:refreshGongXunAchieve()
	self:refreshCopyAchieve()
	self:refreshFunctionNotice()
	self:addMapManager()
	self:initTouchEvent()
	ChatManager:addObserver(self)
	GamePlayer:addObserver(self)
	TerrBuildManager:addObserver(self)
	FriendManager:addObserver(self)
	AchieveManager:addObserver(self)
	VipManager:addObserver(self)
	GuideManager:addObserver(self)
	MatchManager:addObserver(self)
	HeroManager:addObserver(self)
	SystemManager:addObserver(self)
	WarfareManager:addObserver(self)
	DepotManager:addObserver(self)
end

function This:addMapManager()
	self:initDangerous()
	WorldMapManager:addObserver(self)
end

function This:removeMapManager()
	WorldMapManager:removeObserver(self)
end

function This:onExit()
	super.onExit(self)
    HeroManager:removeObserver(self)
    SystemManager:removeObserver(self)
    VipManager:removeObserver(self)
    ChatManager:removeObserver(self)
	GamePlayer:removeObserver(self)
	TerrBuildManager:removeObserver(self)
	FriendManager:removeObserver(self)
	AchieveManager:removeObserver(self) 
	GuideManager:removeObserver(self)
	MatchManager:removeObserver(self)
	WarfareManager:removeObserver(self)
	DepotManager:removeObserver(self)
	self:removeMapManager()
end

function This:initUI()
    self.m_csNode = cc.Node:createFromCSFile("GameScene/NodeUI/HomeUI.csb")
	self.m_csNode.huodong:recoveryToFixedWidth("right","top")
	self.m_csNode.panel_btns:recoveryToFixedWidth("right","bottom")
	self.m_csNode.player_info:recoveryToFixedWidth("left","top")
	self.m_csNode.res_info:recoveryToFixedWidth("left","top")
	self.m_csNode.chat_node:recoveryToFixedWidth("left","bottom")
	self.m_csNode.close_bg:recoveryToFixedWidth("right","bottom")
	self.m_csNode.huodong_button:recoveryToFixedWidth("right","top")
	self.m_csNode.uieffect:recoveryToFixedWidth("right","top")
	self.m_csNode.paiwei:recoveryToFixedWidth("right","bottom")
	self.m_csNode.Dangerous:recoveryToFixedWidth("right","bottom")
	self.m_csNode.build_queue:recoveryToFixedWidth("right","bottom")
	if self.m_csNode["function"] then
		self.m_csNode["function"]:recoveryToFixedWidth("right","top")
	end
	self:fixUniqueNodes()

	self.m_btnHelper = MenuBtnHelper:create(self)
    self:addChild(self.m_csNode) 
	self:refreshPaiWeiBtnEffect()
	self.m_btnHelper:refresh(true)
	HeroManager:calcSaintFightPower()
end

function This:fixUniqueNodes()
	self.m_csNode.people:recoveryToFixedWidth("right","top")
	self.m_csNode.Recommend:recoveryToFixedWidth("left","top")
	if GamePlayer:isIPhioneX() then
		self.m_csNode.Recommend:setPositionX(50)
	end
end

function This:initTouchEvent()
	local csNode = self.m_csNode
	local chatBg = csNode.chat_node.chat
    chatBg:setTouch({
		onEnded = function()
			local dialog = g_scene:openDialog("Chat.ChatPanel",{})
		end,
		isScale = false
	})
    local resInfor= csNode.res_info
    if resInfor then
		if resInfor.vigor then
			resInfor.vigor:setTouchEnded(function()
				if SystemManager:getPowerIsFull() then
	            	g_scene:showTips(Serialize["System_SystemManager_1"])
				elseif SystemManager:canBuyPower() then
	                g_scene:openDialog("System.BuyPowerMain")
	            else
	                g_scene:showTips(Serialize["power_buy_times_limit"])
	            end
			end)
		end    
		
		if resInfor.gold then
			resInfor.gold:setTouchEnded(function()
	            GamePlayer:checkGold({nocheck = true, nowarming = true})
			end)
		end   
		 
		resInfor.recharge:setTouch({
			onEnded = function()
		        g_scene:openDialog("System.RechargeMainUI")
		    end,
		    isDynamic = true,
		})

		if resInfor.email then
			resInfor.email:setTouch({
				onEnded = function()
					g_scene:openDialog("Mail.MailMainUI")
				end,
				isScale = false,
				isDynamic = true
			})
		end

		if resInfor.setting then
			resInfor.setting:setTouch({
				onEnded = function()
					g_scene:openDialog("Player.SettingPanel")
				end,
				isScale = false,
				isDynamic = true
			})
		end

		if resInfor.help then
			resInfor.help:setTouch({
				onEnded = function()
					g_scene:openDialog("UI.HelpPanel")
				end,
				isScale = false,
				isDynamic = true
			})
		end
    end
	local playerInfo = csNode.player_info
	playerInfo.touxiangbg:setTouchEnded(function()
        g_scene:openDialog("Player.RoleInfoPanel",{id=GamePlayer:getPlayerID()})
	end)

	playerInfo.vip.vipbg:setTouchEnded(function()
		g_scene:openDialog("Vip.VipPanel")
	end)

	playerInfo.vip.novip:setTouchEnded(function()
		g_scene:openDialog("Vip.VipPanel")
	end)

	playerInfo.zhanli.bg_zhanlidi:setTouchEnded(function()
		g_scene:openDialog("Function.FunctionMainPanel")
	end)

	if csNode.paiwei then
		csNode.paiwei:setTouch({
			isScale = false, 
			isDynamic = true, 
			onEnded = function()
				if GamePlayer:isInKingMap() then
					g_scene:showTips(Serialize[60592])
					return
				end

				if EntrantManager:isJoinKingWar() then
					g_scene:showTips(Serialize[60593])
					return
				end

				if not GamePlayer:isInWorld() then
					g_scene:openDialog("Match.MatchPanel")
				else
					cc.SceneManager:switchTo("World.WorldScene")
				end
		    end
		})
	end

	if csNode.close_bg then
		-- self.m_csNode.close_bg:setTouchEnded(function()
		-- 	local isVisible = not self.m_csNode.panel_btns.bg2:isVisible()
		-- 	self:showPanelBtns(isVisible)
		-- end)

		csNode.close_bg:setTouchEnded(function(_, touch, callback)
			local isVisible = not self.m_csNode.panel_btns.bg2:isVisible()
			local info = {
			    value = isVisible,
				hasAnimation = false,
			    callbackList = { 
			        node_handler = function() 
						self:showPanelBtns(isVisible)
					end, 
			        other_handler = callback,
				    start_index = 8,
			    }
			} 

			self.m_csNode.close_bg:playBehaviourSwitchAnimation(info)
		end)
		csNode.close_bg:setAngle(180)
	end

	
	if csNode.huodong_button then
		csNode.huodong_button:setTouchEnded(function(_, touch, callback)
			local isVisible = not self.m_csNode.huodong:isVisible()
			local info = {
			    value = isVisible,
			    callbackList = { 
			        node_handler = function() 
					    self:showActivityBtns(isVisible)
					end, 
			        other_handler = callback,
			    }
			} 

			self.m_csNode.huodong_button:playBehaviourSwitchAnimation(info)
		end)
		EventDispatcher:dispatcher("huodong_switch_changed", true)
		csNode.huodong_button:setAngle(180)
	end
	local panelBtns = self.m_csNode.panel_btns
	if panelBtns then
		if panelBtns.stage then
			panelBtns.stage:setTouch({
				isScale = false, 
				isDynamic = true, 
				onEnded = function()
			       if testRunStr then
    					if testRunAttr then
    						g_scene:openDialog(testRunStr,testRunAttr)
    					else
    		        		g_scene:openDialog(testRunStr)
    					end
    		        else
    			        g_scene:openDialog("Stage.StagePanel")
    		        end
				end
			})
		end
		
	    if panelBtns.friend then	
			panelBtns.friend:setTouch({
				isScale = false, 
				isDynamic = true, 
				onEnded = function()
					g_scene:openDialog("Friend.FriendPanel")
				end
			})
		end

	    if panelBtns.family then	
			panelBtns.family:setTouch({
				isScale = false, 
				isDynamic = true, 
				onEnded = function()
					g_scene:openDialog("Family.FamilyPanel")
				end
			})
		end

	    if panelBtns.zhenfa then
			panelBtns.zhenfa:setTouch({
				isScale = false, 
				isDynamic = true, 
				onEnded = function()
					g_scene:openDialog("Hero.CountryArrayPanel")
			    end
			})
		end
		
		if panelBtns.hero then
			panelBtns.hero:setTouch({
				isScale = false, 
				isDynamic = true, 
				onEnded = function()
					g_scene:openDialog("Hero.HeroListPanel")
				end
			})
		end

		if panelBtns.empero then
			panelBtns.empero:setTouch({
				isScale = false, 
				isDynamic = true, 
				onEnded = function()
					g_scene:openDialog("Awake.LordPanel")
				end
			})
		end

		if panelBtns.huishou then
			panelBtns.huishou:setTouch({
				isScale = false, 
				isDynamic = true, 
				onEnded = function()
					g_scene:openDialog("Bag.RecyclePanel")
				end
			})
		end

		if panelBtns.task then
			panelBtns.task:setTouch({
				isScale = false, 
				isDynamic = true, 
				onEnded = function()
					g_scene:openDialog("Achieve.AchieveMainPanel")
				end
			})
		end

		if panelBtns.jice then
			panelBtns.jice:setTouch({
			    isScale = false, 
				isDynamic = true, 
				onEnded = function()
					g_scene:openDialog("PlanShop.PlanShopPanel")
			    end,
			})
		end

		if panelBtns.prop then
			panelBtns.prop:setTouch({
				isScale = false, 
				isDynamic = true, 
				onEnded = function()
					g_scene:openDialog("Depot.DepotMainUI")
				end
			})
		end

		if panelBtns.recruit then
			panelBtns.recruit:setTouch({
				isScale = false, 
				isDynamic = true, 
				onEnded = function()
					g_scene:openDialog("Recruit.RecruitPanel")
				end
			})
		end

		if panelBtns.shop then
			panelBtns.shop:setTouch({
				isScale = false, 
				isDynamic = true, 
				onEnded = function()
			        g_scene:openDialog("Store.StoreMainPanel")
				end
			})
		end
			
		if panelBtns.paihang then
			panelBtns.paihang:setTouch({
				isScale = false, 
				isDynamic = true, 
				onEnded = function()
					g_scene:openDialog("Rank.RankMainPanel")
				end
			})
		end
		if panelBtns.mythicalanimals then
			panelBtns.mythicalanimals:setTouchEnded(function()
				g_scene:openDialog("GodBeast.MythicalAnimalsPanel")
			end)
		end
		if panelBtns.lordequip then
			panelBtns.lordequip:setTouchEnded(function()
				g_scene:openDialog("Awake.LordEquipPanel")
			end)
		end

		if panelBtns.planbtn then	
			panelBtns.planbtn:setTouch({
				isScale = false, 
				isDynamic = true, 
				onEnded = function()
					g_scene:openDialog("Family.FamilyPlanPanel")
				end
			})
		end
	end
	local huodong = csNode.huodong
	if huodong then
		huodong.activity:setTouchEnded(function()
			g_scene:openDialog("Activity.ActivityPanel")
		end)
		
		huodong.office:setTouchEnded(function()
			g_scene:openDialog("Match.MatchOfficePanel")
		end)

		huodong.greatEvent:setTouchEnded(function()
			g_scene:openDialog("Achieve.TianXiaAchievePanel")
		end)

		if huodong.huanggong then
			huodong.huanggong:setTouch({
				onEnded = function()
			        g_scene:openDialog("Official.OfficialPanel")
				end,
				isScale = false
			})
		end
		if huodong.gift then
			huodong.gift:setTouch({
				onEnded = function()
			        g_scene:openDialog("Achieve.GiftMainPanel")
				end,
				isScale = false
			})
		end
	end

	local recommend = self.m_csNode.Recommend
	if recommend then
		recommend.main.bg:setTouch({
			onEnded = function()
                local mainAchieve = AchieveManager:getCurMainAchieve()
                if mainAchieve then
				    g_scene:openDialog("Achieve.MainLineAchievePanel")
                end
			end,
			isScale = false
		})
		recommend.main.bg1:setTouch({
			onEnded = function()
				local isShow = recommend.main.bg:isVisible()
				recommend.main.bg:setVisible(not isShow)
				recommend.main.text:setVisible(not isShow)
				-- g_scene:openDialog("Achieve.MainLineAchievePanel")
				if self.m_achieveEffect then
					self.m_achieveEffect:setVisible(not isShow)
				end
				EventDispatcher:dispatcher("task_switch_click", not isShow)
			end,
			isScale = false
		})

		recommend.gongxun.bg4:setTouchEnded(function()
			local gongxun = AchieveManager:getGongXun()
			local maxGongXun = AchieveManager:getMaxGongXun()
			local hasReward = AchieveManager:hasGongXunBoxReward()
			if gongxun >= maxGongXun and hasReward then
				g_scene:showTips(Serialize[61488])
			else
				g_scene:openDialog("Achieve.GongXunAchievePanel")
			end
		end)

		recommend.gongxun.bg3:setTouchEnded(function()
			local isShow = recommend.gongxun.bg4:isVisible()
			recommend.gongxun.bg4:setVisible(not isShow)
			recommend.gongxun.text_0:setVisible(not isShow)
			if self.m_gongxunEffect then
				self.m_gongxunEffect:setVisible(not isShow)
			end
		end)

		if recommend.fuben then
			recommend.fuben.bg5:setTouchEnded(function ()
				print("点击组队副本")
				if WarfareManager:hasTeam() or WarfareManager:hasTeam(TeamType.kTowerTeam) then
					local team = WarfareManager:getMyTeam() or WarfareManager:getMyTeam(TeamType.kTowerTeam)
					local build = TerrBuildManager:getBuildByType(TerrBuildType.kJiaoChang)
					if  WarfareManager:hasTeam() then
						local nowWar = team:getWar()
						if build:getHelpListCount() > 0 then
							build:onHelpFuncionEvent()
						end
						if nowWar:getType() == WarfareType.kAnimal then
							ViewUtil:jumpToPanel("TeamWarfarePanel", {tab = 4,args = {war = nowWar}})
						else
							g_scene:openDialog("Warfare.TeamWarfarePanel",{war = nowWar})
						end
					elseif WarfareManager:hasTeam(TeamType.kTowerTeam) then
						g_scene:openDialog("SingleDaily.TowerPanel")
					end
				else
					g_scene:showTips(Serialize[61489])
				end
			end)

			recommend.fuben.bg6:setTouchEnded(function()
				local isShow = recommend.fuben.bg5:isVisible()
				recommend.fuben.bg5:setVisible(not isShow)
				recommend.fuben.text_0:setVisible(not isShow)
				self:refreshCopyAchieve()
				if self.m_fubenEffect then
					self.m_fubenEffect:setVisible(not isShow)
				end
			end)

		end
	end

	if csNode.people then
		csNode.people.content.fresh:setTouchEnded(function()
			self:refreshGirlGuide(true)
		end)
		csNode.people.icon:setTouchEnded(function()
			local isVisible = self.m_csNode.people.content:isVisible()
			self.m_csNode.people.content:setVisible(not isVisible)
		end)

		-- playerInfo.zhanli.bg_zhanlidi:setTouchEnded(function()
		-- 	g_scene:openDialog("Hero.SaintStrongInfoPanel")
		-- end)
	end


	if csNode["function"] then
		csNode["function"].tubiaodi:setTouchEnded(function ()
			self:onFunctionNoticeClick()
		end)
	end
end

function This:refresh(field)
	if field == nil or field == PlayerAttr.level then
		self.m_csNode.player_info.level:setString(GamePlayer:getLevel())
	end
	if field == nil or field == PlayerAttr.name then
		self.m_csNode.player_info.name:setString(GamePlayer:getRoleName())
	end
	if field == nil  or field == PlayerAttr.icon then
		local icon = self.m_csNode.player_info.icon
		GameUtil:setPlayerIconNodeImage(icon, GamePlayer:getIcon())
	end

	if field == nil  or field == PlayerAttr.effect then
		local icon = self.m_csNode.player_info.icon
		GameUtil:setPlayerEffectNodeTo(icon, GamePlayer:getEffect())
	end

	local res_info = self.m_csNode.res_info
	if res_info then
		if field == nil or field == PlayerAttr.gold then
			res_info.money:setString(math.floor(GamePlayer:getGold()))
		end
		if field == nil or field == PlayerAttr.diamond then
			res_info.diamond:setString(math.floor(GamePlayer:getDiamond()))
		end
		if (field == nil or field == PlayerAttr.power) and res_info.vigor1 then
			res_info.vigor1:setString(string.format("%d/%d", GamePlayer:getPower(), kMaxPower))
		end
	end

	if field == nil or field == PlayerAttr.exp then
		local level = GamePlayer:getLevel()
		if level < kMaxLevel then
			local limit = RoleLevelConfig[level + 1].exp
			self.m_csNode.player_info.exp:setPercent(GamePlayer:getExp() / limit * 100)
		else
			self.m_csNode.player_info.exp:setPercent(100)
		end		
	end

	self:onMatchRankLvChanged()
    self:refreshTerrBuildQueues()
	self:refreshVipState()
	self:refreshSaintPower()
	if res_info then
		self:refreshRechargeReward()
	end
end

--------------聊天-------------------------
function This:initChat()
	local w , h = self.m_csNode.chat_node.chatbg:getContentSize()
	local layer = cc.LayerColor:create(cc.Color(255,255,255,255))
	layer:setContentSize(w,h)
	self.m_chatContainer = cc.ClippingNode:create(layer)
	self.m_chatContainer:setContentSize(w,h)
	self.m_csNode.chat_node:addChild(self.m_chatContainer)
	local panel_btns= self.m_csNode.panel_btns
	if panel_btns then
		self.m_csNode.panel_btns.friend.hongdian:setVisible(false)
	end

	local chatList = ChatManager:geWorldAndServerChatList()
	local startIndex = math.max(1,#chatList - 3)
	for i = startIndex , #chatList do
		self:refreshChat(chatList[i])
	end
end

function This:getChatNode(chat)
	local str = ""
	if chat:getChannel() ~= ChatChannelType.kSystem then
		str = string.format("<A1>[%s]<A6>%s:<A0>%s",ChatChannelName[chat:getChannel()],chat:getFromRole().name,chat:getContent())
	else
		str = string.format("<A1>[%s]:<A0>%s",ChatChannelName[chat:getChannel()],chat:getContent())
	end
	local label = cc.Label:createNormalTTF("",16)
	label:setAnchorPoint(0,1)
	label:setStringWithColor(str,290)
	label:setPositionX(20)
	return label
end

function This:refreshChat(chat)
	local node = self:getChatNode(chat)
	node:setAnchorPoint(0,0)
	self.m_chatContainer:addChild(node)
	table.insert(self.m_chatNodeList,node)
	
	local cw , ch = self.m_chatContainer:getContentSize()
	local height = 0
	for i = #self.m_chatNodeList , 1 , -1 do
		local node = self.m_chatNodeList[i]
		if height <= ch then
			node:setPositionY(height)
			if node:getContentHeight() > ch/2 then
				height = height + ch + 2
			else
				height = height + ch/2 + 2
			end
		else
			node:removeFromParent()
			table.remove(self.m_chatNodeList,i)
		end
	end
end

-----------城池警告--------------------
function This:initDangerous()
	if not GamePlayer:isInWorld() then
		self.m_csNode.Dangerous:setVisible(false)
		return
	end

	local armyList = WorldMapManager:getEnemyMarchArmyToMyCity()
	table.sort(armyList,function(a,b)
		return a:getStartTime() < b:getStartTime()
	end)
	local cityList = {}
	local citys = {}
	for i , army in ipairs(armyList) do
		local toCityId = army:getToCity()
		if not citys[toCityId] then
			table.insert(cityList,toCityId)
			citys[toCityId] = {army}
		else
			table.insert(citys[toCityId],army)
		end
	end
	 
	self.m_dangerViewList = {}
	self.m_csNode.Dangerous:setVisible(#self.m_dangerViewList > 0)

	local total = #self.m_dangerViewList 
	local fromIndex = total >= MaxDangerNum and total - MaxDangerNum + 1 or 1
	for i = fromIndex , #cityList  do
		local cityId = cityList[i]
		self:addDangerView(citys[cityId],cityId)
	end
end

function This:addDangerView(armyList,cityId,isInit)
	local function refreshContent()
		local w = 0
		for i , view in ipairs(self.m_dangerViewList) do
			view:setPositionX(w)
			w = w - view:getContentWidth()
		end
	end
	local function removeHandler(cityId)
		for i , view in ipairs(self.m_dangerViewList) do
			if view:getCityId() == cityId then
				view:removeFromParent()
				table.remove(self.m_dangerViewList,i)
				refreshContent()
				break
			end
		end
	end

	local view = MarchDangerView:create({armyList = armyList,cityId = cityId })
	view:setAnchorPoint(1.0,0.5)
	view:setRemoveHandler(removeHandler)
	view:setLookedHandler(refreshContent)
	view:setTouchHandler(function(id)
		cc.SceneManager:switchTo("World.WorldScene",nil,{
			focuseCityId = id
		})
	end)
	self.m_csNode.Dangerous:addChild(view)

	if #self.m_dangerViewList >= MaxDangerNum then
		local tmpView = self.m_dangerViewList[1]
		tmpView:removeFromParent()
		table.remove(self.m_dangerViewList,1)
	else
		table.insert(self.m_dangerViewList,view)
	end

	self.m_csNode.Dangerous:setVisible(#self.m_dangerViewList > 0)
	refreshContent()
	return view
end

--------------封地-------------------
function This:refreshTerrBuildQueues()
	if not self.m_csNode.build_queue then
        return
    end

	self.m_csNode.build_queue:removeAllChildren()	
	local lastView = nil
	local emptyQueues = TerrBuildManager:getAllTempEmptyBuildQueue()
	for id, emptyQueue in pairs(emptyQueues) do
		local queue = TerrBuildManager:getBuildQueueBy(id) or emptyQueue
		local view = TerrBuildQueueView:create(queue)
		if lastView then
			view:setPositionBy(lastView)
		else
			view:setPosition(10, 0)
		end
        lastView = view
		self.m_csNode.build_queue:addChild(view)
	end
end

--------------篇章任务----------------------

function This:refreshGongXunAchieve()
	local achieveNode = self.m_csNode.Recommend
	if achieveNode then
		local gongxun = AchieveManager:getGongXun()
		local maxGongxun = AchieveManager:getMaxGongXun()

		if gongxun >= maxGongxun then
			if self.m_gongxunEffect then
				self.m_gongxunEffect:removeFromParent()
				self.m_gongxunEffect = nil
			end
			achieveNode.gongxun.text_0:setString(Serialize[61490],(not AppText:isChinese() and 250 or nil))
			--achieveNode.gongxun.text_0:setVisible(false)
			--achieveNode.gongxun.bg4:setVisible(false)
		else
			achieveNode.gongxun.text_0:setString(string.format(Serialize[61491],gongxun,maxGongxun),(not AppText:isChinese() and 250 or nil))
			local canReward = AchieveManager:canGongXunReward()
			if canReward and not self.m_gongxunEffect then
				self.m_gongxunEffect = GameUtil:createEffect("Task",true)
				achieveNode:addChild(self.m_gongxunEffect)
				self.m_gongxunEffect:setPosition(140,-8)
			elseif not canReward and self.m_gongxunEffect then
				self.m_gongxunEffect:removeFromParent()
				self.m_gongxunEffect = nil
			end
			--achieveNode.gongxun.text_0:setVisible(true)
			--achieveNode.gongxun.bg4:setVisible(true)
		end
	end
end

function This:refreshRecommendAchieve()
	local achieveNode = self.m_csNode.Recommend
	if achieveNode then
		local achieve = AchieveManager:getCurMainSubAchieve()
		if achieve == nil then
			achieve = AchieveManager:getCurMainAchieve()
		end

		if not achieve then
			achieveNode.main:setVisible(false)
			return
		end 

		local state = achieve:getState()
		local str
		if state == AchieveState.kHaseFinish then
			str = string.format(Serialize[61492],achieve:getDesc())
		else
			str = string.format("<New5>%s (%d/%d)",achieve:getDesc(),achieve:getProgress(),achieve:getMaxProgress())
		end
		self.m_csNode.Recommend.main.text:setStringWithColor(str,(not AppText:isChinese() and 210 or nil))

		if state == AchieveState.kHaseFinish and not self.m_achieveEffect then
			self.m_achieveEffect = GameUtil:createEffect("Task",true)
			achieveNode:addChild(self.m_achieveEffect)
			self.m_achieveEffect:setPosition(140,58)
		elseif state ~= AchieveState.kHaseFinish and self.m_achieveEffect then
			self.m_achieveEffect:removeFromParent()
			self.m_achieveEffect = nil
		end
	end
end

function This:refreshCopyAchieve()
	local achieveNode = self.m_csNode.Recommend
	if achieveNode then
		local state = WarfareManager:getNowWarState()
		local fight = false
		local isShow = achieveNode.fuben.bg5:isVisible()
		if WarfareManager:hasTeam() then
			local team = WarfareManager:getMyTeam()
			local war = team:getWar()
			local RoleNum,maxNum = team:getPeople()
			if ((RoleNum >= 2 and war:getType() == 2) or (RoleNum >=3 and war:getType() == 3)) and isShow then
				if not self.m_fubenEffect then
					self.m_fubenEffect = GameUtil:createEffect("Task",true)
					achieveNode.fuben:addChild(self.m_fubenEffect)
					self.m_fubenEffect:setPosition(140,-76)	
				end
			else
				if self.m_fubenEffect then
					self.m_fubenEffect:removeFromParent()
					self.m_fubenEffect = nil
				end
			end
			achieveNode.fuben.text_0:setString(string.format( "%s(%s)",war:getName(),WarfareUtil.getHardDesc(war:getNextHard())),(not AppText:isChinese() and 400 or nil))
			achieveNode.fuben.roleNum:setString(string.format( "%d/%d",RoleNum,maxNum))
		elseif WarfareManager:hasTeam(TeamType.kTowerTeam) then
			local team = WarfareManager:getMyTeam(TeamType.kTowerTeam)
			local name = team:getWarFullName()
			local RoleNum,maxNum = team:getPeople()
			if RoleNum >= 2 and isShow then
				if not self.m_fubenEffect then
					self.m_fubenEffect = GameUtil:createEffect("Task",true)
					achieveNode.fuben:addChild(self.m_fubenEffect)
					self.m_fubenEffect:setPosition(140,-76)	
				end
			else
				if self.m_fubenEffect then
					self.m_fubenEffect:removeFromParent()
					self.m_fubenEffect = nil
				end
			end
			achieveNode.fuben.text_0:setString(name,(not AppText:isChinese() and 400 or nil))
			achieveNode.fuben.roleNum:setString(string.format( "%d/%d",RoleNum,maxNum))
		end
		if state and #state > 0 then
			fight = true
		end
		achieveNode.fuben:setVisible(WarfareManager:hasTeam() or WarfareManager:hasTeam(TeamType.kTowerTeam))
		achieveNode.fuben.zhandou:setVisible(fight and isShow)
		achieveNode.fuben.roleNum:setVisible(not fight and isShow)
	end
end


-------------VIP-------------------
function This:refreshVipState(maxLevel)
    local curNode = self.m_csNode.player_info.vip
	if curNode.vipbg then
		local level = maxLevel or VipManager:getMaxMemberLevel()
		local hasVip = level ~= VipType.kNone
		curNode.vipbg:setVisible(hasVip)
		curNode.novip:setVisible(not hasVip)
		curNode.vip:setImage(VipImageName[level])

	    if not self.m_effectVip then
	        self.m_effectVip = GameUtil:createEffect("Huiyuan", true, self)
	        local posx, posy = curNode.vipbg:getPosition()
	        self.m_effectVip:setPosition(posx + 2, posy)
	        curNode:addChild(self.m_effectVip)             
	    end
	end
end

function This:refreshSunshineEffect(enterView)
	if enterView then
		if not self.m_effectLight then
			local nameList = {"YangGuang", "Xue", "Yu"}
			local num = math.random(1, 1000)
			num = num % 4 + 1
			if nameList[num] then
		        self.m_effectLight = GameUtil:createEffect(nameList[num], true, self)
		        self.m_csNode.uieffect:addChild(self.m_effectLight)      
		        if num == 1 then   
		        	self.m_effectLight:setRotation(90)
		        end
		    end
	    end
	else
        if self.m_effectLight then
            self.m_effectLight:removeFromParent()
            self.m_effectLight = nil
        end		
	end
end

function This:refreshSaintPower()
    self:onSaintStrongPowerChange()
end

function This:showLevelUpEffect()
	local x , y = self.m_csNode.player_info.icon:getPosition()
	local eff = nil
	eff = GameUtil:createEffect("Level",false,nil,{
		onAnimationComplete = function()
			eff:removeFromParent()
		end
	})
	eff:setPosition(x,y)
	self.m_csNode.player_info:addChild(eff)
    cc.Audio:playEffect("lvup.mp3")
end

function This:showPanelBtns(isShow)
	local node = self.m_csNode.panel_btns
	local isVisible = node.bg2:isVisible()
	if isVisible ~= isShow then
		node.bg2:setVisible(isShow)
		if isShow then
			self.m_csNode.close_bg.close_title:runAction(cc.RotateTo(0.1,0,"SineInOut"))
		else
			self.m_csNode.close_bg.close_title:runAction(cc.RotateTo(0.1,180,"SineInOut"))
		end
	end
end

function This:showActivityBtns(isShow)
	local isVisible = self.m_csNode.huodong:isVisible()
	if isVisible ~= isShow then
		self.m_csNode.huodong:setVisible(isShow)
		self.m_csNode.huodong.m_skipState = isShow
		
		if isShow then
			self.m_csNode.huodong_button:setAngle(180)
		else
			self.m_csNode.huodong_button:setAngle(0)
		end
		EventDispatcher:dispatcher("huodong_switch_changed", isShow)
	end
end

function This:refreshPaiWeiBtnEffect()
	if self.m_csNode.paiwei then
		if GamePlayer:isInMatchMap() and not WorldMapManager:isInProtected() and not self.m_paiweiEffect then
			self.m_paiweiEffect = GameUtil:createEffect("ZhengBa",true)
			local w , h = self.m_csNode.paiwei:getContentSize()
			self.m_paiweiEffect:setPosition(w/2, h/2)
			self.m_csNode.paiwei:addChild(self.m_paiweiEffect)
		elseif (not GamePlayer:isInMatchMap() or WorldMapManager:isInProtected()) and self.m_paiweiEffect then
			self.m_paiweiEffect:removeFromParent()
			self.m_paiweiEffect = nil
		end  
	end
end

function This:refreshGirlGuide(isRandom)
	if not GuideManager:isInGuide() then
		local people = self.m_csNode.people
		if people then
			self.m_csNode.people:setVisible(false)
		end
		return
	end

	local mainAchieve = AchieveManager:getCurMainAchieve()
	if not mainAchieve then
		self.m_csNode.people:setVisible(false)
		return
	end

	if not self.m_csNode.people then
		return
	end

	local achieveList = AchieveManager:getMainSubAchieve(mainAchieve:getId())
	table.insert(achieveList,mainAchieve)

	local isCanReward = false
	for i , achieve in ipairs(achieveList) do
		if achieve:getState() == AchieveState.kHaseFinish then
			isCanReward = true
			break
		end
	end

	if isCanReward then
		self.m_csNode.people.content.text:setStringWithColor(Serialize[61493],235)
		self.m_csNode.people:setVisible(true)
		self.m_csNode.people.content.fresh:setVisible(false)
		return
	end

	if #achieveList <= 0 then
		self.m_csNode.people:setVisible(false)
		return
	end

	local achieve = achieveList[1]
	local despList = achieve:getGuideSession()
	if #despList <= 0 then
		self.m_csNode.people:setVisible(false)
		return
	end

	self.m_csNode.people.content.fresh:setVisible(#despList > 1)
	if isRandom then
		local index = math.random(1,#despList)
		self.m_csNode.people.content.text:setStringWithColor(despList[index],235)
	else
		self.m_csNode.people.content.text:setStringWithColor(despList[1],235)
	end
	self.m_csNode.people:setVisible(true)
end

---------------------------------------------------------------------

function This:onPlayerAttrChanged(field, lastValue, value)
	self:refresh(field)
	if os.isWin32 then
	    if field == PlayerAttr.diamond then
	        local deltaValue = value - lastValue
	        if deltaValue > 0 then
	            g_scene:showMoneyTips("+" .. deltaValue .. Serialize[61494], { delayFactor = 1.5, colorId = "A2" } )
	        elseif deltaValue < 0 then
	            g_scene:showMoneyTips(tostring(deltaValue) .. Serialize[61494], { delayFactor = 1.5, colorId = "R0" } )
	        end
		elseif field == PlayerAttr.level and lastValue ~= value then
			self:showLevelUpEffect()
			if self.m_btnHelper then
				self.m_btnHelper:refresh()
			end
			self:refreshFunctionNotice()
		end
	else
		if field == PlayerAttr.level and lastValue ~= value then
			self:showLevelUpEffect()
			if self.m_btnHelper then
				self.m_btnHelper:refresh()
			end
			self:refreshFunctionNotice()
		end
	end
end

function This:onAddChat(chat)
	self:refreshChat(chat)
end

function This:onBuildQueueBuy()
    self:refreshTerrBuildQueues()
end

function This:onVipActivated(maxLevel)
	self:refreshVipState(maxLevel)
end

function This:onAchieveChanged(achieveType)
	if achieveType == AchieveType.kMainLine then
		self:refreshRecommendAchieve()
		self:refreshGirlGuide(true)
	elseif achieveType == AchieveType.kGongXun then
		self:refreshGongXunAchieve()
	end
end

function This:onGetAchieveReward()
	self:refreshGirlGuide()
	self:refreshRecommendAchieve()
	self:refreshGongXunAchieve()
end

function This:onGetGongXunBoxReward()
	self:refreshGongXunAchieve()
end

function This:onChapterOpen(achieve)
	self:refreshGirlGuide()
	if not GuideManager:isInGuide() then
		PopDialogManager:addPopDialog({
			name = "Achieve.ChapterOpenPanel",
			arg = achieve,
			level = DialogLevel.kThrLevel
		})
	end
end

function This:onAddMarchArmy(model)
	if not model:isOur() then
		local city = WorldMapManager:getCity(model:getToCity())
		if city:isMy() then
			for i , view in ipairs(self.m_dangerViewList) do
				if view:getCityId() == city:getCityId() then
					view:addArmy(model)
					return
				end
			end
			self:addDangerView({model},city:getCityId())
		end
	end
end

function This:onFightTimeStart()
	self:refreshPaiWeiBtnEffect()
end

function This:onExitWorldMap()
	self:refreshPaiWeiBtnEffect()
end

function This:onGetMyTeamInfo()
	self:refreshCopyAchieve()		
end

function This:onChangeTeamOwner()
	self:refreshCopyAchieve()			
end

function This:onCreateTeam()
	self:refreshCopyAchieve()			
end

function This:onGetWarfareTabData()
	self:refreshCopyAchieve()				
end

function This:onFightStateChange()
	self:refreshCopyAchieve()					
end

function This:onJoinMatchTeam()
	self:refreshCopyAchieve()					
end

function This:onExitTowerTeam()
	self:refreshCopyAchieve()						
end

function This:onBossTeamRemove()
	self:refreshCopyAchieve()						

end

function This:itemUpdate(itemList)
	if itemList and #itemList > 0 and self.m_csNode.res_info then
        self.m_csNode.res_info.diamond:setString(math.floor(GamePlayer:getDiamond()))
    end
end

function This:onExitInfo( reportInfo )
	self.m_remainingTime = reportInfo.end_time - GamePlayer:getServerTime()
	if self.m_remainingTime > 0 then
		self:scheduleUpdate()
	end
end

function This:update(dt)
	self.m_escape = self.m_escape + dt
	if self.m_escape > 1 then
		self.m_escape = self.m_escape - 1
		self.m_remainingTime = self.m_remainingTime - 1
		if self.m_remainingTime <= 0 then
			if WarfareManager:hasTeam() then
				WarfareManager:loadCacheBattle()
			elseif WarfareManager:hasTeam(TeamType.kTowerTeam) then
				WarfareManager:loadCacheBattle(TeamType.kTowerTeam)
			end
			self:unscheduleUpdate()
		end
	end
end

function This:onMatchRankLvChanged(oldRankLv,curRankLv)
	self.m_csNode.player_info.office:setString(MatchManager:getRankName())
end

function This:onFightTimeStart()
	local eff = nil
	eff = GameUtil:createEffect("ZhengBaKaiZhan",false,nil,{
		onAnimationComplete = function()
			eff:removeFromParent()
		end
	})
	eff:setPosition(cc.visible.center.x,cc.visible.center.y)
	self:addChild(eff)
	self:runAction(cc.Sequence(cc.DelayTime(1.0), cc.CallFunc(function()
		cc.Audio:playEffect("Open_Fight.mp3")	
	end)))
end

function This:onSaintStrongPowerChange(oldvalue, power)
	if not power then
		power = HeroManager:getStrongestPower()
	end

	local node = self.m_csNode.player_info.zhanli.number_zl
	if node and oldvalue then
	    node:setString(power)
		local param = {startNum=oldvalue, endNum=power, interval=1}
	    ViewUtil:startCountUp(node, param)
    elseif node then
	   	node:setString(power)
	end
end

function This:refreshRechargeReward()
	local hasBuyReward = SystemManager:hasBuyReward()
    if hasBuyReward and not self.m_effectRecharge then
    	local node = self.m_csNode.res_info.recharge
        self.m_effectRecharge = GameUtil:createEffect("ChongZhiJia", true, node)
        node:addChild(self.m_effectRecharge)         
    elseif not hasBuyReward and self.m_effectRecharge then
        self.m_effectRecharge:removeFromParent()
        self.m_effectRecharge = nil
    end
end

This.onBuyShopItem = This.refreshRechargeReward

--功能预告
function This:refreshFunctionNotice()
	local node = self.m_csNode["function"]
	if not node then
		return
	end

	local lv = GamePlayer:getLevel()
	if lv < 15 then
		node:setVisible(false)
		return
	end

	if g_scene:getType() ~= SceneType.kHomeScene then
		node:setVisible(false)
		return
	end

	local config = FunctionNoticeManager:getFunctionNoticeForHomeUI()
	if not config then
		node:setVisible(false)
		return
	end

	node:setVisible(true)
	node.tubiao:setImage(config.icon)
	node.name:setString(config.name)
	node.tiaojian:setString( FunctionNoticeManager:getOpenTips(config.id) )
end

function This:onFunctionNoticeClick()
	local config = FunctionNoticeManager:getFunctionNoticeForHomeUI()
	if not config then
		return
	end

	g_scene:openDialog("Function.FunctionNotOpenPanel",{id = config.id})
end

function This:showBottomButton()
	local csNode = self.m_csNode
	if csNode.close_bg then
		local isVisible = csNode.panel_btns.bg2:isVisible()
		if isVisible then
			return --已经打开
		end

		local info = {
			value = true,
			hasAnimation = false,
			callbackList = { 
			    node_handler = function() 
					self:showPanelBtns(true)
				end, 
			    other_handler = nil,
				start_index = 8,
			}
		} 
		csNode.close_bg:playBehaviourSwitchAnimation(info)
	end
end

function This:showTopButton()
	local csNode = self.m_csNode
	if csNode.huodong_button then
		local isVisible = csNode.huodong:isVisible()
		if isVisible then
			return --已经打开
		end

		local info = {
			value = true,
			callbackList = { 
			    node_handler = function() 
					self:showActivityBtns(true)
				end, 
			    other_handler = nil,
			}
		} 
		csNode.huodong_button:playBehaviourSwitchAnimation(info)
	end
end

function This:showRecommend()
	local recommend = self.m_csNode.Recommend
	if recommend then
		recommend.main.bg:setVisible(true)
		recommend.main.text:setVisible(true)
		if self.m_achieveEffect then
			self.m_achieveEffect:setVisible(true)
		end
	end
end

function This:refreshBtnHelp()
	if self.m_btnHelper then
        self.m_btnHelper:refresh()
	end
end