

local This , super = class(..., "Base.BaseModel")
local Application = require("cc.Application")
local EventDispatcher = require("EventDispatcher")
local InviteModel = require("Invite.InviteModel")
local PopDialogManager = require("UI.PopDialogManager")


function This:init()
	super.init(self)
	self.m_inviteList = {}
    self:initListener()
end

function This:initListener()
	EventDispatcher:addListener(self, "invite_pop_close", self.delayCheck)
end

-- 添加邀请 (info = InviteModel的参数)
function This:addInvite(info)
	local model = InviteModel:create(info)
	table.insert(self.m_inviteList, model)
	self:delayCheck()
	return model
end

function This:delayCheck()
	local timer = cc.Application:getTimer()
	timer:setTimer(0.2, function()
		self:check()
	end, "invite_pop_check")
end

function This:check()
	if #self.m_inviteList <= 0 then
		return
	end

	local panel = g_scene:getDialog("InvitePopPanel")
	if panel then
		return
	end

	local model = table.remove(self.m_inviteList, 1)
	if model:onCheck() ~= false then
		PopDialogManager:addPopDialog({
			name = "Invite.InvitePopPanel",
			arg = model,
			level = DialogLevel.kTopLevel,
			onlyone = true,
		})
	else
		self:check()
	end
end