

local This , super = class(..., "Base.BaseModel")
local MatchingConfig = require("Metadatas.MatchingConfig")


function This:init(info)
	super.init(self)

	self.m_info 		= info
	self.m_name 		= info.name
	self.m_level 		= info.level
	self.m_icon 		= info.icon
	self.m_rankLv 		= info.rankLv
	self.m_inviteText	= info.inviteText
	self.m_onCheck 		= info.onCheck
	self.m_onSure 		= info.onSure
	self.m_onRefuse 	= info.onRefuse
end

-- 检查，true打开界面，false数据无效，不打开
function This:onCheck()
	if type(self.m_onCheck) == "function" then
		return self.m_onCheck(self)
	end
	return true
end

-- 同意
function This:onSure()
	if type(self.m_onSure) == "function" then
		return self.m_onSure(self)
	end
end

-- 拒绝
function This:onRefuse()
	if type(self.m_onRefuse) == "function" then
		return self.m_onRefuse(self)
	end	
end

function This:getInfo()
	return self.m_info
end

function This:getName()
	return self.m_name
end

function This:getLevel()
	return self.m_level
end

function This:getIcon()
	return self.m_icon
end

function This:getRankLvText()
	local rank = self.m_rankLv <= 0 and 1 or self.m_rankLv
	return MatchingConfig[rank].rank_level
end

function This:getInviteText()
	return self.m_inviteText
end