
local This , super = class(...,"Dialog")
local GameUtil = require("Util.GameUtil")
local EventDispatcher = require("EventDispatcher")


function This:initData(info)
	self.m_invite = info
end

function This:initNode(info)
	local csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/TeamMatchingInvitationPopup.csb")
	csNode:setToCenter()
	self:addChild(csNode)
	self.m_csNode = csNode

	GameUtil:setPlayerIconNodeImage(csNode.icon, self.m_invite:getIcon())
	csNode.name:setString( self.m_invite:getName() )
	csNode.office:setString( self.m_invite:getRankLvText() )
	csNode.level:setString( string.format("Lv.%d", self.m_invite:getLevel()) )
	csNode.type:setString( self.m_invite:getInviteText() )

	self.m_escape = 0
	self.m_totalTime = 10
	self.m_csNode.time:setString(string.format(Serialize[61506],self.m_totalTime))
	self.m_csNode:setScale(0)
end

function This:initTouchEvent()
	self.m_csNode.close:setTouch({
		onEnded = function()
			self:close()
		end,
		isDynamic = true
	})
	self.m_csNode.cancel:setTouch({
		onEnded = function()
			self.m_invite:onRefuse()
			self:close()
		end,
		isDynamic = true
	})
	self.m_csNode.confirm:setTouch({
		onEnded = function()
			self.m_invite:onSure()
			self:close()
		end,
		isDynamic = true
	})
end

function This:onEnter()
	super.onEnter(self)
end

function This:onExit()
	EventDispatcher:dispatcher("invite_pop_close")
	super.onExit(self)
end

function This:runOpenAnimation()
	self.m_csNode:runAction(cc.Sequence(
		cc.ScaleTo(0.5,1.0,"ElasticInOut"),
		cc.CallFunc(function()
			self:onOpen()
		end)
	))
end

function This:update(dt)
	super.update(self,dt)
	self.m_escape = self.m_escape + dt
	if self.m_escape > 1 then
		self.m_escape = self.m_escape - 1
		self.m_totalTime = self.m_totalTime - 1
		if self.m_totalTime <= 0 then
			self:close()
		else
			self.m_csNode.time:setString(string.format(Serialize[61506],self.m_totalTime))
		end
	end
end

