
local This , super = class(...,"Player.FightResultBasePanel")
local MenuScene = require("Home.MenuScene")
local GamePlayer = require("Player.GamePlayer")


function This:initNode(info)
	self.m_onTouchMask = info.onTouchMask

	local csNode = cc.Node:createFromCSFile("GameScene/NodeUI/ArenFailshare.csb")
	csNode:setToCenter()
	self:addChild(csNode)
	self.m_csNode = csNode

	local seqence1 = cc.Sequence(cc.FadeTo(0.4,64),cc.FadeTo(0.4,255))
	local seqence2 = cc.Sequence(cc.ScaleTo(0.4,0.68),cc.ScaleTo(0.4,0.66))
	csNode.continue:setScale(0.66)
	csNode.continue:runAction(cc.RepeatForever(cc.Spawn(seqence1, seqence2)))

	self:setContentSize(cc.visible.width, cc.visible.height)
	self:initFailedGuide()
end

function This:onEnter()
	super.onEnter(self)
	cc.Audio:playEffect("Lose.mp3")
end

function This:onExit()
	super.onExit(self)
end

function This:initTouchEvent()
	
end

function This:onTouchMask()
	if type(self.m_onTouchMask) == "function" then
		self.m_onTouchMask()
		return
	end
	
	if GamePlayer:isInWorld() then
		cc.SceneManager:switchTo("World.WorldScene")
	else
		cc.SceneManager:switchTo("Home.MenuScene")
	end
end
