

local This , super = class(...,"NodeUI")
local ItemUtil = require("Bag.ItemUtil")


function This:initData(data)
    self.m_data = data

end

function This:initNode(data)
    self:setContentSize(384, 30)

    local label = cc.Label:createNormalTTF("", 20)
	label:setAnchorPoint(0, 0)
	label:setPosition(0, 0)
	label:enableOutline(26, 26, 26, 255, 1)
	label:setScale(0.8)
	self:addChild(label, 0)
	self.m_label = label
end

function This:onEnter()
    super.onEnter(self)
    self:refresh()
end

function This:setModel(data)
    self.m_data = data
    self:refresh()
end

function This:refresh()
	local data = self.m_data
	local roleName = string.format("<A1>%s", data.name)
	local itemName = string.format("<Q%s>%s", ItemUtil.getQuality(data.itemId), ItemUtil.getName(data.itemId)) 

	self.m_label:setStringWithColor( string.format(Serialize[61535], roleName, itemName, ItemUtil.formatItemCount(data.itemNum)) )
end