

local This, super = class(..., "Dialog")
local LegionAbossManager = require("LegionAboss.LegionAbossManager")
local RankPageListLayer = require("Rank.RankPageListLayer")
local LegionAbossRecordItemView = require("LegionAboss.LegionAbossRecordItemView")

function This:initData()

end

function This:initNode()
    local csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/FamilyActiveBossRecord.csb")
    csNode:setToCenter()
    self:addChild(csNode)
    self.m_csNode = csNode

    local scrollView = csNode.scrollView
	scrollView:setDirection("vertical")

	self.m_listLayer = RankPageListLayer:create({
        itemWidth = 384,
        itemHeight = 30,
        spaceX = 0,
        spaceY = 0,
        scrollView = scrollView,
		dataCounter = function ()	 
	        return #self:getRecord()
        end,
        viewCreator =  function(index, node) 
        	local data = self:getRecord()[index]
        	if data then     
			    if not node then
                    node = LegionAbossRecordItemView:create(data, index)
				    return node
				else
			        node:setModel(data, index)
			    end
			end
	    end
    })
    self.m_listLayer:setCascadeOpacityEnabled(true)
    self.m_listLayer:setAnchorPoint(0.5, 0)
    local w, h = self.m_listLayer:getContentSize()
    scrollView:pushBackCustomItem(self.m_listLayer, w, h, 0)   
    self.m_listLayer:setDataList()

end

function This:initTouchEvent()
    if not self.m_inited then
        local csNode = self.m_csNode
        self.m_inited = true

        csNode.close:setTouchEnded(function()
            self:close()
        end)
    end
end

function This:getRecord()
	local dataModel = LegionAbossManager:getDataModel()
	return dataModel:getRecord()
end
