

local This , super = class(...,"NodeUI")
local ItemNode = require("UI.ItemNode")
local LegionActiveItemConfig = require("Metadatas.LegionActiveItemConfig")
local ItemUtil = require("Bag.ItemUtil")


function This:initData(data)
    self.m_data = data
    self.m_itemNode = nil
end

function This:initNode(data)
    self.m_csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/FamilyActiveBossRewardItem.csb")
    self:addChild(self.m_csNode)

    self:setContentSize(111, 127)
end

function This:onEnter()
    super.onEnter(self)
    self:refresh()
end

function This:setModel(data)
    self.m_data = data
    self:refresh()
end

function This:refresh()
	local rid = self.m_data
	local config = LegionActiveItemConfig[rid]
	local csNode = self.m_csNode

	if not self.m_itemNode then
		local node = ItemNode:create(config.item_id)
        node:setAnchorPoint(0.5, 0.5)
        node:setPosition(csNode.bg:getPosition())
        node:setScale(0.85)
        self.m_csNode:addChild(node)
        self.m_itemNode = node
    else
    	self.m_itemNode:setModel({id = config.item_id})
	end

    csNode.zhezhao:setLocalZOrder(1)
    csNode.num1:setLocalZOrder(1)
	csNode.num1:setString( ItemUtil.formatItemCount(config.num) )
	csNode.num2:setString( "X"..config.count )
end