

local This , super = class(...,"NodeUI")
local GameUtil = require("Util.GameUtil")
local MatchingConfig = require("Metadatas.MatchingConfig")


function This:initData(data)
    self.m_data = data
end

function This:initNode(data)
    self.m_csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/KingWarApplyItem.csb")
    self:addChild(self.m_csNode)

    local w, h = self.m_csNode.bg0:getContentSize()
    self:setContentSize(w, h)
end

function This:initTouchEvent()
    if not self.m_isInit then
        local csNode = self.m_csNode
        self.m_isInit = true

        csNode.sure:setTouch({
            isDynamic = true, 
            isContainer = true,
            onEnded = function ()
                if type(self.m_sureCb) == "function" then
                    self.m_sureCb(self)
                end
            end,
        })

        csNode.refuse:setTouch({
            isDynamic = true, 
            isContainer = true,
            onEnded = function ()
                if type(self.m_refuseCb) == "function" then
                    self.m_refuseCb(self)
                end
            end,
        })

        csNode.txt_bg:setTouch({
            isDynamic = true, 
            isContainer = true,
            onEnded = function ()
                g_scene:openDialog("Player.RoleInfoPanel",{id = self.m_data.id})
            end,
        })
    end
end

function This:onEnter()
    super.onEnter(self)
    self:refresh()
end

function This:setModel(data)
    self.m_data = data
    self:refresh()
end

function This:refresh()
    local data = self.m_data
    local csNode = self.m_csNode

    csNode.name:setString(data.name)
    csNode.level:setString(string.format("Lv.%d", data.level))

    local rank = data.rankLv <= 0 and 1 or data.rankLv
    csNode.marquis:setString(MatchingConfig[rank].rank_level)
end

function This:getData()
    return self.m_data
end

function This:setSureCb(func)
    self.m_sureCb = func
end

function This:setRefuseCb(func)
    self.m_refuseCb = func
end

