

-- 皇帝战初始界面

local This, super = class(..., "NodeView")
local GameUtil = require("Util.GameUtil")


function This:initData(info)
	self.m_mainUI = info.mainUI
	self.m_data = info.data
	self.m_mapType = info.data:getMapType()
	self.m_leftTime = info.data:getStateLeftTime()
end

function This:initNode(info)
    local csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/KingWarPreview.csb")
    csNode:setToCenter()
    self:addChild(csNode)
    self.m_csNode = csNode

    csNode.bg1:adapterFullScreen()
	csNode.close:adapterBorder("right", "top", -cc.visible.designWidth/2, -cc.visible.designHeight/2)
	csNode.guize:adapterBorder("right", "bottom", -cc.visible.designWidth/2, -cc.visible.designHeight/2)

	-- 关闭
	csNode.close:setTouchEnded(function()
	    self.m_mainUI:close()
	end) 

	-- 规则
	csNode.guize:setTouchEnded(function()
        g_scene:openDialog("UI.RulesPanel", {rulesType = RulesType.kKing})
	end)

	self:updateLeftTime(self.m_leftTime)
end

function This:refresh()

end

function This:updateLeftTime(leftTime)
	self.m_leftTime = leftTime
	self.m_csNode.time:setString( GameUtil:formatDTime(Serialize[61556], leftTime) )
end

