

local This , super = class(...,"NodeUI")
local GameUtil = require("Util.GameUtil")


function This:initData(data)
    self.m_data = data
end

function This:initNode(data)
    self.m_csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/KingWarIntegralRankItem.csb")
    self:addChild(self.m_csNode)

    local w, h = self.m_csNode.bg:getContentSize()
    self:setContentSize(w, h)
end

function This:onEnter()
    super.onEnter(self)
    self:refresh()
end

function This:setModel(data)
    self.m_data = data
    self:refresh()
end

function This:refresh()
    local data = self.m_data
    local me = self.m_csNode.me

    me.paiming:setString(data.loongRank)
    me.level:setString(string.format("Lv%d", data.level))
    me.name:setString(data.name)
    me.qufu:setString(data.areaName)
    me.hurt:setString(data.loongVal)
end


