

-- 皇帝战结果界面

local This, super = class(..., "NodeView")
local GameUtil = require("Util.GameUtil")
local EntrantManager = require("LegionEntrant.EntrantManager")


function This:initData(info)
	self.m_mainUI = info.mainUI
	self.m_data = info.data
	self.m_mapType = info.data:getMapType()
end

function This:initNode(info)
    local csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/KingWarEnd.csb")
    csNode:setToCenter()
    self:addChild(csNode)
    self.m_csNode = csNode

    csNode.bg1:adapterFullScreen()
	csNode.close:adapterBorder("right", "top", -cc.visible.designWidth/2, -cc.visible.designHeight/2)
	csNode.guize:adapterBorder("right", "bottom", -cc.visible.designWidth/2, -cc.visible.designHeight/2)
	
	-- 关闭
	csNode.close:setTouchEnded(function()
	    self.m_mainUI:close()
	end)

	-- 排行
	csNode.into:setTouchEnded(function()
	    g_scene:openDialog("LegionEntrant.KingWarResultRankPanel")
	end)

	-- 规则
	csNode.guize:setTouchEnded(function()
        g_scene:openDialog("UI.RulesPanel", {rulesType = RulesType.kKing})
	end)	

	self:refresh()
end

function This:onEnter()
    super.onEnter(self)
    EntrantManager:addObserver(self)
end

function This:onExit()
    EntrantManager:removeObserver(self)
    super.onExit(self)
end

function This:refresh()
	local rank = self.m_data:getResultRank()
	local csNode = self.m_csNode

	self:refreshWiner(csNode.player1, rank[2])
	self:refreshWiner(csNode.player2, rank[1])
	self:refreshWiner(csNode.player3, rank[3])
end

function This:refreshWiner(node, data)
	local isHas = (data ~= nil)

	node.name:setVisible(isHas)
	node.icon:setVisible(isHas)
	node.none:setVisible(not isHas)

	if not isHas then
		return
	end

	GameUtil:setPlayerFeltNodeResource(node.icon, data.icon)
	node.name:setString(string.format("%s-%s", data.name, data.areaName))
end

function This:onKingWarResultNotify(data)
	self.m_data = data
	self:refresh()
end



