

-- 军团战备战界面


local This, super = class(...,"NodeView")
local RankPageListLayer = require("Rank.RankPageListLayer")
local LegionWarPrepareItemView = require("LegionEntrant.LegionWarPrepareItemView")
local GameUtil = require("Util.GameUtil")
local EntrantManager = require("LegionEntrant.EntrantManager")


function This:initData(info)
	self.m_mainUI = info.mainUI
	self.m_data = info.data
	self.m_mapType = info.data:getMapType()
    self.m_leftTime = info.data:getStateLeftTime()	
end

function This:initNode(info)
    local csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/LegionWarGroup.csb")
    csNode:setToCenter()
    self:addChild(csNode)
    self.m_csNode = csNode

    csNode.bg1:adapterFullScreen()
	csNode.close:adapterBorder("right", "top", -cc.visible.designWidth/2, -cc.visible.designHeight/2)
	csNode.guize:adapterBorder("right", "bottom", -cc.visible.designWidth/2, -cc.visible.designHeight/2)
	csNode.toumingzhuang:adapterBorder("right", "bottom", -cc.visible.designWidth/2, -cc.visible.designHeight/2 )
	csNode.into:setVisible(false)
	csNode.time:setVisible(true)

	-- 关闭
	csNode.close:setTouchEnded(function()
	    self.m_mainUI:close()
	end) 

	-- 规则
	csNode.guize:setTouchEnded(function()
        g_scene:openDialog("UI.RulesPanel", {rulesType = RulesType.kLegion})
	end)

	-- 投名状
	csNode.toumingzhuang:setTouchEnded(function()
		g_scene:openDialog("FamilyRating.FamilWarlordPanel",{warType = self.m_mapType})
	end)

   	local scrollView = self.m_csNode.ScrollView
	scrollView:setDirection("vertical")

    self.m_listLayer = RankPageListLayer:create({
        itemWidth = 440,
        itemHeight = 39,
        spaceX = 0,
        spaceY = 0,
        scrollView = scrollView,
		dataCounter = function ()
	        local rank = self:getRankData()	 
	        return #rank
        end,
        viewCreator =  function(index, node)
        	local rank = self:getRankData()	   
        	local data = rank[index]
        	if data then     
			    if not node then
				    return LegionWarPrepareItemView:create(data, index)
				else
			        node:setModel(data, index)
			    end
			end
	    end
    })

    self.m_listLayer:setCascadeOpacityEnabled(true)
    self.m_listLayer:setAnchorPoint(0.5, 0)
    local w, h = self.m_listLayer:getContentSize()
    scrollView:pushBackCustomItem(self.m_listLayer, w, h, 0)
    self.m_listLayer:setDataList()

    self:updateLeftTime(self.m_leftTime)
end

function This:onEnter()
    super.onEnter(self)
    EntrantManager:addObserver(self)
end

function This:onExit()
    super.onExit(self)
    EntrantManager:removeObserver(self)
end

function This:updateLeftTime(leftTime)
	self.m_leftTime = leftTime
	self.m_csNode.time:setString( GameUtil:formatDTime(Serialize[61602], leftTime) )
end

function This:getRankData()
	return self.m_data:getGroupList()
end

function This:onLegionWarResultReply(data)
	self.m_data = data
	self.m_listLayer:setDataList()
end
