

--军团战报名界面

local This, super = class(..., "NodeView")
local GameUtil = require("Util.GameUtil")
local EntrantManager = require("LegionEntrant.EntrantManager")


function This:initData(info)
	self.m_mainUI = info.mainUI
	self.m_data = info.data
	self.m_mapType = info.data:getMapType()
	self.m_leftTime = info.data:getStateLeftTime()
end

function This:initNode(info)
    local csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/LegionWarPreview.csb")
    csNode:setToCenter()
    self:addChild(csNode)
    self.m_csNode = csNode

    csNode.bg1:adapterFullScreen()
	csNode.close:adapterBorder("right", "top", -cc.visible.designWidth/2, -cc.visible.designHeight/2)
	csNode.guize:adapterBorder("right", "bottom", -cc.visible.designWidth/2, -cc.visible.designHeight/2)
	csNode.toumingzhuang:adapterBorder("right", "bottom", -cc.visible.designWidth/2, -cc.visible.designHeight/2 )

	-- 关闭
	csNode.close:setTouchEnded(function()
	    self.m_mainUI:close()
	end) 

	-- 规则
	csNode.guize:setTouchEnded(function()
        g_scene:openDialog("UI.RulesPanel", {rulesType = RulesType.kLegion})
	end)

	-- 投名状
	csNode.toumingzhuang:setTouchEnded(function()
		g_scene:openDialog("FamilyRating.FamilWarlordPanel",{warType = self.m_mapType})
	end)

	-- 响应
	csNode.baoming:setTouchEnded(function()
		local data = self.m_data
		local curResp = data:getCurResponse()
		local maxResp = data:getMaxResponse()
		local isResp = data:getIsResponse()

		if curResp >= maxResp then
			return
		end

		if isResp then
			return
		end

        if self.m_leftTime <= 0 then
        	return
        end

        EntrantManager:onLegionWarResponseRequest()
	end)

	self:refresh()
end

function This:onEnter()
    super.onEnter(self)
    EntrantManager:addObserver(self)
end

function This:onExit()
    super.onExit(self)
    EntrantManager:removeObserver(self)
end

function This:refresh()
	local data = self.m_data
	local csNode = self.m_csNode

	local curResp = data:getCurResponse()
	local maxResp = data:getMaxResponse()
	local isResp = data:getIsResponse()
	
	if curResp >= maxResp then
		-- 报名成功
		csNode.already:setString(Serialize[61608])
		csNode.already:setVisible(true)
		csNode.baoming:setVisible(false)
	else
		if isResp then
			csNode.baoming.text:setString( string.format(Serialize[61609], curResp, maxResp) )
		else
			csNode.baoming.text:setString( string.format(Serialize[61610], curResp, maxResp) )
		end
		csNode.baoming:setVisible(true)
		csNode.already:setVisible(false)
	end

    self:updateLeftTime(self.m_leftTime)
end

function This:updateLeftTime(leftTime)
	self.m_leftTime = leftTime
	self.m_csNode.time:setString( GameUtil:formatDTime(Serialize[61611], leftTime) )
end

-- 军团战响应
function This:onLegionWarResponseReply(data)
	self.m_data = data
	self:refresh()
end

