

-- 军团战结果界面

local This, super = class(...,"NodeView")
local EntrantManager = require("LegionEntrant.EntrantManager")
local GameUtil = require("Util.GameUtil")
local FamilyRatingManager = require("FamilyRating.FamilyRatingManager")


function This:initData(info)
	self.m_mainUI = info.mainUI
	self.m_data = info.data
	self.m_mapType = info.data:getMapType()
end

function This:initNode(info)
    local csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/KingWarReward.csb")
    csNode:setToCenter()
    self:addChild(csNode)
    self.m_csNode = csNode

	-- 关闭
	csNode.close:setTouchEnded(function()
	    self.m_mainUI:close()
	end)

	-- 规则
	csNode.guize:setTouchEnded(function()
        g_scene:openDialog("UI.RulesPanel", {rulesType = RulesType.kLegion})
	end)

	-- 本场排行
	csNode.rank:setTouchEnded(function()
        g_scene:openDialog("LegionEntrant.LegionWarRankPanel", {data = self.m_data})
	end)

	-- 投名状
	csNode.toumingzhuang:setTouchEnded(function()
		g_scene:openDialog("FamilyRating.FamilWarlordPanel",{warType = self.m_mapType})
	end)	

	self:refresh()
end

function This:onEnter()
    super.onEnter(self)
    EntrantManager:addObserver(self)
    FamilyRatingManager:addObserver(self)
    self:initRed() 
end

function This:onExit()
    EntrantManager:removeObserver(self)
    FamilyRatingManager:removeObserver(self)    
    super.onExit(self)
end

function This:refresh()
	local csNode = self.m_csNode
	local data = self.m_data

	local groupRank = data:getGroupRank()
	self:refreshGroup(csNode.huosheng.text, nil, groupRank[1])
	self:refreshGroup(csNode.juntuan2, csNode.dierming, groupRank[2])
	self:refreshGroup(csNode.juntuan3, csNode.disanming, groupRank[3])
	self:refreshGroup(csNode.juntuan4, csNode.disiming, groupRank[4])

	local roleRank = data:getRoleRank()
	self:refreshWiner(csNode.winer2, roleRank[1])
	self:refreshWiner(csNode.winer1, roleRank[2])
	self:refreshWiner(csNode.winer3, roleRank[3])
end

function This:refreshGroup(lbName, lbRank, data)
	if not data then
		lbName:setString("")
		if lbRank then
			lbRank:setVisible(false)
		end
	else
		lbName:setString(data.groupName)
		if lbRank then
			lbRank:setVisible(true)
		end		
	end	
end

function This:refreshWiner(node, data)
	if not data then
		node.name:setString("")
		node.icon:setVisible(false)
		node.namebg:setVisible(false)
		node.noone:setVisible(true)
		return
	end
	node.namebg:setVisible(true)
	node.noone:setVisible(false)
	node.icon:setVisible(true)
	GameUtil:setPlayerFeltNodeResource(node.icon, data.icon)
	node.name:setString(data.name)
end

function This:onLegionWarResultReply(data)
	self.m_data = data
	self:refresh()
end

function This:initRed()
	local node = self.m_csNode.toumingzhuang
	if node then
		GameUtil:refreshRedDot(node,FamilyRatingManager:hasCastRed(self.m_mapType),{80,75},1)
	end
end

function This:onCastReward()
	self:initRed()
end

function This:onGetCastInfo()
	self:initRed()
end