--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"Base.BaseModel")
local UpdateList = require("Base.UpdateList")
local HeroQueue = require("List.HeroQueue")
local EventDispatcher = require("EventDispatcher")
local Socket = require("Net.Socket")
local HeroManager = require("Hero.HeroManager")

local kMaxListCount = 6
local ListOpen =
{
	[1] = {level = 20, rank = 1, cost = 20},
	[2] = {level = 20, rank = 1, cost = 20},
	[3] = {level = 20, rank = 1, cost = 20},
	[4] = {level = 20, rank = 1, cost = 20},
	[5] = {level = 20, rank = 1, cost = 20},
	[6] = {level = 20, rank = 1, cost = 20}
}

function This:init()
	super.init(self)
	self.m_list = {}
	self.m_openCount = 0
	self:initListener()
end

function This:initListener()
	EventDispatcher:addListener(self,10208,self.onGetListInfoReply)
	EventDispatcher:addListener(self,10206,self.onOpenListReply)
	EventDispatcher:addListener(self,10207,self.onEditListReply)
end

function This:removeListener()
	EventDispatcher:removeListener(self,10208)
	EventDispatcher:removeListener(self,10206)
	EventDispatcher:removeListener(self,10207)
end

function This:getList(index)
	if index <= kMaxListCount then
		if not self.m_list[index] then
			self.m_list[index] = HeroQueue:create(index)
		end
		return self.m_list[index]
	end
end

function This:getListCount()
	return self.m_openCount
end

function This:openList(index)
	local queue = self:getList(index)
	if queue and not queue:isOpen() then
		queue:setIsOpen(true)
		self.m_openCount = self.m_openCount + 1
	end
end

function This:onGetListInfoRequest()
	Socket:sendAndLock(10208,{})
end

function This:onGetListInfoReply(msg)
	for i , info in ipairs(msg.queue_list) do
		local queue = self:getList(info.index)
		queue:setName(info.name)
		queue:setIsOpen(true)
		queue:updateHeroWithUid(info.card_id)
	end
	self:notifyObservers("onGetListInfo")
end

function This:onOpenListRequest(index)
	Socket:sendAndLock(10206,{index = index})
end

function This:onOpenListReply(msg)
	if msg.err_code == 0 then
		local queue = self:getList(msg.index)
		queue:setIsOpen(true)
		self:notifyObservers("onOpenList",queue)
	else
		g_scene:handleErrorCode(msg.err_code)
	end
end

function This:onEditListNameRequest(index,name)
	local queue = self:getList(index)
	local idList = queue:getHeroList()
	self:onEditListReqest(index,name,idList)
end

function This:onEditListHeroRequest(index,idList)
	local queue = self:getList(index)
	self:onEditListReqest(index,queue:getName(),idList)
end

function This:onEditListReqest(index,name,idList)
	local uidList = {}
	for i , heroId in ipairs(idList) do
		local hero = HeroManager:getHero(heroId)
		table.insert(uidList,hero:getUid())
	end
	Socket:sendAndLock(10207,{index = index , name = name, card_id = uidList})
end

function This:onEditListReply(msg)
	if msg.err_code == 0 then
		local queue = self:getList(msg.queue.index)
		queue:setName(msg.queue.name)
		queue:updateHeroWithUid(msg.queue.card_id)
		self:notifyObservers("onEditList",queue)
	else
		g_scene:handleErrorCode(msg.err_code)
	end
end





--endregion
