--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"Base.BaseModel")
local UpdateList = require("Base.UpdateList")
local HeroManager = require("Hero.HeroManager")
local HeroListConfig = require("Metadatas.HeroListConfig")
local MatchManager = require("Match.MatchManager")
local GamePlayer = require("Player.GamePlayer")
local MatchManager = require("Match.MatchManager")

function This:init(index)
    self.m_index = index
    self.m_isOpen = false
    self.m_name = ""
    self.m_list = UpdateList:create()
end

function This:getIndex()
    return self.m_index
end

function This:getName()
    if self.m_name == "" then
		return string.format(Serialize[61620],self.m_index)
	end
	return self.m_name
end

function This:setName(name)
    self.m_name = name
end

function This:addHero(heroId)
    if not self.m_list:hasNode(heroId) then
        self.m_list:addNode(heroId)
    end
end

function This:removeHero(heroId)
    if self.m_list:hasNode(heroId) then
        self.m_list:removeNode(heroId)
    end
end

function This:updateHero(heroList)
    self.m_list:clear()
    for i , heroId in ipairs(heroList) do
        self.m_list:addNode(heroId)
    end
end

function This:updateHeroWithUid(uidList)
	self.m_list:clear()
	for i , uid in ipairs(uidList) do
		local hero = HeroManager:getHeroByUid(uid)
		self.m_list:addNode(hero:getId())
	end
end

function This:hasHero(heroId)
    return self.m_list:hasNode(heroId)
end

function This:swapHero(a,b)
    self.m_list:swapNode(a,b)
end

function This:getHeroList()
    return self.m_list:getNodeList()
end

function This:getUpdateList()
    return self.m_list
end

function This:getCount()
    return self.m_list:getSize()
end

function This:getOpenCondition()
	return HeroListConfig[self.m_index].rank_level , HeroListConfig[self.m_index].role_level , HeroListConfig[self.m_index].cost
end

function This:isOpen()
	if self.m_isOpen then
		return true
	end
	local rank , level = self:getOpenCondition()
	if GamePlayer:getLevel() >= level then
		return true
	end
	if MatchManager:getRankLv() >= rank then
		return true
	end
    return false
end

function This:setIsOpen(bOpen)
    self.m_isOpen = bOpen
end

--endregion
