--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"Dialog")
local HeroListManager = require("List.HeroListManager")
local MatchingConfig = require("Metadatas.MatchingConfig")

function This:initNode()
	self.m_csNode = cc.Node:createFromCSFile("GameScene/NodeUI/ListMain.csb")
	self:addChild(self.m_csNode)
	self.m_csNode:setToCenter()
	self:refresh()
end

function This:refresh()
	for i = 1 , 6 do
		local queue = HeroListManager:getList(i)
		if queue:isOpen() then
			self.m_csNode["list"..i]:clearShader()
		else
			self.m_csNode["list"..i]:setGrayShader()
		end
		self.m_csNode["list"..i].name:setString(queue:getName())
	end
end

function This:initTouchEvent()
	for i = 1, 6  do
		local queue = HeroListManager:getList(i)
		self.m_csNode["list"..i]:setTouchEnded(function()
			if queue:isOpen() then
				self:onListBtnClicked(i)
			else
				local rank , level , cost = queue:getOpenCondition()
				local str = string.format(Serialize[61622],MatchingConfig[rank].rank_level,level,cost)
				if i > 1 then
					local prequeue = HeroListManager:getList(i-1)
					if not prequeue:isOpen() then
						g_scene:showTips(string.format(Serialize[61623],i-1))
						return
					end
				end
				local panel = g_scene:openDialog("UI.ConfirmPanel")
				panel:setOkHandler(function()
					HeroListManager:onOpenListRequest(i)
				end)
				panel:setString(str)
			end
		end)
	end
	self.m_csNode.close:setTouchEnded(function()
		self:close()
	end)
end

function This:onEnter()
	super.onEnter(self)
	HeroListManager:addObserver(self)
end

function This:onExit()
	super.onExit(self)
	HeroListManager:removeObserver(self)
end

function This:onListBtnClicked(index)
	local queue = HeroListManager:getList(index)
	g_scene:openDialog("List.ListEditorPanel",queue)
end

function This:onOpenList(index)
	self:refresh()
end

function This:onEditList()
	self:refresh()
end


--endregion
