--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super  = class(...,"Dialog")
local HeroListManager = require("List.HeroListManager")
local GamePlayer = require("Player.GamePlayer")

local GameUtil = require("Util.GameUtil")

function This:initNode(info)
	self.m_csNode = cc.Node:createFromCSFile("GameScene/NodeUI/ListPreservation.csb")
	self:addChild(self.m_csNode)
	self.m_csNode:setToCenter()
	self.m_csNode.editor:setString(info.defaultStr or "")
	if info.title then
		self.m_csNode.title:setString(info.title)
	end
	if info.maxLength then
		self.m_csNode.editor:setMaxLength(info.maxLength)
	end
	if info.cost then
		self.m_csNode.num:setString(info.cost)
	else
		self.m_csNode.num:setVisible(false)
		self.m_csNode.icon:setVisible(false)
	end
	self.m_info = info
end

function This:initTouchEvent()
	self.m_csNode.close:setTouchEnded(function()
		self:close()
	end)
	self.m_csNode.cancel:setTouchEnded(function()
		self:close()
	end)
	self.m_csNode.confirm:setTouchEnded(function()
		local str = self.m_csNode.editor:getString()
		local len = string.utf8Len(str)
		if len <= 0 then
			g_scene:showTips(Serialize[61628])
			return
		elseif len < 2 then
			g_scene:showTips(Serialize[61629])
			return
		elseif len > 7 then
			g_scene:showTips(Serialize[61630]) 
			return
		elseif GameUtil:checkInvalidAscill(str) then
			g_scene:showTips(Serialize[61631])
			return
		end
		if self.m_info.cost then
			self.m_info.okHandler = function()
				if self.m_renameHandler then
					self.m_renameHandler(str)
				end
				self:close()
			end
			GamePlayer:costDiamond(self.m_info)
		else
			if self.m_renameHandler then
				self.m_renameHandler(str)
			end
			self:close()
		end
	end)
end

function This:onEnter()
	super.onEnter(self)
	HeroListManager:addObserver(self)
end

function This:onExit()
	super.onExit(self)
	HeroListManager:removeObserver(self)
end

function This:onEditList()
	self:close()
end

function This:setTitle(str)
	self.m_csNode.title:setString(str)
end

function This:setRenameHandler(handler)
	self.m_renameHandler = handler
end

--endregion
