--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(..., "Scene")

local kShowTime = 60.0 		--显示时间
local kShowMode = 1		--显示模式
local kShortTime = 2.0

os.isSingleServerZone = false
function This:init()
	super.init(self)
	self.m_escape = 0
	self.m_updating = true
	if false and os.isSingleServerZone then
		self:initStudioLogo()
	else
		kShowTime = kShortTime
		self:initUI()
	end
end


function This:initStudioLogo()
    self.m_maskLayer = cc.LayerColor:create(cc.Color(255, 255, 255, 255))
    self:addChild(self.m_maskLayer, -1)

    local modelName = "Logo"
    local skeletonNode = cc.SkeletonNode:createCharacter(modelName)
    skeletonNode:scheduleUpdate()
	skeletonNode:playAnimation("animation", false)
	skeletonNode:setAnimationListener({
		onAnimationComplete = function (_,animationName,animationEvent)
			skeletonNode:removeFromParent()
			self:initUI()
			kShowTime = 5.0
			print("Logo end!!!!")
		end
	})
    self:addChild(skeletonNode)
	skeletonNode:setToCenter()
end

function This:initUI()
	if self.m_maskLayer then
		self.m_maskLayer:setVisible(false)
	end
	local csNode = cc.Node:createFromCSFile("GameScene/NodeUI/JianKangScene.csb")
	self.m_csNode = csNode
	self:addChild(csNode)
	csNode:fitScreen(kShowMode)

	if csNode.text.isbn then
		csNode.text.isbn:setVisible(false and os.isSingleServerZone)
	end
end

function This:update(dt)
	super.update(self, dt)
	self.m_escape = self.m_escape + dt
	if self.m_updating and self.m_escape >= kShowTime then
		self.m_updating = false
		local callback
		if g_setting.isDebug and (g_setting.isWarTest or g_setting.isWarWithNetTest) then
			cc.Application:initGame()
			if g_setting.isWarWithNetTest then
				local panel = g_scene:openDialog("Login.LoginUI")
				if panel then
					panel:login()
				end
				g_scene:setTimer(0.5, function ()
					local LoginManager = require("Login.LoginManager")
					LoginManager:onLoginGameServerRequest(LoginManager:getLoginServer():getId())
				end, "login_action1")
			elseif g_setting.isWarTest then
				require("Map.GameMapUtil").getTestor(g_setting.isWarTest, true)
			end
		else
			cc.SceneManager:switchTo("LoginScene")
		end
	end
end

--endregion
