-- @Author: Su
-- @Date:   2020-08-26 15:38:29
-- @Last Modified by:   Su
-- @Last Modified time: 2020-08-26 15:38:29
-- @File Name: LoginSceneLanguagePanel.lua
-- 登陆语言选择

local This , super = class(...,"Dialog")
local GameSetting = require("GameSetting")

This.fileName = "LoginScene/NodeUI/LoginSceneLanguage.csb"

function This:initNode(info)
    self.m_csNode = cc.Node:createFromCSFile(This.fileName)
    self.m_csNode:setToCenter()
    self:addChild(self.m_csNode)

end

function This:initTouchEvent()
    local setLangType = function (langType)
        if AppText:getLanguage() == langType then
            GameSetting:set("language", langType)
            GameSetting:save()
            self:close()
        else
            AppText:setLanguage(langType)
        end
    end

    self.m_csNode.en_US:setTouchEnded(function()
        setLangType(AppLanguage.en_US)
		-- self:close()
    end)  
    
    self.m_csNode.zh_TW:setTouchEnded(function()
		setLangType(AppLanguage.zh_TW)
		-- self:close()
    end)    
    
    self.m_csNode.zh_CN:setTouchEnded(function()
        setLangType(AppLanguage.zh_CN)
		-- self:close()
	end)    
end

function This:onTouchMask ()
    self:close()
end