--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"Base.BaseModel")
local LoginUtil = require("Login.LoginUtil")
local ServerDisplayConfig = require("Metadatas.ServerDisplayConfig")

function This:init(info)
	self.m_id = info.id
	self.m_state = info.state
	self.m_name = info.name
	self.m_ip = info.ip
	self.m_port = info.port
	self.m_group = info.groupid
	if kLoginDefaultGroupIdFix then
		self.m_group = kLoginDefaultGroupId
	elseif self.m_group <= 0 then
		self.m_group = kLoginDefaultGroupId
	end
	self.m_serverGroup = info.groupid
	self.m_roleList = {}
	self.m_index = 0
	self.m_isRecommand = false
	for i , role in ipairs(info.role_list) do
		table.insert(self.m_roleList,{id = role.role_id,name = role.role_name})
	end
end

function This:getId()
	return self.m_id
end

function This:getState()
	return self.m_state
end

function This:setIsRecommand(isRecommand)
	self.m_isRecommand = isRecommand
end

function This:isRecommand()
	return self.m_isRecommand
end

function This:getName()
	return self.m_name
end

function This:hasRole()
	return #self.m_roleList > 0
end

function This:addRole(info)
	table.insert(self.m_roleList,info)
end

function This:getRoleId(index)
	index = index or 1
	if self.m_roleList[index] then
		return self.m_roleList[index].id
	end
	return 0
end

function This:getRoleList()
	return self.m_roleList
end

function This:getIp()
	return self.m_ip
end

function This:getPort()
	return self.m_port
end

function This:getIndex()
	return self.m_index
end

function This:getGroup()
    return self.m_group
end

function This:setGroupIndex(index)
	self.m_indexInGroup = index
end

function This:setIndex(index)
	self.m_index = index
end

function This:getIndexInGroup()
	 return self.m_indexInGroup
end

function This:getAreaName(haveServerName)
	if not self.m_serAreaName then
		local serStrs ={
			[0] = "Z",
			[1] = "B",
			[2] = "R",
			[3] = "M",
		}
		self.m_groupName = serStrs[self.m_serverGroup].. "-".. (self:getIndexInGroup() or 1)
		local serAreaName = serStrs[self.m_serverGroup].. (self:getIndexInGroup() or 1).. "-".. self:getName()
		local displayItem = ServerDisplayConfig[self:getId()]
		if displayItem then
			serAreaName = serAreaName..displayItem.display
		end
		self.m_serAreaName = serAreaName
	end
	if haveServerName then
		return self.m_serAreaName
	else
		return self.m_groupName
	end
end

--endregion
