-- @Author: superm
-- @Date:   2019-01-09 15:53:23
-- @Last Modified by:   zheng
-- @Last Modified time: 2020-01-16 18:47:02
-- @File Name: LoginUtil.lua
-- @Description: 

local This = class(...)
-- os.isSingleServerZone = true

LoginState =
{
	kFree= 0,
	kConnectingLoginServer = 1,
	kRegisterAccount = 2,
	kLoginingLoginServer = 3,
	kConnectingGameServer = 4,
	kLoginingGameServer = 5,
	kEnterGame = 6,
}

LoginError = 
{
	kNoUserAccount = 10006,  --无账号
	kPasswordWrong = 10007, --密码错误
}

ServerState = 
{
	kFree = 0, --空闲
	kBusy = 1, --忙碌
	kMaintenance = 2, --维护
	kNormal = 3, --正常
}

ServerStateImage =   --服务器状态资源
{
	[ServerState.kBusy] = "LoginScene/baomanxin.png",
	[ServerState.kFree] = "LoginScene/changtongxin.png",
	[ServerState.kMaintenance] = "LoginScene/weihuxin.png",
	[ServerState.kNormal] = "LoginScene/yongduxin.png",
}

kLoginDefaultGroupId = 1
kLoginDefaultGroupIdFix = os.isWin32 or os.isIosSimulator

function This.getGroupConfig()
    local ServerConfig = require("Net.ServerConfig")
	local packageId = This.getPackageId()
	local ServerZoomConfig = require("Metadatas.ServerZoomConfig")
	local config = ServerZoomConfig[packageId]
	return config
end

function This.getDefaultGroupId()
	local config = This.getGroupConfig()
	if config and config.name then
		return config.name[1]
	end
end

function This.getPackageId()
	local censoring = nil
	if cc.FileUtils:isFileExist("Metadatas/ServerZoomCensoringConfig.lua") then
		censoring = require("Metadatas.ServerZoomCensoringConfig")
	end
	if kLoginDefaultGroupIdFix then
		return 0
	elseif os.isSingleServerZone then
		if censoring then
	    	return censoring
	    end
		return 2
	else
	    local ServerConfig = require("Net.ServerConfig")
	    if os.isIos and ServerConfig.isAudit then
	    	return 0
	    end
	    if censoring then
	    	return censoring
	    end
		return tonumber(ServerConfig.censoring) or 1
	end
end