-- @Author: superm
-- @Date:   2018-03-23 14:17:24
-- @Last Modified by:   zheng
-- @Last Modified time: 2020-01-16 16:22:28
-- @File Name: ServerItemView.lua
-- @Description: 

local This , super = class(..., "NodeView")

function This:initData(server,isReXue)
	self.m_isReXue = isReXue
	self.m_server = server
	local csNode = cc.Node:createFromCSFile("LoginScene/NodeUI/ZoneNode.csb")
	self.m_csNode = csNode
	self:addChild(csNode)

	local bgNode = csNode.bg or csNode.normal
	local w, h = bgNode:getContentSize()
    self:setContentSize(w, h)
end

function This:initNode()
	self:refresh()
end

function This:refresh()
	local csNode = self.m_csNode
	csNode.new:setVisible(self.m_server:isRecommand())
	local state = self.m_server:getState()
	csNode.state:setImage(ServerStateImage[state])
	local name = string.format(Serialize[61643],self.m_server:getIndexInGroup(not self.m_isReXue) ,self.m_server:getName())
	csNode.name:setString(name)
end

function This:initTouchEvent()
	if not self.m_inited then
		local csNode = self.m_csNode
		csNode.bg:setTouch({
			onEnded = function()
				if self.m_selectHandler then
					self.m_selectHandler(self.m_server)
				end
			end,
			isScale = false,
			isContainer = self.m_isInContainer
		})
		self.m_inited = true
	end
end

function This:setTouchIsContanier(isContanier)
	self.m_isInContainer = isContanier
end

function This:setSelectHandler(handler)
	self.m_selectHandler = handler
end

function This:onEnter()
	super.onEnter(self)
	self:initTouchEvent()
end

function This:setModel(server)
	if self.m_server ~= server then
		self.m_server = server
		self:refresh()
	end
end

--endregion
