-- @Author: superm
-- @Date:   2018-03-23 14:17:24
-- @Last Modified by:   superm
-- @Last Modified time: 2019-01-10 15:06:56
-- @File Name: ServerTabNode.lua
-- @Description: 

local This , super = class(..., "NodeView")

function This:initData(info)
	self.m_index = info.index
	self.m_isSelect = false
	self.m_name = info.name

	local csNode = cc.Node:createFromCSFile("LoginScene/NodeUI/SelectBigZoneItem.csb")
	self.m_csNode = csNode
	self:addChild(csNode)

	local bgNode = csNode.normal
	local w, h = bgNode:getContentSize()
    if info.fullMode then
    	w = 150
    	bgNode:setContentSize(w, h)
    	csNode.light:setContentSize(w, h)
    end
    self:setContentSize(w, h)
end

function This:initNode()
	local csNode = self.m_csNode
	csNode.text:setString(self.m_name)
	csNode.light:setVisible(false)
end

function This:initTouchEvent(  )
	if not self.m_inited then
		local csNode = self.m_csNode
		csNode.normal:setTouch({
			onEnded = function()
				if self.m_touchHandler then
					self.m_touchHandler()
				end
			end,
			isScale = false,
			isContainer = true,
		})
		self.m_inited = true
	end
end

function This:setSelect(isSelect)
	if isSelect ~= self.m_isSelect then
		self.m_csNode.light:setVisible(isSelect)
		self.m_isSelect = isSelect
		if self.m_selectHandler and isSelect then
			self.m_selectHandler(self.m_index)
		end
	end
end

function This:getIndex()
	return self.m_index
end

function This:setSelectHandler(handler)
	self.m_selectHandler = handler
end

function This:setTouchHandler(handler)
	self.m_touchHandler = handler
end

--endregion
