-- @Author: superm
-- @Date:   2018-12-15 17:09:29
-- @Last Modified by:   zheng
-- @Last Modified time: 2019-04-17 12:03:51
-- @File Name: EditMiniUI.lua
-- @Description: 

local This , super = class(...,"cc.Node")
local LegionEditMinMapNode = require("Map.LegionEditMinMapNode")

function This:init()
	self.m_scene = g_scene
	self.m_cityNodes = {}
end

function This:initUI()
	local sourceNode = cc.Node:createFromCSFile(g_scene:getMiniUIFileName())
	local mapNode = sourceNode.smallmap
	local csNode = cc.Node:create()
	mapNode:switchParent(csNode)
	csNode.smallmap = mapNode
	self.m_csNode = csNode
    self:addChild(self.m_csNode) 

    mapNode.voice:setVisible(false)
    mapNode.search:setVisible(true)
    mapNode.help:setVisible(false)
    if mapNode.battlelog then
    	mapNode.battlelog:setVisible(false)
    end
    if mapNode.timetips then
    	mapNode.timetips:setVisible(false)
    end
end

function This:onEnter()
	super.onEnter(self)
    self:initUI()
	self:initTouchEvent()
    self:initMiniMap()
end


function This:initTouchEvent()
	local smapNode = self.m_csNode.smallmap
	smapNode.map_bg:setTouch({
		onEnded = function()
			self.m_scene:openDialog("Map.EditMiniMapPanel", {
				mapRadioX = self.m_scene.m_mapRadioX,
				mapRadioY = self.m_scene.m_mapRadioY,
				filename = self.m_scene.m_mapCsFileName,
			})
		end,
		isScale = false,
		isAlpha = false
	})

	smapNode.search:setTouchEnded(function()
		self.m_scene:openDialog("Map.EditSearchCityPanel")
	end)
end

function This:createCeil(nx, ny, color, mapNode)
	local b = cc.Vec(self.m_dx, self.m_dy):length() / 2
	local t = self.m_vy * b * (ny + 0.5) + self.m_vx * b * (nx + 0.5)
	local layer = cc.Sprite:create("LegionScene/lingxing.png")
	layer:setPosition(t.x, t.y)
	layer:setColor(color.r,color.g,color.b)
	layer:setOpacity(100)
	layer:setScale(self.m_dx / 250 )
	
	mapNode:addChild(layer)
	return layer
end

function This:initMiniMap()

	-- local ColorList = 
	-- {
	-- 	cc.Color.WHITE,
	-- 	cc.Color.YELLOW,
	-- 	cc.Color.GREEN,
	-- 	cc.Color.BLUE,
	-- 	cc.Color.RED,
	-- 	cc.Color.MAGENTA,
	-- 	cc.Color.BLACK,
	-- 	cc.Color.ORANGE,
	-- 	cc.Color.GRAY,
	-- 	cc.ColorList.New14,
	-- 	cc.ColorList.New12,
	-- 	cc.ColorList.New11,
	-- 	cc.ColorList.New10,
	-- 	cc.ColorList.New9,
	-- 	cc.ColorList.New4,
	-- 	cc.ColorList.QQ6,
	-- 	cc.ColorList.QQ5,
	-- 	cc.ColorList.QQ3,
	-- 	cc.ColorList.PetPhase2,
	-- 	cc.ColorList.PetPhase1,
	-- 	cc.ColorList.PetPhase5
	-- }

	 -- local mapNode = self.m_csNode.smallmap.map
	 -- mapNode:setCascadeOpacityEnabled(false)
	 -- mapNode:setOpacity(0)

	 -- local w , h = mapNode:getContentSize()
	-- if self.m_scene.m_cityInfo then
	-- 	for cityId , config in pairs(self.m_scene.m_cityInfo) do

	-- 		for j , ceilKey in ipairs(config.ceilList) do
	-- 			local nx = math.floor(ceilKey / 1000)
	-- 			local ny = ceilKey % 1000
	-- 			self:createCeil(nx,ny, ColorList[config.color] or cc.Color(0,0,0,0), mapNode)
	-- 		end

	-- 		local node = cc.Sprite:create("WarScene/town_0.png")
	-- 		node:setScale(0.2)
	-- 		local rx, ry = self.m_scene:getCityNodeRadio(cityId)
	-- 		node:setPosition(rx * w , ry * h)
	-- 		mapNode:addChild(node)
	-- 		self.m_cityNodes[cityId] = node
	-- 		-- self:refreshMapCityNode(cityId)
	-- 	end
	-- end


	-- local color = cc.Color.RED
	-- color.a = 64
	-- local len = 300
	-- for i = 0 , nx do
	-- 	local p1 = cc.Vec(i * dx, 0)
	-- 	local l1 = math.min(w - p1.x , (h / f))
	-- 	local p2 = cc.Vec(1, f) * l1 + p1
	-- 	self.m_drawNode:drawLine(p1,p2,color)
	-- end

	-- for i = 1 , ny do
	-- 	local p1 = cc.Vec(0 , i * dy)
	-- 	local l2 = math.min(w,(h - p1.y) / f)
	-- 	local p3 = cc.Vec(1, f) * l2 + p1
	-- 	self.m_drawNode:drawLine(p1,p3,color)
	-- end

	-- for i = 1 , ny do
	-- 	local p1 = cc.Vec(0 , i * dy)
	-- 	local l = math.min(w, p1.y / f)
	-- 	local p2 = cc.Vec(1,-f) * l + p1
	-- 	self.m_drawNode:drawLine(p1,p2,color)
	-- end

	-- local top = ny * dy
	-- for i = 0 , nx do
	-- 	local p1 = cc.Vec(i * dx, top)
	-- 	local l = math.min(w - p1.x, top / f)
	-- 	local p2 = cc.Vec(1,-f) * l + p1
	-- 	self.m_drawNode:drawLine(p1,p2,color)
	-- end
	local info = { 
		map = self.m_map, 
		-- scaleRate = self.m_scene.m_miniScaleRate,
		scaleRateX = self.m_scene.m_miniScaleRateX,
		scaleRateY = self.m_scene.m_miniScaleRateY,
		mapRadioX = self.m_scene.m_miniMapRadioX,
		mapRadioY = self.m_scene.m_miniMapRadioY,
		mapNode = self.m_csNode.smallmap.map, 
	}
	local liangDianNode = LegionEditMinMapNode:create(info)
	self:addChild(liangDianNode)
	liangDianNode:refresh()
	self.m_liangDianNode = liangDianNode

	self.m_rectW , self.m_rectH = 35, 25
	self.m_rectNode = cc.DrawNode:create()
	self.m_rectNode:drawRect(cc.Rect(0,0,self.m_rectW,self.m_rectH),cc.Color(255,255,0,255))
	self.m_csNode.smallmap.map.img:addChild(self.m_rectNode)

	local rx , ry = self.m_scene:getViewportCenterRatio()
	local w , h = self.m_csNode.smallmap.map.img:getContentSize()
	local x1,y1 = rx * w - self.m_rectW / 2, ry * h - self.m_rectH / 2
	self:updateMiniPos(x1,y1)
end

function This:updateMiniMap(rx,ry)
	local cw, ch = self.m_csNode.smallmap.map:getContentSize()
	local w , h = self.m_csNode.smallmap.map.img:getContentSize()
	local y = ry * h - self.m_rectH / 2
	local topy = y + self.m_rectH
	if topy > ch then
		self.m_csNode.smallmap.map.img:setPositionY(ch - topy)
	end
	local x = rx * w - self.m_rectW / 2
	x = math.min(w - self.m_rectW, math.max(0,x))
	y = math.min(h - self.m_rectH, math.max(0,y))
	self:updateMiniPos(x,y)
end

function This:updateMiniPos(x,y)
	-- print("xy",x,y)
	self.m_rectNode:setPosition(x,y)
end
