-- @Author: superm
-- @Date:   2019-03-26 15:41:36
-- @Last Modified by:   superm
-- @Last Modified time: 2019-10-11 11:58:43
-- @File Name: GameMapUtil.lua
-- @Description: 

local This = class( ... )

GameMapType = {
	kLegionMap = 1, --军团地图
	kEmperorMap = 2, --皇帝战地图
	kRescueMap = 3,	--勤王战
}

function This.getTestor(mapType, forceEnter)
	local GameMapManager = require("Map.GameMapManager")
	local map = GameMapManager:getMap(mapType)
	if not map then 
		print("没找到地图")
		return
	end

	local switch = {  
	    [GameMapType.kLegionMap] = function()  
	        return require("Map.LegionTestManager")
	    end,  
	    [GameMapType.kEmperorMap] = function()  
	        return require("Map.LegionTestManager")
	    end,  
	    [GameMapType.kRescueMap] = function()  
	        return require("RescueEmperor.RescueTestManager") 
	    end,  
	}  
	  
	local fSwitch = switch[mapType]
	if fSwitch then
	    local model = fSwitch() 
		local testor = model:create(map)
		if forceEnter then
			testor:createMap()
			map:enter()
		end
	end  
end

function This.enterMap(mapType)
	local GameMapManager = require("Map.GameMapManager")
	local map = GameMapManager:getMap(mapType)
	if not map then 
		print("没找到地图")
		return
	else
		map:enter()
	end
end

function This.getEditor(mapType, forceEnter)
	local switch = {  
	    [GameMapType.kLegionMap] = {
			width = 4500,
			height = 4500,
			mapRadioX = 1.3,
			mapRadioY = 1.3,
			-- miniScaleRate = 119 / 470,
			miniScaleRateX = 119 / 470,
			miniScaleRateY = 119 / 470,
			miniMapRadioX = 2.15,
			miniMapRadioY = 2.15,
			output_config = "Map.CeilsConfig",
			city_config = "Metadatas.LegionCityConfig",
			csfile = "LegionScene/NodeUI/LegionScene.csb",
			uicsfile = "LegionScene/NodeUI/LegionBuildMain.csb",
			mapcsfiel = "LegionScene/NodeUI/LegionWorldMap.csb",
		},
	    [GameMapType.kEmperorMap] = {
			width = 4500,
			height = 4500,
			mapRadioX = 1.3,
			mapRadioY = 1.3,
			-- miniScaleRate = 119 / 470,
			miniScaleRateX = 119 / 470,
			miniScaleRateY = 119 / 470,
			miniMapRadioX = 2.15,
			miniMapRadioY = 2.15,
			output_config = "Map.CeilsConfig",
			city_config = "Metadatas.LegionCityConfig",
			csfile = "LegionScene/NodeUI/LegionScene.csb",
			uicsfile = "LegionScene/NodeUI/LegionBuildMain.csb",
			mapcsfiel = "LegionScene/NodeUI/LegionWorldMap.csb",
		},
	    [GameMapType.kRescueMap] = {
			width = 3000,
			height = 2500,
			mapRadioX = 2.54,
			mapRadioY = 2.54,
			-- miniScaleRate = 195 / 512,
			miniScaleRateX = 195 / 512,
			miniScaleRateY = 195 / 512,
			-- miniScaleRateX = 195 / 513,
			-- miniScaleRateY = 195 / 512,
			miniMapRadioX = 2.75,
			miniMapRadioY = 2.75,
			output_config = "RescueEmperor.RescueCeilsConfig",
			city_config = "Metadatas.RescueEmperorCityConfig",
			csfile = "RescueEmperor/RescueEmperorScene.csb",
			uicsfile = "RescueEmperor/RescueEmperorBuildMain.csb",
			mapcsfiel = "RescueEmperor/RescueEmperorWorldMap.csb",
		},
	}  
	  
	local param = switch[mapType]
	if param then
	    cc.SceneManager:switchTo("Map.LegionEditScene", nil, param)
	end  
end

