--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"cc.Node")
local GameUtil = require("Util.GameUtil")
local GamePlayer = require("Player.GamePlayer")

function This:init(info)
	self.m_map = info.map
	self.m_city = info.city
	self.m_junce = info.junce
	self.m_csNode = cc.Node:createFromCSFile("LegionScene/NodeUI/LegionPlanItem.csb")
	self:addChild(self.m_csNode)
	self.m_escape = 0
end

function This:refresh()
	local csNode = self.m_csNode
	csNode.name:setString(self.m_junce:getName())
	local maxTime = self.m_junce:getUseMaxTime()
	if maxTime > 0 then
		csNode.limit:setString(string.format("%d/%d",self.m_junce:getCount(), maxTime))
		csNode.limit:setVisible(true)
	else
		csNode.limit:setVisible(false)
	end
	csNode.icon:setImage(self.m_junce:getIcon())
	self:refreshTime()
	local leftCd = self.m_junce:getLeftUseCDTime()
	local isCanUse = self.m_junce:isCanUseOnCity(self.m_city)
	csNode.cantuse:setVisible(leftCd <= 0 and not isCanUse)
	csNode.number:setVisible(true)

end

function This:refreshTime()
	local useCd = self.m_junce:getUseCDTime()
	self.m_csNode.normal:setVisible(useCd > 0)
	self.m_csNode.progress:setVisible(useCd > 0)
	if useCd <= 0 then
		return
	end
	local leftCd = self.m_junce:getLeftUseCDTime()
	self.m_csNode.normal:setString(GameUtil:formatTime(Serialize["H_M_S"],leftCd))
	if not self.m_progressTimer then
		self.m_progressTimer =  cc.ProgressTimer:create(self.m_csNode.progress.cooldowncd)
		self.m_csNode.progress:addChild(self.m_progressTimer)
	end
	self.m_progressTimer:setPercent(leftCd / useCd * 100)
	--self.m_progressTimer:startTimer(useCd, useCd - leftCd)
end

function This:initTouchEvent()
	self.m_csNode.bg:setTouch({
		onEnded = function()
			local leftCd = self.m_junce:getLeftUseCDTime()
			if leftCd > 0 then
				local cost = self.m_junce:getClearCDCost()
				GamePlayer:costDiamond({
					cost = cost,
					okHandler = function()
						self.m_map:onClearJunceUseCDRequest(self.m_junce:getId())
					end
				})
			else
				local isCan , reason = self.m_junce:isCanUseOnCity(self.m_city)
				if isCan then
					g_scene:openDialog("UI.ConfirmPanel",{
						richText = Serialize[61665],
						okHandler = function()
							self.m_map:onUseLegionJunCeRequest(self.m_city:getId(), self.m_junce:getId())
						end
					})
				else
					g_scene:showTips(reason)
				end
			end
		end,
		isScale = false,
		isContainer = true
	})
end

function This:onEnter()
	super.onEnter(self)
	self.m_map:addObserver(self)
	self:scheduleUpdate()
	self:refresh()
	self:initTouchEvent()
end

function This:onExit()
	super.onExit(self)
	self.m_map:removeObserver(self)
end

function This:onLegionJunCeChanged(junce)
	if junce == self.m_junce then
		self:refresh()
	end
end

function This:update(dt)
	self.m_escape = self.m_escape + dt
	if self.m_escape < 1 then
		return
	end
	self.m_escape = self.m_escape - 1
	self:refresh()
end
--endregion
