--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"Dialog")
local LegionBattleItemView = require("Map.LegionBattleItemView")

function This:initNode(info)
	self.m_map = info.map
	self.m_cityId = info.cityId
	self.m_map:onGetCityBattleReportRequest(self.m_cityId)
	self.m_msg = {}
	self.m_leftViewList = {}
	self.m_rightViewList = {}

	self.m_csNode = cc.Node:createFromCSFile("LegionScene/NodeUI/LegionBattleReport.csb")
	self:addChild(self.m_csNode)
	self.m_csNode:setToCenter()

	self.m_csNode.shengyubudui:setString(string.format(Serialize[61672]))
end

function This:refresh()
	local itemList = self.m_csNode.attack_scroll:getItemList()
	for i , info in ipairs(self.m_msg.attack_troop_list) do
		info.index = i
		if self.m_leftViewList[i] then
			self.m_leftViewList[i]:setModel(info)
		else
			local view = LegionBattleItemView:create(info)
			self.m_csNode.attack_scroll:pushBackCustomItem(view,400,80)
			self.m_leftViewList[i] = view
		end
	end
	for i = #itemList , #self.m_msg.attack_troop_list + 1, -1 do
		self.m_csNode.attack_scroll:removeItem(i)
	end
	itemList = self.m_csNode.guard_scroll:getItemList()
	for i , info in ipairs(self.m_msg.guard_troop_list) do
		info.index = i
		if self.m_rightViewList[i] then
			self.m_rightViewList[i]:setModel(info)
		else
			local view = LegionBattleItemView:create(info)
			self.m_csNode.guard_scroll:pushBackCustomItem(view,400,80)
			self.m_rightViewList[i] = view
		end
	end
	for i = #itemList , #self.m_msg.guard_troop_list + 1, -1 do 
		self.m_csNode.guard_scroll:removeItem(i)
	end
	self.m_csNode.shengyubudui:setString(string.format(Serialize[61673],#self.m_msg.attack_troop_list,#self.m_msg.guard_troop_list))
end

function This:onEnter()
	super.onEnter(self)
	self.m_map:addObserver(self)
end

function This:onExit()
	super.onExit(self)
	self.m_map:removeObserver(self)
end

function This:initTouchEvent()
	self.m_csNode.shuaxin:setTouchEnded(function()
		local city = self.m_map:getCity(self.m_cityId)
		if city:isInFighting() then
			self.m_map:onGetCityBattleReportRequest(self.m_cityId)
		else
			g_scene:showTips(Serialize[61674])
		end
	end)
	self.m_csNode.close:setTouchEnded(function()
		self:close()
	end)
end

function This:onGetCityBattleReport(msg)
	if msg.attack_troop_list then
		self.m_msg = msg
		self:refresh()
	end
end


--endregion
