--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"Base.BaseModel")

function This:init(info)
	self.m_map = info.map
	self.m_troop = nil
	self.m_name = ""
	self.m_pos = info.pos or 0
	self.m_transResList = {0,0,0,0,0,0}
end

function This:getTroop()
	return self.m_troop
end

function This:getName()
	return self.m_name
end

function This:getPos()
	return self.m_pos
end

function This:getState()
	if self.m_troop then
		return self.m_troop:getState()
	end
	return LegionTroopState.kIdle
end

function This:getCityId()
	if self.m_troop then
		return self.m_troop:getCityId()
	end
	return 0
end

function This:getFightPower()
	if self.m_troop then
		return self.m_troop:getFightPower()
	end
	return 0
end

function This:isEmpty()
	if self.m_troop == nil then
		return true
	end
	local cardList = self.m_troop:getCardList()
	return #cardList <= 0
end

function This:setTroop(troop,index)
	if self.m_troop ~= troop then
		self.m_troop = troop
		self.m_pos = index
	end
end

function This:getState()
	if self.m_troop then
		return self.m_troop:getState()
	end
	return LegionTroopState.kIdle
end

function This:getTotalHp()
	return self.m_troop:getTotalHp()
end

function This:getTotalTransNum()
	local total = 0
	local cardList = self.m_troop:getCardList()
	for i , card in ipairs(cardList) do
		total = total + card:getTransNum()
	end
	return total
end

function This:getCard(index)
	if self.m_troop then
		return self.m_troop:getCard(index)
	end
end

function This:getCardList()
	if self.m_troop then
		return self.m_troop:getCardList()
	end
	return {}
end

function This:updateInfo(info)
	if info.troop_id > 0 then
		self.m_troop = self.m_map:getTroop(info.troop_id)
		if not self.m_troop then
			assert(false)
		end
		self.m_name = info.name
		if self.m_pos ~= info.pos then
			assert(false)
		end
		self.m_pos = info.pos
	else
		self.m_troop = nil
	end
end

--endregion
