-- @Author: ZYY
-- @Date:   2018-08-14 10:49:30
-- @Last Modified by:   zheng
-- @Last Modified time: 2019-04-01 20:49:44
-- @File Name: LegionBianDuiNode.lua
-- @Desc: 编组小窗口
local This, super = class(...,"NodeUI")
local LegionBianDuiView = require("Map.LegionBianDuiView")

function This:initNode(info)
	self.m_map = info.map
    self.m_csNode = cc.Node:createFromCSFile(self.m_fileName or "LegionScene/NodeUI/LegionTroopsPreview.csb")
	self:addChild(self.m_csNode)
	self.m_troopItemList = {}
	self.m_bianduiList = self.m_map:getAllBianDui()
	self.m_offsetAnim = 140
	self.m_csNode.zhanchu:setAngle(180)
	self:refresh()
end

function This:refresh()
	local maxCount = self.m_map:getMaxBianDuiCount()
	local bianduiCount = self.m_map:getBianDuiCount()
	self.m_csNode.Text_25:setString(string.format("%d/%d",bianduiCount,maxCount))

	for i = 1 , maxCount do 
		local item = self.m_troopItemList[i]
		if not item then 
			local infor = {
				biandui = self.m_bianduiList[i],
				map = self.m_map,
				index = i
			}
			item = self:createItemView(infor)
			self.m_csNode["Node_"..(i + 9)]:addChild(item)
			self.m_troopItemList[i] = item
		end
		item:setModel(self.m_bianduiList[i])
	end
end

function This:createItemView(data)
	return LegionBianDuiView:create(data)
end


function This:initTouchEvent()
	local isHide = false
	local x , y = self:getPosition()
	-- self.m_csNode.shousuo:setTouch({
	-- 	onEnded = function()
	-- 		if not isHide then
	-- 			self:runAction(cc.MoveTo(0.3,x+self.m_offsetAnim,y,"SineOut"))
	-- 			isHide = true
	-- 		end
	-- 	end,	
	-- 	isDynamic = true
	-- })
	self.m_csNode.zhanchu:setTouch({
		onEnded = function()
			if isHide then
				self:runAction(cc.MoveTo(0.3,x,y,"SineOut"))
				isHide = false
				self.m_csNode.zhanchu:setAngle(180)
			else
				self:runAction(cc.MoveTo(0.3,x+self.m_offsetAnim,y,"SineOut"))
				isHide = true
				self.m_csNode.zhanchu:setAngle(0)
			end
		end,
		isDynamic = true
	})
	self.m_csNode.legiontianjia_5:setTouch({
		onEnded = function()
			print("添加最大编队...")
			if self.addBianDui then
				self:addBianDui()
			end
		end,
		isDynamic = true
	})
end

function This:onEnter()
	super.onEnter(self)
	self.m_map:addObserver(self)
end

function This:onExit()
	super.onExit(self)
	self.m_map:removeObserver(self)
end

function This:onUpdateBianDuiTroop(index,team)
	local view = self.m_troopItemList[index]
	if view then
		view:setModel(team)
	end
	local count = self.m_map:getBianDuiCount()
	local maxCount = self.m_map:getMaxBianDuiCount()
	self.m_csNode.Text_25:setString(string.format("%d/%d",count,maxCount))
end

