-- @Author: ZYY
-- @Date:   2018-08-01 11:33:42
-- @Last Modified by: ZYY
-- @Last Modified time: 2018-08-15 10:36:39
-- @File Name: LegionTroopsHeroItemView.lua
-- @Desc: 部队英雄头像
local This , super = class(...,"NodeUI")
local HeroConfig = require("Metadatas.HeroConfig")
local ItemUtil = require("Bag.ItemUtil")

This.fileName = "LegionScene/NodeUI/LegionTroopsHeroItem.csb"

function This:initNode(card)
	self:setModel(card)
end

function This:refresh()
	local heroId = self.m_card:getHeroId()
	local config = HeroConfig[heroId]
	if config then
		self.hero:setImage(ItemUtil.getIconImage(heroId))
		self.bg1:setImage(ItemUtil.getQualityImage(heroId))
		self.level:setString(self.m_card:getLevel())
		local star = math.floor(self.m_card:getStar() / 5)
		for i = 1 , 5 do
			self["star"..i]:setVisible(star >= i)
		end
		self.xuetiao_3:setPercent(self.m_card:getHp() / self.m_card:getMaxHp() * 100)

		self.bg1:setVisible(true)
		self.hero:setVisible(true)
		self.starbg:setVisible(star > 0)
	else
		self.bg1:setVisible(false)
		for i = 1 , 5 do
			self["star"..i]:setVisible(false)
		end
		self.hero:setVisible(false)
		self.starbg:setVisible(false)
	end
end

function This:initTouchEvent()
	
end

function This:setModel(card)
	if self.m_card ~= card then
		self.m_card = card
		self:refresh()
	end
end