--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"Base.BaseModel")
local LegionDefenseNpcConfig = require("Metadatas.LegionDefenseNpcConfig")
local ArgConfig = require("Metadatas.ArgConfig")
local ItemUtil = require("Bag.ItemUtil")
local GameUtil = require("Util.GameUtil")

function This:init(info)
	self.m_map = info.map
	self.m_pos = info.pos
	self.m_configId = 0
	self.m_quality = 0
	self.m_troop = nil
end

function This:getConfigId()
	return self.m_configId
end

function This:getConfig()
	return LegionDefenseNpcConfig[self.m_configId]
end

function This:getTroop()
	return self.m_troop
end

function This:getQuality()
	return self.m_quality
end

function This:getIcon()
	return self.m_config.icon
end

function This:getPos()
	return self.m_pos
end

function This:getQualityUpCost()
	if self.m_quality <= Quality.kOrange then
		return self.m_config.cost
	end
	return 0
end

function This:getCfTrainCostWithOnceKey()
	if self.m_quality < ArgConfig["legion_war_city_npc_train_quality"].arg[1] then
		return ArgConfig["legion_war_city_npc_train_cost"].arg[1]
	end
	return 0
end

function This:updateInfo(info)
	self.m_configId = info.config_id
	self.m_quality = info.quality
	self.m_config = LegionDefenseNpcConfig[self.m_configId]
	self.m_troopId = info.troop_id
	local troop = self.m_map:getTroop(info.troop_id)
	self.m_troop = troop
	if not self.m_troop then
		print("缺乏队列信息，队列 troop_id = %s", GameUtil:int64ToString(info.troop_id))
		-- assert(false)
	end
end



--endregion
