--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"cc.Node")
local GamePlayer = require("Player.GamePlayer")

function This:init(info)
	self.m_chengfang = info.chengfang
	self.m_city = info.city
	self.m_map = info.map
	self.m_csNode = cc.Node:createFromCSFile("LegionScene/NodeUI/LegionDefenseItem.csb")
	self:addChild(self.m_csNode)
end

function This:refresh()
	if self.m_chengfang then
		local quality = self.m_chengfang:getQuality()

		local troop = self.m_chengfang:getTroop()
		local card = troop:getCard(1)
		self.m_csNode.icon:setImage(self.m_chengfang:getIcon())
		self.m_csNode.bg:setImage("MenuScene/itemQuality" .. quality .. ".png")
		self.m_csNode.jiantou:setVisible(quality < Quality.kOrange)
		self.m_csNode.level:setString(string.format("Lv.%d",card:getLevel()))
		self.m_csNode.recruit:setVisible(false)
		self.m_csNode.icon:setVisible(true)
		self.m_csNode.level:setVisible(true)
	else
		self.m_csNode.icon:setVisible(false)
		self.m_csNode.level:setVisible(false)
		self.m_csNode.jiantou:setVisible(false)
		self.m_csNode.recruit:setVisible(true)
	end
end

function This:initTouchEvent()
	self.m_csNode.jiantou:setTouch({
		onEnded = function()
			local cost = self.m_chengfang:getQualityUpCost()
			GamePlayer:costDiamond({
				cost = cost,
				okHandler = function()
					self.m_map:onTrainChengFangRequest(self.m_city:getId(),self.m_chengfang:getPos())
				end
			})
		end,
		isContainer = true
	})
end

function This:onEnter()
	super.onEnter(self)
	self:initTouchEvent()
	self:refresh()
end

function This:setModel(chengfang)
	if self.m_chengfang ~= chengfang then
		self.m_chengfang = chengfang
	end
	self:refresh()
end

--endregion
