--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"Dialog")
local LegionTechView = require("Map.LegionTechView")
local GamePlayer = require("Player.GamePlayer")
local FamilyManager = require("Family.FamilyManager")
local GameUtil = require("Util.GameUtil")
local ItemUtil = require("Bag.ItemUtil")
local FamilyManager = require("Family.FamilyManager")

function This:initNode(info)
	self.m_troopMaxCount = 6
	self.m_city = info.city
	self.m_map = info.map
	self.m_escape = 0
	self.m_csNode = cc.Node:createFromCSFile("LegionScene/NodeUI/LegionBuildMake.csb")
	self:addChild(self.m_csNode)
	self.m_csNode:setToCenter()
	self:scheduleUpdate()
end

function This:refreshBuildState()
	local csNode = self.m_csNode
	local level = self.m_city:getLevel()
	local maxLevel = self.m_city:getMaxLevel()
	local visible = false
	if level >= maxLevel then
		csNode.shengji1:setVisible(visible)
		csNode.shengji2:setVisible(visible)
		return
	end
	
	local isInBuilding = self.m_city:isInBuilding()
	visible = not isInBuilding 
	csNode.shengji1:setVisible(visible)
	csNode.shengji2:setVisible(not visible)
	if visible then
		local upgradeNode = csNode.shengji1
		local upbtn = upgradeNode.shengjibutton
		local curItemNum, costItemNum = self.m_map:getOre(), self.m_city:getLevelUpCost()
		upgradeNode.num:setString(ItemUtil.formatItemCount(curItemNum) .. "/" .. ItemUtil.formatItemCount(costItemNum)) 	    
		if curItemNum >= costItemNum then
            upbtn:clearShader()
        else
            upbtn:setGrayShader()
        end
	end
end

function This:refreshTroopInfo()
	local csNode = self.m_csNode
	local makeListNode = csNode.shengji2
	local level = self.m_city:getLevel()
	local maxLevel = self.m_city:getMaxLevel()
	local visible = false
	if level >= maxLevel then
		csNode.shengji1:setVisible(visible)
		makeListNode:setVisible(visible)
		return
	end

	local isInBuilding = self.m_city:isInBuilding()
	visible = not isInBuilding
	csNode.shengji1:setVisible(visible)
	makeListNode:setVisible(not visible)
	if visible then
		return
	end

	local maxJianSheDu = self.m_city:getMaxJianSheDu()
	local curJianSheDu = self.m_city:getCurJianSheDu()
	makeListNode.makejindu:setPercent(curJianSheDu / maxJianSheDu * 100)
	makeListNode.jianshedu:setString(string.format("%d/%d", curJianSheDu, maxJianSheDu))

	local isAddSpeed = false
	local curTime = GamePlayer:getServerTime()
	for i = 1 , self.m_troopMaxCount do
		local result, card
		local addspeedinfo = self.m_city:getTroopInfo(i)
		local node = makeListNode["tianjia"..i]
		if addspeedinfo then
			local troopId = addspeedinfo.troop_id
			local troop = self.m_map:getTroop(troopId)
			local endTime = self.m_city:getAddSpeedEndTime(troopId)
			local state = troop:getState()
			if state == LegionTroopState.kTechAddSpeed and curTime <= endTime then
				result = endTime - curTime
				card = troop:getCard(1)
			end
			if result then print( i, troopId, card:getName() ) end
		end

		isAddSpeed = isAddSpeed or result
		if result then
			node.jiahao:setVisible(false)
			node.icon:setVisible(true)
			node.icon:setImage(card:getIcon())
			makeListNode["time" .. i]:setVisible(true)
			makeListNode["time" .. i]:setString(GameUtil:formatTime(Serialize["H_M_S"], math.max(result,0)))
		else		    
			makeListNode["time" .. i]:setVisible(false)
			node.jiahao:setVisible(true)
			node.icon:setVisible(false)
		end

	end
	self.m_isAddSpeed = isAddSpeed
	-- self:refreshTimeInfo()
end

function This:refreshTimeInfo()
	local isAddSpeed = false
	local makeListNode = self.m_csNode.shengji2
	local curTime = GamePlayer:getServerTime()
	for i = 1 , self.m_troopMaxCount do
		local result
		local addspeedinfo = self.m_city:getTroopInfo(i)
		if addspeedinfo then
			local troopId = addspeedinfo.troop_id
			local endTime = self.m_city:getAddSpeedEndTime(troopId)
			local troop = self.m_map:getTroop(troopId)
			local state = troop:getState()
			if state == LegionTroopState.kTechAddSpeed and curTime <= endTime then
				result = endTime - curTime
			end
		end

		isAddSpeed = isAddSpeed or result
		local node = makeListNode["tianjia"..i]
		if result then
			node.icon:setVisible(true)
			node.jiahao:setVisible(false)
			makeListNode["time" .. i]:setVisible(true)
			makeListNode["time" .. i]:setString(GameUtil:formatTime(Serialize["H_M_S"], math.max(result,0)))
		else
			makeListNode["time" .. i]:setVisible(false)
			node.jiahao:setVisible(true)
			node.icon:setVisible(false)
		end
	end
	self.m_isAddSpeed = isAddSpeed
end

function This:refreshCityInfo()
	local csNode = self.m_csNode
	local curNode = csNode.iconbefore
	local nexNode = csNode.iconafter
	local name = self.m_city:getBuildName()
	local level = self.m_city:getLevel()
	local maxLevel = self.m_city:getMaxLevel()
	local reachMaxLevel = level >= maxLevel
	local image = self.m_city:getImage()
	curNode.build:setImage(image)
	curNode.name:setString(name)
	if not reachMaxLevel then
		nexNode.build:setImage(image)
		nexNode.name:setString(self.m_city:getBuildNameNextLevel())
	end
	nexNode:setVisible(not reachMaxLevel)
	csNode.after.yimanji:setVisible(reachMaxLevel)

	local techsDesList = self:getTechsDesList(reachMaxLevel)
	local index = 0 
	for id, v in pairs( techsDesList ) do
		index = index + 1
		local name = LegionTechAttrTarget[id]
		local des1 = table.concat(v[1], ", ")
		csNode["attr" .. index]:setVisible(true)
		csNode["attr" .. index]:setString(name)
		csNode.before["num" .. index]:setString(des1)

		local des2
		if v[2] then
			des2 = table.concat(v[2], ", ")
			csNode.jiantou["jiantou" .. index]:setVisible(true)
			csNode.after["num" .. index]:setString(des2)
			csNode.after["num" .. index]:setVisible(true)
		else
			csNode.jiantou["jiantou" .. index]:setVisible(false)
			csNode.after["num" .. index]:setVisible(false)
		end

		if false then
			print(name .. ":" .. (des1 or " ") .. "=>" .. (des2 or " "))
		end
	end
	for i = index + 1, 6 do
		csNode["attr" .. i]:setVisible(false)
		csNode.jiantou["jiantou" .. i]:setVisible(false)
		csNode.before["num" .. i]:setVisible(false)
		csNode.after["num" .. i]:setVisible(false)
	end
end

function This:getTechsDesList(reachMaxLevel)
	local techsDesList = {}
	local techList = self.m_city:getTechList()
	for i , tech in ipairs(techList) do
		local level = tech:getLevel()
		local attrList = tech:getAttrList(tech:getLevel())
		for i = 1 , 2 do
			local attr = attrList[i]
			if attr then
				local id, des, factor = unpack(LegionTechAttrNewText[attr.attrId])
				if not techsDesList[id] then
					if not reachMaxLevel then
						techsDesList[id] = {[1]={}, [2]={}}
					else
						techsDesList[id] = {[1]={}}
					end
				end
				local value = attr.value
				if factor then
					value = value * factor
				end
				table.insert(techsDesList[id][1], string.format(des, value))
			end
		end

		if not reachMaxLevel then
			level = self.m_city:getTechNextLevel(tech:getTechType())
			if level == nil then
				assert(false)
			end
			attrList = tech:getAttrList(level)
			for i = 1 , 2 do
				local attr = attrList[i]
				if attr then
					local id, des, factor = unpack(LegionTechAttrNewText[attr.attrId])
					if not techsDesList[id] then
						techsDesList[id] = {[1]={}, [2]={}}
					end
					local value = attr.value
					if factor then
						value = value * factor
					end
					table.insert(techsDesList[id][2], string.format(des, value))
				end
			end
		end
	end
	return techsDesList
end

function This:initTouchEvent()
	local csNode = self.m_csNode
	for i = 1 , self.m_troopMaxCount do
		csNode.shengji2["tianjia"..i]:setTouchEnded(function()
			if not self.m_city:hasTroopAddSpeed(i) then
				g_scene:openDialog("Map.LegionTechSelectJSDPanel",{
					map = self.m_map,
					city = self.m_city,
					pos = i
				})
			end
		end)
	end

	csNode.close:setTouchEnded(function()
		self:close()
	end)

	csNode.shengji1.shengjibutton:setTouchEnded(function()
		if self.m_city:isInBuilding() then
			return
		end

		if not FamilyManager:checkMySelfTitlePower(FamilyPower.klegionTechnologyLevelUp) then
				g_scene:showTips(Serialize["Map_CityConstructe_1"])
				return
			end
		if self.m_city:getLevel() >= self.m_city:getMaxLevel() then
			g_scene:showTips(Serialize[61435])
			return
		end
		local cost = self.m_city:getLevelUpCost()
		if cost == 0 then
			g_scene:showTips(Serialize[61699])
			return 
		end
		g_scene:openDialog("UI.CostConfirmPanel", {
            cost = cost,
            costId = kLegionIronOreItemId,
            desc = Serialize[60793], 
            okHandler = function()
				self.m_map:onUpgradeCityRequest(self.m_city:getId(), 1)
            end
        })
	end)
end

function This:onEnter()
	super.onEnter(self)
	self:refresh()
	self.m_map:addObserver(self)
end

function This:onExit()
	self.m_map:removeObserver(self)
	super.onExit(self)
end


function This:refresh()
	self:refreshCityInfo()
	self:refreshBuildState()
	self:refreshTroopInfo()
end

function This:update(dt)
	super.update(self, dt)
	if not self.m_isAddSpeed then 
		return
	end
	self.m_escape = self.m_escape + dt
	if self.m_escape < 1 then
		return 
	end
	self.m_escape = self.m_escape - 1
	self:refreshTimeInfo()
end

--------------------------------------------------
function This:onUpgradeCity(city)
	if self.m_city == city then
		self:refresh()
	end
end

This.onCityInfoChanged = This.onUpgradeCity
This.onCityUpgradeAddSpeed = This.onUpgradeCity
--endregion
