--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"Dialog")
local LegionBuildView = require("Map.LegionBuildView")
local LegionChangeLevelConfig = require("Metadatas.LegionChangeLevelConfig")
local GamePlayer = require("Player.GamePlayer")
local FamilyManager = require("Family.FamilyManager")

function This:initNode(info)
	self.m_city = info.city
	self.m_map = info.map
	self.m_csNode = cc.Node:createFromCSFile("LegionScene/NodeUI/LegionBuildRemake.csb")
	self:addChild(self.m_csNode)
	self.m_csNode:setToCenter()
	self:initBuildList()
end

function This:initBuildList()
	self.m_buildViewList = {}
	local buildList = {LegionBuildType.kBarracks , 
	LegionBuildType.kWarehouse,
	LegionBuildType.kArrowTower,
	LegionBuildType.kBoltTower,
	LegionBuildType.kFarmland,
	LegionBuildType.kMarket}

	for i , buildType in ipairs(buildList) do
		local view = LegionBuildView:create({
			buildType = buildType,
			level = 1
		})

		view:setTouchHandler(function(bt)
			self:selectBuildItem(bt,view)
		end)
		self.m_csNode["build"..i]:addChild(view)
		self.m_buildViewList[i] = view
	end
end

function This:initTouchEvent()
	self.m_csNode.close:setTouchEnded(function()
		self:close()
	end)

	self.m_csNode.quedingbutton:setTouchEnded(function()
		if not FamilyManager:checkMySelfTitlePower(FamilyPower.kLegionWarChangeCity) then
			g_scene:showTips(Serialize["Map_CityRemake_1"])
			return
		end
		local ore = self.m_map:getOre()
		if ore < self.m_config.change_cost then
			g_scene:showTips(Serialize[61701])
			return
		end
		g_scene:openDialog("UI.ConfirmPanel",{
			richText = Serialize[61702],
			okHandler = function()
				self.m_map:onRebuildCityRequest(self.m_city:getId(),self.m_config.change_type)
				self:close()
			end
		})
	end)
end

function This:selectBuildItem(buildType,view)
	if self.m_curView ~= view then
		if self.m_curView then 
			self.m_curView:setIsSelected(false)
		end
		self.m_curView = view
		if self.m_curView then
			self.m_curView:setIsSelected(true)
		end
		self.m_config = LegionChangeLevelConfig[100 * buildType + 1]
		self.m_csNode.miaoshu:setString(self.m_config.change_dec)
		self.m_csNode.num:setString(self.m_config.change_cost)
		self.m_csNode.buildzhanshi:setImage(self.m_config.picture2)
	end
end

function This:onEnter()
	super.onEnter(self)
	local view = self.m_buildViewList[1]
	self:selectBuildItem(view:getBuildType(),view)
end




--endregion
