--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"cc.Node")
local GameUtil = require("Util.GameUtil")
local TerrBarrackShopView = require("Territory/TerrBarrackShopView")

local EffectZorder = 
{
	kProtected = 3,--保护罩
	kIndexFlag = 7,--旗子
	kTroopInfo = 6,--部队信息
	kHpInfo = 5,--兵力槽
	kMainFlag = 9,--玉玺
	kHorse = 2,--城池建筑
	kCityLv = 4,--城池等级
	kMenuUI = 1, --菜单
	kName = 8, --城池名字
	kBox = 10, --战局宝箱
	kImprison = 11, --禁锢特效
}

local JunceEffectInfo = {
	[LegionStrategyType.kTuCheng] = {
		name = "Huo",
		zorder = EffectZorder.kProtected
	},
	[LegionStrategyType.kQiangXi] = {
		name = "JiHuo",
		zorder = EffectZorder.kProtected,
		scale = 0.7
	},
	[LegionStrategyType.kBaGua] = {
		name = "BaGua2",
		zorder = EffectZorder.kProtected
	},
}


local UpdateObjType = {
	kMarch = 1,
	kJunce = 2,
}

function This:initCsNode()
	self.m_effect = {}
	self.m_csNode = cc.Node:createFromCSFile("LegionScene/NodeUI/LegionCity.csb")
	self:addChild(self.m_csNode)
end

function This:initBarrackNode()
	if self.m_city:isBarrack() and self.m_city:isOur() then
		-- print("军营商店添加")
		local node = TerrBarrackShopView:create({cityId =self.m_city:getId(),map=self.m_map})
		self.m_csNode.shop:addChild(node)
		self.m_hasShop = true
	end
end

function This:init(info)
	self.m_city = info.city
	self.m_map = info.map
	self.m_scene = g_scene
	self.m_hasShop = false

	self:initCsNode()
	self.m_isSelected = nil
	self.m_isObservers = false

	self.m_escape = 0
	self.m_isUpdating = false
	local updateObjectList = {}
	for _, otype in pairs( UpdateObjType ) do
		updateObjectList[otype] = false
	end
	self.m_updateObjectList = updateObjectList

	self.m_marchs = {}
	self.m_attackInterval = {}
	self.m_csNode.cityname:setString(self.m_city:getName())
	self.m_csNode.citylevel.name:setString(self.m_city:getId())
	self:setSelected(false)
	self:initBarrackNode()
end

function This:setIsUpdating(otype, value)
    if value then
    	self.m_isUpdating = true
    	self.m_updateObjectList[otype] = true
    else
    	local list = self.m_updateObjectList
    	list[otype] = false
    	local ret = false       
    	for _, v in ipairs( list ) do
    		ret = ret or v
    	end
    	self.m_isUpdating = ret
	end
end

function This:initTouchEvent()
	local csNode = self.m_csNode
	csNode.city:setTouch({
		onEnded = function()
			if self.m_touchHandler then
				self.m_touchHandler(self)
			end
		end,
		isDynamic = true,
		isSwallow = false
	})
	csNode.boxNode.box:setTouch({
			onEnded = function()
				g_scene:openDialog("Map.LegionWarBoxPanel")
			end,
			isDynamic = true
		})
end

function This:createEffect(isAdd,node)
    local function createAnim( parent,anmStr )
        local GameUtil = require("Util.GameUtil")
        local effect1 = GameUtil:createEffect(anmStr,true)
        parent:addChild(effect1)
        return effect1
    end
    if node then
	    node:removeAllChildren()
	    if isAdd then
	    	local effect1 = createAnim( node,"FaBaoLight" )
	    	effect1:setPosition(42,42)
	    end
    end
end

function This:showLegionBox(isVisible)
	local temVisible = isVisible or false
	local boxNode = self.m_csNode.boxNode
	local box = boxNode.box
	boxNode:setVisible(temVisible)
	self.m_isShowBox = temVisible
	self:createEffect(temVisible,box)
	if temVisible then
		local initX, initY = 0, 49
		local upAction = cc.MoveTo(0.8,initX,initY + 30,"SineInOut")
		local downAction = cc.MoveTo(0.8,initX,initY + 25,"SineInOut")
		local action = cc.RepeatForever(cc.Sequence(upAction,downAction))
		box:runAction(action)
		self:refreshLegionBoxTime()
		self:unscheduleUpdate()
		self:scheduleUpdate()
	else
		self:unscheduleUpdate()
		box:stopAllActions()
	end
end

function This:refreshLegionBoxTime()
	local boxNode = self.m_csNode.boxNode
	local mMap = self.m_map
	local boxState,leftTime = mMap:getWarBoxLeftTime()
	boxNode.boxtime:setString(GameUtil:formatTime(Serialize["H_M_S"],leftTime))

	if leftTime ==0 then
		self:showLegionBox(false)
	end
end

function This:setTouchHandler(handler)
	self.m_touchHandler = handler
end

function This:onEnter()
	super.onEnter(self)
	self:initTouchEvent()
	self:refresh()
	if self.m_map then
		self.m_map:addObserver(self)
	end
end

function This:onExit()
	super.onExit(self)
	if self.m_map then
		self.m_map:removeObserver(self)
	end
end

function This:getModel()
	return self.m_city
end

function This:refresh()
	self:refreshCityInfo()
	self:refreshFightingState()
	self:refreshProtectedState()
	self:refreshAlertState()
	self:refreshJunceState()
end

function This:setSelected(isSelected)
	if self.m_isSelected ~= isSelected then
		self.m_isSelected = isSelected
		self.m_csNode.choose:setVisible(isSelected)
		self.m_csNode.citylevel:setVisible(isSelected)
		self.m_csNode.buildname:setVisible(isSelected)
	end
	self:showSelectMenu(isSelected)
end

function This:refreshCityUI()
	if not self.m_city then
		return
	end
	local image = self.m_city:getImage()
	if image ~= "" then
		self.m_csNode.city:setImage(image)
	end
end

function This:refreshCityInfo()
	local legionId = self.m_city:getLegionId()
	local legion
	if legionId > 0 then
		legion = self.m_map:getLegion(legionId)
	end
	
	if legion then 
		self.m_csNode.camp.name:setString(legion:getName())
		self.m_csNode.camp:setVisible(true)
	else
		self.m_csNode.camp:setVisible(false)
	end

	self:refreshCityUI()

	local count , totalHp = self.m_city:getGuardCountAndHp()
	if count > 0 then
		self.m_csNode.armydetails.linenumber:setString(count)
		self.m_csNode.armydetails.hpnumber:setString(GameUtil:formatCount(totalHp))
		self.m_csNode.armydetails:setVisible(true)
	else
		self.m_csNode.armydetails:setVisible(false)
	end
	self.m_csNode.buildname.name:setString(self.m_city:getBuildName())
	self:refreshBarrackNode()
	self:refreshBuildEffct()
end

function This:refreshBuildEffct()
	if self.m_city:isInBuilding() then
		local level = self.m_city:getLevel()
		local maxLevel = self.m_city:getMaxLevel()
		if level >=maxLevel then
			if self.m_updateEffect then
				self.m_updateEffect:removeFromParent()
				self.m_updateEffect = nil
			end
			return
		end
		if not self.m_updateEffect then
			self.m_updateEffect = GameUtil:createEffect("BuildImpact",true,self)
			local _, h = self.m_csNode.city:getContentSize() 
			local posx, posy = self.m_csNode.city:getPosition()
			self.m_updateEffect:setPosition(posx+10, posy+10)
			self:addChild(self.m_updateEffect)	
		end
	else
		if self.m_updateEffect then
			self.m_updateEffect:removeFromParent()
			self.m_updateEffect = nil
		end
	end
end

function This:refreshBarrackNode()
	if self.m_city:isBarrack() and self.m_city:isOur() and not self.m_hasShop then
		-- print("军营商店添加")
		local node = TerrBarrackShopView:create({
			cityId = self.m_city:getId(),
			map = self.m_map
		})
		self.m_csNode.shop:addChild(node)
		self.m_hasShop = true
	end
	self.m_csNode.shop:setVisible(true)
end

function This:refreshFightingState()
	local isFighting = self.m_city:isFighting()
	if isFighting and not self.m_fightEffect then
		self.m_fightEffect =  GameUtil:createEffect("Engagement",true,nil,nil,false)
		self:addChild(self.m_fightEffect)
		self.m_fireEffect = GameUtil:createEffect("Flames",true,nil,nil,false)
		self:addChild(self.m_fireEffect)
	elseif not isFighting and self.m_fightEffect then
		self.m_fightEffect:removeFromParent()
		self.m_fightEffect = nil
		self.m_fireEffect:removeFromParent()
		self.m_fireEffect = nil
	end
end


function This:refreshJunceEffect(hasEffect, jcType, effectInfo)
	local effect = self.m_effect[jcType]
	if hasEffect and not effect then
		local name, zorder, scale = effectInfo.name, effectInfo.zorder, effectInfo.scale
		effect = GameUtil:createEffect(name,true,nil,nil,false)
		self.m_csNode:addChild(effect)
		effect:setLocalZOrder(zorder)
		if scale then
			effect:setScale(scale)
		end
		self.m_effect[jcType] = effect
	elseif not hasEffect and effect then
		effect:removeFromParent()
		self.m_effect[jcType] = nil
	end
end

function This:refreshProtectedState()
	if self.m_city:isEmptyCity() then
		self.m_city:setState(LegionCityState.kProtected)
	elseif not self.m_city:isInFighting() then
		self.m_city:setState(LegionCityState.kNormal)
	end
	local isInProtected = self.m_city:isInProtected()
	if isInProtected and not self.m_protectEffect then
		if self.m_city:isEmptyCity() then
			self.m_protectEffect = GameUtil:createEffect("Kongchengji",true,nil,nil,false)
		else
			self.m_protectEffect = GameUtil:createEffect("Protection",true,nil,nil,false)
		end
		self.m_csNode:addChild(self.m_protectEffect)
		self.m_protectEffect:setLocalZOrder(EffectZorder.kProtected)
	elseif not isInProtected and self.m_protectEffect then
		self.m_protectEffect:removeFromParent()
		self.m_protectEffect = nil
	end
end

function This:showSelectAnimation(isShow)
	if isShow and not self.m_selectAnimation then
		local str = ""
		if self.m_city:isOur() then
			str = "WarScene/jiantou1.png"
		else
			str = "WarScene/jiantou2.png"
		end
		local sprite = cc.Sprite:create(str)
		local initPos = Vec(0,50)
		local upPos = Vec(initPos.x,initPos.y + 10)
		sprite:setPosition(initPos.x,initPos.y)
		sprite:runAction(cc.RepeatForever(cc.Sequence(cc.MoveTo(0.5,upPos.x,upPos.y,"SineOut"),cc.MoveTo(0.5,initPos.x,initPos.y,"SineOut"))))
		self:addChild(sprite)
		self.m_selectAnimation = sprite

		self.m_csNode.armydetails:setVisible(false)
		self.m_csNode.hpdetails:setVisible(false)
	else
		self.m_selectAnimation:removeFromParent()
		self.m_selectAnimation = nil
		self.m_csNode.armydetails:setVisible(self.m_data.forceVisible)
		self.m_csNode.hpdetails:setVisible(self.m_data.hpVisible)
	end
end

function This:getOurCityMenu()
	local node = cc.Node:createFromCSFile("LegionScene/NodeUI/LegionMySelect.csb")
	node.ownclick.troops:setTouch({
		onEnded = function()
        	g_scene:openDialog("Map.LegionTroopsPanel",{
				map = self.m_map,
				city = self.m_city
			})
		end,
		isScale = false,
		isDynamic = true
	})
	node.ownclick.jice:setTouch({
		onEnded = function()
			g_scene:openDialog("Map.JunCeUsePanel",{
				city = self.m_city,
				map = self.m_map
			})
		end,
		isScale = false,
		isDynamic = true
	})
	node.ownclick.keji:setTouch({
		onEnded = function()
			g_scene:openDialog("Map.LegionCityConstructePanel",{
				city = self.m_city,
				map = self.m_map
			})
		end,
		isScale = false,
		isDynamic = true
	})
	node.ownclick.guanzhan:setTouch({
		onEnded = function()
			if self.m_city:isInFighting() then
				self.m_scene:openDialog("Map.LegionBattleLogPanel",{
					map = self.m_map,
					cityId = self.m_city:getId()
				})
			else
				self.m_scene:showTips(Serialize[61704])
			end
		end,
		isScale = false,
		isDynamic = true
	})
	node.ownclick.gaizao:setTouch({
		onEnded = function()
			-- print("改造...")
			g_scene:openDialog("Map.LegionCityRemakePanel",{
				city = self.m_city,
				map = self.m_map
			})
		end,
		isScale = false,
		isDynamic = true
	})
	local buildType = self.m_city:getBuildType()
	local isFighting = self.m_city:isFighting()
	node.ownclick.guanzhan:setVisible(isFighting)
	node.ownclick.troops:setVisible(not isFighting)
	node.ownclick.keji:setVisible(buildType ~= LegionBuildType.kNone)
	node.ownclick.gaizao:setVisible(buildType == LegionBuildType.kNone)
	return node
end

function This:getEmptyCityMenu()
	local node = cc.Node:createFromCSFile("LegionScene/NodeUI/LegionOtherSelect.csb")
	node.otherclick.see:setTouch({
		onEnded = function()
			if self.m_city:isInFighting() then
				self.m_scene:openDialog("Map.LegionBattleLogPanel",{
					map = self.m_map,
					cityId = self.m_city:getId()
				})
			else
				self.m_scene:showTips(Serialize[61704])
			end
		end,
		isScale = false,
		isDynamic = true
	})
	node.otherclick.plan:setTouch({
		onEnded = function()
			-- print("计策...")
			g_scene:openDialog("Map.JunCeUsePanel",{
				city = self.m_city,
				map = self.m_map
			})
		end,
		isScale = false,
		isDynamic = true
	})
	return node
end

function This:getEnemyCityMenu()
	local node = cc.Node:createFromCSFile("LegionScene/NodeUI/LegionEnemySelect.csb")
	node.see:setTouch({
		onEnded = function()
			if self.m_city:isInFighting() then
				self.m_scene:openDialog("Map.LegionBattleLogPanel",{
					map = self.m_map,
					cityId = self.m_city:getId()
				})
			else
				self.m_scene:showTips(Serialize[61704])
			end
		end,
		isScale = false,
		isDynamic = true
	})
	node.ownclick.jice:setTouch({
		onEnded = function()
			-- print("计策...")
			g_scene:openDialog("Map.JunCeUsePanel",{
				city = self.m_city,
				map = self.m_map
			})
		end,
		isScale = false,
		isDynamic = true
	})
	return node
end

function This:showSelectMenu(isShow)
	if isShow and not self.m_menu then
		if self.m_city:isOur() then
			self.m_menu = self:getOurCityMenu()
		elseif self.m_city:isEmpty() then
			self.m_menu = self:getEmptyCityMenu()
		else
			self.m_menu = self:getEnemyCityMenu()
		end
		self.m_menu:setLocalZOrder(g_scene:getMaxLocalZOrder() + 1)
		self.m_scene:showMenu(self.m_menu,self.m_city:getId())
	elseif not isShow and self.m_menu then
		self.m_menu:removeFromParent()
		self.m_menu = nil
		self.m_scene:showMenu(nil)
	end
end

function This:showSelectAnimation(isShow)
	if isShow and not self.m_selectAnimation then
		local str = ""
		if self.m_city:isOur() then
			str = "WarScene/jiantou1.png"
		else
			str = "WarScene/jiantou2.png"
		end
		local sprite = cc.Sprite:create(str)
		local initPos = cc.Vec(0,50)
		local upPos = cc.Vec(initPos.x,initPos.y + 10)
		sprite:setPosition(initPos.x,initPos.y)
		sprite:runAction(cc.RepeatForever(cc.Sequence(cc.MoveTo(0.5,upPos.x,upPos.y,"SineOut"),cc.MoveTo(0.5,initPos.x,initPos.y,"SineOut"))))
		self:addChild(sprite)
		self.m_selectAnimation = sprite
	else
		self.m_selectAnimation:removeFromParent()
		self.m_selectAnimation = nil
	end
end

function This:refreshAlertState()
	local isOur = self.m_city:isOur() and self.m_city:isAlertBuilding()
	local marchList = self.m_map:getMarchList(function(march)
		return self.m_city:isAlertMarch(march) 
	end)
	for i , march in ipairs(marchList) do
		if not self.m_marchs[march:getId()] then
			self.m_marchs[march:getId()] = march
			self.m_attackInterval[march:getId()] = self:getAttackInterval()
		end
	end
end	

function This:refreshJunceState()
	local cityId = self.m_city:getId()
	local junceList, junce = self.m_map:getEffectJunCesInCity(cityId)

	local isUsed = junce ~= nil
	self.m_csNode.timebg:setVisible(isUsed)
	local userNode = self.m_csNode.userbg
	userNode:setVisible(isUsed)

	if isUsed then
		local leftTime = junce:getLeftHoldTime(cityId)
		self.m_csNode.timebg.time:setString(GameUtil:formatTime(Serialize[61705], leftTime))

		local legionId = junce:getUsedLegionId(cityId)
		if legionId and legionId > 0 then
			local legion = self.m_map:getLegion(legionId)
			userNode.name:setString(legion:getName())
		else
			userNode:setVisible(false)
		end

		if not self.m_isUpdating then
			self:scheduleUpdate()
			self:setIsUpdating(UpdateObjType.kJunce, true)
		end
	end

	for jcType, einfo in pairs( JunceEffectInfo ) do
		local eJunce = junceList[jcType]
		local hasEffect = eJunce ~= nil
		self:refreshJunceEffect(hasEffect, jcType, einfo)
	end
end

function This:getAttackInterval(city)
	local towerCity = city or self.m_city
	if towerCity:getBuildType() == LegionBuildType.kArrowTower then
		local tech = towerCity:getTech(LegionTechType.kReduceArrowDamageInterval)
		return tech:getTechAttrValue(LegionTechAttrType.kReduceArrowAttackInterval)
	elseif towerCity:getBuildType() == LegionBuildType.kBoltTower then
		local tech = towerCity:getTech(LegionTechType.kReduceBoltDamageInterval)
		return tech:getTechAttrValue(LegionTechAttrType.kReduceBoltAttackInterval)
	end
	return 0
end

function This:onAddMarch(march)
	-- local s = debug.getinfo(2,'S')
	if self.m_city:isAlertBuilding() and self.m_city:isAlertMarch(march) and not self.m_marchs[march:getId()] then
		self.m_marchs[march:getId()] = march
		self.m_attackInterval[march:getId()] = self:getAttackInterval()
		if not self.m_isUpdating then
			self:scheduleUpdate()
			self:setIsUpdating(UpdateObjType.kMarch, true)
		end
	end
end

function This:onDeleteMarch(march)
	if self.m_marchs[march:getId()] then
		self.m_marchs[march:getId()] = nil
		self.m_attackInterval[march:getId()] = nil
		if next(self.m_marchs) == nil and self.m_isUpdating then
			self:unscheduleUpdate()
			self:setIsUpdating(UpdateObjType.kMarch, true)
		end
	end
end

function This:update(dt)
	local interval = self:getAttackInterval()
	for i , march in pairs(self.m_marchs) do
		local id = march:getId()
		self.m_attackInterval[id] = self.m_attackInterval[id] + dt
		if self.m_attackInterval[id] >= interval then
			self.m_attackInterval[id] = self.m_attackInterval[id] - interval
			self.m_scene:addAttackMarchView(self.m_city,march)
		end
	end
	self.m_escape = self.m_escape + dt
	if self.m_escape < 1 then
		return 
	end
	self.m_escape = self.m_escape - 1
	self:refreshJunceState()
	
	if self.m_isShowBox then
		self:refreshLegionBoxTime()
	end
end

function This:onWarShopOver()
	self.m_csNode.shop:setVisible(false)
end

function This:onRemoveBuild()
	self.m_csNode.shop:setVisible(false)	
end

function This:onUseLegionJunCe()
	self:refresh()
end

function This:onLegionJunCeChanged()
	self:refresh()	
end
--endregion
