-- @Author: superm
-- @Date:   2019-09-16 15:27:20
-- @Last Modified by:   zheng
-- @Last Modified time: 2020-07-09 11:59:02
-- @File Name: LegionContributionPanel.lua
-- @Description: 

local This, super = class(...,"Dialog")
local LegionContributionItem = require("Map.LegionContributionItem")

function This:initNode(info)
    local csNode = cc.Node:createFromCSFile("LegionScene/NodeUI/LegionBuildContribution.csb")
    self.m_csNode = csNode
    csNode:setToCenter()
    self:addChild(csNode)
end

function This:onEnter()
    super.onEnter(self)
end

function This:onExit()
	super.onExit(self) 
end

function This:refresh()
    local node = self.m_csNode
    local rankInfo = {}

    local personalNode = node.me
    personalNode.hurt:setString("0")
    personalNode.name:setString(GamePlayer:getRoleName())
    personalNode.level:setString(GamePlayer:getLevel())
    if rankInfo and rankInfo.rank then
        personalNode.paiming:setString(rankInfo.rank)
        personalNode.name02:setString(rankInfo.role_name)
        personalNode.hurt02:setString(rankInfo.value)
    else
        personalNode.paiming:setString(Serialize["family_BuildNode_7"])
    end

    local sv = node.scrollView
    sv:removeAllItems()
    local rankList = {}
    for _,rankInfo in ipairs(rankList) do
        local item = LegionContributionItem:create(rankInfo)
        local w,h = item:getSize()
        item:setAnchorPoint(0.5,0.5)
        sv:pushBackCustomItem(item,w,h,0.5)
    end
end

function This:initTouchEvent()
    self.m_csNode.beijing.close:setTouchEnded(function()
        self:close()
    end)

end
function This:onGetBossRankInfo()
    self:refresh()
end