--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"LoadingScene")
local SlideScaleContaner = require("Action.SlideScaleContaner")
local GameEvent = require("Event.GameEvent")
local AsynchEvent = require("Event.AsynchEvent")
local EditMiniUI = require("Map.EditMiniUI")
local GameMapUtil = require("Map.GameMapUtil")

local LegionCityConfig = false
local CeilsConfig = false
local OutputPath = false
local kMapWidth = false
local kMapHeight = false
local kMapCityNum = 1
local kCsFileName = false

local ColorList = 
{
	cc.Color.WHITE,
	cc.Color.YELLOW,
	cc.Color.GREEN,
	cc.Color.BLUE,
	cc.Color.RED,
	cc.Color.MAGENTA,
	cc.Color.BLACK,
	cc.Color.ORANGE,
	cc.Color.GRAY,
	cc.ColorList.New14,
	cc.ColorList.New12,
	cc.ColorList.New11,
	cc.ColorList.New10,
	cc.ColorList.New9,
	cc.ColorList.New4,
	cc.ColorList.QQ6,
	cc.ColorList.QQ5,
	cc.ColorList.QQ3,
	cc.ColorList.PetPhase2,
	cc.ColorList.PetPhase1,
	cc.ColorList.PetPhase5
}

function This:getCityConfig()
    return CeilsConfig
end

function This:init(info)
	super.init(self)

	if info then
		LegionCityConfig = require(info.city_config)
		CeilsConfig = require(info.output_config)
		kMapCityNum = #LegionCityConfig
		kMapWidth = info.width 
		kMapHeight = info.height
		kCsFileName = info.csfile
		kMiniUIFileName = info.uicsfile
		local path = info.output_config:gsub('%.', '/')
		OutputPath = "./Resources/Scripts/" .. path .. ".lua"
		self.m_mapCsFileName = info.mapcsfiel
		self.m_mapRadioX = info.mapRadioX
		self.m_mapRadioY = info.mapRadioY
		self.m_miniScaleRateX = info.miniScaleRateX
		self.m_miniScaleRateY = info.miniScaleRateY
		self.m_miniMapRadioX = info.miniMapRadioX
		self.m_miniMapRadioY = info.miniMapRadioY
		print("output path:" .. OutputPath)
	end

	self.m_cityViews = {}
	self.m_cityInfo = type(CeilsConfig) == "table" and CeilsConfig or {}
	self.m_ceils = {}
	self.m_curColorIndex = 1
	self:initTask()
end

function This:initNode()
	local size = {width = kMapWidth or 4500 , height = kMapHeight or 4500}
	self.m_mapLayer = cc.Node:createFromCSFile(kCsFileName or "LegionScene/NodeUI/LegionScene.csb")
	self.m_mapLayer:setAnchorPoint(0,0)
	self.m_mapLayer:setContentSize(size.width,size.height)
	self.m_mapLayer:setPosition((cc.visible.width - size.width)/2,(cc.visible.height - size.height)/2)
	self:addChild(self.m_mapLayer)
end

function This:getMiniUIFileName()
	return kMiniUIFileName
end

function This:getAllCitys()
	return self.m_cityInfo
end

function This:initUI()
	self.m_ui = EditMiniUI:create()
	self:addChild(self.m_ui)
end

function This:initTask()
	self:addTask(GameEvent:create(function()
		self:initNode()
	end))

	for i = 0 , kMapCityNum, 3 do
		local s , e = i + 1, i + 3
		task = GameEvent:create(function()
			print(string.format("create from %d to %d",s,e))
			for j = s , e do
				if j <= kMapCityNum then
					self:addCityView(j)
				end
			end
		end)
		self:addTask(task)
	end

	self:addTask(GameEvent:create(function()
		self:initAction()
	end))
	
	self:addTask(GameEvent:create(function()
		self:initCeils()
	end))

	self:addTask(GameEvent:create(function()
		self:initUI()
	end))
end

local count = 0
function This:addCityView(cityId)
	count = count + 1
	print(string.format("count = %d",count))
	local sprite = cc.Sprite:create("GameScene/bingzhongdi.png")
	local node = self.m_mapLayer[tostring(cityId)]
	node:addChild(sprite)

	local config = LegionCityConfig[cityId]
	local name = cc.Label:createNormalTTF(string.format("%s(%d)",config.city_name,cityId),20)
	node:addChild(name)

	sprite:setTouch({
		onEnded = function()
			self:selectCity(cityId)
		end,
		isDynamic = true,
		isSwallow = false
	})
	self.m_cityViews[cityId] = sprite
end

function This:getViewportCenterRatio()
	local x , y = self.m_mapLayer:getPosition()
	local fx , fy = cc.visible.center.x - x , cc.visible.center.y - y
	local w , h = self.m_mapLayer:getContentSize()
	local scale = self.m_mapLayer:getScale()
	w = w * scale 
	h = h * scale
	return fx / w, fy / h
end

function This:getCityNodeRadio(cityId)
	local node = self.m_mapLayer[tostring(cityId)]
	if not node then
		print(cityId)
	end
	local x , y = node:getPosition()
	local w , h = self.m_mapLayer:getContentSize()
	return x / w, y / h
end

function This:getPositionRatio(id)
	local cityNode = self.m_mapLayer[tostring(id)]
	local x ,y = cityNode:getPosition()
	local w , h = self.m_mapLayer:getContentSize()
	return x / w , y / h
end

function This:selectCity(cityId)
	self.m_curCityId = cityId
	if self.m_cityInfo[cityId] then
		self.m_curColorIndex = self.m_cityInfo[cityId].color
	else
		self.m_curColorIndex = self.m_curColorIndex % #ColorList + 1
		self.m_cityInfo[cityId] = {color = self.m_curColorIndex, ceilList = {}}
	end
	if not self.m_selectFalg then
		self.m_selectFalg = cc.Sprite:create("WarScene/jiantou1.png")
		self.m_mapLayer:addChild(self.m_selectFalg)
	end
	self.m_selectFalg:stopAllActions()
	local x , y = self.m_mapLayer[tostring(cityId)]:getPosition()
	local initPos = cc.Vec(x,y + 50)
	local upPos = cc.Vec(initPos.x,initPos.y + 10)
	self.m_selectFalg:setPosition(initPos.x,initPos.y)
	self.m_selectFalg:runAction(cc.RepeatForever(cc.Sequence(cc.MoveTo(0.5,upPos.x,upPos.y,"SineOut"),cc.MoveTo(0.5,initPos.x,initPos.y,"SineOut"))))
end

function This:initAction()
	self.m_mapLayer:setTouch({
		onMoved = function()
		end,
		onEnded = function(_,p)
			if self.m_curCityId then
				local x , y = self.m_mapLayer:convertToNodeSpace(p.x, p.y)
				print(string.format("(%d,%d)",x,y))
				self:onTouchMapLayer(x,y)
			end
		end,
		isSwallow = false,
		isScale = false,
		isAlpha = false
	 })
	local width , height = self.m_mapLayer:getContentSize()
	self.m_slideScaleContaner = SlideScaleContaner:create({
		node = self.m_mapLayer,
		maxWidth = 	width,
		maxHeight = height,
		minWidth = cc.visible.width,
		minHeight = cc.visible.height,
	})
	self.m_slideScaleContaner:setSlideHandler(function(newx,newy)
		local w , h = self.m_mapLayer:getContentSize()
		local x , y = self.m_mapLayer:getPosition()
		local scale = self.m_mapLayer:getScale()
		w = w * scale 
		h = h * scale
		x , y = cc.visible.center.x - x , cc.visible.center.y - y
		self.m_ui:updateMiniMap(x / w, y / h)
	end)
end

function This:initCeils()
	self.m_drawNode = cc.DrawNode:create()
	self.m_mapLayer:addChild(self.m_drawNode)
	
	--local f = math.tan( math.pi/6)
	local w , h = 4500, 4500
	local dx , dy = 250, 150
	local f = dy / dx
	local nx , ny = math.ceil(w /  dx), math.ceil(h / dy)
	 
	local color = cc.Color.RED
	color.a = 64
	local len = 300
	for i = 0 , nx do
		local p1 = cc.Vec(i * dx, 0)
		local l1 = math.min(w - p1.x , (h / f))
		local p2 = cc.Vec(1, f) * l1 + p1
		self.m_drawNode:drawLine(p1,p2,color)
	end

	for i = 1 , ny do
		local p1 = cc.Vec(0 , i * dy)
		local l2 = math.min(w,(h - p1.y) / f)
		local p3 = cc.Vec(1, f) * l2 + p1
		self.m_drawNode:drawLine(p1,p3,color)
	end

	for i = 1 , ny do
		local p1 = cc.Vec(0 , i * dy)
		local l = math.min(w, p1.y / f)
		local p2 = cc.Vec(1,-f) * l + p1
		self.m_drawNode:drawLine(p1,p2,color)
	end

	local top = ny * dy
	for i = 0 , nx do
		local p1 = cc.Vec(i * dx, top)
		local l = math.min(w - p1.x, top / f)
		local p2 = cc.Vec(1,-f) * l + p1
		self.m_drawNode:drawLine(p1,p2,color)
	end

	self.m_nx = nx
	self.m_ny = ny
	self.m_dx = dx
	self.m_dy = dy
	self.m_top = top
	self.m_f = f
	self.m_vy = cc.Vec(self.m_dx,self.m_dy):normalize()
	self.m_vx = cc.Vec(-self.m_dx,self.m_dy):normalize()

	for cityId , config in pairs(self.m_cityInfo) do
		for j , ceilKey in ipairs(config.ceilList) do
			local nx = math.floor(ceilKey / 1000)
			local ny = ceilKey % 1000
			local sprite = self:createCeil(nx,ny,config.color)
			self.m_ceils[ceilKey] = {node = sprite, color = config.color, cityId = cityId}
		end
	end
end

function This:createCeil(nx,ny,colorIndex)
	local b = cc.Vec(self.m_dx, self.m_dy):length() / 2
	local t = self.m_vy * b * (ny + 0.5) + self.m_vx * b * (nx + 0.5)
	local layer = cc.Sprite:create("LegionScene/lingxing.png")
	layer:setPosition(t.x,t.y)
	local color = ColorList[colorIndex]
	layer:setColor(color.r,color.g,color.b)
	layer:setOpacity(128)
	self.m_mapLayer:addChild(layer)
	return layer
end

function This:addCeils(nx,ny,cityId)
	local key = nx * 1000 + ny
	if not self.m_ceils[key] then
		local config = self.m_cityInfo[cityId]
		local layer = self:createCeil(nx,ny,config.color)
		self.m_ceils[key] = {node = layer, color = config.color, cityId = cityId}
		table.insert(config.ceilList, key)
	end
end

function This:removeCeils(nx,ny)
	local key = nx * 1000 + ny
	if self.m_ceils[key] then
		local sprite = self.m_ceils[key].node
		sprite:removeFromParent()
		local cityId = self.m_ceils[key].cityId
		for i , id in ipairs(self.m_cityInfo[cityId].ceilList) do
			if id == key then
				table.remove(self.m_cityInfo[cityId].ceilList,i)
				break
			end
		end
		self.m_ceils[key] = nil
	end
end

function This:getCeilsPosition(x,y)
	local vy = self.m_vy
	local vx = self.m_vx
	 
	local v = cc.Vec(x,y)
	local l = v:length()
	local nv = v:getNormalize()
	local v1 = vy * nv:dot(vy) * l
	local flag = nv:dot(self.m_vx) > self.m_vy:dot(self.m_vx) and 1 or -1
	local v2 = v1:getNormalize() * (v - v1):length() * (( 1 - self.m_f * self.m_f) / (2 * self.m_f)) * flag
			
	local v3 = v1 + v2
	local v4 = v - v3
	 
	local b = cc.Vec(self.m_dx, self.m_dy):length() / 2
	local b1 = v3:getNormalize():dot(vy) * v3:length()
	local b2 = v4:getNormalize():dot(vx) * v4:length()
	local ny = math.floor( b1 / b)
	local nx = math.floor( b2 / b)
	return nx , ny
end

function This:focusePoint(ratiox,ratioy)
	local w , h = self.m_mapLayer:getContentSize()
	local x , y = self.m_mapLayer:getPosition()
	local scale = self.m_mapLayer:getScale()
	w = w * scale 
	h = h * scale

	local dx , dy = cc.visible.center.x - (w * ratiox+x) , cc.visible.center.y - (h * ratioy+y)
	x = math.min(0,math.max(cc.visible.width - w,dx + x))
	y = math.min(0,math.max(cc.visible.height - h,dy + y))
	self.m_mapLayer:setPosition(x,y)
	self.m_ui:updateMiniMap(ratiox, ratioy)
end

function This:getCityNode(cityId)
	local nodeId
	if cityId > 1000 then
		nodeId = cityId - 1000
	else
		nodeId = cityId
	end
	local node = self.m_mapLayer[tostring(nodeId)]
	return node
end

function This:focuseCity(cityId,handler,bAction)
	self:focuseToCity({
		cityId = cityId,
		bAction = bAction,
		handler = handler
	})
end

function This:focuseToCity(info)
	self.m_mapLayer:stopAllActions()

	local cityId = info.cityId
	local node = self:getCityNode(cityId)
	local x , y = node:convertToWorldSpace(0,0)
	local dx , dy = cc.visible.center.x - x , cc.visible.center.y - y
	local lx , ly = self.m_mapLayer:getPosition()
	local boundRect = self.m_mapLayer:getBoundingBox()

	local maxx = 0
	local minx = cc.visible.width - boundRect.width

	if lx + dx > maxx then
		dx = maxx - lx
	elseif lx + dx < minx then
		dx = minx - lx
	end

	local maxy = 0
	local miny = cc.visible.height - boundRect.height

	if ly + dy > maxy then
		dy = maxy - ly
	elseif ly + dy < miny then
		dy = miny - ly
	end

	local x , y = self.m_mapLayer:getPosition()
	self.m_mapLayer:setPosition(x + dx, y + dy)
	local rx , ry = self:getPositionRatio(cityId)
	self.m_ui:updateMiniMap(rx, ry)
end

function This:onTouchMapLayer(x,y)
	local nx , ny = self:getCeilsPosition(x,y)
	local key = nx * 1000 + ny
	print(string.format("(%d,%d)-->(%d,%d)",x,y,nx,ny))
	if not self.m_ceils[key] and self.m_isSelected then	
		self:addCeils(nx,ny,self.m_curCityId)
	elseif self.m_ceils[key] and self.m_isDelete then
		self:removeCeils(nx,ny)
	end
end

function This:saveCeilsConfig()
	local str = table.dump(CeilsConfig)
	print(str)
	str = "local CeilsConfig = \n" .. str .. "\nreturn CeilsConfig"
	local file = io.open(OutputPath,"w")
	if file then
		file:write(str);
		io.close(file)
		print("save success!!!")
	else
		print("save fail!!!")
	end
end

function This:onKeyDown(keyCode)
	print(keyCode)
	if keyCode == 'A' then
		self.m_isSelected = true
	elseif keyCode == "Q" then
		self.m_isDelete = true
	elseif keyCode == "S" then
		self:saveCeilsConfig()
	elseif keyCode == "`" then
		self:openDialog("Map.EditMiniMapPanel", {
			mapRadioX = self.m_mapRadioX,
			mapRadioY = self.m_mapRadioY,
			filename = self.m_mapCsFileName,
		})
	elseif keyCode == "+" then
		local name = "Map.EditMiniMapPanel"
	    local reload = require "reload"
	    local co = coroutine.create(function ()
	        reload.reload { name }
	    end)
	    coroutine.resume(co)
	end
end

function This:onKeyUp(keyCode)
	if keyCode == 'A' then
		self.m_isSelected = false
	elseif keyCode == "Q" then
		self.m_isDelete = false
	end
end

function This:loadFinish()
	super.loadFinish(self)
	cc.Application:addListener(self)
end

function This:onExit()
	super.onExit(self)
	cc.Application:removeListener(self)
end

--endregion
