--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"Base.BaseModel")
local LegionMapRole = require("Map.LegionMapRole")

function This:init(info)
	super.init(self)
	self.m_map = info.map
	self.m_id = 0
	self.m_name = ""
	self.m_title = ""
	self.m_jifen = 0
	self.m_roles = {}
	self.m_citys = {}
	self.m_mainCityId = 0
	self.m_mainCity = nil
	self.m_silkBagNum = 0
end

function This:createLegionRole(data)
	return LegionMapRole:create(data)
end

function This:getId()
	return self.m_id
end

function This:getName()
	return self.m_name
end

function This:getTitle()
	return self.m_title
end

function This:getJiFen()
	return self.m_jifen
end

function This:setJiFen(score)
	self.m_jifen = score
end

function This:setSilkBagNum(value)
    self.m_silkBagNum = value
end

function This:getSilkBagNum()
    return self.m_silkBagNum
end

function This:getRole(id)
	return self.m_roles[id]
end

function This:getAllRoles()
	local result = {}
	for id , role in pairs(self.m_roles) do
		table.insert(result,role)
	end
	return result
end

function This:getRoleCount(selector)
	local result = 0
	if not selector then
		for _, role in pairs(self.m_roles) do
			result = result + 1
		end
	else
		for _, role in pairs(self.m_roles) do
			if selector(role) then
				result = result + 1
			end
		end
	end
	return result
end

function This:addCity(city)
	local cityId = city:getId()
	if not self.m_citys[cityId] then
		self.m_citys[cityId] = city
		if cityId == self.m_mainCityId then
			self.m_mainCity = city
		end
	end
end

function This:removeCity(city)
	local cityId = city:getId()
	if self.m_citys[cityId] then
		self.m_citys[cityId] = nil
	end
end

function This:getCityOwned(selector)
	local result = {}
	for i , city in pairs(self.m_citys) do
		if not selector or selector(city) then
			table.insert(city)
		end
	end
	return result
end

function This:getMainCity()
	if not self.m_mainCity then
		self.m_mainCity = self.m_citys[self.m_mainCityId] 
	end
	return self.m_mainCity
end

function This:updateInfo(info)
	self.m_id = info.group_id
	self.m_name = info.group_name
	self.m_title = info.group_title
	self.m_jifen = info.group_jifen
	self.m_mainCityId = info.main_city
	self.m_silkBagNum = info.trick_value

	if self.m_citys and self.m_mainCityId and self.m_mainCityId > 0 then
		local city = self.m_citys[self.m_mainCityId]
		if city then
			self.m_mainCity = city
		end
	end

	local tmp = {}
	for id , role in pairs(self.m_roles) do
		tmp[id] = true
	end
	for i , info in ipairs(info.role_list) do
		local role = self.m_roles[info.base.id]
		if not role then
			role = self:createLegionRole({
				map = self.m_map
			})
			self.m_roles[info.base.id] = role
		end
		role:updateInfo(info)
		tmp[info.base.id] = nil
	end
	for id , _ in pairs(tmp) do
		self.m_roles[id] = nil
	end
end

--endregion
