---
---
--- Created by aid.
--- DateTime: 2018/12/14 15:06
---
local This , super = class(...,"Dialog")
local LegionMapGuideConfig = require("Metadatas.LegionMapGuideConfig")

function This:initData(arguments)
    super.initData(self, arguments)
    self.m_showLoginHintOption = arguments.showLoginHintOption
    self.m_map = arguments.map
    self.m_loginHintSelected = false
end

function This:initNode()
    self.m_csNode = cc.Node:createFromCSFile("LegionScene/NodeUI/LegionGuide.csb")
    self:addChild(self.m_csNode)
    self.m_csNode:setToCenter()

    -- 登陆提示选项显示
    if self.m_showLoginHintOption then
        self:enableLoginOption()
    else
        self:disableLoginOption()
    end

    -- 登陆提示选项的选中状态
    if self.m_loginHintSelected then
        self.m_csNode.gouxuan:setVisible(true)
    else
        self.m_csNode.gouxuan:setVisible(false)
    end

    -- 分页
    for index, _ in ipairs(LegionMapGuideConfig) do
        self:addTabButton(index, self.m_csNode["tep"..index], function()
            self:selectTab(index)
        end)
    end
    self:selectTabButton(1)
end

function This:onEnter()
    super.onEnter(self)
end

function This:onExit()
    super.onExit(self)
end

function This:initTouchEvent()
    -- 关闭按钮
    self.m_csNode.close:setTouchEnded(function()
        self:close()
    end)

    -- 上一页按钮
    self.m_csNode.previous:setTouchEnded(function()
        self:showImage(self.m_currentImageIndex-1)
    end)

    -- 下一页按钮
    self.m_csNode.next:setTouchEnded(function()
        self:showImage(self.m_currentImageIndex+1)
    end)

    -- 登陆提示选项
    local function callback()
        if self.m_loginHintSelected then
            self.m_csNode.gouxuan:setVisible(false)
            self.m_loginHintSelected = false
            self.m_map:setShowHelpWhenEnterMap(true)
        else
            self.m_csNode.gouxuan:setVisible(true)
            self.m_loginHintSelected = true
            self.m_map:setShowHelpWhenEnterMap(false)
        end
    end
    self.m_csNode.weigouxuan:setTouch({
        onEnded = callback,
        isScale = false,
    })
    self.m_csNode.fujiang:setTouch({
        onEnded = callback,
        isScale = false,
    })
end

function This:selectTab(index)
    if self.m_currentTabIndex == index then
        return
    end
    self.m_currentTabIndex = index

    self.m_currentConfig = LegionMapGuideConfig[self.m_currentTabIndex]
    self.m_currentImageIndex = 1
    self.m_currentMaxImageIndex = #self.m_currentConfig.photo
    self:showImage(self.m_currentImageIndex)
end

function This:showImage(index)
    self.m_csNode.previous:setVisible(false)
    self.m_csNode.next:setVisible(false)

    if self.m_currentMaxImageIndex ~= 1 then
        if index == 1 then
            self.m_csNode.next:setVisible(true)
        elseif index == self.m_currentMaxImageIndex then
            self.m_csNode.previous:setVisible(true)
        else
            self.m_csNode.previous:setVisible(true)
            self.m_csNode.next:setVisible(true)
        end
    end

    self.m_currentImageIndex = index
    self.m_csNode.photo:setImage("LegionScene/Guide/"..self.m_currentConfig.photo[self.m_currentImageIndex]..".png")
    self.m_csNode.num:setString(""..self.m_currentImageIndex.."/"..self.m_currentMaxImageIndex)
end

function This:enableLoginOption()
    self.m_csNode.weigouxuan:setVisible(true)
    self.m_csNode.gouxuan:setVisible(true)
    self.m_csNode.fujiang:setVisible(true)
end

function This:disableLoginOption()
    self.m_csNode.weigouxuan:setVisible(false)
    self.m_csNode.gouxuan:setVisible(false)
    self.m_csNode.fujiang:setVisible(false)
end