--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"Dialog")
local Report = require("Report.Report")
local LegionReportView = require("Report.LegionReportView")
local ReportManager = require("Report.ReportManager")

function This:initNode(reportList)
	self.m_reports = {}
	for i , info in ipairs(reportList) do
		local report = ReportManager:getReport(info.id)
		table.insert(self.m_reports,report)
	end
	self.m_csNode = cc.Node:createFromCSFile("LegionScene/NodeUI/LegionLogList.csb")
	self:addChild(self.m_csNode)
	self.m_csNode:setToCenter()

	self.m_isAll = true
	self.m_csNode.gouxuan:setVisible(false)
	self:refreshListItem()
end

function This:refreshListItem()
	local reports = {}
	for i , report in ipairs(self.m_reports) do
		if self.m_isAll or (not self.m_isAll and report:isMy()) then
			table.insert(reports,report)
		end
	end
	local itemList = self.m_csNode.scrollview:getItemList()
	for i, report in ipairs(reports) do
		if #itemList < i then
			local view = LegionReportView:create(report)
			self.m_csNode.scrollview:pushBackCustomItem(view, 820, 140) 
		else
			itemList[i]:setModel(report)
		end
	end
	for i = #itemList, #reports + 1, -1 do
		self.m_csNode.scrollview:removeItem(i)
	end
end


function This:initTouchEvent()
	self.m_csNode.close:setTouchEnded(function()
		self:close()
	end)
	self.m_csNode.weigouxuan:setTouchEnded(function()
		self.m_isAll = not self.m_isAll
		self.m_csNode.gouxuan:setVisible(not self.m_isAll)
		self:refreshListItem()
	end)
end

--endregion
