﻿--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"Base.BaseModel")
local LegionMapRoomConfig = require("Metadatas.LegionMapRoomConfig")
local EventDispatcher = require("EventDispatcher")
local Socket = require("Net.Socket")
local LegionCity = require("Map.LegionCity")
local LegionTroop = require("Map.LegionTroop")
local LegionGroup = require("Map.LegionGroup")
local LegionMarch = require("Map.LegionMarch")
local GamePlayer = require("Player.GamePlayer")
local LegionBianDui = require("Map.LegionBianDui")
local ArgConfig = require("Metadatas.ArgConfig")
local FamilyManager = require("Family.FamilyManager")
local HeroManager = require("Hero.HeroManager")
local PlayTypeConfig = require("Metadatas.PlayTypeConfig")
local LegionStrategy = require("Map.LegionStrategy")
local GameMapManager = require("Map.GameMapManager")
local GameUtil = require("Util.GameUtil")
local GameWarShopData = require("Map.GameWarShopData")
local LegionWarBoxConfig = require("Metadatas.LegionWarBoxConfig")
local SingleManager = require("SingleDaily.SingleManager")
local LegionIntegralBox = require("Map.LegionIntegralBox")
local StateEntryController = require("Map.LegionStateEntryController")

LegionMapManagerBoxStateFileName = "LegionMapManagerBoxStateFileName"
LegionMapResType = {
	kFood = 1,
	kCopper = 2,      
	kOre = 3,
}

LegionBoxState = {
	kFuture = 1,	--预告
	kAppear = 2,    --出现  一有宝箱
	kEnd = 3,		--结束（结束的时候一定不会有宝箱）
}
function This:init(mapType)
	super.init(self)
	self.m_mapType = mapType
	self.m_level = 1
	self.m_config = LegionMapRoomConfig[self.m_mapType * 1000 + self.m_level]
	self.m_citys = {}
	self.m_troops = {}
	self.m_legions = {}
	self.m_legionsInRank = {}
	self.m_marchs = {}
	self.m_biandui = {}
	self.m_warBoxAppearCitys = {}--ciytid{ciytid1,ciytid2,ciytid3}
	self.m_warBoxId = 0
	self.m_maxBianDuiCount = 0
	self.m_escape = 0
	self.m_myLegionId = 0
	self.m_isInit = false
	self.m_gameWarShopData = nil
	self.m_showHelpWhenEnterMap = true
	self.m_stateEntrys = StateEntryController:create(self)
	EventDispatcher:addListener(self,13000,self.onGetMapInfoReply)
end

function This:initListener()
	EventDispatcher:addListener(self,13001,self.onRefreshTroopNotify)
	EventDispatcher:addListener(self,13002,self.onCityInfoChangeNotify)
	EventDispatcher:addListener(self,13003,self.onUpdateMapRoleNotify)
	EventDispatcher:addListener(self,13004,self.onUpdateBianDuiReply)
	EventDispatcher:addListener(self,13005,self.onAddBianDuiHpReply)
	EventDispatcher:addListener(self,13006,self.onUndoAddTroopHpReply)
	EventDispatcher:addListener(self,13007,self.onAddHpSpeedTroopReply)
	EventDispatcher:addListener(self,13012,self.onClearBianDuiHpReply)
	EventDispatcher:addListener(self,13008,self.onAddHpFinishNotify)
	EventDispatcher:addListener(self,13009,self.onCreateMarchReply)
	EventDispatcher:addListener(self,13010,self.onMarchChangedNotify)
	EventDispatcher:addListener(self,13014,self.onClearChengFangCreateTimeReply)
	EventDispatcher:addListener(self,13015,self.onTrainChengFangOnceKeyReply)
	EventDispatcher:addListener(self,13013,self.onTrainChengFangReply)
	EventDispatcher:addListener(self,13016,self.onMarchAddSpeedReply)
	EventDispatcher:addListener(self,13017,self.onRebuildCityReply)
	EventDispatcher:addListener(self,13018,self.onRemoveCityBuildReply)
	EventDispatcher:addListener(self,13019,self.onCityUpgradeAddSpeedReply)
	EventDispatcher:addListener(self,13020,self.onUpgradeCityReply)
	-- EventDispatcher:addListener(self,13021,self.onCityAddSpeedChangeNotify)
	EventDispatcher:addListener(self,13022,self.onGetCityBattleReportReply)
	EventDispatcher:addListener(self,13023,self.onGeRenInfoChangedNotify)
	EventDispatcher:addListener(self,13024,self.onLegionExitMapNotity)
	EventDispatcher:addListener(self,13027,self.onLegionJunCeChangedNotify)
	EventDispatcher:addListener(self,13028,self.onUseLegionJunCeReply)
	EventDispatcher:addListener(self,13029,self.onClearJunceUseCDReply)
    EventDispatcher:addListener(self,13030,self.onReceiveLegionScoreChangedReply) -- 军团积分发生改变
	EventDispatcher:addListener(self,13031,self.onLegionResourceChangedNotify)
	EventDispatcher:addListener(self,13032,self.onReceiveJunCeInfoNotify)

	EventDispatcher:addListener(self,13060,self.onWarShopReply)--军营商店拉取信息
    EventDispatcher:addListener(self,13061,self.onWarShopBuyReply)--军营个人商店商品购买
    EventDispatcher:addListener(self,13062,self.onWarShopBuyReply)--军营共享商店商品购买
    EventDispatcher:addListener(self,13063,self.onReceiveBarracksScoreAwardsReply) -- 军营积分奖励领取
    EventDispatcher:addListener(self, 13064, self.onLegionBoxInfoReply)

	EventDispatcher:addListener(self, 13065, self.onPickupJifenBoxReply)
	EventDispatcher:addListener(self, 13066, self.onPickupJifenSpecialBoxReply)
	EventDispatcher:addListener(self, 13067, self.onGetJinNangInfoNotify)
	EventDispatcher:addListener(self, 13068, self.onGetIntegralNotify)
	EventDispatcher:addListener(self, 13069, self.onGetIntegralRankInfoReply)
	EventDispatcher:addListener(self, 13070, self.onGetLuoYangBuffStateChangeNotify)
end

function This:removeListener()
	EventDispatcher:removeListener(self,13000)
	EventDispatcher:removeListener(self,13001)
	EventDispatcher:removeListener(self,13002)
	EventDispatcher:removeListener(self,13003)
	EventDispatcher:removeListener(self,13004)
	EventDispatcher:removeListener(self,13005)
	EventDispatcher:removeListener(self,13006)
	EventDispatcher:removeListener(self,13007)
	EventDispatcher:removeListener(self,13017)
	EventDispatcher:removeListener(self,13008)
	EventDispatcher:removeListener(self,13009)
	EventDispatcher:removeListener(self,13010)
	EventDispatcher:removeListener(self,13011)
	EventDispatcher:removeListener(self,13014)
	EventDispatcher:removeListener(self,13015)
	EventDispatcher:removeListener(self,13016)
	EventDispatcher:removeListener(self,13017)
	EventDispatcher:removeListener(self,13018)
	EventDispatcher:removeListener(self,13019)
	EventDispatcher:removeListener(self,13020)
	-- EventDispatcher:removeListener(self,13021)
	EventDispatcher:removeListener(self,13022)
	EventDispatcher:removeListener(self,13023)
	EventDispatcher:removeListener(self,13013)
	EventDispatcher:removeListener(self,13027)
	EventDispatcher:removeListener(self,13028)
	EventDispatcher:removeListener(self,13029)
	EventDispatcher:removeListener(self,13031)
	EventDispatcher:removeListener(self,13032)
	EventDispatcher:removeListener(self,13060)--军营商店信息
    EventDispatcher:removeListener(self,13061)--军营个人商店商品购买
    EventDispatcher:removeListener(self,13062)--军营共享商店商品购买
    EventDispatcher:removeListener(self,13063) --军营积分奖励领取
    EventDispatcher:removeListener(self,13030) -- 军团积分发生改变
    EventDispatcher:removeListener(self,13064)
	EventDispatcher:removeListener(self,13065)
	EventDispatcher:removeListener(self,13066)
	EventDispatcher:removeListener(self,13067)
	EventDispatcher:removeListener(self,13068)
	EventDispatcher:removeListener(self,13069)
	EventDispatcher:removeListener(self,13070)
end

function This:isInit()
	return self.m_isInit
end

function This:getId()
	return self.m_id
end


function This:getMapLevel()
	return self.m_level
end

function This:getMapType()
	return self.m_mapType
end

function This:getCityCeilConfig()
    return require("Map.CeilsConfig")
end

function This:getCityConfig()
    return require("Metadatas.LegionCityConfig")
end

function This:getCityRange()
	if self.m_mapType == GameMapType.kLegionMap then
		return 1 , 153
	else
		return 1001, 1153
	end
end

function This:getCityInitLevel()
	return self.m_config.initial_city_level
end

function This:getCityMaxLevel()
	return self.m_config.city_max_level
end

function This:getRoleMaxCoin()
	return self.m_config.max_coin
end

function This:getRoleMaxFood()
	return self.m_config.max_food
end

function This:getRoleMaxOre()
	local myCityList = self:getAllCitys()
	local maxRoleMaxOre = 0
	for _,city in pairs(myCityList) do
		if city:isOur() then
			maxRoleMaxOre = city:getMaxOre() + maxRoleMaxOre
		end
	end
	return maxRoleMaxOre
end

function This:getRoleInitCoin()
	return self.m_config.initial_coin
end

function This:getRoleInitFood()
	return self.m_config.initial_food
end

function This:getBarracksInitHp()
	return self.m_config.initial_arm
end

function This:getWarehouseInitMineral()
	return self.m_config.initial_minerals
end


function This:getWarehouseEndTime()
	local config = self.m_config
	local time = config.minerals_max / config.minerals_per_time
	local time1 = config.minerals_max1 / config.minerals_per_time1
	return time, time1
end

function This:getGameWarShopData()
	if not self.m_ratingData then
		self.m_ratingData = GameWarShopData:create(0)
	end
	return self.m_ratingData
end

function This:getCity(cityId)
	if not cityId or cityId <= 0 then
		assert(false)
	end
	local city = self.m_citys[cityId]
	if not city then
		city = LegionCity:create({
			id = cityId,
			map = self
		})
		self.m_citys[cityId] = city
	end
	return city
end

function This:getLegionColor(legionId)
	local colors = {
		cc.Color.YELLOW,
		cc.Color.GREEN,
		cc.Color.BLUE,
		cc.Color.RED
	}

	if not self.m_cityColors then
		self.m_cityColors = {}
	end

	if not self.m_cityColors[legionId] then
		local legions = self:getAllLegions()
		local count = 1
		for id, _ in pairs(legions) do
			if not self.m_cityColors[id] then
				self.m_cityColors[id] = colors[count]
			end
			count = count + 1
		end
	end
	return self.m_cityColors[legionId]
end

function This:getAllCitys()
	return self.m_citys
end

--获取部队
function This:getTroop(troopId)
	return self.m_troops[troopId]
end

--获取编队
function This:getBianDui(index)
	return self.m_biandui[index]
end

function This:getAllBianDui()
	return self.m_biandui
end

--获取最大编队数
function This:getMaxBianDuiCount()
	return self.m_bianduiMaxCount
end

function This:getBianDuiCount()
	local count = 0
	for i , biandui in ipairs(self.m_biandui) do
		if not biandui:isEmpty() then
			count = count + 1
		end
	end
	return count
end

function This:getLegion(legionId)
	return self.m_legions[legionId]
end

function This:getAllLegions()
	return self.m_legions
end

function This:getMyLegion()
	if self.m_myLegionId and self.m_myLegionId > 0 then
		return self.m_legions[self.m_myLegionId]
	end
	assert(false)
	return nil
end

function This:getMyLegionId()
	return self.m_myLegionId
end

function This:getMyLegionCityId()
	return self.m_myLegionCityId
end

function This:getMyLegionCity()
    return self.m_citys[self.m_myLegionCityId]
end

function This:getQuitLegionList()
	local result = {}
	for _, info in pairs(self.m_legionsInRank) do
        result[info.rank] = info
    end
    return result
end

--获取行军
function This:getMarch(marchId)
	return self.m_marchs[marchId]
end

function This:getMarchList(selector)
	local result = {}
	for i , march in pairs(self.m_marchs) do
		if not selector or selector(march) then
			table.insert(result,march)
		end
	end
	return result
end

function This:getEnemyMarchArmyToMyCity()
	return self:getMarchList(function(march)
		if not march:isOur() then
			local city = self:getCity(march:getToCity())
			return city:isOur()
		end
		return false
	end)
end

function This:getRole(id)
	for legionId, legion in pairs(self.m_legions) do
		local role = legion:getRole(id)
		if role then
			return role
		end
	end
end

function This:getJifenDetail()
    return self.m_scoreDetailList
end

function This:getJiFen()
    return self.m_jifen or 0
end

function This:getJiFenRank()
    return self.m_jifenRank or 0
end

function This:IsJifenSpecialBoxRewarded()
    return self.m_jifenSpecialBoxRewarded
end

function This:getJifenBoxList()
	local ret = GameUtil:shallowChange(self.m_jifenBoxList)
	table.sort(ret, function( A, B )
		return A:getId() < B:getId()
	end)
    return ret
end

function This:getDebuffInfo()
    return self.m_debuffInfo
end

function This:getCoin()
	return self.m_coin
end

function This:getFood()
	return self.m_food
end

function This:getOre()
	return self.m_ore
end

function This:getMaxOre()
	return self.m_oreMax
end

function This:setCoin(number)
	local old = self.m_coin
	if old ~= number then
		self.m_coin = number
		self:notifyObservers("onLegionResChanged", LegionMapResType.kCopper, old, number)
	end
end

function This:setFood(number)
	local old = self.m_food
	if old ~= number then
		self.m_food = number
		self:notifyObservers("onLegionResChanged", LegionMapResType.kFood, old, number)
	end
end

function This:setOre(number)
	local old = self.m_ore
	if old ~= number then
		self.m_ore = number
		self:notifyObservers("onLegionResChanged", LegionMapResType.kOre, old, number)
	end
end

--获取补兵时间花费
function This:getAddHpCostTime(hp,cityId)
	local city = self:getCity(cityId)
	local speed = city:getAddHpSpeed()
	if self:isToJueShengTime() then
		return math.ceil(hp / speed * self:getAddHpTimeFactorInVictory())
	else
		return math.ceil(hp / speed)
	end
end

--获取加速补兵花费
function This:getAddHpSpeedCost()
	return ArgConfig["legion_war_mending_speedup_cost"].arg[1]
end

--获取补兵花费
function This:getAddHpCostCoin(hp,heroId)
	local hero = HeroManager:getHero(heroId)
	local soilder = hero:getCurSoilder()
	local coin = soilder:getRecruitCost()
	return hp * coin * ArgConfig["legion_war_mending_coin_coefficient"].arg[1]
end

--决胜期补兵时间比例
function This:getAddHpTimeFactorInVictory()
	return ArgConfig["legion_war_decisive_victory_mending_proportion"].arg[1]
end

--获取最大运矿量
function This:getTransMaxMineral(hp,heroId)
	local hero = HeroManager:getHero(heroId)
	local soilder = hero:getCurSoilder()
	local soilderId = soilder:getId()
	return hp * ArgConfig["legion_war_troops_change_mineral_coefficient"].arg[1] * 1 --鍏电绯绘暟
end

--获取运矿花费
function This:getTransMineralCostCoin(mineral)
	return mineral * ArgConfig["legion_war_mineral_coin_coefficient"].arg[1]
end

--获取决胜期行军时间比例
function This:getMarchTimeFactorInVictory()
	-- return 0.5
	return ArgConfig["legion_war_decisive_victory_march_proportion"].arg[1]
end

--获取最大行军加速次数
function This:getMaxMarchAddSpeedTime()
	return ArgConfig["legion_war_march_speedup_max_times"].arg[1]
end

--获取行军加速花费
function This:getMarchAddSpeedCost()
	return ArgConfig["legion_war_march_speedup_cost"].arg[1]
end

--获取建设度战力限制
function This:getMinJianSheDuFightPower()
	return self.m_config.min_fight_power
end

function This:getStartTime()
	return self.m_fightTime - ArgConfig["legion_city_propect_time"].arg[1]
end

function This:getFightTime()
	return self.m_fightTime
end

function This:getJueZhanTime()
	return self.m_juezhanTime
end

--是否到达决胜期
function This:isToJueShengTime()
	local curTime = GamePlayer:getServerTime()
	return curTime >= self.m_juezhanTime
end

function This:getEndTime()
	local curTime = GamePlayer:getServerTime()

	local t = PlayTypeConfig[self:getMapType()].fight_end_time
	return {
		wday = t[1],
		hour = t[2],
		min = t[3],
		sec = t[4]
	}
end

function This:setBoxIsHaveAppear(appear)
	local isHaveAppear = appear or false
	local fightTime = self:getFightTime()
	SingleManager:setPalyerActInfo(fightTime, isHaveAppear,LegionMapManagerBoxStateFileName)
end

function This:getBoxIsHaveAppear()
	local fightTime = self:getFightTime()
	return SingleManager:getPalyerActInfo(fightTime,false,LegionMapManagerBoxStateFileName)
end

-- 军团战当前开启的宝箱id
function This:getWarBoxId()

	local result = self.m_warBoxId
	if not result or result ==0  then
		 local function getAllBox()
            local allBoxIds ={}
            for _,boxItem in pairs(LegionWarBoxConfig) do
                local mType = boxItem.type
                local mLevel = boxItem.map_level
                local order = boxItem.order
                if not allBoxIds[mType] then
                    allBoxIds[mType] = {}
                end
                local mapItem = allBoxIds[mType]
                if not mapItem[mLevel] then
                    mapItem[mLevel] ={}
                end
                local levelItem = mapItem[mLevel]
                levelItem[order]= boxItem
            end
            return allBoxIds
        end
        local allBoxIds = self.m_allBoxIds
        if not allBoxIds then
            allBoxIds =getAllBox()
            self.m_allBoxIds =allBoxIds
        end
		local mapType = self.m_mapType
		local mapLevel = self.m_level
		if allBoxIds[mapType] then
			local boxIds = allBoxIds[mapType][mapLevel] or {}
			local curTime = GamePlayer:getServerTime()
			local startTime = self:getStartTime()
			local offsetTime = curTime - startTime
			for boxIndex = #boxIds , 1 , -1 do
				local warBoxItem = boxIds[boxIndex]
				if warBoxItem then
					local futureTime = warBoxItem.notice_time
					local endTime = warBoxItem.settling_time
					if offsetTime >=futureTime and offsetTime< endTime then
						result = warBoxItem.id
						break
					end
				end
			end
		end
	end
	return result,LegionWarBoxConfig[result]
	-- local result = 1011
	-- return result,LegionWarBoxConfig[result]
end

function This:getWarBoxLeftTime()
	if self:getMapType() ~=GameMapType.kLegionMap or not self:isInit() then
		return LegionBoxState.kEnd,0
	end
	local _,warBoxItem = self:getWarBoxId()
	local curTime = GamePlayer:getServerTime()
	local startTime = self:getStartTime()
	local offsetTime = curTime - startTime
	if curTime>startTime and warBoxItem then
		local endTime = warBoxItem.settling_time
		local apearTime = warBoxItem.appear_time
		local futureTime = warBoxItem.notice_time
		if offsetTime >=endTime then
			self.m_warBoxId = 0
			self.m_warBoxAppearCitys = {}
			return LegionBoxState.kEnd,0
		elseif offsetTime >=apearTime then
			if #self.m_warBoxAppearCitys ~=3 then
				return LegionBoxState.kFuture,0
			end
			return LegionBoxState.kAppear,endTime-offsetTime
		elseif offsetTime >=futureTime then
			return LegionBoxState.kFuture,apearTime-offsetTime
		end
	end
	return LegionBoxState.kEnd,0
	-- return LegionBoxState.kAppear,100
end
--获取宝箱出现的城市id
function This:getAppearCitys()

	return self.m_warBoxAppearCitys--cityId列表
	-- return {136,137,145}
end

--获取军策
function This:getJunCe(type)
	return self.m_junces[type]
end

function This:getJunCeList()
	local result = {}
	for i , junce in pairs(self.m_junces) do
		table.insert(result,junce)
	end
	return result
end

function This:isJunceEffectInLegion(jctype)
    return self.m_stateEntrys:isJunceEffectInLegion(jctype)
end

function This:getEffectJunCesInCity(cityId)
	local ret = {}
	local minValue, minJunce
	for jctype, junce in pairs(self.m_junces) do
		if junce:canShowEffect() and junce:isUsedOnCity(cityId) then
			local time = junce:getLeftHoldTime(cityId)
			if time > 0 then
				ret[jctype] = junce
				if not minJunce or time < minvalue then
					minvalue = time
					minJunce = junce
				end
			end
		end
	end
	return ret, minJunce
end

function This:getKuangdongTime()
	return self.m_whSmallEndTime,self.m_whEndTime
end

function This:getLuoyangOwnerName()
	local luoYangOwerId = self.m_luoYangOwerId 
	if luoYangOwerId and luoYangOwerId > 0 then
		local legion = self:getLegion(luoYangOwerId)
		if legion then
			return legion:getName()
		end
	end
    return Serialize[60243]
end

function This:exit()
	self.m_isInit = false
	self.m_stateEntrys:cleanup()
	self.m_stateEntrys = nil
	self:removeListener()
end

function This:enter()
	if g_setting.isDebug and g_setting.isWarTest then
		self:onGetMapInfoRequest()
		cc.SceneManager:switchTo("Map.LegionScene",nil,{
			map = self
		})
		return
	end

	local routine = coroutine.create(function(synchro)
    	self.m_routine = synchro
		self:onGetMapInfoRequest()
		local result = coroutine.yield()
		if result then
			cc.SceneManager:switchTo("Map.LegionScene",nil,{
				map = self
			})
		end
	end)
	coroutine.resume(routine, routine)
end

function This:setShowHelpWhenEnterMap(ok)
	self.m_showHelpWhenEnterMap = ok
end

function This:needShowHelpWhenEnterMap()
	return self.m_showHelpWhenEnterMap
end
----------------------------------------------------------

function This:onGetMapInfoRequest()
	self:sendAndLock(13000,{})
end

function This:onGetMapInfoReply(msg)
	if self.m_routine then
		coroutine.resume(self.m_routine, msg.err_code == 0)
		self.m_routine = nil
	end

	if msg.err_code ~= 0 then
		self:notifyObservers("onGetMapInfoFail", msg) --界面有特殊处理
		-- g_scene:handleErrorCode(msg.err_code)
		return 
	end
	local map = msg.map
	self.m_legions = {}
    self.m_legionsInRank = {}
	self.m_marchs = {}
	self.m_junces = {}

	self.m_citys = {}
	self.m_id = msg.map.id
	self.m_mapType = msg.map.map_type
	self.m_level = msg.map.map_level
	self.m_config = LegionMapRoomConfig[self.m_mapType * 1000 + self.m_level]

	-- 设置下这个地图id，防止后端没传
	GamePlayer.m_data[PlayerAttr.group_war_map_id] = self.m_id

	self.m_fightTime = msg.map.fight_time
	self.m_escape = 0
	self.m_juezhanTime = self.m_fightTime + (ArgConfig["legion_war_decisive_victory_time"].arg[1] - ArgConfig["legion_city_propect_time"].arg[1])
	self.m_warBoxId = map.box_id
	self.m_warBoxAppearCitys = map.box_city_list

	local stime = self:getStartTime()
	local whCostTime, whCostTime1 = self:getWarehouseEndTime() 
	self.m_whSmallEndTime = stime + whCostTime
	self.m_whEndTime = stime + whCostTime1

	self.m_checkWhEndTime  = true
	local curTime = GamePlayer:getServerTime()
	if self.m_fightTime > curTime then
		cc.Application:addToUpdateList(self)
	end

	self.m_myLegionId = map.geren.group_id

	for _, info in ipairs(map.group_list) do
		local groupId = info.group_id
		local legion = self.m_legions[groupId]
		if not legion then
			legion = LegionGroup:create({
				map = self
			})
			self.m_legions[groupId] = legion
		end
		legion:updateInfo(info)
        if self.m_myLegionId == groupId then
			self.m_myLegionCityId = info.main_city
		end
	end

	for _, info in ipairs(map.quit_group_list) do
		local groupId = info.group_id
		if self.m_legions[groupId] then
			self.m_legions[groupId] = nil
		end
		self.m_legionsInRank[groupId] = info
	end

	for i , info in ipairs(map.troop_list) do
		local troop = self.m_troops[info.id]
		if not troop then
			troop = LegionTroop:create({
				map = self
			})
			self.m_troops[info.id] = troop
		end
		-- print_tmp({index = i, troop = info})
		troop:updateInfo(info)
	end

	for i , info in ipairs(map.city_list) do
		local city = self.m_citys[info.city_id]
		if not city then
			city = LegionCity:create({
				id = info.city_id,
				map = self
			})
			self.m_citys[info.city_id] = city
		end
		city:updateInfo(info)
	end

	for i , info in ipairs(map.march_list) do
		if info.endtime > curTime then
			local march = self.m_marchs[info.id]
			if not march then
				march = LegionMarch:create({
					map = self
				})
				self.m_marchs[info.id] = march
			end
			march:updateInfo(info)
		end
	end

	self.m_scoreDetailList = map.geren.score_detail_list
	self.m_bianduiMaxCount = map.geren.max_count
	self.m_biandui = {}

	for i = 1, self.m_bianduiMaxCount do
		self.m_biandui[i] = LegionBianDui:create({
			map = self,
			pos = i
		})
	end

	for i , info in ipairs(map.geren.biandui_list) do
		local biandui = self.m_biandui[info.pos]
		biandui:updateInfo(info)
	end

	for _ , id in pairs(LegionStrategyType) do
		self.m_junces[id] = LegionStrategy:create({
			type = id,
			map = self
		})
	end
	
	for i , info in ipairs(map.geren.junce_list) do
		self.m_junces[info.type]:updateInfo(info)
	end

	if self.m_stateEntrys then
		self.m_stateEntrys:cleanup()
	else
	    self.m_stateEntrys = StateEntryController:create(self)
	end

	for i , info in ipairs(map.junce_list) do
		self.m_junces[info.type]:addEntry(info)
		self.m_stateEntrys:addEntry(info)
	end

	local luoYangOwerId = map.luoyang_owner_id or 0
	if luoYangOwerId > 0 and luoYangOwerId == self.m_myLegionId then
		self.m_stateEntrys:addOtherEntry(LegionStateEntryType.kSeizedCity)
	else
		self.m_stateEntrys:removeOtherEntry(LegionStateEntryType.kSeizedCity)
	end
	self.m_luoYangOwerId = luoYangOwerId

	do
		local jifenBoxList = {}
		local nextId = (self.m_mapType * 100 + self.m_level) * 100 + 1
		repeat
			local box = LegionIntegralBox:create({id = nextId})
			jifenBoxList[nextId] = box
			nextId = box:getNextBoxId()
		until nextId == 0

		for _, boxId in ipairs(map.geren.scorereward_list) do
			jifenBoxList[boxId]:setState(true)
		end
		self.m_jifenBoxList = jifenBoxList
		self.m_jifen = map.geren.score
		self.m_jifenRank = 0
		self.m_jifenSpecialBoxRewarded = map.geren.group_scorereward 
	end

	do
		local debuffInfo = {}
		local idList, numList = map.geren.debuff_card_type_list, map.geren.debuff_count_list
		if idList then
			for indice, heroId in ipairs(idList) do
				debuffInfo[heroId] = numList[indice] 
			end
		end
		self.m_debuffInfo = debuffInfo
	end

	self.m_food = map.geren.food
	self.m_coin = map.geren.coin
	self.m_ore = map.geren.ore
	self.m_oreMax = map.geren.ore_max
	self.m_maxBianDuiCount = map.geren.max_count

	self.m_isInit = true
	self:initListener()
	self:notifyObservers("onGetLegionMapInfo",self)
end

function This:getStateEntryList()
    return self.m_stateEntrys:getEntryList()
end

function This:getStateEntryController()
    return self.m_stateEntrys
end

-------------------------------刷新部队-----------------------
function This:onRefreshTroopNotify(msg)
	local updateList = {}
	for i , info in ipairs(msg.update_troop_list) do
		local troop = self.m_troops[info.id]
		if not troop then
			troop = LegionTroop:create({
				map = self
			})
			self.m_troops[info.id] = troop
		end
		troop:updateInfo(info)
		print(string.format("更新部队:%s",GameUtil:int64ToString(info.id)))
		self:notifyObservers("onUpdateTroop",troop)
	end

	for i , id in ipairs(msg.delete_troop_list) do
		local troop = self.m_troops[id]
		if self.m_troops[id] then
			self.m_troops[id] = nil
			self:notifyObservers("onDeleteTroop",troop)
			print(string.format("删除部队:%s",GameUtil:int64ToString(id)))
		end
	end
end

-------------------------------刷新玩家---------------------
function This:onUpdateMapRoleNotify(msg)
	local roles = {}
	for i , info in ipairs(msg.role_list) do
		local legion = self:getLegion(info.group_id)
		local role = legion:getRole(info.base.id)
		role:updateInfo(info)
		roles[info.base.id] = role
	end
	self:notifyObservers("onUpdateMapRole",roles)
end

-------------------------------刷新编队------------------------
function This:onUpdateBianDuiRequest(index,cardList,name)
	self:sendAndLock(13004,{
		index = index,
		card_list = cardList,
		name = name
	})
end

function This:onUpdateBianDuiReply(msg)
	if msg.err_code == 0 then
		local biandui = self.m_biandui[msg.biandui_info.pos]
		biandui:updateInfo(msg.biandui_info)
		self:notifyObservers("onUpdateBianDuiTroop",msg.biandui_info.pos,biandui)
	else
		g_scene:handleErrorCode(msg.err_code)
	end
end
-------------------------刷新编队---------------------------------
function This:onAddBianDuiResRequest(index,cardList,hpList,resType,cityId)
	self:sendAndLock(13005,{
		index = index,
		card_list = cardList,
		hp_list = hpList,
		res_type = resType,
		city_id = cityId,
		to_city_id = 0
	})
end

function This:onAddBianDuiHpReply(msg)
	if msg.err_code == 0 then
		local biandui = self:getBianDui(msg.index)
		self:notifyObservers("onAddBianDuiRes",biandui)
	else
		g_scene:handleErrorCode(msg.err_code)
	end
end

-------------------------撤销补兵---------------------------
function This:onUndoAddTroopHpRequest(index)
	self:sendAndLock(13006,{
		index = index
	})
end
function This:onUndoAddTroopHpReply(msg)
	if msg.err_code == 0 then
		local biandui = self:getBianDui(msg.index)
		self:notifyObservers("onUndoAddBianDuiHp",biandui)
	else
		g_scene:handleErrorCode(msg.err_code)
	end
end
----------------------------补兵加速------------------------
function This:onAddHpSpeedTroopRequest(index)
	self:sendAndLock(13007,{
		index = index
	})
end

function This:onAddHpSpeedTroopReply(msg)
	if msg.err_code == 0 then
		local biandui = self:getBianDui(msg.index)
		self:notifyObservers("onAddBianDuiHpSpeed",biandui)
	else
		g_scene:handleErrorCode(msg.err_code)
	end
end

----------------------------撤销兵力--------------------------
function This:onClearBianDuiHpRequest(index)
	self:sendAndLock(13012,{
		index = index
	})
end

function This:onClearBianDuiHpReply(msg)
	if msg.err_code == 0 then
		local biandui = self:getBianDui(msg.index)
		self:notifyObservers("onClearBianDuiHp",biandui)
	else
		g_scene:handleErrorCode(msg.err_code)
	end
end

----------------------------补兵完成通知-----------------------
function This:onAddHpFinishNotify(msg)
	local biandui = self:getBianDui(msg.index)
	self:notifyObservers("onAddHpFinish",biandui)
end

----------------------------创建行军---------------------------
function This:onCreateMarchRequest(info)
	self:sendAndLock(13009,{
		index = info.index,
		res_type = info.res_type,
		res_list = info.res_list,
		from_city = info.from_city,
		to_city = info.to_city
	})
end

function This:onCreateMarchReply(msg)
	if msg.err_code == 0 then
		local march = self.m_marchs[msg.march_id]
		self:notifyObservers("onCreateMarch",march)
	else
		g_scene:handleErrorCode(msg.err_code)
	end
end

---------------------------加速行军----------------------------
function This:onMarchAddSpeedRequest(id)
	self:sendAndLock(13016,{
		march_id = id
	})
end

function This:onMarchAddSpeedReply(msg)
	if msg.err_code == 0 then
		local march = self:getMarch(msg.march_id)
		self:notifyObservers("onMarchAddSpeed",march)
	else
		g_scene:handleErrorCode(msg.err_code)
	end
end

-------------------------行军变化通知---------------------------
function This:onMarchChangedNotify(msg)
	local curTime = GamePlayer:getServerTime()
	for i , info in ipairs(msg.update_march_list) do
		local march = self.m_marchs[info.id]
		if not march then
			if info.endtime < curTime then
				assert(false)
			end
			march = LegionMarch:create({
				map = self
			})
			self.m_marchs[info.id] = march
			march:updateInfo(info)
			self:notifyObservers("onAddMarch",march)
		else
			march:updateInfo(info)
			self:notifyObservers("onUpdateMarch",march)
		end
	end

	for i , id in ipairs(msg.arrive_march_list) do
		local march = self.m_marchs[id]
		if march then
			self.m_marchs[id] = nil
			march:clear()
			self:notifyObservers("onDeleteMarch",march)
		end
	end
end

-------------------------城市信息变化-------------------------
function This:onCityInfoChangeNotify(msg)
	for i , info in ipairs(msg.city_list) do
		local city = self:getCity(info.city_id)
		local oldState = city:getState()
		local oldLegionId = city:getLegionId()

		city:updateInfo(info)
		local newState = city:getState()
		local newLegionId = info.group_id

		if oldState ~= newState then
			if newState == LegionCityState.kFighting then
				self:notifyObservers("onCityStartFight",city)
			elseif oldState ~= LegionCityState.kFighting and newState == LegionCityState.kFighting then
				self:notifyObservers("onCityEndedFight",city)
			end
			print(string.format("***************************city:%d state -> (%d,%d)********************",info.city_id,oldState,newState))
		end

		if oldLegionId ~= newLegionId then
			self:notifyObservers("onCityOwnerChanged",city)
		end

		self:notifyObservers("onCityInfoChanged",city)
	end
end

-------------------------清除城墙时间-------------------------

function This:onClearChengFangCreateTimeRequest(cityId)
	self:sendAndLock(13014,{
		city_id = cityId
	})
end

function This:onClearChengFangCreateTimeReply(msg)
	if msg.err_code == 0 then
		local city = self.m_citys[msg.city_id]
		self:notifyObservers("onClearChengFangTime",city)
	else
		g_scene:handleErrorCode(msg.err_code)
	end
end

----------------------------训练城防军-----------------------

function This:onTrainChengFangRequest(cityId, pos)
	self:sendAndLock(13013,{
		city_id = cityId,
		pos = pos
	})
end

function This:onTrainChengFangReply(msg)
	if msg.err_code == 0 then
		g_scene:showTips(Serialize[61727])
		self:notifyObservers("onTrainChengFang",msg.city_id,msg.pos)
	else
		g_scene:handleErrorCode(msg.err_code)
	end
end

--------------------------一键训练城墙----------------------
function This:onTrainChengFangOnceKeyRequest(cityId)
	self:sendAndLock(13015,{
		city_id = cityId
	})
end

function This:onTrainChengFangOnceKeyReply(msg)
	if msg.err_code == 0 then
		local city = self.m_citys[msg.city_id]
		self:notifyObservers("onTrainChengFangOnceKey",city)
	else
		g_scene:handleErrorCode(msg.err_code)
	end
end

---------------------------改造城池---------------------------
function This:onRebuildCityRequest(cityId,buildType)
	self:sendAndLock(13017,{
		city_id = cityId,
		build_type = buildType
	})
end

function This:onRebuildCityReply(msg)
	if msg.err_code == 0 then
		local city = self.m_citys[msg.city_id]
		self:notifyObservers("onRebuildCity",city)
	else
		g_scene:handleErrorCode(msg.err_code)
	end
end

-------------------------拆除城池建筑------------------------
function This:onRemoveCityBuildRequest(cityId)
	self:sendAndLock(13018,{
		city_id = cityId
	})
end

function This:onRemoveCityBuildReply(msg)
	if msg.err_code == 0 then
		local city = self.m_citys[msg.city_id]
		self:notifyObservers("onRemoveBuild",city)
	else
		g_scene:handleErrorCode(msg.err_code)
	end
end

------------------------加速升級城池---------------------------
function This:onCityUpgradeAddSpeedRequest(cityId,pos,bianduiIndex,addSpeedId,isRate)
	self:sendAndLock(13019,{
		city_id = cityId,
		tech_type = 0,
		biandui_index = bianduiIndex,
		add_speed_id = addSpeedId,
		pos = pos,
		is_rate = isRate or false
	})
end

function This:onCityUpgradeAddSpeedReply(msg)
	if msg.err_code == 0 then
		local city = self.m_citys[msg.city_id]
		self:notifyObservers("onCityUpgradeAddSpeed",city)
	else
		g_scene:handleErrorCode(msg.err_code)
	end
end

--------------------------升級城池-------------------------
function This:onUpgradeCityRequest(cityId,state)
	Socket:sendAndLock(13020,{
		city_id = cityId,
		tech_type = 0,
		state = state
	})
end

function This:onUpgradeCityReply(msg)
	if msg.err_code == 0 then
		local city = self.m_citys[msg.city_id]
		city:setBuildState(LegionBuildState.kUpgrading)
		self:notifyObservers("onUpgradeCity",city)
	else
		g_scene:handleErrorCode(msg.err_code)
	end
end

---------------------------城池升级加速变化通知-----------------------
-- function This:onCityAddSpeedChangeNotify(msg)
-- 	if not self.m_isInit then
-- 		return
-- 	end
-- 	local city = self.m_citys[msg.city_id]
-- 	self:notifyObservers("onCityAddSpeedChange", city)
-- end

---------------------------请求城市战报--------------------------
function This:onGetCityBattleReportRequest(cityId)
	self:sendAndLock(13022,{
		city_id = cityId
	})
end

function This:onGetCityBattleReportReply(msg)
	if msg.err_code == 0 then
		self:notifyObservers("onGetCityBattleReport",msg)
	else
		g_scene:handleErrorCode(msg.err_code)
	end
end

--------------------------个人信息变化------------------------------
function This:onGeRenInfoChangedNotify(msg)
	self.m_bianduiMaxCount = msg.geren.max_count

	for i = 1, self.m_bianduiMaxCount do
		if not self.m_biandui[i] then
			self.m_biandui[i] = LegionBianDui:create({
				map = self,
				pos = i
			})
		end
	end

	for i , info in ipairs(msg.geren.biandui_list) do
		local biandui = self.m_biandui[info.pos]
		biandui:updateInfo(info)
	end

	for i , info in ipairs(msg.geren.junce_list) do
		self.m_junces[info.type]:updateInfo(info)
		self:notifyObservers("onLegionJunCeChanged",self.m_junces[info.type])
	end

	self.m_food = msg.geren.food
	self.m_coin = msg.geren.coin
	self.m_ore = msg.geren.ore
	self.m_oreMax = msg.geren.ore_max
	self.m_myLegionId = msg.geren.group_id
	self.m_maxBianDuiCount = msg.geren.max_count

	self.m_jifen = msg.geren.score
	self.m_scoreDetailList = msg.geren.score_detail_list
	self.m_jifenSpecialBoxRewarded = msg.geren.group_scorereward 
	for _, boxId in ipairs(msg.geren.scorereward_list) do
		self.m_jifenBoxList[boxId]:setState(true)
	end
	
	local debuffInfo = {}
	local idList, numList = msg.geren.debuff_card_type_list, msg.geren.debuff_count_list
	if idList then
		for indice, heroId in ipairs(idList) do
			debuffInfo[heroId] = numList[indice] 
		end
	end
	self.m_debuffInfo = debuffInfo
	self:notifyObservers("onGeRenInfoChanged")
end

---------------------------军团退出通知----------------------------
function This:onLegionExitMapNotity(msg)
	local legion = self.m_legions[msg.group_id]
	self:notifyObservers("onLegionExitMap",msg)
	if self.m_myLegionId == msg.group_id then
		self:exit()
	end
	self.m_legions[msg.group_id] = nil
    self.m_legionsInRank[msg.group_id] = {
        group_id = msg.group_id,
        group_name = msg.name,
        rank = msg.rank,
        score = msg.score,
    }
    self:notifyObservers("onLegionExitMapAfter")
end

----------------------------军策使用-----------------------------
function This:onUseLegionJunCeRequest(cityId,type)
	self:sendAndLock(13028,{
		city_id = cityId,
		type = type
	})
end

function This:onUseLegionJunCeReply(msg)
	if msg.err_code == 0 then
		self:notifyObservers("onUseLegionJunCe",msg.type,msg.city_id)
	else
		g_scene:handleErrorCode(msg.err_code)
	end
end

----------------------------军策变化通知--------------------------
function This:onLegionJunCeChangedNotify(msg)
	for i , info in ipairs(msg.update_entry_list) do
		local junce = self.m_junces[info.type]
		junce:addEntry(info)
		self.m_stateEntrys:addEntry(info) 
		self:notifyObservers("onLegionJunCeChanged", junce, info.city_id)
	end
	for i , info in ipairs(msg.del_entry_list) do
		local junce = self.m_junces[info.type]
		junce:removeEntry(info)
		self.m_stateEntrys:removeEntry(info)
		self:notifyObservers("onLegionJunCeChanged", junce, info.city_id)
	end
end

----------------------------清楚军策使用CD------------------------
function This:onClearJunceUseCDRequest(type)
	self:sendAndLock(13029,{
		type = type
	})
end

function This:onClearJunceUseCDReply(msg)
	if msg.err_code == 0 then
		local junce = self.m_junces[msg.type]
		self:notifyObservers("onClearJunceUseCD",junce)
	else
		g_scene:handleErrorCode(msg.err_code)
	end
end

function This:onLegionResourceChangedNotify(msg)
    local resourceType = msg.res_type
    if resourceType == LegionMapResType.kCopper then
    	self:setCoin(msg.res_value)
    elseif resourceType == LegionMapResType.kFood then
    	self:setFood(msg.res_value)
    elseif resourceType == LegionMapResType.kOre then
    	self:setOre(msg.res_value)
    end
end

function This:onReceiveJunCeInfoNotify(msg)
    if msg then
        local info = msg.junce
        if info and info.type then
        	self.m_junces[info.type]:updateInfo(info)
			self:notifyObservers("onLegionJunCeChanged",self.m_junces[info.type], info.city_id)
        end
	else
        g_scene:handleErrorCode("")
    end
end

---------------------------------------------------------
function This:update(dt)
	self.m_escape = self.m_escape + dt
	if self.m_escape < 1.0 then
		return
	end
	self.m_escape = self.m_escape - 1
	local curTime = GamePlayer:getServerTime()
	if self.m_checkWhEndTime then
		if curTime >= self.m_whSmallEndTime and self.m_whSmallEndTime < curTime + 1 then
			self:notifyObservers("refreshMapPaoMa", true)
		elseif curTime >= self.m_whEndTime and self.m_whEndTime < curTime + 1 then
			self:notifyObservers("refreshMapPaoMa")
			self.m_checkWhEndTime = false
		end
	end

	if curTime >= self.m_fightTime and self.m_fightTime < curTime + 1 then
		self:notifyObservers("onLegionMapStartFight")
	elseif curTime >= self.m_juezhanTime and self.m_juezhanTime < curTime + 1 then
		cc.Application:removeFromUpdateList(self)
		self:notifyObservers("onLegionMapStartJueZhan")
	end
end

---------------------------- 拉取军营商店信息----------------
function This:onWarShopRequest()
    self:sendAndLock(13060)
end

----------------------------------------------------------
function This:onWarShopReply( msg )
	if msg.err_code == 0 then
		local gameWarShopData = self:getGameWarShopData()
        gameWarShopData:setWarShopkey(msg.shop_key)
    	gameWarShopData:setWarPersonShopList(msg.role_solt_list)
        gameWarShopData:setWarShareShopList(msg.share_solt_list)
        gameWarShopData:setOverTime(msg.over_time)
		gameWarShopData:setRoleScoreReward(msg.role_jifen_rewarded)
		gameWarShopData:setWarShareShopIntegral(msg.jifen)
		if msg.shop_key ~= 0 then
			self:notifyObservers("onWarShopStart")
		else
			self:notifyObservers("onWarShopEnd")
			if msg.over_time == 0 then
				self:notifyObservers("onWarShopOver")
			end
		end
    else
		--g_scene:showTips(Serialize[61728])
		g_scene:handleErrorCode(msg.err_code)
    end
end

---------------------------- 购买军营商店商品-----------------
function This:onWarShopBuyRequest(m_item_id,item_solt,shop_type,m_cityid)
    --print("item_id "..m_item_id.."item_solt "..item_solt)
    if shop_type == 1 then
        self:sendAndLock(13061,{item_id = m_item_id,solt = item_solt,city_id = m_cityid})
    elseif shop_type == 2 then
        self:sendAndLock(13062,{item_id = m_item_id,solt = item_solt,city_id = m_cityid})
    end
end

-------------------------------------------------------------
function This:onWarShopBuyReply( msg )
    if msg.err_code == 0 then
        if msg.role_solt_list then
            --print("msg.role_solt_list "..#msg.role_solt_list)
			self.m_ratingData:setWarPersonShopList(msg.role_solt_list)
            self:notifyObservers("onShopItem", 1)
        elseif msg.share_solt_list then
            --print("msg.share_solt_list "..#msg.share_solt_list)
			self.m_ratingData:setWarShareShopList(msg.share_solt_list)
            self.m_ratingData:setWarShareShopIntegral(msg.jifen)
            self:notifyObservers("onShopItem", 2)
        end
        g_scene:showReward(msg.reward)
    else
        g_scene:handleErrorCode(msg.err_code)
    end
end


------------------------ 军营积分领取奖励请求-----------------------
function This:onGetBarracksScoreAwardRequest(awardId)
    local data = {id=awardId}
    self:sendAndLock(13063, data)
end

------------------------------------------------------------------
function This:onReceiveBarracksScoreAwardsReply(data)
    -- 处理错误码
    if data.err_code ~= 0 then
        g_scene:handleErrorCode(data.err_code)
        return
	end
	
	self.m_ratingData:setRoleScoreReward(data.role_jifen_rewarded)
    -- 处理领取到的奖励
    g_scene:showReward(data.reward)
    self:notifyObservers("onReceiveBarracksScoreAwards", data)
end

-- 军团积分发生改变
function This:onReceiveLegionScoreChangedReply(msg)
    local legion = self.m_legions[msg.group_id]
    legion:setJiFen(msg.jifen)
    self:notifyObservers("onLegionScoreChanged", msg.group_id, msg.jifen)
end
	
function This:onLegionBoxInfoRequest()
	self:sendAndLock(13064)
end

function This:onLegionBoxInfoReply( msg )
    self.m_warBoxId = msg.box_id or 0
	self.m_warBoxAppearCitys = msg.city_list or {}
    self:notifyObservers("onLegionBoxInfo")
end

-- 个人积分箱子
function This:onPickupJifenBoxRequest(rewardId)
	self:sendAndLock(13065, { reward_id=rewardId})
end

function This:onPickupJifenBoxReply( msg )
    if msg.err_code == 0 then
        local box = self.m_jifenBoxList[msg.reward_id]
		if box then
			g_scene:showReward(box:getReward())
        	box:setState(true)
        	self:notifyObservers("onPickupJifenBox")
        end
    else
        g_scene:handleErrorCode(msg.err_code)
    end
end

-- 个人积分特殊箱子
function This:onPickupJifenSpecialBoxRequest()
	self:sendAndLock(13066)
end

function This:onPickupJifenSpecialBoxReply( msg )
    if msg.err_code == 0 then
		self.m_jifenSpecialBoxRewarded = true 
        self:notifyObservers("onPickupJifenSpecialBox")
    else
        g_scene:handleErrorCode(msg.err_code)
    end
end

function This:onGetJinNangInfoNotify( msg )
	if msg then
        local legion = self:getMyLegion()
	    legion:setSilkBagNum(msg.trick_value)
        self:notifyObservers("onGetJinNangInfo")
	else
		g_scene:handleErrorCode("")
	end
end

function This:onGetIntegralNotify( msg )
	if msg then
        self.m_jifen = msg.score
		self.m_scoreDetailList = msg.score_detail_list
        self:notifyObservers("onGetIntegral", msg.score)
	else
		g_scene:handleErrorCode("")
	end
end

function This:onGetIntegralRankInfoReply( msg )
	if msg then
		local rankList, mine = msg.rank_info.list
	    local targetId = GamePlayer:getPlayerID()
	    for i, rankInfo in ipairs(rankList) do
	        if rankInfo.roleid == targetId then
	            mine = rankInfo
	            mine.index = i
				
	        end
	    end
	    self.m_myIntegralRankInfo = mine
    	self.m_jifenRank = mine and mine.index or 0
        self:notifyObservers("onGetIntegralRankInfo", rankList, mine)
	else
		g_scene:handleErrorCode("")
	end
end

function This:onGetLuoYangBuffStateChangeNotify( msg )
	if msg then
		local luoYangOwerId = msg.owner_group_id or 0
		if luoYangOwerId > 0 and luoYangOwerId == self.m_myLegionId then
			self.m_stateEntrys:addOtherEntry(LegionStateEntryType.kSeizedCity)
		else
			self.m_stateEntrys:removeOtherEntry(LegionStateEntryType.kSeizedCity)
		end
		self.m_luoYangOwerId = luoYangOwerId
        self:notifyObservers("onGetLuoYangBuffStateChange")
	end
end

function This:send(cmd, message)
	if g_setting.isDebug and g_setting.isWarTest then
		print("[test]send proto:" .. cmd)
		EventDispatcher:dispatcher(tostring(cmd), message)
		return
	end
	Socket:send(cmd, message)
end

function This:sendAndLock( cmd, message )
	if g_setting.isDebug and g_setting.isWarTest then
		print("[test]send proto:" .. cmd)
		EventDispatcher:dispatcher(tostring(cmd), message)
		return
	end
	Socket:sendAndLock(cmd, message)
end

--endregion
