﻿--region *.lua
--Date
--姝ゆ枃浠剁敱[BabeLua]鎻掍欢鑷姩鐢熸垚

local This , super = class(...,"Base.BaseModel")
local GamePlayer = require("Player.GamePlayer")
local GameUtil = require("Util.GameUtil")
local FamilyManager = require("Family.FamilyManager")
function This:init(info)
	super.init(self)
	self.m_map = info.map
	self.m_id = 0
	self.m_troop = nil
	self.m_fromCity = 0
	self.m_toCity = 0
	self.m_resType = 0
	self.m_resNum = 0
	self.m_endTime = 0
	self.m_startTime = 0
	self.m_addSpeedTime = 0
	self.m_legionId = 0
end

function This:getId()
	return self.m_id
end

function This:getFromCity()
	return self.m_fromCity
end

function This:getToCity()
	return self.m_toCity
end

function This:isOur()
	local myLegionId = FamilyManager:getMyFamilyId()
	if myLegionId then
		return self.m_legionId == myLegionId
	end
	return false
end

function This:getResType()
	return self.m_resType
end

function This:getTransType()
	return self.m_resType
end

function This:getResNum()
	return self.m_resNum
end

function This:getEndTime()
	return self.m_endTime
end

function This:getStartTime()
	return self.m_startTime
end

function This:getLeftTime()
	local curTime = GamePlayer:getServerTime()
	return math.max(0,self.m_endTime - curTime)
end

function This:getAddSpeedTime()
	return self.m_addSpeedTime
end

function This:getHp()
	if self.m_resType == LegionTransType.kHp then
		return self.m_resNum
	end
	return 0
end

function This:getMineral()
	if self.m_resType == LegionTransType.kMineral then
		return self.m_resNum
	end
	return 0
end

function This:getTroop()
	return self.m_troop
end

function This:isMy()
	if self.m_troop then
		return GamePlayer:getPlayerID() == self.m_troop:getRoleId()
	end
	return false
end

function This:isOur()
	if self.m_troop then
		local role = self.m_map:getRole(self.m_troop:getRoleId())
		local legionId = role:getLegionId() 
		return self.m_map:getMyLegion():getId() == legionId
	end
	return false
end

function This:isVisibleOnMap()
	if self:isOur() then
		return true	
	end
	local toCity = self.m_map:getCity(self.m_toCity)
	return toCity:isOur()
end

function This:getMarchFlag()
	if self.m_resType == LegionTransType.kHp then
		local fromCity = self.m_map:getCity(self.m_fromCity)
		local toCity = self.m_map:getCity(self.m_toCity)
		if fromCity:isOur() and toCity:isOur() then
			return "GameScene/yidong.png"
		else
			return "MenuScene/zhengzhan.png"
		end
	else
		return "MenuScene/zhengzhan.png"
	end
end

function This:updateInfo(info)
	self.m_troopId = info.troop_id
	self.m_troop = self.m_map:getTroop(info.troop_id)
	if not self.m_troop then
		print("缺乏队列信息，队列 troop_id = " .. GameUtil:int64ToString(info.troop_id))
		-- assert(false)
	end
	self.m_id = info.id
	self.m_fromCity = info.from_city
	self.m_toCity = info.to_city
	self.m_resType = info.res_type
	self.m_resNum = info.res_num
	self.m_endTime = info.endtime
	self.m_addSpeedTime = info.addspeedtime
	self.m_startTime = info.starttime
	self.m_legionId = info.group_id
	if self.m_troop then
		self.m_troop:setMarch(self)
	end
end

function This:clear()
	if self.m_troop then
		self.m_troop:clearMarch()
	end
end

--endregion
