--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"World.MarchDangerView")
local GameUtil = require("Util.GameUtil")

function This:init(info)
	self.m_marchList = info.marchList
	self.m_map = info.map
	self.m_city = self.m_map:getCity(info.cityId)
	self.m_isLooked = false
	self.m_marchList = info.armyList

	self.m_csNode = cc.Node:createFromCSFile("GameScene/NodeUI/Dangerous.csb")
	self:addChild(self.m_csNode)
	self.m_csNode.name1:setString(self.m_city:getName())

	self:refreshContentSize()
	self.m_effect = GameUtil:createEffect("Warning",true,nil,nil,false)
	self.m_csNode:addChild(self.m_effect)
	local w , h = self:getContentSize()
	self.m_csNode:setPositionY(h/2)
end

function This:addMarch(march)
	if not march:isOur() and march:getToCity() == self.m_city:getId() then
		for i , mh in ipairs(self.m_marchList) do
			if march == mh then
				return
			end
		end
		table.insert(self.m_marchList,march)
	end
end

function This:removeMarch(march)
	for i , mh in ipairs(self.m_marchList) do
		if mh == march then
			table.remove(self.m_marchList,i)
			self:refresh()
			return
		end
	end
end

function This:onEnter()
	cc.Node.onEnter(self)
	self:initTouchEvent()
	self.m_map:addObserver(self)
end

function This:onExit()
	cc.Node.onExit(self)
	self.m_map:removeObserver(self)
end

function This:isCanRemove()
	return #self.m_marchList <= 0 or not self.m_city:isOur()
end

function This:onAddMarch(march)
	self:addMarch(march)
end

function This:onDeleteMarch(march)
	self:removeMarch(march)
end

function This:onCityInfoChanged(city)
	if self.m_city == city then
		self:refresh()
	end
end

--endregion
