﻿-- @Author: ZYY
-- @Date:   2018-08-07 14:59:02
-- @Last Modified by:   superm
-- @Last Modified time: 2018-11-16 18:01:09
-- @File Name: LegionMarchListPanel.lua
-- @Desc: 
local This, super = class(...,"Dialog")
local LegionMarchListItemView = require("Map.LegionMarchListItemView")

function This:initNode(info)
	self.m_map = info.map
    self.m_csNode = cc.Node:createFromCSFile("LegionScene/NodeUI/LegionMarchingList.csb")
    self.m_csNode:setToCenter()
	self:addChild(self.m_csNode)
	self.m_viewList = {}
	self.m_csNode.ScrollView.m_direction = "right"
	self:initItemList()
end

function This:initItemList()
	local marchList = self.m_map:getMarchList()
	for i , march in ipairs(marchList) do
		if march:isMy() then
			local view = LegionMarchListItemView:create({
				march = march,
				map = self.m_map
			})
			self.m_csNode.ScrollView:pushBackCustomItem(view,200,400,0.5)
		end
	end
end

function This:initTouchEvent()
	self.m_csNode.close:setTouchEnded(function()
		self:close()
	end)
end

function This:onEnter()
	super.onEnter(self)
	self.m_map:addObserver(self)
end

function This:onExit()
	super.onExit(self)
	self.m_map:removeObserver(self)
end

------------------------------------------------
function This:onAddMarch(march)
	if march:isMy() then
		local view = LegionMarchListItemView:create({
			march = march
		})
		self.m_csNode.ScrollView:pushBackCustomItem(view,200,400,0)
	end
end

function This:onDeleteMarch(march)
	if march:isMy() then
		local itemList = self.m_csNode.ScrollView:getItemList()
		for i , view in ipairs(itemList) do
			if view:getModel() == march then
				self.m_csNode.ScrollView:removeItem(i)
				return
			end
		end
	end
end