--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"World.MarchArmyPathView")
local Vec = require("Vec")
-- local GameUtil = require("Util.GameUtil")
-- local GamePlayer = require("Player.GamePlayer")
local MarchPaoTuView = require("World.MarchPaoTuView")
-- local PaoMaEffect = 
-- {
-- 	[1] = {name = "zuo", isFlipX = true},
-- 	[2] = {name = "xieshang", isFlipX = true},
-- 	[3] = {name = "shang", isFlipX = false},
-- 	[4] = {name = "xieshang", isFlipX = false},
-- 	[5] = {name = "zuo", isFlipX = false},
-- 	[6] = {name = "xiexia", isFlipX = false},
-- 	[7] = {name = "xia", isFlipX = false},
-- 	[8] = {name = "xiexia", isFlipX = true},
-- }

function This:init(info)
	self.m_army = info.march
	self.m_map = info.map
	self.m_scene = g_scene

	self.m_spriteList = {}
	self.m_transType = self.m_army:getTransType()
	self.m_file = self:getPathImage()
	self.m_startTime = self.m_army:getStartTime()
	self.m_endTime = self.m_army:getEndTime()
	self.m_escape = 0

	local fromView = self.m_scene:getCityNode(self.m_army:getFromCity())
	local x1 , y1 = fromView:getPosition()
	local toView = self.m_scene:getCityNode(self.m_army:getToCity())
	local x2 , y2 = toView:getPosition()
	self.m_sv = cc.Vec(x1,y1)
	self.m_ev = cc.Vec(x2,y2)

	local info = {startTime = self.m_startTime,endTime = self.m_endTime,
		toNode = toView,fromNode = fromView,runAnim = false,configId = 1}

	self.m_paoma = MarchPaoTuView:create(info)
	self.m_scene:addMarchPaoMaEffect(self.m_paoma,self:getModel())

	self:initMarchPath(self.m_file,x1,y1,x2,y2,nil)
	self:updateSpeed()
	self:scheduleUpdate()
end

-- function This:updateSpeed()
-- 	local curTime = GamePlayer:getServerTime()
-- 	local x, y = self.m_paoma:getPosition()
-- 	local v = self.m_ev - cc.Vec(x,y)
-- 	local len = v:length()
-- 	local unit = v:getNormalize()
-- 	local time = self.m_army:getEndTime() - curTime
-- 	self.m_speed = unit * (len / time)
-- end

-- function This:getPaoMaPosition()
--     if self.m_paoma then
--     	return self.m_paoma:getPosition()
--     end
--     return self:getPosition()
-- end

-- function This:getConfigWithDegree(degree)
-- 	if degree < 0 then
-- 		degree = 360 + degree
-- 	end
-- 	for i , config in ipairs(PaoMaEffect) do
-- 		if degree <= i * 45 - 22.5 then
-- 			return config
-- 		end
-- 	end
-- 	return PaoMaEffect[1]
-- end

-- function This:initMarchPath(file,x1,y1,x2,y2,radio)
-- 	super.initMarchPath(self,file,x1,y1,x2,y2)
-- 	local v = cc.Vec(x2 - x1, y2 - y1)
-- 	local v1 = v * radio
-- 	local degree = v:getDegree()
-- 	local config = self:getConfigWithDegree(degree)
	
-- 	self.m_paoma = GameUtil:createEffect("PaoTu",true)
-- 	self.m_paoma:setFlippedX(config.isFlipX)
-- 	self.m_paoma:setPosition(x1 + v1.x, y1 + v1.y)
-- 	self.m_paoma:playAnimation(config.name,true)
-- 	self.m_scene:addMarchPaoMaEffect(self.m_paoma,self.m_army)
-- end

function This:getPathImage()
	if self.m_transType == LegionTransType.kHp or self.m_transType == 0 then
		local fromCity = self.m_map:getCity(self.m_army:getFromCity())
		local toCity = self.m_map:getCity(self.m_army:getToCity())
		if fromCity:isOur() == toCity:isOur() or (self.m_army:isOur() and toCity:isOur()) then
		-- if self.m_army:isOur() then
			return "Common/yunshu.png"
		else
			return "Common/gongji.png"
		end
	elseif self.m_transType == LegionTransType.kMineral then
		return "Common/zhiyuan.png"
	end
end

function This:getModel()
	return self.m_army
end

function This:getMarchName()
	return "PaoTu"
end

-- function This:refresh()
-- 	local file = self:getPathImage()
-- 	if file ~= self.m_file then
-- 		for i , sprite in ipairs(self.m_spriteList) do
-- 			sprite:setImage(file)
-- 		end
-- 		self.m_file = file
-- 	end
-- end

-- function This:onEnter()
-- 	super.onEnter(self)
-- 	self.m_map:addObserver(self)
-- end

-- function This:onExit()
-- 	super.onExit(self)
-- 	self.m_map:removeObserver(self)
-- end

-- function This:update(dt)
-- 	self.m_escape = self.m_escape + dt
-- 	local x , y = self.m_paoma:getPosition()
-- 	x = x + self.m_speed.x * dt
-- 	y = y + self.m_speed.y * dt
-- 	self.m_paoma:setPosition(x,y)
-- end

----------------------------------------------------------
function This:onCityInfoChanged(city)
	if self.m_army:getToCity() == city:getId() then
		self:refresh()
	end
end

function This:onUpdateMarch(march)
	if self.m_army == march then
		self:updateSpeed()
	end
end

--endregion
