﻿--region *.lua
--Date
--姝ゆ枃浠剁敱[BabeLua]鎻掍欢鑷姩鐢熸垚

local This , super = class(...,"World.MarchArmyView")
local GamePlayer = require("Player.GamePlayer")
local GameUtil = require("Util.GameUtil")

function This:init(info)
	self.m_march = info.march
	self.m_map = info.map
	self.m_escape = 0
	self.m_csNode = cc.Node:createFromCSFile("LegionScene/NodeUI/LegionMarchingItem.csb")
	self:addChild(self.m_csNode)
	self.m_fromCity = self.m_map:getCity(self.m_march:getFromCity())
	self.m_toCity = self.m_map:getCity(self.m_march:getToCity())
	self.m_csNode.target:setString(self.m_toCity:getName())
end

function This:getImage()
	return self.m_map:getMarchFlag()
end

function This:onEnter()
	super.onEnter(self)
	self:refresh()
	self:scheduleUpdate()
	self.m_map:addObserver(self)
end

function This:onExit()
	super.onExit(self)
	self.m_map:removeObserver(self)
end

function This:getModel()
	return self.m_march
end

function This:refresh()
	-- if self.m_toCity:isFighting() then
	-- 	self.m_csNode.inwar:setVisible(true)
	-- 	self.m_csNode.costtime:setVisible(false)
	-- else
		local leftTime = self.m_march:getLeftTime()
		self.m_csNode.costtime:setString(GameUtil:formatTime(Serialize["H_M_S"],leftTime))
		self.m_csNode.inwar:setVisible(false)
		self.m_csNode.costtime:setVisible(true)
	-- end
end

-----------------------------------------------------
function This:onCityInfoChanged(city)
	if self.m_march:getToCity() == city:getId() then
		self:refresh()
	end
end

function This:update(dt)
	self.m_escape = self.m_escape + dt
	if self.m_escape < 1 then
		return
	end
	self.m_escape = self.m_escape - 1
	self:refresh()
end

--endregion
