--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"Base.BaseModel")
local LegionTechnologyConfig = require("Metadatas.LegionTechnologyConfig")
local GamePlayer = require("Player.GamePlayer")

function This:init(info)
	super.init(self)
	self.m_buildType = info.buildType
	self.m_techType = info.techType
	self.m_maxLevel = info.maxLevel
	self.m_map = info.map
	self.m_attrValue = {}
	self:setLevel(info.initLevel)
end

function This:getId()
	return self.m_config.id
end

function This:getConfigId(level)
	return self.m_buildType * 10000 + self.m_techType * 100 + level
end

function This:getTechType()
	return self.m_techType
end

function This:getBuildType()
	return self.m_buildType
end

function This:getLevel()
	return self.m_level
end

function This:setLevel(level)
	if self.m_level ~= level then
		self.m_level = level
		local configId = self:getConfigId(self.m_level)
		self.m_config = LegionTechnologyConfig[configId]
		if not self.m_config then
			print("techn config not found, id:" .. tostring(configId))
		end
		self.m_attrValue = {}
		for i , info in ipairs(self.m_config.arg) do
			self.m_attrValue[info[1]] = info[2]
		end
	end
end

function This:getName()
	return self.m_config.technology_name
end

function This:getDesc()
	return self.m_config.technology_dec
end

function This:getImage()
	if self.m_config.pictur ~= "" then
		return self.m_config.pictur
	end
	return "MenuScene/build_10.png"
end

function This:getMaxLevel()
	return self.m_maxLevel
end

function This:setMaxLevel(maxLevel)
	self.m_maxLevel = maxLevel
end

function This:getAttrList(level)
	local configId = self:getConfigId(level)
	local config = LegionTechnologyConfig[configId] or {}
	local result = {}
	for i , info in ipairs(config.arg) do
		local t = {
			attrId = info[1],
			value = info[2]
		}
		table.insert(result,t)
	end
	return result
end

function This:getTechAttrValue(techAttrType)
	return self.m_attrValue[techAttrType] or 0
end

function This:updateInfo(info)
	self:setLevel(info.level)
end

--endregion
