--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"Dialog")
local LegionTechTroopItemView = require("Map.LegionTechTroopItemView")
local LegionTechnologyBuildConfig = require("Metadatas.LegionTechnologyBuildConfig")
local GamePlayer = require("Player.GamePlayer")

function This:initNode(info)
	self.m_map = info.map
	self.m_city = info.city
	self.m_pos = info.pos
	self.m_csNode = cc.Node:createFromCSFile("LegionScene/NodeUI/LegionTechnology.csb")
	self:addChild(self.m_csNode)
	self.m_csNode:setToCenter()
	self:initBaseInfo()
	self:initItemViewList()
	self:selectAddSpeedItem(1)
end

function This:initBaseInfo()
	for i = 1 , 3 do
		local config = LegionTechnologyBuildConfig[i]
		self.m_csNode["button"..i].text1:setString(string.format(Serialize[61828],config.time / 60))
		self.m_csNode["button"..i].text2:setString(string.format(Serialize[61829],config.value))
	end
end

function This:createItemView(biandui)
	local view = LegionTechTroopItemView:create({
		map = self.m_map,
		city = self.m_city,
		biandui = biandui
	})
	view:setSelectHandler(function(biandui)
		self:selectItemView(view)
	end)
	return view
end

function This:selectItemView(view)
	if self.m_curView then
		if self.m_curView == view then
			self.m_curView:setIsSelected(false)
			self.m_curView = nil
		else
			self.m_curView:setIsSelected(false)
			self.m_curView = view 
			self.m_curView:setIsSelected(true)
		end
	else
		self.m_curView = view
		self.m_curView:setIsSelected(true)
	end
end

function This:initItemViewList()
	local bianduis = self.m_map:getAllBianDui()
	for index , biandui in pairs(bianduis) do
		if not biandui:isEmpty() then
			local view = self:createItemView(biandui)
			self.m_csNode.scrollview:pushBackCustomItem(view,450,80,0.5)
		end
	end
end

function This:selectAddSpeedItem(index)
	self.m_curConfig = LegionTechnologyBuildConfig[index]
	self.m_csNode.jiasubutton.num:setString(self.m_curConfig.cost)
	for i = 1 , 3 do
		self.m_csNode["button"..i].choose:setVisible(i == index)
	end
end

function This:initTouchEvent()
	self.m_csNode.closebutton:setTouchEnded(function()
		self:close()
	end)
	self.m_csNode.jiasubutton:setTouchEnded(function()
		if not self.m_curView then
			g_scene:showTips(Serialize[61830])
			return 
		end
		GamePlayer:costDiamond({
			desc = Serialize["legion_war_build_speed_tip"],
			cost = self.m_curConfig.cost,
			okHandler = function()
				local biandui = self.m_curView:getModel()
				self.m_map:onCityUpgradeAddSpeedRequest(self.m_city:getId(),
					self.m_pos,
					biandui:getPos(),
					self.m_curConfig.solt,
					true
				)
				self:close()
			end
		})
	end)
	self.m_csNode.shengjibutton:setTouchEnded(function()
		if not self.m_curView then
			g_scene:showTips(Serialize[61830])
			return 
		end
		local biandui = self.m_curView:getModel()
		self.m_map:onCityUpgradeAddSpeedRequest(self.m_city:getId(),
			self.m_pos,
			biandui:getPos(),
			self.m_curConfig.solt,
			false
		)
		self:close()
	end)
	for i = 1 , 3 do
		self.m_csNode["button"..i]:setTouchEnded(function()
			self:selectAddSpeedItem(i)
		end)
	end
end



--endregion
