--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"cc.Node")
local GamePlayer = require("Player.GamePlayer")
local GameUtil = require("Util.GameUtil")

function This:init(info)
	self.m_biandui = info.biandui
	self.m_city = info.city
	self.m_map = info.map
	self.m_csNode = cc.Node:createFromCSFile("LegionScene/NodeUI/Technologylist.csb")
	self:addChild(self.m_csNode)
	self:setIsSelected(false)
	self.m_escape = 0
end

function This:refresh()
	local troop = self.m_biandui:getTroop()
	local card = troop:getCard(1)
	local fightPower = self.m_biandui:getFightPower()
	self.m_csNode.icon:setImage(card:getIcon())
	self.m_csNode.buduiname:setString(self.m_biandui:getName())
	self.m_csNode.zhanli:setString(string.format(Serialize[61832],fightPower))
	
	local state = troop:getState()
	local cityId = troop:getCityId()
	if cityId > 0 then
		local city = self.m_map:getCity(cityId)
		self.m_csNode.zhuangtai:setString(string.format("%s-%s",city:getName(),LegionTroopStateText[state]))
	else
		self.m_csNode.zhuangtai:setString(LegionTroopStateText[state])
	end
	local minFightPower = self.m_map:getMinJianSheDuFightPower()
	self.m_csNode.gouxuan:setVisible(fightPower >= minFightPower and state == LegionTroopState.kIdle)
	self.m_csNode.time:setVisible(state == LegionTroopState.kTechAddSpeed)
	self:refreshTime()
end

function This:refreshTime()
	local curTime = GamePlayer:getServerTime()
	local troop = self.m_biandui:getTroop()
	local endTime = self.m_city:getAddSpeedEndTime(troop:getId())
	local state = troop:getState()
	if state == LegionTroopState.kTechAddSpeed and curTime <= endTime then
		self.m_csNode.time:setString(GameUtil:formatTime(Serialize["H_M_S"], math.max( endTime - curTime,0)))
		self.m_csNode.time:setVisible(true)
		self:scheduleUpdate()
	else
		self.m_csNode.time:setVisible(false)
	end
end

function This:initTouchEvent()
	self.m_csNode.gouxuan:setTouchEnded(function()
		local troop = self.m_biandui:getTroop()
		if troop:getState() ~= LegionTroopState.kIdle then
			g_scene:showTips(Serialize[61833])
			return 
		end
		local isVisible = self.m_csNode.gouxuan.duihao:isVisible()
		self.m_csNode.gouxuan.duihao:setVisible(not isVisible)
		if self.m_selectHandler then
			self.m_selectHandler(self.m_biandui)
		end
	end)
end

function This:setSelectHandler(handler)
	self.m_selectHandler = handler
end

function This:setIsSelected(isSelected)
	self.m_csNode.gouxuan.duihao:setVisible(isSelected)
end

function This:onEnter()
	super.onEnter(self)
	self:refresh()
	self:initTouchEvent()
end

function This:onExit()
	super.onExit(self)
end

function This:getModel()
	return self.m_biandui
end

function This:update(dt)
	self.m_escape = self.m_escape + dt
	if self.m_escape < 1 then
		return 
	end
	self.m_escape = self.m_escape - 1
	self:refresh()
end

--endregion
