--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"Base.BaseModel")
local LegionCard = require("Map.LegionCard")
local GamePlayer = require("Player.GamePlayer")
local FamilyManager = require("Family.FamilyManager")
local LegionCityConfig = require("Metadatas.LegionCityConfig")
local EventDispatcher = require("EventDispatcher")
local HeroManager = require("Hero.HeroManager")
local EventDispatcher = require("EventDispatcher")
local ArgConfig = require("Metadatas.ArgConfig")
local LegionDefenseNpcConfig = require("Metadatas.LegionDefenseNpcConfig")
local HeroNpcConfig = require("Metadatas.HeroNpcConfig")
local BehaviorConfig = require("Metadatas.BehaviorConfig")
local LegionTechnologyConfig = require("Metadatas.LegionTechnologyConfig")
local LegionChangeLevelConfig = require("Metadatas.LegionChangeLevelConfig")
local LegionTechnologyBuildConfig = require("Metadatas.LegionTechnologyBuildConfig")

local ObjID = 10001

function This:init(map)
	self.m_map = map
	self.m_mapId = 0
	self.m_mapType = 0
	self.m_mapLevel = 0
	self.m_fightTime = 0
	self.m_citys = {}
	self.m_legions = {}
	self.m_troops = {}
	self.m_marchs = {}
	self.m_junces = {}
	self.m_geren = {}
	self.m_escape = 0
	self:initListener()
end

function This:initListener()
	EventDispatcher:addListener(self,"13000",self.onGetMapInfoRequest)
	EventDispatcher:addListener(self,"13004",self.onUpdateBianDuiRequest)
	EventDispatcher:addListener(self,"13005",self.onAddHpRequest)
	EventDispatcher:addListener(self,"13006",self.onUndoAddHpRequest)
	EventDispatcher:addListener(self,"13007",self.onAddHpSpeedRequest)
	EventDispatcher:addListener(self,"13012",self.onClearTroopHpRequest)
	EventDispatcher:addListener(self,"13009",self.onCreateMarchRequest)
	EventDispatcher:addListener(self,"13016",self.onMarchAddSpeedRequest)
	EventDispatcher:addListener(self,"13014",self.onClearChengFangCreateTimeRequest)
	EventDispatcher:addListener(self,"13015",self.onTrainChengFangOnceKeyRequest)
	EventDispatcher:addListener(self,"13017",self.onRebuildCityRequest)
	EventDispatcher:addListener(self,"13018",self.onRemoveCityBuildRequest)
	EventDispatcher:addListener(self,"13019",self.onUpgradeTechRequest)
	EventDispatcher:addListener(self,"13020",self.onChangeTechStateRequest)
	EventDispatcher:addListener(self,"13028",self.onUseLegionJunCeRequest)

end

function This:removeListener()
	EventDispatcher:removeListener(self,"13000")
	EventDispatcher:removeListener(self,"13004")
	EventDispatcher:removeListener(self,"13005")
	EventDispatcher:removeListener(self,"13006")
	EventDispatcher:removeListener(self,"13007")
	EventDispatcher:removeListener(self,"13012")
	EventDispatcher:removeListener(self,"13009")
	EventDispatcher:removeListener(self,"13014")
	EventDispatcher:removeListener(self,"13015")
	EventDispatcher:removeListener(self,"13017")
	EventDispatcher:removeListener(self,"13018")
	EventDispatcher:removeListener(self,"13019")
	EventDispatcher:removeListener(self,"13020")
	EventDispatcher:removeListener(self,"13028")

	cc.Application:removeFromUpdateList(self)
end

function This:createUid()
	local uid = ObjID
	ObjID = ObjID + 1
	return uid
end


function This:createRole()
	local role = {}
	local base = {}
	base.id = self:createUid()
	base.name = "role" 
end

function This:createMap()
	print("--------createMap-------")
	self.m_mapId = self:createUid()
	self.m_mapType = 1
	self.m_mapLevel = 1
	self.m_fightTime = GamePlayer:getServerTime() - 3600

	local legionIdList = {}
	for i = 1, 4 do
		local legion = {}
		if i== 1 then
			legion.group_id = FamilyManager:getMyFamilyId()or 0
		else
			legion.group_id = self:createUid()
		end
		legion.group_name = "group"..i
		legion.group_title = ""
		legion.group_jifen = math.random(100,1000)
		legion.trick_value = math.random(3,10) * 100

		local role_list = {}
		for j = 1 , 10 do
			local role = {}
			local base = {}
			if i == 1 and j == 1 then
				base.id = GamePlayer:getPlayerID()
			else
				base.id = self:createUid()
			end
			base.name = "role-" .. i .. "-" .. j
			base.icon = 1
			base.cur_rank_level = math.random(1,15)
			base.vip_list = {}
			role.base = base
			role.group_id = legion.group_id
			role.group_office = 1
			table.insert(role_list,role)
		end
		legion.role_list = role_list
		self.m_legions[legion.group_id] = legion
		table.insert(legionIdList,legion.group_id)
	end


	local index = 1

	for i , config in pairs(LegionCityConfig) do
		if config.type == 1 and config.initial_change_tpye == 1 then
			local openList = {}
			local tmp = {} 
			table.insert(openList,config.city_id)
			tmp[config.city_id] = true
			print("group id:" .. legionIdList[index])
			print("main city id:" .. config.city_id)
			self.m_legions[legionIdList[index]].main_city = config.city_id
			while #openList > 0 do
				local cityId = openList[1]
				table.remove(openList,1)
				local cfg = LegionCityConfig[cityId]
				local city = {}
				city.city_id = cityId
				city.build_type = cfg.initial_change_tpye
				city.group_id = legionIdList[index]
				if city.city_id == 101 then
					assert(true)
				end
				if city.build_type == LegionBuildType.kBarracks then
					city.res_type = LegionTransType.kHp
				elseif city.build_type == LegionBuildType.kWarehouse then
					city.res_type = LegionTransType.kMineral
				elseif city.build_type == LegionBuildType.kMintage then
					city.res_type = LegionTransType.kMineral
				end
				city.res_num = 10000
				city.level = math.random(1,5)
				if city.build_type == LegionBuildType.kArrowTower or city.build_type == LegionBuildType.kBoltTower then
					city.damage = math.random(10,100)
				else
					city.damage = 0
				end

				city.state = LegionCityState.kNormal
				city.guard_troop_list = {}
				city.fill_force_troop_list = {}
				city.attack_troop_list = {}

				city.tech_list = {}
				city.cf_list = {}
				city.cf_next_time = GamePlayer:getServerTime() + 1000
				city.tech_state = LegionBuildState.kNormal
				city.jianshedu = 0
				city.troop_list = {}

				local levelconfig = LegionChangeLevelConfig[city.build_type * 100 + 1]
				for i , info in ipairs(levelconfig.technology) do
					city.tech_list[i] = {
						tech_type = info[1],
						level = 1,
						-- jianshedu = 0,
						-- state = LegionTechState.kNormal,
						-- troop_list = {}
					}
				end

				self.m_citys[city.city_id] = city

				for i , id in ipairs(config.neighborhood) do
					if not tmp[id] and LegionCityConfig[id].initial_change_tpye > 0 then
						table.insert(openList,id)
						tmp[id] = true
					end
				end
			end
			index = index + 1
		end
	end
	for i , config in pairs(LegionCityConfig) do
		if config.type == 1 and not self.m_citys[config.city_id] then
			local city = {}
			city.city_id = config.city_id
			city.build_type = config.initial_change_tpye
			city.group_id = 0
			city.res_type = 0
			city.res_num = 0
			city.level = 1
			city.damage = 0
			city.state = LegionCityState.kNormal
			city.guard_troop_list = {}
			city.fill_force_troop_list = {}
			city.attack_troop_list = {}
			city.tech_state = LegionBuildState.kNormal
			city.jianshedu = 0
			city.troop_list = {}
			city.tech_list = {}
			city.cf_list = {}
			city.cf_next_time = 0
			self.m_citys[city.city_id] = city
		end
	end

	for i , legion in pairs(self.m_legions) do
		if legion.group_name == "group1" then
			self.m_citys[118].group_id = legion.group_id
			self.m_citys[118].build_type = LegionBuildType.kArrowTower
		elseif legion.group_name == "group2" then
			self.m_citys[119].group_id = legion.group_id
		end
	end
	
	self.m_geren.max_count = 3
	self.m_geren.biandui_list = {}
	self.m_geren.food = 20000
	self.m_geren.coin = 20000
	self.m_geren.ore = 20000
	self.m_geren.group_id = FamilyManager:getMyFamilyId()

	self.m_geren.junce_list = {}
	self.m_geren.score = 0
	self.m_geren.scorereward_list = {}
end

function This:createMyTreamTroop(cardList,teamIndex,name)
	local troop = {}
	troop.id = self:createUid()
	troop.role_id = GamePlayer:getPlayerID()
	troop.city_id = cityId or 0
	troop.state = LegionTroopState.kIdle
	troop.type = 0
	troop.add_speed_time = 0
	troop.endtime = 0
	local card_list = {}
	for i , uid in ipairs(cardList) do
		local hero = HeroManager:getHeroByUid(uid)
		local card = {}
		card.id = uid
		card.card_type = hero:getId()
		card.star = hero:getStarLv()
		card.level = hero:getLevel()
		card.fight_power = hero:getFightPower()
		card.pos = i
		card.hp = 0
		card.max_hp = hero:getAttr(AttrType.kMaxHp)
		card.res_type = 0
		card.res_num = 0
		table.insert(card_list,card)
	end
	troop.card_list = card_list
	return troop
end

function This:updateMyTeamTroop(info)
	local biandui = self.m_geren.biandui_list[info.index]
	local troop = self.m_troops[biandui.troop_id]

	troop.role_id = info.roleId or troop.role_id
	troop.city_id = info.cityId or troop.city_id
	troop.state = info.state or troop.state
	troop.type = info.type or troop.type
	troop.add_speed_time = info.addSpeedTime or troop.add_speed_time
	troop.endtime = info.endtime or troop.endtime
	troop.city_id = info.cityId or troop.city_id
	troop.card_list = {}
	for i ,  card in ipairs(info.cardList) do
		local hero = HeroManager:getHeroByUid(card.id)
		troop.card_list[i] = {
			card_type = hero:getId(),
			star = hero:getStarLv(),
			level = hero:getLevel(),
			fight_power = hero:getFightPower(),
			pos = i,
			hp = card.hp,
			max_hp = hero:getAttr(AttrType.kMaxHp),
			res_type = card.res_type,
			res_num = card.res_num
		}
	end 
	return troop
end

function This:changeCityState(cityId,state)
	local city = self.m_citys[cityId]
	if city.state ~= state then
		city.state = state
		self:onUpdateCityNotify(cityId)
	end
end

function This:changeCityOnwer(cityId,legionId)
	local city = self.m_citys[cityId]
	if city.legionId ~= legionId then
		city.group_id = legionId
		self:onUpdateCityNotify(cityId)
	end
end

function This:changeCityToOur(cityId,legionName)
	local city = self.m_citys[cityId]
	local legionId = FamilyManager:getMyFamilyId()
	for i , legion in pairs(self.m_legions) do
		if legion.group_name == legionName then
			legionId = legion.group_id
			break
		end
	end
	city.group_id = legionId
	self:onUpdateCityNotify(cityId)
end

function This:changeCityToMy(cityId)
	local legionId = FamilyManager:getMyFamilyId()
	self:changeCityOnwer(cityId,legionId)
end

function This:createEnemyMarch(info)
	local city = self.m_citys[info.from_city]
	if city.group_id == 0 or city.group_id == self.m_geren.group_id then
		return
	end
	
	local legion = self.m_legions[city.group_id]
	local role = legion.role_list[1]
	
	local cardList = {}
	for i = 1 , 6 do
		cardList[i] = {
			id = self:createUid(),
			card_type = 1001 + i,
			star = 1,
			level = 10,
			fight_power = 1000,
			pos = i,
			hp = 2000,
			max_hp = 2000,
			res_type = 0,
			res_num = 0
		}
	end

	local troop = {
		id = self:createUid(),
		role_id = role.base.id,
		city_id = info.from_city,
		state = LegionTroopState.kDefensive,
		type = LegionTroopType.kRoleTroop,
		add_speed_time = 0,
		endtime = 0,
		card_list = cardList
	}
	self.m_troops[troop.id] = troop
	self:onUpdateTroopNotify({troop})
	
	local march = {
		id = self:createUid(),
		troop_id = troop.id,
		from_city = info.from_city,
		to_city = info.to_city,
		res_type = info.transType,
		res_num = info.resNum,
		endtime = GamePlayer:getServerTime() + 120,
		addspeedtime = 0,
	}
	self.m_marchs[march.id] = march
	self:onMarchChangedNotify({march},{})
end


-------------------------------------------------------------------------

function This:onGetMapInfoRequest(msg)
	local map = {}
	map.id = self.m_mapId
	map.map_type = self.m_mapType
	map.map_level = self.m_mapLevel
	map.fight_time = self.m_fightTime
	local cityList = {}
	for i , city in pairs(self.m_citys) do
		table.insert(cityList,city)
	end
	map.city_list = cityList
	local troopList = {}
	for i , troop in pairs(self.m_troops) do
		table.insert(troopList,troop)
	end
	map.troop_list = troopList
	local groupList = {}
	for i , group in pairs(self.m_legions) do
		table.insert(groupList,group)
	end
	map.group_list = groupList
	map.quit_group_list = {}

	local marchList = {}
	for i , march in pairs(self.m_marchs) do
		table.insert(marchList,march)
	end
	map.march_list = marchList

	local junceList = {}
	for _, junce in pairs(self.m_junces) do
		table.insert(junceList,junce)
	end
	map.junce_list = junceList
	map.box_city_list = {}

	map.geren = self.m_geren

	EventDispatcher:dispatcher(13000,{
		err_code = 0,
		map = map
	})
	cc.Application:addToUpdateList(self)
end

function This:onUpdateTroopNotify(updateList,deleteList)
	local updateTroop = {}
	for i , data in ipairs(updateList) do
		table.insert(updateTroop,data)
	end
	EventDispatcher:dispatcher(13001,{
		update_troop_list = updateTroop,
		delete_troop_list = deleteList or {}
	})
end

function This:onUpdateBianDuiRequest(msg)
	local biandui = self.m_geren.biandui_list[msg.index]
	local troop = nil
	if not biandui then
		troop = self:createMyTreamTroop(msg.card_list,msg.index,msg.name)
		self.m_troops[troop.id] = troop
		self.m_geren.biandui_list[msg.index] = {
			troop_id = troop.id,
			name = msg.name,
			pos = msg.index
		}
		self:onUpdateTroopNotify({troop},{})
	else
		local cardList = {}
		for i , uid in ipairs(msg.card_list) do
			table.insert(cardList,{
				id = uid,
				hp = 0
			})
		end
		troop = self:updateMyTeamTroop({
			cardList = cardList,
			index = msg.index,
			name = msg.name
		})
		local biandui = self.m_geren.biandui_list[msg.index]
		biandui.pos = msg.index
		biandui.name = msg.name
		self:onUpdateTroopNotify({troop},{})
	end
	EventDispatcher:dispatcher(13004,{
		err_code = 0,
		biandui_info = self.m_geren.biandui_list[msg.index]
	})
end

function This:onAddHpRequest(msg)
	local biandui = self.m_geren.biandui_list[msg.index]
	local troop = self.m_troops[biandui.troop_id]
	local troopCardList = troop.card_list

	local cardList = {}
	for i , uid in ipairs(msg.card_list) do
		table.insert(cardList,{
			id = uid,
			hp = troopCardList[i].hp,
			res_num = msg.hp_list[i],
			res_type = msg.res_type
		})
	end

	self:updateMyTeamTroop({
		cardList = cardList,
		endtime = GamePlayer:getServerTime() + 600,
		state = LegionTroopState.kAddHp,
		index = msg.index,
		state = LegionTroopState.kAddHp,
		cityId = msg.city_id
	})
	self:onUpdateTroopNotify({troop})
	EventDispatcher:dispatcher(13005,{
		err_code = 0,
		index = msg.index
	})
end

function This:onUndoAddHpRequest(msg)
	local troopId = self.m_geren.biandui_list[msg.index].troop_id
	local troop = self.m_troops[troopId]
	local cardList = {}
	for i , info in ipairs(troop.card_list) do
		info.res_type = 0
		info.res_num = 0
	end
	troop.endtime = 0
	troop.state = LegionTroopState.kIdle
	troop.add_speed_time = 0
	self:onUpdateTroopNotify({troop})
	EventDispatcher:dispatcher(13006,{
		err_code = 0,
		index = msg.index
	})
end

function This:onAddHpSpeedRequest(msg)
	local troopId = self.m_geren.biandui_list[msg.index].troop_id
	local troop = self.m_troops[troopId]
	local curTime = GamePlayer:getServerTime() 
	troop.endtime = curTime + (troop.endtime - curTime) / 2
	troop.add_speed_time = troop.add_speed_time + 1
	self:onUpdateTroopNotify({troop})
	EventDispatcher:dispatcher(13007,{
		err_code = 0,
		index = msg.index
	})
end

function This:onClearTroopHpRequest(msg)
	local troopId = self.m_geren.biandui_list[msg.index].troop_id
	local troop = self.m_troops[troopId]
	if troop.state ~= LegionTroopState.kDefensive then
		assert(false)
	end
	troop.state = LegionTroopState.kIdle
	for i , card in ipairs(troop.card_list) do
		card.hp = 0
		card.res_type = 0
		card.res_num = 0
	end
	self:onUpdateTroopNotify({troop})
	EventDispatcher:dispatcher(13012,{
		err_code = 0,
		index = index
	})
end

function This:onAddHpFinishNotify(index)
	local troopId = self.m_geren.biandui_list[index].troop_id
	local troop = self.m_troops[troopId]
	troop.endtime = 0
	troop.state = LegionTroopState.kDefensive
	troop.add_speed_time = 0

	for i , card in ipairs(troop.card_list) do
		if card.res_type == LegionTransType.kHp then
			card.hp = card.res_num
			card.res_type = 0
			card.res_num = 0
		end
	end
	
	self:onUpdateTroopNotify({troop})
	EventDispatcher:dispatcher(13008,{
		index = index
	})
end

function This:onCreateMarchRequest(msg)
	local troopId = self.m_geren.biandui_list[msg.index].troop_id
	local troop = self.m_troops[troopId]
	troop.state = LegionTroopState.kMarch
	troop.city_id = 0

	local march = {}
	march.id = self:createUid()
	march.troop_id = troopId
	march.from_city = msg.from_city
	march.to_city = msg.to_city
	march.res_type = msg.res_type

	local total = 0
	local cardList = troop.card_list
	for i , num in ipairs(msg.res_list) do
		total = total + num
		cardList[i].res_num = num
		cardList[i].res_type = msg.res_type
	end
	march.res_num = total
	march.endtime = GamePlayer:getServerTime() + 300
	march.addspeedtime = 0
	self.m_marchs[march.id] = march

	self:onUpdateTroopNotify({troop})
	self:onMarchChangedNotify({march},{})

	EventDispatcher:dispatcher(13009,{
		err_code = 0,
		march_id = march.id
	})
end

function This:onMarchAddSpeedRequest(msg)
	local march = self.m_marchs[msg.march_id]
	local curTime = GamePlayer:getServerTime()
	march.endtime = curTime + (march.endtime - curTime)/2
	march.addspeedtime = march.addspeedtime + 1
	self:onMarchChangedNotify({march})

	EventDispatcher:dispatcher(13016,{
		err_code = 0,
		march_id = march.id
	})
end

function This:onMarchChangedNotify(updateList,arrieveList)
	EventDispatcher:dispatcher(13010,{
		update_march_list = updateList,
		arrive_march_list = arrieveList or {}
	})
end

function This:onMarchFinishNotify(marchId)
	local march = self.m_marchs[marchId]
	local troop = self.m_troops[march.troop_id]
	if march.res_type == LegionTransType.kHp then
		troop.state = LegionTroopState.kDefensive
		troop.city_id = march.to_city
	else
		troop.state = LegionTroopState.kIdle
		troop.city_id = 0
		for i , card in ipairs(troop.card_list) do
			card.res_num = 0
			card.res_type = 0
		end
	end
	self.m_marchs[marchId] = nil

	self:onUpdateTroopNotify({troop})

	local city = self.m_citys[march.from_city]
	table.insert(city.guard_troop_list,troop.id)
	self:onUpdateCityNotify(city.city_id)

	self.m_marchs[marchId] = nil
	self:onMarchChangedNotify({},{marchId})
end

function This:onUpdateCityNotify(cityId)
	local city = self.m_citys[cityId]
	EventDispatcher:dispatcher(13002,{
		city = city
	})
end

function This:createNewChengFang(cityId)
	local city = self.m_citys[cityId]
	local configId = self.m_mapType * 1000 + self.m_mapLevel
	local config = LegionDefenseNpcConfig[configId]

	local cardList = {}
	for i , info in ipairs(config.hero) do
		local cfg1 = HeroNpcConfig[info[1]]
		local cfg2 = BehaviorConfig[info[2]]
		local card = {
			id = self:createUid(),
			card_type = cfg2.hero_id,
			star = 1,
			level = cfg1.level,
			fight_power = 100,
			pos = i,
			hp = cfg1.kMaxHp,
			max_hp = cfg1.kMaxHp,
			final_hp = 0
		}
		cardList[i] = card
	end
	
	local troop = {
		id = self:createUid(),
		role_id = GamePlayer:getPlayerID(),
		city_id = cityId,
		state = LegionTroopState.kDefensive,
		type = LegionTroopType.kChengFang,
		add_speed_time = 0,
		endtime = 0,
		card_list = cardList
	}

	local chengfang = {
		 config_id = configId,
		 troop_id = troop.id,
		 quality = 1
	}
	
	table.insert(city.cf_list,chengfang)

	self:onUpdateTroopNotify({troop})
	self:onUpdateCityNotify(cityId)
end

function This:onClearChengFangCreateTimeRequest(msg)
	local city = self.m_citys[msg.city_id]
	city.cf_next_time = GamePlayer:getServerTime() + 300
	self:createNewChengFang(msg.city_id)
	EventDispatcher:dispatcher(13014,{
		err_code = 0,
		city_id = msg.city_id
	})
end

function This:onTrainChengFangOnceKeyRequest(msg)
	local city = self.m_citys[msg.city_id]
	for i , chengfang in ipairs(city.cf_list) do
		chengfang.quality = ArgConfig["legion_war_city_npc_train_quality"].arg[1]
	end
	self:onUpdateCityNotify(msg.city_id)
	EventDispatcher:dispatcher(13015,{
		err_code = 0,
		city_id = msg.city_id
	})
end

function This:onRebuildCityRequest(msg)
	local city = self.m_citys[msg.city_id]
	city.build_type = msg.build_type
	city.tech_list = {}

	local config = LegionChangeLevelConfig[msg.build_type * 100 + 1]
	for i , info in ipairs(config.max_technology) do
		city.tech_list[i] = {
			tech_type = info[1],
			level = 1,
			-- jianshedu = 0,
			-- state = LegionTechState.kNormal,
			-- troop_list = {}
		}
	end

	self:onUpdateCityNotify(msg.city_id)
	EventDispatcher:dispatcher(13018,{
		err_code = 0,
		city_id = msg.city_id
	})
end

function This:onRemoveCityBuildRequest(msg)
	local city = self.m_citys[msg.city_id]
	city.build_type = 0
	city.tech_list = {}
	self:onUpdateCityNotify(msg.city_id)
	EventDispatcher:dispatcher(13019,{
		err_code = 0,
		city_id = msg.city_id
	})
end

function This:onUpgradeTechRequest(msg)
	local city = self.m_citys[msg.city_id]
	for i , tech in ipairs(city.tech_list) do
		if tech.tech_type == msg.tech_type then
			local biandui = self.m_geren.biandui_list[msg.biandui_index]
			local jiasu = {
				troop_id = biandui.troop_id,
				pos = msg.pos,
				endtime = GamePlayer:getServerTime() + 30,
				add_speed_id = msg.add_speed_id,
				is_rate = msg.is_rate,
			}
			local troop = self.m_troops[biandui.troop_id]
			troop.state = LegionTroopState.kTechAddSpeed
			self:onUpdateTroopNotify({troop})

			table.insert(tech.troop_list,jiasu)

			self:onUpdateCityNotify(msg.city_id)
			EventDispatcher:dispatcher(13019,{
				err_code = 0,
				city_id = msg.city_id,
				tech_type = msg.tech_type,
				biandui_index = msg.biandui_index,
				add_speed_id = msg.add_speed_id,
				pos = msg.pos,
				is_rate = msg.is_rate
			})
			break
		end
	end
end

function This:onChangeTechStateRequest(msg)
	local city = self.m_citys[msg.city_id]
	for i , tech in ipairs(city.tech_list) do
		if tech.tech_type == msg.tech_type then
			tech.state = msg.state
			self:onUpdateCityNotify(msg.city_id)
			EventDispatcher:dispatcher(13020,{
				err_code = 0,
				city_id = msg.city_id,
				tech_type = msg.tech_type
			})
		end
	end
end

function This:onTechAddSpeedChangeNotify(cityId, tech)
	EventDispatcher:dispatcher(13021,{
		city_id = cityId,
		tech = tech
	})
end

function This:onUseLegionJunCeRequest(msg)
	local jctype, cityId = msg.type, msg.city_id
	if jctype == LegionStrategyType.kHuanBing then
		cityId = 0
	end
	-- EventDispatcher:dispatcher(13027,{
	-- 	city_id = cityId,
	-- 	type = msg.type
	-- })
	EventDispatcher:dispatcher(13028,{
		city_id = cityId,
		type = msg.type
	})
end

function This:update(dt)
	self.m_escape = self.m_escape + dt
	if self.m_escape < 1 then
		return
	end
	self.m_escape = self.m_escape - 1
	local curTime = GamePlayer:getServerTime()
	for i , biandui in ipairs(self.m_geren.biandui_list) do
		local troop = self.m_troops[biandui.troop_id]
		if troop.state == LegionTroopState.kAddHp and curTime >= troop.endtime then
			self:onAddHpFinishNotify(i)
		end
	end
	for i , march in pairs(self.m_marchs) do
		if curTime >= march.endtime then
			self:onMarchFinishNotify(march.id)
		end
	end
	-- for id , city in pairs(self.m_citys) do
	-- 	for i , tech in ipairs(city.tech_list) do
	-- 		local isChange = false
	-- 		local index = 1
	-- 		while tech.state == LegionTechState.kUpgrading and index <= #tech.troop_list do
	-- 			local techspeed = tech.troop_list[index]
	-- 			if curTime >= techspeed.endtime then
	-- 				local speed = LegionTechnologyBuildConfig[techspeed.add_speed_id].value
	-- 				if not techspeed.is_rate then
	-- 					tech.jianshedu = tech.jianshedu + speed 
	-- 				else
	-- 					tech.jianshedu = tech.jianshedu + speed * 1.5
	-- 				end
						
	-- 				table.remove(tech.troop_list,index)
	-- 				local buildType = city.build_type
	-- 				local config = LegionTechnologyConfig[buildType * 10000 + tech.tech_type * 100 + tech.level]
	-- 				if tech.jianshedu >= config.technology_degree then
	-- 					tech.level = tech.level + 1
	-- 					tech.jianshedu = 0
	-- 					tech.state = LegionTechState.kNormal
	-- 					isChange = true
	-- 					break
	-- 				end
	-- 			else
	-- 				index = index + 1
	-- 			end
	-- 		end
	-- 		if isChange then
	-- 			self:onTechAddSpeedChangeNotify(id,tech)
	-- 		end
	-- 	end
	-- end
end

--endregion
