--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"Base.BaseModel")
local LegionCard = require("Map.LegionCard")
local ArgConfig = require("Metadatas.ArgConfig")
local HeroManager = require("Hero.HeroManager")

function This:init(info)
	super.init(self)
	self.m_map = info.map
	self.m_id = 0
	self.m_roleId = 0
	self.m_cityId = 0
	self.m_type = 0
	self.m_cardList = {}

	self.m_hpAddSpeedTime = 0 --补兵加速次数
	self.m_addHpEndTime = 0  --补兵结束时间

	self.m_techIndex = 0 --科技加速位置
	self.m_techSpeed = 0  --科技速度加成
	self.m_techEndTime = 0 --科技加速结束时间
	self.m_tech = nil  --加速的科技

	self.m_march = nil --行军
	self.m_state = LegionTroopState.kIdle
end

function This:getId()
	return self.m_id
end

function This:getRoleId()
	return self.m_roleId
end

function This:getCityId()
	return self.m_cityId
end

function This:isEmpty()
	return self.m_id <= 0 or #self.m_cardList <= 0
end

function This:getState()
	return self.m_state
end

function This:isOur()
	local role = self.m_map:getRole(self.m_roleId)
	if role then
		local legionId = role:getLegionId()
		return legionId == self.m_map:getMyLegionId()
	end
	return false
end

function This:getType()
	return self.m_type
end

function This:getCardList()
	return self.m_cardList
end

--获取补兵加速次数
function This:getAddHpSpeedTime()
	return self.m_hpAddSpeedTime
end

--补兵加速结束时间
function This:getAddHpEndTime()
	return self.m_addHpEndTime
end

function This:getMarchEndTime()
	if self.m_march then
		return self.m_march:getEndTime()
	end
end

--是否可以补兵
function This:isCanAddHp()
	return self.m_state == LegionTroopState.kIdle or self.m_state == LegionTroopState.kDefensive
end

function This:getMaxAddHpSpeedTime()
	return ArgConfig["legion_war_mending_speedup_max_times"].arg[1]
end

function This:getAddHpSpeedCost()
	return ArgConfig["legion_war_mending_speedup_cost"].arg[1]
end

--获取为科技加速值
function This:getTechAddSpeed()
	return self.m_techSpeed
end

--获取为科技加速结束时间
function This:getTechEndTime()
	return self.m_techEndTime
end

--科技加速位置
function This:getTechIndex()
	return self.m_techIndex
end

function This:setTechAddSpeed(tech,info)
	self.m_techIndex = info.pos
	self.m_techSpeed= info.speed
	self.m_techEndTime = info.endtime
	self.m_tech = tech
	self.m_state = LegionTroopState.kTechAddSpeed
end

function This:clearTechAddSpeed()
	self.m_techIndex = 0
	self.m_techSpeed = 0
	self.m_techEndTime = 0
	self.m_tech = nil
	self.m_state = LegionTroopState.kIdle
end

function This:setMarch(march)
	self.m_march = march
end

function This:getMarchId()
    if self.m_march then
    	return self.m_march:getId()
    end
    return 0
end

function This:clearMarch()
	self.m_march = nil
end

function This:getTotalHp()
	local total = 0
	for pos , card in pairs(self.m_cardList) do
		total = total + card:getHp()
	end
	return total
end

function This:getCard(index)
	return self.m_cardList[index]
end

function This:getFightPower()
	local total = 0
	for pos , card in pairs(self.m_cardList) do
		total = total + card:getFightPower()
	end
	return total
end

function This:updateCardList(cardList)
	for i , info in ipairs(cardList) do
		local card = self.m_cardList[i]
		if not card then
			card = LegionCard:create(info)
			self.m_cardList[i] = card
		else
			card:updateInfo(info)
		end
	end
	for i = #cardList+1 , #self.m_cardList do
		self.m_cardList[i] = nil
	end
end

function This:updateInfo(info)
	print_r(info)
	self.m_id = info.id
	self.m_roleId = info.role_id
	self.m_cityId = info.city_id
	self.m_state = info.state
	self.m_type = info.type 
	self.m_addHpEndTime = info.endtime
	self.m_hpAddSpeedTime = info.add_speed_time
	self:updateCardList(info.card_list)
end

--endregion
