-- @Author: ZYY
-- @Date:   2018-07-25 14:53:28
-- @Last Modified by:   zheng
-- @Last Modified time: 2020-07-03 16:42:11
-- @File Name: LegionTroopHeroView.lua
-- @Desc: 队伍英雄头像
local This , super = class(...,"NodeUI")
local GameUtil = require("Util.GameUtil")
local HeroConfig = require("Metadatas.HeroConfig")
local ItemUtil = require("Bag.ItemUtil")

This.fileName = "LegionScene/NodeUI/LegionTroopEditItem.csb"

function This:initNode(info)
	self.m_hero = info.hero
	self.m_isInAllTeam = false
	self.m_isInCurTeam = false
end

function This:refresh()
	if self.m_hero then
		local heroId = self.m_hero:getId()
		self.hero:setImage(ItemUtil.getIconImage(heroId))
		self.bg1:setImage(ItemUtil.getQualityImage(heroId))

		local star = self.m_hero:getStarLv()
		for i = 1 , 5 do
			self["star"..i]:setVisible(star >= i)
		end
		self.hero:setVisible(true)
		self.level:setVisible(true)
		self.starbg:setVisible(star > 0)
		self.level:setString(self.m_hero:getLevel())
	else
		self.bg1:setImage(ItemUtil.getQualityImage(0))
		for i = 1 , 5 do
			self["star"..i]:setVisible(false)
		end
		self.hero:setVisible(false)
		self.starbg:setVisible(false)
		self.level:setVisible(false)
	end
	self:refreshSelectState()
end

function This:refreshSelectState()
	if self.m_hero then
		self.m_isInAllTeam = self.m_judgeInAllTeamHandler and self.m_judgeInAllTeamHandler(self.m_hero)
		self.xuanzhong:setVisible(self.m_isInAllTeam)
		self.m_isInCurTeam = self.m_judgeInCurTeamHandler and self.m_judgeInCurTeamHandler(self.m_hero)
		self.xuanzhong.gou:setVisible(self.m_isInCurTeam)
	else
		self.xuanzhong:setVisible(false)
		self.xuanzhong.gou:setVisible(false)
	end
end

function This:initTouchEvent()
	self.bg1:setTouch({
		onEnded = function()
			if not self.m_isInAllTeam then
				if self.m_selectHandler and self.m_hero then
					self.m_selectHandler(self.m_hero)
					self:refresh()
				end
			else
				g_scene:showTips(Serialize[61678])
			end
		end,
		isContanier = true,
		isSwallow = false
	})
end

function This:onEnter()
	super.onEnter(self)
	self:refresh()
end

function This:onEixt()
	super.onExit(self)
end

function This:setSelectHandler(handler)
	self.m_selectHandler = handler
end

function This:setJudgeIsInAllTeamHandler(handler)
	self.m_judgeInAllTeamHandler = handler
end

function This:setJudgeIsInCurTeamHandler(handler)
	self.m_judgeInCurTeamHandler = handler
end

function This:setModel(hero)
	if self.m_hero ~= hero then
		self.m_hero = hero
		self:refresh()
	else
		self:refreshSelectState()
	end
end

function This:getModel()
	return self.m_hero
end