-- @Author: ZYY
-- @Date:   2018-08-14 11:01:40
-- @Last Modified by:   superm
-- @Last Modified time: 2019-01-14 16:41:13
-- @File Name: LegionTroopPreviewListView.lua
-- @Desc: 编辑部队列表
local This , super = class(...,"NodeUI")
local ItemUtil = require("Bag.ItemUtil")
local LegionCityConfig = require("Metadatas.LegionCityConfig")

This.fileName = "LegionScene/NodeUI/LegionPreviewlist.csb"

local StateImage = 
{
[LegionTroopState.kAddHp] = "MenuScene/zhengzhan.png",
[LegionTroopState.kBattle] = "MenuScene/zhengzhan.png",
[LegionTroopState.kDefensive] = "MenuScene/zhengzhan.png",
[LegionTroopState.kIdle] = "MenuScene/zhengzhan.png",
[LegionTroopState.kMarch] = "MenuScene/zhengzhan.png",
[LegionTroopState.kTechAddSpeed] = "MenuScene/zhengzhan.png",
[LegionTroopState.kTransport] = "MenuScene/zhengzhan.png"
}

local StateColor = 
{
	[LegionTroopState.kAddHp] = {255,0,255},
	[LegionTroopState.kBattle] = {255,0,255},
	[LegionTroopState.kDefensive] = {255,0,255},
	[LegionTroopState.kIdle] = {255,0,255},
	[LegionTroopState.kMarch] = {255,0,255},
	[LegionTroopState.kTechAddSpeed] = {255,0,255},
	[LegionTroopState.kTransport] = {255,0,255}
}

function This:initNode(info)
	local troop = info.troop
	self.m_map = info.map
	self.m_index = info.index
	self:setModel(troop)
end

function This:refresh()
	if not self.m_troop or self.m_troop:isEmpty() then 
		self.node:setVisible(false)
	else
		local cardList = self.m_troop:getCardList()
		local firstCard
		local maxHp , hp = 0, 0
		for _, card in ipairs(cardList) do
			maxHp = maxHp + card:getMaxHp()
			hp = hp + card:getHp()
			if card:getPos() == 1 then
				firstCard = card
			end
		end

		local heroId = firstCard:getHeroId()
		self.node.icon:setImage(ItemUtil.getIconImage(heroId))
		self.node.name:setString(self.m_troop:getName())

		local state = self.m_troop:getState()
		self.node.pic:setImage(StateImage[state])

		local cityId = self.m_troop:getCityId()
		local statestr = LegionTroopStateText[state]
		if cityId > 0 then
			 statestr = LegionCityConfig[cityId].city_name .. statestr
		end
		self.node.state2:setString(statestr)
		self.node.state2:setColor(StateColor[state][1],StateColor[state][2],StateColor[state][3])
		self.node.hpbat:setPercent(hp / maxHp * 100)
		self.node:setVisible(true)
	end
end

function This:onEnter()
	super.onEnter(self)
	self:refresh()
end

function This:onExit()
	super.onExit(self)
end

function This:initTouchEvent()
	self.biandui:setTouch({
		onEnded = function()
			g_scene:openDialog("Map.LegionTroopsEditPanel",{
				teamIndex = self.m_index,
				map = self.m_map
			})
		end,
		isDynamic = true
	})
end

function This:setModel(troop)
	if self.m_troop ~= troop then
		self.m_troop = troop 
		self:refresh()
	end
end