--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"cc.Node")
local HeroManager = require("Hero.HeroManager")

function This:init(info)
	self.m_map = info.map
	self.m_card = info.card

	self.m_hero = HeroManager:getHero(self.m_card:getHeroId())
	self.m_csNode = cc.Node:createFromCSFile("LegionScene/NodeUI/LegionTroopsHeroCard.csb")
	self:addChild(self.m_csNode)
	self.m_csNode.choose:setVisible(false)
	self:refresh()
end

function This:refresh()
	local country = self.m_hero:getCountry()
	self.m_csNode.country:setString(CountryName[country])
	self.m_csNode.name:setString(self.m_hero:getName(), AppText:isChinese() and 10 or nil)
	self.m_csNode.level:setString(self.m_hero:getLevel())
	self.m_csNode.fightPower:setString(self.m_hero:getFightPower())
	local star = self.m_hero:getStarLv()
	for i = 1 , 5 do
		self.m_csNode["star"..i]:setVisible(star >= i)
	end
	local quality = self.m_hero:getQuality()
	local color = SmallCardQualityColor[quality]
	self.m_csNode.country:setColor(color.r , color.g, color.b)

	self.m_csNode.qualitybg:setImage(QualityBgFile[quality])
	self.m_csNode.quality:setImage(QualityFrameFile[quality])
	self.m_csNode.icon:setImage(self.m_hero:getIcon())
	self.m_csNode.hpbar:setPercent(self.m_card:getHp() / self.m_card:getMaxHp() * 100)
end

function This:setIsSelect(isSelected)
	if self.m_isSelected ~= isSelected then
		self.m_isSelected = isSelected
		self.m_csNode.choose:setVisible(self.m_isSelected)
	end
end

function This:setSelectHandler(handler)
	self.m_selectHandler = handler
end

function This:initTouchEvent()
	self.m_csNode:setTouch({
		onEnded = function()
			if self.m_selectHandler then
				self.m_selectHandler(self.m_hero)
			end
		end,
		sizeNode = self.m_csNode.icon,
		isScale = false
	})
end

function This:onEnter()
	super.onEnter(self)
	self:refresh()
	self:initTouchEvent()
end

function This:onExit()
	super.onExit(self)
end

function This:getModel()
	return self.m_hero
end

--endregion
