--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"Dialog")
local LegionTroopsAddHpItemView = require("Map.LegionTroopsAddHpItemView")
local HeroManager = require("Hero.HeroManager")
local GameUtil = require("Util.GameUtil")
local ArgConfig = require("Metadatas.ArgConfig")
local GamePlayer = require("Player.GamePlayer")
local LegionMapUtil = require("Map.LegionMapUtil")

function This:initNode(info)
	self.m_biandui = info.biandui
	self.m_map = info.map
	self.m_city = info.city
	self.m_csNode = cc.Node:createFromCSFile("LegionScene/NodeUI/LegionTroopsPatch.csb")
	self:addChild(self.m_csNode)
	self.m_csNode:setToCenter()
	self.m_itemViewList = {}
	self.m_maxHp = {0,0,0,0,0,0}
	self.m_curHp = {0,0,0,0,0,0}
	self.m_initHp = {0,0,0,0,0,0}
	self.m_curHero = nil
	
	self.m_isAddingHp = false
	self.m_escape = 0
	self.m_csNode.troopname:setString(self.m_biandui:getName())
	self.m_maxTime = ArgConfig.legion_war_mending_speedup_max_times.arg[1]
	self:updateCardInfo()
	self:initItemViewList()
	self:initSlider()
	self:selectItemView(1)
end

function This:initItemViewList()
	local troop = self.m_biandui:getTroop()
	local cardList = troop:getCardList()
	for _, card in ipairs(cardList) do
		local pos = card:getPos()
		local view = self:createItemView(card, pos)
		self.m_csNode["hero".. pos]:addChild(view)
		self.m_itemViewList[pos] = view
	end
end

function This:updateCardInfo()
	self.m_reserveHp = self.m_city:getHp()
	self.m_unitcost = 1

	local troop = self.m_biandui:getTroop()
	local state = troop:getState()
	self.m_isAddingHp = (state == LegionTroopState.kAddHp)

	self.m_cardList = {}
	local troop = self.m_biandui:getTroop()
	local cardList = troop:getCardList()
	for _, card in ipairs(cardList) do
		local pos = card:getPos()
		self.m_maxHp[pos] = card:getMaxHp()
		if self.m_isAddingHp then
			self.m_curHp[pos] = card:getHp() + card:getTransNum()
		else
			self.m_curHp[pos] = card:getHp()
		end
		self.m_initHp[pos] = card:getHp()
		if self.m_curPos == pos then
			self.m_unitcost = self.m_map:getAddHpCostCoin(1, card:getHeroId())
		end
		self.m_cardList[pos] = card
	end
end

function This:selectItemView(pos)
	local view = self.m_itemViewList[pos]
	if self.m_curView == view then
		return
	end
	local hero = view:getModel()
	if self.m_curView then
		self.m_curView:setIsSelect(false)
	end
	self.m_curView = view
	self.m_curHero = hero
	self.m_curPos = pos
	self.m_curView:setIsSelect(true)
	local x = self.m_csNode["hero"..pos]:getPositionX()
	self.m_csNode.legionjiantou:setPositionX(x)

	self.m_csNode.slider:setPercent(self.m_curHp[self.m_curPos] / self.m_maxHp[self.m_curPos])
end

function This:createItemView(card,pos)
	local hero = HeroManager:getHero(card:getHeroId())
	local view = LegionTroopsAddHpItemView:create({
		map = self.m_map,
		hero = hero,
		card = card
	})
	view:setSelectHandler(function()
		self:selectItemView(pos)
	end)
	return view
end

function This:initSlider()
	self.m_csNode.slider:setSilderHandler(function(percent)
		percent = math.max(self.m_initHp[self.m_curPos] / self.m_maxHp[self.m_curPos],percent)
		
		if self.m_isAddingHp then
			self:refresh()
			return self.m_curHp[self.m_curPos] / self.m_maxHp[self.m_curPos]
		end

		local total = 0
		for i = 1,  6 do
			if self.m_curPos ~= i then
				total = total + self.m_curHp[i] - self.m_initHp[i]
			end
		end

		local coinHp = (self.m_map:getCoin() - total * self.m_unitcost) / self.m_unitcost
		local hp = math.floor( math.min(percent * self.m_maxHp[self.m_curPos] - self.m_initHp[self.m_curPos], coinHp,self.m_reserveHp - total))
		if hp < 0 then hp = 0 end

		self.m_curHp[self.m_curPos] = hp + self.m_initHp[self.m_curPos]
		self:refresh()
		return self.m_curHp[self.m_curPos] / self.m_maxHp[self.m_curPos]
	end)
end

function This:refresh()
	local totalHp , maxTotal ,addTotal, coin = 0 , 0 , 0, 0
	for i = 1 , 6 do
		totalHp = totalHp + self.m_curHp[i]
		maxTotal = maxTotal + self.m_maxHp[i]
		addTotal = addTotal + self.m_curHp[i] - self.m_initHp[i]
		coin = coin + self.m_map:getAddHpCostCoin(self.m_curHp[i] - self.m_initHp[i],self.m_cardList[i]:getHeroId())
	end

	addTotal = math.max(0,addTotal)

	self.m_csNode.zongbingli:setString(string.format(Serialize[61841],totalHp))
	self.m_csNode.money:setString(string.format(Serialize[61842],coin))

	local time = self.m_map:getAddHpCostTime(addTotal,self.m_city:getId())
	if time < ArgConfig["legion_war_min_mending_time"].arg[1] then
		time = ArgConfig["legion_war_min_mending_time"].arg[1]
	end
	local time1 = self.m_map:getAddHpCostTime(self.m_curHp[self.m_curPos] - self.m_initHp[self.m_curPos], self.m_city:getId())
	self.m_csNode.time:setString(string.format(Serialize[61843],GameUtil:formatTime(Serialize["H_M_S"],time1)))
	
	local soilder = self.m_curHero:getCurSoilder()
	self.m_csNode.bingzhong:setString(string.format(Serialize[61844],soilder:getName()))
	self.m_csNode.bingli:setString(string.format(Serialize[61845],self.m_curHp[self.m_curPos],self.m_maxHp[self.m_curPos]))

	local coin1 = self.m_map:getAddHpCostCoin(self.m_curHp[self.m_curPos] - self.m_initHp[self.m_curPos],self.m_cardList[self.m_curPos]:getHeroId())
	self.m_csNode.xiaohao:setString(string.format(Serialize[61846],coin1))

	self.m_csNode.hpnum:setString(string.format(Serialize[61847],self.m_reserveHp))
	self.m_csNode.cointotal:setString(string.format(Serialize[61848],self.m_map:getCoin()))

	self.m_csNode.jiesangbutton.text:setString(self.m_isAddingHp and Serialize[61849] or Serialize[61850])

	local troop = self.m_biandui:getTroop()
	self.m_csNode.kaishibutton.text:setString(self.m_isAddingHp and string.format(Serialize[61782],troop:getMaxAddHpSpeedTime()-troop:getAddHpSpeedTime(),troop:getMaxAddHpSpeedTime()) or Serialize[61851])
	self.m_csNode.bubingbutton:setVisible(not self.m_isAddingHp)

	if self.m_isAddingHp then
		local endTime = self.m_biandui:getTroop():getAddHpEndTime() 
		local curTime = GamePlayer:getServerTime()
		self.m_csNode.time2:setString( GameUtil:formatTime(Serialize[61852],math.max(0,endTime - curTime)))
	else
		self.m_csNode.time2:setString(string.format(Serialize[61853],GameUtil:formatTime(Serialize["H_M_S"],time)))
	end
end

function This:refreshCardListView()
	for i , view in ipairs(self.m_itemViewList) do
		view:refresh()
	end
end

function This:autoAddHp()
	local coin = self.m_map:getCoin()
	local totalHp = 0
	for i = 1 , 6 do
		local unitcost = self.m_map:getAddHpCostCoin(1,self.m_cardList[i]:getHeroId())
		self.m_curHp[i] = self.m_initHp[i]
		local hp = math.floor( math.min(coin / unitcost, self.m_maxHp[i] - self.m_curHp[i], self.m_reserveHp - totalHp))
		self.m_curHp[i] = self.m_curHp[i] + hp
		coin = coin - hp * unitcost
		totalHp = totalHp + hp
	end
	self.m_csNode.slider:setPercent(self.m_curHp[self.m_curPos] / self.m_maxHp[self.m_curPos])
end

function This:autoClearHp()
	for i = 1 ,  6 do
		self.m_curHp[i] = self.m_initHp[i]
	end
	self.m_csNode.slider:setPercent(self.m_curHp[self.m_curPos] / self.m_maxHp[self.m_curPos])
end

function This:initTouchEvent()
	self.m_csNode.closebutton:setTouchEnded(function()
		self:close()
	end)
	self.m_csNode.jiesangbutton:setTouchEnded(function()
		if self.m_isAddingHp then
			local panel = g_scene:openDialog("UI.ConfirmPanel",{
				text = Serialize[61854]
			})
			panel:setOkHandler(function()
				self.m_map:onUndoAddTroopHpRequest(self.m_biandui:getPos())
			end)
		else
			local state = self.m_biandui:getTroop():getState()
			if state == LegionTroopState.kDefensive then
				self.m_map:onClearBianDuiHpRequest(self.m_biandui:getPos())
			else
				g_scene:showTips(Serialize[61855])
			end
		end
	end)
	self.m_csNode.bubingbutton:setTouchEnded(function()
		if self.m_isAddingHp then
			return
		end
		self:autoAddHp()
	end)
	self.m_csNode.kaishibutton:setTouchEnded(function()
		if self.m_isAddingHp then
			local troop = self.m_biandui:getTroop()
			if troop:getAddHpSpeedTime() < troop:getMaxAddHpSpeedTime() then
				GamePlayer:costDiamond({
					desc = Serialize[61856],
					cost = troop:getAddHpSpeedCost(),
					okHandler = function()
						self.m_map:onAddHpSpeedTroopRequest(self.m_biandui:getPos())
					end
				})
			else
				g_scene:showTips(Serialize[61857])
			end
		else
			if self.m_map:getCoin() <= 0 then
				g_scene:showTips(Serialize[61858])
				return
			end
			local cardList = self.m_biandui:getTroop():getCardList()
			local hpList , idList = {}, {}
			local totalAdd = 0
			for _, card in ipairs(cardList) do
				local pos = card:getPos()
				table.insert(idList,card:getId())
				table.insert(hpList,self.m_curHp[pos] - self.m_initHp[pos])
				totalAdd = totalAdd + self.m_curHp[pos] - self.m_initHp[pos]
			end
			if totalAdd <= 0 then
				g_scene:showTips(Serialize[61691])
				return
			end
			self.m_map:onAddBianDuiResRequest(self.m_biandui:getPos(),idList,hpList,LegionTransType.kHp,self.m_city:getId())
		end
	end)
	self.m_csNode.jiahao:setTouchEnded(function()
		self.m_csNode.slider:setPercent(1)
	end)
	self.m_csNode.jianhao:setTouchEnded(function()
		self.m_csNode.slider:setPercent(0)
	end)
end

function This:onEnter()
	super.onEnter(self)
	self.m_map:addObserver(self)
end

function This:onExit()
	super.onExit(self)
	self.m_map:removeObserver(self)
end

function This:update(dt)
	super.update(self,dt)
	self.m_escape = self.m_escape + dt
	if self.m_escape < 1 then
		return
	end
	self.m_escape = self.m_escape - 1
	if self.m_isAddingHp then
		local endTime = self.m_biandui:getTroop():getAddHpEndTime() 
		local curTime = GamePlayer:getServerTime()
		self.m_csNode.time2:setString( GameUtil:formatTime(Serialize[61852],math.max(0,endTime - curTime)))
	end
end

--------------------------------------------------
function This:onAddBianDuiRes(biandui)
	if self.m_biandui == biandui then
		self:updateCardInfo()
		self:refresh()
	end
end

function This:onUndoAddBianDuiHp(biandui)
	if self.m_biandui == biandui then
		self:updateCardInfo()
		self.m_csNode.slider:setPercent(self.m_curHp[self.m_curPos] / self.m_maxHp[self.m_curPos])
	end
end

function This:onAddBianDuiHpSpeed(biandui)
	if self.m_biandui == biandui then
		self:updateCardInfo()
		self.m_csNode.slider:setPercent(self.m_curHp[self.m_curPos] / self.m_maxHp[self.m_curPos])
	end
end

function This:onClearBianDuiHp(biandui)
	if self.m_biandui == biandui then
		self:updateCardInfo()
		self.m_csNode.slider:setPercent(self.m_curHp[self.m_curPos] / self.m_maxHp[self.m_curPos])
		self:refreshCardListView()
	end
end

function This:onAddHpFinish(biandui)
	if self.m_biandui == biandui then
		self:updateCardInfo()
		self.m_csNode.slider:setPercent(self.m_curHp[self.m_curPos] / self.m_maxHp[self.m_curPos])
		self:refreshCardListView()
	end
end

--endregion
