-- @Author: ZYY
-- @Date:   2018-07-31 17:43:01
-- @Last Modified by:   superm
-- @Last Modified time: 2018-11-30 10:24:03
-- @File Name: LegionTroopsMainPanel.lua
-- @Desc: 部队总界面
local This, super = class(...,"Dialog")
local LegionTroopsMainItemView = require("Map.LegionTroopsMainItemView")

local TabName = 
{
	kTroop = 1,
	kDefense = 2
}

function This:initNode(info)
	self.m_map = info.map
	self.m_city = info.city

    self.m_csNode = cc.Node:createFromCSFile("LegionScene/NodeUI/LegionTroopMain.csb")
    self.m_csNode:setToCenter()
	self:addChild(self.m_csNode)

    self.m_select = 1
    self.m_troopItem = {}
    self.m_troop = {}

	self:addTabButton(TabName.kTroop,self.m_csNode.tep1,function()
		self:selectTabButton(TabName.kTroop)
	end)

	self:addTabButton(TabName.kDefense,self.m_csNode.tep2,function()
		self:selectTabButton(TabName.kDefense)
	end)

	self:selectTabButton(TabName.kTroop)
end

function This:initTouchEvent()
	self.m_csNode.close:setTouchEnded(function()
		self:close()
	end)
	self.m_csNode.defence.reducetime:setTouchEnded(function()
		print("消除时间...")
	end)
	self.m_csNode.defence.xunlian:setTouchEnded(function()
		print("一件训练...")
	end)
	self.m_csNode.defence.help:setTouchEnded(function()
		g_scene:openDialog("UI.HelpTips", {text = Serialize.legion_troop_help ,node = self.m_csNode.defence.help})
	end)
end


function This:updateTroopList()
	local teamList = self.m_map:getAllTeam()
	self.m_teamList = {}
	if self.m_tab == TabName.kTroop then
		for i , team in ipairs(teamList) do
			if not team:isEmpty() then
				table.insert(self.m_teamList,team)
			end
		end
	elseif self.m_tab == TabName.kDefense then
		for i , team in ipairs(teamList) do
			if not team:isEmpty() and team:getCityId() == self.m_city:getId() then
				table.insert(self.m_teamList,team)
			end
		end
	end
end

function This:selectTabButton(tab)
	super.selectTabButton(self,tab)
	if self.m_tab ~= tab then
		self.m_tab = tab
		self:updateTroopList()
		self:refresh()
	end
end

function This:refresh()
	
end




