-- @Author: ZYY
-- @Date:   2018-07-21 18:08:25
-- @Last Modified by:   superm
-- @Last Modified time: 2019-01-14 16:43:53
-- @File Name: LegionTroopsPatchPanel.lua
-- @Desc: 军团长补兵界面

local This, super = class(...,"Dialog")
local LegionTroopsHeroCardView = require("Map.LegionTroopsHeroCardView")
local GameUtil = require("Util.GameUtil")
local ArgConfig = require("Metadatas.ArgConfig")

function This:initNode(troop)
	-- self.m_heroList = data:getCardList() or {}
	self.m_heroList = {}
	for i , card in pairs(troop:getCardList()) do 
		local pos = card:getPos()
		self.m_heroList[pos] = card
	end	
	self.m_troopName = troop:getName() or ""
    self.m_csNode = cc.Node:createFromCSFile("LegionScene/NodeUI/LegionTroopsPatch.csb")
    self.m_csNode:setToCenter()
	self:addChild(self.m_csNode)
    self.m_percent = 0
	self.m_select = 1
	self.m_heroListItem = {}
	self.m_timeSoldier = 100 --每秒补兵数
	self.m_cost = ArgConfig["legion_war_mending_coin_coefficient"].arg[1] or 1 --补兵消耗
	self.m_allSoldier = 0 
	self.m_allTimeStamp = 0 --总补兵时间戳
	--初始化队列数据
	-- for i = 1 , 6 do  
	-- 	self.m_heroList[i] = {
	-- 		heroId = 10001 + i,
	-- 		star = 10,
	-- 		id = 21 - i,
	-- 		level = i,
	-- 		fight_power = 10* i,
	-- 		max_hp = 10000 * i,
	-- 		hp = 1000 * i * i}
	-- end

	self.m_csNode.slider:setSilderHandler(function(percent)
		self.m_percent = percent
		local data = self.m_heroList[self.m_select]
		local hp = data:getMaxHp() * percent
		local cost = self.m_cost * (hp - data:getHp())
		if cost < 0 then 
			cost = 0
		end
		self.m_readyTime =  math.round((hp - data:getHp()) / self.m_timeSoldier) 
		self.m_readyHP = hp
		if self.m_readyTime < 0 then 
			self.m_readyTime = 0 
		end
		self.m_csNode.bingli:setString(string.format(Serialize[61876],hp,data:getMaxHp()))
		self.m_csNode.xiaohao:setString(string.format(Serialize[61877],cost))
		self.m_csNode.time:setString(string.format(Serialize[61878],GameUtil:formatTime(Serialize["H_M_S"],self.m_readyTime)))
		return percent
	end)
	self.m_csNode.money:setString(Serialize[61879])
	self.m_csNode.time2:setString(Serialize[61880])
	self:setTimer(1,function ()
		self:updateCountDown()
	end, "TroopCountDown" ,-1)
	self:refresh()
end

function This:refresh()
	self.m_csNode.troopname:setString(self.m_troopName)
	local function role_touch_fun(value)
		self.m_select = value
		for i , v in ipairs(self.m_heroListItem) do 
			self.m_heroListItem[i]:setSelectState(i == value)
		end
		self.m_csNode.legionjiantou:setPositionX(-400 + value * 115)
		local data = self.m_heroList[value]
		self:updateHP(data:getHp(),data:getMaxHp())
	end
	for i , v in ipairs(self.m_heroListItem) do 
		v:setVisible(false)
	end
	for i , v in ipairs(self.m_heroList) do
		local view = self.m_heroListItem[i] 
		if not view then 
			view = LegionTroopsHeroCardView:create(i,v,role_touch_fun)
			self.m_csNode["hero"..i]:addChild(view)
		else
			view:setData(i,v,role_touch_fun)
		end
		self.m_heroListItem[i] = view
	end
	role_touch_fun(self.m_select)

	self:updateAllSoldier()

end

function This:initTouchEvent()
	self.m_csNode.closebutton:setTouchEnded(function()
		self:close()
	end)

	self.m_csNode.bubingbutton:setTouchEnded(function()
	
	end)

	self.m_csNode.kaishibutton:setTouchEnded(function()
		local timeStamp = self.m_readyTime + os.time()
		self.m_heroList[self.m_select].timeStamp = timeStamp
		if self.m_readyHP then 
			self.m_heroList[self.m_select]:setHp(self.m_readyHP) 
		end
		if not self.m_allTimeStamp or timeStamp > self.m_allTimeStamp then 
			self.m_allTimeStamp = timeStamp
		end	
	end)

	self.m_csNode.jiesangbutton:setTouchEnded(function()
	
	end)

	self.m_csNode.jiantou1:setTouchEnded(function()
		local data = self.m_heroList[self.m_select]
		self:updateHP(0,data:getMaxHp() )
	end)	

	self.m_csNode.jiantou2:setTouchEnded(function()
		local data = self.m_heroList[self.m_select]
		self:updateHP(data:getMaxHp(),data:getMaxHp())
	end)

	self.m_csNode.jiasubutton:setTouchEnded(function()
	
	end)
end

function This:onTouchMask()

end

function This:updateHP(hp,max_hp)
	hp = hp or 0
	max_hp = max_hp or 0
	self.m_csNode.slider:setPercent( hp / max_hp)	
end

function This:updateAllSoldier()
	self.m_allSoldier = 0 
	for i , hero in ipairs(self.m_heroList) do 
		self.m_allSoldier = self.m_allSoldier + hero:getHp()
	end
	self.m_csNode.zongbingli:setString(Serialize[61881]..self.m_allSoldier)
end

function This:updateCountDown()
	if self.m_allTimeStamp - os.time() >= 0 then 
		self.m_csNode.time2:setString(string.format(Serialize[61878],GameUtil:formatTime(Serialize["H_M_S"],self.m_allTimeStamp - os.time())))
		self.m_csNode.jiasubutton:setVisible(true)
		self.m_csNode.kaishibutton:setVisible(false)
	else
		self.m_csNode.jiasubutton:setVisible(false)
		self.m_csNode.kaishibutton:setVisible(true)
	end
	if self.m_heroList[self.m_select].timeStamp then
		local time = self.m_heroList[self.m_select].timeStamp - os.time()
		if time >= 0 then  
			self.m_csNode.time:setString(string.format(Serialize[61878],GameUtil:formatTime(Serialize["H_M_S"],time)))
		end
	end
end