-- @Author: ZYY
-- @Date:   2018-08-14 10:49:30
-- @Last Modified by:   superm
-- @Last Modified time: 2019-04-10 17:56:07
-- @File Name: LegionTroopsPreviewNode.lua
-- @Desc: 编组小窗口
local This, super = class(...,"NodeUI")
local LegionTroopPreviewListView = require("Map.LegionTroopPreviewListView")

function This:initNode(info)
	self.m_map = info.map
    self.m_csNode = cc.Node:createFromCSFile("LegionScene/NodeUI/LegionTroopsPreview.csb")
	self:addChild(self.m_csNode)
	self.m_troopItemList = {}
	self.m_troopList = self.m_map:getAllTeam()
	
	self.m_csNode.legiontianjia_5:setVisible(false)
	self:refresh()
end

function This:refresh()
	for i , v in ipairs(self.m_troopItemList) do 
		v:setVisible(false)
	end

	local csNode = self.m_csNode

	local maxCount = self.m_map:getMaxTeamCount()
	local troopCount = 0
	for i , troop in ipairs(self.m_troopList) do
		if not troop:isEmpty() then
			troopCount = troopCount + 1
		end
	end
	csNode.Text_25:setString(string.format("%d/%d",troopCount,maxCount))

	for i = 1 , 3 do 
		local item = self.m_troopItemList[i]
		if not item then 
			item = LegionTroopPreviewListView:create({
				troop = self.m_troopList[i],
				map = self.m_map,
				index = i
			})
			csNode["Node_"..(i + 9)]:addChild(item)
		else
			item:setData(self.m_troopList[i],i)
		end
		item:setVisible(true)
		self.m_troopItemList[i] = item
	end
end

function This:initTouchEvent()
	local x , y = self:getPosition()
	local isHide = false
	self.m_csNode.legionshousuo_3:setTouch({
		onEnded = function()
			if not isHide then
				--self:runAction(cc.MoveTo(0.3,x+100,y,"SineOut"))
				isHide = true
			else
				--self:runAction(cc.MoveTo(0.3,x,y,"SineOut"))
				isHide = false
			end
		end,	
		isDynamic = true
	})
	self.m_csNode.legiontianjia_5:setTouch({
		onEnded = function()
			print("添加最大编队...")
		end,
		isDynamic = true
	})
end

function This:onEnter()
	super.onEnter(self)
	self.m_map:addObserver(self)
end

function This:onExit()
	super.onExit(self)
	self.m_map:removeObserver(self)
end

function This:onUpdateTeamTroop(index,team)
	local view = self.m_troopItemList[index]
	if view then
		view:setModel(team)
	end
end