﻿--region *.lua
--Date
--姝ゆ枃浠剁敱[BabeLua]鎻掍欢鑷姩鐢熸垚

local This , super = class(...,"World.WorldUI")
local HomeUI = require("Home.HomeUI")
local MenuBtnHelper = require("Home.MenuBtnHelper")
local LegionBianDuiNode = require("Map.LegionBianDuiNode")
local LegionMarchView = require("Map.LegionMarchView")
local LegionMarchDangerView = require("Map.LegionMarchDangerView")
local GamePlayer = require("Player.GamePlayer")
local GameUtil = require("Util.GameUtil")
local ItemUtil = require("Bag.ItemUtil")
local VoiceChatManager = require("VoiceChat")
local AchieveManager = require("Achieve.AchieveManager")
local LegionRankingView = require("Map.LegionRankingView")
local LegionWarBoxTip = require("Map.LegionWarBoxTip")
local LegionMinMapNode = require("Map.LegionMinMapNode")

local LegionPersonalRankingController = require("Map.LegionPersonalRankingController")
local LegionStateUI = require("Map.LegionStateUI")

local LegionUITabName={
    ktep1 = 1,--军团排名
    ktep2 = 2,--军团积分任务
    ktep3 = 3,--个人排名
}
function This:init(info)
	super.init(self)
	self.m_map = info.map
end

function This:initUI()
	self.m_scene = g_scene
	self.m_csNode = cc.Node:createFromCSFile("LegionScene/NodeUI/LegionBuildMain.csb")
	self:fixScreen()

    -- 军团排行列表
    self.m_rankTableView = LegionRankingView:create()
    self.m_rankTableView:setAnchorPoint(0.5, 0.5)
    self.m_csNode.target.item1:addChild(self.m_rankTableView)
    self.m_rankController = LegionPersonalRankingController:create(self.m_csNode.target.item3)
    self.m_strategyUI = LegionStateUI:create(self.m_csNode.state)

	self.m_btnHelper = MenuBtnHelper:create(self)
	self:addChild(self.m_csNode)

	self.m_boxTip = LegionWarBoxTip:create(self)
	self:addChild(self.m_boxTip)

	self.m_csNode.selectcity:setVisible(false)
	self.m_csNode.res_info.foodtxt:setVisible(false)
	self.m_csNode.res_info.coppertxt:setVisible(false)
	self.m_csNode.smallmap.voice.icon2:setVisible(false)
	self.m_btnHelper:refresh(true)

	self.m_cityNodes = {}
	self.m_cityEffect = {}
	self.m_isInVoiceRoom = false
	self.m_taskIsShow = true

	self:refreshTaskTab(LegionUITabName.ktep2)--军团任务
	self.m_rankTableView:refreshLegionRanking()
	AchieveManager:onGetAchieveInfoRequest(AchieveType.kJunTuanDaShi)
end


function This:fixUniqueNodes()
	self.m_csNode.target:recoveryToFixedWidth("right","bottom")
	self.m_csNode.biandui:recoveryToFixedWidth("right","")
	if GamePlayer:isIPhioneX() then
		self.m_csNode.target:setPositionX(50)
		self.m_csNode.march:setPositionX(50)
	else
		self.m_csNode.target:setPositionX(0)
	end
end

function This:onEnter()
	HomeUI.onEnter(self)
	self:refreshBaseInfo()
	self:initTroopTreamNode()
	self:initMarchArmy()
	self:initDangerous()
    self:initMiniMap()
	self:refreshTime()
	self:refreshReportEffect()
	self:refreshModelVisible()
	self:initAction()
	self:addMapManager()
	cc.Application:addListener(self)
    AchieveManager:addObserver(self)
    self.m_rankController:onEnter()
    if self.m_strategyUI then
    	self.m_strategyUI:onEnter()
    end
	if self.m_map:needShowHelpWhenEnterMap() then
		self.m_scene:openDialog("Map.LegionHelpPanel", {showLoginHintOption = true, map = self.m_map})
	end
end

function This:addMapManager()
	self.m_map:addObserver(self)
end

function This:removeMapManager()
	self.m_map:removeObserver(self)
end

function This:onExit()
	if self.m_strategyUI then
    	self.m_strategyUI:onExit()
    end
    self.m_rankController:onExit()
	AchieveManager:removeObserver(self)
	cc.Application:removeListener(self)
	VoiceChatManager:setJoinRoomCallback(function(memeberId)
		if memeberId > 0 then
			self.m_scene:showTips(Serialize["world_WorldUI_1"])
			self.m_isInVoiceRoom = true
			self.m_csNode.smallmap.voice.icon2:setVisible(true)
		else
			self.m_scene:showTips(Serialize["world_WorldUI_2"])
			self.m_isInVoiceRoom = false
			self.m_csNode.smallmap.voice.icon2:setVisible(false)
		end
	end)
	self:removeMapManager()
	HomeUI.onExit(self)
end

function This:initTouchEvent()
	HomeUI.initTouchEvent(self)
	local csNode = self.m_csNode
	csNode["goto"]:setTouch({
	    isScale = false, 
		isDynamic = true, 
		onEnded = function()
			cc.SceneManager:switchTo("Home.MenuScene")
	    end,
	})

	local tinyMapNode = csNode.smallmap
	tinyMapNode.battlelog:setTouchEnded(function()
		g_scene:openDialog("Map.LegionBattleReportPanel")
	end)
	tinyMapNode.map_bg:setTouch({
		onEnded = function()
			self:refreshCityCeil()
			self.m_scene:openDialog("Map.LegionMiniMapPanel",{
				map = self.m_map,
				scene = self.m_scene
			})
		end,
		isScale = false,
		isAlpha = false
	})
	tinyMapNode.help:setTouch({
		onEnded = function()
			self.m_scene:openDialog("Map.LegionHelpPanel", {showLoginHintOption = false, map = self.m_map})
		end,
		isScale = false
	})

	if csNode.panel_btns.junce then
		csNode.panel_btns.junce:setTouch({
		    isScale = false, 
			isDynamic = true, 
			onEnded = function()
				g_scene:openDialog("Family.FamilyPlanPanel")
		    end,
		})
	end

	
	local bp = cc.Vec()
	local marchNode = csNode.march
	marchNode.bg:setTouch({
		onBegan = function(_,touch)
			bp.x = touch.x
			bp.y = touch.y
			local boundbox = marchNode.bg:getBoundingBox()
			return boundbox:isContainsPoint({x = touch.x , y = touch.y})
		end,
		onEnded = function(_,touch)
			local ep = cc.Vec(touch.x - bp.x,touch.y - bp.y)
			if ep:length() < 10 then
				self.m_scene:openDialog("Map.LegionMarchListPanel",{
					map = self.m_map
				})
			end
		end,
		isScale = false,
		name = "march.bg"
	})
	marchNode.ScrollView:setTouchEnabled(true)
	marchNode.ScrollView:setSwallowTouch(false)

	local resNode = csNode.res_info
	resNode.copper:setTouch({
		onEnded = function()
		end,
		isScale = false,
		isDynamic = true
	})
	resNode.food:setTouch({
		onEnded = function()
		end,
		isScale = false,
		isDynamic = true
	})

	tinyMapNode.search:setTouchEnded(function()
		self.m_scene:openDialog("Map.LegionSearchCityPanel",{
			map = self.m_map
		})
	end)

	self.m_csNode.selectcity.close:setTouchEnded(function()
		self.m_scene:exitSelectMode()
	end)
	
	tinyMapNode.voice:setTouchEnded(function()
		if not self.m_isInVoiceRoom then
			local mapId = GamePlayer:getLegionMapId()
			if mapId > 0 then
				local key = "map_" .. GameUtil:int64ToString(GamePlayer:getLegionMapId())
				VoiceChatManager:joinTeamRoom(key)
			end
		else
			VoiceChatManager:exitRoom()
		end
	end)

	local targetNode = self.m_csNode.target
	local initialPosX = targetNode:getPositionX()
	local targetOffset = targetNode.bg:getContentWidth() + 6
	targetNode.jiantoubg:setTouch({
		getRect = function (touch)
            local rect = touch.sizeNode:getBoundingBox()
            local rectEx = touch.sizeNode.titlebg:getBoundingBox()
            return rect:merge(rectEx)
        end,
        onEnded = function()
            local target = targetNode
            local targetY = target:getPositionY()
            local targetX = initialPosX
            if self.m_taskIsShow then
                targetX = initialPosX - targetOffset
            end
            target:stopAllActions()
            target:runAction(cc.Sequence(cc.MoveTo(0.3, targetX ,targetY), cc.CallFunc(function ()
                self.m_taskIsShow = not self.m_taskIsShow
                local angle = 0
                if not self.m_taskIsShow then
                	angle = 180
                end
                targetNode.jiantoubg.jiantou:setAngle(angle)
            end)))
        end,
        isDynamic = true
    })

	-- 个人威望改成军团积分
    targetNode.item2.weiwang:setTouch({
        onEnded = function()
            g_scene:openDialog("Map.LegionIntegralPanel")
        end,
        isDynamic = true
    })
    targetNode.item2.juntuandashi:setTouch({
        onEnded = function()
            g_scene:openDialog("Achieve.JunTuanAchievePanel")
        end,
        isDynamic = true
    })
    targetNode.item2.zhanlingluoyang:setTouch({
        onEnded = function()
            g_scene:openDialog("Achieve.LegionWarSpecificActivityPanel",{map = self.m_map})
        end,
        isDynamic = true
    })

    for tabIndex=1, LegionUITabName.ktep3 do
        local btn = targetNode["tep"..tabIndex]
        btn:setTouch({
	        onEnded = function()
	            self:refreshTaskTab(tabIndex)
	        end,
	        isDynamic = true
	    })
    end
end

function This:refreshTaskTab(tabType)
    if not tabType then
        return
    end
    self.m_normalTabType = tabType
    for tabIndex=1,LegionUITabName.ktep3 do
        self.m_csNode.target["tep"..tabIndex].light:setVisible(tabType ==tabIndex)
        self.m_csNode.target["item"..tabIndex]:setVisible(tabType ==tabIndex)
    end
end

function This:refreshJtdsVisible()
	local jtdsIsEnd = AchieveManager:getJtdsIsEnd()
	local item2 = self.m_csNode.target.item2
	item2.juntuandashi:setVisible(not jtdsIsEnd)
	item2.zhanlingluoyang:setVisible(jtdsIsEnd)
end

function This:initTroopTreamNode()
	self.m_bianduiNode = LegionBianDuiNode:create({
		map = self.m_map
	})
	self.m_csNode.biandui:addChild(self.m_bianduiNode)
	self.m_bianduiNode:setScale(0.8)
end

function This:initMarchArmy()
	local marchList = self.m_map:getMarchList(function(march)
		return march:isMy()
	end)
	for i , march in ipairs(marchList) do
		local view = LegionMarchView:create({
			march = march,
			map = self.m_map
		})
		self.m_csNode.march.ScrollView:pushBackCustomItem(view,150,30,0.5)
	end
	-- self:refreshModelVisible()
end

function This:getAllCitys()
	return self.m_map:getAllCitys() or {}
end


function This:refreshCityCeil()
	local liangDianNode = self.m_liangDianNode
	if liangDianNode then
		liangDianNode:initCeils()
	end
end

function This:initMiniMap()
	local info = { 
		map = self.m_map, 
		scaleRate = 119 / 470,
		mapRadioX = 2.15,
		mapRadioY = 2.15,
		mapNode = self.m_csNode.smallmap.map, 
	}
	local liangDianNode = LegionMinMapNode:create(info)
	self:addChild(liangDianNode)
	liangDianNode:refresh()
	self.m_liangDianNode = liangDianNode

	self.m_rectW , self.m_rectH = 35, 25
	self.m_rectNode = cc.DrawNode:create()
	self.m_rectNode:drawRect(cc.Rect(0,0,self.m_rectW,self.m_rectH),cc.Color(255,255,0,255))
	self.m_csNode.smallmap.map.img:addChild(self.m_rectNode)

	local rx , ry = self.m_scene:getViewportCenterRatio()
	local w , h = self.m_csNode.smallmap.map.img:getContentSize()
	self.m_rectNode:setPosition(rx * w - self.m_rectW / 2, ry * h - self.m_rectH / 2)
end

function This:initDangerous()
	local marchList = self.m_map:getEnemyMarchArmyToMyCity()
	table.sort(marchList,function(a,b)
		return a:getStartTime() < b:getStartTime()
	end)
	local cityList = {}
	local citys = {}
	for i , march in ipairs(marchList) do
		local toCityId = march:getToCity()
		if not citys[toCityId] then
			table.insert(cityList,toCityId) 
			citys[toCityId] = {march}
		else
			table.insert(citys[toCityId],march)
		end
	end

	self.m_dangerViewList = {}
	local total = #self.m_dangerViewList 
	local fromIndex = total >= MaxDangerNum and total - MaxDangerNum + 1 or 1

	for i = fromIndex , #cityList  do
		local cityId = cityList[i]
		self:addDangerView(citys[cityId],cityId)
	end
end

function This:refreshBaseInfo()
	local copper, food , ore = math.floor(self.m_map:getCoin()), math.floor(self.m_map:getFood()), math.floor(self.m_map:getOre())
	local maxCopper, maxFood = math.floor(self.m_map:getRoleMaxCoin()), math.floor(self.m_map:getRoleMaxFood())
	local maxOre = math.floor(self.m_map:getRoleMaxOre())
	local maxFoodDesc = ItemUtil.customFormatCount(maxFood, 100000)
	local maxCopperDesc = ItemUtil.customFormatCount(maxCopper, 100000)
	local maxOreDesc = ItemUtil.customFormatCount(maxOre, 100000)
	if food < maxFood then
		food = ItemUtil.customFormatCount(food, 100000)
		self.m_csNode.res_info.food:setString(food .. "/" .. maxFoodDesc)
	else
		self.m_csNode.res_info.food:setStringWithColor("<R0>" .. maxFoodDesc .. "/" .. maxFoodDesc)
	end

	if copper < maxCopper then
		copper = ItemUtil.customFormatCount(copper, 100000)
		self.m_csNode.res_info.copper:setString(copper .. "/" .. maxCopperDesc)
	else
		self.m_csNode.res_info.copper:setStringWithColor("<R0>" .. maxCopperDesc .. "/" .. maxCopperDesc)
	end

	if ore < maxOre then
		ore = ItemUtil.customFormatCount(ore, 100000)
		self.m_csNode.res_info.mine:setString(ore .. "/" .. maxOreDesc)
	else
		self.m_csNode.res_info.mine:setStringWithColor("<R0>" .. maxOreDesc .. "/" .. maxOreDesc)
	end

--	self.m_csNode.res_info.kuang:setString(GameUtil:formatCount(self.m_map:getOre()))
end

function This:addDangerView(armyList,cityId,isInit)
	local function refreshContent()
		local w = 0
		for i , view in ipairs(self.m_dangerViewList) do
			view:setPositionX(w)
			w = w - view:getContentWidth()
		end
	end
	local function removeHandler(cityId)
		for i , view in ipairs(self.m_dangerViewList) do
			if view:getCityId() == cityId then
				view:removeFromParent()
				table.remove(self.m_dangerViewList,i)
				refreshContent()
				self:refreshModelVisible()
				break
			end
		end
	end

	local view = LegionMarchDangerView:create({armyList = armyList,map = self.m_map, cityId = cityId })
	view:setAnchorPoint(1.0,0.5)
	view:setRemoveHandler(removeHandler)
	view:setLookedHandler(refreshContent)
	view:setTouchHandler(function(id)
		self.m_scene:focuseCity(id)
	end)
	self.m_csNode.Dangerous:addChild(view)

	if #self.m_dangerViewList >= MaxDangerNum then
		local tmpView = self.m_dangerViewList[1]
		tmpView:removeFromParent()
		table.remove(self.m_dangerViewList,1)
	else
		table.insert(self.m_dangerViewList,view)
	end

	refreshContent()
	return view
end


function This:refreshTime()
	local curTime = GamePlayer:getServerTime()
	local curDate = os.date("*t",curTime)
	local fightTime = self.m_map:getFightTime()
	local juezhanTime = self.m_map:getJueZhanTime()
	if curTime < fightTime then
		local fightDate = os.date("*t",fightTime)
		if curDate.day ~= fightDate.day then
			self.m_csNode.smallmap.timetips.time:setString(string.format(Serialize[61886],fightDate.hour,fightDate.min,fightDate.sec))
		else
			self.m_csNode.smallmap.timetips.time:setString(string.format(Serialize[61887],fightDate.hour,fightDate.min,fightDate.sec))
		end
	elseif curTime < juezhanTime then
		local juezhanDate = os.date("*t",juezhanTime)
		if curDate.day ~= juezhanDate.day then
			self.m_csNode.smallmap.timetips.time:setString(string.format(Serialize[61888],juezhanDate.hour,juezhanDate.min,juezhanDate.sec))
		else
			self.m_csNode.smallmap.timetips.time:setString(string.format(Serialize[61889],juezhanDate.hour,juezhanDate.min,juezhanDate.sec))
		end
	else
		local time = self.m_map:getEndTime()
		local str = {Serialize[60012],Serialize[60013],Serialize[60014],Serialize[60015],Serialize[60016],Serialize[60097],Serialize[60978]}
		self.m_csNode.smallmap.timetips.time:setString(string.format(Serialize[61890],str[time.wday],time.hour, time.min,time.sec))
	end
end

function This:updateMiniMap(rx,ry)
	local cw, ch = self.m_csNode.smallmap.map:getContentSize()
	local w , h = self.m_csNode.smallmap.map.img:getContentSize()

	local y = ry * h - self.m_rectH / 2
	local topy = y + self.m_rectH
	if topy > ch then
		self.m_csNode.smallmap.map.img:setPositionY(ch - topy)
	end
	local x = rx * w - self.m_rectW / 2
	x = math.min(w - self.m_rectW, math.max(0,x))
	y = math.min(h - self.m_rectH, math.max(0,y))
	if self.m_rectNode then
		self.m_rectNode:setPosition(x,y)
	end
end

function This:refreshModelVisible()
    local sceneType = self.m_scene:getType()
    if sceneType ~= SceneType.kLegionScene then
		return    
    end

	local mode = self.m_scene:getShowMode()
	self.m_csNode.player_info:setVisible(mode == ShowMode.kNormal)
	self.m_csNode.res_info:setVisible(mode == ShowMode.kNormal)
	self.m_refreshModelVisible_count = (self.m_refreshModelVisible_count or 0) + 1
	-- self.m_csNode.huodong_button:setVisible(mode == ShowMode.kNormal)
	-- self.m_csNode.huodong:setVisible(mode == ShowMode.kNormal and self.m_csNode.huodong_button:getSwitchState())
	self.m_csNode.chat_node:setVisible(mode == ShowMode.kNormal)
	self.m_csNode.panel_btns:setVisible(mode == ShowMode.kNormal)
	self.m_csNode.march:setVisible(mode == ShowMode.kNormal)
	self.m_csNode.selectcity:setVisible(mode == ShowMode.kSelect)
	self.m_csNode.Dangerous:setVisible(mode == ShowMode.kNormal)
	self.m_csNode.close_bg:setVisible(mode == ShowMode.kNormal)
	self.m_csNode["goto"]:setVisible(mode == ShowMode.kNormal)
	self.m_csNode.smallmap:setVisible(mode == ShowMode.kNormal)
	self.m_csNode.biandui:setVisible(mode == ShowMode.kNormal)
	self.m_csNode.Dangerous:setVisible(#self.m_dangerViewList > 0)
	self.m_csNode.target:setVisible(mode == ShowMode.kNormal)
	local itemList = self.m_csNode.march.ScrollView:getItemList()
	self.m_csNode.march:setVisible(#itemList > 0)
end

function This:refresh()
	super.refresh(self)
	self:refreshBaseInfo()
	self:refreshJtdsVisible()
	self.m_csNode.goto.icon:clearShader()
end

-------------------------------------------------------------
function This:onCityInfoChanged(city)
	print("onCityInfoChanged") 
	self:refreshCityCeil()
end

function This:onGetMapInfoReply()
	self:refreshCityCeil()
end

function This:onAddMarch(march)
	if march:isMy() then
		local view = LegionMarchView:create({
			march = march,
			map = self.m_map
		})
		self.m_csNode.march.ScrollView:pushBackCustomItem(view,150,30,0.5)
		self:refreshModelVisible()
	end
	if not march:isOur() then
		local toCity = self.m_map:getCity(march:getToCity())
		if toCity:isOur() then
			for i , view in ipairs(self.m_dangerViewList) do
				if view:getCityId() == toCity:getId() then
					view:addMarch(march)
					return
				end
			end
			self:addDangerView({march},toCity:getId())
			self:refreshModelVisible()
		end
	end
end

function This:onDeleteMarch(march)
	if march:isMy() then
		local itemList = self.m_csNode.march.ScrollView:getItemList()
		for i , view in ipairs(itemList) do
			if view:getModel() == march then
				self.m_csNode.march.ScrollView:removeItem(i)
				self:refreshModelVisible()
				return
			end
		end
	end
end

function This:onUpdateMarch(march)
	if not march:isOur() then
		local city = self.m_map:getCity(march:getToCity())
		if city:isOur() then
			for i , view in ipairs(self.m_dangerViewList) do
				if view:getCityId() == city:getId() then
					view:addMarch(march)
					return
				end
			end
			self:addDangerView({march},city:getId())
			self:refreshModelVisible()
		end
	end
end

function This:onGeRenInfoChanged()
	self:refreshBaseInfo()
end

function This:onResChanged()
	self:refreshBaseInfo()
end


function This:onLegionResChanged(resType, oldvalue, newvalue)
    if resType == LegionMapResType.kCopper then
		local maxCopper = math.floor(self.m_map:getRoleMaxCoin())
		local maxCopperDesc = ItemUtil.customFormatCount(maxCopper, 100000)
		if newvalue < maxCopper then
			local copper = ItemUtil.customFormatCount(newvalue, 100000)
			self.m_csNode.res_info.copper:setString(copper .. "/" .. maxCopperDesc)
		else
			self.m_csNode.res_info.copper:setStringWithColor("<R0>" .. maxCopperDesc .. "/" .. maxCopperDesc)
		end
    elseif resType == LegionMapResType.kFood then
		local maxFood = math.floor(self.m_map:getRoleMaxFood())
		local maxFoodDesc = ItemUtil.customFormatCount(maxFood, 100000)
		if newvalue < maxFood then
			local food = ItemUtil.customFormatCount(newvalue, 100000)
			self.m_csNode.res_info.food:setString(food .. "/" .. maxFoodDesc)
		else
			self.m_csNode.res_info.food:setStringWithColor("<R0>" .. maxFoodDesc .. "/" .. maxFoodDesc)
		end
    elseif resType == LegionMapResType.kOre then
		local ore = ItemUtil.customFormatCount(newvalue, 100000)
		local maxOre = math.floor(self.m_map:getRoleMaxOre())
		local maxOreDesc = ItemUtil.customFormatCount(maxOre, 100000)
		if ore < maxOre then
			ore = ItemUtil.customFormatCount(ore, 100000)
			self.m_csNode.res_info.mine:setString(ore .. "/" .. maxOreDesc)
		else
			self.m_csNode.res_info.mine:setStringWithColor("<R0>" .. maxOreDesc .. "/" .. maxOreDesc)
		end
		--self.m_csNode.res_info.kuang:setString(GameUtil:formatCount(newvalue))
    end
end

function This:onLegionMapStartFight()
	self:refreshTime()
end

function This:onLegionMapStartJueZhan()
	self:refreshTime()
end

function This:onRefreshAchieve()
	self:refreshJtdsVisible()
end

function This:onGetLegionMapInfo()
    self.m_rankTableView:refreshLegionRanking()
end
