-- @Author: zheng
-- @Date:   2019-01-19 11:48:49
-- @Last Modified by:   zheng
-- @Last Modified time: 2019-11-07 20:02:13
-- @File Name: LegionWarBoxPanel.lua
-- 军团战宝箱弹出面板
-- LegionBoxState = {
--     kFuture = 1,    --预告
--     kAppear = 2,    --出现  一有宝箱
--     kEnd = 3,       --结束（结束的时候一定不会有宝箱）
-- }
-- local LegionWarBoxConfig = require("Metadatas.LegionWarBoxConfig")
local EventDispatcher = require("EventDispatcher")

local GameUtil = require("Util.GameUtil")
local GameMapManager = require("Map.GameMapManager")

local This , super = class(...,"Dialog")
This.fileName = "GameScene/NodeUI/TreasurePeerless.csb"
function This:initNode(info)
    -- if info then
    --    self.m_family = info.family
    -- end
    self.m_csNode = cc.Node:createFromCSFile(This.fileName)
    self.m_csNode:setToCenter()
    self:addChild(self.m_csNode)
    self.m_escape = 0
    self:getData()
    self:refresh()
end

function This:refresh()
    local function getCityName(cityId)
        local LegionCityConfig = require("Metadatas.LegionCityConfig")
        local cityItem = LegionCityConfig[cityId]
        if cityItem then
            return cityItem.city_name
        end
        return ""
    end
    local mMap = self.m_map
    local _,warBoxItem = mMap:getWarBoxId()
    local boxState,leftTime = mMap:getWarBoxLeftTime()
    -- local warBoxItem = LegionWarBoxConfig[1011]
    -- local boxState,leftTime = LegionBoxState.kAppear,16
    local futureNode = self.m_csNode.node1
    local appearNode = self.m_csNode.node2
    if warBoxItem then
        local cityIds = warBoxItem.city_id

        local needs = warBoxItem.reward_preview
        GameUtil:resetScoolItemNode(self.m_csNode.scrollview,needs)
        local futureVisible = true
        local str = Serialize["Map_BoxPanel_1"]
        local limit =350
        if boxState == LegionBoxState.kAppear then
            futureVisible = false
            str = str .. Serialize["Map_BoxPanel_2"]
            cityIds= self:getAppearCity()
            for cityIndex,cityId in ipairs(cityIds) do
                local cityName = ""
                if cityIndex~=1 then
                    cityName = cityName.."、"
                end
                cityName = cityName.."["..getCityName(cityId).."]"
                local name = appearNode["name"..cityIndex].txt
                name:setString(cityName)
                name:setVisible(true)
            end
            if #cityIds ~=4 then
               appearNode.name4.txt:setVisible(false)
            end
            appearNode.text1:setStringWithColor(str,limit)
        elseif boxState == LegionBoxState.kFuture then
            str = str .. Serialize["Map_BoxPanel_3"]
            for cityIndex,cityId in ipairs(cityIds) do
                if cityIndex~=1 then
                     str = str.."，"
                end
                str = str .. getCityName(cityId)
            end
            str = str .. Serialize["Map_BoxPanel_4"]
            futureNode.text1:setStringWithColor(str,limit)
        end
        futureNode:setVisible(futureVisible)
        appearNode:setVisible(not futureVisible)
        self:refreshTime()
    end
end

function This:refreshTime()
    local mMap = self.m_map
    local boxState,leftTime = mMap:getWarBoxLeftTime()
    -- if not self.m_leftTime  then
    --     self.m_leftTime = 1800
    -- end
    -- self.m_leftTime = self.m_leftTime-1
    -- local boxState,leftTime = LegionBoxState.kFuture ,self.m_leftTime

    local strFormat = Serialize["Map_BoxPanel_6_c"]..":"..Serialize["H_M_S"]
    if boxState == LegionBoxState.kAppear then
        strFormat = Serialize["Map_BoxPanel_5_c"]..":"..Serialize["H_M_S"]
    end
    local str = GameUtil:formatTime(strFormat,leftTime)
    self.m_csNode.time:setString(str)
end

function This:initTouchEvent()
	self.m_csNode.close:setTouchEnded(function()
       local mMap = self.m_map
       if not mMap:getBoxIsHaveAppear() then
           mMap:setBoxIsHaveAppear(true)
           EventDispatcher:dispatcher("legionWarBoxTipClose")
       end
        self:close()
    end)
    local appearNode = self.m_csNode.node2
    for nameIndex=1,3 do
        local nameNode = appearNode["name"..nameIndex]
        if nameNode then
            local bg= nameNode.bg
            bg:setTouch({
                        isAlpha = false,
                        isScale = false, 
                        isDynamic = true, 
                        onEnded = function ()
                            local cityId = self:getAppearCity()
                            -- print(cityId[nameIndex])
                            g_scene:focuseCity(cityId[nameIndex])
                            self:close()
                            g_scene:showTips(Serialize["world_SearchCity_3"])
                        end
                    })
        end
    end
end
--cityId列表
function This:getAppearCity()
    return self.m_map:getAppearCitys()
    -- return {11,12,13}--cityId列表
end

function This:update(dt)
    super.update(self,dt)
    self.m_escape = self.m_escape + dt
    if self.m_escape < 1 then
        return
    end
    self.m_escape = self.m_escape - 1
    self:refreshTime()
end

function This:getData()
	-- local mapType = GameMapManager:getMapType()
    self.m_map = GameMapManager:getMap(GameMapType.kLegionMap)
end
