--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"cc.Node")
local GameUtil = require("Util.GameUtil")

local YunKuangEffect = 
{
	[1] = {name = "zuo", isFlipX = true},
	[2] = {name = "xieshang", isFlipX = true},
	[3] = {name = "shang", isFlipX = false},
	[4] = {name = "xieshang", isFlipX = false},
	[5] = {name = "zuo", isFlipX = false},
	[6] = {name = "xiexia", isFlipX = false},
	[7] = {name = "xia", isFlipX = false},
	[8] = {name = "xiexia", isFlipX = true},
}

local YunKuangEffect2 = 
{
	[1] = {name = "zuo2", isFlipX = true},
	[2] = {name = "xieshang2", isFlipX = true},
	[3] = {name = "shang2", isFlipX = false},
	[4] = {name = "xieshang2", isFlipX = false},
	[5] = {name = "zuo2", isFlipX = false},
	[6] = {name = "xiexia2", isFlipX = false},
	[7] = {name = "xia2", isFlipX = false},
	[8] = {name = "xiexia2", isFlipX = true},
}


function This:init(info)
	self.m_cityNode = info.cityNode
	self.m_kongNode = info.kongNode
	self.m_isSmall = info.small
	local x1, y1 = self.m_cityNode:getPosition()
	local x2 , y2 = self.m_kongNode:getPosition()
	self:initYunKuang(x2,y2,x1,y1)
end

function This:getConfigWithDegree(degree,isTo)
	if degree < 0 then
		degree = 360 + degree
	end
	if degree > 360 then
		degree = degree - 360
	end
	local configList = isTo and YunKuangEffect or YunKuangEffect2
	for i , config in ipairs(configList) do
		if degree <= i * 45 - 22.5 then
			return config
		end
	end
	return configList[1]
end

function This:initYunKuang(x1,y1,x2,y2)
	local v = cc.Vec(x2 - x1,y2 - y1)
	local degree = v:getDegree()
	self.m_config1 = self:getConfigWithDegree(degree,true)
	self.m_config2 = self:getConfigWithDegree(degree + 180,false)
	self.m_startPos = cc.Vec(x1,y1)
	self.m_endPos = cc.Vec(x2,y2)

	self.m_kuang1 = GameUtil:createEffect("YunKuang",true)
	self.m_kuang1:setFlippedX(self.m_config1.isFlipX)
	self.m_kuang1:setPosition(x1,y1)
	self.m_kuang1:playAnimation(self.m_config1.name,true)
	self:addChild(self.m_kuang1)

	self.m_kuang2 = GameUtil:createEffect("YunKuang",true)
	self.m_kuang2:setFlippedX(self.m_config2.isFlipX)
	self.m_kuang2:setPosition(x2,y2)
	self.m_kuang2:playAnimation(self.m_config2.name,true)
	self:addChild(self.m_kuang2)
	self.m_kuang2:setVisible(false)

	local speed = 50
	local l = v:length()
	self.m_kuang1:runAction(cc.RepeatForever(cc.Sequence(
		cc.MoveTo(l/speed,x2,y2),
		cc.CallFunc(function()
			self.m_kuang1:setVisible(false)
			self.m_kuang1:setPosition(self.m_startPos.x,self.m_startPos.y)
		end),
		cc.DelayTime(1),
		cc.CallFunc(function()
			self.m_kuang2:setVisible(true)
			self.m_kuang2:setPosition(self.m_endPos.x,self.m_endPos.y)
			self.m_kuang2:runAction(cc.Sequence(
				cc.MoveTo(l/speed,x1,y1),
				cc.CallFunc(function()
					self.m_kuang2:setVisible(false)
					self.m_kuang2:setPosition(self.m_endPos.x,self.m_endPos.y)
				end)
			))
		end),
		cc.DelayTime(l/speed + 1),
		cc.CallFunc(function()
			self.m_kuang1:setVisible(true)
			self.m_kuang1:setPosition(self.m_startPos.x,self.m_startPos.y)
		end)
	)))
end

function This:isSmall()
    return self.m_isSmall
end



--endregion
