--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"Dialog")
local GameUtil = require("Util.GameUtil")
local GamePlayer = require("Player.GamePlayer")
local MatchingConfig = require("Metadatas.MatchingConfig")

This.openSound = "Open_Ui.mp3"

local ResultImg = {
	[ResultState.kSecceed] = "MenuScene/zbwin.png",
	[ResultState.kFailed] = "MenuScene/zbfail.png",
	[ResultState.kDogfall] = "MenuScene/zbdogfall.png",
}

function This:initNode(battleList)
	self.m_battleList = {}
	for id , report in pairs(battleList) do
		table.insert(self.m_battleList,report)
	end
	table.sort(self.m_battleList,function(a,b)
		return a.start_time > b.start_time
	end)
	self.m_csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/WarBattlefieldNew.csb")
	self:addChild(self.m_csNode)
	self.m_csNode:setToCenter()
	self:initItems()
end

function This:getItemNode(info, index)
	local node = cc.Node:createFromCSFile("MenuScene/NodeUI/WarBattlefieldNewItem2.csb")
	node.resuilt:setImage(ResultImg[info.state])
	local timeStr = GameUtil:formatDate(Serialize["y_m_d"].."\n"..Serialize["H_M"],info.start_time)
	node.normal.time:setString(timeStr)
	node.light.time:setString(timeStr)
	node:setTouch({
		onEnded = function()
			if self.m_index == index then
				return
			end
			self.m_index = index
			self.m_curSubNode = nil
			self.m_subIndex = nil
			self:selectItemNode(node,index)
			self:initSubItems(index)
		end,
		isContainer = true,
		isScale = false,
	})
	return node
end

function This:selectItemNode(node,index)
	if self.m_curNode then
        self.m_curNode.light:setVisible(false)
        self.m_curNode.normal:setVisible(true)
	end
	self.m_curNode = node
    self.m_curNode.light:setVisible(true)
    self.m_curNode.normal:setVisible(false)
end

function This:initItems()
	for i , info in ipairs(self.m_battleList) do
		local node = self:getItemNode(info,i)
		local w , h = node.normal:getContentSize()
		self.m_csNode.ScrollViewLeft:pushBackCustomItem(node, w, h-5, 0.5)
		if i == 1 then
			self:selectItemNode(node,i)
			self:initSubItems(i)
		end
	end
end

function This:selectSubItemNode(node,index)
	if self.m_curSubNode then
		self.m_curSubNode.bg:setImage("MenuScene/zhengbadian.png")
	end
	self.m_curSubNode = node
	self.m_curSubNode.bg:setImage("MenuScene/zhengbadiliang.png")
end

function This:getSubItemNode(info, index)
	local node = cc.Node:createFromCSFile("MenuScene/NodeUI/WarBattlefieldNewItem.csb")
	node.name:setString(info.name)
	local rankLv = info.rank_level == 0 and 1 or info.rank_level
	node.post:setString(MatchingConfig[rankLv].rank_level)
	node.score:setString(info.pingfen)
	node.kas:setString(string.format("%d/%d/%d",info.kill,info.assist,info.city_num))

	GameUtil:setPlayerIconNodeImage(node.icon, info.icon)
	local w, h = node.bg:getContentSize()
	node:setContentSize(w, h)
	node.bg:setTouch({
		onEnded = function()
			if self.m_subIndex == index then
				return
			end
			
			self.m_subIndex = index
			self:selectSubItemNode(node,i)
		end,
		isContainer = true,
		isScale = false,
	})
	return node
end

function This:initSubItems(index)
	self.m_csNode.ScrollViewRight:removeAllItems()
	local selfId = GamePlayer:getPlayerID()
	local firstIndex = 1
	local nodeList = {}
	for i , info in ipairs(self.m_battleList[index].score_list) do
		nodeList[i] = self:getSubItemNode(info, i)
		if info.id == selfId then
			firstIndex = i
		end
	end

	local firstNode = nodeList[firstIndex]
	local w , h = firstNode:getContentSize()
	self.m_csNode.ScrollViewRight:pushBackCustomItem(firstNode,w,h,0.5)
	self:selectSubItemNode(firstNode, 1)

	for i, node in ipairs(nodeList) do
		if i ~= firstIndex then
			self.m_csNode.ScrollViewRight:pushBackCustomItem(node,w,h,0.5)
		end
	end
end

function This:onTouchMask()
	self:close()
end

--endregion
