--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"cc.Node")
local GameUtil = require("Util.GameUtil")
local MatchManager = require("Match.MatchManager")

function This:init(box)
	self.m_box = box
	self.m_csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/MatchingMainBox.csb")
	self:addChild(self.m_csNode)
	local w , h = self.m_csNode.icon:getContentSize()
	self:setContentSize(w,h)
end

function This:initNode()
	self:refresh()
end

function This:initTouchEvent()
	self.m_csNode.icon:setTouchEnded(function()
		local state = self.m_box:getState()
		if state == BoxState.kOpening or state == BoxState.kLock then
			g_scene:openDialog("Match.BoxDescPanel",self.m_box)
		else
			MatchManager:onOpenBoxRequest(self.m_box:getIndex())
		end
	end)
end

function This:refresh()
	local state = self.m_box:getState()
	self.m_csNode.cd:setVisible(state == BoxState.kOpening)
	self.m_csNode.text:setVisible(state == BoxState.kReceive)
	self.m_csNode.time:setVisible(state == BoxState.kLock)
	self.m_csNode.diamondicon:setVisible(state ~= BoxState.kReceive)
	self.m_csNode.diamond:setVisible(state == BoxState.kOpening or state == BoxState.kLock)
	self.m_csNode.click:setVisible(state == BoxState.kLock)
	if state == BoxState.kOpening then
		local time = self.m_box:getLeftTime()
		self.m_csNode.cd:setString(GameUtil:formatTime(Serialize["H_M_S"],time))
	elseif state == BoxState.kLock then
		local str = GameUtil:formatTime(Serialize["H_M_S"],self.m_box:getUnlockTime())
		self.m_csNode.time:setString(str)
	end
	self.m_csNode.diamond:setString(""..self.m_box:getRecieveCost())
end

function This:setModel(model)
	if self.m_box:getIndex() ~= model:getIndex() then
		self.m_box:removeObserver(self)
		self.m_box = model
		self.m_box:addObserver(self)
		self:refresh()
	end
end

function This:onEnter()
	super.onEnter(self)
	self:initNode()
	self:initTouchEvent()
	self.m_box:addObserver(self)
end

function This:onExit()
	super.onExit(self)
	self.m_box:removeObserver(self)
end

function This:updateTime(leftTime)
	self.m_csNode.cd:setString(GameUtil:formatTime(Serialize["H_M_S"],leftTime))
end

function This:onBoxUpdateEnd(box)
	self:refresh()
end

function This:onInfoChanged()
	self:refresh()
end

--endregion
