--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"Dialog")
local GameUtil = require("Util.GameUtil")
local MatchingConfig = require("Metadatas.MatchingConfig")
local MatchManager = require("Match.MatchManager")

function This:initData( info )
    if info then
		self.m_role = info.role
		self.m_relation = info.relation
    end
end

function This:initNode(info)
	self.m_csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/TeamMatchingInvitationPopup.csb")
	self:addChild(self.m_csNode)
	self.m_csNode:setToCenter()

	GameUtil:setPlayerIconNodeImage(self.m_csNode.icon, self.m_role:getIcon())
	self.m_csNode.name:setString(self.m_role:getName())
	self.m_csNode.office:setString(MatchingConfig[self.m_role:getRank()].rank_level)
	self.m_csNode.level:setString(string.format("Lv.%d",self.m_role:getLevel()))
	self:refreshContent(info)
	self.m_escape = 0
	self.m_totalTime = info.time or 10
	self.m_csNode.time:setString(string.format(Serialize[61506],self.m_totalTime))
	self.m_csNode:setScale(0)
end

function This:refreshContent(info)
	if self.m_relation == RelationType.kTongMeng then
		self.m_csNode.type:setString(Serialize[61907])
	else
		self.m_csNode.type:setString(Serialize[61908])
	end
end

function This:initTouchEvent()
	self.m_csNode.close:setTouch({
		onEnded = function()
			self:reponseRequest(false)
			self:close()
		end,
		isDynamic = true
	})
	self.m_csNode.cancel:setTouch({
		onEnded = function()
			self:reponseRequest(false)
		end,
		isDynamic = true
	})
	self.m_csNode.confirm:setTouch({
		onEnded = function()
			self:reponseRequest(true)
		end,
		isDynamic = true
	})
end

function This:onEnter()
	super.onEnter(self)
	self:addCustomListener()
	self:scheduleUpdate()
end

function This:onExit()
	self:removeCustomListener()
	super.onExit(self)
end

function This:addCustomListener()
	MatchManager:addObserver(self)
end

function This:removeCustomListener()
	MatchManager:removeObserver(self)
end

function This:reponseRequest( value )
	MatchManager:onReponseTeamMatchRequest(self.m_role:getId(), value)
end

function This:runOpenAnimation()
	self.m_csNode:runAction(cc.Sequence(
		cc.ScaleTo(0.5,1.0,"ElasticInOut"),
		cc.CallFunc(function()
			self:onOpen()
		end)
	))
end

function This:onReponseTeamMatch(code,friendId,isAgree)
	if isAgree then
		g_scene:openDialog("Match.BuildRoomPanel")
	end
	self:close()
end

function This:update(dt)
	super.update(self,dt)
	self.m_escape = self.m_escape + dt
	if self.m_escape > 1 then
		self.m_escape = self.m_escape - 1
		self.m_totalTime = self.m_totalTime - 1
		if self.m_totalTime <= 0 then
			self:reponseRequest(false)
			self:close()
		else
			self.m_csNode.time:setString(string.format(Serialize[61506],self.m_totalTime))
		end
	end
end

--endregion
