--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"cc.Node")
local MatchConfig = require("Metadatas.MatchingConfig")
local GameUtil = require("Util.GameUtil")
local MatchManager = require("Match.MatchManager")

function This:init(invite)
	self.m_invite = invite
	self.m_csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/TeamMatchingFriendList.csb")
	self:addChild(self.m_csNode)
	local w , h = self.m_csNode.bg:getContentSize()
	self:setContentSize(w,h)
end

function This:initBaseInfo()
	self.m_csNode.name:setString(self.m_invite:getName())
	local rankLv = self.m_invite:getRankLv()
	local config = MatchConfig[rankLv or 1]
	self.m_csNode.office:setString(config.rank_level)
	GameUtil:setPlayerIconNodeImage(self.m_csNode.icon, self.m_invite:getIcon())
	self.m_csNode.level:setString("Lv." .. (self.m_invite:getLevel() or 1))
	self.m_csNode.cd:setVisible(false)
	self:refresh()
end

function This:refresh()
	self.m_csNode.online:setVisible(not self.m_invite:isInMap() and self.m_invite:isOnline())
	self.m_csNode.outline:setVisible(not self.m_invite:isOnline())
	self.m_csNode.gaming:setVisible(self.m_invite:isInMap())

	local inviteType = self.m_invite:getSendType()
	self.m_csNode.yiyaoqing:setVisible(inviteType ~= MatchRelationType.kSingle)
	local room = MatchManager:getRoom()

	self.m_csNode.button:setVisible(self.m_invite:isOnline() 
		and not self.m_invite:isInMap() 
		and not room:getRole(self.m_invite:getId())
		and self.m_invite:getMatchType() == room:getMatchType()
	)
end

function This:initTouchEvent()
	self.m_csNode.button:setTouch({
		onEnded = function()
			local room = MatchManager:getRoom()
			local relationType = room:getRelationType()
			MatchManager:onInviteFriendRequest(self.m_invite:getId(),relationType)
		end,
		isContainer = true,
		isScale = false
	})
	self.m_csNode.iconbg:setTouch({
		onEnded = function()
			g_scene:openDialog("Player.RoleInfoPanel",{id = self.m_invite:getId()})
		end,
		isScale = false,
		isContainer = true
	})
end

function This:getModel()
	return self.m_invite
end

function This:onEnter()
	super.onEnter(self)
	self.m_invite:setView(self)
	self:initBaseInfo()
	self:initTouchEvent()
end

function This:onExit()
	super.onExit(self)
	self.m_invite:setView(nil)
end

function This:refreshTime(leftTime)
	local room = MatchManager:getRoom()
	self.m_csNode.cd:setString(math.floor(leftTime) .. Serialize[60010])
	self.m_csNode.cd:setVisible(leftTime > 0 )
	self.m_csNode.button:setVisible(leftTime <= 0)

	if leftTime <= 0 then
		self:refresh()
	end
end

--endregion
