--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"Dialog")
local GamePlayer = require("Player.GamePlayer")
local GuideManager = require("Guide.GuideManager")
local MatchingAreaConfig = require("Metadatas.MatchingAreaConfig")
local MatchingConfig = require("Metadatas.MatchingConfig")

function This:initNode(msg)
	self.m_csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/MatchingEndRewardNew.csb")
	self:addChild(self.m_csNode)
	self.m_csNode:setToCenter()
	self.m_csNode.bg2:fitScreenX()
	self.m_csNode.bg1:fitScreenX()
	self.m_csNode.bg3:fitScreen()

	self.m_msg = msg
	self:initBaseInfo()
end

function This:initBaseInfo()
	local function arrayToKey(array)
		local result = {}
		for i , info in ipairs(array) do
			result[info.id] = info.num
		end
		return result
	end

	local itemId = {104,101,107,112}
	local total = {}

	local reward1 = arrayToKey(self.m_msg.reward.base_reward)
	for i , id in ipairs(itemId) do
		self.m_csNode["areareward"..i]:setString(reward1[id] or 0)
		total[id] = total[id] or 0
		total[id] = total[id] + (reward1[id] or 0)
	end
	local reward2 = arrayToKey(self.m_msg.reward.kill_reward)
	for i , id in ipairs(itemId) do
		self.m_csNode["beatreward"..i]:setString(reward2[id] or 0)
		total[id] = total[id] or 0
		total[id] = total[id] + (reward2[id] or 0)
	end
	local reward3 = arrayToKey(self.m_msg.reward.time_reward)
	for i , id in ipairs(itemId) do
		self.m_csNode["timereward"..i]:setString(reward3[id] or 0)
		total[id] = total[id] or 0
		total[id] = total[id] + (reward3[id] or 0)
	end
	local reward4 = arrayToKey(self.m_msg.reward.win_reward)
	for i , id in ipairs(itemId) do
		self.m_csNode["unifiedreward"..i]:setString(reward4[id] or 0)
		total[id] = total[id] or 0
		total[id] = total[id] + (reward4[id] or 0)
	end
	local reward5 = arrayToKey(self.m_msg.reward.master_reward)
	for i , id in ipairs(itemId) do
		self.m_csNode["masterreward"..i]:setString(reward5[id] or 0)
		total[id] = total[id] or 0
		total[id] = total[id] + (reward5[id] or 0)
	end

	self.m_csNode.allexpreward:setString(total[itemId[1]])
	self.m_csNode.allmoneyreward:setString(total[itemId[2]])
	self.m_csNode.allmilitaryreward:setString(total[itemId[3]])
	self.m_csNode.allarmreward:setString(total[itemId[4]])

	for i , info in ipairs(self.m_msg.score_list) do
		if info.id == GamePlayer:getPlayerID() then
			self.m_csNode.descrp:setStringWithColor(string.format(Serialize[61911],info.kill,info.city_num))
			break
		end
	end
	local scale = self.m_csNode.jixu:getScale()
	self.m_csNode.jixu:runAction(cc.RepeatForever(cc.Sequence(cc.ScaleTo(1,1.2* scale),cc.ScaleTo(1,scale))))

	local matchType = self.m_msg.match_type > 0 and self.m_msg.match_type or 1
	local areaId = MatchingConfig[matchType].matching_area
	self.m_csNode.area:setString(MatchingAreaConfig[areaId].rank_name)

	if self.m_msg.state == BattleResult.kAttackerVictory then
		if self.m_msg.is_master then
			self.m_csNode.result:setImage("Common/win2.png")
		elseif self.m_msg.is_colleague then
			self.m_csNode.result:setImage("Common/win1.png")
		elseif self.m_msg.is_ally then
			self.m_csNode.result:setImage("Common/win3.png")
		else
			self.m_csNode.result:setImage("Common/win2.png")
		end
	elseif self.m_msg.state == BattleResult.kDogfall then
		self.m_csNode.result:setImage("Common/pingju2.png")
	end
end

function This:onTouchMask()
	if g_setting.isGuide and GuideManager:isInGuide() then
		g_scene:openDialog("Match.ShengZhiPanel")
	else
		cc.SceneManager:switchTo("Home.MenuScene")
	end
end

--endregion
