--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"Dialog")
local GamePlayer = require("Player.GamePlayer")
local MatchingConfig = require("Metadatas.MatchingConfig")
local MatchManager = require("Match.MatchManager")
local GameUtil = require("Util.GameUtil")

RankIconImage = 
{
	[1] = "Common/dw/dw1.png",
	[2] = "Common/dw/dw2.png",
	[3] = "Common/dw/dw3.png",
	[4] = "Common/dw/dw4.png",
	[5] = "Common/dw/dw5.png",
	[6] = "Common/dw/dw6.png",
	[7] = "Common/dw/dw7.png",
	[8] = "Common/dw/dw8.png",
	[9] = "Common/dw/dw9.png",
	[10] = "Common/dw/dw10.png",
	[11] = "Common/dw/dw11.png",
	[12] = "Common/dw/dw12.png",
	[13] = "Common/dw/dw13.png",
	[14] = "Common/dw/dw14.png",
	[15] = "Common/dw/dw15.png",
	[16] = "Common/dw/dw16.png",
	[17] = "Common/dw/dw17.png",
	[18] = "Common/dw/dw18.png",
	[19] = "Common/dw/dw19.png",
	[20] = "Common/dw/dw20.png",
	[21] = "Common/dw/dw21.png",
	[22] = "Common/dw/dw22.png",
	[23] = "Common/dw/dw23.png",
	[24] = "Common/dw/dw24.png",
	[25] = "Common/dw/dw25.png"
}

function This:initNode(msg)
	self.m_state = msg.state
	self.m_curScore = msg.score
	self.m_curRank = msg.rank_level

	self.m_winScore = msg.win_add_score
	self.m_skillScore = msg.kill_add_score
	self.m_msg = msg

	local playerId = GamePlayer:getPlayerID()
	for i , info in ipairs(msg.score_list) do
		if info.id == playerId then
			self.m_preScore = info.score
			self.m_preRank = info.rank_level
			break
		end
	end
	self.m_csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/MatchingEndNew.csb")
	self:addChild(self.m_csNode)
	self.m_csNode.bg:fitScreen()
	self.m_csNode:setToCenter()

	self:initAction()
end

function This:initAction()
	self.m_rank = self.m_preRank
	self.m_score = self.m_preScore
	
	self.m_isFinish = false
	self.m_isUp = self.m_curRank > self.m_preRank or (self.m_curRank == self.m_preRank and self.m_curScore > self.m_preScore)
	
	if self.m_rank == self.m_curRank then
		self.m_toScore = self.m_curScore
	elseif self.m_rank < self.m_curRank then
		self.m_toScore = MatchingConfig[self.m_rank].score
	else
		self.m_toScore = 0
	end
	self.m_csNode.marquisname:setString(MatchingConfig[self.m_rank].rank_level)
	self.m_csNode.jifenbar:setPercent(self.m_curScore / MatchingConfig[self.m_rank].score * 100)
	self.m_csNode.info.jifen2:setString(string.format(Serialize[61913],self.m_skillScore))
	self.m_csNode.marquisicon:setImage(RankIconImage[self.m_rank])
	if self.m_state == ResultState.kSecceed then
		self.m_csNode.info.result:setString(Serialize[61914])
		self.m_csNode.info.jifen1:setString(string.format(Serialize[61913],self.m_winScore))
	elseif self.m_state == ResultState.kDogfall then
		self.m_csNode.info.result:setString(Serialize[61915])
		self.m_csNode.info.jifen1:setString(string.format(Serialize[61913],self.m_winScore))
	elseif self.m_state == ResultState.kFailed then
		self.m_csNode.info.result:setString(Serialize[61916])
		self.m_csNode.info.jifen1:setString(string.format(Serialize[61917],self.m_winScore))
	end
	self.m_csNode.info:setVisible(false)
	local scale = self.m_csNode.info.jixu:getScale()
	self.m_csNode.info.jixu:runAction(cc.RepeatForever(cc.Sequence(cc.ScaleTo(1,1.2* scale),cc.ScaleTo(1,scale))))
end

function This:addRankAction()
	if self.m_rank < self.m_curRank then
		self.m_rank = self.m_rank + 1
		if self.m_rank < self.m_curRank then
			self.m_toScore = MatchingConfig[self.m_rank].score
		else
			self.m_toScore = self.m_curScore
		end
		self.m_score = 0
		self.m_csNode.marquisname:setString(MatchingConfig[self.m_rank].rank_level)
		self.m_csNode.marquisicon:setImage(RankIconImage[self.m_rank])

		local sprite = cc.Sprite:create(RankIconImage[self.m_rank])
		local w1 , h1 = self.m_csNode.marquisicon:getContentSize()
		x1 , y1 = self.m_csNode.marquisicon:convertToWorldSpace(w1/2,h1/2)
		sprite:setPosition(x1,y1)
		sprite:runAction(cc.Sequence(
			cc.Spawn(cc.ScaleTo(0,3),cc.FadeOut(0)),
		  	cc.Spawn(cc.ScaleTo(0.18,0.8),cc.FadeIn(0.18)),
			cc.ScaleTo(0.1,0.95),
			cc.ScaleTo(0.15,0.85),
			cc.ScaleTo(0.2,0.9),
			cc.FadeOut(0.8),
			cc.RemoveAction()))
		self:addChild(sprite)
	else
		self.m_isFinish = true
	end
end

function This:reduceRankAction()
	if self.m_rank > self.m_curRank then
		self.m_rank = self.m_rank - 1
		if self.m_rank > self.m_curRank then
			self.m_toScore = 0
		else
			self.m_toScore = self.m_curScore	
		end
		
		self.m_score = MatchingConfig[self.m_rank].score
		self.m_csNode.marquisname:setString(MatchingConfig[self.m_rank].rank_level)
		self.m_csNode.marquisicon:setImage(RankIconImage[self.m_rank])

		local sprite = cc.Sprite:create(RankIconImage[self.m_rank])
		local w1 , h1 = self.m_csNode.marquisicon:getContentSize()
		x1 , y1 = self.m_csNode.marquisicon:convertToWorldSpace(w1/2,h1/2)
		sprite:setPosition(x1,y1)
		sprite:runAction(cc.Sequence(
			cc.Spawn(cc.ScaleTo(0,3),cc.FadeOut(0)),
		  	cc.Spawn(cc.ScaleTo(0.18,0.8),cc.FadeIn(0.18)),
			cc.ScaleTo(0.1,0.95),
			cc.ScaleTo(0.15,0.85),
			cc.ScaleTo(0.2,0.9),
			cc.FadeOut(0.8),
			cc.RemoveAction()))
		self:addChild(sprite)
	else
		self.m_isFinish = true
	end
end

function This:onEnter()
	super.onEnter(self)
	self:scheduleUpdate()
end

function This:onTouchMask()
	if self.m_isFinish then
		self:close()
		g_scene:openDialog("Match.MatchBattleDetailPanel",self.m_msg)
	end
end

function This:finishAction()
	self:unscheduleUpdate()
	self.m_csNode.info:setVisible(true)
	self.m_csNode.jifenbar:setPercent(self.m_score / MatchingConfig[self.m_rank].score * 100)
	self.m_csNode.jifen:setString(string.format("%d/%d",self.m_score,MatchingConfig[self.m_rank].score))

	self:refreshRewardBoxes()
end

function This:refreshRewardBoxes()
	local qualityList = MatchManager:getNewBoxQualityList()
	local nodeList = {[1]=self.m_csNode.info.boxtext}
	local totalNum, index = 0, 0
	for quality, count in pairs(qualityList) do
		index = index + 1
		totalNum = totalNum + count
		local qualityNode = self.m_csNode.info["boxquality" .. index]
		qualityNode:setImage("MenuScene/boxGet" .. quality .. ".png")
		qualityNode:setVisible(false)
		table.insert(nodeList, qualityNode) 

		local numNode = self.m_csNode.info["boxnum" .. index]
		numNode:setString("+" .. count)
		numNode:setVisible(false)
		table.insert(nodeList, numNode)
	end

	self.m_csNode.info.boxtext:setVisible(false)
	if (self.m_state == ResultState.kSecceed and totalNum < 2) or (self.m_state ~= ResultState.kSecceed and totalNum < 1) then
		self.m_csNode.info.boxtips:setVisible(false)
		table.insert(nodeList, self.m_csNode.info.boxtips)
	else
		self.m_csNode.info.boxtips:setVisible(false)
	end
	GameUtil:linearLayoutNodes(3, nodeList, false, self.m_csNode.bg:getContentWidth())	
	MatchManager:setEnableShowReward(true)
end

function This:update(dt)
	if self.m_isFinish then
		self:finishAction()
		return
	end
	if self.m_isUp then
		if self.m_score >= self.m_toScore then
			self:addRankAction()
		else
			self.m_score = self.m_score + dt * 10
			self.m_csNode.jifenbar:setPercent(self.m_score / MatchingConfig[self.m_rank].score * 100)
			self.m_csNode.jifen:setString(string.format("%d/%d",self.m_score,MatchingConfig[self.m_rank].score))
		end
	else
		if self.m_score <= self.m_toScore then
			self:reduceRankAction()
		else
			self.m_score = self.m_score - dt * 10
			self.m_csNode.jifenbar:setPercent(self.m_score / MatchingConfig[self.m_rank].score * 100)
			self.m_csNode.jifen:setString(string.format("%d/%d",self.m_score,MatchingConfig[self.m_rank].score))
		end
	end
end

--endregion
