-- @Author: superm
-- @Date:   2018-04-02 10:26:03
-- @Last Modified by:   superm
-- @Last Modified time: 2018-04-11 17:28:26
-- @File Name: MatchFightTimeTipPanel.lua
-- @Description: 

local This , super = class(...,"Dialog")
local GameUtil = require("Util.GameUtil")
local WorldMapManager = require("World.WorldMapManager")

This.maskOpacity = 0

function This:initData( info )
    self.m_fightTime = info.time
	self:addCloseCallback(info.callback)
	self.m_noTipsValue = false
end

function This:initNode()
	self.m_csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/timecue.csb")
	self:addChild(self.m_csNode)
	self.m_csNode:setToCenter()

	self.m_csNode.time:setString(GameUtil:formatDate(Serialize["H_M_S"], self.m_fightTime))
end

function This:initTouchEvent()
	self.m_csNode.close:setTouchEnded(function()
		self:close()
	end)

	self.m_csNode.kuang:setTouchEnded(function()
        local visible = self.m_csNode.gou:isVisible()
        self.m_csNode.gou:setVisible(not visible)
        self.m_noTipsValue = not visible
	end)
end

function This:close()
	if self.m_noTipsValue then
		WorldMapManager:saveShowNextFightTimeTipRecord(false)
	end
	super.close(self)
end

-- function This:onTouchMask()
-- 	self:close()
-- end
