--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"Dialog")
local MatchingConfig = require("Metadatas.MatchingConfig")
local GameUtil = require("Util.GameUtil")

local TitleImage = 
{
	[TitleType.kBazhu] = "MenuScene/pingfen_1.png",
	[TitleType.kMvp] = "MenuScene/pingfen_2.png",
	[TitleType.kZhanshen] = "MenuScene/pingfen_3.png",
	[TitleType.kJunShi] = "MenuScene/pingfen_4.png",
}

function This:initNode(info)
	self.m_infoList = info.infoList
	self.m_state = info.state
	self.m_csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/MatchingEndInformation.csb")
	self:addChild(self.m_csNode)
	self.m_csNode:setToCenter()
	self.m_csNode.dogfall:setVisible(self.m_state == ResultState.kDogfall)
	self.m_csNode.lose:setVisible(self.m_state == ResultState.kFailed)
	self.m_csNode.win:setVisible(self.m_state == ResultState.kSecceed)
	self:initItems()
end

function This:getItemNode(info)
	local node = cc.Node:createFromCSFile("MenuScene/NodeUI/MatchingEndItem.csb")
	node.name:setString(info.name)
	local rankLv = info.rank_level == 0 and 1 or info.rank_level
	node.marquise:setString(MatchingConfig[rankLv].rank_level)
	node.score:setString(info.pingfen)
	node.ksc:setString(string.format("%d/%d/%d",info.kill,info.assist,info.city_num))

	local tmp = {}
	for i , key in ipairs(info.title_list) do
		tmp[key] = true
	end

	for i = 1 , 4 do
		if info.title_list[i] then
			node["achievement"..i]:setImage(TitleImage[info.title_list[i]])
		else
			node["achievement"..i]:setVisible(false)
		end
	end
	GameUtil:setPlayerIconNodeImage(node.touxiang, info.icon)
	local w , h = node.bg:getContentSize()
	node:setContentSize(w,h)
	return node
end

function This:initItems()
	for i , info in ipairs(self.m_infoList) do
		local node = self:getItemNode(info)
		local w , h = node:getContentSize()
		self.m_csNode.itemScroll:pushBackCustomItem(node,w,h,0.5)
	end
end

function This:onTouchMask()
	self:close()
end

--endregion
