--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"Base.BaseModel")
local FriendManager = require("Friend.FriendManager")
local Application = require("cc.Application")
local MatchManager = require("Match.MatchManager")

function This:init(info)
	super.init(self)
	self.m_escape = 0
	self.m_friendId = info.friend_id
	self.m_name = info.friend_name
	self.m_icon = info.friend_icon
	self.m_level = info.friend_level
	self.m_rank = info.friend_rank_level
	self.m_groupId = info.friend_group_id
	self.m_groupName = info.friend_group_name
	self.m_groupTitle = info.friend_group_title
	self.m_isInMap = info.in_map
	self.m_isOnline = info.online
	self.m_sendType = MatchRelationType.kSingle
	self.m_matchType = info.match_type
	self.m_view = nil
end

function This:getId()
	return self.m_friendId
end

function This:setSendType(relationType)
	if self.m_sendType ~= relationType then	
		self.m_sendType = relationType
		if self.m_sendType > 0 then
			self:startUpdate()
		end
	end
end

function This:getSendType()
	return self.m_sendType
end

function This:getName()
	return self.m_name
end

function This:getLevel()
	return self.m_level
end

function This:getIcon()
	return self.m_icon
end

function This:getRankLv()
	return self.m_rank > 0 and self.m_rank or 1
end

function This:getGroupId()
	return self.m_groupId
end

function This:getGroupName()
	return self.m_groupName
end

function This:isInMap()
	return self.m_isInMap
end

function This:setView(view)
	self.m_view = view
end

function This:getView()
	return self.m_view
end

function This:isOnline()
	return self.m_isOnline
end

function This:getState()
	if self.m_isInMap then
		return InviteState.kInMap
	elseif self.m_isOnline then
		return InviteState.kOnline
	else
		return InviteState.kOffline
	end
end

function This:getMatchType()
	return self.m_matchType
end

function This:startUpdate()
	self.m_escape = 0
	Application:addToUpdateList(self)
end

function This:endUpdate()
	Application:removeFromUpdateList(self)
	local room = MatchManager:getRoom()
	self.m_sendType = MatchRelationType.kSingle
end

function This:clear()
	self:endUpdate()
end

function This:update(dt)
	local maxCd = 10
	self.m_escape = self.m_escape + dt
	local room = MatchManager:getRoom()

	if self.m_escape >= maxCd or room:getRole(self.m_friendId) then
		self:endUpdate()
		if self.m_view then
			self.m_view:refreshTime(0)
		end
	else
		if self.m_view then
			self.m_view:refreshTime(maxCd - self.m_escape)
		end
	end
end


--endregion
