--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"Base.BaseModel")
local EventDispatcher = require("EventDispatcher")
local Socket = require("Net.Socket")
local MatchBox = require("Match.MatchBox")
local GamePlayer = require("Player.GamePlayer")
local MatchInvite = require("Match.MatchInvite")
local MatchRoom = require("Match.MatchRoom")
local MatchUtil = require("Match.MatchUtil")
local MatchingConfig = require("Metadatas.MatchingConfig")
local WarBoxConfig = require("Metadatas.WarBoxConfig")
local PopDialogManager = require("UI.PopDialogManager")
local ArgConfig = require("Metadatas.ArgConfig")
local VipManager = require("Vip.VipManager")
local EntrantManager = require("LegionEntrant.EntrantManager")

InviteType = 
{
	kFriend = 1, --好友邀请
	kGroup = 2, --军团邀请
}

InviteState = 
{
	kInMap = 1, --
	kOnline = 2,
	kOffline = 3,
}

kSecceedFinishNumLimit = 10

function This:init()
	super.init(self)
	self.m_box = {}
	self.m_newBoxIdList = {}
	self.m_observers = {}
	-- self.m_merit = 0
	self.m_matchResult = {}
	self.m_star = 0
	self.m_rankLv = 0
	self.m_maxRankLvInHistory = 0
	self.m_seasonMaxRankLv = 0
	self.m_score = 0
	self.m_isInit = false
	self.m_battleReports = {}

	self.m_isGotDailyReward = false		--今日是否领取了奖励
	self.m_levelListGotReward = {}		--已经领取的爵位列表

	self:initListener()
end

function This:initListener()
	EventDispatcher:addListener(self,11211,self.onOpenBoxReply)
	EventDispatcher:addListener(self,11212,self.onGetBoxInfoReply)
	EventDispatcher:addListener(self,11213,self.onUnlockBoxReply)
	EventDispatcher:addListener(self,11218,self.onFinishBoxCDReply)

	EventDispatcher:addListener(self,11200,self.onGetMatchInfoReply)
	EventDispatcher:addListener(self,11201,self.onApplyTeamMatchReply)
	EventDispatcher:addListener(self,11202,self.onReponseTeamMatchReply)
	EventDispatcher:addListener(self,11203,self.onPrepareMatchReply)
	EventDispatcher:addListener(self,11204,self.onMatchBattleReply)
	EventDispatcher:addListener(self,11205,self.onInvitateMatchNotify)
	EventDispatcher:addListener(self,11206,self.onExitTeamMatchReply)
	EventDispatcher:addListener(self,11207,self.onBattleSettlementNotify)
	EventDispatcher:addListener(self,11208,self.onRoomChangedNotify)
	EventDispatcher:addListener(self,11209,self.onInviteFriendReply)
	EventDispatcher:addListener(self,11210,self.onChangeRoomOwnerReply)
	EventDispatcher:addListener(self,10209,self.onGetSeasonInfoReply)
	EventDispatcher:addListener(self,11214,self.onGetBattleListReply)

	EventDispatcher:addListener(self, 11215, self.onPickUpDailyRewardReply)
	EventDispatcher:addListener(self, 11216, self.onPickUpLevelRewardReply)
	EventDispatcher:addListener(self, 11217, self.onGetRewardInfoReply)

	EventDispatcher:addListener(self, "day_passed",self.onDayPassed)
end

function This:removeListener()
	EventDispatcher:removeListener(self,11211)
	EventDispatcher:removeListener(self,11212)
	EventDispatcher:removeListener(self,11213)
	EventDispatcher:removeListener(self,11200)
	EventDispatcher:removeListener(self,11201)
	EventDispatcher:removeListener(self,11202)
	EventDispatcher:removeListener(self,11203)
	EventDispatcher:removeListener(self,11204)
	EventDispatcher:removeListener(self,11205)
	EventDispatcher:removeListener(self,11206)
	EventDispatcher:removeListener(self,11207)
	EventDispatcher:removeListener(self,11208)
	EventDispatcher:removeListener(self,11208)
	EventDispatcher:removeListener(self,11210)
	EventDispatcher:removeListener(self,10209)
	EventDispatcher:removeListener(self,11214)
	EventDispatcher:removeListener(self,11215)
	EventDispatcher:removeListener(self,11216)
	EventDispatcher:removeListener(self,11217)
	EventDispatcher:removeListener(self,11218)
	
	EventDispatcher:removeListener(self, "day_passed")
end

-- function This:getMerit()
-- 	return self.m_merit
-- end

function This:getStar()
	return self.m_star
end

function This:getRankLv()
	return self.m_rankLv > kMaxMatchRankLv and kMaxMatchRankLv or self.m_rankLv
end

function This:getRankName(rank)
	rank = rank or self.m_rankLv
	local rank = rank > 0 and rank or 1
	return MatchingConfig[rank].rank_level
end

function This:getMaxRankLvInHistory()
	return self.m_maxRankLvInHistory > kMaxMatchRankLv and kMaxMatchRankLv or self.m_maxRankLvInHistory
end

function This:getPrivilegeNumBy( name )
	local maxLevel = self:getMaxRankLvInHistory()
    return MatchingConfig[maxLevel][name] or 0
end

function This:getScore()
	return self.m_score
end

function This:getAllBox()
	return self.m_box
end

function This:getBox(index)
	for i , box in ipairs(self.m_box) do
		if box:getIndex() == index then
			return box
		end
	end
	return nil
end

function This:getBoxCountInOpening()
	local count, index = 0, nil
	for i , box in pairs(self.m_box) do
		if box:getState() == BoxState.kOpening then
			count = count + 1
			if not index then
				index = box:getIndex()
			end
		end
	end
	return count, index
end

function This:hasBoxNotInOpening()
	local ret = false
	for i , box in pairs(self.m_box) do
		if box:getId() > 0 then
			if box:isOpening() then
				ret = false
				break
			else
				ret = true
			end
		end
	end
	return ret
end

function This:hasBoxRed()
	local ret = false
	local canopen = self:getIfCanOpen()
	if canopen then
		ret = true
	end
	for i , box in pairs(self.m_box) do
		if box:getId() > 0 then
			if box:getState() == BoxState.kReceive then
				ret = true
				break
			end
		end
	end
	return ret
end


function This:addBox(info)
	local box = MatchBox:create(info)
	table.insert(self.m_box,box)
	self:notifyObservers("onAddBox",box)
end

function This:updateBox(boxList)
	for i , info in ipairs(boxList) do
		--local box = self.m_box[i]
		local box = self:getBox(info.box_index)
		if box then
			box:updateInfo(info)
		else
			self:addBox(info)
		end
	end
	for i = #self.m_box, #boxList+1, -1 do
		local box = self.m_box[i]
		self:removeBox(box:getIndex())
	end
end

function This:removeBox(index)
	for i , box in ipairs(self.m_box) do
		if box:getIndex() == index then
			table.remove(self.m_box,i)
			self:notifyObservers("onRemoveBox",box)
			break
		end
	end
end

function This:getNewBoxQualityList()
	local ret = {}
	for i, lev in ipairs(self.m_newBoxIdList) do
		local quality = WarBoxConfig[lev].quality
		local num = ret[quality] or 0
		ret[quality] = num + 1
	end
	return ret
end

function This:setEnableShowReward( value )
	self.m_isEnableShowReward = value
end

function This:showBattleEndReward()
	if self.m_isEnableShowReward then
		self.m_isEnableShowReward = false

		local maxBoxLevel = 0
		for _, lev in ipairs(self.m_newBoxIdList) do
			local quality = WarBoxConfig[lev].quality
			if quality > maxBoxLevel then
				maxBoxLevel = quality
			end
		end
    	PopDialogManager:addPopDialog({name = "Depot.DepotBoxEffect", arg = {level = maxBoxLevel}})
    end
end

function This:getRoom()
	return self.m_room
end

function This:isInRoom()
	if self.m_room then
		return self.m_room:getMainRole() ~= nil
	end
end

function This:getCanInviteList(inviteType)
	local result = {}
	if inviteType == InviteType.kFriend then
		for i , invite in pairs(self.m_friendInvitesRoles) do
			if invite:getId() ~= GamePlayer:getPlayerID() then
				table.insert(result,invite)
			end
		end
	else
		for i , invite in pairs(self.m_groupInvitesRoles) do
			if invite:getId() ~= GamePlayer:getPlayerID() then
				table.insert(result,invite)
			end
		end
	end

	table.sort(result,function(a,b)
		if a:getState() ~= b:getState() then
			return a:getState() < b:getState()
		else
			return a:getId() < b:getId()
		end
		return false
	end)
	return result
end

function This:destroyRoom()
	local roleList = self.m_room:getAllRole()
	for i , invite in pairs(self.m_friendInvitesRoles) do
		invite:clear()
	end
	for i , invite in pairs(self.m_groupInvitesRoles) do
		invite:clear()
	end
	self.m_sendInvites = {}
	self.m_room = nil
end

function This:exitRoom()
	self.m_room = nil
	self.m_sendInvites = {}
end

function This:getSeason()
	return self.m_season
end

function This:getBattleReports()
	return self.m_battleReports
end

function This:hasBattleReportWithMapId(mapId)
	return self.m_battleReports[mapId] ~= nil
end

function This:getLevelListGotReward()
    return self.m_levelListGotReward 
end

function This:isGotDailyReward()
    return self.m_isGotDailyReward
end

function This:getSeasonId()
	return self.m_seasonId
end

function This:getSeasonEndTime()
	return self.m_seasonEndTime
end

function This:getCurSeasonMaxRankLv()
	return math.max(self.m_seasonMaxRankLv,1)
end

function This:isHeroResetIsOpen()
	return MatchingConfig[self.m_rankLv] and MatchingConfig[self.m_rankLv].reset > 0
end

function This:getHeroResetOpenRankLv()
	for i , config in ipairs(MatchingConfig) do
		if config.reset > 0 then
			return i
		end
	end
	return 1
end

function This:getIfCanOpen()
	local vipState = VipManager:getMemberState()
	local hasVip = vipState[1]
	local limitNum,num = 1,0
	if hasVip then
		limitNum = 2
	end
	for _,box in pairs(self.m_box) do
		if box:isOpening() then
			num = num + 1
		end
	end
	if #self.m_box > num then
		return num < limitNum,hasVip
	else
		return false,hasVip
	end
end
------------------------------------------------
--获取匹配信息
function This:onGetMatchInfoRequest()
	Socket:sendAndLock(11200,{})
end

function This:onGetMatchInfoReply(msg)
	self.m_relationType = 0
	self.m_rankLv = msg.rank_level
	self.m_star = msg.star_level
	self.m_score = msg.score
	self.m_seasonId = msg.season_num
	self.m_seasonEndTime = msg.season_end_time
	self.m_maxRankLvInHistory = msg.max_rank_level
	self.m_seasonMaxRankLv = msg.season_max_rank_level
	self.m_sendInvites = {}

	self.m_friendInvitesRoles = {}
	for i , info in ipairs(msg.friend_info_list) do
		local invite = MatchInvite:create(info)
		self.m_friendInvitesRoles[info.friend_id] = invite
	end

	self.m_groupInvitesRoles = {}
	for i , info in ipairs(msg.group_info_list) do
		local invite = MatchInvite:create(info)
		self.m_groupInvitesRoles[info.friend_id] = invite
	end

	self.m_room = MatchRoom:create(msg.room)
	self.m_isInit = true

	self:notifyObservers("onGetMatchInfo")
	EventDispatcher:dispatcher("match_rank_reward_changed")
end

--申请组队匹配
function This:onApplyTeamMatchRequest(friendList,relation)
	Socket:sendAndLock(11201,{friend_id = friendList, relation_type = relation})
end

function This:onApplyTeamMatchReply(msg)
	if msg.err_code == 0 then
		if msg.relation_type == MatchRelationType.kSingle then
			self:onPrepareMatchRequest(true)
		else
			self.m_relationType = msg.relation_type
			self:notifyObservers("onApplyTeamMatch",msg.friend_id)
		end
	else
		g_scene:handleErrorCode(msg.err_code)
	end
end

--相应组队匹配
function This:onReponseTeamMatchRequest(friendId,isAgree)
	Socket:sendAndLock(11202,{friend_id = friendId , agree = isAgree})
end
function This:onReponseTeamMatchReply(msg)
	if msg.err_code == 0 or msg.err_code == 11204 then
		if msg.agree then
			g_scene:openDialog("Match.BuildRoomPanel")
		end
		self:notifyObservers("onReponseTeamMatch",msg.err_code,msg.friend_id,msg.agree)
	end
	if msg.err_code ~= 0 then
		g_scene:handleErrorCode(msg.err_code)
	end
end

--准备
function This:onPrepareMatchRequest(isReady)
	Socket:send(11203,{is_ready = isReady})
end
function This:onPrepareMatchReply(msg)
	if msg.err_code == 0 then
		if msg.relation_type == MatchRelationType.kSingle then
			self:notifyObservers("onPrepareMatch")
			self:onMatchBattleRequest()
		else
			local role = self.m_room:getMainRole()
			self:notifyObservers("onPrepareMatch",role:getId())
		end
	else
		g_scene:handleErrorCode(msg.err_code)
	end
end

--匹配
function This:onMatchBattleRequest()
	Socket:send(11204,{})
end
function This:onMatchBattleReply(msg)
	if msg.err_code == 0 then
		self:destroyRoom()
		self:notifyObservers("onMatchBattle")
		cc.SceneManager:switchTo("World.WorldScene")
	else
		g_scene:handleErrorCode(msg.err_code)
	end
end

--邀请通知
function This:onInvitateMatchNotify(msg)
	local relation = msg.relation_type
	if not self:isInRoom() then
		self.m_room = MatchRoom:create(msg.friend_room_info)
		local role = self.m_room:getOwner()
		if role and not GamePlayer:isInWorld() and not EntrantManager:isJoinKingWar() then
			local panel = g_scene:getDialog("InviteMatchPopPanel")
			if not panel then
				PopDialogManager:addPopDialog({
					name = "Match.InviteMatchPopPanel",
					arg = {role = role,relation = relation},
					level = DialogLevel.kSecLevel,
					bCheck = true
				})
			end
			--g_scene:openDialog("Match.InviteMatchPopPanel",{role = role,relation = relation})
		end
		self:notifyObservers("onInvitateNotify",role,relation)
	end
end

--退出组队
function This:onExitTeamMatchRequest(targetId)
	Socket:sendAndLock(11206,{target_id = targetId})
end

function This:onExitTeamMatchReply(msg)
	if msg.err_code == 0 then
		local sourceId = msg.source_id
		local targetId = msg.target_id

		if targetId == self.m_room:getOwnerId() then
			self:notifyObservers("onDissolveTeam",targetId,sourceId)
			self:destroyRoom()
		elseif targetId == GamePlayer:getPlayerID() then
			self:notifyObservers("onExitTeamBattle",targetId,sourceId)
			self:exitRoom()
		else
			self:notifyObservers("onExitTeamBattle",targetId,sourceId)
		end
	else
		g_scene:handleErrorCode(msg.err_code)
	end
end

--房间信息变化
function This:onRoomChangedNotify(msg)
	print("房间变化通知...")
	if self.m_room then
		self.m_room:updateInfo(msg.room)
	else
		self.m_room = MatchRoom:create(msg.room)
	end
	self:notifyObservers("onRoomChanged")
end

--邀请好友加入组队
function This:onInviteFriendRequest(friendId,relationType)
	Socket:sendAndLock(11209,{friend_id_list={friendId},relation_type = relationType})
end

function This:onInviteFriendReply(msg)
	if msg.err_code == 0 then
		local friendId = msg.friend_id_list[1]
		if not self.m_sendInvites[friendId] then
			self.m_sendInvites[friendId] = true
		end

		local friendInvite = self.m_friendInvitesRoles[friendId]
		if friendInvite then
			friendInvite:setSendType(msg.relation_type)
		end
		local groupInvite = self.m_groupInvitesRoles[friendId]
		if groupInvite then
			groupInvite:setSendType(msg.relation_type)
		end

		self:notifyObservers("onInviteFriend",friendId)
	else
		g_scene:handleErrorCode(msg.err_code)
	end
end

--房间君主转让
function This:onChangeRoomOwnerRequest(targetId)
	Socket:sendAndLock(11210,{target_id = targetId})
end

function This:onChangeRoomOwnerReply(msg)
	if msg.err_code == 0 then
		self:notifyObservers("onRoomOwnerChanged",msg.target_id)
	else
		g_scene:handleErrorCode(msg.err_code)
	end
end

--战局结算
function This:onBattleSettlementNotify(msg)
	local oldRank = self.m_rankLv
	self.m_rankLv = msg.map_result.rank_level
	self.m_star = msg.map_result.star
	self.m_score = msg.map_result.score
	if oldRank ~= self.m_rankLv then
		self:onGetRewardInfoRequest()
		self:notifyObservers("onMatchRankLvChanged",self.m_oldRank,self.m_rankLv)
		EventDispatcher:dispatcher("rank_level_change")
	end
end

--查看赛季信息
function This:onGetSeasonInfoRequest()
	Socket:sendAndLock(10209,{})
end

function This:onGetSeasonInfoReply(msg)
	self:notifyObservers("onGetSeasonInfo",msg.info)
end

--战局列表
function This:ononGetBattleListRequest()
	Socket:sendAndLock(11214,{})
end

function This:onGetBattleListReply(msg)
	for i , report in ipairs(msg.result_list) do
		self.m_battleReports[report.map_id] = report
	end
	self:notifyObservers("onGetBattleList",msg.result_list)
end

------------------------------------------------

function This:onOpenBoxRequest(index, nolock)
	if not nolock then
		Socket:sendAndLock(11211,{box_index = index})
	else
		Socket:send(11211,{box_index = index})
	end
end

function This:onOpenBoxReply(msg)
	if msg.err_code == 0 then
		local box = self:getBox(msg.box_index)
		self:removeBox(msg.box_index)
		g_scene:showReward(msg.reward_list)
		self:notifyObservers("onOpenBox",box)
		
		EventDispatcher:dispatcher("match_boxes_changed")
	else
		g_scene:handleErrorCode(msg.err_code)
	end
end

function This:onGetBoxInfoRequest()
	Socket:sendAndLock(11212,{})
end

function This:onGetBoxInfoReply(msg)
	self.m_newBoxIdList = {}
	if msg.box_id_list then
		for i, info in ipairs(msg.box_id_list) do
			local index, boxId = info.id, info.num
			local box = self:getBox(index)
			if not box or box:getId() ~= boxId then
				table.insert(self.m_newBoxIdList, boxId)
			end
		end
	end
	self:updateBox(msg.box_list)
	self:notifyObservers("getBoxInfo")
	EventDispatcher:dispatcher("match_boxes_changed")
end

function This:onUnlockBoxRequest(index, nolock)
	if not nolock then
		Socket:sendAndLock(11213,{box_index = index})
	else
		Socket:send(11213,{box_index = index})
	end
end

function This:onUnlockBoxReply(msg)
	if msg.err_code == 0 then
		local box = self:getBox(msg.box_index)
		box:setEndTime(msg.end_time)
		self:notifyObservers("onUnlockBox",box)
		EventDispatcher:dispatcher("match_boxes_changed")
	else
		g_scene:handleErrorCode(msg.err_code)
	end
end

function This:onFinishBoxCDRequest(index, nolock)
	if not nolock then
    	Socket:sendAndLock(11218,{box_index = index}) 
    else
    	Socket:send(11218,{box_index = index}) 
    end
end

function This:onFinishBoxCDReply(msg)
	if msg.err_code == 0 then
		local box = self:getBox(msg.box_index)
		box:endUpdate()
		self:notifyObservers("onFinishBoxCD",box)
		EventDispatcher:dispatcher("match_boxes_changed")
	else
		g_scene:handleErrorCode(msg.err_code)
	end
end

--------------------------------------------------------

function This:onPickUpLevelRewardRequest(level)
	Socket:sendAndLock(11216, {rank_level = level})
end

function This:onPickUpLevelRewardReply( msg )
    if msg.err_code == 0 then
        self.m_levelListGotReward[msg.rank_level] = true
        EventDispatcher:dispatcher("match_rank_reward_changed")
		self:notifyObservers("onPickUpLevelReward", msg.rank_level)
    else
        g_scene:handleErrorCode(msg.err_code)
    end
end

function This:onPickUpDailyRewardRequest()
	Socket:sendAndLock(11215)
end

function This:onPickUpDailyRewardReply( msg )
    if msg.err_code == 0 then
    	self.m_isGotDailyReward = true
		EventDispatcher:dispatcher("match_daily_reward_changed")
        self:notifyObservers("onPickUpDailyReward")
    else
        g_scene:handleErrorCode(msg.err_code)
    end
end

function This:onGetRewardInfoRequest()
	Socket:sendAndLock(11217)
end

function This:onGetRewardInfoReply( msg )
	if msg then
		self.m_isGotDailyReward = msg.is_reward
		local oldRank = self.m_maxRankLvInHistory
		self.m_maxRankLvInHistory = msg.max_rank or 0

		for _, level in ipairs(msg.reward_rank_list) do
			self.m_levelListGotReward[level] = true
		end
		
        self:notifyObservers("onGetRewardInfo")
		
		if oldRank ~= self.m_maxRankLvInHistory then
			EventDispatcher:dispatcher("rank_level_history_change", oldRank, self.m_maxRankLvInHistory)
		end
		EventDispatcher:dispatcher("match_rank_reward_refresh")
	else
		g_scene:handleErrorCode("")
	end
end

--------------------------------------------------------
function This:onDayPassed()
	self:onGetRewardInfoRequest()
end

function This:onBoxStartOpen(index)
	self:notifyObservers("onBoxStartOpen",index)
end

function This:onBoxEndOpen(index)
	self:notifyObservers("onBoxEndOpen",index)
	EventDispatcher:dispatcher("match_boxes_changed")
end


--endregion
