--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"Dialog")
local MatchManager = require("Match.MatchManager")
-- local BoxView = require("Match.BoxView")
local MatchingConfig = require("Metadatas.MatchingConfig")
local Serialize = require("Serialize.Serialize")
local GamePlayer = require("Player.GamePlayer")
local SeasonConfig = require("Metadatas.SeasonConfig")
local SeasonRewardConfig = require("Metadatas.SeasonRewardConfig")
local DropConfig = require("Metadatas.DropConfig")
local ItemNode = require("UI.ItemNode")
local MatchingAreaConfig = require("Metadatas.MatchingAreaConfig")

function This:initNode()
	self.m_csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/MatchingMain.csb")
	self:addChild(self.m_csNode)
	--self.m_csNode:fitScreen(1)
	self.m_csNode.bg4:fitScreenX()
	self.m_csNode.bg1:fitScreenX()
	--self.m_csNode.area.right:fitToScreen("right")
	self.m_csNode.area:recoveryToFixedWidth("right","top")
	self.m_csNode.junchen:recoveryToFixedWidth("right","")
	self.m_csNode.tongmeng:recoveryToFixedWidth("right","")
	self.m_csNode.singlebattle:recoveryToFixedWidth("right","")
	self.m_csNode.winreward:recoveryToFixedWidth("left","bottom")
	self.m_csNode.seasonreward:recoveryToFixedWidth("left","bottom")
	--self.m_csNode.bg4:recoveryToFixedWidth("left","bottom")
	--self.m_csNode.marquis:recoveryToFixedWidth("left","bottom")
	self.m_csNode.close:recoveryToFixedWidth("right","top")
	self.m_csNode.bg:fitScreen()

	-- self:initBox()
	self:refreshBaseInfo()
	self:initSeasonReward()
	self:initRankArea()
	GamePlayer:onGetSeasonInfoRequest()
end

-- function This:initBox()
-- 	self.m_boxView = {}
-- 	local boxList = MatchManager:getAllBox()
-- 	for i, box in ipairs(boxList) do
-- 		local view = BoxView:create(box)
-- 		self.m_csNode["box"..i]:addChild(view)
-- 		self.m_boxView[i] = view
-- 	end
-- end

function This:initSeasonReward()
	local seasonId = MatchManager:getSeasonId()
	self.m_csNode.winreward.text_0:setString(string.format(Serialize[61927],seasonId))
	local endTime = MatchManager:getSeasonEndTime()

	local date = os.serverdate("*t",endTime)
	self.m_csNode.winreward.text_0_0:setString(string.format(Serialize[61928],date.year,date.month,date.day))
	local limitRank = SeasonConfig[seasonId].rank_limit
	self.m_csNode.winreward.desc:setString(string.format(Serialize[61929],MatchingConfig[limitRank].rank_level))

	local maxRank = MatchManager:getCurSeasonMaxRankLv()
	local item = SeasonRewardConfig[seasonId * 1000 + maxRank].office_reward[1]
	local node = ItemNode:create(item[1],item[2])
	node:setAnchorPoint(0.5,0.5)
	self.m_csNode.seasonreward.rank_item:addChild(node) 
	
	item = SeasonConfig[seasonId].reward
	node = ItemNode:create(item[1],item[2])
	node:setAnchorPoint(0.5,0.5)
	self.m_csNode.winreward.season_item:addChild(node)
	self.m_csNode.seasonreward.des:setString(string.format(Serialize[61925],MatchingConfig[maxRank].rank_level))
	self.m_csNode.winreward.finished:setVisible(false)
end

function This:initRankArea()
	local curRank = MatchManager:getRankLv()
	self.m_curArea = MatchingConfig[curRank].matching_area
	self:refreshRankArea(self.m_curArea)
end

function This:refreshRankArea(rankArea)
	local curRank = MatchManager:getRankLv()
	local config = MatchingAreaConfig[rankArea]
	if config then
		self.m_csNode.area.title:setString(config.rank_name)
		local file = string.format("MenuScene/%s.png",config.show_img)
		self.m_csNode.area.duanwei:setImage(file)
		local minRank = config.office_area[1]
		self.m_csNode.area.office:setString(MatchingConfig[minRank].rank_level)
		local nextConfig = MatchingAreaConfig[rankArea + 1]
		self.m_csNode.area.right:setVisible(nextConfig ~= nil)
		local preConfig = MatchingAreaConfig[rankArea - 1]
		self.m_csNode.area.left:setVisible(preConfig ~= nil)

		local area = MatchingConfig[curRank].matching_area
		if area == rankArea then
			self.m_csNode.tongmeng:clearShader()
			self.m_csNode.junchen:clearShader()
			self.m_csNode.singlebattle:clearShader()
		else
			self.m_csNode.tongmeng:setGrayShader()
			self.m_csNode.junchen:setGrayShader()
			self.m_csNode.singlebattle:setGrayShader()		
		end
	end
end

function This:getStarOrder(maxStar)
	local order3 = {2,3,4,1,5}
	local order1 = {3,1,2,4,5}
	local order5 = {1,2,3,4,5}
	local order = order5
	if maxStar == 1 then
		return order1
	elseif maxStar == 3 then
		return order3
	end
	return order5
end

function This:refreshBaseInfo()
	local rankLv = MatchManager:getRankLv()
	local config = MatchingConfig[rankLv]
	self.m_csNode.marquis.marquisname:setString(config.rank_level)
	local score = MatchManager:getScore()
    local jifenStr = score
    if rankLv < kMaxMatchRankLv then
        jifenStr = string.format("%d/%d",score,config.score)
    end
    self.m_csNode.jifen:setString(jifenStr)
	self.m_csNode.jifendes:setString(string.format(Serialize[61947],config.score))

	self.m_csNode.marquis.marquistar.staricon:setVisible(rankLv >= kMaxMatchRankLv)
	self.m_csNode.marquis.marquistar.starnumber:setVisible(rankLv >= kMaxMatchRankLv)

	self.m_csNode.jifenbar:runPercentAction(score / config.score * 100, 100)
	self.m_csNode.marquis.marquisicon:setImage(RankIconImage[rankLv])
	self.m_csNode.gotobattle:setVisible(GamePlayer:isInWorld())
	self.m_csNode.singlebattle:setVisible(not GamePlayer:isInWorld())
end

-- function This:refreshBox()
-- 	local boxList = MatchManager:getAllBox()
-- 	for i = 1 , 5 do
-- 		local box = boxList[i]
-- 		if box and not self.m_boxView[i] then
-- 			local view = BoxView:create(box)
-- 			self.m_csNode["box"..i]:addChild(view)
-- 			self.m_boxView[i] = view
-- 		elseif not box and self.m_boxView[i] then
-- 			self.m_boxView[i]:removeFromParent()
-- 			self.m_boxView[i] = nil
-- 		elseif box and self.m_boxView[i] then
-- 			self.m_boxView[i]:setModel(box)
-- 		end
-- 	end
-- end

function This:initTouchEvent()
	self.m_csNode.close:setTouchEnded(function()
		self:close()
	end)
	self.m_csNode.junchen:setTouchEnded(function()
		local curRank = MatchManager:getRankLv()
		local area = MatchingConfig[curRank].matching_area
		if area ~= self.m_curArea then
			g_scene:showTips(Serialize[61948])
			return
		end
		if MatchManager:isInRoom() then
			g_scene:openDialog("Match.BuildRoomPanel")
		elseif not self.m_isRequesting then
			self.m_relation = RelationType.kJun
			self.m_isRequesting = true
			MatchManager:onGetMatchInfoRequest()
		end
	end)
	self.m_csNode.tongmeng:setTouchEnded(function()
		local curRank = MatchManager:getRankLv()
		local area = MatchingConfig[curRank].matching_area
		if area ~= self.m_curArea then
			g_scene:showTips(Serialize[61948])
			return
		end
		if MatchManager:isInRoom() then
			g_scene:openDialog("Match.BuildRoomPanel")
		elseif not self.m_isRequesting then
			self.m_relation = RelationType.kTongMeng
			self.m_isRequesting = true
			MatchManager:onGetMatchInfoRequest()
		end
	end)

	self.m_csNode.singlebattle:setTouchEnded(function()
		local curRank = MatchManager:getRankLv()
		local area = MatchingConfig[curRank].matching_area
		if area ~= self.m_curArea then
			g_scene:showTips(Serialize[61948])
			return
		end
		if MatchManager:isInRoom() then
			MatchManager:onExitTeamMatchRequest(GamePlayer:getPlayerID())
		else
			MatchManager:onApplyTeamMatchRequest({},0)
		end
	end)
	self.m_csNode.rankinglist.rankinglistbg:setTouch({
		onEnded = function()
			self.m_isRequesting = true
			MatchManager:onGetRankListRequest(0)
		end,
		isScale = false
	})
	self.m_csNode.gameinformation.gameinformationbg:setTouch({
		onEnded = function()
			self.m_isRequesting = true
			MatchManager:onGetSeasonInfoRequest()
		end,
		isScale = false
	})

	self.m_csNode.help:setTouchEnded(function()
		self:openDialog("UI.HelpTips",{text = Serialize["match_help_2"],node = self.m_csNode.help})
	end)
	self.m_csNode.gotobattle:setTouchEnded(function()
		cc.SceneManager:switchTo("World.WorldScene")
	end)

	self.m_csNode.zhanbao:setTouchEnded(function()
		local battleList = MatchManager:getBattleReports()
		g_scene:openDialog("Match.BattleListPanel",battleList)
	end)
	self.m_csNode.area.left:setTouchEnded(function()
		self.m_curArea = self.m_curArea - 1
		self:refreshRankArea(self.m_curArea)
	end)
	self.m_csNode.area.right:setTouchEnded(function()
		self.m_curArea = self.m_curArea + 1
		self:refreshRankArea(self.m_curArea)
	end)
end

function This:onEnter()
	super.onEnter(self)
	MatchManager:addObserver(self)
	GamePlayer:addObserver(self)
end

function This:onExit()
	super.onExit(self)
	MatchManager:removeObserver(self)
	GamePlayer:removeObserver(self)
end

function This:onApplyTeamMatch()
	self.m_isRequesting = false
	g_scene:openDialog("Match.BuildRoomPanel")
end

-- function This:onAddBox(box)
-- 	self:refreshBox()
-- end

-- function This:onRemoveBox(box)
-- 	self:refreshBox()
-- 	self:refreshBaseInfo()
-- end

function This:onGetSeasonInfo(msg)
	if self.m_isRequesting then
		g_scene:openDialog("Match.MatchSeasonPanel",msg)
		self.m_isRequesting = false
	end
end

function This:onGetRankListInfo(msg)
	if self.m_isRequesting then
		g_scene:openDialog("Match.MatchRankListPanel",msg)
		self.m_isRequesting = false
	end
end

function This:onGetMatchInfo()
	if self.m_isRequesting then
		MatchManager:onApplyTeamMatchRequest({},self.m_relation)
	end
end

function This:onGetSeasonInfo(info)
	self.m_csNode.winreward.finished:setVisible(info.win_num >= kSecceedFinishNumLimit)
end

--endregion
