--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"Dialog")
local MatchManager = require("Match.MatchManager")
local GamePlayer = require("Player.GamePlayer")
local InviteView = require("Match.InviteView")

function This:initNode()
	self.m_csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/TeamMatchingMain.csb")
	self:addChild(self.m_csNode)
	self.m_csNode:setToCenter()
	self.m_inviteViews = {}
	
	self:refreshItems()
end

function This:initTouchEvent()
	self.m_csNode.Choose.unionbattle:setTouchEnded(function()
		MatchManager:onApplyTeamMatchRequest({},MatchRelationType.kAlly)
		self.m_isRequesting = true
	end)
	self.m_csNode.Choose.masterbattle:setTouchEnded(function()
		MatchManager:onApplyTeamMatchRequest({},MatchRelationType.kJun)
	end)
	self.m_csNode.close:setTouchEnded(function()
		self:close()
	end)
end

function This:refreshItems()
	self.m_csNode.ScrollView:removeAllItems()
	self.m_inviteList = MatchManager:getRecvInviteList()
	self.m_inviteViews = {}
	for i , invite in ipairs(self.m_inviteList) do
		local view = InviteView:create(invite)
		view:setAnchorPoint(0,0)
		local w , h = view:getContentSize()
		self.m_csNode.ScrollView:pushBackCustomItem(view,w,h,0.5)
		self.m_inviteViews[invite:getFriendId()] = view
	end
end

function This:onEnter()
	super.onEnter(self)
	MatchManager:addObserver(self)
end

function This:onExit()
	super.onExit(self)
	MatchManager:removeObserver(self)
end

function This:onApplyTeamMatch()
	self:close()
	g_scene:openDialog("Match.BuildRoomPanel")
end

function This:onInviteFriend(friendId)
	local view = self.m_inviteViews[friendId]
	if view then
		view:refresh()
	end
end

function This:onInvitateNotify(friendId,relation)
	self:refreshItems()
end

function This:onReponseTeamMatch(errorCode,friendId,isAgree)
	if errorCode == 0 then
		local itemList = self.m_csNode.ScrollView:getItemList()
		for i , view in ipairs(itemList) do
			if view:getModel():getFriendId() == friendId then
				self.m_csNode.ScrollView:removeItem(i)
				break
			end
		end
		self:close()
		g_scene:openDialog("Match.BuildRoomPanel")
	else
		self:refreshItems()
	end
end

--endregion
