--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"Dialog")
local GamePlayer = require("Player.GamePlayer")
local MatchManager = require("Match.MatchManager")
local MatchingConfig = require("Metadatas.MatchingConfig")
local GuideManager = require("Guide.GuideManager")
local GameUtil = require("Util.GameUtil")
local GuideManager = require("Guide.GuideManager")

ResultImage = 
{
	failed = "Common/fail.png",
	master = "Common/win2.png",
	colleague = "Common/win1.png",
	ally = "Common/win3.png",
	dogfall = "Common/pingju2.png",
}

TitleScore =
{
	[TitleType.kBazhu] = 0,
	[TitleType.kMvp] = 0,
	[TitleType.kZhanshen] = 0,
	[TitleType.kJunShi] = 0,
}

--星星开始的位置

function This:initNode(msg)
	self:initAction(msg)
end

function This:initNewPlayerAction()
	local function finishHandler()
		if g_scene:getName() ~= "MenuScene" then
			cc.SceneManager:switchTo("Home.MenuScene")
		else
			self:close()
		end
	end 

	local effect
	effect = GameUtil:createEffect("ShengZhi",false,nil,{
		onAnimationEvent = function()
			effect:unscheduleUpdate()
			self.m_csNode.button:setVisible(true)
			self.m_csNode.button:runAction(cc.RepeatForever(cc.Sequence(cc.ScaleTo(1,1.1),cc.ScaleTo(1,1))))
		end,
		onAnimationComplete = function()
			finishHandler()
		end
	})
	self:addChild(effect)
	effect:setPosition(cc.visible.center.x,cc.visible.center.y)

	self.m_csNode = cc.Node:createFromCSFile("Common/NodeUI/Decree.csb")
	self:addChild(self.m_csNode)
	self.m_csNode:setToCenter()

	self.m_csNode.button:setVisible(false)
	self.m_csNode.button:setTouchEnded(function()
		effect:scheduleUpdate()
		self.m_csNode.button:setVisible(false)
	end)
end

function This:initAction(msg)
	print(msg)
	local playerId = GamePlayer:getPlayerID()
 --    msg = {["list"]={{["level"]=20,["star"]=3,["icon"]=5,["id"]=55867917545472,["rank_level"]=2,["assist"]=0,["kill"]=0,["pingfen"]=1,["title_list"]={},["city_num"]=2,["name"]=Serialize[61957],["score"]=30}, 
	-- {["level"]=23,["star"]=4,["icon"]=1,["id"]=55868062070784,["rank_level"]=21,["assist"]=0,["kill"]=0,["pingfen"]=1,["title_list"]={},["city_num"]=1,["name"]=Serialize[61958],["score"]=32}, {["level"]=16,["star"]=4,["icon"]=1,["id"]=55868083744768,["rank_level"]=23,["assist"]=0,["kill"]=0,["pingfen"]=1,["title_list"]={3, 2, 1},["city_num"]=2,["name"]=Serialize[61959],["score"]=18}},
	-- ["rank_level"]=25,["score"]=32,["star"]=4,["win_zhangong"]=0,["is_colleague"]=false,["coin"]=48000,["bingfashu"]=240,["win_exp"]=50,["start_time"]=1509371761,["win_score"]=0,["time_zhangong"]=19200,["map_id"]=55868096477184,["state"]=3,["exp"]=480,["is_ally"]=true,["is_master"]=false}
	--  playerId= 55868062070784

	--msg = {["list"]={{["level"]=34,["star"]=0,["icon"]=1,["id"]=4.4729795468288e+14,["rank_level"]=1,["assist"]=0,["kill"]=0,["pingfen"]=1,["title_list"]={3, 2, 1},["city_num"]=2,["name"]=Serialize[61960],["score"]=0}},["rank_level"]=1,["score"]=0,["star"]=0,["win_zhangong"]=0,["is_colleague"]=false,["coin"]=48000,["bingfashu"]=240,["win_exp"]=50,["start_time"]=1511247058,["win_score"]=2,["time_zhangong"]=19200,["map_id"]=4.4729805176832e+14,["state"]=1,["exp"]=480,["is_ally"]=false,["is_master"]=false}
	--playerId= 4.4729795468288e+14

	self.m_msg = msg
	self.m_gold = msg.coin
	self.m_state = msg.state
	self.m_curScore = msg.score
	self.m_curStar = msg.star
	self.m_curRankLv = msg.rank_level
	self.m_winScore = msg.win_score
	self.m_infoList = msg.list
	
	self.m_scoreList = {}
	local totalScore = 0
	for i , info in ipairs(msg.list) do
		if info.id == playerId then
			self.m_preScore = info.score
			self.m_preStar = info.star
			self.m_preRankLv = info.rank_level == 0 and 1 or info.rank_level
			self.m_kill = info.kill
			self.m_assist = info.assist
			self.m_maxCityNum = info.city_num
			for i , title in ipairs(info.title_list) do
				totalScore = totalScore + TitleScore[title]
			end
			break
		end
	end
	if self.m_state == ResultState.kSecceed then
		table.insert(self.m_scoreList,self.m_winScore)
	elseif self.m_state == ResultState.kFailed then
		local tmp = 0
		for i = self.m_preRankLv , self.m_curRankLv , -1 do
			tmp = tmp + MatchingConfig[i].limit_socre
		end
		table.insert(self.m_scoreList,-tmp)
	else
		table.insert(self.m_scoreList,0)
	end
	table.insert(self.m_scoreList,totalScore + self.m_scoreList[1])

	if self.m_preRankLv >= kMaxMatchRankLv then
		self.m_preRankLv = kMaxMatchRankLv
	end
	if self.m_curRankLv >= kMaxMatchRankLv then
		self.m_curRankLv = kMaxMatchRankLv
	end
	self.m_timeExp = msg.exp
	self.m_winExp = msg.win_exp
	self.m_isMaster = msg.is_master
	self.m_isColleague = msg.is_colleague
	self.m_isAlly = msg.is_ally
	self.m_curConfig = MatchingConfig[self.m_curRankLv]
	self.m_preConfig = MatchingConfig[self.m_preRankLv]

	self.m_csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/MatchingEnd.csb")
	self:addChild(self.m_csNode)
	
	self.m_csNode.continue:setVisible(false)
	self.m_csNode.assess:setVisible(false)
	self.m_csNode.marqcompare:setVisible(false)
	self.m_csNode.descrp:setVisible(false)
	self.m_initRankX , self.m_initRankY = self.m_csNode.marqcompare:getPosition()
	self.m_initScoreX , self.m_initScoreY = self.m_csNode.assess:getPosition() 

	self.m_star = self.m_preStar
	self.m_rank = self.m_preRankLv
	self.m_score = self.m_preScore
	self.m_config = self.m_preConfig

	self:initBaseInfo()
	self:initScoreAction()
end

function This:initBaseInfo()
	self:refreshStarInfo(false,true)
	for i = 1, 2 do
		self.m_csNode.assess["jifen"..i]:setString(string.format("%+d",self.m_scoreList[i]))
	end

-------------------------------------------------------
	if self.m_state == ResultState.kSecceed then
		if self.m_isMaster then
			self.m_csNode.result:setImage(ResultImage.master)
		elseif self.m_isColleague then
			self.m_csNode.result:setImage(ResultImage.colleague)
		elseif self.m_isAlly then
			self.m_csNode.result:setImage(ResultImage.ally)
		else
			self.m_csNode.result:setImage(ResultImage.master)
		end
	elseif self.m_state == ResultState.kDogfall then
		self.m_csNode.result:setImage(ResultImage.dogfall)
	else
		self.m_csNode.assess.des1:setString(Serialize[61961])
	end
-------------------------------------------------------	 
	self.m_csNode.marqcompare.marquisbefore.marquisname:setString(self.m_preConfig.rank_level)
	local zorder = self:getStarOrder(self.m_preConfig)
	for i = 1, 5 do
		local key = zorder[i]
		self.m_csNode.marqcompare.marquisbefore["star"..key]:setVisible(self.m_preRankLv < kMaxMatchRankLv and self.m_preStar >= i)
		self.m_csNode.marqcompare.marquisbefore["starbg"..key]:setVisible(self.m_preRankLv < kMaxMatchRankLv and self.m_preConfig.star >= i)
	end
	self.m_csNode.marqcompare.marquisbefore.marquistar:setVisible(self.m_preRankLv >= kMaxMatchRankLv)
	self.m_csNode.marqcompare.marquisbefore.marquistar.starnumber:setString(string.format("x%d",self.m_preStar))
	self.m_csNode.marqcompare.marquisbefore.marquisname:setString(self.m_preConfig.rank_level)
	self.m_csNode.marqcompare.marquisbefore.marquisicon:setImage(RankIconImage[self.m_preRankLv])
	zorder = self:getStarOrder(self.m_curConfig)
	for i = 1, 5 do
		local key = zorder[i]
		self.m_csNode.marqcompare.marquisafter["star"..key]:setVisible(self.m_curRankLv < kMaxMatchRankLv and self.m_curStar >= i)
		self.m_csNode.marqcompare.marquisafter["starbg"..key]:setVisible(self.m_curRankLv < kMaxMatchRankLv and self.m_curConfig.star >= i)
	end
	self.m_csNode.marqcompare.marquisafter.marquistar:setVisible(self.m_curRankLv >= kMaxMatchRankLv)
	self.m_csNode.marqcompare.marquisafter.marquistar.starnumber:setString("x"..self.m_curStar)
	self.m_csNode.marqcompare.marquisafter.marquisname:setString(self.m_curConfig.rank_level)
	self.m_csNode.marqcompare.marquisafter.marquisicon:setImage(RankIconImage[self.m_curRankLv])

	if self.m_curRankLv ~= self.m_preRankLv then
		self.m_csNode.marqcompare.textdes:setString(string.format(Serialize[61962],self.m_curRankLv - self.m_preRankLv))
	elseif self.m_curStar ~= self.m_preStar then
		self.m_csNode.marqcompare.textdes:setString(string.format(Serialize[61963],self.m_curStar - self.m_preStar))
	elseif self.m_curScore ~= self.m_preScore then
		self.m_csNode.marqcompare.textdes:setString(string.format(Serialize[61964],self.m_curScore - self.m_preScore))
	else
		self.m_csNode.marqcompare.textdes:setString(string.format(Serialize[61965]))
	end
	self.m_csNode.descrp:setStringWithColor(string.format(Serialize[61966],self.m_kill,self.m_maxCityNum))
end

function This:initTouchEvent()
	self.m_csNode.continue:setTouchEnded(function()
		if g_setting.isGuide and GuideManager:isInGuide() then
			local panel = g_scene:openDialog("Match.ShengZhiPanel")
			panel:setLocalZOrder(1000)
		else
			local panel = g_scene:openDialog("Match.MatchSettleRewardPanel",self.m_msg)
			panel:setLocalZOrder(1000)
		end
		self:close()
	end)
end

function This:getStarOrder(config)
	local order3 = {2,3,4,1,5}
	local order1 = {3,1,2,4,5}
	local order5 = {1,2,3,4,5}
	local order = order5
	if config.star == 1 then
		return order1
	elseif config.star == 3 then
		return order3
	end
	return order5
end

function This:initScoreAction()
	local dist = 400
	local x = self.m_csNode.assess:getPositionX()
	self.m_csNode.assess:setPositionX(x - dist)
	for i = 1 , 2 do
		self.m_csNode.assess["des"..i]:setVisible(false)
		self.m_csNode.assess["jifen"..i]:setVisible(false)
	end

	local moveTime = 0.75  --计分板出来的时间
	local tmp = 0
	for i , value in ipairs(self.m_scoreList) do
		if value ~= 0 then
			tmp = tmp + 1
		end
	end
	if tmp <= 0 then tmp = 1 end

	local interval = 1  --积分项相隔的时间
	local scoreChangeTime = interval * tmp  --积分项出来的总时间
	self.m_scoreChangeTime = scoreChangeTime
	self.m_csNode.assess:setVisible(true)
	self.m_csNode.assess:runAction(cc.MoveBy(moveTime,dist,0,"BounceIn"))

	local w, h = self.m_csNode.assess.jifenbg:getContentSize()
	self.m_progressTimer = cc.ProgressTimer:create(self.m_csNode.assess.jifenbar)
	self.m_csNode.assess.jifenbg:addChild(self.m_progressTimer)
	self.m_progressTimer:setScaleY(-1)
	self.m_progressTimer:setPosition(w/2,h/2)
	self.m_progress = self.m_preScore / self.m_preConfig.score  --初始百分比
	self.m_progressTimer:setPercent(self.m_progress * 100)

	self:runAction(cc.Sequence(
		cc.DelayTime(moveTime),
		cc.CallFunc(function()
			local actionList = {}
			for i = 1, 2 do
				if self.m_scoreList[i] ~= 0 then
					table.insert(actionList,cc.DelayTime(interval))
					table.insert(actionList,cc.CallFunc(function()
						self.m_csNode.assess["des"..i]:setVisible(true)
						self.m_csNode.assess["jifen"..i]:setVisible(true)
						local eff = nil
						eff = GameUtil:createEffect("JiFen",false,nil,{
							onAnimationComplete = function()
								eff:removeFromParent()
							end
						})
						local x1, y1 = self.m_csNode.assess["des"..i]:getPosition()
						eff:setPosition( x1 ,  y1 )
						self.m_csNode.assess:addChild(eff)

						if i < 2 then
							self.m_score = self.m_score + self.m_scoreList[i]
							self:refreshStarInfo()
						end
					end))
				end
			end
			if #actionList > 0 then
				self.m_csNode.assess:runAction(cc.Sequence(unpack(actionList)))
			end
		end),
		cc.DelayTime(scoreChangeTime),
		cc.CallFunc(function()
			if self.m_curRankLv ~= self.m_preRankLv or self.m_curStar ~= self.m_preStar then
				self:initStarAction()
			else
				self:initRankAction()
			end
		end)
	))
end

function This:getBezierAction(time,bx,by,tx,ty,isup)
	local config = cc.BezierConfig()
	local ep = cc.Vec(tx,ty)
	local sp = cc.Vec(bx,by)
	config.endPosition = ep

	local v = ep - sp
	local len = v:length()
	local degree = v:getDegree()
	local n = v:getNormalize()
	if isup then
		config.controlPoint1 = cc.Vec.createByDegree(degree - 90) * 100 + n * 0.3 * len + sp
		config.controlPoint2 = cc.Vec.createByDegree(degree - 90) * 100 + n * 0.7 * len + sp
	else
		config.controlPoint1 = cc.Vec.createByDegree(degree - 90) * 100 + n * 0.3 * len + sp
		config.controlPoint2 = cc.Vec.createByDegree(degree - 90) * 100 + n * 0.7 * len + sp
	end
	return cc.BezierTo(time,config)
end

--升星动画
function This:starUpAction(particlex , particley , tx , ty, finishHandler)
	self.m_starEff = GameUtil:createEffect("ShengXing2",false)
	self.m_starEff:setPosition(particlex,particley)
	self:addChild(self.m_starEff)
	self:runAction(cc.Sequence(
		cc.DelayTime(0.5), --等待ShengXing2动画的时间
		cc.CallFunc(function()
			self.m_starEff:removeFromParent()
			self.m_starEff = nil
			self.m_particle = cc.Particle:create("lizi2.plist")
			self.m_particle:setPosition(particlex,particley)
			self:addChild(self.m_particle)
			self.m_particle:runAction(self:getBezierAction(0.5,particlex,particley,tx,ty,false))
		end),
		cc.DelayTime(0.45), --等待粒子的时间
		cc.CallFunc(function()
			self.m_starEff = GameUtil:createEffect("ShengXing",false)
			self.m_starEff:setPosition(tx,ty)
			self:addChild(self.m_starEff)
			self.m_particle:removeFromParent()
			self.m_particle = nil
		end),
		cc.DelayTime(0.2), --等待动画ShengXing的时间
		cc.CallFunc(function()
			self:refreshStarInfo()
		end),
		cc.DelayTime(0.5), --刷新数据后等待删除动画ShengXing的时间
		cc.CallFunc(function()
			self.m_starEff:removeFromParent()
			self.m_starEff = nil
			finishHandler()
		end)
	))
end

--首次升星的动画
function This:firstStarUpAction(x,y,finishHandler) 
	self.m_starEff = GameUtil:createEffect("ShengXing",false)
	self.m_starEff:setPosition(x,y)
	self:addChild(self.m_starEff)
	self:runAction(cc.Sequence(
		cc.DelayTime(1),  --等待动画的时间
		cc.CallFunc(function()
			self.m_starEff:removeFromParent()
			self.m_starEff = nil
			finishHandler()
		end)
	))
end

--降星动画
function This:starDownAction(particlex , particley , tx , ty , centerHandler , finishHandler)
	self.m_starEff = GameUtil:createEffect("DiaoXing",false)
	self.m_starEff:setPosition(particlex,particley)
	self:addChild(self.m_starEff)
	self:runAction(cc.Sequence(
		cc.DelayTime(1),  --等待动画DiaoXing的时间
		cc.CallFunc(function()
			self.m_starEff:removeFromParent()
			self.m_starEff = nil
			self.m_particle = cc.Particle:create("lizi2.plist")
			self.m_particle:setPosition(particlex,particley)
			self:addChild(self.m_particle)
			self.m_particle:runAction(self:getBezierAction(0.5,particlex,particley,tx,ty,true))
			centerHandler()
		end),
		cc.DelayTime(0.5), --等待粒子的时间
		cc.CallFunc(function()
			self.m_particle:removeFromParent()
			self.m_particle = nil
			self.m_starEff =GameUtil:createEffect("ShengXing2",false)
			self.m_starEff:setPosition(tx,ty)
			self:addChild(self.m_starEff)
			self:refreshStarInfo()
		end),
		cc.DelayTime(0.5), --刷新数据后等待删除ShengXing2的时间
		cc.CallFunc(function()
			self.m_starEff:removeFromParent()
			self.m_starEff = nil
			finishHandler()
		end)
	))
end

--进阶动画
function This:rankUpAction(finishHandler,isUp)
	local node = self.m_csNode.marquis.marquistar.starnumber
	local w , h = node:getContentSize()
	local x , y = node:getPosition()
	x , y = node:convertToWorldSpace(w/2,h/2)

	if isUp then
		local sprite = cc.Sprite:create(RankIconImage[self.m_rank])
		local w1 , h1 = self.m_csNode.marquis.marquisicon:getContentSize()
		x1 , y1 = self.m_csNode.marquis.marquisicon:convertToWorldSpace(w1/2,h1/2)
		sprite:setPosition(x1,y1)
		sprite:runAction(cc.Sequence(
			cc.Spawn(cc.ScaleTo(0,3),cc.FadeOut(0)),
		  	cc.Spawn(cc.ScaleTo(0.18,0.8),cc.FadeIn(0.18)),
			cc.ScaleTo(0.1,0.95),
			cc.ScaleTo(0.15,0.85),
			cc.ScaleTo(0.2,0.9),
			cc.FadeOut(0.8),
			cc.RemoveAction()))
		self:addChild(sprite)
	end
	


	self:runAction(cc.Sequence(
		cc.DelayTime(0.42), --等待进阶动画的时间
		cc.CallFunc(function()
			local upAction = GameUtil:createEffect("ShengDuan",false)
			upAction:setPosition(x-10,y-10)
			upAction:runAction(cc.Sequence(cc.DelayTime(0.8),cc.RemoveAction()))
			self:addChild(upAction)			
		end),
		cc.DelayTime(0.45),
		cc.CallFunc(function()
			finishHandler()
		end)
	))
end

function This:refreshStarInfo(isOnlyStar,isNotRefreshBar)
	local order = self:getStarOrder(self.m_config)
	for i = 1 , 5 do
		local key = order[i]
		self.m_csNode.marquis["star"..key]:setVisible(self.m_rank < kMaxMatchRankLv and self.m_star >= i and self.m_config.star >= i)
		self.m_csNode.marquis["starbg"..key]:setVisible(self.m_rank < kMaxMatchRankLv and self.m_config.star >= i)
	end
	self.m_csNode.marquis.marquistar:setVisible(self.m_rank >= kMaxMatchRankLv)
	self.m_csNode.marquis.marquistar.starnumber:setString("x"..self.m_star)
	self.m_csNode.marquis.marquisname:setString(self.m_config.rank_level)	
	self.m_csNode.marquis.marquisicon:setImage(RankIconImage[self.m_rank])
	
	if not isNotRefreshBar then
		local progress = self.m_score / self.m_config.score
		local time = math.abs(progress - self.m_progress) * self.m_scoreChangeTime
		if time > 0.005 then
			self.m_progressTimer:fromToTimer(time,self.m_progress,progress)
		else
			self.m_progressTimer:setPercent(progress * 100)
		end
		self.m_progress = progress
	end

	if not isOnlyStar then
		self.m_csNode.assess.jifen:setString(string.format("%d/%d",self.m_score,self.m_config.score))
		self.m_csNode.assess.jifendes:setString(string.format(Serialize[61947],self.m_config.score))
		self.m_csNode.marquis.marquistar.starnumber:setString(string.format("x%d",self.m_star))
	end
end

function This:addOneStar(isFirst)
	local w1 , h1 = self.m_csNode.assess.icon:getContentSize()
	local x1 , y1 = self.m_csNode.assess.icon:convertToWorldSpace(w1/2,h1/2)

	function runAddStarAction()
		if self.m_star <= 0 then
			self:addOneStar(false)
			return 
		end
		local tx , ty
		if self.m_rank >= kMaxMatchRankLv then
			local starNode = self.m_csNode.marquis.marquistar.staricon
			local w2 , h2 = starNode:getContentSize()
			tx , ty = starNode:convertToWorldSpace(w2 / 2,h2 / 2)			
		else
			local order = self:getStarOrder(self.m_config)
			local starNode = self.m_csNode.marquis["star"..order[self.m_star]]
			local w2 , h2 = starNode:getContentSize()
			tx , ty = starNode:convertToWorldSpace(w2 / 2,h2 / 2)
		end

		if isFirst then
			self:firstStarUpAction(tx,ty,function()
				self:refreshStarInfo()	
				self:addOneStar(false)
			end)
		else
			self:starUpAction(x1,y1,tx,ty,function()
				self:refreshStarInfo()	
				self:addOneStar(false)			
			end)
		end
	end

	if self.m_star >= self.m_config.star then
		self.m_star = self.m_star - self.m_config.star
		self.m_rank = math.min(self.m_rank + 1,kMaxMatchRankLv)
		self.m_config = MatchingConfig[self.m_rank]
		self:rankUpAction(function()
			self:refreshStarInfo()
			runAddStarAction()
		end,true)
	else
		if self.m_starChangeCount <= 0 then
			self:initRankAction()
		else
			self.m_star = self.m_star + 1
			self.m_starChangeCount = self.m_starChangeCount - 1
			if not isFirst then
				self.m_score = self.m_score - self.m_config.score
			end
			runAddStarAction()
		end
	end
end

function This:reduceOneStar()
	local w1 , h1 = self.m_csNode.assess.icon:getContentSize()
	local x1 , y1 = self.m_csNode.assess.icon:convertToWorldSpace(w1/2,h1/2)
	local function runReduceStarAction()
		local tx , ty
		if self.m_rank >= kMaxMatchRankLv then
			local starNode = self.m_csNode.marquis.marquistar.staricon
			local w2 , h2 = starNode:getContentSize()
			tx , ty = starNode:convertToWorldSpace(w2 / 2,h2 / 2)			
		else
			local order = self:getStarOrder(self.m_config)
			local starNode = self.m_csNode.marquis["star"..order[self.m_star]]
			local w2 , h2 = starNode:getContentSize()
			tx , ty = starNode:convertToWorldSpace(w2 / 2,h2 / 2)
		end
		self:starDownAction(tx,ty,x1,y1,
			function()
				self.m_star = self.m_star - 1
				self.m_score = self.m_score + self.m_config.score   --- self.m_config.limit_socre
				self.m_progressTimer:setPercent(100)
				self.m_starChangeCount = self.m_starChangeCount - 1
				self:refreshStarInfo(true)
			end,
			function()
				self:refreshStarInfo()
				self:reduceOneStar()			
			end
		)
	end

	if self.m_star <= 0 and self.m_starChangeCount > 0 then
		self.m_rank = math.max(self.m_rank - 1,1)
		self.m_config = MatchingConfig[self.m_rank]
		self.m_star = self.m_config.star
		self.m_score = self.m_score + self.m_config.score  --- self.m_config.limit_socre
		self:rankUpAction(function()
			self:refreshStarInfo()
			if self.m_star > 0 then
				runReduceStarAction()
			else
				self:reduceOneStar()
			end
		end,false)
	else
		if self.m_starChangeCount <= 0 then
			self:initRankAction()
		else
			runReduceStarAction()
		end
	end
end

function This:initStarAction()
	local curStarTotal , preStarTotal = 0, 0
	for i = 1 , self.m_curRankLv - 1 do
		curStarTotal = curStarTotal + MatchingConfig[i].star
	end
	for i = 1 , self.m_preRankLv - 1 do
		preStarTotal = preStarTotal + MatchingConfig[i].star
	end
	local star = curStarTotal + self.m_curStar - preStarTotal - self.m_preStar
	if star > 0 then
		self.m_starChangeCount = star
		self:addOneStar(true)
	elseif star < 0 then
		self.m_starChangeCount = -star
		self:reduceOneStar()
	else
		self:initRankAction()
	end
end

function This:initRankAction()
	local dist = 400
	self.m_csNode.marqcompare:setVisible(true)
	local x , y = self.m_csNode.marqcompare:getPosition()
	self.m_csNode.marqcompare:setPosition(x + dist, y)
	self.m_csNode.marqcompare:runAction(cc.Sequence(
		cc.MoveTo(0.5,x,y,"BounceIn"),
		cc.CallFunc(function()
			self.m_csNode.continue:setVisible(true)
			self.m_csNode.descrp:setVisible(true)
			self:onTouchMask()
		end)
	))
end

function This:onTouchMask()
	self.m_star = self.m_curStar
	self.m_rank = self.m_curRankLv
	self.m_config = self.m_curConfig
	self.m_score = self.m_curScore
	self:refreshStarInfo()
	for i = 1 , 2 do
		self.m_csNode.assess["des"..i]:setVisible( self.m_scoreList[i] ~= 0)
		self.m_csNode.assess["jifen"..i]:setVisible( self.m_scoreList[i] ~= 0)
	end

	self.m_csNode.marqcompare:setVisible(true)
	self.m_csNode.marqcompare:setPosition(self.m_initRankX,self.m_initRankY)
	self.m_csNode.assess:setVisible(true)
	self.m_csNode.assess:setPosition(self.m_initScoreX,self.m_initScoreY)
	self.m_csNode.continue:setVisible(true)
	self.m_csNode.descrp:setVisible(true)

	if self.m_particle then
		self.m_particle:removeFromParent()
		self.m_particle = nil
	end

	if self.m_starEff then
		self.m_starEff:removeFromParent()
		self.m_starEff = nil
	end

	self:stopAllActions()
	self.m_csNode.assess:stopAllActions()
	self.m_csNode.marqcompare:stopAllActions()
end



--endregion
