-- @Author: Su
-- @Date:   2020-04-16 14:15:24
-- @Last Modified by:   zheng
-- @Last Modified time: 2020-07-09 12:00:24
-- @File Name: MatchingLevelListRechargePanel.lua

local This, super = class(..., "NodeUI")
local MatchManager = require("Match.MatchManager")
local MatchingLevelListRechargeItemView = require("Match.MatchingLevelListRechargeItemView")
local NewActivityManager = require("NewActivity.NewActivityManager")
local GameUtil = require("Util.GameUtil")
local GamePlayer = require("Player.GamePlayer")


function This:initData(info)
    self.m_activity = NewActivityManager:getActivity(NewActivityType.kSeasonRecharge)
    -- self.m_activity:onGetActivityInfoRequest()
end

function This:initNode(info)
    self.m_csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/MatchingLevelListRecharge.csb")
    self:addChild(self.m_csNode)

    self.m_scrollView = self.m_csNode.scrollView
    self:refresh()
end

function This:onEnter()
    super.onEnter(self)
	self.m_activity:addObserver(self)
end

function This:onExit()
    self.m_activity:removeObserver(self)
    super.onExit(self)

end

function This:initTouchEvent()
    local csNode = self.m_csNode
    csNode.button:setTouchEnded(function()
        g_scene:openDialog("System.RechargeMainUI")     
    end)
end

function This:refresh()
	local number = self.m_activity:getPayNum()
    if number then
	    self.m_csNode.chongzhi:setString(Serialize[60194] .. Serialize[60195].. number)
    end
    self.m_scrollView:removeAllItems()
    self.m_scrollView:setTouchEnabled(true)
    local taskList= self.m_activity:getTurnDatas()
    for _,chapt in ipairs(taskList) do
        local view = MatchingLevelListRechargeItemView:create(chapt,number)
        local w , h = view:getContentSize()
        self.m_scrollView:pushNode(view, w, h, nil)
    end
end

function This:onRefreshListRecharge()
    self:refresh()
end

function This:onUpdateActivity( act )
    if act:getId() == NewActivityType.kSeasonRecharge then
        local csNode = self.m_csNode
        local time =MatchManager:getSeasonEndTime() - GamePlayer:getServerTime()
        if csNode.time then
            csNode.time:setString(Serialize[60123] .. GameUtil:formatDTime(Serialize["activity_BaseTabs_1_c"] ,time))
        end
    end
end