-- @Author: Su
-- @Date:   2020-04-15 16:25:52
-- @Last Modified by:   Su
-- @Last Modified time: 2020-04-15 16:25:52
-- @File Name: MatchingLevelListRewardItemView.lua

local This , super = class(..., "NodeView")
This.fileName = "MenuScene/NodeUI/MatchingLevelListRewardItem.csb"

local SeasonRewardConfig = require("Metadatas.SeasonRewardConfig")
local ItemNode = require("UI.ItemNode")
local MatchManager = require("Match.MatchManager")


function This:initData(lev, config)
    self.m_level = lev or 1
    self.m_config = config
    self.m_inited = false
    local w , h = self.bg:getContentSize()
    self:setContentSize(w,h)
    self.duanwei:setImage(RankIconImage[self.m_level])
end

-- function This:onEnter()
--     -- super.onEnter(self)
--     MatchManager:addObserver(self)
-- end

-- function This:onExit()
-- 	MatchManager:removeObserver(self)
--     -- super.onExit(self)
-- end

function This:initNode()
    self:refreshItemUI()
end

function This:refreshItemUI()
    local seasonId = MatchManager:getSeasonId()

    self.des:setString(string.format(Serialize[61925], self.m_config.rank_level))
    self.title:setString(self.m_config.rank_level)
    local item = SeasonRewardConfig[seasonId * 1000 + self.m_level].office_reward[1]
    local node = ItemNode:create(item[1],item[2])
    node:setAnchorPoint(0.5,0.5)
    self.season_item:addChild(node)

    self.gaoguang:setVisible(self.m_level==MatchManager:getRankLv())
end