--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"cc.Node")
local GameUtil = require("Util.GameUtil")
local MatchingConfig = require("Metadatas.MatchingConfig")

function This:init(info,index)
	self.m_index = index
	self.m_id = info.role_id
	self.m_name = info.role_name
	self.m_level = info.role_level
	self.m_icon = info.role_icon
	self.m_rank = math.floor(info.rank_first_key / 10000)
    self.m_rank = self.m_rank > 0 and self.m_rank or 1
	self.m_star = info.rank_first_key % 10000
	self.m_score = info.rank_second_key
	self.m_serverId = info.server_id
	self.m_csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/RankingListItem.csb")
	self:addChild(self.m_csNode)
	local w , h = self.m_csNode.bg:getContentSize()
	self:setContentSize(w,h)
	self:initInfo()
end

function This:initRankIndexNode(node)
	node:removeAllChildren()
	if self.m_index <= 3 then
		local sprite = cc.Sprite:create(string.format("Common/%d.png",self.m_index))
		node:addChild(sprite)
		self.m_csNode.rankbg:setImage(RankBgImage[self.m_index])
	else
		local index = self.m_index
		local nodes = {}
		while index > 0 do
			local n = index % 10
			index = math.floor(index / 10)
			local sprite = cc.Sprite:create(string.format("MenuScene/RankNumber/%d.png",n))
			table.insert(nodes,sprite)
		self.m_csNode.rankbg:setVisible(false)
		end
		local w = 0
		for i = #nodes , 1 , -1 do
			local sprite = nodes[i]
			sprite:setPositionX(w)
			w = w + sprite:getContentWidth()
			node:addChild(sprite)
		end
	end
end

function This:initInfo()
	self:initRankIndexNode(self.m_csNode.rank)
	GameUtil:setPlayerIconNodeImage(self.m_csNode.pic.icon, self.m_icon)
	self.m_csNode.name:setString(self.m_name)
	self.m_csNode.level:setString(Serialize[61950]..self.m_level)
	if MatchingConfig[self.m_rank] == nil then
		print(string.format("官职等级错误,rank = %d",self.m_rank))
		assert(false)
	end
	self.m_csNode.marquis:setString(MatchingConfig[self.m_rank].rank_level)
	self.m_csNode.starnumber:setString(self.m_star)
	self.m_csNode.marquisicon:setImage(RankIconImage[self.m_rank] or RankIconImage[1])
end


--endregion
