--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"cc.Node")
local GameUtil = require("Util.GameUtil")
local MatchManager = require("Match.MatchManager")
local GamePlayer = require("Player.GamePlayer")
local MatchingConfig = require("Metadatas.MatchingConfig")

function This:init(role)
	self.m_role = role
	self.m_csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/TeamMatchingItem.csb")
	self:addChild(self.m_csNode)
	local w, h = self.m_csNode.bg:getContentSize()
	self:setContentSize(w,h)
	self.m_csNode:setPosition(w/2,h/2)
	self:setAnchorPoint(0.5,0.5)
	self:refresh() 
end

function This:refresh()
	self.m_csNode.content:setVisible(self.m_role ~= nil)
	self.m_csNode.self:setVisible(self.m_role and self.m_role:getId() == GamePlayer:getPlayerID())
	if self.m_role then
		local room = MatchManager:getRoom()
		GameUtil:setPlayerIconNodeImage(self.m_csNode.content.icon, self.m_role:getIcon())
		self.m_csNode.content.level:setString("Lv." .. self.m_role:getLevel())
		self.m_csNode.content.name:setString(self.m_role:getName())
		self.m_csNode.content.duizhang:setVisible(self.m_role:isRoomOwner())
		self.m_csNode.content.yizhunbei:setVisible(self.m_role:isReady())
		self.m_csNode.content.setbutton:setVisible(room:getRelationType() == MatchRelationType.kJun and room:getOwnerId() == GamePlayer:getPlayerID() and not self.m_role:isMaster())
		self.m_csNode.content.zhugong:setVisible(self.m_role:isMaster())
		self.m_csNode.content.close:setVisible(not self.m_role:isRoomOwner() and room:getOwnerId() == GamePlayer:getPlayerID())
		self.m_csNode.content.office:setString(MatchingConfig[self.m_role:getRank()].rank_level)
	end
end

function This:initTouchEvent()
	self.m_csNode.content.close:setTouchEnded(function()
		MatchManager:onExitTeamMatchRequest(self.m_role:getId())
	end)
	self.m_csNode.content.setbutton:setTouchEnded(function()
		MatchManager:onChangeRoomOwnerRequest(self.m_role:getId())
	end)
end

function This:onEnter()
	super.onEnter(self)
	self:initTouchEvent()
end

function This:onExit()
	super.onExit(self)
end

function This:getModel()
	return self.m_role
end

function This:setModel(role)
	if self.m_role ~= role then
		self.m_role = role
	end
	self:refresh()
end

--endregion
