local Socket = nil
local SocketError = {
    [0]="Unknow",
    [1]="CannotCreateSocket",
    [2]="ConnectTimeOut",
    [3]="ServerProcessNotExist",
    [4]="CannotFindRoute",
    [5]="LostConnection",
    [6]="RecvEmpty",
}

local EventDispather = require("EventDispatcher")

NetCode =
{
	kNormalConnect = 0, --正常连接
	kSocketInvalid = 1, --socket无效
	kConnectFailed = 2, --连接失败
	kConnectSecceed = 3, --连接成功
	kSdkLoginSecceed = 1001, --sdk登录成功
	kSdkLoginFalied = 1002, --sdk登录失败
	kSdkLogout = 1003, --退出
	kSdkPaymentSecceed = 1004, --
	kSdkPaymentFailed = 1005,
	kJpushRegist = 1008,  --
	kIosKeyboardShow = 9000,
	kIosKeyboardHide = 9001,
}

function onNativeCall(id,param1,param2,param3)
	if not Socket then
        Socket = require("Net.Socket")
    end
	print("-------onNativeCall------",id,param1)
	if id == NetCode.kNormalConnect then
		Socket:handleCmd(param1,param2,param3)
	elseif id == NetCode.kConnectSecceed then
		Socket:connectServerSecceed()
	elseif id == NetCode.kSdkPaymentSecceed then
		EventDispather:dispatcher("sdk_payment_secceed",param1)
	elseif id == NetCode.kSdkPaymentFailed then
		EventDispather:dispatcher("sdk_payment_failed",param1)
	elseif id == NetCode.kConnectFailed then
		Socket:connectFailed()
	elseif id == NetCode.kSocketInvalid then
		Socket:connectLost()
	elseif id == NetCode.kSdkLoginSecceed then
		EventDispather:dispatcher("sdk_login_secceed",param1,param2)
	elseif id == NetCode.kSdkLoginFalied then
		EventDispather:dispatcher("sdk_login_failed")
	elseif id == NetCode.kSdkLogout then
		EventDispather:dispatcher("sdk_logout")
	elseif id == NetCode.kJpushRegist then
		EventDispather:dispatcher("jpush_regist",param1)
	elseif id == NetCode.kIosKeyboardShow then
		EventDispather:dispatcher("ios_keyboard_show", tonumber(param1))
	elseif id == NetCode.kIosKeyboardHide then
		EventDispather:dispatcher("ios_keyboard_hide")
	end
end

debug.getregistry()["onNativeCall"] = onNativeCall

if os.isWin32 then
    local FuncList = {
        pay = function (payCode, name, price, desc, order)
            if lib2d.showMessageBox(Serialize[60056], Serialize[60057] .. price .. Serialize[60058]) then
                onNativeCall(1001, payCode, order, tostring(os.time()))
            else
                onNativeCall(1002, payCode, order)
            end
        end,
        isLogined = function ()
            return true
        end
    }
    local native_call = os.native_call
    os.native_call = function (name, ...)
        native_call(name, ...)
        if FuncList[name] then
            return FuncList[name](...)
        end
    end
end