local convertor = {}
local function analyzeUnionValue(unionValue)
    if unionValue.table then
        local ret = loadstring("return " .. unionValue.table)
        if not ret then
            logError(unionValue.table)
        end
        return ret()
    else
        return unionValue.int or unionValue.str or unionValue.bool
    end
end

local GameUtil = require("Util.GameUtil")
convertor.common_data_multi = function(message)
    local subcmd = message.subcmd
    local data  = analyzeUnionValue(message.data)
    message.data = data
    local dataName, fields = string.match(subcmd, "(%w+)%.(.*)")
    local manager = GameUtil:getDataManager(dataName)
    local rootData = manager:getData()
    local lastDt = rootData
    if os.isWin32 then
        assert(lastDt, dataName .. "/" .. fields)
    elseif not lastDt then
        return
    end

    local lastField
    local fieldList = {}
    for field in (fields .. "."):gmatch("(.-)%.") do
        field = tonumber(field) or field
        if lastField then
            local fieldDt = lastDt[lastField]
            if not fieldDt then
                fieldDt = {}
                lastDt[lastField] = fieldDt
                print("Warining_CommonData.............", subcmd, lastField)
            end
            lastDt = fieldDt
        end
        lastField = field
        table.insert(fieldList, field)
    end
    local lastValue  = lastDt[lastField]
    lastDt[lastField] = data
    if manager:callMsgOnDataUpdate(fieldList, data, lastValue) == false then
        require("EventDispatcher"):addMsg("common_data_" .. dataName, {fieldList=fieldList, data=data})
    end
    return message
end

convertor.common_typedata_multi = function(message)
    local subcmd = message.subcmd
    local dataName, fields = string.match(subcmd, "(%w+)%.?(.*)")
	print(string.format("*****************LOAD MODULE DATA : %s*********************",subcmd))
    local rootData = assert(message[dataName], dataName)
    local manager = GameUtil:getDataManager(dataName)
    if fields ~= "" then
        local data = rootData
        rootData = manager:getData()
        local lastDt = rootData
        if os.isWin32 then
            assert(lastDt, dataName .. "/" .. fields)
        elseif not lastDt then
            return
        end

        local lastField
        local fieldList = {}
        for field in (fields .. "."):gmatch("(.-)%.") do
            field = tonumber(field) or field
            if lastField then
                local fieldDt = lastDt[lastField]
                if not fieldDt then
                    fieldDt = {}
                    lastDt[lastField] = fieldDt
                    print("Warining_CommonTypeData.............", subcmd, lastField)
                end
                lastDt = fieldDt
            end
            lastField = field
            table.insert(fieldList, field)
            data = data[field]
        end
        if not lastDt then
            logError("not lastDt, subcmd:" .. subcmd)
        end
        local lastValue  = lastDt[lastField]
        lastDt[lastField] = data
        if manager:callMsgOnDataUpdate(fieldList, data, lastValue) == false then
            require("EventDispatcher"):addMsg("common_data_" .. dataName, {fieldList=fieldList, data=data})
        end
    else
        manager:loadData(rootData)
    end
    return message
end
return convertor