-- @Author: Su
-- @Date:   2019-06-06 10:25:14
-- @Last Modified by:   zheng
-- @Last Modified time: 2019-06-15 16:42:56
-- @File Name: ActivityDecreeRewardItem.lua
-- @Description: 

local This , super = class(...,"NodeUI")
local ItemNode = require("UI.ItemNode")
local ViewUtil = require("UI.ViewUtil")
local GameUtil = require("Util.GameUtil")


function This:initNode(info)
    self.m_stage = info.stage
    self.m_activity = info.activity
    -- self.m_config = self.m_activity:getConfigById(self.m_id)
    self.m_csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/DecreeRewardItem.csb")
    self:addChild(self.m_csNode)
    self:initView()
    self:refresh()
end

function This:getSize()
    local w,h = self.m_csNode.bg:getContentSize()
    return w,h
end

function This:initView()
    self.m_csNode.title:setString(string.format( Serialize[60312],self.m_stage))
    local rewardList,vipRewardList = self.m_activity:getRewardByStage(self.m_stage)
    for i,info in ipairs(rewardList) do
        local node = ItemNode:create(info[1],info[2])
        -- node:setAnchorPoint(0,0)
        node:setScale(0.7)
        node:setPosition(node:getPositionX() - 25,node:getPositionY() - 30)
        self.m_csNode.bg1["item"..i]:addChild(node)
    end

    for i,info in ipairs(vipRewardList) do
        local node = ItemNode:create(info[1],info[2])
        node:setScale(0.7)
        node:setPosition(node:getPositionX() - 25,node:getPositionY() - 30)
        -- node:setAnchorPoint(0,0)
        self.m_csNode.bg2["item"..i]:addChild(node)
    end
end

function This:refresh()
    local canRecevie = self.m_activity:getDecreeStage() >= self.m_stage
    local nextCanRecevie = self.m_activity:getDecreeStage() >= self.m_stage and self.m_activity:getVipNum() == 1
    local bg1 = self.m_csNode.bg1
    local bg2 = self.m_csNode.bg2
    bg1.yilingqu:setVisible(self.m_activity:isDecreeRewardReceive(self.m_stage + 1000))
    bg1.zhezhao:setVisible(self.m_activity:isDecreeRewardReceive(self.m_stage + 1000))
    bg2.yilingqu:setVisible(self.m_activity:isDecreeRewardReceive(self.m_stage + 2000))
    bg2.zhezhao:setVisible(self.m_activity:isDecreeRewardReceive(self.m_stage + 2000))

    bg1.xuanzhong:setVisible(false)
    bg2.xuanzhong:setVisible(false)
    if canRecevie and not self.m_activity:isDecreeRewardReceive(self.m_stage + 1000) then
        if not self.m_Effect1 then
            local w,h = bg1.xuanzhong:getContentSize()
            self.m_Effect1 = GameUtil:createEffect("ZL_LingQu1",true)
            self.m_Effect2 = GameUtil:createEffect("ZL_LingQu2",true)
            self.m_Effect1:setPosition(w/2,h/2)
            self.m_Effect2:setPosition(w/2,h/2)
            bg1.effect:addChild(self.m_Effect1,-1)
            bg1.effect:addChild(self.m_Effect2,-1)
        end
    else
        self.m_Effect1 = nil
        self.m_Effect2 = nil
        bg1.effect:removeAllChildren()

    end
    if nextCanRecevie and not self.m_activity:isDecreeRewardReceive(self.m_stage + 2000) then

        if not self.m_Effect3 then
            local w,h = bg2.xuanzhong:getContentSize()

            self.m_Effect3 = GameUtil:createEffect("ZL_LingQu1",true)
            self.m_Effect4 = GameUtil:createEffect("ZL_LingQu2",true)
            self.m_Effect3:setPosition(w/2,h/2)
            self.m_Effect4:setPosition(w/2,h/2)
            bg2.effect:addChild(self.m_Effect3)
            bg2.effect:addChild(self.m_Effect4)
        end
    else
        self.m_Effect3 = nil
        self.m_Effect4 = nil
        bg2.effect:removeAllChildren()
    end
end

function This:onEnter()
    super.onEnter(self)
    self.m_activity:addObserver(self)
end

function This:onExit()
    self.m_activity:removeObserver(self)
    super.onExit(self)
end

function This:initTouchEvent()
    self.m_csNode.bg1:setTouch({
        isScale = false, 
        isDynamic = true, 
        isContainer  = true,
        onEnded = function ()
            if self.m_activity:getDecreeStage() >= self.m_stage then
                self.m_activity:onGetDecreeRewardRequest(self.m_stage+1000)
            else
                g_scene:showTips(Serialize[61984])
            end
    end})

    self.m_csNode.bg2:setTouch({
        isScale = false, 
        isDynamic = true, 
        isContainer  = true,
        onEnded = function ()
            if self.m_activity:getVipNum() == 0 then
                g_scene:showTips(Serialize[61985])
                return
            end
            if self.m_activity:getDecreeStage() >= self.m_stage then
                self.m_activity:onGetDecreeRewardRequest(self.m_stage+2000)
            else
                g_scene:showTips(Serialize[61984])
            end
    end})

end

function This:onDecreeTaskStateRefresh()
    self:refresh()
end

function This:onDecreeRefresh()
    self:refresh()
end