-- @Author: Su
-- @Date:   2019-06-05 17:05:14
-- @Last Modified by:   Su
-- @Last Modified time: 2019-06-05 17:05:14
-- @File Name: ActivityDecreeRewardNode.lua
-- @Description: 

local This , super = class(...,"NodeUI")
local NewActivityManager = require("NewActivity.NewActivityManager")
local ActivityDecreeRewardItem = require("NewActivity.ActivityDecreeRewardItem")
local GamePlayer = require("Player.GamePlayer")
local GameUtil = require("Util.GameUtil")
local SdkManager = require("Sdk.SdkManager")



function This:initNode()
    self.m_csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/DecreeReward.csb")
    self:addChild(self.m_csNode)

    self.m_activity =NewActivityManager:getActivity(NewActivityType.kDecreeTask)
    self:refreshReward()
    self:refresh()

end

function This:onEnter()
    super.onEnter(self)
    GamePlayer:addObserver(self)
    self.m_activity:addObserver(self)
end

function This:onExit()
    GamePlayer:addObserver(self)
    self.m_activity:removeObserver(self)
    super.onExit(self)
end

function This:initTouchEvent()
    self.m_csNode.kaitong:setTouchEnded(function ()
        SdkManager:onApplyBillIDRequest(52)
    end)

    self.m_csNode.gantanhao:setTouchEnded(function ()
        g_scene:openDialog("UI.HelpTips",{text = Serialize[61987],node = self.m_csNode.gantanhao})
    end)

    self.m_csNode.info:setTouchEnded(function()
        g_scene:openDialog("NewActivity.ActivityDecreeTaskLvPanel",{})
    end)
end

function This:refreshReward()
    local cNode = self.m_csNode
    local scrollView = cNode.ScrollView
    scrollView:setDirection("horizontal")
    scrollView.m_direction ="right"
    scrollView:removeAllItems()
    local maxStage = self.m_activity:getMaxStage()
    for i=1,maxStage do
        local item = ActivityDecreeRewardItem:create({stage = i,activity = self.m_activity})
        local w,h = item:getSize()
        scrollView:pushBackCustomItem(item,w-10,h,0.5)
    end
end

function This:refresh()
    local cNode = self.m_csNode
    cNode.dengjinum:setString(self.m_activity:getDecreeStage())
    cNode.jifen:setStringWithColor(string.format( Serialize[61988],self.m_activity:getDecreeNum(),self.m_activity:getLostNum()))
    cNode.tips2:setStringWithColor(Serialize[61989])
    if self.m_activity:getVipNum() == 1 then
        cNode.tips2:setStringWithColor(Serialize[61990])
    end
    self.m_csNode.kaitong:setVisible(self.m_activity:getVipNum() ~= 1)
    -- cNode.jifennum:setString(string.format( "%d/%d",self.m_activity:getOfficeNum(),888))
    cNode.jindubg.jindutiao:setPercent(self.m_activity:getPercent())
    cNode.biaoqian:setVisible(self.m_activity:getVipNum() ~= 1)
    -- cNode.kezhuanjifennum:setString(string.format( Serialize[61991],self.m_activity:getOfficeNum()))
    -- cNode.renwunum:setString(string.format( Serialize[61992],0))
end

function This:refreshTime()
    local node = self.m_csNode
    local leftTime = self.m_activity:getEndTime() - GamePlayer:getServerTime()
    node.time:setString(GameUtil:formatDTime(Serialize[60856],leftTime))
end

function This:onUpdateActivity(activity)
    local type = activity:getId()
    if type == NewActivityType.kDecreeTask then
        self:refreshTime()
    end
end

function This:onDecreeRefresh()
    self:refresh()
end

function This:onDecreeTaskStateRefresh()
    self:refresh()
end