-- @Author: zheng
-- @Date:   2018-08-07 19:16:50
-- @Last Modified by:   zheng
-- @Last Modified time: 2019-03-23 14:59:50
-- @File Name: ActivityHappyTurnDayItemView.lua

local This , super = class(...,"NodeView")
local UpdateLayer = require("UI.UpdateLayer")
local ItemNode = require("UI.ItemNode")
This.fileName = "MenuScene/NodeUI/ActivityHappyTurnTableDayList.csb"
local NewActivityManager = require("NewActivity.NewActivityManager")

local strList ={
    count ="次",
}

function This:initData(info)
    --基础类尽量不要修改 FamilyRatingRewardItemView,ChallengeTimesItemView,ChallengeTurnDayItemView,RecruitRewardItemView,RescuRewardItemView
    self:resetInfo(info)
    self.m_inited = false
    local w , h = self.beijing.bg:getContentSize()
    self:setContentSize(w,h)
    self.scrollview:setDirection("horizontal")
    self.scrollview.m_direction = "right"
end

function This:resetInfo(info)
   if info then
        if info.customConfig then
            self.m_activityType = info.activityType or NewActivityType.kLuckyRoulette
            self.m_config = info.customConfig
        else
            self.m_config = info
        end
    end 
end

function This:initNode()
    self:refreshItemUI()
    self:refresh()
end

function This:initTouchEvent()
    if not self.m_inited then
        self.button:setTouch({
            getRect = function (touch)
                local rect = touch.sizeNode:getBoundingBox()
                return rect
            end,
            onEnded = function()
                self:onPickUpBtnClick()
            end,
            isContainer = true,
            isDynamic = true,
            isScale = false,
        })  
        self.m_inited = true
        self.scrollview:setSwallowTouch(false)
    end
end

function This:refreshItemUI()
    self.scrollview:removeAllItems()
    local function createItemView(model)
        local node = ItemNode:create(model[1],model[2])
        node:setAnchorPoint(0.5,0.5)
        return node
    end
    local rewardList = self.m_config.reward
    for i,itemConfig in ipairs(rewardList) do
        local item = createItemView(itemConfig)
        local scale = 0.9
        item:setScale(scale)
        local w , h = item:getContentSize()
        self.scrollview:pushBackCustomItem(item,w*scale,h,0.5)
    end
end

function This:setItemEnable(enble)
    if self:isLocked() then
        self.button:setGrayShader()
        self.button:setVisible(true)
        
        if self.yilingqu then 
            self.yilingqu:setVisible(false)
        end
    else
        if enble then
            self.button:clearShader()
        else
            self.button:setVisible(false)
        end

        if self.yilingqu then 
            self.yilingqu:setVisible(not enble)
        end
    end
end

function This:onPickUpBtnClick()
    if self:isOpening() then
        self.m_activity = NewActivityManager:getActivity(self.m_activityType)
        self.m_activity:onGetTurnBoxRequest(self.m_config.id)
    end
end

function This:refresh(info)
    self:resetInfo(info)
    self.numbercishu:setString(self.m_config.times .. strList.count)
    self:setItemEnable(self:isOpening())
end

function This:isOpening()
    return self.m_config and self.m_config.state == HappyTurnBoxState.kOpen
end

function This:isLocked()
    return self.m_config and self.m_config.state == HappyTurnBoxState.kLock
end