-- @Author: zheng
-- @Date:   2018-08-06 15:24:41
-- @Last Modified by:   zheng
-- @Last Modified time: 2019-03-23 15:00:01
-- @File Name: ActivityHappyTurnDayPanel.lua

local This , super = class(...,"Dialog")


local ActivityHappyTurnDayItemView = require("NewActivity.ActivityHappyTurnDayItemView")
local NewActivityManager = require("NewActivity.NewActivityManager")
local This , super = class(...,"Dialog")
local ItemNode = require("UI.ItemNode")
local GameUtil = require("Util.GameUtil")

function This:initNode(info)
    --基础类尽量不要修改 FamilyRatingRewardPanel,ChallengeTimesRewardPanel,ChallengeTurnDayPanel,RecruitRewardPanel,RescuRewardPanel
    if info and info.activityType then
        self.m_activityType = info.activityType
    end
    self.m_itemViews = {}
    self.m_csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/ActivityHappyTurnTableDay.csb")
    self:addChild(self.m_csNode)
    self:initCustomUi()
    self.m_csNode:setToCenter()
    self:onGetTurnBox()

end

function This:releaseAllViews()
    for _, view in pairs(self.m_itemViews) do
        view:release()
    end
    self.m_itemViews={}
end

function This:refreshRewardList()
    self.m_csNode.scrollView:removeAllItems()
    self.m_csNode.scrollView:setTouchEnabled(true)
    table.sort(self.m_itemDataList, function( a, b )
        if a.state ~= b.state then
            return a.state > b.state
        else
            return a.id < b.id
        end
    end)

    for index, data in ipairs(self.m_itemDataList) do
        local itemId = data.id
        local view = self.m_itemViews[itemId]
        local info = data
        if self.m_activityType then
            info = {activityType = self.m_activityType,customConfig = data}
        end
        if not view then
            view = self:createItemView( info )
            self.m_itemViews[itemId] = view
            view:retain()
        else
            view:refresh(info)
        end
        local w , h = view:getContentSize()
        self.m_csNode.scrollView:pushNode(view, w, h)
    end  
end

function This:initTouchEvent()
    self.m_csNode.closebg:setTouchEnded(function()
        if self.m_runningAniantion then
            return false
        end
        self:close()
    end)
end

function This:onEnter()
    super.onEnter(self)
    self:addManager()
end

function This:onExit()
    self:releaseAllViews()
    self:removeManager(  )
    super.onExit(self)
end


function This:addManager(  )
    self.m_activity:addObserver(self)
end

function This:removeManager(  )
    self.m_activity:removeObserver(self)
end

function This:initCustomUi(  )
    self.m_activity = NewActivityManager:getActivity(self.m_activityType)
end


function This:createItemView( data )
    return ActivityHappyTurnDayItemView:create(data)
end

function This:onGetTurnBox()
    self.m_itemDataList = self.m_activity:getRewardList()
    self:refreshRewardList()
end