-- @Author: zheng
-- @Date:   2018-08-06 15:24:41
-- @Last Modified by:   zheng
-- @Last Modified time: 2018-09-06 11:37:21
-- @File Name: ActivityHappyTurnNode.lua
-- local ItemNode = require("UI.ItemNode")
local itemCount =5
local This , super = class(...,"cc.Node")

local strList ={
    time =Serialize[62015],
}

function This:init(infor)
	self.m_itemList = infor.itemList
	self.m_endCallBack = infor.callFunc
	self.m_itemIndex =1
	self.m_animTag = 1
	self:scheduleUpdate()
	self.m_timeOffset = 0.05
	self.m_items ={}
	self.m_itemYs ={}
	self.m_y = 0
	self.m_offsetY = 0
	self.m_node = infor.node
	self:resetData( )
	if self.m_node then
		self:initItemNode()
		self:resetItemPos(  )
	end
end

function This:resetData( )
	self.m_escape = 0
	self.m_isUpdating = false
	self.m_isDown = false--向下减速
	self.m_UniformSpeedLimit =0.1--匀速运动时间限制
	self.m_stopIndex = 3
	self.m_stopItem = {}
	self.m_count = 0 --修改y多少次了
	self.m_speedIndex = 1--y变化索引
	self.m_CurentSpeed =1
	self.m_curentCount = 0--
	self.m_isUp = false--向上加速
	self.m_UniformSpeed = 0--匀速运动时间
	self.m_times = 1--多少倍
end

function This:initItemNode( )
	for i=1,itemCount do
		self:creatItemNode(112,i,i)
		self:updateItemIcon(i)
	end
end

function This:initTouchEvent()
   
end

function This:start(index,stopItem,times)
	print("start  ","ActivityHappyTurnNode.lua",times)
	self.m_animTag = index
	self:resetData( )
	self:resetItemPos(  )
	self.m_isUpdating = true
	if index then
		self.m_UniformSpeedLimit = self.m_UniformSpeedLimit + 0.3*(index)
	end
	self.m_isUp = true
	self.m_stopItem = stopItem
	if times then
		self.m_times = times
	end
	self:scheduleUpdate()
end

function This:pause(  )
	self:unscheduleUpdate()
	-- print("end  ","ActivityHappyTurnNode.lua",self.m_times)
end


function This:resetItemPos(  )
	local halfNum = math.ceil(itemCount/2)--不小于x的最大整数
	local itemYs ={}
	for index,item in ipairs(self.m_items) do
		local y = self.m_y
		local temY = y*(index-halfNum)
    	item:setPositionY(temY)
    	table.insert(itemYs,temY)
	end
	self.m_itemYs =itemYs
	print(table.tostring(self.m_itemYs))
end

function This:updateItemPos(count)
	self.m_curentCount = self.m_curentCount +count
	local function checkNum( num1,num2 )
		-- print(num1,"num",num2)
		local temNum1 = math.abs(num1)
		if num2>= temNum1 then
			return true
		end
		return false
	end
	local isSwith = false
	local isStop = false
	for index,item in ipairs(self.m_items) do
		local temY = item:getPositionY()-self.m_offsetY*count
		if temY<self.m_itemYs[1] then
			temY = item:getPositionY() + itemCount*self.m_y-self.m_offsetY*count
			-- print("limit name",item:getName())
			isSwith= true
			self:updateItemIcon(index)
		end
		item:setPositionY(temY)
		if count ==1 and index ==self.m_stopIndex and temY==0 then
			isStop = true
		end
		if count ==1 and self.m_isDown and not self.m_isUp then
			if checkNum(temY,self.m_offsetY) or checkNum(item:getPositionY(),self.m_offsetY) then
				self:allStop(index)
				print(temY,"  ",item:getName()," ",index)
				break
			end
		end
	end
end

function This:allStop( index2 )
	local function getPosIndex( index )
		local temIndex = index
		return temIndex
	end
	for index,item in ipairs(self.m_items) do
		local temIndex= getPosIndex(index)
		local x = self.m_itemYs[temIndex]
		if x then
			item:setPositionY(x)
		end
		-- print("y",item:getPositionY())
	end
	self:pause(  )
	if self.m_endCallBack then
		local tag = self.m_animTag
		self.m_endCallBack(tag)
	end
end

function This:creatItemNode(key,num,index)
    -- print(key,"creatItemNode",num)
    local function getItem(  )
    	local node = cc.Node:createFromCSFile("MenuScene/NodeUI/ActivityHappyTurnTableItem.csb")
    	local x,y = node.kuang:getContentSize()
    	node:setContentSize(x, y)
    	return node
    end
    local function resetItem(node)
    	local ItemUtil = require("Bag.ItemUtil")
    	local itemType = ItemUtil.getType(key)
    	node.count:setString(num)
    	node.item:setImage(ItemUtil.getIconImage(key))
    	node.pieceicon:setVisible(itemType==ItemCommonType.kSpall)
    end
    local name = string.format("%s%d","ItemNode",index)
    local parent = self--self.m_node
    local node = self.m_items[index]--parent:getChildByName(name)
    if not node then
        node = getItem()--ItemNode:create(key, num,true,false,true)
        parent:addChild(node)
        node:setName(name)
        self.m_items[index] = node
        if index==1 then
    		local x,y = node:getContentSize()
    		self.m_y = y+44
        	self.m_offsetY= self.m_y/20
        end
    end
    resetItem(node)
    -- node.ItemNode:initItem(key, num)
    self:updateTimes(node)
end

--修改多少倍
function This:updateTimes(node,num)
	local bg = node.bg5
	local txt = node.discount
	local visible = false
	if num then
		visible = true
	end
	bg:setVisible(visible)
	txt:setVisible(visible)
end

function This:refreshTimes( )
	local item = self.m_items[self.m_stopIndex]
	if self.m_times>1 then
		self:updateTimes(item,self.m_times)
	end
end

function This:updateItemIcon( index )
	local itemList = self.m_itemList
	self.m_itemIndex = self.m_itemIndex+1
	if self.m_itemIndex >#itemList then
		self.m_itemIndex =1
	end
	local itemData = itemList[self.m_itemIndex]
	if self.m_isDown and index == self.m_stopIndex then
		itemData = self.m_stopItem
	end
	self:creatItemNode(itemData[1],itemData[2],index)
end

function This:update(dt)
	if self.m_isUpdating then
		self.m_escape = self.m_escape + dt
		if self.m_escape > self.m_timeOffset then
			self.m_escape = self.m_escape - self.m_timeOffset
			self.m_count = self.m_count +1
			local speeds={1,4,7,10}
			-- print("count",self.m_count)
			local isModifySpeed = self.m_count %(12) == 0
			local upLimit = #speeds
			if self.m_isUp then
				if isModifySpeed and self.m_speedIndex<upLimit then
					self.m_speedIndex = self.m_speedIndex+1
					if self.m_speedIndex==upLimit then
						self.m_isUp = false
						print("upEnd")
						self.m_count =5
					end
				end
			end
			if self.m_isDown then
				if isModifySpeed and self.m_speedIndex>1 then
					self.m_speedIndex = self.m_speedIndex-1
				end
			end
			self:updateItemPos(speeds[self.m_speedIndex])
			if not self.m_isUp and not self.m_isDown then
				self.m_UniformSpeed = self.m_UniformSpeed+ dt
				if self.m_UniformSpeed> self.m_UniformSpeedLimit then
					self:resetItemPos(  )
					self.m_count =5
					self.m_isDown = true
					print("downend")
				end
			end
		end
	end
end