--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"NewActivity.ActivityBase")
local LimitRechargeConfig = require("Metadatas.LimitRechargeConfig")
local EventDispatcher = require("EventDispatcher")
local GamePlayer = require("Player.GamePlayer")
local Socket = require("Net.Socket")

function This:init()
	super.init(self,NewActivityType.kLimitRecharge)
	self.m_totalPay = 0
	self.m_targetPay = 0
	self.m_curPay = 0
	self.m_haveReward = false
	self.m_escapeDay = 0
end

function This:initListener()
	EventDispatcher:addListener(self,12018,self.onGetActivityInfoReply)
	EventDispatcher:addListener(self,12019,self.onRewardLimitRechargeReply)
end

function This:removeListener()
	EventDispatcher:removeListener(self,12018)
	EventDispatcher:removeListener(self,12019)
end

function This:getTotalPay()
	return self.m_totalPay
end

function This:getTargetPay()
	return self.m_targetPay
end

function This:getCurPay()
	return self.m_curPay
end

function This:isHaveReward()
	return self.m_haveReward
end

function This:getEscapeDay()
	return self.m_escapeDay
end

function This:getRechargeConfig()
	return self.m_rechargeConfig
end

function This:isCanReward()
	return not self.m_haveReward and self.m_curPay >= self.m_targetPay
end

function This:getRewardList()
	local rewardList = {}
	for i , info in ipairs(self.m_rechargeConfig.reward) do
		table.insert(rewardList,{id = info[1],num = info[2]})
	end
	return rewardList
end

function This:updateRechargeConfig()
	for i , info in pairs(LimitRechargeConfig) do
		if self.m_totalPay >= info.min_money and self.m_totalPay <= info.max_money and self.m_escapeDay == info.day then
			self.m_rechargeConfig = info
			break
		end
	end
end

function This:getState()
	local state = super.getState(self)
	if state == NewActivityState.kUpdating then
		if GamePlayer:getLevel() < self.m_config.level_min then
			return NewActivityState.kNotOpen
		end
	end
	return state
end

----------------------------------------------------
function This:onGetActivityInfoRequest()
	Socket:sendAndLock(12018,{activity_id = self:getId()})
end

function This:onGetActivityInfoReply(msg)
	if msg.err_code == 0 then
		self.m_totalPay = msg.total_pay
		self.m_targetPay = msg.task_pay
		self.m_curPay = msg.cur_pay
		self.m_haveReward = msg.reward
		self.m_escapeDay = msg.days
		self:updateRechargeConfig()
		self:notifyObservers("onRefreshLimitRecharge")
		EventDispatcher:dispatcher("activity_limit_recharge_changed")
	else
		g_scene:handleErrorCode(msg.err_code)
	end
end

function This:onRewardLimitRechargeRequest()
	Socket:sendAndLock(12019,{activity_id = self:getId()})
end

function This:onRewardLimitRechargeReply(msg)
	if msg.err_code == 0 then
		local rewardList = {}
		for i , info in ipairs(self.m_rechargeConfig.reward) do
			table.insert(rewardList,{id = info[1],num = info[2]})
		end
		g_scene:showReward(rewardList)
		self:notifyObservers("onRewardLimitRecharge")
	else
		g_scene:handleErrorCode(msg.err_code)
	end
end

function This:getUITypeName()
    return "NewActivity.LimitRechargeTabNode"
end

function This:getUIFileName()
    return "LabourLimitRecharge"
end

--endregion
