-- @Author: superm
-- @Date:   2018-03-14 17:23:43
-- @Last Modified by:   zheng
-- @Last Modified time: 2019-02-27 14:51:56
-- @File Name: ActivityLimitedTimePreferential.lua
-- @Description: 


local This , super = class(...,"NewActivity.ActivityBase")
local EventDispatcher = require("EventDispatcher")
local Socket = require("Net.Socket")
local GamePlayer = require("Player.GamePlayer")
local GameUtil = require("Util.GameUtil")
local AchieveManager = require("Achieve.AchieveManager")
local GameUtil = require("Util.GameUtil")
function This:init(id)
	super.init(self, id)
	self.m_curentAchieveId = 0
	if self.m_config then
	    self.m_startTime = self.m_config.start_time or 0
	    self.m_endTime = self.m_config.end_time or 0
	end
	self.m_isHaveShow = false
end

function This:setIsHaveShow(isHaveShow)
	self.m_isHaveShow = isHaveShow
end

function This:getIsHaveShow()
	return self.m_isHaveShow
end

function This:initListener()
	EventDispatcher:addListener(self, 12047, self.onGetActivityInfoReply)
end

function This:removeListener()
	EventDispatcher:removeListener(self,12047)
end

function This:getLeftTime(timeLimit)

	local curTime = GamePlayer:getServerTime()
	local timeOffset = curTime-self.m_startTime
	local leftTime = 0
	local str =""
	if timeOffset>0 and timeOffset<=timeLimit  then
		leftTime = timeLimit-timeOffset
		str = GameUtil:formatTime(Serialize["H_M_S"], leftTime)
	end
	return str,leftTime
end

function This:getUITypeName()
    -- return "NewActivity.ActivityHappyTurnTabNode"

    return ""
end
-- 获取转盘信息
function This:onGetActivityInfoRequest()
	Socket:send(12047,{activity_id = self:getId()})
end

function This:setCurentAchieveId(curentAchieveId)
	self.m_curentAchieveId = curentAchieveId
	EventDispatcher:dispatcher("activity_pushgift_state_changed")
end

function This:getCurentAchieveId()
	-- return 101
	return self.m_curentAchieveId or 0
end

function This:isUpdating()
    return self.m_curentAchieveId~=0
end

function This:isCanReward()
	local achieve = AchieveManager:getAchieve(AchieveType.kLimitedTimePreferential, self:getCurentAchieveId())
	local result = false
	if achieve and achieve:getState() == AchieveState.kHaseFinish then
		result = true
	end
	return result
end

function This:onGetActivityInfoReply( msg )
	if msg then
		if msg.err_code == 0 then
			local achieveId = msg.mission_id or 0
			self.m_startTime = msg.times or 0
			self:setCurentAchieveId(achieveId)
			self:notifyObservers("onGetActivityPushGiftInfo", self:getId())
		else
        	g_scene:handleErrorCode(msg.err_code)
		end
	end
end

function This:updateInfo()
    self:onGetActivityInfoRequest()
end