-- @Author: superm
-- @Date:   2018-02-07 19:46:35
-- @Last Modified by:   superm
-- @Last Modified time: 2018-08-07 12:52:42
-- @File Name: ActivityNewYearExchangeItemView.lua
-- @Description: 

local This , super = class(..., "Activity.ActivityItemView")
This.csfileName = "MenuScene/NodeUI/ActivityFestivalItem.csb"

local ItemNode = require("UI.ItemNode")
local DepotManager = require("Depot.DepotManager")

function This:onEnter()
    super.onEnter(self)
    DepotManager:addObserver(self)
end

function This:onExit()
    DepotManager:removeObserver(self)
    super.onExit(self)
end

function This:refreshItemUI()
    print_r(self.m_activity.m_exchangeConfig)
    local csNode = self.m_csNode
    local _, rewardItemInfo = next(self.m_activity:getRewardList(1))
	local itemId, num = rewardItemInfo.id, rewardItemInfo.count
	local itemNode = csNode.item
	if itemNode then
		itemNode:setVisible(true)
		local node = itemNode.node
		if not node then
	        node = ItemNode:create(itemId, num, false, true)
	        node:setAnchorPoint(0.5, 0.5)
	        itemNode:addChild(node)
	        itemNode.node = node
	    else
	        node:init(itemId, num)
	    end
	end

    local needItemList = self.m_activity:getNeedItemList()
    local count = #needItemList
    for i, info in ipairs(needItemList) do
    	local itemId, num = info[1], info[2]
    	local itemNode = csNode.need["item" .. tostring(i)]
    	if itemNode then
    		itemNode:setVisible(true)
    		local node = itemNode.node
			if not node then
		        node = ItemNode:create(itemId, num, false, true)
		        node:setAnchorPoint(0.5, 0.5)
		        itemNode:addChild(node)
		        itemNode.node = node
		    else
		        node:init(itemId, num)
		    end
	    	node:showNeedNum()
    	end
    end

    for i=count + 1, 4 do
    	local itemNode = csNode.need["item" .. tostring(i)]
    	if itemNode then
    		itemNode:setVisible(false)
    	end
    end	
end

function This:refreshStateUI()
    local csNode = self.m_csNode
    for i=1, 4 do
        local itemNode = csNode.need["item" .. tostring(i)]
        if itemNode.node and itemNode:isVisible() then
            itemNode.node:showNeedNum()
        end
    end 
    self:setItemEnable(self.m_activity:isOpening())
    csNode.times:setString(Serialize[62039].. self.m_activity:getWholeDescNum())
end

function This:onPickUpBtnClick()
    if self.m_activity then
        self.m_activity:requestExchange()
    end
end

function This:itemUpdate()
    if self.m_activity then
        self.m_activity:updateState()
    end
    self:refresh()
end