-- @Author: superm
-- @Date:   2018-08-04 17:02:35
-- @Last Modified by:   superm
-- @Last Modified time: 2018-08-08 10:53:52
-- @File Name: ActivityScoreShop.lua
-- @Description: 

local This , super = class(...,"NewActivity.ActivityWestShop")
local ScoreShopItem = require("NewActivity.ScoreShopItem")
local EventDispatcher = require("EventDispatcher")
local Socket = require("Net.Socket")

function This:getMaxTotalBuyTimes()
    return nil
end

function This:init(id)
	super.init(self, id)
	if self.m_descConfig then
	    self.m_startTime = self.m_descConfig.start_time or 0
	    self.m_endTime = self.m_descConfig.end_time or 0
	end
	self.m_slotList = {}
	self.m_curMaxTotalBuyTime = self:getMaxTotalBuyTimes()
	self.m_curTotalBuyTime = 0
	self.m_curRefreshTime = 0
end

function This:initListener()
	EventDispatcher:addListener(self,12036,self.onGetActivityInfoReply)
	EventDispatcher:addListener(self,12037,self.onBuyActShopItemReply)
end

function This:removeListener()
	EventDispatcher:removeListener(self,12036)
	EventDispatcher:removeListener(self,12037)
end

function This:getNewActivityItem( ... )
    return ScoreShopItem:create( ... )
end

function This:onGetActivityInfoRequest()
	Socket:sendAndLock(12036,{activity_id = self:getId()})
end

function This:onBuyActShopItemReply(msg)
	if msg and msg.activity_id == self:getId() then
		if msg.err_code == 0 then
			local item = self.m_slotList[msg.grid_id]
			if item then
				item:increaseBuyTime()
				g_scene:showReward({{id=item:getItemId(), count=item:getItemNum()}})
			end

			self:notifyObservers("onBuyActShopItem", self:getId(), msg.grid_id)	
		else
        	g_scene:handleErrorCode(msg.err_code)
		end
	elseif msg.activity_id == 0 and msg.err_code ~= 0 then
		msg.activity_id = self:getId()
		g_scene:handleErrorCode(msg.err_code)
	end
end

function This:canBuy()
	if self.m_curMaxTotalBuyTime then
    	return self:getLeftTotalBuyTime() > 0
    else
    	return true
    end
end

function This:getUITypeName()
    return "NewActivity.ScoreShopTabNode"
end

function This:getUIFileName()
    return "ActivityHappyShop"
end

