-- @Author: Su
-- @Date:   2019-03-27 18:32:43
-- @Last Modified by:   Su
-- @Last Modified time: 2019-03-27 18:32:43
-- @File Name: ActivitykBestKing.lua
-- @Description: 

local This , super = class(...,"NewActivity.ActivityBase")
local EventDispatcher = require("EventDispatcher")
local Socket = require("Net.Socket")

function This:init(id)
    super:init(id)
    self.m_id = id
    self:initListener()
    self.m_roleInfoList = {}
end

function This:initListener()
    EventDispatcher:addListener(self, 12051, self.onGetActivityInfoReply)
end

function This:removeListener()
	EventDispatcher:removeListener(self, 12051)
end

function This:getUITypeName()
    return "Activity.ActivitySevenDayCelebrationPanel"
end

function This:getId()
    return self.m_id
end

function This:onGetActivityInfoRequest()
    for activityId = NewActivityType.kBestKing,NewActivityType.kBestKing3 do
       Socket:sendAndLock(12051,{activity_id = activityId})
    end
end

function This:onGetActivityInfoReply(msg)
    if self:getId() > msg.activity_id  or msg.activity_id > NewActivityType.kBestKing3 then
        return
    end
    if msg.err_code == 0 then
        self.m_roleInfoList[msg.activity_id] = msg
        self:notifyObservers("onRefreshkBestKing")
		EventDispatcher:dispatcher("activity_activitysevenday_state_changed")             
    elseif msg.err_code == 1 then
        self:notifyObservers("onRefreshkBestKing")
        
    else
		g_scene:handleErrorCode(msg.err_code)
    end
end

function This:getRoleInfoByIndex(index)
    return self.m_roleInfoList[index+66]
end