-- @Author: Su
-- @Date:   2019-03-26 15:44:43
-- @Last Modified by:   Su
-- @Last Modified time: 2019-03-26 15:44:43
-- @File Name: ActivitykSpendGold.lua
-- @Description: 

local This , super = class(...,"NewActivity.ActivityBase")
local EventDispatcher = require("EventDispatcher")
local Socket = require("Net.Socket")
local GamePlayer = require("Player.GamePlayer")
local CelebrationCostRankConfig = require("Metadatas.CelebrationCostRankConfig")

function This:init(id)
    super:init(id)
    self.m_id = id
    self:initListener()
    self.m_payNum = 0
    self.m_rolePayList = {}
end

function This:initListener()
    EventDispatcher:addListener(self, 12052, self.onGetActivityInfoReply)
    GamePlayer:addObserver(self)
end

function This:removeListener()
	EventDispatcher:removeListener(self, 12052)
end

function This:getId()
    return self.m_id
end

function This:getUITypeName()
    return "Activity.ActivitySevenDayCelebrationPanel"
end

function This:getMyConsumption()
    return self.m_payNum
end

function This:getRoleList()
    return self.m_rolePayList
end

function This:getRewardList(index)
    return CelebrationCostRankConfig[index].reward
end

function This:getTurnDatas()
    return CelebrationCostRankConfig
end

---------------------------------------------

function This:onGetActivityInfoRequest()
	Socket:sendAndLock(12052,{activity_id = self:getId()})
end

function This:onGetActivityInfoReply(msg)
    if self:getId() ~= msg.activity_id then
		return
    end
    if msg.err_code == 0 then
        self.m_payNum = msg.self_consumption
        self.m_rolePayList = msg.info_list
        table.sort(self.m_rolePayList,function(a,b)
            return a.rank < b.rank
        end)
        self:notifyObservers("onGetActivityInfo",self:getId())
		EventDispatcher:dispatcher("activity_activitysevenday_state_changed")             
    else
		g_scene:handleErrorCode(msg.err_code)
    end
end

function This:onPlayerAttrChanged(field, oldValue, value)
    if field == PlayerAttr.diamond then
        self:onGetActivityInfoRequest()
    end
end

