
--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"NodeUI")
local ActivityDailySignIn = require("NewActivity.ActivityDailySignIn")
local CommonBox = require("UI.CommonBox")
local UpdateLayer = require("UI.UpdateLayer")
local CumulativeSignConfig = require("Metadatas.CumulativeSignConfig")
local DaySignConfig = require("Metadatas.DaySignConfig")
local DailySignView = require("NewActivity.DailySignView")
local NewActivityManager = require("NewActivity.NewActivityManager")
local GameUtil = require("Util.GameUtil")

function This:initData()
	self.m_activity = NewActivityManager:getActivity(NewActivityType.kSignInDaily)
    self.m_csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/ActivitySign.csb")
    self:addChild(self.m_csNode)
end

function This:initNode()
	self:initTimeNode()

	self:refreshRewardBox()
	self:refreshDailyItem()
end

function This:initTimeNode()
	local startTime = self.m_activity:getStartTime()
	local startStr = GameUtil:formatDate(Serialize["activity_FamilyUI_1_c"],startTime)	
	local endTime = self.m_activity:getEndTime()
	local endStr = GameUtil:formatDate(Serialize["activity_FamilyUI_1_c"],endTime)

	self.m_csNode.time:setString(string.format("%s ~ %s",startStr,endStr))
end

function This:refreshRewardBox()
	local config = {desc = Serialize[62086]}
	local hasReward = {}
	for i , box in ipairs(CumulativeSignConfig) do
		config[i] = box.days
		hasReward[i] = self.m_activity:hasReward(box.days)
	end
	local rewardCount = self.m_activity:getRewardDays()

	if not self.m_boxNode then
		self.m_boxNode = CommonBox:create(config)
		self.m_csNode.box:addChild(self.m_boxNode)
		self.m_boxNode:setClickHandler(function(index,isFinish,isReward)
			local state = RewardState.kNotFinish
			if isReward then state = RewardState.kHasReward end
			local panel = g_scene:openDialog("UI.RewardShowPanel",{
				title = Serialize[62087],
				state = state,
				text = string.format(Serialize[62088],CumulativeSignConfig[index].days)
			})
			local rewardList = self.m_activity:getBoxRewardList(index)
			panel:setRewardList(rewardList)
		end)
	end
	
	self.m_boxNode:setValue(rewardCount,hasReward)
end

function This:refreshDailyItem()
    local csNode = self.m_csNode
	local itemList = csNode.scrollView:getItemList()
	for i , config in ipairs(DaySignConfig) do
		if i <= #itemList then
			itemList[i]:refresh()
		else
			local view = DailySignView:create(i)
			csNode.scrollView:pushNode(view,88,93,6)		
		end
	end
	csNode.day:setString(self.m_activity:getRewardDays())
end

function This:onEnter()
	super.onEnter(self)
	self.m_activity:addObserver(self)
end

function This:onExit()
	super.onExit(self)
	self.m_activity:removeObserver(self)
end

function This:onGetSignInfo()
	self:refreshRewardBox()
	self:refreshDailyItem()
end

function This:onRewardDailySign()
	self:refreshRewardBox()
	self:refreshDailyItem()
end

--endregion
