--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"cc.Node")
local ActivityDailySignIn = require("NewActivity.ActivityDailySignIn")
local ItemNode = require("UI.ItemNode")
local NewActivityManager = require("NewActivity.NewActivityManager")
local GameUtil = require("Util.GameUtil")

function This:init(index)
	self.m_index = index
	self.m_activity = NewActivityManager:getActivity(NewActivityType.kSignInDaily)
	self.m_csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/ActivitySignItem.csb")
	self:addChild(self.m_csNode)
	self.m_rewardList = self.m_activity:getRewardList(index)
	self.m_isDouble = self.m_activity:isRewardDouble(index)
	self:refresh()
end

function This:refresh()
	local isReward = self.m_activity:hasReward(self.m_index)
	self.m_csNode.yilingqu:setVisible(isReward)
	self.m_csNode.signzhezhao:setVisible(isReward)
	self.m_csNode.double:setVisible(self.m_isDouble)
	self.m_csNode.choose:setVisible(false)
	local item = self.m_rewardList
	if not self.m_itemNode then
		self.m_itemNode = ItemNode:create(item.id,item.num)
		self.m_itemNode:setAnchorPoint(0.5,0.5)
		self.m_itemNode:setScale(0.8)
		self.m_csNode.itemNode:addChild(self.m_itemNode)
	else
		self.m_itemNode:initItem(item.id,item.num)
	end
	local isCanReward = self.m_activity:isCanReward(self.m_index)
	if not self.m_effect and isCanReward then
		--self.m_effect = GameUtil:createEffect("BoxLing",true)
		--self:addChild(self.m_effect)
		self.m_csNode.choose:setVisible(true)
	elseif self.m_effect and not isCanReward then
		self.m_effect:removeFromParent()
		self.m_effect = nil
	end
end

function This:setModel(index)
	if self.m_index ~= index then
		self.m_index = index
		self.m_rewardList = self.m_activity:getRewardList(index)
		self.m_isDouble = self.m_activity:isRewardDouble(index)
		self:refresh()
	end
end

function This:onEnter()
	super.onEnter(self)
	self.m_csNode:setTouch({
		onEnded = function()
			if self.m_activity:isCanReward(self.m_index) then
				self.m_activity:onRewardSignInRequest()
			end
		end,
		sizeNode = self.m_itemNode,
		isScale = false,
		isContainer = true
	})
end

--endregion
