-- @Author: Su
-- @Date:   2019-06-06 10:59:14
-- @Last Modified by:   Su
-- @Last Modified time: 2019-06-06 10:59:14
-- @File Name: .lua
-- @Description: 

local This , super = class(...,"Dialog")
local ItemNode = require("UI.ItemNode")
local GameUtil = require("Util.GameUtil")
local GamePlayer = require("Player.GamePlayer")

function This:initNode(info)
    self.m_id = info.id
    self.m_activity = info.activity
    self.m_escape = 0
    
    self.m_config = self.m_activity:getConfigById(self.m_id)
    self.m_csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/DecreeTaskItemGet.csb")
    self.m_csNode:setToCenter()
    self:addChild(self.m_csNode)
    self:initView()
    self:refresh()

end

function This:initView()
    local node = self.m_csNode
    node.renwu:setString(self.m_config.des)
    node.jifen:setString(self.m_config.jifen)
    node.text:setString(self.m_config.name)

    node.tiem:removeAllChildren()
    for i,info in ipairs(self.m_config.reward) do
        local item = ItemNode:create(info[1],info[2])
        item:setAnchorPoint(0,0)
        item:setPosition(-45,-50)
        node.tiem:addChild(item)
    end
end

function This:refresh()
    local node = self.m_csNode
    node.jiequ:setVisible(not self.m_activity:isReceive(self.m_id))
    node.jindu:setString(string.format( "%d/%d",self.m_activity:getTaskProgress(self.m_id),self.m_config.progress))
    if self.m_activity:isReceive(self.m_id) then
        self:scheduleUpdate()    
    else
        self:unscheduleUpdate()        
        node.time:setString("00:30:00")       
    end
end

function This:initTouchEvent()
    local node = self.m_csNode
    node.close:setTouchEnded(function ()
        self:close()
    end)

    node.bg:setTouchEnded(function ()
        
        self.m_activity:onGetTaskRewardRequest(self.m_id)
    end)

    node.jiequ:setTouchEnded(function ()
        if not self.m_activity:isReceive(self.m_id) then
            self.m_activity:onReceiveTaskRequest(self.m_id)
            self:close()
        else
            g_scene:showTips(Serialize[62091])
        end
    end)


end

function This:refreshTimeInfo()
    local node = self.m_csNode
    local lessTime = self.m_activity:getTaskStartTime(self.m_id) + self.m_config.time - GamePlayer:getServerTime()
    if lessTime < 0 then
        lessTime = 0
    end
    node.time:setString(GameUtil:formatTime(Serialize["H_M_S"],lessTime))
end


function This:update(dt)
	self.m_escape = self.m_escape + dt
	if self.m_escape > 1 then
		self.m_escape = self.m_escape - 1
		self:refreshTimeInfo()
	end
end