--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"NodeUI")
local NewActivityManager = require("NewActivity.NewActivityManager")
local GameUtil = require("Util.GameUtil")
local ItemNode = require("UI.ItemNode")


function This:initData( queue, dialog )
	self.m_activity = queue
	self.m_dialog = dialog
end

function This:initNode()
    self.m_fileName = self.m_activity:getUIFileName()
	self.m_csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/" .. self.m_fileName .. ".csb")
	self:addChild(self.m_csNode)
	
	local startTime = self.m_activity:getStartTime()
	local startStr = GameUtil:formatDate(Serialize["activity_FamilyUI_1_c"],startTime)	
	local endTime = self.m_activity:getEndTime()
	local endStr = GameUtil:formatDate(Serialize["activity_FamilyUI_1_c"],endTime)

	self.m_csNode.time:setString(string.format("%s ~ %s",startStr,endStr))
	self.m_itemNodeList = {}

	self:refresh()
end

function This:refresh()
	self.m_csNode.dec1:setStringWithColor(string.format(Serialize[62097],self.m_activity:getTargetPay()))
	self.m_csNode.yichongzhi:setVisible(self.m_activity:isHaveReward())
	self.m_csNode.recharge:setVisible(self.m_activity:getCurPay() < self.m_activity:getTargetPay())
	self.m_csNode.lingqu:setVisible(self.m_activity:getCurPay() >= self.m_activity:getTargetPay() and not self.m_activity:isHaveReward())
	self:refreshReward()
end

function This:refreshReward()
	local rewardList = self.m_activity:getRewardList()
	for i = 1 , 4 do
		if not self.m_activity:isHaveReward() and i <= #rewardList then
			if self.m_itemNodeList[i] then
				self.m_itemNodeList[i]:initItem(rewardList[i].id,rewardList[i].num)
			else
				local itemNode = ItemNode:create(rewardList[i].id,rewardList[i].num)
				itemNode:setAnchorPoint(0.5,0.5)
				self.m_csNode["item"..i]:addChild(itemNode)
				self.m_itemNodeList[i] = itemNode
			end
			self.m_csNode["item"..i]:setVisible(true)
		else
			self.m_csNode["item"..i]:setVisible(false)
		end 
	end
end

function This:initTouchEvent()
	self.m_csNode.lingqu:setTouchEnded(function()
		if self.m_activity:getCurPay() >= self.m_activity:getTargetPay() then
			self.m_activity:onRewardLimitRechargeRequest()
		end
	end)
	self.m_csNode.recharge:setTouchEnded(function()
		g_scene:openDialog("System.RechargeMainUI")
	end)
end

function This:onEnter()
	super.onEnter(self)
	self.m_activity:addObserver(self)
end

function This:onExit()
	super.onExit(self)
	self.m_activity:removeObserver(self)
end

function This:onRefreshLimitRecharge()
	self:refresh()
end

function This:onRewardLimitRecharge()
	self:refresh()
end

--endregion
