--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"NodeUI")
local NewActivityManager = require("NewActivity.NewActivityManager")
local GameUtil = require("Util.GameUtil")
local GamePlayer = require("Player.GamePlayer")
local HeroManager = require("Hero.HeroManager")
local DepotManager = require("Depot.DepotManager")

function This:initData( queue, dialog )
	self.m_activity = queue
	self.m_dialog = dialog
end

function This:initNode()
    self.m_fileName = self.m_activity:getUIFileName()
	self.m_csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/" .. self.m_fileName .. ".csb")
	self:addChild(self.m_csNode)
	
	local startTime = self.m_activity:getStartTime()
	local startStr = GameUtil:formatDate(Serialize["activity_FamilyUI_1_c"],startTime)
	local endTime = self.m_activity:getEndTime()
	local endStr = GameUtil:formatDate(Serialize["activity_FamilyUI_1_c"],endTime)
	self.m_csNode.time:setString(string.format("%s ~ %s",startStr,endStr))
	self.m_csNode.recruit.cost:setString(self.m_activity:getRecruitCost())

	self:refresh() 
end

function This:refresh()
	self.m_csNode.cishu:setString(string.format(Serialize[62099],self.m_activity:getRecruitTime(),self.m_activity:getMaxRecruitTime()))
	self.m_csNode.text1_0:setString(GamePlayer:getDiamond())
	local hero = HeroManager:getHero(self.m_activity:getHeroId())
	self.m_csNode.icon:setImage(hero:getIcon())
	self.m_csNode.name:setString(hero:getName())
	local curFavours = self.m_activity:getFavours()
	local maxFavours = self.m_activity:getMaxFavours()
	if curFavours < maxFavours then
		self.m_csNode.haogandu:setString(string.format(Serialize[62100],curFavours,maxFavours))
	else
		self.m_csNode.haogandu:setString(string.format(Serialize[62101],hero:getName()))
	end
	
	if hero:isGot() then
		self.m_csNode.recruit:setGrayShader()
	else
		self.m_csNode.recruit:clearShader()
	end
	local num = DepotManager:getItemCount(121)
	self.m_csNode.spallnumber:setString(num)
end

function This:initTouchEvent()
	self.m_csNode.add:setTouchEnded(function()
		g_scene:openDialog("System.RechargeMainUI")
	end)

	self.m_csNode.recruit:setTouchEnded(function()
		local hero = HeroManager:getHero(self.m_activity:getHeroId())
		if hero:isGot() then
			g_scene:showTips(Serialize[62102])
		else
			local cost = self.m_activity:getRecruitCost()
            g_scene:openDialog("UI.CostConfirmPanel", {
                cost = cost,
                notips = "Activity" .. tostring(self.m_activity:getId()) .. "recruit",
                desc = Serialize[62103], 
                okHandler = function()
                    self.m_activity:onRecruitHeroRequest()
                end } )			
		end
	end)

	self.m_csNode.shuaxin:setTouchEnded(function()
		local cost = self.m_activity:getRecruitCost()
        g_scene:openDialog("UI.CostConfirmPanel", {
            cost = kRefreshLimitRecruitCost,
            notips = "Activity" .. tostring(self.m_activity:getId()) .. "shuaxin",
            desc = Serialize[62006], 
            okHandler = function()
                self.m_activity:onRefreshLimitRecruitRequest()
            end } )	
	end)
	
	if self.m_csNode.help then 
		self.m_csNode.help:setTouchEnded(function()
			g_scene:openDialog("UI.HelpTips",{text = Serialize[62104],node = self.m_csNode.help})
		end)
	end
end

function This:onEnter()
	super.onEnter(self)
	self.m_activity:addObserver(self)
	GamePlayer:addObserver(self)
	HeroManager:addObserver(self)
end

function This:onExit()
	super.onExit(self)
	self.m_activity:removeObserver(self)
	GamePlayer:removeObserver(self)
	HeroManager:removeObserver(self)
end

function This:onRefreshLimitRecruit()
	self:refresh()
end

function This:onRecruitHero()
	self:refresh()
end

function This:onPlayerAttrChanged(attrId)
	if attrId == PlayerAttr.diamond then
		self:refresh()
	end
end

function This:onLimitRecruitHero(heroInfoList)
	self:refresh()
	local w , h = self.m_csNode.equipSpall:getContentSize()
	local x , y = self.m_csNode.equipSpall:convertToWorldSpace(w/2,h/2)
	local view = g_scene:openDialog("Recruit.RecruitView",{
		particlex = x,
		particley = y,
		particleFinishHandler = function()
			local x1 , y1 = self.m_csNode.equipSpall:getPosition()
			local sprite = cc.Sprite:create("MenuScene/wannengsuipian1.png")
			self:addChild(sprite)
			sprite:setPosition(x1,y1)
			sprite:setScale(0.5)
			sprite:runAction(cc.Sequence(cc.ScaleTo(2,1.1,"ElasticIn")))
			sprite:runAction(cc.Sequence(cc.FadeOut(1,180),cc.RemoveAction()))
		end
	})
	view:setLocalZOrder(1001)
	view:showExtractEffect(heroInfoList,ExtractType.kSingleSpecial)
end

--endregion
