--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"Base.BaseModel")
local EventDispatcher = require("EventDispatcher")
local Socket = require("Net.Socket")
local ActivityLimitRecruit = require("NewActivity.ActivityLimitRecruit")
local NewActivityUtil = require("NewActivity.NewActivityUtil")
local ActivityLimitRecharge = require("NewActivity.ActivityLimitRecharge")
local ActivityPrizeDraw = require("NewActivity.ActivityPrizeDraw")
local ActivityDailySignIn = require("NewActivity.ActivityDailySignIn")
local ActivityWestShop = require("NewActivity.ActivityWestShop")
local ActivityContinuePay = require("NewActivity.ActivityContinuePay")
local ActivityEntireConsume = require("NewActivity.ActivityEntireConsume")
local ActivityWuDaoShop = require("NewActivity.ActivityWuDaoShop")
local ActivityScoreShop = require("NewActivity.ActivityScoreShop")
local ActivityHappyPlay = require("NewActivity.ActivityHappyPlay")
local ActivityLimitedTimePreferential = require("NewActivity.ActivityLimitedTimePreferential")
local ActivitykSpendGold = require("NewActivity.ActivitykSpendGold")
local ActivitykCumulative = require("NewActivity.ActivitykCumulative")
local ActivitykAnimalTable = require("NewActivity.ActivitykAnimalTable")
local ActivitykRedHeroTable = require("NewActivity.ActivitykRedHeroTable")
local ActivitykBestKing = require("NewActivity.ActivitykBestKing")
local ActivitykDecreeTask = require("NewActivity.ActivitykDecreeTask")
local ActivitykDailyRecharge = require("NewActivity.ActivitykDailyRecharge")
local ActivityExpedition = require("NewActivity.ActivityExpedition")
local ActivitykSeasonRecharge = require("NewActivity.ActivitykSeasonRecharge")

function This:init()
	super.init(self)
	self.m_activitys = {}
	self:initListener()
	for i , id in pairs(NewActivityType) do
		self:addActivity(id)
	end
end

function This:initListener()
	EventDispatcher:addListener(self,12009,self.onGetActivityTimeReply)
end

function This:getActivity(id)
	if not id then
		return nil
	end
	if id >= NewActivityType.kWuDaoShop1 and id <= NewActivityType.kWuDaoShop4 then
		return self.m_activitys[NewActivityType.kWuDaoShop1]
	end
	if id >= NewActivityType.kBestKing and id <= NewActivityType.kBestKing3 then
		return self.m_activitys[NewActivityType.kBestKing]
	end
	return self.m_activitys[id]
end

function This:addActivity(id)
	if id == NewActivityType.kLimitRecruit then
		self.m_activitys[id] = ActivityLimitRecruit:create()
	elseif id == NewActivityType.kLimitRecharge then
		self.m_activitys[id] = ActivityLimitRecharge:create()
	elseif id == NewActivityType.kYuanxiaoDraw
			or id == NewActivityType.kNormalDraw
			or id == NewActivityType.kLuckyDraw
			or id == NewActivityType.kFabaoDraw
			or id == NewActivityType.kCelebration
	then
		self.m_activitys[id] = ActivityPrizeDraw:create(id)
	elseif id == NewActivityType.kSignInDaily then
		self.m_activitys[id] = ActivityDailySignIn:create()
	elseif id == NewActivityType.kWestShop1 or id == NewActivityType.kWestShop2 or id == NewActivityType.kWestShop3 then
		self.m_activitys[id] = ActivityWestShop:create(id)
	elseif id == NewActivityType.kContinuePay or id == NewActivityType.kLaborContinuePay then
		self.m_activitys[id] = ActivityContinuePay:create(id)
	elseif id == NewActivityType.kEntireConsume then
		self.m_activitys[id] = ActivityEntireConsume:create()
	elseif id == NewActivityType.kWuDaoShop1 then
		self.m_activitys[id] = ActivityWuDaoShop:create()
	elseif id == NewActivityType.kScoreShop then
		self.m_activitys[id] = ActivityScoreShop:create(id)
	elseif id == NewActivityType.kLuckyRoulette or id == NewActivityType.kBingFaRoulette then
		self.m_activitys[id] = ActivityHappyPlay:create(id)
	elseif id == NewActivityType.kLimitedTimePreferential then
		self.m_activitys[id] = ActivityLimitedTimePreferential:create(id)
	elseif id == NewActivityType.kSpendGold then
		self.m_activitys[id] = ActivitykSpendGold:create(id)
	elseif id == NewActivityType.kCumulative then
		self.m_activitys[id] = ActivitykCumulative:create(id)
	elseif id >= NewActivityType.kBestKing and id <= NewActivityType.kBestKing3 then
		self.m_activitys[id] = ActivitykBestKing:create(id)
	elseif id == NewActivityType.kDailyRecharge then
		self.m_activitys[id] = ActivitykDailyRecharge:create(id)
	elseif id == NewActivityType.kAnimalTable then
		self.m_activitys[id] = ActivitykAnimalTable:create(id)
	elseif id == NewActivityType.kRedHeroTable then
		self.m_activitys[id] = ActivitykRedHeroTable:create(id)
	elseif id == NewActivityType.kDecreeTask then
		self.m_activitys[id] = ActivitykDecreeTask:create(id)
	elseif id == NewActivityType.kExpedition then
		self.m_activitys[id] = ActivityExpedition:create(id)
	elseif id == NewActivityType.kSeasonRecharge then
		self.m_activitys[id] = ActivitykSeasonRecharge:create(id)

	end
end

function This:activityStart(activity)
	self:notifyObservers("onActivityStart",activity)
end

function This:activityEnded(activity)
	local activityId = activity:getId()
	self.m_activitys[activityId] = nil
	self:notifyObservers("onActivityEnded",activity)
end

----------------------------------------------

function This:onGetActivityTimeRequest()
	Socket:sendAndLock(12009,{})
end

function This:onGetActivityTimeReply(msg)
	if msg.err_code == 0 then
		for i , activity in pairs(self.m_activitys) do
			activity:preWork()
		end
		for i , info in ipairs(msg.activity_time_list) do
			local activity = self:getActivity(info.activity_id)
			if activity then
				-- info.start_time,info.end_time,info.activity_id, info.start_level
				activity:updateTimeInfo(info)
				if activity:isUpdating() then
					activity:onGetActivityInfoRequest(info.activity_id)
				end
			end
		end
		for i , activity in pairs(self.m_activitys) do
			activity:work()
		end
	else
		g_scene:handleErrorCode(msg.err_code)
	end
end

--endregion
