-- @Author: Su
-- @Date:   2019-08-05 16:57:32
-- @Last Modified by:   zheng
-- @Last Modified time: 2020-07-03 16:45:05
-- @File Name: RedHeroRewardItemView.lua
-- @Description: 
local This , super = class(...,"NodeUI")
local ItemNode = require("UI.ItemNode")

function This:initNode(data)
    local csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/ActivityHappyTurnTableDayList.csb")
    self:addChild(csNode)
    self.m_csNode = csNode
    self.m_data = data
    self.m_activity = data.activity

    self:initView()
    self:refresh()
end

function This:initView()
    local node= self.m_csNode.scrollview
    node.m_direction = "right"
    node:setDirection("horizontal")
    node:setSwallowTouch(false)
    for i,info in ipairs(self.m_data.reward) do
        local item = ItemNode:create(info[1],info[2])
		local w , h = item:getContentSize()
		item:setAnchorPoint(0.5,0.5)
		node:pushBackCustomItem(item,w,h,0.5)
    end
end

function This:getSize()
    local w, h = self.m_csNode.beijing.bg:getContentSize()
    return w,h    
end


function This:refresh()
    local node = self.m_csNode
    node.beijing.zhuandong:setImage("MenuScene/wordcishu.png")
    node.numbercishu:setString(self.m_data.lucky_count..Serialize[60532])
    node.yilingqu:setVisible(self.m_activity:isReceive(self.m_data.id))
    node.button:setVisible(not self.m_activity:isReceive(self.m_data.id))
    if not self.m_activity:isCanReceive(self.m_data.id) then
        node.button:setGrayShader()
    else
        node.button:clearShader()
    end
end

function This:initTouchEvent()
    local node =self.m_csNode
    node.button:setTouch({
        isScale = false, 
        isDynamic = true, 
        isContainer  = true,
        onEnded = function ()
            if not self.m_activity:isCanReceive(self.m_data.id) then
                return 
            end
            self.m_activity:onReceiveBoxRequest(self.m_data.id)
        end
    })
end