-- @Author: Su
-- @Date:   2019-08-05 16:57:32
-- @Last Modified by:   zheng
-- @Last Modified time: 2020-07-03 16:44:32
-- @File Name: RedHeroRewardPanel.lua
-- @Description: 

local This , super = class(...,"Dialog")
local ItemNode = require("UI.ItemNode")
local GameUtil = require("Util.GameUtil")
local RedHeroRewardItemView = require("NewActivity.RedHeroRewardItemView")

function This:initNode(info)
    self.m_csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/TeamWarIntegral.csb")
    self:addChild(self.m_csNode)
    self.m_csNode:setToCenter()

    self.m_activity = info.activity
    self:refresh()
    self:initItemList()
end

function This:onEnter()
    super.onEnter(self)
    if self.m_activity then
        self.m_activity:addObserver(self)
    end
end

function This:onExit()
    super.onExit(self)
    if self.m_activity then
        self.m_activity:removeObserver(self)
    end
end

function This:refresh()
    local node = self.m_csNode
    node.title:setString(Serialize[60534])
    node.tips1:setVisible(false)
    node.tips2:setVisible(false)
    node.numberjifen:setString(string.format( Serialize[60535],self.m_activity:getBuyTime() ))
end

function This:initItemList()
    local node = self.m_csNode.scrollView
    node:setSwallowTouch(false)
    node:removeAllItems()
    local itemList =self.m_activity:getBoxList()
    for i,itemData in pairs(itemList) do
        itemData.activity = self.m_activity
        local item = RedHeroRewardItemView:create(itemData)
        local w,h = item:getSize()
        node:pushBackCustomItem(item,w,h,0.5)
    end
end

function This:initTouchEvent()
    self.m_csNode.closebg:setTouchEnded(function ()
        self:close()
    end)
end

function This:onRefreshPrizeDraw(id)
    if self.m_activity:getId() == id then
        self:initItemList()
    end
end
