-- @Author: superm
-- @Date:   2018-08-04 17:19:50
-- @Last Modified by:   superm
-- @Last Modified time: 2018-08-08 10:13:08
-- @File Name: ScoreShopItem.lua
-- @Description: 

local This , super = class(...,"NewActivity.WestShopItem")
local ScoreShopConfig = require("Metadatas.ScoreShopConfig")
local GamePlayer = require("Player.GamePlayer")
local Socket = require("Net.Socket")

function This:getConfigById( id )
    return ScoreShopConfig[id]
end

function This:getCondition()
	return self.m_config.min_lv
end

function This:isNotLockedBy( conds )
	local level = GamePlayer:getLevel()
    return level >= conds
end

function This:getPrice()
    return self.m_config.price
end

function This:getPriceItemId()
    local priceType = self:getPriceType()
    if priceType == 1 then
        return 102
    elseif priceType == 2 then
        return kScoreShopCostItemId
    end
end

function This:isMaxTime()
	local times = self:getMaxBuyTime()
	if times > 0 then
    	return self.m_buyTime >= times
    end
    return false
end

function This:onBuyActShopItemRequest()
    Socket:sendAndLock(12037, {activity_id = self:getActivityId(), grid_id = self:getId()})
end