-- @Author: Su
-- @Date:   2019-03-26 15:11:05
-- @Last Modified by:   Su
-- @Last Modified time: 2019-03-26 15:11:05
-- @File Name: SevenDayCelebrationBoxPanel.lua
-- @Description: 

local This, super = class(..., "Dialog")
local CelebrationFirstPlayerConfig = require("Metadatas.CelebrationFirstPlayerConfig")
local ItemNode = require("UI.ItemNode")

function This:initData(info)
    self.m_id = info.index
    self.m_tytle = info.name
    self.m_config = CelebrationFirstPlayerConfig[self.m_id]
end

function This:initNode()
    self.m_csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/SevenDayCelebrationBox.csb")
    self:addChild(self.m_csNode)
    self.m_csNode:setToCenter()
    self:refresh()
    self:refreshItems()
end

function This:refresh()
    self.m_csNode.title:setString(self.m_tytle)
end

function This:refreshItems()
    local scrollView = self.m_csNode.scrollView
    scrollView:setDirection("horizontal")
    scrollView.m_direction = "right"
    scrollView:removeAllItems()
    for _,itemConfig in pairs(self.m_config.reward) do
        local item = ItemNode:create(itemConfig[1],itemConfig[2])
        local w , h = item:getContentSize()
        item:setAnchorPoint(0.5,0.5)
        scrollView:pushBackCustomItem(item,w,h,0.5)
    end

end

function This:initTouchEvent()
    local node = self.m_csNode
    node.close:setTouchEnded(function ()
        self:close()
    end)
end