-- @Author: superm
-- @Date:   2018-07-02 09:51:23
-- @Last Modified by:   superm
-- @Last Modified time: 2018-08-07 20:43:05
-- @File Name: WestShopItemView.lua
-- @Description: 

local This , super = class(..., "Territory.TerrAltarItemView")
This.fileName = "MenuScene/NodeUI/FamilyShopItem.csb"

local ItemNode = require("UI.ItemNode")

function This:initStateUI()
    self:refreshStateUI()
end

function This:refreshItemUI()
    local node = self.item.itemNode
    local itemId, num = 102, 0
    if not self:isLocked() then
        itemId, num = self.m_altarItem:getItemId(), self.m_altarItem:getItemNum()
        self.itemName:setString(self.m_altarItem:getName())
        self.itemName:setColorByID("Q".. self.m_altarItem:getQuality())
    end
    if not node then
        node = ItemNode:create(itemId, num)
        node:setAnchorPoint(0.5, 0.5)
        self.item:addChild(node)
        self.item.itemNode = node
    else
        node:init(itemId, num)
    end
    self:initStateUI()
end

function This:setItemEnable(enble)
	local isLocked = self:isLocked()
    self.buy:setVisible(not isLocked)
    self.item:setVisible(not isLocked)
    self.itemName:setVisible(not isLocked)

    if not isLocked then
        self.buy.tips:setVisible(not enble)
        self.buy.button:setVisible(enble)
        self.buy.icon:setVisible(enble)

        self.buy.price:setVisible(enble)
        if self.buy.bg3 then
            self.buy.bg3:setVisible(enble)
        end

        local maxTime = self.m_altarItem:getMaxBuyTime()
        self.buy.number:setVisible(enble and maxTime > 0)
    end
end