--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"cc.Node")
local ItemUtil = require("Bag.ItemUtil")
local DepotManager = require("Depot.DepotManager")
local NewActivityManager = require("NewActivity.NewActivityManager")
local ItemNode = require("UI.ItemNode")
local GameUtil = require("Util.GameUtil")
local GamePlayer = require("Player.GamePlayer")

function This:init(model)
	self.m_model = model
	self.m_csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/WuDaoShopItem.csb")
	self:addChild(self.m_csNode)
	self.m_itemNode = nil
	self.m_isUpdate = false
	self.m_escape = 0
end

function This:initTouchEvent()
	self.m_csNode.buybutton:setTouch({
		onEnded = function()
			local costId , costNum = self.m_model:getCostItem()
			if DepotManager:getItemOrResCount(costId) < costNum then
				g_scene:showTips(Serialize[62147])
				return 
			end
			local shopItemConfigId = self.m_model:getConfigId()
			local itemId = self.m_model:getPassiveSkillId()
			local str = Serialize[60495] .. "[" .. ItemUtil.getName(itemId).. "]"

			if costId == 101 then
				GamePlayer:costGold({ cost = costNum , desc = str, okHandler = function() 
					local activity = NewActivityManager:getActivity(NewActivityType.kWuDaoShop1)
					activity:onBuyShowItemRequest(shopItemConfigId,costId, costNum)
				end})
			end
			if costId == 102 then
				GamePlayer:costDiamond({cost = costNum, desc = str, okHandler = function()
					local activity = NewActivityManager:getActivity(NewActivityType.kWuDaoShop1)
					activity:onBuyShowItemRequest(shopItemConfigId,costId, costNum)
				end})
			end
		end,
		isContainer = true
	})
end

function This:refresh()
	local itemId = self.m_model:getPassiveSkillId()
	self.m_csNode.name:setString(ItemUtil.getName(itemId))
	if self.m_itemNode then
		self.m_itemNode:initItem(itemId)
	else
		self.m_itemNode = ItemNode:create(itemId)
		self.m_csNode.item:addChild(self.m_itemNode)
		self.m_itemNode:setAnchorPoint(0.5,0.5)
	end
	local leftTime = self.m_model:getLeftTime()
	self.m_csNode.time:setVisible(leftTime > 0)
	self.m_csNode.timeicon:setVisible(leftTime > 0)
	if leftTime > 0 then
		self.m_csNode.time:setString(GameUtil:formatTime(Serialize["M_S"],leftTime))
	end
	if self.m_isUpdate and leftTime <= 0 then
		self:unscheduleUpdate()
	elseif not self.m_isUpdate and leftTime > 0 then
		self:scheduleUpdate()
	end

	local costId, costNum = self.m_model:getCostItem()
	self.m_csNode.yuanbao:setImage(ItemUtil.getIconImage(costId))
	self.m_csNode.price:setString(costNum)
	local discount = self.m_model:getDiscount()
	if discount < 10 then
		self.m_csNode.discount:setString(discount .. Serialize[60327])
	end
	self.m_csNode.discount:setVisible(discount < 10)
	self.m_csNode.bg5:setVisible(discount < 10)
end

function This:onEnter()
	super.onEnter(self)
	self:initTouchEvent()
	self:refresh()
	self.m_model:addObserver(self)
end

function This:onExit()
	super.onExit(self)
	self.m_model:removeObserver(self)
end

function This:setModel(model)
	self.m_model = model
	self:refresh()
end

function This:setRefreshHandler(handler)
	self.m_refreshHandler = handler
end

function This:update(dt)
	self.m_escape = self.m_escape + dt
	if self.m_escape >= 1.0 then
		self.m_escape = self.m_escape - 1
		local leftTime = self.m_model:getLeftTime()
		self.m_csNode.time:setString(GameUtil:formatTime(Serialize["M_S"],leftTime))
		if leftTime <= 0 then
			self:unscheduleUpdate()
			self.m_isUpdate = false
			if self.m_refreshHandler then
				self.m_refreshHandler(self.m_model)
			end
		end
	end
end

--endregion
