--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"Dialog")
local GamePlayer = require("Player.GamePlayer")
local GameUtil = require("Util.GameUtil")
local WuDaoShopItemView = require("NewActivity.WuDaoShopItemView")
local NewActivityManager = require("NewActivity.NewActivityManager")

local RefreshRequestCount = 0
local ShowBuyTextList = 
{
	Serialize[62149],
	Serialize[62150],
	Serialize[62151]
}

function This:initNode()
	self.m_model = NewActivityManager:getActivity(NewActivityType.kWuDaoShop1)
	self.m_csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/WuDaoShop.csb")
	self:addChild(self.m_csNode)
	self.m_csNode:setToCenter()
	self.m_csNode.tip2:setScale(1)
	self.m_csNode.tip2:runAction(cc.RepeatForever(cc.Sequence(cc.ScaleTo(2,0.95),cc.ScaleTo(2,1))))
	self.m_csNode.speek:setCascadeOpacityEnabled(true)
	self.m_csNode.speek:setOpacity(0)
	self.m_model:onGetActivityInfoRequest()
end

function This:initTouchEvent()
	self.m_csNode.close:setTouchEnded(function()
		self:close()
	end)
	self.m_csNode.res_node.add1:setTouchEnded(function()
		g_scene:openDialog("System.GlodChangePanel")
	end)
	self.m_csNode.res_node.add2:setTouchEnded(function()
		g_scene:openDialog("System.RechargeMainUI")
	end)
	self.m_csNode.refresh_btn:setTouchEnded(function()
		self.m_model:onGetActivityInfoRequest()
	end)
	self.m_csNode.wenhao:setTouchEnded(function()
		g_scene:openDialog("UI.HelpTips",{text = Serialize[62152],node = self.m_csNode.wenhao})
	end)
end

function This:refresh()
	self.m_csNode.res_node.number1:setString(GamePlayer:getGold())
	self.m_csNode.res_node.number2:setString(GamePlayer:getDiamond())
	local leftTime = self.m_model:getLeftTime()
	self.m_csNode.tiptime:setString(GameUtil:formatTime(Serialize["H_M_S"],leftTime))
	self:refreshItemList()
end

function This:onEnter()
	super.onEnter(self)
	self.m_model:addObserver(self)
	self:refresh()
end

function This:onExit()
	super.onExit(self)
	self.m_model:removeObserver(self)
end

function This:createItemView(item)
	local view = WuDaoShopItemView:create(item)
	view:setRefreshHandler(function(model)
		if RefreshRequestCount <= 0 then
			self.m_model:onGetActivityInfoRequest()
			RefreshRequestCount = RefreshRequestCount + 1
		end
	end)
	return view
end

function This:refreshItemList()
	local shopItemList = self.m_model:getItemList()
	local itemList = self.m_csNode.scrollview:getItemList()
	for i , item in ipairs(shopItemList) do
		if i <= #itemList then
			itemList[i]:setModel(item)
		else
			local itemView = self:createItemView(item)
			self.m_csNode.scrollview:pushNode(itemView,290,100,2)
		end
	end
	for i = #itemList , #shopItemList + 1, -1 do
		self.m_csNode.scrollview:removeItem(i)
	end
end

function This:appearSpeek()
	local str = ShowBuyTextList[math.random(1,#ShowBuyTextList)]
	self.m_csNode.speek.text:setString(str, 500)
	local w , h = self.m_csNode.speek.text:getContentSize()
	local scale = self.m_csNode.speek.text:getScale()
	w , h = w * scale + 15 , h * scale + 15

	self.m_csNode.speek.bg:setContentSize(w ,h)

	local x , y = self.m_csNode.speek.bg:getPosition()
	self.m_csNode.speek.text:setPosition(x - w/2, y - h/2 - 10)
	self.m_csNode.speek:stopAllActions()

	self.m_csNode.speek:setOpacity(0)
	self.m_csNode.speek:runAction(cc.Sequence(cc.FadeIn(0.5), cc.DelayTime(3), cc.FadeOut(0.5)))
end

function This:onActivityEnded()
	self:close()
	local panel = g_scene:getDialog("CostConfirmPanel")
	if panel then
		panel:close()
	end
end

function This:onUpdateActivity()
	self.m_csNode.res_node.number1:setString(GamePlayer:getGold())
	self.m_csNode.res_node.number2:setString(GamePlayer:getDiamond())
	local leftTime = self.m_model:getLeftTime()
	self.m_csNode.tiptime:setString(GameUtil:formatTime(Serialize["H_M_S"],leftTime))
end

function This:onRefreshActivityInfo()
	self:refresh()
	g_scene:showTips(Serialize[62153])
	RefreshRequestCount = 0
end

function This:onBuyShopItem()
	self:appearSpeek()
end



--endregion
