

-- 爵位晋升条件
local This , super = class(..., "Base.BaseModel")
local PromotionConditionsConfig = require("Metadatas.PromotionConditionsConfig")


function This:init(info)
    super.init(self)

	self.m_id = info.id
	self.m_progress = info.num or 0
	self.m_state = info.state or 0
	self.m_type = info.type or 0
	self.m_config = PromotionConditionsConfig[self.m_id]
end

function This:getId()
	return self.m_id
end

function This:getType()
	if self.m_config then
		return self.m_config.progress_type
	end
end

function This:getDesc()
	if self.m_config then
		return self.m_config.des
	end
	return ""
end

function This:getMaxProgress()
	if self.m_config then
		return self.m_config.progress
	end
	return 1
end

function This:getConfig()
	return self.m_config
end

function This:getProgress()
	return math.min(self.m_progress, self:getMaxProgress())
end

function This:setProgress(progress)
	self.m_progress = progress
end

function This:getState()
	return self.m_state
end

function This:setState(state)
	self.m_state = state
end

function This:updateInfo(info)
	self.m_type = info.type or 0
	self.m_progress = info.num or 0
	self.m_state = info.state or 0
end

function This:isFinish()
	return (self:getProgress() >= self:getMaxProgress())
end

