
local This , super = class(...,"NodeUI")
local ViewUtil = require("UI.ViewUtil")


function This:initData(data)
    self.m_data = data
    self.m_gotoCb = nil
end

function This:initNode(data)
    local csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/KingWayNobilityItem.csb")
    self:addChild(csNode)
    self.m_csNode = csNode

    local w, h = self.m_csNode.bg:getContentSize()
    w = w - 17
    self:setContentSize(w, h)
end

function This:initTouchEvent()
    if not self.m_inited then
        self.m_inited = true

        self.m_csNode.button:setTouch({
            isDynamic = true, 
            isContainer = true,
            onEnded = function ()
                self:goto()
            end,
        })
    end    
end

function This:onEnter()
    super.onEnter(self)
    self:refresh()
end

function This:setModel(data)
    self.m_data = data
    self:refresh()
end

function This:refresh()
    local data = self.m_data
    local csNode = self.m_csNode

    local desc = string.format("<New1>%s<New8>(<New7>%d<New8>/%d)", data:getDesc(), data:getProgress(), data:getMaxProgress())
    csNode.name:setStringWithColor(desc)

    local isFinish = data:isFinish()
    csNode.button:setVisible(not isFinish)
    csNode.yidacheng:setVisible(isFinish)
end

--前往
function This:goto()
    local config = self.m_data:getConfig()
    local panel = config.panel

    if type(panel) == "table" and panel.name then
        ViewUtil:jumpToPanel(panel.name, panel.arg)
    end
    
    if type(self.m_gotoCb) == "function" then
        self.m_gotoCb()
    end
end

function This:setGotoCb(cb)
    self.m_gotoCb = cb
end
