


local This , super = class(...,"NodeUI")
local NobilityTitleConfig = require("Metadatas.NobilityTitleConfig")
local NobilityManager = require("Nobility.NobilityManager")


function This:initData(id)
	self.m_id = id or 0
	self.m_selectCb = nil
	self.m_icon = nil
end

function This:initNode()
	local csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/KingWayNobilityNode.csb")
    self:addChild(csNode)
    self.m_csNode = csNode

    self:refresh()
end

function This:setSelect(isSelect)
	if type(self.m_selectCb) == "function" then
		self.m_selectCb(isSelect, self)
	end
end

function This:setSelectHandler(func)
	self.m_selectCb = func
end

function This:setId(id)
	self.m_id = id
	self:refresh()
end

function This:getId()
	return self.m_id
end

function This:refresh()
	local csNode = self.m_csNode
	local curId = NobilityManager:getNobility()
	local config = NobilityTitleConfig[self.m_id]

	if not config then
		return
	end

	csNode.icon:setImage(config.icon)

	if curId < self.m_id then
		--未解锁
		csNode.lock:setVisible(true)
		csNode.icon:setColor(120, 120, 120)
	else
		csNode.lock:setVisible(false)
		csNode.icon:setColor(255, 255, 255)
	end

	local w, h = csNode.icon:getContentSize()
	self:setContentSize(w, h)
	csNode:setPosition(w/2, h/2)
end