
--爵位特权界面

local This, super = class(..., "Dialog")
local NobilityPrivilegeItem = require("Nobility.NobilityPrivilegeItem")
local RankPageListLayer = require("Rank.RankPageListLayer")
local NobilityTitleConfig = require("Metadatas.NobilityTitleConfig")
local NobilityManager = require("Nobility.NobilityManager")


function This:initData(info)
	self.m_data = {}

	for k, v in pairs(NobilityTitleConfig) do
		local t = {}
		t.id 			= v.id
		t.name 			= v.name
		t.icon 			= v.icon
		t.desc 			= {v.privilege_desc1, v.privilege_desc2, v.privilege_desc3, v.privilege_desc4}
		t.reward 		= v.reward
		t.myNobility	= NobilityManager:getNobility()
		table.insert(self.m_data, t)
	end

	table.sort(self.m_data, function (a, b)
		return a.id < b.id
	end)
end

function This:initNode(info)
    self.m_csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/KingWayNobilityOverview.csb")
    self:addChild(self.m_csNode)
    self.m_csNode:setToCenter()

   	local scrollView = self.m_csNode.scrollView
	scrollView:setDirection("vertical")

    self.m_listLayer = RankPageListLayer:create({
        itemWidth = 675,
        itemHeight = 102,
        spaceX = 0,
        spaceY = 3,
        scrollView = scrollView,
		dataCounter = function ()	 
	        return #self.m_data
        end,
        viewCreator =  function(index, node) 
        	local data = self.m_data[index]
        	if data then     
			    if not node then
				    return NobilityPrivilegeItem:create(data, index)
				else
			        node:setModel(data, index)
			    end
			end
	    end
    })

    self.m_listLayer:setCascadeOpacityEnabled(true)
    self.m_listLayer:setAnchorPoint(0.5, 0)
    local w, h = self.m_listLayer:getContentSize()
    scrollView:pushBackCustomItem(self.m_listLayer, w, h, 0)
    self.m_listLayer:setDataList()
end

function This:initTouchEvent()
	if not self.m_inited then
		self.m_inited = true

		self.m_csNode.close:setTouchEnded(function()
        	self:close()
    	end)
		
	end
end

function This:onEnter()
    super.onEnter(self)
end

function This:onExit()
    super.onExit(self)
end

