-- @Author: superm
-- @Date:   2017-10-20 10:51:53
-- @Last Modified by:   superm
-- @Last Modified time: 2018-07-17 12:58:07
-- @File Name: NodeView.lua

local This, super = class(..., "cc.Node")
local EventDispatcher = require("EventDispatcher")
local Timer = require("Timer")

function This:create(...)
    if self.fileName then
        local node = super.createFromCSFile(self, self.fileName, self._MNAME)
        node:init(...)
        return node
    else
        return super.create(self, ...)
    end
    return node
end

function This:onEnter()
    super.onEnter(self)
    self:initNode()
    self:initTouchEvent()
end

function This:onExit()
    super.onExit(self)
    EventDispatcher:removeAllListener(self)
end

function This:init(...)
    self:setName(self._NAME)
    self:initData(...)
end

function This:initNode()
    
end

function This:initTouchEvent()
    
end

function This:update(deltaTime)
    if self.m_timer then
        self.m_timer:update(deltaTime)
    end
end

function This:setTimer(delayTime, listener, key, triggerTotal)
    if not self.m_timer then
        self.m_timer = Timer:create(self)
        self:scheduleUpdate()
    end
    self.m_timer:setTimer(delayTime, listener, key, triggerTotal)
end

function This:removeAllTimer()
    if self.m_timer then
        self.m_timer:removeAllTimer()
    end 
end

