local This = class(...)

local random = math.random
local ccSequence = cc.Sequence
local ccSpawn = cc.Spawn
local ccMoveBy = cc.MoveBy
local ccFadeIn = cc.FadeIn
local ccFadeOut = cc.FadeOut
local ccDelayTime = cc.DelayTime
local ccRemoveAction = cc.RemoveAction
local ccScaleTo = cc.ScaleTo

function This:create()
    local obj = {
        m_count = 0,
        m_count3 = 0,
        m_actions = {},
        m_actions3 = {},
        update = self.update,
        runAction = self.runAction,
    }
    return obj
end

local function action1(self, node)
    local scale = node:getScale()
    node:setScale(scale * 0.8)
    node:setOpacity(0)
    node:setCascadeOpacityEnabled(true)

    local count = self.m_count % 5
    if count == 0 then
        count = 1
    end
    local t = (count - 1) * 0.1 + 0.2

    local x, y = node:getPosition()
    node:setPosition(x + random(-4, 4), y + (count - 1) * 10)

    local action = ccSequence(
        ccSpawn(ccScaleTo(0.05, scale, "BackOut"), ccFadeIn(0.05)),
        ccMoveBy(0.05, 0, 25),
        ccMoveBy(0.04, 0, 12),
        ccMoveBy(t, 0, t * 80, "QuadraticOut"),
        ccSpawn(ccScaleTo(0.1, 0, "QuadraticIn"), ccMoveBy(0.1, -20, 5), ccFadeOut(0.1)),
        ccDelayTime(0.03),
        ccRemoveAction())
    node:runAction(action)
    self.m_actions[action] = 0.4 + t
end

local function action2(self, node)
    local scale = node:getScale()
    node:setScale(scale * 0.8)
    node:setOpacity(0)
    node:setCascadeOpacityEnabled(true)

    local count = self.m_count % 5
    if count == 0 then
        count = 1
    end

    local x, y = node:getPosition()
    node:setPosition(x + random(-10, 10), y + (count - 1) * 10)
    local t = (count - 1) * 0.1 + 0.4

    local action = ccSequence(
        ccSpawn(ccScaleTo(0.05, scale, "BackOut"), ccFadeIn(0.05)),
        ccMoveBy(0.05, 0, 25),
        ccMoveBy(0.04, 0, 12),
        ccMoveBy(0.04, 0, 4),
        ccMoveBy(t, 0, t * 50, "QuadraticOut"),
        ccSpawn(ccScaleTo(0.1, 0, "QuadraticIn"), ccMoveBy(0.1, -20, 5), ccFadeOut(0.1)),
        ccDelayTime(0.03),
        ccRemoveAction())
    node:runAction(action)
    self.m_actions[action] = 0.4 + t
end

local function action3(self, node)
    local scale = node:getScale()
    node:setScale(scale * 2.2)
    node:setOpacity(0)
    node:setCascadeOpacityEnabled(true)

    local count = self.m_count3 % 5
    if count == 0 then
        count = 1
    end
    local t = (count - 1) * 0.1 + 0.1
    local action = ccSequence(
        ccDelayTime(self.m_count3 % 2 == 0 and 0.1 or 0),
        ccSpawn(ccFadeIn(0.1), ccScaleTo(0.1, scale * 1.5)),
        ccScaleTo(0.08, scale * 1.05, "BackOut"),
        ccScaleTo(0.02, scale, "BackIn"),
        ccDelayTime(0.2),
        ccMoveBy(0.6, 0, 80 + self.m_count3 * 1),
        ccSpawn(ccScaleTo(t, scale * 0.8, "QuadraticIn"), ccFadeOut(t)),
        ccDelayTime(0.03),
        ccRemoveAction())
    node:runAction(action)
    self.m_actions3[action] = 0.5 + t
end

local actionList = {
    [1] = action1,
    [2] = action2,
    [3] = action3,
}

function This:runAction(node, actionType)
    if actionType == 3 then
        self.m_count3 = self.m_count3 + 1
    else
        self.m_count = self.m_count + 1
    end
    actionList[actionType](self, node)
end


function This:update(deltaTime)
    if self.m_count > 0 then
        local actions = self.m_actions
        for id,time in pairs(actions) do
            local t = time - deltaTime
            if t <= 0 then
                self.m_count = self.m_count - 1
                t = nil
            end
            actions[id] = t
        end
    end
    if self.m_count3 > 0 then
        local actions = self.m_actions3
        for id,time in pairs(actions) do
            local t = time - deltaTime
            if t <= 0 then
                self.m_count3 = self.m_count3 - 1
                t = nil
            end
            actions[id] = t
        end
    end
end