-- @Author: zheng
-- @Date:   2018-09-26 14:50:08
-- @Last Modified by:   zheng
-- @Last Modified time: 2018-11-26 15:19:28
-- @File Name: OfficialAwardItemView.lua
local OfficialManager = require("Official.OfficialManager")
local GameUtil = require("Util.GameUtil")

local This , super = class(...,"NodeUI")

This.fileName = "MenuScene/NodeUI/OfficialConferOperatePeople.csb"

local strList={
	btnTitle1 = Serialize["Official_AwardItem_1"],
	btnTitle2 = Serialize["Official_AwardItem_2"],
	btnTitle3 = Serialize["Official_AwardItem_3"],
	btnTitle4 = Serialize["Official_AwardItem_4_c"],
}

function This:initNode(info)
    if info then
       self.m_panelType = info.types
       -- if info.rquestType then
       -- 		self.m_requestType = info.rquestType
       -- end
       if info.officialId then
       		self.m_officialId = info.officialId
       end
       self.m_endCallBack = info.callFunc
       self.m_btnCallBack = info.btnCallBack
       local datas = info.data
       self:updateInfor(datas)
--       local w,h = self.bg:getContentSize()
		local w =447
		local h=72
       self:setContentSize(w,h)
    end
end

-- function This:initData( queue, dialog )
--     self.m_activity = queue
--     self.m_dialog = dialog
-- end
function This:initTouchEvent()
	self.button:setTouch({
		onEnded = function()
			local panelType = self.m_panelType
	   		local requestType = panelType--self.m_requestType
	   		local friend = self.m_config
	   		local playerUid = friend.role_id
	   		local playerName = friend.name
	   		local officialId = self.m_officialId
	   		local configData = self.m_config
	   		if panelType and friend and configData then
				if panelType == OfficialSearchType.kType1 and officialId then
					local isEmperor = OfficialManager:myIsEmperor(self.m_officialId)
					local itemOfficialId = configData.id
					if itemOfficialId~=0 then
						local tipStr = Serialize["Official_TipStr_1_c"]
						local itemIsEmperor = OfficialManager:myIsEmperor(itemOfficialId)
						if isEmperor then
							if itemIsEmperor then
								tipStr = Serialize["Official_TipStr_3_c"]
							end
						else
							tipStr = Serialize["Official_TipStr_6_c"]
							if itemIsEmperor then
								tipStr = Serialize["Official_TipStr_4_c"]
							end
						end
						g_scene:showTips(tipStr)
						return
					end
					if isEmperor then
						requestType = OfficialSearchType.kType3 --禅让
						local emperorData = OfficialManager:getPowerWithOfficialId(OfficialType.kType1)
						local leftTimes = emperorData.times
						local officialData = self.m_data
						if times==0 then
							OfficialManager:onModifyOfficialRequest(requestType,playerUid,officialId)
						else
							local diamond = officialData:getDemiseCost(leftTimes)
							g_scene:openDialog("UI.CostConfirmPanel", {
						        cost = diamond,
						        desc = string.format("%s%s",Serialize["Official_TipStr_15"],playerName), 
						        okHandler = function(build)
						              OfficialManager:onModifyOfficialRequest(requestType,playerUid,officialId)
						        end } )
							end
					else
						OfficialManager:onModifyOfficialRequest(requestType,playerUid,officialId)
					end
				elseif panelType == OfficialSearchType.kType7 then
					if OfficialManager:checkHaveGift(friend.reward_times) then
						if self.m_btnCallBack then
							local infor = {playerUid = playerUid,node = self,playerName = playerName}
							self.m_btnCallBack(infor)
						end
					end
				end
				if self.m_endCallBack then
					self.m_endCallBack()
				end
   			end
		end,
		isDynamic = true
	})
end

function This:updateInfor(newData)
	if not newData then
		self:setVisible(false)
		return
	end
	self.m_config = newData
	self:setVisible(true)
	self:getData()
	self:refresh()
end

function This:refresh()
	local panelType = self.m_panelType
	local friend = self.m_config
	local officialData = self.m_data
	local familyTitle = officialData:getFamilyTitel(friend.title)
	local icon = friend.icon
	local name = friend.name
	local level = "lv."..friend.level

	GameUtil:setPlayerIconNodeImage(self.touxiang.icon, icon)
	self.name:setString(name)
	self.level:setString(level)
	self.position:setString(familyTitle)
	local btn = self.button
	btn:clearShader()
	local btnTitle = strList.btnTitle1
	btn:setVisible(true)
	self.text2:setVisible(false)
	if panelType == OfficialSearchType.kType1 then
		if OfficialManager:myIsEmperor(self.m_officialId) then
			btnTitle = strList.btnTitle4
		end
		if friend.id~=0 then
			self:grayBtn(Serialize["Official_AwardItem_5"])
		end
	elseif panelType == OfficialSearchType.kType7 then
		btnTitle = strList.btnTitle2
		-- if friend.reward_times>0 then
		if not OfficialManager:checkHaveGift(friend.reward_times) then
			btnTitle = nil
			self:grayBtn()
		end
	elseif panelType == OfficialSearchType.kType8 then
		self.position:setVisible(false)
		btn:setVisible(false)
	end
	if btnTitle then
		btn.text1:setString(btnTitle)
	end

end

function This:grayBtn(btnTitle)
	-- local btnStr = strList.btnTitle3
	local btn = self.button
	btn:setVisible(false)
	local str = btnTitle or strList.btnTitle3
	self.text2:setVisible(true)
	self.text2:setString(str)
	-- btn:setGrayShader()
	-- btn.text1:setString(btnStr)
end

function This:getData()
	self.m_data = OfficialManager:getPowerData()
end