-- @Author: zheng
-- @Date:   2018-09-25 20:47:27
-- @Last Modified by:   zheng
-- @Last Modified time: 2019-10-17 10:31:16
-- @File Name: OfficialAwardPanel.lua

local OfficialManager = require("Official.OfficialManager")
local OfficialAwardItemView = require("Official.OfficialAwardItemView")
local OfficialGiftItemView = require("Official.OfficialGiftItemView")

local ItemNode = require("UI.ItemNode")
local GameUtil = require("Util.GameUtil")
local strList={
	title1 = Serialize["Official_AwardPane_1"],
	title2 = Serialize["Official_AwardPane_2"],
	title3 = Serialize["Official_AwardPane_3"],
	nameNormal = Serialize["Official_AwardPane_4_c"],
	ceFeng = Serialize["Official_AwardPane_5"],
	tip1 = Serialize["Official_AwardPane_6"],
	gift = Serialize["Official_AwardPane_7"],
	giftTip = Serialize["Official_AwardPane_8"],
}
local txtColor ={
    name = {112,136,164},
    nameNormal = cc.ColorList.New11,
}
local This , super = class(...,"Dialog")

This.fileName = "MenuScene/NodeUI/OfficialAward.csb"

function This:initNode(info)
    self:getData()
    if info then
    	local panelType = info.types
    	self.m_panelType = panelType
    	if info.officialId then
       		self.m_officialId = info.officialId
       end
       local fileName = This.fileName
       local title = strList.title2
       if self:isType(OfficialSearchType.kType1) then
       		title = strList.title1
			if OfficialManager:myIsEmperor(self.m_officialId) then
				title = strList.title3
			end
       else
       		fileName = "MenuScene/NodeUI/OfficialAwardGift.csb"
       end
		self.m_csNode = cc.Node:createFromCSFile(fileName)
	    self.m_csNode:setToCenter()
	    self:addChild(self.m_csNode)
       self.m_csNode.beijing.title:setString(title)
       -- self.m_family = info.family
       if panelType and panelType >0 and panelType<3 then
       		-- self.m_csNode["info"..1]:setVisible(false)
       		-- self.m_csNode["info"..2]:setVisible(false)
       		self.m_csNode["info"..panelType]:setVisible(true)
       end
    	self:refresh()
    end
end

function This:initTouchEvent()
	local csNode = self.m_csNode
   csNode.beijing.closebutton.close:setTouchEnded(function()
		self:close()
	end)
   --serarch
   if csNode.other.button then
	   csNode.other.button:setTouchEnded(function() 
			local str = csNode.other.word:getString()
			local panelType = self.m_panelType
			OfficialManager:onSearchRequest(panelType,str)
			-- if string.len(str) > 0 and panelType then
			-- end
		end)
   end
--    csNode.info8.button1:setTouchEnded(function() 
		
-- 	end)
end

function This:refresh()
	self:refreshScroolView()
	if self:isType(OfficialSearchType.kType1) then
		self:refreshOfficial()
	elseif self:isType(OfficialSearchType.kType7) then
		self:refreshGift()
	end
end


function This:refreshOfficial()
	local data = self.m_data
	local node = self.m_csNode.info1
	local officialId = self.m_officialId
	local officialConfig = data:getOfficialConfig(officialId)
	local officialData = OfficialManager:getPowerWithOfficialId(officialId)
	local nameStr = strList.nameNormal
	local nameColor = txtColor.nameNormal
	local iconVisible = false
	local icon = node.zhiweiicon.icon
	if officialData and officialData.role_id ~=0 then
		nameStr = officialData.name
		nameColor = txtColor.name
		iconVisible = true
		GameUtil:setPlayerIconNodeImage(icon, officialData.icon)
	end
	icon:setVisible(iconVisible)
	node:setVisible(true)
	self:resetTxtColor(node.kongque, nameColor)
	node.kongque:setString(nameStr)
	local ceFengStr = strList.ceFeng
	if OfficialManager:myIsEmperor(officialId) then
		ceFengStr = Serialize["Official_AwardPane_9"]
	end
	local times = 0
	if officialData then
		times = officialData.times
	end
	node.txtCeFeng:setString(string.format("%s%d/%d",ceFengStr,times,officialConfig.appointment_times))

	local zhiWeiLabel = node.zhiwei
	if officialId<=OfficialType.kType3 then
		zhiWeiLabel = node.gaozhiwei
	end
	zhiWeiLabel:setVisible(true)
	zhiWeiLabel:setString(data:getName(officialId))

	-- local rewards = data:getWage(officialId)
	-- self:refreshItemNode(node.items,rewards,3)
	data:refreshOfficialPawerAttr(node.items,officialId)	
	data:refreshOfficialRewards(node.scrollView,298,80,officialId)
	-- local attrs = data:getPowerAttr(officialId)
	-- local strs ,lineCount = data:convertDataToStr(attrs)
	-- data:resetScoolSize(node.scrollView,150,76,strs)
	if not OfficialManager:myIsEmperor() then
		self.m_csNode.other.other:setVisible(false)
	end
end

function This:resetTxtColor(txtNode,color)
	local temColor =color
	if not color.r then
		temColor ={}
		temColor.r = color[1]
		temColor.g = color[2]
		temColor.b = color[3]
	end
	txtNode:setColor(temColor.r,temColor.g,temColor.b)
end

function This:refreshGift()
	self:refreshScroolViewGift()
	local data = self.m_data
	local node = self.m_csNode.info8
	-- node:setVisible(true)
	-- self:refreshItemNode(node,giftList,2)
	-- -- gift = Serialize[62170],
	-- for index,giftData in ipairs(giftList) do
	-- 	local item1 = node["number"..index]
	-- 	item1:setString(string.format("%s%d",strList.gift,giftData[2]))
	-- end
	local haveGiftIsVisible =false
	if self.m_isHaveGift then
		local giftList,itemNum,itemId = self:getGiftItem()
		if #giftList ==0 then
			local giftIdList = {}
			local needCheckOfficialId = {OfficialType.kType1,OfficialType.kWenWang}
			for _,officialId in ipairs(needCheckOfficialId) do
				local temConfig = data:getOfficialConfig(officialId)
				local reward = temConfig.emperor_award[1]
				if reward then
					table.insert(giftIdList,reward[1])
				end
			end
			local emptyGift = node.emptyGift
			for index,giftId in ipairs(giftIdList) do
				GameUtil:creatItemNode(emptyGift["item"..index],{giftId})
			end
		else
			local haveGift = node.haveGift
			haveGiftIsVisible = true
			haveGift.number1:setString(string.format("%s%d",strList.gift,itemNum))
			GameUtil:creatItemNode(haveGift.item1,{itemId})
		end
	end
	node.haveGift:setVisible(haveGiftIsVisible)
end

function This:getGiftItem(idIndex)
	local res = {}
	local res2 = 0
	local res3 = 0
	local giftList = self:getGiftInfo().gift_list
	-- for index=1,2 do
		local item1 = giftList[1]
		if item1 then
			local item2 = {item1.id,item1.num}
			table.insert(res,item2)
			-- if idIndex and idIndex == 1 then
				res2 = item2[2]
				res3 = item2[1]
			-- end
		end
		
	-- end
	return res,res2,res3
end

function This:getGiftInfo()
	local countryInfor = OfficialManager:getCountryInfor()
	local giftList = countryInfor.reward_info
	return giftList
end

function This:refreshScroolViewGift()

    local scrollView = self.m_csNode.info8.scrollView1
    scrollView:removeAllItems()

    local giftList = self:getGiftInfo().record_list
    table.sort(giftList,function(a,b)
            return a.time > b.time
        end)
    for itemIndex,groupData in ipairs(giftList) do
    	local view = OfficialGiftItemView:create(groupData)
        local w , h = view:getContentSize()
        scrollView:pushBackCustomItem(view,w,h,0.5)
    end
end

function This:refreshScroolView()
    local scrollView = self.m_csNode.other.scrollView2
    -- scrollView:removeAllItems()
    local itemList = scrollView:getItemList()
    local officialList,groupList = OfficialManager:getAllPower(self.m_panelType)
    for itemIndex,groupData in ipairs(groupList) do
    	self.m_isHaveGift = true
    	local view = itemList[itemIndex]
    	if view then
    		view:updateInfor(groupData)
    	else
    		view = self:createItem(groupData)
	        local w , h = view:getContentSize()
	        scrollView:pushBackCustomItem(view,w,h,0.5)
    	end
    end
end

function This:getFriendNode(friend)
	self.m_friendData = friend
	if self.m_searchNode then
		self.m_searchNode:updateInfor(friend)
	else
		self.m_searchNode = self:createItem(friend)
		self.m_csNode.other.otherpeople:addChild(self.m_searchNode)
	end
end

function This:createItem(data)
	local panelType = self.m_panelType
	local info = {types = panelType,data = data,officialId = self.m_officialId,callFunc = function (index2)
                 self:close()
            end,btnCallBack = function (infor)
            	local isEmperor = OfficialManager:myIsEmperor()
            	if not OfficialManager:myIsEmperor() and not OfficialManager:myIsQinWang() then
            		g_scene:showTips(Serialize["Official_TipStr_10"])
            		return
            	end
                 local _,itemNum,itemId = self:getGiftItem()
                 if itemNum>0 then
	                 OfficialManager:onGetGiftRequest(itemId,infor.playerUid,infor.playerName)
	             else
	             	 g_scene:showTips(strList.giftTip)
	             end
            end }
    if self:isType(OfficialSearchType.kType7) then
    	info.callFunc = nil
    end
	local node = OfficialAwardItemView:create(info)
	return node
end

function This:refreshItems(friendList)
	
	if not friendList then
		g_scene:showTips(Serialize["friend_SearchPanel_1"])
		if self.m_searchNode then
			self.m_searchNode:updateInfor()
		end
	else
		self:getFriendNode(friendList)
	end
end

function This:isType(checkType)
	local res = false
	if self.m_panelType == checkType then
		res = true
	end
	return res
end

function This:onEnter()
    super.onEnter(self)
    OfficialManager:addObserver(self)
end

function This:onExit()
    super.onExit(self)
    OfficialManager:removeObserver(self)
end

function This:getData()
	self.m_data = OfficialManager:getPowerData()
end

function This:onSearchPlayer(friendList,opType)
 	-- if opType and (opType == OfficialSearchType.kType1 or opType == OfficialSearchType.kType7 )then
		self:refreshItems(friendList)
	-- end
	-- if not friendList then
	-- 	self:refreshItems(friendList)
	-- end
end

function This:onGetGift()
	self:refresh()
end
