-- @Author: zheng
-- @Date:   2019-09-26 17:33:18
-- @Last Modified by:   zheng
-- @Last Modified time: 2019-10-08 17:04:19
-- @File Name: OfficialBoxPanel.lua

local GameUtil = require("Util.GameUtil")
local TreasureConfig = require("Metadatas.TreasureConfig")
local This , super = class(...,"Dialog")
-- local FamilyManager = require("Official.FamilyManager")
This.fileName = "MenuScene/NodeUI/OfficialAwardGiftList.csb"
function This:initNode(info)
    if info then
       self.m_family = info.family
    end
    self.m_csNode = cc.Node:createFromCSFile(This.fileName)
    self.m_csNode:setToCenter()
    self:addChild(self.m_csNode)

    local scrollView = self.m_csNode.scrollview
    scrollView:setDirection("horizontal")
    scrollView.m_direction = "right"
    --self:getData()
    self:refresh()
end

function This:refresh()
    self:rerfreshScroolView()
    -- local data = self.m_data
    -- local csNode = self.m_csNode
end

function This:initTouchEvent()
    local csNode = self.m_csNode
    csNode.closebutton:setTouchEnded(function()
        self:close()
    end)
    local wenhao = csNode.wenhao
    wenhao:setTouchEnded(function()
        local text = Serialize["Official_BoxPanel_1"]
        g_scene:openDialog("UI.HelpTips", {text = text,node = wenhao})
    end)
end

function This:rerfreshScroolView()

    local function getItem(  )
        local node = cc.Node:createFromCSFile("MenuScene/NodeUI/OfficialAwardGiftListItem.csb")
        node:setContentSize(140, 110)
        return node
    end
    local function updateItem(rewardData,viewNode)
        local itemId = rewardData.prop_id
        GameUtil:creatItemNode(viewNode.item,itemId)
        if rewardData.precious_prop ==1 then
            viewNode.num:setString("X"..rewardData.number)
        end
    end
    local scrollView = self.m_csNode.scrollview
    scrollView:removeAllItems()

    local officalId = 8
    local maxCount = #TreasureConfig
    for index = maxCount , 1 , -1 do
        local item1 = TreasureConfig[index]
    -- for _,item1 in ipairs(TreasureConfig) do
        if item1.official_id ==officalId then
            local view = getItem()
            updateItem(item1,view)
            local w , h = view:getContentSize()
            scrollView:pushBackCustomItem(view,w,h,0.5)
         end 
    end

end