-- @Author: zheng
-- @Date:   2018-10-09 16:41:13
-- @Last Modified by:   zheng
-- @Last Modified time: 2018-11-03 16:22:03
-- @File Name: OfficialConferPanel.lua

local This , super = class(...,"Dialog")
local OfficialManager = require("Official.OfficialManager")

This.fileName = "MenuScene/NodeUI/OfficialConfer.csb"
local strList={
	title1 = Serialize["Official_AwardPane_4_c"],
	tip1 = Serialize["Official_TipStr_7_c"],
}
function This:initNode(info)
	self.m_csNode = cc.Node:createFromCSFile(This.fileName)
    self.m_csNode:setToCenter()
    self:addChild(self.m_csNode)

     self:getData()
    -- if info then
    --    self.m_family = info.family
    -- end
    self:refresh()
end

-- function This:initData( queue, dialog )
--     self.m_activity = queue
--     self.m_dialog = dialog
-- end
function This:initTouchEvent()
   self.m_csNode.close:setTouchEnded(function()
        self:close()
    end)
   local data = self.m_data
   local officailCount = data:getOfficialCount()
   for officialId=1,officailCount do
		local item1 = self.m_csNode["item"..officialId]
		item1.bg:setTouchEnded(function()
			local isEmperor = OfficialManager:myIsEmperor()
			local officialData = OfficialManager:getPowerWithOfficialId(officialId)
			local haveOfficial = false
			if officialData then
				haveOfficial = officialData.role_id ~=0
			end
			local infor ={types = OfficialSearchType.kType1,member = officialData,officialId = officialId}
			if officialId >= OfficialType.kWuWang then
				g_scene:showTips(Serialize[62173])
				return
			end
			if haveOfficial then
				g_scene:openDialog("Official.OfficialPersonPanel",infor)
				return
			end
			if isEmperor then
				infor.member = nil
				g_scene:openDialog("Official.OfficialAwardPanel",infor)	
			else--if not haveOfficial then
				g_scene:showTips(strList.tip1)
			end
		end)
	end
end

function This:refresh()
	local officialList,groupList = OfficialManager:getAllPower()
	local data = self.m_data
    local officailCount = data:getOfficialCount()
	for officialId=1,officailCount do
		local item1 = self.m_csNode["item"..officialId]
		local officialData = officialList[officialId]
		if officialData then
			local titelName = strList.title1
			local color = "<New11>"
			if officialData.role_id ~=0 then
				titelName = officialData.name
				color = "<New13>"
			end
			item1.name:setStringWithColor(string.format("%s%s",color,titelName))
		else
			item1.name:setStringWithColor(string.format("%s%s","<New11>",strList.title1))
		end
		
	end
end

function This:onEnter()
    super.onEnter(self)
    OfficialManager:addObserver(self)
end

function This:onExit()
    super.onExit(self)
    OfficialManager:removeObserver(self)
end


function This:onModifyOfficial(op_type)
	self:refresh()
end

-- This.onModifyOfficial = This.refresh
function This:getData()
	self.m_data = OfficialManager:getPowerData()
end