-- @Author: zheng
-- @Date:   2018-10-10 14:09:34
-- @Last Modified by:   zheng
-- @Last Modified time: 2019-11-12 14:38:25
-- @File Name: OfficialEdictPanel.lua
local OfficialManager = require("Official.OfficialManager")

local This , super = class(...,"Dialog")

This.fileName = "MenuScene/NodeUI/OfficialImperialEdict.csb"
local strList={
	tip1 = Serialize["Official_TipStr_8"],
	cost1 =Serialize["Official_EdictPanel_1"],
	costLimit =Serialize["Official_EdictPanel_2"],
}
function This:initNode(info)
	self.m_csNode = cc.Node:createFromCSFile(This.fileName)
    self.m_csNode:setToCenter()
    self:addChild(self.m_csNode)
    self.m_csNode.bg:fitScreen()
    if info then
    	local panelType = info.types
    	self.m_panelType = panelType
    end
    self:refresh()
end

-- function This:initData( queue, dialog )
--     self.m_activity = queue
--     self.m_dialog = dialog
-- end
function This:initTouchEvent()
	-- if self:isType(OfficialType.kcreate) then--创立国号
	   self.m_csNode.before.button1:setTouchEnded(function()
	        self:close()
	    end)
	   self.m_csNode.before.button2:setTouchEnded(function()
	        if self:isType(OfficialType.kcreate) then--创立国号
				local function getChineseString(str,chineseLimit)
				     if str and chineseLimit then
				         local GameUtil = require("Util.GameUtil")
				         local str2 = GameUtil:filterSpecChars(str,true)
				         local length = string.utf8Len(str)
				         local length2  = string.utf8Len(str2)
				         if length == length2 and length2 <=chineseLimit and length2>0 then
				             return true
				         end
				     end
				     return false
				end

		   		local str = self.m_csNode.before.write.shuruword:getString()
		   		if getChineseString(str,2) then
		   			local data = self.m_data
		   			local cost,leftTime = data:getCouuntryCost()
		   			if leftTime>0 then
			   			local panel = g_scene:openDialog("UI.CostConfirmPanel", {cost = cost, desc = strList.cost1,
			   			    okHandler = function()
			   			    OfficialManager:onModifyCountryNameRequest(str)
			   			    self:close()
			   			end})
			   			return
		   			else
		   				g_scene:showTips(strList.costLimit)
		   			end
		   		else
		   			g_scene:showTips(strList.tip1)
		   			return
		   		end
	   		-- elseif self:isType(OfficialType.kcreateInfor) then--官报
	   		end
	        self:close()
	    end)
	-- end
   self.m_csNode.after.button2:setTouchEnded(function()
   		self:close()
    end)
end

function This:refresh()
	self:getData()
	local node = self.m_csNode
	if self:isType(OfficialType.kcreate) then--创立国号
		node.before:setVisible(true)
	elseif self:isType(OfficialType.kcreateInfor) then--官报
		node.after:setVisible(true)
		local countryInfor = OfficialManager:getCountryInfor()
		local countryName = countryInfor.contry_code_info.country_code2
		node.after.text3:setString(countryName)
		OfficialManager:onGetOfficialInfoRequest()
	end
end

function This:isType(checkType)
	local res = false
	if self.m_panelType == checkType then
		res = true
	end
	return res
end

-- function This:onEnter()
--     super.onEnter(self)
--     -- FamilyManager:addObserver(self)
-- end

-- function This:onExit()
--     super.onExit(self)
--     -- FamilyManager:removeObserver(self)
-- end

function This:getData()
	self.m_data = OfficialManager:getPowerData()
end
