-- @Author: zheng
-- @Date:   2018-09-21 14:26:35
-- @Last Modified by:   zheng
-- @Last Modified time: 2019-10-17 17:07:36
-- @File Name: OfficialManager.lua
-- local OfficialManager = require("Official.OfficialManager")
local FamilyManager = require("Family.FamilyManager")
local This = class(...)

-- local KinglyWayConfig = require("Metadatas.KinglyWayConfig")
local GameOfficialPosition = require("Official.GameOfficialPosition")

local PopDialogManager = require("UI.PopDialogManager")
local GamePlayer = require("Player.GamePlayer")
local HeroManager = require("Hero.HeroManager")
local Socket = require("Net.Socket")
local EventDispatcher = require("EventDispatcher")
local Serialize = require("Serialize.Serialize")
local OfficialManagerFileName = "OfficialManager"
local PrisonConfig = require("Metadatas.PrisonConfig")

OfficialSearchType ={
	kType1 =1,--册封
	kType2 =2,--罢免
	kType3 =3,--禅让
	kType4 =4,--宫俸
	kType5 =5,--作揖
	kType6 =6,--朝拜
	kType7 =7,--封赏
	kType8 =8,--收监
}

-- 官职ID
OfficialType ={
	kType0 =0,--无官职
	kType1 =1,--皇帝
	kType3 =3,--皇后
	kWuWang = 8,--武亲王
	kWenWang = 9, --文亲王
	-- kTypeCount = 7,--最后一个官职
	kcreate = "kcreate",--创立国号
	kcreateInfor = "kcreateInfor",--官报
	kemperorNew = 1,--皇帝战
	kemperorOld = 2,--皇帝禅让
	ktalkTime = 2,--气泡提示时间
}
function This:init()
	self.m_powerData = GameOfficialPosition:create(1)
	self.m_power = 0
	self.m_prisonList = {}--犯人列表
	self.m_officialList = {}--官职列表(包含军团成员)
	self.m_countryInfor = {}--国家信息朝拜self.m_SearchResult ={}--搜索结果
	self.m_salaryCount = 0 --今日剩余领取官俸次数
	-- self.m_workCount = 0 --今日剩余朝拜次数
	self.m_bowCount = {} --今日剩余跪拜次数列表
	self.m_hitCount = 0 --今日累计教育次数
	self.m_leftHitCount = 0 --剩余教育次数
	-- self.m_giftInfo = {} --天子赏赐

	self.m_observers = {}
	self:initEventListener()
end

-- --搜索结果
-- function This:setSearchResult(SearchResult)
-- 	if not SearchResult then
-- 		SearchResult ={}
-- 	end
-- 	self.m_SearchResult = SearchResult
-- end

-- function This:getSearchResult()
-- 	return self.m_SearchResult
-- end

function This:checkHaveGift(giftNum)
	-- return true
	return giftNum==0
end

--官俸
function This:isCanSalary()
	return self.m_salaryCount>0
end

--作揖
-- function This:isCanBow()
-- 	if not self:isHaveEmperor() then
-- 		return false
-- 	end
-- 	return self.m_bowCount>0
-- end

--朝拜
function This:isCanWork(id)
	if not id then
		if not self:isHaveEmperor() then
			return false
		end
		for i,data in pairs(self.m_bowCount) do
			if data > 0 and self:isHaveKing(i) then
				return true
			end
		end
		return false
	else
		if self.m_bowCount[id] then
			return self.m_bowCount[id] > 0 and self:isHaveKing(id)
		else
			return false
		end
	end
end

--剩余教育次数
function This:getIsCanHit()
	return self.m_leftHitCount>0,self.m_leftHitCount
end

--教育次数(除了教育,其他次数都是剩余)
function This:getHitCount()
	return self.m_hitCount
end

--所有可能有免费奖励的情况
function This:isHaveRedDot()
	if self:isCanWork() or self:isCanSalary() or (self:getIsCanHit() and self:isHavePrison())then
		return true	
	end
	return false
end

--是否有犯人
function This:isHavePrison()
	for prisonId,conf in pairs(PrisonConfig) do
		local prisonData = self:getPrisonWithPrisonId(prisonId)
		if prisonData.id ~=0 then
			return true
		end
	end
	return false
end
	
-- --天子赏赐end
-- function This:getgiftInfo()
-- 	return self.m_giftInfo
-- end

--获得牢房里的所有人
function This:getAllPrison()
	--牢房Id为关键字的犯人
	local res =self:convertInfor(self.m_prisonList)
	return res,self.m_prisonList
end

-- local officialList,groupList = OfficialManager:getAllPower()
function This:getAllPower(searchType)
	--所有有官职的人
	local officialList = {}
	local groupList = {}
	local officialKey ={}
	for _,memeber in pairs(self.m_officialList) do
		local officialId = memeber.id
		if officialId ~=0 then
			officialKey[memeber.role_id] = officialId
			officialList[officialId]= memeber
		end
	end

	local family = FamilyManager:getMyFamily()
	if family then
		local groupId = FamilyManager:getMyFamilyId()
		local needCheckOfficialId = {OfficialType.kType1,OfficialType.kWenWang,OfficialType.kWuWang}
		local isHave = false
		for _,officialId in ipairs(needCheckOfficialId) do
			local officialData = officialList[officialId]
			if officialData and officialData.group_id == groupId then
				isHave = true
				break
			end
		end
		if isHave then
			local rewardHistoryIdKey ={}
			if self.m_countryInfor and self.m_countryInfor.reward_info then
				local rewardHistory = self.m_countryInfor.reward_info.record_list
				for _,rewardInfo in ipairs(rewardHistory) do
					rewardHistoryIdKey[rewardInfo.role_id] = 1
				end
			end
			local memeberList = family:getMemberList()
			for _,member in ipairs(memeberList) do
				local memeberId = member:getId()
				local officialId = officialKey[memeberId] or 0
				local leftTime = 0
				if officialKey[memeberId] then
					leftTime = officialList[officialId].times
				end
				local temInfo = {} 
				temInfo.id = officialId
				temInfo.role_id = memeberId
				temInfo.group_id = groupId
				temInfo.name = member:getName()
				temInfo.level = member:getLevel()
				temInfo.icon = member:getIcon()
				temInfo.title = member:getTitle()
				temInfo.times = leftTime
				temInfo.reward_times = rewardHistoryIdKey[memeberId] or 0
				table.insert(groupList,temInfo)
			end

			 table.sort( groupList, function ( memberA, memberB )
			 	-- true 在最上面
			 	local res1= memberA.title < memberB.title
			 	local res2 = memberA.reward_times < memberB.reward_times
			 	local res3 = memberA.id < memberB.id
			 	local res = res1
			 	if searchType then
			 		if searchType == OfficialSearchType.kType1 then--册封
			 			res = res3
			 		elseif searchType == OfficialSearchType.kType7 then--封赏
			 			res = res2
			 		end
			 	end
			 	return res
		    end)
		end
	end
	return officialList,groupList
end

--转化官职(牢房)信息
function This:convertInfor(data)
	local res ={}
	for playerId,playerData in pairs(data) do
		res[playerData.id] = playerData
	end
	return res
end

-- 初始化官职(牢房)信息
function This:setList(tableSrc)
	local res ={}
	for _,itemData in ipairs(tableSrc) do
		local playerId = itemData.role_id
		res[playerId] = itemData
	end
	return res
end

function This:checkIsOnPrison(prisonData)
	local serTime = GamePlayer:getServerTime()
	local openTime = prisonData.release_time
	if serTime>openTime then
		return false
	end
	return true
end

function This:getPrisonWithPrisonId(prisonId)
	local prisonList = self:getAllPrison()
	local prisonData = prisonList[prisonId]
	if prisonData then
		if self:checkIsOnPrison(prisonData) then
			return prisonData
		end
	end
	return {role_id = 0,id =0}
end

--获取玩家罪名
function This:getPrisonWithPlayerId(playerId)
	if not playerId then
		playerId = GamePlayer:getPlayerID()
	end
	local item1 = self.m_prisonList[playerId]
	if item1 then
		if self:checkIsOnPrison(item1) then
			return item1
		end
	end
	return {role_id = playerId,id =0}
end

function This:getPowerWithOfficialId(officialId)
	local officialList,groupList = self:getAllPower()
	local officialData = officialList[officialId]
	-- local res = nil
	-- if officialData then
	-- 	res = officialData
	-- end
	return officialData
end

--获取玩家官职
function This:getPowerWithPlayerId(playerId)
	if not playerId then
		playerId = GamePlayer:getPlayerID()
	end
	local officialList,groupList = self:getAllPower()
	local item1 = nil
	for k,memeber in pairs(officialList) do
		if memeber.role_id == playerId then
			item1 = memeber
			break
		end
	end
	if item1 then
		return item1
	end
	return {role_id = playerId,id =0,}
end


-- 自己的官职
function This:getMyPower()
	return self.m_power
end

--是否有官职
function This:myIsEmpty(power)
	if not power then
		power = self.m_power
	end
	return power ==OfficialType.kType0
end

--是否是皇帝
function This:myIsEmperor(power)
	if not power then
		power = self.m_power
	end
	-- return true
	return power ==OfficialType.kType1
end

function This:myIsQinWang(power)
	local temPower = power or self.m_power
	return OfficialType.kWenWang == temPower or OfficialType.kWuWang == temPower
end

function This:getCountryName()
	local res = ""
	local countryInfor = self:getCountryInfor()
	if not countryInfor.time or countryInfor.time ==0 then
		return res
	else
		res = countryInfor.contry_code_info.country_code or ""
		local times = countryInfor.contry_code_info.effective_time
		if self:checkCountryNameIsEffect(times) then
			res = countryInfor.contry_code_info.country_code2 or ""
		end
	end
	return res
end

--检测国号是否生效
function This:checkCountryNameIsEffect(effectTime)
	local res =false
	if effectTime and effectTime~= 0 then
		local offsetTime = 86400 --1天
		local serTime = GamePlayer:getServerTime()
		if serTime>effectTime and (serTime-effectTime)< offsetTime then
			res = true
		end
	end
	return res
end

--是否是皇帝所在的军团
function This:checkEmperorGroup(groupId)
	local res = false
	local emperorGroupId = self.m_countryInfor.group_id or 0
	if groupId and emperorGroupId and emperorGroupId~=0 and emperorGroupId == groupId then
		res = true
	end
	return res,emperorGroupId
end

function This:isHaveEmperor()
	local emperorData = self:getPowerWithOfficialId(OfficialType.kType1)
	local res = false
	if emperorData and emperorData.role_id then
		res = emperorData.role_id~=0
	end
	return res
end

function This:isHaveKing(type)
	local emperorData = self:getPowerWithOfficialId(type)
	local res = false
	if emperorData and emperorData.role_id then
		res = emperorData.role_id~=0
	end
	return res
end

--获取国家信息
function This:getCountryInfor()
	return self.m_countryInfor
end

function This:modifyMyPower(powerId)
	self.m_power = powerId
	self.m_powerData:init(powerId)
end

function This:getPowerData()
	return self.m_powerData
end

-- --官职属性
-- function This:getMyAttrs()
-- 	local res ={}
-- 	local powerData = self.m_powerData
-- 	if self:myIsEmpty() then
-- 		local attrs = powerData:getPowerAttr()
-- 		powerData:tableAdd(attrs, res)
-- 	end
-- 	local prisonAttr = powerData:getPrisonAttr()
-- 	powerData:tableAdd(prisonAttr, res)
-- 	return res
-- end

----------------------------------------------------------
function This:initEventListener()
	EventDispatcher:addListener(self, 13300, self.onGetOfficialInfoReply)--Official信息
	EventDispatcher:addListener(self, 13301, self.onModifyCountryNameReply)--创立/修改国号
	EventDispatcher:addListener(self, 13302, self.onModifyOfficialReply)--册封/罢免
	EventDispatcher:addListener(self, 13303, self.onGetGiftReply)--天子赏赐
	EventDispatcher:addListener(self, 13304, self.onGetRewardReply)--领取奖励
	EventDispatcher:addListener(self, 13305, self.onModifyPrisonReply)--关押
	EventDispatcher:addListener(self, 13306, self.onHitPrisonReply)--教育
	EventDispatcher:addListener(self, 13307, self.onSearchReply)--搜索玩家
	EventDispatcher:addListener(self, 13308, self.onGetBuyHitTimeReply)--购买教育次数
	EventDispatcher:addListener(self, 13309, self.onRefreshPrissonReply)--犯人列表刷新
end

function This:removeEventListener()
	EventDispatcher:removeListener(self,13300)--Official信息
	EventDispatcher:removeListener(self,13301)--创立/修改国号
	EventDispatcher:removeListener(self,13302)--册封/罢免
	EventDispatcher:removeListener(self,13303)--天子赏赐
	EventDispatcher:removeListener(self,13304)--领取奖励
	EventDispatcher:removeListener(self,13305)--关押
	EventDispatcher:removeListener(self,13306)--教育
	EventDispatcher:removeListener(self,13307)--搜索玩家
	EventDispatcher:removeListener(self,13308)--购买教育次数
	EventDispatcher:removeListener(self,13309)--犯人列表刷新
end

function This:addObserver(observer)
	for i , o in pairs(self.m_observers) do
		if o == observer then
			return 
		end
	end
	table.insert(self.m_observers,observer)
end

function This:removeObserver(observer)
	for i , o in pairs(self.m_observers) do
		if o == observer then
			table.remove(self.m_observers,i)
			return
		end
	end
end

function This:notifyObservers(funcName,...)
	local tmp = {}
	for i, observer in pairs(self.m_observers) do
		tmp[i] = observer
	end

	for i , observer in pairs(tmp) do
		if observer[funcName] then
			observer[funcName](observer,...)
		end
	end
end
----------------------------------------------------------------------

function This:setPalyerActInfo(key, value,fileName)
	local luaFileName = fileName
	-- local GamePlayer = require("Player.GamePlayer")
	local GameUtil = require("Util.GameUtil")
    local info = cc.FileUtils:loadLuaFile(luaFileName) or {}
    local id = GameUtil:int64ToString(GamePlayer:getPlayerID())
    local actinfo = info[id]
    if not actinfo then
    	actinfo = {}
    	info[id] = actinfo
    end
	actinfo[key] = value
    cc.FileUtils:saveToLua(info,luaFileName)
end

function This:getPalyerActInfo(key, defaultValue,fileName)
	local luaFileName = fileName
    local info = cc.FileUtils:loadLuaFile(luaFileName)
    if not info then
    	return defaultValue
    end
	-- local GamePlayer = require("Player.GamePlayer")
	local GameUtil = require("Util.GameUtil")
    local id = GameUtil:int64ToString(GamePlayer:getPlayerID())
    local actinfo = info[id]
    if not actinfo then
    	return defaultValue
    end

    local value = actinfo[key]
    if value ~= nil then
    	return value
    else
    	return defaultValue
    end
end

function This:showEditPanel()
    local canOpen = false

    local countryInfor = self:getCountryInfor()
    if not countryInfor.time or countryInfor.time ==0 then
    	return false
    end
	local times = countryInfor.contry_code_info.effective_time
	-- local serTime = GamePlayer:getServerTime()
	if times~=0 then
	    local value = self:getPalyerActInfo(times,canOpen,OfficialManagerFileName)
	    local isEffect = self:checkCountryNameIsEffect(times)
	    -- local offsetTime = 86400 --1天
	    -- if serTime>times and (serTime-times)< offsetTime then
	    -- 	isEffect = true
	    -- end
	    if not value and isEffect then
	    	canOpen = true
	    	self:setPalyerActInfo(times,canOpen,OfficialManagerFileName)
	    end
	end
    
	if canOpen then
        PopDialogManager:addPopDialog({
            bCheck = true,
            name = "Official.OfficialEdictPanel", 
            arg = {types = OfficialType.kcreateInfor}, 
            level = DialogLevel.kThrLevel
        })
        return true
	end
	canOpen = false
	times = countryInfor.time
	if times~=0 then
		local value = self:getPalyerActInfo(times,canOpen,OfficialManagerFileName)
		if not value then
			canOpen = true
			self:setPalyerActInfo(times,canOpen,OfficialManagerFileName)
		end
	end
	if canOpen then
        PopDialogManager:addPopDialog({
            bCheck = true,
            name = "Official.OfficialNewEmperor", 
            arg = {}, 
            level = DialogLevel.kThrLevel
        })
        return true
	end
    return false
end
-----------------------------------------------------------------------
	
-- function This:onRefreshPrissonRequest()
-- 	Socket:sendAndLock(13309)--犯人列表刷新
-- end

function This:onRefreshPrissonReply( msg )
	if msg then
        local perisoner_list = msg.perisoner_list or {}
        self.m_prisonList = self:setList(perisoner_list)
        self:notifyObservers("onRefreshPrisson")
	else
		g_scene:handleErrorCode("")
	end
end
function This:onGetBuyHitTimeRequest(id)
	Socket:send(13308,{id = id})--购买教育次数
end

function This:onGetBuyHitTimeReply( msg )
    -- if msg.err_code == 0 then
    --     self.m_leftHitCount = msg.left_hit_times or 0 --剩余教育次数
    --     self:notifyObservers("onGetBuyHitTime")
    -- else
    --     g_scene:handleErrorCode(msg.err_code)
    -- end
end
-- op_type 搜索类型 册封 封赏 收监
function This:onSearchRequest(op_type,name)
	local function getChineseString(str,chineseLimit)
	     if str and chineseLimit then
	         local GameUtil = require("Util.GameUtil")
	         local str2 = GameUtil:filterSpecChars(str)
	         local length = string.utf8Len(str)
	         local length2  = string.utf8Len(str2)
	         if length == length2 and length2 <=chineseLimit and length2>0 then
	             return true
	         end
	     end
	     return false
	end
	local nameLength = string.len(name)
	if nameLength>0 then
		if getChineseString(name,7) then
			Socket:sendAndLock(13307,{name = name,op_type = op_type})--搜索玩家
		else
			g_scene:showTips(Serialize["tip_2_c"])
		end
	elseif nameLength ==0 then
		g_scene:showTips(Serialize["tip_5_c"])
	end
end

function This:onSearchReply( msg )
    if msg.err_code == 0 then
        local opType = msg.op_type
        local searchResult = msg.member
        if searchResult then
        	self:notifyObservers("onSearchPlayer",searchResult,opType)
        end
    else
		self:notifyObservers("onSearchPlayer")
        g_scene:handleErrorCode(msg.err_code)
    end
end
function This:onHitPrisonRequest(id)
	Socket:sendAndLock(13306,{id = id})--教育
end

function This:onHitPrisonReply( msg )
    if msg.err_code == 0 then
        -- print(msg)
        local prisonId = msg.id or 0
        local reward_list = msg.reward_list or {}
        self.m_hitCount = msg.hit_times or 0 --今日累计教育次数
		self.m_leftHitCount = msg.left_hit_times or 0 --剩余教育次数

		self:notifyObservers("onHitPrison",prisonId)
		EventDispatcher:dispatcher("official_change")		
        g_scene:showReward(reward_list)
    else
        g_scene:handleErrorCode(msg.err_code)
    end
end

function This:onModifyPrisonRequest(id,playerUid)
	Socket:sendAndLock(13305,{id = id,role_id = playerUid})--关押
end

function This:onModifyPrisonReply( msg )
    if msg.err_code == 0 then
    	local prisoner = msg.prisoner or {}
        self:modifyPrison(prisoner)
        self:notifyObservers("onModifyPrison")
    else
        g_scene:handleErrorCode(msg.err_code)
    end
end
-- op_type 4宫俸 6朝拜 typeId 1皇帝 8文 9武
function This:onGetRewardRequest(op_type,typeId)
	Socket:sendAndLock(13304,{op_type = op_type,type_id = typeId })--领取奖励
end

function This:onGetRewardReply( msg )
    if msg.err_code == 0 then
		local op_type = msg.op_type
		local type_id = msg.type_id
        local times = msg.left_times or 0
        local reward_list = msg.reward_list or {}
        if op_type == OfficialSearchType.kType4 then
    		self.m_salaryCount = times --今日剩余领取官俸次数
        -- elseif op_type == OfficialSearchType.kType5 then
		-- 	self.m_bowCount = times --今日剩余作揖次数
        elseif op_type == OfficialSearchType.kType6 then
			self.m_bowCount[type_id] = times --今日剩余朝拜次数
        end
        g_scene:showReward(reward_list)
		self:notifyObservers("onGetReward",op_type)
		EventDispatcher:dispatcher("official_change")
    else
        g_scene:handleErrorCode(msg.err_code)
    end
end

function This:onGetGiftRequest(gift_id,playerUid,playerName)
	Socket:sendAndLock(13303,{gift_id = gift_id,role_id =playerUid,name = playerName})--天子赏赐
end

function This:onGetGiftReply( msg )
    if msg.err_code == 0 then
    	local official_list = msg.member_list or {}
        self:setOfficialList(official_list)
        local rewardInfo = {gift_list =msg.gift_list,
							record_list = msg.record_list}
        self.m_countryInfor.reward_info = rewardInfo --天子赏赐
        self:notifyObservers("onGetGift")
    else
        g_scene:handleErrorCode(msg.err_code)
    end
end
-- op_type 1册封 2罢免 3禅让 (2、3不用发official_id)
function This:onModifyOfficialRequest(op_type,playerUid,officialId)
	Socket:sendAndLock(13302,{op_type = op_type,role_id = playerUid,official_id =officialId})--册封/罢免
end

function This:onModifyOfficialReply( msg )
    if msg.err_code == 0 then
        local op_type = msg.op_type
        local playerId = msg.role_id
        -- local officialData = msg.member
        -- if op_type ==1 then
        -- 	self.m_officialList[playerId]= officialData
        -- elseif op_type ==2 then
        -- 	self.m_officialList[playerId] = nil
        -- end
        local official_list = msg.member_list or {}
        self:setOfficialList(official_list)
        local countryInfor = msg.emperor_info or {}
        self.m_countryInfor = countryInfor

        self:notifyObservers("onModifyOfficial",op_type)
    else
        g_scene:handleErrorCode(msg.err_code)
    end
end

function This:onModifyCountryNameRequest(countryName)
	Socket:sendAndLock(13301,{country_code=countryName})--创立/修改国号
end

function This:onModifyCountryNameReply( msg )
    if msg.err_code == 0 then
        if self.m_countryInfor.contry_code_info then
        	self.m_countryInfor.contry_code_info = msg.country_code_info or {}
        end
        -- self:notifyObservers("onModifyCountryName")
    else
        g_scene:handleErrorCode(msg.err_code)
    end
end
	
function This:onGetOfficialInfoRequest()
	Socket:sendAndLock(13300)--Official信息
end

--修改罪名玩家列表
function This:modifyPrison(prisonData)
	if prisonData and prisonData.id then
		local prisonId = prisonData.id
		self.m_prisonList[prisonId] = prisonData
	end
end

-- 官职列表(包含军团成员)
function This:setOfficialList(officialList)
	if officialList then
        self.m_officialList =  officialList
		local powerInfor = self:getPowerWithPlayerId()
		self:modifyMyPower(powerInfor.id)
	end
end

function This:onGetOfficialInfoReply( msg )

	if msg.err_code == 0 then
--        print(mySerialize(msg),"onGetOfficialInfoReply")
--        print(table.tostring(msg),"onGetOfficialInfoReply2")
        local countryInfor = msg.emperor_info or {}
        local official_list = msg.member_list or {}
        local perisoner_list = msg.perisoner_list or {}
      
        self.m_countryInfor = countryInfor
        self.m_prisonList = self:setList(perisoner_list)
        self:setOfficialList(official_list)
        self.m_salaryCount = msg.salary_times or 0 --今日剩余领取官俸次数
		-- self.m_workCount = msg.worship_times2 or 0 --今日剩余朝拜次数
		for _,data in ipairs(msg.worship_times) do
			self.m_bowCount[data.type_id] = data.worship_times or 0--今日剩余跪拜次数列表
		end
		-- self.m_bowCount = msg.worship_times or 0 --今日剩余跪拜次数列表
		self.m_hitCount = msg.hit_times or 0 --今日累计教育次数
		self.m_leftHitCount = msg.left_hit_times or 0 --剩余教育次数
		local rewardInfo = {gift_list =msg.gift_list,
							record_list = msg.record_list}
        self.m_countryInfor.reward_info = rewardInfo --天子赏赐
        self:notifyObservers("onGetOfficialInfo")
		EventDispatcher:dispatcher("official_change")
    else
        g_scene:handleErrorCode(msg.err_code)
    end
end

