-- @Author: zheng
-- @Date:   2018-10-09 11:30:31
-- @Last Modified by:   zheng
-- @Last Modified time: 2019-11-12 14:27:21
-- @File Name: OfficialPanel.lua

local This , super = class(...,"Dialog")
local OfficialManager = require("Official.OfficialManager")
local GameUtil = require("Util.GameUtil")
local RulesPanel = require("UI.RulesPanel")
local EntrantManager = require("LegionEntrant.EntrantManager")

This.fileName = "MenuScene/NodeUI/OfficialPalace.csb"

local btnTypes ={
    kType1 =1,--创立国号
    kType2 =2,--每日官俸
    kType3 =3,--皇帝朝拜
    kType4 =4,--金銮册封
    kType5 =5,--天子赏赐
    kType6 =6,--监牢
}
local strList={
	tip1 = Serialize["Official_TipStr_9"],
	tip2 = Serialize["Official_TipStr_10"],
}
function This:initNode(info)
	self.m_csNode = cc.Node:createFromCSFile(This.fileName)
    self.m_csNode:setToCenter()
    self:addChild(self.m_csNode)
	self:getData()
	self.m_csNode:fitScreen(1)
	local isOpenKing = EntrantManager:getEntrantOpenState(GameMapType.kEmperorMap)
	self.m_csNode.huangdi:setVisible(isOpenKing)

	local isOpenLegion = EntrantManager:getEntrantOpenState(GameMapType.kLegionMap)
	self.m_csNode.juntuan:setVisible(isOpenLegion)

    OfficialManager:onGetOfficialInfoRequest()
end

function This:initTouchEvent()
	local csNode =  self.m_csNode

    csNode.closebutton:setTouch({
		onEnded =function()
        self:close()
    end,
		isDynamic = true
	})

    for btnType=1,btnTypes.kType6 do
   		local item1 = csNode["item"..btnType]
   		local btn = item1.bg
   		if item1 and btn then
	   		item1:setTouch({
		onEnded =function()
				self:btnCallBack(btnType)
			end,btn,
			isDynamic = true
		})
   		end
    end

    csNode.huangdi.huangdi:setTouch({
		onEnded =function()
	        g_scene:openDialog("UI.RulesPanel", {rulesType = RulesType.kKing})
	    end,
		isDynamic = true
	})

    csNode.juntuan.juntuan:setTouch({
		onEnded =function()
	        g_scene:openDialog("UI.RulesPanel", {rulesType = RulesType.kLegion})
	    end,
		isDynamic = true
	})
end

function This:refreshRed()
	GameUtil:refreshRedDot(self.m_csNode.item2,OfficialManager:isCanSalary(),{5,40},0.8)
	GameUtil:refreshRedDot(self.m_csNode.item3,OfficialManager:isCanWork(),{5,40},0.8)
	GameUtil:refreshRedDot(self.m_csNode.item6,OfficialManager:getIsCanHit() and OfficialManager:isHavePrison(),{5,40},0.8)
end

function This:btnCallBack(btnIndex)
	local isEmperor = OfficialManager:myIsEmperor()
	if btnIndex == btnTypes.kType1 then--创立国号
		if isEmperor then
			 local infor ={types = OfficialType.kcreate}
			 g_scene:openDialog("Official.OfficialEdictPanel",infor)	
		else
			g_scene:showTips(strList.tip1)
		end
	elseif btnIndex == btnTypes.kType2 then--每日官俸
		g_scene:openDialog("Official.OfficialSalaryPanel")	
	elseif btnIndex == btnTypes.kType3 then--皇帝朝拜
		g_scene:openDialog("Official.OfficialWorshipPanel")	
	elseif btnIndex == btnTypes.kType4 then--金銮册封
		g_scene:openDialog("Official.OfficialConferPanel")	
	elseif btnIndex == btnTypes.kType5 then--天子赏赐
		-- if isEmperor then 
			local infor ={types = OfficialSearchType.kType7}
			g_scene:openDialog("Official.OfficialAwardPanel",infor)	
		-- else
		-- 	g_scene:showTips(strList.tip2)
		-- end
	elseif btnIndex == btnTypes.kType6 then--监牢
		g_scene:openDialog("Official.OfficialPrisonPanel")	
	end
end

function This:getData()
	self.m_data = OfficialManager:getPowerData()
end

function This:onEnter()
    super.onEnter(self)
	-- FamilyManager:addObserver(self)
	OfficialManager:addObserver(self)
end

function This:onExit()
    super.onExit(self)
	-- FamilyManager:removeObserver(self)
	OfficialManager:removeObserver(self)
end

function This:onGetOfficialInfo()
	self:refreshRed()
end

function This:onGetReward()
	self:refreshRed()	
end

function This:onHitPrison()
	self:refreshRed()		
end

function This:onGetBuyHitTime()
	self:refreshRed()			
end