-- @Author: zheng
-- @Date:   2018-10-08 10:07:29
-- @Last Modified by:   zheng
-- @Last Modified time: 2018-11-09 17:30:50
-- @File Name: OfficialPersonPanel.lua

local This , super = class(...,"Dialog")
local OfficialManager = require("Official.OfficialManager")
local GameUtil = require("Util.GameUtil")

-- This.fileName = "MenuScene/NodeUI/Dialog.csb"
local fileNames ={
	kType1 = "MenuScene/NodeUI/OfficialPower.csb",--册封
	kType8 = "MenuScene/NodeUI/OfficialPrisonerPunish.csb",--收监
}
local strList={
	btnTitle2 = Serialize["Official_AwardItem_4_c"],
	btnTitle1 = Serialize["Official_PersonPanel_1"],
	title1 = Serialize["Official_PersonPanel_2"],
	title2 = Serialize["Official_PersonPanel_3"],
}
function This:initNode(info)

	local fileName = fileNames.kType1
    if info then
       -- self.m_family = info.family
       local panelType = info.types
       local memberData = info.member
       	self.m_panelType = panelType
       	self.m_memberData = memberData --囚犯或者官职的数据
       	local titelName = strList.title1
       if panelType == OfficialSearchType.kType8 then
       		fileName = fileNames.kType8
       		titelName = strList.title2
       end
   		self.m_csNode = cc.Node:createFromCSFile(fileName)
	    self.m_csNode:setToCenter()
	    self:addChild(self.m_csNode)
        self.m_csNode.title:setString(titelName)
		if info.officialId then
       		self.m_officialId = info.officialId
       		local btn = self.m_csNode.button2
       		if OfficialManager:myIsEmperor() then
	       		if self:isType(OfficialSearchType.kType1) then
		   			local isEmperor = OfficialManager:myIsEmperor(self.m_officialId)
		   			local btnTitle = strList.btnTitle1
		   			if isEmperor then
		   				btnTitle = strList.btnTitle2
		   			end
		   			btn.text1:setString(btnTitle)
		   		end
       		else
       			btn:setVisible(false)
       		end
       end
       if info.prisonId then
       		self.m_prisonId = info.prisonId
       end

    end
    self:refresh()
end

-- function This:initData( queue, dialog )
--     self.m_activity = queue
--     self.m_dialog = dialog
-- end
function This:initTouchEvent()
   self.m_csNode.closebutton.close:setTouchEnded(function()
		self:close()
	end)
   self.m_csNode.button1:setTouchEnded(function()
   		local memberData = self.m_memberData
   		if memberData then
   			local roleId = memberData.role_id
		 	g_scene:openDialog("Player.RoleInfoPanel",{id = roleId})
   		end
   	end)
   if self:isType(OfficialSearchType.kType1) then
	   self.m_csNode.button2:setTouchEnded(function()
	   		local isEmperor = OfficialManager:myIsEmperor(self.m_officialId)
	   		if isEmperor then
	   			local infor = {officialId = self.m_officialId,types = OfficialSearchType.kType1}
	   			g_scene:openDialog("Official.OfficialAwardPanel",infor)
	   			
	   		else
	   			local memberData = self.m_memberData
	   			local leftTime = memberData.times
	   			if leftTime then
	   				local function requesServer()
	   					local playerUid = memberData.role_id
			   			OfficialManager:onModifyOfficialRequest(OfficialSearchType.kType2,playerUid)
	   				end
	   				if leftTime == 0 then
	   						g_scene:openDialog("Stage.ChallengeConfirmPanel", {
					           simple = Serialize["Official_TipStr_13"], 
					           okHandler = function()
					                requesServer()
					           end 
					       })
		   				else
			   			requesServer()
	   				end
	   			end
	   		end
	   		self:close()
		end)
	end
end

function This:refresh()
	self:getData()
	self:refreshCommon()
	if self:isType(OfficialSearchType.kType1) then
		self:refreshOfficial()
	elseif self:isType(OfficialSearchType.kType8) then
		self:refreshPrison()
	end
end

function This:refreshCommon()
	local node = self.m_csNode
	local memberData = self.m_memberData
	local icon = node.zhiweiicon.icon
	local iconVisible = false
	if memberData.role_id ~=0 then
		iconVisible = true
		GameUtil:setPlayerIconNodeImage(icon, memberData.icon)
	end
	icon:setVisible(iconVisible)
	node.kongque:setString(memberData.name)

end

function This:refreshOfficial()
	local data = self.m_data
	local node = self.m_csNode
	local officialId = self.m_officialId
	local officialData = data:getOfficialConfig(officialId)
	if officialData then
		data:refreshOfficialPawerAttr(node.items,officialId)	
		data:refreshOfficialRewards(node.scrollView,298,80,officialId)
		local zhiWeiLabel = node.zhiwei
		if officialId<=OfficialType.kType3 then
			zhiWeiLabel = node.gaozhiwei
		end
		zhiWeiLabel:setVisible(true)
		zhiWeiLabel:setString(officialData.name)
	end
end

function This:refreshPrison()
	local data = self.m_data
	local node = self.m_csNode
	local prisonId = self.m_prisonId
	local prisonData = data:getPrisonConfig(prisonId)
	if prisonData then
		node.zhiwei:setString(prisonData.accusation)
	end
	--犯人惩罚需要再这里补充
	data:refreshPrisonRewards(node.scrollView,256,176,prisonId)
end

function This:isType(checkType)
	local res = false
	if self.m_panelType == checkType then
		res =true
	end
	return res
end

-- function This:getmemeberData()
-- 	local res = false
-- 	if self.m_memberData then
		
-- 	end
-- 	return self.m_memberData ,
-- end

function This:getData()
	self.m_data = OfficialManager:getPowerData()
end

-- function This:onEnter()
--     super.onEnter(self)
--     -- FamilyManager:addObserver(self)
-- end

-- function This:onExit()
--     super.onExit(self)
--     -- FamilyManager:removeObserver(self)
-- end