-- @Author: zheng
-- @Date:   2018-09-25 14:38:56
-- @Last Modified by:   zheng
-- @Last Modified time: 2018-11-13 16:41:37
-- @File Name: OfficialPrisonItemView.lua

local OfficialManager = require("Official.OfficialManager")

local GameUtil = require("Util.GameUtil")
local GamePlayer = require("Player.GamePlayer")
local This , super = class(...,"NodeUI")

This.fileName = "MenuScene/NodeUI/OfficialPrisoner.csb"
local strList={
	cost1 = Serialize["Official_TipStr_11"],
	tip = Serialize["Official_TipStr_12"],
}
function This:initNode(info)
    if info then
    	self.m_prisonId = info.types
    end
    self.speek:setVisible(false)
    self.m_talkTables = {}
    self:getData()
    self:refresh()
end

-- function This:initData( queue, dialog )
--     self.m_activity = queue
--     self.m_dialog = dialog
-- end

function This:initTouchEvent()
   self.jiahao:setTouchEnded(function()
   		if OfficialManager:myIsEmperor() then
			local prisonId = self.m_prisonId
			local infor = {types = prisonId}
			g_scene:openDialog("Official.OfficialPrisonSearchPanel",infor)
		else
			g_scene:showTips(strList.tip)
		end
	end)
   self.prison_node.fanrenicon:setTouchEnded(function()
   		local prisonId = self.m_prisonId
		local data = self.m_data
		local hitCost,reachLimit = data:getHitCost()
		if reachLimit then
			g_scene:showTips(Serialize["power_buy_times_limit"])
			return
		end
		if not OfficialManager:getIsCanHit() and hitCost>0 then
			local panel = g_scene:openDialog("UI.CostConfirmPanel", {cost = hitCost, desc = strList.cost1,notips = "OfficialManager"..hitCost,
			    okHandler = function()
			    OfficialManager:onGetBuyHitTimeRequest(prisonId)
			end})
			return
		else
			OfficialManager:onHitPrisonRequest(prisonId)
		end
	end)
   self.prison_node.wenhao:setTouchEnded(function()
		local prisonData = self:getPrisonData()
		if prisonData then
			local prisonId = self.m_prisonId
			local infor = {types = OfficialSearchType.kType8,prisonId= prisonId,member = prisonData}
			g_scene:openDialog("Official.OfficialPersonPanel",infor)
		end
	end)
end

function This:refresh()
	local data = self.m_data
	local prisonId = self.m_prisonId
	local prisonData = self:getPrisonData()
	local jiaHaoVisible = true
	if prisonData then
		jiaHaoVisible = false
		self:updateTime()
		local prisonNode = self.prison_node
		local junTuanVisible = false
		if prisonData.group_name ~= "" then
			junTuanVisible = true
			prisonNode.juntuannode.juntuanname:setString(prisonData.group_name)
		end
		prisonNode.juntuannode:setVisible(junTuanVisible)
		prisonNode.name:setString(prisonData.name)
	end
	self.prison_node:setVisible(not jiaHaoVisible)
	self.jiahao:setVisible(jiaHaoVisible)
	local prisonConfig = data:getPrisonConfig(prisonId)
	if prisonConfig then
--		self.zuiming:setString(prisonConfig.accusation)
		local str = string.format("<New1>%s：<New8>%s",prisonConfig.accusation,prisonConfig.desc)
		self.zuiming:setStringWithColor(str,338*self.zuiming:getScaleX())
	end
end

function This:getPrisonData()
	local prisonId = self.m_prisonId
	local prisonData = OfficialManager:getPrisonWithPrisonId(prisonId)
	if prisonData.id ~=0 then
		return prisonData
	end
	return false
end

function This:showTip(node)
	if not self:getPrisonData() then--教育的过程中犯人释放了
		self.m_talkTables ={}
		return
	end
	local data = self.m_data
	local talkTables = self.m_talkTables
	if not node.isTalk then
		local nodeVisible = false
		if #talkTables>0 then
			nodeVisible = true
			local text = node.text
			local textScaleY = text:getScaleY()
			-- local textScaleX = text:getScaleX()
			local talkTable = table.remove(talkTables, 1)
			local talkTxt = data:getRandTalk(talkTable)
			local bg = node.bg
			-- local x,y = bg:getPosition()
			local w,h = bg:getContentSize()
			local lw,lh = text:getContentSize()
			-- w =  252
			text:setString(talkTxt,330)
			lw,lh = text:getContentSize()
			bg:setContentSize(w,lh*textScaleY+60)
			node:runAction(cc.Sequence(cc.DelayTime(OfficialType.ktalkTime), cc.CallFunc(function ()
				node.isTalk = false
				node:setVisible(node.isTalk)
			end)))
			node.isTalk = nodeVisible
			self:createEffect()
		end
		node:setVisible(nodeVisible)
	end
end

function This:createEffect()
    local function createAnim( parent,anmStr )
        local GameUtil = require("Util.GameUtil")
        local effect1 = GameUtil:createEffect(anmStr)
        parent:addChild(effect1)
        return effect1
    end
    cc.Audio:playEffect("Slap.mp3")
    local node = self.prison_node.hit_anim
    node:removeAllChildren()
    local effects = createAnim( node,"Xuanyun" )
end

function This:updateTime()
	local prisonData = self:getPrisonData()
	if prisonData then
		local data = self.m_data
		local serTime = GamePlayer:getServerTime()
		local leftTime = prisonData.release_time- serTime
		if serTime>0 then
			self.prison_node.time:setString( GameUtil:formatDTime(Serialize["D_H_M_S"], leftTime))
		end
		local hitCost,reachLimit,freeTime = data:getHitCost()
		local isCanHit,leftHitTiem = OfficialManager:getIsCanHit()
		self.prison_node.hit_node.hittimes:setString(string.format("%d/%d",leftHitTiem,freeTime))
	else
		self:refresh()--教育的过程中犯人释放了	
	end
end

function This:updateWithPrisonId(prisonId)
	if prisonId then
		self.m_prisonId = prisonId
		-- if self:getPrisonData() then
			self:refresh()
		-- else
			
		-- end
	end
end

function This:updateTip(prisonId)
	local data = self.m_data
	if prisonId == self.m_prisonId then
		local talkTable = data:getPrisonTalks(prisonId)
		table.insert(self.m_talkTables,talkTable)
		self:showTip(self.speek)
	end
end

function This:getData()
	self.m_data = OfficialManager:getPowerData()
end

