-- @Author: zheng
-- @Date:   2018-09-25 14:38:56
-- @Last Modified by:   zheng
-- @Last Modified time: 2018-10-22 14:34:12
-- @File Name: OfficialPrisonPanel.lua

local OfficialManager = require("Official.OfficialManager")
local OfficialPrisonItemView = require("Official.OfficialPrisonItemView")
local This , super = class(...,"Dialog")

This.fileName = "MenuScene/NodeUI/OfficialPrison.csb"
-- local strList={
-- 	title2 = Serialize[62182]
-- }
local OfficialPrisonTabName = 
{
    ktep1 = 1,--天牢
    ktep2 = 2,--地牢
    ktep3 = 3,--班房
}
local prisonIdTables ={
	[OfficialPrisonTabName.ktep1] = {1,2,3},--天牢
	[OfficialPrisonTabName.ktep2] = {4,5,6},--地牢
	[OfficialPrisonTabName.ktep3] = {7,8,9},--班房
}
function This:initNode(info)
    self.m_csNode = cc.Node:createFromCSFile(This.fileName)
    self.m_csNode:setToCenter()
    self:addChild(self.m_csNode)
    self:getData()
    self.m_escape = 0
	self.m_selectIndex = OfficialPrisonTabName.ktep1
	local prisonTabel = prisonIdTables[self.m_selectIndex]
    local prisonUi ={}
   	 for tabKey=1,OfficialPrisonTabName.ktep3 do
   	 	local item1 = self.m_csNode["fanren"..tabKey]
   	 	local prisonItem = OfficialPrisonItemView:create({types= prisonTabel[tabKey]})
   	 	item1:addChild(prisonItem)
   	 	prisonUi[tabKey] =prisonItem
   	 end
    self.m_prisonUi = prisonUi
   for tabKey=1,OfficialPrisonTabName.ktep1 do
		local item = self.m_csNode["tep"..tabKey]
		self:addTabButton(tabKey,item,function()
			if self.m_inited then
				self:lightTabButton(tabKey)
				self.m_selectIndex = tabKey
			end
			self:refresh(  )
	    end)
	end
	self:selectTabButton(self.m_selectIndex)
	self.m_inited = true
end

-- function This:initData( queue, dialog )
--     self.m_activity = queue
--     self.m_dialog = dialog
-- end
function This:initTouchEvent()
   self.m_csNode.closebutton.close:setTouchEnded(function()
		self:close()
	end)
end

function This:refresh()
	local selectIndex = self.m_selectIndex
	local prisonIds= prisonIdTables[selectIndex]
	for index,prisonId in ipairs(prisonIds) do
		local prisonUi = self.m_prisonUi[index]
		prisonUi:updateWithPrisonId(prisonId)
	end
end

function This:onEnter()
    super.onEnter(self)
    OfficialManager:addObserver(self)
end

function This:onExit()
    super.onExit(self)
    OfficialManager:removeObserver(self)
end

function This:getData()
	self.m_data = OfficialManager:getPowerData()
end

function This:update(dt)
    super.update(self,dt)
    self.m_escape = self.m_escape + dt
    if self.m_escape < 1 then
        return
    end
    self.m_escape = self.m_escape - 1
    
    for index,prisonUi in ipairs(self.m_prisonUi) do
		prisonUi:updateTime()
	end
end

function This:onHitPrison(prisonId)
	if prisonId and prisonId>0 then
		for index,prisonUi in ipairs(self.m_prisonUi) do
			prisonUi:updateTip(prisonId)
		end
	end
end

function This:onModifyPrison()
	self:refresh()
end