-- @Author: zheng
-- @Date:   2018-09-25 14:38:56
-- @Last Modified by:   zheng
-- @Last Modified time: 2018-10-23 15:01:04
-- @File Name: OfficialPrisonSearchPanel.lua

local OfficialManager = require("Official.OfficialManager")
local OfficialAwardItemView = require("Official.OfficialAwardItemView")

local GameUtil = require("Util.GameUtil")

local This , super = class(...,"Dialog")

This.fileName = "MenuScene/NodeUI/OfficialImprison.csb"
local strList={
	title2 = Serialize["Official_PrisonSearch_1"],
}
function This:initNode(info)
    self.m_csNode = cc.Node:createFromCSFile(This.fileName)
    self.m_csNode:setToCenter()
    self:addChild(self.m_csNode)
    self:getData()
    self.m_friendData = {}
    if info then
		local prisonType = info.types
		self.m_prisonType = prisonType
		local prisonData = self.m_data:getPrisonConfig(prisonType)
		if prisonData then
			self.m_csNode.text2:setStringWithColor(string.format(strList.title2,prisonData.type_name,prisonData.accusation))
		end
    end
end

-- function This:initData( queue, dialog )
--     self.m_activity = queue
--     self.m_dialog = dialog
-- end
function This:initTouchEvent()
   self.m_csNode.closebutton.close:setTouchEnded(function()
		self:close()
	end)
   self.m_csNode.button1:setTouchEnded(function()
		self:close()
	end)
   self.m_csNode.button2:setTouchEnded(function()
   		local playerUid = self.m_friendData.role_id
   		local prisonType = self.m_prisonType
   		local itemOfficialId = self.m_friendData.id
		if itemOfficialId and itemOfficialId~=0 then
			local tipStr = Serialize["Official_TipStr_2_c"]
			local itemIsEmperor = OfficialManager:myIsEmperor(itemOfficialId)
			if itemIsEmperor then
				tipStr = Serialize["Official_TipStr_5_c"]
			end
			g_scene:showTips(tipStr)
			return
		end
	   	if playerUid and prisonType then
   			OfficialManager:onModifyPrisonRequest(prisonType,playerUid)
	   	end
		self:close()
	end)
	self.m_csNode.button3:setTouchEnded(function()
		local str = self.m_csNode.editor:getString()
		-- if string.len(str) > 0 then
			OfficialManager:onSearchRequest(OfficialSearchType.kType8,str)
		-- end
	end)
end

function This:getFriendNode(friend)
	self.m_friendData = friend
	if self.m_searchNode then
		self.m_searchNode:updateInfor(friend)
	else
		self.m_searchNode = self:createItem(friend)
		self.m_csNode.hero:addChild(self.m_searchNode)
	end
end

function This:createItem(data)
	local node = OfficialAwardItemView:create({types = OfficialSearchType.kType8,data = data})
	return node
end

function This:refreshItems(friendList)
	
	if not friendList then
		g_scene:showTips(Serialize["friend_SearchPanel_1"])
		if self.m_searchNode then
			self.m_searchNode:updateInfor()
		end
	else
		-- self:getFriendNode(friendList[1])
		self:getFriendNode(friendList)
	end
end

function This:onEnter()
    super.onEnter(self)
    OfficialManager:addObserver(self)
end

function This:onExit()
    super.onExit(self)
    OfficialManager:removeObserver(self)
end

function This:getData()
	self.m_data = OfficialManager:getPowerData()
end

function This:onSearchPlayer(friendList,opType)
	-- if opType and opType == OfficialSearchType.kType8 then
		self:refreshItems(friendList)
	-- end
end