-- @Author: zheng
-- @Date:   2018-10-08 17:23:49
-- @Last Modified by:   zheng
-- @Last Modified time: 2018-11-03 15:15:24
-- @File Name: OfficialSalaryPanel.lua

local This , super = class(...,"Dialog")
local OfficialManager = require("Official.OfficialManager")

-- local OfficialPositionConfig = require("Metadatas.OfficialPositionConfig")

This.fileName = "MenuScene/NodeUI/OfficialSalary.csb"
local strList={
	title1 = Serialize["Official_SalaryPanel_1"],
    btnTitle1 = Serialize["Official_SalaryPanel_2"],
    btnTitle2 = Serialize["Official_SalaryPanel_3"],
}

function This:initNode(info)
	self.m_csNode = cc.Node:createFromCSFile(This.fileName)
    self.m_csNode:setToCenter()
    self:addChild(self.m_csNode)
    self:getData()
    self:refresh()
    -- if info then
    --    self.m_family = info.family
    -- end
end

-- function This:initData( queue, dialog )
--     self.m_activity = queue
--     self.m_dialog = dialog
-- end
function This:initTouchEvent()
    self.m_csNode.beijing.closebutton:setTouchEnded(function()
        self:close()
    end)
	self.m_csNode.button:setTouchEnded(function()
        if OfficialManager:isCanSalary() then
           OfficialManager:onGetRewardRequest(OfficialSearchType.kType4)
        end
    end)

end

function This:refresh()
	self:rerfreshScroolView()
	local data = self.m_data
    local node = self.m_csNode
    local btn = node.button
    local rewardBg = node.rewardBg
    if OfficialManager:myIsEmpty() then
        btn:setVisible(false)
    else
        btn:setVisible(true)
        local officialId = OfficialManager:getMyPower()
        data:refreshOfficialPawerAttr(node.items,officialId)
        -- local officialData = OfficialManager:getPowerWithPlayerId()
        local desc = data:getOfficialDesc()
        node.info:setString(desc,556)
        local name = data:getName()
        node.title2:setString(name)

        local titleName = strList.btnTitle1
        if OfficialManager:isCanSalary() then
            btn:clearShader()
        else
            btn:setGrayShader()
            titleName = strList.btnTitle2
        end
        btn.text:setString(titleName)
    end
    rewardBg:setVisible(btn:isVisible())
end

function This:rerfreshScroolView()
	local data = self.m_data

	local function getItem(  )
    	local node = cc.Node:createFromCSFile("MenuScene/NodeUI/OfficialSalaryList.csb")
--    	local x,y OfficialSalaryList= --node.bg:getContentSize()
    	node:setContentSize(330, 70)
        -- node:setAnchorPoint(0.5,1)
    	return node
    end
    local function updateItem(officialId,viewNode)
    	local officialData = data:getOfficialConfig(officialId)
    	if officialData then
    		data:refreshOfficialPawerAttr(viewNode.items,officialId)
    		viewNode.zhiwei:setString(officialData.name)
    	end
    end

    local scrollView = self.m_csNode.scrollView1
    local itemList = scrollView:getItemList()
    if itemList and #itemList>0 then
        return
    end
    local officialIds = data:getOfficialIds()
    for _,officialId in pairs(officialIds) do
    	local view = getItem()
    	updateItem(officialId,view)
        local w , h = view:getContentSize()
        -- if OfficialManager:myIsEmperor(officialId) then
        --     h = h+20
        --     view:setContentSize(w,h)
        -- end
        scrollView:pushBackCustomItem(view,w,h,0.5)
        -- view:setAnchorPoint(0,1)
    end

end

function This:getData()
    self.m_data = OfficialManager:getPowerData()
end

function This:onEnter()
    super.onEnter(self)
    OfficialManager:addObserver(self)
end

function This:onExit()
    super.onExit(self)
    OfficialManager:removeObserver(self)
end

function This:onGetReward()
    self:refresh()
end
