-- @Author: zheng
-- @Date:   2018-10-11 14:45:23
-- @Last Modified by:   zheng
-- @Last Modified time: 2019-11-12 14:39:34
-- @File Name: OfficialWorshipPanel.lua
local OfficialManager = require("Official.OfficialManager")
local GameUtil = require("Util.GameUtil")
local GamePlayer = require("Player.GamePlayer")

local officialList ={
    OfficialType.kType1,--皇帝
    OfficialType.kWuWang,
    OfficialType.kWenWang,
}
local talkType ={
  kInit =0,
  kHuangDi =1,
  kWuWang =2,
  kWenWang =3,
}
local This , super = class(...,"Dialog")

This.fileName = "MenuScene/NodeUI/OfficialPilgrimageEmperor.csb"

function This:initNode(info)
    local csNode = cc.Node:createFromCSFile(This.fileName)
    csNode:setToCenter()
    self:addChild(csNode)
    self.m_csNode = csNode
    self.m_csNode.bgditu:fitScreen()
    self.m_csNode.bg:fitScreenX()
    local nodeList = {}
    for index,_ in ipairs(officialList) do
        local node = csNode["item"..index]
        nodeList[index] = node
    end
    self.m_nodeList =nodeList
    
    self.m_talkTables = {{},{},{}}
    self:refresh()
    	 self:updateTipWithIndex(talkType.kInit)

    self:createEffectCharacter()
end

function This:initTouchEvent()
   self.m_csNode.close:setTouchEnded(function()
        self:close()
    end)
   local function requestTip()
   		if not OfficialManager:isHaveEmperor() then
   			g_scene:showTips(Serialize["Official_TipStr_14"])
   			return true
   		end
   		return false
   end

   local fficialList,groupList = OfficialManager:getAllPower()
   for index,item1 in ipairs(self.m_nodeList) do
        local btn = item1.button
        btn:setTouchEnded(function()
            if not OfficialManager:isCanWork(officialList[index]) then
                return
            end
            self:updateTipWithIndex(index)
            OfficialManager:onGetRewardRequest(OfficialSearchType.kType6,officialList[index])
        end)
   end
end

function This:retreshBtnState()
  for index,item1 in ipairs(self.m_nodeList) do
      local btn = item1.button
      local isCanWork = OfficialManager:isCanWork(officialList[index])
      if btn.isGray then
          isCanWork = false
      end
      self:btnGray(btn,not isCanWork)
  end
end

function This:refresh()
    self:getData()
    local normalName = "<New11>"..Serialize["Official_AwardPane_4_c"]
    local OfficialList,groupList = OfficialManager:getAllPower()
    for index, node in ipairs(self.m_nodeList) do
        if OfficialList[officialList[index]] and OfficialList[officialList[index]].role_id ~= 0 then
            local name = OfficialList[officialList[index]].name
            self.m_csNode["item"..index].name:setString(name)
        else
            self.m_csNode["item"..index].name:setStringWithColor(normalName)
        end
    end
    local function resetQinIcon(officialData,uiNode)
        local icon = nil
        if officialData and officialData.role_id~=0 then
            icon = officialData.icon
        end
        if uiNode then
            if icon then
                GameUtil:setPlayerFeltNodeResource(uiNode, icon)
            end
            uiNode:setVisible(icon)
        end
    end
    resetQinIcon(OfficialList[OfficialType.kWuWang],self.m_csNode["wuqin"])
    resetQinIcon(OfficialList[OfficialType.kWenWang],self.m_csNode["wenqin"])

	self:retreshBtnState()
end

function This:btnGray(btn,isGray)
	local gray = false
	if isGray then
		gray = true
	end
	if btn then
		if gray then
			btn:setGrayShader()
		else
			btn:clearShader()
		end
	end
end

function This:createEffectCharacter()
    local function createAnim( parent,anmStr )
        -- local GameUtil = require("Util.GameUtil")
        local skeletonNode = cc.SkeletonNode:createCharacter(anmStr)
        skeletonNode:scheduleUpdate()
        skeletonNode:playAnimation("animation", true)
        skeletonNode:setScale(0.75)
        skeletonNode:setPositionY(0)
        -- local effect1 = GameUtil:createEffectCharacter(anmStr,true)
        parent:addChild(skeletonNode)
        -- return effect1
    end
    local node = self.m_csNode.huangdianim
    node:removeAllChildren()
    createAnim(node,"HuangDi")
end

function This:onEnter()
    super.onEnter(self)
    OfficialManager:addObserver(self)
end

function This:onExit()
    super.onExit(self)
    OfficialManager:removeObserver(self)
end

function This:getData()
	self.m_data = OfficialManager:getPowerData()
end

function This:showTip(index)
	local data = self.m_data
	local talkTables = self.m_talkTables[index]
  local node = self.m_nodeList[index].speek
	if not node.isTalk then
		local nodeVisible = false
		if #talkTables>0 then
			nodeVisible = true
			local text = node.text
			local textScaleX = text:getScaleX()
			local talkTxt = table.remove(talkTables, 1)
			text:setString(talkTxt)
			local bg = node.bg
			-- local x,y = bg:getPosition()
			local w,h = bg:getContentSize()
			local lw,lh = text:getContentSize()
			bg:setContentSize(lw*textScaleX+50,h)
			-- bg:setCapInsets(x,y,lw*textScaleX+50,h*textScaleX)
			node:runAction(cc.Sequence(cc.DelayTime(OfficialType.ktalkTime), cc.CallFunc(function ()
				node.isTalk = false
				node:setVisible(node.isTalk)
			end)))
			node.isTalk = nodeVisible
		end
		node:setVisible(nodeVisible)
	end
end

function This:updateTipWithIndex(index)
	if not index then
		return
	end
  local data = self.m_data
  local temTalkIndex = index
  local talkTable = nil
  if index == talkType.kInit then
      temTalkIndex = 1
      local talks = data:getWorshipTalkWithOfficial(officialList[temTalkIndex])
      talkTable = talks[1]
  elseif index == talkType.kHuangDi then
      local talks = data:getWorshipTalkWithOfficial(officialList[temTalkIndex])
      talkTable = talks[2]
  elseif index == talkType.kWenWang then
      local talks = data:getWorshipTalkWithOfficial(officialList[temTalkIndex])
      talkTable = talks[1]
  elseif index == talkType.kWuWang then
      local talks = data:getWorshipTalkWithOfficial(officialList[temTalkIndex])
      talkTable = talks[1]
  end
	if talkTable then
    local talkStr =data:getRandTalk(talkTable)
		table.insert(self.m_talkTables[temTalkIndex],talkStr)
		self:showTip(temTalkIndex)
	end
end

function This:onGetReward(opType)
	local data = self.m_data
	if opType == OfficialSearchType.kType6 then--朝拜
        -- self:updateTipWithIndex(3)
        self:retreshBtnState()
	end
	self:refresh()
end
