-- @Author: ZYY
-- @Date:   2018-09-21 18:21:16
-- @Last Modified by: ZYY
-- @Last Modified time: 2018-09-28 11:50:54
-- @File Name: PeakContestBoxPanel.lua
-- @Desc: 
local This, super = class(...,"Dialog")
local TopArenaLegionRewardConfig = require("Metadatas.TopArenaLegionRewardConfig")
local TopArenaRewardConfig = require("Metadatas.TopArenaRewardConfig")
local PeakContestManager = require("PeakContest.PeakContestManager")
local ItemNode = require("UI.ItemNode")

function This:initNode()
    self.m_csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/PeakContestBox.csb")
    self.m_csNode:setToCenter()
	self:addChild(self.m_csNode)
	self.m_myRewardItemList = {}
	self.m_grounRewardItemList = {}
	self.m_csNode.scrollView1:setDirection("horizontal")
	self.m_csNode.scrollView1.m_direction = "right"
	self.m_csNode.scrollView2:setDirection("horizontal")
	self.m_csNode.scrollView2.m_direction = "right"
	self.data = PeakContestManager:getMyData()
	self:refresh()
end

function This:refresh()
	local roleRewardId = self.data.role_reward or 0
	local groupRewardId = self.data.group_reward or 0
	local myReward = TopArenaRewardConfig[#TopArenaRewardConfig].rewardlist
	local groupReward = TopArenaLegionRewardConfig[#TopArenaLegionRewardConfig].rewardlist
	for i , v in ipairs(TopArenaRewardConfig) do 
		if v.id == roleRewardId then 
			myReward = v.rewardlist
		end
	end
	for i , v in ipairs(TopArenaLegionRewardConfig) do 
		if v.id == groupRewardId then 
			groupReward = v.rewardlist
		end		
	end	

	if self.data.is_get_role_reward ~= 0 then 
		self.m_csNode.button1:setVisible(false)
		self.m_csNode.received1:setVisible(false)
		self.m_csNode.help1:setVisible(true)		
	-- elseif self.data.is_get_role_reward == 1 then 
	-- 	self.m_csNode.button1:setVisible(false)
	-- 	self.m_csNode.received1:setVisible(false)
	-- 	self.m_csNode.help1:setVisible(true)
	else
		self.m_csNode.button1:setVisible(true)
		self.m_csNode.received1:setVisible(false)
		self.m_csNode.help1:setVisible(false)
	end

	if self.data.is_get_group_reward ~= 0 then 
		self.m_csNode.button2:setVisible(false)
		self.m_csNode.received2:setVisible(false)
		self.m_csNode.help2:setVisible(true)		
	-- elseif self.data.is_get_group_reward == 1 then 
	-- 	self.m_csNode.button2:setVisible(false)
	-- 	self.m_csNode.received2:setVisible(true)
	-- 	self.m_csNode.help2:setVisible(false)
	else
		self.m_csNode.button2:setVisible(true)
		self.m_csNode.received2:setVisible(false)
		self.m_csNode.help2:setVisible(false)
	end
	local width, height = 90, 90
	for i , reward in ipairs(myReward) do 
		local item = self.m_myRewardItemList[i]
		if not item then 
			item = ItemNode:create(reward[1] ,reward[2])
			item:setScale(0.8)
			item:setAnchorPoint(0.5,0.5)
			self.m_csNode.scrollView1:pushBackCustomItem(item,width,height)
		else
			item:initItem(reward[1] ,reward[2])
		end
		self.m_myRewardItemList[i] = item
	end

	for i , reward in ipairs(groupReward) do 
		local item = self.m_grounRewardItemList[i]
		if not item then 
			item = ItemNode:create(reward[1] ,reward[2])
			item:setScale(0.8)
			item:setAnchorPoint(0.5,0.5)
			self.m_csNode.scrollView2:pushBackCustomItem(item,width,height)
		else
			item:initItem(reward[1] ,reward[2])
		end
		self.m_grounRewardItemList[i] = item
	end
end

function This:initTouchEvent()
	self.m_csNode.help1:setTouchEnded(function()
       	local roleRankID = self.data.rank_id or 0
	    if roleRankID == 0 then 
            g_scene:showTips(Serialize[62205])
	    elseif roleRankID <= 1000 then
	    	g_scene:showTips(Serialize[62206])
        else
            g_scene:showTips(Serialize[62207]..roleRankID - 1000 ..Serialize[62208])
        end
	end)

	self.m_csNode.help2:setTouchEnded(function()
		local groupNumOnRank = self.data.group_num_on_rank or 0
		if groupNumOnRank < 5 then
			g_scene:showTips(Serialize[62209])
		else
			g_scene:showTips(Serialize[62210])
		end
	end)

	self.m_csNode.button1:setTouchEnded(function()
		PeakContestManager:reqReceiveRoleReward()
	end)

	self.m_csNode.button2:setTouchEnded(function()
		PeakContestManager:reqReceiveGroupReward()
	end)

	self.m_csNode.close:setTouchEnded(function()
		self:close()
	end)
end

function This:updateBoxData()
	self.data = PeakContestManager:getMyData()
	self:refresh()
end

function This:onEnter()
	super.onEnter(self)
	PeakContestManager:addObserver(self)
	self:refresh()
end

function This:onExit()
	PeakContestManager:removeObserver(self)
	super.onExit(self)
end