-- @Author: Su
-- @Date:   2018-09-11 20:24:11
-- @Last Modified by: Su
-- @Last Modified time: 2018-11-29 16:44:29
-- @File Name: PeakContestChallengeBoxItem.lua
-- @Desc:

local This,super = class(...,"NodeView")
local PeakContestManager = require("PeakContest.PeakContestManager")
local ItemNode = require("UI.ItemNode")

This.fileName = "MenuScene/NodeUI/PeakContestChallengeBoxList.csb"


function This:initData(info)
    self.m_data = info
    self.m_state = info.state
end

function This:initNode(info)
    self.scrollview:setDirection("horizontal")
    self.scrollview:setSwallowTouch(false)
    self.scrollview:removeAllItems()
    for _, item in pairs(self.m_data.reward) do
        local itemView = ItemNode:create(item[1],item[2])
        local width, height = itemView:getContentSize()
        local x,y = itemView:getPosition()
        itemView:setAnchorPoint(0.5, 0.5)
        self.scrollview:pushNode(itemView, width, height,#self.m_data.reward)
    end
    self:refresh()
end


function This:refresh()
    self.number:setString(string.format( Serialize[62212],self.m_data.frequency))
    self.button:setVisible(self.m_state~=PeakContestChallengeBoxRewardState.kHasReceive)
    if self.m_state == PeakContestChallengeBoxRewardState.kUnReceive then
        self.button:setGrayShader()
    else
        self.button:clearShader()
    end
    self.yilingqu:setVisible(self.m_state==PeakContestChallengeBoxRewardState.kHasReceive)
end

function This:initTouchEvent()
    self.button:setTouch({
        isScale = false, 
        isDynamic = true, 
        onEnded =function()
        if self.m_state == PeakContestChallengeBoxRewardState.kCanReceive then
            PeakContestManager:reqReceiveFightReward(PeakContestChallengeBoxRewardType.kDay,self.m_data.id)
        else
            g_scene:showTips(Serialize[61984])
        end
    end})
end


function This:onEnter()
    super.onEnter(self)
    PeakContestManager:addObserver(self)
end

function This:onExit()
    super.onExit(self)
    PeakContestManager:removeObserver(self)
end

function This:updateBoxRewardState()
    local state = self.m_state
    self.m_state = PeakContestManager:getTaskState(self.m_data.id,PeakContestChallengeBoxRewardType.kDay)
    if state ~= self.m_state then
        self:refresh()
    end
end

---  工具函数
function This:getState()
    if self.m_state then
        return PeakContestManager:getTaskState(self.m_data.id,PeakContestChallengeBoxRewardType.kDay)
    else                                            --测试
        g_scene:showTips(Serialize[62213])
        return 1
    end
end

function This:getId()
    if self.m_data then
        return self.m_data.id
    else                                            --测试
        g_scene:showTips(Serialize[62214])
        return 1
    end
end