-- @Author: Su
-- @Date:   2018-09-11 20:24:11
-- @Last Modified by: Su
-- @Last Modified time: 2018-11-29 16:44:29
-- @File Name: PeakContestChallengeBoxReward.lua
-- @Desc: 

local This,super = class(...,"Dialog")
local PeakContestManager = require("PeakContest.PeakContestManager")
local ItemNode = require("UI.ItemNode") 
local WeeklyRewardConfig = require("Metadatas.WeeklyRewardConfig")


function This:initNode(info)
    self.m_csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/PeakContestChallengeBoxReward.csb")
    self.m_csNode:setToCenter()
    self:addChild(self.m_csNode)
    --local node = self.m_csNode.itemtipslist
    local node = self.m_csNode.scrollView
    node:setDirection("horizontal")
    node.m_direction = "right"
    for _,data in pairs(self.m_data.reward) do
        local itemView = ItemNode:create(data[1],data[2])
        itemView:setAnchorPoint(0.5,0.5)
        local w,h = itemView:getContentSize()
        node:pushBackCustomItem(itemView,w,h,1.5-(#self.m_data.reward-2)*0.5)
    end
    self:refresh()
end

function This:initData(info)
    self.m_data = self:getWeekData(info.key)
    self.m_state = PeakContestManager:getTaskState(self.m_data.id,PeakContestChallengeBoxRewardType.kWeek)
end

function This:refresh()
    local node = self.m_csNode
    node.title:setString(self.m_data.name)
    node.condition:setString(self.m_data.tips)
    node.condition:setVisible(self.m_state == PeakContestChallengeBoxRewardState.kUnReceive)
    node.lingqu:setVisible(self.m_state == PeakContestChallengeBoxRewardState.kCanReceive)
    node.yilingqu:setVisible(self.m_state == PeakContestChallengeBoxRewardState.kHasReceive)
end

function This:initTouchEvent()
    local csNode = self.m_csNode
    csNode.close:setTouchEnded(function ()
        self:close()
    end)
    csNode.lingqu:setTouchEnded(function ()
        PeakContestManager:reqReceiveFightReward(PeakContestChallengeBoxRewardType.kWeek,self.m_data.id)
    end)
end

function This:onEnter()
    super.onEnter(self)
    PeakContestManager:addObserver(self)
end

function This:onExit()
    super.onExit(self)
    PeakContestManager:removeObserver(self)
end

------------------- 工具函数 --------------------

function This:getWeekData(key)
    local res 
    for _,data in pairs(WeeklyRewardConfig) do
        if key == data.id then
            res = data
        end
    end
    return res or {}
end

function This:updateBoxRewardState()
    local state = self.m_state  
    self.m_state = PeakContestManager:getTaskState(self.m_data.id,PeakContestChallengeBoxRewardType.kWeek)
    if self.m_state ~= state then
        self:refresh()
    end
end