-- @Author: ZYY
-- @Date:   2018-09-14 11:35:42
-- @Last Modified by:   zheng
-- @Last Modified time: 2019-01-14 12:50:11
-- @File Name: PeakContestLookInfoPanel.lua
-- @Desc: 
local This, super = class(...,"Dialog")
local GameUtil = require("Util.GameUtil")
local PeakContestTeamItemView = require("PeakContest.PeakContestTeamItemView")
local TopArenaRankingConfig = require("Metadatas.TopArenaRankingConfig")  
local HeroManager = require("Hero.HeroManager")
local Hero = require("Hero.Hero")
local HeroConfig = require("Metadatas.HeroConfig")  

function This:initNode(data)
	self.data = data or {}
    self.m_csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/PeakContestLookInfo.csb")
    self.m_csNode:setToCenter()
	self:addChild(self.m_csNode)
	self.m_troopItemList = {}
	self:refresh()
end

function This:refresh()
	self.m_csNode.name:setString(self.data.name or "")
	self.m_csNode.power:setString(string.format(Serialize[62223],self.data.power or 0))
	self.m_csNode.level:setString(self.data.level or 0)
	local icon = self.m_csNode.pic.icon
	GameUtil:setPlayerIconNodeImage(icon, self.data.icon)
	GameUtil:setPlayerEffectNodeTo(icon, self.data.effect)

	if not self.data.group_name or self.data.group_name == "" then 
		self.m_csNode.family:setString(Serialize[62224])
	else
		self.m_csNode.family:setString(string.format(Serialize[62225],self.data.group_name))
	end
 	if self.data.max_rank_id <= 3 and self.data.max_rank_id > 0  then 
		self.m_csNode.top:setVisible(true)
		self.m_csNode.rank:setVisible(false)
		self.m_csNode.top:setImage(string.format("MenuScene/top%d.png",self.data.max_rank_id))
	else
		self.m_csNode.top:setVisible(false)
		self.m_csNode.rank:setVisible(true)
		self.m_csNode.rank:setString(self.data.max_rank_id)
	end
	self:updateTroopItem()
end

function This:updateTroopItem()
	local width = 70
	for i = 1 , 3 do 
		self.m_troopItemList[i] = self.m_troopItemList[i] or {}
		for j = 1 , 6 do 
			local function getHide()
				for _ , v in ipairs(TopArenaRankingConfig) do 
					if self.data.rank_id >= v.top and self.data.rank_id <= v.lowest then 
						for _ ,t in ipairs(v.pocket_formation) do 
							if i == t[1] then 
								return true
							end
						end
					end
				end
				return false
			end
			local hide = getHide()

			local item = self.m_troopItemList[i][j]
			local hero = nil
			local awake = nil
			if self.data["card_list" .. i] and self.data["card_list" .. i][j] then 
				if HeroConfig[self.data["card_list" .. i][j].card_type] then
					hero = Hero:create({
					heroId = self.data["card_list" .. i][j].card_type or 1000,
					starLv = self.data["card_list" .. i][j].star or 0
					})
					awake = self.data["card_list" .. i][j].awake or false
				end
			end
			if not item then 
				if hero then
					item = PeakContestTeamItemView:create(hero,nil,nil,awake)
					item:setPosition(width * (j - 3.5), 0)
					item:setScale(0.7)
					self.m_csNode["troop" .. i]:addChild(item)
				end
			else
				item:setModel(hero,nil,nil,awake)
				item:setHide(hide)
			end
			print('ZYY:PeakContestLookInfoPanel.lua [start:72] :data',tostring(hide))
			self.m_troopItemList[i][j] = item
		end
	end	
end

function This:initTouchEvent()
	self.m_csNode.close:setTouchEnded(function()
		self:close()
	end)
end

function This:onTouchMask()

end
