-- @Author: ZYY
-- @Date:   2018-09-12 16:24:24
-- @Last Modified by: ZYY
-- @Last Modified time: 2018-09-28 14:25:34
-- @File Name: PeakContestPlayerView.lua
-- @Desc: 
local This , super = class(...,"NodeUI")
local GameUtil = require("Util.GameUtil")
local PeakContestManager = require("PeakContest.PeakContestManager")
local GamePlayer = require("Player.GamePlayer")
local VipManager = require("Vip.VipManager")
local VipConfig = require("Metadatas.VipConfig")  
local TopArenaTimesConfig = require("Metadatas.TopArenaTimesConfig") 

This.fileName = "MenuScene/NodeUI/PeakContestItem.csb"

function This:initNode(data,myData)
	-- self.infonode.fighttext:setString(Serialize[62236])
	self:setData(data,myData)
end

function This:refresh()
	self.infonode.name:setString(self.m_name)
	self.infonode.ranknum:setString(self.m_rankId)
	self.infonode.fightnum:setString(self.m_power)
	self.infonode.level:setString(self.m_level)

	local icon = self.infonode.icon
	GameUtil:setPlayerIconNodeImage(icon, self.m_icon)
	GameUtil:setPlayerEffectNodeTo(icon, self.m_effect)
end

function This:onEnter()
	super.onEnter(self)
	self:refresh()
end

function This:onExit()
	super.onExit(self)
end

function This:initTouchEvent()
	self.infonode.challenge:setTouchEnded(function()
		if #self.myData.defened_lineup == 0 then 
			g_scene:showTips(Serialize[62237])
			return
		end
		local time = PeakContestManager:getChallengeCD()
		if time > 0 then 
			local cost = math.ceil(time/kCostClearChallengeCD)
			GamePlayer:costDiamond({
				cost = cost,
				okHandler = function()
					PeakContestManager:reqCleanChallengeCD()
				end,
				desc = Serialize["Arena_PlayerView_3"]
			})
		elseif self.myData.challenge_times > 0  then
			g_scene:openDialog("PeakContest.PeakContestDefenseFightPanel",{myData = self.myData,roleData = self.data})
		else
			if self.myData.challenge_times > 0 then
				g_scene:showTips(Serialize["Arena_ArenaPanel_2"])
				return
			end
			local buyTimes = self.myData.buy_times or 0
			local vipLevel = VipManager:getMaxMemberLevel() or 0
			local toparenaTimes = 0
			for i = 0 , vipLevel do 
				toparenaTimes = VipConfig[i].toparena_times + toparenaTimes
			end
			if buyTimes >= toparenaTimes then 
				if vipLevel == 3 then 
					g_scene:showTips(Serialize[62233])
				else
					local panel = g_scene:openDialog("UI.ConfirmPanel", {
							fileName = "MenuScene/NodeUI/MemberActivation.csb" , 
							text = Serialize["vip_priv_warming_arena_times"], 
							okBtnTxt = Serialize[62234],
							okHandler = function () g_scene:openDialog("Vip.VipPanel") end
					})				
				end
			else
				local cost = TopArenaTimesConfig[buyTimes + 1].reset_cost
				GamePlayer:costDiamond({
					cost = cost,
					okHandler = function()
						PeakContestManager:reqBuyChallenge()
					end,
					desc = Serialize["Arena_ArenaPanel_3"]
				})
			end
		end
	end)

	self.infonode.icon:setTouchEnded(function()
		g_scene:openDialog("PeakContest.PeakContestLookInfoPanel",self.data)
	end)
end

function This:setData(data,myData)
	data = data or {}
	self.m_roleId = data.role_id or 0
	self.m_rankId = data.rank_id or 0
	self.m_name = data.name or Serialize[62238]
	self.m_icon = data.icon or 0
	self.m_title = data.title or 0
	self.m_effect = data.effect or 0
	self.m_level = data.level or 0
	self.m_rankLevel = data.rank_level or 0
	self.m_power = data.power or 0
	self.m_groupId = data.group_id or 0
	self.m_groupName = data.group_name or Serialize[60243]
	self.m_cardList = {}
	self.data = data
	self.myData = myData
	for i = 1, 3 do 
		self.m_cardList[i] = data["card_list"..i] or {}
	end
	self:refresh()
end
