-- @Author: ZYY
-- @Date:   2018-09-18 17:46:26
-- @Last Modified by:   superm
-- @Last Modified time: 2019-01-02 21:34:02
-- @File Name: PeakContestRankingItemView.lua
-- @Desc: 
local This , super = class(...,"NodeUI")
local GameUtil = require("Util.GameUtil")
local GamePlayer = require("Player.GamePlayer")
This.fileName = "MenuScene/NodeUI/PeakContestRankingList.csb"

function This:initNode(...)
	self:setModel(...)
end

function This:refresh()
	if self.data.rank_id <= 3 then
		self.geren.top:setVisible(true)
		self.geren.rank:setVisible(false)
		self.geren.top:setImage(string.format("MenuScene/top%d.png",self.data.rank_id))
	else 
		self.geren.top:setVisible(false)
		self.geren.rank:setVisible(true)
		self.geren.rank:setString(self.data.rank_id)
	end
	self.geren.name:setString(self.data.name)
	self.geren.level:setString("LV." .. self.data.level)
	self.geren.power:setString(Serialize[62240].. self.data.power)
	local icon = self.geren.pic.icon
	GameUtil:setPlayerIconNodeImage(icon, self.data.icon)
	GameUtil:setPlayerEffectNodeTo(icon, self.data.effect)
	self.selectBg:setVisible(GamePlayer:getPlayerID() == self.data.role_id)
end

function This:onEnter()
	super.onEnter(self)
	self:refresh()
end

function This:onExit()
	super.onExit(self)
end

function This:initTouchEvent()
	self.geren.see:setTouch({
	    onEnded = function()
	    	if self.data.role_id == 0 then 
	    		g_scene:showTips(Serialize[62241])
	    	else
		    	g_scene:openDialog("PeakContest.PeakContestLookInfoPanel",self.data)
		    end
	    end,
	    isScale = false,
	    isDynamic = true,
		isSwallow = false,
		isContainer = true,
	})
end

function This:setModel(data,index)
	self.data = data or {}
	self:refresh()
end