-- @Author: ZYY
-- @Date:   2018-09-14 16:17:45
-- @Last Modified by: ZYY
-- @Last Modified time: 2018-09-26 15:53:27
-- @File Name: PeakContestRankingPanel.lua
-- @Desc: 
local This, super = class(...,"Dialog")
local PeakContestRankingItemView = require("PeakContest.PeakContestRankingItemView")
local PeakContestManager = require("PeakContest.PeakContestManager")
local UpdateLayer = require("UI.UpdateLayer")

function This:initNode()
    self.m_csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/PeakContestRanking.csb")
    self.m_csNode:setToCenter()
	self:addChild(self.m_csNode)
	self.m_rankData = {}
	self.m_rankItemList = {}
	if not self.m_csNode.ScrollView then 
		print('ZYY:PeakContestRankingPanel.lua [start:19] :data',data)
	end
	self.m_rankLayer = UpdateLayer:create({
		itemWidth = 676,
		itemHeight = 55,
		spaceY = 0,
		spaceX = 0,
		scrollView = self.m_csNode.ScrollView,
	})
	self.m_rankLayer:setAnchorPoint(0.5,0)
	local w , h = self.m_rankLayer:getContentSize()
	self.m_csNode.ScrollView:pushBackCustomItem(self.m_rankLayer, w,h,0)
	self.m_rankLayer:setCascadeOpacityEnabled(true)
	PeakContestManager:reqSeeRankData()
	self:refresh()
end

function This:refresh()
	self.m_rankLayer:setDataList(self.m_rankData, function(data, index)
		local item = PeakContestRankingItemView:create(data,index)
		return item
	end)
end

function This:initTouchEvent()
	self.m_csNode.beijing.close:setTouchEnded(function()
		self:close()
	end)
end

function This:onTouchMask()

end

function This:onEnter()
	super.onEnter(self)
	PeakContestManager:addObserver(self)
	self:refresh()
end

function This:onExit()
	PeakContestManager:removeObserver(self)
	super.onExit(self)
end

function This:UpdateRankData(rankData)
	self.m_rankData = rankData 
	self:refresh()
end