-- @Author: ZYY
-- @Date:   2018-09-28 18:09:33
-- @Last Modified by: ZYY
-- @Last Modified time: 2018-09-28 18:24:19
-- @File Name: PeakContestReportEndPanel.lua
-- @Desc: 
local This , super = class(...,"Player.FightResultBasePanel")
local MenuScene = require("Home.MenuScene")
local ArenaManager = require("Arena.ArenaManager")
local GamePlayer = require("Player.GamePlayer")

function This:initNode(report)
	self.m_report = report
	local isWin = (self.m_report:isAttacker() and self.m_report:isAttackerVictory()) or (self.m_report:isDefender() and self.m_report:isDefencerVictory())
	if isWin then
		self.m_csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/PeakContestWinshare.csb")
		cc.Audio:playEffect("TopArenaWin.mp3")
	else
		self.m_csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/PeakContestFailshare.csb")
		self:initFailedGuide()
		cc.Audio:playEffect("TopArenaLose.mp3")
	end
	self:addChild(self.m_csNode)
	self.m_csNode:setToCenter()

	self.m_csNode.continue:setScale(0.66)
	local seqence1 = cc.Sequence(cc.FadeTo(0.4,64),cc.FadeTo(0.4,255))
	local seqence2 = cc.Sequence(cc.ScaleTo(0.4,0.68),cc.ScaleTo(0.4,0.66))
	self.m_csNode.continue:runAction(cc.RepeatForever(cc.Spawn(seqence1,seqence2)))
end

function This:onTouchMask()
	if GamePlayer:isInWorld() then
		cc.SceneManager:switchTo("World.WorldScene")
	else
		cc.SceneManager:switchTo("Home.MenuScene")
	end	
end

--endregion
