-- @Author: ZYY
-- @Date:   2018-09-25 15:04:57
-- @Last Modified by: ZYY
-- @Last Modified time: 2018-09-28 18:50:01
-- @File Name: PeakContestReportItemView.lua
-- @Desc: 
local This , super = class(...,"NodeUI")
local CityConfig = require("Metadatas.CityConfig")
local GameUtil = require("Util.GameUtil")
local ChatManager = require("Chat.ChatManager")
local ReportManager = require("Report.ReportManager")
local GamePlayer = require("Player.GamePlayer")

This.fileName = "MenuScene/NodeUI/PeakContestLogDetails.csb"
local LastShareReportTime = 0

function This:initNode(report)
	self.m_report = report
	self.weidu:setVisible(false)
	self:initBaseInfo()
end

function This:initBaseInfo()
	local isAtt = false
	if self.m_report.attack_player.role_id == GamePlayer:getPlayerID() then 
		isAtt = true
	end
	self.defence.defense:setVisible(not isAtt)
	self.attacker.actiontitle:setVisible(isAtt)
	self.defence.txt:setVisible(not isAtt)
	self.attacker.txt:setVisible(isAtt)

	self.actionaddress:setVisible(false)

	self.time:setString(GameUtil:formatDate(Serialize[62245],self.m_report.fight_time))
	local rankNum = self.m_report.up_rank_num
	if not isAtt then  
		rankNum = -rankNum
	end
	if rankNum > 0 then
		self.paiming:setString(string.format(Serialize[62246],rankNum))
	elseif rankNum < 0 then 
		self.paiming:setString(string.format(Serialize[62247],math.abs(rankNum)))
	end
	self.paiming:setVisible(rankNum ~= 0)

	self.jiantou:setVisible(rankNum > 0)
	self.jiantou2:setVisible(rankNum < 0)

	local win = self.m_report.res
	local lose = #self.m_report.report_list - self.m_report.res

	self.attacker.actionname:setString(self.m_report.attack_player.name)
	self.defence.name:setString(self.m_report.defence_player.name)
	self.attacker.numberbifen:setString(string.format("%d:%d",win,lose))
	self.defence.numberbifen:setString(string.format("%d:%d",lose,win))
	if not self.m_report.attack_player.group_name or self.m_report.attack_player.group_name == "" then
		self.attacker.name:setString(Serialize[62248])
	else
		self.attacker.name:setString(self.m_report.attack_player.group_name)
	end	
	if not self.m_report.defence_player.group_name or self.m_report.defence_player.group_name == "" then
		self.defence.tongmengname:setString(Serialize[62248])
	else
		self.defence.tongmengname:setString(self.m_report.defence_player.group_name)
	end
	
	if isAtt then 
		self.wintitle:setVisible(win > lose)
		self.falsetitle:setVisible(win < lose)
	else
		self.wintitle:setVisible(win < lose)
		self.falsetitle:setVisible(win > lose)		
	end



end

function This:refresh()

end

function This:initTouchEvent()
	self.videotape:setTouch({
		onEnded = function()
			for i , info in ipairs(self.m_report.report_list) do	
				ReportManager:addReport(info)
			end		
			g_scene:openDialog("PeakContest.PeakContestBattleInfoPanel",self.m_report.report_list)
		end,
		isContainer = true
	})
	-- self.share:setTouch({
	-- 	onEnded = function()
	-- 		local ret , msg = ChatManager:isCanChatInWorld()
	-- 		if not ret then
	-- 			g_scene:showTips(msg)
	-- 			return 
	-- 		end
	-- 		if os.time() - LastShareReportTime >= 5 then
	-- 			local panel = g_scene:openDialog("UI.ConfirmPanel")
	-- 			panel:setString(Serialize[62201])
	-- 			panel:setOkHandler(function()
	-- 				ChatManager:onShareBattleReportRequest(self.m_report:getId())
	-- 				LastShareReportTime = os.time()
	-- 				ReportManager:setIsRead(self.m_report:getId(),true)
	-- 			end)
	-- 		else
	-- 			g_scene:showtTips(string.format(Serialize[62202],os.time() - LastShareReportTime))
	-- 		end
	-- 	end,
	-- 	isContainer = true
	-- })
	-- self.weidu:setTouch({
	-- 	onEnded = function()
	-- 		ReportManager:setIsRead(self.m_report:getId(),true)
	-- 		self:refresh()
	-- 	end,
	-- 	isScale = false,
	-- 	isContainer = true
	-- })
end

function This:onEnter()
	super.onEnter(self)
	ChatManager:addObserver(self)
end

function This:onExit()
	super.onExit(self)
	ChatManager:removeObserver(self)
end

function This:onGetReportDetail(msg)
	cc.SceneManager:switchTo("Report.ReportLoadingScene",nil,msg)
end


--endregion
