-- @Author: ZYY
-- @Date:   2018-09-25 14:59:08
-- @Last Modified by: ZYY
-- @Last Modified time: 2018-09-27 14:30:59
-- @File Name: PeakContestReportPanel.lua
-- @Desc: 
local This, super = class(...,"Dialog")
local PeakContestReportItemView = require("PeakContest.PeakContestReportItemView")
local PeakContestManager = require("PeakContest.PeakContestManager")
local GamePlayer = require("Player.GamePlayer")

local TabName = 
{
	kAll = 1,
	kJinGong = 2, 
	kFangShou = 3,
}

function This:initNode(info)
	self.m_reportList = info.reportList
	self.m_csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/ArenaReport.csb")
	self:addChild(self.m_csNode)
	self.m_csNode:setToCenter()

	self:addTabButton(TabName.kAll , self.m_csNode.tab1,function()
		self:onSelectTab(TabName.kAll)
	end)
	self:addTabButton(TabName.kFangShou, self.m_csNode.tab3,function()
		self:onSelectTab(TabName.kFangShou)
	end)
	self:addTabButton(TabName.kJinGong, self.m_csNode.tab2,function()
		self:onSelectTab(TabName.kJinGong)
	end)
	self:selectTabButton(TabName.kAll)
end

function This:onEnter()
	super.onEnter(self)
end

function This:onExit()
	super.onExit(self)
end

function This:initTouchEvent()
	self.m_csNode.close:setTouchEnded(function()
		self:close()
	end)
	self.m_csNode.changbutton:setTouchEnded(function ()
		-- for i , report in ipairs(self.m_reportList) do
		-- 	if not ReportManager:isRead(report:getId()) then
		-- 		ReportManager:setIsRead(report:getId(),true)
		-- 	end
		-- end
		-- local itemList = self.m_csNode.ScrollView:getItemList()
		-- for i ,view in ipairs(itemList) do
		-- 	view:refresh()
		-- end
	end)
end

function This:getAllReportList()
	return self.m_reportList
end

function This:getJinGongReportList()
	local result = {}
	for i , report in ipairs(self.m_reportList) do	
		if report.attack_player.role_id == GamePlayer:getPlayerID() then
			table.insert(result,report)
		end
	end
	return result
end

function This:getFangShouReportList()
	local result = {}
	for i , report in ipairs(self.m_reportList) do
		if report.defence_player.role_id == GamePlayer:getPlayerID() then
			table.insert(result,report)
		end
	end
	return result
end

function This:onSelectTab(tab)
	if tab == TabName.kAll then
		local reportList = self:getAllReportList()
		self:refreshReportItems(reportList)
	elseif tab == TabName.kJinGong then
		local reportList = self:getJinGongReportList()
		self:refreshReportItems(reportList)
	elseif tab == TabName.kFangShou then
		local reportList = self:getFangShouReportList()
		self:refreshReportItems(reportList)
	end
end

function This:refreshReportItems(reportList)
	self.m_csNode.ScrollView:removeAllItems()
	self.m_timer:removeAllTimer()
	for i , report in ipairs(reportList) do
		self.m_timer:setTimer(i * 0.1,function()
			local view = PeakContestReportItemView:create(report)
			self.m_csNode.ScrollView:pushBackCustomItem(view,820,138,0.5)
		end,"peak_contest_report"..i)
	end
end

function This:onGetArenaBattleReport(reportList)
	
end