-- @Author: ZYY
-- @Date:   2018-09-21 17:05:45
-- @Last Modified by: ZYY
-- @Last Modified time: 2018-09-28 15:12:44
-- @File Name: PeakContestRuleItemView.lua
-- @Desc: 
local This , super = class(...,"NodeUI")
local PeakContestUtil = require("PeakContest.PeakContestUtil")
local PeakContestManager = require("PeakContest.PeakContestManager")
local ItemNode = require("UI.ItemNode")

This.fileName = "MenuScene/NodeUI/PeakContestRuleReward.csb"

function This:initNode(data,type)
	self.data = data
	self.m_type = type
	self.m_perItemList = {}
	self.m_groudItemList = {}
	self.geren.ScrollView:setDirection("horizontal")
	self.geren.ScrollView.m_direction = "right"
	self.juntuan.ScrollView:setDirection("horizontal")
	self.juntuan.ScrollView.m_direction = "right"
end

function This:refresh()
	local myData = PeakContestManager:getMyData()
	local roleReward = myData.role_reward
	local groupReward = myData.group_reward
	local width, height = 70, 55
	if self.m_type == PeakContestRuleType.Personal then 
		self.geren:setVisible(true)
		self.juntuan:setVisible(false)
		local minRank ,maxRank = self.data.max, self.data.min
		if minRank ~= maxRank or minRank > 3 then 
			self.geren.top:setVisible(false)
			self.geren.rank:setVisible(true)
			if minRank == maxRank then 
				self.geren.rank:setString(minRank)
			else
				self.geren.rank:setString(string.format("%d~%d",minRank,maxRank))
			end
		else
			self.geren.top:setVisible(true)
			self.geren.top:setImage(string.format("MenuScene/top%d.png",minRank))
			self.geren.rank:setVisible(false)
		end
		for i , reward in ipairs(self.data.rewardlist) do 
			local item = self.m_perItemList[i]
			if not item then 
				item = ItemNode:create(reward[1] ,reward[2])
				item:setScale(0.7)
				item:setAnchorPoint(0.5,0.5)
				self.geren.ScrollView:pushBackCustomItem(item,width,height)
			else
				item:initItem(reward[1] ,reward[2])
			end
			self.m_perItemList[i] = item
		end
		self.geren.selectBg:setVisible(self.data.id == roleReward)
	elseif self.m_type == PeakContestRuleType.Groud then 
		self.geren:setVisible(false)
		self.juntuan:setVisible(true)
		local rank = self.data.id
		if rank > 3 then 
			self.juntuan.top:setVisible(false)
			self.juntuan.rank:setVisible(true)
			self.juntuan.rank:setString(rank)
		else
			self.juntuan.top:setVisible(true)
			self.juntuan.top:setImage(string.format("MenuScene/top%d.png",rank))
			self.juntuan.rank:setVisible(false)
		end
		self.juntuan.jutanpaiming:setString(string.format(Serialize[62251],self.data.rank_number or 0))
		for i , reward in ipairs(self.data.rewardlist) do 
			local item = self.m_groudItemList[i]
			if not item then 
				item = ItemNode:create(reward[1] ,reward[2])
				item:setScale(0.7)
				item:setAnchorPoint(0.5,0.5)
				self.juntuan.ScrollView:pushBackCustomItem(item,width,height)
			else
				item:initItem(reward[1] ,reward[2])
			end
			self.m_groudItemList[i] = item
		end
		self.juntuan.selectBg:setVisible(self.data.id == groupReward)
	end
end

function This:onEnter()
	super.onEnter(self)
	self:refresh()
end

function This:onExit()
	super.onExit(self)
end

function This:initTouchEvent()
	self.geren.ScrollView:setSwallowTouch(false)
	self.juntuan.ScrollView:setSwallowTouch(false)
end
