-- @Author: ZYY
-- @Date:   2018-09-21 16:09:54
-- @Last Modified by: ZYY
-- @Last Modified time: 2018-09-27 15:15:25
-- @File Name: PeakContestRulePanel.lua
-- @Desc: 
local This, super = class(...,"Dialog")
local TopArenaLegionRewardConfig = require("Metadatas.TopArenaLegionRewardConfig")
local TopArenaRewardConfig = require("Metadatas.TopArenaRewardConfig")
local PeakContestRuleItemView = require("PeakContest.PeakContestRuleItemView")
local PeakContestManager = require("PeakContest.PeakContestManager")
local PeakContestUtil = require("PeakContest.PeakContestUtil")

function This:initNode()
    self.m_csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/PeakContestRule.csb")
    self.m_csNode:setToCenter()
	self:addChild(self.m_csNode)
	self:refresh()
end

function This:refresh()

end

function This:initTouchEvent()

	self.m_csNode.beijing.close:setTouchEnded(function()
		self:close()
	end)

	self:addTabButton(PeakContestRuleType.Rule, self.m_csNode.tep1, function()
		self.m_csNode.txt_node.rule1:setVisible(true)
		self.m_csNode.txt_node.rule2:setVisible(false)
		self:updateMaxRank()
    end)

    self:addTabButton(PeakContestRuleType.Personal, self.m_csNode.tep2, function()
		self.m_csNode.txt_node.rule1:setVisible(false)
		self.m_csNode.txt_node.rule2:setVisible(true)
		self:updatePersonalReward()
    end)

    self:addTabButton(PeakContestRuleType.Groud, self.m_csNode.tep3, function()
		self.m_csNode.txt_node.rule1:setVisible(false)
		self.m_csNode.txt_node.rule2:setVisible(true)
		self:updateGroudReward()
    end)
	self:selectTabButton(PeakContestRuleType.Rule)
end

function This:updateMaxRank()
	self.m_csNode.txt_node.rule1:setVisible(true)
	local maxRank = PeakContestManager:getMyMaxRank()
	self.m_csNode.txt_node.rule1.number:setString(maxRank)
	self.m_csNode.txt_node.rule1.txt:setString(Serialize["peak_contest_help_tips"])
end

function This:updatePersonalReward()
	self.m_csNode.txt_node.rule1:setVisible(false)
	self.m_csNode.txt_node.rule2.scrollView:removeAllItems()
	local width = 560
	local height = 55
	for i , v in ipairs(TopArenaRewardConfig) do 
		local item = PeakContestRuleItemView:create(v,PeakContestRuleType.Personal)
		self.m_csNode.txt_node.rule2.scrollView:pushNode(item,width,height)
	end
end

function This:updateGroudReward()
	self.m_csNode.txt_node.rule1:setVisible(false)
	self.m_csNode.txt_node.rule2.scrollView:removeAllItems()
	local width = 560
	local height = 55
	for i , v in ipairs(TopArenaLegionRewardConfig) do 
		local item = PeakContestRuleItemView:create(v,PeakContestRuleType.Groud)
		self.m_csNode.txt_node.rule2.scrollView:pushNode(item,width,height)
	end
end

function This:onTouchMask()

end
