-- @Author: ZYY
-- @Date:   2018-09-20 17:54:00
-- @Last Modified by:   superm
-- @Last Modified time: 2019-01-02 21:30:08
-- @File Name: PeakContestShopItemView.lua
-- @Desc: 
local This , super = class(...,"NodeUI")
local TopArenaCommonShopConfig = require("Metadatas.TopArenaCommonShopConfig")
local TopArenaFirstShopConfig = require("Metadatas.TopArenaFirstShopConfig")
local PeakContestManager = require("PeakContest.PeakContestManager")
local PeakContestUtil = require("PeakContest.PeakContestUtil")
local DepotManager = require("Depot.DepotManager")
local ItemUtil = require("Bag.ItemUtil")
local ItemNode = require("UI.ItemNode")
local GameUtil = require("Util.GameUtil")

This.fileName = "MenuScene/NodeUI/FamilyStoreItem.csb"

function This:initNode(...)
	self.condition:setVisible(false)
	self:setData(...)
end

function This:refresh()
	self.name:setString(ItemUtil.getName(self.m_itemData.item_id))
  	self.name:setColorByID("Q".. ItemUtil.getQuality(self.m_itemData.item_id))
	self.unlock.price:setString(self.m_itemData.price_num or 0)
	self.unlock.yuanbao:setImage(ItemUtil.getIconImage(self.m_itemData.price_id))

    if self.m_itemData.discount == 10 then
        self.unlock.bg5:setVisible(false)
        self.unlock.discount:setVisible(false)
    else
        self.unlock.bg5:setVisible(true)
        self.unlock.discount:setVisible(true)
        self.unlock.discount:setString( GameUtil:discountStr(self.m_itemData.discount) )
    end

	if not self.itemNode then 
		self.itemNode = ItemNode:create(self.m_itemData.item_id,self.m_itemData.item_num)
		self.itemNode:setAnchorPoint(0.5,0.5)
		self.unlock.item:addChild(self.itemNode)
	else
		self.itemNode:initItem(self.m_itemData.item_id,self.m_itemData.item_num)
	end

  	

	if self.m_type == PeakContestShopType.Honor then 
		local rank = PeakContestManager:getMyMaxRank()
		if rank <= self.m_itemData.need and rank~= 0 then 
			self.unlock.buyTimes:setVisible(self.m_itemData.buy_times ~= 0)
            self.unlock.buyTimes:setVisible(self.m_itemData.buy_times - self.data.buy_times ~= 0)
			self.unlock.buyTimes:setString(string.format(Serialize[61081],self.m_itemData.buy_times - self.data.buy_times , self.m_itemData.buy_times))
            if self.m_itemData.buy_times ~= 0 and self.m_itemData.buy_times == self.data.buy_times then 
		        self.unlock.purchased:setVisible(true)
		        self.unlock.buybutton:setVisible(false)
	        else
		        self.unlock.purchased:setVisible(false)
		        self.unlock.buybutton:setVisible(true)
	        end
		else
			self.unlock.buyTimes:setStringWithColor(string.format("<Peak1>%s",self.m_itemData.text))
		    self.unlock.buybutton:setVisible(false)
            self.unlock.purchased:setVisible(false)
        end
	elseif self.m_type == PeakContestShopType.Peak then 
		self.unlock.buyTimes:setVisible(self.m_itemData.buy_times ~= 0)
        self.unlock.buyTimes:setVisible(self.m_itemData.buy_times - self.data.buy_times ~= 0)
		self.unlock.buyTimes:setString(string.format(Serialize[61081],self.m_itemData.buy_times - self.data.buy_times , self.m_itemData.buy_times))
		self.unlock.discount:setString(  GameUtil:discountStr(self.m_itemData.discount) )
		self.unlock.discount:setVisible(self.m_itemData.discount ~= 10)
		self.unlock.bg5:setVisible(self.m_itemData.discount ~= 10)
        if self.m_itemData.buy_times ~= 0 and self.m_itemData.buy_times == self.data.buy_times then 
		    self.unlock.purchased:setVisible(true)
		    self.unlock.buybutton:setVisible(false)
	    else
		    self.unlock.purchased:setVisible(false)
		    self.unlock.buybutton:setVisible(true)
	    end
	end

 

end

function This:onEnter()
	super.onEnter(self)
	self:refresh()
end

function This:onExit()
	super.onExit(self)
end

function This:initTouchEvent()
	self.unlock.buybutton:setTouch({
	    onEnded = function()
			if self.m_itemData.buy_times ~= 0 and self.m_itemData.buy_times - self.data.buy_times <= 0 then 
				g_scene:showTips(Serialize[62255])
				return 
			end
			local count = DepotManager:getItemOrResCount(self.m_itemData.price_id)
			if count < self.m_itemData.price_num then 
				local name = ItemUtil.getName(self.m_itemData.price_id)
				g_scene:showTips(name..Serialize[60715])
				return 
			end
			if self.m_type == PeakContestShopType.Peak then 
				PeakContestManager:reqBuyPeakShop(self.data.trench,self.data.config_id)
			elseif self.m_type == PeakContestShopType.Honor then
				if PeakContestManager:getMyMaxRank() == 0 or PeakContestManager:getMyMaxRank() > self.m_itemData.need then 
					g_scene:showTips(Serialize[62256])
					return 
				end 
				PeakContestManager:reqBuyHonorShop(self.data.trench,self.m_itemData.item_id)
			end
	    end,
	    isScale = false,
	    isDynamic = true,
		isContainer = true,
	})
end

function This:setData(data,type)
	self.data = data
	self.m_type = type
	if self.m_type == PeakContestShopType.Peak then 
		self.m_itemData = TopArenaCommonShopConfig[self.data.config_id]
	elseif self.m_type == PeakContestShopType.Honor then 
		self.m_itemData = TopArenaFirstShopConfig[self.data.trench]
	end
	self:refresh()
end