-- @Author: ZYY
-- @Date:   2018-09-19 17:40:32
-- @Last Modified by: ZYY
-- @Last Modified time: 2018-09-28 18:35:06
-- @File Name: PeakContestShopPanel.lua
-- @Desc: 
local This, super = class(...,"Dialog")
local PeakContestManager = require("PeakContest.PeakContestManager")
local PeakContestShopItemView = require("PeakContest.PeakContestShopItemView")
local CommonShopRenovateConfig = require("Metadatas.CommonShopRenovateConfig")
local DepotManager = require("Depot.DepotManager")
local TopArenaFirstShopConfig = require("Metadatas.TopArenaFirstShopConfig")

local TabName = 
{
	kPeak = 1,
    kHonor = 2,
}


function This:initNode()
    self.m_csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/PeakContestShop.csb")
    self.m_csNode:setToCenter()
	self:addChild(self.m_csNode)
	self.m_select = TabName.kPeak
	-- self.m_refreshTimes = 0
	self.m_shopItemList = {}
end

function This:initTouchEvent()
	self.m_csNode.close:setTouchEnded(function()
		self:close()
	end)

	self:addTabButton(TabName.kPeak, self.m_csNode.peak, function()
		PeakContestManager:reqPeakShopData()
		self.m_csNode.tip:setString(Serialize[62258])
		self.m_csNode.reset:setVisible(false)
    end)

    self:addTabButton(TabName.kHonor, self.m_csNode.honor, function()
		PeakContestManager:reqHonorShopData()
		self.m_csNode.tip:setString(Serialize[62259])
		self.m_csNode.reset:setVisible(false)
    end)
	self:selectTabButton(TabName.kPeak)

	self.m_csNode.reset:setTouchEnded(function()
		local data = CommonShopRenovateConfig[self.m_refreshTimes + 1]
		if not data then 
			g_scene:showTips(Serialize[62260])
		else
			local panel = g_scene:openDialog("UI.CostConfirmPanel", {
				cost = data.cost, 
				desc = Serialize[60115], 
				notips = "Reset", 
				okHandler = function()
					PeakContestManager:reqUpdatePeakShopData()
			    end 
			})			
		end
	end)
end

function This:onEnter()
	super.onEnter(self)
	PeakContestManager:addObserver(self)
	-- self:refresh()
end

function This:onExit()
	PeakContestManager:removeObserver(self)
	super.onExit(self)
end

function This:UpdateShopItem(data, type)
	self.m_csNode.zijin.number1:setString(DepotManager:getItemOrResCount(161))
	self.m_csNode.zijin.number2:setString(DepotManager:getItemOrResCount(102))
    
	local function sort_shop(a,b)
        if type == PeakContestShopType.Honor then
           return TopArenaFirstShopConfig[a.trench].need < TopArenaFirstShopConfig[b.trench].need
        else
            return a.trench < b.trench
        end
		
	end
	table.sort(data,sort_shop)
	if #data ~= #self.m_shopItemList then 
		self.m_csNode.ScrollView:removeAllItems()
		self.m_shopItemList = {}
	end
	local width = 360
	local height = 118
	for i , v in ipairs(data) do 
		local item = self.m_shopItemList[i]
		if not item then 
			item = PeakContestShopItemView:create(v,type)
			self.m_csNode.ScrollView:pushNode(item,width,height,2)
		else
			item:setData(v,type)		
		end
		self.m_shopItemList[i] = item
	end
end

function This:UpdateRefreshTimes(refreshTimes)
	self.m_refreshTimes = refreshTimes
	self.m_csNode.reset.shuaxin:setString(string.format(Serialize[62261],#CommonShopRenovateConfig - self.m_refreshTimes))
end