-- @Author: ZYY
-- @Date:   2018-09-13 14:59:58
-- @Last Modified by:   superm
-- @Last Modified time: 2019-12-23 14:59:14
-- @File Name: PeakContestTeamItemView.lua
-- @Desc: 
local This , super = class(...,"NodeUI")
local PeakContestManager = require("PeakContest.PeakContestManager")
local ArenaHeroView = require("Arena.ArenaHeroView")

This.fileName = "MenuScene/NodeUI/PeakContestTeam.csb"

function This:initNode(...)
	self:setModel(...)
end

function This:refresh()
	if self.m_heroId ~= 0 then 
		if not self.m_heroItem then 
			self.m_heroItem = ArenaHeroView:create({
				heroId = self.m_heroId,
				level = self.m_level,
				star = self.m_star,
				awake = self.m_awake,
			})
			self.item:addChild(self.m_heroItem)
		else
			self.m_heroItem:setModel({
				heroId = self.m_heroId,
				level = self.m_level,
				star = self.m_star,			
				awake = self.m_awake,
			})
		end
		self.m_heroItem:setVisible(true)
	else
		if self.m_heroItem then 
			self.m_heroItem:setVisible(false)
		end
	end
	if self.m_troop == 0 then
		self.troop:setVisible(false)
		self.gou:setVisible(false)
		self.goubg:setVisible(false)
	else
		self.troop:setVisible(true)
		self.gou:setVisible(true)
		self.goubg:setVisible(true)
		local troop = self.m_troop
		if self.m_troop <= 5 then
			troop = self.m_troop + 36
		else
			troop = self.m_troop + 247
		end
		self.troop:setImage(string.format("MenuScene/kuang%d.png",troop))
	end
	self.troop.num:setString(self.m_troop)
end

function This:showX(isShow)
	self.x1:setVisible(isShow)
end

function This:onEnter()
	super.onEnter(self)
	self:refresh()
end

function This:onExit()
	super.onExit(self)
end

function This:initTouchEvent()
		
end

function This:setHide(state)
	self.item:setVisible(not state)
	self.wenhao:setVisible(state)
end

function This:setSelectHandler(handler)
	self.itembg:setTouch({
	    onEnded = function()
	    	handler(self.m_hero)
	    end,
	    isScale = false,
	    isDynamic = true,
		isSwallow = false,
	})
end

function This:setModel(hero, index, parentNode, isAwakeFull)
	self.m_parentNode = parentNode or self.m_parentNode
	if hero then
		if isAwakeFull == nil then
			self.m_awake = hero:isAwakeFull()
		else
			self.m_awake = isAwakeFull
		end
		self.m_hero = hero
		self.m_level = hero:getLevel()
		self.m_star = hero:getTotalPhase()
		self.m_heroId = hero:getId()
		self.m_uid = hero:getUid()
	else
		self.m_heroId = 0
		self.m_troop = 0
		self.m_hero = nil
		self.m_uid = 0
		self.m_awake = false
	end
	if self.m_parentNode then 
		self.m_troop = self.m_parentNode:getCardTroop(self.m_uid)
	else
		self.m_troop = 0
	end
	self.m_index = index or 1
	self:refresh()
end