-- @Author: ZYY
-- @Date:   2018-09-26 21:29:21
-- @Last Modified by: ZYY
-- @Last Modified time: 2018-09-28 20:14:35
-- @File Name: PeakContestVictoryPanel.lua
-- @Desc: 
local This, super = class(...,"Dialog")
local ItemNode = require("UI.ItemNode")

function This:initNode(info)
	self.m_reward = info.reward_list
	self.m_maxRank = info.max_rank
	self.m_rank = info.rank
	self.m_upRank = info.up_rank_num
	self.m_goldList = info.gold_list[1]
    self.m_csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/PeakContestVictory.csb")
    self.m_csNode:setToCenter()
	self:addChild(self.m_csNode)
	self.m_rewardItemList = {}
	cc.Audio:playEffect("TopArenaWin.mp3")
	self:refresh()
end

function This:refresh()
	for i = 1, 3 do 
		local item = self.m_rewardItemList[i] 
		if not item then 
			item = ItemNode:create(self.m_reward[i].id,self.m_reward[i].num)
			item:setAnchorPoint(0.5,0.5)
			item:setScale(0.8)
			self.m_csNode.Node_1["item"..i]:addChild(item)
		else
			item:initItem(self.m_reward[i].id,self.m_reward[i].num)
		end
		self.m_rewardItemList[i] = item
	end
end

function This:runOpenAnimation()
	self.m_runAction = true
	self.m_csNode:playCSAnimation(nil,false,function()
		self.m_runAction = false
	end)
	self:onOpen()
end


function This:initTouchEvent()

end

function This:onTouchMask()
	self:close()
	if self.m_upRank > 0 then 
		g_scene:openDialog("PeakContest.PeakContestArenarulePanel",{maxRank = self.m_maxRank, offsetRank = self.m_upRank, diamond = self.m_goldList.num})
	end
end
