local This, super = class(..., "Dialog")
local PlanShopManager = require("PlanShop.PlanShopManager")

function This:initNode(info)
    self.m_csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/PlanClear.csb")
    self.m_csNode:setPosition(cc.visible.center.x, cc.visible.center.y)
    self:addChild(self.m_csNode)
    self.m_csNode.cost:setString(info.cost)
    if info.title then
        self.m_csNode.title:setString(info.title)
    end
    if info.desc then
        self.m_csNode.vigor:setString(info.desc)
    end
end

function This:initTouchEvent()
    self.m_csNode.confirmButton:setTouchEnded(function()
        if self.m_okHandler then
            self.m_okHandler()
        end
        self:close()
    end)
    self.m_csNode.cancelButton:setTouchEnded(function()
        if self.m_cancelHandler then
            self.m_cancelHandler()
        end
        self:close()
    end)
end

function This:setHandler(okHandler,cancelHandler)
    self.m_okHandler = okHandler
    self.m_cancelHandler = cancelHandler
end

function This:setTitle(title)
	self.m_csNode.texxt:setString(title)
end

function This:setDesc(desc)
	self.m_csNode.vigor:setString(desc)
end
