--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(..., "cc.Node")
local PlanShopConfig = require("Metadatas.PlanShopConfig")
local ItemUtil = require("Bag.ItemUtil")
local ItemNode = require("UI.ItemNode")
local PlanShopManager = require("PlanShop.PlanShopManager")
local DepotManager = require("Depot.DepotManager")
local NobilityManager = require("Nobility.NobilityManager")

function This:init(id)
    self.planId = id
    self.m_isLocked = false
	self.m_itemId = PlanShopConfig[id].item_id
    self.m_time =PlanShopConfig[self.planId].time
    self.m_lockLevel = PlanShopConfig[self.planId].unlock_nobilitytitle
	self.m_csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/PlanShopItem.csb")
    self:addChild(self.m_csNode)
    local w , h = self.m_csNode.bg:getContentSize()
    self:setContentSize(w,h)
    self:refresh()
    self:setItemEnable(true)
end

function This:onEnter()
    super.onEnter(self)
    self:initTouchEvent()
    PlanShopManager:addObserver(self)
    NobilityManager:addObserver(self)
end

function This:onExit()
    PlanShopManager:removeObserver(self)
    NobilityManager:removeObserver(self)
    super.onExit(self)
end

function This:initTouchEvent()
    self.m_csNode.button:setTouch({
        isContainer = true,
        onEnded = function()
            self:onStudyClick()
        end,
		name = "PlanShopItemView_listener"
    })    
    self.m_csNode.button_gray:setTouch({
        isContainer = true,
		onEnded = function()
            if NobilityManager:checkPlanUnlock(self.planId) then
                return
            end
            g_scene:showTips(string.format(Serialize[62267],NobilityManager:getLockedNobilityName(self.planId)))
        end,
    })
end

function This:refresh()
    self.m_csNode.name:setString(ItemUtil.getName(self.m_itemId))
    self.m_csNode.number:setString(string.format(Serialize[62268], DepotManager:getItemCount(self.m_itemId)))

    local itemNode = self.m_csNode.item
    local node = itemNode.node
    if not node then
        node = ItemNode:create(self.m_itemId)
        node:setAnchorPoint(0.5, 0.5)
        -- node:setScale(0.5)
        local x, y = itemNode:getPosition()
        node:setPosition(x, y)
        self.m_csNode:addChild(node)
        itemNode.node = node
    else
        node:init(self.m_itemId)
        node:setVisible(true)
    end

    local hour = math.floor(self.m_time / 3600)
    local minute = math.floor(self.m_time % 3600 / 60)
    local second = math.floor(self.m_time % 60)
    self.m_csNode.time:setString(string.format("%02d:%02d:%02d", hour, minute, second))
    -- self:setItemEnable(NobilityManager:checkPlanUnlock(self.planId))
    self:setItemEnable(false)

    
end 

function This:setItemEnable(enble)
    self.m_isLocked = not enble
    self.m_csNode.button:setVisible(enble)
    self.m_csNode.button_gray:setVisible(not enble)
    self.m_csNode.text:setVisible(enble)
    self.m_csNode.dark:setVisible(not enble)
end

function This:isLocked()
    return self.m_isLocked
end

function This:onStudyClick()
    PlanShopManager:onStudyPlanRequest(self.planId)
end

function This:onStudyPlan( planId )
    if planId == self.planId then
        self.m_csNode.number:setString(string.format(Serialize[62268], DepotManager:getItemCount(self.m_itemId)))
    end
end

function This:getId()
    return self.planId
end

--endregion
