--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...)
local PlanShopConfig = require("Metadatas.PlanShopConfig")
local ItemUtil = require("Bag.ItemUtil")
local GamePlayer = require("Player.GamePlayer")
local DepotManager = require("Depot.DepotManager")
local WorldMapManager = require("World.WorldMapManager")

JiCeType = {
    kCaiYuanGunGun      = 1,
    kWuGuFengDeng       = 2,
    kZhaoBinMaima       = 3,
    kXingJunJiaSu       = 4,
    kNengGongQiaoJiang  = 5,
    kLuBanZaiShi        = 6,
	kQianDuLing         = 7,
	kQiMenBaGua         = 8,
	kKongChengJi        = 10,
	kDongRuoGuanHuo     = 9,
    kHanDiShouYu        = 11,
    kTotal              = 11,
}

JiCeState = 
{
    kQMBG = 1, -- 奇门八卦
    kKCJ = 2, --空城
    kDRGH = 3, --洞若观火
    kHide = 4, --隐藏城池
    kAppear = 5, --显示城池
    kHDSY = 6, --献帝手谕
}

JiCeToState = 
{
    [JiCeState.kDRGH] = JiCeType.kDongRuoGuanHuo,
    [JiCeState.kKCJ] = JiCeType.kKongChengJi,
    [JiCeState.kQMBG] = JiCeType.kQiMenBaGua,
    [JiCeState.kHDSY] = JiCeType.kHanDiShouYu
}

function This:getPlanIdByItemId(itemId)
    for id, plan in ipairs(PlanShopConfig) do
        if itemId == plan.item_id then
            return id 
        end
    end
    return 0
end

function This:isPlanCanUsed(itemId)
    for id, plan in ipairs(PlanShopConfig) do
        if itemId == plan.item_id then
            return id == JiCeType.kCaiYuanGunGun or id == JiCeType.kWuGuFengDeng
        end
    end
    return false
end

function This:usePlan(param)
    local id = param.plan
    local item = PlanShopConfig[id]
    param.comment = ItemUtil.getComment(item.item_id)
    param.gold = item.gold
    param.itemId = item.item_id
    
    return g_scene:openDialog("PlanShop.UsePlanPanel", param)
end

function This:needUsePlan( planId, needNum, deltaNum )
    local info = {
        [JiCeType.kWuGuFengDeng] = {warmming = 11102, value = WorldMapManager:getFood()},
        [JiCeType.kCaiYuanGunGun] = {warmming = 11103, value = WorldMapManager:getCopper()},
    }

    local delta = deltaNum
    local planInfo = info[planId]
    assert(planInfo ~= nil)
    
    if not delta then
        delta = needNum - planInfo.value
    end
    if delta > 0 then
        local unitValue = WorldMapManager:getValueByUsingJice(planId)
        local useNumber = math.ceil(delta / unitValue)
        print("delta:" .. delta, "unitValue:" .. unitValue)
        self:usePlan({plan=planId, num = useNumber, unitValue=unitValue})
        g_scene:showTips(Serialize[planInfo.warmming])
        return true
    end
    return false
end

function This:getPlanNumInDepot(planId)
    local id = planId
    local item = PlanShopConfig[id]
    return DepotManager:getItemCount(item.item_id)
end

--endregion
