--region *.lua
--Date
--此文件由[BabeLua]插件自动生成
local GameUtil = require("Util.GameUtil")
local This, super = class(..., "Dialog")
local PlanShopManager = require("PlanShop.PlanShopManager")
local DepotManager = require("Depot.DepotManager")
local WorldMapManager = require("World.WorldMapManager")
local GamePlayer = require("Player.GamePlayer")
local ItemConfig = require("Metadatas.ItemConfig")

local jiceLimitType={
    [2001] = JiCeType.kCaiYuanGunGun,
    [2002] = JiCeType.kWuGuFengDeng,
    [2003] = JiCeType.kZhaoBinMaima,
}
local jiceModifyNum ={
    [2001] = JiCeType.kCaiYuanGunGun,
    [2002] = JiCeType.kWuGuFengDeng,
    [2003] = JiCeType.kZhaoBinMaima,
    [2004] = JiCeType.kXingJunJiaSu,
}
local jiceName ={
    [JiCeType.kCaiYuanGunGun] = Serialize[62273],
    [JiCeType.kWuGuFengDeng] = Serialize[62274],
    [JiCeType.kZhaoBinMaima] = Serialize[62275],
}
function This:initNode(info)

    self.m_info = info
    self.m_planType = info.plan
    self.m_num = info.num
    self.m_gold = info.gold
    self.m_itemId = info.itemId
    self.m_curAddSpeed = info.curAddSpeed or 0  --计策剩余使用次数，暂时只有，行军加速，招兵买马用到了
    self.m_addSpeedMax = kMaxSpeedUpTime       --计策使用上限，暂时只有，行军加速，招兵买马用到了

    self.m_modifyNum = jiceModifyNum[self.m_itemId]
    self.m_jiCeLimit = jiceLimitType[self.m_itemId]
    if self.m_modifyNum and self.m_modifyNum == JiCeType.kZhaoBinMaima then
        local canUsePlan, useNum, maxNum = WorldMapManager:canUseItem(JiCeType.kZhaoBinMaima)
        self.m_curAddSpeed = maxNum - useNum
        self.m_addSpeedMax = maxNum
    end
    local fileName = "GameScene/NodeUI/UsePlan.csb"
    if self.m_modifyNum then
        fileName = "GameScene/NodeUI/UsePlan2.csb"
    end
    if info.comment then
        self.m_comment = info.comment
    else
        self.m_comment = ItemConfig[self.m_itemId].comment
    end
    self.m_argId = info.argId
    self.m_info.rest_num = DepotManager:getItemCount(info.itemId)

	self.m_csNode = cc.Node:createFromCSFile(fileName)
    local csNode = self.m_csNode
    csNode:setPosition(cc.visible.center.x,cc.visible.center.y)
	self:addChild(csNode)
	csNode:setToCenter()

    csNode.desc_txt:setString(self.m_comment, 450)
    -- local priceDesc = tostring(self.m_gold)
    -- if self.m_num > 1 then 
    --     priceDesc =  self.m_num*tostring(self.m_gold) 
    -- end
    -- csNode.price:setString(priceDesc .. Serialize[60197])
    self:refreshBuyDes()
    csNode.surplus:setString(Serialize[62276] .. self.m_info.rest_num .. Serialize[60804])

    local visible = self.m_info.rest_num > 0
    csNode.goto_btn_txt:setVisible(not visible)
    csNode.use_txt:setVisible(visible)
--    if visiblkZhaoBinMaima 1 then
        self:refreshUseDes()
        -- self.m_csNode.use_txt:setString(Serialize[62046] .. self.m_num  .. Serialize[60804])
--    end
    if self.m_modifyNum and csNode.xianyongnum1 then
        local str =nil
        if JiCeType.kXingJunJiaSu ==self.m_modifyNum then
            str = string.format(Serialize[62277],self.m_curAddSpeed,self.m_addSpeedMax)
        elseif JiCeType.kZhaoBinMaima ==self.m_modifyNum then
            str = string.format(Serialize[62278],self.m_curAddSpeed,self.m_addSpeedMax)
        end
        if str then
            csNode.xianyongnum1:setString(str)
        end
        csNode.xianyongnum1:setVisible(str)
    end
end

function This:checkUserLimit()
    local res,leftNum = false,0
    if self.m_modifyNum and JiCeType.kXingJunJiaSu ==self.m_modifyNum or JiCeType.kZhaoBinMaima ==self.m_modifyNum then
        return true,self.m_curAddSpeed
    end
    return rs,leftNum
end

function This:isEnough()
    return self.m_info.rest_num>=self.m_num
end


function This:refreshBuyDes()
    local csNode = self.m_csNode
    local priceDesc = tostring(self.m_gold)
    if self.m_num > 1 then 
        priceDesc =  self.m_num*tostring(self.m_gold) 
    end
    csNode.price:setString(priceDesc .. Serialize[60197])
end

function This:refreshUseDes()
    local csNode = self.m_csNode
    local useStr = Serialize[62279]
    local num = self.m_num
    if self:isEnough() then
        -- if num>1 then
        --     useStr = Serialize[62046] .. num  .. Serialize[60804]
        -- else
            useStr = Serialize[62046]
        -- end
    end
    csNode.use_txt:setString(useStr)

    if csNode.yujinum1 and self.m_modifyNum then
        local str = string.format(Serialize[62280],num*2)
        if JiCeType.kXingJunJiaSu ~=self.m_modifyNum then
            local unitNum = WorldMapManager:getValueByUsingJice( self.m_modifyNum )
            str = string.format(Serialize[62281],jiceName[self.m_modifyNum],num*unitNum)
        end
        csNode.yujinum1:setString(str)
        csNode.usecount:setString(num)
    end

end

function This:initTouchEvent()
    local csNode = self.m_csNode
    csNode.close:setTouchEnded(function()
        self:close()
    end)
    if csNode.cancel_btn then
        csNode.cancel_btn:setTouchEnded(function()
            self:close()
        end)
    end
    csNode.study_btn:setTouchEnded(function()
        local cost = self.m_num * self.m_gold
        if cost > GamePlayer:getDiamond() then
            GamePlayer:checkDiamond(0, true)
            return
        end
        PlanShopManager:onUsePlanRequest(self.m_info, true)
        self:close()
    end)
    csNode.use_btn:setTouchEnded(function()  
        local count  =  self.m_num or 1
        if self.m_info.rest_num > 0 then
            if self.m_info.rest_num >= count then
                PlanShopManager:onUsePlanRequest(self.m_info, false)
                self:close()
            else
                g_scene:openDialog("PlanShop.PlanShopPanel")
            end
        else
            g_scene:openDialog("PlanShop.PlanShopPanel")
        end
        self:close()
    end)
    if csNode.reduce then
        csNode.reduce:setTouchEnded(function()  --
            self.m_num = self.m_num -1
            if self.m_num<1 then
                self.m_num =1
            end
            self.m_info.num = self.m_num
            self:refreshBuyDes()
            self:refreshUseDes()
        end)    
        csNode.increase:setTouchEnded(function()  --+ add
            self.m_num = self.m_num +1
            local addLimit ,leftNUm = self:checkUserLimit()
            if addLimit and self.m_num>leftNUm then
                self.m_num = leftNUm
                g_scene:showTips(Serialize[62282])
                return
            end
            self.m_info.num = self.m_num
            self:refreshBuyDes()
            self:refreshUseDes()
        end)    
    end
end

function This:showStudyNode(isShow)
     self.m_csNode.study_btn:setVisible(isShow)
	 self.m_csNode.study_txt:setVisible(isShow)
	 self.m_csNode.price:setVisible(isShow)
	 self.m_csNode.icon2:setVisible(isShow)
end

function This:onEnter()
	super.onEnter(self)
	WorldMapManager:addObserver(self)
end

function This:onExit()
	super.onExit(self)
	WorldMapManager:removeObserver(self)
end

function This:onRemoveMarchArmy(armyId)
	if self.m_argId == armyId then
		self:close()
	end
end

--endregion
