-- @Author: superm
-- @Date:   2018-01-28 16:16:07
-- @Last Modified by:   zheng
-- @Last Modified time: 2019-06-19 14:51:37
-- @File Name: ChangeIconPanel.lua
-- @Description: 

local This , super  = class(...,"Dialog")
local GamePlayer = require("Player.GamePlayer")
-- local RoleWidgetItemView = require("Player.RoleWidgetItemView")
local CityEffectTab = require("Player.CityEffectTab")
local CityIconTab = require("Player.CityIconTab")

local TabNameIndex ={
	kSkin =1,--皮肤
	kPlayer =2,--头像
}

local function enableButton(button)
	button.bg1:setVisible(true)
	button.bg2:setVisible(false)
end

local function disableButton(button)
	button.bg1:setVisible(false)
	button.bg2:setVisible(true)
end

function This:selectTab(key)
	if key and self.m_currentTabKey == key then
		return
	end
	local csNode = self.m_csNode
	for tepIndex=1,PlayerEffectType.kCount do
		if key == tepIndex then
			enableButton(csNode["tep"..tepIndex])
		else
			disableButton(csNode["tep"..tepIndex])	
		end
	end

	self.m_currentTabKey = key
	self:onTabHasChanged(self.m_currentTabKey)
end

function This:initNode(info)
	self.m_csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/RoleChangeName.csb")
	self:addChild(self.m_csNode)
	self.m_csNode:setToCenter()
	self.m_allTabNode = {}
	GamePlayer:onGetOwnedRoleWidgetsRequest()
	self:selectTab(PlayerEffectType.icon) -- 默认打开头像设置页
end


function This:initTouchEvent()
	-- 关闭按钮
	local csNode = self.m_csNode
	csNode.close.returnicon:setTouchEnded(function()
		self:close()
	end)

	for tepIndex=1,PlayerEffectType.mounticon do
		csNode["tep"..tepIndex].bg2:setTouchEnded(function()
			self:selectTab(tepIndex)
		end)
	end
end


function This:createTab(tabKey)
	local tabNode = nil
	if tabKey == PlayerEffectType.cityicon or tabKey == PlayerEffectType.mounticon then
		tabNode = self.m_allTabNode[TabNameIndex.kSkin]
		if not tabNode then
			tabNode = CityEffectTab:create({tabType = tabKey})
			self:addChild(tabNode)
		end
		self.m_allTabNode[TabNameIndex.kSkin] = tabNode
	else
		tabNode = self.m_allTabNode[TabNameIndex.kPlayer]
		if not tabNode then
			tabNode = CityIconTab:create({tabType = tabKey})
			self:addChild(tabNode)
		end
		self.m_allTabNode[TabNameIndex.kPlayer] = tabNode
	end
	return tabNode
end

function This:onTabHasChanged(tabKey)
	-- GamePlayer:refreshOwnedRoleWidgetList() -- 把过期的widget删除

	for _,tab in pairs(self.m_allTabNode) do
		tab:setVisible(false)
	end
	local cityEffectTab = self:createTab(tabKey)
	
	if cityEffectTab then
		cityEffectTab:setVisible(true)
		cityEffectTab:setTabType(tabKey)
		cityEffectTab:refresh()
	end
end