-- @Author: zheng
-- @Date:   2019-03-14 16:33:24
-- @Last Modified by:   zheng
-- @Last Modified time: 2019-06-25 16:31:13
-- @File Name: CityEffectItemView.lua

local This , super = class(...,"NodeUI")
local WorldMapManager = require("World.WorldMapManager")
local GameUtil = require("Util.GameUtil")
local GamePlayer = require("Player.GamePlayer")
This.fileName = "MenuScene/NodeUI/RoleCityAppearanceItem.csb"

function This:setModel( achieve, index )
    if achieve then
        self.m_config = achieve
        self.m_tabType = achieve.tabTypes
        self.m_myIndex = index
        self.m_islock = achieve.isHave --or {id= skinid,end_time =0}
    end
    -- self.xuanzhong:setVisible(selectIndex == self.m_myIndex)
    self:refresh()
end

function This:initNode(info)
    local tabType = info.tabType
    local configItem = info.configItem
    self.m_tabType = tabType
    self.m_config = configItem
    self.m_islock = configItem.isHave --or {id= skinid,end_time =0}
    self.m_myIndex = info.myIndex
    self.addHorseFun = info.addHorse
    self.refreshCitySkinFun = info.refreshCitySkin
    self.m_playerAttrType = GamePlayer:convertEffectTypeToPlayerAttrType(self.m_tabType)
    self.xuanzhong:setVisible(false)
    local w,h = self.bg:getContentSize()
    self:setContentSize(w,h)
    self:refresh()
    self:refreshLeftTime()
    self:refreshCitySkin()
end

function This:refreshCitySkin()
    if self.m_tabType == PlayerEffectType.mounticon then
        self.addHorseFun(true,self.item.item2,self.m_config)
        self.refreshCitySkinFun(false,self.item.item2,self.m_config)
    elseif self.m_tabType == PlayerEffectType.cityicon then
        self.addHorseFun(false,self.item.item2,self.m_config)
        self.refreshCitySkinFun(true,self.item.item2,self.m_config)
    end
end

function This:refresh()
    -- self.pifu:setImage(self.m_config.image)
    -- self.m_curentSelectId = GamePlayer:getPlayerAttrWithType(self.m_playerAttrType,1)
    -- local islock = false
    -- if self.m_islock then
    --     islock = true
    -- end
    -- self.name:setString(self.m_config.name)
    -- self.name:setColorByID("Q".. self.m_config.quality)
    -- -- self.time:setString(self:getTime(self.m_config.time))
    -- self.from:setString(self.m_config.unlock_des)--红字节点 暂无

    -- local isUsed = self.m_curentSelectId == self:getId()

    -- self.from:setVisible(not islock and not isUsed)--未解锁
    -- -- self.time:setVisible(islock )--已解锁
    -- self:refreshLeftTime()
    -- self.onoff:setVisible(islock or isUsed)--已解锁
    -- self.use:setVisible(isUsed)
    -- self.button1:setVisible(not isUsed and islock)--已解锁
end

-- function This:initTouchEvent()

--     self.bg:setTouch({
--         isScale = false, 
--         isDynamic = true, 
--         isSwallow = false,
--         onEnded = function()
--             print("点击")
--             if self.m_btnHandle then
--                 self.m_btnHandle()
--             end
--         end
--     }) 

--     self.button1:setTouch({
--         isScale = false, 
--         isDynamic = true, 
--         onEnded = function()
--             print("使用皮肤")
--             if WorldMapManager:isInWorld() then
--                 local tioStr = Serialize["Player_CityEffect_2"]
--                 if self.m_tabType == PlayerEffectType.mounticon then
--                     tioStr = Serialize["Player_CityEffect_3"]
--                 end
--                 g_scene:openDialog("UI.CostConfirmPanel", {
--                 simple = tioStr, 
--                 okHandler = function(build)
                    
--                 end } )
--                 return false
--             end
--             GamePlayer:onRefreshGamePlayerEffectRequest(self.m_tabType,self:getId())
--         end
--     }) 

--     self.gantanhao:setTouch({
--         isScale = false, 
--         isDynamic = true, 
--         onEnded = function()
--             g_scene:openDialog("UI.HelpTips", {text = self.m_config.des,node = self.gantanhao})
--         end
--     }) 

-- end

function This:onEnter()
    super.onEnter(self)
	GamePlayer:addObserver(self)
end

function This:onExit()
    super.onExit(self)
    GamePlayer:removeObserver(self)
end

-- function This:getId()
--     return self.m_config.id
-- end

function This:refreshLeftTime()
    local skinItem= self.m_islock or {id= nil,end_time =0}
    local curentTime = GamePlayer:getServerTime()
    local time = skinItem.end_time
    local res =""
    -- local timeVisible = true
    if time ~= -1 then
        local offsetTime = time-curentTime
        if offsetTime>0 then
            time = offsetTime
        -- else
            -- timeVisible = false
        end

        local day,hour,minue,second = GameUtil:getFormatDtime(time)
        -- res = GameUtil:formatTime( Serialize[60148],time)
        if day>0 then
            res = string.format(Serialize[62299],day,hour)
        elseif hour>0 then
            res = string.format(Serialize[62300],hour,minue)
        elseif minue>0 then
            res = string.format(Serialize[62301],minue,second)
        elseif second>0 then
            res = string.format(Serialize[61501],second)
        end
    else
        res = Serialize[62302]
    end
    -- if time ==0 then
    --     timeVisible = false
    -- end
    local str = string.format(Serialize[62303],res)
    local timeNode = self.time
    timeNode:setString(str)
    timeNode:setVisible(self:isHaveMy())
    -- return str  
end

function This:setBtnHandle(btnclick)
    self.m_btnHandle = btnclick
end

function This:getMyIndex()
   return self.m_myIndex 
end

function This:isHaveMy()
    return self.m_config.isHave
end

function This:setSelect(selectIndex)
    self.m_selectIndex = selectIndex
    self:updateSelectState()
end

function This:updateSelectState()
    if self.m_selectIndex then        
        self.xuanzhong:setVisible(self.m_selectIndex == self.m_myIndex)
    end
end


function This:onPlayerAttrChanged(attrType)
    if attrType == PlayerAttr.cityicon or PlayerAttr.mounticon then
        self:refresh()
    end
end