-- @Author: zheng
-- @Date:   2019-03-14 16:20:08
-- @Last Modified by:   zheng
-- @Last Modified time: 2019-12-23 10:12:44
-- @File Name: CityEffectTab.lua

local This , super = class(...,"NodeUI")
local GameUtil = require("Util.GameUtil")
local CityAppearanceConfig = require("Metadatas.CityAppearanceConfig")
local MarchAppearanceConfig = require("Metadatas.MarchAppearanceConfig")
-- local CityEffectItemView = require("Player.CityEffectItemView")
local RoleWidgetItemView = require("Player.RoleWidgetItemView")
local GamePlayer = require("Player.GamePlayer")
local PlayerMarchArmyPathView = require("Player.PlayerMarchArmyPathView")
local UpdateLayer = require("Rank.RankPageListLayer")

This.fileName = "MenuScene/NodeUI/RoleChangePlayer.csb"
function This:initNode(info)
    if info then
       self.m_tabType = info.tabType
    end
    self:setToCenter()
    self:getData()
    self.m_listLayer = UpdateLayer:create({
        itemWidth = 358,
        itemHeight = 104,
        spaceX = 0,
        spaceY = 2,
        scrollView = self.scrollView,
        dataCounter = function ()
            return #self.m_configlist
        end,
     viewCreator =  function(index, node)

            local item = self.m_configlist[index]
            if item then
                if not node then
                    return self:getScroolItem(item,index)
                else
                    node:setModel(item, index)
                end
            end
        end,
        hint = self.m_selectIndex,
    })
    
    local w , h = self.m_listLayer:getContentSize()
    self.scrollView:pushBackCustomItem(self.m_listLayer, w, h, 0)
    self.m_listLayer:setCascadeOpacityEnabled(true)
    
    self.m_isUpdating = false
    self.m_escape = 0
    self.m_isUpdating = true
    self:scheduleUpdate()
end

function This:setTabType(tabType)
    if tabType then
        self.m_tabType = tabType
        self:getData()
    end
end

function This:initTouchEvent()

    self.gantanhao:setTouch({
        isScale = false, 
        isDynamic = true, 
        onEnded = function()
            local configItem = self.m_configlist[self.m_selectIndex]
            g_scene:openDialog("UI.HelpTips", {text = configItem.des or "kjlkjlkjlkjlk",node = self.gantanhao})
        end
    }) 

end

function This:refresh(isOld)
    self:getData()
    self:refreshCommon()
    self:refreshScroolView()
end

function This:refreshCitySkin(isAdd,csNode,config1)
    local function sheckIsEmptyStr(str)
        if not str or (str and str == "") then
            return true
        end
        return false
    end
    local function createAnim( parent,anmStr )
        local GameUtil = require("Util.GameUtil")
        local effect1 = GameUtil:createEffect(anmStr,true)
        parent:addChild(effect1)
        return effect1
    end
    local cityItem = csNode.item5
    cityItem:setVisible(isAdd)
    if not isAdd then
        return
    end
    local cityIcon = cityItem.city
    local effectNode = cityItem.effect
    local configItem = config1--self.m_configlist[self.m_selectIndex]
    local cityPictures = configItem.city_picture
    local cityEffects = configItem.city_effect
    local lv = 5--math.random(1,5)
    local cityPicture = cityPictures[lv]
    local cityEffect = cityEffects[lv]
    local cityEmpty = sheckIsEmptyStr(cityPicture)
    local effectEmpty = sheckIsEmptyStr(cityEffect)
    cityIcon:setVisible(not cityEmpty)
    effectNode:setVisible(not effectEmpty)
    if not cityEmpty then
        cityIcon:setImage(string.format("GameScene/%s.png",cityPicture))
    end

    effectNode:removeAllChildren()
    if not effectEmpty then
        local effect = createAnim(effectNode,cityEffect)
    end


end

function This:addHorse(isAdd,csNode,config1)
    local horseItem = csNode.item4
    horseItem:setVisible(isAdd)
    local startNode = horseItem.start_node
    local endNode = horseItem.end_node
    local effectParent = horseItem.effect
    local nodeList = {startNode,endNode,effectParent}
    for _,node in pairs(nodeList) do
        node:removeAllChildren()
    end
    if not isAdd then
        return
    end
    local configItem = config1--self.m_configlist[self.m_selectIndex]

    if isAdd then
        local info = {effectParent = effectParent,fromNode=startNode ,toNode =endNode,
        marchName = configItem.house_animation,file = "Common/gongji.png",
        configId= configItem.id}
        local view = PlayerMarchArmyPathView:create(info)
        info.fromNode:addChild(view)
    end
end

function This:addMarchPaoMaEffect(effectNode)
    local effectParent = self.skin.item4.effect
    effectParent:addChild(effectNode)
    effectNode:setPosition(0,0)
end

function This:refreshAttr()
    local configItem = self.m_configlist[self.m_selectIndex]
    -- local attrCount =4
    GameUtil:resetTexts(self.shiyonghou,{Serialize["no"]},false,3)
    GameUtil:resetTexts(self.yongyou,{Serialize["no"]},false,3)
    -- if #attribute==0 then
    --     self.text1:setString(Serialize["Player_CityEffect_1"])
    --     for index=2,attrCount do
    --         self["text"..index]:setVisible(false)
    --     end
    -- else
    --     for index=1,attrCount do
    --         local txt = self["text"..index]
    --         local attrItem = attribute[index]
    --         local txtVisible = false
    --         if attrItem then
    --             txtVisible = true
    --             local name,value = GameUtil:getAttrStr(attrItem[1],attrItem[2])
    --             local str = string.format("%s%s%s",Serialize["Awake_FameUp_3_c"],name,value)
    --             txt:setString(str)
    --         end
    --         txt:setVisible(txtVisible)
    --     end
    -- end
end

function This:refreshCommon()
    self:refreshAttr()
    local tabType = self.m_tabType
    local configItem = self.m_configlist[self.m_selectIndex]
    local skinNode = self.skin
    if tabType == PlayerEffectType.mounticon then
        self:addHorse(true,skinNode,configItem)
        self:refreshCitySkin(false,skinNode,configItem)
    else
        self:addHorse(false,skinNode,configItem)
        self:refreshCitySkin(true,skinNode,configItem)
    end
    skinNode:setVisible(true)
    skinNode.name:setString(configItem.name, AppText:isChinese() and 27 or nil)
end

function This:refreshScroolView()
    -- self.m_listLayer:setDataList(self.m_configlist, function(achieve, index)
    --     return self:getScroolItem(achieve,index)
    -- end,nil,self.m_selectIndex)
    self.m_listLayer:clearNode(true, true)
    self.m_listLayer:setDataList()
    self:refreshSelectState()
end

function This:refreshSelectState(refreshId)
    local viewList = self.m_listLayer:getAllViews()
    for _,item in pairs(viewList) do
        item:setSelect(self.m_selectIndex)
        if refreshId and refreshId == item:getId() then
            self:refreshCommon()
        end
    end
end

function This:getScroolItem(data,index)
    
    local selectIndex = self.m_selectIndex
    -- local haveSkins = GamePlayer:getPlayerEffectListWithType(self.m_tabType)
    local sinId = data.id or data.ID
    local info= {tabType = self.m_tabType,configItem = data,isSelect = (selectIndex== index),
        addHorse = function (isAdd,csNode,config1)
            self:addHorse(isAdd,csNode,config1)
        end,
        refreshCitySkin = function (isAdd,csNode,config1)
            self:refreshCitySkin(isAdd,csNode,config1)
        end}
        info.myIndex = index
    local view = RoleWidgetItemView:create(info)
    view:setSelect(selectIndex)
    view:setBtnHandle(function (selectView)
        local selectViewIndex = selectView:getMyIndex() 
        if self.m_selectIndex ~= selectViewIndex then
            self.m_selectIndex = selectViewIndex
            self:refreshSelectState(selectView:getId())
        end
    end)
    return view
end

function This:onEnter()
    super.onEnter(self)
    GamePlayer:addObserver(self)
end

function This:onExit()
    super.onExit(self)
    GamePlayer:removeObserver(self)
end

function This:update(dt)
    self.m_escape = self.m_escape + dt
    if self.m_escape > 1 then
        self.m_escape = self.m_escape - 1
        local viewList = self.m_listLayer:getAllViews()
        for _,view in pairs(viewList) do
            if self.m_isUpdating and view then
                view:refreshLeftTime()
            end
        end
    end
end

function This:sortList()
   local temList = {}
   local allList = self.m_configlist or {}
   local haveSkins = GamePlayer:getPlayerEffectListWithType(self.m_tabType)
   for _,configItem in pairs(allList) do
       local temItem = table.clone(configItem or{})
       local aId = temItem.id or temItem.ID
       temItem.tabTypes = self.m_tabType
       temItem.isHave = haveSkins[aId]
       table.insert(temList,temItem)
   end
    table.sort(temList,function (a,b)
        local aId,bId = a.id or a.ID ,b.id or b.ID
        local compareQuality = a.quality>b.quality
        local aHave,bHave = haveSkins[aId],haveSkins[bId]
        if self.m_curentSelectId~=-1 then
            local aSelect,bSelect = aId == self.m_curentSelectId, bId == self.m_curentSelectId
            if aSelect then
                return true
            end
            if bSelect then
                return false
            end
        end
        if aHave or bHave then
            if aHave and bHave  then
                
            elseif aHave then
                return true
            else
                return false
            end
        end
        return compareQuality
    end)
    local temSelect = 1
    for index,configItem in ipairs(temList) do
        local id = configItem.id or configItem.ID
        if id == self.m_curentSelectId then
            temSelect = index
            break
        end
    end
    return temList,temSelect
end

function This:getData()
    local tabType = self.m_tabType
    self.m_configlist = CityAppearanceConfig
    if tabType == PlayerEffectType.mounticon then
        self.m_configlist = MarchAppearanceConfig
    end
    self.m_playerAttrType = GamePlayer:convertEffectTypeToPlayerAttrType(tabType)
	self.m_curentSelectId = GamePlayer:getPlayerAttrWithType(self.m_playerAttrType,1)
    local temList,temSelect = self:sortList()
    self.m_selectIndex = temSelect
    self.m_configlist = temList
end

function This:onModifyGamePlayerSkin(effectType,effectId)
    if effectType and effectId then
        if effectType == self.m_tabType then
            self.m_listLayer:clearNode(true,true)
            self:refresh(true)
        end
    end
end


function This:onCheckSkinLeftTime()
    self.m_isUpdating = false
    self:refresh(true)
    self.m_isUpdating = true
end


function This:onRefreshGamePlayerEffect()
    self.m_listLayer:clearNode(true,true)
    self:refresh(true)
end
