-- @Author: zheng
-- @Date:   2019-03-14 16:20:08
-- @Last Modified by:   zheng
-- @Last Modified time: 2019-07-18 14:29:43
-- @File Name: CityIconTab.lua

local This , super = class(...,"Player.CityEffectTab")
local GameUtil = require("Util.GameUtil")
local ImageConfig = require("Metadatas.ImageConfig") -- 头像配表
local TitleConfig = require("Metadatas.TitleConfig") -- 称号配表
local ImageEffectConfig = require("Metadatas.ImageEffectConfig") -- 头像特效配表

local RoleWidgetItemView = require("Player.RoleWidgetItemView")
local GamePlayer = require("Player.GamePlayer")

This.fileName = "MenuScene/NodeUI/RoleChangePlayer.csb"

function This:initNode(info)
    super.initNode(self,info)
end

function This:refreshCommon()
    self:refreshAttr()
    local temTabType = self.m_tabType
    local configItem = self.m_configlist[self.m_selectIndex]
    local tabNode = nil
    local headVisible = false
    local iconVisible = false
    if temTabType == PlayerEffectType.title or temTabType == PlayerEffectType.effect then
        headVisible = true
        local mytitle = GamePlayer:getTitle()
        local icon = self.head.icon
        if temTabType == PlayerEffectType.title then
            mytitle = configItem.ID
            GameUtil:setPlayerIconNodeImage(icon, GamePlayer:getIcon())
            GameUtil:setPlayerEffectNodeTo(icon, GamePlayer:getEffect())
        else
            GameUtil:setPlayerIconNodeImage(icon, GamePlayer:getIcon())
            GameUtil:setPlayerEffectNodeTo(icon, configItem.ID)
        end
        local chenghaoVisible = false
        if mytitle ~= 0 then
            chenghaoVisible = true
            self.head.chenghao.chenghao:setImage(TitleConfig[mytitle].head)
            local bgPath = TitleConfig[mytitle].titlebg
            local bgImage =self.head.chenghao.chenghaobg
            if bgPath ~= "" then
                bgImage:setImage(bgPath)
            end
            bgImage:setVisible(bgPath ~="")
        end
        self.head.chenghao:setVisible(chenghaoVisible)
        self.head.name:setString(configItem.name, AppText:isChinese() and 27 or nil)
    elseif temTabType == PlayerEffectType.icon then
        iconVisible = true
        GameUtil:setPlayerFeltNodeResource(self.icon.icon,configItem.ID)
        GameUtil:setPlayerEffectNodeTo(self.icon.icon)
        self.icon.name:setString(configItem.name, AppText:isChinese() and 27 or nil)
    end
    self.icon:setVisible(iconVisible)
    self.head:setVisible(headVisible)
end

function This:addHorse(isAdd,csNode,config1)
end
function This:refreshCitySkin(isAdd,csNode,config1)
end


function This:getData()
    local tabType = self.m_tabType

    local configlist = ImageEffectConfig
    local normlSelect = -1--101
    -- local ownerIdKeys = 
    if tabType == PlayerEffectType.icon then--头像
        local temImageConfig = {}
        for id,configItem in pairs(ImageConfig) do
            if configItem.valid == 1 then
                table.insert(temImageConfig,table.clone(configItem or {}))
            end
        end
        configlist = temImageConfig
        normlSelect =-1--1
    elseif tabType == PlayerEffectType.title then-- 称号
        configlist = TitleConfig
    -- elseif tabType == PlayerEffectType.effect then-- 头像特效
    --     configlist = MarchAppearanceConfig
    end
    self.m_playerAttrType = GamePlayer:convertEffectTypeToPlayerAttrType(tabType)
	self.m_curentSelectId = GamePlayer:getPlayerAttrWithType(self.m_playerAttrType,normlSelect)
    self.m_configlist = configlist
    local temList,temSelect = self:sortList()
    self.m_selectIndex = temSelect
    self.m_configlist = temList
end


function This:onModifyGamePlayerSkin(effectType,effectId)
    if effectType and effectId then
        if effectType == self.m_tabType then
            self.m_listLayer:clearNode(true,true)
            self:refresh(true)
        end
    end
end