--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"LoadingScene")
local GameEvent = require("Event.GameEvent")
local AsynchEvent = require("Event.AsynchEvent")
local IterateEvent = require("Event.IterateEvent")
local GamePlayer = require("Player.GamePlayer")
local VipManager = require("Vip.VipManager")
local EquipManager = require("Equip.EquipManager")
local HeroManager = require("Hero.HeroManager")
local GameStageManager = require("Stage.GameStageManager")
local ChatManager = require("Chat.ChatManager")
local FriendManager = require("Friend.FriendManager")
local MailManager = require("Mail.MailManager")
local ReportManager = require("Report.ReportManager")
local HeroListManager = require("List.HeroListManager")
local MatchManager = require("Match.MatchManager")
local RecruitManager = require("Recruit.RecruitManager")
local SdkManager = require("Sdk.SdkManager")
local AchieveManager = require("Achieve.AchieveManager")
local LoginManager = require("Login.LoginManager")
local EventDispatcher = require("EventDispatcher")
local AsynchEvent = require("Event.AsynchEvent")
local RedDotManager = require("RedDot.RedDotManager")
local DailyAchieveManager = require("Achieve.DailyAchieveManager")
local MatchManager = require("Match.MatchManager")
local ArenaManager = require("Arena.ArenaManager")
local FamilyManager = require("Family.FamilyManager")
local FamilyRatingManager = require("FamilyRating.FamilyRatingManager")
local ArrayManager = require("Hero.ArrayManager")
local ActivityManager = require("Activity.ActivityManager")
local NobilityManager = require("Nobility.NobilityManager")
local ArmyTacticalManager = require("ArmyTactical.ArmyTacticalManager")
local CompetitionManager = require("Competition.CompetitionManager")
local DrumManager = require("Drum.DrumManager")

function This:init()
	super.init(self)
	self.m_total = 0
	self.m_progress = 0
	RedDotManager:initRedDots()
	self:initListener()
end

function This:initListener()
	self.m_eventList = {
		10202, --请求服务器时间
		10200, --请求玩家信息
		11700, --请求vip信息
		10600, --请求装备信息
		10400, --请求武将信息
		10700, --请求关卡信息
		10801, --请求历史聊天信息
		10900, --请求好友信息
		11001, --请求邮件信息
		10301, --请求战报信息
		11200, --请求竞技场信息
		11212, --请求竞技场宝箱信息
		10208, --请求武将队列信息
		11900, --请求主线任务信息
		11800, --请求招募信息
		12005, --请求在线活动
		12000, --请求首充活动
		12200, --竞技场信息
	}
	local task = nil
	for i , event in ipairs(self.m_eventList) do
		EventDispatcher:addListener(self,event,function()
			self.m_progress = self.m_progress + 1
			EventDispatcher:removeListener(self,event)
		end)
		self.m_total = self.m_total + 1
	end

	--jpushID
	--if not os.isWin32 then
	--	EventDispatcher:addListener(self,10007,function()
	--		self.m_progress = self.m_progress + 1
	--	end)
	--	self.m_total = self.m_total + 1
	--end
	--初始化完成通知
	EventDispatcher:addListener(self,10203,function()
		--SdkManager:onPushJPushIDToServerRequest()
		MatchManager:onGetMatchInfoRequest()
		AchieveManager:onGetAchieveInfoRequest(AchieveType.kMainLine)
		AchieveManager:onGetAchieveInfoRequest(AchieveType.kGongXun)
		AchieveManager:onGetAchieveInfoRequest(AchieveType.kWeiWang)
		AchieveManager:onGetAchieveInfoRequest(AchieveType.kZhengJi)
		ActivityManager:onGetPhoneCardRequest(0)

		DailyAchieveManager:onGetDailyAchieveRequest()
		DailyAchieveManager:onGetCrusadeInfoRequest()
		ArenaManager:onGetFristRankRoleRequest()
		FamilyManager:onGetMyFamilyInfoRequest()
		FamilyRatingManager:onGetCastInfoRequest()
		ArrayManager:onGetArrayInfoRequest()
		NobilityManager:onAllRequest()
		ArmyTacticalManager:onArmyTactInfoRequest()
		CompetitionManager:onGetSelfInfoRequest()
		DrumManager:onGetDrumRequest()
		cc.Audio:preLoad()
		self.m_timer:setTimer(0.5,function()
			GamePlayer:onGameDataLoadFinishNotify()
		end,"init_data")
	end)
end

function This:removeListener()
	EventDispatcher:removeListener(self,10007)
	EventDispatcher:removeListener(self,10203)
end

function This:onEnter()
	super.onEnter(self)
	self.m_csLoadingNode:setLocalZOrder(0)
end

function This:onExit()
	super.onExit(self)
	self:removeListener()
end

function This:updateProgress()
	if self.m_csLoadingNode then
		local progress = self.m_progress / self.m_total
		self.m_csLoadingNode.progress.bar:setPercent(progress * 100)
		self.m_csLoadingNode.progress.state:setString(string.format("%d",progress*100).."%")
		local posx = self.m_csLoadingNode.progress.bg:getPositionX() 
		local width = self.m_csLoadingNode.progress.bg:getContentWidth() * progress
		self.m_csLoadingNode.progress.light:setPositionX(posx + width)
	end
end

function This:update(dt)
	self.m_timer:update(dt)
	self:updateProgress()
end

--endregion
