-- @Author: zheng
-- @Date:   2019-06-17 19:45:40
-- @Last Modified by:   zheng
-- @Last Modified time: 2020-07-03 16:49:13
-- @File Name: RoleChangePlayerItemChoicePanel.lua

local GameUtil = require("Util.GameUtil")
local This , super = class(...,"Dialog")
local RoleChangePlayerItemChoiceItemView = require("Player.RoleChangePlayerItemChoiceItemView")
local DepotManager = require("Depot.DepotManager")

This.fileName = "MenuScene/NodeUI/RoleChangePlayerItemChoice.csb"
function This:initNode(info)
    -- self.m_listData = info or {{110,7}}
    -- self.m_listData = info or {{110,7},{111,7}}
    -- self.m_listData = info or {{110,7},{111,7},{113,7}}
    self.m_listData = info.listData--info or {{110,7},{112,7},{113,7},{114,7}}
    self.m_okHandler = info.okHandler
    self.m_selectIndex = nil
    self.m_csNode = cc.Node:createFromCSFile(This.fileName)
    self.m_csNode:setToCenter()
    self:addChild(self.m_csNode)
    -- self:getData()
    self:refresh()
    self:resetScoolItemNode(self.m_csNode.scrollviewnode,self.m_listData,4,function (data)
        return self:createItem(data)
    end)
end

function This:refresh()
    self.m_csNode.text:setVisible(not self.m_selectIndex)
    self.m_csNode.button1:setVisible(self.m_selectIndex)
end

function This:resetScoolItemNode(parent,listData,recommendCount,createHandler,spaceNum)
    if not spaceNum then
        spaceNum = 0
    end
    local w = 0
    -- local width =92+10
    local oneNum = nil
    for itemId,itemValue in ipairs(listData) do
        local node = createHandler(itemValue)
        if not oneNum then
            oneNum = node:getContentWidth() + spaceNum
        end
        -- node:setAnchorPoint(0,0.5)
        node:setPositionX(w)
        w = w+oneNum
        -- print(itemId,"width",w)
        parent:addChild(node)
    end
    if oneNum then
        local listNum = #listData
        -- print(listNum)
        local posx =(listNum-1)*oneNum/2
        -- print("posx",posx)
        parent:setPositionX(-posx) 
    end
end

function This:initTouchEvent()
	local csNode = self.m_csNode
	csNode.close:setTouchEnded(function()
        self:close()
    end)
    csNode.button1:setTouchEnded(function()
        local item = self.m_listData[self.m_selectIndex]
        -- print("kkk",item[self.m_selectIndex])
        if self.m_selectIndex and  self.m_selectIndex > 0 then
            local itemId = item[1]
            if itemId and DepotManager:getItemCount(itemId)>0 then
                local item1 = DepotManager:getItem(itemId)
                DepotManager:useItem(item1, 1, 0) 
            else
                g_scene:showTips(Serialize[60731])
            end
            -- 
             self:close()
        end

    end)
end


function This:createItem(data)

    local node = RoleChangePlayerItemChoiceItemView:create(data)
    node:setBtnHandle(function (view)
        local csNode = self.m_csNode
        csNode.text:setVisible(false)
        csNode.button1:setVisible(true)
        local viewList = csNode.scrollviewnode:getChildren()
        for index,item in ipairs(viewList) do
            if view:getId() == item:getId() then
                item:setSelect(true)
                self.m_selectIndex = index
            else
                item:setSelect(false)
            end
        end
    end)
    return node
end
