--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"Dialog")
local HeroConfig = require("Metadatas.HeroConfig")
local GameUtil = require("Util.GameUtil")
local HeroUtil = require("Hero.HeroUtil")
local ListLayer = require("UI.ListLayer")
local UpdateLayer = require("UI.UpdateLayer")

function This:initNode(heroList)
	self.m_heroList = heroList

	table.sort(self.m_heroList,function(a,b)
		if a.quality ~= b.quality then
			return a.quality > b.quality
		end
		return a.type_id < b.type_id
	end)


	self.m_csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/RoleHeroList.csb")
	self:addChild(self.m_csNode)
	self.m_csNode:setToCenter()

	self.m_listLayer = UpdateLayer:create({
		itemWidth = 116,
		itemHeight = 150,
		itemCount = #heroList,
		column = 6,
		scrollView = self.m_csNode.heroList
	})
	self.m_listLayer:setDataList(self.m_heroList,function (hero)
		local node = self:getHeroNode(hero)
		return node
	end)
	self.m_listLayer:setAnchorPoint(0.5,0)
	local w , h = self.m_listLayer:getContentSize()
	self.m_csNode.heroList:pushBackCustomItem(self.m_listLayer, w,h,0)
	self.m_listLayer:setCascadeOpacityEnabled(true)
end

function This:getHeroNode(hero)
	local function refresh(node,info)
		local quality = info.quality
		node.country:setString(CountryName[HeroConfig[info.type_id].country])
		local color = SmallCardQualityColor[quality]
		node.country:setColor(color.r , color.g, color.b)

		node.name:setString(HeroConfig[info.type_id].name, AppText:isChinese() and 10 or nil)
		node.level:setString(info.level)

		node.heroqulitybg:setImage(QualityBgFile[quality])
		node.bg:setImage(QualityFrameFile[quality])
		node.icon:setImage(GameUtil:getHeroIcon(HeroConfig[info.type_id].icon))
		-- node.herofightbg:setImage(QualityFightPowerFrameFile[quality])
	end
	local node = cc.Node:createFromCSFile("MenuScene/NodeUI/RoleHeroListItem.csb")
	refresh(node,hero)
	
	node.setModel = function(_,info)
		refresh(node,info)
	end
	return node
end

function This:initTouchEvent()
	self.m_csNode.close:setTouchEnded(function()
		self:close()
	end)
end

--endregion
