--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"Dialog")
local GameUtil = require("Util.GameUtil")
local RoleLevelConfig = require("Metadatas.RoleLevelConfig")
local MatchingConfig = require("Metadatas.MatchingConfig")
local GamePlayer = require("Player.GamePlayer")
local BaseInfoNode = require("Player.BaseInfoNode")
local FriendMangager = require("Friend.FriendManager")

local TabName = 
{
	kBase = "base",
	kBattle = "battle",
}

function This:initNode(info)
	FriendMangager:onGetFriendDetailRequest(info.id)
	self.m_csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/RoleInformationMain.csb")
	self:addChild(self.m_csNode)
	self.m_csNode:setToCenter()
	self:addTabButton(TabName.kBase,self.m_csNode.qieye.teb1,function()
		self:selectTab(TabName.kBase)
	end)
	self:addTabButton(TabName.kBattle,self.m_csNode.qieye.teb2,function()
		self:selectTab(TabName.kBattle)
	end)
end

function This:initFinish(info)
	self.m_info = info
	self.m_isMy = GamePlayer:getPlayerID() == info.friend_detail.id
	self.m_csNode.qieye:setVisible(self.m_isMy)
	self.m_curTab = ""
	self:selectTabButton(TabName.kBase)
end

function This:initTouchListener()
	self.m_csNode.close:setTouchEnded(function()
		self:close()
	end)
end

function This:onEnter()
	super.onEnter(self)
	FriendMangager:addObserver(self)	
end

function This:onExit()
	FriendMangager:removeObserver(self)
	super.onExit(self)
end

function This:onGetFriendDetail(msg)
	self:initFinish(msg)
	self:initTouchListener()
end

function This:selectTab(tab)
	if self.m_curTab ~= tab then
		self.m_curTab = tab
		if self.m_node then
			self.m_node:removeFromParent()
		end
		self.m_node = self:getTabNode()
		self.m_node:setCascadeOpacityEnabled(true)
		print_r({self.m_node:getPosition()})
		self.m_csNode:addChild(self.m_node)
	end
end

function This:getTabNode()
	if self.m_curTab == TabName.kBase then
		return BaseInfoNode:create(self.m_info)
	else
		return cc.Node:create()
	end
end





--endregion
