---
---
--- Created by aid.
--- DateTime: 2018/12/7 10:17
---
-- local This , super = class(...,"Player.CityEffectItemView")
local This , super = class(...,"Player.CityEffectItemView")
This.fileName = "MenuScene/NodeUI/RoleChangePlayerItem.csb"
-- This.fileName = "MenuScene/NodeUI/RoleCityAppearanceItem.csb"
local TitleConfig = require("Metadatas.TitleConfig") -- 称号配表
local WorldMapManager = require("World.WorldMapManager")

local GameUtil = require("Util.GameUtil")
local GamePlayer = require("Player.GamePlayer")
local DepotManager = require("Depot.DepotManager")

function This:initTouchEvent()

    self.bg:setTouch({
        isScale = false, 
        isDynamic = true, 
        isSwallow = false,
        onEnded = function()
            print("点击")
            if self.m_btnHandle then
                self.m_btnHandle(self)
            end
        end
    }) 

    self.button1:setTouch({
        isScale = false, 
        isDynamic = true, 
        onEnded = function()
            print("使用皮肤")
            local temTabType = self.m_tabType
            if temTabType == PlayerEffectType.mounticon  or temTabType == PlayerEffectType.cityicon then
                if WorldMapManager:isInWorld() then
                    local tioStr = Serialize["Player_CityEffect_2"]
                    if self.m_tabType == PlayerEffectType.mounticon then
                        tioStr = Serialize["Player_CityEffect_3"]
                    end
                    g_scene:openDialog("UI.CostConfirmPanel", {
                    simple = tioStr, 
                    okHandler = function(build)
                        
                    end } )
                    return false
                end
            end
            GamePlayer:onRefreshGamePlayerEffectRequest(self.m_tabType,self:getId())
        end
    }) 
    self.button2:setTouch({
        isScale = false, 
        isDynamic = true, 
        onEnded = function()
            print("激活")
            self:jihuoCallBack()
        end
    }) 

    self.jiahao:setTouch({
        isScale = false, 
        isDynamic = true, 
        onEnded = function()
            self:jiaHalCallBack()
            -- g_scene:openDialog("UI.HelpTips", {text = self.m_config.des,node = self.gantanhao})
        end
    }) 

end

function This:jiaHalCallBack()
    -- g_scene:showTips(Serialize[63964]) -- TODO 国际化
    local items = self.m_config.item or {}
    g_scene:openDialog("Player.RoleChangePlayerItemChoicePanel",{listData = items})
end

function This:jihuoCallBack(jiaHao)
    local items = self.m_config.item or {}
    if #items>0 or jiaHao then
        self:jiaHalCallBack()
    else
        local priceItem= self.m_config.price
        if priceItem and priceItem[2] and priceItem[2]>0 then
            local priceNum = priceItem[2]
            g_scene:openDialog("UI.CostConfirmPanel", {
                    cost = priceNum,
                    itemId = priceItem[1],
                    desc = string.format(Serialize[63965],self.m_config.name) , 
                    okHandler = function()
                        GamePlayer:onRefreshGamePlayerEffectRequest(self.m_tabType,self:getId())
            end })
        else
            g_scene:showTips(self.m_config.unlock_des or"") -- TODO 国际化
        end
    end
    
end

function This:createTabItem(tabType)
    local temTabType = self.m_tabType
    local configItem = self.m_config
    local headVisible = false
    local iconVisible = false
    local skinVisible = false
    local titleVisble = false
    local itemNode = self.item
    local iconNode = itemNode.item3--形象
    local headNode = itemNode.item4--特效
    local skinNode = itemNode.item2--城池皮肤
    local titleNode = itemNode.item1--称号
    local temCurent = headNode

    local mytitle = GamePlayer:getTitle()
    if temTabType == PlayerEffectType.title then--称号
        titleVisble = true
        temCurent = titleNode
        mytitle = configItem.ID
        -- if not skinVisible then
            local chenghaoVisible = false
            if mytitle ~= 0 then
                chenghaoVisible = true
                temCurent.chenghao.chenghao:setImage(TitleConfig[mytitle].head)
                local bgPath = TitleConfig[mytitle].titlebg
                local bgImage =temCurent.chenghao.chenghaobg
                if bgPath ~= "" then
                    bgImage:setImage(bgPath)
                end
                bgImage:setVisible(bgPath ~="")
                -- GameUtil:setPlayerTitleNodeTo(temCurent.chenghao,mytitle)
            end
            temCurent.chenghao:setVisible(chenghaoVisible)
        -- end
    elseif temTabType == PlayerEffectType.effect then--特效
        headVisible = true
        GameUtil:setPlayerEffectNodeTo(temCurent.effect, configItem.ID)
    --     if temTabType == PlayerEffectType.title then
    --         mytitle = configItem.ID
    --         GameUtil:setPlayerIconNodeImage(icon, GamePlayer:getIcon())
    --         GameUtil:setPlayerEffectNodeTo(icon, GamePlayer:getEffect())
    --     else
    --         GameUtil:setPlayerIconNodeImage(icon, GamePlayer:getIcon())
    --         GameUtil:setPlayerEffectNodeTo(icon, configItem.ID)
    --     end
    elseif temTabType == PlayerEffectType.icon then--形象
        iconVisible = true
        temCurent = iconNode
        local icon = iconNode.icon
        GameUtil:setPlayerIconNodeImage(icon, self:getId())
    --     GameUtil:setPlayerEffectNodeTo(icon, GamePlayer:getEffect())
    elseif temTabType == PlayerEffectType.mounticon  or temTabType == PlayerEffectType.cityicon then
        skinVisible = true
        temCurent = skinNode
        self:refreshCitySkin()
    end
    local quaility = configItem.quality
    if quaility ==2 then
        quaility =1
    end

    local bianQianPath = string.format("MenuScene/biaoqianxx%d.png",quaility)
    local imagePath = string.format("MenuScene/wordxx%d.png",quaility)
    temCurent.biaoqian:setImage(bianQianPath)
    temCurent.biaoqian.text:setImage(imagePath)

    iconNode:setVisible(iconVisible)
    headNode:setVisible(headVisible)
    skinNode:setVisible(skinVisible)
    titleNode:setVisible(titleVisble)
end

function This:refresh(isOld)
    self:updateSelectState()
    self:createTabItem()
    -- self.m_curentSelectId = GamePlayer:getPlayerAttrWithType(self.m_playerAttrType,1)
    -- self.pifu:setImage(self.m_config.image)
    local islock = false
    if self:isHaveMy() then
        islock = true
    end
    -- self.m_islock = islock
    self.name:setString(self.m_config.name)
    self.name:setColorByID("Q".. self.m_config.quality)
    -- self.time:setString(self:getTime(self.m_config.time))
    self.from:setString(self.m_config.unlock_des,250)--红字节点 暂无

    local isUsed = self:isUsed()

    self.from:setVisible(not islock and not isUsed)--未解锁
    self:refreshLeftTime()
    self.time:setVisible( islock)--已解锁
    self.onoff:setVisible(islock or isUsed)--已解锁
    self.use:setVisible(isUsed)
    -- self.button1:setVisible(not isUsed and islock)--已解锁
    self.button1:setVisible(not isUsed and islock)--已解锁
    self.button2:setVisible(not islock)
    local items = self.m_config.item or {}
    self.jiahao:setVisible(isUsed and #items>0)
end

function This:isUsed()
    self.m_curentSelectId = GamePlayer:getPlayerAttrWithType(self.m_playerAttrType,1)
    local isUsed = self.m_curentSelectId == self:getId()
    return isUsed
end

function This:getId()
    return self.m_config.ID or self.m_config.id
end

-- function This:refreshLeftTime()
--     super.refreshLeftTime(self)
--     -- self.time:setVisible( self:isHaveMy())--已解锁
-- end

