--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"Dialog")
local GameSetting = require("GameSetting")
local GamePlayer = require("Player.GamePlayer")
local GameUtil = require("Util.GameUtil")
local LoginManager = require("Login.LoginManager")

function This:initNode()
	self.m_csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/Stting.csb")
	if GamePlayer:isAuditVersion() then
		GameUtil:hideNodeList(self.m_csNode, {"Redeem", "text5"});
	end

	self:addChild(self.m_csNode)
	self.m_csNode:setToCenter()

	self.m_isOpenMusic = GameSetting:get("isOpenMusic")
	if self.m_isOpenMusic == nil then
		self.m_isOpenMusic = true
	end
	self.m_csNode.selectbg.select1:setVisible(self.m_isOpenMusic)

	self.m_isOpenEffect = GameSetting:get("isOpenSound")
	if self.m_isOpenEffect == nil then
		self.m_isOpenEffect = true
	end
	self.m_csNode.selectbg2.select2:setVisible(self.m_isOpenEffect)

	local id = GamePlayer:getPlayerID()
	local str = ""
	while id > 0 do  
		str = (id % 10) .. str  
		id = math.floor(id / 10) 
	end
	self.m_csNode.usenumber:setString(str)

	local server = LoginManager:getLoginServer()
	self.m_csNode.area:setString(server:getName())

	self:initLangUI()
end

function This:initTouchEvent()
	self.m_csNode.selectbg:setTouchEnded(function(args)
		self.m_isOpenMusic = not self.m_isOpenMusic
		self.m_csNode.selectbg.select1:setVisible(self.m_isOpenMusic)
		if self.m_isOpenMusic then
			cc.Audio:openBackground()
		else
			cc.Audio:closeBackground()
		end
		GameSetting:set("isOpenMusic",self.m_isOpenMusic)
		GameSetting:save()
	end)

	self.m_csNode.selectbg2:setTouchEnded(function()
		self.m_isOpenEffect = not self.m_isOpenEffect

		self.m_csNode.selectbg2.select2:setVisible(self.m_isOpenEffect)
		if not self.m_isOpenEffect then
			cc.Audio:closeAllEffect()
		else
			cc.Audio:openAllEffect()
		end
		GameSetting:set("isOpenSound",self.m_isOpenEffect)
		GameSetting:save()
	end)

	self.m_csNode.Redeem:setTouchEnded(function()
		g_scene:openDialog("Player.RedeemUI")
	end)

	self.m_csNode.charge:setTouchEnded(function()
		LoginManager:switchAccount()
	end)

	self.m_csNode.close:setTouchEnded(function()
		self:close()
	end)

	self:initLangTouch()
end

function This:initLangUI()
	local csNode = self.m_csNode
	local list = AppText:getLanguageOptions(true)

	self.m_langState = 0
	self.m_langOptNodes = {}

	for i, v in ipairs(list) do
		local node = csNode[string.format("langOpt%d", i)]
		if node then
			node.m_langType = v.id
			node.text:setString(v.text)
			node:setVisible(false)
			table.insert(self.m_langOptNodes, node)
		end
	end

	csNode.language.arrow:setRotation(180)
	csNode.language.text:setString( AppText:getLangTypeText(AppText:getLanguage()) )
end

function This:setLangSwitch(isOpen)
	for i, node in ipairs(self.m_langOptNodes) do
		node:setVisible(isOpen)
	end
	self.m_langState = isOpen and 1 or 0
	self.m_csNode.language.arrow:setRotation((self.m_langState == 0) and 180 or 0)
end

function This:initLangTouch()
	for i, node in ipairs(self.m_langOptNodes) do
		node:setTouchEnded(function()
			if node.m_langType then
				AppText:setLanguage(node.m_langType)
			end
		end)
	end

	self.m_csNode.language:setTouch({
		onEnded = function()
			if self.m_langState == 0 then
				self:setLangSwitch(true)
			else
				self:setLangSwitch(false)
			end
		end,
		isScale = false
	})
end




--endregion
