local This, super = class(..., "Dialog")
local QuestManager = require("Quest.QuestManager")
local ViewUtil = require("UI.ViewUtil")
local RedDotManager = require("RedDot.RedDotManager")

This.openSound = "Open_Ui.mp3"

local TabName = 
{
	kDaily = "daily",
    kMain = "main",
	kWeekly = "weekly",
	kGongXun = "gongxun"
}

function This:initNode(info)
    self.m_csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/TaskUI.csb")
    self.m_csNode:setPosition(cc.visible.center.x, cc.visible.center.y)
    self:addChild(self.m_csNode)
    self:addTabButton(TabName.kDaily, self.m_csNode.daily, function()
        if QuestManager:hasData() then
            self:openTabNode("Quest.DailyQuestUI")
        else
            QuestManager:loadData()
        end
    end)
    self:addTabButton(TabName.kMain, self.m_csNode.zhuxian, function()
        self:openTabNode("Achieve.MainTabNode")
    end)
    self:addTabButton(TabName.kWeekly, self.m_csNode.weekly, function()
        self:openTabNode("Achieve.WeeklyTabNode")
    end)

	self:addTabButton(TabName.kGongXun,self.m_csNode.battle,function()
		self:openTabNode("Achieve.GongXunTabNode")
	end)

	local tab = TabName.kDaily
	if info then
		tab = info.tab or tab
	end
	self:selectTabButton(tab)
    --ViewUtil:refreshRedDot(self.m_csNode.taskMain.hongdian, RedDotManager:getNodeDot("taskMain"))  
    --ViewUtil:refreshRedDot(self.m_csNode.taskDaily.hongdian, RedDotManager:getNodeDot("taskDaily"))  
    --ViewUtil:refreshRedDot(self.m_csNode.taskWeekly.hongdian, RedDotManager:getNodeDot("taskWeekly"))  
end

function This:initListener()
    QuestManager:addObserver(self, {
        loadData = function(self)
            self:openTabNode("Quest.DailyQuestUI")
        end,
    })
    --RedDotManager:addObserver(self)
end

function This:onExit()
    --RedDotManager:removeObserver(self)
    QuestManager:removeObserver(self)
    super.onExit(self)
end

function This:initTouchEvent()
    self.m_csNode.close:setTouchEnded(function()
        self:close()
    end)
end

function This:onSubRedDotChange( info )
    local node = self.m_csNode[info.name]
    if node then
        ViewUtil:refreshRedDot(node.hongdian, info.dot)  
    end
end