-- @Author: superm
-- @Date:   2017-12-28 10:27:04
-- @Last Modified by:   superm
-- @Last Modified time: 2018-03-10 17:09:00
-- @File Name: RankFamilyItemView.lua
-- @Description: 


local This , super = class(..., "Rank.RankOfficeItemView")
This.fileName = "MenuScene/NodeUI/RankingListFamilyItem.csb"

local FamilyManager = require("Family.FamilyManager")

function This:initTouchEvent()
    if not self.m_inited then
        self.m_inited = true
    end
end

function This:hideBg()
    self.bg:setVisible(false)
end

function This:refreshIcon( new, old )
end

function This:refreshName( info )
    self.name:setString( (info and info.role_name) or FamilyManager:getMyFamilyName() )
end

function This:refreshLevelInfo(new, old)
	self:refreshIcon(new, old)
	if new or old then
		if old then
			if old.rank_first_key ~= new.rank_first_key then
				self.integral:setString( new.rank_first_key)
			end

			if old.rank_second_key ~= new.rank_second_key then
				self.level:setString("Lv." .. new.rank_second_key)
			end

			if old.role_icon ~= new.role_icon then
				self.people:setString( new.role_icon)
			end
		else
			self.integral:setString(new.rank_first_key)
			self.level:setString("Lv." .. new.rank_second_key)
			self.people:setString(new.role_icon)
		end
	else
		local family = FamilyManager:getMyFamily()
		self.integral:setString( tostring(family:getScore()) )
		self.people:setString( tostring(family:getMemberNum()) )
		self.level:setString("Lv." .. family:getLevel() )
	end
end
