-- @Author: superm
-- @Date:   2017-11-29 11:49:47
-- @Last Modified by:   superm
-- @Last Modified time: 2017-12-28 19:18:44
-- @File Name: RankMainPanel.lua
-- @Description: 

local This , super = class(...,"Dialog")
local RankBaseUI = require("Rank.RankBaseUI")
local RankFamilyUI = require("Rank.RankFamilyUI")
local RankManager = require("Rank.RankManager")

function This:initNode()
	self.m_csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/RankingListMain.csb")
	self:addChild(self.m_csNode)
	self.m_csNode:setToCenter()

	for name, rankType in pairs(RankType) do
		local button = self.m_csNode.tabs[name .. "List"]
	    self:addTabButton(tostring(rankType), button, function()
	    	if self.m_curType == rankType then
	    		return false
	    	end
	        self.m_curType = rankType
			self:selectTabById(rankType)
	        return true
	    end)
	end
	-- self.m_csNode.tabs.FamilyList:setVisible(false)
end

function This:initTouchEvent()
	self.m_csNode.close:setTouchEnded(function()
		self:close()
	end)
end

function This:onEnter()
	super.onEnter(self)
	self:selectTabButton(tostring(RankType.Office))
end

function This:onExit()
	super.onExit(self)
	RankManager:clearInfo()
end

function This:selectTabById( rankType )
	self:openTabNode(tostring(rankType))
end

function This:createTabNode(name)
	if tonumber(name) ~= RankType.Family then
		return RankBaseUI:create(self.m_curType)
	else
		return RankFamilyUI:create(self.m_curType)
	end
end