--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"Dialog")
local HeroConfig = require("Metadatas.HeroConfig")
local HeroManager = require("Hero.HeroManager")
local UpdateLayer = require("UI.UpdateLayer")
local RecruitHeroView = require("Recruit.RecruitHeroView")
local RecruitHeroPanel = require("Recruit.RecruitHeroPanel")

local TabName = 
{
	kShu = "shu",
	kWei = "wei",
	kWu = "wu",
	kQun = "qun"
}

local TabCountry = 
{
	[TabName.kShu] = Country.kShuGuo,
	[TabName.kWei] = Country.kWeiGuo,
	[TabName.kWu] = Country.kWuGuo,
	[TabName.kQun] = Country.kQunXiong
}

function This:initNode()
	self.m_csNode = cc.Node:createFromCSFile("GameScene/NodeUI/HeroRecruitList.csb")
	self:addChild(self.m_csNode)
	self.m_csNode:setToCenter()

	self:addTabButton(TabName.kShu,self.m_csNode.teb1,function()
		self:selectTab(TabName.kShu)
	end)
	self:addTabButton(TabName.kWei,self.m_csNode.teb2,function()
		self:selectTab(TabName.kWei)
	end)
	self:addTabButton(TabName.kWu,self.m_csNode.teb3,function()
		self:selectTab(TabName.kWu)
	end)
	self:addTabButton(TabName.kQun,self.m_csNode.teb4,function()
		self:selectTab(TabName.kQun)
	end)

	self.m_heroList = {}
	self.m_gotCount = 0
	for id , config in pairs(HeroConfig) do
		if config.country > 0 and (id <= 10200 or id>=11001) then
			local hero = HeroManager:getHero(id)
			table.insert(self.m_heroList,hero)
			if hero:isGot() then
				self.m_gotCount = self.m_gotCount + 1
			end
		end
	end

	table.sort(self.m_heroList,function(a,b)
		local qa =a:getQuality()
		local qb = b:getQuality()
		if qa~= qb then
			return qa>qb
		end
		return a:getId() < b:getId()
	end)
	self.m_csNode.count:setString(string.format("%d/%d",self.m_gotCount,#self.m_heroList))

	self.m_listLayer = UpdateLayer:create({
		itemWidth = 130,
		itemHeight = 150,
		itemCount = 0,
		column = 6,
		scrollView = self.m_csNode.heroList,
	})
	
	self.m_listLayer:setAnchorPoint(0.5,0)
	local w , h = self.m_listLayer:getContentSize()
	self.m_csNode.heroList:pushBackCustomItem(self.m_listLayer, w,h,0)
	self.m_listLayer:setCascadeOpacityEnabled(true)

	self:selectTabButton(TabName.kShu)
end

function This:initTouchEvent()
	self.m_csNode.close:setTouchEnded(function()
		self:close()
	end)
end

function This:getHeroList(tab)
	local country = TabCountry[tab]
	local list = {}
	for i , hero in ipairs(self.m_heroList) do
		if hero:getCountry() == country then
			table.insert(list,hero)
		end
	end
	return list
end

function This:selectTab(tab)
	self.m_curHeroList = self:getHeroList(tab)
	self.m_listLayer:setDataList(self.m_curHeroList,function(model)
		local view = RecruitHeroView:create(model)
		view:setClickHandler(function(hero)
			g_scene:openDialog("Recruit.RecruitHeroPanel",{heroList = self.m_curHeroList,hero = hero})
		end,true)
		return view
	end)
end



--endregion
