--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This, super = class(...,"Dialog")
local HeroConfig = require("Metadatas.HeroConfig")
local HeroManager = require("Hero.HeroManager")
local RecruitHeroView = require("Recruit.RecruitHeroView")

function This:initNode(hero)
	self.m_hero = hero
	self.m_csNode = cc.Node:createFromCSFile("GameScene/NodeUI/HeroRecruitBestLegion.csb")
	self:addChild(self.m_csNode)
	self.m_csNode:setToCenter()
	self:initRecommandDeputy()
end

function This:initRecommandDeputy()
	local deputyList = HeroConfig[self.m_hero:getId()].legion
	local items = {}
	local total = 0
	local space = 10
	for i , id in ipairs(deputyList) do
		local hero = HeroManager:getHero(id)
		local view = RecruitHeroView:create(hero)
		self.m_csNode.items:addChild(view)
		table.insert(items,view)
		total = total + view:getContentWidth() + space
	end
	local cw = 0
	for i , view in ipairs(items) do
		view:setAnchorPoint(0.5,0.5)
		local w = view:getContentWidth()
		view:setPositionX(-total/2 + cw + w / 2)
		cw = cw + w + space
	end
end

function This:initTouchEvent()
	self.m_csNode.close:setTouchEnded(function()
		self:close()
	end)
end


--endregion
