--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"cc.Node")
local HeroConfig = require("Metadatas.HeroConfig")
local GameUtil = require("Util.GameUtil")
local Hero = require("Hero.Hero")
local HeroManager = require("Hero.HeroManager")

function This:init(heroId)
	self.m_heroId = heroId
	self.m_hero = Hero:create({
		heroId = heroId,
	})
	self.m_config = HeroConfig[heroId]
	self.m_csNode = cc.Node:createFromCSFile("GameScene/NodeUI/HeroListItem.csb")
	local w , h = self.m_csNode.bg:getContentSize()
	local scale = self.m_csNode.bg:getScale()

	w = w * scale
	h = h * scale
	self.m_csNode:setContentSize(w,h)
	self.m_csNode:setAnchorPoint(0.5,0.5)
	self:addChild(self.m_csNode)

	self:initHeroInfo()
	self:setCascadeOpacityEnabled(true)
	-- self:refreshAwak()
end

function This:refreshAwak()
	local hero = HeroManager:getHero(self.m_heroId)
	if hero:isAwaken() and not hero:isGot() then
		self.m_csNode.xingdian:setVisible(true)
		local curentLv = hero:getAwakeLevel()
		if curentLv==0 then
			self.m_csNode.xingdian.light:setVisible(false)
		else
			self.m_csNode.xingdian.light:setVisible(true)
			for i=1,AwakdValue.ParagraphLimit do
				local item = self.m_csNode.xingdian.light["dian"..i]
				item:setVisible(curentLv>=i)
			end
		end
	else
		self.m_csNode.xingdian:setVisible(false)
	end
end

function This:initHeroInfo()
	self.m_csNode.level:setString(1)
	self.m_csNode.name:setString(self.m_config.name, AppText:isChinese() and 10 or nil)
	self.m_csNode.heroqulitybg:setImage(QualityBgFile[self.m_config.quality])
	self.m_csNode.bg:setImage(QualityFrameFile[self.m_config.quality])
	-- self.m_csNode.herofightbg:setImage(QualityFightPowerFrameFile[self.m_config.quality])
	self.m_csNode.icon:setImage(GameUtil:getHeroIcon(self.m_heroId))

	self.m_csNode.country:setString(CountryName[self.m_config.country])

	self.m_csNode.text:setString(math.floor(self.m_hero:getFightPower()))
	self.m_csNode.city:setVisible(false)
	self.m_csNode.state:setVisible(false)
	self.m_csNode.corps:setVisible(false)
	self.m_csNode.citybg:setVisible(false)
	self.m_csNode.toumingdi:setVisible(false)
	self.m_csNode.statebg:setVisible(false)


	for i = 1, 5 do
		self.m_csNode["star"..i]:setVisible(false)
	end
	self.m_csNode:setScale(1.9)
	self.m_csNode:setCascadeOpacityEnabled(true)
	self.m_csNode:setVisible(false)
end

function This:showCard()
	self.m_csNode:setVisible(true)
end

--单抽普通卡
function This:initSingleExtractCommonCard()
	cc.Audio:playEffect("chouputong.mp3")
	self.m_skeletNode = GameUtil:createEffect("ChouKa1",false)
	self:addChild(self.m_skeletNode)
	self.m_skeletNode:setTimeScale(0.5)  --播放速度

	self.m_skeletNode:runAction(cc.Sequence(
		cc.DelayTime(0.5),  --延时
		cc.CallFunc(function()
			self.m_skeletNode:setTimeScale(1)  --播放速度
			self.m_csNode:setVisible(true)
		end),
		cc.DelayTime(0.3),
		cc.FadeOut(0.9),  --淡出
		cc.CallFunc(function()
			if self.m_finishHandler then
				self.m_finishHandler()
			end
		end
	)))
end

--单抽特殊卡
function This:initSingleExtractSpecialCard()
	cc.Audio:playEffect("chouchuanqi.mp3")
	self.m_skeletNode = GameUtil:createEffect("ChouKa3")
	self:addChild(self.m_skeletNode)
	self.m_skeletNode:setTimeScale(0.5)

	self.m_skeletNode:runAction(cc.Sequence(
		cc.DelayTime(0.5),
		cc.CallFunc(function()
			self.m_skeletNode:setTimeScale(1)
			self.m_csNode:setVisible(true)
		end),
		cc.DelayTime(0.5),
		cc.FadeOut(0.3),
		cc.CallFunc(function()
			if self.m_finishHandler then
				self.m_finishHandler()
			end
		end
	)))
end

function This:initExtractEffect(extractType)
	if self.m_config.quality < Quality.kOrange then
		self:initSingleExtractCommonCard()
	else
		self:initSingleExtractSpecialCard()
	end
end

--通用获取动画
function This:initObtainEffect()  
	if self.m_config.quality < Quality.kOrange then
		self.m_skeletNode = GameUtil:createEffect("ChouKa1",false)
		cc.Audio:playEffect("chouputong.mp3")
	else
		self.m_skeletNode = GameUtil:createEffect("ChouKa3",false)
		cc.Audio:playEffect("chouchuanqi.mp3")
		
	end
	self:addChild(self.m_skeletNode)
	self.m_skeletNode:setLocalZOrder(-1)

	self.m_skeletNode:setTimeScale(0.5)
	self.m_skeletNode:runAction(cc.Sequence(
		cc.DelayTime(0.3),
		cc.CallFunc(function()
			self.m_skeletNode:setTimeScale(1)
		end),
		cc.FadeOut(0.5),
		cc.DelayTime(0.5),
		cc.CallFunc(function()
			if self.m_finishHandler then
				self.m_finishHandler()
			end
		end
	)))
	self.m_csNode:setVisible(true)
end

function This:showConversionsPiece(isShow)
	if isShow and not self.m_label then
		local label = cc.Label:createNormalTTF("已拥有,转为碎片",16)
		label:setColor(184,228,97,255)
		label:setPosition(0,20)
		local w , h = self.m_csNode:getContentSize()
		label:setPosition(w/2,50)
		self.m_csNode:addChild(label)
		self.m_label = label
	end
	self.m_csNode:setVisible(true)
end

function This:cancelShowEffect()
	if self.m_skeletNode then
		self.m_skeletNode:removeFromParent()
		self.m_skeletNode = nil
	end
	self.m_csNode:setVisible(true)
end

function This:setFinishHandler(handler)
	self.m_finishHandler = handler
end

--endregion
