--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"cc.Node")
local RecruitManager = require("Recruit.RecruitManager")
local GamePlayer = require("Player.GamePlayer")
local GameUtil = require("Util.GameUtil")
local RecruitView = require("Recruit.RecruitView")
local DepotManager = require("Depot.DepotManager")
local HeroRecruitListPanel = require("Recruit.HeroRecruitListPanel")
local RedDotManager = require("RedDotManager")
local ViewUtil = require("UI.ViewUtil")

function This:init()
	self.m_csNode = cc.Node:createFromCSFile("GameScene/NodeUI/HeroRecruitHero.csb")
	self:addChild(self.m_csNode)
	self.m_country = Country.kShuGuo
	self:initBaseInfo()
	self:refresh()
	self:setCascadeOpacityEnabled(true)
end

function This:initTouchEvent()
	self.m_csNode.recruit1:setTouchEnded(function()
		self:onRecruitBtnClick(ExtractType.kSingleCommon)
	end)
	self.m_csNode.recruit2:setTouchEnded(function()
		self:onRecruitBtnClick(ExtractType.kMultiCommon)
	end)
	self.m_csNode.recruit3:setTouchEnded(function()
		self:onRecruitBtnClick(ExtractType.kSingleSpecial)
	end)
	self.m_csNode.recruit4:setTouchEnded(function()
		self:onRecruitBtnClick(ExtractType.kMultiSpecial)
	end)
	self.m_csNode.free:setTouchEnded(function()
		self:onRecruitBtnClick(ExtractType.kSingleSpecial)
	end)
	self.m_csNode.change:setTouchEnded(function()
		local panel = g_scene:openDialog("Recruit.SelectCountryPanel",{country = self.m_country})
		panel:setHandler(function(country)
			self.m_country = country
			self:refresh()
		end)
	end)
	self.m_csNode.mingjianglu:setTouchEnded(function()
		g_scene:openDialog("Recruit.HeroRecruitListPanel")
	end)
	self.m_csNode.help:setTouchEnded(function()
		g_scene:openDialog("UI.HelpTips",{text = Serialize["wanneng_suipian_help_tips"],node = self.m_csNode.help})
	end)

end

function This:onEnter()
	super.onEnter(self)
	RecruitManager:addObserver(self)
	GamePlayer:addObserver(self)
	self:initTouchEvent()
end

function This:onExit()
	super.onExit(self)
	RecruitManager:removeObserver(self)
	GamePlayer:removeObserver(self)
end

function This:initBaseInfo()
	local item1 , num1 = RecruitManager:getRecruitCost(ExtractType.kSingleCommon)
	self.m_csNode.recruit1.times:setString(num1)
	local item2 , num2 = RecruitManager:getRecruitCost(ExtractType.kMultiCommon)
	self.m_csNode.recruit2.times:setString(num2)
	local item3 , num3 = RecruitManager:getRecruitCost(ExtractType.kSingleSpecial)
	self.m_csNode.recruit3.cost:setString(num3)
	local item4 , num4 = RecruitManager:getRecruitCost(ExtractType.kMultiSpecial)
	self.m_csNode.recruit4.cost:setString(num4)
end

function This:refresh()
	local zhaomuling = RecruitManager:getRecruitmentOrder()
	self.m_csNode.num:setString(zhaomuling)

	local leftTime = RecruitManager:getLeftTime()
	self.m_csNode.time:setVisible(leftTime > 0)
	self.m_csNode.text3:setVisible(leftTime > 0)

	self.m_csNode.free:setVisible(leftTime <= 0)
	self.m_csNode.recruit3:setVisible(leftTime > 0)

	if leftTime > 0 then
		self.m_csNode.time:setString(GameUtil:formatTime(Serialize["H_M_S"],leftTime))
	end

	local time = 5 - RecruitManager:getProgressTime()
	self.m_csNode.bencaizhaomu:setVisible(time == 1)
	self.m_csNode.text9:setVisible(time > 1)
	self.m_csNode.zhaomutime:setVisible(time > 1)
	
	if time > 1 then
		self.m_csNode.zhaomutime:setImage(string.format("MenuScene/zhaomutext%d.png",time))
	end
	self.m_csNode.VIPdiscount:setVisible(RecruitManager:isCanDiscount(ExtractType.kMultiSpecial))
	self.m_csNode.country:setString(CountryName[self.m_country])
	self.m_csNode.spallnumber:setString(DepotManager:getItemCount(121))

    ViewUtil:refreshRedDot(self.m_csNode.recruitItem1.hongdian, RedDotManager:getNodeDot("recruitItem1")) 
	ViewUtil:refreshRedDot(self.m_csNode.recruitItem5.hongdian, RedDotManager:getNodeDot("recruitItem5")) 
	ViewUtil:refreshRedDot(self.m_csNode.recruitHasFreeTimes.hongdian, RedDotManager:getNodeDot("recruitHasFreeTimes")) 
end

function This:onRecruitBtnClick(recruitType)
	local item , num = RecruitManager:getRecruitCost(recruitType)
	if recruitType == ExtractType.kSingleCommon or recruitType == ExtractType.kMultiCommon then
		local zhaomuling = RecruitManager:getRecruitmentOrder()
		if zhaomuling >= num then
			RecruitManager:onRecruitCommonRequest(self.m_country,recruitType)
		else
			g_scene:showTips(Serialize[64065])
		end
	elseif recruitType == ExtractType.kSingleSpecial then	
		local leftTime = RecruitManager:getLeftTime()
		if leftTime > 0 then
			GamePlayer:costDiamond({cost = num , desc = Serialize[62103], title = Serialize[62103], okHandler = function()
				RecruitManager:onRecruitSpecialRequest(self.m_country,recruitType)
			end})
		else
			RecruitManager:onRecruitSpecialRequest(self.m_country,recruitType)
		end
	else
		GamePlayer:costDiamond({cost = num, title = Serialize[64066], desc = Serialize[64066], okHandler = function()
			RecruitManager:onRecruitSpecialRequest(self.m_country,recruitType)
		end})
	end
end

function This:onRecruitCard(heroInfoList,recruitType)
	local w , h = self.m_csNode.equipSpall:getContentSize()
	local x , y = self.m_csNode.equipSpall:convertToWorldSpace(w/2,h/2)
	local view = RecruitView:create({
		particlex = x,
		particley = y,
		particleFinishHandler = function()
			local x1 , y1 = self.m_csNode.equipSpall:getPosition()
			local sprite = cc.Sprite:create("MenuScene/wannengsuipian1.png")
			self:addChild(sprite)
			sprite:setPosition(x1,y1)
			sprite:setScale(0.5)
			sprite:runAction(cc.Sequence(cc.ScaleTo(2,1.1,"ElasticIn")))
			sprite:runAction(cc.Sequence(cc.FadeOut(1,180),cc.RemoveAction()))
		end
	})
	view:showExtractEffect(heroInfoList,recruitType)
	g_scene:addChild(view)
	self:initBaseInfo()
	self:refresh()
end

function This:onRecruitCDUpdate(leftTime)
	self:refresh()
end

function This:onGetRecruitInfo()
	self:refresh()
end

function This:onDayPassed()
	self:initBaseInfo()
	self:refresh()
end

--endregion
