--region *.lua
--Date
--此文件由[BabeLua]插件自动生成
--RecruitHeroPanel.lua
local This , super = class(...,"Dialog")
local HeroConfig = require("Metadatas.HeroConfig")
local SkillConfig = require("Metadatas.SkillConfig")
local StarUpConfig = require("Metadatas.StarUpConfig")
local FetterConfig = require("Metadatas.FetterConfig")
local RedFetterConfig = require("Metadatas.RedFetterConfig")
local AttrListNode = require("Hero.AttrListNode")
local Hero = require("Hero.Hero")
function This:initNode(info)
	local function findItem(heroList,hero)
		for k,heroData in pairs(heroList) do
			if heroData:getId() == hero:getId() then
				return k
			end
		end
		return nil
	end
	self.m_curIndex = findItem(info.heroList,info.hero)
	self:refreshHero(info.hero)
	self.m_heroList = info.heroList
	self.m_csNode = cc.Node:createFromCSFile("GameScene/NodeUI/HeroRecruitInfomation.csb")
	self:addChild(self.m_csNode)
	self.m_csNode:setToCenter()
	self:refresh()
	self:refreshSwitchBtn()
end

function This:refresh()
	local csNode = self.m_csNode
	local heroNode = csNode.heronode

	local config = HeroConfig[self.m_hero:getId()]
	local skillId = config.skill_id
	local enger = SkillConfig[skillId].anger_cost
	for i= 1,4 do
		csNode["energ"..i]:setVisible(enger >= i)
	end
	local skillConfig = SkillConfig[skillId]
	csNode.skillname:setString(skillConfig.name)
	csNode.skilldes:setString(string.format("%s",skillConfig.desp), AppText:isChinese() and 900 or 1020)
	-- for i = 1 , 5 do
	-- 	local starAttrId = config.up_star[i]
	-- 	local str = string.format("<New7>%s:<New3>%s",StarUpConfig[starAttrId].name,StarUpConfig[starAttrId].desc)
	-- 	csNode["talent"..i]:setStringWithColor(str)
	-- end
	-- for i = #config.up_star+1 , 5 do
	-- 	csNode["talent"..i]:setVisible(false)
	-- end
	for i , id in ipairs(config.fetter) do
		local fetterItem = FetterConfig[id] or RedFetterConfig[id]
		local str = string.format("<New7>%s:<New3>%s",fetterItem.name,fetterItem.desc)
		csNode["Fate"..i]:setStringWithColor(str, (not AppText:isChinese()) and 510 or nil)
	end
	for i = 1, 3 do
		csNode["Fate"..i]:setVisible(#config.fetter >= i)
	end
	self:refreshHeroCard()
	self:refreshGrowAttr()
	self:refreshAwak()
end

function This:refreshGrowAttr()
	local hero = self.m_hero
	local csNode = self.m_csNode
	csNode.chief:setString(string.format("%d",hero:getAttr(AttrType.kChiefValue)))
	local growChief = hero:getChiefGrowValue()
	csNode.chiefgrowth:setString(string.format("(+%.2f)",growChief))

	csNode.power:setString(string.format("%d",hero:getAttr(AttrType.kPower)))
	local growPower = hero:getPowerGrowValue()
	csNode.powergrowth:setString(string.format("(+%.2f)",growPower))

	csNode.Intelligence:setString(string.format("%d",hero:getAttr(AttrType.kIntelligence)))
	local growIntelligence = hero:getIntelligenceGrowValue()
	csNode.Intelligencegrowth:setString(string.format("(+%.2f)",growIntelligence))

	csNode.defense:setString(string.format("%d",hero:getAttr(AttrType.kDfs)))
	local growDfs = hero:getDfsGrowValue()
	csNode.dfsgrow:setString(string.format("(+%.2f)",growDfs))

	csNode.speed:setString(string.format("%.2f",hero:getAttr(AttrType.kFirst)))
end

function This:refreshAwak()
	local hero = self.m_hero
	local heroEffect = false
	if hero:isAwaken() then
		self.m_csNode.heronode.xingdian:setVisible(true)
	else
		self.m_csNode.heronode.xingdian:setVisible(false)
	end
end

function This:initTouchEvent()
	local csNode = self.m_csNode
	local heroNode = csNode.heronode
	heroNode.xingdian.buttonjuexing:setTouchEnded(function()
		g_scene:openDialog("Awake.AwakeInfoPanel",{heroId = self.m_hero:getId()})
	end)
	csNode.close:setTouchEnded(function()
		self:close()
	end)
	local showCard = true
	csNode.bestlegion:setTouchEnded(function()
		showCard = not showCard
		if showCard then
			self:showHeroCard()
		else
			self:showHeroAttr()
		end
		-- g_scene:openDialog("Recruit.RecruitDeputyPanel",self.m_hero)
	end)
	csNode.zuo:setTouchEnded(function()
		if self.m_curIndex > 0 then
			self.m_curIndex = self.m_curIndex - 1
			self:setHero(self.m_heroList[self.m_curIndex])
			self:refreshSwitchBtn()
		end 
	end)
	csNode.you:setTouchEnded(function()
		if self.m_curIndex < #self.m_heroList then
			self.m_curIndex = self.m_curIndex + 1
			self:setHero(self.m_heroList[self.m_curIndex])
			self:refreshSwitchBtn()
		end
	end)
end

function This:showHeroAttr()
	if self.m_attrNode == nil then
		self.m_attrNode = AttrListNode:create(self.m_hero:getId())
		self.m_csNode.left:addChild(self.m_attrNode)
		self:refreshHeroAttr()
	end
	self.m_attrNode:setVisible(true)
	if self.m_csNode.heronode then
		self.m_csNode.heronode:setVisible(false)
	end
	self.m_csNode.bestlegion.text:setString(Serialize[61298])
end

function This:refreshHeroAttr()
	if self.m_attrNode then
		self.m_attrNode:refresh()
	end
end

function This:refreshHeroCard()
	local csNode = self.m_csNode
	local heroNode = csNode.heronode
	-- heroNode:setVisible(true)
	heroNode.name:setString(self.m_hero:getName(), AppText:isChinese() and 10 or nil)
	heroNode.level:setString(self.m_hero:getLevel())
	heroNode.country:setString(CountryName[self.m_hero:getCountry()])
	local color = SmallCardQualityColor[self.m_hero:getQuality()]
	heroNode.country:setColor(color.r , color.g, color.b)
	local sound = self.m_hero:getSound()
	if self.m_soundId then
		cc.Audio:stopEffect(self.m_soundId)
	end
	if sound then
		self.m_soundId = cc.Audio:playEffect(sound)
	end
	heroNode.icon:setImage(self.m_hero:getIcon())
	heroNode.quality:setImage(QualityBigFrameFile[self.m_hero:getQuality()])
	heroNode.qualitybg:setImage(QualityBgFile[self.m_hero:getQuality()])
end

function This:showHeroCard()
	if self.m_attrNode then
		self.m_attrNode:setVisible(false)
	end
	self:refreshHeroCard()
	self.m_csNode.heronode:setVisible(true)
	self.m_csNode.bestlegion.text:setString(Serialize[61297])
end

function This:refreshSwitchBtn()
	self.m_csNode.zuo:setVisible(self.m_curIndex > 1)
	self.m_csNode.you:setVisible(self.m_curIndex < #self.m_heroList)
end

function This:setHero(hero)
	if self.m_hero:getId() ~= hero:getId() then
		self:refreshHero(hero)
		if self.m_attrNode then
			local isVisible = self.m_attrNode:isVisible()
			self.m_attrNode:removeFromParent()
			self.m_attrNode = AttrListNode:create(self.m_hero:getId())
			self.m_csNode.left:addChild(self.m_attrNode)
			self.m_attrNode:setVisible(isVisible)
			self:refreshHeroAttr()
		end
		self:refresh()
		-- self:showHeroCard()
	end
end

function This:refreshHero(hero)
	self.m_hero = Hero:create({heroId = hero:getId()})
end

--endregion
