--region *.lua
--Date
--此文件由[BabeLua]插件自动生成
--RecruitHeroView.lua
local This , super = class(...,"cc.Node")
local HeroManager = require("Hero.HeroManager")
local Hero = require("Hero.Hero")
function This:init(hero)
	self:refreshHero(hero)
	self.m_csNode = cc.Node:createFromCSFile("GameScene/NodeUI/HeroRecruitListItem.csb")
	self:addChild(self.m_csNode)

	local w , h = self.m_csNode.bg:getContentSize()
	local scale = self.m_csNode.bg:getScale()
	w = w * scale
	h = h * scale
	self:setContentSize(w,h)
	self.m_csNode:setPosition(w/2,h/2)

	self.m_mask = cc.LayerColor:create(cc.Color(0,0,0,128))
	self.m_mask:setContentSize(w,h)
	self:addChild(self.m_mask)

	self:refresh()
end

function This:refresh()
	local country = self.m_hero:getCountry()
	local quality = self.m_hero:getQuality()
	self.m_csNode.country:setString(CountryName[country])
	local color = SmallCardQualityColor[quality]
	self.m_csNode.country:setColor(color.r , color.g, color.b)

	self.m_csNode.name:setString(self.m_hero:getName(), AppText:isChinese() and 10 or nil)
	self.m_csNode.level:setString(self.m_hero:getLevel())
	

	self.m_csNode.heroqulitybg:setImage(QualityBgFile[quality])
	self.m_csNode.bg:setImage(QualityFrameFile[quality])
	self.m_csNode.icon:setImage(self.m_hero:getIcon())
	self.m_mask:setVisible(not HeroManager:isGotHero(self.m_hero:getId()))
	self:refreshAwak()
end

function This:refreshAwak()
	local hero = self.m_hero
	local heroEffect = false
	if hero:isAwaken() then
		self.m_csNode.xingdian:setVisible(true)
	else
		self.m_csNode.xingdian:setVisible(false)
	end
end

function This:setModel(hero)
	if self.m_hero:getId() ~= hero:getId() then
		self:refreshHero(hero)
		self:refresh()
	end
end

function This:onEnter()
	super.onEnter(self)
	if self.m_clickHandler then
		self.m_csNode.bg:setTouch({
			onEnded = function()
				self.m_clickHandler(self.m_hero)
			end,
			isSwallow = false,
			isScale = false,
			isContainer = self.m_isContainer
		})
	end
end

function This:setClickHandler(handler,isContainer)
	self.m_clickHandler = handler
	self.m_isContainer = isContainer
end

function This:refreshHero(hero)
	self.m_hero = Hero:create({heroId = hero:getId()})
end



--endregion
