--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"Dialog")
local RecruitManager = require("Recruit.RecruitManager")
local GamePlayer = require("Player.GamePlayer")
local GameUtil = require("Util.GameUtil")
local RecruitView = require("Recruit.RecruitView")
local DepotManager = require("Depot.DepotManager")
local HeroRecruitListPanel = require("Recruit.HeroRecruitListPanel")
local RedDotManager = require("RedDotManager")
local ViewUtil = require("UI.ViewUtil")
local EventDispatcher = require("EventDispatcher")
local RecruitBoxConfig = require("Metadatas.RecruitBoxConfig")

This.country = Country.kShuGuo

function This:initNode()
	self.m_csNode = cc.Node:createFromCSFile("GameScene/NodeUI/HeroRecruitHero.csb")
	self:addChild(self.m_csNode)
	self.m_csNode:setToCenter()

	--[[self.m_csNode.close:fitToScreen("right","top")
	self.m_csNode.icon:fitToScreen("left","top")
	self.m_csNode.yuanbao:fitToScreen("left","top")
	
	local nodeList = {"jifenbg","icon1","jifenbar","jifendiban","luckynum","text","luckyhelp"}
	for i , key in ipairs(nodeList) do
		self.m_csNode[key]:fitToScreen("left","bottom")
	end

	self.m_csNode.mingjianglu:fitToScreen("right","bottom")
	self.m_csNode.help:fitToScreen("right","bottom")
	self.m_csNode.spallnumber:fitToScreen("right","bottom")
	self.m_csNode.equipSpall:fitToScreen("right","bottom")]]

	self.m_csNode.bg:fitScreen()

	self.m_country = This.country
	local w , h = self.m_csNode.jifenbg:getContentSize()
	self.m_progressTimer = cc.ProgressTimer:create(self.m_csNode.jifenbar)
	self.m_csNode.jifenbg:addChild(self.m_progressTimer)
	self.m_progressTimer:setScaleY(-1)
	self.m_progressTimer:setPosition(w/2,h/2)
	self.m_favours = 0

	self:initBaseInfo()
	self:refresh()
end
	
function This:initTouchEvent()
	local csNode = self.m_csNode
	csNode.recruit1:setTouch({
		onEnded = function()
			self:onRecruitBtnClick(ExtractType.kSingleCommon)
		end,
		isDynamic = true
	})
	csNode.recruit2:setTouch({
		onEnded = function()
			self:onRecruitBtnClick(ExtractType.kMultiCommon)
		end,
		isDynamic = true
	})
	csNode.recruit3:setTouch({
		onEnded = function()
			self:onRecruitBtnClick(ExtractType.kSingleSpecial)
		end,
		isDynamic = true
	})
	csNode.recruit4:setTouch({
		onEnded = function()
			self:onRecruitBtnClick(ExtractType.kMultiSpecial)
		end,
		isDynamic = true
	})
	csNode.free:setTouch({
		onEnded = function()
			self:onRecruitBtnClick(ExtractType.kSingleSpecial)
		end,
		isDynamic = true
	})
	csNode.change:setTouch({
		onEnded = function()
			local panel = g_scene:openDialog("Recruit.SelectCountryPanel",{country = self.m_country})
			panel:setHandler(function(country)
				self.m_country = country
				This.country = self.m_country
				self:refresh()
			end)
		end,
		isDynamic = true
	})
	csNode.mingjianglu:setTouch({
		onEnded = function()
			g_scene:openDialog("Recruit.HeroRecruitListPanel")
		end,
		isDynamic = true
	})
	csNode.help:setTouch({
		onEnded = function()
			g_scene:openDialog("UI.HelpTips",{text = Serialize["wanneng_suipian_help_tips"],node = self.m_csNode.help})
		end,
		isDynamic = true
	})
	csNode.luckyhelp:setTouch({
		onEnded = function()
			g_scene:openDialog("UI.HelpTips",{text = Serialize[64072],node = self.m_csNode.luckyhelp})
		end,
		isDynamic = true
	})
	csNode.close:setTouch({
		onEnded = function()
			self:close()
		end,
		isDynamic = true
	})
	csNode.box.box:setTouch({
		onEnded = function()
			g_scene:openDialog("Recruit.RecruitRewardPanel")
		end,
		isDynamic = true
	})
end

function This:onEnter()
	super.onEnter(self)
	RecruitManager:addObserver(self)
	GamePlayer:addObserver(self)
	self.m_csNode:playCSAnimation(nil,false,function()
		self:checkFavours()
		self:refreshFavours()
		EventDispatcher:dispatcher("recruit_panel_animate_end")
	end)

	EventDispatcher:addListener(self,"recruit_end",function()
		self:checkFavours()
		self:refreshFavours()
	end)

	cc.Audio:playEffect("Recruit_Open.mp3",false)
end

function This:onExit()
	super.onExit(self)
	RecruitManager:removeObserver(self)
	GamePlayer:removeObserver(self)
	EventDispatcher:removeListener(self,"recruit_end")
end

function This:checkFavours()
	if RecruitManager:getFavours() >= kMaxFavoursValue then
		local panel = g_scene:openDialog("Recruit.SelectFavourCardPanel",{country = self.m_country})
	end
end

function This:initBaseInfo()
	local item1 , num1 = RecruitManager:getRecruitCost(ExtractType.kSingleCommon)
	self.m_csNode.recruit1.times:setString(num1)
	local item2 , num2 = RecruitManager:getRecruitCost(ExtractType.kMultiCommon)
	self.m_csNode.recruit2.times:setString(num2)
	local item3 , num3 = RecruitManager:getRecruitCost(ExtractType.kSingleSpecial)
	self.m_csNode.recruit3.cost:setString(num3)
	local item4 , num4 = RecruitManager:getRecruitCost(ExtractType.kMultiSpecial)
	self.m_csNode.recruit4.cost:setString(num4)
end

function This:refreshFavours()
	local favours = RecruitManager:getFavours()
	if self.m_favours ~= favours then
		self.m_progressTimer:fromToTimer(1.0,self.m_favours / kMaxFavoursValue,favours / kMaxFavoursValue)
		self.m_favours = favours
	end	
end

function This:refreshBoxState()
	local boxNode = self.m_csNode.box
	boxNode:setVisible(true)
	local rewardHistory = RecruitManager:getBoxHistory()
	local isGray = #rewardHistory ==#RecruitBoxConfig
	local isAdd = RecruitManager:getIsCanReward()
	GameUtil:createBoxEffect(isAdd,boxNode.box,3,isGray)
	local curentScore = RecruitManager:getBoxRewardScore()
	local minCanStarLv = RecruitManager:getMinBoxStarLv()
	boxNode.num:setString(string.format("%d/%d",curentScore,minCanStarLv))
end

function This:refresh(spall)
	self.m_csNode.yuanbao:setString(GamePlayer:getDiamond())
	local zhaomuling = RecruitManager:getRecruitmentOrder()
	self.m_csNode.num:setString(zhaomuling)

	local leftTime = RecruitManager:getLeftTime()
	self.m_csNode.time:setVisible(leftTime > 0)
	self.m_csNode.text3:setVisible(leftTime > 0)

	self.m_csNode.free:setVisible(leftTime <= 0)
	self.m_csNode.recruit3:setVisible(leftTime > 0)
	
	local facours = RecruitManager:getFavours()
	self.m_csNode.luckynum:setString(facours)

	if leftTime > 0 then
		self.m_csNode.time:setString(GameUtil:formatTime(Serialize["H_M_S"],leftTime))
	end

	local time = 5 - RecruitManager:getProgressTime()
	self.m_csNode.bencaizhaomu:setVisible(time == 1)
	self.m_csNode.text9:setVisible(time > 1)
	self.m_csNode.zhaomutime:setVisible(time > 1)
	
	if time > 1 then
		self.m_csNode.zhaomutime:setImage(string.format("MenuScene/zhaomutext%d.png",time))
	end
	self.m_csNode.VIPdiscount:setVisible(RecruitManager:isCanDiscount(ExtractType.kMultiSpecial))
	self.m_csNode.country:setString(CountryName[self.m_country])
	if not spall then
		self.m_csNode.spallnumber:setString(DepotManager:getItemCount(121))
	end
    ViewUtil:refreshRedDot(self.m_csNode.recruitItem1.hongdian, RedDotManager:getNodeDot("recruitItem1")) 
	ViewUtil:refreshRedDot(self.m_csNode.recruitItem5.hongdian, RedDotManager:getNodeDot("recruitItem5")) 
	ViewUtil:refreshRedDot(self.m_csNode.recruitHasFreeTimes.hongdian, RedDotManager:getNodeDot("recruitHasFreeTimes")) 
	self:refreshBoxState()
end

function This:onRecruitBtnClick(recruitType)
	local item , num = RecruitManager:getRecruitCost(recruitType)
	if recruitType == ExtractType.kSingleCommon or recruitType == ExtractType.kMultiCommon then
		local zhaomuling = RecruitManager:getRecruitmentOrder()
		if zhaomuling >= num then
			RecruitManager:onRecruitCommonRequest(self.m_country,recruitType)
		else
			g_scene:showTips(Serialize[64065])
		end
	elseif recruitType == ExtractType.kSingleSpecial then	
		local leftTime = RecruitManager:getLeftTime()
		if leftTime > 0 then
			GamePlayer:costDiamond({cost = num , desc = Serialize[62103], title = Serialize[62103], okHandler = function()
				RecruitManager:onRecruitSpecialRequest(self.m_country,recruitType)
			end})
		else
			RecruitManager:onRecruitSpecialRequest(self.m_country,recruitType)
		end
	else
		GamePlayer:costDiamond({cost = num, title = Serialize[64066], desc = Serialize[64066], okHandler = function()
			RecruitManager:onRecruitSpecialRequest(self.m_country,recruitType)
		end})
	end
end

function This:onRecruitCard(heroInfoList,recruitType)
	print("开始展示抽奖特效...")
	local tx , ty = self.m_csNode.equipSpall:getPosition()
	local x , y = self.m_csNode:convertToWorldSpace(tx,ty)
	local view = g_scene:openDialog("Recruit.RecruitView",{
		particlex = x,
		particley = y,
		particleFinishHandler = function()
			local x1 , y1 = self.m_csNode.equipSpall:getPosition()
			local sprite = cc.Sprite:create("MenuScene/wannengsuipian1.png")
			self:addChild(sprite)
			sprite:setPosition(x1,y1)
			sprite:setScale(0.5)
			sprite:runAction(cc.Sequence(cc.ScaleTo(2,1.1,"ElasticIn"),cc.RemoveAction()))
			self:initBaseInfo()
			self:refresh()
		end
	})
	view:setLocalZOrder(1001)
	view:showExtractEffect(heroInfoList,recruitType)
	-- self:initBaseInfo()
	-- self:refresh()
	self:refreshBoxState()
end

function This:onRecruitCDUpdate(leftTime)
	self:refresh(true)
end

function This:onGetRecruitInfo()
	self:refresh()
	self:refreshFavours()
end

function This:onPlayerAttrChanged(attrId,old,value)
	if attrId == PlayerAttr.diamond then
		self.m_csNode.yuanbao:setString(value)
	end
end

function This:onRecruitFavours()
	self:refresh()
	self:refreshFavours()
end

function This:onRecruitDayPassed()
	self:initBaseInfo()
	self:refresh()
	local panel = g_scene:getDialog("SelectCountryPanel")
	if panel then
		panel:close()
	end
end

function This:onGetBoxReward()
	self:refreshBoxState()
end




--endregion
