--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"Dialog")
local Timer = require("Timer")
local RecruitEffectNode = require("Recruit.RecruitEffectNode")
local RecruitManager = require("Recruit.RecruitManager")
local HeroManager = require("Hero.HeroManager")
local EventDispatcher = require("EventDispatcher")
local HeroConfig = require("Metadatas.HeroConfig")

function This:initNode(info)
	self.m_particlex = 0
	self.m_particley = 0
	local opacity = 255
	if info then
		self.m_particlex = info.particlex or 0
		self.m_particley = info.particley or 0
		opacity = info.opacity or 255
		self.m_particleFinishHandler = info.particleFinishHandler
	end

	self:setContentSize(cc.visible.width,cc.visible.height)
	self.m_layer = cc.LayerColor:create(cc.Color(0,0,0, opacity))
	self.m_layer:setContentSize(cc.visible.width,cc.visible.height)
	self:addChild(self.m_layer)
	self:setCascadeOpacityEnabled(true)
	self.m_nodes = {}
end

function This:onTouchMask()
	self:showCardImmediately()
end

function This:onEnter()
	super.onEnter(self)
	self:scheduleUpdate()
	EventDispatcher:dispatcher("guide_finger_visible", false)
end

function This:onExit()
	EventDispatcher:dispatcher("guide_finger_visible", true)
	super.onExit(self)
end

function This:setFinishHandler(handler)
	self.m_finishHandler = handler
end

function This:showCardEffect()
	local eventIndex = 1
	self.m_cardEffect = cc.SkeletonNode:createEffect("ChouKa01")
	self.m_cardEffect:scheduleUpdate()
	if #self.m_heroInfo == 1 then
		self.m_cardEffect:playAnimation("animation",false)
	else
		self.m_cardEffect:playAnimation("animation2",false)
	end
	self.m_cardEffect:setAnimationListener({
		onAnimationEvent = function(_,animationName,eventName)
			local node = RecruitEffectNode:create(self.m_heroInfo[eventIndex].heroId)
			node:setPosition(self.m_cardPosition[eventIndex].x,self.m_cardPosition[eventIndex].y)
			node:setScale(0.5)
			self:addChild(node)
			node:showConversionsPiece(self.m_heroInfo[eventIndex].isGot)
			self.m_nodes[eventIndex] = node
			if HeroConfig[self.m_heroInfo[eventIndex].heroId].quality == Quality.kOrange then
				cc.Audio:playEffect("Recruit_ChengKa.mp3",false)
			else
				cc.Audio:playEffect("Recruit_Common.mp3",false)
			end
			eventIndex = eventIndex + 1
		end
	})
	self.m_cardEffect:setPosition(cc.visible.center.x,cc.visible.center.y)
	self:addChild(self.m_cardEffect)
end

function This:showBeforeEffect()
	self.m_beforeEffect = cc.SkeletonNode:createEffect("ChouKa1_1")
	self.m_beforeBgEffect = cc.SkeletonNode:createEffect("ChouKa1_2")
	self.m_beforeEffect:scheduleUpdate()
	self.m_beforeBgEffect:scheduleUpdate()
	self.m_beforeEffect:playAnimation("animation",false)
	self.m_beforeBgEffect:playAnimation("animation",false)
	self.m_beforeEffect:setAnimationListener({
		onAnimationComplete = function(_,animationName,eventName)
			self.m_beforeEffect:removeFromParent()
			self.m_beforeBgEffect:removeFromParent()
			self.m_beforeEffect = nil
			self.m_beforeBgEffect = nil
		end,
		onAnimationEvent = function(_,animationName,eventName)
			if not self.m_cardEffect then
				self:showCardEffect()
			end
		end
	})
	self.m_beforeEffect:setPosition(cc.visible.center.x,cc.visible.center.y)
	self.m_beforeBgEffect:setPosition(cc.visible.center.x,cc.visible.center.y)
	self.m_beforeBgEffect:setScale(1.3)
	self:addChild(self.m_beforeBgEffect)
	self:addChild(self.m_beforeEffect)
end

function This:showExtractEffect(heroInfo,recruitType)
	self.m_heroInfo = heroInfo
	self.m_type = recruitType
	self.m_cardPosition = {{x = cc.visible.center.x + 2, y = 276}}
	if #heroInfo > 1 then
		self.m_cardPosition = {
			{x = cc.visible.center.x - 370, y = 276},
			{x = cc.visible.center.x - 184, y = 276},
			{x = cc.visible.center.x + 371, y = 276},
			{x = cc.visible.center.x + 184, y = 276},
			{x = cc.visible.center.x + 2, y = 276},
		}
	end
	self:showBeforeEffect()
	self:runAction(cc.Sequence(
		cc.DelayTime(4.5),
		cc.CallFunc(function()
			self:showEffectFinish()
		end)
	))
	cc.Audio:playEffect("Recruit_AppearCard.mp3",false)
end

function This:showObtainEffect(heroInfo)
	local node = RecruitEffectNode:create(heroInfo.heroId)
	node:setPosition(cc.visible.center.x,cc.visible.center.y)
	self:addChild(node)

	node:initObtainEffect()
	node:setFinishHandler(function()
		self:showEffectFinish(0.1)
	end)
	node:showConversionsPiece(heroInfo.isGot)
	self.m_obtainNode = node
end

function This:showParticle()
	local bPlay = false
	for i , node in ipairs(self.m_nodes) do
		if self.m_heroInfo[i].isGot then
			local particle = cc.Particle:create("lizi.plist",self)
			local x , y = node:getPosition()
			local tx , ty = self:convertToNodeSpace(self.m_particlex,self.m_particley)
			particle:setPosition(x,y)
			particle:runAction(cc.Sequence(cc.DelayTime(0.3),
				cc.MoveTo(0.85,tx,ty,"SineInOut"),
				cc.DelayTime(0.3),
				cc.RemoveAction()
			))
			self:addChild(particle)
			bPlay = true
		end
	end
	if bPlay then
		cc.Audio:playEffect("Recruit_Change.mp3",false)
	end
end

function This:showEffectFinish(time)
	if self.m_isRemoving then
		return
	end
	self.m_isRemoving = true
	self:stopAllActions()
	time = time or 0.1

	local isShowParticle = false
	if self.m_type == ExtractType.kMultiSpecial or self.m_type == ExtractType.kSingleSpecial then
		for i , info in ipairs(self.m_heroInfo) do
			if info.isGot then
				isShowParticle = true
				break
			end
		end
	end

	if not isShowParticle then
		self:runAction(cc.Sequence(cc.DelayTime(time),
			cc.FadeOut(0.3),
			cc.CallFunc(function()
				self:close()
				self.m_isRemoving = nil
				if self.m_finishHandler then
					self.m_finishHandler()
				end
				if self.m_particleFinishHandler then
					self.m_particleFinishHandler()
				end
				EventDispatcher:dispatcher("recruit_end")
			end)
		))
	else
		self:runAction(cc.Sequence(cc.DelayTime(time),
			cc.FadeTo(0.3,200),
			cc.CallFunc(function()
				self:showParticle()
			end),
			cc.FadeOut(0.3),
			cc.DelayTime(1),
			cc.CallFunc(function()
				self:close()
				self.m_isRemoving = nil
				if self.m_finishHandler then
					self.m_finishHandler()
				end
				if self.m_particleFinishHandler then
					self.m_particleFinishHandler()
				end
				EventDispatcher:dispatcher("recruit_end")
			end)
		))
	end
end

function This:showCardImmediately()
	if self.m_isRemoving then
		return 
	end
	if self.m_videoNode then
		self.m_videoNode:removeFromParent()
		self.m_videoNode = nil
	end

	if self.m_obtainNode then
		self.m_obtainNode:cancelShowEffect()
		self.m_obtainNode:stopAllActions()
		self.m_obtainNode = nil
		self:showEffectFinish(0.05) --抽取特效
	end

	if self.m_heroInfo and not self.m_cardEffect then
		self:stopAllActions()
		self:showCardEffect()
		self.m_beforeEffect:removeFromParent()
		self.m_beforeEffect = nil
		self:runAction(cc.Sequence(
			cc.DelayTime(1.5),
			cc.CallFunc(function()
				self:showEffectFinish()
			end)
		))
	end
end
--endregion