--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"Dialog")
local GamePlayer = require("Player.GamePlayer")
local CountryConfig = require("Metadatas.CountryConfig")
local HeroManager = require("Hero.HeroManager")
local RecruitManager = require("Recruit.RecruitManager")

function This:initNode(info)
	self.m_csNode = cc.Node:createFromCSFile("GameScene/NodeUI/HeroRecruitChange.csb")
	self:addChild(self.m_csNode)
	self.m_csNode:setToCenter()
	self.m_country = info.country or Country.kShuGuo
	local heroCountry = RecruitManager:getCountryHero()
	self.m_isCountryOpen = {}
	for key , country in pairs(Country) do
		self.m_isCountryOpen[country] = RecruitManager:isCountryOpen(country)
		self:selectCountryUI(country)
	end
end

function This:initTouchEvent()
	for _ , country in pairs(Country) do
		self.m_csNode["node"..country].country:setTouch({
			onEnded = function()
				self:selectCountry(country)
			end,
			isScale = false
		})

		self.m_csNode["node"..country].zhezhao:setTouch({
			onEnded = function()
				local config = CountryConfig[country]
				local c = config.card_num[1]
				g_scene:showTips(string.format(Serialize[64078],config.card_num[2], CountryName[c],config.day))
			end,
			isScale = false
		})
	end

	self.m_csNode.close:setTouchEnded(function()
		self:close()
	end)
	self.m_csNode.surebutton:setTouchEnded(function()
		if self.m_handler then
			self.m_handler(self.m_country)
		end
		self:close()
	end)
end

function This:selectCountry(country)
	self.m_country = country
	for key , country in pairs(Country) do
		self:selectCountryUI(country)
	end
end

function This:selectCountryUI( country )
	local isOpen = self.m_isCountryOpen[country]
	self.m_csNode["node"..country].zhezhao:setVisible(not isOpen)
	if isOpen then
		local chosen = country == self.m_country
		self.m_csNode["node"..country].country:setVisible(not chosen)
		self.m_csNode["node"..country].choose:setVisible(chosen)
	else
		self.m_csNode["node"..country].country:setVisible(false)
		self.m_csNode["node"..country].choose:setVisible(false)
	end
end

function This:setHandler(handler)
	self.m_handler = handler
end

function This:setAsSelectFavoursCard()
	self.m_csNode.close:setVisible(false)
	self.m_csNode.test:setString(Serialize[64079])
end


--endregion
