--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"Base.BaseModel")
local EventDispatcher = require("EventDispatcher")

function This:init(config)
	self.m_config = config
	self.m_keyList = {}
    for match in string.gmatch(self.m_config.node_path, "[^%.]+") do
        self.m_keyList[#self.m_keyList + 1] = match
    end

	self.m_isShow = false
	self.m_isDirty = true
	self.m_node = nil
	self.m_sprite = nil
	self.m_children = {}
	self:initListener()
end

function This:initListener()
	self.m_logicCheck = {}
	for key , value in pairs(self.m_config.events) do
		if type(key) == "string" then
			EventDispatcher:addListener(self.m_logicCheck,key,function(_,...)
				--print(string.format("%s 接收到逻辑事件:%s",self.m_config.name,key))
				self.m_isShow = value(self,...)
				self.m_isDirty = true
			end)
		elseif type(key) == "number" then
			EventDispatcher:addListener(self.m_logicCheck,value,function(_,...)
				--print(string.format("%s 接收到逻辑事件:%s",self.m_config.name,tostring(value)))
				self.m_isDirty = true
			end)
		end
	end

	self.m_nodeCheck = {}
	for key , value in ipairs(self.m_config.node_events) do
		if type(key) == "string" then
			EventDispatcher:addListener(self.m_nodeCheck,key,function(_,...)
				--print(string.format("%s 接收到节点事件:%s",self.m_config.name,key))
				if value(...) then
					self:initNode()
				end
			end)
		elseif type(key) == "number" then
			EventDispatcher:addListener(self.m_nodeCheck,value,function(_,...)
				--print(string.format("%s 接收到节点事件:%s",self.m_config.name,tostring(value)))
				self:initNode()
			end)
		end
	end
end

function This:removeListener()
	for key , value in pairs(self.m_config.events) do
		if type(key) == "string" then
			EventDispatcher:removeListener(self.m_logicCheck,key)
		elseif type(key) == "number" then
			EventDispatcher:removeListener(self.m_logicCheck,value)
		end
	end

	for key , value in ipairs(self.m_config.node_events) do
		if type(key) == "string" then
			EventDispatcher:removeListener(self.m_nodeCheck,key)
		elseif type(key) == "number" then
			EventDispatcher:removeListener(self.m_nodeCheck,value)
		end
	end
end

function This:getId()
	return self.m_config.id
end

function This:getType()
	return self.m_config.type
end

function This:setIsDynamic(bDynamic)
	self.m_isDynamic = bDynamic
end

function This:getName()
	return self.m_config.name
end

function This:isDirty()
	return self.m_isDirty
end

function This:setIsDirty(bDirty)
	self.m_isDirty = bDirty
end

function This:isLeaves()
	return next(self.m_children) == nil
end

function This:setFather(father)
	self.m_father = father
	if father then
		father:addChild(self)
	end
end

function This:addChild(child)
	local id = child:getId()
	if not self.m_children[id] then
		self.m_children[id] = child
	end
end

function This:removeChild(child)
	local id = child:getId()
	if self.m_children[id] then
		self.m_children[id] = nil
		child:clear()
	end
end

function This:isShow()
	return self.m_isShow
end

function This:getNode()
	local curNode = g_scene
	if self:getType() == RedDotType.kSpecifiedScene and curNode:getName() ~= self.m_keyList[1] then
		return
	end

	local fromIndex = 2
	local isVisible = curNode:isVisible()
	while fromIndex <= #self.m_keyList do
		local name = self.m_keyList[fromIndex]
		curNode = curNode:getChildByName(name)
		if not curNode then
			return
		end
		fromIndex = fromIndex + 1
	end
	return curNode
end

function This:initNode()
	if self.m_sprite then
		self.m_sprite:setVisible(self.m_isShow)
	else
		self.m_node = self:getNode()
		if self.m_node then
			local onExit = self.m_node.onExit
			self.m_node.onExit = function()
				onExit(self.m_node)
				self.m_node = nil
				self.m_sprite = nil
				if self.m_isDynamic and self.m_father and self.m_father.removeChild then
					self.m_father:removeChild(self)
				end
			end
			self.m_sprite = cc.Sprite:create("LoginScene/baoman.png")
			local w , h = self.m_node:getContentSize()
			local w1 , h1 = self.m_sprite:getContentSize()
			self.m_sprite:setPosition(w - w1/2,h - h1/2)
			self.m_node:addChild(self.m_sprite)
			self.m_sprite:setVisible(self.m_isShow)
		end
	end
end

function This:check()
	if self:isLeaves() then
		if self.m_config.check_func and self.m_config.check_func.func then
			return self.m_config.check_func.func()
		end
	else
		for i , child in pairs(self.m_children) do
			if child:isShow() then
				return true
			end
		end
		return false
	end
end

function This:refresh(bShow)
	local bSkip = false
	if self.m_config.check_func and self.m_config.check_func.skip_func then
		bSkip = self.m_config.check_func.skip_func(self)
        if bSkip ~= false then 
        	bShow = self.m_isShow 
        end
	end

	if bSkip == false and not bShow then
		bShow = self:check()
	end

	if self.m_isShow ~= bShow then
		self.m_isShow = bShow
		if self.m_father and self.m_father.refresh then
			self.m_father:refresh(bShow)
		end
	end

	if self.m_isShow and (not self.m_sprite or not self.m_sprite:isVisible()) then
		if self.m_sprite then
			self.m_sprite:setVisible(true)
		end
	elseif not self.m_isShow and (self.m_sprite and self.m_sprite:isVisible()) then
		if self.m_sprite then
			self.m_sprite:setVisible(false)
		end
	end
	self.m_isDirty = false
end

function This:clear()
	self:removeListener()
	if self.m_father then
		local father = self.m_father
		self.m_father = nil
		father:removeChild(self)
	end
end


--endregion
