--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"Base.BaseModel")
local RedDot = require("RedDot.RedDot")
local RedDotConfig = require("Metadatas.RedDotConfig")
local RedDotUtil = require("RedDot.RedDotUtil")
local Application = require("cc.Application")

RedDotType = 
{
	kShareScene = 1, --共享场景
	kSpecifiedScene = 2, --特定场景
}

function This:init()
	self.m_reddots = {}
end

function This:initRedDots()
	for id , config in pairs(RedDotConfig) do
		self:addStaticRedDot(id)
	end
	Application:addToUpdateList(self)
end

function This:addRedDot(config,isDynamic)
	local reddot = RedDot:create(config)
	if not isDynamic and config.father > 0 then
		local father = self.m_reddots[config.father] 
		if not father then
			father = self:addStaticRedDot(config.father)
		end
		reddot:setFather(father)
	else
		reddot:setFather(self)
	end
	reddot:setIsDynamic(isDynamic)
	self.m_reddots[config.id] = reddot
	return reddot
end

function This:addStaticRedDot(id)
	local config = RedDotConfig[id]
	local redot = self.m_reddots[config.id]
	if not redot then
		redot = self:addRedDot(config,false)
	end
	redot:setIsDirty(true)
	return redot
end

function This:addDynamicRedDot(config)
	local redot = self.m_reddots[config.id]
	if not redot then
		redot = self:addRedDot(config,true)
	end
	redot:setIsDirty(true)
	return redot
end

function This:addChild(child)
	local id = child:getId()
	if not self.m_reddots[id] then
		self.m_reddots[id] = child
	end
end

function This:removeChild(child)
	local id = child:getId()
	if self.m_reddots[id] then
		child:clear()
		self.m_reddots[id] = nil
	end
end

function This:update()
	for i , reddot in pairs(self.m_reddots) do
		if reddot:isLeaves() and reddot:isDirty() then
			reddot:refresh()
		end
	end
end

--endregion
