--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This = class(...)
local WeekMissionBoxConfig = require("Metadatas.WeekMissionBoxConfig")
local VitalityManager = require("Achieve.VitalityManager")
local DayMissionBoxConfig = require("Metadatas.DayMissionBoxConfig")
local AchieveManager = require("Achieve.AchieveManager")
local DailyAchieveManager = require("Achieve.DailyAchieveManager")
local MeritoriousMissionBoxConfig = require("Metadatas.MeritoriousMissionBoxConfig")
local DepotManager = require("Depot.DepotManager")
local RecruitManager = require("Recruit.RecruitManager")
local PlanShopManager = require("PlanShop.PlanShopManager")
local GameStageManager = require("Stage.GameStageManager")
local FriendManager = require("Friend.FriendManager")
local ActivityManager = require("Activity.ActivityManager")
local MenuBtnHelper = require("Home.MenuBtnHelper")
local MatchManager = require("Match.MatchManager")
local WorldMapManager = require("World.WorldMapManager")
local GamePlayer = require("Player.GamePlayer")
local VipManager = require("Vip.VipManager")
local StoreManager = require("Store.StoreManager")
local NewActivityManager = require("NewActivity.NewActivityManager")
local ArrayManager = require("Hero.ArrayManager")
local GameKingWayManager = require("Awake.GameKingWayManager")
local OfficialManager = require("Official.OfficialManager")
local FamilyManager = require("Family.FamilyManager")
local LegionTaskBoxConfig = require("Metadatas.LegionTaskBoxConfig")
local RolePrestigeConfig = require("Metadatas.RolePrestigeConfig")
local ArgConfig = require("Metadatas.ArgConfig")
local FamilyBossManager = require("FamilyBoss.FamilyBossManager")
local FamilyBuildManager = require("Family.FamilyBuildManager")
local FunctionNoticeManager = require("Function.FunctionNoticeManager")
local NobilityManager = require("Nobility.NobilityManager")
local EventListConfig = require("Metadatas.EventListConfig")

g_redDot = This

RedDotID = 
{
	kTask = 1, --主界面任务红点
	kWeeklyTask = 2, --活跃任务红点
	kDialyTask = 3, --日常任务红点
	kMainTaks = 4, --主线任务红点
	kGongxunTask = 5, --功勋任务红点
}

RedDotType = 
{
	kNormal = 1, --普通基类
	kAchieve = 2, --任务类型
}

-- 不开放返回true
local function checkOpenlvLimit(configId,lv)
	local OpenLevelConfig = require("Metadatas.OpenLevelConfig")
	local level = GamePlayer:getLevel()
	local temLv = lv or 0
	local openConfigItem = OpenLevelConfig[configId] or {}
	if openConfigItem then
		temLv = openConfigItem.open_level or 0
	end
	return level< temLv
end
function This:isWeeklyTaskReward()  --周活跃任务检测函数
	local achieveType = AchieveType.kWeekly
	local weeklyAchieves = VitalityManager:getAllAchieves(achieveType)

	local lastValue = {}
	local idList = {}
    for id, achieve in pairs(weeklyAchieves) do
        if achieve:getState() == AchieveState.kHaseFinish then
        	return true
        end
    end
	local weeklyVitality = VitalityManager:getVitalityInWeek()
	for i = 1 , kWeeklyBoxNum do
		if not VitalityManager:isBoxReward(i, achieveType) and weeklyVitality >= WeekMissionBoxConfig[i].vitality then
			return true
		end
	end

	local dailyVitality = VitalityManager:getVitalityInDay()
	for i = 1 , kDailyBoxNum do
		if not VitalityManager:isDailyBoxReward(i, achieveType) and dailyVitality >= DayMissionBoxConfig[i].vitality then
			return true
		end
	end
	return false
end

function This:isDailyTaskReward()
	local achieves = DailyAchieveManager:getAllAchieves()
	for id , achieve in pairs(achieves) do
		if achieve:getState() == DailyAchieveState.kFinish then
			return true
		end
	end
	return false
end

function This:isCrusadeReward()
	return DailyAchieveManager:achieveHasReward()
end

function This:isHaveGiftDayBox()
	if checkOpenlvLimit(45) then
		return false
	end
	return AchieveManager:isHaveGiftDayBox()
end

-- openConfigId 检查某个id有没有达到开放等级
function This:acheveTypeHasReward(type,openConfigId)
	if openConfigId and checkOpenlvLimit(openConfigId) then
		return false
	end
	local result = AchieveManager:hasAchieveFinish(type)
	return result
end

function This:isMainTaskReward()
	return AchieveManager:hasAchieveFinish(AchieveType.kMainLine)
end

function This:isGongXunTaskReward()
	return AchieveManager:hasAchieveFinish(AchieveType.kGongXun)
end

function This:isGongXunBoxCanReward()
	local gongxun = AchieveManager:getGongXun()
	for i , config in ipairs(MeritoriousMissionBoxConfig) do
		if AchieveManager:isCanRewardGongXunBox(i) then
			return true
		end
	end
	return false
end

---招募
function This:isHasItemZML() --判断时候有招募令
	local recruitItemCount = DepotManager:getItemCount(116)
	return recruitItemCount > 0
end

function This:isRecruitZhongJinCDEnd()
	return RecruitManager:getLeftTime() <= 0 or RecruitManager:getIsCanReward()
end

function This:isPlanShopCDEnd()
	local leftTime = PlanShopManager:getLeftTime() or 0
	return leftTime <= 0
end

function This:isFreeVisitHero()
	return GameStageManager:isCanFreeVisitHero()
end

--好友
function This:isHaveFriendRequest()  --是否有加好友邀请
	local recvRequest = FriendManager:getAllRecvRequest()
	return next(recvRequest) ~= nil
end

function This:isHaveFriendNoReadChatMessage()  --是否有未读聊天
	return FriendManager:haveFriendNoReadChatMessage()
end

function This:isHaveNoReadChatMessage()
	return FriendManager:haveNoReadChatMessage()
end

function This:hasNewActReward(actId)
	local activity = NewActivityManager:getActivity(actId)
	if activity and activity:isUpdating() then
		return activity:isCanReward()
	end  
end

function This:hasActReward(actQueueId, exchange, groupIndex)
	local activity = ActivityManager:getQueueById(actQueueId)
	if activity then
		local state
		if not groupIndex then
			if not exchange then
				state = activity:getAllObjectState()
			else
				state = activity:getAllExchangeObjectState()
			end
		else
			state = activity:getObjectStateByGroupIndex(groupIndex, exchange)
		end
		return state == true
	end
end

--电话卡
function This:hasPhoneCardReward()
	if checkOpenlvLimit(13) then
		return false
	end
	local activity = ActivityManager:getQueueById(NewActivityType.kPhoneCardAd)
	if activity then
		return activity:getAllObjectState()
	end
	return false
end

function This:hasActTabReward( actQueueId, ruleIndex )
	local activity = ActivityManager:getQueueById(actQueueId)
	if activity then
		local state = activity:getObjectStateByRuleIndex(ruleIndex)
		return state == true
	end
end

--投资计划
function This:isActivityTZJHNormal()
	return self:hasActReward(11)
end

-- 首充
function This:isActivitySCReward()
	return self:hasActReward(1)
end

-- 加官进爵
function This:isActivityJSXZReward()
	return self:hasActReward(13)
end

-- 七日活动
function This:isActivitySevenDayReward()
	return self:hasActReward(9)
end

function This:isActSevenDayHasDayReward( dayNum )
	local activity = ActivityManager:getQueueById(9)
	local state = false
	if activity then
		state = activity:getObjectStateByGroupIndex(dayNum)
	end
	return state == true
end

-- 活动
function This:isActivityListReward()
	if checkOpenlvLimit(13) then
		return false
	end
	local node = MenuBtnHelper:getRedDotValue("activity")
    if not node then
        return false 
    end

    return node.value == true
end

function This:isActivityLimitTimeListReward()
	local node = MenuBtnHelper:getRedDotValue("kaifuhuodong")
    if not node then
        return false 
    end

    return node.value == true
end

function This:isActivityCrossZoomeListReward()
	local node = MenuBtnHelper:getRedDotValue("kuafuhuodong")
    if not node then
        return false 
    end

    return node.value == true  
end

-- 团购
function This:isActGroupRechargeReward( num )
	return self:hasActReward(8, false, num)    
end

function This:isYuanBaoTZJHCanReward()
	return self:hasActReward(11, false, 1)    
end

function This:isGoldTXJHCanReward()
	return self:hasActReward(11, false, 2)    
end

--每日首胜
function This:isMRSSCanReward()
	local mrssAchieve = AchieveManager:getAchieve(AchieveType.kGongXun,99999)
	if mrssAchieve then
		return mrssAchieve:getState() == AchieveState.kHaseFinish
	end
end

function This:isMatchRankCanReward()
	if checkOpenlvLimit(12) then
		return false
	end
	local rewards = MatchManager:getLevelListGotReward()
	local activity = NewActivityManager:getActivity(NewActivityType.kSeasonRecharge)
	local rank = MatchManager:getRankLv()
	for i = 1 , rank do
		if not rewards[i] then
			return true
		end
	end
	if not MatchManager:isGotDailyReward() then
		return true
	end
	if activity:hasRewardCanReceive() then
		return true
	end
	return false
end

function This:isMatchCanReward()
	if checkOpenlvLimit(12) then
		return false
	end
	local rewards = MatchManager:getLevelListGotReward()
	local activity = NewActivityManager:getActivity(NewActivityType.kSeasonRecharge)
	local rank = MatchManager:getRankLv()
	for i = 1 , rank do
		if not rewards[i] then
			return true
		end
	end
	if not MatchManager:isGotDailyReward() then
		return true
	end
end

function This:isMatchSeasonReward()
	local activity = NewActivityManager:getActivity(NewActivityType.kSeasonRecharge)
	return activity:hasRewardCanReceive()
end

function This:isHasRecvRelationRequest()
	if GamePlayer:isInWorld() then
		return WorldMapManager:hasRecvRelationRequest()
	end
end

--新年任务
function This:isNewyearTaskCanTask(hasRules, ruleIndex)
	if not hasRules then
		return self:hasActReward(19)
	else
		return self:hasActTabReward(19, ruleIndex)
	end
end

--字帖兑换
function This:isNewyearZTDHCanReward()
	return self:hasActReward(19, true)
end

--元宵任务
function This:isLanternTaskCanTask()
	return self:hasActReward(21)

end

--元宵兑换
function This:isLanternTYDHCanReward()
	return self:hasActReward(21, true)
end

function This:isVipReward()
    return VipManager:hasVipReward()
end

--战功商店
function This:isZGSDCanFreeRefresh()
	return StoreManager:hasStoreRedDot(StoreType.kZhangong)
end

--将魂商店
function This:isJHSDCanFreeRefresh()
	return StoreManager:hasStoreRedDot(StoreType.kJianghun)
end

--显示充值
function This:isLimitRechargeCanReward(id)
	return self:hasNewActReward(id or NewActivityType.kLimitRecharge)
end

-- 铜雀台
function This:isActivityTQTReward()
    return self:hasActReward(14)
end

-- 元宵抽奖
function This:isActivityPrizeDrawReward(activityId)
	local activity = NewActivityManager:getActivity(activityId or NewActivityType.kYuanxiaoDraw)
	if activity and activity:isUpdating() then
		return activity:isCanPrizeDraw()
	end
end

-- 七天庆典
function This:isCanSevenDayReward(activityId)
	local activity = NewActivityManager:getActivity(activityId or NewActivityType.kCumulative)
	local newActivity = NewActivityManager:getActivity(NewActivityType.kDailyRecharge)
	if activityId then
		return activity:hasRewardCanReceive()
	end
	return activity:hasRewardCanReceive() and newActivity:hasRewardCanReceive()
end

--签到
function This:isCanDailySignReward()
	if checkOpenlvLimit(13) then
		return false
	end
	return self:hasNewActReward(NewActivityType.kSignInDaily)
end

-- 连充
function This:isCanContinuePayReward(id)
	if id and id == NewActivityType.kLaborContinuePay then
		if checkOpenlvLimit(13) then--连续充值再活动里里面
			return false
		end
	end
	return self:hasNewActReward(id or NewActivityType.kContinuePay)
end

function This:isCanEntireCostReward()
	return self:hasNewActReward(NewActivityType.kEntireConsume)
end

function This:isCanHappyPlayReward()
	return self:hasNewActReward(NewActivityType.kLuckyRoulette)
end

-- 节日累计充值
function This:isWuyiTotalPayReward()
	return self:hasActReward(35)
end

-- 在线礼包
function This:isActivityOnlineReward()
	return self:hasActReward(7)
end

function This:isTrailerExist()
	if not ActivityManager:getPalyerActInfo("trailer_nocheck") then
		return ActivityManager:getPalyerActInfo("trailer")
	end
end
--今天有没点开过
function This:isOpenInOneDay(isReturnTwo)

	local ihasClick = 0
	local ihasClick2 = 0

	local loginServerTimeKing = cc.FileUtils:loadLuaFile("loginServerTimeKing")
    local loginServerTimeQW = cc.FileUtils:loadLuaFile("loginServerTimeQW")


    local serverOpenDate = os.serverdate("*t",GamePlayer:getServerTime())	

    local hasEvent,hasEvent2 = require("LegionEntrant.EntrantManager"):hasCountEventFignt()

    if hasEvent then
	    if loginServerTimeKing then
	    	local serverOpenKing = os.serverdate("*t",loginServerTimeKing.time)	

	    	print("serverOpenDate.day1111111111====="..serverOpenDate.day..">>>>>>>>==="..serverOpenKing.day)

	    	if serverOpenDate.day ~= serverOpenKing.day then
	    		ihasClick = ihasClick + 1
	    	end
	    else
	    	ihasClick = ihasClick + 1
	    end
	end

	if hasEvent2 then
	    if loginServerTimeQW then
		    local serverOpenQW = os.serverdate("*t",loginServerTimeQW.time)	

		    print("serverOpenDate.day222222222222222====="..serverOpenDate.day..">>>>>>>>==="..serverOpenQW.day)

		    if serverOpenDate.day ~= serverOpenQW.day then
		    	ihasClick2 = ihasClick2 + 1
		    end
		else
			ihasClick2 = ihasClick2 + 1
	    end
	 end

	local s_time = GamePlayer:getServerTime()
    -- cc.FileUtils:saveToLua({time = s_time},"loginServerTimeKing")
    -- cc.FileUtils:saveToLua({time = s_time},"loginServerTimeQW")

    print("ihasClick====="..ihasClick..">>>>>===="..ihasClick2)

    if not isReturnTwo then
    	return ihasClick + ihasClick2
    else
    	return ihasClick,ihasClick2
    end
end

-- 政绩、是否存在可以开启的宝箱和可以领取宝箱和可领取的政绩任务
function This:hasDepotBoxReward()
	if not FunctionNoticeManager:checkOpen(FunctionOpenId.kZhengJiBaoXiang) then
		return false
	end
    return MatchManager:hasBoxRed() or AchieveManager:hasAchieveFinish(AchieveType.kZhengJi)
end

-- 阵法 是否存在可以激活的阵法
function This:hasArrayActivation(countryId)
	local ArrayData = ArrayManager:getArrayData()
	if countryId then
		return ArrayData:hasArrayActivation(countryId)
	else
		return ArrayData:hasArrayActivation()
	end
end

function This:mingWangIsCanUp()
	local level = GamePlayer:getLevel()
	local lwevelLimit = ArgConfig.renown_open_level.arg[1]
	if level< lwevelLimit then
		return false
	end

	local mingWang = GamePlayer:getMingWangValue()
	local lv = GamePlayer:getMingWangLv()
	local lvConfig = RolePrestigeConfig[lv]
	if lvConfig then
		local needMingWang = lvConfig.value
		local needLv = lvConfig.level
		if needMingWang~=-1 and mingWang>=needMingWang and GamePlayer:getLevel()>=needLv then
			return true
		end
	end
	return false
end

-- 王道
function This:kingWayCanUp()
	if GameKingWayManager:isHaveLevelLimit() then
		return false
	end

	local kingWay = GameKingWayManager:getKingWay()
	if kingWay then
		if GamePlayer:getLevel() >= kingWay:getPlayerLevelLimit() then
			local isCanUp = kingWay:isCanUp()
			local nextData ,haveNext= GameKingWayManager:getNexKingWay()
			if not haveNext then
				isCanUp = false
			end
			return isCanUp
		else
			return false
		end
	else
		return false
	end
end
-- 军团建筑
function This:checkFamilyBuilding(building)
	local myInfoInFamily = FamilyManager:getMySelfMemeberInfo()
	if myInfoInFamily
			and (myInfoInFamily:getTitle() == FamilyTitle.kMengZhu
				or myInfoInFamily:getTitle() == FamilyTitle.kFuMengZhu)
	then
		building:updateUpgradeState()
		if building:isMaintaince() then
			local ret, state = building:isCanChangeMaintaince()
			return ret
		else
			local ret, state, tips = building:canUpgrade(true)
			return ret
		end
	else
		return false
	end
end

-- 检查所有军团建筑
function This:checkAllFamilyBuilding()
	local show = false
	for _, buildType in pairs(FamilyBuildType) do
		local building = FamilyBuildManager:getBuildByType(buildType)
		if building and building:getLevel() ~= 0 and g_redDot:checkFamilyBuilding(building) then
			show = true
			break
		end
	end
	return show
end

-- 皇宫 
function This:hasOfficialRed()
	return OfficialManager:isHaveRedDot()
	-- return true
end

-- 军团
function This:hasFamilyRed()
	local red = FamilyManager:hasFamilyRed()
	return red
end

-- 军团活跃度
function This:checkFamilyVitality()
	local show = false
	for _, achieve in ipairs(VitalityManager:getAchieveWithSort()) do
		if achieve:getState() == AchieveState.kHaseFinish then
			show = true
			break
		end
	end
	for index = 1 , kDailyBoxNum do
		local vitality = VitalityManager:getVitalityInFamilyMember()
		local boxConfig = LegionTaskBoxConfig[index]
		if vitality >= boxConfig.vitality and not VitalityManager:isDailyBoxReward(boxConfig.id) then
			show = true
			break
		end
	end
	for index = 1, kWeeklyBoxNum do
		local vitality = VitalityManager:getVitalityInFamily()
		local boxConfig = LegionTaskBoxConfig[kDailyBoxNum+index]
		if vitality >= boxConfig.vitality and not VitalityManager:isDailyBoxReward(boxConfig.id) then
			show = true
			break
		end
	end
	return show
end

-- 军团内务分红
function This:checkFamilyAffairsBonus()
	local family = FamilyManager:getMyFamily()
	if not family then
		return false
	end

	local bonusState = family:getBonusState()
	if bonusState == nil then
		return false
	end

	if bonusState then
		return false
	else
		return true
	end
end

-- 军团内务boss战
function This:checkFamilyAffairsBoss()
	return FamilyBossManager:isRedDot()
end

--功能预告红点
function This:checkFunctionNotice()
	return FunctionNoticeManager:isExistReward()
end

--爵位红点
function This:checkNobility()
	return NobilityManager:isCanUpgradeNobility() or NobilityManager:isHasReward()
end

-- 神兽转盘红点
function This:isAnimalPrizeDrawReward()
	local activity = NewActivityManager:getActivity(NewActivityType.kAnimalTable)
	if checkOpenlvLimit(46) then
		return false
	end
	if activity and activity:isUpdating() then
		return activity:hasBoxCanReceive()
	end
end

-- 乱世政令红点
function This:isDecreeReward()
	local activity = NewActivityManager:getActivity(NewActivityType.kDecreeTask)
	if activity and activity:isUpdating() then
		return activity:hasRedPoint()
	end
end

-- 政令任务红点
function This:isDecreeTaskReward()
	local activity = NewActivityManager:getActivity(NewActivityType.kDecreeTask)
	if activity and activity:isUpdating() then
		return activity:hasTaskRewardCanReceive()
	end
end

-- 政令大赏红点
function This:isDecreeStageReward()
	local activity = NewActivityManager:getActivity(NewActivityType.kDecreeTask)
	if activity and activity:isUpdating() then
		return activity:hasDecreeRewardCanReceive()
	end
end

-- 勤王殿红点
function This:isRescuePalaceRedDot()
	return require("Palace.RescuePalaceManager"):isRedDot()
end

-- 勤王殿红点
function This:lordEquipHaveRedDot()
	if checkOpenlvLimit(50) then
		return false
	end
	return require("Awake.LordEquipManager"):isHaveRed()
end

function This:godBeastHaveRedDot()
	local GodBeastManager = require("GodBeast.GodBeastManager")
	return GodBeastManager:isHaveRed() or GodBeastManager:isHaveRed(GodBeastManagerTabType.kStar)
end

-- 军团战红点
function This:EntrantHasCastRedDot()
	return require("FamilyRating.FamilyRatingManager"):hasCastRed(1)
end

-- 皇帝战红点
function This:KingHasCastRedDot()
	return require("LegionEntrant.EntrantManager"):isKingWarApplyRedDot()
end

-- 魔将召唤红点
function This:RedHeroRedDot()
	local activity = NewActivityManager:getActivity(NewActivityType.kRedHeroTable)
	return activity:hasRewardCanReceive()
end

-- 军团活跃boss红点
function This:checkLegionAboss()
	return require("LegionAboss.LegionAbossManager"):isRedDot()
end