

--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"Player.FightResultBasePanel")
local MenuScene = require("Home.MenuScene")
local ArenaManager = require("Arena.ArenaManager")
local PeakContestManager = require("PeakContest.PeakContestManager")
local GamePlayer = require("Player.GamePlayer")

function This:initNode(report)
	self.m_report = report
	local isWin = (self.m_report:isAttacker() and self.m_report:isAttackerVictory()) or (self.m_report:isDefender() and self.m_report:isDefencerVictory())
	if isWin then
		self.m_csNode = cc.Node:createFromCSFile("GameScene/NodeUI/ArenaWinshare.csb")
	else
		self.m_csNode = cc.Node:createFromCSFile("GameScene/NodeUI/ArenFailshare.csb")
		self:initFailedGuide()
	end
	self:addChild(self.m_csNode)
	self.m_csNode:setToCenter()

	self.m_csNode.continue:setScale(0.66)
	local seqence1 = cc.Sequence(cc.FadeTo(0.4,64),cc.FadeTo(0.4,255))
	local seqence2 = cc.Sequence(cc.ScaleTo(0.4,0.68),cc.ScaleTo(0.4,0.66))
	self.m_csNode.continue:runAction(cc.RepeatForever(cc.Spawn(seqence1,seqence2)))
end

function This:onTouchMask()
	local report = self.m_report
	if report:getType() == ReportType.kArena  then
		cc.SceneManager:switchTo("Home.MenuScene")
		if ArenaManager:isArenaOpened() then
			MenuScene:addDelayDialog({name = "Arena.ArenaPanel"})
		end
	elseif report:getType() == ReportType.kPeakContest then
		cc.SceneManager:switchTo("Home.MenuScene")
		if PeakContestManager:isOpen() then
			MenuScene:addDelayDialog({name = "PeakContest.PeakContestPanel"})
		end
	else
		if GamePlayer:isInWorld() then
			cc.SceneManager:switchTo("World.WorldScene")
		else
			cc.SceneManager:switchTo("Home.MenuScene")
		end
	end
end

function This:getJumpToTargetScene()
	local report = self.m_report
	if report:getType() == ReportType.kArena then
		return "MenuScene"

	elseif report:getType() == ReportType.kPeakContest then
		return "MenuScene"

	else
		if GamePlayer:isInWorld() then
			return "WorldScene"
		else
			return "MenuScene"
		end
	end
end

--endregion
