--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"Dialog")
local ArenaManager = require("Arena.ArenaManager")
local ReportManager = require("Report.ReportManager")
local ArenaReportView = require("Report.ArenaReportView")

local TabName = 
{
	kAll = 1,
	kJinGong = 2, 
	kFangShou = 3,
}

function This:initNode(info)
	self.m_reportList = info.reportList
	self.m_csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/ArenaReport.csb")
	self:addChild(self.m_csNode)
	self.m_csNode:setToCenter()

	self:addTabButton(TabName.kAll , self.m_csNode.tab1,function()
		self:onSelectTab(TabName.kAll)
	end)
	self:addTabButton(TabName.kFangShou, self.m_csNode.tab3,function()
		self:onSelectTab(TabName.kFangShou)
	end)
	self:addTabButton(TabName.kJinGong, self.m_csNode.tab2,function()
		self:onSelectTab(TabName.kJinGong)
	end)
	self:selectTabButton(TabName.kAll)
end

function This:onEnter()
	super.onEnter(self)
	ReportManager:addObserver(self)
end

function This:onExit()
	super.onExit(self)
	ReportManager:removeObserver(self)
end

function This:initTouchEvent()
	self.m_csNode.close:setTouchEnded(function()
		self:close()
	end)
	self.m_csNode.changbutton:setTouchEnded(function ()
		for i , report in ipairs(self.m_reportList) do
			if not ReportManager:isRead(report:getId()) then
				ReportManager:setIsRead(report:getId(),true)
			end
		end
		local itemList = self.m_csNode.ScrollView:getItemList()
		for i ,view in ipairs(itemList) do
			view:refresh()
		end
	end)
end

function This:getAllReportList()
	return self.m_reportList
end

function This:getJinGongReportList()
	local result = {}
	for i , report in ipairs(self.m_reportList) do	
		if report:isAttacker() then
			table.insert(result,report)
		end
	end
	return result
end

function This:getFangShouReportList()
	local result = {}
	for i , report in ipairs(self.m_reportList) do
		if report:isDefender() then
			table.insert(result,report)
		end
	end
	return result
end

function This:onSelectTab(tab)
	if tab == TabName.kAll then
		local reportList = self:getAllReportList()
		self:refreshReportItems(reportList)
	elseif tab == TabName.kJinGong then
		local reportList = self:getJinGongReportList()
		self:refreshReportItems(reportList)
	elseif tab == TabName.kFangShou then
		local reportList = self:getFangShouReportList()
		self:refreshReportItems(reportList)
	end
end

function This:refreshReportItems(reportList)
	self.m_csNode.ScrollView:removeAllItems()
	self.m_timer:removeAllTimer()
	for i , report in ipairs(reportList) do
		self.m_timer:setTimer(i * 0.1,function()
			local view = ArenaReportView:create(report)
			self.m_csNode.ScrollView:pushBackCustomItem(view,820,138,0.5)
		end,"arena_report"..i)
	end
end

function This:onGetArenaBattleReport(reportList)
	
end

--endregion
