--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"Dialog")
local GamePlayer = require("Player.GamePlayer")
local ItemNode = require("UI.ItemNode")
local ReportManager = require("Report.ReportManager")
local ChatManager = require("Chat.ChatManager")
local CityConfig = require("Metadatas.CityConfig")
local GameUtil = require("Util.GameUtil")

local kSharedReportCd = 60
local LastShareReportTime = 0

function This:initNode(report)
	self.m_report = report
	self.m_csNode = cc.Node:createFromCSFile("GameScene/NodeUI/BattleLogDetails.csb")
	self:addChild(self.m_csNode)
	self.m_csNode:setToCenter()
	self.m_escape = 0
	self:refresh()
end

function This:initTouchEvent()
	self.m_csNode.queding:setTouchEnded(function()
		self:close()
	end)

	self.m_csNode.playback:setTouchEnded(function()
		self:onPlayBackBtnClicked()
	end)
end

function This:refresh()
	self.m_csNode.actiontitle:setVisible(self.m_report:isAttacker())
	self.m_csNode.shenglitext:setVisible(self.m_report:isAttacker())

	self.m_csNode.defense:setVisible(self.m_report:isDefender())
	self.m_csNode.fangshoutext:setVisible(self.m_report:isDefender())

	local cityId = self.m_report:getCityId()
	if cityId > 0 then
		self.m_csNode.actionaddress:setString(string.format(Serialize[64087],CityConfig[cityId].name))
	elseif self.m_report:getType() == ReportType.kArena then
		self.m_csNode.actionaddress:setString(Serialize[64092])
	else
		self.m_csNode.actionaddress:setVisible(false)
	end

	local attack = self.m_report:getAttackerInfo()
	local defence = self.m_report:getDefencerInfo()

	self.m_csNode.name1:setString(attack.name)
	if not attack.group_name or attack.group_name == "" then
		self.m_csNode.name3:setString(Serialize[62248])
	else
		self.m_csNode.name3:setString(attack.group_name)
	end
	self.m_csNode.hp1:setString(string.format("%d/%d",attack.resultHp,attack.initHp))
	self.m_csNode.hpbar1:setPercent(attack.resultHp / attack.initHp * 100)

	self.m_csNode.name2:setString(defence.name)
	if not defence.group_name or defence.group_name == "" then
		self.m_csNode.Text_tongmeng2:setString(Serialize[62248])
	else
		self.m_csNode.Text_tongmeng2:setString(defence.group_name)
	end
	self.m_csNode.hp2:setString(string.format("%d/%d",defence.resultHp,defence.initHp))
	self.m_csNode.hpbar2:setPercent(defence.resultHp / defence.initHp * 100)
	
	local time = self.m_report:getStartTime()
	self.m_csNode.time1:setString(GameUtil:formatDate(Serialize[62245],time))

	local escapeTime = os.time() - LastShareReportTime
	self.m_csNode.time:setVisible( escapeTime < kSharedReportCd)
	if escapeTime < kSharedReportCd then
		self.m_csNode.time:setString(string.format(Serialize[61501],kSharedReportCd - escapeTime))
	end

	if self.m_report:isAttacker() then
		self.m_csNode.results:setVisible(self.m_report:isAttackerVictory())
		self.m_csNode.falsetitle:setVisible(not self.m_report:isAttackerVictory())
	elseif self.m_report:isDefender() then
		self.m_csNode.results:setVisible(self.m_report:isDefencerVictory())
		self.m_csNode.falsetitle:setVisible(not self.m_report:isDefencerVictory())
	else
		self.m_csNode.results:setVisible(self.m_report:isAttackerVictory())
		self.m_csNode.falsetitle:setVisible(not self.m_report:isAttackerVictory())
	end
end

function This:setToShared()
	-- self.m_csNode.share:setVisible(false)
	-- self.m_csNode.text:setVisible(false)
	-- self.m_csNode.reward:setVisible(false)
	-- self.m_csNode.text7:setVisible(false)
end

function This:onTouchMask()
	self:close()
end

function This:onEnter()
	super.onEnter(self)
	ReportManager:addObserver(self)
	ChatManager:addObserver(self)
end

function This:onExit()
	super.onExit(self)
	ReportManager:removeObserver(self)
	ChatManager:removeObserver(self)
end

function This:onPlayBackBtnClicked()
	ReportManager:onGetReportDetailRequest(self.m_report:getId())
end

function This:onGetReportDetail(msg)
	cc.SceneManager:switchTo("Report.ReportLoadingScene",nil,msg)
end

function This:onShareBattle()
	self:close()
end

function This:update(dt)
	super.update(self,dt)
	self.m_escape = self.m_escape + dt
	if self.m_escape < 1 then
		return
	end
	self.m_escape = self.m_escape - 1
	local escapeTime = os.time() - LastShareReportTime
	if escapeTime < kSharedReportCd then
		self.m_csNode.time:setString(string.format(Serialize[64093],kSharedReportCd - escapeTime))
		self.m_csNode.time:setVisible(true)
		self.m_csNode.text:setVisible(false)
	else
		self.m_csNode.time:setVisible(false)
	end
end

--endregion
