--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"Dialog")
local ListLayer = require("UI.ListLayer")
local ReportView = require("Report.ReportView")
local ReportManager = require("Report.ReportManager")

function This:initNode()
	self.m_csNode = cc.Node:createFromCSFile("GameScene/NodeUI/BattleLog.csb")
	self:addChild(self.m_csNode)
	self.m_csNode:setToCenter()

	local reportList = ReportManager:getReportList(function(report)
		if report:isMy() and not report:isInFighting() then
			return true
		end
		return false
	end)

	self.m_listLayer = ListLayer:create({
		itemWidth = 548,
		itemHeight = 86,
		itemCount = #reportList,
		frameCount = #reportList,
		column = 1,
		spaceX = 0,
		spaceY = 4,
	})
	self.m_listLayer:setAnchorPoint(0.5,0)

	local w , h = self.m_listLayer:getContentSize()
	self.m_csNode.ScrollView:pushBackCustomItem(self.m_listLayer, w,h,0)
	--[[local layer = cc.LayerColor:create(cc.Color(255,0,0,128))
	layer:setContentSize(w,h)
	self.m_listLayer:addChild(layer)]]

	self.m_reportViews = {}
	self.m_listLayer:starList(function (index)
		local report = reportList[index]
		local view = ReportView:create(report)
		view:setAnchorPoint(0.5,0.5)
		self.m_reportViews[report:getId()] = view
		return view
	end)

	self.m_reportList = reportList
end

function This:initTouchEvent()
	self.m_csNode.close:setTouchEnded(function()
		self:close()
	end)
	self.m_csNode.read:setTouchEnded(function()
		for i , report in pairs(self.m_reportList) do
			ReportManager:setIsRead(report:getId(),true)
			local view = self.m_reportViews[report:getId()]
			if view then
				view:refresh()
			end
		end
	end)
end

--endregion
