--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"cc.Node")
local CityConfig = require("Metadatas.CityConfig")
local GamePlayer = require("Player.GamePlayer")
local ReportManager = require("Report.ReportManager")
local ReportDetailPanel = require("Report.ReportDetailPanel")
local GameUtil = require("Util.GameUtil")

local ReadStateImage = 
{
	[true] = "MenuScene/diban4.png",
	[false] = "MenuScene/diban3.png",
}

function This:init(report)
	self.m_report = report
	self.m_csNode = cc.Node:createFromCSFile("GameScene/NodeUI/BattleLogItem.csb")
	local w , h = self.m_csNode.bg:getContentSize()
	self:setContentSize(w,h)
	self:addChild(self.m_csNode)
end

function This:initNode()
	local str = GameUtil:int64ToString(self.m_report:getId())
	self.m_csNode.time:setString(os.date("%Y-%m-%d %X ",self.m_report:getStartTime())..str)
	local cityId = self.m_report:getCityId()
	self.m_csNode.city:setString(CityConfig[cityId].name)

	local isRead = ReportManager:isRead(self.m_report:getId())
	self.m_csNode.bg:setImage(ReadStateImage[isRead])

	local result = self.m_report:getResult()
	if self.m_report:getAttackerInfo().id == GamePlayer:getPlayerID() then
		self.m_csNode.name:setString(self.m_report:getDefencerName())
		self.m_csNode.results:setVisible(self.m_report:isAttackerVictory())
		self.m_csNode.results2:setVisible(not self.m_report:isAttackerVictory())
		self.m_csNode.jingong:setVisible(true)
		self.m_csNode.fangshou:setVisible(false)
	else
		self.m_csNode.name:setString(self.m_report:getAttackerName())
		self.m_csNode.results:setVisible(self.m_report:isDefencerVictory())
		self.m_csNode.results2:setVisible(not self.m_report:isDefencerVictory())
		self.m_csNode.jingong:setVisible(false)
		self.m_csNode.fangshou:setVisible(true)
	end
end

function This:initTouchEvent()
	self.m_csNode.bg:setTouch({
		onEnded = function(_,touch)
			self:onTouched()
		end,
		--isDynamic = true,
		isSwallow = false,
		isScale = false,
		isContainer = true,
	})
end

function This:onEnter()
	super.onEnter(self)
	self:initNode()
	self:initTouchEvent()
end

function This:onExit()
	super.onExit(self)
end

function This:refresh()
	local isRead = ReportManager:isRead(self.m_report:getId())
	self.m_csNode.bg:setImage(ReadStateImage[isRead])
end

function This:onTouched()
	print("onTouch ...")
	g_scene:openDialog("Report.ReportDetailPanel",self.m_report)
	ReportManager:setIsRead(self.m_report:getId(),true)
	self:refresh()
end



--endregion
