-- @Author: zheng
-- @Date:   2019-03-30 14:04:04
-- @Last Modified by:   zheng
-- @Last Modified time: 2019-03-30 14:13:30
-- @File Name: RescuBattleEndPanel.lua

local This , super = class(...,"Dialog")
local GameMapManager = require("Map.GameMapManager")

function This:initNode(info)
    self.m_csNode = cc.Node:createFromCSFile("LegionScene/NodeUI/LegionBattleEnd.csb")
    self:addChild(self.m_csNode)
    self.m_csNode:setToCenter()
    
    local isWin = false 
    local isDogfall = false
    if info then
        isWin = info.isWin or false
        isDogfall = info.isDogfall or false
    end
    self.m_csNode.continue_0:setVisible(isDogfall)
    self.m_csNode.battlewin_2:setVisible(isWin)
    self.m_csNode.battlefailed_1:setVisible(not isWin)
    self:initAnimation()
end

function This:initAnimation()
    self.m_csNode.continue:setScale(0.66)
    local seqence1 = cc.Sequence(cc.FadeTo(0.4,64),cc.FadeTo(0.4,255))
    local seqence2 = cc.Sequence(cc.ScaleTo(0.4,0.68),cc.ScaleTo(0.4,0.66))
    self.m_csNode.continue:runAction(cc.RepeatForever(cc.Spawn(seqence1,seqence2)))
end

function This:onTouchMask()
    -- print("exit")
    if GameMapManager:isInMap(GameMapType.kRescueMap) then
        GameMapManager:enterRescueMap()
    else
        cc.SceneManager:switchTo("Home.MenuScene")
    end
end