-- @Author: zheng
-- @Date:   2019-03-22 14:15:07
-- @Last Modified by:   superm
-- @Last Modified time: 2019-04-10 18:17:21
-- @File Name: RescuBianDuiNode.lua

local This , super = class(...,"Map.LegionBianDuiNode")
local RescuBianDuiView = require("RescueEmperor.RescuBianDuiView")
local kMaxBianDuiCount = 3

function This:initData()
    self.m_fileName = "RescueEmperor/RescueEmperorTroopsPreview.csb"
end

function This:initTouchEvent()
    local isHide = false
    local x , y = self:getPosition()
    -- self.m_csNode.shousuo:setTouch({
    --     onEnded = function()
    --         if not isHide then
    --             self:runAction(cc.MoveTo(0.3,x+self.m_offsetAnim,y,"SineOut"))
    --             isHide = true
    --         end
    --     end,    
    --     isDynamic = true
    -- })
    self.m_csNode.zhanchu:setTouch({
        onEnded = function()
            if isHide then
                self:runAction(cc.MoveTo(0.3,x,y,"SineOut"))
                self.m_csNode.zhanchu:setAngle(0)
                isHide = false
            elseif not isHide then
                self:runAction(cc.MoveTo(0.3,x+self.m_offsetAnim,y,"SineOut"))
                self.m_csNode.zhanchu:setAngle(180)
                isHide = true
            end
        end,
        isDynamic = true
    })
    -- self.m_csNode.legiontianjia_5:setTouch({
    --     onEnded = function()
    --         print("添加最大编队...")
    --         if self.addBianDui then
    --             self:addBianDui()
    --         end
    --     end,
    --     isDynamic = true
    -- })
end

function This:refresh()
    super.refresh(self)
    self.m_offsetAnim = 170
    self:refreshLockTxt()
end

function This:refreshLockTxt()
    if not self.m_troopItemList[1] then
        return
    end

    local maxCount = self.m_map:getMaxBianDuiCount()
    local csNode = self.m_csNode
    for bianduiIndex=1, kMaxBianDuiCount do
        local visible = bianduiIndex <= maxCount
        local temIndex = bianduiIndex-1
        local txt = csNode["jiesuo"..temIndex]
        if txt then
            txt:setVisible(not visible)
        end
        local item = self.m_troopItemList[bianduiIndex]
        if item then
            item:setVisible(visible)
        end
    end
end

function This:addBianDui()
    -- g_scene:openDialog("Vip.VipPanel")
end

function This:createItemView(info)
    return RescuBianDuiView:create(info)
end