-- @Author: zheng
-- @Date:   2019-03-21 11:34:07
-- @Last Modified by:   superm
-- @Last Modified time: 2019-04-10 17:52:21
-- @File Name: RescuBoxAndRank.lua

local This , super = class(...,"NodeUI")
local GameUtil = require("Util.GameUtil")
local RescueEmperorBuildMainRankItem = require("RescueEmperor.RescueEmperorBuildMainRankItem")
local RescueEmperorBoxRewardConfig = require("Metadatas.RescueEmperorBoxRewardConfig")
local RescueEmperorTimeConfig = require("Metadatas.RescueEmperorTimeConfig")
local GamePlayer = require("Player.GamePlayer")
local GameUtil = require("Util.GameUtil")

local selectCount =3
local TabName = 
{
    kForceKill   = 1,--杀兵
    kTroopKill = 2,--杀敌
    kCombKill  = 3,--连斩
}

function This:initNode(info)
	local node = info.node
	self.m_map = info.map
	self.m_boxManager = info.map:getBoxManager()--宝箱管理类
    
    self.m_rankNode = node.m_csNode.rank
    self.m_boxNode = node.m_csNode.kills
    self.m_timeTipNode = node.m_csNode.smallmap.timetips
	-- self.m_curListSelectedIndex = 1
	self.m_rankTitleList ={"","",""}

	local myRank = RescueEmperorBuildMainRankItem:create({})
	self.m_rankNode.me:addChild(myRank)
	self.m_myRank = myRank
	self.m_inited = false
	for tabKey=1,TabName.kCombKill do
		local item = self.m_rankNode.queeList["selectbg"..tabKey]
		self:addTabButton(tabKey,item,function()
			if self.m_inited then
				self:lightTabButton(tabKey)
				self.m_curListSelectedIndex = tabKey
			end
			self:refresh()
	    end)
	end
	self.m_curListSelectedIndex = TabName.kForceKill
	self:selectTabButton(self.m_curListSelectedIndex)
	self.m_escape = 0
	self:scheduleUpdate()
	self:refresh()
	self.m_inited = true
end

function This:refreshBoxState()
	local map = self.m_boxManager
	local boxNode = self.m_boxNode
	local rewardHistory = map:getBoxHistory()
	local isGray = #rewardHistory == table.count(RescueEmperorBoxRewardConfig)
	local isAdd = map:getIsCanReward()
	GameUtil:createBoxEffect(isAdd,boxNode.box,2,isGray)
	local curentScore = GameUtil:formatCount(map:getBoxRewardScore())
	local minCanStarLv = GameUtil:formatCount(map:getMinBoxStarLv())
	local str = Serialize["RescueEmperor_BoxAnd_1"] ..":".. curentScore .."/".. minCanStarLv
	boxNode.time1:setString(str)
end

function This:refresh()
	self:refreshTimeTip()
	self:refreshRankItem()
	self:refreshBoxState()
end

-- function This:initData( queue, dialog )
--     self.m_activity = queue
--     self.m_dialog = dialog
-- end

function This:initTouchEvent()
	local boxNode = self.m_boxNode
	boxNode.box:setTouch({
		onEnded = function()
			g_scene:openDialog("RescueEmperor.RescuRewardPanel",{map = self.m_boxManager})
		end,
		isDynamic = true
	})

	local randNode = self.m_rankNode
	local x,y = randNode:getPosition()
	local isHide = false
	randNode.jiantoubg:setTouch({
		onEnded = function()
			print("点击")
			if not isHide then
				randNode:runAction(cc.MoveTo(0.3,x-225,y,"SineOut"))
				isHide = true
                randNode.jiantoubg.jiantou:setAngle(180)
			else
				randNode:runAction(cc.MoveTo(0.3,x,y,"SineOut"))
				isHide = false
                randNode.jiantoubg.jiantou:setAngle(0)
			end
		end,
		isDynamic = true
	})

	if self.m_tabButtons then
        for name,button in pairs(self.m_tabButtons) do
            if not button.m_touch then
                button:setTouch({
                    onEnded = function ()
                        self:selectTabButton(name)
                    end,
                    isDynamic = true
                })
            end
        end
    end
end

function This:onEnter()
    super.onEnter(self)
    self.m_boxManager:addObserver(self)
end

function This:onExit()
    super.onExit(self)
    self.m_boxManager:removeObserver(self)
end

function This:refreshHeroListBtns(isShowBtn)
	self.m_rankNode.queeList:setVisible(isShowBtn)
end

function This:refreshRankItem()
	local itemData = self:getRankData() or {}
	local scrollView = self.m_rankNode.scrollView1
	scrollView:removeAllItems()
	local w2 , _ = scrollView:getContentSize()
	local myItem = {}
	for _,rankItem in ipairs(itemData) do
		if rankItem.isMe then
			myItem = rankItem
		end
		local item = RescueEmperorBuildMainRankItem:create(rankItem)
		-- item:setAnchorPoint(0.5,0.5)
		local w , h = item:getContentSize()
		scrollView:pushBackCustomItem(item, w2, h ,0.5)
	end
	self.m_myRank:refresh(myItem)
end

function This:getRankData()
	local map = self.m_boxManager
	local requestIndex = self:getRequestIndex()
	local rankList = map:getRankInfor(requestIndex)
	-- local result = {}
	-- if rankList and rankList.list then
	-- 	result = rankList.list
	-- end
	return rankList or {}
	-- local result ={}
	-- local selectIndex = self.m_curListSelectedIndex
	-- for index=1,10 do
	-- 	local item1= {level =index,name = Serialize[64104]..selectIndex,num = index}
	-- 	table.insert(result,item1)
	-- end
	-- return result

end


function This:getRequestIndex(selectIndex)
	local temSelectIndex = self.m_curListSelectedIndex
	if selectIndex then
		temSelectIndex = selectIndex
	end
	return temSelectIndex + 3
end

function This:getStartTime()
	return self.m_map:getStartTime()
end

function This:onFightTimeStart()
    local eff = nil
    eff = GameUtil:createEffect("ZhengBaKaiZhan",false,nil,{
        onAnimationComplete = function()
            eff:removeFromParent()
        end
    })
    eff:playAnimation("animation2")
    eff:setPosition(cc.visible.center.x,cc.visible.center.y)
    self:addChild(eff)
    self:runAction(cc.Sequence(cc.DelayTime(1.0), cc.CallFunc(function()
        cc.Audio:playEffect("Open_Fight.mp3")   
    end)))
end

function This:refreshTimeTip()
	local map = self.m_map
	local curTime = GamePlayer:getServerTime()
	local startTime = self:getStartTime()
	local offsetTime = curTime - startTime
	-- print("kk c",curTime," s",startTime," off",offsetTime)
	local timeNode = self.m_timeTipNode
	local tipVisible = false
	if offsetTime>0 then
		local curentTipItem = nil
		for _,tipItem in ipairs(RescueEmperorTimeConfig) do
			if offsetTime<tipItem.end_time then
				curentTipItem = tipItem
				break
			end
		end
		if curentTipItem then
			tipVisible = true
			local timeTxt = timeNode.time
			-- local temOffsetTime = offsetTime - curentTipItem.start_time
			local temOffsetTime = curentTipItem.end_time- offsetTime
			if curentTipItem.id ==1 and temOffsetTime <=1 and not self.m_startAnim then
				self.m_startAnim = true
				self:onFightTimeStart()
			end
			local leftTxt = GameUtil:formatTime(Serialize["M_S"],temOffsetTime)
			-- print("kk c",curTime," s",startTime," off",offsetTime,"temOffsetTime",temOffsetTime," s ",leftTxt)
			timeTxt:setString(string.format("%s %s",curentTipItem.name,leftTxt))
		end
	end
	timeNode:setVisible(tipVisible)
end

function This:update(dt)
    self.m_escape = self.m_escape + dt
    if self.m_escape > 1 then
        self.m_escape = self.m_escape - 1
        self:refreshTimeTip()
    end
end

function This:onGetBoxReward()
	self:refreshBoxState()
end

function This:onGetRankInfor()
	self:refreshRankItem()
end

-- This.onGetBoxReward = This.refreshBoxState
-- This.onGetRankInfor = This.refreshRankItem
