-- @Author: superm
-- @Date:   2019-03-25 16:44:14
-- @Last Modified by:   superm
-- @Last Modified time: 2019-03-25 17:20:52
-- @File Name: RescuTroopsPanel.lua
-- @Description: 

local This, super = class(...,"Dialog")
local RescuTroopsView = require("RescueEmperor.RescuTroopsView")
local GameUtil = require("Util.GameUtil")
local GamePlayer = require("Player.GamePlayer")

function This:initNode(info)
	self.m_map = info.map
	self.m_city = info.city
	self.m_escape = 0

	local csNode = cc.Node:createFromCSFile("RescueEmperor/RescueEmperorTroopMain.csb")
    self.m_csNode = csNode
    csNode:setToCenter()
	self:addChild(csNode)

	self:updateTroopList()
	self:updateTroopNode()
end

function This:initTouchEvent()
	self.m_csNode.close:setTouchEnded(function()
		self:close()
	end)
end

function This:onEnter()
	super.onEnter(self)
	self.m_map:addObserver(self)
end

function This:onExit()
	super.onExit(self)
	self.m_map:removeObserver(self)
end

function This:updateTroopList()
	self.m_bianduiList = {}
	local bianduiList = self.m_map:getAllBianDui()
	for i , biandui in ipairs(bianduiList) do
		if not biandui:isEmpty() then
			local state = biandui:getState()
			if state == LegionTroopState.kDefensive and biandui:getCityId() == self.m_city:getId()then
				table.insert(self.m_bianduiList,biandui)
			elseif state == LegionTroopState.kIdle then
				table.insert(self.m_bianduiList,biandui)
			end
		end
	end
end

function This:updateTroopNode()
	self.m_csNode.ScrollView:removeAllItems()
	for i , biandui in ipairs(self.m_bianduiList) do
		local view = RescuTroopsView:create({
			biandui = biandui, 
			city = self.m_city,
			map = self.m_map
		})
		self.m_csNode.ScrollView:pushBackCustomItem(view,630,150,0.5)
	end
end

function This:refresh()
	local itemList = self.m_csNode.ScrollView:getAllItem()
	for i , view in ipairs(itemList) do
		view:refresh()
	end
end

---------------------------------------------------------
function This:onAddHpFinish(biandui)
	if self.m_biandui == biandui then
		self:refresh()
	end
end