-- @Author: Su
-- @Date:   2019-03-22 14:44:07
-- @Last Modified by:   zheng
-- @Last Modified time: 2019-04-03 11:14:49
-- @File Name: RescueLogListPanel.lua

local This , super = class(...,"Dialog")
local RescueReportItemView = require("RescueEmperor.RescueReportItemView")
local GamePlayer = require("Player.GamePlayer")

function This:initNode(info)
	self.m_cityId = info.id
    self.m_map = info.map
    self.m_csNode = cc.Node:createFromCSFile("RescueEmperor/RescueEmperorLogList.csb")
    self:addChild(self.m_csNode)
    self.m_csNode:setToCenter()
    self.m_map:onGetCityBattleReportRequest(self.m_cityId)
--    self:refresh()

end

function This:refresh()
    self:refreshItemList()
end

function This:refreshItemList()
    local itemList = self:getListData()
    local scrollview = self.m_csNode.scrollview
    scrollview:removeAllItems()
    for _,itemData in ipairs(itemList) do

        local info = {map = self.m_map,itemData =itemData }
        local item = RescueReportItemView:create(info)
        local w,h = item.bg:getContentSize()
        scrollview:pushBackCustomItem(item, w, h ,0.5)
    end
end

function This:initTouchEvent()
    local csNode = self.m_csNode
    csNode.close:setTouchEnded(function()
		self:close()
    end)

    --刷新
    csNode.bubing:setTouchEnded(function()
        self.m_map:onGetCityBattleReportRequest(self.m_cityId)
    end)
end

 -- function This:onEnter()
 --     super.onEnter(self)
 --     self.m_map:addObserver(self)
 -- end

 -- function This:onExit()
 --     super.onExit(self)
 --     self.m_map:removeObserver(self)
 -- end

function This:setlistData(fightList)
    self.m_fightList = fightList or {}

end

function This:getListData()
    return self.m_fightList
    -- return {{attackid = 1020,name1= "name1",name2= "name2",group1 = "group1",group2 = "group2",isOur = true,isOther = false},
    --         {attackid = 2222,name1= "name1",name2= "name2",group1 = "group1",group2 = "group2",isOur = false,isOther = true},
    --         {attackid = 2222,name1= "name1",name2= "name2",group1 = "group1",group2 = "group2",isOur = false,isOther = false},}
end

-- function This:onGetCityBattleReport(info)
--     local cityId = info.city_id or 0
--     if cityId == self.m_cityId then
--         local function getGroupInfo(troopInfo,normalKillNum)
--             local groupName = troopInfo.group_name
--             local roleName = troopInfo.role_info.name
--             local isMy = troopInfo.role_info.id == GamePlayer:getPlayerID()
--             local killNum = troopInfo.troop.comb_kill

--             local temKillNum = killNum
--             if normalKillNum>killNum then
--                 temKillNum = normalKillNum
--             end

--             return groupName,roleName,isMy,temKillNum
--         end
--         self.m_attackCount = info.attack_count--进攻
--         self.m_defendCount = info.defend_count
--         local temFightList = {}
--         local fightList = info.fight_list
        
--         local killNum = 0
--         for _,fightInfo in ipairs(fightList) do
--             local reportId = fightInfo.report_id
--             local name1,group1,temIsOur1,temKillNum1 = getGroupInfo(fightInfo.attack_troop,0)
--             local name2,group2 ,temIsOur2,temKillNum2 = getGroupInfo(fightInfo.defend_troop,temKillNum1)
--             if temKillNum2>killNum then
--                 killNum = temKillNum2
--             end
--             local temIsOur = temIsOur1 or temIsOur2
--             local item1 = {attackid = reportId,name1 = name1,name2 = name2,group1 = group1,group2 = group2,isOur = temIsOur ,killNum =temKillNum2 }
--             table.insert(temFightList,item1)
--         end

--         local isOther = false
--         local isOur = false
--         local temFightList2 ={}
--         for _,fightItem in ipairs(temFightList) do
--             local temKillNum = fightItem.killNum
--             local temIsOther = killNum ==temKillNum
--             if fightItem.isOur and not isOur then
--                 isOur = true
--                 fightItem.isOther = false
--                 table.insert(temFightList2,1,fightItem)
--             elseif temIsOther and not isOther then
--                 fightItem.isOur = false
--                 fightItem.isOther = true
--                 table.insert(temFightList2,1,fightItem)
--             else
--                 fightItem.isOur = false
--                 fightItem.isOther = false
--                 table.insert(temFightList2,fightItem)
--             end
--             isOther = isOther or temIsOther
--         end
--         self.m_fightList = temFightList2
--         self:refresh()

--     end
-- end