-- @Author: zheng
-- @Date:   2019-03-25 10:19:31
-- @Last Modified by:   zheng
-- @Last Modified time: 2019-03-25 14:22:13
-- @File Name: RescueQueueDetailsPanel.lua

local This , super = class(...,"Dialog")

function This:initNode(info)
    local csFile = info.csFile or "RescueEmperor/RescueEmperorReportQueueDetails.csb"
    self.m_csNode = cc.Node:createFromCSFile(csFile)
    self:addChild(self.m_csNode)
    self.m_csNode:setToCenter()
    self:refresh(info)
end

function This:refresh(info)
    local csNode = self.m_csNode
    local titleName  = info.title
    local listData = info.listData
    if titleName then
        csNode.title:setString(titleName)
    end

    if listData then
        for index, data in ipairs(listData) do
            local view = self:createItemView(data)
            local w , h = view:getContentSize()
            csNode.scrollView:pushNode(view, w, h)
        end
    end

end

function This:createItemView(data)
    local groupName = data.groupName
    local numList ={data.num1,data.num2}
    local rootNode = cc.Node:createFromCSFile("RescueEmperor/RescueEmperorReportQueueDetailsItem.csb")
    rootNode:setContentSize(182,94)
    rootNode.name:setString(groupName)
    for index,numValue in ipairs(numList) do
        local txt = rootNode["num"..index]
        txt:setString(numValue)
    end
    return rootNode
end


function This:onTouchMask() -- 对话框之外区域的点击事件
    self:close()
end