

-- 勤王战分组中

local This , super = class(...,"NodeView")
local EntrantManager = require("LegionEntrant.EntrantManager")
local GameUtil = require("Util.GameUtil")
local GamePlayer = require("Player.GamePlayer")

-- 刷新间隔
local ReqMsgTime = 60 * 1


function This:initData(info)
	self.m_mainUI = info.mainUI
	self.m_rescueWarData = info.data
	self.m_lastReqTime = GamePlayer:getServerTime()
end

function This:initNode(info)
    local csNode = cc.Node:createFromCSFile("RescueEmperor/RescueEmperorPreview.csb")
    csNode:setToCenter()
    self:addChild(csNode)
    self.m_csNode = csNode

    csNode.button1:setVisible(false)

    csNode.bg1:adapterFullScreen()
	csNode.close:adapterBorder("right", "top", -cc.visible.designWidth/2, -cc.visible.designHeight/2)
	csNode.guize:adapterBorder("right", "bottom", -cc.visible.designWidth/2, -cc.visible.designHeight/2)
	csNode.qinwangdian:adapterBorder("right", "bottom", -cc.visible.designWidth/2, -cc.visible.designHeight/2 )
	csNode.button:setVisible(false)
	csNode.tips:setVisible(false)
	csNode.time:setString("分组中")
	csNode.time:setVisible(false) -- 先隐藏

	self:setTimer(2.0, function ()
	    csNode.time:setVisible(true)
	end)

	-- 关闭
	csNode.close:setTouchEnded(function()
	    self.m_mainUI:close()
	end) 

	-- 规则
	csNode.guize:setTouchEnded(function()
        g_scene:openDialog("RescueEmperor.RescueWarRulePanel")
	end)

	-- 勤王殿
	csNode.qinwangdian:setTouchEnded(function()
        g_scene:openDialog("Palace.PalacePanel", {tab = "tep2"})
	end)
end


function This:updateLeftTime(leftTime)
	local curTime = GamePlayer:getServerTime()
	if curTime - self.m_lastReqTime > ReqMsgTime then
		self.m_lastReqTime = curTime
		EntrantManager:onRescueInfoRequest()
	end
end