
local This , super = class(...,"NodeUI")
local GameUtil = require("Util.GameUtil")
local FamilyManager = require("Family.FamilyManager")


function This:initData(data)
    self.m_data = data
end

function This:initNode(data)
    self.m_csNode = cc.Node:createFromCSFile("RescueEmperor/RescueEmperorQualificationList.csb")
    self:addChild(self.m_csNode)

    local w, h = self.m_csNode.xuanzhong:getContentSize()
    self:setContentSize(w, h)
end

function This:onEnter()
    super.onEnter(self)
    self:refresh()
end

function This:setModel(data)
    self.m_data = data
    self:refresh()
end

function This:refresh()
    local data = self.m_data
    local csNode = self.m_csNode
    local myGroupId = FamilyManager:getMyFamilyId() or 0

    csNode.xuanzhong:setVisible( data.groupId == myGroupId )
    csNode.weixuanzhong:setVisible( data.groupId ~= myGroupId )

    --排名
    csNode.rank:setString(data.index)

    --军团名字
    csNode.name:setString(data.groupName)

    --区服
    local tag = GameUtil:getServerTag(data.serverId)
    csNode.number:setString( string.format("%s%d区-%s", tag, data.indexInGroup, data.serverName) )
end


