

-- 勤王战备战界面


local This, super = class(...,"NodeView")
local RankPageListLayer = require("Rank.RankPageListLayer")
local RescueWarPrepareItemView = require("RescueEmperor.RescueWarPrepareItemView")
local GameUtil = require("Util.GameUtil")
local EntrantManager = require("LegionEntrant.EntrantManager")

function This:initData(info)
	self.m_mainUI = info.mainUI
	self.m_rescueWarData = info.data
    self.m_leftTime = info.data:getStateLeftTime()	
end

function This:initNode(info)
    local csNode = cc.Node:createFromCSFile("RescueEmperor/RescueEmperorQualification.csb")
    csNode:setToCenter()
    self:addChild(csNode)
    self.m_csNode = csNode

    csNode.bg1:adapterFullScreen()
	csNode.close:adapterBorder("right", "top", -cc.visible.designWidth/2, -cc.visible.designHeight/2)
	csNode.guize:adapterBorder("right", "bottom", -cc.visible.designWidth/2, -cc.visible.designHeight/2)
	csNode.qinwangdian:adapterBorder("right", "bottom", -cc.visible.designWidth/2, -cc.visible.designHeight/2 )
	csNode.buttonjinru:setVisible(false)

	-- 关闭
	csNode.close:setTouchEnded(function()
	    self.m_mainUI:close()
	end) 

	-- 规则
	csNode.guize:setTouchEnded(function()
        g_scene:openDialog("RescueEmperor.RescueWarRulePanel")
	end)

	-- 勤王殿
	csNode.qinwangdian:setTouchEnded(function()
        g_scene:openDialog("Palace.PalacePanel", {tab = "tep2"})
	end)

   	local scrollView = self.m_csNode.ScrollView
	scrollView:setDirection("vertical")

    self.m_listLayer = RankPageListLayer:create({
        itemWidth = 440,
        itemHeight = 39,
        spaceX = 0,
        spaceY = 0,
        scrollView = scrollView,
		dataCounter = function ()
	        local rank = self:getRankData()	 
	        return #rank
        end,
        viewCreator =  function(index, node)
        	local rank = self:getRankData()	   
        	local data = rank[index]
        	if data then     
			    if not node then
				    return RescueWarPrepareItemView:create(data, index)
				else
			        node:setModel(data, index)
			    end
			end
	    end
    })

    self.m_listLayer:setCascadeOpacityEnabled(true)
    self.m_listLayer:setAnchorPoint(0.5, 0)
    local w, h = self.m_listLayer:getContentSize()
    scrollView:pushBackCustomItem(self.m_listLayer, w, h, 0)
    self.m_listLayer:setDataList()
end

function This:onEnter()
    super.onEnter(self)
    EntrantManager:addObserver(self)
end

function This:onExit()
    super.onExit(self)
    EntrantManager:removeObserver(self)
end

function This:updateLeftTime(leftTime)
	self.m_leftTime = leftTime
	self.m_csNode.time:setString( GameUtil:formatDTime(Serialize[61602], leftTime) )
end

function This:getRankData()
	return self.m_rescueWarData:getGroupList()
end

function This:onRescueResultReply(data)
	self.m_rescueWarData = data
	self.m_listLayer:setDataList()
end

