
local This , super = class(...,"NodeUI")
local GameUtil = require("Util.GameUtil")


function This:initData(data)
    self.m_data = data
end

function This:initNode(data)
    self.m_csNode = cc.Node:createFromCSFile("RescueEmperor/RescueEmperorRewardRankItem.csb")
    self:addChild(self.m_csNode)

    local w, h = self.m_csNode.weixuanzhong:getContentSize()
    self:setContentSize(w, h)
    --self.m_csNode:setPosition(w/2, h/2) 
end

function This:onEnter()
    super.onEnter(self)
    self:refresh()
end

function This:setModel(data)
    self.m_data = data
    self:refresh()
end

function This:refresh()
    local data = self.m_data
    local csNode = self.m_csNode

    --排名
    local rankImg = {
        [1] = "MenuScene/top1.png",
        [2] = "MenuScene/top2.png",
        [3] = "MenuScene/top3.png",
    }
    local img = rankImg[data.rank]
    if img then
        csNode.top:setImage(img)
        csNode.top:setVisible(true)
        csNode.rank:setVisible(false)
    else
        csNode.top:setVisible(false)
        csNode.rank:setString(data.rank)
        csNode.rank:setVisible(true)
    end

    --军团名字
    csNode.familyname:setString(data.groupName)

    --玩家名字
    csNode.name:setString(data.name)

    --服务器
    local tag = GameUtil:getServerTag(data.serverId)
    csNode.qufu:setString(string.format("%s%d区-%s", tag, data.indexInGroup, data.serverName))

    --数值
    csNode.time:setString(data.value)
end


