
-- 响应界面数据

local This , super = class(..., "Base.BaseModel")
local FamilyManager = require("Family.FamilyManager")


function This:init(msg)
	super.init(self)
    
	self.m_rank = {}
	self.m_lastWinId = 0
	self.m_response = 0

	self:handleMsg(msg)
end

function This:handleMsg(msg)
	if not msg then
		return
	end

    local list = {}
    local lastWinId = msg.last_week_win_id

    for i, v in ipairs(msg.rescuermperor_group_list) do
    	local t = {}
    	t.index 		= i
    	t.rank 			= i
    	t.groupId 		= v.group_id
    	t.groupName 	= v.group_name
    	t.times 		= v.times
    	t.power 		= v.power
    	t.isLastWin     = (v.group_id == lastWinId)
    	table.insert(list, t)
    end

 --    if #list > 1 then
	--     table.sort(list, function (a, b)
	--     	local aWin = a.isLastWin and 1 or 0
	--     	local bWin = b.isLastWin and 1 or 0
	--     	if aWin ~= bWin then
	--     		return aWin > bWin
	--     	else
	--     		if a.power ~= b.power then
	--     			return a.power > b.power
	--     		else
	--     			return a.index < b.index
	--     		end
	--     	end
	--     end)
	-- end

	-- for i, v in ipairs(list) do
	-- 	v.rank = i
	-- end

	self.m_rank 			= list
    self.m_lastWinId 		= lastWinId
    self.m_response 		= msg.signupflag --0没有响应，1已响应或者不能进行响应操作	
end

function This:getRank()
	return self.m_rank
end

function This:getRankByPhase(phase)
	if phase >= EntrantState.kGroup then
		local list = {}
		for i = 1, 4 do
			if self.m_rank[i] then
				table.insert(list, self.m_rank[i])
			end
		end
		return list	
	end

	return self.m_rank
end

function This:getMyRank()
	local familyId = self:getFamilyId()
	for _, v in ipairs(self.m_rank) do
		if v.groupId == familyId then
			return v
		end
	end
end

function This:getFamilyId()
	return FamilyManager:getMyFamilyId() or 0
end

function This:getResponseState()
	-- 1没有资格
	local rank = self:getMyRank()
	if not rank then
		return 1
	end

	-- 2上周冠军，默认已响应
	if rank.isLastWin then
		return 2
	end

	-- 3已响应
	if self.m_response == 1 then
		return 3
	end

	-- 0未响应
	return 0 
end

--是否有资格战斗(前4名)
function This:isHasQuaFight()
	local familyId = self:getFamilyId()
	local rank = self:getRank()

	for i=1, 4 do
		if rank[i] then
			if rank[i].groupId == familyId then
				return true
			end
		end
	end

	return false
end
