
local This , super = class(...,"NodeUI")


function This:initData(data)
    self.m_data = data
end

function This:initNode(data)
    self.m_csNode = cc.Node:createFromCSFile("RescueEmperor/RescueEmperorQualificationList.csb")
    self:addChild(self.m_csNode)

    local w, h = self.m_csNode.bg:getContentSize()
    self:setContentSize(w, h)
    self.m_csNode:setPosition(w/2, h/2) 
end

function This:onEnter()
    super.onEnter(self)
    self:refresh()
end

function This:setModel(data)
    self.m_data = data
    self:refresh()
end

function This:refresh()
    local data = self.m_data
    local csNode = self.m_csNode

    csNode.xuanzhong:setVisible( (data.rank%2 == 0) and true or false )

    --排名
    csNode.rank:setString(data.rank)

    --军团名字
    csNode.name:setString(data.groupName)

    --响应次数
    csNode.number:setString(data.isLastWin and "" or data.times)

    --战力
    csNode.power:setString(data.isLastWin and Serialize[64142] or data.power)

end


