

-- 勤王战响应界面

local This , super = class(...,"NodeView")
local EntrantManager = require("LegionEntrant.EntrantManager")
local GameUtil = require("Util.GameUtil")


function This:initData(info)
	self.m_mainUI = info.mainUI
	self.m_rescueWarData = info.data
    self.m_leftTime = info.data:getStateLeftTime()
end

function This:initNode(info)
    local csNode = cc.Node:createFromCSFile("RescueEmperor/RescueEmperorPreview.csb")
    csNode:setToCenter()
    self:addChild(csNode)
    self.m_csNode = csNode

    csNode.button1:setVisible(false)

    csNode.bg1:adapterFullScreen()
	csNode.close:adapterBorder("right", "top", -cc.visible.designWidth/2, -cc.visible.designHeight/2)
	csNode.guize:adapterBorder("right", "bottom", -cc.visible.designWidth/2, -cc.visible.designHeight/2)
	csNode.qinwangdian:adapterBorder("right", "bottom", -cc.visible.designWidth/2, -cc.visible.designHeight/2 )

	-- 关闭
	csNode.close:setTouchEnded(function()
	    self.m_mainUI:close()
	end) 

	-- 规则
	csNode.guize:setTouchEnded(function()
        g_scene:openDialog("RescueEmperor.RescueWarRulePanel")
	end)

	-- 勤王殿
	csNode.qinwangdian:setTouchEnded(function()
        g_scene:openDialog("Palace.PalacePanel", {tab = "tep2"})
	end)

	-- 响应
	csNode.button:setTouchEnded(function()
		local data = self.m_rescueWarData
		local curResp = data:getCurResponse()
		local maxResp = data:getMaxResponse()
		local isResp = data:getIsResponse()

		if curResp >= maxResp then
			return
		end

		if isResp then
			return
		end

        if self.m_leftTime <= 0 then
        	return
        end

        EntrantManager:onRescueResponseRequest()
	end)

	self:refresh()
end

function This:onEnter()
    super.onEnter(self)
    EntrantManager:addObserver(self)
end

function This:onExit()
    super.onExit(self)
    EntrantManager:removeObserver(self)
end

function This:refresh()
	local data = self.m_rescueWarData
	local csNode = self.m_csNode

	local curResp = data:getCurResponse()
	local maxResp = data:getMaxResponse()
	local isResp = data:getIsResponse()
	
	if curResp >= maxResp then
		-- 报名成功
		csNode.button.text:setString(Serialize[61608])
	else
		if isResp then
			csNode.button.text:setString( string.format(Serialize[61609], curResp, maxResp) )
		else
			csNode.button.text:setString( string.format(Serialize[61610], curResp, maxResp) )
		end
	end

    self:updateLeftTime(self.m_leftTime)
end

function This:updateLeftTime(leftTime)
	self.m_leftTime = leftTime
	self.m_csNode.time:setString( GameUtil:formatDTime(Serialize["Warfare_WarfareInfo_51"], leftTime) )
end

-- 勤王战响应
function This:onRescueResponseReply(data)
	self.m_rescueWarData = data
	self:refresh()
end