

-- 勤王战结果界面

local This, super = class(...,"NodeView")
local EntrantManager = require("LegionEntrant.EntrantManager")
local GameUtil = require("Util.GameUtil")


function This:initData(info)
	self.m_mainUI = info.mainUI
	self.m_rescueWarData = info.data
end

function This:initNode(info)
    local csNode = cc.Node:createFromCSFile("RescueEmperor/RescueEmperorReward.csb")
    csNode:setToCenter()
    self:addChild(csNode)
    self.m_csNode = csNode

	-- 关闭
	csNode.close:setTouchEnded(function()
	    self.m_mainUI:close()
	end)

	-- 规则
	csNode.guize:setTouchEnded(function()
        g_scene:openDialog("RescueEmperor.RescueWarRulePanel")
	end)

	-- 本场排行
	csNode.rank:setTouchEnded(function()
        g_scene:openDialog("RescueEmperor.RescueWarRankPanel", {dataType = 1, data = self.m_rescueWarData})
	end)

	-- 赛区排行
	csNode.rank1:setTouchEnded(function()
        g_scene:openDialog("RescueEmperor.RescueWarRankPanel", {dataType = 2, data = self.m_rescueWarData})
	end)

	self:refresh()
end

function This:onEnter()
    super.onEnter(self)
    EntrantManager:addObserver(self)
end

function This:onExit()
    EntrantManager:removeObserver(self)
    super.onExit(self)
end

function This:refresh()
	local csNode = self.m_csNode
	local data = self.m_rescueWarData

	local groupRank = data:getGroupRank()
	self:refreshGroup(csNode.huosheng.text, groupRank[1])
	self:refreshGroup(csNode.juntuan2, groupRank[2])
	self:refreshGroup(csNode.juntuan3, groupRank[3])
	self:refreshGroup(csNode.juntuan4, groupRank[4])

	--杀敌
	local roleRank1 = data:getRoleRankByType(RescueRankType.kShaDi)
	self:refreshWiner(csNode.winer2, roleRank1[1])

	--屠戮
	local roleRank2 = data:getRoleRankByType(RescueRankType.kTuLu)
	self:refreshWiner(csNode.winer1, roleRank2[1])

	--连斩
	local roleRank3 = data:getRoleRankByType(RescueRankType.kLianZhan)
	self:refreshWiner(csNode.winer3, roleRank3[1])

end

function This:refreshGroup(node, data)
	if not data then
		node:setString("")
		return
	end
	node:setString(data.groupName)
end

function This:refreshWiner(node, data)
	if not data then
		node.name:setString("")
		node.icon:setVisible(false)
		node.namebg:setVisible(false)
		node.noone:setVisible(true)
		return
	end
	node.namebg:setVisible(true)
	node.noone:setVisible(false)
	node.icon:setVisible(true)
	GameUtil:setPlayerFeltNodeResource(node.icon, data.icon)
	node.name:setString(data.name)
end

function This:onRescueResultReply(data)
	self.m_rescueWarData = data
	self:refresh()
end