
--勤王战规则界面

local This , super = class(...,"Dialog")
local RescueEmperorRuleConfig = require("Metadatas.RescueEmperorRuleConfig")
local RescueWarRuleRewardNode = require("RescueEmperor.RescueWarRuleRewardNode")


function This:initData(info)
    self.m_ruleList = {}
    self.m_rewardView = nil

    for k, v in pairs(RescueEmperorRuleConfig) do
        table.insert(self.m_ruleList, v)
    end

    table.sort(self.m_ruleList, function (a, b)
        return a.id < b.id
    end)

    --最后一个是奖励页面
    local id = #self.m_ruleList
    table.insert(self.m_ruleList, {
        id = id,
        paging_id = id,
        paging_name = Serialize[60659],
        paging_text = "",
    })
end

function This:initNode(info)
    local csNode = cc.Node:createFromCSFile("RescueEmperor/RescueEmperorRule.csb")
    self:addChild(csNode)
    self.m_csNode = csNode

    csNode:setToCenter()

    for i, config in ipairs(self.m_ruleList) do
        local node = csNode[string.format("tep%d", i)]
        if not node then
            break
        end
        node.normal:setString(config.paging_name)
        node.light.light:setString(config.paging_name)
        self:addTabButton(i, node, function()
            self:selectTab(i)
        end)
    end

    self:selectTabButton(1)
end

function This:initTouchEvent()
    self.m_csNode.close:setTouchEnded(function()
        self:close()
    end)
end

function This:onEnter()
    super.onEnter(self)
end

function This:onExit()
    super.onExit(self)
end

function This:selectTab(tab)
    if self.m_curTab == tab then
        return
    end
    self.m_curTab = tab

    local csNode = self.m_csNode

    -- 小标题
    local config = self.m_ruleList[tab]
    csNode.teptitle:setString(config.paging_name)

    -- 内容
    csNode.scrollview:removeAllItems()

    if tab == #self.m_ruleList then
        if not self.m_rewardView then
            self.m_rewardView = RescueWarRuleRewardNode:create()
            self.m_rewardView:setPosition( csNode.scrollview:getPosition() )
            self.m_csNode:addChild(self.m_rewardView)
        end
        self.m_rewardView:setVisible(true)
        csNode.scrollview:setVisible(false)
    else
        local text = cc.Label:createNormalTTF("", 16)
        text:setStringWithColor(config.paging_text, 740)
        text:setAnchorPoint(0.5,0)
        text:setCascadeOpacityEnabled(true)
        local w , h = text:getContentSize()
        csNode.scrollview:pushBackCustomItem(text, w, h, 0)
        csNode.scrollview:setVisible(true)
        if self.m_rewardView then
            self.m_rewardView:setVisible(false)
        end
    end
end