---
---
--- Created by aid.
--- DateTime: 2018/4/18 16:46
---

-- signalHandlers的定义和使用示例
--local Signals = require("SignalSystem.Signals")
--local SignalSystem = require("SignalSystem.SignalSystem")
--
--local signalHandlers = {}
--signalHandlers[Signals.Xxx1] = function(data)
--    -- TODO something
--end
--signalHandlers[Signals.Xxx2] = function(data)
--    -- TODO something
--end
--SignalSystem.addSignalHandlers(signalHandlers)
---- do something
--SignalSystem.removeSignalHandlers(signalHandlers)
--
--SignalSystem.distributeSignal(Signals.Xxx1, data)

local M = {}
package.loaded[...] = M

-- 查询上次收到的信号
function M.inquireLastSignals(signalHandlers)
    for signal, handler in pairs(signalHandlers) do
        if signal.data ~= nil then
            handler(signal.convert(signal.data))
        end
    end
end

-- 添加信号监听器
function M.addSignalHandlers(signalHandlers)
    for signal, handler in pairs(signalHandlers) do
        local handlerList  = signal.handlerList
        if handlerList == nil then
            handlerList = {}
            signal.handlerList = handlerList
        end
        handlerList[handler] = true
    end
end

-- 移除信号监听器
function M.removeSignalHandlers(signalHandlers)
    for signal, handler in pairs(signalHandlers) do
        local handlerList  = signal.handlerList
        if handlerList ~= nil then
            handlerList[handler] = nil -- 移除回调
        end
    end
end

-- 查询上次收到的信号并监听该信号
function M.inquireAndListenSignals(signalHandlers)
    M.addSignalHandlers(signalHandlers)
    M.inquireLastSignals(signalHandlers)
end


function M.distributeSignal(signal, data)
    signal.data = data -- 缓存回复信息

    local handlerList = signal.handlerList
    if handlerList == nil then
        return
    end

    for handler, _ in pairs(handlerList) do
        handler(signal.convert(data))
    end
end