-- @Author: zheng
-- @Date:   2018-12-13 16:12:45
-- @Last Modified by:   zheng
-- @Last Modified time: 2019-01-04 17:15:59
-- @File Name: GameTowerDayReward.lua

local This = class(...)

local DayRewardConfig = require("Metadatas.DayRewardConfig")

-- local SingleManager = require("SingleDaily.SingleManager")

function This:create()
    local o = {}
    setmetatable(o,This)
    o:init()
    return o
end

function This:init(id)
  if id then
      local temId = nil
      local dayRewardCount = #DayRewardConfig
      for configId=dayRewardCount,1,-1 do
      -- for configId,configData in ipairs(DayRewardConfig) do
        configItem = DayRewardConfig[configId]
        if id>= configItem.min then
          temId = configId
          break
        end
      end
      if temId then
  	    self.m_id = temId
  	    self.m_config = DayRewardConfig[temId]
      end
   	else
   		self.m_isReceiver = 0--(0:未领奖, 1:领取过免费奖励, 2:领取过付费奖励)
   	end
end

function This:getId()
    return self.m_id
end

function This:getReward()
    return self.m_config.reward
end

function This:getMoneyReward()
   return self.m_config.moneyreward 
end

function This:getCostMoney()
   return self.m_config.money 
end

function This:setIsReceiver(isReceiver)
	self.m_isReceiver = isReceiver
end

function This:getIsReceiver()
	return self.m_isReceiver
end

function This:isCanReward()
    return self.m_isReceiver ==0
end
