-- @Author: zheng
-- @Date:   2018-12-13 16:12:45
-- @Last Modified by:   zheng
-- @Last Modified time: 2019-11-21 14:38:55
-- @File Name: GameTowerMaster.lua

local This = class(...)
local GamePlayer = require("Player.GamePlayer")
local GameUtil = require("Util.GameUtil")

local TowerMasterConfig = require("Metadatas.TowerMasterConfig")

-- local SingleManager = require("SingleDaily.SingleManager")

function This:create(id)
    local o = {}
    setmetatable(o,This)
    o:init(id)
    self:updateInfor()
    return o
end

function This:init(id,info)
    self.m_id = id
    self.m_config = TowerMasterConfig[id]
    if info then
    	self:updateInfor(info)
    end
end

function This:getId()
    return self.m_id
end

function This:getReward()
    return GameUtil:convertData(self.m_config.reward)
end

function This:getLevelLimit()
   return self.m_config.pass 
end
-----------------------------------------后端参数
function This:updateInfor(info)
	local roleId = 0
	local name = ""
	local icon = 0
	local title = 0
	local effectStr = 0
	local power = 0
	local roleLevel = 0
	local group_name = ""
	local heroList = {}--{{card_id =0,card_type = 0,star = 0,level =0,awake = false}}
	if info then
		roleId = info.role_id
		name = info.name
		icon = info.icon
		title = info.title
		effectStr = info.effect
		power = info.power
		heroList = info.card_list
		roleLevel = info.role_level
		group_name = info.group_name
	end
	self.m_roleId = roleId
	self.m_name = name
	self.m_icon = icon
	self.m_title = title
	self.m_effectStr = effectStr
	self.m_power = power
	self.m_heroList = heroList
	self.m_roleLevel = roleLevel
	self.m_group_name = group_name
end

--是否有塔主
function This:isHaveTower()
	return self.m_roleId~=0
end

function This:isMyHeroList()
	if self:isHaveTower() then
		return self.m_roleId ==GamePlayer:getPlayerID()
	end
	return false
end

function This:getRoleId()
	return self.m_roleId
end

function This:getRoleName()
	return self.m_name
end

function This:getRoleLevel()
	return self.m_roleLevel
end

function This:getIcon()
	return self.m_icon
end

function This:getGroupName()
	return self.m_group_name
end

function This:getTitle()
	return self.m_title
end

function This:getEffect()
	return self.m_effectStr
end

function This:getPowerNum()
	return self.m_power
end

function This:setPowerNum(power)
	self.m_power = power or self.m_power
end

function This:setHeroList(heroList)
	self.m_heroList = heroList or self.m_heroList
end

function This:getHeroList()
-- 	message msgcardbase{
--     optional int64 card_id = 1;
--     optional int32 card_type = 2;
--     optional int32 star = 3;
--     optional int32 level = 4;
--     optional bool awake = 5;                    //是否完全觉醒
-- }
	return self.m_heroList----{{card_id =0,card_type = 0,star = 0,level =0,awake = false}}
end
--获取所有阵容的武将id
function This:getAllHeroIds()
	local result = {}
	 for _,heroCardBase in ipairs(self.m_heroList) do
            local heroId = heroCardBase.card_type
            if heroId and heroId~=0 then
                table.insert(result,heroId)
            end
        end
	return result
end
