-- @Author: zheng
-- @Date:   2018-08-14 17:17:16
-- @Last Modified by:   zheng
-- @Last Modified time: 2018-09-01 18:27:11
-- @File Name: SingleStageEmbattleHeroPanel.lua


local This , super = class(...,"Stage.EmbattleHeroPanel")
local SingleManager = require("SingleDaily.SingleManager")

local GamePlayer = require("Player.GamePlayer")


function This:initNode(info)
	self:refreshStage()
	self.m_teamIndex = info.teamIndex
	super.initNode(self,info)
	
end

function This:initBaseInfo()
	self.m_csNode.helpbutton:setVisible(false)
	self.m_csNode.bg3.tagettext:setString(Serialize[64171])
	self.m_csNode.bg3.taget:setString(string.format("%s(%s)",self.m_data:getName(),self.m_stage:getTitle()))
	self.m_csNode.bg3.name:setString(GamePlayer:getRoleName())
	
	local hp = self:getTotalHp()
	self.m_csNode.bg3.totalhp:setString(string.format("%d",hp))
	self.m_csNode.bg3.cost:setVisible(false)
	self.m_csNode.bg3.consume:setVisible(false)
	self.m_csNode.Battlebutton.text:setString(Serialize[64172])

end

function This:getHeroSource()
    return self.m_stage:getTeam(self.m_teamIndex)
end

function This:openSelectPanel()
	local haveSelected = {}
	local stage = self.m_stage
	local allHeroList = stage:getEmBattle(  )
	for i , info in pairs(allHeroList) do
		haveSelected[info] = true
	end
	local panel = self:openDialog("Stage.StageSelectHeroPanel",{haveSelected = haveSelected})
	return panel
end

function This:onEmbattleOnceKey()
	local stage = self.m_stage
	stage:setTeamHeroIdList({},self.m_teamIndex)
	local heros1 = self:getAllHeroList()

	local heros = stage:getAllHeros(heros1)
	if table.count(heros)==0 then
		g_scene:showTips(Serialize[64173])
		return 
	end
	local maxCount = math.min(#heros,6)
	self.m_fetters = {}
	for i , info in pairs(self.m_heros) do
		info.heroId = nil
		if info.node then
			info.node:removeFromParent()
			info.node = nil
		end
	end
	self.m_heros = {}
	for i = 1 , maxCount do
		self:addHero(i,heros[i]:getId())
	end
	self:embattle(true)

end

function This:gotoBattle(heroList, isOnceKey)
	local tmp = {}
	for pos , info in pairs(self.m_heros) do
		tmp[pos] = info.heroId
	end
	local stage = self.m_stage
	self.m_stage:setTeamHeroIdList(tmp,self.m_teamIndex)
	local id = stage:getId()
	SingleManager:onEmbattleHerosRequest(id,self.m_teamIndex)

	if isOnceKey then
	else--保存
		self:close()
	end
end

function This:refreshStage(  )
	self.m_data = SingleManager:getSelectChapter()
	self.m_stage = self.m_data:getSelectStage( )
end

