-- @Author: zheng
-- @Date:   2018-08-14 17:04:47
-- @Last Modified by:   zheng
-- @Last Modified time: 2018-10-22 10:31:39
-- @File Name: SingleStageEndPanel.lua


local This , super = class(...,"Dialog")
local strList ={
    chapter =Serialize[64175],
}


local SingleManager = require("SingleDaily.SingleManager")

local ArenaHeroView = require("Arena.ArenaHeroView")
local HeroManager = require("Hero.HeroManager")
local MenuScene = require("Home.MenuScene")

function This:initNode(info)
	if info then
		self.m_hurts = info.hurts
		self.m_rewards = info.rewards
	end

	self.m_csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/SingleDailyStageEnd.csb")
	self:addChild(self.m_csNode)
	self.m_csNode:setToCenter()

	self:refreshStage()
	local stage = self.m_stage
	local maxTeam = stage:getMaxTeam()
	self.m_cardNodes = {}
	for i = 1 , maxTeam do
        local view = ArenaHeroView:create(nil)
        local team = self.m_csNode["team"..i]
        local item = team.hero
        item:addChild(view)
        self.m_cardNodes[i] = view
    end

	cc.Audio:playEffect("Win.mp3")
	self:refrsh( )
end


function This:initTouchEvent()
	self.m_csNode.button:setTouchEnded(function ()
		cc.SceneManager:switchTo("Home.MenuScene")
		local id = SingleManager:getSelectChapterId( )
		local info = { tabIndex =1, arg = { id = id}}
		MenuScene:addDelayDialog({name = "Warfare.WarfarePanel", arg = info})
	end)
end

function This:refrsh( )
	self:refreshStage(  )
	local hurts = self.m_hurts
	local rewards = self.m_rewards
	local stage = self.m_stage
	local percent = stage:getCurentPercent()
	local isChange,percentChange =stage:getProgressChange()
	local node = self.m_csNode

	node.number:setString(string.format("%d%%",percent))
	node.jindutiao:setPercent(percent)
	node.change:setVisible(isChange)
	if isChange then
		node.change.numbertisheng:setString(string.format("%d%%",percentChange))
	end

	local maxTeam = stage:getMaxTeam()
	for i=1,maxTeam do
		node["team"..i]:setVisible(false)
	end
	for i,hurtData in ipairs(hurts) do
		local index = hurtData.index
		local damage = hurtData.damage
		local item = node["team"..index]

		local cardList = stage:getTeam(index,true)
		local heroId = cardList[1]
		if heroId then
			item:setVisible(true)
			item.numbershanghai:setString(string.format("%d%%",damage))
			local hero = HeroManager:getHero(heroId)--getHeroByUid(cardList[i])
            local info = {id = hero:getUid(), level = hero:getLevel(), star = hero:getStarLv() * 5 + hero:getPhase(), heroId = hero:getId(),awake = hero:isAwakeFull()}
            self.m_cardNodes[index]:setModel(info)
		end
	end

	self:refreshItemNode( node,rewards )
end

function This:refreshItemNode( node,scrTable )
    local count = 1
    for i=1,5 do
        local item = node["item"..i]
        item:setVisible(false)
    end
    for k,itemConfig in pairs(scrTable) do
        local item = node["item"..count]
        if type(itemConfig) == "number" then
        	item:setVisible(false)
        else
        	item:setVisible(true)
        	self:creatItemNode(item,itemConfig.id,itemConfig.num)
        end
        count = count+1
    end
end

function This:creatItemNode(parent,key,needNum)
	local ItemNode = require("UI.ItemNode")
    local name = "ItemNode"
    local node = parent:getChildByName(name)
    if not node then
        node = ItemNode:create(key, 1)
        node:setAnchorPoint(0.5, 0.5)
        parent:addChild(node)
        node:setName(name)
    end
    node:initItem(key,needNum) 
end

function This:refreshStage(  )
	self.m_data = SingleManager:getSelectChapter()
	self.m_stage = self.m_data:getSelectStage( )
end