-- @Author: zheng
-- @Date:   2018-08-15 11:07:39
-- @Last Modified by:   zheng
-- @Last Modified time: 2018-09-01 17:31:43
-- @File Name: SingleStageFightItemView.lua

local ArenaHeroView = require("Arena.ArenaHeroView")
local HeroManager = require("Hero.HeroManager")

local This , super = class(...,"NodeUI")

This.fileName = "MenuScene/NodeUI/SingleDailyStageFightList.csb"

function This:initData(info)
	self.m_inited = false
    self.m_stage = info.stage
	self.m_teamIndex = info.teamIndex
    self.m_cardNodes = {}
    for i = 1 , 6 do
        local view = ArenaHeroView:create(nil)
        local item = self.kaiqi["item"..i]
        item:addChild(view)
        -- view:setPositionY(15)
        self.m_cardNodes[i] = view
    end
    local w , h = self.kaiqi.bg:getContentSize()
    self:setContentSize(w,h)
    self:refresh()
end

function This:refresh( info )
	if info then
        self.m_stage = info.stage
        self.m_teamIndex = info.teamIndex
    end
    self:refreshCardInfo()
end

function This:refreshCardInfo()
    local stage = self.m_stage
    local teamCount = stage:getTeamCount()
    if teamCount>= self.m_teamIndex then
        self.kaiqi:setVisible(true)
        self.weikaiqi:setVisible(false)
        local cardList = stage:getTeam(self.m_teamIndex,true)
        local fightPower = 0
        for i = 1 , 6 do
            if #cardList >= i and cardList[i] > 0 then
                local hero = HeroManager:getHero(cardList[i])--getHeroByUid(cardList[i])
                local info = {id = hero:getUid(), level = hero:getLevel(), star = hero:getStarLv() * 5 + hero:getPhase(), heroId = hero:getId(),awake = hero:isAwakeFull()}
                self.m_cardNodes[i]:setModel(info)
                fightPower = fightPower + hero:getFightPower()
            else
                self.m_cardNodes[i]:setModel(nil)
            end
        end
        self.kaiqi.numberzhanli:setString(math.floor(fightPower))
    else
        self.kaiqi:setVisible(false)
        self.weikaiqi:setVisible(true)
    end
    
end

function This:initTouchEvent()
    self.kaiqi.button:setTouchEnded(function ()
        g_scene:openDialog("SingleDaily.SingleStageEmbattleHeroPanel",{stageId = self.m_stage:getId(),teamIndex =self.m_teamIndex})
    end)
end