-- @Author: zheng
-- @Date:   2018-08-14 17:04:47
-- @Last Modified by:   zheng
-- @Last Modified time: 2018-11-17 16:45:58
-- @File Name: SingleStageFightPanel.lua


local This , super = class(...,"Dialog")

local SingleManager = require("SingleDaily.SingleManager")
local SingleStageFightItemView = require("SingleDaily.SingleStageFightItemView")

function This:initNode(info)
	self.m_csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/SingleDailyStageFight.csb")
	self:addChild(self.m_csNode)
	self.m_csNode:setToCenter()
	self:refreshStage(  )
	SingleManager:onEmbattleHerosRequest(self.m_stage:getId())
	self:refresh( )
end

function This:onEnter()
	super.onEnter(self)
	SingleManager:addObserver(self)
end

function This:onExit()
	super.onExit(self)
	SingleManager:removeObserver(self)
end

function This:initTouchEvent()
	self.m_csNode.closebg:setTouchEnded(function ()
		self:close()
	end)
	self.m_csNode.button:setTouchEnded(function ()
		local stage = self.m_stage
		local allHeroList = stage:getEmBattle()
		local stageId = stage:getId()
		if #allHeroList==0 then
			g_scene:showTips(Serialize[64178])
			return
		end
		local teamCount = stage:getTeamCount()
		for i=1,teamCount do
			local heroList = stage:getTeam(i,true)

			if #heroList<6 then
			local panel = g_scene:openDialog("UI.ConfirmPanel",{text = Serialize[64179]})
				panel:setOkHandler(function()
					SingleManager:onChallengeStageRequest(stageId)
				end)
				return			
			end
		end
		SingleManager:onChallengeStageRequest(stageId)
	end)

end

function This:refresh( )
	local data = self.m_data
	local stage = self.m_stage
	local maxTeam = stage:getMaxTeam()
    local scrollView = self.m_csNode.scrollView
    local itemList = scrollView:getItemList()
    if itemList and #itemList>0 then
    	for i=1,maxTeam do
    		local item = itemList[i]
    		item:refresh({stage = stage,teamIndex= i})
    	end
        return
    end

    for i=1,maxTeam do
        local view = self:getScroolItem({stage = stage,teamIndex= i})
        local w , h = view:getContentSize()
        scrollView:pushBackCustomItem(view,w,h,0.5)
    end
end

function This:getScroolItem(itemData)
    local view = SingleStageFightItemView:create(itemData)
    return view
end

function This:refreshStage(  )
	self.m_data = SingleManager:getSelectChapter()
	self.m_stage = self.m_data:getSelectStage( )
end

function This:onStarRewardChanged(  )
	self:refresh()
end


function This:onHeroChange(  )
	self:refresh()
end
