-- @Author: zheng
-- @Date:   2018-12-20 10:23:34
-- @Last Modified by:   zheng
-- @Last Modified time: 2018-12-24 18:02:53
-- @File Name: TowerDayRewardPanel.lua


local This , super = class(...,"Dialog")
local TowerManager = require("SingleDaily.TowerManager")
This.fileName = "MenuScene/NodeUI/TowerReward.csb"
local ItemUtil = require("Bag.ItemUtil")

function This:initNode(info)
    -- if info then
    --    self.m_family = info.family
    -- end
    self.m_csNode = cc.Node:createFromCSFile(This.fileName)
    self.m_csNode:setToCenter()
    self:addChild(self.m_csNode)
    self:getData()
    self:refresh()
end

function This:refresh()
    self:refreshBaseInfo()
    self:refreshReward()
end

function This:initTouchEvent()
 --   item1:setTouchEnded(function()
    --  self:btnCallBack(btnType)
    -- end,item1.bg)
    
    self.m_csNode.closebutton:setTouchEnded(function()
        self:close()
    end)
    local function checkBtnVisible(btnIndex)
        if self.m_csNode.Tips:isVisible() then-- 防止没有奖励时误点
            return false
        end
        if not self.m_csNode["button"..btnIndex]:isVisible() then
            g_scene:showTips(Serialize["SingleDaily_DayReward_2"])
            return false
        end
        return true
    end
    self.m_csNode.button1:setTouchEnded(function()--直接领取
        -- local data = self.m_data
        -- local rewardData = data:getDayReward()
        if checkBtnVisible(2) then
            TowerManager:onGetDayRewardRequest(SingleTowerDayRewardState.kFreeReward)
        end
    end)
    self.m_csNode.button2:setTouchEnded(function()--元宝领取
        if checkBtnVisible(1) then
            local data = self.m_data
            local rewardData = data:getDayReward()

            g_scene:openDialog("UI.CostConfirmPanel", {
        -- fileName = "MenuScene/NodeUI/ActivityHappyRewardVoucher.csb",
        cost = rewardData:getCostMoney(),
        -- notips = "ChallengeStageManager"..self.cost,
        -- text1 = "是否花费",
        desc = Serialize["SingleDaily_DayReward_3"],--"SingleDaily_DayReward_3", 
        okHandler = function(build)
            TowerManager:onGetDayRewardRequest(SingleTowerDayRewardState.kMoneyReward)
        end } )
        end
    end)
end

function This:onEnter()
    super.onEnter(self)
    TowerManager:addObserver(self)
end

function This:onExit()
    super.onExit(self)
    TowerManager:removeObserver(self)
end

function This:refreshBaseInfo()
    local data = self.m_data
    local rewardData = data:getDayReward()
    local yesterdayLevel = data:getYesterdayLevel()

    local csNode= self.m_csNode
    local tipVisible = true
    if yesterdayLevel ==0 then
    -- elseif rewardData:isCanReward() and yesterdayLevel>0 then
    --     tipStr = Serialize["SingleDaily_DayReward_3"]
    else
        tipVisible = false
        csNode.ceng:setString(string.format(Serialize["SingleDaily_DayReward_1"],yesterdayLevel))
        csNode.money.costNum:setString(rewardData:getCostMoney())

        local button1 = csNode.button1
        local button2 = csNode.button2
        button1:setVisible(true)
        button2:setVisible(true)
        if not rewardData:isCanReward() then
            local receiverType =  rewardData:getIsReceiver()
            csNode["button"..receiverType]:setVisible(false)
        end
        csNode.yilingqu1:setVisible(not button1:isVisible())
        csNode.yilingqu2:setVisible(not button2:isVisible())
    end

    csNode.Tips:setVisible(tipVisible)
    self.m_isHaveReward = not tipVisible
end

function This:refreshReward()
    if not self.m_isHaveReward then
        
        return
    end
    local data = self.m_data
    local rewardData = data:getDayReward()
    local scrollView1 = self.m_csNode.scrollView1
    local scrollView2 = self.m_csNode.scrollView2

    local function createItemView(model)
        local ItemNode = require("UI.ItemNode")
        local node = ItemNode:create(model[1],model[2])
        node:setAnchorPoint(0.5,0.7)
        return node
    end
    local function refreshScroolView(scrollView,rewards)
        scrollView:setDirection("horizontal")
        scrollView.m_direction = "right"
        for i,itemConfig in ipairs(rewards) do
            local item = createItemView(itemConfig)
            local scale = 0.7
            item:setScale(scale)
            local w , h = item:getContentSize()
            scrollView:pushBackCustomItem(item,w*scale,h,0.5)
        end
    end
    refreshScroolView(scrollView1,rewardData:getReward())
    refreshScroolView(scrollView2,rewardData:getMoneyReward())
    

end

function This:onGetDayReward()
    self:refreshBaseInfo()
end

function This:getData()
    self.m_data = TowerManager:getTowerData()
end