-- @Author: zheng
-- @Date:   2018-12-22 14:44:44
-- @Last Modified by:   zheng
-- @Last Modified time: 2020-07-06 15:20:21
-- @File Name: TowerEmbattleHeroPanel.lua

local This , super = class(...,"Stage.EmbattleHeroPanel")

local GamePlayer = require("Player.GamePlayer")


function This:initNode(info)
    self.m_initHeros = info.initHeros or {}-- 初始化添加的武将{heroid1,heroid2}
    self.m_targetStr = info.targetStr or "" 
    self.m_okStr = info.okStr or Serialize["Warfare_WarfareInfo_53"]
    self.m_notCanChoseHero = info.allChoseHero or {}--不能选择的武将
    self.m_saveHeroCallBack = info.saveHeroCallBack--保存武将在回调
    -- self.m_teamIndex = info.teamIndex
    super.initNode(self,info)
    
end

function This:initBaseInfo()
    self.m_csNode.helpbutton:setVisible(false)
    self.m_csNode.bg3.tagettext:setString(Serialize[64171])
    self.m_csNode.bg3.taget:setString(self.m_targetStr)--目标
    self.m_csNode.bg3.name:setString(GamePlayer:getRoleName())
    
    local hp = self:getTotalHp()
    self.m_csNode.bg3.totalhp:setString(string.format("%d",hp))
    self.m_csNode.bg3.cost:setVisible(false)
    self.m_csNode.bg3.consume:setVisible(false)
    self.m_csNode.Battlebutton.text:setString(self.m_okStr)

end

--初始化时获取当前队列
function This:getHeroSource()
    return self.m_initHeros
end

function This:openSelectPanel()
    local haveSelected = {}
    local allHeroList = self.m_notCanChoseHero
    for i , info in pairs(allHeroList) do
        haveSelected[info] = true
    end
    for pos , info in pairs(self.m_heros) do
        haveSelected[info.heroId] = true
    end
    local panel = self:openDialog("Stage.StageSelectHeroPanel",{haveSelected = haveSelected})
    return panel
end

function This:onEmbattleOnceKey()
    local heros1 = self:getAllHeroList()

    local heros = {}
    local temNotCanChoseHero = {}
    for _,heroId in ipairs(self.m_notCanChoseHero) do
        temNotCanChoseHero[heroId]= heroId
    end
    for _,hero in pairs(heros1) do
        local id = hero:getId()
        if not temNotCanChoseHero[id] then
            table.insert(heros,hero)
        end
    end
    if table.count(heros)==0 then
        g_scene:showTips(Serialize[64173])
        return 
    end
    local maxCount = math.min(#heros,6)
    self.m_fetters = {}
    for i , info in pairs(self.m_heros) do
        info.heroId = nil
        if info.node then
            info.node:removeFromParent()
            info.node = nil
        end
    end
    self.m_heros = {}
    for i = 1 , maxCount do
        self:addHero(i,heros[i]:getId())
    end
    self:embattle(true)

end

function This:gotoBattle(heroList, isOnceKey)
    local tmp = {}
    for pos , info in pairs(self.m_heros) do
        tmp[pos] = info.heroId
    end
    

    if isOnceKey then
    else--保存
		if self.m_saveHeroCallBack then
			self.m_saveHeroCallBack(tmp)
		end
        self:close()
    end
end