-- @Author: zheng
-- @Date:   2018-12-20 17:50:31
-- @Last Modified by:   zheng
-- @Last Modified time: 2018-12-29 16:54:36
-- @File Name: TowerItemView.lua

local This , super = class(...,"NodeUI")
local TowerManager = require("SingleDaily.TowerManager")

local GameUtil = require("Util.GameUtil")

This.fileName = "MenuScene/NodeUI/TowerList.csb"

function This:initNode(info)
    if info then
       self.m_levelModel = info.levelModel
    end
    -- self.m_csNode = cc.Node:createFromCSFile(This.fileName)
    -- self.m_csNode:setToCenter()
    -- self:addChild(self.m_csNode)
    self:getData()
    self:refresh()
end

function This:refresh(info)
    if info then
        self.m_levelModel = info
    end
    local data = self.m_data
    local levelModel = self.m_levelModel

    -- local isSelect ,curentLv = self:isSelected()        local GameUtil = require("Util.GameUtil")

    local curentLv = data:getLevelNum()
    local myLevel = levelModel:getId()
    local isSelect = myLevel == curentLv

    self.icon:setImage(levelModel:getLevelHeadIcon())
    local isHaveReward = false
    local boxVisible = #levelModel:getPassReward()>0
    local boxNode = self.reward
    if boxVisible then
        local boxIsGray = curentLv>data:getMaxLevel()
        local boxIndex = 3
        if isSelect and levelModel:IsHaveBoxReward() then
            isHaveReward = true
        end
        if boxIsGray then
           isHaveReward = false
           boxNode:setImage("MenuScene/boxGet"..boxIndex..".png") 
        end
        GameUtil:createBoxEffect(isHaveReward,boxNode,boxIndex)
        self:btnGray(boxNode,boxIsGray)
    end
    boxNode:setVisible(boxVisible)
    self.m_isHaveGet = isHaveReward
    self.m_isHaveBox = boxVisible

    self.tongguan:setVisible(curentLv>myLevel or levelModel:IsHaveBoxReward() )
    -- self.xuanzhong:setVisible(isSelect)
    self.text:setString(string.format(Serialize["SingleDaily_TowerItem_2"],myLevel))--string.numberToWord(myLevel)
    self.suo:setVisible(myLevel>curentLv)
end

function This:getIsPassed()
    return self.tongguan:isVisible()
end

function This:initTouchEvent()
 --   item1:setTouchEnded(function()
    --  self:btnCallBack(btnType)
    -- end,item1.bg)
    
    self.reward:setTouchEnded(function()
        local data = self.m_data
        if data:myNotTeamLeader() then
            return false
        end
        local levelModel = self.m_levelModel
        local curentLv = data:getLevelNum()
        local myLevel = levelModel:getId()

        local rewards = levelModel:getPassReward()
        local function titleCallBack(  )
            TowerManager:onGetLevelRewardRequest()
        end
        local isReceiver = curentLv>myLevel
        local info ={rewards =rewards,isGray = not self.m_isHaveGet,title = Serialize["SingleDaily_TowerItem_1"],
        receive = isReceiver,btnCallBack =titleCallBack }        
        g_scene:openDialog("FamilyRating.FamilyRatingWeeklyRewardPanel",info)
    end)
end

function This:btnGray(btn,isGray)
    local gray = false
    if isGray then
        gray = true
    end
    if btn then
        if gray then
            btn:setGrayShader()
        else
            btn:clearShader()
        end
    end
end

function This:getData()
    self.m_data = TowerManager:getTowerData()
end