-- @Author: zheng
-- @Date:   2018-12-18 16:41:01
-- @Last Modified by:   zheng
-- @Last Modified time: 2018-12-28 10:49:15
-- @File Name: TowerMasterLogPanel.lua

local This , super = class(...,"Dialog")
-- local FamilyManager = require("Official.FamilyManager")
This.fileName = "MenuScene/NodeUI/TowerLog.csb"

local TowerManager = require("SingleDaily.TowerManager")
local GameUtil = require("Util.GameUtil")


function This:initNode(info)
    -- if info then
    --    self.m_family = info.family
    -- end
    self.m_csNode = cc.Node:createFromCSFile(This.fileName)
    self.m_csNode:setToCenter()
    self:addChild(self.m_csNode)
    self:getData()
    self:refresh()
end

function This:refresh()
    local masterStr = self:getMasterLog()
    local myLogStr = self:getMyLog()
    GameUtil:resetScoolSize3(self.m_csNode.scrollView1,279,275,masterStr)
    GameUtil:resetScoolSize3(self.m_csNode.scrollView2,279,275,myLogStr)
end

function This:getMasterLog()
    local data = self.m_data
    local masterList =data:getMasterlog()
    local result = ""
    for _,masterItem in ipairs(masterList) do
        local time = masterItem.time or os.time()
        local timeStr = GameUtil:formatDate(Serialize["m_d_H_M"].." ",time)
        local str = "<New13>"..timeStr.."<New9>"..masterItem.newmaster_name.."<New13>"..Serialize["SingleDaily_MasterLog_1"]..
            "<New9>"..masterItem.oldmaster_name.."<New13>"..Serialize["SingleDaily_MasterLog_2"]..
            "<New7>"..masterItem.level..Serialize["SingleDaily_MasterLog_3"]
            if masterItem.oldmaster_name =="" or not masterItem.oldmaster_name then
                str = "<New13>"..timeStr.."<New9>"..masterItem.newmaster_name.."<New13>"..Serialize["SingleDaily_MasterLog_9"]..
                "<New7>"..masterItem.level..Serialize["SingleDaily_MasterLog_3"]
            end
            result = result .. str.."\n"
    end
    return result
end

function This:getMyLog()
    local data = self.m_data
    local masterList =data:getRoleLog() 
    local result = ""
    for _,masterItem in ipairs(masterList) do
        local time = masterItem.time
        local timeStr = GameUtil:formatDate(Serialize["m_d_H_M"].." ",time)
        local state = masterItem.state
        local str = ""
        if state == 1 then
            str = "<New13>"..timeStr..Serialize["SingleDaily_MasterLog_4"].."<New9>"..masterItem.master_name..
            "<New13> "..Serialize["SingleDaily_MasterLog_7"]..
            "<New7>"..masterItem.level..Serialize["SingleDaily_MasterLog_3"]
        elseif state == 2 then
            str = "<New13>"..timeStr..Serialize["SingleDaily_MasterLog_4"].."<New9>"..masterItem.master_name..
            "<New13> "..Serialize["SingleDaily_MasterLog_6"]
        elseif state == 3 then
            str = "<New13>"..timeStr..Serialize["SingleDaily_MasterLog_5"].."<New9>"..masterItem.master_name..
            "<New13> "..Serialize["SingleDaily_MasterLog_8"]..
            "<New7>"..masterItem.level..Serialize["SingleDaily_MasterLog_3"]
        end
        result = result .. str.."\n"
    end
    return result
end

function This:initTouchEvent()
 --   item1:setTouchEnded(function()
	-- 	self:btnCallBack(btnType)
	-- end,item1.bg)
	
	self.m_csNode.close:setTouchEnded(function()
       self:close()
   end)
end

function This:getData()
    self.m_data = TowerManager:getTowerData()
end