-- @Author: zheng
-- @Date:   2019-11-22 10:18:12
-- @Last Modified by:   zheng
-- @Last Modified time: 2019-12-11 14:09:28
-- @File Name: WarTowerMainMapNode.lua

local WarTowerManager = require("SingleDaily.WarTowerManager")
local DrumTowerConfig = require("Metadatas.DrumTowerConfig")

local This , super = class(...,"NodeUI")
local fileNames = {
	"MenuScene/NodeUI/DrumTowerItem.csb",
	"MenuScene/NodeUI/DrumTowerItem2.csb",
}
-- This.fileName = "MenuScene/NodeUI/DrumTowerItem.csb"
-- self.num:setString(Serialize[64209]..index)
local strList ={
    lockLimit =Serialize[64210]
}
local chapterCount =5

function This:init(infor)
	self.m_UiItems ={}--ui节点
	self.m_chapters ={}
	self.m_scrollView = infor.scrollview
	self.m_selectFun = infor.selectFun
end

function This:onChapterClick( index )
	if self.m_selectFun then
		self.m_selectFun(index)
	end
end

-- function This:onEnter()
--     super.onEnter(self)
--     WarTowerManager:addObserver(self)
-- end

-- function This:onExit()
--     super.onExit(self)
--     WarTowerManager:removeObserver(self)
-- end

function This:initBg()

	local maxCount = 1
	maxCount = math.ceil(#DrumTowerConfig/chapterCount)--不小于x的最大整数
	local chapterId = WarTowerManager:getLastLv() or 1
	local anx =0
	self:setAnchorPoint(anx, anx)
	local x,y = 0
	for i=1,maxCount do
		local item = self.m_UiItems[i]
		if not item then
			item= self:createItem(i%2)
			item:setAnchorPoint(0.5, 0)
			self:addChild(item)
			-- item.num:setString(Serialize[64209]..i)
			for index=1,chapterCount do
				local chapterIndex =#self.m_chapters +1
				local chapterView = item["FileNode_"..index]
				self.m_chapters[chapterIndex]= chapterView
				chapterView.item1:setTouch({onEnded = function ()
					self:onChapterClick( chapterIndex )
				end,
				sizeNode = chapterView.item1.towericon,
				isDynamic = true})

				chapterView.paretView = item
			end
			self.m_UiItems[i] =item
		end
		if i==1 then
			x,y= 382,494
		end
	end
	local maxHeight = 0
	local swithPosX= 0
	local swithPosY =0
	for i=1,maxCount do
		local item = self.m_UiItems[i]
		swithPosY= y*(i-0.5)
		swithPosX = x/2
		maxHeight = y*i
		item:setPositionY(swithPosY)
	end
	self:setContentSize(x,maxHeight)
end

function This:refreshScroolViewPos()
	if self.m_scrollView then
		local scrollview = self.m_scrollView
		if not self.m_maxLimit then
			local maxCount = #DrumTowerConfig
			self.m_maxLimit = maxCount+1- chapterCount
		end
		local chapterId = WarTowerManager:getLastLv() or 1
		if chapterId>self.m_maxLimit then
			chapterId = self.m_maxLimit
		end
		local temChapter = chapterId
		if chapterId>0 then
			temChapter = chapterId-1
		end
		local temY = -494/chapterCount*temChapter
		scrollview:setInnerContainerPosition(0, temY)
	end
end

function This:createItem(index)
	if index ==0 then
		index =2
	end
	local node = cc.Node:createFromCSFile(fileNames[index])
	-- node:fitScreenY()
	return node
end


function This:refresh()
	self:initBg()
	self:refreshScroolViewPos()
	self:refreshChapterItem()
end

function This:chapterAction( chapterView,haveAction)
end

function This:refreshChapterItem()
	local curentLv = WarTowerManager:getCurentLv()
	for index,chapterView in ipairs(self.m_chapters) do
		local item1 = chapterView.item1
		item1.text:setString(string.format(Serialize["SingleDaily_TowerMain_1_c"],index))
		item1.suo:setVisible(index>(curentLv+1))
		item1.tongguan:setVisible(index<=curentLv)
		item1.icon:setImage(self:getLevelHeadIcon(index))
	end
end

function This:getLevelHeadIcon(lv)
    local iconId = DrumTowerConfig[lv].icon
    local result = "Icons/Item/"..iconId..".png"
    return result
end
