-- @Author: zheng
-- @Date:   2019-11-22 10:05:43
-- @Last Modified by:   zheng
-- @Last Modified time: 2020-03-30 15:04:40
-- @File Name: WarTowerMainPanel.lua
local WarTowerManager = require("SingleDaily.WarTowerManager")
local GamePlayer = require("Player.GamePlayer")
local WarTowerMainMapNode = require("SingleDaily.WarTowerMainMapNode")
local GameUtil = require("Util.GameUtil")
local This , super = class(...,"Dialog")

-- local FamilyManager = require("Official.FamilyManager")
This.fileName = "MenuScene/NodeUI/DrumTower.csb"
local uiStr ={
    normalStr = Serialize[60736],
    normalStr3 = Serialize[64212],
}
function This:initNode(info)
    -- if info then
    --    self.m_family = info.family
    -- end
    -- self.m_select = WarTowerManager:getCurentLv()
    self.m_csNode = cc.Node:createFromCSFile(This.fileName)
    self.m_csNode:setToCenter()
    self:addChild(self.m_csNode)
    --self:getData()
    WarTowerManager:onGetInfoRequest()
    local scrollview =  self.m_csNode.ScrollView
    local info1 = {scrollview = scrollview,selectFun = function (selectIndex)
        self:refreshSelect(selectIndex)
    end}
    local view = WarTowerMainMapNode:create(info1)
    view:initBg()
    self.m_view = view
    scrollview:setSwallowTouch(false)
    local w , h = view:getContentSize()
    scrollview:pushBackCustomItem(view,w,h,0)
    -- self:refresh()
end

function This:refreshSelect(selectIndex)
    print("jkjkk"..selectIndex)
    self.m_select = selectIndex
    self:refreshReward()
    self:refreshMinPower()
end

function This:refresPaihang()
    local csNode = self.m_csNode
    local function refreshPaiHang(itemNode,data)
        local nodeList = {itemNode["name"],itemNode["ceng"],}
        if nodeList[1] and data then
            for itemIndex,nodeUi in ipairs(nodeList) do
                nodeUi:setString(data[itemIndex] or "")
            end
        elseif nodeList[1] then
            nodeList[1]:setString(uiStr.normalStr)
            nodeList[2]:setString("")
        end
    end 
    local paihang = csNode.paihang
    for index=1,3 do
        local rankData = WarTowerManager:getRankList(index)
        local itemNode = paihang["paihang"..index]
        local info = rankData
        if rankData then
            info = {rankData.name,rankData.value}
        end
        refreshPaiHang(itemNode,info)
    end
    local maxLv = WarTowerManager:getMaxLv()
    local maxHistory = WarTowerManager:getMaxHistoryLv()
    csNode.Text_jindu:setString(string.format(Serialize[64213],maxLv))
    csNode.lishi_jindu:setString(string.format(Serialize[64214],maxHistory))
end

function This:refreshMinPower()
    local csNode = self.m_csNode
    local function refreshTeamItem(itemNode,data)
        -- local itemNode = csNode.team.zuidi
        local icon = itemNode["icon"]
        local name = itemNode["name"]
        local zhanli = itemNode["zhanli"]
        local nameStr = uiStr.normalStr
        local power 
        if data then
            nameStr = data.name
            power = data.power
            GameUtil:setPlayerIconNodeImage(icon, data.icon)
        end
        local zhanLiSttr = string.format("%s%d",uiStr.normalStr3,power or 0)
        name:setString(nameStr)
        zhanli:setString(zhanLiSttr)
        icon:setVisible(data)
    end
    local curentSelect = self.m_select
    local zuidi = csNode.team.zuidi
    refreshTeamItem(zuidi.item1,WarTowerManager:getOtherMinPower(curentSelect))
    refreshTeamItem(zuidi.item2,WarTowerManager:getMyMinPower(curentSelect))
end

function This:refreshReward()
    local csNode = self.m_csNode
    local saodang = csNode.team.saodang

    local curentSelect = self.m_select
    local jiangLi = csNode.team.jiangli
    local maxLv = WarTowerManager:getMaxLv()
    local curLv = WarTowerManager:getCurentLv()
    local isPassed = curentSelect>maxLv
    csNode.team.cengshu:setString(string.format(Serialize["SingleDaily_TowerMain_1_c"],curentSelect))
    csNode.team.tiaozhan:setVisible(curentSelect==(curLv+1))
    saodang:setVisible(not (curentSelect>curLv))
    saodang.num:setString(WarTowerManager:getSaoDangNum())

    local firstReward ,secondReward = WarTowerManager:getPassReward(curentSelect)
    local rewardList = secondReward
    if isPassed then
        rewardList = firstReward
    end
    for index=1,5 do
        local item1 = rewardList[index]
        local itemNode = jiangLi["item"..index]
        if not itemNode then
            break
        end
        if item1 then
            GameUtil:creatItemNode(itemNode,item1)
        end
        local diIcon = jiangLi["shoutongdi"..index]
        local diTxt = jiangLi["shoutongtext"..index]
        if diIcon then
            diIcon:setVisible(isPassed and item1)
            diTxt:setVisible(isPassed and item1)
        end
        itemNode:setVisible(item1)
    end
    if isPassed then
        
    end
    local isHaveReward = WarTowerManager:isCanGetSaoDang()
    GameUtil:refreshRedDot(csNode.freegift.box,isHaveReward)
    GameUtil:refreshRedDot(csNode.chongta.box,WarTowerManager:isHaveVipReward(),{75,70},1)
    GameUtil:refreshRedDot(csNode.chengjiu.box,WarTowerManager:isHaveSaoDangReward(),{110,100},1.5)
    if not isHaveReward then
        csNode.freegift.Text_yueka:setStringWithColor("<New11>"..Serialize[14101])
    end
    -- g_scene:showReward(rewardList or {})
end

function This:refresh()
    if self.m_view then
        self.m_view:refresh()
    end
    self:refreshReward()
    self:refresPaihang()
end

function This:initTouchEvent()
    local csNode = self.m_csNode
    local saodang = csNode.team.saodang
    csNode.closebutton:setTouchEnded(function()
        self:close()
    end)
    csNode.freegift:setTouchEnded(function()
        if WarTowerManager:isCanGetSaoDang() then
            WarTowerManager:onGetSaoDangRewardRequest()
        end
    end)
    csNode.chongta:setTouchEnded(function()--冲塔帮手
        g_scene:openDialog("SingleDaily.WarTowerVipBuyPanel")
    end)
    saodang.add:setTouchEnded(function()--add
        local cost = WarTowerManager:getBuySaoDangCost(1)
        g_scene:openDialog("UI.CostConfirmPanel", {
                cost = cost,
                desc = string.format(Serialize[64215],1) ,
                okHandler = function()
                if GamePlayer:checkDiamond(cost) then
                   WarTowerManager:onGetBuySaoDangTimeRequest(1) 
                end
        end })
    end)
    saodang.saodang1:setTouchEnded(function()
        WarTowerManager:checkSaoDangBuy(1,self.m_select)
    end)
    saodang.saodang5:setTouchEnded(function()
        WarTowerManager:checkSaoDangBuy(5,self.m_select)
    end)
    csNode.chengjiu:setTouchEnded(function()--成就宝箱
        g_scene:openDialog("SingleDaily.WarRewardPanel")
    end)
    csNode.team.tiaozhan:setTouchEnded(function()--挑  战
        local _,maxChallenge = WarTowerManager:getTeamNum()
        local curentChallenge = WarTowerManager:getChallengeNum()
        if curentChallenge>=maxChallenge then
            g_scene:showTips(Serialize[64216])
            return false
        end
        g_scene:openDialog("SingleDaily.WarTowerTeamPanel",{lv =self.m_select})
    end)
    csNode.team.zuidi.item1.info2:setTouchEnded(function()--最低战力通关
        local minInfo = WarTowerManager:getOtherMinPower(self.m_select)
        if not minInfo then
            g_scene:showTips(Serialize[64217])
            return false
        end
        g_scene:openDialog("SingleDaily.WarTwoerMinPowerPanel",{minInfo = minInfo,lv = self.m_select})
    end)
    csNode.paihang.info:setTouchEnded(function()--查看排行
        g_scene:openDialog("SingleDaily.WarTowerRankPanel")
    end)
    local wenhao = csNode.wenhao
    if wenhao then
        wenhao:setTouchEnded(function()
            local text = Serialize["SingleDaily_WarTowerMain_1"]
            g_scene:openDialog("UI.HelpTips", {text = text,node = wenhao})
        end)
    end
end

function This:onEnter()
    super.onEnter(self)
    WarTowerManager:addObserver(self)
end

function This:onExit()
    super.onExit(self)
    WarTowerManager:removeObserver(self)
end

function This:onGetInfo()
    if not self.m_select then
        self.m_select = WarTowerManager:getCurentLv()+1
    end
    self:refresh()
end

function This:onGetSaodangFight(reward)
    self:refreshReward()
    local info1 = {lv = self.m_select,reward = reward,closeFun = function ()
        self.m_saoDangPanel = nil    
    end}
    g_scene:openDialog("SingleDaily.WarTowerSaoDangRewardPanel",info1)
    -- if self.m_saoDangPanel then
    --     self.m_saoDangPanel:close()
    -- end
    -- if not self.m_saoDangPanel then
        -- self.m_saoDangPanel = g_scene:openDialog("SingleDaily.WarTowerSaoDangRewardPanel",info1)
    -- else
    --     self.m_saoDangPanel:refresh(reward)
    -- end
end
-- This.onGetInfo = This.refresh
This.onGetTowerRank = This.refresPaihang
This.onGetMinPassPower = This.refreshMinPower
This.onGetBuySaoDangTime = This.refreshReward
This.onGetSaoDangReward = This.refreshReward
This.onGetBoxReward = This.refreshReward
This.onGetVipReward = This.refreshReward
This.onGetOneKeyFight = This.refresh