-- @Author: zheng
-- @Date:   2019-11-27 14:25:23
-- @Last Modified by:   zheng
-- @Last Modified time: 2019-12-14 12:11:34
-- @File Name: WarTowerRankPanel.lua
local TowerPassRewardConfig = require("Metadatas.TowerPassRewardConfig")
local WarTowerRankItemView = require("SingleDaily.WarTowerRankItemView")
local WarTowerManager = require("SingleDaily.WarTowerManager")
local GamePlayer = require("Player.GamePlayer")

local This , super = class(...,"Dialog")
-- local FamilyManager = require("Official.FamilyManager")
This.fileName = "MenuScene/NodeUI/DrumFastRanking.csb"
function This:initNode(info)
    self.m_csNode = cc.Node:createFromCSFile(This.fileName)
    self.m_csNode:setToCenter()
    self:addChild(self.m_csNode)
    --self:getData()
    self:refresh()
end

function This:refresh()
    -- local data = self.m_data
    -- local csNode = self.m_csNode
    self:refreshScroolView()
end

function This:refreshScroolView()
    local csNode = self.m_csNode
    local scrollView = csNode.ScrollView
    scrollView:removeAllItems()
    local myId = GamePlayer:getPlayerID()

    local myRank = nil
    for index, achieve in ipairs(TowerPassRewardConfig) do
        local rankData = WarTowerManager:getRankList(index)
        local info = {config = achieve,index = index,rankData = rankData}
        local view = self:getAchieveView(info)
        local w , h = view:getContentSize()
        scrollView:pushBackCustomItem(view,w,h,0.5)
        if rankData and rankData.roleid == myId then
            myRank = index
        end
    end
    if myRank then
        csNode.me:setString(myRank)
    end
    csNode.ceng:setString(Serialize[64225]..WarTowerManager:getSaoDangDayNum())
end

function This:getAchieveView(achieve)
    local view = WarTowerRankItemView:create(achieve)
    return view
end

function This:initTouchEvent()
    local csNode = self.m_csNode
 --    item1:setTouchEnded(function()
    --  self:btnCallBack(btnType)
    -- end,item1.bg)
    
 --    self.zhengduo:setTouch({
 --            isScale = false,
 --            isDynamic = true,
 --            isContainer = true,
 --            onEnded = function()
 --                 self:close()
 --            end
 --        })
    -- csNode.close:setTouchEnded(function()
 --        self:close()
 --    end)
    csNode.beijing.close:setTouchEnded(function()
        self:close()
    end)
end