-- @Author: zheng
-- @Date:   2019-12-02 16:58:33
-- @Last Modified by:   zheng
-- @Last Modified time: 2019-12-07 15:21:32
-- @File Name: WarTwoerMinPowerPanel.lua
local ArenaHeroView = require("Arena.ArenaHeroView")
local HeroManager = require("Hero.HeroManager")
local WarTowerManager = require("SingleDaily.WarTowerManager")
local This , super = class(...,"Dialog")
-- local FamilyManager = require("Official.FamilyManager")
This.fileName = "MenuScene/NodeUI/DrumTowerMinPower.csb"
function This:initNode(info)
    -- if info then
    --    self.m_family = info.family
    -- end
    self.m_lv = info.lv or 1
    self.m_csNode = cc.Node:createFromCSFile(This.fileName)
    self.m_csNode:setToCenter()
    self:addChild(self.m_csNode)
    self.m_data = info.minInfo
    if self.m_data then
        self.m_cardNodes={}
        self.m_heroNodeList = self.m_data.card_list
        if self.m_heroNodeList then
            local heroXList ={}
            self.m_maxHeroNum = 6
            for uiIndex = 1 , self.m_maxHeroNum do
                local heros = self.m_csNode
                local view = ArenaHeroView:create(nil)
                local item1 = heros["team"..uiIndex]
                item1:addChild(view)
                self.m_cardNodes[uiIndex] = view
                view:setVisible(false)
                heroXList[uiIndex] = item1:getPositionX()
            end
            self.m_heroOffsetX = (heroXList[2]-heroXList[1])/2
            self:refreshHeroList()
        end
    end

    self:refresh()
end

function This:refreshHeroList()
    local heroList = self.m_heroNodeList
    if not heroList then
        return
    end
    -- local heros = self.m_csNode.heros
    local uiNodes = self.m_cardNodes
    for heroIndex,info in ipairs(heroList) do
        local heroId = info.cardid
        local heroUi = uiNodes[heroIndex]
        -- local hero = HeroManager:getHero(heroId)--getHeroByUid(cardList[i])
        local info = {star = info.star * 5, id = heroId,heroId = heroId}
        if heroUi then
            heroUi:setVisible(true)
            heroUi:setModel(info)
        end
    end
    local heroNum = self.m_maxHeroNum
    local heroOffsetNum = heroNum - #heroList
end

function This:refresh()
    -- local data = self.m_data
    -- local csNode = self.m_csNode
end

function This:initTouchEvent()
    local csNode = self.m_csNode
    csNode.closebg:setTouchEnded(function()
        self:close()
    end)
    csNode.confirmButton:setTouchEnded(function()
        if not (WarTowerManager:getCurentLv()>= self.m_lv) then
            g_scene:showTips(Serialize[64235])
            return false
        end
        local info = {
            initHeros = {},
            stageId = 1,
            targetStr = string.format(Serialize["SingleDaily_MinPower_1_c"],self.m_lv),
            allChoseHero = {},
            okStr = Serialize[64156],
            saveHeroCallBack = function (saveHeroList)
                WarTowerManager:onGetOneFigthRequest(2,self.m_lv,saveHeroList)
            end
        }
        g_scene:openDialog("SingleDaily.TowerEmbattleHeroPanel", info)
    end)
end
