--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This = class(...,"Base.BaseModel")
local BattleDataManager = require("Battle.BattleDataManager")
local SkillCommon = require("Skill.SkillCommon")
local BattlePlayer = require("Battle.BattlePlayer")
local BattleUtil = require("Battle.BattleUtil")
local Behavior = require("Skill.Behavior")
local EffectTimeConfig = require("Metadatas.EffectTimeConfig")
local FightBackBehavior = require("Skill.FightBackBehavior")

local EffectFunc = 
{
	[EffectType.kCrit] = function(troops,effect)
		print(string.format("部队%d暴击...",troops:getId()))
		for i , behavior in ipairs(effect.behavior) do
			if troops:isEnemy() == behavior.isEnemy and troops:getHeroId() == behavior.heroId then
				if behavior.effectType == EffectType.kDodge or behavior.effectType == EffectType.kPenetrate then
					return
				end
			end
		end
		local view = troops:getView()
		if view then
			view:showCrit()
		end
		troops:reduceAttr(AttrType.kHp,effect.effectValue,effect.effectFinalValue,EffectType.kCrit,effect)
	end,

	[EffectType.kCommonAttack] = function(troops,effect) 
		if effect.hitCount and effect.hitIndex then
			assert(effect.hitCount > 0)
			local damagePerHit = math.floor( math.min(effect.effectValue,troops:getAttr(AttrType.kHp)) / effect.hitCount)
			if effect.hitIndex < effect.hitCount then
				troops:reduceAttr(AttrType.kHp,damagePerHit,effect.effectFinalValue + damagePerHit * (effect.hitCount-effect.hitIndex),nil,effect)
			else
				troops:reduceAttr(AttrType.kHp,effect.effectValue - (damagePerHit * (effect.hitIndex - 1)),effect.effectFinalValue,nil,effect)
			end
		else
			troops:reduceAttr(AttrType.kHp,effect.effectValue,effect.effectFinalValue,nil,effect)
		end
	end,
	
	[EffectType.kPhyAttack] = function(troops,effect) 
		if effect.hitCount and effect.hitIndex then
			assert(effect.hitCount > 0)
			local damagePerHit = math.floor( math.min(effect.effectValue,troops:getAttr(AttrType.kHp)) / effect.hitCount)
			if effect.hitIndex < effect.hitCount then
				troops:reduceAttr(AttrType.kHp,damagePerHit,effect.effectFinalValue + damagePerHit * (effect.hitCount-effect.hitIndex),nil,effect)
			else
				troops:reduceAttr(AttrType.kHp,effect.effectValue - (damagePerHit * (effect.hitIndex - 1)),effect.effectFinalValue,nil,effect)
			end
		else
			troops:reduceAttr(AttrType.kHp,effect.effectValue,effect.effectFinalValue,nil,effect)
		end
	end,

	[EffectType.kMagAttack] = function(troops,effect) 
		if effect.hitCount and effect.hitIndex then
			assert(effect.hitCount > 0)
			local damagePerHit = math.floor( math.min(effect.effectValue,troops:getAttr(AttrType.kHp)) / effect.hitCount)
			if effect.hitIndex < effect.hitCount then
				troops:reduceAttr(AttrType.kHp,damagePerHit,effect.effectFinalValue + damagePerHit * (effect.hitCount-effect.hitIndex),nil,effect)
			else
				troops:reduceAttr(AttrType.kHp,effect.effectValue - (damagePerHit * (effect.hitIndex - 1)),effect.effectFinalValue,nil,effect)
			end
		else
			troops:reduceAttr(AttrType.kHp,effect.effectValue,effect.effectFinalValue,nil,effect)
		end
	end,

	[EffectType.kPhyTreat] = function(troops,effect)
		troops:addAttr(AttrType.kHp,effect.effectValue,effect.effectFinalValue,effect)
	end, 
	
	[EffectType.kMagTreat] = function(troops,effect)
		troops:addAttr(AttrType.kHp,effect.effectValue,effect.effectFinalValue,effect)
	end,

	[EffectType.kRemoveDebuff] = function(troops,effect)
		print("净化...")
	end,

	[EffectType.kRemoveBuff] = function(troops,effect)
		print("驱散...")
	end,

	[EffectType.kRecoverAnger] = function(troops,effect) 
		troops:addAttr(AttrType.kAngerValue,effect.effectValue,effect.effectFinalValue,effect)
	end,
	
	[EffectType.kReduceAnger] = function(troops,effect) 
		troops:reduceAttr(AttrType.kAngerValue,effect.effectValue,effect.effectFinalValue,nil,effect)
	end,

	[EffectType.kSelfMaxHpDamage] = function(troops,effect)
		if troops:getAttr(AttrType.kHp) < effect.effectFinalValue then
			troops:addAttr(AttrType.kHp,effect.effectValue,effect.effectFinalValue,effect)
		else
			troops:reduceAttr(AttrType.kHp,effect.effectValue,effect.effectFinalValue,nil,effect)
		end
	end,

	[EffectType.kAddBuff] = function(troops,effect)
		troops:generateBuff(effect)
	end,

	[EffectType.kEffectAttackAddAnger] = function(troops,effect)  
		troops:addAttr(AttrType.kAngerValue,effect.effectValue,effect.effectFinalValue,effect)
	end,

	[EffectType.kEffectSkillDelAnger] = function(troops, effect)
		troops:reduceAttr(AttrType.kAngerValue,effect.effectValue,effect.effectFinalValue,nil,effect)
	end,

	[EffectType.kReboundDamage] = function(troops, effect)
		print("反弹...")
	end,

	[EffectType.kFightBack] = function(troops,effect)
		troops:reduceAttr(AttrType.kHp,effect.effectValue,effect.effectFinalValue,nil,effect)
	end,

	[EffectType.kPenetrate] = function(troops,effect)
		print("识破...")
	end,

	[EffectType.kPhyDamage] = function(troops,effect) 
		troops:reduceAttr(AttrType.kHp,effect.effectValue,effect.effectFinalValue,nil,effect)
	end,

	[EffectType.kMagDamage] = function(troops,effect) 
		troops:reduceAttr(AttrType.kHp,effect.effectValue,effect.effectFinalValue,nil,effect)
	end,

	[EffectType.kJiNengXiXue] = function(troops,effect)
		troops:addAttr(AttrType.kHp,effect.effectValue,effect.effectFinalValue,effect)
	end,
	[EffectType.kPuGongXiXue] = function(troops,effect)
		troops:addAttr(AttrType.kHp,effect.effectValue,effect.effectFinalValue,effect)
	end,
	[EffectType.kLianJi] = function(troops , effect)
		troops:reduceAttr(AttrType.kHp,effect.effectValue,effect.effectFinalValue,nil,effect)
	end,
	[EffectType.kFuHuo] = function(troops , effect)
		troops:addAttr(AttrType.kHp,effect.effectValue,effect.effectFinalValue,effect)
	end,
	[EffectType.kFengLiao] = function(troops,effect)
		troops:addAttr(AttrType.kHp,effect.effectValue,effect.effectFinalValue,effect)
	end,
	[EffectType.kMonsterDamage] = function(troops,effect)
		-- troops:addAttr(AttrType.kHp,effect.effectValue,effect.effectFinalValue,effect)
		if effect.hitCount and effect.hitIndex then
			assert(effect.hitCount > 0)
			local damagePerHit = math.floor( math.min(effect.effectValue,troops:getAttr(AttrType.kHp)) / effect.hitCount)
			if effect.hitIndex < effect.hitCount then
				troops:reduceAttr(AttrType.kHp,damagePerHit,effect.effectFinalValue + damagePerHit * (effect.hitCount-effect.hitIndex),nil,effect)
			else
				troops:reduceAttr(AttrType.kHp,effect.effectValue - (damagePerHit * (effect.hitIndex - 1)),effect.effectFinalValue,nil,effect)
			end
		else
			troops:reduceAttr(AttrType.kHp,effect.effectValue,effect.effectFinalValue,nil,effect)
		end
		
	end,
	[EffectType.kMonsterLiao] = function(troops,effect)
		troops:addAttr(AttrType.kHp,effect.effectValue,effect.effectFinalValue,effect)
	end

}

function This:init()
end

function This:getBehavior(behavior)
	local effectType = EffectTimeConfig[behavior.effectId].effect_type
	if effectType == EffectType.kFightBack then
		return FightBackBehavior:create(behavior)
	else
		return Behavior:create(behavior)
	end
end

local effectKey = 1

function This:work(effect,attacker,finishHandler)
	local troops = BattlePlayer:getTroopsByHeroId(effect.isEnemy,effect.heroId)

	local index = 0
	local function applyBehavior()
		index = index + 1
		if index <= #effect.behavior then
			local behavior = effect.behavior[index]
			local b = self:getBehavior(behavior)
			b:work(behavior,applyBehavior)
		end
	end

	local function hitEndHandler()
		applyBehavior()
	end

	local function hitHandler(hitCount,hitIndex)
		if effect.effectResult == 0 then
			effect.effectType = EffectTimeConfig[effect.effectId].effect_type
			effect.hitIndex = hitIndex
			effect.hitCount = hitCount
			print("effect.effectType-====="..effect.effectType)
			local func = EffectFunc[effect.effectType]
			if func then
				func(troops,effect)
			else
				print("找不到效果函数",effect.effectType)
			end
		else
			troops:lostEffect(effect)
		end
	end

	local function skipHandler()
		if effect.effectResult == 0 then
			effect.effectType = EffectTimeConfig[effect.effectId].effect_type
			local func = EffectFunc[effect.effectType]
			if func then
				func(troops,effect)
			end
			hitEndHandler()
		else
			troops:lostEffect(effect)
		end
	end

	local function nextHandler(isSkip)
		local view = troops:getView()
		if isSkip or not view then
			if finishHandler then
				finishHandler()
			end
		elseif finishHandler then
			local soilderId = attacker:getSoilderId()
			local time = EffectTimeConfig[effect.effectId].arm_time[soilderId] or kWallSoilderComAttackTime * 1000
			g_scene.m_timer:setTimer(time/1000,finishHandler,"action_effect"..effectKey)
			effectKey = effectKey + 1
		end
	end
	if effect.effectId == 30026 then
		assert(true)
	end
	local effectFile = EffectTimeConfig[effect.effectId].effect_name
	local view = troops:getView()
	if view and effectFile and effectFile ~= "" then
		view:addSkillEffect(troops,effect.effectId,hitHandler,hitEndHandler)
		nextHandler()
	else
		skipHandler()
		nextHandler()
	end
end



--endregion
