--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This = class(...)
local BuffConfig = require("Metadatas.BuffConfig")
local SkillSpecial = require("Skill.SkillSpecial")
local AwakeConfig = require("Metadatas.AwakeConfig")
local HeroConfig = require("Metadatas.HeroConfig")
local ActionEffect = require("Skill.ActionEffect")
local BattlePlayer = require("Battle.BattlePlayer")
local EffectTimeConfig = require("Metadatas.EffectTimeConfig")

function This:create(id)
	local buff = {}
	setmetatable(buff,self)
	buff:init(id)
	return buff
end

function This:init(id)
	self.m_id = id
	self.m_config = BuffConfig[id]
	if self.m_config == nil then
		assert(false)
	end
	self.m_troops = nil
end

function This:isSkill()
	return false
end

function This:isBuff()
	return true
end

function This:getId()
	return self.m_id
end

function This:getConfig()
	return self.m_config
end

function This:isContinuous()
	return self.m_config.last_round_num > 0
end

function This:hasActiveEffect()
	local effectId = self.m_config.effect_id
	return EffectTimeConfig[effectId].effect ~= ""
end


function This:setTroops(troops)
	self.m_troops = troops
end

function This:getTroops()
	return self.m_troops
end

function This:appear(effect)
	local isContinuous = self.m_config.timetype > 0
	if effect.effectResult == 0 then
		local view = self.m_troops:getView()
		if view and self.m_config.effect_name ~= "" then
			view:addBuffEffect(self,self.m_config.effect_name,isContinuous)
		end
	else
		self.m_troops:lostEffect(effect)
	end
end

function This:disappear()
	local view = self.m_troops:getView()
	if view and self.m_config.effect_name ~= "" then
		view:removeBuffEffect(self)
	end
end

local IsWakenBuff =
{
	[EffectType.kPhyAttack] = true,
	[EffectType.kMagAttack] = true,
	[EffectType.kPhyTreat] = true,
	[EffectType.kMagTreat] = true,
	[EffectType.kRecoverAnger] = true,
	[EffectType.kReduceAnger] = true,
	[EffectType.kSelfMaxHpDamage] = true,
	[EffectType.kAddBuff] = true,
}

function This:work(troops,effectList)
	local targetList = {}
	local hitList = {}
	if self.m_id == 60046 then
		assert(true)
	end
	for i , effect in ipairs(effectList) do
		if effect.effectResult == 0 then
			for i , hitInfo in ipairs(effect.target) do
				local target = BattlePlayer:getTroopsByHeroId(hitInfo.isEnemy,hitInfo.heroId)
				if target and target:getState() ~= TroopsState.kDead then
					table.insert(targetList,target)
					table.insert(hitList,hitInfo)
				end
			end
		else
			self.m_troops:lostEffect(effect)
		end
	end

	for i , hitInfo in ipairs(hitList) do
		local function endHandler()
			if i == #hitList then
				BattlePlayer:onBuffActiveEnded(self)
			end
		end
		local target = targetList[i]
		target:applyEffect(hitInfo,troops,endHandler)
	end
end

--endregion
