--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This = class(...,"Base.BaseModel")
local ActionEffect = require("Skill.ActionEffect")
local BattleDataManager = require("Battle.BattleDataManager")
local SkillCommon = require("Skill.SkillCommon")
local BattlePlayer = require("Battle.BattlePlayer")
local BattleUtil = require("Battle.BattleUtil")
local EffectTimeConfig = require("Metadatas.EffectTimeConfig")

BehaviorFunc = 
{
	[EffectType.kDodge] = function(troops)
		print(string.format("部队%d闪避...",troops:getId()))
		local view = troops:getView()
		if view then
			view:showDodge()
		end
	end,

	[EffectType.kPenetrate] = function(troops) 
		print(string.format("部队%d识破...",troops:getId()))
		local view = troops:getView()
		if view then
			view:showPenetrate()
		end
	end,

	[EffectType.kEffectAttackAddAnger] = function(troops,effect)  
		troops:addAttr(AttrType.kAngerValue,effect.effectValue,nil,effect)
	end,

	[EffectType.kEffectSkillDelAnger] = function(troops, effect)
		troops:reduceAttr(AttrType.kAngerValue,effect.effectValue,nil,nil,effect)
	end,

	[EffectType.kSpiritChain] = function(troops,effect)
		troops:reduceAttr(AttrType.kHp,effect.effectValue,effect.hp,nil,effect)
		local view = troops:getView()
		if view then
			view:showFenTan()
		end
	end,
	[EffectType.kReboundDamage] = function(troops, effect)
		troops:reduceAttr(AttrType.kHp,effect.effectValue,effect.hp,nil,effect)
		local view = troops:getView()
		if view then
			view:showFantan()
		end
	end,
	[EffectType.kTieSuoLianHuan] = function(troops , effect)
		troops:reduceAttr(AttrType.kHp,effect.effectValue,effect.hp,nil,effect)
		local view = troops:getView()
		if view then
			view:showLianHuan()
		end
	end,
	[EffectType.kPuGongXiXue] = function(troops,effect)
		troops:addAttr(AttrType.kHp,effect.effectValue,effect.hp,nil,effect)
	end,
}

function This:init()
end

function This:work(behavior,finishHandler)
	local troops = BattlePlayer:getTroopsByHeroId(behavior.isEnemy,behavior.heroId)
	if not troops or troops:getState() == TroopsState.kDead then
		finishHandler()
		return
	end
	behavior.effectType = EffectTimeConfig[behavior.effectId].effect_type
	
	local func = BehaviorFunc[behavior.effectType]
	if func then
		func(troops,behavior)
		finishHandler()
	else
		print(string.format("找不到效果%d的处理函数",behavior.effectType))
		finishHandler()
	end
end



--endregion
