--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

--------------------------------------回合群体伤害型BUFF-------------------------------

local This, super = class(...,"Skill.BuffDamage")

local Templates = 
{
	--伤害分摊
	[BuffKind.kSpiritChain] = function (config,damageInfo)
		local count = #damageInfo.hitters
		assert(count > 0, Serialize[64272])
		if count > 0 then
			local phyValue = damageInfo.receiver:getAttr(AttrType.kPhyDamageValue) / count
			damageInfo.receiver:setAttr(AttrType.kPhyDamageValue,phyValue)
			for i , receiver in pairs(damageInfo.hitters) do
				if receiver ~= damageInfo.receiver then
					receiver:addAttr(AttrType.kPhyDamageValue,phyValue)
				end
			end
			local magicValue = damageInfo.receiver:getAttr(AttrType.kMagicDamageValue) / count
			damageInfo.receiver:setAttr(AttrType.kMagicDamageValue,magicValue)
			for i , receiver in pairs(damageInfo.hitters) do
				if receiver ~= damageInfo.receiver then
					receiver:addAttr(AttrType.kMagicDamageValue,magicValue)
				end
			end
			print("伤害分摊作用...")
		end
	end,
	--伤害共享
	[BuffKind.kIronChain] = function (config,damageInfo)
		local count = #damageInfo.hitters
		assert(count > 0, Serialize[64273])
		if count > 0 then
			local phyValue = damageInfo.receiver:getAttr(AttrType.kPhyDamageValue)
			for i , receiver in pairs(damageInfo.hitters) do
				if receiver ~= damageInfo.receiver then
					receiver:addAttr(AttrType.kPhyDamageValue,phyValue)
				end
			end
			local magicValue = damageInfo.receiver:getAttr(AttrType.kMagicDamageValue)
			for i , receiver in pairs(damageInfo.hitters) do
				if receiver ~= damageInfo.receiver then
					receiver:addAttr(AttrType.kMagicDamageValue,magicValue)
				end
			end
			print("伤害共享作用...")
		end
	end
}

function This:work()
	super.work(self)
	self.m_gameScene:addObserver(self)
end

function This:stop()
	if self.m_state ~= BuffState.Stop then
		print(string.format("%s 停止",BuffClass[self:getType()].name))
		super.stop(self)
		self.m_gameScene:removeObserver(self)
	end
end

function This:receiverEnterAttack(receiver)
	local attackInfo = self:getAttackInfo()
	if attackInfo.receiver ~= receiver then
		return
	end
	self.m_roundCount = self.m_roundCount - 1
	if self.m_roundCount <= 0 then
		self:stop()
	end
end

function This:receiverHitted(hitter)
	local attackInfo = self:getAttackInfo()
	if attackInfo.receiver ~= hitter then
		return
	end
	local config = self:getConfig()
	local func = Templates[config.type]
	if func then
		func(config,attackInfo)
	else
		assert(false,Serialize[64274])
	end
end

function This:onTroopsDead(troops)
	local attackInfo = self:getAttackInfo()
	for i , hitter in pairs(attackInfo.hitters) do
		if hitter ~= attackInfo.receiver and hitter == troops then
			table.remove(attackInfo.hitters,i)
			break
		end
	end
end

--endregion
