--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"Skill.AttrBuff")
local SkillCommon = require("Skill.SkillCommon")
local BattlePlayer = require("Battle.BattlePlayer")

function This:getForwardPosition(forwardx , forwardy)
	local index = ( math.abs(forwardx) - 1) * 3 + forwardy
	local isEnemy = forwardx > 0
	local troops = BattlePlayer:getTroops(index,isEnemy)
	local attackView = self.m_troops:getView()
	local view = troops:getView()
	return view:getAttackPoint(attackView)
end

function This:getForwardPositionByTargetList(targetList)
	local target = {}
	for i , info in pairs(targetList) do
		local troops = BattlePlayer:getTroopsByHeroId(info.isEnemy,info.heroId)
		table.insert(target,troops)
	end

	local selfx,selfy = self.m_troops:getXY()
	local forwardx , forwardy = SkillCommon:selectAttackPosition(TargetSearchType.kOtherSideSingle,target,selfx,selfy)
	local x , y = self:getForwardPosition(forwardx,forwardy)
	return x , y
end

function This:isNeedForward(troops)
	if troops:getSoilderId() == SoilderType.kArcher then
		return false
	end
	if troops:getSoilderId() == SoilderType.kSapperCar then
		return false
	end

	if not BattlePlayer:isPlaying() or BattlePlayer:isInPrepare() then
		return false
	end
	return true
end

function This:hasActiveEffect()
	return false
end

function This:doWork(effectList,isNeedBack)
	local function hitEndHandler()
		self.m_troops:back(isNeedBack)
	end

	local index = 1
	local function applyEffect()
		if index <= #effectList then
			local effect = effectList[index]
			index = index + 1

			local callbackCount , callbackTotal = 0 , 0
			local function handler()
				callbackCount = callbackCount + 1
				if callbackCount == callbackTotal then
					applyEffect()
				end
			end

			if #effect.target <= 0 then
				applyEffect()
			else
				for i , hitInfo in ipairs(effect.target) do
					callbackTotal = callbackTotal + 1
					local target = BattlePlayer:getTroopsByHeroId(hitInfo.isEnemy,hitInfo.heroId)
					if target and target:getState() ~= TroopsState.kDead then
						target:hitted(hitInfo,self.m_troops,handler)
					else
						handler()
					end
				end
			end
		else
			print("连击效果施加完毕",index)
			hitEndHandler()
		end
	end

	local targetList = {}
	for i , effect in ipairs(effectList) do
		for i , hitInfo in ipairs(effect.target) do
			local target = BattlePlayer:getTroopsByHeroId(hitInfo.isEnemy,hitInfo.heroId)
			if target and target:getState() ~= TroopsState.kDead then
				table.insert(targetList,target)
			end
		end
	end
	self.m_troops:attack(targetList,applyEffect)
	local view = self.m_troops:getView() 
	if view then
		view:showLianJi()
	end
end

function This:work(troops,effectList)
	--[[if #effectList <= 0 then
		return
	end]]
	self.m_troops = troops
	local isNeedForward = self:isNeedForward(troops)
	local function forwardHandler()
		self:doWork(effectList,isNeedForward)
	end
	if isNeedForward and #effectList[1].target > 0 then
		local x , y = self:getForwardPositionByTargetList(effectList[1].target)
		troops:forward(x,y,forwardHandler)
	else
		forwardHandler()
	end
end

--endregion
