--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

------------------------------------普通技能---------------------------

local This , super = class(...,"Base.BaseModel")
local BattleSceneView = require("Battle.BattleSceneView")
local Timer = require("Timer")
local SearchTargetHelper = require("Battle.SearchTargetHelper")
local BattlePlayer = require("Battle.BattlePlayer")

function This:init(id)
	self.m_id = id or 1
	self.m_searchId = TargetSearchType.kOtherSideSingle
	self.m_isFightBack = false
end

function This:getId()
	return self.m_id
end

function This:isSkill()
	return true
end

function This:isBuff()
	return false
end
function This:getName()
	return Serialize[64282]
end

function This:getDescripe()
	return Serialize[64283]
end

function This:getTroops()
	return self.m_troops
end

function This:setTroops(troops)
	self.m_troops = troops
end

function This:isPassive()
	return false
end

function This:getDamageType()
	return DamageType.kPhyDamage
end

function This:isFightBack()
	return self.m_isFightBack
end

function This:setIsFightBack(isBack)
	self.m_isFightBack = isBack
end

function This:isNeedForward()
	if self.m_isFightBack then
		return false
	end
	if self:getDamageType() ~= DamageType.kPhyDamage then
		return false
	end
	if self.m_troops:getSoilderId() == SoilderType.kArcher then
		return false
	end
	if self.m_troops:getSoilderId() == SoilderType.kSapperCar then
		return false
	end

	if not BattlePlayer:isPlaying() or BattlePlayer:isInPrepare() then
		return false
	end
	return true
end

function This:selectAttackPosition(searchId , targets,selfx,selfy)
	function RowForward()  
		local minX = 0xffff
		for i , t in pairs(targets) do
			local x , y = t:getXY()
			x = math.abs(x)
			if x < minX then
				minX = x
			end
		end
		return selfx < 0 and minX or -minX , math.floor((TroopsFormate.COLUMN + 1) / 2)
	end

	function ColumnForward()
		local minX = 0xffff
		for i , t in pairs(targets) do
			local x , y = t:getXY()
			x = math.abs(x)
			if x < minX then
				minX = x
			end
		end
		return selfx < 0 and minX or -minX , selfy
	end

	if searchId == TargetSearchType.kOtherSideSingle or #targets == 1 then
		return targets[1]:getXY()
	elseif searchId == TargetSearchType.kOtherSideAll then
		return -selfx , math.floor((TroopsFormate.COLUMN+1)/2)
	elseif searchId == TargetSearchType.kOtherSideFrontRow then
		return RowForward()
	elseif searchId == TargetSearchType.kOtherSideVertical then
		return ColumnForward()
	elseif searchId == TargetSearchType.kOtherSideBackRow then
		return RowForward()
	elseif searchId == TargetSearchType.kOtherSideMinHp then
		return targets[1]:getXY()
	elseif searchId == TargetSearchType.kOtherSideMaxHp then
		return targets[1]:getXY()
	else
		return RowForward()
	end
end

function This:active(endHandler)   --激活
	if endHandler then
		endHandler()
	end
end

function This:getForwardPosition(forwardx , forwardy)
	local index = ( math.abs(forwardx) - 1) * 3 + forwardy
	local isEnemy = forwardx > 0
	local troops = BattlePlayer:getTroops(index,isEnemy)
	local attackView = self.m_troops:getView()
	local view = troops:getView()
	if view then
		return view:getAttackPoint(attackView)
	else
		local view = BattleSceneView:createTroopsView(troops)
		if view then
			-- print("view:getAttackPoint(attackView)===="..view:getAttackPoint(attackView))
			return view:getAttackPoint(attackView)
		end
		return 0,0
	end
end

function This:getForwardPositionByTargetList(targetList)
	local target = {}
	for i , info in pairs(targetList) do
		local troops = BattlePlayer:getTroopsByHeroId(info.isEnemy,info.heroId)
		if troops == nil then
			print(string.format("是否敌方：%s，heroID:%d",info.isEnemy,info.heroId))
			BattlePlayer:print()
			assert(false)
		end
		table.insert(target,troops)
	end

	local selfx,selfy = self.m_troops:getXY()
	local forwardx , forwardy = self:selectAttackPosition(self.m_searchId,target,selfx,selfy)
	local x , y = self:getForwardPosition(forwardx,forwardy)
	return x , y
end

function This:doWork(effectList,isNeedBack,endCallBack)
	local function hitEndHandler()
		self.m_troops.m_attackEndTime = os.clock()
		self.m_troops:back(isNeedBack)
		if endCallBack then
			endCallBack()
		end
	end

	if #effectList <= 0 then
		hitEndHandler()
		return
	end

	local index = 1
	local function applyEffect()
		if index <= #effectList then
			local effect = effectList[index]
			index = index + 1

			local callbackCount , callbackTotal = 0 , 0
			local function handler()
				callbackCount = callbackCount + 1
				if callbackCount == callbackTotal then
					applyEffect()
				end
			end

			if #effect.target <= 0 then
				applyEffect()
			else
				for i , hitInfo in ipairs(effect.target) do
					callbackTotal = callbackTotal + 1
					local target = BattlePlayer:getTroopsByHeroId(hitInfo.isEnemy,hitInfo.heroId)
					if target and target:getState() ~= TroopsState.kDead then
						target:hitted(hitInfo,self.m_troops,handler)
					else
						handler()
					end
				end
			end
		else
			print("效果施加完毕",index)
			hitEndHandler()
		end
	end

	local targetList = {}
	for i , effect in ipairs(effectList) do
		for i , hitInfo in ipairs(effect.target) do
			local target = BattlePlayer:getTroopsByHeroId(hitInfo.isEnemy,hitInfo.heroId)
			if target and target:getState() ~= TroopsState.kDead then
				table.insert(targetList,target)
			end
		end
	end

	self.m_troops:attack(targetList,applyEffect)
end

function This:work(effectList)
	local isNeedForward = self:isNeedForward()
	local function forwardHandler()
		self:doWork(effectList,isNeedForward)
	end
	if isNeedForward and #effectList[1].target > 0 then
		local x , y = self:getForwardPositionByTargetList(effectList[1].target)
		self.m_troops:forward(x,y,forwardHandler)
	else
		self.m_troops.m_forwardEndTime = os.clock()
		self:doWork(effectList,isNeedForward)
	end
end

--endregion
