-- SkillMonster.lua


-------------------------------------神兽技能------------------------
local This,super = class(...,"Skill.SkillSpecial")
local SkillConfig = require("Metadatas.SkillConfig")
local BuffConfig = require("Metadatas.BuffConfig")
local BattleDataManager = require("Battle.BattleDataManager")
local BattlePlayer = require("Battle.BattlePlayer")
local Timer = require("Timer")
local EffectTimeConfig = require("Metadatas.EffectTimeConfig")
local MythicalAnimalsAttributeConfig = require("Metadatas.MythicalAnimalsAttributeConfig")
local EffectConfig = require("Metadatas.EffectConfig")
local BattleDataManager = require("Battle.BattleDataManager")


function This:work(effectList)
	local isNeedForward = self:isNeedForward()

	local sCharacterName = "SS_JiuWeiHu"
	local sEffectName = "SS_JiuWei1"
	local fight_offset = {}
	local fight_offset2 = {}
	local offsetX = 0
	local offsetY = 0

	local offsetX2 = 0
	local offsetY2 = 0

	if MythicalAnimalsAttributeConfig[self.m_troops:getHeroId()] then
		sCharacterName = MythicalAnimalsAttributeConfig[self.m_troops:getHeroId()].action
		sEffectName = MythicalAnimalsAttributeConfig[self.m_troops:getHeroId()].effect
		fight_offset = MythicalAnimalsAttributeConfig[self.m_troops:getHeroId()].fight_offset

		fight_offset2 = MythicalAnimalsAttributeConfig[self.m_troops:getHeroId()].fight_offset2

		offsetX = fight_offset[1]
		offsetY = fight_offset[2]

		offsetX2 = fight_offset2[1]
		offsetY2 = fight_offset2[2]
	end
	local m_MonsterEffectLayer = cc.Node:create()
	local skeletonNode = cc.SkeletonNode:createCharacter(sCharacterName)
    skeletonNode:scheduleUpdate()
    skeletonNode:playAnimation("animation", false)

    local skeletonAppear = cc.SkeletonNode:createEffect("SS_ChuXian")  --出现

    local skeletonSecond = cc.SkeletonNode:createEffect(sEffectName)

    local appearConfig = EffectConfig["SS_ChuXian"]

    local secondConfig = EffectConfig[sEffectName]

	local function backHandler()
		if skeletonNode then
			if skeletonNode.unscheduleUpdate then
				skeletonNode:unscheduleUpdate()
			end
			if skeletonNode.removeFromParent then
				if skeletonNode[0] and type(skeletonNode[0]) ~= "number" then
					skeletonNode:removeFromParent()
				end
			end
		end
		if skeletonNode2 then
			if skeletonNode2.unscheduleUpdate then
				skeletonNode2:unscheduleUpdate()
			end
			if skeletonNode2.removeFromParent then
				if skeletonNode2[0] and type(skeletonNode2[0]) ~= "number" then
					skeletonNode2:removeFromParent()
				end
			end
		end
		if skeletonNode3 then
			if skeletonNode3.unscheduleUpdate then
				skeletonNode3:unscheduleUpdate()
			end
			if skeletonNode3.removeFromParent then
				if skeletonNode3[0] and type(skeletonNode3[0]) ~= "number" then
					skeletonNode3:removeFromParent()
				end
			end
		end		
		if m_MonsterEffectLayer.removeFromParent then
			-- print_tmp(m_MonsterEffectLayer)
			if m_MonsterEffectLayer[0] and type(m_MonsterEffectLayer[0]) ~= "number" then
				m_MonsterEffectLayer:removeFromParent()
			end
		end
	end

	local function toDoWorkHandler()
		local view = self.m_troops:getView()
		if view then
			local timer = g_scene:getTimer()
			timer:setTimer(kSkillShowTime - kSkillActiveTime,function()
				self.m_troops.m_forwardEndTime = os.clock()
				self:doWork(effectList,true,backHandler)
			end,"skill_work")
		else
			self:doWork(effectList,true,backHandler)
		end
	end
    local isRuning = false

	skeletonNode:setAnimationListener({
		onAnimationComplete = function (_,animationName,animationEvent)
			-- print("animationName11111111===="..animationName..">>>>>=="..animationEvent)
		end,
		onAnimationEvent = function (_,animationName,animationEvent)
			if not isRuning then
				skeletonAppear:scheduleUpdate()
			    skeletonAppear:playAnimation("animation", false)
			else
				skeletonSecond:scheduleUpdate()
				skeletonSecond:playAnimation("animation", false)
			end
			isRuning = true
		end
	})

	local isEnemy = self.m_troops:getAction().isEnemy
    -- if self.m_troops:isEnemy() then
    if isEnemy then
    	skeletonNode:setFlippedX(true)
    	skeletonAppear:setFlippedX(true)
    	skeletonSecond:setFlippedX(true)
    else	
    	skeletonNode:setFlippedX(false)
    	skeletonAppear:setFlippedX(false)
    	skeletonSecond:setFlippedX(false)
   	end

   	local m_mapInfoId = BattlePlayer:getMapInfoId()

   	skeletonNode:setPosition(400 + offsetX,200 + offsetY)

   	if m_mapInfoId == 2 then
   		skeletonNode:setPosition(400 + offsetX2,200 + offsetY2)
   	end

 	local characterPosX,characterPosY = skeletonNode:getPosition()

    if appearConfig then
    	skeletonAppear:setPosition(characterPosX + appearConfig.offset[1],characterPosX + appearConfig.offset[2])
    else
	    skeletonAppear:setPosition(characterPosX,characterPosY)
    end
    if secondConfig then
    	skeletonSecond:setPosition(characterPosX + 130 + secondConfig.offset[1],characterPosY + 30 + secondConfig.offset[2])
    else
    	skeletonSecond:setPosition(characterPosX + 130,characterPosY + 30)
    end

	local timer2 = nil
    if g_scene.getTimer then
    	timer2 = g_scene:getTimer()
    end

    local delayTime = 0.3
    if not self.m_troops:getView() then
    	delayTime = 1.2
    end
    if timer2 then
		timer2:setTimer(delayTime,function()
			toDoWorkHandler()
		end,"monster_attack")
	else
		toDoWorkHandler()
	end

	if skeletonAppear[0] and type(skeletonAppear[0]) ~= "number" then
		skeletonAppear:setLocalZOrder(100)  
	end
	if skeletonNode[0] and type(skeletonNode[0]) ~= "number" then
		skeletonNode:setLocalZOrder(101)  
	end

	if m_MonsterEffectLayer[0] and type(m_MonsterEffectLayer[0]) ~= "number" then
	    m_MonsterEffectLayer:addChild(skeletonNode)
	    m_MonsterEffectLayer:addChild(skeletonAppear)
	    m_MonsterEffectLayer:addChild(skeletonSecond)

		if g_scene[0] and type(g_scene[0]) ~= "number" then
	    	g_scene:addChild(m_MonsterEffectLayer)
	    end	
	end
end
