-- @Author: zheng
-- @Date:   2018-08-14 17:17:16
-- @Last Modified by:   zheng
-- @Last Modified time: 2020-07-03 17:33:54
-- @File Name: ChallengeEmbattleHeroPanel.lua


local This , super = class(...,"Stage.EmbattleHeroPanel")
local ChallengeStageManager = require("Stage.ChallengeStageManager")

local GamePlayer = require("Player.GamePlayer")


function This:initNode(info)
	super.initNode(self,info)
end

function This:initBaseInfo()
	self.m_csNode.helpbutton:setVisible(false)
	self.m_csNode.bg3.tagettext:setString(Serialize[64171])
	local stage = ChallengeStageManager:getStage(self.m_stageId)
	self.m_csNode.bg3.taget:setString(stage:getName())
	self.m_csNode.bg3.name:setString(GamePlayer:getRoleName())
	
	local hp = self:getTotalHp()
	self.m_csNode.bg3.totalhp:setString(string.format("%d",hp))
	self.m_csNode.bg3.cost:setVisible(false)
	self.m_csNode.bg3.consume:setVisible(false)
end

function This:getHeroSource()
    return ChallengeStageManager:getEmbattleHero()
end

function This:gotoBattle(heroList, isOnceKey)
		local stage = ChallengeStageManager:getStage(self.m_stageId)
		if isOnceKey then
			ChallengeStageManager:onEmbattleHerosRequest(heroList)
		elseif #heroList ==0 then
			g_scene:showTips(Serialize[64178])
		elseif not isOnceKey and #heroList < 6 then
			local panel = g_scene:openDialog("UI.ConfirmPanel",{text = Serialize[64179]})
			panel:setOkHandler(function()
				ChallengeStageManager:onChallengeStageRequest(self.m_stageId)
			end)				
		else
			ChallengeStageManager:onChallengeStageRequest(self.m_stageId)
		end
end

