-- @Author: zheng
-- @Date:   2018-08-14 17:04:47
-- @Last Modified by:   zheng
-- @Last Modified time: 2019-11-13 10:31:02
-- @File Name: ChallengeMapPanel.lua

local strList ={
    chapter ="今日剩余挑战次数",
}
local This , super = class(...,"Dialog")

local ChallengeStageManager = require("Stage.ChallengeStageManager")
local GameUtil = require("Util.GameUtil")

local ChallengeMapNode = require("Stage.ChallengeMapNode")

local SlideAction = require("Action.SlideAction")


function This:initNode(info)
	self.m_csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/TeamWarMap.csb")
	self:addChild(self.m_csNode)
	local csNode = self.m_csNode
	csNode:setToCenter()
	csNode.zhezhaoshang:fitScreenX()
	csNode.zhezhaoxia:fitScreenX()
	 local scrollview =  csNode.scrollView
	local view = ChallengeMapNode:create(scrollview)
	view:initBg()

	self.m_view = view
	scrollview:fitScreen()
	scrollview:setDirection("horizontal")
	scrollview.m_direction = "right"
	scrollview:setSwallowTouch(false)
    local w , h = view:getContentSize()
	scrollview:pushBackCustomItem(view,w,h,0)
	self:refresh(  )
	if info then
		self:addOpenCallBack(function ()
			local chapter = ChallengeStageManager:getLastChapter()
			g_scene:openDialog("Stage.ChallengeChapterPanel",{chapterId = chapter:getId()})
		end)
	end
	ChallengeStageManager:onGetStateInfoRequest()

end

function This:initAction()
end

function This:update(dt)
	super.update(self,dt)
end

function This:onEnter()
	super.onEnter(self)
	ChallengeStageManager:addObserver(self)
end

function This:onExit()
	super.onExit(self)
	ChallengeStageManager:removeObserver(self)
end

function This:refresh(  )
	if self.m_view then
		self.m_view:refresh()
	end
	self:refreshTxtNode()
	self:createEffect(ChallengeStageManager:isCanReward(),self.m_csNode.Box)
    self:createEffect(ChallengeStageManager:challengedTimesIsCanReward(),self.m_csNode.Box1)
end

function This:initTouchEvent()
	self.m_csNode.closebg:setTouch({
		onEnded =function ()
			self:close()
		end
		,
		isDynamic = true
	})
	self.m_csNode.Box:setTouch({
		onEnded =function ()
			g_scene:openDialog("Stage.ChallengeTurnDayPanel")
		end
		,
		isDynamic = true
	})
	self.m_csNode.addbg:setTouch({
		onEnded =function ()
			ChallengeStageManager:resetBtnCallBack( )
		end
		,
		isDynamic = true
	})
	self.m_csNode.wenhao:setTouch({
		onEnded =function ()
			g_scene:openDialog("UI.HelpTips", {text = Serialize["Stage_ChallengeMap_1"],node = self.m_csNode.wenhao})
		end
		,
		isDynamic = true
	})

    self.m_csNode.Box1:setTouch({
		onEnded =function ()
			g_scene:openDialog("Stage.ChallengeTimesRewardPanel")
		end
		,
		isDynamic = true
	})
	self:initAction()
end

function This:refreshTxtNode()
	local canChalenge, chanlengeTime = ChallengeStageManager:getChallengeTimes()
	local canReset,resetTime = ChallengeStageManager:getResetTiem()
	local totalStar = ChallengeStageManager:getTotalStar()
	local minStar = ChallengeStageManager:getMinChallengeStarLv()
	local strFormat = "<A5>"..strList.chapter.."：%d"
	if not canChalenge then
		strFormat = "<A5>"..strList.chapter.."：<New11>%d"
	end
	local str = string.format(strFormat,chanlengeTime)

	self.m_csNode.name:setStringWithColor(str)
	self.m_csNode.addbg:setVisible(not canChalenge)
	self.m_csNode.number:setString(string.format("%d/%d",totalStar,minStar))

    local curChallengeNum = ChallengeStageManager:getChallengedTimes()
    local nextChallengeNum = ChallengeStageManager:getNextChallengedTimes()
    self.m_csNode.number1:setString(string.format("%d/%d",curChallengeNum,nextChallengeNum))
    
end

function This:createEffect(isAdd,node)
    local function createAnim( parent,anmStr )
        local GameUtil = require("Util.GameUtil")
        local effect1 = GameUtil:createEffect(anmStr,true)
        parent:addChild(effect1,-1)
        return effect1
    end
   
    node:removeAllChildren()
    local textures ={"MenuScene/boxLock2.png","MenuScene/boxGet2.png"}
    local texture = textures[1]
    if isAdd then
        texture = textures[2]
        local effect1 = createAnim(node,"BoxLing")
        local w ,h = node:getContentSize()
        effect1:setPosition(w/2, h/2)
        local effect2 = createAnim(node,"BoxLing2")
        effect2:setPosition(w/2, h/2)
    end
    node:setImage(texture)
end

function This:OnStateInfo()--获取挑战关卡信息
	self:refresh()
end

function This:onChallengeState(  )--挑战关卡
	self:refresh()
end

function This:onStageReset(  )--挑战次数重置
	self:refresh()
end

function This:onStageSweep(  )--关卡扫荡
	self:refresh()
end

function This:onStarRewardChanged(  )--领取奖励
	self:refresh()
end

