-- @Author: zheng
-- @Date:   2018-08-14 17:04:47
-- @Last Modified by:   zheng
-- @Last Modified time: 2018-11-17 16:46:21
-- @File Name: ChallengeRewardPanel.lua


local This , super = class(...,"Dialog")

local ChallengeStageManager = require("Stage.ChallengeStageManager")
local ChallengeRewarditemView = require("Stage.ChallengeRewarditemView")

function This:initNode(info)
	self.m_csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/TeamWarReward.csb")
	self:addChild(self.m_csNode)
	self.m_csNode:setToCenter()

	self.m_chapterId = info.chapterId
	local chapter = ChallengeStageManager:getChapter(self.m_chapterId)
	self.m_data = chapter
	self:refresh( )
end

function This:onEnter()
	super.onEnter(self)
	ChallengeStageManager:addObserver(self)
end

function This:onExit()
	super.onExit(self)
	ChallengeStageManager:removeObserver(self)
end

function This:initTouchEvent()
	self.m_csNode.closebg:setTouchEnded(function ()
		self:close()
	end)

end

function This:refresh( )
	local chapter = self.m_data
	self.m_csNode.number:setString(string.format("%d/%d",chapter:getTotalStar(),chapter:getMaxStar()))

    local rewList = chapter:getRewardList()
    local scrollView = self.m_csNode.scrollView
    local itemList = scrollView:getItemList()
    if itemList and #itemList>0 then
    	for i,v in ipairs(rewList) do
    		local item = itemList[i]
    		item:refresh(v)
    	end
        return
    end

    for i,v in ipairs(rewList) do
        local view = self:getScroolItem({chapterId = self.m_chapterId,itemData= v})
        local w , h = view:getContentSize()
        scrollView:pushBackCustomItem(view,w,h,0.5)
    end
end

function This:getScroolItem(itemData)
    local view = ChallengeRewarditemView:create(itemData)
    return view
end

function This:onStarRewardChanged(  )
	self:refresh()
end

