-- @Author: zheng
-- @Date:   2018-08-13 15:37:02
-- @Last Modified by:   zheng
-- @Last Modified time: 2018-08-21 20:12:10
-- @File Name: GameChallengeStage.lua

local This = class(...)

local StageConfig = require("Metadatas.ChallengeStageStageConfig")
local DropConfig = require("Metadatas.DropConfig")
local GamePlayer = require("Player.GamePlayer")
-- local NpcConfig = require("Metadatas.HeroNpcConfig")

function This:create(id)
	local stage = {}
	setmetatable(stage,This)
	stage:init(id)
	return stage
end

function This:init(id)
	self.m_id = id
	self.m_config = StageConfig[id]
	self.m_starLv = 0
	self.m_preStage = nil
end

function This:setPreStage(stage)
	self.m_preStage = stage
end

function This:getPreStage()
	return self.m_preStage
end

function This:clear()
	self.m_starLv = 0
end

function This:getId()
	return self.m_id
end

function This:getChapterId()
	return self.m_config.chapter_id
end

function This:getChapterNumber()
	return tostring(self.m_config.chapter_id)
end

function This:getName()
	return self.m_config.name
end

function This:getDropId()
	return self.m_config.drop_id
end

function This:getImageFile()
	local GameUtil = require("Util.GameUtil")
	return GameUtil:getHeroIcon(tonumber(self.m_config.image))
end

function This:getStarLv()
	return self.m_starLv
end

function This:setStarLv(starLv)
	self.m_starLv = starLv
end

function This:isPassed()
    return self:getStarLv() >= 3
end

function This:isLock()
	if self.m_preStage then
		return self.m_preStage:isPassed()
	end
	return true
end

function This:getDrops()
	local result = {}
	local drops = DropConfig[self.m_config.drop_id].drop_info
	for i , info in pairs(drops) do
		table.insert(result,{info[1],info[2]})
	end
	return result
end

