--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This = class(...)
local ChapterConfig = require("Metadatas.StageChapterConfig")
local DropConfig = require("Metadatas.DropConfig")

RewardLevel =
{
	kFirstStarLv = 1,
	kSecondStarLv = 2,
	kThirdStarLv = 3
}

function This:create(...)
	local chapter = setmetatable({},self)
	chapter:init(...)
	return chapter
end

function This:init(id)
	self.m_id = id
	self.m_stages = {}
	self.m_config = ChapterConfig[id]
	self.m_totalStar = 0
	self.m_starReward = {false,false,false}
	self.m_maxStar = 0
	self.m_preChapter = nil
	self.m_nexChapter = nil
	self:initVisitInfo()
end

function This:initVisitInfo()
	self.m_visitHeroList = self:getConfigVisitHeroList()
	self.m_visitHeroInstanceList = {}
end

function This:clear()
	self.m_totalStar = 0
	for i , _ in pairs(self.m_starReward) do
		self.m_starReward[i] = false
	end
end

function This:addStage(stage)
	table.insert(self.m_stages,stage)
	self.m_maxStar = self.m_maxStar + 3
end

function This:getId()
	return self.m_id
end

function This:getStages()
	return self.m_stages
end

function This:isLock()
    local ret = false
    if self.m_stages[1] then
    	ret = self.m_stages[1]:isLock()
    end
    return ret
end

function This:getLockLevel()
    local ret = 0
    if self.m_stages[1] then
    	ret = self.m_stages[1]:getPlayerLevelLimit()
    end
    return ret
end

function This:getLockStr()
	local result =Serialize["stage_unlock"]
	if self.m_stages[1] then
    	result = self.m_stages[1]:getLockStr()
    end
	return result
end


function This:setPreChapter(chapter)
	self.m_preChapter = chapter
end

function This:getPreChapter()
	return self.m_preChapter
end

function This:setNexChapter(chapter)
	self.m_nexChapter = chapter
end

function This:getNexChapter()
	return self.m_nexChapter
end

function This:onStageLoadFinish()
	table.sort(self.m_stages,function(s1,s2)
		return s1:getId() < s2:getId()
	end)
	self:updateTotoalStar()
end

function This:getMaxStar()
	return self.m_maxStar
end

function This:setTotoalStar(star)
	self.m_totalStar = star
end

function This:getTotalStar()
	return self.m_totalStar
end

function This:getName()
	return self.m_config.name
end

function This:getTitle()
	return string.format(Serialize[60857],self.m_id)
end

function This:setVisitHeroState( heroIndex, state )
	local stateList = self.m_visitHeroList
	if not stateList then
		stateList = self:getVisitHeroList()
	end
	stateList[heroIndex].isMine = state
end

function This:getVisitHeroState( heroIndex )
	local stateList = self.m_visitHeroList
	if not stateList then
		stateList = self:getVisitHeroList()
	end

	return stateList[heroIndex].isMine
end

function This:getVisitHeroTimes( )
	local stateList = self.m_visitHeroList
	if not stateList then
		stateList = self:getVisitHeroList()
	end

	local num = 0
	for _, info in ipairs(stateList) do
		if info.isMine then
			num = num + 1 
		end
	end
	return num, num < #stateList
end

function This:preHaveNotVisited()
	local pre, curChapter = self, nil
	repeat
		curChapter = pre:getPreVisitChapter()
		if curChapter and curChapter:isPassAllStages() then
			local _, state = curChapter:getVisitHeroTimes()
			print(tostring(curChapter:getId()), tostring(state))
			if state then
				return true
			end
		end

        if pre ~= curChapter and curChapter then
		    pre = curChapter:getPreChapter()
        else
            pre = nil
        end
	until not pre 
	return false
end

function This:getConfigVisitHeroList()
	local ret = {}
	local t = self.m_config.heor_list
	if not t or t[1] == 0 then
		return nil
	end

	for i, info in ipairs(t) do
		ret[i]={heroId = info[1], isMine = false}
	end
	
	if #ret <= 0 then
		return nil
	end
	return ret
end

function This:getCurVisitHeroList()
	return self.m_visitHeroList
end

function This:getVisitHeroInstanceList()
	return self.m_visitHeroInstanceList
end

function This:getVisitHeroInstanceBy(heroId)
	return self.m_visitHeroInstanceList[heroId]
end

function This:setVisitHeroInstance(hero, heroId)
	self.m_visitHeroInstanceList[heroId] = hero
end

function This:hasVisitHeroList()
	return self.m_visitHeroList ~= nil and #self.m_visitHeroList > 0
end

function This:getPreVisitChapter()
	local pre = self:getPreChapter()
	if pre then
        if pre:hasVisitHeroList() then
        	return pre
        else
			return pre:getPreVisitChapter()
        end
	end
	return nil
end

function This:getPreCanVisitChapter()
	local pre = self:getPreChapter()
	if pre then
        if pre:hasVisitHeroList() and pre:isPassAllStages() then
        	local _, state = pre:getVisitHeroTimes()
	    	if state then
	    		return pre
	    	end
	    end
		return pre:getPreVisitChapter()
	end
	return nil
end

--只能动态获取
function This:getNextVisitChapter()
	local nextCh = self:getNexChapter()
	if nextCh then
		if nextCh:hasVisitHeroList() then
			return nextCh
		else 
			return nextCh:getNextVisitChapter()
		end
	end
	return nil
end

--只能动态获取
function This:getVisitChapterList()
	local ret = {}
	local retIndex = 0
	local count = 0
	local pre = self
	repeat
		curChapter = pre:getPreVisitChapter()
		if curChapter then
			retIndex = retIndex + 1
			table.insert(ret, curChapter)
		end

        if pre ~= curChapter and curChapter then
		    pre = curChapter:getPreChapter()
        else
            pre = nil
        end
	until not pre 

	if ret then
		for i = 1, retIndex / 2 do
			local temp = ret[i]
			local j = retIndex + 1 - i
			ret[i] = ret[j]
			ret[j] = temp
		end
	end

	if self:hasVisitHeroList() then
        retIndex = retIndex + 1
		table.insert(ret, self)
        curChapter = self
	end

	count = retIndex
	if retIndex == 0 then
		retIndex = 1
	end

	if curChapter:isPassAllStages() then
		local chapter = self
		repeat
			local nextChapter = chapter:getNextVisitChapter()
			if nextChapter then
				count = count + 1
				table.insert(ret, nextChapter)
			end
			chapter = nextChapter
		until not chapter or not chapter:isPassAllStages()
	end

	for i=1, count do
		local index = count + 1 - i
		if ret[index]:isPassAllStages() then
			local _, state = ret[index]:getVisitHeroTimes()
			if state then
				return ret, index
			end
		end
	end

	return ret, retIndex
end

--用于快捷获取，直接调用
function This:getVisitHeroList()
	local ret = self:getCurVisitHeroList()
	if ret and #ret > 0 then
		return ret
	end

	local pre = self:getPreChapter()
	while(not ret and pre)
	do
		ret = pre:getCurVisitHeroList()
		pre = pre:getPreChapter()
	end

	if not ret or #ret <= 0 then
		return nil
	end
	return ret
end

function This:getVisitPriceBy( curTimes )
	if not curTimes then
		curTimes = self:getVisitHeroTimes() + 1
	end

	local index = 0
	local count = #self.m_config.diamond_cost
	if count < curTimes then
		return -1
	else
		index = curTimes
	end
	return self.m_config.diamond_cost[index]
end

function This:isPassAllStages()
	local stage = self.m_stages[#self.m_stages]
	return stage:getStarLv() > 0
end

function This:updateTotoalStar()
	local total = 0
	for i , stage in ipairs(self.m_stages) do
		total = total + stage:getStarLv()
		stage:setChapterIndex(i)
	end
	self.m_totalStar = total
end


function This:getRewardStarLimit(rewardLv)
	assert(rewardLv >= RewardLevel.kFirstStarLv and rewardLv <= RewardLevel.kThirdStarLv)
	return self.m_config.reward_starlv[rewardLv]
end

function This:getRewardDrops(rewardLv)
	assert(rewardLv >= RewardLevel.kFirstStarLv and rewardLv <= RewardLevel.kThirdStarLv)
	local dropId = self.m_config.drop_id[rewardLv]
	local drops = DropConfig[dropId]
	local result = {}
	for i , info in pairs(drops.drop_info) do
		table.insert(result,{id = info[1], num = info[2]})
	end
	return result
end

function This:isStarRewardReceived(rewardLv)
	if rewardLv >= RewardLevel.kFirstStarLv and rewardLv <= RewardLevel.kThirdStarLv then
		return self.m_starReward[rewardLv]
	end
end

function This:setStarRewardReceived(rewardLv,isReceived)
	if rewardLv >= RewardLevel.kFirstStarLv and rewardLv <= RewardLevel.kThirdStarLv then
		self.m_starReward[rewardLv] = isReceived
	end
end

function This:starIsEnough(rewardLv)
	if rewardLv >= RewardLevel.kFirstStarLv and rewardLv <= RewardLevel.kThirdStarLv then
		return self.m_totalStar >= self.m_config.reward_starlv[rewardLv]
	end
end

function This:getRewardBox()
	local ret = {}
	local chapterId = self:getId() * 10
	for i = RewardLevel.kFirstStarLv , RewardLevel.kThirdStarLv do
		if (not self.m_starReward[i]) and self:starIsEnough(i) then
			table.insert(ret, chapterId + i)
		end
	end
	return ret
end

--endregion
