-- @Author: zheng
-- @Date:   2019-05-05 11:42:39
-- @Last Modified by:   zheng
-- @Last Modified time: 2019-05-06 15:05:33
-- @File Name: GameEliteStage.lua

local This , super = class(...,"Stage.GameStage")
local StageEliteConfig = require("Metadatas.StageEliteConfig")
local StageEliteResetConfig = require("Metadatas.StageEliteResetConfig")
local StageManager = require("Stage.GameStageManager")
function This:init(id)
    self.m_id = id
    self.m_config = StageEliteConfig[id]
    self.m_starLv = 0
    self.m_challengeTimes = 0
    self.m_resetTimes = 0
    self.m_preStage = nil
end

function This:getResetCost()
    return super.getResetCost(self,StageEliteResetConfig)
end

function This:isLock()
    local locakStage = self.m_config.unlock_stage
    local stage = StageManager:getStage(locakStage)
    if not stage then
        return true
    else
        if stage:isLock() then
            local chapterIndex = stage:getChapterIndex()
            local chapterId = stage:getChapterId()
            local str = string.format("%s%d-%d",Serialize["Stage_GameStage_1"],chapterId,chapterIndex)
            self:setLockStr(str)
            return true
        else
            return super.isLock(self)
        end
    end

end
