
--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This = class(...)

local StageConfig = require("Metadatas.StageConfig")
local StageResetConfig = require("Metadatas.StageResetConfig")
local DropConfig = require("Metadatas.DropConfig")
local GamePlayer = require("Player.GamePlayer")
local NpcConfig = require("Metadatas.HeroNpcConfig")
local Hero = require("Hero.Hero")
local StageManager = require("Stage.GameStageManager")

function This:create(id)
	local stage = setmetatable({},self)
	-- setmetatable(stage,This)
	stage:init(id)
	return stage
end

function This:init(id)
	self.m_id = id
	self.m_config = StageConfig[id]
	self.m_starLv = 0
	self.m_challengeTimes = 0
	self.m_resetTimes = 0
	self.m_preStage = nil
end

function This:setPreStage(stage)
	self.m_preStage = stage
end

function This:getPreStage()
	return self.m_preStage
end

function This:clear()
	self.m_starLv = 0
end

function This:getId()
	return self.m_id
end

function This:getChapterId()
	return self.m_config.chapter_id
end

function This:getChapterNumber()
	return tostring(self.m_config.chapter_id)
end

function This:getName()
	return self.m_config.name
end

function This:getPowerCost()
	return self.m_config.power_cost
end

function This:getPlayerLevelLimit()
	return self.m_config.level_limit
end

function This:getDropId()
	return self.m_config.drop_id
end

function This:getImageFile()
	return self.m_config.image
end

function This:getChallengeTimesLimit()
    return self.m_config.challenge_times
end

function This:getLeftChallengeTimes()
	local totalTime = self:getChallengeTimesLimit()
	local ltime = totalTime - self.m_challengeTimes
	if ltime <= 0 then
		return 0, totalTime
	end
    return ltime, totalTime
end

function This:setChallengeTimes(num)
	-- print("章节：" .. tostring(self:getId()) .. ", 已经挑战的次数：" .. tostring(num))
    self.m_challengeTimes = num
end

function This:setLeftChallengeTimes(num)
	-- print("章节：" .. tostring(self:getId()) .. ", 剩余挑战的次数：" .. tostring(num))
	self:setChallengeTimes(self:getChallengeTimesLimit() - num)
    self.m_leftChallengeTimes = num
end

function This:getResetCost(resetConfig)
	local temResetConfig = resetConfig or StageResetConfig
	local count = #temResetConfig
	local index = self:getResetTimes() + 1
	if index > count then
		index = count
	end
	local config = temResetConfig[index]
	if config then
		return config.reset_cost
	else
		return 0
	end
end

function This:getResetTimes()
    return self.m_resetTimes
end

function This:setResetTimes(num)
	-- print("章节：" .. tostring(self:getId()) .. ", 已经重置的次数：" .. tostring(num))
    self.m_resetTimes = num
end

function This:getStarLv()
	return self.m_starLv
end

function This:setStarLv(starLv)
	self.m_starLv = starLv
end

--获取当前关卡属于本章节的第几关
function This:getChapterIndex()
	return self.m_chapterIndex or 1
end

function This:setChapterIndex(chapterIndex)
	self.m_chapterIndex = chapterIndex
end

function This:isPassed()
    return self:getStarLv() >= 3
end

function This:setLockStr(lockStr)
	self.m_lockStr = lockStr
end

function This:getLockStr()
	self:isLock()
	return self.m_lockStr or Serialize["stage_unlock"]
end

function This:isLock()
	local function checkLvLimit()
		local levelLimit = self.m_config.level_limit
		local res = GamePlayer:getLevel() < levelLimit
		if res then
			local str = string.format(Serialize["activity_FestivalPanel_2_c"],levelLimit)
			self:setLockStr(str)
		end
		return res
	end
	local result = checkLvLimit()
	if not result and self.m_preStage then
		result = not (self.m_preStage:getStarLv() > 0)
		if result then
			self:setLockStr(Serialize["stage_unlock"])
			return result
		end
	end
	return result
end

function This:getDrops()
	local result = {}
	local drops = DropConfig[self.m_config.drop_id].drop_info
	for i , info in pairs(drops) do
		-- if math.random(1,100) <= info[3] * 100 then
		table.insert(result,{id = info[1],num = info[2]})
		-- end
	end
	return result
end

--endregion
