--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This = class(...)
local StageChapterConfig = require("Metadatas.StageChapterConfig")
local StageConfig = require("Metadatas.StageConfig")
local GameChapter = require("Stage.GameChapter")
local GameStage = require("Stage.GameStage")
local GameEliteChapter = require("Stage.GameEliteChapter")
local GameEliteStage = require("Stage.GameEliteStage")
local StageEliteBoxConfig = require("Metadatas.StageEliteBoxConfig")
local StageEliteConfig = require("Metadatas.StageEliteConfig")
local Socket = require("Net.Socket")         
local EventDispatcher = require("EventDispatcher")
local Serialize = require("Serialize.Serialize")
local BattleDataManager = require("Battle.BattleDataManager")
local HeroManager = require("Hero.HeroManager")
local Hero = require("Hero.Hero")
GameStageManagerStageType = {
	kCopyStage = 1,
	kMliteStage = 2,
}
function This:init()
	local function initStage(chapterConfigs,stageConfigs,gameStageData,gameChapterData)
		local stages ={}
		local chapters = {}
		for id , config in pairs(chapterConfigs) do
			chapters[id] = gameChapterData:create(id)
		end

		for id , chapter in pairs(chapters) do
			local preChapter = chapters[id - 1]
			if preChapter then
				chapter:setPreChapter(preChapter)
			end
			local nexChapter = chapters[id + 1]
			if nexChapter then
				chapter:setNexChapter(nexChapter)
			end
		end
		
		for id , config in pairs(stageConfigs) do
			local stage = gameStageData:create(id)
			local chapter = chapters[config.chapter_id]
			chapter:addStage(stage)
			stages[id] = stage
		end

		for id , stage in pairs(stages) do
			local preStage = stages[id-1]
			stage:setPreStage(preStage)
		end

		for id , chapter in pairs(chapters) do
			chapter:onStageLoadFinish()
		end
		return chapters,stages
	end
	self.m_chapter,self.m_stage = initStage(StageChapterConfig,StageConfig,GameStage,GameChapter)

	self.m_chapterElite,self.m_stageElite = initStage(StageEliteBoxConfig,StageEliteConfig,GameEliteStage,GameEliteChapter)
	self.m_nextCanBattleStageElite = self.m_stageElite[1] or self.m_stageElite[1001]

	self.m_emBattleHeros = {}
	self.m_lastChapter = self.m_chapter[1]
	self.m_nextCanBattleStage = self.m_stage[1]
	self.m_enterStage = 0
	self.m_observers = {}
	self.m_battleResult = {}
    self.m_isEnterRobber = false
    self.m_lastRefreshTime = 0
	self:initEventListener()
end

function This:initEventListener()
	EventDispatcher:addListener(self, 10700, self.onGetStateInfoNotify)
	EventDispatcher:addListener(self, 10701, self.onChallengeStateReply)
	EventDispatcher:addListener(self, 10703, self.onReceiveStarRewardReply)
	EventDispatcher:addListener(self, 10702, self.onEmbattleHerosReply)
	EventDispatcher:addListener(self, 10704, self.onSkipBattleReply)
 
	EventDispatcher:addListener(self, 10705, self.onVisitHeroReply)
	EventDispatcher:addListener(self, 10706, self.onStageSweepReply)
	EventDispatcher:addListener(self, 10707, self.onStageResetReply)
	EventDispatcher:addListener(self, 10708, self.onChallengeStateReply)--精英副本挑战
	EventDispatcher:addListener(self, 10709, self.onReceiveStarRewardReply)--领取精英副本奖励
	EventDispatcher:addListener(self, 10710, self.onStageSweepReply)--精英副本扫荡
	EventDispatcher:addListener(self, 10711, self.onStageResetReply)--精英副本重置

end

function This:removeEventListener()
	EventDispatcher:removeListener(self, 10700)
	EventDispatcher:removeListener(self, 10701)
	EventDispatcher:removeListener(self, 10703)
	EventDispatcher:removeListener(self, 10702)
	EventDispatcher:removeListener(self, 10704)
	EventDispatcher:removeListener(self, 10705)
	EventDispatcher:removeListener(self, 10706)
	EventDispatcher:removeListener(self, 10707)
	EventDispatcher:removeListener(self,10708)
	EventDispatcher:removeListener(self,10709)
	EventDispatcher:removeListener(self,10710)
	EventDispatcher:removeListener(self,10711)
	
end

function This:addObserver(o)
	for i , observer in pairs(self.m_observers) do
		if observer == o then
			return 
		end
	end
	table.insert(self.m_observers,o)
end

function This:removeObserver(o)
	for i , observer in pairs(self.m_observers) do
		if observer == o then
			table.remove(self.m_observers,i)
			return
		end
	end
end

function This:notifyObservers(funcName,...)
	local observers = {}
	for i , o in pairs(self.m_observers) do
		table.insert(observers,o)
	end
	
	for i, observer in pairs(observers) do
		if observer[funcName] then
			observer[funcName](observer,...)
		end
	end
end

function This:setStageType(stageType)
	self.m_stageType = stageType
end

function This:getStageType()
	return self.m_stageType or 1
end

function This:getLastChapter()
	return self.m_lastChapter
end

function This:setLastChapter(chapter)
	self.m_lastChapter = chapter or self.m_chapter[1]
end

function This:checkStageType(stageType,stageType2)
	local temStageType = stageType2 or self:getStageType()
	if stageType then
		return temStageType == stageType
	end
	return false
end

function This:getStage(id,stageType)
	if self:checkStageType(stageType,GameStageManagerStageType.kMliteStage) then
		return self.m_stageElite[id]
	end
	return self.m_stage[id]
end

function This:getStages(stageType)
	if self:checkStageType(stageType,GameStageManagerStageType.kMliteStage) then
		return self.m_stageElite
	end
	return self.m_stage
end

function This:getChapter(id,stageType)
	if self:checkStageType(stageType,GameStageManagerStageType.kMliteStage) then
		return self.m_chapterElite[id]
	end
	return self.m_chapter[id]
end

function This:getChapters(stageType)
	if self:checkStageType(stageType,GameStageManagerStageType.kMliteStage) then
		return self.m_chapterElite
	end
	return self.m_chapter
end

function This:setNextCanBattleStage(nextCanBattleStage,stageType)
	local temStageType = stageType or self:getStageType()
	if self:checkStageType(temStageType,GameStageManagerStageType.kMliteStage) then
		self.m_nextCanBattleStageElite = nextCanBattleStage
		return
	end
	self.m_nextCanBattleStage = nextCanBattleStage
end

function This:getNextCanBattleStage(stageType)
	local temStageType = stageType or self:getStageType()
	if self:checkStageType(temStageType,GameStageManagerStageType.kMliteStage) then
		return self.m_nextCanBattleStageElite
	end
	return self.m_nextCanBattleStage
end

function This:getNextBattleChapter()
	local chapterId = self:getNextCanBattleStage():getChapterId()
	if self:checkStageType(GameStageManagerStageType.kMliteStage) then
		return self.m_chapterElite[chapterId]
	end
	return self.m_chapter[chapterId]
end

function This:passStage(stageId,starLv)
	local stageType = self:getStageType()
	local stage = self:getStage(stageId,stageType)
	stage:setStarLv(starLv)
	local chapter = self:getChapter(stage:getChapterId(),stageType)
	chapter:updateTotoalStar()
	if self:getNextCanBattleStage(stageType) == stage then
		local nextStage = self:getStage(stageId + 1,stageType)
		if nextStage then
			self:setNextCanBattleStage(nextStage,stageType)
		end
	end
end

function This:clearAllStageDataTimes()
	self:onGetStateInfoRequest()
	-- local function resetStages(stages)
	-- 	for id , stage in pairs(stages) do
	-- 		stage:setChallengeTimes(0)
	-- 		stage:setResetTimes(0)
	-- 	end 
	-- end
	-- resetStages(self:getStages())
	-- resetStages(self:getStages(GameStageManagerStageType.kMliteStage))
end

function This:isCanFreeVisitHero()
	for i , chapter in pairs(self.m_chapter) do
		local price = chapter:getVisitPriceBy()
		local opening = chapter:isPassAllStages()
		if opening and price == 0 then
			return true
		end
	end
	return false
end


function This:onGetStateInfoRequest()
	Socket:sendAndLock(10700, {})
end

function This:onGetStateInfoNotify(msg)
	local function resetChapter(chapterList,stageType)
		for i , info in ipairs(chapterList) do
			local chapter = self:getChapter(info.chapter_id,stageType)
			for i , rewardLv in pairs(info.reward_list) do
				chapter:setStarRewardReceived(rewardLv,true)
			end
			for i , stageInfo in pairs(info.copy_list) do
				local stage = self:getStage(stageInfo.copy_id,stageType)
				stage:setStarLv(stageInfo.star)
				stage:setChallengeTimes(stageInfo.challenge_time)
				stage:setResetTimes(stageInfo.reset_time)
			end
			chapter:onStageLoadFinish()
		end

		local stages = self:getStages(stageType)
		for i, stage in pairs(stages) do
			local preStage = stage:getPreStage()
			if preStage and preStage:getStarLv() <= 0 then
				break
			end
			local nextCanBattleStage = self:getNextCanBattleStage(stageType)
			if not nextCanBattleStage or not preStage then
				self:setNextCanBattleStage(stage,stageType)
			elseif nextCanBattleStage:getId() < stage:getId() then 
				self:setNextCanBattleStage(stage,stageType)
			end
		end

	end
	resetChapter(msg.chapter_list)
	resetChapter(msg.elite_chapter_list,GameStageManagerStageType.kMliteStage)
	for i , uid in ipairs(msg.card_list) do
		if uid > 0 then
			local hero = HeroManager:getHeroByUid(uid)
			if hero then
				self.m_emBattleHeros[i] = hero:getId()
			end
		end
	end

	for _, info in ipairs(msg.cardvisit_list) do
		local chapter = self:getChapter(info.copy_id)
		for i, heroIndex in ipairs(info.visit_index_list) do
			chapter:setVisitHeroState(heroIndex, true)
			if i >= info.times then
				break
			end
		end
	end
	self.m_lastRefreshTime = os.date("*t", msg.last_refresh_time ).yday
	EventDispatcher:dispatcher("stage_star_changed")
end

function This:getEmbattleHero()
	return self.m_emBattleHeros
end

function This:isInEmbattle(heroId)
	for pos , id in pairs(self.m_emBattleHeros) do
		if id == heroId then
			return true
		end
	end
	return false
end

function This:unEmbattleHero(heroId)
	local result = {}
	for pos , id in pairs(self.m_emBattleHeros) do
		if heroId ~= id then
			table.insert(result,{pos = pos, heroId = id})
		end
	end
	self:onEmbattleHerosRequest(result)
end

function This:createHeroForEmbattle()
	local posTable = {}
	local heroTable = {}
	for pos , heroId in pairs(self.m_emBattleHeros) do
		local playerHero = HeroManager:getHero(heroId)
		local hero = Hero:create({
			heroId = heroId,
			level = playerHero:getLevel(),
			starLv = playerHero:getStarLv(),
			quality = playerHero:getQuality(),
			deputy = table.clone(playerHero:getDeputyWithPos())
		})
		posTable[pos] = hero
		heroTable[heroId] = hero
	end
	for heroId , hero in pairs(heroTable) do
		hero:addFetterWithHero(heroTable)
	end
	return posTable
end

function This:getLastRefreshTime()
    return self.m_lastRefreshTime  
end

function This:onBattleSkip(result)
	self:onSkipBattleRequest()
end

function This:onBattleVictory()
	g_scene:openDialog("Stage.StageVictoryPanel",{
		stageId = self.m_battleResult.stageId,
		starLv = self.m_battleResult.starLv,
		dropInfo = self.m_battleResult.item
	})
	BattleDataManager:removeObserver(self)
end

function This:onBattleFailed()
	g_scene:openDialog("Stage.StageFailedPanel")
	BattleDataManager:removeObserver(self)
end

function This:onChallengeStageRequest(stageId)
	local cmd = 10701
	if self:checkStageType(GameStageManagerStageType.kMliteStage) then
		cmd = 10708
	end
	Socket:sendAndLock(cmd,{copy_id = stageId})
	self.m_curStageId = stageId
end

function This:onChallengeStateReply(message)
	if message.err_code == 0 then
		self.m_battleResult = {}
		self.m_battleResult.isWin = message.win
		self.m_battleResult.starLv = message.star
		self.m_battleResult.item = message.item
		BattleDataManager:addObserver(self)
		cc.SceneManager:switchTo("Stage.StageLoadingScene",nil, {stageId = message.copy.copy_id, msg = message})
		EventDispatcher:dispatcher("stage_star_changed")
	else
		g_scene:handleErrorCode(message.err_code)
	end
end

function This:enterStage(stageId, from)
	if next(self.m_emBattleHeros) then
		if type(from) == "table" then
			self.m_from = from
		else
			self.m_from = nil
		end
		self:onChallengeStageRequest(stageId)
	else
		g_scene:showTips(Serialize["add_embattle_hero"])
	end
end

function This:onReceiveStarRewardRequest(chapterId,rewardLv)
	if chapterId and rewardLv then
		local cmd = 10703
		if self:checkStageType(GameStageManagerStageType.kMliteStage) then
			cmd = 10709
		end
		Socket:sendAndLock(cmd,{chapter_id = chapterId,index = rewardLv})
	end
end

function This:onReceiveStarRewardReply(message)
	if message.err_code == 0 then
		local chapter = self:getChapter(message.chapter_id,self:getStageType())
		chapter:setStarRewardReceived(message.index,true)
		g_scene:showReward(message.item_list)
		self:notifyObservers("onStarRewardChanged",message.chapter_id,message.index)
		EventDispatcher:dispatcher("stage_box_changed")
	else
		g_scene:handleErrorCode(message.errorCode)
	end
end

function This:onEmbattleHerosRequest(heros)
	local result = {0,0,0,0,0,0}
	for i , info in pairs(heros) do
		local hero = HeroManager:getHero(info.heroId)
		result[info.pos] = hero:getUid()
	end
	Socket:sendAndLock(10702,{card_list = result})
end

function This:onEmbattleHerosReply(message)
	if message.err_code == 0 then
		self.m_emBattleHeros = {}
		for i , uid in ipairs(message.card_list) do
			if uid > 0 then
				local uhero = HeroManager:getHeroByUid(uid)
				self.m_emBattleHeros[i] = uhero:getId()
			end
		end
		self:notifyObservers("onEmbattleHeros")
	else
		g_scene:showTips(Serialize[message.err_code])
	end
end

function This:onSkipBattleRequest()
    if not self.m_isEnterRobber then
	    Socket:sendAndLock(10704,{})
    end
end

function This:onSkipBattleReply(msg)
    if not self.m_isEnterRobber then
	    if msg.err_code == 0 then
		    if self.m_battleResult.isWin then
			    self:onBattleVictory()
		    else
			    self:onBattleFailed()
		    end
			BattleDataManager:clear()
	    else
		    g_scene:handleErrorCode(msg.err_code)
	    end
    end
end

function This:onVisitHeroRequest( copyId, isLocked )
	local chapter = self:getChapter(copyId)
	if not chapter or not chapter:isPassAllStages() then
		return 
	end

	if isLocked then
		Socket:sendAndLock(10705, { copy_id = copyId })
	else
		Socket:send(10705, { copy_id = copyId })
	end
end

function This:onVisitHeroReply( msg )
	if msg.err_code == 0 then
		local chapter = self:getChapter(msg.copy_id)
		chapter:setVisitHeroState(msg.card_index, true)
		self:notifyObservers("onVisitHero", { copyId = msg.copy_id, heroId = msg.card_id, heroIndex = msg.card_index, time = msg.time })
		EventDispatcher:dispatcher("stage_visit_hero_changed")
	else
		g_scene:handleErrorCode(msg.err_code)
	end
end

function This:setEnterRobber( value )
    self.m_isEnterRobber = value 
end

function This:isEnterRobber()
    return self.m_isEnterRobber
end

function This:onStageSweepRequest(stageId)
	local cmd = 10706
	if self:checkStageType(GameStageManagerStageType.kMliteStage) then
		cmd = 10710
	end
	Socket:sendAndLock(cmd, {stage_id = stageId})
end

function This:onStageSweepReply( msg )
    if msg.err_code == 0 then
    	local stage = self:getStage(msg.stage_id,self:getStageType())
    	if stage then
    		stage:setChallengeTimes(msg.challenge_time)
    	end
		self:notifyObservers("onStageSweep", msg.award_all_list)
    else
        g_scene:handleErrorCode(msg.err_code)
    end
end

function This:onStageResetRequest(stageId)
	local cmd = 10707
	if self:checkStageType(GameStageManagerStageType.kMliteStage) then
		cmd = 10711
	end
	Socket:sendAndLock(cmd, {stage_id = stageId})
end

function This:onStageResetReply( msg )
    if msg.err_code == 0 then
    	local stage = self:getStage(msg.stage_id,self:getStageType())
    	if stage then
    		stage:setChallengeTimes(msg.challenge_time)
    		stage:setResetTimes(msg.reset_time)
    	end
        self:notifyObservers("onStageReset")
    else
        g_scene:handleErrorCode(msg.err_code)
    end
end

function This:getFrom()
	return self.m_from
end

function This:clearFrom()
	self.m_from = nil
end
-----------------------------------------------------------------
