--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"Player.FightResultBasePanel")
local MenuScene = require("Home.MenuScene")
local StageManager = require("Stage.GameStageManager")

function This:initNode(info)
	if info then
		self.m_showStagePanel = info.isRobber or false
		self.m_callBack = info.callback
		self.m_keepScene = info.keepScene
	else
		self.m_showStagePanel = false
	end

	self:setContentSize(cc.visible.width,cc.visible.height)
	self.m_csNode = cc.Node:createFromCSFile("GameScene/NodeUI/Fail.csb")
	self.m_csNode:setPosition(cc.visible.width/2,cc.visible.height/2)
	self:addChild(self.m_csNode)
	self:initAnimation()
	self:initFailedGuide()
end

function This:initTouchEvent()

end

function This:initAnimation()
	self.m_csNode.continue:setScale(0.66)
	local seqence1 = cc.Sequence(cc.FadeTo(0.4,64),cc.FadeTo(0.4,255))
	local seqence2 = cc.Sequence(cc.ScaleTo(0.4,0.68),cc.ScaleTo(0.4,0.66))
	self.m_csNode.continue:runAction(cc.RepeatForever(cc.Spawn(seqence1,seqence2)))
end

function This:onEnter()
	super.onEnter(self)
	cc.Audio:playEffect("Lose.mp3")
end

function This:onExit()
	StageManager:clearFrom()
	super.onExit(self)
end

function This:onTouchMask()
	if self.m_keepScene then
		self:close()
		return
	end
	local from = StageManager:getFrom()
	if from then
		cc.SceneManager:switchTo("Home.MenuScene", function ( ... )
			from.recoverUI()
		end)
		return
	end

	if not self.m_showStagePanel then
		cc.SceneManager:switchTo("Home.MenuScene")
		MenuScene:addDelayDialog({name = "Stage.StagePanel", arg = { lastchapter = true }})
	else
		cc.SceneManager:switchTo("Home.MenuScene", self.m_callBack)
	end
end

function This:getJumpToTargetScene()
	return "MenuScene"
end

function This:getSwitchSceneCallback()
	return self.m_callBack
end

--endregion
