--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"cc.Node")
local HeroManager = require("Hero.HeroManager")

function This:init(heroId, info, csbFile)
	self.m_heroId = heroId
	self.m_hp = info.hp or 0
	self.m_maxHp = info.maxHp or 0

    if csbFile then
        self.m_csNode = cc.Node:createFromCSFile(csbFile)
    else
        self.m_csNode = cc.Node:createFromCSFile("GameScene/NodeUI/LineUpHeroItem.csb")
    end

	local w , h = self.m_csNode.quality:getContentSize()
	local scale = self.m_csNode.quality:getScale()
	self:setContentSize(w * scale,h * scale)
	self:addChild(self.m_csNode)
	self:setCascadeOpacityEnabled(true)

	self.m_csNode.cancel:setVisible(false)
	self:refreshAttr()
end

function This:refreshAttr()
	local hero = self:getHeroInfo()
	local country = hero:getCountry()
	local quality = hero:getQuality()
	self.m_csNode.country:setString(CountryName[hero:getCountry()])
	local color = SmallCardQualityColor[quality]
	self.m_csNode.country:setColor(color.r , color.g, color.b)

	self.m_csNode.name:setString(hero:getName(), AppText:isChinese() and 10 or nil)
	self.m_csNode.level:setString(hero:getLevel())
	self.m_csNode.qualitybg:setImage(QualityBgFile[quality])
	self.m_csNode.icon:setImage(hero:getIcon())
	self.m_csNode.quality:setImage(QualityFrameFile[quality])
    local hpbg = self.m_csNode.hpbg
    if hpbg then
        hpbg:setImage(QualityFightPowerFrameFile[quality])
    end
	
	for i= 1, 5 do
		self.m_csNode["star"..i]:setVisible(hero:getStarLv() >= i)
	end

    local fightPower = self.m_csNode.fightPower
    if fightPower then
        fightPower:setString(string.format("%d",hero:getFightPower()))
    end

    local ability = self.m_csNode.ability
    if ability then
        ability:setString(string.format("%d",hero:getFightPower()))
    end

    if self.m_maxHp > 0 then
		self.m_csNode.hp:setString(string.format("%d/%d",self.m_hp,self.m_maxHp))
		self.m_csNode.hpbar:setPercent(self.m_hp / self.m_maxHp * 100)
	else
		self.m_csNode.hp:setString(string.format("%d",self.m_hp))
		self.m_csNode.hpbar:setPercent(100)
	end
	self:refreshAwak(self.m_csNode)
end

function This:refreshAwak(node)
	local hero = HeroManager:getHero(self.m_heroId)
	local heroEffect = false
	if hero:isAwaken() then
		node.xingdian:setVisible(true)
		local curentLv = hero:getAwakeLevel()
		if curentLv==0 then
			node.xingdian.light:setVisible(false)
		else
			node.xingdian.light:setVisible(true)
			for i=1,AwakdValue.ParagraphLimit do
				local item = node.xingdian.light["dian"..i]
				item:setVisible(curentLv>=i)
			end
		end
		heroEffect = hero:isAwakeFull()
	else
		node.xingdian:setVisible(false)
	end

	self:createWeakEffect( node.quality, heroEffect )
end

function This:createWeakEffect( node,isAdd,heroBg )
	local function createAnim( parent,anmStr )
        local GameUtil = require("Util.GameUtil")
        local effect1 = GameUtil:createEffect(anmStr, true)
        local scale =0.564
        effect1:setScale(scale)
        local x = 56
        local y = 54
        effect1:setPosition(x,y)
        print("xy",x,"  ",y,"scale",scale)
        parent:addChild(effect1)
        return effect1
    end
    local effectName = "JueXing5"
    node:removeAllChildren()
    if isAdd then
    	local effect = createAnim( node,effectName )
    end
end

function This:getHeroInfo()
    return HeroManager:getHero(self.m_heroId)
end

function This:getHeroId()
	return self.m_heroId
end

function This:setModel(hero)
	if hero._NAME == "Troop" then
		local troop = hero
		if self.m_heroId ~= troop:getHeroId() then
			self.m_heroId = troop:getHeroId()
			self.m_hp = troop:getHp()
			self.m_maxHp = troop:getMaxHp()
			self:refreshAttr()
		end
	elseif hero._NAME == "Hero" then
		if self.m_heroId ~= hero:getId() then
			self.m_heroId = hero:getId()
			self.m_maxHp = hero:getAttr(AttrType.kMaxHp)
			self.m_hp = self.m_maxHp
			self:refreshAttr()
		end
	end
end

function This:setCancelHandler(handler,isContainer)
	self.m_csNode.cancel:setVisible(true)
	self.m_csNode.cancel:setTouch({
		isContainer = isContainer or false,
		onEnded = function()
			handler(self.m_heroId)
		end
	})
end

function This:setSelectHandler(handler,isContainer)
	self:setTouch({
		isContainer = isContainer or false,
		isDynamic = true,
		isSwallow = false,
		isScale = false,
		sizeNode = self.m_csNode.qualitybg,
		onEnded = function()
			handler(self.m_heroId)
		end
	})
end

--endregion
