--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"LoadingScene")
local StageConfig = require("Metadatas.StageConfig")
local HeroManager = require("Hero.HeroManager")
local GamePlayer = require("Player.GamePlayer")
local GameStageManager = require("Stage.GameStageManager")
local HeroNpcConfig = require("Metadatas.HeroNpcConfig")
local EventDispatcher = require("EventDispatcher")
local Socket = require("Net.Socket")
local BattleDataManager = require("Battle.BattleDataManager")
local AsynchEvent = require("Event.AsynchEvent")
local GameEvent = require("Event.GameEvent")
local GameUtil = require("Util.GameUtil")

local ResultDesp = 
{
	[1] = Serialize[64328],
	[2] = Serialize[64329],
	[3] = Serialize[64330],
	[4] = Serialize[64331]
}

function This:init(info)
	super.init(self)
	self.m_stageId = info.stageId
	self.m_msg = info.msg
	self.m_battleReport = info.msg.report
	print(string.format("ID为%s的战斗结果:%s",GameUtil:int64ToString(self.m_battleReport.id),ResultDesp[self.m_battleReport.state]))
	self.m_attackerHeroAttrList = info.msg.attack_list or {}
	self.m_defenderHeroAttrList = info.msg.defence_list or {}
	self:initTask()
end

function This:initTask()
	self:addParseBattleDataTask()
	self:addBattlePrepareTask()
end

function This:addParseBattleDataTask()
	local task2 = GameEvent:create(function()
		BattleDataManager:setAttackerInfo(self.m_battleReport.attack)
	end)
	self:addTask(task2)

	local task3 = GameEvent:create(function()
		BattleDataManager:setDefenderInfo(self.m_battleReport.defence)
	end)
	self:addTask(task3)

	local task4 = GameEvent:create(function()
		for i, info in ipairs(self.m_battleReport.attack.card_list) do
			BattleDataManager:addAttackerHero(info)
		end
	end)
	self:addTask(task4)

	local task5 = GameEvent:create(function()
		for i, info in ipairs(self.m_battleReport.defence.card_list) do
			BattleDataManager:addDefenderHero(info)
		end
	end)
	self:addTask(task5)

	local task10 = GameEvent:create(function()
		BattleDataManager:setBattleId(self.m_battleReport.id)
		BattleDataManager:setBattleResult(self.m_battleReport.state)
		BattleDataManager:setStartTime(self.m_battleReport.start_time)
		BattleDataManager:setEndTime(self.m_battleReport.end_time)
		BattleDataManager:setCityId(self.m_battleReport.city_id)
	end)
	self:addTask(task10)

	local task6 = GameEvent:create(function()
		for i , data in ipairs(self.m_battleReport.fight) do
			BattleDataManager:addRoundData(data.round,data.action_list)
		end
	end)
	self:addTask(task6)

	local task7 = GameEvent:create(function()
		for i , info in ipairs(self.m_attackerHeroAttrList) do
			BattleDataManager:setAttackerHeroAttrList(info.pos,info.index_list,info.value_list)
		end
	end)
	self:addTask(task7)

	local task8 = GameEvent:create(function()
		for i , info in ipairs(self.m_defenderHeroAttrList) do
			BattleDataManager:setDefenderHeroAttrList(info.pos,info.index_list,info.value_list)
		end
	end)
	self:addTask(task8)

	local task9 = GameEvent:create(function()
		if #self.m_battleReport.prepare > 0 then
			for i , data in ipairs(self.m_battleReport.prepare) do
				BattleDataManager:addRoundData(data.round,data.action_list)
			end
		end
	end)
	self:addTask(task9)

	local task10 = GameEvent:create(function()
		local fileName = "Fonts/Skill.fnt"
		lib2d.ccFontCache.addFNT(fileName)
	end)
	self:addTask(task10)
end

function This:addBattlePrepareTask()
	local task10 = GameEvent:create(function()
		BattleDataManager:prepareBattle(false,PlayMode.kStage,StageConfig[self.m_stageId].bgId)
	end)
	self:addTask(task10)
end

function This:loadFinish()
	cc.SceneManager:switchTo("Battle.BattleTestSceneView",function()
		BattleDataManager:startBattle()
	end)
end

--endregion
