--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"Dialog")

local StageManager = require("Stage.GameStageManager")
local ChapterConfig = require("Metadatas.StageChapterConfig")
local StageEliteBoxConfig   = require("Metadatas.StageEliteBoxConfig")
local LoadingScene = require("LoadingScene")
local Serialize = require("Serialize.Serialize")
local GamePlayer = require("Player.GamePlayer")
local GameUtil = require("Util.GameUtil")
local ArgConfig = require("Metadatas.ArgConfig")
local DailyAchieveManager = require("Achieve.DailyAchieveManager")

local TerrTabGroupBehaviour = require("Territory.TerrTabGroupBehaviour")
local TabNames = {
	kCopyStage = GameStageManagerStageType.kCopyStage,
	kMliteStage = GameStageManagerStageType.kMliteStage,
}
function This:initNode(info)
	self.m_csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/StoryStageMain.csb")
	self.m_csNode:setPosition(cc.visible.center.x,cc.visible.center.y)
	self.m_boxEffect={}

	self.m_title = self.m_csNode.title.text
	self.m_closeBtn = self.m_csNode.closedi

	self:addChild(self.m_csNode)
	self.m_csNode:setToCenter()

	self.m_leftBtn = self.m_csNode.left
	self.m_rightBtn = self.m_csNode.right
	self.m_pageView = self.m_csNode.PageView
	self.m_chapter = nil
	self.m_inited = false
	local function initPageView(index,chapter)
		if self.m_inited then
			StageManager:setStageType(index)
			self.m_selectTabName = index
			local temChapter = chapter or StageManager:getNextBattleChapter()
			self.m_chapter = temChapter
			self.m_pageNodes = {}
			self.m_pageView:removeAllPages()
			local chapters = self:getChapters()
			for i , chapter in ipairs(chapters) do
				local preChapter = chapter:getPreChapter()
				if preChapter and not preChapter:isPassAllStages() then
					break
				end
				local node = cc.Widget:create()
				node:setAnchorPoint(0, 0)
				self.m_pageView:addPage(node)
				self.m_pageNodes[i - 1] = {}
				self.m_pageNodes[i - 1].isInit = false
				self.m_pageNodes[i - 1].node = node
			end
			self.m_csNode.visitNode:setVisible(TabNames.kCopyStage==index)

			local index = self.m_chapter:getId()-1
			local count = self.m_pageView:getPageCount()
			if index > count then
				index = count
			end
			self:focusePageOnIndex(self.m_chapter:getId()-1)
			self.m_csNode.vigor:setString(string.format("%d/%d",GamePlayer:getPower(),kMaxPower))
			self:refreshVisitNode()
		end
	end
	local function refreshGroup(index)
		print(index)
		initPageView(index,selectStageType)
	end
	local group = TerrTabGroupBehaviour:create(param)
	for index=1,TabNames.kMliteStage do
		local node = self.m_csNode["tab" .. index]
		group:addTabButton(index, node, function ()
			if index==TabNames.kMliteStage then
				local crusadeData =DailyAchieveManager:getCrusadeData()
				local openDayLimit = crusadeData:getCrusadeConfigNum("hero_refinementConfig_open_days")
				local lvLimit = crusadeData:getCrusadeConfigNum("hero_refinementConfig_open_level")
				local openDay = GamePlayer:getOpenServerDays()
				local lv = GamePlayer:getLevel()
				if openDayLimit>openDay or lvLimit>lv then
					g_scene:showTips(string.format(Serialize["Stage_StagePanel_1"],openDayLimit,lvLimit))
					return false
				end
			end
	    	refreshGroup(index)
	    end, false)
	end
	self.m_tabGroup = group
	local selectStageType = StageManager:getStageType()
	self.m_selectTabName = selectStageType
	group:selectTabButton(selectStageType)

	local chapter 
	if info and info.lastchapter then
		chapter = StageManager:getLastChapter()
	else
		self:refreshStageDataTimes()
	end
	self.m_inited = true
	initPageView(selectStageType,chapter)
	-- print("next chapter id = " .. self.m_chapter:getId())
--	StageManager:onGetStateInfoRequest()
end

function This:onEnter()
	super.onEnter(self)
	StageManager:addObserver(self)
	GamePlayer:addObserver(self)
end

function This:onExit()
	super.onExit(self)
	StageManager:removeObserver(self)
	GamePlayer:removeObserver(self)
end

function This:initTouchEvent()
	self.m_closeBtn:setTouchEnded(function ()
		self:close()
	end)
	self.m_rightBtn:setTouchEnded(function()
		self:onNextChapter()
	end)
	self.m_leftBtn:setTouchEnded(function()
		self:onPreChaper()
	end)
	self.m_pageView:addEventListener(function (eventType)
		local index = self.m_pageView:getCurrentPageIndex()
		self:focusePageOnIndex(index)
	end)

	self.m_csNode.buyvigorbutton:setTouchEnded(function()
		g_scene:handleErrorCode("powerLack", {notips=true})
	end)

	self.m_csNode.visitNode.touxiangbg:setTouchEnded(function()
        g_scene:openDialog("Stage.StageVisitHeroPanel", self.m_chapter)
	end)
end

function This:refreshStageDataTimes()
    local record = StageManager:getLastRefreshTime()
    local nowTime = os.date("*t", GamePlayer:getServerTime()).yday
    if nowTime ~= record then
    	StageManager:clearAllStageDataTimes()
    end
end

function This:refreshVisitNode( )
	local tabName = self:getSelectTabName()
	if tabName== TabNames.kMliteStage then
		if self.m_visitNodeEffect then
			self.m_visitNodeEffect:removeFromParent()
			self.m_visitNodeEffect = nil
		end
		return
	end
	local curNotAllPass, preHaveNotVisited = not self.m_chapter:isPassAllStages() and self.m_chapter:hasVisitHeroList(), false
	local preChapter = self.m_chapter:getPreChapter()
	if preChapter and preChapter:isPassAllStages()  then
		preHaveNotVisited = preChapter:preHaveNotVisited()
	end

	local strArr = { Serialize[64333] .. self.m_chapter:getTitle() .. Serialize[64334], Serialize[64335]}
	if curNotAllPass and not preHaveNotVisited then
		self.m_csNode.visitNode.word:setString(strArr[1])
	elseif not curNotAllPass and preHaveNotVisited then
		self.m_csNode.visitNode.word:setString(strArr[2])
	elseif not curNotAllPass and not preHaveNotVisited then
		self.m_csNode.visitNode.word:setVisible(false)
		self.m_csNode.visitNode.duihuakuang:setVisible(false)
	else
		local v, value = math.random(0,2), 1
	    if v < 1 then
	        value = 1
	    end
	    if v > 1 then
	        value = 2
	    end
		self.m_csNode.visitNode.word:setString(strArr[value])
	end

	self.m_csNode.visitNode.word:runAction(cc.Sequence(cc.DelayTime(2), cc.FadeOut(3), cc.Hide(), cc.CallFunc(function ()
		self.m_csNode.visitNode.word:setVisible(false)
    end)))
	self.m_csNode.visitNode.duihuakuang:runAction(cc.Sequence(cc.DelayTime(2), cc.FadeOut(3), cc.Hide(), cc.CallFunc(function ()
		self.m_csNode.visitNode.duihuakuang:setVisible(false)
    end)))

    self:refreshVisitEffect()
end

function This:refreshVisitEffect()
	local showEff = StageManager:isCanFreeVisitHero()
	if showEff then
		if not self.m_visitNodeEffect then
			local icon = self.m_csNode.visitNode.touxiangbg
			self.m_visitNodeEffect = GameUtil:createEffect("TiXing", true, icon)
			icon:addChild(self.m_visitNodeEffect)
		end
	else
		if self.m_visitNodeEffect then
			self.m_visitNodeEffect:removeFromParent()
			self.m_visitNodeEffect = nil
		end
	end
end

function This:checkPage(index)
	local count = self.m_pageView:getPageCount()
	local minIndex = index - 1 < 0 and 0 or index - 1
	local maxIndex = index + 1 >= count and count - 1 or index + 1

	for i = minIndex , maxIndex do
		if not self.m_pageNodes[i].isInit then
			local chapter = self:getChapter(i + 1)
			local node = cc.Node:createFromCSFile("MenuScene/NodeUI/StageContent.csb")
			local page = self.m_pageView:getPage(i)
			page:addChild(node)
			node:setName("pageNode"..i)
			node:setPositionY(self.m_pageView:getContentHeight())
			node.lock.mask:setTouch({
				isContainer = true,
				isSwallow = true,
				onEnded = function ()
					g_scene:showTips(chapter:getLockStr())
				end,
		        isAlpha = false,
				isScale = false,
			})
			self:refreshChapterInfo(chapter,node)
			self:refreshStageInfo(chapter,node)
			self:initStageNodeEvent(chapter,node)

			self.m_pageNodes[i].node = node
			self.m_pageNodes[i].isInit = true
		end
	end 	
end

function This:focusePageOnIndex(index)
	self:checkPage(index)
	self.m_chapter = self:getChapter(index + 1)
	self.m_page = self.m_pageNodes[index].node
	self.m_pageView:setCurrentPageIndex(index)
	self:refreshChapterInfo(self.m_chapter,self.m_page)
	self:refreshDirBtn()
end

local BoxImage = 
{
	[1] = {
		"MenuScene/boxLock1.png",
		"MenuScene/boxGet1.png",
	},
	[2] = {
		"MenuScene/boxLock2.png",
		"MenuScene/boxGet2.png",
	},
	[3] = {
		"MenuScene/boxLock3.png",
		"MenuScene/boxGet3.png",
	}
}

function This:refreshChapterInfo(chapter , page)
	self.m_csNode.title.text:setString(chapter:getTitle())
	self.m_csNode.chaptername:setString(chapter:getName(), 5)
	page.lock:setVisible(chapter:isLock())
	local maxStar = chapter:getMaxStar()
	local totalStar = chapter:getTotalStar()
	page.processBG.star.test:setString(totalStar.."/"..maxStar)

	local chapterConfigs = self:getChapterConfig()
	local config = chapterConfigs[chapter:getId()]
	for i = RewardLevel.kFirstStarLv , RewardLevel.kThirdStarLv do
		page.processBG["star"..i].test:setString(tostring(config.reward_starlv[i]))
		local boxImage = page.processBG["box"..i]
		local hasEff = false
		if chapter:starIsEnough(i) then
			boxImage:setImage(BoxImage[i][2])
			if chapter:isStarRewardReceived(i) then
				boxImage:setGrayShader()
			else
				hasEff = true
			end
		else
			boxImage:setImage(BoxImage[i][1])
		end

		if hasEff then
			if not boxImage.effect then
				local w ,h = boxImage:getContentSize()
				local effect1 = GameUtil:createEffect("BoxLing",true)
				effect1:setPosition(w/2, h/2)
				boxImage:addChild(effect1, -1)
				local effect2 = GameUtil:createEffect("BoxLing2",true)
				boxImage:addChild(effect2, -1)
				effect2:setPosition(w/2,h)
				boxImage.effect = {effect1,effect2}
			end
		else
			if boxImage.effect then
				for _ , effect in ipairs(boxImage.effect) do
					effect:removeFromParent()
				end
				boxImage.effect = nil
			end
		end
	end
	page.processBG.bar:setPercent(totalStar / maxStar * 100)
end

function This:refreshStageInfo(chapter , page)
	local stages = chapter:getStages()
	for i = 1 , #stages do
		local stage = stages[i]
		local stageNode = page["stage"..i]
		stageNode.title:setString(stage:getName(), 5)
		stageNode.stage:setString("" .. stage:getChapterNumber() .. "-" .. tostring(i))
		stageNode.lock:setVisible(stage:isLock())
		local starLv = stage:getStarLv()
		stageNode.star11:setVisible(starLv >= 1)
		stageNode.star12:setVisible(starLv >= 2)
		stageNode.star13:setVisible(starLv >= 3)
		stageNode.tongguan:setVisible(starLv >= 3)
		stageNode.starnum:setString(starLv)
		stageNode.selet:setVisible(true)
	end
end

function This:refreshStageStar(stageId)
	local stages = self.m_chapter:getStages()
	for i , stage in pairs(stages) do
		if stage:getId() == stageId then
			local stageNode = self.m_page["stage"..i]
			local starLv = stage:getStarLv()
			stageNode.star11:setVisible(starLv >= 1)
			stageNode.star12:setVisible(starLv >= 2)
			stageNode.star13:setVisible(starLv >= 3)
			break
		end
	end
	self:refreshChapterInfo(self.m_chapter,self.m_page)
end

function This:initStageNodeEvent(chapter,page)
	local stages = chapter:getStages()
	for i , stage in ipairs(stages) do
		local stageNode = page["stage"..i]
		stageNode.selet:setTouch({
			isContainer = true,
            getRect = function (touch)
                local rect = touch.sizeNode:getBoundingBox()
                rect.x = rect.x + rect.width * 0.15
                rect.width = rect.width * 0.7
                return rect
            end,
			onEnded = function ()
				self:onStageNodeClicked(stage,stageNode)
			end,
			isScale = false,
		})
	end
	local id = chapter:getId()
	for i = RewardLevel.kFirstStarLv , RewardLevel.kThirdStarLv do
		local boxNode = page.processBG["box"..i]
		boxNode:setTouch({
			isContainer = true,
			onEnded = function ()
				g_scene:openDialog("Stage.StarBoxPreview",{chapterId = id, rewardLv = i,chapterConfigs = self:getChapterConfig()})
				if chapter:isStarRewardReceived(i) then
					g_scene:showTips(Serialize["reward_have_recieved"])
				end
			end,
		})
	end
end

function This:refreshDirBtn()
	if self.m_chapter:getPreChapter() then
		self.m_csNode.left:setVisible(true)
	else
		self.m_csNode.left:setVisible(false)
	end
	if self.m_chapter:getNexChapter() then
		self.m_csNode.right:setVisible(true)
	else
		self.m_csNode.right:setVisible(false)
	end
end

function This:getSelectTabName()
	return self.m_selectTabName
end

function This:getChapters()
	local tabName = self:getSelectTabName()
	return StageManager:getChapters(tabName)
end

function This:getChapter(chapterId)
	local tabName = self:getSelectTabName()
	return StageManager:getChapter(chapterId,tabName)
end

function This:getChapterConfig()
	local tabName = self:getSelectTabName()
	if tabName == TabNames.kMliteStage then
		return StageEliteBoxConfig
	end
	return ChapterConfig
end

function This:onPreChaper()
	local index = self.m_pageView:getCurrentPageIndex()
	if index > 0 then
		self.m_pageView:scrollToPage(index - 1)
	end
end

function This:onNextChapter()
	if not self.m_chapter:isPassAllStages() then
		g_scene:showTips(Serialize["please_clear_chapter"])
		return
	end
	local index = self.m_pageView:getCurrentPageIndex()
	self:setTimer(0, function (self) 
		self.m_pageView:scrollToPage(index + 1)
	end)
end

function This:onStageNodeClicked(stage,stageNode)
	if stage:isLock() then
		g_scene:showTips(stage:getLockStr())
	else
		self:openDialog("Stage.StageConfirmPanel",stage)
		StageManager:setLastChapter(self.m_chapter)
	end
end

function This:onStarRewardChanged(chapterId,rewardLv)
	if self.m_chapter:getId() == chapterId then
		self:refreshChapterInfo(self.m_chapter,self.m_page)
	end
end

function This:onStageStarCountChanged(stageId,stageCount)
	self:refreshStageInfo(self.m_chapter,self.m_page)
	self:refreshChapterInfo(self.m_chapter,self.m_page)
end

function This:onVisitHero()
	self:setTimer(0.3, function (self) 
		self:refreshVisitEffect()
	end)
end

function This:onPlayerAttrChanged(field,oldValue,value)
	if field == PlayerAttr.power then
		self.m_csNode.vigor:setString(string.format("%d/%d",GamePlayer:getPower(), kMaxPower))
	end
end

function This:onDayPassed()
	StageManager:clearAllStageDataTimes()
end


--endregion
