--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This, super = class(...,"Dialog")
local StageHeroItemView = require("Stage.StageHeroItemView")
local HeroManager = require("Hero.HeroManager")
local UpdateLayer = require("UI.UpdateLayer")

function This:initNode(info)
	self.m_haveSelectHeros = info.haveSelected or {}
	self.m_csNode = cc.Node:createFromCSFile("GameScene/NodeUI/LineUpChoose.csb")
	self:addChild(self.m_csNode)
	self.m_csNode:setToCenter()
	self.m_excludeRedHero = info.excludeRedHero
	self.m_selectHandler = nil
	local heros = self:getHeroList()

	self.m_listLayer = UpdateLayer:create({
		itemWidth = 116,
		itemHeight = 164,
		column = 5,
		scrollView = self.m_csNode.CardScrollView
	})

	self.m_listLayer:setDataList(heros,function(troop)
		local view = self:getHeroView(troop)
		view:setSelectHandler(function(id)
			if self.m_selectHandler then
				self.m_selectHandler(id)
			end
			self:close()
		end)
		return view
	end)

	self.m_listLayer:setCascadeOpacityEnabled(true)
	self.m_listLayer:setAnchorPoint(0.5,0)
	local w , h = self.m_listLayer:getContentSize()
	self.m_csNode.CardScrollView:pushBackCustomItem(self.m_listLayer, w,h,0)
end

function This:getHeroView(hero)
	local maxHp = hero:getAttr(AttrType.kMaxHp)
	local node = StageHeroItemView:create(hero:getId(),{
		maxHp = maxHp,
		hp = maxHp,
	})
	return node
end

function This:getHeroList()
	local heros = HeroManager:getAllHeroGotWithSort(function(hero) 
			if self.m_haveSelectHeros[hero:getId()] then
				return false
			end 

			if hero:isDeputy() then
				return false
			end
			if self.m_excludeRedHero then
				return not hero:isRed()
			end
			return true
		end
	)
	return heros
end

function This:initTouchEvent()
	local csNode = self.m_csNode
	local closeBtn = csNode.closebutton or csNode.close
	if closeBtn then
		closeBtn:setTouchEnded(function()
			self:close()
		end)
	end
end

function This:setSelectHandler(handler)
	self.m_selectHandler = handler
end



--endregion
