-- @Author: superm
-- @Date:   2017-10-12 17:40:35
-- @Last Modified by:   superm
-- @Last Modified time: 2017-10-20 11:06:54

local This , super = class(..., "NodeView")
This.fileName = "MenuScene/NodeUI/StageSweepSettlementItem.csb"
local ItemNode = require("UI.ItemNode")

function This:initData(items, index)
    self.m_items = items
    self.m_index = index
    local w , h = self.bg:getContentSize()
    self:setContentSize(w,h)
end

function This:initNode()
	self.title:setString(Serialize[60247] .. self.m_index .. Serialize[64338])
    self:refreshItemUI()
end

function This:refreshItemUI()
	local count = #self.m_items
    local initX = -190
    local scale = count > 4 and 4 / count or 1
	for i, item in ipairs(self.m_items) do
        local node = ItemNode:create(item.id, item.num)
        node:setScale(scale)
        node:setPosition(initX, -55)
        self:addChild(node)
        initX = initX + node:getContentWidth()* scale  + 10 * scale
    end
end