--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"Dialog")
local StageManager = require("Stage.GameStageManager")
local ItemNode = require("UI.ItemNode")
local MenuScene = require("Home.MenuScene")

function This:initNode(info)
	self.m_keepScene = info.keepScene
	self.m_stageId = info.stageId or 0
	self.m_starLv = info.starLv or 0
	self.m_drops = info.dropInfo or {}
	self.m_hasShowPanel = not info.isRobber
	self.m_callBack = info.callback
	self:setContentSize(cc.visible.width,cc.visible.height)

	self.m_csNode = cc.Node:createFromCSFile("GameScene/NodeUI/Win.csb")
	self.m_csNode:setPosition(cc.visible.width/2,cc.visible.height/2)
	self:addChild(self.m_csNode)

	self.m_csNode.starList:setVisible(self.m_hasShowPanel)
	if self.m_hasShowPanel then
		self.m_csNode.starList.star1:setVisible(self.m_starLv >= 1)
		self.m_csNode.starList.star2:setVisible(self.m_starLv >= 2)
		self.m_csNode.starList.star3:setVisible(self.m_starLv >= 3)
	else
		self.m_csNode.ustar1:setVisible(self.m_hasShowPanel)
		self.m_csNode.ustar2:setVisible(self.m_hasShowPanel)
		self.m_csNode.ustar3:setVisible(self.m_hasShowPanel)
	end
	self:initItmes()
	self:initAnimation()
end

function This:initItmes()
	local initX = 0
	for i , info in pairs(self.m_drops) do
		local node = self:getItemNode(info.id or info[1], info.num or info[2])
		node:setPositionX(initX)
		self.m_csNode.reward:addChild(node)
		initX = initX + node:getContentWidth() + 10
	end
end

function This:initAnimation()
	self.m_csNode.continue:setScale(0.66)
	local seqence1 = cc.Sequence(cc.FadeTo(0.4,64),cc.FadeTo(0.4,255))
	local seqence2 = cc.Sequence(cc.ScaleTo(0.4,0.68),cc.ScaleTo(0.4,0.66))
	self.m_csNode.continue:runAction(cc.RepeatForever(cc.Spawn(seqence1,seqence2)))
end

function This:onEnter()
	super.onEnter(self)
	cc.Audio:playEffect("Win.mp3")
end

function This:onExit()
	StageManager:clearFrom()
	super.onExit(self)
end

function This:getItemNode(itemId,itemNum)
	local node = ItemNode:create(itemId,itemNum)
	node:setCascadeOpacityEnabled(true)
	node:setAnchorPoint(0.5,0.5)
	return node
end

function This:initTouchEvent()
	
end

function This:onTouchMask()
	if self.m_keepScene then
		self:close()
		return
	end
	local from = StageManager:getFrom()
	if from then
		cc.SceneManager:switchTo("Home.MenuScene", function ( ... )
			from.recoverUI()
		end)
		return
	end

	if self.m_hasShowPanel then
		cc.SceneManager:switchTo("Home.MenuScene")
		MenuScene:addDelayDialog({name = "Stage.StagePanel", arg = { lastchapter = true }})
	else
		cc.SceneManager:switchTo("Home.MenuScene", self.m_callBack)
	end
end

--endregion
