-- @Author: Su
-- @Date:   2019-10-19 16:24:00
-- @Last Modified by:   zheng
-- @Last Modified time: 2020-07-03 17:49:19
-- @File Name: CompetitionShopItemView.lua
-- @Desc: 
local This , super = class(...,"PeakContest.PeakContestShopItemView")
local DepotManager = require("Depot.DepotManager")
local ItemUtil = require("Bag.ItemUtil")
local ItemNode = require("UI.ItemNode")
local GameUtil = require("Util.GameUtil")
local StoreManager = require("Store.StoreManager")
local CompetitionShopConfig = require("Metadatas.CompetitionShopConfig")

This.fileName = "MenuScene/NodeUI/FamilyStoreItem.csb"

function This:initTouchEvent()
	self.unlock.buybutton:setTouch({
	    onEnded = function()
			if self.m_itemData.buy_times ~= 0 and self.m_itemData.buy_times - self.data.buy_times <= 0 and self.m_itemData.buy_times ~= -1 then 
				g_scene:showTips(Serialize[11517])
				return 
			end

			local count = DepotManager:getItemOrResCount(self.m_itemData.price_id)
			local str = string.format( Serialize[63965],ItemUtil.getName(self.m_itemData.item_id))
			if count < self.m_itemData.price_num then 
				local name = ItemUtil.getName(self.m_itemData.price_id)
				g_scene:showTips(name..Serialize[60715])
				return 
			end	
			if self.m_itemData.price_id == 102 then
				local panel = g_scene:openDialog("UI.CostConfirmPanel", {
					cost = self.m_itemData.price_num,
					desc = str, 
					okHandler = function(build)
						StoreManager:onBuyJinLianJifenStoreItemRequest(self.data.trench)
					end } )
			else
				StoreManager:onBuyJinLianJifenStoreItemRequest(self.data.trench)
			end
	    end,
	    isScale = false,
	    isDynamic = true,
		isContainer = true,
	})
end

function This:refresh()
	self.name:setString(ItemUtil.getName(self.m_itemData.item_id))
  	self.name:setColorByID("Q".. ItemUtil.getQuality(self.m_itemData.item_id))
	self.unlock.price:setString(self.m_itemData.price_num or 0)
	self.unlock.yuanbao:setImage(ItemUtil.getIconImage(self.m_itemData.price_id))

    if self.m_itemData.discount == 10 then
        self.unlock.bg5:setVisible(false)
        self.unlock.discount:setVisible(false)
    else
        self.unlock.bg5:setVisible(true)
        self.unlock.discount:setVisible(true)
         self.unlock.discount:setString(string.format(Serialize[61082],self.m_itemData.discount))
    end

	if not self.itemNode then 
		self.itemNode = ItemNode:create(self.m_itemData.item_id,self.m_itemData.item_num)
		self.itemNode:setAnchorPoint(0.5,0.5)
		self.unlock.item:addChild(self.itemNode)
	else
		self.itemNode:initItem(self.m_itemData.item_id,self.m_itemData.item_num)
	end

  

	-- if self.m_type == PeakContestShopType.Honor then 
	-- 	local rank = PeakContestManager:getMyMaxRank()
	-- 	if rank <= self.m_itemData.need and rank~= 0 then 
	-- 		self.unlock.buyTimes:setVisible(self.m_itemData.buy_times ~= 0)
    --         self.unlock.buyTimes:setVisible(self.m_itemData.buy_times - self.data.buy_times ~= 0)
	-- 		self.unlock.buyTimes:setString(string.format("限购(%d/%d)",self.m_itemData.buy_times - self.data.buy_times , self.m_itemData.buy_times))
    --         if self.m_itemData.buy_times ~= 0 and self.m_itemData.buy_times == self.data.buy_times then 
	-- 	        self.unlock.purchased:setVisible(true)
	-- 	        self.unlock.buybutton:setVisible(false)
	--         else
	-- 	        self.unlock.purchased:setVisible(false)
	-- 	        self.unlock.buybutton:setVisible(true)
	--         end
	-- 	else
	-- 		self.unlock.buyTimes:setStringWithColor(string.format("<Peak1>%s",self.m_itemData.text))
	-- 	    self.unlock.buybutton:setVisible(false)
    --         self.unlock.purchased:setVisible(false)
    --     end
	-- elseif self.m_type == PeakContestShopType.Peak then 
		self.unlock.buyTimes:setVisible(self.m_itemData.buy_times ~= 0)
        self.unlock.buyTimes:setVisible(self.m_itemData.buy_times - self.data.buy_times ~= 0 and self.m_itemData.buy_times ~= -1 )
		self.unlock.buyTimes:setString(string.format(Serialize[61081],self.m_itemData.buy_times - self.data.buy_times , self.m_itemData.buy_times))
		self.unlock.discount:setString(self.m_itemData.discount .. Serialize[62254])
		self.unlock.discount:setVisible(self.m_itemData.discount ~= 10)
		self.unlock.bg5:setVisible(self.m_itemData.discount ~= 10)
        if self.m_itemData.buy_times ~= 0 and self.m_itemData.buy_times == self.data.buy_times then 
		    self.unlock.purchased:setVisible(true)
		    self.unlock.buybutton:setVisible(false)
	    else
		    self.unlock.purchased:setVisible(false)
		    self.unlock.buybutton:setVisible(true)
	    end
	-- end

 

end

function This:setData(data)
	self.data = data
    self.m_itemData = CompetitionShopConfig[self.data.config_id]
	self:refresh()
end