-- @Author: Su
-- @Date:   2019-10-18 17:00:30
-- @Last Modified by:   Su
-- @Last Modified time: 2019-10-18 17:00:30
-- @File Name: CompetitionShopPanel.lua

local This, super = class(...,"Dialog")
local StoreManager = require("Store.StoreManager")
local DepotManager = require("Depot.DepotManager")
local GamePlayer = require("Player.GamePlayer")
local ItemUtil = require("Bag.ItemUtil")
local PeakContestManager = require("PeakContest.PeakContestManager")
local CompetitionShopItemView = require("Store.CompetitionShopItemView")
local CompetitionShopConfig = require("Metadatas.CompetitionShopConfig")

local TabName = 
{
	kJifen = 1,
}

function This:initNode()
    self.m_csNode = cc.Node:createFromCSFile("GameScene/NodeUI/CompetitionShop.csb")
    self.m_csNode:setToCenter()
    self:addChild(self.m_csNode)
	self.m_select = TabName.kJifen
    self.m_shopItemList = {}
    self:addTabButton(TabName.kJifen, self.m_csNode.jifen, function()
        -- self:selectTabByType( self.m_curTab )
		StoreManager:onGetJinLianJifenStoreInfoRequest()
    end)
    self:selectTabButton(TabName.kJifen)
end

function This:initTouchEvent()
    self.m_csNode.close:setTouchEnded(function()
        self:close()
    end)
    self.m_csNode.wenhaoxin_18:setTouchEnded(function()
        g_scene:openDialog("UI.HelpTips",{text = Serialize[64356], node = self.m_csNode.wenhaoxin_18})
        
    end)
end

function This:onEnter()
    super.onEnter(self)
    StoreManager:addObserver(self)
    DepotManager:addObserver(self)
    PeakContestManager:addObserver(self)
    GamePlayer:addObserver(self)

    -- self:refresh()
end

function This:onExit()
    GamePlayer:removeObserver(self)
    DepotManager:removeObserver(self)
    StoreManager:removeObserver(self)
    PeakContestManager:removeObserver(self)
    super.onExit(self)
end

function This:onRefreshCompetionStore(data)
    self.m_csNode.zijin.number1:setString(DepotManager:getItemOrResCount(335))
	self.m_csNode.zijin.number2:setString(DepotManager:getItemOrResCount(102))
    
	local function sort_shop(a,b)
        return a.trench < b.trench
	end
	table.sort(data,sort_shop)
	if #data ~= #self.m_shopItemList then 
		self.m_csNode.ScrollView:removeAllItems()
		self.m_shopItemList = {}
	end
	local width = 360
	local height = 118
	for i , v in ipairs(data) do 
		local item = self.m_shopItemList[i]
		if not item then 
			item = CompetitionShopItemView:create(v)
			self.m_csNode.ScrollView:pushNode(item,width,height,2)
		else
			item:setData(v,type)		
		end
		self.m_shopItemList[i] = item
	end
end

function This:onPlayerAttrChanged(field, oldValue, value)
    if field == PlayerAttr.diamond or field ==  PlayerAttr.quiz_score then
        self.m_csNode.zijin.number1:setString(DepotManager:getItemOrResCount(335))
        self.m_csNode.zijin.number2:setString(DepotManager:getItemOrResCount(102))
    end
end

function This:itemUpdate(itemList)
    if itemList and #itemList > 0 then
        g_scene:showReward(itemList)
    end
end