-- @Author: superm
-- @Date:   2018-04-09 20:15:07
-- @Last Modified by:   superm
-- @Last Modified time: 2018-04-19 16:48:12
-- @File Name: StoreArenaItemView.lua
-- @Description: 

local This , super = class(..., "Store.StoreItemView")
This.fileName = "MenuScene/NodeUI/ArenaShopitem.csb"

function This:isLocked()
    return false
end

function This:isPurchased()
    return self.m_slot:isMaxTime()
end

function This:refreshConditionUI()
    local cType, cNum = self.m_slot:getCondition()
    if cType == TerrConditionType.kArenaRank then
        local w = (self.bg:getContentSize()-5)/self.condition:getScaleX()
        self.condition:setVisible(true)
        self.condition:setString(string.format("%s %s %s", Serialize[64360], cNum, Serialize[64361]), w)
        self.unlock.times:setVisible(false)
    else
        self.condition:setVisible(false)
    end
end

function This:setItemEnable(enble)
    if self.m_slot:isLocked() then
        self.condition:setVisible(true)
        self:refreshConditionUI()
        self.unlock.buybutton:setGrayShader()
        self.unlock.yuanbao:setGrayShader()
    else
        self.unlock.buybutton:clearShader()
        self.unlock.yuanbao:clearShader()
        if self.condition then
            self.condition:setVisible(false)
        end
    end

    if self.kong then
        self.unlock:setVisible(true)
        self.kong:setVisible(false)
    end
    self.unlock.buybutton:setVisible(enble)
    self.unlock.purchased:setVisible(not enble)
end

function This:refreshNumNode()
    if self.m_slot:getStoreType() == StoreType.kArena then
        if self.unlock.buyTimes then
            local times = self.m_slot:getLeftBuyTimes()
            local visible = times and times > 0
            self.unlock.buyTimes:setVisible(visible)
            if visible then
                local w = (self.bg:getContentSize()-10)/self.unlock.buyTimes:getScaleX()
                self.unlock.buyTimes:setString(string.format(Serialize[64362], times, self.m_slot:getMaxBuyTime()), w)
            end
        end
    else
        if self.unlock.times then
            local times = self.m_slot:getLeftBuyTimes()
            local visible = times and times > 0
            self.unlock.times:setVisible(visible)
            if visible then
                self.unlock.times:setString(string.format(Serialize[64363], times))
            end
        end
    end
end

function This:onBuyArenaStoreItem( storeType, slotId )
    self:refreshWhenBought( storeType, slotId )
end

function This:onBuyArenaBaogeStoreItem( storeType, slotId )
    self:refreshWhenBought( storeType, slotId )
end
