-- @Author: superm
-- @Date:   2018-01-15 15:51:07
-- @Last Modified by:   superm
-- @Last Modified time: 2018-12-11 15:58:12
-- @File Name: StoreBaogeModel.lua
-- @Description:宝阁商店

local This , super = class(...,"Store.StoreBaseModel")
local StoreSlotBaoGeModel = require("Store.StoreSlotBaoGeModel")
local JRareStoreConfig = require("Metadatas.JRareStoreConfig")
local OfficeStoreConfig = require("Metadatas.OfficeStoreConfig")
local PrestigeConfig = require("Metadatas.PrestigeConfig")

local StoreBaogeConfigs = {
    [StoreType.kJianghunBaoge] = JRareStoreConfig,
    [StoreType.kRankBaoge] = OfficeStoreConfig,
    [StoreType.kMingWangBaoge] = PrestigeConfig,
}


function This:create(...)
    local ret = {}
    setmetatable(ret,self)
    ret:init(...)
    return ret
end

function This:initBeforeUpdateState(info, isInit)
    if isInit then
        self.m_objects = {}
    end
    for _, slotInfo in ipairs(info.queue_list) do
        slotInfo.shop_type = info.shop_type
        self:updateSlot(slotInfo)
    end 
    self:initConfigData()
end


function This:beforeEndUpdate()
end

function This:initConfigData()
end

function This:initBaseData( info )
    super.initBaseData(self, info)
    self.m_endTime = 0
end

function This:getCSFileName()
    return "MenuScene/NodeUI/QualifyingBaogeBg.csb"
end

function This:getUITypeName()
	if self:getId() == StoreType.kRankBaoge then
    	return "Store.StoreRankBaogeUI"
    elseif self:getId() == StoreType.kMingWangBaoge then
		return "Store.StoreMingWangBaogeUI"
    else
        return "Store.StoreBaogeUI"
    end
end


function This:updateSlot(slotInfo)
    if slotInfo and slotInfo.index then 
        local index = slotInfo.index
        local slot = self.m_objects[index]
        if not slot then
            slot = StoreSlotBaoGeModel:create(slotInfo)
            slot:setStore(self)
            self.m_objects[index] = slot
        else
            slot:updateInfo(slotInfo)
        end
    end    
end
--endregion