-- @Author: superm
-- @Date:   2017-11-25 13:21:03
-- @Last Modified by:   superm
-- @Last Modified time: 2018-12-11 15:10:31
-- @File Name: StoreBaogeUI.lua
-- @Description: 宝阁商店界面

local This, super = class(..., "NodeView")

local StoreManager = require("Store.StoreManager")
local StoreBaogeItemView = require("Store.StoreBaogeItemView")

function This:initData(store)
	self.m_store = store
	self.m_curViews = {}
    self:initCsNode()
end

function This:initCsNode()
	local csfileName = self.m_store:getCSFileName() 
	local csNode = cc.Node:createFromCSFile(csfileName)
    self.m_csNode = csNode
    self:addChild(csNode)
	csNode.scrollView:setDirection("horizontal")
	csNode.scrollView.m_direction = "right"
end

function This:initNode()
    self:refreshItemList()
end

function This:onEnter()
    super.onEnter(self)
    StoreManager:addObserver(self)
    -- self.m_store:addObserver(self)
end

function This:onExit()
	-- self.m_store:removeObserver(self)
    StoreManager:removeObserver(self)
    super.onExit(self)
end

function This:initTouchEvent()

end

function This:refresh()
	self:refreshItemList(true)
end

function This:refreshItemList(refresh)
    local csNode = self.m_csNode
	if not refresh then
	    csNode.scrollView:removeAllItems()
	    csNode.scrollView:setTouchEnabled(true)
	end

	local slots = self.m_store:getAllObjects()
	for index, slot in ipairs(slots) do
		local view = self.m_curViews[index]
		if not view then
			view = StoreBaogeItemView:create(slot)
			self.m_curViews[index] = view
	        local w , h = view:getContentSize()
	        csNode.scrollView:pushBackCustomItem(view, w, h) 
		else
			view:refresh()
		end
        if view:isLocked() and index > kStoreBageViewNumInPage then
        	break
        end
	end
end