-- @Author: superm
-- @Date:   2018-07-09 11:32:54
-- @Last Modified by:   superm
-- @Last Modified time: 2018-11-06 17:51:08
-- @File Name: StoreFamilyItemView.lua
-- @Description: 

local This , super = class(..., "Store.StoreItemView")
This.fileName = "MenuScene/NodeUI/FamilyStoreItem.csb"

function This:initNode()
    self.condition:setVisible(false)
    self.rightTopCondition:setVisible(false)
    super.initNode(self)
end

function This:isLocked()
    return not self.m_slot or self.m_slot:isLocked()
end

function This:isPurchased()
    return self.m_slot:isMaxTime()
end

function This:refreshConditionUI()
    local cType, cValue = self.m_slot:getCondition()
    if cType == TerrConditionType.kFamilySelfBuildLev then
        self.condition:setVisible(true)
        self.condition:setString(string.format(Serialize[64381], cValue))
    elseif cType == TerrConditionType.kPlayerLev then
        self.condition:setString(string.format(Serialize[64382], cValue))
    else
        self.condition:setVisible(false)
    end
end

function This:refreshBuyConditionUI()
    local cType, cValue = self.m_slot:getCurBuyCondition()
    local visible = false
    if cType == TerrConditionType.kFamilyLevel then
        visible = true
        self.rightTopCondition:setString(string.format(Serialize[64383], cValue))
    elseif cType == TerrConditionType.kPlayerLev then
        visible = true
        self.rightTopCondition:setString(string.format(Serialize[64384], cValue))
    end
    self.rightTopCondition:setVisible(visible)
    self:refreshNumNode(visible)
end

function This:setItemEnable(enble)
    local isLocked = self.m_slot:isLocked()
    if self.condition then
        self.condition:setVisible(isLocked)
        if isLocked then
            self:refreshConditionUI()
        end
    end

    if self.kong then
        self.unlock:setVisible(not isLocked)
        self.kong:setVisible(isLocked)
    end
    self.name:setVisible(not isLocked)

    if self.share then
        self.share:setVisible(not isLocked and self.m_slot:isShared())
    end

    if isLocked then
        self.unlock.buybutton:setGrayShader()
        self.unlock.yuanbao:setGrayShader()
    else
        self.unlock.buybutton:clearShader()
        self.unlock.yuanbao:clearShader()
    end
    self.unlock.buybutton:setVisible(enble)
    self.unlock.purchased:setVisible(not enble)
end

function This:refreshNumNode(hidden)
    if self.unlock.buyTimes then
        if not hidden then
            local times = self.m_slot:getLeftBuyTimes()
            local visible = times and times > 0
            self.unlock.buyTimes:setVisible(visible)
            if visible then
                self.unlock.buyTimes:setString(string.format(Serialize[60782], times, self.m_slot:getMaxBuyTime()))
            end
        else
            self.unlock.buyTimes:setVisible(false)
        end
    end
end

function This:onBuyFamilyStoreItem( storeType, slotId )
    self:refreshWhenBought( storeType, slotId )
end