-- @Author: Su
-- @Date:   2019-07-16 21:36:40
-- @Last Modified by:   Su
-- @Last Modified time: 2019-07-16 21:36:40
-- @File Name: StoreHeroModel.lua
-- @Description: 
local This , super = class(...,"Store.StoreBaseModel")
local StoreManager = require("Store.StoreManager")
local GamePlayer = require("Player.GamePlayer")
local DepotManager = require("Depot.DepotManager")
local LordEquipShopConfig = require("Metadatas.LordEquipShopConfig")
local StoreSlotBaseModel = require("Store.StoreSlotBaseModel")

function This:create(...)
    local ret = {}
    setmetatable(ret,self)
    ret:init(...)
    return ret
end

function This:initBeforeUpdateState(info, isInit)
    info.queue_list = info.shop_item_list
    --super.initBeforeUpdateState(self, info, isInit)

end

function This:getRefreshTimes()
    return 0,0
end

function This:getCommonCostId()
    return 307,GamePlayer:getStone(),false
    
end

function This:isCostEnoughBy(num)
    local ids = {
        [StoreType.kJianghun] = 118,
        [StoreType.kJianghunBaoge] = 118,
        [StoreType.kZhangong] = 119,
        [StoreType.kJianghunMystery] = 118,
        [StoreType.kZhangongMystery] = 119,
        [StoreType.kRankBaoge] = 102,
        [StoreType.kJifen] = 119,
        [StoreType.kJifenMystery] = 119,	
        [StoreType.kAnimalShop] = 118,
        [StoreType.kAnimalMystery] = 118,
        [StoreType.kHeroEquipShop] = 307,
    }
    local id = ids[self:getId()]
    local curNumber = DepotManager:getItemOrResCount(id)
    return curNumber >= num, id, curNumber
end

function This:getUITypeName()
    return "Store.StoreHeroUI"
end

function This:getName()
    return Serialize[64388]
end

function This:getAllObjects()
    if not self.m_objects or #self.m_objects == 0 then
        for i,itemInfo in ipairs(LordEquipShopConfig) do
            if GamePlayer:getLevel() >=  itemInfo.level then
                local arg={
                shop_type = StoreType.kHeroEquipShop,
                award_id=itemInfo.item_id,
                index=i,
                count=itemInfo.item_num,
                cost_id=307,
                cost_count =itemInfo.cost_num,
            }
                local slot = StoreSlotBaseModel:create(arg)
                self.m_objects[i]=slot
            else
                break
            end
        end

    end
    return self.m_objects
end