-- @Author: Su
-- @Date:   2019-07-16 22:11:15
-- @Last Modified by:   Su
-- @Last Modified time: 2019-07-16 22:11:15
-- @File Name: StoreHeroUI.lua
-- @Description: 

local This, super = class(..., "NodeView")
This.fileName = "MenuScene/NodeUI/QualifyingShopBg.csb"

local StoreManager = require("Store.StoreManager")
local StoreItemView = require("Store.StoreItemView")
local ItemNode = require("UI.ItemNode")
local GamePlayer = require("Player.GamePlayer")
local GameUtil = require("Util.GameUtil")
local ItemUtil = require("Bag.ItemUtil")

function This:initData(store)
    self.m_store = store
    self.m_curViews ={}
	self:initNode()
end

function This:initNode()
    self.title:setString(self.m_store:getName())
	self.bg3:setVisible(false)
	self.bg22:setVisible(false)
    self.free_time:setVisible(false)
    self.free_text:setVisible(false)
    self.free_tips:setVisible(false)
    self.cleanbutton:setVisible(false)
    self:refresh()
end

function This:onEnter()
    super.onEnter(self)
    StoreManager:addObserver(self)
    self.m_store:addObserver(self)
end

function This:onExit()
	self.m_store:removeObserver(self)
    StoreManager:removeObserver(self)
    if self.m_curViews then
    	for _, view in pairs(self.m_curViews) do
    		if view and view[0] ~= 0 then
    			view:release()
    		end
    	end
    end
    super.onExit(self)
end

function This:refreshItemList(refresh)
    self.scrollView:removeAllItems()
    self.scrollView:setTouchEnabled(true)

	local slots = self.m_store:getAllObjects()
	for index, slot in ipairs(slots) do
		local view = self.m_curViews[index]
		if not view then
			view = StoreItemView:create(slot)
			self.m_curViews[index] = view
			view:retain()
		else
			view:refresh()
		end
        local w , h = view:getContentSize()
        self.scrollView:pushNode(view, w, h, 2)
	end
end

function This:refresh()
	-- if self.m_inited then
	--    local ret = self:refreshCostItem()
	    self:refreshItemList(true)
        -- self:refreshFavourNode()
	-- end
end