--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(..., "NodeView")
This.fileName = "MenuScene/NodeUI/QualifyingShopItem.csb"

local StoreManager = require("Store.StoreManager")
local ItemNode = require("UI.ItemNode")
local ItemUtil = require("Bag.ItemUtil")
local GameUtil = require("Util.GameUtil")

-- function This:init(slot)
--     super.init(self)
-- end

function This:initData(slot)
    self.m_inited = false
    self.m_slot = slot
    local w , h = self.bg:getContentSize()
    self:setContentSize(w,h)
end

function This:onEnter()
    super.onEnter(self)
    StoreManager:addObserver(self)
end

function This:onExit()
    StoreManager:removeObserver(self)
    super.onExit(self)
end

function This:initNode()
    self.m_slot:updateState()
    self:refreshItemUI()
    self:setItemEnable(not self.m_slot:isMaxTime())
end

function This:initTouchEvent()
    if not self.m_inited then
        self.unlock.buybutton:setTouch({
            getRect = function (touch)
                local rect = touch.sizeNode:getBoundingBox()
                return rect
            end,
		    onEnded = function()
                self:onBuyBtnClick()
            end,
            isContainer = true,
        })    
        self.m_inited = true
    end
end

function This:refreshItemUI()
    if self:isLocked() then
        return
    end
    
    local node = self.unlock.item.node
    local itemId, num = self.m_slot:getItemId(), self.m_slot:getItemNum()
    if not node then
        node = ItemNode:create(itemId, num)
        node:setAnchorPoint(0.5, 0.5)
        self.unlock.item:addChild(node)
        self.unlock.item.node = node
    else
        node:init(itemId, num)
    end

    local discount = self.m_slot:getDiscount()
    if self.unlock.discount and discount < 10 then
        self.unlock.discount:setString( GameUtil:discountStr(discount) )
        self.unlock.discount:setVisible(true)
        self.unlock.bg5:setVisible(true)
    elseif self.unlock.discount then
        self.unlock.discount:setVisible(false) 
        self.unlock.bg5:setVisible(false) 
    end

    self.name:setString(self.m_slot:getName(), (not AppText:isChinese()) and 320 or nil)
    self.name:setColorByID("Q".. ItemUtil.getQuality(itemId))
    self:refreshBuyConditionUI()

    if self:isPurchased() then
        self.unlock.yuanbao:setVisible(false)
        self.unlock.price:setVisible(false)
        return
    end

    local priceNum = self.m_slot:getPrice() * discount / 10
    if ( priceNum and priceNum > 0 ) or ( not self.free ) then
        self.unlock.yuanbao:setVisible(true)
        self.unlock.price:setVisible(true)
        if self.unlock.free then
            self.unlock.free:setVisible(false)
        end
        self.unlock.yuanbao:setImage(self.m_slot:getPriceImage())
        self.unlock.price:setString("" .. priceNum)
    else
        self.unlock.yuanbao:setVisible(false)
        self.unlock.price:setVisible(false)
        if self.unlock.free then
            self.unlock.free:setVisible(true)
        end
    end

end

function This:refreshNumNode()
    if self.unlock.num then
        local visible = self.m_slot:isSpall()
        self.unlock.num:setVisible(visible)
        if visible then
            local curNum, synthesizeCost = self.m_slot:getNumInDepot()
            self.unlock.num:setString("(" .. curNum .. "/" .. synthesizeCost .. ")")
        end
    end
end

function This:refreshConditionUI()
end

function This:refreshBuyConditionUI()
    self:refreshNumNode()
end

function This:setItemEnable(enble)
    if self:isLocked() then
        if self.condition then
            self.condition:setVisible(true)
            self:refreshConditionUI()
        end

        if self.kong then
            self.unlock:setVisible(false)
            self.kong:setVisible(true)
        end
    else
        if self.condition then
            self.condition:setVisible(false)
        end
        if self.kong then
            self.unlock:setVisible(true)
            self.kong:setVisible(false)
        end
        self.unlock.buybutton:setVisible(enble)
        self.unlock.purchased:setVisible(not enble)
    end
end

function This:isLocked()
    return false
end

function This:isPurchased()
    return false
end

function This:refresh()
    self.m_slot:updateState()
    self:refreshItemUI()
    self:setItemEnable(not self.m_slot:isMaxTime())
end

function This:onBuyBtnClick()
    if self.m_slot then
        self.m_slot:requestBuy()
    end
end

function This:refreshWhenBought( storeType, slotId )
    if self.m_slot:getStoreType() == storeType and self.m_slot:getId() == slotId then
        self:refresh()
        local itemId = self.m_slot:getItemId()
        if ItemUtil.getType(itemId) == ItemCommonType.kGameRes then
            g_scene:showReward({{id = itemId, num = self.m_slot:getItemNum()}})
        end
    end
end

function This:onBuyCommonStoreItem( storeType, slotId )
    self:refreshWhenBought( storeType, slotId )
end


--endregion
