-- @Author: superm
-- @Date:   2018-12-10 18:19:37
-- @Last Modified by:   superm
-- @Last Modified time: 2018-12-11 15:50:51
-- @File Name: FamilyWarShopPanel.lua
-- @Description: 

local This,super = class(...,"Dialog")

local This, super = class(...,"Dialog")
local StoreManager = require("Store.StoreManager")
local DepotManager = require("Depot.DepotManager")
local GamePlayer = require("Player.GamePlayer")
local ItemUtil = require("Bag.ItemUtil")

local StoreTab = {
    [StoreType.kLegionWarPersonal] = 1,
    [StoreType.kLegionWarShare] = 2,
}

function This:initData(info)
    self.m_map = info.map
    self.m_cityId = info.cityId
    self.m_storeModel = self:getStore()
end

function This:initNode(info)
	local csNode = cc.Node:createFromCSFile("LegionScene/NodeUI/LegionShop.csb")
    self.m_csNode = csNode
    csNode:setToCenter()
    self:addChild(csNode)

	local tagNode = csNode.biaoqian
	for storeType, tabIndex in pairs(StoreTab) do
	    self:addTabButton(tostring(storeType), tagNode["tep" .. tab], function()
        	self.m_curTab = tab
	        self:selectTabUI(storeType)
	        return true
	    end)
	end
end

function This:initTouchEvent()
    if not self.m_inited then
        local csNode = self.m_csNode
        csNode.close:setTouchEnded(function()
            self:close()
        end)
        self.m_inited = true
    end
end

function This:createTabNode(name)
    local storeType = tonumber(name)
    local uiName = self.m_storeMolde:getUITypeName()
    if uiName  then
        local tabNode = require(uiName):create(self.m_storeMolde, storeType)
        return tabNode
    end
end

function This:selectTabUI(storeType)
	local node = self:openTabNode(tostring(storeType))
    if node then
        node:refresh()
    end
end