--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This, super = class(...,"Dialog")
local StoreManager = require("Store.StoreManager")
local DepotManager = require("Depot.DepotManager")
local GamePlayer = require("Player.GamePlayer")
local ItemUtil = require("Bag.ItemUtil")
local LordEquipShopConfig = require("Metadatas.LordEquipShopConfig")

function This:initData(info)
    self.m_inited = false
    self.m_initing = true
    self.m_mysteryChecked = true
    self:selectTabZhangong()
end

function This:onOpen()
    if self.m_tabButtons then
        for name,button in pairs(self.m_tabButtons) do
            if not button.m_touch then
                button:setTouch({
                    onEnded = function ()
                        self:selectTabButton(name)
                    end,
                    isSwallow = false,
                    isContainer = true,
                })
            end
        end
    end
    super.onOpen(self)
end

function This:initNode(info)
    self.m_csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/QualifyingShop.csb")
    self.m_csNode:setToCenter()
    self:addChild(self.m_csNode)

    local defaultTab 
    if info then
        defaultTab = info.tabs
    end
    defaultTab = defaultTab or StoreType.kZhangong
    -- self.m_csNode.icon1:setImage(ItemUtil.getIconImage(102))
    -- self.m_csNode.icon3:setImage(ItemUtil.getIconImage(101))
    self.m_csNode.text1:setString("" .. GamePlayer:getDiamond())
    self.m_csNode.text3:setString("" .. GamePlayer:getGold())

    self:addTabButton(tostring(StoreType.kZhangong), self.m_csNode.ListView["2"].tep2, function()
        self.isSwallow = true
        self:selectTabZhangong()
        return true
    end)

    self:addTabButton(tostring(StoreType.kJianghun), self.m_csNode.ListView["1"].tep1, function()
        self.isSwallow = true
        self:selectTabJianghun()
        return true
    end)
    self:addTabButton(tostring(StoreType.kJifen), self.m_csNode.ListView["5"].tep5, function()
        return self:selectTabJifen()
    end)

    self:addTabButton(tostring(StoreType.kJianghunBaoge), self.m_csNode.ListView["3"].tep3, function()
        self.m_curTab = StoreType.kJianghunBaoge
        self.m_curSubTab = StoreType.kJianghunBaoge
        self:selectTabByType( self.m_curTab )
        return true
    end)
    
    self:addTabButton(tostring(StoreType.kRankBaoge), self.m_csNode.ListView["4"].tep4, function()
        self.m_curTab = StoreType.kRankBaoge
        self.m_curSubTab = StoreType.kRankBaoge
        self:selectTabByType( self.m_curTab )
        return true
    end)

    self:addTabButton(tostring(StoreType.kMingWangBaoge), self.m_csNode.ListView["6"].tep6, function()
        return self:selectTabMingWang()
    end)

    self:addTabButton(tostring(StoreType.kAnimalShop),self.m_csNode.ListView["7"].tep7, function()

        return self:selectTabAnimal()
    end)

    self:addTabButton(tostring(StoreType.kHeroEquipShop),self.m_csNode.ListView["8"].tep8, function()

        return self:selectTabHeroEquip()
    end)


    self:selectTabButton(tostring(defaultTab))
    local level = GamePlayer:getLevel()
	if level < 38 then
        self.m_csNode.ListView["5"].tep5.suo:setVisible(true)
	else
        self.m_csNode.ListView["5"].tep5.suo:setVisible(false)
    end
    if level < 20 then
        self.m_csNode.ListView["6"].tep6.suo:setVisible(true)
	else
        self.m_csNode.ListView["6"].tep6.suo:setVisible(false)
    end
    if level < 64 then
        self.m_csNode.ListView["7"].tep7.suo:setVisible(true)
    else
        self.m_csNode.ListView["7"].tep7.suo:setVisible(false)
    end
    if level < 55 then
        self.m_csNode.ListView["8"].tep8.suo:setVisible(true)
    else
        self.m_csNode.ListView["8"].tep8.suo:setVisible(false)
    end
end

function This:initTouchEvent()
    local csNode = self.m_csNode
    csNode.close:setTouchEnded(function()
        self:close()
    end)

    csNode.add:setTouchEnded(function()
        g_scene:openDialog("System.RechargeMainUI")
    end)

    csNode.add1:setTouchEnded(function()
        GamePlayer:checkGold({nocheck = true, nowarming = true})
    end)

	csNode.help:setTouchEnded(function()
		g_scene:openDialog("UI.HelpTips",{text = Serialize["zhangongstore"],node = self.m_csNode.help})
	end)
end

function This:initFinish(info)
    self:refreshResourceNode()
end

function This:onEnter()
    super.onEnter(self)
    DepotManager:addObserver(self)
    StoreManager:addObserver(self)
    GamePlayer:addObserver(self)
    self:refresh()
end

function This:onExit()
    StoreManager:removeObserver(self)
    DepotManager:removeObserver(self)
    GamePlayer:removeObserver(self)
    super.onExit(self)
end

function This:refresh()
end

function This:getTabNodeData(name)
    return self.m_store
end

-- function This:hideBaoTabBtn()
--     self.m_csNode.sub_tabs:setVisible(false)
-- end

-- function This:showBaoTabBtn()
--     self.m_csNode.sub_tabs:setVisible(true)
-- end

function This:refreshResourceNode()
    --獲取戰功、将魂
    self.m_csNode.text1:setString("" .. GamePlayer:getDiamond())
    self.m_csNode.text3:setString("" .. GamePlayer:getGold())
    local id, number, coinVisible = self.m_store:getCommonCostId()
    if id and number then
        self.m_csNode.icon2:setImage(ItemUtil.getIconImage(id))
        self.m_csNode.text2:setString("" .. number)
        local visibleList = {true, true, coinVisible}
        for i=2, 3 do
            local visible = visibleList[i]
            self.m_csNode["icon" .. i]:setVisible(visible)
            self.m_csNode["text" .. i]:setVisible(visible)
            self.m_csNode["bg" .. (3 + i)]:setVisible(visible)
            self.m_csNode["di" .. (4 - i)]:setVisible(visible)
            local btn = self.m_csNode["add" .. (4 - i)]
            if btn then
                btn:setVisible(visible)
            end
        end
    else
        for i=2, 3 do
            self.m_csNode["icon" .. i]:setVisible(false)
            self.m_csNode["text" .. i]:setVisible(false)
            self.m_csNode["bg" .. (3 + i)]:setVisible(false)
            self.m_csNode["di" .. (4 - i)]:setVisible(false)
            local btn = self.m_csNode["add" .. (4 - i)]
            if btn then
                btn:setVisible(false)
            end
        end
    end
end

function This:selectTabJianghun()
    local mysteryStore = StoreManager:getStoreBy(StoreType.kJianghunMystery, true)
    if ( not mysteryStore ) and  ( self.m_mysteryChecked or not self.m_initing ) then
        self.m_curTab = StoreType.kJianghun
        self.m_curSubTab = StoreType.kJianghun
        self:selectTabByType( self.m_curSubTab )
    else
        if mysteryStore and not self.m_mysteryChecked and self.m_initing then
            self.m_initing = false
            self.m_inited = true
        end
        self.m_curTab = StoreType.kJianghun
        self.m_curSubTab = StoreType.kJianghunMystery
        self:selectTabByType( self.m_curSubTab )
    end
end

function This:selectTabZhangong()
    local mysteryStore = StoreManager:getStoreBy(StoreType.kZhangongMystery, true)
    if not mysteryStore then
        self.m_curTab = StoreType.kZhangong
        self.m_curSubTab = StoreType.kZhangong
        self:selectTabByType( self.m_curSubTab )
    else
        self.m_curTab = StoreType.kZhangong
        self.m_curSubTab = StoreType.kZhangongMystery
        self:selectTabByType( self.m_curSubTab )        
    end
end

function This:selectTabJifen()
    local level = GamePlayer:getLevel()
	if level < 38 then
        g_scene:showTips(Serialize[64397])
		return false
	end
    local mysteryStore = StoreManager:getStoreBy(StoreType.kJifenMystery, true)
    if not mysteryStore then
        self.m_curTab = StoreType.kJifen
        self.m_curSubTab = StoreType.kJifen
        self:selectTabByType( self.m_curSubTab )
    else
        self.m_curTab = StoreType.kJifen
        self.m_curSubTab = StoreType.kJifenMystery
        self:selectTabByType( self.m_curSubTab )        
    end
    return true
end

function This:selectTabMingWang()
    local level = GamePlayer:getLevel()
	if level < 20 then
        g_scene:showTips(Serialize[64398])
		return false
	end
    self.m_curTab = StoreType.kMingWangBaoge
    self.m_curSubTab = StoreType.kMingWangBaoge
    self:selectTabByType( self.m_curTab )
    return true
end

function This:selectTabAnimal()
    local level = GamePlayer:getLevel()
	if level < 64 then
        g_scene:showTips(Serialize[64399])
		return false
    end
    local mysteryStore = StoreManager:getStoreBy(StoreType.kAnimalMystery, true)
    if ( not mysteryStore ) and  ( self.m_mysteryChecked or not self.m_initing ) then
        self.m_curTab = StoreType.kAnimalShop
        self.m_curSubTab = StoreType.kAnimalShop
        self:selectTabByType( self.m_curSubTab )
    else
        if mysteryStore and not self.m_mysteryChecked and self.m_initing then
            self.m_initing = false
            self.m_inited = true
        end
        self.m_curTab = StoreType.kAnimalShop
        self.m_curSubTab = StoreType.kAnimalMystery
        self:selectTabByType( self.m_curSubTab )     
    end
    return true
end

function This:selectTabHeroEquip()
    local level = GamePlayer:getLevel()
	if level < 55 then
        g_scene:showTips(Serialize[60428])
		return false
    end
    self.m_curTab = StoreType.kHeroEquipShop
    self.m_curSubTab = StoreType.kHeroEquipShop
    self:selectTabByType( self.m_curSubTab )
    return true
end


function This:createTabNode(name)
    local store = self:getTabNodeData(name)
    local uiName = store:getUITypeName()
    if uiName  then
        local tabNode = require(uiName):create(store)
        return tabNode
    end
end

function This:selectTabByType( storeType, forceRequest )
    self.m_store = StoreManager:getStoreBy(storeType)
    if storeType == StoreType.kZhangong or storeType == StoreType.kZhangongMystery then
        if not forceRequest and self.m_store then
            if not self.m_initing then
                local node = self:openTabNode(tostring(storeType))
                if node and node ~= false then
                    node:refresh()
                    self:refreshResourceNode()
                end
            else
                self.m_initing = false
                self.m_inited = true
            end
        elseif self.m_inited or self.m_initing then
            if self.m_initing then
                self.m_initing = false
            end
            StoreManager:onGetStoreInfoRequest(storeType)
        end
    elseif storeType == StoreType.kJianghunBaoge or storeType == StoreType.kRankBaoge or storeType == StoreType.kMingWangBaoge then
        if not forceRequest and self.m_store then
            -- self:showBaoTabBtn()
            local node = self:openTabNode(tostring(storeType))
            if node and node ~= false then
                node:refresh()
                self:refreshResourceNode()
            end
        else
            StoreManager:onGetStoreInfoRequest(storeType)
        end
    elseif storeType == StoreType.kJianghun then
        if self.m_store then
            -- self:hideBaoTabBtn()
            local node = self:openTabNode(tostring(storeType))
            if node and node ~= false then
                node:refresh()
                self:refreshResourceNode()
            end
        else
            StoreManager:onGetStoreInfoRequest(storeType)
        end
    elseif storeType == StoreType.kJianghunMystery then
        if not forceRequest and self.m_store then
            -- self:hideBaoTabBtn()
            local node = self:openTabNode(tostring(storeType))
            if node and node ~= false then
                node:refresh()
                self:refreshResourceNode()
            end
        else
            StoreManager:onGetStoreInfoRequest(storeType)
        end
    elseif storeType == StoreType.kJifen then
        if self.m_store then
            -- self:hideBaoTabBtn()
            local node = self:openTabNode(tostring(storeType))
            if node and node ~= false then
                node:refresh()
                self:refreshResourceNode()
            end
        else
            StoreManager:onGetStoreInfoRequest(storeType)
        end
    elseif storeType == StoreType.kJifenMystery then
        if not forceRequest and self.m_store then
            -- self:hideBaoTabBtn()
            local node = self:openTabNode(tostring(storeType))
            if node and node ~= false then
                node:refresh()
                self:refreshResourceNode()
            end
        else
            StoreManager:onGetStoreInfoRequest(storeType)
        end
    elseif storeType == StoreType.kAnimalShop then

        if self.m_store then
            -- self:hideBaoTabBtn()
            local node = self:openTabNode(tostring(storeType))
            if node and node ~= false then
                node:refresh()
                self:refreshResourceNode()
            end
        else
            StoreManager:onGetStoreInfoRequest(storeType)
        end
    elseif storeType == StoreType.kAnimalMystery then
        if not forceRequest and self.m_store then
            -- self:hideBaoTabBtn()
            local node = self:openTabNode(tostring(storeType))
            if node and node ~= false then
                node:refresh()
                self:refreshResourceNode()
            end

        else
            StoreManager:onGetStoreInfoRequest(storeType)
        end
    elseif storeType == StoreType.kHeroEquipShop then
        if self.m_store then
            -- self:hideBaoTabBtn()
            local node = self:openTabNode(tostring(storeType))
            if node and node ~= false then
                node:refresh()
                self:refreshResourceNode()
            end
        else
            local itemList={}
            for i,itemInfo in ipairs(LordEquipShopConfig) do
                if GamePlayer:getLevel() >=  itemInfo.level then
                    itemList[i]=itemInfo
                else
                    break
                end
            end
            StoreManager:addStore({shop_type =StoreType.kHeroEquipShop,shop_item_list=itemList} )
            self:selectTabByType(StoreType.kHeroEquipShop)
            self:refreshResourceNode()
        end
    end
end

-------------------------------------
function This:onGetMysteryStoreInfo( storeType )
    if self.m_initing then
        self.m_initing = false
        self.m_inited = true
    end
    self.m_curSubTab = storeType
    self:selectTabByType( storeType )
    self:refresh()
end


function This:onGetCommonStoreInfo( storeType )
    if self.m_curSubTab == storeType then
        if storeType == StoreType.kZhangong and not self.m_store then
            self.m_inited = true
        end
            
        self:selectTabByType( storeType )
        self:refresh()
    end
end

function This:onGetBaogeStoreInfo()
    if self.m_curSubTab == StoreType.kJianghunBaoge then
        self:selectTabByType( StoreType.kJianghunBaoge )
    elseif self.m_curSubTab == StoreType.kRankBaoge then
        self:selectTabByType( StoreType.kRankBaoge )
    elseif self.m_curSubTab == StoreType.kMingWangBaoge then
        self:selectTabByType( StoreType.kMingWangBaoge )
    end

end

function This:onLeaveMysteryStore( storeType )
    if self.m_curSubTab == storeType then
        self.m_curSubTab = self.m_curTab
        self:selectTabByType(self.m_curTab)
    end
end

function This:itemUpdate(itemList)
    if itemList and #itemList > 0 then
        g_scene:showReward(itemList)
    end
end

function This:onPlayerAttrChanged(field, oldValue, value)
    if field == PlayerAttr.gold or field == PlayerAttr.diamond or field == PlayerAttr.zhangong or field == PlayerAttr.soul or field ==  PlayerAttr.skill_reel or field == PlayerAttr.animalsoul then
        self.m_csNode.text1:setString("" .. GamePlayer:getDiamond())
        self.m_csNode.text3:setString("" .. GamePlayer:getGold())
        local id, number, _ = self.m_store:getCommonCostId()
        if id and number then
            self.m_csNode.text2:setString("" .. number)
        end
    end
end

function This:onBuyHeroQuipStoreItem()
    self:refreshResourceNode()
end

--endregion
