-- @Author: superm
-- @Date:   2018-01-15 15:51:07
-- @Last Modified by:   superm
-- @Last Modified time: 2018-12-10 18:00:57
-- @File Name: StoreSlotBaseModel.lua
-- @Description: 

local This , super = class(...,"Store.StoreSlotBaseModel")
local ItemUtil = require("Bag.ItemUtil")
local GamePlayer = require("Player.GamePlayer")
local DepotManager = require("Depot.DepotManager")
local StoreManager = require("Store.StoreManager")
local JRareStoreConfig = require("Metadatas.JRareStoreConfig")
local OfficeStoreConfig = require("Metadatas.OfficeStoreConfig")
local MatchManager = require("Match.MatchManager")
local GameUtil = require("Util.GameUtil")
local PrestigeConfig = require("Metadatas.PrestigeConfig")

local StoreBaogeSlotConfigs = {
    [StoreType.kJianghunBaoge] = JRareStoreConfig,
    [StoreType.kRankBaoge] = OfficeStoreConfig,
    [StoreType.kMingWangBaoge] = PrestigeConfig,
}


function This:initSelf( info )
    self.m_storeType = info.shop_type
    self.m_ID = info.index 
    self.m_buyTime = info.buy_times or 0
    self.m_config = StoreBaogeSlotConfigs[self.m_storeType][self.m_ID]
    self.m_orderId = self.m_config.shopping_order
    self.m_itemId = self.m_config.item_id
    self.m_itemNum = self.m_config.count
    self.m_costId = self.m_config.cost_id
    self.m_costNum = self.m_config.cost_count
    self.m_discount = self.m_config.discount
    self.m_condLevel = self.m_config.cond_level    
end

function This:updateStateByConds()
    local oldState = self.m_state
  
        local ret = self:isNotLockedBy()
        self.m_state = ret and StoreObjectState.kNormal or StoreObjectState.kLocked
 
     
    return oldState ~= self.m_state
end



function This:isNotLockedBy()
    if self.m_storeType == StoreType.kJianghunBaoge then
        local level = GamePlayer:getLevel()
        return level >= self.m_condLevel
    elseif self.m_storeType == StoreType.kRankBaoge then
       local level = MatchManager:getMaxRankLvInHistory() or MatchManager:getRankLv()
        return level >= self.m_condLevel
    elseif self.m_storeType == StoreType.kMingWangBaoge then
       local level =  GamePlayer:getMingWangLv()
       return level >= self.m_condLevel
    else
        return true
    end
end