-- @Author: superm
-- @Date:   2018-10-30 17:20:32
-- @Last Modified by:   superm
-- @Last Modified time: 2018-11-06 16:00:01
-- @File Name: StoreSlotFamilyLevelModel.lua
-- @Description: 

local This , super = class(...,"Store.StoreSlotFamilyModel")

function This:isBuyLocked()
    local cType, cValue = self:getCurBuyCondition()
    return cType and cType ~= TerrConditionType.kNone
end

function This:getCondition()
    return TerrConditionType.kNone, 0
end

function This:getBuyCondition()
    if self.m_config then
        local condlist = {
            {TerrConditionType.kFamilyLevel, self.m_config.quality_type},
            {TerrConditionType.kPlayerLev, self.m_config.level},
        }
        return TerrConditionType.kComplex, condlist
    else
        return TerrConditionType.kNone, 0
    end
end

function This:showBuyLockedTips()
    local cType, cValue = self:getCurBuyCondition()
    if cType then
        if cType == TerrConditionType.kPlayerLev then
            g_scene:showTips(Serialize[64424])
        elseif cType == TerrConditionType.kFamilyLevel then
            g_scene:showTips(Serialize[64425])
        end
    end
end
