-- @Author: superm
-- @Date:   2018-10-30 20:07:58
-- @Last Modified by:   superm
-- @Last Modified time: 2018-11-06 17:38:26
-- @File Name: StoreSlotFamilyShareModel.lua
-- @Description: 
local This , super = class(...,"Store.StoreSlotFamilyModel")
local StoreManager = require("Store.StoreManager")

function This:isBuyLocked()
    local store = self:getStore()
    if store then
        return store:getLeftBuyTimes() <= 0
    end

    local cType, cValue = self:getCurBuyCondition()
    return cType and cType ~= TerrConditionType.kNone
end

function This:getCondition()
    if self.m_config then
        return TerrConditionType.kFamilySelfBuildLev, self.m_ID
    else
        return TerrConditionType.kNone, 0
    end
end

function This:getBuyCondition()
    if self.m_config then
    	return TerrConditionType.kPlayerLev, self.m_config.level
    else
        return TerrConditionType.kNone, 0
    end
end

function This:showBuyLockedTips()
    local cType, cValue = self:getCurBuyCondition()
    if cType and cType ~= TerrConditionType.kNone then
        g_scene:showTips(Serialize[64424])
    else
        g_scene:showTips(Serialize[64429])
    end
end

function This:getPriceType()
    if self.m_config then
        return self.m_config.money_id
    end
    return 0
end

function This:doRequestBuy()
    StoreManager:onBuyStoreItemRequest(self.m_storeType, self.m_ID, self.m_itemId, self.m_orderId, self:getPriceType(), self:getPrice())
end