-- @Author: superm
-- @Date:   2017-10-20 19:04:52
-- @Last Modified by:   superm
-- @Last Modified time: 2017-10-20 19:33:46
-- @File Name: GlodMutilChangePanel.lua

local This, super = class(..., "Dialog")
local SystemManager = require("System.SystemManager")

function This:initData(info)
	self.m_times = info.times
	self.m_gain = info.gain
	self.m_cost = info.cost
end

function This:initNode()
    self.m_csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/GoldExchangeMany.csb")
    self.m_csNode:setPosition(cc.visible.center.x, cc.visible.center.y)
    self.m_csNode:setScale(1)
    self:addChild(self.m_csNode)
    self.m_csNode.descr:setString(tostring(self.m_times) .. Serialize["System_GlodMutilChangePanel_1"])
    self.m_csNode.scount:setString("x" .. tostring(self.m_cost))
    self.m_csNode.tcount:setString("x" .. tostring(self.m_gain))
end

function This:initTouchEvent()
    self.m_csNode.close:setTouchEnded(function()
        self:close()
    end)

    self.m_csNode.multiExchange:setTouchEnded(function()
        SystemManager:onUseGlodChangeRequest(self.m_times)
        self:close()
    end)
end
