--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"Base.BaseModel")
local ItemUtil = require("Bag.ItemUtil")
local GamePlayer = require("Player.GamePlayer")
local TerrAltarShopConfig = require("Metadatas.TerrAltarShopConfig")

function This:init( info )
    super.init(self)
    if info then
        self:initSelf( info )
        self:updateState(true, info)
    else
        self.m_ID = 0
        self.m_state = TerrObjectState.kLocked
    end
end

function This:initSelf( info )
    self.m_itemId = info.award_id or 0
    self.m_ID = info.index or 0
    self.m_buyTime = info.buy_times
    self.m_config = TerrAltarShopConfig[self.m_itemId]
    if not self.m_requireKing then
        self.m_requireKing = info.slotConfig
    end
end

function This:updateInfo( info )
    local isDiff = self:isSameType(info)
    self:initSelf( info )
    self:updateState(isDiff, info)
    -- print("槽位" .. tostring(self.m_ID), ItemUtil.getName(self.m_itemId), "购买次数:" .. tostring(self.m_buyTime), "需要爵位等级：" .. tostring(self.m_requireKing))
end

function This:updateState(isInit, info)
    if isInit then
        self:initSelf(info)
    end

    local conds = self:getCondition()
    if not conds or conds == 0 then
        self.m_state = TerrObjectState.kNormal
    else
        local ret = self:isNotLockedBy(conds)
        self.m_state = ret and TerrObjectState.kNormal or TerrObjectState.kLocked
    end
    -- if self.m_state == TerrObjectState.kLocked then
    --     print("槽位" .. tostring(self.m_ID) .. "锁定")
    -- else
    --     print("槽位" .. tostring(self.m_ID) .. "开放")
    -- end
end

function This:getCondition()
    return self.m_requireKing
end

function This:setId( id )
    self.m_ID = id
end

function This:getId()
    return self.m_ID
end

--道具ID
function This:getConfigId()
    return self.m_config.id
end

function This:isNotLockedBy( conds )
    return self.m_itemId > 0 and self.m_config ~= nil
end

function This:isSameType( info )
    return self.m_ID == info.index and self.m_itemId == info.award_id
end

function This:isCostEnoughBy()
    local id, num = 100 + self.m_config.price_type, self:getPrice()
    if ItemUtil.getType(id) == ItemCommonType.kGameRes then
        local switch = {
            [101] = function(num)
                return GamePlayer:getGold() >= num, 101
            end,
            [102] = function(num)
                return GamePlayer:getDiamond() >= num , 102
            end,
        }
        return switch[id](num)
    else
        return true, id
    end
end

function This:isLocked()
    return (self.m_state == TerrObjectState.kLocked) or (not self.m_config)
end

function This:isOpening()
    return self.m_state == TerrObjectState.kNormal
end

function This:isMaxTime()
    return self.m_buyTime >= self:getMaxBuyTime()
end

function This:getBuyTime()
    return self.m_buyTime
end

function This:getMaxBuyTime()
    return self.m_config.buy_num
end

function This:requestBuy(build)
    local state, id = self:isCostEnoughBy() 
    if state and build then
        build:onBuyAltarItemRequest(self.m_ID, self.m_itemId)
    else
        if id == 102 then
            GamePlayer:checkDiamond(0, true)
        else
            g_scene:showTips(Serialize[60714] .. ItemUtil.getName(id) .. Serialize[60715])
        end
    end
end

--获取配置信息region begin

function This:getItemNum()
    return self.m_config.item_num
end

function This:getPriceType()
    return self.m_config.price_type
end

function This:getPrice()
    return self.m_config.prop_price1[self.m_buyTime + 1]
end

function This:getName()
    return self.m_config.name
end

function This:getItemImage()
    return ItemUtil.getIconImage(self.m_itemId)
end

function This:getItemQulityImage()
    return ItemUtil.getQualityImage(self.m_itemId)
end

function This:getQuality()
    return ItemUtil.getQuality(self.m_itemId)
end

function This:getPriceTypeImage()
    local itemId = 100 + self.m_config.price_type
    return  ItemUtil.getIconImage(itemId)
end




--获取配置信息region end

--endregion