-- @Author: superm
-- @Date:   2018-11-13 17:40:16
-- @Last Modified by:   superm
-- @Last Modified time: 2018-11-30 12:19:19
-- @File Name: TerrBarrackShopView.lua
-- @Description: 

local This , super = class(...,"NodeView")
local GamePlayer = require("Player.GamePlayer")
local GameUtil = require("Util.GameUtil")
local Timer = require("Timer")

local kShowSeconds = 5 
local kHideSeconds = 3

local showText = {
	Serialize[64453],
	Serialize[64454],
	Serialize[64455]
}

function This:initData( info)
	self.m_map = info.map
	self.m_cityId = info.cityId
	self:initNode()
end

function This:initNode()
	self.m_map:onWarShopRequest()-- 测试
	self.m_ratingData = self.m_map:getGameWarShopData()
	self.m_csNode = cc.Node:createFromCSFile("LegionScene/NodeUI/LegionShopNode.csb")
	self:addChild(self.m_csNode)
	

	local skeletonNode = cc.SkeletonNode:createCharacter("ShangRen")
	skeletonNode:scheduleUpdate()
	self:scheduleUpdate()
	self.m_csNode:addChild(skeletonNode,-1)

	self.m_csNode.name:setString(Serialize[64456])
	self.m_csNode.node:setCascadeOpacityEnabled(true)
	self.m_csNode.node:setOpacity(0)


	self.m_isVisible = false
	self.m_skeleton = skeletonNode
	self.m_escape = 15
	self.m_timeEscape = 0
	self.warShopStart = false
	self.m_timer = Timer:create(self)
end

function This:initTouchEvent()
	self:setTouch({
		onEnded = function()
			print("点击商店")
			self.m_map:onWarShopRequest()-- 测试
			if self.m_ratingData:getWarShopkey() == 0 then
				local fightData = os.date("*t",self.m_ratingData:getOverTime())
				local curData = os.date("*t",GamePlayer:getServerTime())
				local tex
				if fightData.day ~= curData.day then
					tex =Serialize[64457]
				else
					tex =Serialize[64458]
				end
				local res =  GameUtil:formatDate(Serialize["H_M_S"],self.m_ratingData:getOverTime())
				g_scene:showTips(string.format(Serialize[64456]..tex..Serialize[64459],res))
			else
				g_scene:openDialog("FamilyRating.FamilyWarShopPanel",{cityId = self.m_cityId,map = self.m_map})
			end
		end,
		isDynamic = true,
		sizeNode = self.m_csNode.dikuang
	})
end

function This:appearWithIdleText()
	local index = math.random(1,#showText)
	self:appear(showText[index])
end

function This:onEnter()
	self:initTouchEvent()
	self.m_map:addObserver(self)
end

function This:onExit()
	self.m_map:removeObserver(self)
end

function This:appear( str )
	self.m_csNode.node.speek:setString(str, 600)
	local w , h = self.m_csNode.node.speek:getContentSize()
	local scale = self.m_csNode.node.speek:getScale()
	w , h = w * scale + 15 , h * scale + 40

	self.m_csNode.node.bg:setContentSize(w ,h)

	self.m_csNode.node.bg:setPosition(w / 2, h / 2)
	local x , y = self.m_csNode.node.bg:getPosition()
	self.m_csNode.node.speek:setPosition(w/2 , h/2 + 10)
	self.m_csNode.node:runAction(cc.FadeIn(0.5))
	self.m_isVisible = true
end

function This:appearWithIdleText()
	local index = math.random(1,#showText)
	self:appear(showText[index])
end

function This:disappear()
	self.m_csNode.node:runAction(cc.FadeOut(0.5))
	self.m_isVisible = false
end

function This:onWarShopStart()
	self.m_escape = 0
	self:appearWithIdleText()
	self.warShopStart = true
end

function This:onWarShopEnd()
	self.m_escape = 0
	self:disappear()
	self.warShopStart = false
end

function This:onWarShopUpdate(  )
	self:updateLabel()
end

function This:updateLabel()
	if self.m_isVisible then
		self.m_escape = self.m_escape + 1
		if self.m_escape >= kShowSeconds then
			self.m_escape = 0
			self:disappear()
		end
	else
		self.m_escape = self.m_escape + 1
		if self.m_escape >= kHideSeconds then
			self.m_escape = 0
			self:appearWithIdleText()
		end
	end
end

function This:update( dt )
	self.m_timeEscape = self.m_timeEscape + dt
	if self.m_timeEscape >= 1 then
		self.m_timeEscape = self.m_timeEscape - 1
		if self.warShopStart then
			self:updateLabel()
		end
	end
end

