-- @Author: superm
-- @Date:   2018-06-25 11:59:08
-- @Last Modified by:   zheng
-- @Last Modified time: 2019-07-18 22:58:10
-- @File Name: TerrBlackSmithMWenWokerNode.lua
-- @Description: 

local This = class(...)
local GameUtil = require("Util.GameUtil")
local WorkerPriceConfig = require("Metadatas.WorkerPriceConfig")
local InscriptionCreatorConfig = require("Metadatas.InscriptionCreatorConfig")

function This:create(...)
	local o = {}
	setmetatable(o,self)
	o:init(...)
	return o
end

function This:init(info)
    self.m_csNode = info.node
    self.m_csParentNode = info.parent
    self.m_build = info.build

	self:initNode()
	-- self:initTouchEvent()
end

function This:initNode()
    self:refresh()
end

function This:onEnter()
end

function This:onExit()
	self:setWorker()
end

-- 融合剂 
function This:refresh()
	if self.m_runningAnimate then
		return
	end

	local hasWorker, worker = self.m_build:hasPloyWorkerForEquip()
	self.m_csNode.yiguyong:setVisible(hasWorker)
	self.m_csNode.weiguyong:setVisible(not hasWorker)
	if hasWorker then 
		self.m_csNode.yiguyong.gytime:setString(GameUtil:formatTime("H", InscriptionCreatorConfig[1].derate))
		self.m_csNode.yiguyong.rhstime:setString(Serialize[64484]..self.m_build:getHireNpcTimeForEquip())
	end
	self.m_hasWorker = hasWorker
	self:setWorker(worker)
end

function This:updateWorkerTime( leftTime )
	if leftTime > 0 then
		self.m_csNode.yiguyong.rhstime:setString(GameUtil:formatTime(Serialize["H_M_S"], leftTime))
	end
end

function This:onWorkerUpdateEnd()
    self.m_polyInfo = self.m_build:getMwPolyInfo()
    if self.m_polyInfo then
    	self.m_polyInfo:notifyObservers("onWorkerUpdateEnd")
    end
    self:refresh()
end

function This:setWorker( worker )
	if self.m_worker ~= worker then
		if self.m_worker then
			self.m_worker:removeObserver(self)
		end
		self.m_worker = worker
		if self.m_worker then
			self.m_worker:addObserver(self)
		end
	end 
end

function This:speakRandom( timestamp )
    local index = (timestamp or 0) % 3 + 1
    local node = self.m_csNode.yiguyong.guyongtime
	local textNode = self.m_csNode.yiguyong.gytime
    if node then
		self.m_runningAnimate = true
	    node:stopAllActions()
	    node:setVisible(true)
	    textNode:setVisible(false)
	    node:setOpacity(0)
	    node:setString(Serialize[ "black_smith_sp" .. index])
	    node:runAction(cc.Sequence(
	    cc.FadeIn(0.4),
		cc.DelayTime(1.8), 
		cc.CallFunc(function ()
			textNode:setVisible(true)
			self.m_runningAnimate = false
			self:refresh()
	    end)))
	end
end