-- @Author: superm
-- @Date:   2018-06-23 12:36:13
-- @Last Modified by:   superm
-- @Last Modified time: 2018-06-25 15:38:55
-- @File Name: TerrBlackSmithWorkerPanel.lua
-- @Description: 

local This, super = class(...,"Dialog")
local GameUtil = require("Util.GameUtil")
local GamePlayer = require("Player.GamePlayer")
local WorkerFrequencyPriceConfig = require("Metadatas.WorkerFrequencyPriceConfig")
local WorkerPriceConfig = require("Metadatas.WorkerPriceConfig")
local InscriptionCreatorConfig = require("Metadatas.InscriptionCreatorConfig")

function This:initNode(info)
	self.m_build = info.build
	self.isEquipMake = info.isEquipMake
    self.m_csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/BlackSmithFusingMaster.csb")
	self:addChild(self.m_csNode)
    self.m_csNode:setToCenter()
    -- self.m_csNode.rongheshi.tips:setString(Serialize[64493])
	-- self.m_csNode.title:setString(Serialize[64494])
	if not self.isEquipMake then
		self.m_csNode.rongheshi.tips:setString(Serialize[64495])
		self.m_csNode.title:setString(Serialize[64496])
		for i = 1,3 do
        	self.m_csNode["item" .. i].zhikou.discount:setString( GameUtil:discountStr(WorkerFrequencyPriceConfig[i].discount) )
        	self.m_csNode["item" .. i].button.text:setString(WorkerFrequencyPriceConfig[i].price[2])
    	end
	else
		self.m_csNode.rongheshi.tips:setString(Serialize[64493])
		self.m_csNode.title:setString(Serialize[64494])
		for i = 1,3 do
        	self.m_csNode["item" .. i].zhikou.discount:setString( GameUtil:discountStr(InscriptionCreatorConfig[i].discount) )
        	self.m_csNode["item" .. i].button.text:setString(InscriptionCreatorConfig[i].price[2])
    	end
	end

--
--    self.m_id = 1
--    if info then
--    	self.m_id = info.id or 1
--    end
--    self.m_woker = self.m_build:getWorker(self.m_id)
--	self.m_priceInfo = self.m_woker:getPrice()
--    self.m_csNode.button.number:setString(self.m_priceInfo[2])
--    self.m_csNode.rongheshi.rongheshiname:setString(self.m_woker:getName())
--    self.m_csNode.rongheshi.time:setString(GameUtil:formatTime(Serialize[60148], self.m_woker:getCDTotalTime()))
--    self.m_csNode.rongheshi.tips:setString(Serialize[64497] .. GameUtil:formatTime(Serialize[60148], self.m_woker:getDerateTime()))
end

function This:onEnter()
    super.onEnter(self)
	if self.m_build then
		-- self.m_build:onCheckHireInfo()
		self.m_build:addObserver(self)
	end
end

function This:onExit()
	if self.m_build then
		self.m_build:removeObserver(self)
	end
    super.onExit(self)
end

function This:initTouchEvent()
    for i = 1,3 do
        self.m_csNode["item" .. i].button:setTouchEnded(function ()
        	local buyCost = nil
        	if self.isEquipMake then
        		buyCost = InscriptionCreatorConfig[i].price[2]
        	else
        		buyCost = WorkerFrequencyPriceConfig[i].price[2]
        	end
		GamePlayer:costDiamond({
			cost = buyCost,
			title = Serialize[60495],
			desc = Serialize[60495] .. InscriptionCreatorConfig[i].frequency .. Serialize[60532],
			okHandler = function()
				if self.m_build then
					if not self.isEquipMake then
						self.m_build:onBuyHireTimesRequest(i)
					else
						self.m_build:onBuyHireTimesRequestForEquip(i)
					end
				end
			end
		})

        end)
    end
    
  
	self.m_csNode.closebutton:setTouchEnded(function()
		self:close()
	end)
end

function This:onHirePolymerization()
	self:close()
end
