--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"Territory.TerrQueue")
local GamePlayer = require("Player.GamePlayer")
local TerrBuildQueueConfig = require("Metadatas.TerrBuildQueueConfig")

function This:create(...)
	local ret = {}
	setmetatable(ret,self)
	ret:init(...)
	return ret
end

function This:initBeforeUpdateState(info, createHandler)
	self.m_object = nil

	if createHandler then
		for _, buildInfo in ipairs(info.building_list) do
			local id, build = createHandler(buildInfo, self)
            if build:isUpgrading() then
			    self.m_object = build
            end
		end
	end

	if not self.m_config then
		self.m_config = TerrBuildQueueConfig[self.m_index]
	end
end

function This:selfUpdateInfo(info, createHandler)
	self:initBeforeUpdateState(info, createHandler)
end

function This:isNeedBuyValid()
	return true
end

function This:needBuy()
	if self.m_upStartTime < 0 and self.m_upEndTime < 0 then
		return false
	end
	return true
end

function This:getBuyCost(buyDays, idx)
	local field = {
		[1]="one_day",[7]="seven_day",
	}
	if not idx or idx <= 0 then
		return TerrBuildQueueConfig[self.m_index][field[buyDays]]
	else
		return TerrBuildQueueConfig[idx][field[buyDays]]
	end
end

function This:getBuildLeftTime()
	local leftTime = 0
	if self.m_object then
		leftTime = self.m_object:getLeftTime()
	end
	return leftTime
end

function This:getUpgradingBuild()
	if self.m_object and self.m_object:isUpgrading() then
		return self.m_object
	end
	return
end

function This:isEmpty()
    return self.m_object == nil or not self.m_object:isUpgrading()
end

function This:getUpgradingBuildInFreeTime()
	if self.m_object and self.m_object:isUpgrading() and self.m_object:isInFreeTime() then
		return self.m_object
	end
	return
end

function This:getBuild()
    return self.m_object
end

function This:isVipBuildQueue()
	return self:getId() == kTerrVipBuildQueueId  
end

--获取配置信息region begin

--获取配置信息region end

--endregion