--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"cc.Node")
local Timer = require("Timer")
local TerrBuildManager = require("Territory.TerrBuildManager")
local PrivilegeManager = require("Vip.PrivilegeManager")
local GamePlayer = require("Player.GamePlayer")
local ItemUtil = require("Bag.ItemUtil")
local GameUtil = require("Util.GameUtil")
local EventDispatcher = require("EventDispatcher")

function This:init(build)
    self.m_build = build
    self.m_build:updateState()
    self.m_hasFuncQueue = build:hasFuncQueue()
    self.m_hasHelpList = build:hasHelpList()
    self.m_hasProduction = self.m_build:hasProduction()
    self.m_buildId = self.m_build:getConfigId()
    self.m_resEscape = 0
    self.m_upIconVisible = false
    self.m_effectBuilding = nil
    self.m_effectProduct = nil
    self.m_clickView = nil
    local csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/Building1.csb")
    self.m_csNode = csNode
    self:addChild(csNode)

    local titleNode = csNode.title
    local rollNode = csNode.roll

    titleNode.name:setString(self.m_build:getName())

    local w, h = rollNode.reward:getContentSize()
    rollNode:setContentSize(w, h)
    rollNode.reward:setPosition(w / 2, h / 2)
    rollNode.mianfei:setPosition(w / 2, h / 2)
    rollNode.mianfei:setScale(1.15)
    rollNode.help:setPosition(w / 2, h / 2)
    rollNode.func:setPosition(w / 2, h / 2)
    rollNode.func.icon:setScale(0.85)

    rollNode:setAnchorPoint(0.5, 0.1)

    csNode.GongNeng:setVisible(false)
    self:setScale(0.85)
    
    local visible = self:refreshTimeNode(self.m_build:getLeftTime())
    local level = self.m_build:getLevel()
    if self.m_hasProduction then
        local id = self.m_build:getProduction()
        if id and id > 0 then
            rollNode.reward.icon:setImage(ItemUtil.getIconImage(id))
        end
    end

    self.m_timer = Timer:create(self)
    self:scheduleUpdate()
end

function This:setPositionBy( view ) 
    local posInfo = TerrBuildViewPosition[self.m_buildId]
    local posX, posY = view:getPosition()
    if posInfo then
        self:setPosition(posX + posInfo.offset.x, posY + posInfo.offset.y)
        self.m_csNode.title:setPosition(posInfo.name.x, posInfo.name.y)
        self.m_csNode.JinDu:setPosition(posInfo.name.x, posInfo.name.y)
        self.m_csNode.GongNeng:setPosition(posInfo.menu.x, posInfo.menu.y)
        self.m_csNode.roll:setPosition(posInfo.roll.x, posInfo.roll.y)
    else
        self:setPosition(posX, posY)
    end
end

function This:setClickView( view )
    self.m_clickView = view
end

function This:isUpIconVisible()
    return self.m_upIconVisible
end

function This:getClickView()
    return self.m_clickView
end

function This:adjustZOrder( isToppest )
    if not self.m_build then
        return 
    end 

    if not isToppest then
        local zorder = TerrBuildZOrder[self.m_buildId]
        if not zorder then
            return
        end
        if self.m_clickView then
            self.m_clickView:setLocalZOrder(zorder)
        end
        self:setLocalZOrder(zorder)
    else
        -- if self.m_clickView then
        --     self.m_clickView:setLocalZOrder(kTerrBuildMaxZOrder)
        -- end
        self:setLocalZOrder(kTerrBuildMaxZOrder)
    end
end

function This:showLockedTips()
    local switch = {
        [TerrConditionType.kPlayerLev] = Serialize[64565],
        [TerrConditionType.kTerrMainBuildLev] = Serialize[64368],
    }
    local cond1, cond2 = self.m_build:getCondition()
    g_scene:showTips(switch[cond1] .. cond2 .. Serialize[64573])
    if self.m_selectHandler then
        self.m_selectHandler()
    end
end

function This:setSelectHandler( handler )
    self.m_selectHandler = handler
end

function This:setSelect( isSelected )
    -- print("setSelect  " .. tostring(isSelected) .. "：" .. self.m_build:getName())
    self:adjustZOrder(isSelected)
    if isSelected and self.m_build:isLocked() and self.m_build:getLevel() <= 0 then
        -- self:showLockedTips()
        self.m_csNode.GongNeng.bg1.m_touch:onEnded()
        return
    end

    if isSelected and not self.m_csNode.GongNeng.bg1:isVisible() then
        self.m_csNode.GongNeng.bg2.m_touch:onEnded()
    else
        self.m_csNode.GongNeng:setVisible(isSelected)
    end
end

function This:loadBuildingEffect()
    if not self.m_effectBuilding then
        self.m_effectBuilding = GameUtil:createEffect("Building", true, self)
        local posx, posy = self.m_csNode.JinDu.jiantou:getPosition()
        self.m_effectBuilding:setPosition(posx, posy)
        self.m_csNode.JinDu:addChild(self.m_effectBuilding)         
    end
end

function This:unloadBuildingEffect()
    if self.m_effectBuilding then
        self.m_effectBuilding:removeFromParent()
        self.m_effectBuilding = nil
    end
end

function This:loadBuildUpEffect()
    if not self.m_effectBuildUp then
        self.m_effectBuildUp = GameUtil:createEffect("BuildUp", false, self)
        self.m_effectBuildUp:setPosition(0, -100)
        self.m_csNode:addChild(self.m_effectBuildUp)             
    end

    self.m_timer:setTimer(1.5, function()
        self:unloadBuildUpEffect()
    end, "buildUp" .. tostring(self.m_build:getId()))
    cc.Audio:playEffect("building.mp3")
end

function This:unloadBuildUpEffect()
    if self.m_effectBuildUp then
        self.m_effectBuildUp:removeFromParent()
        self.m_effectBuildUp = nil
    end
end

function This:loadProductEffect()
    if not self.m_effectProduct then
        print("loadProductEffect")

        local parentNode = self.m_csNode.roll
        if parentNode.mianfei:isVisible() then
			EventDispatcher:dispatcher("roll_appear")
		end
        self.m_effectProduct = GameUtil:createEffect("Build1", true, self)
        local posx, posy = 43, 56.8
        self.m_effectProduct:setPosition(posx, posy)
        self.m_effectProduct:setScale(1)
        parentNode:addChild(self.m_effectProduct)
        parentNode:runActionByID("Roll")  
    end
end

function This:unloadProductEffect()
    if self.m_effectProduct then
        print("unloadProductEffect")
        local parentNode = self.m_csNode.roll
        if not parentNode.mianfei:isVisible() then
            EventDispatcher:dispatcher("roll_disappear")
        end
        parentNode:stopAllActions()
        self.m_effectProduct:removeFromParent()
        self.m_effectProduct = nil
    end
end

function This:onEnter()
    super.onEnter(self)
    self:adjustZOrder()
    self.m_build:addObserver(self)
    self.m_build:setView(self)
    self.m_build:updateState()

    GamePlayer:addObserver(self)
    TerrBuildManager:addObserver(self)
    self:initTouchEvent()
    self:refresh()
end

function This:onExit()
    super.onExit(self)
    self:setClickView(nil)
    self.m_build:setView(nil)
    self:unloadBuildingEffect()

    self.m_build:removeObserver(self)
    GamePlayer:removeObserver(self)
    TerrBuildManager:removeObserver(self)
end


function This:initTouchEvent()
    local csNode = self.m_csNode
    csNode.title.bg:setTouch({
        onEnded = function()
            -- print("点击：" .. self.m_build:getName())
            if self.m_build:isLocked() and self.m_build:getLevel() <= 0 then
                -- self:showLockedTips()
                self.m_csNode.GongNeng.bg1.m_touch:onEnded()
            else
                if self.m_selectHandler then
                    self.m_selectHandler(self)
                end
            end
        end,
        isDynamic = true
    })

    csNode.GongNeng.bg2:setTouch({
        onEnded = function()
            local request = self.m_build:getRequest()
            if request then
                request()
            end
        end,
        isDynamic = true
    })
    
    csNode.GongNeng.bg1:setTouch({
        onEnded = function()
            local request = self.m_build:getRequest(TerrBuildRequestMode.kUpgrade)
            if request then
                request()
            end
            if self.m_selectHandler then
                self.m_selectHandler()
            end
        end,
        isDynamic = true
    })

    csNode.roll.mianfei:setTouch({
        onEnded = function()
            self.m_build:requestAccerlate(TerrAccelerateSkipMode.kInFreeTime)
        end,
        isDynamic = true
    })

    csNode.roll.reward:setTouch({
        onEnded = function()
            self.m_build:requestonGetReward(true)
        end,
        isDynamic = true
    })
end

function This:refresh(delay)
    -- print("----build---".. self.m_build:getConfigId() .. "----------------------------refresh(delay)")
    local function update() 
        local visible = false
        local csNode = self.m_csNode
        local titleNode = csNode.title
        local rollNode = csNode.roll

        csNode.GongNeng:setVisible(false)
        local buildLevel = self.m_build:getLevel()
        local buildLevel = self.m_build:getLevel()
        if self.m_build:isLocked() and buildLevel <= 0 then
            self.m_upIconVisible = false
            csNode.JinDu:setVisible(false)
            rollNode.mianfei:setVisible(false)
            rollNode.help:setVisible(false)

            titleNode.lock:setVisible(true)
            titleNode.bg:setVisible(true)
            titleNode.name:setVisible(true)
            titleNode.level:setVisible(false)
            titleNode.levelbg:setVisible(true)
            titleNode.up:setVisible(false)
            self:unloadBuildingEffect()
        else
            titleNode.lock:setVisible(false)
            titleNode.bg:setVisible(true)
            titleNode.level:setVisible(true)
            titleNode.levelbg:setVisible(true)
            self.m_upIconVisible = self.m_build:canUpgrade()
            titleNode.up:setVisible(self.m_upIconVisible)
            titleNode.name:setVisible(true)

            rollNode.mianfei:setVisible(false)
            rollNode.help:setVisible(false)
            rollNode.reward:setVisible(false)
            rollNode.func:setVisible(false)
            local isUpgrading = self.m_build:isUpgrading()
            if isUpgrading then
                visible = self:refreshTimeNode(self.m_build:getLeftTime())

                csNode.JinDu:setVisible(true)
                titleNode.bg:setVisible(false)
                titleNode.level:setVisible(false)
                titleNode.levelbg:setVisible(false)
            else
                self:unloadBuildingEffect()
                rollNode.mianfei:setVisible(false)
                csNode.JinDu:setVisible(false)
            end
            csNode.title.level:setString("" .. buildLevel)
            self:refreshMenuUI()
            if buildLevel > 0 then
                if self.m_hasHelpList then
                    visible = visible or self:checkHelpList()
                end

                if self.m_hasProduction then
                    visible = visible or self:checkProduction()
                end

                if self.m_hasFuncQueue then
                    visible = visible or self:checkFuncReward()
                end
            end
        end

        local value
        if self.m_upIconVisible then
            value = 15000 + kTerrMaxBuildId  - buildLevel * 100 - self.m_buildId
        end
        TerrBuildManager:setUpgradeList(self.m_buildId , value)

        if visible then
            self:loadProductEffect()
        else
            self:unloadProductEffect()
        end
    end

    if delay then
        self.m_timer:setTimer(delay,function()
            update()
        end, "building" .. tostring(self.m_build:getId()))
    else
        update()
    end
end

function This:updateTime(leftTime)
    local curVisible = self.m_csNode.roll.mianfei:isVisible() 
    local visible = self:refreshTimeNode(leftTime)
    if leftTime <= 0 then
        self:refresh()
    elseif visible and curVisible ~= visible then
        self:loadProductEffect()
    end
end

function This:refreshViewEffect(needChecked)
    local rollNode = self.m_csNode.roll

    local visible = curVisible
    if needChecked then
        visible = rollNode.mianfei:isVisible()
    end

    rollNode.help:setVisible(false)
    if self.m_hasHelpList then
        visible = visible or self:checkHelpList()
    end

    rollNode.reward:setVisible(false)
    if self.m_hasProduction then
        visible = visible or self:checkProduction(needChecked)
    end

    rollNode.func:setVisible(false)
    if self.m_hasFuncQueue then
        visible = visible or self:checkFuncReward()
    end

    if needChecked then
        if visible then
            self:loadProductEffect()
        else
            self:unloadProductEffect()
        end
    else
        self.m_resEscape = self.m_build:getProductTime() % kTerrBuildProductIntervalInView
    end
    return ret
end

function This:checkHelpList()
    return false
end

function This:checkProduction(needChecked)
    local rewardNode = self.m_csNode.roll.reward
    local ret = false
    local id, num = self.m_build:getCurProduction()
    if num > 0 then
        rewardNode:setVisible(true)
        rewardNode.text:setString(tostring(num))
        ret = true
    else
        rewardNode:setVisible(false)
    end

    if needChecked then
        self.m_resEscape = self.m_build:getProductTime() % kTerrBuildProductIntervalInView
    end
    return ret
end

function This:checkFuncReward()
    return false
end

function This:refreshTimeNode(leftTime)
    if leftTime > 0 then
        self.m_csNode.JinDu.time:setString(GameUtil:formatTime(Serialize["H_M_S"],leftTime))
        local progress = 100 - self.m_build:getProgress() * 100.0
        self.m_csNode.JinDu.jindu2:setPercent(progress)

        local visible = leftTime <= PrivilegeManager:getPrivilegeNumBy(Privilege.kBuildTime)
        self.m_csNode.roll.mianfei:setVisible(visible)
        self:loadBuildingEffect()
        if visible then
            local queue = self.m_build:getQueue()
            if queue then
                queue:notifyObservers("onQueueUpgradeFree")
            end
        end
        return visible
    else
        self.m_csNode.roll.mianfei:setVisible(false)
        self:unloadBuildingEffect()
        return false
    end
end

function This:refreshMenuUI()
    if self.m_build:getLevel() > 0 then
        local default = self.m_build:getRequestNameBy()
        local name = self.m_build:getRequestName()
        for i=1, 2 do
            self.m_csNode.GongNeng["bg" .. 1]:setVisible(false)
            self.m_csNode.GongNeng["Text_" .. 1]:setVisible(false)
        end

        if not self.m_build:hasFunctions() then
            self.m_csNode.GongNeng.bg2:setVisible(true)
            self.m_csNode.GongNeng.Text_2:setVisible(true)
            -- if isUpgrading then
            --     self.m_csNode.GongNeng.Text_2:setImage(name)
            -- else
            --     self.m_csNode.GongNeng.Text_2:setImage(default)
            -- end
        else
            for i=1, 2 do
                self.m_csNode.GongNeng["bg" .. i]:setVisible(true)
                self.m_csNode.GongNeng["Text_" .. i]:setVisible(true)
            end
            self.m_csNode.GongNeng.Text_1:setImage(default)
            self.m_csNode.GongNeng.Text_2:setImage(name)
        end
    end
end

function This:update(dt)
    self.m_timer:update(dt)
    if self.m_hasProduction and self.m_build:getLevel() > 0 then
        self.m_resEscape = self.m_resEscape + dt
        
        -- if self.m_build:getConfigId() == 14 then
        --     if not self.m_resEscapeInTest then
        --         self.m_resEscapeInTest = self.m_resEscape + dt
        --     else
        --         self.m_resEscapeInTest = self.m_resEscapeInTest + dt
        --     end
        --     if self.m_resEscapeInTest >= SECONDS_PER_MIN then
        --         self.m_resEscapeInTest = self.m_resEscapeInTest - SECONDS_PER_MIN
        --         print( string.format("%s刷新的时间:%2d分钟", self.m_build:getName(), math.floor(self.m_resEscape/SECONDS_PER_MIN)) )
        --     end
        -- end

        if self.m_resEscape >= kTerrBuildProductIntervalInView then
            self.m_resEscape = self.m_resEscape - kTerrBuildProductIntervalInView
            self:refreshViewEffect(true)
        end
    end
end

function This:onPlayerAttrChanged(field, oldValue, value)
    if field == PlayerAttr.level then
        local isChanged = self.m_build:updateState()
        if isChanged then
            self.m_hasFuncQueue = self.m_build:hasFuncQueue()
            self.m_hasHelpList = self.m_build:hasHelpList()
            self:refresh()
        end
    end
end

function This:onBuildUpAccelerate( buildId )
    if self.m_buildId == buildId then
        self:refresh()
    end
end

function This:onGetBuildGeneralReward( buildId )
    if self.m_buildId == buildId then
        self:refresh()
    end
end

function This:onBuildUpFinish( buildId )
    if self.m_buildId == buildId then
        self:refresh()
        self:loadBuildUpEffect()
    elseif self.m_build:getTypeBy(buildId) == TerrBuildType.kGuanfu then
        self:refresh()
    end
end

function This:onBuildUpgrade( buildQueueId )
    if self.m_build:getQueueId() == buildQueueId then
        self:refresh()
    end
end


function This:setTitleVisible( value, delay )
    if self.m_titleVisible ~= value then
        self.m_titleVisible = value
        if delay then
            self.m_timer:setTimer(delay,function()
                self.m_csNode.title:setVisible(value)
            end, "building_tile" .. tostring(self.m_build:getId()))
        else
            self.m_csNode.title:setVisible(value)
        end
    end
end

function This:hide()
    self:setTitleVisible( false, 0.2 )
end

function This:show()
    self:setTitleVisible( true, 0.2 )
end



--endregion