-- @Author: superm
-- @Date:   2018-09-26 11:54:32
-- @Last Modified by:   superm
-- @Last Modified time: 2019-12-12 16:27:45
-- @File Name: TerrBuildingDianFengJingJi.lua
-- @Description: 

local This , super = class(..., "Territory.TerrBuild")
local TerrBuildViewWithFunc = require("Territory.TerrBuildViewWithFunc")
local Socket = require("Net.Socket")
local PeakContestManager = require("PeakContest.PeakContestManager")
local EventDispatcher = require("EventDispatcher")

function This:createView()
    self:onGetChallengeInfoRequest(false)
    return TerrBuildViewWithFunc:create(self)
end

function This:hasListener()
    return true
end

function This:hasFunctions()
    return false
end

function This:hasHelpList()
    return PeakContestManager:isOpen(), "MenuScene/wordketiaozhan1.png"
end


function This:getHelpListCount()
    local ratingData = PeakContestManager:getPeakContestData()
    return ratingData:getChallengeTimes()
end

function This:onHelpFuncionEvent()
    local func = self:getRequest()
    if func then
        func()
    end
end

function This:getCondition()
    local conds = self:getConditions()
    if conds then
        return conds[1], conds[2]
    end
    return nil, nil
end

function This:getConditions()
    return {1,self.m_descConfig.open_level}
end

function This:hasProduction()
	return false
end

function This:getName()
    return self.m_descConfig.name
end

function This:getRequest(mode)
    local requestMode = mode or TerrBuildRequestMode.kOther
    if requestMode == TerrBuildRequestMode.kUpgrade then
    	local _, level = self:getCondition()
    	g_scene:showTips(string.format(Serialize[61296], level)) 
        return
    else
        if not self.m_clickFunc then
            self.m_clickFunc = function()
                g_scene:openDialog("PeakContest.PeakContestPanel")
            end
        end
        return self.m_clickFunc
    end
end

function This:initListener()
    EventDispatcher:addListener(self, "day_passed", self.onDayPassed)
    EventDispatcher:addListener(self, 13200,self.onGetChallengeInfoReply)
    EventDispatcher:addListener(self, 13203,self.onGetChallengeInfoReply)
    EventDispatcher:addListener(self, 13205,self.onGetChallengeInfoReply)
end

function This:removeListener()
    EventDispatcher:removeListener(self, "day_passed")
    EventDispatcher:removeListener(self, 13200)
    EventDispatcher:removeListener(self, 13205)
end



----------------------------------------------------------------------------
function This:onDayPassed()
    self:onGetChallengeInfoRequest(true)
end

function This:onGetChallengeInfoRequest(slient)
    if not slient then
        Socket:sendAndLock(13200)
    else
        Socket:send(13200)
    end
end

function This:onGetChallengeInfoReply( msg )
    local ratingData = PeakContestManager:getPeakContestData()
    local num
    if msg.challenge_times then
        num = msg.challenge_times
    else
        num = msg.challenge_time
    end
    ratingData:setChallengeTimes(num)
    self:notifyObservers("onGetBuildHelpInfo", self:getId())
end