-- @Author: superm
-- @Date:   2018-09-26 11:54:32
-- @Last Modified by:   superm
-- @Last Modified time: 2019-12-12 16:30:34
-- @File Name: TerrBuildingJingJi.lua
-- @Description: 

local This , super = class(..., "Territory.TerrBuild")
local TerrBuildViewWithFunc = require("Territory.TerrBuildViewWithFunc")
local Socket = require("Net.Socket")
local PeakContestManager = require("PeakContest.PeakContestManager")
local EventDispatcher = require("EventDispatcher")
local ArenaManager = require("Arena.ArenaManager")

function This:createView()
    -- self:onGetChallengeInfoRequest(false)
    -- self:initListener()
    return TerrBuildViewWithFunc:create(self)
end

function This:hasFunctions()
    return false
end

function This:hasHelpList()
    return ArenaManager:isArenaOpened(), "MenuScene/wordketiaozhan1.png"
end


function This:getHelpListCount()
    return ArenaManager:getLeftChallengeTimes()
end

function This:onHelpFuncionEvent()
    local func = self:getRequest()
    if func then
        func()
    end
end

function This:getCondition()
    local conds = self:getConditions()
    if conds then
        return conds[1], conds[2]
    end
    return nil, nil
end

function This:getConditions()
    return {1,self.m_descConfig.open_level}
end

function This:hasProduction()
	return false
end

function This:getName()
    return self.m_descConfig.name
end

function This:getRequest(mode)
    local requestMode = mode or TerrBuildRequestMode.kOther
    if requestMode == TerrBuildRequestMode.kUpgrade then
    	local _, level = self:getCondition()
    	g_scene:showTips(string.format(Serialize[61296], level)) 
        return
    else
        if not self.m_clickFunc then
            self.m_clickFunc = function()
                if ArenaManager:isArenaOpened(true) then
                    g_scene:openDialog("Arena.ArenaPanel")
                end
            end
        end
        return self.m_clickFunc
    end
end