-- @Author: su
-- @Date:   2019-02-28 16:14:00
-- @Last Modified by:   zheng
-- @Last Modified time: 2019-11-06 17:57:06
-- @File Name: TerrBuildingWuDaoShangDian.lua
-- @Description: 
local This , super = class(...,"Territory.TerrBuild")
local ArgConfig = require("Metadatas.ArgConfig")
local NewActivityManager = require("NewActivity.NewActivityManager")

local kShowSeconds = 5
local kHideSeconds = 3

local ShowTextList = 
{
	Serialize[64533],
	Serialize[64534],
	Serialize[64535],
	Serialize[64536],
}

local ShowBuyTextList = 
{
	Serialize[64537],
	Serialize[64538],
	Serialize[64539]
}

local TerrBuildViewWithFunc = require("Territory.TerrBuildViewWithFunc")

function This:createView()
    local view = TerrBuildViewWithFunc:create(self)
    view:runAction(cc.RepeatForever(cc.Sequence( cc.DelayTime(10), cc.CallFunc(function ()
            self:notifyObservers("onGetBuildHelpInfo", self:getId())
        end))))
    return view
end

function This:hasFunctions()
    return false
end

function This:hasHelpList()
    return self:isLocked(), "MenuScene/wordyikaiqi.png"
end


function This:getHelpListCount()
    self.m_model = NewActivityManager:getActivity(NewActivityType.kWuDaoShop1)
    if self.m_model:getState() == NewActivityState.kUpdating then
        return 1
    end
    return 0
end

function This:onHelpFuncionEvent()
    local func = self:getRequest()
    if func then
        func()
    end
end

function This:getCondition()
    local conds = self:getConditions()
    if conds then
        return conds[1], conds[2]
    end
    return nil, nil
end

function This:getConditions()
    return {1,self.m_descConfig.open_level}
end

function This:hasProduction()
	return false
end

function This:getName()
    return self.m_descConfig.name
end

function This:getRequest(mode)
    local requestMode = mode or TerrBuildRequestMode.kOther
    if requestMode == TerrBuildRequestMode.kUpgrade then
    	local _, level = self:getCondition()
    	g_scene:showTips(Serialize[64521] .. level .. Serialize[60394]) 
        return
    else
        if not self.m_clickFunc then
            self.m_clickFunc = function()
                self.m_model = NewActivityManager:getActivity(NewActivityType.kWuDaoShop1)
                local ret , season = self.m_model:isLevelOpen() 
                if not ret then
                    g_scene:showTips(season)
                    return
                end
                if self.m_model:getState() == NewActivityState.kUpdating then
                    g_scene:openDialog("NewActivity.WudaoShopPanel")
                else
                    g_scene:showTips(Serialize[62062])
                end
            end
        end
        return self.m_clickFunc
    end
end