-- @Author: superm
-- @Date:   2019-12-11 14:09:39
-- @Last Modified by:   superm
-- @Last Modified time: 2019-12-12 21:46:50
-- @File Name: TerrBuildingYiJi.lua
-- @Description: 

local This , super = class(..., "Territory.TerrBuild")
local TerrBuildViewWithFunc = require("Territory.TerrBuildViewWithFunc")
local ExpeditionManager = require("Expedition.ExpeditionManager")
local NewActivityManager = require("NewActivity.NewActivityManager")
local GameUtil = require("Util.GameUtil")
local ArgConfig = require("Metadatas.ArgConfig")

function This:createView()
	local view = TerrBuildViewWithFunc:create(self)
    local csNode = view.m_csNode 
    local buildview = GameUtil:createEffect("JianTa", true, kuang, nil, nil, nil)
    csNode:addChild(buildview)
    buildview:setPositionY(-150)
    buildview:setLocalZOrder(9)
    csNode.title:setLocalZOrder(10)
    return view
end

function This:hasListener()
    return true
end

function This:hasFunctions()
    return false
end

function This:hasHelpList()
    return true, "MenuScene/wordketiaozhan1.png"
end

function This:getHelpListCount()
    local chapter = ExpeditionManager:getCurChapter()
    if chapter then
        if not chapter:isFinish() or chapter:hasNext() then
            return 1
        end
    end
    return 0
end

function This:onHelpFuncionEvent()
    local func = self:getRequest()
    if func then
        func()
    end
end

function This:initListener()
    ExpeditionManager:addObserver(self)
end

function This:removeListener()
    ExpeditionManager:removeObserver(self)
end

function This:getCondition()
    local conds = self:getConditions()
    if conds then
        return conds[1], conds[2]
    end
    return nil, nil
end


function This:getConditions()
    return {1, ArgConfig["remains_openlevel"].arg[1]}
end

function This:hasProduction()
	return false
end

function This:getName()
    return self.m_descConfig.name
end

function This:getRequest(mode)
    local requestMode = mode or TerrBuildRequestMode.kOther
    if requestMode == TerrBuildRequestMode.kUpgrade then
    	local _, level = self:getCondition()
    	g_scene:showTips(Serialize[64521] .. level .. Serialize[60394]) 
        return
    else
        if not self.m_clickFunc then
            self.m_clickFunc = function()
                local queue = NewActivityManager:getActivity(NewActivityType.kExpedition)
                if not queue then
                    return
                end
                local state = queue:getState()
                if state == NewActivityState.kNotOpen then
                    g_scene:showTips(Serialize[64545])
                elseif state == NewActivityState.kNotStart then
                    g_scene:showTips(GameUtil:formatDate(Serialize[64542], queue:getStartTime()))
                elseif state == NewActivityState.kEnded then
                    g_scene:showTips(GameUtil:formatDate(Serialize[64543], queue:getEndTime()))
                else
                    g_scene:openDialog("Expedition.ExpeditionPanel", {
                    	queue = queue,
                    	play = true
                    })
                end
            end
        end
        return self.m_clickFunc
    end
end

function This:onGetExpeditionInfo()
    self:notifyObservers("onGetBuildHelpInfo", self:getId())
end