-- @Author: superm
-- @Date:   2018-12-25 20:14:00
-- @Last Modified by:   superm
-- @Last Modified time: 2019-12-14 16:08:19
-- @File Name: TerrBuildingZhanYiTa.lua
-- @Description: 

local This , super = class(..., "Territory.TerrBuild")
local ArgConfig = require("Metadatas.ArgConfig")
local WarfareManager = require("Warfare.WarfareManager")

local TerrBuildViewWithFunc = require("Territory.TerrBuildViewWithFunc")
local WarTowerManager = require("SingleDaily.WarTowerManager")
local GamePlayer = require("Player.GamePlayer")
local EventDispatcher = require("EventDispatcher")

function This:createView()
    return TerrBuildViewWithFunc:create(self)
end

function This:hasListener()
    return true
end

function This:hasFunctions()
    return false
end

function This:hasHelpList()
    return not self:isLocked(), "MenuScene/wordkelingqu1.png"
end

function This:getHelpListCount()
    if WarTowerManager:isHaveReward() then
        return 1
    end
    return 0
end

function This:onHelpFuncionEvent()
    local func = self:getRequest()
    if func then
        func()
    end
end

function This:getCondition()
    local conds = self:getConditions()
    if conds then
        return conds[1], conds[2]
    end
    return nil, nil
end

function This:getConditions()
    return {1, ArgConfig.drum_open_level.arg[1]}
end

function This:hasProduction()
	return false
end

function This:getName()
    return self.m_descConfig.name
end

function This:getRequest(mode)
    local requestMode = mode or TerrBuildRequestMode.kOther
    if requestMode == TerrBuildRequestMode.kUpgrade then
    	local _, level = self:getCondition()
    	g_scene:showTips(Serialize[64521] .. level .. Serialize[60394]) 
        return
    else
        if WarfareManager:hasTeam() then
            g_scene:showTips(Serialize[64547])
            return 
        else
            if not self.m_clickFunc then
                self.m_clickFunc = function()
                    g_scene:openDialog("SingleDaily.WarTowerMainPanel")
                end
            end
            return self.m_clickFunc
        end
    end
end

function This:initListener()
    WarTowerManager:addObserver(self)
    GamePlayer:addObserver(self)
    self:onPlayerLevelChanged()
end

function This:removeListener()
    GamePlayer:removeObserver(self)
    WarTowerManager:removeObserver(self)
end

function This:onGetMasterInfo()
    self:notifyObservers("onGetBuildHelpInfo", self:getId())
end

function This:onPlayerLevelChanged( newv )
    local _, level = self:getCondition()
    if newv then 
        if level == new then
            WarTowerManager:onGetInfoRequest()
        end
    else
        if level <= GamePlayer:getLevel() then
            WarTowerManager:onGetInfoRequest()
        end
    end
end

This.onGetSaoDangReward = This.onGetMasterInfo
This.onGetBoxReward = This.onGetMasterInfo
This.onGetVipReward = This.onGetMasterInfo
This.onGetInfo = This.onGetMasterInfo