-- @Author: superm
-- @Date:   2018-12-25 20:14:00
-- @Last Modified by:   zheng
-- @Last Modified time: 2020-07-03 18:05:04
-- @File Name: TerrBuildingZhenHeTa.lua
-- @Description: 

local This , super = class(..., "Territory.TerrBuild")
local ArgConfig = require("Metadatas.ArgConfig")
local WarfareManager = require("Warfare.WarfareManager")

local TerrBuildViewWithFunc = require("Territory.TerrBuildViewWithFunc")
local TowerManager = require("SingleDaily.TowerManager")
local EventDispatcher = require("EventDispatcher")
local GamePlayer = require("Player.GamePlayer")

function This:createView()
    return TerrBuildViewWithFunc:create(self)
end

function This:hasListener()
    return true
end

function This:hasFunctions()
    return false
end

function This:hasHelpList()
    -- return not self:isLocked(), "MenuScene/wordketiaozhan1.png"
    return not self:isLocked(), "MenuScene/wordkelingqu1.png"
end


function This:getHelpListCount()
    if TowerManager:isHaveYesterdayReward() then
        return 1
    end
    return 0
end

function This:onHelpFuncionEvent()
    local func = self:getRequest()
    if func then
        func()
    end
end

function This:getCondition()
    local conds = self:getConditions()
    if conds then
        return conds[1], conds[2]
    end
    return nil, nil
end

function This:getConditions()
    return {1,self.m_descConfig.open_level}
end

function This:hasProduction()
	return false
end

function This:getName()
    return self.m_descConfig.name
end

function This:getRequest(mode)
    local requestMode = mode or TerrBuildRequestMode.kOther
    if requestMode == TerrBuildRequestMode.kUpgrade then
    	local _, level = self:getCondition()
        g_scene:showTips(Serialize[64521] .. level .. Serialize[60394]) 
        return
    elseif WarfareManager:hasTeam() then
        g_scene:showTips(Serialize[64547])
        return 
    else
        if not self.m_clickFunc then
            self.m_clickFunc = function()
                g_scene:openDialog("SingleDaily.TowerPanel")
            end
        end
        return self.m_clickFunc
    end
end

function This:initListener()
    TowerManager:addObserver(self)
    GamePlayer:addObserver(self)
    self:onPlayerLevelChanged()
end

function This:removeListener()
    GamePlayer:removeObserver(self)
    TowerManager:removeObserver(self)
end

function This:onGetMasterInfo()
    self:notifyObservers("onGetBuildHelpInfo", self:getId())
end

function This:onPlayerLevelChanged( newv )
    local _, level = self:getCondition()
    if newv then 
        if level == new then
            self:onGetMasterInfo()
        end
    else
        if level <= GamePlayer:getLevel() then
            self:onGetMasterInfo()
        end
    end
end
This.onGetDayReward = This.onPlayerLevelChanged
