--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"Dialog")
local TerrBuildManager = require("Territory.TerrBuildManager")
local PrivilegeManager = require("Vip.PrivilegeManager")
local GameUtil = require("Util.GameUtil")
local ViewUtil = require("UI.ViewUtil")
local ItemUtil = require("Bag.ItemUtil")
local TerrOfflineIncomeConfig = require("Metadatas.TerrOfflineIncomeConfig")

function This:initNode(info)
	self.m_csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/Building6.csb")
	self.m_csNode.close:setVisible(false)
	self:addChild(self.m_csNode)
	self.m_csNode:setToCenter()


	self.m_time = info.time or 0
	self.m_timeLimit = info.timeLimit or 0
	self.m_okHandler = info.pickUpHandler
	print("TerrOfflineIncomePanel",self.m_timeLimit)
	self:setTime(self.m_time)

	local i = 1
	if info and info.list then
		for buildType, income in pairs(info.list) do
			local itemId, count = next(income)

			self.m_csNode["buildName" .. i]:setString(info.name[buildType])
			self.m_csNode["building" .. i]:setImage(info.image[buildType])
	        if itemId then
			    self.m_csNode["icon" .. i]:setImage(ItemUtil.getIconImage(itemId))
			    self.m_csNode["number" .. i]:setString("" .. count)
	        else
	        	self.m_csNode["icon" .. i]:setVisible(false)
	            self.m_csNode["number" .. i]:setString("0")
	        end

	        self.m_csNode["buidingbg" .. i]:setVisible(true)
			self.m_csNode["icon" .. i]:setVisible(true)
		    self.m_csNode["number" .. i]:setVisible(true)
			self.m_csNode["buildName" .. i]:setVisible(true)
			self.m_csNode["building" .. i]:setVisible(true)
			i = i + 1
		end
	end

	for j=i, 4 do
	    self.m_csNode["number" .. j]:setVisible(false)
	    self.m_csNode["buidingbg" .. j]:setVisible(false)
		self.m_csNode["icon" .. j]:setVisible(false)
		self.m_csNode["buildName" .. j]:setVisible(false)
		self.m_csNode["building" .. j]:setVisible(false)
	end
end

function This:setTitle(str)
	self.m_csNode.title:setString(str)
end

function This:setTime(time)
	self.m_csNode.time:setString(Serialize[64593] .. GameUtil:formatTime(Serialize["H_M_S"],time))
	local limit = PrivilegeManager:getPrivilegeNumBy(Privilege.kTerrOfflineLimit) + self.m_timeLimit * kTerrOfflineTimeBuyOnce
	if time > limit then
		time = limit
	end
	self.m_csNode.timeTips:setString(string.formatSecondInCn(time) .. Serialize[64594])
	self.m_csNode.maxTime:setString(Serialize[64595] .. tostring(math.floor(limit / SECONDS_PER_MIN / MINS_PER_HOUR )) .. Serialize[64596] )
	if self.m_csNode.addTime and self.m_timeLimit >= kTerrOfflineTimeLimitBuyTimesLimit then
		self.m_csNode.addTime:setVisible(false)
	else
		self.m_csNode.addTime:setVisible(false)
	    ViewUtil:refreshRedDot(self.m_csNode.addTime, true)
	end
end

function This:setCancelHandler(handler)
	self.m_cancelHandler = handler
end

function This:setOkHandler(handler)
	self.m_okHandler = handler
end

function This:initTouchEvent()
	-- self.m_csNode.close:setTouchEnded(function()
	-- 	if self.m_cancelHandler then
	-- 		self.m_cancelHandler()
	-- 	end
	-- 	self:close()
	-- end)

	if self.m_csNode.help then
		self.m_csNode.help:setTouchEnded(function()

		end)
	end
	
	
	self.m_csNode.addTime:setTouchEnded(function()
        local panel = self:openDialog("UI.CostConfirmPanel")
        panel:setString(Serialize[64597])
        panel:setTimeString(Serialize[64598])
        print("TerrOfflineIncomePanel",self.m_timeLimit)
        panel:setCost(TerrOfflineIncomeConfig[self.m_timeLimit + 1].cost)
        panel:setOkHandler(function()
            TerrBuildManager:onBuyOfflineTimeLimitRequest()
        end)
	end)
	
	if self.m_csNode.button then
		self.m_csNode.button:setTouchEnded(function()
			if self.m_okHandler then
				self.m_okHandler()
			end	
			self:close()
		end)
	end
end

function This:onEnter()
	super.onEnter(self)
    TerrBuildManager:addObserver(self)
end

function This:onExit()
    TerrBuildManager:removeObserver(self)
	super.onExit(self)
end

function This:onBuyOfflineTimeLimit( num )
	self.m_timeLimit = num
	self:setTime(self.m_time)
end

-- function This:onTouchMask()
-- 	self:close()
-- end


--endregion
