-- @Author: superm
-- @Date:   2017-10-21 10:51:06
-- @Last Modified by:   superm
-- @Last Modified time: 2017-11-30 18:08:34
-- @File Name: TerrPatrolSelectModePanel.lua
-- @Description: 

local This, super = class(...,"Dialog")
local TerrPatrolTypeConfig = require("Metadatas.TerrPatrolTypeConfig")

function This:initNode(info)
    self.m_csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/Manor5.csb")
    self.m_csNode:setPosition(cc.visible.center.x,cc.visible.center.y)
	self:addChild(self.m_csNode)

    self.m_queueId = info.queueId
    -- self.m_mode = info.mode or 0
    self.m_handler = info.callback
    self.m_config = info.config
end

function This:onEnter()
	super.onEnter(self)
end

function This:onExit()
    super.onExit(self)
end

function This:initTouchEvent()
    self.m_csNode.close:setTouchEnded(function()
		self:close()
    end)
    

    for i=1, kTerrPatrolTypeCount do
        local heroNode = self.m_csNode["nandu" .. i]
        local mode = self.m_config[TerrPatrolType[i].field]
        local info = TerrPatrolTypeConfig[mode]
        heroNode.text:setStringWithColor(string.format(TerrPatrolTypeDesc[info.speed > 1 and 2 or 1], info.time/SECONDS_PER_MIN), 136)
        heroNode.xlfs_bg:setTouchEnded(function()
            self:onSelectBtnClick(mode)
            self:close()
        end)
    end
end

function This:onSelectBtnClick(mode)
    -- self.m_mode = mode
    if self.m_handler then
        self.m_handler(mode, self.m_queueId)
    end
end



--endregion
