--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This, super = class(...,"Dialog")
local TerritoryManager = require("Territory.TerritoryManager")
local DepotManager = require("Depot.DepotManager")
local GameUtil = require("Util.GameUtil")
local ItemNode = require("UI.ItemNode")

local TerrNandu = {
    kEasy = 1,
    kNormal = 2, 
    kDifficult = 3,
}

function This:initNode(robber)
    self.m_robber = robber
    self.m_csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/Building4.csb")
    self.m_csNode:setPosition(cc.visible.center.x,cc.visible.center.y)
    self:addChild(self.m_csNode)

    self.m_csNode.nandu:setString(Serialize[64500] .. self.m_robber:getHardDesc())
    -- local fightLimit = self.m_robber:getFightLimit()
    -- local fightTimes = self.m_robber:getFightTimes()
    -- local restTime = fightLimit - fightTimes
    -- if restTime > 0 then
    --     self.m_csNode.shengyuText:setString(Serialize[64617] .. restTime .. "/" .. tostring(fightLimit))
    -- else
    --     self.m_csNode.shengyuText:setString(Serialize[64618])
    -- end

    self.m_csNode.title:setString(self.m_robber:getName())
    if self.m_robber:getReportId() > 0 and self.m_robber:isAttackerVictory() then
        self.m_csNode.button.text:setString(Serialize[61310])
    else
        self.m_csNode.button.text:setString(Serialize[64501])
    end
end

function This:onEnter()
    super.onEnter(self)
    DepotManager:addObserver(self)
    TerritoryManager:addObserver(self)
    self:refresh()
end

-- function This:itemUpdate(itemList)
--     if itemList and #itemList > 0 then
--         g_scene:showReward(itemList)
--     end
-- end

function This:onExit()
    super.onExit(self)
    TerritoryManager:removeObserver(self)
    DepotManager:removeObserver(self)
end

function This:initTouchEvent()
    self.m_csNode.close:setTouchEnded(function()
        self:close()
    end)

    -- self.m_csNode.xzk.add:setTouchEnded(function()
    --     g_scene:openDialog("Vip.VipPanel")
    -- end)

    self.m_csNode.button:setTouchEnded(function()
        if self.m_robber:getReportId() > 0 and self.m_robber:isAttackerVictory() then
            TerritoryManager:onBattleVictory()
            self:close()
        else
            g_scene:openDialog("Territory.TerrBattleHeroPanel", {
                targetType = TerrBattleTarget.kRobber, 
                attacker = self.m_robber, 
                stageId = self.m_robber:getBattleId(),
                heroSource = TerritoryManager:getEmbattleHero(),
                battleHandler = function ( heroList )
                    TerritoryManager:onFightRobbersRequest(heroList, self.m_robber:getId())
                end
            })
        end
    end)
end

function This:refresh()
    local items = self.m_robber:getReward()
    for index, item in ipairs(items) do
         self:refreshItem(index, item)
    end
end

function This:refreshItem(i, item)
    local curNode = self.m_csNode["reward" .. i]
    local node = curNode.itemNode
    if not node then
        node = ItemNode:create(item[1], item[2])
        node:setAnchorPoint(0.5, 0.5)
        curNode:addChild(node)
    else
        node:init(item[1], item[2])
    end
end

function This:onGetRobbersInfo()
    if self.m_robber and self.m_robber:hasReportInFight() then
        self.m_robber:readReport()
    end
end

function This:onFightRobbers(id)
    if self.m_robber and self.m_robber:getId() == id and self.m_robber:hasReportInFight() then
        self.m_robber:readReport()
    end
end


--endregion
