-- @Author: superm
-- @Date:   2017-10-21 10:51:06
-- @Last Modified by:   superm
-- @Last Modified time: 2017-11-28 14:06:04
-- @File Name: TerrTechnItemView.lua
-- @Description: 

local This, super = class(..., "NodeView")
This.fileName = "MenuScene/NodeUI/TaiXueYuan3.csb"
local TerrTechnManager = require("Territory.TerrTechnManager")
local TerrTechnView = require("Territory.TerrTechnView")

This.createAllTechnViews = TerrTechnView.createAllTechnViews
This.releaseAllTechnViews = TerrTechnView.releaseAllTechnViews

function This:initData()
    self.m_technViews = TerrTechnView.getAllTechnViews()
    local bgWidth , height = self.bg:getContentSize()
    local width = bgWidth + self.number_bg:getContentWidth() + 5
    self:setContentSize(width, height)
    self.m_curTechnType = 0
    self.m_curLayerIndex = 0
end

function This:initNode()
end

function This:onEnter()
    super.onEnter(self)
    TerrTechnManager:addObserver(self)
end

function This:onExit()
    TerrTechnManager:removeObserver(self)
    super.onExit(self)
end

function This:refreshList(technType, layerIndex)
    self.m_curTechnType, self.m_curLayerIndex = technType, layerIndex
    self.number:setString(tostring(layerIndex))
    local technNode = self.bg
    technNode:removeAllChildren()
    local techns = self.m_technViews[technType * 100 + layerIndex]
    if not techns or table.count(techns) <= 0 then
        if not techns then
            self.m_technViews[technType * 100 + layerIndex] = {}
            techns = self.m_technViews[technType * 100 + layerIndex]
        end
        local models = TerrTechnManager.getTechnByFilter(technType, layerIndex)
        for technId, model in pairs(models) do
            local view = TerrTechnView:create(model)
            technNode:addChild(view)
            view:setPositionBy(self.bg)
            techns[technId] = view
            view:retain()
        end
    else
        for technId, view in pairs(techns) do
            technNode:addChild(view)
            view:setPositionBy(self.bg)
        end
    end
end

function This:isAllTechnsLocked()
    local ret = true
    local models = TerrTechnManager.getTechnByFilter(self.m_curTechnType, self.m_curLayerIndex)
    for _, model in ipairs(models) do
        ret = ret and model:isCompleteLocked()
        if not ret then
            break
        end
    end
    return ret
end


--endregion