-- @Author: superm
-- @Date:   2017-12-04 10:57:04
-- @Last Modified by:   superm
-- @Last Modified time: 2018-06-19 12:09:43
-- @File Name: TerrTechnQueue.lua
-- @Description: 

local This , super = class(...,"Territory.TerrQueue")

This.defalutState = TerrObjectState.kNormal

function This:create(...)
    local ret = {}
    setmetatable(ret,self)
    ret:init(...)
    return ret
end

function This:isNeedBuyValid()
    return false
end

function This:needBuy()
	return false
end

function This:isVisibleQueue()
    return true
end

function This:getCondition()
    return
end

function This:updateBaseData( info )
    self.m_index = info.id or 1
    if info.start_time then
        self.m_upStartTime = info.start_time
    end

    if info.end_time then
        self.m_upEndTime = info.end_time
    end
end

function This:initBeforeUpdateState(info, createHandler)
	if createHandler then
        self.m_techn, self.m_object = createHandler(info, self)
    end
end

function This:updateObjects( isInit, oldState )
    if self.m_state ~= oldState then
        local view = self:getView()
        if view then
            view:onStateChange(self:getId(), self:isEmpty(), oldState)
        end
    end
end

function This:selfUpdateInfo(info, createHandler)
    self:initBeforeUpdateState(info, createHandler)
end

function This:removeAllObjects()
    if self.m_upIsUpdating and self.m_upEndTime > 0 then
        if self:isVisibleQueue() and self.m_object then
            self.m_object:notifyObservers("onQueueUpdateEnd", self:getId())
        end
    end
    super.removeAllObjects(self)
end

function This:getTechnId()
    if self.m_object and self.m_techn then
        return self.m_techn:getId()
    end
end

function This:getFuncItemImage()
    if self.m_object and self.m_techn then
    	return self.m_techn:getImage()
    end
end

function This:onFunctionEvent(build)
    if self.m_upIsUpdating and not self:isEmpty() and self:getLeftTime() > 0 then
        g_scene:openDialog("Territory.TerrTechnUpgradePanel", self.m_techn)
    end
end

--获取配置信息region begin

--获取配置信息region end