

local This, super = class(..., "Home.MenuButton")
local ThroneManager = require("Throne.ThroneManager")


function This:init(config)
    super.init(self, config)
    self.m_isOpen = ThroneManager:checkOpen()
end

function This:initTouchEvent()
    self:setTouch({
		onEnded = function()
	        -- g_scene:openDialog("Throne.ThronePanel")
	        g_scene:openDialog("Palace.PalacePanel")
		end,
		isScale = false
	})
end

function This:addCustomListener()
    super.addCustomListener(self)
    ThroneManager:addObserver(self)
end

function This:removeCustomListener()
	ThroneManager:removeObserver(self)
    super.removeCustomListener(self)
end

function This:getDefaultVisible()
    return self.m_isOpen
end

function This:onDayPassNotify()
	local isOpen = ThroneManager:checkOpen()
	if self.m_isOpen ~= isOpen then
		self.m_isOpen = isOpen
		self:setVisible(isOpen)
	end
end