

local This, super = class(...,"Base.BaseModel")
local ThroneConfig = require("Metadatas.ThroneConfig")


function This:init(rankNum, info)
	super.init(self)

	self.m_rankNum 		= rankNum
	self.m_roleId 		= info.role_id
	self.m_roleName 	= info.role_name
	self.m_roleLv 		= info.role_level
	self.m_roleIcon 	= info.role_icon
	self.m_roleTitle 	= info.role_title
	self.m_roleEffect 	= info.role_effect
	self.m_serverId 	= info.server_id
	self.m_groupName 	= info.group_name
	self.m_score 		= info.rank_second_key

	-- 官职
	self.m_matchLv = math.floor(info.rank_first_key/10000)
	if self.m_matchLv < 1 then 
		self.m_matchLv = 1 
	end
	if self.m_matchLv > kMaxMatchRankLv then 
		self.m_matchLv = kMaxMatchRankLv 
	end

	-- 君主id
	self.m_throneId = 0
	for id, config in pairs(ThroneConfig) do
		if self.m_rankNum >= config.mix_ranking and self.m_rankNum <= config.max_ranking then
			self.m_throneId = id
			break
		end
	end
end

function This:getTitleName()
	local config = ThroneConfig[self.m_throneId]	
	if config then
		return config.title
	end
	return ""
end

function This:getName()
	return self.m_roleName
end

function This:getRankNum()
	return self.m_rankNum
end

function This:getScore()
	return self.m_score
end

function This:getIcon()
	return self.m_roleIcon
end

function This:getRoleId()
	return self.m_roleId
end

function This:getTitleIcon()
	local config = ThroneConfig[self.m_throneId]	
	if config then
		return self.m_throneId + 117
	end
	return 1
end

function This:getTitle()
	return self.m_throneId
end

function This:getReward()

	local config = ThroneConfig[self.m_throneId]	
	if config then
		return config.reward
	end
	return {}
end

