local This , super = class(...,"NodeUI")
local GameUtil = require("Util.GameUtil")

function This:initData(data)
    self.m_data = data
end

function This:initNode(data)
    local csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/KingPalaceKingItem.csb")
    self:addChild(csNode)
    self.m_csNode = csNode
    self:setToCenter()
    local w, h = self.m_csNode.bg1:getContentSize()
    --self:setContentSize(w-70, h-165)
end

function This:getSize()
    local w, h = self.m_csNode.bg1:getContentSize()
    return w,h
end

function This:getRankNum()
    return self.m_data:getRankNum()
end

function This:showLight(isOpen)
    self.m_csNode.xuanzhong:setVisible(isOpen)
end

function This:initTouchEvent()
    if not self.m_inited then
        self.m_inited = true

        self.m_csNode.bg1:setTouch({
            onEnded = function()
                self:onClick()
            end,
            isContainer = true,
            isSwallow = false,
            isScale = false,
        }) 
    end
end

function This:onEnter()
    super.onEnter(self)
    self:refresh()
end

function This:onExit()
    super.onExit(self)
end

-- function This:setModel(data)
--     self.m_data = data
--     self:refresh()
-- end

function This:refresh()
    local data = self.m_data
    local csNode = self.m_csNode

    -- csNode.bg1:setVisible(math.mod(data:getRankNum(),2) == 1)
    csNode.bg2:setVisible(math.mod(data:getRankNum(),2) ~= 1)
    -- 排名
    if data:getRankNum() >= 1 and data:getRankNum() <= 3 then
        csNode.top3:setImage( string.format("MenuScene/top%d.png", data:getRankNum()) )
    else
        csNode.rankbg.rank:setString(data:getRankNum())
    end
    csNode.top3:setVisible(data:getRankNum() >= 1 and data:getRankNum() <= 3)
    csNode.rankbg:setVisible(data:getRankNum() > 3)
    -- csNode.rankbg.rank:setVisible(data:getRankNum() > 3)

    -- 称号
    csNode.chengweibg.chengwei:setImage( string.format("Icons/Role/chenghao%d.png",data:getTitleIcon()))
    csNode.chengweibg:setImage(string.format("Icons/Role/chenghaodi%d.png",5-data:getTitle()))

    -- 头像
    -- local icon = csNode.icon
    -- GameUtil:setPlayerIconNodeImage(icon, data.m_roleIcon)
    -- GameUtil:setPlayerEffectNodeTo(icon, data.m_roleEffect)

    -- 名字
    csNode.name:setString(data:getName())

    -- -- 积分
    csNode.num:setString(data:getScore())
end

function This:setClick(func)
    self.m_clickFunc = func
end

function This:onClick()
    if type(self.m_clickFunc) == "function" then
        self.m_clickFunc(self)
    end
end

