local This, super = class(..., "cc.Node")
local ItemNodeUI = require("UI.Item")
local registerObject = cc.registerObject
local createFromCSFile = lib2d.ccNode.createFromCSFile
function This:create(...)
    local node = createFromCSFile("MenuScene/NodeUI/BaseItem.csb")
    node = registerObject(node, self)
    node:init(...)
    return node
end

function This:createBindNode(data, itemNodeClass)
    local node = ItemNodeUI:createWithData(data, self, itemNodeClass)
    node:setCascadeOpacityEnabled(true)
    return node
end

function This:init(data)
    for name, node in pairs(self:getChildrenNames()) do
        self[name] = node
    end
    self.m_bindNode = false
    self.m_isHideCount = false
    if data then
        self.m_bindNode = self:createBindNode(data)
        self.m_bindNode:retain()
    end
end

function This:onEnter()
    super.onEnter(self)
    if self.m_bindNode and not self.m_bindNode:getParent() then
        self:addChild(self.m_bindNode)
        self.m_bindNode:release()
    end
end

function This:setData(data, itemNodeClass)
    if self.m_bindNode then
        if self.m_bindNode:canSetData(data, itemNodeClass) then
            self.m_bindNode:setData(data)
        else
            self.m_bindNode:removeFromParent()
            self.m_bindNode = self:createBindNode(data, itemNodeClass)
            self:addChild(self.m_bindNode)
            self:onBindNodeUpdate()
        end
    else
        self.m_bindNode = self:createBindNode(data, itemNodeClass)
        self:addChild(self.m_bindNode)
    end
end

function This:onBindNodeUpdate()
end