--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"cc.Node")
local GameUtil = require("Util.GameUtil")

local BoxImage = 
{
	[1] = {
		"MenuScene/boxLock1.png",
		"MenuScene/boxGet1.png",
	},
	[2] = {
		"MenuScene/boxLock2.png",
		"MenuScene/boxGet2.png",
	},
	[3] = {
		"MenuScene/boxLock3.png",
		"MenuScene/boxGet3.png",
	},
	[4] = {
		"MenuScene/boxLock4.png",
		"MenuScene/boxGet4.png",
	}
}

function This:init(config)
	self.m_csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/TaskBoxCommon.csb")
	self:addChild(self.m_csNode)

	self.m_maxValue = 0
	self.m_maxIndex = 0
	self.m_config = config
	
	self.m_csNode.text:setString(config.desc or Serialize[64664])
	local width = self.m_csNode.jindubg:getContentWidth()
	local x , y = self.m_csNode.jindubg:getPosition()

	for i = 1 , 4 do
		self.m_csNode["boxLock"..i]:setVisible(i <= #config)
		self.m_csNode["bg"..i]:setVisible(i <= #config)
		if i <= #config then
			self.m_csNode["bg"..i].text:setString(config[i])
			self.m_maxValue = config[i]
			self.m_maxIndex = i
		end
	end

	for i = 1 , self.m_maxIndex do
		local px = x + width * (self.m_config[i] / self.m_maxValue)
		self.m_csNode["boxLock"..i]:setPositionX(px)
		self.m_csNode["bg"..i]:setPositionX(px)
	end

	self.m_effect = {}
end

function This:setValue(value,rewardList)
	self.m_value = value
	self.m_rewardList = rewardList
	self.m_csNode.weekvitality:setString(value)
	self.m_csNode.jindubg.jindutiao:setPercent(self.m_value / self.m_maxValue * 100)
	for i = 1 , self.m_maxIndex do
		if not rewardList[i] then
			if value >= self.m_config[i] then
				self.m_csNode["boxLock"..i]:setImage(string.format("MenuScene/boxGet%d.png",i))
			else
				self.m_csNode["boxLock"..i]:setImage(string.format("MenuScene/boxLock%d.png",i))
			end

			if value >= self.m_config[i] and not self.m_effect[i] then
				local x , y = self.m_csNode["boxLock"..i]:getPosition()
				self.m_effect[i] = {}
				self.m_effect[i][1] = GameUtil:createEffect("BoxLing",true)
				self.m_effect[i][1]:setPosition(x,y)
				self.m_csNode:addChild(self.m_effect[i][1],-1)
				self.m_effect[i][2] = GameUtil:createEffect("BoxLing2",true)
				self.m_effect[i][2]:setPosition(x,y)
				self.m_csNode:addChild(self.m_effect[i][2],-1)
			elseif value < self.m_config[i] and self.m_effect[i] then
				self.m_effect[i][1]:removeFromParent()
				self.m_effect[i][2]:removeFromParent()
				self.m_effect[i] = nil
			end
		else
			self.m_csNode["boxLock"..i]:setImage(string.format("MenuScene/boxGet%d.png",i))
			if self.m_effect[i] then
				self.m_effect[i][1]:removeFromParent()
				self.m_effect[i][2]:removeFromParent()
				self.m_effect[i] = nil
			end
			self.m_csNode["boxLock"..i]:setGrayShader()
		end
	end
end

function This:onEnter()
	super.onEnter(self)
	for i = 1, self.m_maxIndex do
		self.m_csNode["boxLock"..i]:setTouchEnded(function()
			if self.m_clickHandler then
				self.m_clickHandler(i,self.m_value >= self.m_config[i],self.m_rewardList[i])
			end
		end)
	end
end

function This:setClickHandler(handler)
	self.m_clickHandler = handler
end

--endregion
