--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"Dialog")

function This:initNode(info)
	if not info or not info.fileName then
		self.m_csNode = cc.Node:createFromCSFile("GameScene/NodeUI/DiplomaticSend.csb")
		self.m_csNode.des:setContentSize(395,155)
	else
		self.m_csNode = cc.Node:createFromCSFile(info.fileName)
	end
	self:addChild(self.m_csNode)
	self.m_csNode:setToCenter()

	if info then
		if info.richText then
			self:setStringWithColor(info.richText)
		else
			self:setString(info.text or "")
		end

		if info.okHandler then
			self:setOkHandler(info.okHandler)
		end

		if info.cancelHandler then
			self:setCancelHandler(info.cancelHandler)
		end

		if info.okBtnTxt then
			self:setOkBtnString(info.okBtnTxt)
		end

		if info.cancelBtnTxt then
			self:setCancelBtnString(info.cancelBtnTxt)
		end

		if info.title then
			self:setTitle(info.title)
		end
	end
end

function This:setString(str, width)
	self.m_text = str
	self.m_csNode.des:setString(str, width or 395)
end

function This:setStringWithColor(str, width)
	self.m_text = str
	self.m_csNode.des:setStringWithColor(str, width or 300)
end

function This:setCancelHandler(handler)
	self.m_cancelHandler = handler
end

function This:setOkHandler(handler)
	self.m_okHandler = handler
end

function This:setBtnString(cancel,ok)
	self:setCancelBtnString(cancel)
	self:setOkBtnString(ok)
end

function This:setCancelBtnString(cancel)
	if not cancel then
		return
	end

	if self.m_csNode.text2 then
		self.m_csNode.text2:setString(cancel)
	elseif self.m_csNode.cancel.text then
		self.m_csNode.cancel.text:setString(cancel)
	end
end

function This:setOkBtnString(ok)
	if not ok then
		return
	end

	if self.m_csNode.text1 then
		self.m_csNode.text1:setString(ok)
	elseif self.m_csNode.confirm.text then
		self.m_csNode.confirm.text:setString(ok)
	end
end

function This:setTitle( title )
    if self.m_csNode.title then
    	self.m_csNode.title:setString(title)
    end
end

function This:updateBtnPosition()
	
end

function This:initTouchEvent()
	self.m_csNode.cancel:setTouchEnded(function()
		if self.m_cancelHandler then
			self.m_cancelHandler()
		end
		self:close()
	end)
	self.m_csNode.confirm:setTouchEnded(function()
		if self.m_okHandler then
			self.m_okHandler()
		end	
		self:close()
	end)
end

function This:onTouchMask()
	self:close()
end

--endregion
