-- @Author: Su
-- @Date:   2019-07-08 11:11:51
-- @Last Modified by:   Su
-- @Last Modified time: 2019-07-08 11:11:51
-- @File Name: DragFastSelectContainer.lua
-- @Description:

-- local This , super = class(...,"UI.DragSelectContainer")
local This,super = class(...,"GodBeast.MythicalAnimalsBookListView")
local TouchListener = require("cc.TouchListener")

local nodePositionX ={81.77,210.04,480.00,749.95,878.23}

function This:addItemNode(node)
    local w , h = node:getContentSize()
	node:setAnchorPoint(0.5,0.5)    
	node:setCascadeOpacityEnabled(true)
    if #self.m_itemList > 0 then
		local preNode = self.m_itemList[#self.m_itemList]
		local x = preNode:getPositionX() + preNode:getContentWidth()/2 + w/2 + self.m_space
		-- node:setPosition(x,self.m_height / 2)
		node:setPosition(nodePositionX[#self.m_itemList+3],self.m_height / 2)
		self.m_container:addChild(node)
		self.m_container:setContentSize(x + w/2,self.m_height)
	else
		node:setPosition(nodePositionX[3],self.m_height / 2)
		self.m_container:addChild(node)
		self.m_container:setContentSize(w,self.m_height)
	end
    table.insert(self.m_itemList,node)
    self.m_oldIndex = 1
end


function This:onTouchEnded(touch)
	local center = -self.m_container:getPositionX() + self.m_width / 2
	local oldSelectIdx = self.m_selectIndex

	if self.m_isMoving then
		if center <= 0 then
			self:setItemToCenter(1,true)
		elseif center >= self.m_container:getContentWidth() then
			self:setItemToCenter(#self.m_itemList,true)
		else
			local dir = touch.x - self.m_beganPoint.x
			if dir < 0 then
				--往左拖
				local selectIdx = #self.m_itemList
				for i = 1, #self.m_itemList do
					local node = self.m_itemList[i]
					local x = node:getPositionX()
					if x >= center then
						selectIdx = i
						break
					end
				end
				self:setItemToCenter(selectIdx,true)
			else
				--往右拖
				local selectIdx = 1
				for i = #self.m_itemList, 1, -1 do
					local node = self.m_itemList[i]
					local x = node:getPositionX()
					if x <= center then
						selectIdx = i
						break
					end
				end
				self:setItemToCenter(selectIdx,true)
			end
		end
	-- else
	-- 	for i , node in ipairs(self.m_itemList) do
	-- 		local rect = node:getBoundingBox()
	-- 		if rect:isContainsPoint(touch) then
	-- 			if type(node.onClick) == "function" then
	-- 				node:onClick()
	-- 			end
	-- 			break
	-- 		end
	-- 	end
	end

	local xMove = math.abs(touch.x - self.m_beganPoint.x)
	local yMove = math.abs(touch.y - self.m_beganPoint.y)

	if xMove <= 15 and yMove <= 15 then
		for i , node in ipairs(self.m_itemList) do
			local rect = node:getBoundingBox()
			if rect:isContainsPoint(touch) then
				oldSelectIdx = i
				if type(node.onClick) == "function" then
                    node:onClick()
				end
				break
			end
		end
		self:setItemToCenter(oldSelectIdx, true)
	end
	

end

function This:onTouchMoved(touch)
end

function This:showItem(isShow)
	self.m_itemList[1]:setVisible(isShow)
	self.m_itemList[2]:setVisible(isShow)
	self.m_itemList[3]:setVisible(isShow)
end

function This:setItemToCenter(index,isDelay)
	local node = self.m_itemList[index]
	if not node then
		return
    end
    self.m_selectIndex = index
    
    for i = 1,#self.m_itemList do
        if i == index then
            self.m_itemList[index]:runAction(cc.MoveTo(0.5,nodePositionX[3],self.m_height / 2))
        else
            self.m_itemList[i]:runAction(cc.MoveTo(0.5,nodePositionX[i - index+3],self.m_height / 2))
        end

    end
    if isDelay then
        self.m_draging = true
    end

end

function This:update(dt)
    if self.m_draging then
        local node = self.m_itemList[self.m_selectIndex]
        if self.m_oldIndex ~= self.m_selectIndex then
            if self.m_curSelectNode then
                self.m_curSelectNode:setSelect(false)
            end
            self.m_oldIndex = self.m_selectIndex
            self.m_curSelectNode = node
            self.m_curSelectNode:setSelect(true)
        end
        self.m_draging = false
	end
end