--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"cc.Node")
local TouchListener = require("cc.TouchListener")

function This:init(info)
	self.m_width = info.width
	self.m_height = info.height
	self.m_maxScale = info.maxScale or 1.2
	self.m_minScale = info.minScale or 0.5
	self.m_space = info.space or 10
	self.m_initSpeed = info.initSpeed or 300
	self:setContentSize(self.m_width,self.m_height)

	local layer = cc.LayerColor:create(cc.Color(255,255,255,255))
	layer:setContentSize(self.m_width,self.m_height)
	local clippingNode = cc.ClippingNode:create(layer)
	self:addChild(clippingNode)

	self.m_container = cc.Node:create()
	clippingNode:addChild(self.m_container)

	-- local layer = cc.LayerColor:create(cc.Color(128,128,0,128))
	-- layer:setContentSize(self.m_width,self.m_height)
	-- clippingNode:addChild(layer,-1)

	self.m_itemList = {}
end

function This:initTouchEvent()
	--[[self.m_listener = TouchListener:create({
		onBegan = function(_,touch)
			return self:onTouchBegan(touch)
		end,

		onMoved = function(_,touch)
			self:onTouchMoved(touch)
		end,

		onEnded = function(_,touch)
			self:onTouchEnded(touch)
		end,
		isSwallow = false,
	})
	self:addEventListener(self.m_listener)]]

	self:addTouchListener({
		onBegan = function(_,touch)
			return self:onTouchBegan(touch)
		end,

		onMoved = function(_,touch)
			self:onTouchMoved(touch)
		end,

		onEnded = function(_,touch)
			self:onTouchEnded(touch)
		end,
		isSwallow = false,
	})
end

function This:onEnter()
	super.onEnter(self)
	self:initTouchEvent()
	self:scheduleUpdate()
end

function This:addItemNode(node)
	local w , h = node:getContentSize()
	node:setAnchorPoint(0.5,0.5)
	node:setCascadeOpacityEnabled(true)
	if #self.m_itemList > 0 then
		local preNode = self.m_itemList[#self.m_itemList]
		local x = preNode:getPositionX() + preNode:getContentWidth()/2 + w/2 + self.m_space
		node:setPosition(x,self.m_height / 2)
		self.m_container:addChild(node)
		self.m_container:setContentSize(x + w/2,self.m_height)
	else
		node:setPosition(w/2,self.m_height / 2)
		self.m_container:addChild(node)
		self.m_container:setContentSize(w,self.m_height)
	end
	table.insert(self.m_itemList,node)
end

function This:getItemList()
	return self.m_itemList
end

function This:onTouchBegan(touch)
	local rect = self:getBoundingBox()
	if rect:isContainsPoint(touch) then
		self.m_prePoint = cc.Vec(touch.x,touch.y)
		self.m_draging = false
		return true
	end
	return false
end

function This:onTouchMoved(touch)
	local point = cc.Vec(touch.x,touch.y)
	local add = point - self.m_prePoint
	local newx = 0
	if add.x > 0 then
		newx = self.m_container:getPositionX() + math.sqrt(add.x)
	else
		newx = self.m_container:getPositionX() - math.sqrt(-add.x)
	end
	
	if newx >= -self.m_container:getContentWidth() and newx <= self.m_width then
		self.m_container:setPositionX(newx)
	end
	self.m_prePoint = point
	self.m_isMoving = true
end

function This:onTouchEnded(touch)
	local center = -self.m_container:getPositionX() + self.m_width / 2
	if self.m_isMoving then
		for i , node in ipairs(self.m_itemList) do
			local w = node:getContentWidth()
			local x = node:getPositionX()
			if center >= x - (w+self.m_space) / 2 and center < x + (w + self.m_space)/2 then
				self:setItemToCenter(i,true)
				break
			end
		end
		local node = self.m_itemList[1]
		if center <= 0 then
			self:setItemToCenter(1,true)
		elseif center >= self.m_container:getContentWidth() then
			self:setItemToCenter(#self.m_itemList,true)
		end
	else
		for i , node in ipairs(self.m_itemList) do
			local rect = node:getBoundingBox()
			if rect:isContainsPoint(touch) then
				self:setItemToCenter(i,true)
				break
			end
		end
	end
	self.m_isMoving = false
end

function This:setItemToCenter(index,isDelay)
	local node = self.m_itemList[index]
	local center = -self.m_container:getPositionX() + self.m_width / 2
	local x = center - node:getPositionX()
	self.m_endx = self.m_container:getPositionX() + x
	self.m_selectIndex = index

	if isDelay then
		self.m_draging = true
		self.m_speed = self.m_initSpeed
	else
		self.m_container:setPositionX(self.m_endx)
		if self.m_curSelectNode then
			self.m_curSelectNode:setSelect(false)
		end
		self.m_curSelectNode = node
		self.m_curSelectNode:setSelect(true)
		node:setScale(self.m_maxScale)
	end
end

function This:setPreItemToCenter()
	if self.m_selectIndex > 1 then
		self:setItemToCenter(self.m_selectIndex - 1,true)
	end
end

function This:setNexItemToCenter()
	if self.m_selectIndex < #self.m_itemList then
		self:setItemToCenter(self.m_selectIndex + 1,true)
	end
end

function This:update(dt)
	if self.m_draging then
		local node = self.m_itemList[self.m_selectIndex]
		local x = self.m_container:getPositionX()
		if x < self.m_endx then
			local dx = x + self.m_speed * dt
			if dx >= self.m_endx then
				self.m_container:setPositionX(self.m_endx)
				if self.m_curSelectNode then
					self.m_curSelectNode:setSelect(false)
				end
				self.m_curSelectNode = node
				self.m_curSelectNode:setSelect(true)
				self.m_draging = false
			else
				self.m_container:setPositionX(dx)
			end
		else
			local dx = x - self.m_speed * dt
			if dx <= self.m_endx then
				self.m_container:setPositionX(self.m_endx)
				if self.m_curSelectNode then
					self.m_curSelectNode:setSelect(false)
				end
				self.m_curSelectNode = node
				self.m_curSelectNode:setSelect(true)
				self.m_draging = false
			else
				self.m_container:setPositionX(dx)
			end
		end
		self.m_speed = math.max(self.m_speed - 10 * dt,10)
	end
	local center = -self.m_container:getPositionX() + self.m_width / 2
	for i = 1 , #self.m_itemList do
		local node = self.m_itemList[i]
		local dist = math.abs(node:getPositionX() - center)
		local scale = math.max(self.m_minScale, self.m_maxScale * (1 -  dist / self.m_width))
		node:setScale(scale)
		local opacity = 255 * dist * 2 / self.m_width
		node:setOpacity(255 - math.min(255, math.max(0,opacity)))
	end
end