--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"Dialog")

function This:initNode(info)
	self.m_text = info.text
	self.m_rfNode = info.node

	local fileName = info.file or "GameScene/NodeUI/HelpTips.csb"
	self.m_csNode = cc.Node:createFromCSFile(fileName)
	self:addChild(self.m_csNode)

	local count = string.utf8Len(self.m_text)
	local lineWidth = 750
	if count < 20 then
		lineWidth = 200
	elseif count < 50 then
		lineWidth = 500
	elseif count < 100 then
		lineWidth = 700
	end

	local text = self.m_csNode.text
	text:setStringWithColor(self.m_text,lineWidth)
	text:setAnchorPoint(0,0)

	local w , h = text:getContentSize()
	local scale = text:getScale()
	w , h = w * scale , h * scale
	local dw , dh = 10 * scale , 10 * scale

	self.m_csNode.bg:setContentSize(w + dw,h + dh)
	self:setContentSize(w + dw,h + dh)
	text:setPosition(dw / 2, dh / 2)

	local scale = math.max(960 / cc.visible.width, 540 / cc.visible.height)
	self:setScale(1/scale)

	self.m_maskLayer:setVisible(false)
	self:adjustPosition()
end

function This:getFixScreenPosition(worldx,worldy,nodew,nodeh,selfw,selfh)
	local x , y = worldx, worldy

	if worldx + selfw <= cc.visible.rect.x + cc.visible.rect.width then
		x = worldx
	elseif worldx - selfw >= cc.visible.rect.x then
		x = worldx - selfw
	else
		x = (cc.visible.rect.width - selfw)/2
	end

	if worldy + selfh + nodeh <= cc.visible.rect.y + cc.visible.rect.height then
		y = worldy +  nodeh
	elseif worldy - selfh >= cc.visible.rect.y then
		y = worldy - selfh
	else
		y = (cc.visible.rect.height - selfh)/2
	end

	return x , y
end

function This:initTouchEvent()
	
end

function This:onTouchMask()
	self:close()
end

function This:adjustPosition()
	local w , h = self.m_rfNode:getContentSize()
	local scale = self.m_rfNode:getScale()
	local anchorX, anchorY = self.m_rfNode:getAnchorPoint()

	w = w * scale
	h = h * scale

	local worldx , worldy = self.m_rfNode:convertToWorldSpace(0, 0)
	--local selfw , selfh = self:getContentSize()
	local rt = self:getBoundingBox()
	local selfw , selfh = rt.width , rt.height
	local x , y = self:getFixScreenPosition(worldx,worldy,w,h,selfw,selfh)
	self:setPosition(x,y)
end

function This:adjustContentSize()
	local nodes = self.m_csNode:getChildren()

	local ret = nil
	for i, node in ipairs(nodes) do
		local name = node:getName()
		if name and string.sub(name, -2) ~= "bg" then
			if not ret then
				ret = node:getBoundingBox()
			else
				ret:merge(node:getBoundingBox())
			end
		end
	end

	local w, h = self.m_csNode.bg:getContentSize()
	self.m_csNode.bg:setContentSize( w, ret.height + 20 )
end



--endregion
