--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"cc.Node")

local CritFormat = "Fonts/Damage1/%s.png"
local DamageFormat = "Fonts/Damage3/%s.png"
local AddHp = "Fonts/GreenLife/%s.png"

FigureType = 
{
	kCrit = 1,
	kDamage = 2,
	kAddHp = 3,	
}

function This:init(info)
	self.m_number = info.number
	local sprites = {}

	local format = nil 
	if info.figureType == FigureType.kCrit then
		format = CritFormat
	elseif info.figureType == FigureType.kDamage then
		format = DamageFormat
	else
		format = AddHp
	end

	local n = math.floor(math.abs(self.m_number))
	local totalWidth = 0

	while n > 0 do
		local c = tostring(n % 10)
		local str = string.format(format,c)
		local sprite = cc.Sprite:create(str)
		table.insert(sprites,sprite)
		local w , h = sprite:getContentSize()
		totalWidth = totalWidth + w 
		n = math.floor(n / 10)
	end

	if self.m_number > 0 then
		local str = string.format(format,"add")
		local add = cc.Sprite:create(str)
		table.insert(sprites,add)
		local w , h = add:getContentSize()
		totalWidth = totalWidth + w
	elseif info.figureType == FigureType.kDamage or info.figureType == FigureType.kCrit then
		local str = string.format(format,"-")
		local reduce = cc.Sprite:create(str)
		table.insert(sprites,reduce)
		local w , h = reduce:getContentSize()
		totalWidth = totalWidth + w
	end

	self.m_figuers = {}

	local offset = 0
	for i = #sprites , 1 , -1 do
		local sp = sprites[i]
		local w , h = sp:getContentSize()
		sp:setPosition(offset + w / 2,0)
		offset = offset + w
		self:addChild(sp)
		table.insert(self.m_figuers,sp)
	end

	local effect = info.effect
	if type(effect) == "table" then
		local additional = effect.additionalValue
		if additional and additional ~= 0 then
			local lb = cc.Label:createNormalTTF(string.format("(+%s)",additional), 22)
			lb:setColor(255, 0, 0)
			lb:enableOutline(47, 19, 1, 255, 2)
			local w , h = lb:getContentSize()
	        lb:setAnchorPoint(0.5, 0.5)
	        lb:setPosition(offset + w / 2, 0)
	        self:addChild(lb)
	    end
	end

	self:setCascadeOpacityEnabled(true)
end

function This:onEnter()
	super.onEnter(self)
	self:runAnimation()
end

function This:runAnimation()
	self:runAction(cc.Sequence(
		cc.MoveBy(0.2,0,20,"SineInOut"),
		cc.DelayTime(0.3),
		cc.Spawn(cc.FadeOut(0.3),cc.MoveBy(0.3,0,20,"SineInOut")),
		cc.CallFunc(function()
			self:removeFromParent()
		end)
	))
end

--endregion
