--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This, super = class(..., "Dialog")
local ItemUtil = require("Bag.ItemUtil")

function This:initNode(info)
	self.m_itemID = info.itemId
	self.m_itemType = info.itemType
	self.m_isEquip = info.itemType == ItemCommonType.kEquip -- TODO 支持法宝装备的tips展示

	local strCommon = info.strCommon or ItemUtil.getComment(self.m_itemID)
	if os.isWin32 or os.isIosSimulator then
		strCommon = "ID:".. tostring(self.m_itemID) .. "," .. strCommon
	end
	info.text = strCommon

	self.m_text = info.text
	self.m_rfNode = info.node

	self.m_csNode = cc.Node:createFromCSFile("GameScene/NodeUI/ItemTips.csb")
	self:addChild(self.m_csNode)

	self.m_csNode.text:setString(self.m_text, self.m_csNode.bg:getContentWidth() - 20)

	local strName = info.strName or ItemUtil.getName(self.m_itemID)
	local strGetWays = info.strGetWays or ItemUtil.getItemGetWays(self.m_itemID)
	local quality = info.quality or ItemUtil.getQuality(self.m_itemID)

    self.m_csNode.title:setString(strName, self.m_csNode.bg:getContentWidth() - 0)
    self.m_csNode.title:setColorByID("Q".. quality)
    local temStrGetWays = Serialize[64682] .. strGetWays
    if info.strGetWays then
    	temStrGetWays = info.strGetWays
    end
	self.m_csNode.other:setString(temStrGetWays, 280)

	self:refreshEquipAttr()
	self:adjustPosition()
	self.m_maskLayer:setVisible(false)
end

function This:initTouchEvent()
end

function This:refreshEquipAttr()
    for i=1, 4 do
        local nameNode = self.m_csNode["property" .. i]
        local valueNode = self.m_csNode["property" .. i .. "num"]
        nameNode:setVisible(self.m_isEquip)
        valueNode:setVisible(self.m_isEquip)
    end
    
    if self.m_isEquip then
    	local attrList = ItemUtil.getEquipAttrList(self.m_itemID)
	    for i = 1, 4 do
	        local nameNode = self.m_csNode["property" .. i]
	        local valueNode = self.m_csNode["property" .. i .. "num"]
	        local attr = attrList[i] or {}
	        local attrId, value = attr.attrId, attr.value
	        if attrId and attrId > 0 then
	            nameNode:setString(AttrName[attrId])
	            valueNode:setString("+" .. math.floor(value))
	        else
	            nameNode:setVisible(false)
	            valueNode:setVisible(false)
	        end
	    end
    end  
end

function This:adjustContentSize(nodes)
	local ret = nil
	for i, node in ipairs(nodes) do
		-- local name = node:getName()
		if not ret then
			ret = node:getBoundingBox()
			-- print(name .. " ret.height:" .. ret.height)
		else
			ret:merge(node:getBoundingBox())
			-- print(name .. " ret.height:" .. ret.height)
		end
	end

	local w, h = self.m_csNode.bg:getContentSize()
	self.m_csNode.bg:setContentSize( w, ret.height + 20 )
	-- print("ret.height + 20:" .. ret.height + 20)
end

function This:adjustPosition()
	local nodes = {
		[1] = self.m_csNode.title, 
		[2] = self.m_csNode.line1_bg, 
		[3] = self.m_csNode.text, 
		[4] = self.m_csNode.line2_bg, 
		[5] = self.m_csNode.other
	}

	local equipLayers = {
		[1] = {self.m_csNode.property1, self.m_csNode.property1num, self.m_csNode.property2, self.m_csNode.property2num}, 
		[2] = {self.m_csNode.property3, self.m_csNode.property3num, self.m_csNode.property4, self.m_csNode.property4num}, 
	}

	local padding = -6
    local headH = nodes[1]:getContentHeight()
    local headScaleY = nodes[1]:getScaleY()
    local _, headApy = nodes[1]:getAnchorPoint()
    local py = nodes[1]:getPositionY() 
    local offY = py + headH * headScaleY * (- headApy) + padding
	for i, node in ipairs(nodes) do
        if i > 1 then
            local height = node:getContentHeight()
            if i == 3 then
            	if not self.m_isEquip then
            		height = math.max(height, 55)
        		else
        			for __, equipNodes in ipairs(equipLayers) do
        				if equipNodes[1] and equipNodes[1]:isVisible() then
	        				local eh = equipNodes[1]:getContentHeight()
				            local escaleY = equipNodes[1]:getScaleY()
	            			local _, eapy = equipNodes[1]:getAnchorPoint()
	        				for i, equipNode in ipairs(equipNodes) do
					            equipNode:setPositionY(offY)
	        				end
				            -- print("y=" .. tostring(offY) .. "\t", "h=" .. tostring(eh) .. "\t", "AnchorPointY=" .. tostring(eapy) .. "\t")
						    offY = offY + eh * escaleY * (- eapy) + padding
						end
        			end
    			end
            end

            local scaleY = node:getScaleY()
            local _, apy = node:getAnchorPoint()
            -- print("y=" .. tostring(offY) .. "\t", "h=" .. tostring(height) .. "\t", "AnchorPointY=" .. tostring(apy) .. "\t")
            node:setPositionY(offY)
		    offY = offY + height * scaleY * (- apy) + padding
        end
    end

	self:adjustContentSize(nodes)

	local w , h = self.m_rfNode:getContentSize()
	local scale = self.m_rfNode:getScale()
	local anchorX, anchorY = self.m_rfNode:getAnchorPoint()

	w = w * scale
	h = h * scale

	local worldx , worldy = self.m_rfNode:convertToWorldSpace(0, 0)
	local selfw , selfh = self.m_csNode.bg:getContentSize()
	local selfAnchorX , selfAnchorY = self.m_csNode.bg:getAnchorPoint()
	local x , y = self:getFixScreenPosition(worldx, worldy, w, h, selfw, selfh, selfAnchorX, selfAnchorY)
	self.m_csNode:setPosition(x,y)
end

function This:getFixScreenPosition(worldx,worldy,nodew,nodeh, selfw, selfh, selfAnchorX, selfAnchorY)
	local x , y = worldx, worldy

    if worldx - selfw/2 - nodew/2 > cc.visible.rect.x and worldx + selfw/2 + nodew/2 <= cc.visible.rect.x + cc.visible.rect.width then
		x = worldx - selfw/2 + nodew/2
    elseif worldx + selfw + nodew <= cc.visible.rect.x + cc.visible.rect.width then
		x = worldx + nodew
	elseif worldx - selfw >= cc.visible.rect.x then
		x = worldx - selfw
	end

    if worldy + selfh + nodeh <= cc.visible.rect.y + cc.visible.rect.height then
		y = worldy +  nodeh
	elseif worldy - selfh >= cc.visible.rect.y then
		y = worldy - selfh
	end
	return x , y
end

function This:onTouchMask()
	self:close()
end
