--region *.lua
--Date
--此文件由[BabeLua]插件自动生成
-- UI.RewardPanel
local This , super = class(...,"Dialog")
local ItemNode = require("UI.ItemNode")
local ItemConfig = require("Metadatas.ItemConfig")

function This:initNode(rewardList)
	local tmp = {}
	for i , info in ipairs(rewardList) do
		local id = info.id or info[1]
		local num = info.num or info.count or info[2]
		tmp[id] = tmp[id] or 0
		tmp[id] = tmp[id] + num
	end

	self.m_rewards = tmp
	self.m_csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/RewardTips1.csb")
	self:addChild(self.m_csNode)
	self.m_csNode:setToCenter()

	self.m_csNode:setCascadeOpacityEnabled(true)
	self.m_csNode.ScrollView:setSwallowTouch(false)
end

function This:initItemNode()
	for id, num in pairs(self.m_rewards) do
		local node = self:getItemNode({id = id, num = num})
		self.m_csNode.ScrollView:pushBackCustomItem(node,394,80,0.5)		
	end
end

function This:getItemNode(info)
	local id =  info.id or info[1]
	local node = cc.Node:createFromCSFile("MenuScene/NodeUI/RewardTips2.csb")
	local itemNode = ItemNode:create(id)
	itemNode:setAnchorPoint(0.5,0.5)
	node.reward1:addChild(itemNode)
	node.name:setString(ItemConfig[id].name)
	local quality = ItemConfig[id].quality
	local color = QualityColor[quality]
	node.name:setColor(color.r,color.g,color.b)
	node.count:setString("X" .. (info.num or info.count or info[2]))
	node:setCascadeOpacityEnabled(true)
	return node
end

function This:runOpenAnimation()
	self.m_isRunningAnimation = true
	cc.Audio:playEffect("GetItem.mp3")
	self.m_csNode:playCSAnimation(nil,false,function()
		self.m_isRunningAnimation = false
	end)
	self.m_timer:setTimer(0.23,function()
		local seqence1 = cc.Sequence(cc.FadeTo(0.4,64),cc.FadeTo(0.4,255))
		local seqence2 = cc.Sequence(cc.ScaleTo(0.85,0.95),cc.ScaleTo(0.85,1.1))
		self.m_csNode.tips:runAction(cc.RepeatForever(cc.Spawn(seqence1,seqence2)))
		self:initItemNode()
	end,"reward_tips")
end

function This:onEnter()
	super.onEnter(self)
	self:scheduleUpdate()
end

function This:onTouchMask(touchListener,location)
	if not self.m_isRunningAnimation then
		local x , y = touchListener:getStartTouchLocation()
		local length = cc.Vec(location.x - x, location.y - y):length()
		if length < 15 then
			self:close()
		end
	end
end

--endregion
