--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"Dialog")
local ItemNode = require("UI.ItemNode")

function This:initNode(info)
	local csFileName = info.csFileName or "MenuScene/NodeUI/TaskBattlefieldBox.csb"
	self.m_csNode = cc.Node:createFromCSFile(csFileName)
	self.m_csNode:setToCenter()
	self:addChild(self.m_csNode)
	if info.title then
		self.m_csNode.title:setString(info.title)
	end
	self.m_csNode.lingqu:setVisible(info.state == RewardState.kCanReward)
	self.m_csNode.yilingqu:setVisible(info.state == RewardState.kHasReward)
	if not info.complex then
		self.m_csNode.condition:setVisible(info.state == RewardState.kNotFinish)
		if info.text then
			self.m_csNode.condition:setString(info.text)
		end
	else
		self.m_csNode.condition:setVisible(false)
		self.m_csNode.complex:setVisible(true)
		self.m_csNode.complex.condition:setVisible(info.state == RewardState.kNotFinish)
		self.m_csNode.complex.tips:setVisible(info.state == RewardState.kNotFinish)
		self.m_csNode.complex.tips:setString(info.complex)
		if info.text then
			self.m_csNode.complex.condition:setString(info.text)
		end
	end
end

function This:initTouchEvent()
	self.m_csNode.close:setTouchEnded(function()
		self:close()
	end)
	self.m_csNode.lingqu:setTouchEnded(function()
		if self.m_handler then
			self.m_handler()
		end
	end)
end

function This:setRewardList(rewardList)
	local csNode = self.m_csNode
	local count = #rewardList
	local scrollView = csNode.scrollView
	local itemtipslist = csNode.itemtipslist
	if count <= 4 then
		local w = 0
		for i , info in ipairs(rewardList) do
			local node = ItemNode:create(info.id,info.num)
			node:setAnchorPoint(0,0.5)
			node:setPosition(w, 0)
			w = w + node:getContentWidth() + 10
			itemtipslist:addChild(node)
		end
		itemtipslist:setPositionX(- w / 2)
		itemtipslist:setVisible(true)
		scrollView:setVisible(false)
	else
		scrollView:removeAllChildren()
		scrollView.m_direction = "right"
		for i , info in ipairs(rewardList) do
			local item = ItemNode:create(info.id, info.num)
			item:setAnchorPoint(0.5,0.5)
			local w , h = item:getContentSize()
			scrollView:pushBackCustomItem(item, w, h ,0.5)
		end
		itemtipslist:setVisible(false)
		scrollView:setVisible(true)
	end
end

function This:setHandler(handler)
	self.m_handler = handler
end


--endregion
