--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"UI.UIBaseView")

local Timer =  require("Timer")
local EventDispatchaer = require("EventDispatcher")
local UIPanelManager = require("UI.UIPanelManager")

function This:init(isNeedLoad)
    super.init(self)
    self.m_isNeedLoad = true
    self.m_timer = Timer:create(self)
    self.m_maskLayer = nil
    self.m_rootNode = nil
end

function This:setRootNode(node)
    self.m_rootNode = node
end

function This:onEnter()
    super.onEnter(self)
    UIPanelManager:addPanel(this)
    if self.m_isNeedLoad then
        self:startLoad()
    else
       self:loadEnd()
    end
end

function This:onExit()
   super.onExit(self)
   UIPanelManager:removePanel(self)
end

function This:startLoad()
    local index = 0
    self.m_timer:setTimer(0,function ()
        index = index + 1
        if self:onLoad(index) then
            self:loadEnd()
            return true
        end
        return false
    end,"onLoad")
end

function This:onLoad(frameIndex)
    print(string.format("%s is on loading in frameindex = %d",self._NAME,frameindex))
end

function This:loadEnd()
    EventDispatchaer:dispatcher(self._NAME,self)
end

function This:setMaskLayer(isMask)
   if isMask and self.m_maskLayer == nil then
       local width,height = cc.Director:getWinSize()
       self.m_maskLayer = cc.LayerColor:create(cc.Color(0,0,0,128))
       self.m_maskLayer:setContentSize(width,height)
       self.m_maskLayer:ignoreAnchorPointForPosition(false)
       self.m_maskLayer:setAnchorPoint(0.5,0.5)
       local sizeWidth , sizeHeight = self:getContentSize()
       self.m_maskLayer:setPosition(sizeWidth/2,sizeHeight/2)
       self:addChild(self.m_maskLayer)
   elseif not isMask and self.m_maskLayer then
       self.m_maskLayer:removeFromParent()
       self.m_maskLayer = nil
   end
end

function This:show(isWithAction)
    local width , height = cc.Director:getWinSize()
    self:setAnchorPoint(0.5,0.5)
    self:setPosition(width/2,height/2)
    local scene = cc.Director:getRunningScene()
    scene:addChild(self)
end

function This:close(isWithAction)
    self:removeFromParent()
end



--endregion
