--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This = class(...)
local TerritoryManager = require("Territory.TerritoryManager")
local WorldMapManager = require("World.WorldMapManager")
local TerrBuildManager = require("Territory.TerrBuildManager")
local GamePlayer = require("Player.GamePlayer")
local PopDialogManager = require("UI.PopDialogManager")
local WarfareManager = require("Warfare.WarfareManager")
local HeroManager = require("Hero.HeroManager")

HelpPanelTabName = 
{
	kMatch = 1, --争霸赛
	kRank = 2, --官职说明
	kTerri = 3, --封地
	kStranger = 4, --我要变强
	kLevelUp = 5, --我要升级
	kVip = 6, --VIP

}

function This:refreshRedDot(reddot,isVisible)
	local vs = reddot:isVisible()
	if not vs and isVisible then
		reddot:setVisible(true)
		reddot:setScale(1.0)
		--reddot:runAction(cc.RepeatForever(cc.Sequence(cc.FadeOut(0.6),cc.FadeIn(0.6))))
	elseif vs and not isVisible then
		reddot:setVisible(false)
		--reddot:stopAllActions()
	end
end

function This:blinkView(view,isVisible)
	local vs = view:isVisible()
	if not vs and isVisible then
		view:setVisible(true)
		view:runAction(cc.RepeatForever(cc.Sequence(cc.FadeOut(0.6),cc.FadeIn(0.6))))
	elseif vs and not isVisible then
		view:setVisible(false)
		view:stopAllActions()
	end
end

function This:jumpToPanel(name,arg)
	if name == "Territory.TerrRobberPanel" then
		local robber = TerritoryManager:getRobberBy(arg.pos)
		if robber then
			if g_scene:getName() ~= "MenuScene" then
				cc.SceneManager:switchTo("Home.MenuScene")
			end
			PopDialogManager:addPopDialog({scene = "MenuScene", name = name, arg = robber,level = DialogLevel.kForLevel})
		end
	elseif name == "World.TroopPanel" then
		if GamePlayer:isInWorld() then
			if g_scene:getName() ~= "WorldScene" then
				cc.SceneManager:switchTo("World.WorldScene")
			end
			PopDialogManager:addPopDialog({scene = "WorldScene", name = name, arg = arg.city,level = DialogLevel.kForLevel})
		end
	elseif name == "Territory.TerrBuildUpgradePanel" then
		local build = TerrBuildManager:getBuildByType(arg.type,arg.pos)
		if g_scene:getName() ~= "MenuScene" then
			cc.SceneManager:switchTo("Home.MenuScene",nil,{
				initHandler = function()
					g_scene:focuseBuildByType(arg.type,arg.pos)
					if not build:isUpgrading() then
						PopDialogManager:addPopDialog({scene = "MenuScene", name = name, arg = build, level = DialogLevel.kForLevel})
					else
						g_scene:showTips(Serialize[64701])
					end
				end
			})
		else
			g_scene:focuseBuildByType(arg.type,arg.pos)
			if not build:isUpgrading() then
				PopDialogManager:addPopDialog({scene = "MenuScene", name = name, arg = build,level = DialogLevel.kForLevel})
			else
				g_scene:showTips(Serialize[64701])
			end
		end
	elseif name == "SelectCity" then
		if g_scene:getName() == "WorldScene" then
			g_scene:focuseCity(arg.city)
			g_scene:selectCity(arg.city)
		elseif GamePlayer:isInWorld() then
			cc.SceneManager:switchTo("World.WorldScene",nil,{
				focuseCityId = arg.city,
				initHandler = function() 
					g_scene:selectCity(arg.city) 
				end
			})
		end
	elseif name == "EnterCityUI" then
		local function handler()
			local city = WorldMapManager:getCity(arg.city)
			g_scene:enterBuildMode(city)			
		end
		if g_scene:getName() ~= "WorldScene" then
			if GamePlayer:isInWorld() then
				cc.SceneManager:switchTo("World.WorldScene",nil,{
					focuseCityId = arg.city,
					initHandler = handler
				})
			end
		else
			handler()
		end
	elseif name == "JinRuZhengBa" then
		if g_scene:getName() == "MenuScene" then
			if GamePlayer:isInWorld() then
				cc.SceneManager:switchTo("World.WorldScene")
			else
				g_scene:openDialog("Match.MatchPanel")
			end
		end
	elseif name == "TeamWarfarePanel" then
		local params = arg or {}
		local build = TerrBuildManager:getBuildByType(TerrBuildType.kJiaoChang, 1)
		if params.args.id == 12 then
			if params.tab and params.tab== 5 then
				cc.SceneManager:switchTo("Home.MenuScene")
				return
			else
				local team = WarfareManager:getMyTeam()
				if  WarfareManager:hasTeam() then
					local nowWar = team:getBossWar()

					if nowWar:getType() == WarfareType.kBoss then
						g_scene:openDialog("Warfare.TeamWarfareFundPanel",{war = nowWar})
					end
					return
				end
			end
		end
		if g_scene:getName() ~= "MenuScene" then
			cc.SceneManager:switchTo("Home.MenuScene",nil,{
				initHandler = function()
					g_scene:focuseBuildByType(TerrBuildType.kJiaoChang, 1)
					PopDialogManager:addPopDialog({scene = "MenuScene", name = "Warfare.WarfarePanel", arg = {build = build, tabIndex = params.tab or 1, arg = params.args}, level = DialogLevel.kForLevel})
				end
			})
		 else
			-- g_scene:focuseBuildByType(TerrBuildType.kJiaoChang, 1)
			-- PopDialogManager:addPopDialog({scene = "MenuScene", name = "Warfare.WarfarePanel", arg = {build = build, tabIndex = params.tab or 1, arg = params.args}, level = DialogLevel.kForLevel})
			if WarfareManager:hasTeam() or WarfareManager:hasTeam(TeamType.kTowerTeam) then
				local team = WarfareManager:getMyTeam() or WarfareManager:getMyTeam(TeamType.kTowerTeam)
				local build = TerrBuildManager:getBuildByType(TerrBuildType.kJiaoChang)
				if  WarfareManager:hasTeam() then
					local nowWar = team:getWar()
					if build:getHelpListCount() > 0 then
						build:onHelpFuncionEvent()
					end
					if nowWar:getType() == WarfareType.kAnimal then
						g_scene:openDialog("Warfare.TeamWarfareFundPanel",{war = nowWar})
					else
						g_scene:openDialog("Warfare.TeamWarfarePanel",{war = nowWar})
					end
				elseif WarfareManager:hasTeam(TeamType.kTowerTeam) then
					g_scene:openDialog("SingleDaily.TowerPanel")
				end
			else
				g_scene:showTips(Serialize[61489])
			end
		end
	elseif name == "Awake.LordPanel" then
		local pos = arg.pos
		-- dialog:selectTabButton(pos)
		local dialog = g_scene:openDialog("Awake.LordPanel")
		dialog:selectTabButton(pos)
	elseif name == "Hero.HeroPanel" then
		local pos = arg.pos
		local heroList = HeroManager:getAllHeroGotWithSort(nil, false,true)

		local tmpHeroList = {}
		--没有法宝的排第一个
		for i,v in ipairs(heroList) do
			if not v:isWearFabao(FabaoPos.kFirst) then
				tmpHeroList = v
				break
			end
		end
		if #heroList > 0 then
			-- local dialog = g_scene:openDialog("Hero.HeroListPanel")
			g_scene:openDialog("Hero.HeroPanel", {heroId = tmpHeroList:getId(), tab = "equip"})

		else
			g_scene:showTips(Serialize[61107])
		end
	elseif name == "ExpeditionPanel" then
		self:focuseTerrBuildAndClick(1009) --战场遗迹

	elseif name == "SingleDaily.TowerMainPanel" then
		self:focuseTerrBuildAndClick(1002) --镇河塔

	elseif name == "SingleDaily.WarTowerMainPanel" then		
		self:focuseTerrBuildAndClick(1008) --战意塔

	else
		g_scene:openDialog(name,arg)
	end	
end

function This:focuseTerrBuildAndClick(buildType, index)
	index = index or 1

	local func = function ()
		g_scene:focuseBuildByType(buildType, index, function(node)
		    local view = node:getClickView()
			if view and view.m_touch then
				view.m_touch:onEnded()
			end
		end, true)
	end

	if g_scene:getName() ~= "MenuScene" then
		cc.SceneManager:switchTo("Home.MenuScene", nil, {
			initHandler = func
		})
	else
		func()
	end	
end

function This:startCountUp( view, info, finishHandler )
	if not view.hasCountUp then
	    view.hasCountUp = function( node )
	    	return true
	    end

	    view.countUp = function( node, startNumber, endNumber, intervalTime, handler )
		    if not node.m_cuInited then
		        node.m_cuInited = true
		        view.m_increased = endNumber > startNumber
			    view.m_cuStartNum = startNumber 
			    view.m_cuEndNum = endNumber 
			    view.m_cuOffset = endNumber - startNumber
			    view.m_cuInterval = intervalTime
		    	view:setString(startNumber)
                view.m_cuTotalTime = 0
                view.m_finishHandler = handler
		        node:scheduleUpdate()
		    else
			    view.m_increased = endNumber > startNumber
			    view.m_cuStartNum = startNumber 
			    view.m_cuEndNum = endNumber 
			    view.m_cuOffset = endNumber - startNumber
			    view.m_cuInterval = view.m_cuInterval + intervalTime
		    	view:setString(startNumber)
		    end
	    end

	    local oldupdate = view.update
		view.update = function(node, dt)
			if oldupdate then
				oldupdate(node, dt)
			end

			node.m_cuTotalTime = node.m_cuTotalTime + dt
			local showNum = node.m_cuStartNum + node.m_cuOffset / node.m_cuInterval * node.m_cuTotalTime
			local numInvalid = (view.m_increased and showNum >= node.m_cuEndNum) or (not view.m_increased and showNum <= node.m_cuEndNum)
			if numInvalid or node.m_cuTotalTime >= node.m_cuInterval then
				showNum = node.m_cuEndNum
				node:unscheduleUpdate()
	        	node.m_cuInited = false
	        	node:setString(string.format("%d", showNum))
	        	if node.m_finishHandler then
	        		node.m_finishHandler(node)
	        	end
	        else
				node:setString(string.format("%d", showNum))
			end
		end
	end
	view:countUp(info.startNum, info.endNum, info.interval, finishHandler)
end


function This:runCountDownAction( view, info, handler, finishHandler )
	if not view.hasCountUp then
	    view.hasCountUp = function( node )
	    	return true
	    end

	    view.countUp = function( node, startNumber, endNumber, intervalTime, handler, finHandler )
		    if not node.m_cuInited then
		        node.m_cuInited = true
		        view.m_increased = endNumber > startNumber
			    view.m_cuStartNum = startNumber 
			    view.m_cuEndNum = endNumber 
			    view.m_cuOffset = endNumber - startNumber
			    view.m_cuInterval = intervalTime
                view.m_cuTotalTime = 0
                view.m_cuHandler = handler
                view.m_cuFinishHandler = finHandler
		        node:scheduleUpdate()
		    else
			    view.m_increased = endNumber > startNumber
			    view.m_cuStartNum = startNumber 
			    view.m_cuEndNum = endNumber 
			    view.m_cuOffset = endNumber - startNumber
			    view.m_cuInterval = view.m_cuInterval + intervalTime
		    end
	    end

	    local oldupdate = view.update
		view.update = function(node, dt)
			if oldupdate then
				oldupdate(node, dt)
			end

			node.m_cuTotalTime = node.m_cuTotalTime + dt
			local showNum = node.m_cuStartNum + node.m_cuOffset / node.m_cuInterval * node.m_cuTotalTime
			local numInvalid = (view.m_increased and showNum >= node.m_cuEndNum) or (not view.m_increased and showNum <= node.m_cuEndNum)
			if numInvalid or node.m_cuTotalTime >= node.m_cuInterval then
				showNum = node.m_cuEndNum
				node:unscheduleUpdate()
	        	node.m_cuInited = false
	        	if node.m_cuHandler then
	        		node.m_cuHandler(node, showNum)
	        		node.m_cuHandler = nil
	        	end
	        	if node.m_cuFinishHandler then
	        		node.m_cuFinishHandler(node)
	        		node.m_cuFinishHandler = nil
	        	end
	        else
	        	if node.m_cuHandler then
	        		node.m_cuHandler(node, showNum)
	        	end
			end
		end
	end
	view:countUp(info.startNum, info.endNum, info.interval, handler, finishHandler)
end

--endregion
