--region *.lua
--Date
--此文件由[BabeLua]插件自动生成
-- local GameUtil = require("Util.GameUtil")
local This = class(...)
local EffectConfig = require("Metadatas.EffectConfig")
local HeroConfig = require("Metadatas.HeroConfig")
local ImageEffectConfig = require("Metadatas.ImageEffectConfig") -- 头像特效配表
local TitleConfig = require("Metadatas.TitleConfig") -- 称号配表
local ImageConfig = require("Metadatas.ImageConfig") -- 头像配表
local Image2Config = require("Metadatas.Image2Config") -- 头像配表2

RecruitManagerBoxState = {
    kLock = 1,
    kOpen = 2,
    kClose = 0
}

function This:createEffect(id,isLoop,parent,listener,isFlip,animationName, nonauto)
	local name = id
	if EffectConfig[id] and EffectConfig[id].name then
		name = EffectConfig[id].name
	end
	local skeleteNode = cc.SkeletonNode:createEffect(name)
	local config = EffectConfig[id]
	if config then
		if parent then
			local w , h = parent:getContentSize()
			if config.isFlip == 1 and isFlip then
				skeleteNode:setPosition(-config.offset[1] + w/2 ,config.offset[2] + h/2)
			else
				skeleteNode:setPosition(config.offset[1] + w/2 ,config.offset[2] + h/2)
			end
		else
			skeleteNode:setPosition(config.offset[1],config.offset[2])
			if config.isFlip == 1 and isFlip then
				skeleteNode:setPosition(-config.offset[1],config.offset[2])
			else
				skeleteNode:setPosition(config.offset[1],config.offset[2] )
			end
		end
		skeleteNode:setAnchorPoint(config.anchorpoint[1],config.anchorpoint[2])
		skeleteNode:setScale(config.scale)
		skeleteNode:setLocalZOrder(config.zorder or 1)
	else
		if parent then
			local w , h = parent:getContentSize()
			skeleteNode:setPosition(w/2 ,h/2)
		end
	end

	if listener then
		skeleteNode:setAnimationListener(listener)
	end

	local name = animationName or "animation"
	if not nonauto and skeleteNode.m_animations[name] then
		skeleteNode:playAnimation(name,isLoop)
	end
	
	skeleteNode:scheduleUpdate()
	return skeleteNode, EffectConfig[id]
end

--function This:getPlayerIcon(iconId)
--	iconId = iconId or 1
--	if iconId == 0 then iconId = 1 end
--	local icon = string.format("Icons/Player/icon%d.png",iconId)
--	if cc.FileUtils:isFileExist(icon) then
--		return icon
--	end
--end

function This:setPlayerIconNodeImage(node, iconId)
	if not iconId or iconId == 0 then
		return
	end
	node:setImage(ImageConfig[iconId].head)
end

function This:setPlayerEffectNodeTo(rootNode, effectId)
	local tag = 1128564
	local effectNode = rootNode:getChildByTag(tag)
	if effectNode then
		effectNode:removeFromParent()
	end

	if not effectId or effectId == 0 then
		return
	end

    local width, height = rootNode:getContentSize()
	local result = string.split(ImageEffectConfig[effectId].head_effect, "/")
	effectNode = cc.SkeletonNode:createEffect(result[2])
	effectNode:setTag(tag)
	-- effectNode:setContentSize(width, height)
	effectNode:setPosition(width/2, height/2)
	effectNode:setScale(100/86.25)
	effectNode:scheduleUpdate()
	effectNode:playAnimation("animation", true)
	rootNode:addChild(effectNode)
end

function This:setPlayerTitleWithImgNode(titleId,bgNode,titleIcon)
	local isHaveTitle = titleId and titleId ~=0
	bgNode:setVisible(isHaveTitle)
	titleIcon:setVisible(isHaveTitle)
	if not titleId or titleId ==0 then
		return
	end
	local resourcePath = TitleConfig[titleId].head
	local backgroundPath = TitleConfig[titleId].titlebg or ""
	if backgroundPath~="" then
		bgNode:setImage(backgroundPath)
	end
	titleIcon:setImage(resourcePath)
end

function This:setPlayerTitleNodeTo(rootNode, titleId, vipType)
    local tag = 34534520
    local titleNode = rootNode:getChildByTag(tag)
    if titleNode then
        titleNode:removeFromParent()
    end

	local resourcePath
	local backgroundPath
	local scale = 1
	if titleId == 0 then
		-- if vipType == VipType.kNone then
			return
		-- else
		-- 	resourcePath = VipImageName[vipType]
		-- 	backgroundPath = "Common/titlebg31.png"
		-- 	scale = 0.8
		-- end
	else
		resourcePath = TitleConfig[titleId].head
		backgroundPath = TitleConfig[titleId].titlebg or ""
		scale = 1
	end

	local backgroundImage = nil
    local width, height = rootNode:getContentSize()
    if backgroundPath and backgroundPath~= "" then
		backgroundImage = cc.Sprite:create(backgroundPath)
		backgroundImage:setTag(tag)
		backgroundImage:setAnchorPoint(0.5, 0)
		backgroundImage:setPosition(width/2, -10)
		rootNode:addChild(backgroundImage)
		if titleId ~= 0 then
			backgroundImage:setScale(0.6)
		end
    end

	titleNode = cc.Sprite:create(resourcePath)
	titleNode:setAnchorPoint(0.5, 0.6)
	titleNode:setScale(scale)
	
	if backgroundImage then
		width, height = backgroundImage:getContentSize()
		backgroundImage:addChild(titleNode)
	else
		rootNode:addChild(titleNode)
	end
	titleNode:setPosition(width/2, height/2)
end

--function This:getPlayerFelt(iconId)
--	iconId = iconId or 1
--	if iconId == 0 then iconId = 1 end
--	local icon = string.format("Icons/Player/quanshen%d.png",iconId)
--	if cc.FileUtils:isFileExist(icon) then
--		return icon
--	end
--end

function This:setPlayerFeltNodeResource(node, iconId, isChoose)
	local tag = 545547942
	local effectNode = node:getChildByTag(tag)
	local config = ImageConfig
	if effectNode then
		effectNode:removeFromParent()
	end

	if iconId == 0 then
		return
	end
	if isChoose then
		config =Image2Config
	end
	if config[iconId].dynamic_image ~= "" then
		local width, height = node:getContentSize()
		node:setImage("Common/kuang68.png")
		node:setContentSize(width, height)
		local skeletonResource = string.split(config[iconId].dynamic_image, "/")[2]
		effectNode = cc.SkeletonNode:createCharacter(skeletonResource)
		effectNode:setTag(tag)
		--effectNode:setContentSize(width, height)
		effectNode:setPosition(width/2, height/8 - 50) -- TODO
		--effectNode:setAnchorPoint(0.5, 0.5)
		effectNode:scheduleUpdate()
		effectNode:playAnimation("animation", true)
		node:addChild(effectNode)
	elseif config[iconId].image ~= "" then
		node:setImage(config[iconId].image)
	end
end

function This:getItemIcon(iconId)
	local icon = string.format("Icons/Item/%s.png",iconId)
	if cc.FileUtils:isFileExist(icon) then
		return icon
	end
    print(string.format("找不到资源%s",icon))

	return "Icons/Item/101.png"
end

function This:getHeroIcon(heroId)
    local icon = string.format("Hero/%d.png",HeroConfig[heroId].icon)
    if cc.FileUtils:isFileExist(icon) then
        return icon
    end
    print(string.format("找不到资源%s",icon))
    --assert(false)
    return "Hero/10031.png"
end

function This:getRedHeroIcon(heroId)
	local icon = string.format("Hero/%d.png",HeroConfig[heroId].icon+10000)
	if cc.FileUtils:isFileExist(icon) then
		return icon
	end
	print(string.format("找不到资源%s",icon))
	--assert(false)
	return "Hero/10031.png"
end

function This:getSkillIcon(iconId)
    local icon = string.format("Icons/Skill/%s.png",iconId)
    if cc.FileUtils:isFileExist(icon) then
        return icon
    end
    print(string.format("找不到资源%s",icon))
    --assert(false)
    return "Icons/Skill/1.png"
end

function This:int64ToString(value)
	local str = ""
	while value > 0 do
		local n = value % 10
		str = n .. str
		value = math.floor(value / 10)
	end
	return str
end

function This:getChar(str,index)
	local strlen = string.len(str)
	local i = 1 
	local len = 0
	local count = 0
	while i <= strlen do
		local byte = string.byte(str,i,i)
		if byte >= 0xFC then
			len = 6
		elseif byte >= 0xF8 then
			len = 5
		elseif byte >= 0xF0 then
			len = 4
		elseif byte >= 0xE0 then
			len = 3
		elseif byte >= 0xC0 then
			len = 2
		else
			len = 1
		end
		i = i + len
		count = count + 1
		if count == index then
			local sub = string.sub(str,i - len,i - 1)
			return sub
		end
	end
end

function This:getSubString(str,from,to)
	local strlen = string.len(str)
	local len = 0
	local count = 0
	local i = 1
	from = from or 1

	local fromIndex , endIndex = 1 , 1
	while i <= strlen do
		local byte = string.byte(str,i,i)
		if byte >= 0xFC then
			len = 6
		elseif byte >= 0xF8 then
			len = 5
		elseif byte >= 0xF0 then
			len = 4
		elseif byte >= 0xE0 then
			len = 3
		elseif byte >= 0xC0 then
			len = 2
		else
			len = 1
		end

		i = i + len
		count  = count + 1

		local toIndex = to or count
		if count == from then
			fromIndex = i - len
		end

		if count == toIndex then
			endIndex = i
			break
		end
	end
	return string.sub(str,fromIndex,endIndex-1)
end

function This:formatCount(count)
    return require("Bag.ItemUtil").formatItemCount(count)
end

function This:formatTime(format,time)
	local hour = math.floor(time / 3600)
	time = time % 3600
	local minue = math.floor(time / 60)
	time = time % 60
	local second = time

	if AppText:isEnglish() and string.find(format, "#") then
		format = string.gsub(format,"#H",string.format("%02d",hour), 1)
		format = string.gsub(format,"#M",string.format("%02d",minue), 1)
		format = string.gsub(format,"#S",string.format("%02d",second), 1)
	else
		format = string.gsub(format,"H",string.format("%02d",hour), 1)
		format = string.gsub(format,"M",string.format("%02d",minue), 1)
		format = string.gsub(format,"S",string.format("%02d",second), 1)
	end

	return format
end

function This:getFormatDtime(time)
	local day = math.floor(time / 86400)
	time = time % 86400
	local hour = math.floor(time / 3600)
	time = time % 3600
	local minue = math.floor(time / 60)
	time = time % 60
	local second = time
	return day,hour,minue,second
end

function This:getFormatDtimeStr(time)
	local day,hour,minue,second = self:getFormatDtime(time)
	if time>3600 then
		return string.format(Serialize[64703],day*24+hour,minue)
	else
		return string.format(Serialize[62301],minue,second)
	end
end

function This:formatDTime(format,time)
	local day,hour,minue,second = self:getFormatDtime(time)
	-- local day = math.floor(time / 86400)
	-- time = time % 86400
	-- local hour = math.floor(time / 3600)
	-- time = time % 3600
	-- local minue = math.floor(time / 60)
	-- time = time % 60
	-- local second = time
	if AppText:isEnglish() and string.find(format, "#") then
		format = string.gsub(format,"#D",string.format("%d",day), 1)
		format = string.gsub(format,"#H",string.format("%d",hour), 1)
		format = string.gsub(format,"#M",string.format("%d",minue), 1)
		format = string.gsub(format,"#S",string.format("%d",second), 1)
	else
		format = string.gsub(format,"D",string.format("%d",day), 1)
		format = string.gsub(format,"H",string.format("%d",hour), 1)
		format = string.gsub(format,"M",string.format("%d",minue), 1)
		format = string.gsub(format,"S",string.format("%d",second), 1)
	end

	return format
end

function This:formatDate(format,time)
	local result = os.date("*t",time)

	if AppText:isEnglish() and string.find(format, "#") then
		format = string.gsub(format,"#H",string.format("%02d",result.hour))
		format = string.gsub(format,"#M",string.format("%02d",result.min))
		format = string.gsub(format,"#S",string.format("%02d",result.sec))
		format = string.gsub(format,"#y",string.format("%02d",result.year))
		format = string.gsub(format,"#m",string.format("%02d",result.month))
		format = string.gsub(format,"#d",string.format("%02d",result.day))
	else
		format = string.gsub(format,"H",string.format("%02d",result.hour), 1)
		format = string.gsub(format,"M",string.format("%02d",result.min), 1)
		format = string.gsub(format,"S",string.format("%02d",result.sec), 1)
		format = string.gsub(format,"y",string.format("%02d",result.year), 1)
		format = string.gsub(format,"m",string.format("%02d",result.month), 1)
		format = string.gsub(format,"d",string.format("%02d",result.day), 1)
	end

	return format
end

-- 给定一个时间区间，判断它是否越过了某个每日时间点
function This:isNeedDailyUpdate(lastUpdateTime, currentTime, dailyUpdateHour, dailyUpdateMinute)
    local result = os.serverdate("*t", lastUpdateTime)
    local timeParameter = {day=result.day, month=result.month, year=result.year, hour=dailyUpdateHour, min=dailyUpdateMinute, sec=0}
    local checkingTime = os.time(timeParameter)

    result = os.serverdate("*t", currentTime)
    timeParameter.day = result.day
    local endCheckingTime = os.time(timeParameter)

    while checkingTime <= endCheckingTime do
        if lastUpdateTime < checkingTime and checkingTime <= currentTime then
            return true
        end
        checkingTime = checkingTime + 24*60*60
    end
    return false
end

function This:linearLayoutNodes(padding, nodes, adjust, parentSizeWidth, beginOffset, visible)
    if nodes == nil then return 0 end
    if nodes[1] == nil then return 0 end
    if nodes[1]:getParent() == nil then return 0 end
    if nodes[2] == nil then return 0 end

    local headW = nodes[1]:getContentWidth()
    local headScaleX = nodes[1]:getScaleX()
    local headApx = nodes[1]:getAnchorPoint()

    if adjust then
        local totalWidth = 0
        
        local parentW = nodes[1]:getParent():getContentWidth()
        local parentScaleX = nodes[1]:getParent():getScaleX()
        local parentApx = nodes[1]:getParent():getAnchorPoint() 

        for _, node in ipairs(nodes) do
           totalWidth = totalWidth + node:getContentWidth() * node:getScaleX()    
        end

        local calcPosX = 0
        if beginOffset and parentW > beginOffset then
        	calcPosX = calcPosX + beginOffset
        	parentW = parentW - beginOffset
        end

        if parentW > 0 then
        	if parentSizeWidth and parentSizeWidth > 0 then
            	calcPosX = calcPosX + (parentW - totalWidth) / 2.0 + parentW * parentScaleX * (0 - parentApx)
            else
            	calcPosX = calcPosX + (parentW - totalWidth) / 2.0
            end
        else
        	calcPosX = calcPosX + (parentSizeWidth - totalWidth) / 2.0 + parentSizeWidth * parentScaleX * (0 - 0.5)
        end
        nodes[1]:setPositionX(calcPosX + headW * headScaleX * headApx)
    else
    	if beginOffset and beginOffset > 0 then
        	local skip = false
	    	if visible ~= nil then
        		skip = visible == node:isVisible()
        	end
    		if not skip then
    			nodes[1]:setPositionX(beginOffset)
    		end
    	end
    end

    local px = nodes[1]:getPositionX() 
    local offX = px + headW * headScaleX * (1 - headApx) + padding
	for i, node in ipairs(nodes) do
        if i > 1 then
        	local skip = false
        	if visible ~= nil then
        		skip = visible == node:isVisible()
        	end
        	if not skip then
	            local width = node:getContentWidth()
	            local scaleX = node:getScaleX()
	            local apx = node:getAnchorPoint()
	            node:setPositionX(offX + width * scaleX * apx)
			    offX = offX + width * scaleX+ padding
			    -- print(node:getName(), offX)
			end
        end
    end
	return offX
end

function This:deepCopy(object)
	local lookup_table = {}
	local function _copy(object)
		if type(object) ~= "table" then
			return object
		elseif lookup_table[object] then
			return lookup_table[object]
		end

		local new_table = {}
		lookup_table[object] = new_table
		for index, value in pairs(object) do
			new_table[_copy(index)] = _copy(value)
		end

		return setmetatable(new_table, getmetatable(object))
	end

	return _copy(object)
end

function This:shallowCopy(tb, target)
	if type(tb) == "table" then
		local t = target or {}
		for k, v in pairs(tb) do
			t[k] = v
		end
		return t
	end
	return tb
end

function This:shallowChange(tb, target)
	if type(tb) == "table" then
		local t = target or {}
		for _, v in pairs(tb) do
			table.insert(t, v)
		end
		return t
	end
	return tb
end

function This:getValueMap(t)
	local value_map = {}
	for _, v in pairs(t) do
		value_map[v] = true
	end
	return value_map
end

-- 以key为标准 返回表1存在但表2不存在的部分
function This:diffByKey(t1, t2)
	local t = {}
	for k, v in pairs(t1) do
		if not t2[k] then
			t[k] = v
		end
	end
	return t
end

function This:isSameDay(curTime,preTime)
	local curDate = os.date("*t",curTime)
	local preDate = os.date("*t",preTime)
	if curDate.day ~= preDate.day then
		return false
	end
	if curDate.month ~= preDate.month then
		return false
	end
	if curDate.year ~= preDate.year then
		return false
	end
	return true
end

function This:checkInvalidAscill(str, noCheckSpecChars)
    for i = 1, #str do
        local byte = string.sub(str, i, i)
        if byte == '\n' or byte == '\t' or byte == '\r' or byte == ' ' then
			return true
		end 
    end
    if not noCheckSpecChars then
		local newStr = self:filterSpecChars(str)
	    return newStr ~= str
    else
    	return false
    end
end


-- 中文、英文和数字
-- isOnlyChinese = true 时只返回中文
function This:filterSpecChars(s,isOnlyChinese)  
    local ss = {}  
    for k = 1, #s do 
        local c = string.byte(s,k)  
        if not c then break end  
        -- if c >= 0x20 and c <= 0x2F then print("常用符号") end
        -- if c >= 0x3A and c <= 0x3F then print("关键字符号") end
        -- if c >= 0x0 and c <= 0x7F then print("基础ASCII码") end
        -- if c >= 0x80 and c <= 0xFF then print("扩展ASCII码") end

        if (c >= 0x30 and c <= 0x39) or (c >= 0x41 and c <= 0x5A) or (c >= 0x61 and c <= 0x7A) then  
        	if not isOnlyChinese then
            	table.insert(ss, string.char(c))  
        	end
        elseif c >= 0xE4 and c <= 0xE9 then  
        	-- unicode: 0x4E00, 0x9FA5
        	-- utf8: 0xE4B880, 0xE9BEA5
            local c1 = string.byte(s, k + 1)  
            local c2 = string.byte(s, k + 2)  
            if c1 and c2 then  
                local a1, a2, a3, a4 = 0x80, 0xBF, 0x80, 0xBF 
                if c == 0xE4 then 
                	a1 = 0xB8 
                elseif c == 0xE9 then 
                	a2, a4 = 0xBE, c1 ~= 0xBE and 0xBF or 0xA5 
                end  
                if c1 >= a1 and c1 <= a2 and c2 >= a3 and c2 <= a4 then  
                    k = k + 2 
                    table.insert(ss, string.char(c,c1,c2))  
                end  
            end  
        end  
    end  
    return table.concat(ss)  
end

function This:hideNodeList(node, nameList)
	if node then
	    for _, name in ipairs(nameList) do
	    	if node[name] then
	        	node[name]:setVisible(false)
	        end
	    end
	end
end

function This:printCallStack()
    local level = 1
    while true do
        local info = debug.getinfo(level, "Sl")
        if not info then break end
        if info.what == "C" then
            print(level, "C function")
        else
            print(string.format("[%s]:%d",info.short_src, info.currentline))
        end
        level = level + 1
    end
end

-- table转换
function This:convertData( tableData )
	local function convertItem(data,result)
		local key = data[1]
		if key then
			result[key] = data[2]
		end
	end
	local res ={}
	if type(tableData) == "table" and tableData[1] and type(tableData[1]) == "table" then--{{105,0.1},{105,0.15},{105,0.2}}
		for k,v in pairs(tableData) do
			convertItem(v,res)
		end
		return res
	elseif type(tableData) == "table" and tableData[1] and type(tableData[1]) == "number" then--{105,0.2}
		convertItem(tableData,res)
		return res
	end
	return tableData
end

-- self:resetScoolSize2(self.m_csNode.scrollView,268,233 ,str)
function This:resetScoolSize3(node,widthLimit,_height ,text)
    if node and not node.txt then
        node.txt = node:getChildByName("txt")
    end
    if not _height or not node or not node.txt  then
        return
    end
    local height = 0
    local texRule1 = node.txt
    texRule1:setStringWithColor(text,widthLimit)
    local w ,h = texRule1:getContentSize()
    h = h*texRule1:getScaleY()
    height = height + h
    if height < _height then
        height = _height
    end
    texRule1:setPositionY(height)
    node:setInnerContainerSize(widthLimit,height)
end

function This:resetScoolSize2(node,widthLimit,_height ,text)
	if node and not node.txt then
		node.txt = node:getChildByName("txt")
	end
    if not _height or not node or not node.txt  then
        return
    end
    local height = 0

    local texRule1 = node.txt
    texRule1:setString(text,widthLimit/texRule1:getScaleX())
    local w ,h = texRule1:getContentSize()
    h = h*texRule1:getScaleY()
    height = height + h
    if height < _height then
        height = _height
    end
    texRule1:setPositionY(height)
    node:setInnerContainerSize(widthLimit,height)
end

function This:resetScoolSize(node,widthLimit,_height ,texts)
    if node and not node.txt then
    	local txt ={}
    	for i=1,2 do
    		local item = node["txt"..i]
    		txt[i]= item
    	end
      	node.txt =txt
    end
    if not _height or not node or not node.txt  then
        return
    end
    local txt =node.txt
    for i,v in ipairs(txt) do
    	v:setString(texts[i])
    end
    local height = 0

    local texRule1 = txt[1]
    local w ,h = texRule1:getContentSize()
    h = h*texRule1:getScaleY()
    height = height + h
    if height < _height then
        height = _height
    end
    for i,v in ipairs(txt) do
    	v:setPositionY(height)
    end
    node:setInnerContainerSize(widthLimit,height)
end

function This:resetTexts(node,texts,isHaveColor,itemCount,txtWidth)
	local textCount = #texts
	local countLimit = itemCount or textCount
	if countLimit >textCount then
		for txtIndex=textCount,countLimit do
			node["txt"..txtIndex]:setVisible(false)
		end
	end
	for txtIndex,txtStr in ipairs(texts) do
		local txt = node["txt"..txtIndex]
		if txt then
			txt:setVisible(true)
			if isHaveColor then
				txt:setStringWithColor(txtStr,txtWidth)
			else
				txt:setString(txtStr,txtWidth)
			end
		end
	end
end

function This:checkNeedItem(scrollview)
    local itemList = scrollview:getItemList()
    if #itemList ==0 then
    	local parent = scrollview:getParent()
    	local scrollviewnode = parent.scrollviewnode
    	if scrollviewnode then
    		itemList = itemList:getChildren()
    	end
    end
    for index,itemNode in ipairs(itemList) do
        local needNum =itemNode.needNum
        local total1 = itemNode:getItemCount()
        if needNum> total1 then
            local name = itemNode:getItemName() 
            g_scene:showTips(string.format(Serialize["world_TreasureBox_2"],name))
            return true
        end
    end
    return false
end

function This:creatItemNode(parent,model,showNeed,zorder)
	local ItemNode = require("UI.ItemNode")
	local name = "ItemNode"
    local node = parent:getChildByName(name)
    local key = model[1]
    local needNum = model[2]
    if not node then
        if showNeed then
        	node = ItemNode:create(key, 1,true)
        	node:initItem(key,1,true) 
		    node.needNum = needNum
		    node:showNeedNum(needNum)
        else
        	node = ItemNode:create(key,needNum)
        end
        parent:addChild(node,zorder)
        node:setAnchorPoint(0.5,0.5)
        node:setName(name)
    end
    if showNeed then
	    node:initItem(key,1,true)
	    node.needNum = needNum
	    node:showNeedNum(needNum)
    else
    	node:initItem(key,needNum)
    end
    return node
end

function This:refreshItemInfo(id,parent,nameNode,desNode,desLength)
	if id then
		local ItemUtil = require("Bag.ItemUtil")
		if desNode then
			desNode:setString(ItemUtil.getComment(id),desLength)
		end
		if nameNode then
		    nameNode:setString(ItemUtil.getName(id))
		    nameNode:setColorByID("Q".. ItemUtil.getQuality(id))
		end
		if parent then
	    	self:creatItemNode(parent,{id})	
		end
	end
end

function This:resetScoolItemNode(scroolView,reward,keyItem,isNeed,offsetX,recommendCount)
	local ItemNode = require("UI.ItemNode")
	scroolView:setDirection("horizontal")
    scroolView.m_direction = "right"
	scroolView:removeAllItems()
    local function createItemView(model,showNeed)
    	local key = model[1]
    	local needNum = model[2]
        local node = nil
        if showNeed then
        	node = ItemNode:create(key, 1,true)
        	node:initItem(key,1,true) 
		   node.needNum = needNum
		   node:showNeedNum(needNum)
        else
        	node = ItemNode:create(key,needNum)
        end
        node:setAnchorPoint(0.5,0.5)
        return node
    end
    
    local rewardCount = table.count(reward)

	local parent = scroolView:getParent()
	local scrollviewnode = parent.scrollviewnode
	if scrollviewnode then
		scrollviewnode:removeAllChildren()
	end
    if recommendCount and scrollviewnode and recommendCount>rewardCount then
    	local w = 5
    	-- local width =92+10
		for itemId,itemValue in pairs(reward) do
			local node = nil
	    	if keyItem then
	    		node = createItemView({itemId,itemValue},isNeed)
	    	else
	    		node = createItemView(itemValue,isNeed)
	    	end
			node:setAnchorPoint(0,0.5)
			node:setPositionX(w)
			w = w + node:getContentWidth() + 10
			scrollviewnode:addChild(node)
		end
		-- local posx = scroolView:getPositionX()+ (rewardCount/2)*-width
		-- scrollviewnode:setPositionX(posx*scrollviewnode:getScaleX())
		local posx = scroolView:getPositionX()+ (- w / 2)*scrollviewnode:getScaleX()
		scrollviewnode:setPositionX(posx)
    else
	    for itemId,itemValue in pairs(reward) do
	    	local item1 = nil
	    	if keyItem then
	    		item1 = createItemView({itemId,itemValue},isNeed)
	    	else
	    		item1 = createItemView(itemValue,isNeed)
	    	end
	        local w , h = item1:getContentSize()
	        if offsetX then
	        	w = w+offsetX
	        end
	        scroolView:pushBackCustomItem(item1,w,h,0.5)
	    end
    end
end

--两个表相加
-- GameUtil:tableAdd(curentAttr,res)
function This:tableAdd( table1,table2 )
	local result = table.clone(table2)
    for k,v in pairs(table1) do
        if result[k] then
            result[k] = result[k] + v
        else
            result[k] = v
        end
    end 
    return result
end

function This:getAttrStr( key,value ,removeAdd)
	local name = AttrName[key]
	local attr = "+%d"
	if removeAdd then
		attr ="%d"
	end
	if AttrType.kFirst ==key then
		attr ="+%.2f"
		if removeAdd then
			attr ="%.2f"
		end
	end
	if AttrInfo[key] and AttrInfo[key].valueType == ValueType.kPercent then
		value = value * 100
		attr = "+%.1f%%"
		if removeAdd then
			attr ="%.1f%%"
		end
	end
	return name,string.format(attr, value)
end

--属性特效
function This:createAttrEffect(node,count,offsetY,countLimit)
	if not node or not count then
        return
    end
    if not offsetY then
        offsetY = 31
    end
    local function createAnim( parent,anmStr )
        -- local GameUtil = require("Util.GameUtil")
        local effect1 = self:createEffect(anmStr)
        parent:addChild(effect1)
        return effect1
    end
    local maxCount = count
    if maxCount and countLimit and countLimit>maxCount then
        maxCount = countLimit
    end
    node:removeAllChildren()
    for index=1,maxCount do
        local effects = createAnim( node,"ShuXing" )
        local y= (index-1)*offsetY
        effects:setPositionY(-y)
    end
end
--宝箱特效
function This:createBoxEffect(isAdd,node,boxIndex,boxIsGray)
    local function createAnim( parent,anmStr )
        -- local GameUtil = require("Util.GameUtil")
        local effect1 = self:createEffect(anmStr,true)
        parent:addChild(effect1,-1)
        return effect1
    end
   
    node:removeAllChildren()
    local textures ={"MenuScene/boxLock"..boxIndex..".png","MenuScene/boxGet"..boxIndex..".png"}
    local texture = textures[1]
    if isAdd then
        texture = textures[2]
        local effect1 = createAnim(node,"BoxLing")
        local w ,h = node:getContentSize()
        effect1:setPosition(w/2, h/2)
        local effect2 = createAnim(node,"BoxLing2")
        effect2:setPosition(w/2, h/2)
    elseif boxIsGray then
    	texture = textures[2]
    end
    node:setImage(texture)
    self:btnGray(node,boxIsGray)
end

-- node：节点  isHaveRed:红点状态   position:{x,y}  
function This:refreshRedDot(node,isHaveRed,position,scale) 
	if node then
		if not node.hongdian then
			 local red = cc.Sprite:create("LoginScene/baoman.png")
			 if position then
			   	red:setPosition(position[1],position[2])
			 else
			   	local w , h = node:getContentSize()
			 	local w1 , h1 = red:getContentSize()
			 	red:setPosition(w - w1/2,h - h1/2)
			 end
			 if scale then
			   	red:setScale(scale)
			 end
			 node.hongdian = red
			 node:addChild(red)
		end
		node.hongdian:setVisible(isHaveRed)
	end
end

function This:createRedDotTo(node)
	local tag = 1547192705
	local redDot = node:getChildByTag(tag)
	if redDot then
		return redDot
	end

	redDot = cc.Sprite:create("LoginScene/baoman.png")
	redDot:setTag(tag)

	redDot:setAnchorPoint(0.5, 0.5)
	local nodeWidth , nodeHeight = node:getContentSize()
	local redDotWidth , redDotHeight = redDot:getContentSize()
	redDot:setPosition(nodeWidth-redDotWidth/2, nodeHeight-redDotHeight/2)

	node:addChild(redDot)
	return redDot
end

function This:btnGray(btn,isGray)
    local gray = false
    if isGray then
        gray = true
    end
    if btn then
        if gray then
            btn:setGrayShader()
        else
            btn:clearShader()
        end
    end
end

function This:findItem(list,listItem)
	local result = false
	if list and listItem then
		for _,value in pairs(list) do
			if listItem == value then
				result = true
				break
			end
		end
	end
	return result
end

function This:checkTables( _table )
    local res = false
    if _table  then
    	local function checktable(value)
		    if type(value) ~= "table" then value = {} end
		    return value
		end
        _table = checktable(_table)
        res = next(_table) == nil
        return   res
    end
    return true
end
 	-- rewardTable 本地的奖励列表
    -- curentScore 当前积分
    -- rewardConfig 奖励的配置表,仅支持从1开始的顺序表
    -- rewardReceivedData 已经领取的奖励列表
function This:refreshRewardList(rewardTable,curentScore,rewardConfig,rewardReceivedData,rewardMarkStr)
    local temRewardTable = rewardTable or {}
    if self:checkTables(rewardTable) or self:checkTables(rewardConfig) then
    	return rewardTable,false,0
    end
    local rewardHistory = rewardReceivedData
    table.sort(rewardHistory,function(a,b)
        return a < b
    end)
    local starCount = curentScore
    local isCanReward = false
    local maxCanRewardIndex =0
    local minCanRewardIndex = 1
    for i,item in ipairs(rewardConfig) do
        if item and item[rewardMarkStr]<= starCount then
            maxCanRewardIndex = i
            isCanReward = true
        end
    end
    for index=1,maxCanRewardIndex do
        rewardTable[index].state = RecruitManagerBoxState.kOpen
    end
    for index1=1,#rewardConfig do
        local isFind = table.find(rewardHistory, function (index, value)
            return index1 == value
        end)
        if not isFind then
            minCanRewardIndex = index1
            break
        end
    end
    for _,configIndex in ipairs(rewardHistory) do
        if rewardTable[configIndex] then
            rewardTable[configIndex].state = RecruitManagerBoxState.kClose
        elseif maxCanRewardIndex >= configIndex then
            isCanReward = true
            rewardTable[configIndex].state = RecruitManagerBoxState.kOpen
        else
            rewardTable[configIndex].state = RecruitManagerBoxState.kLock
        end
    end

    if maxCanRewardIndex ==table.count(rewardHistory) then
        isCanReward = false
        if #rewardConfig == maxCanRewardIndex then
            minCanRewardIndex = maxCanRewardIndex
        end
    end
    local minChallengeStarLv = 0
    local minItem = rewardConfig[minCanRewardIndex]
    if minItem then
    	minChallengeStarLv = minItem[rewardMarkStr]
    end
    return rewardTable,isCanReward,minChallengeStarLv
end

function This:getConfigItem(configItem,configItemKey,id,configTables,normalValue)
	if id then
		if configTables[id] then
			return configTables[id][configItemKey]
		else
			return normalValue
		end
	else
		return configItem[configItemKey]
	end
end

-- UUID本地生成器
function This:createUUID( )
    local s = {}
    local hexDigits = "0123456789abcdef"
    for i=1, 36 do
        s[i] = string.byte(hexDigits, math.floor(math.random() * 0x10 + 1))
    end
    s[20] = string.byte(hexDigits, bit.bor(bit.band(s[19], 0x3), 0x8))
    local skipList = {
        [15] = '4',
        [9] = '-',
        [14] = '-',
        [19] = '-',
        [24] = '-',
    }

    for i, v in ipairs(s) do
        if skipList[i] then
            s[i] = skipList[i]
        else
            s[i] = string.char(v)
        end
    end
    local ret = table.concat(s, '')
    return ret
end

-- 服务器开头标识
-- B开头: 1-1030, R开头: 1031以后
function This:getServerTag(serverId)
	if serverId <= 1030 then
		return "B"
	end
	return "R"
end

-- 打折显示
function This:discountStr(discount)
	local lang = AppText:getLanguage()
	if lang == AppLanguage.en_US then
		return string.format("%s%% %s", 100 - discount*10, Serialize[60327])
	end
	return string.format("%s%s", discount, Serialize[60327])
end