local This, super = class(..., "Dialog")
local VipManager = require("Vip.VipManager")
local ItemNode = require("UI.ItemNode")

function This:initNode()
    self.m_csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/MemberPrivilege.csb")
    self.m_csNode:setPosition(cc.visible.center.x,cc.visible.center.y)
    self:addChild(self.m_csNode)

    local models = VipManager:getMemberModels()
    for i=1, VipType.kMax do
    	local curNode = self.m_csNode[VipName[i]]
    	local curConfig = models[i]:getConfig()
		local reward = curConfig.daily_reward
	    for i=1, 4 do
	        local item = reward[i]
            local curRewardNode = curNode["reward" .. i]
            if curRewardNode then
                local node = curRewardNode.node
                if item then
                    if not node then
                        node = ItemNode:create(item[1], item[2])
                        node:setAnchorPoint(0.5, 0.5)
                        -- node:setScale(0.5)
                        local w, h = curRewardNode:getContentSize()
                        node:setPosition(w * 0.5, h * 0.5)
                        curRewardNode:addChild(node)
                        curRewardNode.node = node
                    else
                        node:init(item[1], item[2])
                        node:setVisible(true)
                    end
                else
                    if node then
                        node:setVisible(false)
                    end
                end
    	    end
        end
    end   
end


function This:initTouchEvent()
    self.m_csNode.surebutton:setTouchEnded(function()
        self:close()
    end)
end