-- @Author: Admin
-- @Date:   2017-10-08 16:02:50
-- @Last Modified by:   zheng
-- @Last Modified time: 2018-12-08 17:40:22

-- Vip类型
VipType = {
    kNone = 0,
    kVIP = 1,
    kSVIP = 2,
    kSSVIP = 3,
    kMax = 3,
}

-- Vip类型名字
VipName = {
    [VipType.kNone] = "",
    [VipType.kVIP] = "VIP",
    [VipType.kSVIP] = "SVIP",
    [VipType.kSSVIP] = "SSVIP",
}

-- Vip图片路径
VipImageName = {
    [VipType.kNone] = "GameScene/vip" .. VipType.kNone .. ".png",
    [VipType.kVIP] = "GameScene/vip" .. VipType.kVIP .. ".png",
    [VipType.kSVIP] = "GameScene/vip" .. VipType.kSVIP .. ".png",
    [VipType.kSSVIP] = "GameScene/vip" .. VipType.kSSVIP .. ".png",
}

-- Vip会员开放状态 1未开放 2已开放
VipState = {
    kLocked = 1,
    kUpdating  =2,
}

-- Vip奖励类型
VipReward = {
    kActive = 1,
    kDaily = 2,
    kRenew = 3,
}

-- [特权类型]
Privilege = {
    kBuildTime = 1,                     -- 封地建筑升级加速免费时间    
    kRobberFightTime = 2,               -- 贼寇战斗次数上限    
    kFightSkipDiamond = 3,              -- 跳过战斗元宝  
    kTerrTechnUpdate = 4,               -- 科技升级观看特权
    kFiveRecruitCost = 5,               -- 五连抽
    kBuildQueueUnlock = 6,              -- 第三建筑队列解锁
    kAltarRefreshTimes = 7,             -- 祭坛刷新次数
    kStageFightResetTimes = 8,          -- 关卡重置次数
    kGlodChangeTimes = 9,               -- 点金手次数

    kRecruitCD = 10,                    -- 单抽CD        
    kStageSweepUnlock = 11,             -- 扫荡功能开启
    kArenaBuyTimes = 12,                -- 竞技场挑战机会的购买次数
    kArenaUnlock = 13,                  -- 扫荡功能开启
    kCrusadeUnlock = 14,                -- 一键讨伐开启

    kSupplyTroops = 30,                  -- 自動補兵
    kAutoBuild = 31,                     -- 自動建設
    kArmyUnlock = 32,  
    kLeginUnlock = 33,  
    kTerrOfflineLimit = 99,             -- 封地离线收益时间   
}

-- [Vip特权的有效期种类] 0与会员一致 1在会员过期的第二天之前有效 2空闲为类型0，非空闲一直有效
PrivlValidType = {
    kNormal = 0,
    kDaysValid = 1,
    kInUseValid = 2,    
}

-- [Vip特权的适用范围种类] 2.vip 4.官职 8.等级 
PrivlScopeType = {
    kNone = 0,
    kMIX = 1,
    kVIP = 2,
    kOffice = 4,    
    kLevel = 8,    
}          

-- [特权类型] 
PrivlScopeMap = {
    [Privilege.kBuildTime] = PrivlScopeType.kVIP,              -- 封地建筑升级加速免费时间    
    [Privilege.kRobberFightTime] = PrivlScopeType.kVIP,        -- 贼寇战斗次数上限    
    [Privilege.kFightSkipDiamond] = PrivlScopeType.kMIX + PrivlScopeType.kVIP + PrivlScopeType.kLevel,                           -- 跳过战斗元宝  
    [Privilege.kRecruitCD] = PrivlScopeType.kMIX + PrivlScopeType.kVIP + PrivlScopeType.kOffice,                                 -- 单抽CD        
    [Privilege.kTerrTechnUpdate] = PrivlScopeType.kVIP,        -- 科技升级观看特权
    [Privilege.kFiveRecruitCost] = PrivlScopeType.kVIP,        -- 五连抽
    [Privilege.kBuildQueueUnlock] = PrivlScopeType.kVIP,       -- 第三建筑队列解锁
    [Privilege.kStageSweepUnlock] = PrivlScopeType.kMIX + PrivlScopeType.kVIP + PrivlScopeType.kOffice + PrivlScopeType.kLevel,  -- 扫荡功能开启
    [Privilege.kAltarRefreshTimes] = PrivlScopeType.kVIP,      -- 祭坛刷新次数
    [Privilege.kStageFightResetTimes] = PrivlScopeType.kVIP,   -- 关卡重置次数
    [Privilege.kGlodChangeTimes] = PrivlScopeType.kVIP,        -- 点金手次数
    [Privilege.kArenaBuyTimes] = PrivlScopeType.kVIP,          -- 竞技场挑战机会的购买次数

    [Privilege.kTerrOfflineLimit] = PrivlScopeType.kVIP,       -- 封地离线收益时间    

    [Privilege.kSupplyTroops] = PrivlScopeType.kOffice,
    [Privilege.kAutoBuild] = PrivlScopeType.kOffice,
    [Privilege.kArmyUnlock] = PrivlScopeType.kOffice,
    [Privilege.kLeginUnlock] = PrivlScopeType.kOffice,
    [Privilege.kArenaUnlock] = PrivlScopeType.kLevel,
    [Privilege.kCrusadeUnlock] = PrivlScopeType.kVIP,
}

PrivlLevelMap = {
    [Privilege.kFightSkipDiamond] = 17, --跳过战斗
    [Privilege.kStageSweepUnlock] = 30, --扫荡
    [Privilege.kArenaUnlock] = 20,      --解锁竞技场
}

-- [特权类型] 配置表字段名字 （内部使用）
PrivilegeField = {
    [Privilege.kBuildTime] = "build_free_time",                 -- 封地建筑升级加速免费时间    
    [Privilege.kRobberFightTime] = "robber_fight_times_limit",  -- 贼寇战斗次数上限    
    [Privilege.kFightSkipDiamond] = "skip_cost",                -- 跳过战斗元宝  
    [Privilege.kRecruitCD] = "recruit_cd",                      -- 单抽CD       q 
    [Privilege.kTerrTechnUpdate] = "techn_update",              -- 科技升级观看特权
    [Privilege.kFiveRecruitCost] = "five_recruit_cost",         -- 五连抽             
    [Privilege.kBuildQueueUnlock] = "build_queue_unlock",       -- 第三建筑队列解锁
    [Privilege.kStageSweepUnlock] = "stage_sweep_unlock",       -- 扫荡功能开启 q
    [Privilege.kAltarRefreshTimes] = "altar_refresh_times",     -- 祭坛刷新次数
    [Privilege.kStageFightResetTimes] = "stage_reset_tiems",    -- 关卡重置次数
    [Privilege.kGlodChangeTimes] = "coin_count",                -- 点金手次数
    [Privilege.kTerrOfflineLimit] = "offline_time_limit",       -- 封地离线收益时间    

    [Privilege.kSupplyTroops] = "supply_troops",       -- 自動補兵
    [Privilege.kAutoBuild] = "automaticbuild",         --  自動建設
    [Privilege.kArmyUnlock] = "arm_unlock",  
    [Privilege.kLeginUnlock] = "legin_unlock",
    [Privilege.kArenaBuyTimes] = "arena_times",        -- 竞技场挑战机会的购买次数
    [Privilege.kArenaUnlock] = "arena_unlock",        -- 竞技场
    [Privilege.kCrusadeUnlock] = "crusade_unlock",        -- 讨伐
}


kOpenGoldChangeLevel = 10