--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This = class(...)

local lib_voice_chat = lib2d.ccVoiceChat

function This:init()
	lib_voice_chat.setLuaJoinRoomCallback(function(memberId)
		print("进入语音房间回调")
		if self.m_joinRoomHandler then
			self.m_joinRoomHandler(memberId)
		end
	end)
	lib_voice_chat.setLuaRecordCallback(function(fileId,size)
		print(string.format("记录语音回调：%s",fileId))
		if self.m_recordHandler then
			self.m_recordHandler(fileId,size)
		end
	end)
	lib_voice_chat.setLuaPlayCallback(function()
		print("播放语音回调")
		if self.m_playHandler then
			self.m_playHandler()
		end
	end)
	lib_voice_chat.setLuaSpeechCallback(function(str)
		print("翻译语音回调")
		if self.m_speechHandler then
			self.m_speechHandler(str)
		end
	end)
end

function This:joinTeamRoom(roomName)
	assert(roomName)
	local ret = lib_voice_chat.joinTeamRoom(roomName)
	if ret ~= 0 then
		print("加入小队语音失败")
	end
	return ret
end

function This:joinNationalRoom(roomName,isAnchor)
	assert(roomName)
	isAnchor = isAnchor or false
	local ret = lib_voice_chat.joinNationalRoom(roomName,isAnchor)
	if ret ~= 0 then
		print("加入国战语音失败")
	end
	return ret
end

function This:exitRoom()
	lib_voice_chat.exitRoom()
end

function This:setJoinRoomCallback(handler)
	self.m_joinRoomHandler = handler
end

function This:recordVoice(playerId)
	assert(type(playerId) == "string")
	local ret = lib_voice_chat.recordVoice(playerId)
	if ret ~= 0 then
		print("记录语音失败")
	end
	return ret
end

function This:stopRecord()
	lib_voice_chat.stopRecord()
end

function This:cancelRecord()
	lib_voice_chat.cancelRecord()
end

function This:setRecordCallback(handler)
	self.m_recordHandler = handler
end

function This:playVoice(voiceId)
	assert(type(voiceId) == "string")
	local ret = lib_voice_chat.playVoice(voiceId)
	if ret ~= 0 then
		print("播放录音失败")
	end
	return ret
end

function This:stopPlay()
	lib_voice_chat.stopPlay()
end

function This:setPlayCallback(handler)
	self.m_playHandler = handler
end

function This:speechText()
	local ret = lib_voice_chat.speechText()
	if ret ~= 0 then
		print("翻译语音失败")
	end
	return ret;
end

function This:stopSpeech()
	lib_voice_chat.stopSpeech()
end

function This:cancelSpeech()
	lib_voice_chat.cancelSpeech()
end

function This:setSpeechCallback(handler)
	self.m_speechHandler = handler
end

function This:pause()
	lib_voice_chat.pause()
end

function This:resume()
	lib_voice_chat.resume()
end

function This:clear()
	lib_voice_chat.clear()
end

This:init()

--endregion
