-- @Author: Su
-- @Date:   2019-05-06 15:29:31
-- @Last Modified by:   Su
-- @Last Modified time: 2019-05-06 15:29:31
-- @File Name: AnimalTeamWarView.lua
-- @Description:

local This , super = class(...,"Warfare.TeamWarView")
local ItemNode = require("UI.ItemNode")
local WarfareManager = require("Warfare.WarfareManager")
local ArgConfig = require("Metadatas.ArgConfig")
local GamePlayer = require("Player.GamePlayer")



function This:initData(war)
    self.m_war = war
    self.m_inited = false
    self.m_csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/TeamWarRefreshItem.csb")
    local w, h = self.m_csNode.kuang:getContentSize()
    self:setContentSize(w-15, h + 40)
    self:addChild(self.m_csNode)
    self:initNode()
    self:initTouchEvent()
end

function This:initTouchEvent()
    if not self.m_inited then
        self.m_csNode.button:setTouch({
            onEnded = function(touch, point, params)
                local limitLevel = ArgConfig.mythical_campaign_refresh_open_level.arg[1]
                if GamePlayer:getLevel() < limitLevel then
                    g_scene:showTips(string.format( Serialize[60304],limitLevel))
                    return 
                end
                if not self.m_war then
                    return
                end
                if self.m_war:getIsFight() then
                    return 
                end
                if not WarfareManager:hasTeam() then
                    WarfareManager:onCreateTeamRequest(self.m_war:getCopyId(), self.m_war:getId())
                else
                    local team = WarfareManager:getMyTeam()
                    local war = team:getWar()
                    if war:getType() ~= WarfareType.kAnimal then
                        g_scene:showTips(Serialize[64502])
                        return
                    end
                end

                -- g_scene:openDialog("Warfare.TeamWarfareFundPanel",{war = self.m_war})
                print("神兽战役")
            end,
            isContainer = true,
            isScale = false
        })
        self.m_inited = true
    end

end

function This:onEnter()
    WarfareManager:addObserver(self)
end

function This:onExit()
    WarfareManager:removeObserver(self)
end

function This:refresh()
    local csNode = self.m_csNode
    local rewardNode = csNode.rewardn
    local hard = self.m_war:getNextHard()

    local config = self.m_war:getConfig()
    local bg= string.format("MenuScene/bganimal%d.png",hard)
    local pic = string.format("MenuScene/bganimalhero%d.png",hard)
    local name = string.format("MenuScene/wordanimal%d.png",hard)
    local namebg = string.format("Common/biaoqiananimal%d.png",hard)
    local itembg = string.format("Common/kuang171animal%d.png",hard)

    csNode.kuang:setImage(bg)
    csNode.pic:setImage(pic)
    csNode.name:setImage(name)
    csNode.namebg:setImage(namebg)
    csNode.bgtiao:setImage(itembg)

    csNode.button:setVisible(not self.m_war:getIsFight())
    csNode.yitiaozhan:setVisible(self.m_war:getIsFight())
    -- csNode.name:setString(Serialize[64835])
    local rewardList = self.m_war:getRewardList()
    for i =1, #rewardList do
        local pnode = rewardNode["item"..i]
        local itemId = rewardList[i][1]
        local itemNum = rewardList[i][2]
        if not pnode.node then
            pnode.node = ItemNode:create(itemId,itemNum)
            pnode.node:setAnchorPoint(0.5, 0.5)
            pnode:addChild(pnode.node)
        else
            pnode.node:init(itemId,itemNum)
        end
    end
end

function This:onCreateAnimalTeam(team)
    if team:getWar():getId() == self.m_war:getId() then
        g_scene:openDialog("Warfare.TeamWarfareFundPanel",{war = self.m_war})
    end
end

function This:onExitAnimalTeam(team,iswin)
    if team:getWar():getId() == self.m_war:getId() then
        WarfareManager:onRemoveTeamRequest()
        self.m_war:setIsFight(iswin)
        self:refresh()
    end
end
