-- @Author: superm
-- @Date:   2018-08-23 10:28:20
-- @Last Modified by:   superm
-- @Last Modified time: 2018-09-01 22:27:43
-- @File Name: MatchBaseTeam.lua
-- @Description: 
local This , super = class(...,"Base.BaseModel")
local TeamCampaignConfig = require("Metadatas.TeamCampaignConfig")

function This:init(info)
	super.init(self)
	self.m_id = info.team_id or 0
	self.m_ownerId = info.owner_id
	self.m_warfareId = info.copy_id
	self.m_warfareHard = info.copy_level
	self.m_autoJoin = true
	self.m_roleInfo = info.role_list
end

function This:updateInfo(info)
	self.m_warConfig = nil
	
	self.m_id = info.team_id 
	self.m_ownerId = info.owner_id
	self.m_warfareId = info.copy_id
	self.m_warfareHard = info.copy_level
	self.m_roleInfo = info.role_list
	self.m_autoJoin = true
end

function This:getId()
	return self.m_id
end

function This:getOwnerId()
	return self.m_ownerId
end

function This:getHard()
    return self.m_warfareHard
end

function This:getWarfareConfig()
	local config = self.m_warConfig
	if not config then
	    config = TeamCampaignConfig[self.m_warfareId]
	    self.m_warConfig = config
	end
    return config
end

function This:getPeople()
	local config = self:getWarfareConfig()
    return #self.m_roleInfo, config.number[2]
end

function This:getWarName()
	local config = self:getWarfareConfig()
    return config.name
end

function This:setView(view)
    self.m_view = view
end

function This:getWar()
	if not self.m_build then
		local TerrBuildManager = require("Territory.TerrBuildManager")
    	self.m_build = TerrBuildManager:getBuildByType(TerrBuildType.kJiaoChang)
    end

	return self.m_build:getWarfare(self.m_warfareId)
end

function This:canJoin()
    if not self.m_autoJoin then
    	return false
    end

	local number, max = self:getPeople()
	if number >= max then
		return false
	end

	local war = self:getWar()
	if not war or not war:isOpening() then
		return false
	end

    return true
end