-- @Author: superm
-- @Date:   2018-08-14 17:04:19
-- @Last Modified by:   superm
-- @Last Modified time: 2019-11-30 14:23:15
-- @File Name: MatchTeam.lua
-- @Description: 

local This , super = class(..., "Match.MatchRoom")

function This:initInfo(info)
	self.m_roleRemoved = {}
	self.m_roleList = {}
	self.m_matching = false

	local teamId = info.team_id or 0
	self.m_id = tonumber(teamId)
	
    local ownerId = info.owner_id or 0
	self.m_ownerId = tonumber(ownerId)
	if info.role_list then
		for i , roleInfo in ipairs(info.role_list) do
			self:addRole(roleInfo)
		end
	end
	
	self:setOwnerId(self.m_ownerId)
	self:updateTeamAttrInfo(info)
	self:updateWarfareInfo(info)
end

function This:updateInfo(info)
	self.m_warConfig = nil
	self.m_id = info.team_id 
	self.m_ownerId = info.owner_id

	local updateList = {}
	for i , roleInfo in ipairs(info.role_list) do
		updateList[roleInfo.role_id] = roleInfo
	end
	for i = #self.m_roleList, 1 , -1 do
		local role = self.m_roleList[i]
		if not updateList[role:getId()] then
			table.remove(self.m_roleList,i)
			self.m_roleRemoved[role:getId()] = role
		end
	end
	for i , roleInfo in ipairs(info.role_list) do
		local role = self:getRole(roleInfo.role_id)
		if role then
			role:updateInfo(roleInfo)
		else
			self:addRole(roleInfo)
		end
	end

	if info.owner_id then
		self:setOwnerId(self.m_ownerId)
	end
	self:updateTeamAttrInfo(info)
	self:updateWarfareInfo(info)
end

function This:getPeople()
	local config = self:getWarfareConfig()
    return #self.m_roleList, config.number[2]
end

function This:setView(view)
    self.m_view = view
end

function This:setAutoJoin(value)
	self.m_autoJoin = value
end

function This:getAutoJoin()
	return self.m_autoJoin
end

function This:isCaptain()
	local role = self:getMainRole()
	return role and role:isRoomOwner()
end

function This:isInBattle()
    return self.m_inBattle
end

function This:getType()
	return TeamType.kMatchTeam
end

function This:getWarfareConfig()
	
end