-- @Author: superm
-- @Date:   2018-08-18 17:31:15
-- @Last Modified by:   superm
-- @Last Modified time: 2018-09-06 10:54:58
-- @File Name: TeamListItemView.lua
-- @Description: 

local This , super = class(..., "NodeView")
local WarfareUtil = require("Warfare.WarfareUtil")
local WarfareManager = require("Warfare.WarfareManager")

function This:initData(team, index)
    self.m_team = team
    -- self.m_inited = false
    local csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/TeamWarOrganizeList.csb")
    self.m_csNode = csNode
    self:addChild(csNode)

    local w , h = csNode.bg:getContentSize()
    self:setContentSize(w, h)
end

function This:onEnter()
    super.onEnter(self)
    self.m_team:setView(self)
end

function This:onExit()
    self.m_team:setView(nil)
    super.onExit(self)
end

function This:initNode()
    self:refresh()
end

function This:initTouchEvent()
    if not self.m_inited then
    	local csNode = self.m_csNode
    	csNode.buttonbg:setTouch({
            onEnded = function()
            	self:onBtnClick()
            end,
            isContainer = true,
            isScale = false
        })
        self.m_inited = true
    end
end

function This:refresh()
    local csNode = self.m_csNode
    csNode.fubenname:setString(self.m_team:getWarName())
    csNode.nanyidu:setString(WarfareUtil.getHardDesc(self.m_team:getHard()))
    local number, max = self.m_team:getPeople()
    csNode.number:setString(number .. "/" .. max)
end

function This:setModel(team, index)
    if team ~= self.m_team then
        self:setTeam(team)
        self:refresh()
    end
end

function This:setTeam(team)
    if self.m_team then
        self.m_team:setView(nil)
    end
    self.m_team = team
    if team then
        team:setView(self)
    end
end

function This:onBtnClick()
    if WarfareManager:hasTeam() then
        g_scene:showTips(Serialize[64844])
        return
    end
    
    if self.m_team:canJoin() then
        WarfareManager:onJoinMatchTeamRequest(self.m_team:getId())
    end
end