-- @Author: superm
-- @Date:   2018-08-23 20:11:29
-- @Last Modified by:   superm
-- @Last Modified time: 2018-12-24 17:21:58
-- @File Name: TeamRole.lua
-- @Description: 

local This , super = class(...,"Match.RoomRole")

function This:init(roleInfo)
	self.m_observers = {}
	self.m_isDirty = false
	super.init(self, roleInfo)
	self.m_rankLv = self.m_rankLv or 0
	self.m_fightPower = roleInfo.fight_power or 0
end

function This:setView(view)
    self.m_view = view
end

function This:setIsRoomOwner(isOwner)
	local dirty
	if self.m_isOwner ~= isOwner then
		self.m_isOwner = isOwner
		self.m_isReady = self.m_isReady or isOwner
		dirty  = true
	end
	if dirty and self.m_view then
		self.m_view:refreshByReady(true)
	end
end

function This:getFightPower()
    return self.m_fightPower
end

function This:updateInfo(info)
	if self.m_id == info.role_id then
		local dirty
		if info.is_ready ~= nil then
			dirty = self.m_isReady ~= info.is_ready
			self.m_isReady = info.is_ready
		end
		if info.fight_power then
			dirty = self.m_fightPower ~= info.fight_power
			self.m_fightPower = info.fight_power
		end
		
		if dirty and self.m_view then
			self.m_view:refreshByReady()
		end
	else
		super.init(self, roleInfo)
		self.m_rankLv = self.m_rankLv or 0
		self.m_fightPower = roleInfo.fight_power or 0
		if self.m_view then
			self.m_view:refresh()
		end
	end
end