-- @Author: superm
-- @Date:   2018-12-25 16:53:47
-- @Last Modified by:   zheng
-- @Last Modified time: 2018-12-31 20:07:34
-- @File Name: TowerBattleInfo.lua
-- @Description: 

local This = class(..., "Warfare.WarfareBattleInfo")
local GameUtil = require("Util.GameUtil")
local TowerManager = require("SingleDaily.TowerManager")
local BattleDataManager = require("Battle.BattleDataManager")

function This:init(info)
	local msg = info.msg
	self.m_team = info.team
	self:updateBattleInfo(msg)
end

function This:updateBattleInfo(msg)
    self.m_reportList = {}
	self.m_reportIdList = {}
	self.m_fightPlayerList = msg.fight_player
	self.m_isWin = msg.is_win

	for index, id in ipairs(msg.report_id_list) do
	    local key = GameUtil:int64ToString(id)
	    self.m_reportIdList[index] = key
	    self.m_reportList[key] = false
	end
end

function This:getRewardList()
end

function This:onShowBattleResult(victory)
    if self.m_reportList then
        BattleDataManager:removeObserver(self)
        if self.m_isWin then
        	TowerManager:onBattleVictory(self.m_team)
        else
			TowerManager:onBattleFailed(self.m_team)
        end
        self:clear()
    end
end

This.onBattleSkip = This.onShowBattleResult
