-- @Author: superm
-- @Date:   2018-08-21 16:57:32
-- @Last Modified by:   zheng
-- @Last Modified time: 2020-07-03 18:29:43
-- @File Name: WarfareBoxRewardPanel.lua
-- @Description: 

local This , super = class(..., "Hero.SaintBoxRewardPanel")
local RewardItemView, superView = class(This._NAME .. ".RewardItemView", super._NAME .. ".RewardItemView")

local TerrBuildManager = require("Territory.TerrBuildManager")

function This:initNode(info)
	self.m_war = info.war
    self.m_build = TerrBuildManager:getBuildByType(TerrBuildType.kJiaoChang)
    self.m_itemViews = {}
    local csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/TeamWarIntegral.csb")
    self.m_csNode = csNode
    self:addChild(csNode)
    csNode:setToCenter()
    csNode.numberjifen:setString(Serialize[64860] .. self.m_war:getScore())
    self:onPickupWarBoxReward()
end

function This:addCustomListener()
    if self.m_build then
        self.m_build:addObserver(self)
    end
end

function This:removeCustomListener()
    if self.m_build then
        self.m_build:removeObserver(self)
    end
end

function This:getNewItemView( ... )
    return RewardItemView:create(self, ...)
end

function This:onPickupWarBoxReward()
    self.m_itemDataList = self.m_war:getBoxRewardList()
    self:refreshRewardList()
end

function This:onPickUpBtnClick( boxId )
    if self.m_build then
        self.m_build:onPickupWarBoxRewardRequest(boxId)
    end
end

function This:sortDataList()
    table.sort(self.m_itemDataList, function( a, b )
        if a.state ~= b.state then
            return a.state > b.state
        elseif a.jifen ~= b.jifen then
            return a.jifen < b.jifen
        else
            return a.id < b.id
        end
    end)
end

------------------------------------------------------------------
function RewardItemView:initNode()
    superView.initNode(self)
    local csNode = self.m_csNode
    csNode.beijing.wusheng:setImage("MenuScene/wordjifen.png")
end

function RewardItemView:onPickUpBtnClick()
    if self:isOpening() and self.m_dialog then
    	self.m_dialog:onPickUpBtnClick(self.m_config.id)
    end
end

function RewardItemView:refresh()
    local csNode = self.m_csNode
    csNode.beijing.level:setString(self.m_config.jifen .. Serialize[60008])
    self:setItemEnable(self:isOpening())
end
