-- @Author: superm
-- @Date:   2018-08-24 16:03:33
-- @Last Modified by:   superm
-- @Last Modified time: 2018-09-04 14:50:50
-- @File Name: WarfareInvite.lua
-- @Description: 

local This , super = class(...,"Match.MatchInvite")
local WarfareManager = require("Warfare.WarfareManager")

function This:init(info)
	super.init(self, info)
    self.m_isValid = true
end

function This:createByMember(model)
	local o = {}
	setmetatable(o, self)
	o:initByMember(model)
	return o
end

function This:initByMember(model)
	self.m_observers = {}
	self.m_escape = 0
	self.m_isFamilyMem = true
	self.m_friendId = model.m_id
	self.m_name = model.m_name
	self.m_icon = model.m_icon
	self.m_level = model.m_level
	self.m_rank = model.m_rankLevel
	self.m_isOnline = model.m_isOnline
	self.m_sendType = MatchRelationType.kSingle
	self.m_view = nil
    self.m_isValid = true
end

function This:endUpdate()
	cc.Application:removeFromUpdateList(self)
	self.m_sendType = MatchRelationType.kSingle
end

function This:update(dt)
	local maxCd = 10
	self.m_escape = self.m_escape + dt
	local team = WarfareManager:getMyTeam()

	if self.m_escape >= maxCd or team:getRole(self.m_friendId) then
		self:endUpdate()
		if self.m_view then
			self.m_view:refreshTime(0)
		end
	else
		if self.m_view then
			self.m_view:refreshTime(maxCd - self.m_escape)
		end
	end
end

function This:isValid()
    return self.m_isValid
end

function This:setIsValid(value)
    self.m_isValid = value
end

function This:updateInfo( info )
    if self.m_isFamilyMem then
    	return
    end

	self.m_friendId = info.friend_id
	self.m_name = info.friend_name
	self.m_icon = info.friend_icon
	self.m_level = info.friend_level
	self.m_rank = info.friend_rank_level
	self.m_groupId = info.friend_group_id
	self.m_groupName = info.friend_group_name
	self.m_groupTitle = info.friend_group_title
	self.m_isInMap = info.in_map
	self.m_isOnline = info.online
	self.m_sendType = MatchRelationType.kSingle
    self.m_isValid = true
end