-- @Author: superm
-- @Date:   2018-08-24 16:18:05
-- @Last Modified by:   zheng
-- @Last Modified time: 2020-07-09 14:08:19
-- @File Name: WarfareInviteView.lua
-- @Description: 

local This , super = class(...,"Match.InviteView")
local WarfareManager = require("Warfare.WarfareManager")

function This:init(invite,info2)
	super.init(self,invite)
	if info2 then
		self.m_inviteCallBack = info2.inviteCallBack
		self.m_teamType = info2.teamType
	end
end
function This:refresh()
	local csNode = self.m_csNode
	local online = self.m_invite:isOnline()
	csNode.online:setVisible(online)
	csNode.outline:setVisible(not online)
	csNode.gaming:setVisible(false)

	local team = WarfareManager:getMyTeam(self.m_teamType)
	csNode.button:setVisible(online and not team:getRole(self.m_invite:getId()))
	csNode.yiyaoqing:setVisible(false)
end

function This:initTouchEvent()
	if not self.m_inited then
		local csNode = self.m_csNode
		csNode.button:setTouch({
			onEnded = function()
				if self.m_inviteCallBack then
					self.m_inviteCallBack(self.m_invite)
				else
					WarfareManager:onWarInviteRequest(self.m_invite:getId())
				end
			end,
			isContainer = true,
			isScale = false
		})

		csNode.iconbg:setTouch({
			onEnded = function()
				g_scene:openDialog("Player.RoleInfoPanel",{id = self.m_invite:getId()})
			end,
			isScale = false,
			isContainer = true
		})
		self.m_inited = true
	end
end

function This:refreshTime(leftTime)
	self.m_csNode.cd:setString(math.floor(leftTime) .. Serialize[60010])
	self.m_csNode.cd:setVisible(leftTime > 0 )
	self.m_csNode.button:setVisible(leftTime <= 0)

	if leftTime <= 0 then
		self:refresh()
	end
end
