-- @Author: superm
-- @Date:   2018-08-18 17:30:56
-- @Last Modified by:   superm
-- @Last Modified time: 2019-01-02 19:16:00
-- @File Name: WarfareOverPanel.lua
-- @Description: 

local This, super = class(...,"Player.FightResultBasePanel")
local ViewUtil = require("UI.ViewUtil")
local ItemNode = require("UI.ItemNode")

function This:initNode(info)
	local fileName = info.m_isWin and "MenuScene/NodeUI/TeamWarEnd.csb" or "GameScene/NodeUI/Fail.csb"
    self.m_csNode = cc.Node:createFromCSFile(fileName)
    self.m_csNode:setToCenter()
	self:addChild(self.m_csNode)

	self.m_battleInfo = info
	self.m_config = info:getConfig()

	self.m_result = false
	if info:isWin() then
		self.m_result = true
    	self.m_itemList = {}
		self:initItemViewList()
	else
		self:initFailedGuide()
	end
	self:initAnimation()
end

function This:initItemViewList()
	local csNode = self.m_csNode
	local isCaptain = self.m_battleInfo:isCaptain()
	
	csNode.duizhangjiangli:setVisible(isCaptain)

	local score = isCaptain and self.m_config.captain_jifen or self.m_config.member_jifen
	if score > 0 then
		csNode.numberjifen:setString(string.format("+%d",  score))
	else
		csNode.fubenjifen:setVisible(false)
		csNode.numberjifen:setVisible(false)
	end
	local function addItem(node, info)
		local inode = ItemNode:create(info.id, info.num)
		inode:setAnchorPoint(0.5,0.5)
		inode:setScale(0.8)
		node:addChild(inode)
	end

	local reward, creward = self.m_battleInfo:getRewardList()
	if reward then
		for i=1,4 do
			local info = reward[i]
			if not info then break end
			addItem(csNode["item" .. i], info)
		end
	end

	if isCaptain and creward then
		for i=1,4 do
			local info = creward[i]
			if not info then break end
			addItem(csNode["item" .. (i + 4)], info)
		end
	end
end

function This:onEnter()
	super.onEnter(self)
	cc.Audio:playEffect(self.m_result and "Win.mp3" or "Lose.mp3")
end

function This:initTouchEvent()
end

function This:initAnimation()
	self.m_csNode.continue:setScale(0.66)
	local seqence1 = cc.Sequence(cc.FadeTo(0.4,64),cc.FadeTo(0.4,255))
	local seqence2 = cc.Sequence(cc.ScaleTo(0.4,0.68),cc.ScaleTo(0.4,0.66))
	self.m_csNode.continue:runAction(cc.RepeatForever(cc.Spawn(seqence1,seqence2)))
end

function This:onTouchMask()
	local config = self.m_config
	local params = {
		tab = config.tpye, 
		args = { id = config.id }
	}
	ViewUtil:jumpToPanel("TeamWarfarePanel", params)
end

function This:getJumpToTargetScene()
	return "MenuScene"
end
