-- @Author: superm
-- @Date:   2018-08-20 20:47:10
-- @Last Modified by:   zheng
-- @Last Modified time: 2020-07-03 18:30:12
-- @File Name: WarfareSelectHeroPanel.lua
-- @Description: 

local This , super = class(...,"Stage.StageSelectHeroPanel")
local WarfareHeroItemView = require("Warfare.WarfareHeroItemView")
local UpdateLayer = require("UI.UpdateLayer")

function This:initNode(info)
	self.m_pickHeros = info.pick
	self.m_haveSelectHeros = info.haveSelected or {}
	self.m_csNode = cc.Node:createFromCSFile(info.file or "GameScene/NodeUI/LineUpChoose.csb")
	self:addChild(self.m_csNode)
	self.m_csNode:setToCenter()

	self.m_selectHandler = nil
	local heros = self:getHeroList()

	self.m_listLayer = UpdateLayer:create({
		itemWidth = 116,
		itemHeight = 164,
		column = 5,
		scrollView = self.m_csNode.CardScrollView
	})

	self.m_listLayer:setDataList(heros, function(troop)
		local view = self:getHeroView(troop)
		view:setSelectHandler(function(id)
			if self.m_pickHeros and not self.m_pickHeros[id] then
				g_scene:showTips(Serialize[60413])
		    	return 
			end

			if self.m_selectHandler then
				self.m_selectHandler(id)
			end
			self:close()
		end)
		return view
	end)

	self.m_listLayer:setCascadeOpacityEnabled(true)
	self.m_listLayer:setAnchorPoint(0.5,0)
	local w , h = self.m_listLayer:getContentSize()
	self.m_csNode.CardScrollView:pushBackCustomItem(self.m_listLayer, w,h,0)
end

function This:getHeroView(hero)
	local maxHp = hero:getAttr(AttrType.kMaxHp)
	local param = {maxHp = maxHp, hp = maxHp}
	if self.m_pickHeros then
		param.mask = function ( heroId )
			if not self.m_pickHeros then
				return true
			end
		    return self.m_pickHeros[heroId]
		end
	end
	local node = WarfareHeroItemView:create(hero:getId(), param)
	return node
end