-- @Author: superm
-- @Date:   2018-08-23 10:41:43
-- @Last Modified by:   zheng
-- @Last Modified time: 2019-12-02 10:52:49
-- @File Name: WarfareUtil.lua
-- @Description: 

local This = class(...)

WarfareType = {
	kSingle = 1,
	kTeam = 2,
    kVip = 3,
    kAnimal = 4,
    kBoss = 5,
}

TeamWarState = {
	kNotStart = 1,
	kNotStart = 2,
	kFinish = 3,
	kFighting = 4,
	kActive = 5,
}

-- 1:创建队伍, 2:查看队伍信息, 3:加入队伍
-- 4:退出/踢出队伍, 5:队长转移, 8:解散队伍
-- 6:查看阵容, 7:设置阵容，21,自动开始游戏
-- 
TeamOperateType = {
    kCreateTeam = 1,
	kGetTeamInfo = 2,
    kJoinTeam = 3,
    kExitTeam = 4,
    kChangeOwner = 5,
    kSelectHero = 7,
    kDismissTeam = 8,
    kPrepare = 9,
    kBattle = 10,
    kQuickJoin = 19,    
    kModifyAttr = 20,   
    kAutoStarGame = 21,   
    kBattleReport = 99,
}

TeamType={
    kMatchTeam = 0,
    kWarTeam = 1,
    kTowerTeam = 2,
    kWarTowerTeam = 3,--战意塔
}

TeamBattleState = {
    kInit = 1,
    kLoad = 2,
    kLoadCache = 3,
    kPlay = 4,
}

TeamOperateCommand = {
    [TeamType.kWarTeam] = {
        [TeamOperateType.kGetTeamInfo] = 12516,    
        [TeamOperateType.kCreateTeam] = 12501,
        [TeamOperateType.kJoinTeam] = 12502,
        [TeamOperateType.kPrepare] = 12503,
        [TeamOperateType.kSelectHero] = 12508,
        [TeamOperateType.kBattle] = 12504,
        [TeamOperateType.kExitTeam] = 12506,
        [TeamOperateType.kDismissTeam] = 0,
        [TeamOperateType.kChangeOwner] = 12507,
        [TeamOperateType.kQuickJoin] = 12513,
        [TeamOperateType.kBattleReport] = 12519,
        [TeamOperateType.kModifyAttr] = 12518,
    },
    [TeamType.kTowerTeam] = {
        [TeamOperateType.kGetTeamInfo] = 13701,
        [TeamOperateType.kCreateTeam] = 13701,
        [TeamOperateType.kJoinTeam] = 13701,
        [TeamOperateType.kPrepare] = 13702,
        [TeamOperateType.kSelectHero] = 13703,
        [TeamOperateType.kBattle] = 13705,
        [TeamOperateType.kExitTeam] = 13704,
        [TeamOperateType.kChangeOwner] = 13704,
        [TeamOperateType.kDismissTeam] = 13704,
        [TeamOperateType.kQuickJoin] = 0,
        [TeamOperateType.kBattleReport] = 13706,
        [TeamOperateType.kModifyAttr] = 13707,
    },
    -- [TeamType.kWarTowerTeam] = {
    --     [TeamOperateType.kGetTeamInfo] = 13701,
    --     [TeamOperateType.kCreateTeam] = 13701,
    --     [TeamOperateType.kJoinTeam] = 13701,
    --     [TeamOperateType.kPrepare] = 13702,
    --     [TeamOperateType.kSelectHero] = 13703,
    --     [TeamOperateType.kBattle] = 13705,
    --     [TeamOperateType.kExitTeam] = 13704,
    --     [TeamOperateType.kChangeOwner] = 13704,
    --     [TeamOperateType.kDismissTeam] = 13704,
    --     [TeamOperateType.kQuickJoin] = 0,
    --     [TeamOperateType.kBattleReport] = 13706,
    --     [TeamOperateType.kModifyAttr] = 13707,
    -- }
}

kTeamWarUIMaxHard = 5

kTeamWarMaxHard = 3

RomanNumerals = {"I", "II", "III", "IV", "V", "VI", "VII", "VIII", "IX", "X", "XX", "XXX", "XL", "L", "LX", "LXX", "LXXX", "XC"}

function This.getHardDesc( hard )
    return Serialize[64890] .. RomanNumerals[hard]
end

function This.createBoxEffect(node, addition, container, imageInfo)
	if not node or not container then
		return
	end
    local anmList ={"BoxLing","BoxLing2"}
    if addition then
	    local function createAnim(pnode, anm)
	        local GameUtil = require("Util.GameUtil")
	        local eff = GameUtil:createEffect(anm, true, pnode)
	        eff:setScale(1.2)
	        pnode:addChild(eff,-1)
	        container[anm]=eff
	        return effect1
	    end
		for _, anm in ipairs(anmList) do
			createAnim(node, anm)
		end
    else
    	for _, anm in ipairs(anmList) do
    		local eff = container[anm]
    		if eff then
    			container[anm] = nil
    			eff:removeFromParent()
    		end
    	end
    end
    if imageInfo then
    	local texture
    	if imageInfo == true then
    		texture = addition and "MenuScene/boxGet2.png" or "MenuScene/boxLock2.png"
    	elseif type(imageInfo) == "table" then
    		if imageInfo.pic then
	    		texture = imageInfo.pic
	    	elseif imageInfo.plist then
	    		state = imageInfo.state
	    		texture = imageInfo.plist[state]
	    	end
	    end
    	if texture then
    		node:setImage(texture)
    	end
    end
end