--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This = class(...,"World.TroopEmbattlePanel")
local super = require("Stage.EmbattleHeroPanel")
local WorldMapManager = require("World.WorldMapManager")
local Timer = require("Timer")

function This:initNode(info)
	self.m_fromCity = info.fromCity
	self.m_toCity = info.toCity
	self.m_army = info.army
	self.m_troopList = info.army:getTroopList()
	self.m_troops = {}
	for i , troop in pairs(self.m_troopList) do
		local heroId = troop:getHeroId()
		self.m_troops[heroId] = troop
	end
	super.initNode(self,info)
end

function This:initItems()
	for i , troop in ipairs(self.m_troopList) do
		self:addHero(i,troop:getHeroId())
	end
end

function This:addHeroView(heroId,pos)
	local node = self:getHeroView(heroId)
	node:setAnchorPoint(0.5,0.5)
	local w , h = self.m_csNode.bg2["Cardbg"..pos]:getContentSize()
	node:setPosition(w/2,h/2)

	self.m_csNode.bg2["Cardbg"..pos]:addChild(node)
	self.m_heros[pos].node = node
end

function This:initTouchEvent()
	self.m_csNode.Battlebutton:setTouchEnded(function()
		self:onConfirmBtnClick()
	end)
	self.m_csNode.automaticbutton:setTouchEnded(function()
		g_scene:showTips(Serialize["world_ArmyEmbattle_1"])
	end)
	self.m_csNode.close:setTouchEnded(function()
		self:close()
	end)
	self.m_csNode.helpbutton:setTouchEnded(function()
		g_scene:openDialog("UI.HelpTips",{text=Serialize["embattle_help_tips"],node = self.m_csNode.helpbutton})
	end)
end

function This:getTotalHp()
	local total = 0
	for i , troop in pairs(self.m_troopList) do
		total = total + troop:getHp()
	end
	return total
end

function This:gotoBattle(heroList,isOnceKey)
	if isOnceKey then
		return
	end

	if #heroList <= 0 then
		g_scene:handleErrorCode("please_add_hp_first")
		return
	end

	if self.m_fromCity:isFighting() then
		g_scene:showTips(Serialize["world_ArmyEmbattle_2"])
		return
	end

	local troopList = {self.m_army:getId()}
	WorldMapManager:onMarchArmyRequest(self.m_fromCity:getCityId(),self.m_toCity:getCityId(),{},{},0, troopList)
	if not self.m_toCity:isOur() then
		cc.Audio:playEffect("Chuzheng.mp3",false)
	else
		cc.Audio:playEffect("Yunshubingli.mp3",false)
	end
end


--endregion
