--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"Dialog")
local BattleDataManager = require("Battle.BattleDataManager")

local MatchManager = require("Match.MatchManager")
local ReportManager = require("Report.ReportManager")
local GamePlayer = require("Player.GamePlayer")

function This:initNode(info)
	local reportId = info.reportId
	self.m_report = ReportManager:getReport(reportId)
	self.m_csNode = cc.Node:createFromCSFile("GameScene/NodeUI/BattleEnd.csb")
	self:addChild(self.m_csNode)
	self.m_csNode:setToCenter()
	
	local isWin = false 
	local isDogfall = false
	local exp = 0
	if self.m_report then
		isWin = self.m_report:getResult() == BattleResult.kAttackerVictory 
		isDogfall = self.m_report:getResult() == BattleResult.kDogfall
		exp = self.m_report:getGotReserveExpCount()
	end
	self.m_csNode.continue_0:setVisible(isDogfall)
	self.m_csNode.battlewin_2:setVisible(isWin)
	self.m_csNode.battlefailed_1:setVisible(not isWin)

	self.m_csNode.troopsconsumption1:setVisible(exp > 0)
	self.m_csNode.text3:setVisible(exp > 0)
	if exp > 0 then
		self.m_csNode.troopsconsumption1:setString(exp)
	end
	self:initAnimation()
end

function This:initAnimation()
	self.m_csNode.continue:setScale(0.66)
	local seqence1 = cc.Sequence(cc.FadeTo(0.4,64),cc.FadeTo(0.4,255))
	local seqence2 = cc.Sequence(cc.ScaleTo(0.4,0.68),cc.ScaleTo(0.4,0.66))
	self.m_csNode.continue:runAction(cc.RepeatForever(cc.Spawn(seqence1,seqence2)))
end

function This:onTouchMask()
	if GamePlayer:isInWorld() then
		cc.SceneManager:switchTo("World.WorldScene")
	else
		cc.SceneManager:switchTo("Home.MenuScene")
	end
end

function This:onEnter()
	super.onEnter(self)
	MatchManager:addObserver(self)
end

function This:onExit()
	super.onExit(self)
	MatchManager:removeObserver(self)
end

function This:onBattleSettlement(msg)
	self.m_battleSettleData = msg
end

--endregion
