--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"Dialog")
local GameUtil = require("Util.GameUtil")
local WorldUtil = require("World.WorldUtil")

function This:initNode(build)
	self.m_build = build
	self.m_csNode = cc.Node:createFromCSFile("GameScene/NodeUI/BulidILevelUp.csb")
	self:addChild(self.m_csNode)
	self.m_csNode:setToCenter()

	self.m_csNode.des:setString(self.m_build:getDesc())
	self.m_csNode.title1:setString(string.format(Serialize["world_BuildLv_1"],self.m_build:getName(), self.m_build:getLevel()))

	local isToMaxLv = self.m_build:getLevel() >= self.m_build:getMaxLv()
	local isMainBuild = self.m_build:getType() == BuildType.kMainBuild

	if build:getPos() ~= BuildPos.kMainBuild then
		self.m_csNode.building:setImage(BuildImage[build:getType()])
	end
	self.m_csNode.bulidinglevelup:setVisible(not isMainBuild)
	self.m_csNode.citylevelup:setVisible(not isToMaxLv and isMainBuild)
	self.m_csNode.Cost:setVisible(not isToMaxLv)
	self.m_csNode.Max:setVisible(isToMaxLv)

	self.m_csNode.bulidinglevelup.dismantleCost:setString(self.m_build:getRemoveCost())
	if self.m_build:getLevel() < self.m_build:getMaxLv() then
		self.m_csNode.Cost.moneycost:setString(math.floor(self.m_build:getLvUpCost()))
		self.m_csNode.Cost.timecost:setString(GameUtil:formatTime(Serialize["H_M_S"],self.m_build:getLvUpTime()))	
	end
end

function This:setLvUpHandler(handler)
	self.m_lvUpHandler = handler
end

function This:setRemoveHandler(handler)
	self.m_removeHandler = handler
end

function This:initTouchEvent()
	self.m_csNode.bulidinglevelup.levelupbutton:setTouchEnded(function()
		if self.m_lvUpHandler then
			self.m_lvUpHandler(false)
		end
		self:close()
	end)
	self.m_csNode.bulidinglevelup.batchlevelupbutton:setTouchEnded(function()
		if self.m_lvUpHandler then
			self.m_lvUpHandler(true)
		end
		self:close()
	end)
	self.m_csNode.bulidinglevelup.dismantlebutton:setTouchEnded(function()
		if self.m_removeHandler then
			self.m_removeHandler()
		end
		self:close()
	end)
	self.m_csNode.citylevelup.levelupbutton:setTouchEnded(function()
		if self.m_lvUpHandler then
			self.m_lvUpHandler(false)
		end
		self:close()
	end)
	self.m_csNode.close:setTouchEnded(function()
		self:close()
	end)
end

--endregion
