--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"cc.Node")
local WorldMapManager = require("World.WorldMapManager")
local GameUtil = require("Util.GameUtil")
local Timer = require("Timer")

BuildImage = 
{
	[BuildType.kDwelling] = "GameScene/house.png",
	[BuildType.kFarmland] = "GameScene/farm.png",
	[BuildType.kMarket] = "GameScene/market.png",
}

function This:init(build)
	self.m_build = build
	self.m_csNode = cc.Node:createFromCSFile("GameScene/NodeUI/BulidItem.csb")
	self:addChild(self.m_csNode)
	self.m_csNode.des1:setString(self.m_build:getName())
	local type = self.m_build:getType()
	if BuildImage[type] and BuildImage[type] ~= "" then
		self.m_csNode.building:setImage(BuildImage[type])
	end
	self.m_timer = Timer:create(self)
	self:scheduleUpdate()
end

function This:onEnter()
	super.onEnter(self)
	self.m_build:setView(self)
	WorldMapManager:addObserver(self)
	self:refresh()
end

function This:onExit()
	super.onExit(self)
	self.m_build:setView(nil)
	WorldMapManager:removeObserver(self)
end

function This:refresh(delay)
	local function update() 
		if self.m_build:getState() == BuildState.kUpgrading then
			cc.Audio:playLoopEffect("Build_Make.mp3")
			local time = self.m_build:getLeftTime()
			self.m_csNode.leveluptime:setString(GameUtil:formatTime(Serialize["H_M_S"],time))
			self.m_csNode.leveluptime:setVisible(true)
			if not self.m_effect then
				self.m_effect = GameUtil:createEffect("BuildImpact",true,self)
				local _, h = self.m_csNode.building:getContentSize() 
				local posx, posy = self.m_csNode.building:getPosition()
				self.m_effect:setPosition(posx, posy)
				self:addChild(self.m_effect)			
			end
		else
			self.m_csNode.leveluptime:setVisible(false)
			if self.m_effect then
				cc.Audio:stopLoopEffect("Build_Make.mp3")
				cc.Audio:playEffect("Build_MakeOver.mp3")				
				self.m_effect:removeFromParent()
				self.m_effect = nil
			end
		end
		self.m_csNode.level:setString(Serialize[64048]..self.m_build:getLevel())
	end
	if delay then
		self.m_timer:setTimer(delay,function()
			update()
		end,"build_update"..self.m_build:getPos())
	else
		update()
	end
end

function This:refreshLeftTime(leftTime)
	self.m_csNode.leveluptime:setString(GameUtil:formatTime(Serialize["H_M_S"],leftTime))
end

function This:update(dt)
	self.m_timer:update(dt)
end


--endregion
