--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"World.City")
local GamePlayer = require("Player.GamePlayer")
local TreasureRebelsConfig = require("Metadatas.TreasureRebelsConfig")
local HeroNpcConfig = require("Metadatas.HeroNpcConfig")
local BehaviorConfig = require("Metadatas.BehaviorConfig")

function This:init(info)
	super.init(self,info)
	self.m_startTime = 0
	self.m_endTime = 0
	self.m_isUpdating = false
	self.m_escape = 0
	self.m_rebelsId = info.treasure_npc_id
	if self.m_rebelsId > 0 then
		self.m_rebelsConfig = TreasureRebelsConfig[self.m_rebelsId]
	end
end

function This:isHide()
	local curTime = GamePlayer:getServerTime()
	return curTime >= self.m_endTime
end

function This:getLeftTime()
	local curTime = GamePlayer:getServerTime()
	return math.max(0,self.m_endTime - curTime)
end

function This:getRebelsId()
	return self.m_rebelsId
end

function This:getRebelsName()
	if self.m_rebelsConfig then
		return self.m_rebelsConfig.name
	end
end

function This:getRebelLevel()
	if self.m_rebelsConfig then
		return self.m_rebelsConfig.difficulty
	else
		return 0
	end
end

function This:isVisibleInGuide()
	return true
end

function This:getRebelRewardList()
	local rewardList = {}
	if self.m_rebelsConfig then
		for i , info in ipairs(self.m_rebelsConfig.reward_list) do
			table.insert(rewardList,{id = info[1],num = info[2]})
		end
	end
	return rewardList
end

function This:getHeroCardList()
	local result ={}
	if self.m_rebelsConfig then
		for i , info in ipairs(self.m_rebelsConfig.npc_deploy) do
			local npcId = info[1]
			local modelId = info[2]
			local config1 = HeroNpcConfig[npcId]
			local config2 = BehaviorConfig[modelId]
			local attr = table.clone(config1 or{})
			attr.id = nil
			attr.level = nil
			table.insert(result,{heroId = config2.hero_id, soilderId = config2.arms_id,soilderLv = config2.arms_pahase, quality = config2.hero_quality, level = config1.level,npcAttr =attr})
		end
	end
	return result
end

function This:updateStgState(stateList,isUpdateDRGH)
	super.updateStgState(self,stateList,isUpdateDRGH)
	local bFind = false
	for i , info in ipairs(stateList) do
		if info.state == JiCeState.kHide then
			self:setTime(0,0)
		elseif info.state == JiCeState.kAppear then
			self:setTime(info.start_time,info.end_time)
			bFind = true
		end 
	end
	if not bFind then
		self:setTime(0,0)
	end
end

function This:setTime(startTime,endTime)
	self.m_endTime = endTime
	self.m_startTime = startTime
end

function This:updateInfo(info)
	super.updateInfo(self,info)
	self.m_rebelsId = info.treasure_npc_id
	if self.m_rebelsId > 0 then
		self.m_rebelsConfig = TreasureRebelsConfig[self.m_rebelsId]
	else
		self.m_rebelsConfig = nil
	end
end

--endregion
