--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"World.CityView")
local WorldMapManager = require("World.WorldMapManager")
local Vec = require("Vec")
local GameUtil = require("Util.GameUtil")

local RebelLevelInfo = 
{
	[1] = {
		{scale = 0.25, dx = -10, dy = -10},
		{scale = 0.25, dx = 10, dy = -10},
	},
	[2] = {
		{scale = 0.25, dx = -10, dy = -10},
		{scale = 0.25, dx = 10, dy = -10},
		{scale = 0.25, dx = -10, dy = 20},
		{scale = 0.25, dx = 10, dy = 20},
	},
	[3] = {
		{scale = 0.25, dx = -20, dy = -10},
		{scale = 0.25, dx = 0, dy = -10},
		{scale = 0.25, dx = 20, dy = -10},
		{scale = 0.25, dx = -20, dy = 20},
		{scale = 0.25, dx = 0, dy = 20},
		{scale = 0.25, dx = 20, dy = 20},
	}
}

function This:init(id)
	self.m_csNode = cc.Node:createFromCSFile("WarScene/NodeUI/HideCity.csb")
	self:addChild(self.m_csNode)
	self.m_city = WorldMapManager:getCity(id)
	self.m_csNode.hidecityname:setString(self.m_city:getName())

	self.m_skeletes = {}
	self:refreshRebelsNodes()
end

function This:initTouchEvent()
	self.m_csNode.click:setTouch({
		onEnded = function()
			if g_scene:getShowMode() == ShowMode.kNormal then
				if self.m_city:isFighting() then
					cc.SceneManager:switchTo("World.WorldLoadingScene",nil,self.m_city:getCityId())
				else
					g_scene:openDialog("World.RebelsPanel",self.m_city)
				end
			elseif self.m_touchHandler then
				self.m_touchHandler(self)
			end
		end,
		isDynamic = true,
		isSwallow = false,
		isAlpha = false
	})
end

function This:onEnter()
	cc.Node.onEnter(self)
	self:initTouchEvent()
	self:refresh()
end

function This:onExit()
	cc.Node.onExit(self)
end

function This:showSelectAnimation(isShow)
	if isShow and not self.m_selectAnimation then
		local str = ""
		if self.m_city:isOur() then
			str = "WarScene/jiantou1.png"
		else
			str = "WarScene/jiantou2.png"
		end
		local sprite = cc.Sprite:create(str)
		local initPos = Vec(0,50)
		local upPos = Vec(initPos.x,initPos.y + 10)
		sprite:setPosition(initPos.x,initPos.y)
		sprite:runAction(cc.RepeatForever(cc.Sequence(cc.MoveTo(0.5,upPos.x,upPos.y,"SineOut"),cc.MoveTo(0.5,initPos.x,initPos.y,"SineOut"))))
		self:addChild(sprite)
		self.m_selectAnimation = sprite
	else
		self.m_selectAnimation:removeFromParent()
		self.m_selectAnimation = nil
	end
end

function This:setSelectHandler(handler)
	self.m_touchHandler = handler
end

function This:setSelect(isSelect)
	
end

function This:refreshRebelsNodes()
	local level = self.m_city:getRebelLevel()
	local config = RebelLevelInfo[level]or {}
	for i , info in ipairs(config) do
		if not self.m_skeletes[i] then
			local node = cc.SkeletonNode:createCharacter("PanJun")
			node:scheduleUpdate()
			node:playAnimation("dj",true)
			self:addChild(node)
			node:setScale(info.scale)
			node:setPosition(info.dx,info.dy)
			self.m_skeletes[i] = node
		else
			self.m_skeletes[i]:setPosition(info.dx,info.dy)
			self.m_skeletes[i]:setScale(info.scale)
		end
	end
	for i = #config + 1, #self.m_skeletes do
		self.m_skeletes[i]:removeFromParent()
		self.m_skeletes[i] = nil
	end
end

function This:refresh()
	if not self.m_city:isHide() then
		self:setVisible(true)
		self:refreshRebelsNodes()
		self:refreshFightingState()
	else
		self:setVisible(false)
	end
end

function This:refreshFightingState()
	local state = self.m_city:getState()
	if state == CityState.kInFighting and not self.m_fightEffect then
		self.m_fireEffect =  GameUtil:createEffect("Sha",true,nil,nil,false)
		self:addChild(self.m_fireEffect)
		self.m_fightEffect =  GameUtil:createEffect("Engagement",true,nil,nil,false)
		self:addChild(self.m_fightEffect)
		print(string.format("刷新城市%d战斗状态,添加特效",self.m_city:getCityId()))
	elseif state ~= CityState.kInFighting and self.m_fightEffect then
		self.m_fireEffect:removeFromParent()
		self.m_fireEffect = nil
		self.m_fightEffect:removeFromParent()
		self.m_fightEffect = nil
		print(string.format("刷新城市%d战斗状态,删除特效",self.m_city:getCityId()))
	end
end

--endregion
