--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"Dialog")
local WorldMapManager = require("World.WorldMapManager")
local TroopView = require("World.TroopView")
local GamePlayer = require("Player.GamePlayer")

function This:initNode(city)
	self.m_city = city
	self.m_csNode = cc.Node:createFromCSFile("GameScene/NodeUI/Intelligence.csb")
	self:addChild(self.m_csNode)
	self.m_csNode:setToCenter()
	local owner = WorldMapManager:getRole(self.m_city:getOwnerId())

	if owner then
		self.m_leagueList = owner:getLeagueList(function(id)
			return self.m_city:isInCity(id)
		end)
		table.insert(self.m_leagueList, 1, owner:getId())
	else
		self.m_leagueList = {}
		table.insert(self.m_leagueList,0)
	end

	for i = 1, 3 do
		local node = self.m_csNode["tab"..i]
    	local id = self.m_leagueList[i]

	    self:addTabButton(tostring(i), node, function()
	    	if not id then
	    		return false
	    	end

	        self:onTabClicked(id)
	        return true
	    end)

		if id then
			if id > 0 then
				local role = WorldMapManager:getRole(id)
				node.normal.name:setString( role:getName() )
				node.light:setString( role:getName() )
			else
				node.normal.name:setString(string.format(Serialize["world_CityIntelligence_1_c"],self.m_city:getName()))
				node.light:setString(string.format(Serialize["world_CityIntelligence_1_c"],self.m_city:getName()))
			end
		else
			node:setVisible(false)
		end
	end
	
	if owner then
		self:lightTabButton(tostring(1))
		self:onTabClicked(owner:getId())
	else
		self:lightTabButton(tostring(1))
		self:onTabClicked(0)
	end

	self.m_csNode.des2:setVisible(self.m_city:isInvestigated())
	if self.m_city:isInvestigated() then
		local time = GamePlayer:getServerTime() - self.m_city:getInvestTime()
		print(string.format("-----------------%d-%d",GamePlayer:getServerTime(),self.m_city:getInvestTime()))
		self.m_csNode.des2:setString(string.format(Serialize["world_CityIntelligence_2"],math.floor(time / 60)))
	end
	self.m_csNode.citylevel:setString(string.format(Serialize["world_CityIntelligence_3_c"],self.m_city:getLevel()))
	if self.m_city:isOur() then
		self.m_csNode.hp:setString(self.m_city:getTotalHp())
		self.m_csNode.troops:setString(self.m_city:getReserveHp())
	else
		local investInfo = self.m_city:getInvestigateInfo()
		self.m_csNode.hp:setString(investInfo.totalHp + investInfo.reserveHp)
		self.m_csNode.troops:setString(investInfo.reserveHp)	
	end
end

function This:initTouchEvent()
	self.m_csNode.close:setTouchEnded(function()
		self:close()
	end)
end

function This:onTabClicked(roleId)
	if self.m_curRoleId == roleId then
		return 
	end
	self.m_csNode.ScrollView:removeAllItems()

	local troopList = nil
	if self.m_city:isOur() then
		troopList = self.m_city:getRoleTroop(roleId)
	else
		troopList = self.m_city:getInvestRoleTroop(roleId)
	end
	
	for i , troop in ipairs(troopList) do
		local view = TroopView:create({troop=troop,city = self.m_city})
		view:setAnchorPoint(0.5,0.5)
		view:setScale(0.95)
		local w , h = view:getContentSize()
		self.m_csNode.ScrollView:pushNode(view,w + 18,h+ 25,3)
	end
	self.m_curRoleId = roleId
end
--endregion
