--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"cc.Node")
local WorldMapManager = require("World.WorldMapManager")
local GameUtil = require("Util.GameUtil")
local HeroManager = require("Hero.HeroManager")
local WorldUtil = require("World.WorldUtil")
local Vec = require("Vec")
local HeroManager = require("Hero.HeroManager")
local GamePlayer = require("Player.GamePlayer")
local CityConfig = require("Metadatas.CityConfig")
local CityAppearanceConfig = require("Metadatas.CityAppearanceConfig")
local GuideManager = require("Guide.GuideManager")
local EventDispatcher = require("EventDispatcher")

local CityImage=
{
	[1] = 
	{
		[0] = "GameScene/city1.png",
		[1] = "GameScene/city1.png",
		[2] = "GameScene/city2.png",
		[3] = "GameScene/city3.png",
		[4] = "GameScene/city4.png",
		[5] = "GameScene/city5.png",
	},
	[2] = 
	{
		[0] = "GameScene/town1.png",
		[1] = "GameScene/town1.png",
		[2] = "GameScene/town2.png",
		[3] = "GameScene/town3.png",
	},
	[3] = 
	{
		[0] = "GameScene/town1.png",
		[1] = "GameScene/town1.png",
		[2] = "GameScene/town2.png",
		[3] = "GameScene/town3.png",
	}
}

local kWorldBoxImage = "Common/Box.png"

local EffectZorder = 
{
	kProtected = 3,--保护罩
	kIndexFlag = 7,--旗子
	kTroopInfo = 6,--部队信息
	kHpInfo = 5,--兵力槽
	kMainFlag = 9,--玉玺
	kHorse = 2,--城池建筑
	kCityLv = 4,--城池等级
	kMenuUI = 1, --菜单
	kName = 8, --城池名字
	kBox = 10, --战局宝箱
	kImprison = 11, --禁锢特效
}

function This:init(id)
	self.m_scene = g_scene
	self.m_csNode = cc.Node:createFromCSFile("WarScene/NodeUI/City.csb")
	self:addChild(self.m_csNode)
	self.m_csNode.armydetails:setVisible(false)
	self.m_csNode.hpdetails:setVisible(false)
	self.m_csNode.camp:setVisible(false)
	self.m_csNode.citylevel:setVisible(false)
	self.m_csNode.choose:setVisible(false)
	self.m_city = WorldMapManager:getCity(id)
	self.m_csNode.cityname:setString(self.m_city:getName())

	if self.m_city:isMy() then
		self.m_csNode.cityname:setColor(184,228,97)
	end
	self.m_firstSelected = true
	self.m_data = {}
end

function This:initTouchEvent()
	self.m_csNode.city:setTouch({
		onEnded = function()
			if self.m_selectHandler then
				self.m_selectHandler(self)
			end
		end,
		isSwallow = false,
		isDynamic = true,
		name = "city"..self.m_city:getCityId(),
		isScale = false,
        isAlpha = false
	})
end

function This:setSelectHandler(handler)
	self.m_selectHandler = handler
end

function This:onEnter()
	super.onEnter(self)
	self:refresh()
	self:initTouchEvent()
	self.m_csNode.armydetails:setLocalZOrder(EffectZorder.kTroopInfo)
	self.m_csNode.hpdetails:setLocalZOrder(EffectZorder.kHpInfo)
	self.m_csNode.camp:setLocalZOrder(EffectZorder.kIndexFlag)
	self.m_csNode.citylevel:setLocalZOrder(EffectZorder.kCityLv)
	self.m_csNode.cityname:setLocalZOrder(EffectZorder.kName)
end

function This:onExit()
	super.onExit(self)
	if self.m_minStg then
		self.m_minStg:removeObserver(self)
	end
end

function This:getModel()
	return self.m_city
end

function This:refreshCityInfo()
	local level = self.m_city:getLevel()
	if self.m_data.level ~= level then
		local type = self.m_city:getType()
		if type~=CityType.kThief then
			local role = WorldMapManager:getRole(self.m_city:getOwnerId())
			local skinId = 1
			if role then
				skinId = role:getCitySkinId()
			end	
			self:refreshCitySkin(skinId)
		else
			local file = CityImage[type][level]
			self.m_csNode.citySkin:setImage(CityImage[type][level])
		end
		self.m_csNode.citylevel.name:setString(string.format(Serialize["world_CityView_1"],self.m_city:getCityId()))
		self.m_data.level = level
	end	
end

function This:refreshColor()
	if self.m_data.isMy ~= self.m_city:isMy() then
		if self.m_city:isMy() then
			self.m_csNode.cityname:setColor(255,255,0)
		else
			self.m_csNode.cityname:setColor(255,255,255)
		end		
		if self.m_city:isMy() then
			self.m_csNode.camp.name:setColor(0,255,0)
		else
			self.m_csNode.camp.name:setColor(69,191,255)--设置敌人名字颜色
		end
		self.m_data.isMy = self.m_city:isMy()
	end
end

function This:refreshForce()
	if self.m_city:getCityId() == 11 then
		assert(true)
	end
	local state = self.m_city:getState()
	local investTime = self.m_city:getInvestTime()
	local troopCount = 0
	local forceNum = 0
	local totalHp = 0

	if self.m_city:isOur() then
		troopCount = self.m_city:getTroopCount()
		forceNum = self.m_city:getRoleCount()
		totalHp = self.m_city:getAllTroopsTotalHp()
	elseif self.m_city:isInvestigated() then
		local investInfo = self.m_city:getInvestigateInfo()
		troopCount = investInfo.troopCount
		forceNum = investInfo.forceNum
		totalHp = investInfo.totalHp
	end

	local isVisible = (self.m_city:isInvestigated() or self.m_city:isOur())  and  troopCount > 0 and state ~= CityState.kInFighting
	if self.m_data.totalHp ~= totalHp or self.m_data.forceVisible ~= isVisible or self.m_data.troopCount ~= troopCount or self.m_data.investTime ~= investTime then
		self.m_csNode.armydetails:setVisible(isVisible)
		if isVisible then
			if forceNum > 1 then
				self.m_csNode.armydetails.peoplenumber:setString(forceNum) 
				self.m_csNode.armydetails.peoplenumber:setVisible(true)
				self.m_csNode.armydetails.shili:setVisible(true)
			else
				self.m_csNode.armydetails.peoplenumber:setVisible(false)
				self.m_csNode.armydetails.shili:setVisible(false)
			end
			self.m_csNode.armydetails.heronumber:setString(troopCount)
			self.m_csNode.armydetails.hpnumber:setString(GameUtil:formatCount(totalHp))
		end
		self.m_data.forceVisible = isVisible
		self.m_data.troopCount = troopCount
		self.m_data.investTime = investTime
		self.m_data.totalHp = totalHp
	end
end

function This:refreshHp()
	local state = self.m_city:getState()
	local isVisible = (self.m_city:isInvestigated() or self.m_city:isOur()) and state ~= CityState.kInFighting
	if self.m_data.hpVisible ~= isVisible then
		self.m_csNode.hpdetails:setVisible(isVisible)	
		self.m_data.hpVisible = isVisible
	end
	if isVisible then
		local totalHp = 0
		if self.m_city:isOur() then
			totalHp = self.m_city:getReserveHp()
		elseif self.m_city:isInvestigated() then
			totalHp = self.m_city:getInvestigateInfo().reserveHp
		end
		self.m_csNode.hpdetails.hp:setString(totalHp)
		self.m_csNode.hpdetails.hpbar:setPercent(totalHp / self.m_city:getMaxReserveHp() * 100)
	end
end

function This:refreshOwnerInfo()
	local isWildCity = self.m_city:isWildCity()
	if self.m_data.isWildCity ~= isWildCity or self.m_data.ownerId ~= self.m_city:getOwnerId() then
		self.m_csNode.camp:setVisible(not isWildCity)
		if not isWildCity then
			local role = WorldMapManager:getRole(self.m_city:getOwnerId())
			if role then
				local name = role:getName()
				self.m_csNode.camp.name:setString(name)
				self:refreshCitySkin(role:getCitySkinId())
			end		
			self.m_csNode.camp.name:setVisible(role ~= nil)
		end
		self.m_data.isWildCity = isWildCity
		self.m_data.ownerId = self.m_city:getOwnerId()
	end
end

function This:refreshCitySkin(skinId)
	local type = self.m_city:getType()
	if type == CityType.kThief then
		return
	end
	local function sheckIsEmptyStr(str)
        if not str or (str and str == "") then
            return true
        end
        return false
    end
    local function createAnim( parent,anmStr )
        local GameUtil = require("Util.GameUtil")
        local effect1 = GameUtil:createEffect(anmStr,true)
        parent:addChild(effect1)
        return effect1
    end
    local cityIcon = self.m_csNode.citySkin
    local effectNode = self.m_csNode.effect
	local level = self.m_city:getLevel()
	local temSkinId = skinId or 1
	local skinConfigItem = CityAppearanceConfig[temSkinId]
	local cityPictures = skinConfigItem.town_picture
	local cityEffects = skinConfigItem.towm_effect
	if type == CityType.kCity then
		cityPictures = skinConfigItem.city_picture
		cityEffects = skinConfigItem.city_effect
	end
	local cityPicture = cityPictures[level]
    local cityEffect = cityEffects[level]

    local cityEmpty = sheckIsEmptyStr(cityPicture)
    local effectEmpty = sheckIsEmptyStr(cityEffect)
    cityIcon:setVisible(not cityEmpty)
    effectNode:setVisible(not effectEmpty)
    if not cityEmpty then
        cityIcon:setImage(string.format("GameScene/%s.png",cityPicture))
    end

    effectNode:removeAllChildren()
    if not effectEmpty then
        local effect = createAnim(effectNode,cityEffect)
    end

	-- local imagePath = string.format("GameScene/%s.png",cityPicture)

	-- self.m_csNode.city:setImage(imagePath)
end

function This:refresh()
	self:refreshCityInfo()
	self:refreshColor()
	self:refreshForce()
	self:refreshHp()
	self:refreshOwnerInfo()
	self:refreshFightingState()
	self:refreshProtectedState() 
	self:refreshImprisonedEffect()
	self:refreshMainCityEffect()
	self:refreshFriendTroopFlag()
	self:refreshStgHoldTime()
	self:refreshTreasureBoxEffect()
end

function This:refreshState()
	self:refreshFightingState()
	self:refreshProtectedState() 
end

function This:setSelect(isSelect)
	if isSelect and not self.m_menu then
		if self.m_city:isMy() then
			self:showMyCityMenu()
        elseif self.m_city:isOur() then
            self:showAllyCityMenu()
		else
			self:showOtherCityMenu()
		end
		self.m_csNode.citylevel:setVisible(true)
		self.m_csNode.armydetails:setVisible(false)
		self.m_csNode.hpdetails:setVisible(false)
		self.m_csNode.timebg:setVisible(false)
	elseif not isSelect and self.m_menu then
		self.m_menu:removeFromParent()
		self.m_menu = nil
		self.m_scene:addMenuAtMapLayer(nil)
		self.m_csNode.citylevel:setVisible(false)
		self.m_csNode.armydetails:setVisible(self.m_data.forceVisible)
		self.m_csNode.hpdetails:setVisible(self.m_data.hpVisible)	
		self.m_csNode.timebg:setVisible(not isSelect)
		self:refreshStgHoldTime()
		EventDispatcher:dispatcher("city_nemu_close")
	end
	self.m_csNode.choose:setVisible(isSelect)
end

function This:refreshTroopInfo(node)
	local ownerTroops = self.m_city:getRoleTroop(GamePlayer:getPlayerID())
	if ownerTroops and #ownerTroops > 0 then
		for i , troop in ipairs(ownerTroops) do
			if i > 6 then break end
			local hero = HeroManager:getHero(troop:getHeroId())
			local quality = troop:getQuality()
			node.troopsbg["heroname"..i]:setString(hero:getName())
			node.troopsbg["heroname"..i]:setColor(QualityColor[quality].r,QualityColor[quality].g,QualityColor[quality].b)
			node.troopsbg["herohp"..i]:setString(troop:getHp())
		end
		for i = #ownerTroops + 1 , 6 do
			node.troopsbg["heroname"..i]:setVisible(false)
			node.troopsbg["herohp"..i]:setVisible(false)
		end
		node.troopsbg:setVisible(true)
	else
		node.troopsbg:setVisible(false)
	end
end

function This:showMyCityMenu(isAlly)
    local fileName = isAlly and "WarScene/NodeUI/AllySelect.csb" or "WarScene/NodeUI/MySelect.csb"

	local node = cc.Node:createFromCSFile(fileName)
	local cityNode = self.m_scene:getCityNode(self.m_city:getCityId())
	local x , y = cityNode:getPosition()
	node:setPosition(x,y)
	self.m_scene:addMenuAtMapLayer(node)
	
	self:refreshTroopInfo(node)
	node.ownclick.details:setTouch({
		onEnded = function()
			self:onViewDetailsBtnClicked()
		end,
		isDynamic = true
	})

    if not isAlly then 
	    node.ownclick.gototown:setTouch({
		    onEnded = function()
			    self:onEnterCityBtnClicked()
		    end,
		    isDynamic = true
	    })
    end

	node.ownclick.troops:setTouch({
		onEnded = function()
			self:onTroopBtnClicked()
		end,
		isDynamic = true
	})	

	node.ownclick.jice:setTouch({
		onEnded = function()
			self:onCounselClicked()
		end,
		isDynamic = true
	})

	local friendTroop = self.m_city:getFriendTroop()
	node.ownclick.details:setVisible(#friendTroop > 0)
	node:setName("m_menu")
	self.m_menu = node
	EventDispatcher:dispatcher("city_nemu_open")
end

function This:showAllyCityMenu()
    self:showMyCityMenu(true)
end

function This:showOtherCityMenu()
	local node = cc.Node:createFromCSFile("WarScene/NodeUI/OtherSelect.csb")
	local cityNode = self.m_scene:getCityNode(self.m_city:getCityId())
	local x , y = cityNode:getPosition()
	node:setPosition(x,y)
	self.m_scene:addMenuAtMapLayer(node)

	node.otherclick.intelligence:setVisible(self.m_city:isInvestigated())

	node.otherclick.see:setTouch({
		onEnded = function()
			self:onInvestigateBtnClicked()
		end,
		isDynamic = true
	})

	node.otherclick.intelligence:setTouch({
		onEnded = function()
			self:onIntelligenceBtnClicked()
		end,
		isDynamic = true
	})
	node.otherclick.plan:setTouch({
		onEnded = function()
			self:onCounselClicked()
		end,
		isDynamic = true
	})
	node:setName("m_menu")
	self.m_menu = node
	EventDispatcher:dispatcher("city_nemu_open")
end

function This:showSelectAnimation(isShow)
	if isShow and not self.m_selectAnimation then
		local str = ""
		if self.m_city:isOur() then
			str = "WarScene/jiantou1.png"
		else
			str = "WarScene/jiantou2.png"
		end
		local sprite = cc.Sprite:create(str)
		local initPos = Vec(0,50)
		local upPos = Vec(initPos.x,initPos.y + 10)
		sprite:setPosition(initPos.x,initPos.y)
		sprite:runAction(cc.RepeatForever(cc.Sequence(cc.MoveTo(0.5,upPos.x,upPos.y,"SineOut"),cc.MoveTo(0.5,initPos.x,initPos.y,"SineOut"))))
		self:addChild(sprite)
		self.m_selectAnimation = sprite

		self.m_csNode.armydetails:setVisible(false)
		self.m_csNode.hpdetails:setVisible(false)
	else
		self.m_selectAnimation:removeFromParent()
		self.m_selectAnimation = nil
		self.m_csNode.armydetails:setVisible(self.m_data.forceVisible)
		self.m_csNode.hpdetails:setVisible(self.m_data.hpVisible)
	end
end

function This:refreshFightingState()
	local state = self.m_city:getState()
	if self.m_city:getId() == 115 then
		assert(true)
	end
	if state == CityState.kInFighting and not self.m_fightEffect then
		self.m_fightEffect =  GameUtil:createEffect("Engagement",true,nil,nil,false)
		self:addChild(self.m_fightEffect)
		self.m_fireEffect = GameUtil:createEffect("Flames",true,nil,nil,false)
		self:addChild(self.m_fireEffect)
		print(string.format("刷新城市%d战斗状态,添加特效",self.m_city:getCityId()))
	elseif state ~= CityState.kInFighting and self.m_fightEffect then
		self.m_fightEffect:removeFromParent()
		self.m_fightEffect = nil
		self.m_fireEffect:removeFromParent()
		self.m_fireEffect = nil
		print(string.format("刷新城市%d战斗状态,删除特效",self.m_city:getCityId()))
	end
end

function This:refreshProtectedState()
	local state = self.m_city:getState()
	if state == CityState.kProtected and not self.m_protectEffect then
		if self.m_city:isEmptyCity() then
			self.m_protectEffect = GameUtil:createEffect("Kongchengji",true,nil,nil,false)
		else
			self.m_protectEffect = GameUtil:createEffect("Protection",true,nil,nil,false)
		end
		self.m_csNode:addChild(self.m_protectEffect)
		self.m_protectEffect:setLocalZOrder(EffectZorder.kProtected)
	elseif state ~= CityState.kProtected and self.m_protectEffect then
		self.m_protectEffect:removeFromParent()
		self.m_protectEffect = nil
	end
end

function This:refreshMainCityEffect()
	local isShow = false
	local isAdvance = false
	if self.m_city:isMyMainCity() or self.m_city:isFriendMainCity()  then
		isShow = true
	elseif self.m_city:isAdvanceInvestigated() and self.m_city:isMainCity() then
		isShow = true
		isAdvance = true
	end

	self.m_csNode.camp.flag:setVisible(isShow)

	local cityInfo = self.m_city
	local hanxaindiEffect = false
	if cityInfo:isMainCity() then
		local ownerId = cityInfo:getOwnerId()
		local ownerRole = WorldMapManager:getRole(ownerId)
		hanxaindiEffect = ownerRole:getIsKillHanXianDi()
	end
	-- if not self.m_hanxaindiEffect and hanxaindiEffect then
	-- 	local function createAnim( parent,anmStr )
	--         -- local GameUtil = require("Util.GameUtil")
	--         local skeletonNode = cc.SkeletonNode:createCharacter(anmStr)
	--         skeletonNode:scheduleUpdate()
	--         skeletonNode:playAnimation("animation", true)
	--         -- skeletonNode:setScale(0.75)
	--         -- skeletonNode:setPositionY(0)
	--         -- skeletonNode:setPositionX(250)
	--         -- local effect1 = GameUtil:createEffectCharacter(anmStr,true)
	--         parent:addChild(skeletonNode)
	--         return skeletonNode
	--     end
	-- 	self.m_hanxaindiEffect = createAnim(self.m_csNode,"MoDi2")
	-- 	self.m_hanxaindiEffect:setLocalZOrder(EffectZorder.kMainFlag)
	-- 	-- self.m_hanxaindiEffect2 = createAnim(self.m_csNode,"MoDi2")
	-- 	-- self.m_hanxaindiEffect2:setLocalZOrder(EffectZorder.kMainFlag)
	-- elseif not hanxaindiEffect and self.m_hanxaindiEffect then
	-- 	self.m_hanxaindiEffect:removeFromParent()
	-- 	-- self.m_hanxaindiEffect2:removeFromParent()
	-- 	-- self.m_hanxaindiEffect2 = nil
	-- 	self.m_hanxaindiEffect = nil
	-- end
	--[[if not self.m_mainEffect and isShow then
		self.m_mainEffect = GameUtil:createEffect("MainCity",true,nil,nil,false)
		self.m_mainEffect:setTimeScale(0.4)
		self.m_csNode:addChild(self.m_mainEffect)
		self.m_mainEffect:setLocalZOrder(EffectZorder.kMainFlag)
		if isAdvance then
			local eff = nil
			eff = GameUtil:createEffect("HuoDe2",false,nil,{
				onAnimationComplete = function()
					eff:removeFromParent()
				end
			})
			self.m_csNode:addChild(eff)
		end
	elseif not isShow and self.m_mainEffect then
		self.m_mainEffect:removeFromParent()
		self.m_mainEffect = nil
	end]]
end

function This:refreshFriendTroopFlag()
	local isFriendCity = not self.m_city:isMy() and self.m_city:isOur() and #self.m_city:getRoleTroop(GamePlayer:getPlayerID()) > 0
	if isFriendCity and not self.m_horse then
		self.m_horse = cc.Sprite:create("WarScene/horse.png")
		self.m_horse:setPosition(-10,0)
		self.m_horse:setScale(0.7)
		self.m_csNode:addChild(self.m_horse)
		self.m_horse:setLocalZOrder(EffectZorder.kHorse)
	elseif not isFriendCity and self.m_horse then
		self.m_horse:removeFromParent()
		self.m_horse = nil
	end
end

function This:refreshImprisonedEffect()
	local isImprisoned = self.m_city:isImprisoned() 
	if isImprisoned and not self.m_imprisonEffect then
		self.m_imprisonEffect = GameUtil:createEffect("BaGua2",true,nil,nil,false)
		self.m_csNode:addChild(self.m_imprisonEffect)
		self.m_imprisonEffect:setLocalZOrder(EffectZorder.kImprison)
	elseif not isImprisoned and self.m_imprisonEffect then
		self.m_imprisonEffect:removeFromParent()
		self.m_imprisonEffect = nil
	end
end

function This:refreshStgHoldTime(leftTime)
	local stg = self.m_city:getLeftMinTimeStg()
	if stg and not stg:hasCity(self.m_city:getCityId()) then
		self.m_csNode.timebg:setVisible(false)
		if self.m_minStg then
			self.m_minStg:removeObserver(self)
			self.m_minStg = nil
		end
		return
	end

	if self.m_minStg ~= stg then
		if self.m_minStg then
			self.m_minStg:removeObserver(self)
		end
		self.m_minStg = stg
		if self.m_minStg then
			self.m_minStg:addObserver(self)
		end
	end
	if stg then
		if not leftTime then
			leftTime = stg:getLeftHoldCD(self.m_city:getCityId())
		end
		if leftTime > 0 then
			local str = GameUtil:formatTime(Serialize["H_M_S"],leftTime)
			self.m_csNode.timebg.time:setString(str)
			self.m_csNode.timebg:setVisible(not self.m_menu)
		else
			self.m_csNode.timebg:setVisible(false)
		end
	else
		self.m_csNode.timebg:setVisible(false)
	end
end

function This:showWorldBox(isVisible)
	if isVisible and not self.m_boxNode then
		local initX, initY = 0, 80
		local box = cc.Sprite:create(kWorldBoxImage)
		box:setPosition(initX,initY)
		self:addChild(box)
		box:setLocalZOrder(EffectZorder.kBox)

		local upAction = cc.MoveTo(0.8,initX,initY + 30,"SineInOut")
		local downAction = cc.MoveTo(0.8,initX,initY + 25,"SineInOut")
		local action = cc.RepeatForever(cc.Sequence(upAction,downAction))
		box:runAction(action)
		
		box:setTouch({
			onEnded = function()
				local model = WorldMapManager:getBox()
				if model:isCanReward() then
					WorldMapManager:onRecieveBoxRewardRequest()
				else
					self.m_scene:showTips(Serialize["world_CityView_2"])
				end
			end,
			isDynamic = true
		})

		self.m_boxNode = box
	elseif not isVisible and self.m_boxNode then
		self.m_boxNode:removeFromParent()
		self.m_boxNode = nil
	end
end

function This:refreshTreasureBoxEffect()
	if self.m_city:hasTreasureBox() and not self.m_treasureEffect then
		self.m_treasureEffect = GameUtil:createEffect("BaoTu",true)
		self:addChild(self.m_treasureEffect)
	elseif not self.m_city:hasTreasureBox() and self.m_treasureEffect then
		self.m_treasureEffect:removeFromParent()
		self.m_treasureEffect = nil
	end
end

function This:onViewDetailsBtnClicked()
	print("详情...")
	self.m_scene:openDialog("World.CityIntelligencePanel",self.m_city)
	self:setSelect(false)
end

function This:onEnterCityBtnClicked()
	print("进城...")
	if self.m_city:isMy() then
		WorldMapManager:onGetCityInfoRequest(self.m_city:getCityId())
		self:setSelect(false)
	else
		self.m_scene:handleErrorCode("can_not_enter_city")
	end
end

function This:onInvestigateBtnClicked()
	print("侦查...")
	local panel = self.m_scene:openDialog("UI.ConfirmPanel")
	panel:setOkHandler(function()
		WorldMapManager:onInvestigateCityInfoRequest(self.m_city:getCityId())	
	end)
	panel:setString( Serialize["world_CityView_3"])
	self:setSelect(false)
end

function This:onTroopBtnClicked()
	print("部队...")
	self:setSelect(false)
	if self.m_city:isMy() then
		self.m_scene:openDialog("World.TroopPanel",self.m_city)
	else
		self.m_scene:openDialog("World.TroopGarrisonPanel",self.m_city)
	end
end

function This:onCounselClicked()
	print("计谋...")
	self:setSelect(false)
	self.m_scene:openDialog("World.StgPanel",self.m_city)
end

function This:onIntelligenceBtnClicked()
	print("情报...")
	self.m_scene:openDialog("World.CityIntelligencePanel",self.m_city)
	self:setSelect(false)
end

function This:onStgHoldUpdate(cityId, stgId,leftTime)
	if self.m_city:getId() == cityId then
		self:refreshStgHoldTime(leftTime)
	end
end

--endregion
