-- @Author: zheng
-- @Date:   2019-01-30 14:57:13
-- @Last Modified by:   zheng
-- @Last Modified time: 2019-06-17 10:53:02
-- @File Name: HanXianDiBtn.lua
local GamePlayer = require("Player.GamePlayer")

local This, super = class(..., "Home.MenuButton")
local WorldMapManager = require("World.WorldMapManager")

function This:init(config)
    super.init(self, config)
    self.m_subView = nil
    self.m_uiName = "World.HanXianDiInfoPanel"
    self:refreshRedDot()
    self:showPanel()
    self:refreshRedDot()
end

function This:showPanel()
    if WorldMapManager:getMapType() ~= 0 then
        WorldMapManager:addHanXianDiTipPanel()
    end
end
function This:addCustomListener()
    WorldMapManager:addObserver(self)
    self:refreshRedDot()
end

function This:removeCustomListener()
    WorldMapManager:removeObserver(self)
end

function This:initTouchEvent()
    self:setTouch({
        isScale = false, 
        isDynamic = true, 
        onEnded = function()
            if not self.m_subView and self:getDefaultVisible()  then
                local panel = g_scene:openDialog(self.m_uiName,{achieve = achieve,activityId = self.m_activityId})
                self.m_subView = panel
                panel:addCloseCallback(function ()
                    self.m_subView = nil
                end)
            end
        end
    }) 
end


function This:getDefaultVisible()
    if (WorldMapManager:getMapType() ~= 0 and WorldMapManager:isHanXianDiAppearTime()) or 
        WorldMapManager:getTypeIsHave(SingleManagerSaveState.kWorldMapHanXianDi) then
        return true
    end
    return false
end

function This:getRedDotValue()
    local value = super.getRedDotValue(self)
    if WorldMapManager:getMapType() ~= 0 and WorldMapManager:isHanXianDiAppearTime() then
        return true
    end
    return value
end

function This:onCityAppear(city)
    if city:isHanXianDi() then
        self:showPanel()
    end
end
