-- @Author: zheng
-- @Date:   2019-05-30 10:58:48
-- @Last Modified by:   zheng
-- @Last Modified time: 2019-06-17 10:52:35
-- @File Name: HanXianDiInfoPanel.lua

local GameUtil = require("Util.GameUtil")
local WorldMapManager = require("World.WorldMapManager")

local This , super = class(...,"Dialog")
This.fileName = "MenuScene/NodeUI/EmperorAppear2.csb"
function This:initNode(info)
    self.m_csNode = cc.Node:createFromCSFile(This.fileName)
    self.m_csNode:setToCenter()
    self:addChild(self.m_csNode)
    self:refresh()
    self:createEffectCharacter()
end

function This:getWinPlyaerid()
    return 0
end

function This:createEffectCharacter()
    local function createAnim( parent,anmStr )
        local skeletonNode = cc.SkeletonNode:createCharacter(anmStr)
        skeletonNode:scheduleUpdate()
        skeletonNode:playAnimation("animation", true)
        skeletonNode:setPositionY(-180)
        parent:addChild(skeletonNode)
    end
    local node = self.m_csNode.picture
    node:removeAllChildren()
    createAnim(node,"MoDi")
end

function This:refresh()
    local csNode = self.m_csNode
    local winNode = csNode.win
    local win  = WorldMapManager:getPlayerWinHanXianDi()
    if win then
        local roleNames ={}
        local allRolesList = WorldMapManager:getAllRole()
        for _,roleData in pairs(allRolesList) do
            if roleData:getIsKillHanXianDi() then
                table.insert(roleNames,roleData:getName())
            end
        end
        GameUtil:resetTexts(winNode,roleNames,false,3)
    else
        
    end
    winNode:setVisible(win)
    csNode.noone:setVisible(not win)
    csNode.qianwang:setVisible(not win)
end

function This:initTouchEvent()
    local csNode = self.m_csNode
    csNode.close:setTouchEnded(function()
        self:close()
    end)
    csNode.qianwang:setTouchEnded(function()
        g_scene:focuseCity(kHanXianDi)
        self:close()
    end)
    csNode.wenhao:setTouch({
        isScale = false, 
        isDynamic = true, 
        onEnded = function()
            g_scene:openDialog("UI.HelpTips", {text = Serialize["world_XianDiInfo_1"],node = csNode.wenhao})
        end
    }) 

end
