-- @Author: zheng
-- @Date:   2019-05-30 10:58:48
-- @Last Modified by:   zheng
-- @Last Modified time: 2019-06-17 10:54:58
-- @File Name: HanXianDiTipPanel.lua

-- local EventDispatcher = require("EventDispatcher")

local GameUtil = require("Util.GameUtil")
-- local GameMapManager = require("Map.GameMapManager")
local WorldMapManager = require("World.WorldMapManager")
local MenuBtnHelper = require("Home.MenuBtnHelper")
local GamePlayer = require("Player.GamePlayer")
local This , super = class(...,"Dialog")
This.fileName = "MenuScene/NodeUI/EmperorAppear1.csb"

function This:initNode(info)
    self.m_csNode = cc.Node:createFromCSFile(This.fileName)
    self.m_csNode:setToCenter()
    self:addChild(self.m_csNode)
    self:createEffectCharacter()
end

function This:createEffectCharacter()
    local function createAnim( parent,anmStr )
        local skeletonNode = cc.SkeletonNode:createCharacter(anmStr)
        skeletonNode:scheduleUpdate()
        skeletonNode:playAnimation("animation", true)
        skeletonNode:setPositionY(-120)
        parent:addChild(skeletonNode)
    end
    local node = self.m_csNode.picture
    node:removeAllChildren()
    createAnim(node,"MoDi")
end

function This:refresh()
end
function This:onTouchMask(touchListener,location)
   self.m_csNode:playCSAnimation("end",false,function()
            if not WorldMapManager:getTypeIsHave(SingleManagerSaveState.kWorldMapHanXianDi) then
                WorldMapManager:setTypeIsHave(SingleManagerSaveState.kWorldMapHanXianDi)
                local btn = MenuBtnHelper:getButtonByName("hanxiandi")
                if btn then
                    if g_scene.refreshBtnHelp then
                        g_scene:refreshBtnHelp()
                    end
                    btn:newBtnAnimation({} , 0.5, function()
                    end)
                end 
           end
           self:close()
    end)
end

function This:onEnter()
    super.onEnter(self)
    self:setVisible(false)
    local action = cc.Sequence(cc.DelayTime(1.5),
         cc.CallFunc(function()
            self:setVisible(true)
        end), cc.CallFunc(function()
            self.m_csNode:playCSAnimation("start",false,function()
            end)
        end)
    )
    self:runAction(action)
end