--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This = class(...)
local GamePlayer = require("Player.GamePlayer")
local WorldMapManager = require("World.WorldMapManager")

function This:create(...)
	local p = {}
	setmetatable(p,self)
	p:init(...)
	return p
end

function This:init(info)
	self:updateInfo(info)
end

function This:updateInfo(info)
	self.m_id = info.id
	self.m_name = info.name
	self.m_icon = info.icon
	self.m_title = info.role_title
	self.m_effect = info.role_effect
	self.m_level = info.level
	self.m_speed = info.speed or 0
	self.m_ally = info.ally
	self.m_master = info.master
	self.m_colleague = info.colleague_list
	self.m_mainCity = info.main_city
	self.m_citys = info.city_list
	self.m_index = info.index
	self.m_groupId = info.group_id
	self.m_groupName = info.group_name
	self.m_citySkinId = info.city_skin
	self.m_horseSkinId = info.mount_skin
	self.m_horseSkinId = info.mount_skin
	self.m_serverId = info.server_id
	self.m_isKillHanXianDi = info.is_kill_hanxiandi or false--是否击杀汉献帝
	self.m_sendList = {}
	for i , rt in ipairs(info.send_list) do
		self.m_sendList[rt.target_id] = rt.relation_type
	end
	self.m_recvList = {}
	for i , rt in ipairs(info.request_list) do
		self.m_recvList[rt.target_id] = rt.relation_type
	end
	self.m_rankLv = info.cur_rank_level
end

function This:getId()
	return self.m_id
end

function This:getIndex()
	return self.m_index
end

function This:getName()
	return AppText:getServerText(self.m_name)
end

function This:getIcon()
	return self.m_icon
end

function This:getTitle()
	return self.m_title
end

function This:getEffect()
	return self.m_effect
end

function This:getCitys()
	return self.m_citys
end

function This:getLevel()
	return self.m_level
end

function This:getSpeed()
	return self.m_speed
end

function This:getGroupId()
	return self.m_groupId
end

function This:getGroupName()
	return self.m_groupName
end
function This:getCitySkinId()
	local temSkin =1
	if not self.m_citySkinId or self.m_citySkinId ==0 then
		return temSkin
	end
	return self.m_citySkinId
end

function This:getHorseSkinId()
	local temSkin =1
	if not self.m_horseSkinId or self.m_horseSkinId ==0 then
		return temSkin
	end
	return self.m_horseSkinId
end

function This:getServerId()
	return self.m_serverId
end

function This:getRankLv()
	return self.m_rankLv
end

function This:getAlly()
	return self.m_ally
end

function This:setAlly(id)
	if id ~= 0 then
		assert(self.m_ally == 0 and self.m_master == 0 and #self.m_colleague <= 0)
	end
	self.m_ally = id
end

--是否击杀汉献帝
function This:setIsKillHanXianDi(isKillHanXianDi)
	self.m_isKillHanXianDi = isKillHanXianDi
end

function This:getIsKillHanXianDi()
	return self.m_isKillHanXianDi
end

function This:getMaster()
	return self.m_master
end

function This:setMaster(id)
    if id == self.m_master or self.m_master ~= 0 or self.m_ally ~= 0 or #self.m_colleague > 0 then
		local playerId = GamePlayer:getPlayerID()
		print(string.format("设置主公，id:%s", tostring(playerId)))
		if self.m_master ~= 0 then
    		print(string.format("玩家%s的已有主公%s了", tostring(playerId), tostring(self.m_master)))
    	elseif self.m_ally ~= 0 then
    		print(string.format("玩家%s的已有属臣%s了", tostring(playerId), tostring(self.m_ally)))
    	elseif #self.m_colleague > 0 then
    		for _, v in ipairs(self.m_colleague) do
    			print(string.format("玩家%s的已有联盟%s了", tostring(playerId), tostring(v)))
    		end
    	end
    	return
    end

    if id ~= 0 then
	    assert(self.m_ally == 0 and self.m_master == 0 and #self.m_colleague <= 0)
    end
    self.m_master = id
    if id == 0 then
        self.m_colleague = {}
    end
end

function This:getColleague()
	return self.m_colleague
end

function This:isColleague(id)
    if self.m_master and self.m_master > 0 and self.m_master ~= id then
		local role = WorldMapManager:getRole(id)
        if role then
		    return role:getMaster() == self.m_master
        end
	end
	return false
end

function This:isLiege(id)
    if  self.m_master and self.m_master <= 0 then
	    for i , coId in pairs(self.m_colleague) do
		    if coId == id then
			    return true
		    end
	    end
    end
    return false
end

function This:addColleague(id)
	if not self:isLiege(id) then
		table.insert(self.m_colleague,id)
	end
end

function This:removeColleague(id)
	for i , coId in pairs(self.m_colleague) do
		if coId == id then
			table.remove(self.m_colleague, i)
			return
		end
	end
end

function This:setRelation(target, relation)
	if relation == RelationType.kJun then
		if self.m_master > 0 then
			local master = WorldMapManager:getRole(self.m_master)
			master:removeColleague(self.m_id)
		end
		self.m_master = target
		if self.m_master > 0 then
			local master = WorldMapManager:getRole(self.m_master)
			master:addColleague(self.m_id)
		end
	elseif relation == RelationType.kTongMeng then
		if self.m_ally > 0 then
			local ally = WorldMapManager:getRole(self.m_ally)
			ally:setAlly(0)
		end
		self.m_ally = target
		if self.m_ally > 0 then
			local ally = WorldMapManager:getRole(self.m_ally)
			ally:setAlly(self.m_id)
		end
	elseif relation == RelationType.kChen then
		self:addColleague(target)
		local colleague = WorldMapManager:getRole(target)
		colleague:setMaster(self.m_id)
	elseif relation == nil then
		if self.m_master == target then
			self.m_master = 0
			local master = WorldMapManager:getRole(target)
			master:removeColleague(self.m_id)
		elseif self.m_ally == target then
			self.m_ally = 0
			local ally = WorldMapManager:getRole(target)
			ally:setAlly(0)
		elseif self:isLiege(target) then
            local role = WorldMapManager:getRole(target)
			role:clear()
		end
	end
end

function This:getLeagueList(selector)
	local result = {}
	if self.m_ally > 0 then
		if selector then
			if selector(self.m_ally) then
				table.insert(result,self.m_ally)
			end
		else
			table.insert(result,self.m_ally)
		end
	end
    if self.m_master and self.m_master > 0 then
		if selector then
			if selector(self.m_master) then
				table.insert(result,self.m_master)
			end
		else
			table.insert(result,self.m_ally)
		end
	end
    if #self.m_colleague > 0 then
		for i , col in ipairs(self.m_colleague) do
			if selector then
				if selector(col) then
					table.insert(result,col)
				end
			else
				table.insert(result,col)
			end
		end
	end
	return result
end

function This:getIdentity()
	if self.m_ally > 0 then
		return RelationType.kTongMeng, Serialize["chat_ChatManager_5_c"]
	end
	if self.m_master > 0 then
		return RelationType.kChen , Serialize["world_MapRole_1"]
	end
	if #self.m_colleague > 0 then
		return RelationType.kJun , Serialize["world_MapRole_2"]
	end
	return 0
end

function This:getRelationWithMe()
	local playerId = GamePlayer:getPlayerID()
	if self.m_ally == playerId then
		return RelationType.kTongMeng
	elseif self.m_master == playerId then
		return RelationType.kChen
    elseif self:isLiege(playerId) then
	    return RelationType.kJun
	elseif self:isColleague(playerId) then
		return RelationType.kTongPao
	end
	return 0
end

function This:getRelationWithOther(other)
	local playerId = other:getId()
	if self.m_ally == playerId then
		return RelationType.kTongMeng
	elseif self.m_master == playerId then
		return RelationType.kChen
	elseif self:isLiege(playerId) then
		return RelationType.kJun
	elseif self:isColleague(playerId) then
		return RelationType.kTongPao
	end
	return 0
end

function This:addSendRequest(id, relation)
	if self.m_sendList[id] == nil then
		self.m_sendList[id] = relation
	end
end

function This:removeSendRequest(id)
	if self.m_sendList[id] then
		self.m_sendList[id] = nil
	end
end

function This:getSendRequest()
	if not WorldMapManager:isInProtected() then
		for id , relation in pairs(self.m_sendList) do
			if relation ~= RelationType.kTongMeng then
				self.m_sendList[id] = nil
			end
		end
	end
	return self.m_sendList
end

function This:addRecvRequest(id,relation)
	if self.m_recvList[id] == nil then
		self.m_recvList[id] = relation
	end
end

function This:removeRecvRequest(id)
	if self.m_recvList then
		self.m_recvList[id] = nil
	end
end

function This:getRecvRequest()
	if not WorldMapManager:isInProtected() then
		for id , relation in pairs(self.m_recvList) do
			if relation ~= RelationType.kTongMeng then
				self.m_recvList[id] = nil
			end
		end
	end
	return self.m_recvList
end

function This:getCitys()
	return self.m_citys
end

function This:hasCity(id)
	for i , cityId in pairs(self.m_citys) do
		if cityId == id then
			return true
		end
	end
	return false
end

function This:addCity(id)
	if not self:hasCity(id) then
		table.insert(self.m_citys,id)
	end
end

function This:removeCity(id)
	for i , cityId in pairs(self.m_citys) do
		if cityId == id then
			table.remove(self.m_citys,i)
			return
		end
	end
end

function This:getMainCity()
	return self.m_mainCity
end

function This:setMainCity(id)
	self.m_mainCity = id
end

function This:clear()
	if self.m_ally > 0 then
		local role = WorldMapManager:getRole(self.m_ally)
		if role then
			role:setAlly(0)
		end
		self.m_ally = 0
	elseif self.m_master > 0 then
		local role = WorldMapManager:getRole(self.m_master)
		if role then
			role:removeColleague(self.m_id)
		end
	end
    
    if #self.m_colleague > 0 then
        if self.m_master <= 0 then
		    for i , colId in ipairs(self.m_colleague) do
			    local role = WorldMapManager:getRole(colId)
			    if role then
			    	role:setMaster(0)
			    end
		    end
        else
            for i , colId in ipairs(self.m_colleague) do
			    local role = WorldMapManager:getRole(colId)
			    if role then
			    	role:removeColleague(self.m_id)
			    end
		    end
        end
        self.m_colleague = {}
	end
    self.m_master = 0
end


--endregion
