--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"Dialog")
local WorldMapManager = require("World.WorldMapManager")
local MarchArmyListView = require("World.MarchArmyListView")
local GamePlayer = require("Player.GamePlayer")
local Timer = require("Timer")

function This:initNode()
	self.m_csNode = cc.Node:createFromCSFile("GameScene/NodeUI/MarchingList.csb")
	self:addChild(self.m_csNode)
	self.m_csNode:setToCenter()
	self.m_timer = Timer:create(self)
	self:initItem()
end

function This:initItem()
	self.m_csNode.ScrollView.m_direction = "right"
	local marchList = WorldMapManager:getAllMarchArmy()
	local temArmyInfoList ={}
	local isCanSpeed = true
	local count = 0
	for i , army in pairs(marchList) do
		if army:getOwnerId() == GamePlayer:getPlayerID() then
			table.insert(temArmyInfoList,{army= army,cityInfo = city,
				isCanSpeed =not WorldMapManager:isHanXianDi(army:getToCity())})
			-- table.insert(temArmyInfoList,{army= army,cityInfo = nil})
			-- if isCanSpeed and WorldMapManager:isHanXianDi(army:getToCity()) then
			-- 	isCanSpeed = false
			-- end
		end		
		count = count + 1
	end

	local citys = WorldMapManager:getFightCitys()
	for i , city in pairs(citys) do
		local armyList = city:getMyAttackArmy()
		for i , army in ipairs(armyList) do
			table.insert(temArmyInfoList,{army= army,cityInfo = city,isCanSpeed =true})
			count = count + 1
		end
	end

	for i,armyInfo in ipairs(temArmyInfoList) do
	    local view = MarchArmyListView:create(armyInfo)
		view:setAnchorPoint(0,0.5)
		local w , h = view:getContentSize()
		self.m_csNode.ScrollView:pushBackCustomItem(view,w,h,0)
	end
end

function This:initTouchEvent()
	self.m_csNode.close:setTouchEnded(function()
		self:close()
	end)
end

function This:onEnter()
	super.onEnter(self)
	WorldMapManager:addObserver(self)
end

function This:onExit()
	super.onExit(self)
	WorldMapManager:removeObserver(self)
end

function This:onRemoveMarchArmy(army)
	local itemList = self.m_csNode.ScrollView:getItemList()
	for i , view in ipairs(itemList) do
		local ay = view:getMarchArmy()
		if ay:getId() == army:getId() then
			self.m_csNode.ScrollView:removeItem(i)
			break
		end
	end
end

function This:onCityInfoChanged(city)
	local itemList = self.m_csNode.ScrollView:getItemList()
	local updateList = {}
	local armyList = city:getMyAttackArmy()
	for i , army in pairs(armyList) do
		updateList[army:getId()] = army
	end

	if city:getState() == CityState.kInFighting then
		for i = #itemList , 1 , -1 do
			local view = itemList[i]
			local army = view:getMarchArmy()
			if view:getCity() == city then
				if not updateList[army:getId()] then
					self.m_csNode.ScrollView:removeItem(i)
				else
					updateList[army:getId()] = nil
				end
			end
		end
		for i , army in pairs(updateList) do
			if army then
				local view = MarchArmyListView:create({army= army,cityInfo = city,isCanSpeed =true})
				view:setAnchorPoint(0.5,0.5)
				local w , h = view:getContentSize()
				self.m_csNode.ScrollView:pushBackCustomItem(view,w,h)	
			end
		end
	else
		for i = #itemList , 1 , -1 do
			local view = itemList[i]
			local army = view:getMarchArmy()
			if view:getCity() == city then
				self.m_csNode.ScrollView:removeItem(i)
			end
		end
	end
end

function This:update(dt)
	self.m_timer:update(dt)
end

--endregion
