--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local Vec = require("Vec")
local This , super = class(...,"cc.Node")
local WorldMapManager = require("World.WorldMapManager")
local MarchAppearanceConfig = require("Metadatas.MarchAppearanceConfig")
local MarchPaoTuView = require("World.MarchPaoTuView")
local PlanShopManager = require("PlanShop.PlanShopManager") 
local GamePlayer = require("Player.GamePlayer")

-- local GameUtil = require("Util.GameUtil")
-- local GamePlayer = require("Player.GamePlayer")
-- local PaoMaEffect = 
-- {
-- 	[1] = {name = "zuo", isFlipX = true},
-- 	[2] = {name = "xieshang", isFlipX = true},
-- 	[3] = {name = "shang", isFlipX = false},
-- 	[4] = {name = "xieshang", isFlipX = false},
-- 	[5] = {name = "zuo", isFlipX = false},
-- 	[6] = {name = "xiexia", isFlipX = false},
-- 	[7] = {name = "xia", isFlipX = false},
-- 	[8] = {name = "xiexia", isFlipX = true},
-- }


function This:init(army)
	--基类，相关文件 LegionMarchPathView PlayerMarchArmyPathView
	self.m_army = army
	self.m_spriteList = {}
	self.m_scene = g_scene
	-- self.m_transType = army:getTransportType()

	self.m_file = self:getPathImage()
	self.m_startTime = self.m_army:getStartTime()
	self.m_endTime = self.m_army:getEndTime()
	self.m_escape = 0

	local fromCityView = g_scene:getCityNode(self.m_army:getFromCity())
	local x1,y1 = fromCityView:getPosition()

	local toCityView = g_scene:getCityNode(self.m_army:getToCity())
	local x2,y2 = toCityView:getPosition()
	self.m_sv = cc.Vec(x1,y1)
	self.m_ev = cc.Vec(x2,y2)
	
	local ownerId = self.m_army:getOwnerId()
	local cityRole = WorldMapManager:getRole(ownerId)
	local horse_skinId = 1
	if cityRole then
		horse_skinId = cityRole:getHorseSkinId()
	end

	local info = {startTime = self.m_army:getStartTime(),endTime = self.m_army:getEndTime(),
		toNode = toCityView,fromNode = fromCityView,runAnim = false,configId = horse_skinId}
	-- self.m_startTime = self.m_army:getEndTime()
	-- self.m_endTime = self.m_army:getEndTime()
	self.m_paoma = MarchPaoTuView:create(info)
	self.m_scene:addMarchPaoMaEffect(self.m_paoma,self:getModel())

	self:initMarchPath(self.m_file,x1,y1,x2,y2,nil)
	self:updateSpeed()
	self:scheduleUpdate()
	-- self:paoMaAction(x1,y1,x2,y2)
end

function This:updateSpeed()
	local curTime = GamePlayer:getServerTime()
	local x, y = self.m_paoma:getPosition()
	local v = self.m_ev - cc.Vec(x,y)
	local len = v:length()
	local unit = v:getNormalize()
	local time = self.m_army:getEndTime() - curTime
	self.m_speed = unit * (len / time)
end

function This:getPaoMaPosition()
    if self.m_paoma then
    	return self.m_paoma:getPosition()
    end
    return self:getPosition()
end

function This:getPathImage()
	local transType = self.m_army:getTransportType()
	if transType == TransType.kTransHp then
		return "Common/yunshu.png"
	elseif transType == TransType.kGoToBattle then
		return "Common/gongji.png"
	else
		return "Common/zhiyuan.png"
	end
end

-- function This:paoMaAction(x1,y1,x2,y2)
-- 	--参考运矿
-- 	local v = cc.Vec(x2 - x1,y2 - y1)
-- 	local speed = 50
-- 	local l = v:length()
-- 	if not self.m_paoma then
-- 		return
-- 	end
-- 	self.m_startPos = cc.Vec(x1,y1)
-- 	self.m_endPos = cc.Vec(x2,y2)

-- 	self.m_paoma:setPosition(self.m_startPos.x,self.m_startPos.y)
-- 	self.m_paoma:runAction(cc.RepeatForever(cc.Sequence(
-- 		cc.MoveTo(l/speed,x2,y2),
-- 		cc.CallFunc(function()
-- 			-- self.m_paoma:setVisible(false)
-- 			self.m_paoma:setPosition(self.m_startPos.x,self.m_startPos.y)
-- 		end)--,
-- 		-- cc.DelayTime(1),
-- 		-- cc.CallFunc(function()
-- 		-- 	self.m_kuang2:setVisible(true)
-- 		-- 	self.m_kuang2:setPosition(self.m_endPos.x,self.m_endPos.y)
-- 		-- 	self.m_kuang2:runAction(cc.Sequence(
-- 		-- 		cc.MoveTo(l/speed,x1,y1),
-- 		-- 		cc.CallFunc(function()
-- 		-- 			self.m_kuang2:setVisible(false)
-- 		-- 			self.m_kuang2:setPosition(self.m_endPos.x,self.m_endPos.y)
-- 		-- 		end)
-- 		-- 	))
-- 		-- end),
-- 		-- cc.DelayTime(l/speed + 1),
-- 		-- cc.CallFunc(function()
-- 		-- 	self.m_paoma:setVisible(true)
-- 		-- 	self.m_paoma:setPosition(self.m_startPos.x,self.m_startPos.y)
-- 		-- end)
-- 	)))

-- end

function This:getMarchName()
	local ownerId = self.m_army:getOwnerId()
	local cityRole = WorldMapManager:getRole(ownerId)
	local horse_skinId = 1
	if cityRole then
		horse_skinId = cityRole:getHorseSkinId()
	end
	return MarchAppearanceConfig[horse_skinId].house_animation
end

function This:initMarchPath(file,x1,y1,x2,y2)
	local v = Vec(x2-x1,y2-y1)
	local dist = v:length()
	local degree = v:getDegree()

	local dLen = 15
	local dVec = v:getNormalize() * dLen

	local count = math.ceil(dist / dLen)
	local pt = dVec * count

	local function actionHandler(sp,s,e)
		local time = (e - s):length() * 0.1
		sp:runAction(cc.Sequence(
			cc.MoveTo(time,e.x,e.y),
			cc.CallFunc(function()
				sp:setPosition(0,0)
				return actionHandler(sp,Vec(0,0),e)
			end)
		))
	end

	for i = 1 , count do
		local p = dVec * (i-1)
		local sprite = cc.Sprite:create(file)
		sprite:setRotation(-degree - 90)
		sprite:setPosition(p.x , p.y)
		self:addChild(sprite)
		table.insert(self.m_spriteList,sprite)
		actionHandler(sprite,p,pt)
	end

	-- local radio = self:getPaoMaRadio()
	-- v = cc.Vec(x2 - x1, y2 - y1)
	-- local v1 = v * radio
	-- local degree = v:getDegree()
	-- local config = self:getConfigWithDegree(degree)
	
	-- self.m_paoma = GameUtil:createEffect(self:getMarchName(),true)
	-- self.m_paoma:setFlippedX(config.isFlipX)
	-- self.m_paoma:setPosition(x1 + v1.x, y1 + v1.y)
	-- self.m_paoma:playAnimation(config.name,true)
	-- self.m_scene:addMarchPaoMaEffect(self.m_paoma,self:getModel())
end

-- function This:getPaoMaRadio()
-- 	local curTime = GamePlayer:getServerTime()
-- 	local radio = (curTime - self.m_startTime) / (self.m_endTime - self.m_startTime)
-- 	return radio
-- end

-- function This:getConfigWithDegree(degree)
-- 	if degree < 0 then
-- 		degree = 360 + degree
-- 	end
-- 	for i , config in ipairs(PaoMaEffect) do
-- 		if degree <= i * 45 - 22.5 then
-- 			return config
-- 		end
-- 	end
-- 	return PaoMaEffect[1]
-- end
function This:onEnter()
	super.onEnter(self)
	PlanShopManager:addObserver(self)
	if self.m_map then
		self.m_map:addObserver(self)
	end
end

function This:onExit()
	super.onExit(self)
	PlanShopManager:removeObserver(self)
	if self.m_map then
		self.m_map:removeObserver(self)
	end
end

function This:update(dt)
	self.m_escape = self.m_escape + dt
	if self.m_paoma and self.m_paoma.getPosition then
	-- if self.m_paoma then
		local x , y = self.m_paoma:getPosition()
		if not x then
			return
		end
		x = x + self.m_speed.x * dt
		y = y + self.m_speed.y * dt
		self.m_paoma:setPosition(x,y)
	end
end

function This:stopUpdate()
	self:unscheduleUpdate()
end

function This:getModel()
	return self.m_army
end

function This:refresh()
	local file = self:getPathImage()
	if file ~= self.m_file then
		for i , sprite in ipairs(self.m_spriteList) do
			sprite:setImage(file)
		end
		self.m_file = file
	end
end

function This:onUsePlan(msg)
	if msg.planId == JiCeType.kXingJunJiaSu then
        -- self:refreshUI()
        self:updateSpeed()
    end
end

--endregion
