--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"cc.Node")
local WorldMapManager = require("World.WorldMapManager")
local GameUtil = require("Util.GameUtil")
local GamePlayer = require("Player.GamePlayer")
local MarchArmyListPanel = require("World.MarchArmyListPanel")

MarchFlag =
{
	[TransType.kTransHp] = "GameScene/yidong.png",
	[TransType.kGoToBattle] = "MenuScene/zhengzhan.png",
	[TransType.kGarrison] = "GameScene/yidong.png",
}

function This:init(army,isArmy)
	self.m_model = army
	self.m_isArmy = isArmy
	self.m_csNode = cc.Node:createFromCSFile("GameScene/NodeUI/MarchingItem.csb")
	self:addChild(self.m_csNode)
	local w , h = self.m_csNode.diban:getContentSize()
	self:setContentSize(w,h)
	self:refresh() 
	self:setAnchorPoint(0.5,0)
end

function This:initTouchEvent()
	--[[self.m_csNode.diban:setTouch({
	onEnded = function()
		g_scene:openDialog("World.MarchArmyListPanel")
	end,
	isContainer = true,
	})]]
end

function This:onEnter()
	super.onEnter(self)
	self:initTouchEvent()
	if self.m_isArmy then
		self.m_model:addObserver(self)
	end
end

function This:onExit()
	super.onExit(self)
	if self.m_isArmy then
		self.m_model:removeObserver(self)
	end
end

function This:getModel()
	return self.m_model, self.m_isArmy
end

function This:setModel(army,isArmy)
	self.m_model = army
	if self.m_isArmy and not isArmy then
		self.m_model:removeObserver(self)
	end
	self.m_isArmy = isArmy
	self:refresh()
end

function This:refresh()
	if self.m_isArmy then
		local leftTime = self.m_model:getEndTime() - GamePlayer:getServerTime()
		local cityId = self.m_model:getToCity()
		local city = WorldMapManager:getCity(cityId)
		self.m_csNode.target:setString(city:getName())
		self.m_csNode.costtime:setString(GameUtil:formatTime(Serialize["H_M_S"],leftTime))
		local transType = self.m_model:getTransportType()
		self.m_csNode.state:setImage(MarchFlag[transType])
		self.m_csNode.inwar:setVisible(false)
		self.m_csNode.costtime:setVisible(true)
	else
		self.m_csNode.target:setString(self.m_model:getName())
		self.m_csNode.inwar:setVisible(true)
		self.m_csNode.costtime:setVisible(false)
	end
end

function This:onUpdateTrip(leftTime)
	if leftTime then
		self.m_csNode.costtime:setString(GameUtil:formatTime(Serialize["H_M_S"],leftTime))
	end
end

--endregion
