--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"cc.Node")
local WorldMapManager = require("World.WorldMapManager")
local GameUtil = require("Util.GameUtil")

function This:init(info) 
	self.m_armyList = info.armyList
	self.m_city = WorldMapManager:getCity(info.cityId)
	self.m_isLooked = false
	self.m_csNode = cc.Node:createFromCSFile("GameScene/NodeUI/Dangerous.csb")
	self:addChild(self.m_csNode)
	self.m_csNode.name1:setString(self.m_city:getName())

	self:refreshContentSize()
	self.m_effect = GameUtil:createEffect("Warning",true,nil,nil,false)
	self.m_csNode:addChild(self.m_effect)
	
	
	local w , h = self:getContentSize()
	self.m_csNode:setPositionY(h/2)

	--[[local layer = cc.LayerColor:create(cc.Color(255,255,0,64))
	layer:setContentSize(w,h)
	self:addChild(layer)]]
end

function This:refreshContentSize()
	local w = self.m_csNode.tanhao1:getContentWidth() 
	if self.m_csNode.name1:isVisible() then
		w = w + self.m_csNode.name1:getContentWidth()+ 5
	end
	self:setContentSize(w,36)
end

function This:initTouchEvent()
	self:setTouch({
		onEnded = function()
			if not self.m_isLooked then
				self.m_isLooked = true
				if self.m_touchHandler then
					self.m_touchHandler(self.m_city:getCityId())
				end
				self:refresh()
				if self.m_lookHandler then
					self.m_lookHandler(self.m_city:getCityId())
				end
			else
				if self.m_touchHandler then
					self.m_touchHandler(self.m_city:getCityId())
				end
			end
		end,
		onBegan = function()
			return true
		end,
		isDynamic = true
	})
end

function This:getCityId()
	return self.m_city:getCityId()
end

function This:addArmy(army)
	if not army:isOur() and army:getToCity() == self.m_city:getCityId() then
		for i , ay in ipairs(self.m_armyList) do
			if ay == army then
				return
			end
		end
		table.insert(self.m_armyList,army)
	end
end

function This:reduceArmy(army)
	for i , ay in ipairs(self.m_armyList) do
		if ay:getId() == army:getId() then
			table.remove(self.m_armyList, i)
			self:refresh()()
			break
		end
	end
end

function This:onEnter()
	super.onEnter(self)
	self:initTouchEvent()
	WorldMapManager:addObserver(self)
end

function This:onExit()
	super.onExit(self)
	WorldMapManager:removeObserver(self)
end

function This:setRemoveHandler(handler)
	self.m_removeHandler = handler
end

function This:setLookedHandler(handler)
	self.m_lookHandler = handler
end

function This:setTouchHandler(handler)
	self.m_touchHandler = handler
end

function This:isCanRemove()
	return #self.m_armyList <= 0 or not self.m_city:isMy()
end

function This:refresh()
	if self:isCanRemove() then
		if self.m_removeHandler then
			self.m_removeHandler(self.m_city:getCityId())
		end
	else
		self.m_csNode.name1:setVisible(not self.m_isLooked)
		self.m_effect:setVisible(not self.m_isLooked)
		self:refreshContentSize()
	end
end

function This:onRemoveMarchArmy(army)
	for i , ay in ipairs(self.m_armyList) do
		if ay:getId() == army:getId() then
			table.remove(self.m_armyList,i)
			self:refresh()
			break
		end
	end
end

function This:onCityInfoChanged(city)
	if self.m_city == city then
		self:refresh()
	end
end

--endregion
