--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This = class(...)
local WorldMapManager = require("World.WorldMapManager")
local GamePlayer = require("Player.GamePlayer")

local kTransportFactor =  0.5 * 0.4
local kGoFightFactor = 0.4
local kTransportNightFactor = 1
local kGoFightNightFactor = 1

function This:create(...)
	local p = {}
	setmetatable(p,self)
	p:init(...)
	return p
end

function This:init()
	self.m_path = {}
end

function This:addCity(city,isFront)
	if not isFront then
		local count = #self.m_path
		self.m_path[count+1] = city
	else
		table.insert(self.m_path,1,city)
	end
end

function This:getDistance()
	return #self.m_path
end

function This:getCostTime()
	local time = 0
	for i , city in ipairs(self.m_path) do
		if i ~= 1 then
			if city:isOur() then
				time = time + 1
			else
				time = time + 5
			end
		end
	end
	return time
	--return 1
end
--深度，除了自己算depth个
function This:getAroundCityList(city,depth,handler)
	local function getCityNeighborhood(cityId,res,curentDepth)
		local curentCity = WorldMapManager:getCity(cityId)
		if curentCity:getType()~=CityType.kThief or (curentDepth ==1 and curentCity:isHanXianDi()) then
			local neighborList = curentCity:getNeighborhood()
			for _,id in ipairs(neighborList) do
				if not res[id] then
					res[id] =id
				end
			end
		end
	end
	-- depth =3
	local closeList = {}
	local allCityList ={}
	table.insert(allCityList,city:getId())
	-- getCityNeighborhood(city:getId(),allCityList)
	-- closeList[city:getId()]= city:getId()
	-- local temDepth = depth-1
	local temDepth = depth
	local cityList = table.clone(allCityList)
	-- if depth>1 then
		for i=1,temDepth do
			local temCityList = {}
			for _,cityId in pairs(cityList) do
				if not closeList[cityId] then
					getCityNeighborhood(cityId,temCityList,i)
					closeList[cityId] =true
				end
			end
			cityList =temCityList
			for _,cityId in pairs(temCityList) do
				if not allCityList[cityId] then
					allCityList[cityId] =cityId
				end
			end
		end
	-- end
	local result = {}
	for ct , dp in pairs(allCityList) do
		local curentCity = WorldMapManager:getCity(ct)
		if not handler or handler(curentCity) then
			table.insert(result,curentCity)
		end
	end
	return result
	-- local openList = {}
	-- local closeList = {}
	-- table.insert(openList,city)
	-- closeList[city] = 0

	-- while #openList > 0 do
	-- 	local curCity = openList[1]
	-- 	table.remove(openList,1)
	-- 	if closeList[curCity] and closeList[curCity] >= depth then
	-- 		break
	-- 	end
	-- 	local neighborList = curCity:getNeighborhood()
	-- 	for i , id in ipairs(neighborList) do
	-- 		local neighCity = WorldMapManager:getCity(id)
	-- 		if not closeList[neighCity] then
	-- 			table.insert(openList,neighCity)
	-- 			closeList[neighCity] = closeList[curCity] + 1
	-- 		end
	-- 	end
	-- end

	-- local result = {}
	-- for ct , dp in pairs(closeList) do
	-- 	if not handler or handler(ct) then
	-- 		table.insert(result,ct)
	-- 	end
	-- end
	-- return result
end

function This:getCostFoodForTansport(hp,t)
	local time = t or self:getCostTime()
	local cost = time * hp * kTransportFactor
	local curTime = GamePlayer:getServerTime()
	local info = os.serverdate("*t",curTime)
	if info.hour >= 0 and info.hour < 5 then
		cost = cost * kTransportNightFactor
	end
	return cost
end

function This:getCostFoodForGoFight(hp,t)
	local time = t or self:getCostTime()
	local cost = time * hp * kGoFightFactor
	local curTime = GamePlayer:getServerTime()
	local info = os.serverdate("*t",curTime)
	if info.hour >= 0 and info.hour < 5 then
		cost = cost * kGoFightNightFactor
	end
	return cost
end

function This:getPath(fromId,toId)
	local openList = {}
	local closeList = {}
	local fromCity = WorldMapManager:getCity(fromId)
	local toCity = WorldMapManager:getCity(toId)

	table.insert(openList,fromCity)
	closeList[fromCity] = fromCity

	local function cityLimit(cityData)
		return cityData:isOur()
	end
	local function qiangXiCityLimit(cityData)
		return cityData:getType()~=CityType.kThief
	end
	local checkLimit = cityLimit

	local toCityIsQiangXi = toCity:isUsedOnCity()
	if toCityIsQiangXi then
		checkLimit = qiangXiCityLimit
	end

	while #openList > 0 do
		local city = openList[1]
		table.remove(openList,1)

		if city == toCity then
			break
		end

		local isFind = false
		local neighborList = city:getNeighborhood()
		for i , id in ipairs(neighborList) do
			local neighCity = WorldMapManager:getCity(id)
			if neighCity == toCity then
				closeList[neighCity] = city
				isFind = true
				break
			-- elseif not closeList[neighCity] and neighCity:isOur() then
			elseif not closeList[neighCity] and checkLimit(neighCity) then
				table.insert(openList,neighCity)
				closeList[neighCity] = city
			end
		end

		if isFind then
			break
		end
	end

	local path = This:create()
	local curCity = toCity
	path:addCity(curCity,true)

	while curCity ~= fromCity do
		curCity = closeList[curCity]
		if not curCity then
			assert(false)
		end
		path:addCity(curCity,true)
	end

	return path
end

function This:getAroundCity(fromCity,isGoFight)
	local openList = {}
	local closeList = {}
	local result = {}
	table.insert(openList,fromCity)
	closeList[fromCity] = true

	while #openList > 0 do
		local city = openList[1]
		table.remove(openList,1)

		local neighborList = city:getNeighborhood()
		for i , id in ipairs(neighborList) do
			local neighCity = WorldMapManager:getCity(id)
			if city:isOur() and not closeList[neighCity] then
				local isWalkable = neighCity:isOur() or (city:isOur() and not neighCity:isOur() and  not neighCity:isProtected())
				if isWalkable then
					if isGoFight then
						result[id] = neighCity
						table.insert(openList,neighCity)
						closeList[neighCity] = true
					else
						if neighCity:isOur() then
							if neighCity:isMy() then
								result[id] = neighCity
							end
							table.insert(openList,neighCity)
							closeList[neighCity] = true
						end
					end
				end
			end
		end
	end
	local citys = WorldMapManager:getAllCity()
	for id , ct in pairs(citys) do
		if not result[id] and not ct:isOur() and ct:isUsedOnCity() then
			result[id] = ct
		end
	end
	return result
end




--endregion
