-- @Author: zheng
-- @Date:   2019-06-10 19:53:06
-- @Last Modified by:   zheng
-- @Last Modified time: 2019-06-26 11:31:54
-- @File Name: RebelsHanXianDiPanel.lua

local This , super = class(...,"Dialog")
local HeroManager = require("Hero.HeroManager")
local Hero = require("Hero.Hero")
local ItemNode = require("UI.ItemNode")
local GameUtil = require("Util.GameUtil")
local CityConfig = require("Metadatas.CityConfig")

function This:initNode(city)
	self.m_city = city
	self.m_csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/EmperorAppearLook.csb")
	self:addChild(self.m_csNode)
	self.m_csNode:setToCenter()
	local neighborhood = CityConfig[city:getId()].neighborhood
	local str = Serialize["world_RebelsPanel_1"]
	for i , cityId in ipairs(neighborhood) do
		local config = CityConfig[cityId]
		str = str .. config.name
		if i < #neighborhood then
			str = str .. " ,"
		end 
	end
	str = str .. string.format(Serialize["world_RebelsHanXian_1"])

	self.m_csNode.des:setString(str, (not AppText:isChinese()) and (760/self.m_csNode.des:getScale()) or nil)
	self:initHeroItem()
end

function This:initTouchEvent()
	self.m_csNode.close:setTouchEnded(function()
		self:close()
	end)
end

function This:getCardNode(info)
	local node = cc.Node:createFromCSFile("GameScene/NodeUI/LineUpHeroItem.csb")
	local hero = Hero:create(info)
	hero:setCurSoilder(info.soilderId)
	local attrHelp = hero:getAttribute()
	attrHelp:setAttrDefault()
	for id,value in pairs(info.npcAttr) do
		local attrId = AttrType[id]
		if attrId and value>0 then
			attrHelp:addAttr(attrId,value)
		end
	end
	hero:updateFightPower()
	node.qualitybg:setImage(QualityBgFile[hero:getQuality()])
	node.quality:setImage(QualityFrameFile[hero:getQuality()])
	node.icon:setImage(hero:getIcon())
	for i = 1 , 5 do
		node["star"..i]:setVisible(hero:getStarLv() >= i)
	end
	node.fightPower:setString(math.floor(hero:getFightPower()))
	node.hp:setString(math.floor(hero:getAttr(AttrType.kMaxHp)))
	node.name:setString(hero:getName(), AppText:isChinese() and 10 or nil)
	node.level:setString(hero:getLevel())
	node.country:setString(CountryName[hero:getCountry()])
	node.cancel:setVisible(false)
	local w , h = node.quality:getContentSize()
	node:setContentSize(w,h)
	node:setAnchorPoint(0.5,0.5)
	return node
end

function This:initHeroItem()
	local cardList = self.m_city:getHeroCardList()
	for i , info in ipairs(cardList) do
		local node = self:getCardNode(info)
		local heroParent = self.m_csNode["heroitem"..i]
		heroParent:addChild(node)
	end
end
