-- @Author: zheng
-- @Date:   2019-06-04 16:57:25
-- @Last Modified by:   zheng
-- @Last Modified time: 2019-06-06 18:11:50
-- @File Name: StgHDSY.lua

local This , super = class(...,"World.WorldStratagem")
local WorldMapManager = require("World.WorldMapManager")
local Path = require("World.Path")
local DailyAchieveManager = require("Achieve.DailyAchieveManager")
function This:init()
	super.init(self,{id = JiCeType.kHanDiShouYu})
end

function This:isCanUseWithoutCD(city)
	local result , season = super.isCanUseWithoutCD(self,city)
	if not result then
		return result, season
	end
	if city:isOur() then
		return false, Serialize["world_StgHDSY_1_c"]
	end
	local _,hdsyItem = city:isUsedOnCity()
	if hdsyItem then
		return false, Serialize["world_StgHDSY_5"]
	end
	local path = Path:create()
	local limit = DailyAchieveManager:getArgConfigLv("zb_plan_distance")
	local cityList = path:getAroundCityList(city,limit,function(ct)
		return ct:isOur()
	end)
	local ret = #cityList > 0
	if not ret then
		return false, string.format(Serialize["world_StgHDSY_4_c"],limit)
	end
	return true
end

function This:isCanUse(city)
	local result , season = self:isCanUseWithoutCD(city)
	if not result then
		return result, season
	end
	if self:getLeftUseCD() > 0 then
		return false, Serialize["world_StgCM_7_c"]
	end
	return true
end

function This:addCity(cityId,startTime,endTime)
	super.addCity(self,cityId,startTime,endTime)
	local city = WorldMapManager:getCity(cityId)
	city:setIsAdvanceInvestigated(true)
end

function This:removeCity(cityId)
	super.removeCity(self,cityId)
	local city = WorldMapManager:getCity(cityId)
	city:setIsAdvanceInvestigated(true)
end

--endregion
