--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"Dialog")
local ListLayer = require("UI.ListLayer")
local WorldMapManager = require("World.WorldMapManager")
local StgView = require("World.StgView")
local PlanShopManager = require("PlanShop.PlanShopManager")

function This:initNode(city)
	self.m_city = city
	self.m_csNode = cc.Node:createFromCSFile("WarScene/NodeUI/UesPlan.csb")
	self:addChild(self.m_csNode)
	self.m_csNode:setToCenter()

	self.m_stgItemList = WorldMapManager:getStgItemList()
	self.m_listLayer = ListLayer:create({
		itemWidth = 168,
		itemHeight = 165,
		spaceX = 10,
		itemCount = #self.m_stgItemList,
		frameCount = #self.m_stgItemList,
		column = 3,
	})
	
	self.m_listLayer:setAnchorPoint(0.5,0)
	local w , h = self.m_listLayer:getContentSize()
	self.m_csNode.scrollview:pushBackCustomItem(self.m_listLayer, w,h,0)
	self.m_listLayer:setCascadeOpacityEnabled(true)

	self.m_listLayer:starList(function (index)
		local view = StgView:create(self.m_stgItemList[index],self.m_city)
		view:setCascadeOpacityEnabled(true)
		return view
	end,function()
		local count = collectgarbage("count")
		collectgarbage("collect")
		print("垃圾清理：count = ",count)
	end)
end

function This:initTouchEvent()
	self.m_csNode.close:setTouchEnded(function()
		self:close()
	end)
end

function This:onEnter()
	super.onEnter(self)
	PlanShopManager:addObserver(self)
end

function This:onExit()
	super.onExit(self)
	PlanShopManager:removeObserver(self)
end

function This:onTouchMask()
	self:close()
end

function This:onUsePlan(msg)
	if msg.err_code == 0 then
		self:close()
	end
end

--endregion
