--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"cc.Node")
local GameUtil = require("Util.GameUtil")
local PlanShopManager = require("PlanShop.PlanShopManager")
local DepotManager = require("Depot.DepotManager")
local GamePlayer = require("Player.GamePlayer")

function This:init(stg,city)
	self.m_stg = stg
	self.m_city = city
	self.m_csNode = cc.Node:createFromCSFile("WarScene/NodeUI/PlanItem.csb")
	self:addChild(self.m_csNode)

	local w , h = self.m_csNode.cantuse:getContentSize()
	self:setContentSize(w,h)
end

function This:initBaseInfo()
	local useCd = self.m_stg:getUseCDTime()
	self.m_csNode.normal:setString(string.format(Serialize["world_StgView_1"],useCd / 3600))
	self.m_csNode.name:setString(self.m_stg:getName())
	self.m_csNode.icon:setImage(self.m_stg:getIcon())
end

function This:refresh()
    local useCount = self.m_stg:getUseCount()
	local maxCount = self.m_stg:getMaxUseCount()
	local leftCd = self.m_stg:getLeftUseCD()
	local isCanUse = self.m_stg:isCanUse(self.m_city)
	local isCanUseWithoutCD = self.m_stg:isCanUseWithoutCD(self.m_city)

	self.m_csNode.choose:setVisible(useCount >= maxCount)
	local config = self.m_stg:getConfig()
	self.m_csNode.count:setString(DepotManager:getItemCount(config.item_id))
	self.m_csNode.progress:setVisible(useCount < maxCount and leftCd > 0)
	self.m_csNode.cantuse:setVisible(not isCanUseWithoutCD)
	self.m_csNode.limit:setString(string.format(Serialize[64938],maxCount-useCount), 280)

	if useCount >= maxCount then
		self.m_csNode.normal:setString(string.format(Serialize["world_StgView_2"]))
	elseif leftCd > 0 then
		self.m_csNode.normal:setString(GameUtil:formatTime(Serialize["H_M_S"],leftCd))
		if not self.m_progressTimer then
			self.m_progressTimer =  cc.ProgressTimer:create(self.m_csNode.progress.cooldowncd)
			self.m_csNode.progress:addChild(self.m_progressTimer)
		end
		local useCd = self.m_stg:getUseCDTime()
		self.m_progressTimer:setPercent(leftCd / useCd * 100)
		self.m_progressTimer:startTimer(useCd, useCd - leftCd)
	else
		local useCd = self.m_stg:getUseCDTime()
		self.m_csNode.normal:setString(string.format(Serialize["world_StgView_1"],useCd / 3600))
	end
end

function This:initTouchEvent()
	self:setTouch({
		onEnded = function()
			local isCanUse , season = self.m_stg:isCanUseWithoutCD(self.m_city)
			if isCanUse then
				local leftCd = self.m_stg:getLeftUseCD()
				if leftCd > 0 then
					local panel = g_scene:openDialog("PlanShop.PlanComfirmPanel",{
						cost = PlanFormula.kSkipCdCost(leftCd)
					})
					panel:setHandler(function()
						PlanShopManager:onClearUseCDRequest(self.m_stg:getId())
					end)
				else
					if GamePlayer:isInKingMap() and 8 == self.m_stg:getId() then
						return g_scene:showTips(Serialize[64939])
					end

					local config = self.m_stg:getConfig()
					local panel = g_scene:openDialog("PlanShop.UsePlanPanel",{
						plan = self.m_stg:getId(),
						num = 1,
						gold = config.gold,
						itemId = config.item_id,
						argId = self.m_city:getCityId(), 
					})
					panel:showStudyNode(false)
				end
			else
				g_scene:showTips(season)
			end
		end,
		isScale = false,
		isContainer = true
	})
end

function This:onEnter()
	super.onEnter(self)
	self:initBaseInfo()
	self:refresh()
	self:initTouchEvent()
	self.m_stg:addObserver(self)
end

function This:onExit()
	super.onExit(self)
	self.m_stg:removeObserver(self)
end

function This:onStgUseUpdate(id,leftTime)
	if leftTime > 0 then
		self.m_csNode.normal:setString(GameUtil:formatTime(Serialize["H_M_S"],leftTime))
	else
		self:refresh()
	end
end

function This:onUseCDStart()
	self:refresh()
end

function This:onUseCDEnded()
	self:refresh()
end



--endregion
