--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"Base.BaseModel")
local TreasureCityConfig = require("Metadatas.TreasureCityConfig")
local TreasureBoxConfig = require("Metadatas.TreasureBoxConfig")
local GamePlayer = require("Player.GamePlayer")

function This:init(info)
	super.init(self)
	self.m_id = info.id
	self.m_cityId = info.cityId
	self.m_config = TreasureBoxConfig[self.m_id]
	self.m_isUpdating = false
	self.m_escape = 0
	self.m_pos = info.pos or 0
	self.m_startTime = 0
	self.m_endTime = 0
end

function This:getId()
	return self.m_id
end

function This:getCityId()
	return self.m_cityId
end

function This:getType()
	return self.m_config.treasure_type
end

function This:getKeyId()
	return self.m_config.key_id
end

function This:getRewardList()
	local result = {}
	for i, info in ipairs(self.m_config.item_list) do
		table.insert(result,{id = info[1],num = info[2]})
	end
	return result
end

function This:setTime(startTime,endTime)
	local curTime = GamePlayer:getServerTime()
	if curTime < endTime and not self.m_isUpdating then
		self:startUpdate()
	elseif curTime >= endTime and self.m_isUpdating then
		self:endUpdate()
	end
	self.m_startTime = startTime
	self.m_endTime = endTime
end

function This:setPos(pos)
	self.m_pos = pos
end

function This:getPos()
	return self.m_pos
end

function This:getLeftTime()
	local curTime = GamePlayer:getServerTime()
	return math.max(0,self.m_endTime - curTime)
end

function This:startUpdate()
	cc.Application:addToUpdateList(self)
	self.m_isUpdating = true
end

function This:endUpdate()
	cc.Application:removeFromUpdateList(self)
	self.m_isUpdating = false
end


function This:update(dt)
	self.m_escape = self.m_escape + dt
	if self.m_escape < 1 then
		return
	end
	self.m_escape = self.m_escape - 1
	local leftTime = self:getLeftTime()
	if leftTime > 0 then
		self:notifyObservers("onTreasureBoxUpdate",leftTime)
	else
		self:endUpdate()
		self:notifyObservers("onTreasureBoxUpdate",leftTime)
	end
end

--endregion
