--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"cc.Node")
local GameUtil = require("Util.GameUtil")
local ItemConfig = require("Metadatas.ItemConfig")
local EffectConfig = require("Metadatas.EffectConfig")
local DepotManager = require("Depot.DepotManager")
local WorldMapManager = require("World.WorldMapManager")

function This:init(box)
	self.m_box = box
	self.m_csNode = cc.Node:createFromCSFile("GameScene/NodeUI/TreasuseBox.csb")
	self:addChild(self.m_csNode)
	self:refresh()
end

function This:initTouchEvent()
	self.m_csNode.box:setTouch({
		onEnded = function()
			local keyId = self.m_box:getKeyId()
			local str = string.format(Serialize["world_TreasureBox_1"],ItemConfig[keyId].name)
			g_scene:openDialog("UI.ConfirmPanel",{
				richText = str,
				okHandler = function()
					self:openBox()
				end
			})
		end,
		isDynamic = true
	})
end

function This:onEnter()
	super.onEnter(self)
	self:initTouchEvent()
	self.m_box:addObserver(self)
end

function This:onExit()
	super.onExit(self)
	self.m_box:removeObserver(self)
end

function This:refresh()
	if self.m_box:getType() == TreasureMapType.kHigh then
		self.m_csNode.box:setImage("MenuScene/baotubox2.png")
	else
		self.m_csNode.box:setImage("MenuScene/baotubox1.png")
	end
end

function This:setModel(box)
	if self.m_box ~= box then
		self.m_box:removeObserver(self)
		self.m_box = box 
		self.m_box:addObserver(self)
		self:refresh()
	end
end

function This:setOpenHandler(handler)
	self.m_openHandler = handler
end

function This:openBox()
	local cityId = self.m_box:getCityId()
	local boxId = self.m_box:getId()
	local keyId = self.m_box:getKeyId()
	local effect = nil

	local count = DepotManager:getItemCount(keyId)
	if count <= 0 then
		local str = string.format(Serialize["world_TreasureBox_2"],ItemConfig[keyId].name)
		g_scene:showTips(str)
		return
	end

	local name = "animation"
	if self.m_box:getType() == TreasureMapType.kHigh then
		name = "animation2"
	end

	effect = GameUtil:createEffect("BaoXiang",false,nil,{
		onAnimationEvent = function(_,animationName,eventName)
			WorldMapManager:onOpenTreasureBoxRequest(cityId,boxId,keyId)
		end,
		onAnimationComplete = function()
			effect:removeFromParent()
			if self.m_openHandler then
				self.m_openHandler(false)
			end
		end
	},false,name)
	g_scene:addChild(effect)
	effect:setToCenter()
	if self.m_openHandler then
		self.m_openHandler(true)
	end
	self.m_csNode:setVisible(false)
end

function This:onTreasureBoxUpdate(leftTime)
	local str = GameUtil:formatTime(Serialize["H_M_S"],leftTime)
	self.m_csNode.baotutime:setString(str)
end

--endregion
