--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This = class(...)
local HeroConfig = require("Metadatas.HeroConfig")
local HeroManager = require("Hero.HeroManager")
local GamePlayer = require("Player.GamePlayer")

function This:create(...)
	local t = {}
	setmetatable(t,self)
	t:init(...)
	return t
end

function This:init(info)
	self.m_id = info.id
	self.m_cityId = info.city_id
	self.m_ownerId = info.owner_id
	self.m_level = info.level
	self.m_hp = info.cur_hp
	self.m_heroId = info.card_type
	self.m_pos = info.pos
	self.m_maxHp = info.max_hp
	self.m_star =  math.floor(info.star / 5)
	self.m_phase = info.star % 5
	self.m_quality = info.quality
	self.m_fightPower = info.fight_power
	self.m_awakeLevel = info.awake_level
	self.m_isAwakeFull = info.is_awake
	if GamePlayer:getPlayerID() == self.m_ownerId then
		self.m_hero = HeroManager:getHero(self.m_heroId)
	end
end

function This:getId()
	if self.m_id ~= 0 then
		return self.m_id
	elseif self.m_hero then
		return self.m_hero:getUid()
	end
end

function This:getCityId()
	return self.m_cityId
end

function This:setCityId(cityId)
	self.m_cityId = cityId
end

function This:getOwnerId()
	return self.m_ownerId
end

function This:setOwnerId(ownerId)
	self.m_ownerId = ownerId
end

function This:isMy()
	return GamePlayer:getPlayerID() == self.m_ownerId
end

function This:getHp()
	return self.m_hp
end

function This:setHp(hp)
	self.m_hp = hp
end

function This:getMaxHp()
	if self.m_hero then
		return self.m_hero:getAttr(AttrType.kMaxHp)
	end
	return self.m_maxHp
end

function This:setMaxHp(maxHp)
	self.m_maxHp = maxHp
end

function This:getLevel()
	if self.m_hero then
		return self.m_hero:getLevel()
	end
	return self.m_level
end

function This:setLevel(level)
	self.m_level = level
end

function This:getHeroId()
	return self.m_heroId
end

function This:setHeroId(heroId)
	self.m_heroId = heroId
end

function This:getName()
	return HeroConfig[self.m_heroId].name
end

function This:getPos()
	return self.m_pos
end

function This:setPos(pos)
	self.m_pos = pos
end

function This:getStarLv()
	if self.m_hero then
		return self.m_hero:getStarLv()
	end
	return self.m_star
end

function This:setStarLv(star)
	self.m_star = star
end

function This:getQuality()
	if self.m_hero then
		return self.m_hero:getQuality()
	end
	return self.m_quality <= 0 and 1 or self.m_quality
end

function This:setQuality(quality)
	self.m_quality = quality
end

function This:getFightPower()
	if self.m_hero then
		return self.m_hero:getFightPower()
	end
	return self.m_fightPower
end

function This:setFightPower(fightPower)
	self.m_fightPower = fightPower
end

function This:getAwake()
	return self.m_awakeLevel or 0
end

function This:isAwakeFull()
	return self.m_isAwakeFull or false
end


function This:updateInfo(info)
	assert(self.m_id == info.id)
	assert(info.max_hp)
	self.m_cityId = info.city_id
	self.m_ownerId = info.owner_id
	self.m_level = info.level
	self.m_hp = info.cur_hp
	self.m_heroId = info.card_type	
	self.m_pos = info.pos
	self.m_maxHp = info.max_hp
	self.m_star =  math.floor(info.star / 5)
	self.m_phase = info.star % 5
	self.m_quality = info.quality
	self.m_fightPower = info.fight_power
	self.m_awakeLevel = info.awake_level
	self.m_isAwakeFull = info.is_awake
end

--endregion
