--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"Dialog")
local HeroManager = require("Hero.HeroManager")
local HeroPanel = require("Hero.HeroPanel")
local WorldMapManager = require("World.WorldMapManager")
local PlanShopUtil = require("PlanShop.PlanShopUtil")

function This:initNode(info)
	self.m_troopList = info.troopList
	self.m_troop = info.tp
	self.m_csNode = cc.Node:createFromCSFile("GameScene/NodeUI/TroopsAdjust.csb")
	self:addChild(self.m_csNode)
	self.m_csNode:setToCenter()

	local hero = HeroManager:getHero(self.m_troop:getHeroId())
	local city = WorldMapManager:getCity(self.m_troop:getCityId())

	self.m_curHp = self.m_troop:getHp()
	self.m_initHp = self.m_curHp
	self.m_maxHeroHp = hero:getAttr(AttrType.kMaxHp)
	self.m_reserveHp = city:getReserveHp()
	self.m_maxReserveHp = city:getMaxReserveHp()

	self.m_csNode.troopname:setString(hero:getCurSoilder():getName())

	local quality = hero:getQuality()
	local country = hero:getCountry()
	self.m_csNode.country:setString(CountryName[country])
	local color = SmallCardQualityColor[quality]
	self.m_csNode.country:setColor(color.r , color.g, color.b)


	self.m_csNode.name:setString(hero:getName(), AppText:isChinese() and 10 or nil)
	self.m_csNode.level:setString(hero:getLevel())

	self.m_csNode.qualitybg:setImage(QualityBgFile[quality])
	self.m_csNode.quality:setImage(QualityFrameFile[quality])
	self.m_csNode.icon:setImage(hero:getIcon())
	-- self.m_csNode.herofightbg:setImage(QualityFightPowerFrameFile[quality])
	self.m_csNode.fightPower:setString(math.floor(hero:getFightPower()))

	for i = 1, 5 do
		self.m_csNode["star"..i]:setVisible(hero:getStarLv() >= i)
	end

	local soilder = hero:getCurSoilder()
	local recruitCost = soilder:getRecruitCost()
	self.m_csNode.troopsnum:setString(string.format("%d/%d",self.m_reserveHp,self.m_maxReserveHp))
	self.m_csNode.hp:setString(string.format("%d/%d",self.m_curHp,self.m_maxHeroHp))
	self.m_csNode.moneycost:setString(recruitCost * self.m_curHp)

	local isShowTips = false
	self.m_csNode.slider:setSilderHandler(function(percent)
		local hp = math.floor(percent * self.m_maxHeroHp)
		local cost = (hp - self.m_initHp) * recruitCost
		local curCopper = WorldMapManager:getCopper()
		if curCopper < cost then
			g_scene:handleErrorCode("copperLack", {nocheck = true, callback = function ()
				if not self.m_subView then 
					local panel = PlanShopUtil:usePlan({plan=JiCeType.kCaiYuanGunGun, num = 1})
	                self.m_subView = panel
	                panel:addCloseCallback(function ()
	                    self.m_subView = nil
	                end)
	            end
			end})
			self.m_curHp = WorldMapManager:getCopper() / recruitCost + self.m_initHp
			self:refresh()
			return self.m_curHp / self.m_maxHeroHp
		end

		local addHp = hp - self.m_curHp 
		addHp = math.min(addHp,self.m_reserveHp)
		self.m_curHp = self.m_curHp + addHp
		self.m_reserveHp = self.m_reserveHp - addHp
		self:refresh()
		return self.m_curHp / self.m_maxHeroHp
	end)
	self.m_csNode.slider:setPercent(self.m_curHp / self.m_maxHeroHp)
	isShowTips = true
	self:refreshAwak(self.m_csNode)
end

function This:refreshAwak(node)
	local hero = HeroManager:getHero(self.m_troop:getHeroId())
	local heroEffect = false
	if hero:isAwaken() then
		node.xingdian:setVisible(true)
		local curentLv = hero:getAwakeLevel()
		if curentLv==0 then
			node.xingdian.light:setVisible(false)
		else
			node.xingdian.light:setVisible(true)
			for i=1,AwakdValue.ParagraphLimit do
				local item = node.xingdian.light["dian"..i]
				item:setVisible(curentLv>=i)
			end
		end
		heroEffect = hero:isAwakeFull()
	else
		node.xingdian:setVisible(false)
	end

	self:createWeakEffect( node.quality, heroEffect )
end

function This:createWeakEffect( node,isAdd,heroBg )
	local function createAnim( parent,anmStr )
        local GameUtil = require("Util.GameUtil")
        local effect1 = GameUtil:createEffect(anmStr, true)
        local scale =0.564
        effect1:setScale(scale)
        local x = 58
        local y = 67
        effect1:setPosition(x,y)
        print("xy",x,"  ",y,"scale",scale)
        parent:addChild(effect1)
        return effect1
    end
    local effectName = "JueXing5"
    node:removeAllChildren()
    if isAdd then
    	local effect = createAnim( node,effectName )
    end
end
function This:initTouchEvent()
	self.m_csNode.close:setTouchEnded(function()
		self:close()
	end)
	self.m_csNode.seebutton:setTouchEnded(function()
		if self.m_showHandler then
			self.m_showHandler(self.m_troop:getHeroId())
		end
		--g_scene:openDialog("Hero.HeroPanel",{heroId = self.m_troop:getHeroId()})
	end)
	self.m_csNode.cancelbutton:setTouchEnded(function()
		self:close()
	end)
	self.m_csNode.confirmbutton:setTouchEnded(function()
		local city = WorldMapManager:getCity(self.m_troop:getCityId())
		if city:isFighting() then
			g_scene:showTips(Serialize["world_TroopAdjust_1"])
			return
		end
		if not (self.m_troop:getHp()==0 and self.m_curHp == 0) then
			local heroList = {}
			local hpList = {}
			local isFind = false
			for i , troop in ipairs(self.m_troopList) do
				if troop:getHp() <= 0 then
					break
				end
				if troop:getId() == self.m_troop:getId() then
					table.insert(heroList,self.m_troop:getId())
					table.insert(hpList,self.m_curHp )
					isFind = true
				else
					table.insert(heroList,troop:getId())
					table.insert(hpList,troop:getHp())
				end
			end
			if not isFind then
				table.insert(heroList,self.m_troop:getId())
				table.insert(hpList,self.m_curHp )
			end
			WorldMapManager:onAddHeroHpRequest(self.m_troop:getCityId(),{heros = heroList,hp = hpList})
		end
		self:close()
	end)
	self.m_csNode.Minbutton:setTouchEnded(function()
		self.m_csNode.slider:setPercent(0)
	end)
	self.m_csNode.Maxbutton:setTouchEnded(function()
		self.m_csNode.slider:setPercent(1)
	end)
end

function This:onEnter()
	super.onEnter(self)
	HeroManager:addObserver(self)
end

function This:onExit()
	super.onExit(self)
	HeroManager:removeObserver(self)
end

function This:setShowHeroHandler(handler)
	self.m_showHandler = handler
end

function This:refresh()
	local hero = HeroManager:getHero(self.m_troop:getHeroId())
	local soilder = hero:getCurSoilder()
	self.m_csNode.troopsnum:setString(string.format("%d/%d",self.m_reserveHp,self.m_maxReserveHp))
	self.m_csNode.hp:setString(string.format("%d/%d",self.m_curHp,self.m_maxHeroHp))
	self.m_csNode.moneycost:setString(soilder:getRecruitCost() * self.m_curHp)
	self:refreshAwak(self.m_csNode)
end

function This:refreshHeroAttr()
	local hero = HeroManager:getHero(self.m_troop:getHeroId())
	self.m_maxHeroHp = hero:getAttr(AttrType.kMaxHp)
	if self.m_curHp > self.m_maxHeroHp then
		self.m_curHp = self.m_maxHeroHp
	end
	self.m_csNode.slider:setPercent(self.m_curHp / self.m_maxHeroHp)
	self:refreshAwak(self.m_csNode)
end

function This:onUpgradeLevel(heroId)
	if self.m_troop:getHeroId() == heroId then
		self:refreshHeroAttr()
	end
end

function This:onUpgradeStarLv(heroId)
	if self.m_troop:getHeroId() == heroId then
		self:refreshHeroAttr()
	end
end

function This:onUpgradeQuality(heroId)
	if self.m_troop:getHeroId() == heroId then
		self:refreshHeroAttr()
	end
end

function This:onDeputyChanged(heroId)
	if self.m_troop:getHeroId() == heroId then
		self:refreshHeroAttr()
	end
end

function This:onEquipChanged(heroId)
	if self.m_troop:getHeroId() == heroId then
		self:refreshHeroAttr()
	end
end

function This:onAddAttrPoint(heroId)
	if self.m_troop:getHeroId() == heroId then
		self:refreshHeroAttr()
	end
end

function This:onClearAttrPoint(heroId)
	if self.m_troop:getHeroId() == heroId then
		self:refreshHeroAttr()
	end
end

function This:onTrainSoilder(heroId)
	if self.m_troop:getHeroId() == heroId then
		self:refreshHeroAttr()
	end
end

function This:onUpPhaseSoilder(heroId)
	if self.m_troop:getHeroId() == heroId then
		self:refreshHeroAttr()
	end
end

function This:onAttachSoilder(heroId)
	if self.m_troop:getHeroId() == heroId then
		self:refreshHeroAttr()
	end
end

--endregion
