--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"Dialog")
local TroopView = require("World.TroopView")
local Timer = require("Timer")

function This:initNode(city)
	self.m_city = city

    local armyLists = city:getDefenceQueue()
    self.m_armyList = {}
    for _, army in ipairs(armyLists) do
        if army:isMy() then
            table.insert(self.m_armyList, army) 
        end
    end

	self.m_armyNodes = {}
	self.m_csNode = cc.Node:createFromCSFile("GameScene/NodeUI/GarrisonMain.csb")
	self:addChild(self.m_csNode)
	self.m_csNode:setToCenter()
	self.m_curSelectIndex = nil
	self.m_timer = Timer:create(self)
	self:initItems()
end

function This:initTouchEvent()
	self.m_csNode.battlebutton:setTouchEnded(function()
		if self.m_curSelectIndex then
			local army = self.m_armyList[self.m_curSelectIndex]
			g_scene:enterSelectMode(self.m_city,true,army)
			self:close()
		end
	end)
	self.m_csNode.close:setTouchEnded(function()
		self:close()
	end)
end

function This:getArmyNode(army,index)
	local tmp = {Serialize["world_TroopGarrison_1"],Serialize["world_TroopGarrison_2"],Serialize["world_TroopGarrison_3"],Serialize["world_TroopGarrison_4"],Serialize["world_TroopGarrison_5"],Serialize["world_TroopGarrison_6"]}
	local node = cc.Node:createFromCSFile("GameScene/NodeUI/GarrisonMainHeroItem.csb")
	node.line:setString(tmp[index],20)
	local troopList = army:getTroopList()
	for i , troop in pairs(troopList) do
		local view = TroopView:create({troop = troop,city = self.m_city})
		view:setAnchorPoint(0.505,0.462)
		node["card"..i]:addChild(view)
	end

	local w , h = node.choose:getContentSize()
	node:setContentSize(w,h)
	node:setTouch({
		onEnded = function()
			self:selectArmy(army,index)
		end,
		isContainer = true,
		isScale = false
	})
	node.choose:setVisible(false)
	return node
end

function This:initItems()
	for i , army in ipairs(self.m_armyList) do
		self.m_timer:setTimer(0.1*(i-1),function()
			local node = self:getArmyNode(army,i)
			self.m_armyNodes[i] = node
			node:setAnchorPoint(0.5,0.5)
			local w , h = node:getContentSize()
			self.m_csNode.heroList:pushBackCustomItem(node,w,h)	
			if i == 1 then
				self:selectArmy(army,1)
			end	
		end,"item"..i)
	end
end

function This:selectArmy(army,index)
	if self.m_curSelectIndex then
		self.m_armyNodes[self.m_curSelectIndex].choose:setVisible(false)
	end
	self.m_curSelectIndex = index
	self.m_armyNodes[self.m_curSelectIndex].choose:setVisible(true)
end

function This:update(dt)
	self.m_timer:update(dt)
end

--endregion
