--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"Dialog")
local Path = require("World.Path")
local GameUtil = require("Util.GameUtil")
local WorldMapManager = require("World.WorldMapManager")
local PlanShopUtil = require("PlanShop.PlanShopUtil")

function This:initNode(info)
	self.m_fromCity = info.fromCity
	self.m_toCity = info.toCity
	self.m_hp = 0
	self.m_reserveHp = self.m_fromCity:getReserveHp()

	self.m_csNode = cc.Node:createFromCSFile("GameScene/NodeUI/TroopsTransport.csb")
	self:addChild(self.m_csNode)
	self.m_csNode:setToCenter()

	self.m_csNode.targetcity:setString(self.m_toCity:getName())

	self.m_path = Path:getPath(self.m_fromCity:getCityId(),self.m_toCity:getCityId())
	self.m_time = self.m_path:getCostTime()
	self.m_csNode.timecost:setString(GameUtil:formatTime(Serialize["H_M_S"],self.m_time * 60))
	
	self.m_csNode.slider:setSilderHandler(function(percent)
		self.m_hp = math.floor(percent * self.m_reserveHp)
		self:refresh()
		return percent
	end)

	self.m_csNode.slider:setPercent(0)
end

function This:initTouchEvent()
	self.m_csNode.close:setTouchEnded(function()
		self:close()
	end)
	self.m_csNode.Minbutton:setTouchEnded(function()
		self.m_csNode.slider:setPercent(0)
	end)
	self.m_csNode.Maxbutton:setTouchEnded(function()
		self.m_csNode.slider:setPercent(1)
	end)
	self.m_csNode.cancelbutton:setTouchEnded(function()
		self:close()
	end)
	self.m_csNode.confirmbutton:setTouchEnded(function()
		if self.m_hp > 0 then
            local time = self.m_path:getCostTime()
            local foodCost = self.m_path:getCostFoodForTansport(self.m_hp,time)

			if not self.m_fromCity:isMy() then
				g_scene:showTips(Serialize["world_TroopHpTrans_1"])
				return 	
			end

			if PlanShopUtil:needUsePlan(JiCeType.kWuGuFengDeng, foodCost) then
				return
			end

			WorldMapManager:onMarchArmyRequest(self.m_fromCity:getCityId(),self.m_toCity:getCityId(),{},{},self.m_hp)
			cc.Audio:playEffect("Yunshubingli.mp3",false)
			self:close()
		else
			g_scene:handleErrorCode("reserve_hp_is_empty")
		end
	end)
end

function This:refresh()
	self.m_csNode.troopsnum:setString(self.m_reserveHp - self.m_hp)
	self.m_csNode.hp:setString(string.format("%d/%d",self.m_hp,self.m_reserveHp))
	self.m_csNode.foodcost:setString(math.floor(self.m_path:getCostFoodForTansport(self.m_hp,self.m_time)))
end

--endregion
