--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This ,super = class(...,"Base.BaseModel")
local BattleBoxConfig = require("Metadatas.BattleBoxConfig")
local GamePlayer = require("Player.GamePlayer")
local Application = require("cc.Application")
local WorldMapManager = require("World.WorldMapManager")

kMaxBoxNum = 12

function This:create(info)
	local box = {}
	setmetatable(box,self)
	box:init(info)
	return box
end

function This:init(info)
	super.init(self)
	self.m_id = info.box_id
	if self.m_id > 0 then
		self.m_cityId = info.city_id
		self.m_endTime = info.action_time
		self.m_config = BattleBoxConfig[info.box_id]
		self.m_isUpdating = false
		local curTime = GamePlayer:getServerTime()
		if curTime < self.m_endTime then
			self:startUpdate()
		end
	end
	self.m_escape = 0
end

function This:getConfig()
	return self.m_config
end

function This:getId()
	return self.m_id
end

function This:getCityId()
	return self.m_cityId
end

function This:getCDTime()
	return self.m_config.seconds
end

function This:isUpdating()
	return self.m_isUpdating
end

function This:isExist()
	if self.m_id > 0 and self.m_id <= kMaxBoxNum then
		return true
	end
	return false
end

function This:isCanReward()
	local curTime = GamePlayer:getServerTime()
	if curTime >= self.m_endTime then
		local city = WorldMapManager:getCity(self.m_cityId)
		return city:isOur()
	end
	return false
end

function This:getLeftTime()
	local curTime = GamePlayer:getServerTime()
	if curTime < self.m_endTime then
		return self.m_endTime - curTime
	end
	return 0
end

function This:updateInfo(info)
	if self.m_isUpdating then
		self:endUpdate()
	end
	self.m_cityId = info.city_id
	self.m_boxId = info.box_num
	self.m_id = self.m_boxId
	self.m_endTime = info.action_time
	self.m_config = BattleBoxConfig[self.m_boxId]
	local curTime = GamePlayer:getServerTime()
	if curTime < self.m_endTime then
		self:startUpdate()
	end
end

function This:startUpdate()
	Application:addToUpdateList(self)
	self.m_isUpdating = true	
end

function This:endUpdate()
	Application:removeFromUpdateList(self)
	self.m_isUpdating = false
	WorldMapManager:onBoxUpdateEnd()
end

function This:update(dt)
	self.m_escape = self.m_escape + dt
	if self.m_escape >= 1.0 then
		self.m_escape = self.m_escape - 1.0
		local leftTime = self:getLeftTime()
		if leftTime > 0 then
			self:notifyObservers("onWorldBoxUpdateTime",leftTime)
		else
			self:notifyObservers("onWorldBoxUpdateTime",0)
			self:endUpdate()
		end
	end
end


--endregion
