--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"Stage.StageLoadingScene")
local EventDispatcher = require("EventDispatcher")
local ReportManager = require("Report.ReportManager")
local AsynchEvent = require("Event.AsynchEvent")
local Socket = require("Net.Socket")
local BattlePlayer = require("Battle.BattlePlayer")
local GameEvent = require("Event.GameEvent")
local BattleDataManager = require("Battle.BattleDataManager")
local WorldMapManager = require("World.WorldMapManager")
local LoadingScene = require("LoadingScene")
local GamePlayer = require("Player.GamePlayer")

function This:init(cityId)
	LoadingScene.init(self)
	self.m_cityId = cityId
	self:initTask()
end

function This:initTask()
	local task1 = AsynchEvent:create(function ()
		self:onGetReportDetailRequest()
	end,10302)
	self:addTask(task1)
	self:addParseBattleDataTask()
	self:addBattlePrepareTask()
end

function This:addBattlePrepareTask()
	local task10 = GameEvent:create(function()
		local city = WorldMapManager:getCity(self.m_cityId)
		local reportId = city:getReportId() or 0
		if reportId and reportId > 0 then
			local defenceQueue = city:getDefenceQueue()
			local attackQueue = city:getAttackQueue()
			BattleDataManager:setBattleId(reportId)
			BattleDataManager:setDefenceQueue(defenceQueue)
			BattleDataManager:setAttackQueue(attackQueue)
		end
		BattleDataManager:prepareBattle(true,PlayMode.kWorld)
	end)
	self:addTask(task10)
end

function This:onEnter()
	super.onEnter(self)
	EventDispatcher:addListener(self,10302,self.onGetReportDetailReply)
end

function This:onExit()
	super.onExit(self)
	EventDispatcher:removeListener(self,10302)
end

function This:onGetReportDetailRequest()
	local city = WorldMapManager:getCity(self.m_cityId)
	local reportId = city:getReportId() or 0
	if reportId > 0 then
		print("请求战报"..reportId)
		Socket:sendAndLock(10302,{report_id = reportId})
	else
		print("请求的战报是空的!!!")
	end
end

function This:onGetReportDetailReply(msg)
	self.m_battleReport = msg.report
	self.m_attackerHeroAttrList = msg.attack_list or {}
	self.m_defenderHeroAttrList = msg.defence_list or {}
	BattleDataManager:addObserver(WorldMapManager)
end


--endregion
