--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"Base.BaseModel")
local City = require("World.City")
local Socket = require("Net.Socket")
-- local City = require("World.City")
local MapRole = require("World.MapRole")
local MarchArmy = require("World.MarchArmy")
local EventDispatcher = require("EventDispatcher")
local RoomConfig = require("Metadatas.RoomConfig")
local GamePlayer = require("Player.GamePlayer")
local HeroManager = require("Hero.HeroManager")
local ReportManager = require("Report.ReportManager")
local BattlePlayer = require("Battle.BattlePlayer")
local BattleDataManager = require("Battle.BattleDataManager")
local Application = require("cc.Application")
local WorldBox = require("World.WorldBox")
local GameUtil = require("Util.GameUtil")
local GuideManager = require("Guide.GuideManager")
local StgCMCity = require("World.StgCMCity")
local StgDRGH = require("World.StgDRGH")
local StgKCJ = require("World.StgKCJ")
local StgQMBG = require("World.StgQMBG")
local StgHDSY = require("World.StgHDSY")
local MatchManager = require("Match.MatchManager")
local MatchingConfig = require("Metadatas.MatchingConfig")
local CityHided = require("World.CityHided")
local CityHanXianDi = require("World.CityHanXianDi")
local CityConfig = require("Metadatas.CityConfig")
local DropConfig = require("Metadatas.DropConfig")
local TreasureCityConfig = require("Metadatas.TreasureCityConfig")
local PopDialogManager = require("UI.PopDialogManager")
local SingleManager = require("SingleDaily.SingleManager")
local DailyAchieveManager = require("Achieve.DailyAchieveManager")


RelationType = 
{
	kJun = 1,
	kChen = 2,
	kTongMeng = 3, 
    kTongPao = 4,   --同属于一个主公
}

BattleTime =
{
	9, 12, 15, 18, 21 
}

BuildAddType = 
{
	kBuildTime = 1, --建造时间加成
	kProduct = 2, --产量加成
	kBuildCost = 3, --建造花费
}

TreasureMapType =  --藏宝图类型
{
	kLow = 1, --低级藏宝图
	kHigh = 2, --高级藏宝图
}

TreasureMapEventType = 
{
	kDrop = 1, --掉落包
	kTreasureBox = 2, --箱子
	kRebels = 3, --马贼
}

function This:init()
	super.init(self)
	self.m_observers = {}
	self.m_citys = {}
	self.m_roles = {}
	self.m_marchArmy = {}
	self.m_box = nil
	self.m_worldStartTime = 0
	self.m_nextFightTime = 0
	self.m_mapType = 0
	self.m_copper = 0
	self.m_food = 0
	self.m_escape = 0
	self.m_stgItem = {}
	self.m_isShowHanXianDiTip = false
	self.m_hanXianDiApearTime = 0
	self.m_winHanXianDiName = ""--汉献帝击杀者的名字
	
	self:initPreListener()
end

function This:initPreListener()
	EventDispatcher:addListener(self,11100,self.onGetMapInfoReply)
end

function This:initListener()
	EventDispatcher:addListener(self,11101,self.onInvestigateCityInfoReply)
	EventDispatcher:addListener(self,11102,self.onUpgradeBuildReply)
	EventDispatcher:addListener(self,11103,self.onCreateBuildReply)
	EventDispatcher:addListener(self,11104,self.onGetCityInfoReply)
	EventDispatcher:addListener(self,11105,self.onCityLevelChangedNotify)
	EventDispatcher:addListener(self,11106,self.onAddHeroHpReply)
	EventDispatcher:addListener(self,11107,self.onMarchArmyReply)
	EventDispatcher:addListener(self,11108,self.onChangedTroopPosReply)
	EventDispatcher:addListener(self,11109,self.onRemoveBuildReply)
	EventDispatcher:addListener(self,11110,self.onResourceChangedNotify)
	EventDispatcher:addListener(self,11111,self.onAutoUpgradeBuildReply)
	EventDispatcher:addListener(self,11112,self.onRelationApplyReply)
	EventDispatcher:addListener(self,11113,self.onRelationReponseReply)
	EventDispatcher:addListener(self,11114,self.onRelationApplyChangedNotify)
	EventDispatcher:addListener(self,11115,self.onRelationChangedNotify)
	EventDispatcher:addListener(self,11117,self.onMarchArmyArriveNotify)
	EventDispatcher:addListener(self,11118,self.onCityInfoChangedNotify)
	EventDispatcher:addListener(self,11119,self.onSurrenderReply)
	EventDispatcher:addListener(self,11120,self.onAutoAddHpReply)
	EventDispatcher:addListener(self,11124,self.onMapRoleEnterNotify)
	EventDispatcher:addListener(self,11125,self.onWorldBoxAppearNotify)
	EventDispatcher:addListener(self,11126,self.onRecieveBoxRewardReply)
	EventDispatcher:addListener(self,11132,self.onRoleDisappearNotify)
	EventDispatcher:addListener(self,11127,self.onRoleExitMapNotify)
	EventDispatcher:addListener(self,11128,self.onItemUseTimeChangedNotify)
	EventDispatcher:addListener(self,11129,self.onMarchArmyChangedNotify)
	EventDispatcher:addListener(self,11207,self.onBattleSettlementNotify)
	EventDispatcher:addListener(self,11130,self.onBuildAddValueNotify)
	EventDispatcher:addListener(self,11131,self.onFightTimeChangedNotify)
	EventDispatcher:addListener(self,11134,self.onGetCityTreasureBoxReply)
	EventDispatcher:addListener(self,11133,self.onUseTreasureMapReply)
	EventDispatcher:addListener(self,11135,self.onOpenTreasureBoxReply)
	EventDispatcher:addListener(self, 11136, self.onKillHanXianDiInfoReply)
end

function This:removeListener()
	EventDispatcher:removeListener(self,11101)
	EventDispatcher:removeListener(self,11102)
	EventDispatcher:removeListener(self,11103)
	EventDispatcher:removeListener(self,11104)
	EventDispatcher:removeListener(self,11105)
	EventDispatcher:removeListener(self,11106)
	EventDispatcher:removeListener(self,11107)
	EventDispatcher:removeListener(self,11108)
	EventDispatcher:removeListener(self,11109)
	EventDispatcher:removeListener(self,11110)
	EventDispatcher:removeListener(self,11111)
	EventDispatcher:removeListener(self,11112)
	EventDispatcher:removeListener(self,11113)
	EventDispatcher:removeListener(self,11114)
	EventDispatcher:removeListener(self,11115)
	EventDispatcher:removeListener(self,11117)
	EventDispatcher:removeListener(self,11118)
	EventDispatcher:removeListener(self,11119)
	EventDispatcher:removeListener(self,11120)
	EventDispatcher:removeListener(self,11124)
	EventDispatcher:removeListener(self,11125)
	EventDispatcher:removeListener(self,11126)
	EventDispatcher:removeListener(self,11132)
	EventDispatcher:removeListener(self,11128)
	EventDispatcher:removeListener(self,11129)
	EventDispatcher:removeListener(self,11207)
	EventDispatcher:removeListener(self,11130)
	EventDispatcher:removeListener(self,11131)
	EventDispatcher:removeListener(self,11127)
	EventDispatcher:removeListener(self,11133)
	EventDispatcher:removeListener(self,11134)
	EventDispatcher:removeListener(self,11135)
	EventDispatcher:removeListener(self,11136)
end

function This:onGetMapInfoRequest()
	Socket:sendAndLock(11100,{})
end

function This:onGetMapInfoReply(msg)
	self.m_citys = {}
	self.m_fightCitys = {}
	self.m_roles = {}
	self.m_marchArmy = {}  
	self.m_box = nil
	self.m_worldStartTime = 0
	self.m_nextFightTime = 0
	self.m_mapType = 0
	self.m_copper = 0
	self.m_food = 0
	self.m_escape = 0

	self.m_worldStartTime = msg.start_time
	self.m_nextFightTime =  msg.fight_time
	self.m_mapType = msg.map_type
	self.m_copper = msg.coin
	self.m_food = msg.food
	self.m_mainCityId = msg.main_city
	self.m_itemTimes = {0,0,0,0,0,0}
	self.m_buildAddValue = {}

	self.m_stgItem[JiCeType.kQianDuLing] = StgCMCity:create()
	self.m_stgItem[JiCeType.kQiMenBaGua] = StgQMBG:create()
	self.m_stgItem[JiCeType.kKongChengJi] = StgKCJ:create()
	self.m_stgItem[JiCeType.kDongRuoGuanHuo] = StgDRGH:create()
	self.m_stgItem[JiCeType.kHanDiShouYu] = StgHDSY:create()

	for i, info in pairs(msg.role_list) do
		local role = MapRole:create(info)
		self.m_roles[info.id] = role
	end
	for i , info in pairs(msg.city_list) do
		local city = self:createCity(info)
		if info.city_id == 9 then
			assert(true)
		end
		self.m_citys[info.city_id] = city
		if info.fighting_state == 1 then
			self.m_fightCitys[info.city_id] = city
		end
		city:updateStgState(info.state_list)
	end
	for i , info in pairs(msg.object_list) do
		local army = MarchArmy:create(info)
		self.m_marchArmy[info.id] = army
	end

	for i , info in pairs(msg.search_city_list) do
		local city = self:getCity(info.city_id)
		city:setInvestigateInfo(info)
		city:setInvestTime(msg.search_time[i])
		city:updateStgState(info.state_list,true)
	end

	if self.m_nextFightTime > GamePlayer:getServerTime() then
		Application:addToUpdateList(self)
	end
	self.m_box = WorldBox:create(msg.box_info)
	self.m_hanXianDiApearTime = msg.hanxiandi_appear_time or 0
	self.m_winHanXianDiName = msg.hanxiandi_killer_name or ""--汉献帝击杀者的名字

	self.m_isInit = true
	self:initListener()
	self:loadShowNextFightTimeTipRecord()
	EventDispatcher:dispatcher("world_map_relation_changed")
end

function This:isInit()
	return self.m_isInit
end

function This:createCity(info)
	local config = CityConfig[info.city_id]
	if config.type == CityType.kThief then
		if self:isHanXianDi(info.city_id) then
			return CityHanXianDi:create(info)
		end
		return CityHided:create(info)
	else
		return City:create(info)
	end
end

function This:exitMap()
	self.m_isInit = false
	for i , city in pairs(self.m_citys) do
		city:clear()
	end
	self.m_citys = {}

	self.m_fightCitys = {}
	for i , role in pairs(self.m_roles) do
		role:clear()
	end
	self.m_roles = {}

	for i , army in pairs(self.m_marchArmy) do
		army:clear()
	end

	for i , stg in pairs(self.m_stgItem) do
		stg:clear()
	end

	self.m_marchArmy = {}
	self.m_observers = {}
	self.m_worldStartTime = 0
	self.m_nextFightTime = 0
	self.m_mapType = 0
	self.m_copper = 0
	self.m_food = 0
	self.m_escape = 0
	self.m_isShowHanXianDiTip = false
	Application:removeFromUpdateList(self)
	self:removeListener()
end

function This:getId()
    return GamePlayer:getMapId()
end

function This:isInWorld()
	local playerId = GamePlayer:getPlayerID()
	if self.m_roles[playerId] then
		return true
	end
	return false
end

function This:getMapType()
	return self.m_mapType
end

function This:getAllRole()
	return self.m_roles
end

function This:getRole(id)
	return self.m_roles[id]
end

function This:getMainRole()
	local id = GamePlayer:getPlayerID()
	return self.m_roles[id]
end

function This:getCity(cityId)
	local city = self.m_citys[cityId]
	if city == nil then
		city = self:createCity({city_id = cityId, treasure_npc_id = 0})
		self.m_citys[cityId] = city
	end
	return city
end

function This:getFightCitys()
	return self.m_fightCitys
end

function This:getMainCityId()
	return self.m_mainCityId
end

function This:getAllCity()
	return self.m_citys
end

function This:getWorldStartTime()
	return self.m_worldStartTime
end

function This:getNextFightTime()
	return  self.m_nextFightTime
end

-- SingleManagerSaveState.kWorldMapHanXianDi
function This:setTypeIsHave(saveType,time)
	local startTime = time or self:getWorldStartTime()
	if saveType then
		SingleManager:setIsHave(saveType,startTime)
	end
end

function This:getTypeIsHave(saveType)
	local startTime = self:getWorldStartTime()
	if saveType then
		return SingleManager:getIsHave(saveType,startTime)
	end
	return false
end

function This:loadShowNextFightTimeTipRecord()
    local params = cc.FileUtils:loadLuaFile("WorldMapNextFightTime") or {}
    local key = tostring(GamePlayer:getPlayerID())
    if params[key] == nil then
    	self.m_showNextFightTimeTip = true
    else
    	self.m_showNextFightTimeTip = params[key]
    end
end

function This:saveShowNextFightTimeTipRecord(value)
	self.m_showNextFightTimeTip = value

    local params = cc.FileUtils:loadLuaFile("WorldMapNextFightTime") or {}
    local key = tostring(GamePlayer:getPlayerID())
    if value ~= nil then
        params[key] = self.m_showNextFightTimeTip
        cc.FileUtils:saveToLua(params,"WorldMapNextFightTime")
    end
end

function This:isShowNextFightTimeTipRecord()
    if self.m_showNextFightTimeTip then
    	return self:isInProtected()
	end
	return false  
end

function This:isInProtected()
	local curTime = GamePlayer:getServerTime()
	return curTime < self.m_nextFightTime
end

function This:getCopper()
	return self.m_copper
end

function This:getMaxCopper()
	return RoomConfig[self.m_mapType].coin_use_max
end

function This:getFood()
	return self.m_food
end

function This:getMaxFood()
	return RoomConfig[self.m_mapType].food_use_max
end

function This:getCityMaxHp()
	return RoomConfig[self.m_mapType].init_force_num
end

function This:getValueByUsingJice( jiCeType )
    if JiCeType.kCaiYuanGunGun == jiCeType then
    	return RoomConfig[self.m_mapType].coin_use_value
    elseif JiCeType.kWuGuFengDeng == jiCeType then
		return RoomConfig[self.m_mapType].food_use_value
    elseif JiCeType.kZhaoBinMaima == jiCeType then
		return RoomConfig[self.m_mapType].force_use_value
    end
    return 0
end

--现在只使用招兵买马
function This:canUseItem(id)    
	local maxNum = self:getMaxUseItemNum(id)
    local useNum = self.m_itemTimes[id] or 0
    return useNum < maxNum, useNum, maxNum
end

function This:getMaxUseItemNum(id)
	local config = RoomConfig[self.m_mapType].plan_use_num
	local maxNum = 0
	if config then
		for _, tuple in ipairs(config) do
			if tuple[1] == id then
				maxNum = tuple[2]
				break
			end
		end
	end 
	return maxNum
end

function This:removeRole(id)
	local role = self.m_roles[id]
	if role then
		role:clear()
		self.m_roles[id] = nil
	end
end

function This:addMarchArmy(info)
	if self.m_marchArmy[info.id] then
		print("该行军已经存在")
		assert(false)
	end

	local owner = self:getRole(info.owner_id)
	if not owner then
		return 
	end

	local army = MarchArmy:create(info)
	self.m_marchArmy[info.id] = army
	self:notifyObservers("onAddMarchArmy",army)
	return army
end

function This:updateMarchArmy(cityId)
	for i , army in pairs(self.m_marchArmy) do
		if army:getToCity() == cityId then
			army:updateData()
			self:notifyObservers("onUpdateMarchArmy",army)
		end
	end
end

function This:getMarchArmy(id)
	return self.m_marchArmy[id]
end

function This:getAllMarchArmy()
	return self.m_marchArmy
end

function This:getEnemyMarchArmyToMyCity()
	local armyList = {}
	for i , army in pairs(self.m_marchArmy) do
		local toCityId = army:getToCity()
		local city = self:getCity(toCityId)
		if city:isMy() and not army:isOur() then
			table.insert(armyList,army)
		end
	end
	return armyList
end

function This:removeMarchArmy(id)
	local army = self.m_marchArmy[id]
	if army then
		self.m_marchArmy[id] = nil
		self:notifyObservers("onRemoveMarchArmy",army)
	end
end

function This:getMarchArmyList(id)
	local result = {}
	for i , army in pairs(self.m_marchArmy) do
		if army:getOwnerId() == id then
			table.insert(result,army)
		end
	end
	return result
end

function This:getMarchArmyToCity(cityId)
	local result = {}
	for id , army in pairs(self.m_marchArmy) do
		if army:getToCity() == cityId then
			table.insert(result,army)
		end
	end
	return result
end

function This:getBox()
	return self.m_box
end

function This:getStgItem(id)
	return self.m_stgItem[id]
end

function This:getStgItemWithState(state)
	if state == JiCeState.kDRGH then
		return self.m_stgItem[JiCeType.kDongRuoGuanHuo]
	elseif state == JiCeState.kKCJ then
		return self.m_stgItem[JiCeType.kKongChengJi]
	elseif state == JiCeState.kQMBG then
		return self.m_stgItem[JiCeState.kQMBG]
	elseif state == JiCeState.kHDSY then
		return self.m_stgItem[JiCeState.kHDSY]
	end
end

function This:getStgItemList()
	local result = {}
	table.insert(result,self.m_stgItem[JiCeType.kQianDuLing])
	table.insert(result,self.m_stgItem[JiCeType.kQiMenBaGua])
	table.insert(result,self.m_stgItem[JiCeType.kKongChengJi])
	table.insert(result,self.m_stgItem[JiCeType.kDongRuoGuanHuo])
	table.insert(result,self.m_stgItem[JiCeType.kHanDiShouYu])
	return result
end

function This:getBuildAddValue(buildType,addType)
	if self.m_buildAddValue[buildType] and self.m_buildAddValue[buildType][addType] then
		local info = self.m_buildAddValue[buildType][addType]
		return info.percent, info.value
	end
	return 0 , 0
end

function This:getRoleForcesList()
	local tmp = {}
	local function getForceWithRole(role)
		local result = {}
		local master = role:getMaster()
		if master > 0 then
			local masterRole = self.m_roles[master]
			table.insert(result,masterRole)
			tmp[master] = true
			local coll = masterRole:getColleague()
			for i , id in ipairs(coll) do
				table.insert(result,self.m_roles[id])
				tmp[id] = true
			end
			return result
		end
		local coll = role:getColleague()
		if #coll > 0 then
			table.insert(result,role)
			tmp[role:getId()] = true
			for i , id in ipairs(coll) do
				table.insert(result,self.m_roles[id])
				tmp[id] = true
			end
			return result
		end
		local ally = role:getAlly()
		if ally > 0 then
			table.insert(result,role)
			tmp[role:getId()] = true
			table.insert(result,self.m_roles[ally])
			tmp[ally] = true
			return result
		end
		table.insert(result,role)
		tmp[role:getId()] = true
		return result
	end

	local result = {}
	local mainRole = self:getMainRole()
	local main = getForceWithRole(mainRole)
	table.insert(result,main)
	for id , role in pairs(self.m_roles) do
		if not tmp[id] then
			local t = getForceWithRole(role)
			table.insert(result,t)
		end
	end
	return result
end

function This:hasRecvRelationRequest()
	local role = self:getMainRole()
	if role then
		local recvs = role:getRecvRequest()
		return next(recvs) ~= nil
	end
end

function This:getCopperProduct()
	local total  = 0
	for i , city in pairs(self.m_citys) do
		if city:isMy() then
			total = total + city:getCopperProduct()
		end
	end
	return total
end

function This:getFoodProduct()
	local total  = 0
	for i , city in pairs(self.m_citys) do
		if city:isMy() then
			total = total + city:getFoodProduct()
		end
	end
	return total
end

function This:removeRoleOnMap(roleId)
	local role = self.m_roles[roleId]
	if role then
		print(string.format("玩家%s退出大地图",role:getName()))
		local relation = role:getRelationWithMe()
		if relation == RelationType.kChen then
			local panel = g_scene:openDialog("UI.MsgPmtTips",{
				title = Serialize["world_MapManager_1_c"],
				msg = string.format(Serialize["world_MapManager_2"],role:getName())
			})
		elseif relation == RelationType.kJun then
			local panel = g_scene:openDialog("UI.MsgPmtTips",{
				title = Serialize["world_MapManager_1_c"],
				msg = string.format(Serialize["world_MapManager_3"],role:getName())
			})
		end
		self:removeRole(roleId)
	end
end

-----------------------------协议部分----------------------------------
--侦查城市
function This:onInvestigateCityInfoRequest(cityId)
	Socket:sendAndLock(11101,{city_id = cityId})
end

function This:onInvestigateCityInfoReply(msg)
	if msg.err_code == 0 then
		local city = self:getCity(msg.city.city_id)
		city:setInvestigateInfo(msg.city)
		city:setInvestTime(msg.search_time)
		local isAdvance = false
		for i , stgInfo in ipairs(msg.city.state_list) do
			if stgInfo.state == JiCeState.kDRGH then
				isAdvance = true
			end
		end
		city:setIsAdvanceInvestigated(isAdvance)
		self:notifyObservers("onInvestigateCity",city)
	else
		g_scene:handleErrorCode(msg.err_code)
	end
end

--升级建筑
function This:onUpgradeBuildRequest(cityId,pos)
	Socket:sendAndLock(11102,{city_id = cityId, pos = pos})
end

function This:onUpgradeBuildReply(msg)
	if msg.err_code == 0 then
		local city = self:getCity(msg.city_id)
		table.sort(msg.building_list,function(a,b)
			return a.pos < b.pos
		end)
		for i , info in ipairs(msg.building_list) do
			local build = city:getBuild(info.pos)
			print("pos = ",info.pos)
			info.delay = i * 0.1
			build:updateInfo(info)
		end

		print(string.format("11102 -> cityId = %d, times = %d",msg.city_id,msg.auto_times))
		city:setAutoUpgradeTimes(msg.auto_times)
		self:notifyObservers("onBuildStateChanged",city,msg.building_list)
	else
		g_scene:handleErrorCode(msg.err_code)
	end
end

--建筑建造
function This:onCreateBuildRequest(cityId,posList,typeList)
	for i , pos in ipairs(posList) do
		print(string.format("<--建造建筑，位置%d",pos))
	end
	Socket:send(11103,{city_id = cityId, pos = posList, building_type = typeList})
end

function This:onCreateBuildReply(msg)
	if msg.err_code == 0 then
		for i , info in ipairs(msg.building_list) do
			print(string.format("-->建造建筑，位置%d",info.pos))
		end
		local city = self:getCity(msg.city_id)
		city:addBatchBuild(msg.building_list)
	else
		g_scene:handleErrorCode(msg.err_code)
	end
end

--查看城市信息
function This:onGetCityInfoRequest(cityId)
	Socket:sendAndLock(11104,{city_id = cityId})
end

function This:onGetCityInfoReply(msg)
	if msg.err_code == 0 then
		local city = self:getCity(msg.city.city_id)
		city:updateInfo(msg.city)
		self:notifyObservers("onGetCityInfo",city)
	else
		g_scene:handleErrorCode(msg.err_code)
	end
end

--城市等级变化通知
function This:onCityLevelChangedNotify(msg)
	local city = self:getCity(msg.city_id)
	city:setLevel(msg.level)
	local build = city:getBuild(BuildPos.kMainBuild)
	if build then
		build:setLevel(msg.level)
		self:notifyObservers("onCityLvChanged",city)
	end
end

--补兵
function This:onAddHeroHpRequest(cityId,info)
	Socket:sendAndLock(11106,{city_id = cityId , card_id = info.heros, force_num = info.hp})
end

function This:onAddHeroHpReply(msg)
	if msg.err_code == 0 then
		local city = self:getCity(msg.city_id)
		city:updateTroopList(GamePlayer:getPlayerID(),msg.army_list)
		self:notifyObservers("onAddHeroHp",city,msg.army_list)
		EventDispatcher:dispatcher("add_troop_hp",msg.city_id,msg.army_list)
	else
		g_scene:handleErrorCode(msg.err_code)
	end
end

--行军
function This:onMarchArmyRequest(fromId,toId,troopList,posList, reserveHp, objIdList)
	Socket:sendAndLock(11107,{
		from_city_id = fromId, 
		to_city_id = toId, 
		army_id_list = troopList,
		pos_list = posList, 
		reserve_force_num = reserveHp or 0, 
		object_id = objIdList or {}
	})
	print(string.format("fromId = %d, toId = %d",fromId,toId))
end

function This:onMarchArmyReply(msg)
	if msg.err_code == 0 then
		local army = self:addMarchArmy(msg.object)
		if army then
			self:notifyObservers("onMarchArmy",msg.object)
			EventDispatcher:dispatcher("march_army_start",msg.object)
		end
	else
		g_scene:handleErrorCode(msg.err_code)
	end
end

--卡牌位置调整
function This:onChangedTroopPosRequest(cityId,posList,idList)
	Socket:sendAndLock(11108,{city_id = cityId, pos = posList,card_id = idList})
end

function This:onChangedTroopPosReply(msg)
	if msg.err_code == 0 then
		local city = self:getCity(msg.city_id)
		city:updateTroopList(city:getOwnerId(),msg.army_list)
		self:notifyObservers("onTroopPosChanged",city)
	else
		g_scene:handleErrorCode(msg.err_code)
	end
end

--建筑拆迁
function This:onRemoveBuildRequest(cityId,pos)
	Socket:sendAndLock(11109,{city_id = cityId, pos = pos})
end

function This:onRemoveBuildReply(msg)
	if msg.err_code == 0 then
		local city = self:getCity(msg.city_id)
		city:removeBuild(msg.pos)
	else
		g_scene:handleErrorCode(msg.err_code)
	end
end

--资源发生变化
function This:onResourceChangedNotify(msg)
	local oldFood = self.m_food
	local oldCopper = self.m_copper
	self.m_food = msg.food
	self.m_copper = msg.coin
	for i , cityId in ipairs(msg.city_id) do
		local city = self:getCity(cityId)
		city:setTotalHp(msg.force_num[i])
		city:setReserveHp(msg.reserve_force_num[i])
		self:notifyObservers("onResChanged",city)
	end
	if oldFood > self.m_food then
		g_scene:showMoneyTips(tostring(self.m_food - oldFood) .. Serialize[64955], { delayFactor = 1.5, colorId = "R0" } )
	end
	if oldCopper > self.m_copper then
		g_scene:showMoneyTips(tostring(self.m_copper - oldCopper) .. Serialize[64956], { delayFactor = 1.5, colorId = "R0" } )
	end
end

--自动升级
function This:onAutoUpgradeBuildRequest(cityId,times)
	print("times = ",times)
	Socket:sendAndLock(11111,{city_id = cityId, times = times})
end

function This:onAutoUpgradeBuildReply(msg)
	if msg.err_code == 0 then
		print(string.format("11111 -> cityId = %d, times = %d",msg.city_id,msg.times))
		local city = self:getCity(msg.city_id)
		city:setAutoUpgradeTimes(msg.times)
		self:notifyObservers("onAutoUpgrade",msg.city_id,msg.times)
	else
		g_scene:handleErrorCode(msg.err_code)
	end
end

--外交关系申请
function This:onReleationApplyRequest(target,relationType)
	Socket:send(11112,{target_id = target,relation_type = relationType})
end

function This:onRelationApplyReply(msg)
	if msg.err_code == 0 then
		self:notifyObservers("onRelationApply")
	else
		g_scene:handleErrorCode(msg.err_code)
	end
end

--外交关系回应
function This:onRelationResponseRequest(targetId,isOk)
	Socket:sendAndLock(11113,{target_id = targetId, answer = isOk})
end

function This:onRelationReponseReply(msg)
	if msg.err_code == 0 then
		self:notifyObservers("onRelationResponse")
	else
		g_scene:handleErrorCode(msg.err_code)
	end
end

--外交关系通知
function This:onRelationApplyChangedNotify(msg)
	local mainRole = self:getRole(GamePlayer:getPlayerID())
	
	for i , relation in ipairs(msg.del_send_list) do
		print("删除已经发送外交请求", tostring(relation.target_id), tostring(relation.relation_type))
		mainRole:removeSendRequest(relation.target_id)
	end
	for i , relation in ipairs(msg.add_send_list) do
		print("发送外交请求", tostring(relation.target_id), tostring(relation.relation_type))
		mainRole:addSendRequest(relation.target_id,relation.relation_type)
	end

	for i , relation in ipairs(msg.del_request_list) do
		print("删除已经收到外交请求", tostring(relation.target_id), tostring(relation.relation_type))
		mainRole:removeRecvRequest(relation.target_id)
	end

	for i , relation in ipairs(msg.add_request_list) do
		print("收到外交请求", tostring(relation.target_id), tostring(relation.relation_type))
		mainRole:addRecvRequest(relation.target_id,relation.relation_type)
	end

	EventDispatcher:dispatcher("world_map_relation_changed")
	self:notifyObservers("onApplyStateChanged")
end

function This:onRelationChangedNotify(msg)
	local target = self:getRole(msg.target_id)
	if target then
		target:setRelation(msg.source_id, msg.relation_type)
		self:notifyObservers("onRelationChanged",msg.target_id,msg.source_id)
	end
end

--行军到达通知
function This:onMarchArmyArriveNotify(msg)
	local curTime = GamePlayer:getServerTime()
	print(string.format("行军到达通知,开始时间%s,到达时间%s,当前时间%s",os.serverdate("%c",msg.object.start_time), os.serverdate("%c",msg.object.end_time) ,os.date("%c",curTime)))
	self:removeMarchArmy(msg.object.id)
	EventDispatcher:dispatcher("march_army_changed",army)
end

--城市信息变化通知
function This:onCityInfoChangedNotify(msg) 
	print(string.format("城市%d信息变化通知,战报ID:%d",msg.city.city_id,msg.city.report_id))
	local str =  ""
	for i , info in ipairs(msg.city.guard_list) do
		str = string.format(Serialize[64957],str,GameUtil:int64ToString(info.id),info.force_num,#info.army_list)
	end
	print("防守队列: "..str)

	str = ""
	for i , info in ipairs(msg.city.attack_list) do
		str = string.format(Serialize[64957],str,GameUtil:int64ToString(info.id),info.force_num,#info.army_list)
	end
	print("攻击队列: "..str)

	print(string.format("城市%d状态%d",msg.city.city_id,msg.city.fighting_state))

	local cityId = msg.city.city_id
	local state = msg.city.fighting_state

	local city = self:getCity(cityId)
	local oldOwnerId = city:getOwnerId()
	city:updateInfo(msg.city)
	local newOwnerId = city:getOwnerId()

	if state > 0 and msg.city.report_id > 0 then
		local defenceQueue = city:getDefenceQueue()
		local attackQueue = city:getAttackQueue()
		BattleDataManager:addBattle(cityId,msg.city.report_id,defenceQueue,attackQueue)
	end

	local isOldHide = city:isHide()
	city:updateStgState(msg.city.state_list)
	local isNewHide = city:isHide()

	if isOldHide and not isNewHide then
		self:notifyObservers("onCityAppear",city)
		EventDispatcher:dispatcher("city_appear",city)
	elseif not isOldHide and isNewHide then
		self:notifyObservers("onCityDisappear",city)
		EventDispatcher:dispatcher("city_disappear",city)
	end

	if state == CityState.kInFighting and not self.m_fightCitys[cityId] then
		self.m_fightCitys[cityId] = city
		EventDispatcher:dispatcher("fight_start",city)
	elseif state ~= CityState.kInFighting and self.m_fightCitys[cityId] then
		self.m_fightCitys[cityId] = nil
		EventDispatcher:dispatcher("fight_end",city)
	end

	if newOwnerId ~= oldOwnerId then
		if GamePlayer:getPlayerID() == newOwnerId then
			g_scene:showTips(Serialize[64958]..city:getName())
		end
		self:updateMarchArmy(cityId)
		EventDispatcher:dispatcher("city_owner_changed",cityId)
		self:notifyObservers("onCityOwnerChanged",city)
	end
	self:notifyObservers("onCityInfoChanged",city)
	EventDispatcher:dispatcher("city_state_changed",cityId)
end

--投降
function This:onSurrenderRequest()
	Socket:sendAndLock(11119,{})
end

function This:onSurrenderReply(msg)
	if msg.err_code == 0 then
		self:notifyObservers("onSurrender")
	else
		g_scene:handleErrorCode(msg.err_code)
	end
end

--自动补兵
function This:onAutoAddHpRequest(isAuto,cityId)
	Socket:sendAndLock(11120,{auto = isAuto ,city_id = cityId})
end

function This:onAutoAddHpReply(msg)
	if msg.err_code == 0 then
		local city = self:getCity(msg.city_id)
		city:setIsAutoAddHp(msg.auto)
		self:notifyObservers("onAutoAddHp",msg.city_id,msg.auto)
	else
		g_scene:handleErrorCode(msg.err_code)
	end
end

--玩家进入大地图
function This:onMapRoleEnterNotify(msg)
	local role = self.m_roles[msg.role.id]
	if role then
		role:updateInfo(msg.role)
	else
		role = MapRole:create(msg.role)
		self.m_roles[msg.role.id] = role
		print(string.format("玩家%s进入地图,ID:%d,index:%d",msg.role.name,msg.role.id,msg.role.index))
		self:notifyObservers("onMapRoleEnter",role)
	end
	self:notifyObservers("onMapRoleChanged",role)
end

--地图箱子出现通知
function This:onWorldBoxAppearNotify(msg)
	print("战局宝箱出现通知...")
	self.m_box:updateInfo(msg)
	self:notifyObservers("onWorldBoxAppear")
end

--领取箱子奖励
function This:onRecieveBoxRewardRequest()
	Socket:sendAndLock(11126,{})
end

function This:onRecieveBoxRewardReply(msg)
	print("领取宝箱...")
	if msg.err_code == 0 then
		local itemList = {}
		for i , id in ipairs(msg.item_id_list) do
			table.insert(itemList,{id = id, num = msg.item_num_list[i]})
		end
		g_scene:showReward(itemList)
		self:notifyObservers("onRewardWorldBox",self.m_box)
	else
		g_scene:handleErrorCode(msg.err_code)
	end
end

--玩家主动退出
function This:onRoleExitMapNotify(msg)
	local roleId = msg.id
	if GamePlayer:getPlayerID() == roleId then
		return
	end
	local role = self.m_roles[msg.id]
	self:removeRoleOnMap(msg.id)
	self:notifyObservers("onRoleDisappear",role)
end

--玩家从地图消失
function This:onRoleDisappearNotify(msg)
	local roleId = msg.id
	if GamePlayer:getPlayerID() == roleId then
		return 
	end

	local role = self.m_roles[roleId]
	if role then
		self:removeRoleOnMap(msg.id)
		self:notifyObservers("onRoleDisappear",role)
	end

	local winer = self.m_roles[msg.kill_id]
	if GamePlayer:getPlayerID() == msg.kill_id or (winer and winer:getRelationWithMe() > 0) then
		-- 今晚吃鸡
		msg.chicken_dinner = true
	end

	if not GuideManager:isInGuide() then
		if g_scene:getName() == "BattleTestSceneView" then
			PopDialogManager:addPopDialog({
				bCheck = true,
				scene = "WorldScene", 
				name = "World.LoserShowPanel", 
				arg = msg, 
				level == DialogLevel.kSecLevel
			})
		elseif g_scene:getName() == "WorldScene" then
			g_scene:openDialog("World.LoserShowPanel", msg)
		end
	end
end

--获取玩家的同盟或者盟友列表
function This:getForceList(winPlayerId)
    local list = {}
    local tmp = {}

    local function func(role)
        local identity = role:getIdentity()
        if identity == RelationType.kJun then
            local t = {role:getId()}
            local col = role:getColleague()
            for i , colId in ipairs(col) do
                table.insert(t,colId)
                tmp[colId] = true
            end
            table.insert(list,t)
            return true
        elseif identity == RelationType.kTongMeng then
            table.insert(list,{role:getId(),role:getAlly()})
            tmp[role:getAlly()] = true
            return true
        elseif identity <= 0 then
            table.insert(list,{role:getId()})
            return true
        end
    end

    local mainRole = self:getRole(GamePlayer:getPlayerID())
    func(mainRole)

    local roles = self:getAllRole()
    for id , role in pairs(roles) do
        if id ~= GamePlayer:getPlayerID() and not tmp[id] then
            if func(role) then
                tmp[id] = true
            end
        end
    end
    local temWinPlayerId = winPlayerId
    if temWinPlayerId then
        for i , force in ipairs(list) do
            for j , id in ipairs(force) do
                if id == temWinPlayerId then
                    return force
                end
            end
        end
    end
    return list
end

function This:isHanXianDi(cityId)
	if cityId and cityId== kHanXianDi then
		return true
	end
	return false
end

function This:addHanXianDiSkillInfo(node,roleId)
	if not node then
		return
	end
	local nodeVisible = self:getMapType() >= 0
	if nodeVisible and self:isInWorld()then
		local roleData = self:getRole(roleId)
		if roleData and roleData:getIsKillHanXianDi() then
			local skillIconId = DailyAchieveManager:getArgConfigLv("zb_hxd_skill_icon") or 1
			node.icon:setImage(string.format("Icons/Skill/%s.png", skillIconId))
			nodeVisible = true
		else
			nodeVisible = false
		end
	end
	node:setVisible(nodeVisible)
end

--赢了汉献帝的玩家名字
function This:getPlayerWinHanXianDiName(...)
	return self.m_winHanXianDiName or ""
end

--是否有玩家赢了汉献帝
function This:getPlayerWinHanXianDi()
	local result = self:getPlayerWinHanXianDiName() ~= ""
	return result
end

function This:getHanXianDiApearTime()
	return self.m_hanXianDiApearTime or 0
end

function This:isHanXianDiAppearTime()
	-- return self.m_hanxiandi
	-- return true
	local timeLimit = GamePlayer:getServerTime() >self.m_hanXianDiApearTime
	if (self.m_hanXianDiApearTime>0 and timeLimit) or 
		self:getTypeIsHave(SingleManagerSaveState.kWorldMapHanXianDi) then
		return true
	end
	return false
end

function This:addHanXianDiTipPanel()
	if not self.m_isShowHanXianDiTip and self:isHanXianDiAppearTime() then
		if self:getTypeIsHave(SingleManagerSaveState.kWorldMapHanXianDi) then
			self.m_isShowHanXianDiTip = true
		else
			self.m_isShowHanXianDiTip = true
			PopDialogManager:addPopDialog({
				bCheck = true,
				scene = "WorldScene", 
				name = "World.HanXianDiTipPanel", 
				level =DialogLevel.kForLevel
			})
		end
	end
end

--战局结算
function This:onBattleSettlementNotify(msg)
	print("退出大地图...")
	if msg.map_id == GamePlayer:getMapId() then
		self:notifyObservers("onExitWorldMap")
		self:exitMap()
	end
end

--道具使用次数
function This:onItemUseTimeChangedNotify(msg)
    for i, info in ipairs(msg.item_use_list) do
        local id = info.item_id
		local num = info.use_num
		local lastUseTime = info.last_use_time

        if self.m_itemTimes[id] ~= num then
            self.m_itemTimes[id] = num
		end

		local stg = self.m_stgItem[id]
		if stg then
			stg:setUseCount(num)
			stg:setLastUseTime(lastUseTime)
			self:notifyObservers("onJiCeUseTimeChanged",stg)
		end
    end
end

--部队变化通知
function This:onMarchArmyChangedNotify(msg)
	local army = self.m_marchArmy[msg.object.id]
	if army then
		army:updateInfo(msg.object)
		self:notifyObservers("onMarchArmyChanged",army)
		EventDispatcher:dispatcher("march_army_changed",army)
	end
end

function This:onBattleSettlementNotify(msg)
	self:exitMap()
end

--建筑加成

function This:onBuildAddValueNotify(msg)
	self.m_buildAddValue = {}
	for i , info in ipairs(msg.attr_list) do
		if not self.m_buildAddValue[info.building_type] then
			self.m_buildAddValue[info.building_type] = {}
		end
		self.m_buildAddValue[info.building_type][info.attr_type] = {value = info.value, percent = info.percent}
	end
	local rank = MatchManager:getRankLv()
	for i , info in ipairs(MatchingConfig[rank].level_power) do
		local buildType = info[1]
		local attrId = info[2]
		local value = info[3]
		if not self.m_buildAddValue[buildType] then
			self.m_buildAddValue[buildType] = {}
		end
		if not self.m_buildAddValue[buildType][attrId] then
			self.m_buildAddValue[buildType][attrId] = {value = 0, percent = 0}
		end
		if attrId == 1 then --建造时间需要负数
			self.m_buildAddValue[buildType][attrId].percent = self.m_buildAddValue[buildType][attrId].percent - value
		else
			self.m_buildAddValue[buildType][attrId].percent = self.m_buildAddValue[buildType][attrId].percent + value
		end
	end
	self:notifyObservers("onBuildAddValue")
end

--开战时间变化

function This:onFightTimeChangedNotify(msg)
	self.m_nextFightTime = msg.fight_time
	self:notifyObservers("onFightTimeChanged")
	local str = os.serverdate("*t",msg.fight_time)
	local panel = g_scene:openDialog("UI.MsgPmtTips",{
		title = Serialize["world_MapManager_4"],
		msg = Serialize[64959] .. GameUtil:formatDate(Serialize["world_MapManager_5"],msg.fight_time)
	})
end


--使用藏宝图
function This:onUseTreasureMapRequest(id,typeId)
	self.m_treasureTypeId = typeId
	Socket:sendAndLock(11133,{id = id})
end

function This:onUseTreasureMapReply(msg)
	if msg.err_code == 0 then
		if msg.event_type == TreasureMapEventType.kDrop then
			local rewardList = {}
			for i , info in ipairs(msg.item_list) do
				table.insert(rewardList,{id = info.id,num = info.num})
			end
			g_scene:showReward(rewardList)
		elseif msg.event_type == TreasureMapEventType.kTreasureBox then
			if not TreasureCityConfig[self.m_treasureTypeId] then
				print("没有找到藏宝图%d的配置表",self.m_treasureTypeId)
				assert(false)
			end
			local cityId = TreasureCityConfig[self.m_treasureTypeId].city_id
			local city = self:getCity(cityId)
			g_scene:showTips(string.format(Serialize["world_MapManager_6"],city:getName()))
		elseif msg.event_type == TreasureMapEventType.kRebels then
			g_scene:showTips(Serialize["world_MapManager_7"])
		end
		self:notifyObservers("onUseTreasureMap",msg.event_type)
	else
		g_scene:handleErrorCode(msg.err_code)
	end
end

--城市藏宝图箱子信息
function This:onGetCityTreasureBoxRequest(cityId)
	Socket:sendAndLock(11134,{city_id = cityId})
end

function This:onGetCityTreasureBoxReply(msg)
	if msg.err_code == 0 then
		local city = self:getCity(msg.city_id)
		for i , info in ipairs(msg.box_list) do
			city:addTreasureBox(info)
		end
		self:notifyObservers("onGetCityTreasureBox")
	else
		g_scene:handleErrorCode(msg.err_code)
	end
end

--城市开藏宝图箱子
function This:onOpenTreasureBoxRequest(cityId,treasureId,itemId)
	Socket:sendAndLock(11135,{city_id = cityId, treasure_id = treasureId, item_id = itemId})
end

function This:onOpenTreasureBoxReply(msg)
	if msg.err_code == 0 then
		local city = self:getCity(msg.city_id)
		local box = city:getTreasureBox(msg.treasure_id)
		local rewardList = box:getRewardList()
		g_scene:showReward(rewardList)
		city:removeTreasureBox(msg.treasure_id)
		self:notifyObservers("onOpenTreasureBox",box)
	else
		g_scene:handleErrorCode(msg.err_code)
	end
end

function This:onKillHanXianDiInfoReply( msg )
	if msg then
		local killRoleList = msg.killer_list
		for _,roleId in ipairs(killRoleList) do
			local roleData= self:getRole(roleId)
			if roleData then
				roleData:setIsKillHanXianDi(true)
			end
		end
		self.m_winHanXianDiName = msg.killer_name or ""
		PopDialogManager:addPopDialog({
				bCheck = true,
				scene = "WorldScene", 
				name = "World.HanXianDiInfoPanel", 
				level =DialogLevel.kForLevel
			})
        self:notifyObservers("onKillHanXianDiInfo")
	-- else
	-- 	g_scene:handleErrorCode("")
	end
end
----------------------------------------通知部分----------------------------------------
function This:onAddBuild(city,buildList)
	self:notifyObservers("onAddBuild",city,buildList)
end

function This:onRemoveBuild(city,build)
	self:notifyObservers("onRemoveBuild",city,build)
end

function This:onBuildUpgrade(city,build)
	print(string.format("建筑升级，位置%d",build:getPos()))
	self:notifyObservers("onBuildUpgrade",city,build)
end

function This:onAddTroop(city,army)
	self:notifyObservers("onAddArmy",city,army)
end

function This:onRemoveTroop(city,army)
	self:notifyObservers("onRemoveArmy",city,army)
end

function This:onBattleSkip()
	if GamePlayer:isInWorld() then
		cc.SceneManager:switchTo("World.WorldScene")
	else
		cc.SceneManager:switchTo("Home.MenuScene")
	end
	BattleDataManager:removeObserver(self)
end

function This:onBattleVictory()
	BattleDataManager:removeObserver(self)
	if GamePlayer:isInWorld() then
		local reportId = BattleDataManager:getBattleId()
		local param = {reportId = reportId}
		if g_scene and g_scene:getName() == "BattleTestSceneView" then
			local panel = g_scene:openDialog("World.BattleEndPanel", param)
			panel:setLocalZOrder(BattleZorder.kUiLayer + 1)
		end
	end
end

function This:onBattleFailed(isSkip)
	BattleDataManager:removeObserver(self)
	if GamePlayer:isInWorld() then
		local reportId = BattleDataManager:getBattleId()
		local param = {reportId = reportId}
		if g_scene and g_scene:getName() == "BattleTestSceneView" then
			local panel = g_scene:openDialog("World.BattleEndPanel", param)
			panel:setLocalZOrder(BattleZorder.kUiLayer + 1)
		end
	end
end

function This:onBoxUpdateEnd()
	self:notifyObservers("onWorldBoxUpdateEnd",self.m_box)
end

function This:update(dt)
	self.m_escape = self.m_escape + dt
	if self.m_escape >= 1 then
		if GamePlayer:getServerTime() > self.m_nextFightTime then
			for id , city in pairs(self.m_citys) do
				city:updateState() 
			end
			self:notifyObservers("onFightTimeStart")
			Application:removeFromUpdateList(self)
		end
		self:notifyObservers("onUpdateWorldTime")
		self.m_escape = self.m_escape - 1
--		self:addHanXianDiTipPanel()
	end
end

function This:enter()
	cc.SceneManager:switchTo("World.WorldScene")
end

--endregion
