--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"Dialog")
local WorldMapManager = require("World.WorldMapManager")
local GamePlayer = require("Player.GamePlayer")
local GameUtil = require("Util.GameUtil")

local RoleIndexFlag = "WarScene/town_%d.png"
local CityIndexFlag = 
{
	[CityType.kCity] = "WarScene/city_%d.png",
	[CityType.kTown] = "WarScene/town_%d.png",
	[CityType.kThief] = "WarScene/town_22.png",
}

local CitySelectFlag = 
{
	[CityType.kCity] = "WarScene/citychoose.png",
	[CityType.kTown] = "WarScene/townchoose.png",
	[CityType.kThief] = "WarScene/townchoose.png",
}

local CitySelfFlag = 
{
	[CityType.kCity] = "WarScene/cityown.png",
	[CityType.kTown] = "WarScene/townown.png",		
	[CityType.kThief] = "WarScene/townown.png",		
}

local CityEnemyFlag = 
{
	[CityType.kCity] = "WarScene/cityenemy.png",
	[CityType.kTown] = "WarScene/townenemy.png", 
	[CityType.kThief] = "WarScene/townenemy.png", 
}

local CityFriendFlag = 
{
	[CityType.kCity] = "WarScene/cityfriend.png",
	[CityType.kTown] = "WarScene/townfriend.png",
	[CityType.kThief] = "WarScene/townfriend.png",
}

function This:initNode()
	self.m_csNode = cc.Node:createFromCSFile("GameScene/NodeUI/WorldMap.csb")
	self:addChild(self.m_csNode)
	self.m_csNode:setToCenter()
	self.m_initBtnPosX = self.m_csNode.influence:getPositionX()
	self.m_initBtnPosY = self.m_csNode.influence:getPositionY()
	self.m_csNode.influence.button:setVisible(false)
	self:initMap()
end

function This:initTouchEvent()
	self.m_csNode.close:setTouchEnded(function()
		self:close()
	end)
	self.m_csNode.close:setLocalZOrder(100)
	local isOpen = true
	
	self.m_csNode.influence.button:setTouch({
		onEnded = function()
			self:openScrollList(true)
		end,
		isDynamic = true
	})

	self.m_csNode.influence.fangxiang:setTouch({
		onEnded = function()
			self:openScrollList(false)
		end,
		isDynamic = true
	})

	self.m_csNode.smallmap:setTouch({
		onEnded = function(_,touch)
			self:focusePoint(touch.x,touch.y)
		end,
		isScale = false,
		isAlpha = false
	})
end

-- function This:getForceList()
-- 	local list = {}
-- 	local tmp = {}

-- 	local function func(role)
-- 		local identity = role:getIdentity()
-- 		if identity == RelationType.kJun then
-- 			local t = {role:getId()}
-- 			local col = role:getColleague()
-- 			for i , colId in ipairs(col) do
-- 				table.insert(t,colId)
-- 				tmp[colId] = true
-- 			end
-- 			table.insert(list,t)
-- 			return true
-- 		elseif identity == RelationType.kTongMeng then
-- 			table.insert(list,{role:getId(),role:getAlly()})
-- 			tmp[role:getAlly()] = true
-- 			return true
-- 		elseif identity <= 0 then
-- 			table.insert(list,{role:getId()})
-- 			return true
-- 		end
-- 	end

-- 	local mainRole = WorldMapManager:getRole(GamePlayer:getPlayerID())
-- 	func(mainRole)

-- 	local roles = WorldMapManager:getAllRole()
-- 	for id , role in pairs(roles) do
-- 		if id ~= GamePlayer:getPlayerID() and not tmp[id] then
-- 			if func(role) then
-- 				tmp[id] = true
-- 			end
-- 		end
-- 	end
-- 	return list
-- end

function This:initMap()
	local w = 150
	local itemHeight = 30
	local function getBg(itemNum)
		local node = cc.Node:create()
		local h = itemNum * (itemHeight+2)
		node:setContentSize(w,h)
		if itemNum > 1 then
			local sprite = cc.Scale9Sprite:create("WarScene/townchoose.png",cc.Rect(6,6,6,6))
			sprite:setContentSize(w,h)
			sprite:setPosition(w/2-2,h/2-6)
			node:addChild(sprite)	
		end
		return node	
	end

	local function initItem(id,itemNode)
		local role = WorldMapManager:getRole(id)
		local w , h = itemNode.choose:getContentSize()
		local scalex , scaley = itemNode.choose:getScale()
		w , h = w * scalex , h * scaley
		itemNode:setContentSize(w,h)
		itemNode.name:setString(role:getName())
		itemNode.choose:setVisible(false)
		local str = string.format(RoleIndexFlag,role:getIndex())
		itemNode.color:setImage(str)
		itemNode:setTouch({
			onEnded = function()
				self:onSelectItem(id, itemNode)
			end,
			isContainer = true,
			isScale = false,
			isSwallow = false,
		})

	end

	local forceList = WorldMapManager:getForceList()
	for i , force in ipairs(forceList) do
		local node = getBg(#force)
		local h = 25
		for j , id in ipairs(force) do
			local itemNode = cc.Node:createFromCSFile("GameScene/NodeUI/WorldMapItem.csb")
			initItem(id,itemNode)
			itemNode:setPositionY(h * (j-1) + 2)
			node:addChild(itemNode)

			--[[local w1 , h1 = node:getContentSize()
			local layer = cc.LayerColor:create(cc.Color(255,255,0,64))
			layer:setContentSize(w1,h1)
			node:addChild(layer)]]
		end

		node:setAnchorPoint(0.5,0.5)
		local nodeW , nodeH = node:getContentSize()
		self.m_csNode.influence.listview:pushBackCustomItem(node,nodeW,nodeH,0.5)
	end

	local function getCityNode(city) 
		local ownerId = city:getOwnerId()
		local index = 0
		local cityType = city:getType()
		local role = nil
		if ownerId > 0 then
			role = WorldMapManager:getRole(ownerId)
			index = role:getIndex()
		end

		local str = string.format(CityIndexFlag[cityType],index)
		local sprite = cc.Sprite:create(str)
		local w , h = sprite:getContentSize()

		local bgstr = ""
		if GamePlayer:getPlayerID() == ownerId then
			bgstr = CitySelfFlag[cityType]
		elseif role and role:getRelationWithMe() > 0 then
			bgstr = CityFriendFlag[cityType]
		else
			bgstr = CityEnemyFlag[cityType]
		end
		local bg = cc.Sprite:create(bgstr)
		bg:setPosition(w/2,h/2)
		sprite:addChild(bg)

		if city:getState() ~= CityState.kInFighting then
			local selectSprite = cc.Sprite:create(CitySelectFlag[cityType])
			selectSprite:setPosition(w/2,h/2)
			selectSprite:setVisible(false)
			sprite:addChild(selectSprite)
			sprite.selectSprite = selectSprite
		else
			local fightFlag = cc.Sprite:create("GameScene/fight.png")
			fightFlag:setPosition(w/2,h/2)
			sprite:addChild(fightFlag)
		end
		return sprite
	end

	self.m_cityNodes = {}
	local citys = WorldMapManager:getAllCity()
	for id, city in pairs(citys) do
		local addDian = not city:isHide()
		if addDian and city:isHanXianDi() and not WorldMapManager:getTypeIsHave(SingleManagerSaveState.kWorldMapHanXianDi) then
			addDian = false
		end
		if addDian then
			local node = getCityNode(city)
			node:setScale(1)
			local fx , fy = g_scene:getPositionRatio(id)
			local w, h = self.m_csNode.smallmap:getContentSize()
			node:setPosition(fx * w, fy * h*1.1-20)
			self.m_csNode.smallmap:addChild(node)
			self.m_cityNodes[id] = node
			if city:hasTreasureBox() then
				local eff = GameUtil:createEffect("LiangDian",true)
				local x , y = node:getPosition()
				eff:setPosition(x,y)
				self.m_csNode.smallmap:addChild(eff)
			end
		end
	end
	local boundbox = self.m_csNode.smallmap:getBoundingBox()
	local w , h = self.m_csNode.diban:getContentSize()
	local drawNode = cc.DrawNode:create()
	local x , y = self.m_csNode.smallmap:getPosition()
	local scale = self.m_csNode:getScale()
	drawNode:drawSolidRect(cc.Rect(x,y,w,h))
	
	local clippingNode = cc.ClippingNode:create(drawNode)
	self.m_csNode.influence:switchParent(clippingNode)
	clippingNode:setAnchorPoint(0,0)
	self.m_csNode:addChild(clippingNode)

	self.m_rectW , self.m_rectH = 150,100
	self.m_rectNode = cc.DrawNode:create()
	self.m_csNode.smallmap:addChild(self.m_rectNode)
	self.m_rectNode:drawRect(cc.Rect(0,0,self.m_rectW,self.m_rectH),cc.Color(255,255,0,255))
	local dx , dy = g_scene:getViewportCenterRatio()
	self.m_rectNode:setPosition(w * dx - self.m_rectW/2,h * dy - self.m_rectH/2)
end

function This:selectRoleCity(roleId)
	if self.m_selectRole then
		local cityList = self.m_selectRole:getCitys()
		for i , cityId in ipairs(cityList) do
			local itemNode = self.m_cityNodes[cityId]
			itemNode:setScale(1)
			if itemNode.selectSprite then
				itemNode.selectSprite:setVisible(false)
			end
		end
	end
	local role = WorldMapManager:getRole(roleId)
	local cityList = role:getCitys()
	local count = 0
	local x , y = 0, 0
	for i , cityId in pairs(cityList) do
		local itemNode = self.m_cityNodes[cityId]
		itemNode:setScale(1.2)
		if itemNode.selectSprite then
			itemNode.selectSprite:setVisible(true)
		end
		x = x + itemNode:getPositionX()
		y = y + itemNode:getPositionY()
		count = count + 1
	end
	if count > 0 then
		x = x / count
		y = y / count
		self:focusePoint(x,y,true)
	end
	self.m_selectRole = role
end

function This:onSelectItem(id,itemNode)
	if self.m_selectItem then
		self.m_selectItem.choose:setVisible(false)
	end
	itemNode.choose:setVisible(true)
	self:selectRoleCity(id)
	self.m_selectItem = itemNode
end

function This:openScrollList(isOpen)
	if not isOpen then
		-- local move = cc.MoveTo(0.3,self.m_initBtnPosX + 130,self.m_initBtnPosY,"SineInOut")
		local move = cc.MoveTo(0.3,self.m_initBtnPosX + 170,self.m_initBtnPosY,"SineInOut")
		self.m_csNode.influence:runAction(cc.Sequence(move,cc.CallFunc(function()
			self.m_csNode.influence.button:setVisible(true)
			self.m_csNode.influence.fangxiang:setVisible(false)
			self.m_csNode.influence.bg:setVisible(false)
			self.m_csNode.influence.listview:setVisible(false)
			--self.m_csNode.influence.listview:setTouchEnabled(false)
		end)))
	else
		local move = cc.MoveTo(0.3,self.m_initBtnPosX ,self.m_initBtnPosY,"SineInOut")
		self.m_csNode.influence:runAction(cc.Sequence(move,cc.CallFunc(function()
			self.m_csNode.influence.button:setVisible(false)
			self.m_csNode.influence.fangxiang:setVisible(true)
			self.m_csNode.influence.bg:setVisible(true)
			self.m_csNode.influence.listview:setVisible(true)
			--self.m_csNode.influence.listview:setTouchEnabled(true)
		end)))
	end
end

function This:focusePoint(x,y,isInMapSpace)
	if not isInMapSpace then
		x , y = self.m_csNode.smallmap:convertToNodeSpace(x,y)
	end
	local mapW , mapH = self.m_csNode.smallmap:getContentSize()
	x = x- self.m_rectW / 2
	y = y - self.m_rectH / 2
	x = math.min(math.max(0,x),mapW - self.m_rectW)
	y = math.min(math.max(0,y),mapH - self.m_rectH)
	self.m_rectNode:setPosition(x,y)
	g_scene:focusePoint((x + self.m_rectW / 2)/mapW,(y + self.m_rectH / 2)/mapH)
end

--endregion
