
--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This , super = class(...,"LoadingScene")
local TouchAllListener = require("cc.TouchAllListener")
local SlideScaleContaner = require("Action.SlideScaleContaner")
local CityView = require("World.CityView")
local Vec = require("Vec")
local AsynchEvent = require("Event.AsynchEvent")
local GameEvent = require("Event.GameEvent")
local IterateEvent = require("Event.IterateEvent")
local WorldMapManager = require("World.WorldMapManager")
local WorldUI = require("World.WorldUI")
local CityUI = require("World.CityUI")
local Path = require("World.Path")
local MarchArmyView = require("World.MarchArmyView")
local MarchArmyPathView = require("World.MarchArmyPathView")
local ReportManager = require("Report.ReportManager")
local GamePlayer = require("Player.GamePlayer")
local CityConfig = require("Metadatas.CityConfig")
local GuideManager = require("Guide.GuideManager")
local EventDispatcher = require("EventDispatcher")
local AchieveManager = require("Achieve.AchieveManager")
local GuideManager = require("Guide.GuideManager")
local GameSetting = require("GameSetting")
local GameUtil = require("Util.GameUtil")
local CityConfig = require("Metadatas.CityConfig")
local CityHidedView = require("World.CityHidedView")
local CityHanXianDiView = require("World.CityHanXianDiView")
local PopDialogManager = require("UI.PopDialogManager")

local kMaxCityNum = #CityConfig

ShowMode =
{
	kNormal = 1, --正常模式
	kSelect = 2, --选择模式
	kBuild = 3, --建筑
}

MapZorder =
{
	kMarchArmyZorder = 1,
	kCityViewZorder = 2,
	kPaoMa = 500,
	kMenuZorder = 601,
	kCloudZorder = 602,
	kGuideZorder = 603,
	kTopZorder = 604,
}

local InitState =
{
	kMapDataRequest = 1, --请求数据
	kAchieveDataRequest = 2, --地图数据请求
	kInitMapLayer = 3, --初始化地图层
	kInitUILayer = 4, --初始化UI层
	kInitCityView = 5, --初始化城市view
	kInitMarchArmyPath = 6, --初始化行军路线
	kInitWorldBox = 7, --初始化世界宝箱
	kInitWorldCloud = 8, --初始化云层
	kInitAction = 9, --初始化action
	kInitFinish = 10
}

function This:init(info)
	super.init(self)
	self:setType(SceneType.kWorldScene)
	self.m_isInit = false
	self.m_cityView = {}
	self.m_marchPath = {}
	self.m_paomaEffects = {}
	self.m_mode = ShowMode.kNormal
	if info then
		self.m_focuseCityId = info.focuseCityId
		self.m_initHandler = info.initHandler
	end
	self:initTask()
end

function This:onEnter()
	super.onEnter(self)
	cc.Application:addListener(self)
	WorldMapManager:addObserver(self)
	ReportManager:addObserver(self)
	GuideManager:addObserver(self)
end

function This:onExit()
	super.onExit(self)
	cc.Application:removeListener(self)
	WorldMapManager:removeObserver(self)
	ReportManager:removeObserver(self)
	GuideManager:removeObserver(self)
	EventDispatcher:dispatcher("world_scene_exit")
	GuideManager:cancelAncGuider()
end

function This:loadFinish()
	super.loadFinish(self)

	local function handler()
		self.m_isInit = true
		self.m_isTouchOnView = false
		self.m_worldUI:initAction()
		self:initTouchListener()
		if not self.m_focuseCityId then
			self.m_focuseCityId = WorldMapManager:getMainCityId()
		end
		self:focuseCity(self.m_focuseCityId)
		if self.m_initHandler then
			self.m_initHandler()
		end
		self:checkDelayDialog()
		self.m_slideScaleContaner:setTouchEnable(true)
		self.m_worldUI:setVisible(true)
		if self.m_dramaNode then
			self.m_dramaNode:removeFromParent()
			self.m_dramaNode = nil
		end	
		self.m_mode = ShowMode.kNormal
		self:unlockTouch()
		EventDispatcher:dispatcher("world_scene_enter")
	end
	self:lockTouchWithoutWaiting()

	local key = GameUtil:int64ToString(GamePlayer:getPlayerID()) .. "_enter"
	local bEnter = GameSetting:get(key)
	if WorldMapManager:getMapType() <= 0 and not bEnter then
		self.m_slideScaleContaner:setTouchEnable(false)
		self.m_worldUI:setVisible(false)
		self.m_dramaNode = cc.Node:createFromCSFile("Common/NodeUI/Preface.csb")
		for i = 1 , 6 do
			self.m_dramaNode[i]:recoveryToFixedWidth("right")
		end
		self.m_dramaNode.ef1:recoveryToFixedWidth("right")
		self.m_dramaNode.ef2:recoveryToFixedWidth("right")

		self.m_dramaNode:playCSAnimation(nil,false)
		self:initShowDrama(handler)
		self.m_dramaNode:setPosition(cc.visible.center.x,cc.visible.center.y)
		self:addChild(self.m_dramaNode)

		

		cc.Audio:playEffect("Cg.mp3",false)
		GameSetting:set(key,true)
	else
		handler()
	end
end

function This:initShowDrama(finishHandler)
	local cityList = {
		{id = 9, bMove = false, bScale = false, scale = 0.4},
		{id = 33, bMove = true, bScale = true,scale = 1.0}
	}

	local index = 1
	local function scaleHandler(id,sc,handler)
		local view = self:getCityNode(id)
		local x , y = view:getPosition()
		local w , h = self.m_mapLayer:getContentSize()
		local x1 , y1 = self.m_mapLayer:getPosition()
		local s1 = self.m_mapLayer:getScale()

		local sw = math.max(x / w , (w - x) / w)
		local sh = math.max(y / h , (h - y) / h)
		local scale = math.max( math.max(sw,sh), sc)
		local tx = x1 + (s1-scale) * x
		local ty = y1 + (s1-scale) * y
		self.m_mapLayer:runAction(cc.Sequence(cc.Spawn(
				cc.MoveTo(3,tx,ty),
				cc.ScaleTo(3,scale)
			),
			cc.CallFunc(function()
				handler()
			end)
		))
	end
	local function moveHandler()
		if index <= #cityList then
			local info = cityList[index]
			self:focuseToCity({
				cityId = info.id,
				handler = function()
					index = index + 1
					if info.bScale then
						scaleHandler(info.id,info.scale,moveHandler)
					else
						moveHandler()
					end
				end,
				bAction = info.bMove,
				time = 9
			})
		else
			self.m_timer:setTimer(0.5,finishHandler,"drama_finish")
		end
	end
	self.m_mapLayer:setScale(0.7)
	moveHandler()
end

function This:isInit()
	return self.m_isInit
end

function This:initTouchListener()
	
end

function This:onKeyDown(keyCode)
    print(keyCode)
    if keyCode == "F1" then
        --g_scene:openDialog("Match.MatchSettlePanel")
		--ChatManager:onSendGmRequest("add_exp 1000")
		local count = collectgarbage("count")
		print("垃圾收集:",count)
		collectgarbage("collect")

		local num = 0 
		for key , value in pairs(g_weakTable) do
			if value[0] == 0 then
				print(string.format("key = %s, value = %s , [0] = %s, _NAME = %s, name = %s", tostring(key), tostring(value), tostring(value[0]) , tostring(value._NAME), tostring(value.name)))
				num = num + 1
			end
		end
		print("--------------------------------------------")
		for value , _ in pairs(EventDispatcher.m_listeners) do
			if value[0] == 0 then
				print(string.format("key = %s, value = %s , [0] = %s, name = %s", tostring(key), tostring(value), tostring(value[0]) , tostring(value._NAME)))
			end
		end

		print("--------------------------------------------------------")
		local manager = {
			["HeroManager"] = require("Hero.HeroManager"),
			["HeroListManager"] = require("List.HeroListManager"),
			["DepotManager"] = require("Depot.DepotManager"),
			["PlanShopManager"] = require("PlanShop.PlanShopManager")
		}

		for name , mgr in pairs(manager) do
			local observers = mgr.m_observers
			print("name = ", name)
			for key , value in pairs(observers) do
				if value[0] == 0 then
					print(string.format("key = %s, value = %s , [0] = %s, name = %s", tostring(key), tostring(value), tostring(value[0]) , tostring(value._NAME)))
				end
			end
		end

		print("num = ", num)
		local count = collectgarbage("count")
		print("垃圾收集:",count)
		collectgarbage("collect")
	elseif keyCode == "F2" then
		-- local curTime = GamePlayer:getServerTime()
		-- EventDispatcher:dispatcher(11131,{fight_time = curTime + 600})
		local MenuBtnHelper = require("Home.MenuBtnHelper")
        MenuBtnHelper:forceOpen(8)
	end
end

function This:initTask()
	self.m_initState = InitState.kMapDataRequest

	if not WorldMapManager:isInit() then
		self:addTask(AsynchEvent:create(function()
			self.m_initState = InitState.kMapDataRequest
			WorldMapManager:onGetMapInfoRequest()
		end,11100))
	end

	task = AsynchEvent:create(function()
		self.m_initState = InitState.kAchieveDataRequest
		AchieveManager:onGetAchieveInfoRequest()
	end,11900,nil,2)
	self:addTask(task)

	task = GameEvent:create(function()
		self.m_initState = InitState.kInitMapLayer
		self:initNode()
	end)
	self:addTask(task)

	task = GameEvent:create(function()
		self.m_initState = InitState.kInitUILayer
		self:initUI()
	end)
	self:addTask(task)

	for i = 1 , kMaxCityNum , 3 do
		self:addTask(GameEvent:create(function()
			self.m_initState = InitState.kInitCityView
			for j = i , i + 2 do
				if j <= kMaxCityNum then
					self:addCityView(j)
				end
			end
		end))
	end

	task = GameEvent:create(function()
		self.m_initState = InitState.kInitMarchArmyPath
		self:initMarchArmyPath()
	end)
	self:addTask(task)

	task = GameEvent:create(function()
		self.m_initState = InitState.kInitWorldBox
		self:initWorldBox()
	end)
	self:addTask(task)

	task = GameEvent:create(function()
		self.m_initState = InitState.kInitWorldCloud
		self:initCloud()
	end)
	self:addTask(task)

	task = GameEvent:create(function()
		self.m_initState = InitState.kInitAction
		self:initAction()
	end)
	self:addTask(task)

	task = GameEvent:create(function()
		self.m_initState = InitState.kInitFinish
		local count = collectgarbage("count")
		collectgarbage("collect")
		print("垃圾收集 ",count)
	end)
	self:addTask(task)
end

function This:initNode()
	local size = {width = 4684, height = 2845}
	self.m_mapLayer = cc.Node:createFromCSFile("WarScene/NodeUI/WarScene.csb")
	self.m_mapLayer:setName("mapLayer")
	self.m_mapLayer:setContentSize(size.width,size.height)
	self.m_mapLayer:setPosition((cc.visible.width - size.width) / 2,(cc.visible.height - size.height) / 2)
	self.m_mapLayer:setTouch({
		onMoved = function()
			if g_scene:getName() == "WorldScene" then
				self:onTouchView()	
			end
		end,
		onEnded = function()
			if g_scene:getName() == "WorldScene" then
				self:onTouchView()
			end
		end,
		isSwallow = false,
		isScale = false,
		isAlpha = false,
		name = "worldscene_maplayer",
	})
	self:addChild(self.m_mapLayer)
end

function This:initAction()
	local width , height = self.m_mapLayer:getContentSize()
	self.m_slideScaleContaner = SlideScaleContaner:create({
		node = self.m_mapLayer,
		maxWidth = 	width,
		maxHeight = height,
		minWidth = cc.visible.width,
		minHeight = cc.visible.height,
		scale = 0.9
	})
	self.m_slideScaleContaner:setSlideHandler(function(newx,newy)
		local w , h = self.m_mapLayer:getContentSize()
		local x , y = self.m_mapLayer:getPosition()
		local scale = self.m_mapLayer:getScale()
		w = w * scale 
		h = h * scale
		x , y = cc.visible.center.x - x , cc.visible.center.y - y
		self.m_worldUI:updateMiniMap(x / w, y / h)
	end)
end

function This:initUI()
	self.m_worldUI = WorldUI:create()
	self:addChild(self.m_worldUI)
end

function This:initMarchArmyPath()
	local marchArmyList = WorldMapManager:getAllMarchArmy()
	for i , army in pairs(marchArmyList) do
		self:addMarchArmyPath(army)
	end
end

function This:initWorldBox()
	local box = WorldMapManager:getBox()
	if box and box:isExist() and not box:isUpdating() then
		local view = self.m_cityView[box:getCityId()]
		view:showWorldBox(true)
	end
end
 
function This:initCloud()
	local mapType = WorldMapManager:getMapType()
	if mapType <= 1  then
		if mapType == 0 then
			self.m_cloudLayer = cc.Node:createFromCSFile("Common/NodeUI/GuideZheZhao.csb")
		else
			self.m_cloudLayer = cc.Node:createFromCSFile("GameScene/NodeUI/BattleZheZhao.csb")
		end
		self.m_mapLayer:addChild(self.m_cloudLayer,MapZorder.kCloudZorder)
		for i = 1 , kMaxCityNum do
			local city = WorldMapManager:getCity(i)
			if not city:isVisibleInGuide() then
				self:getCityNode(i):setVisible(false)
			end
		end
	end
end

-------------------------------------------------

function This:addCityView(index)
	local city = self:createCityView(index)
	city:setSelectHandler(function(view)
		self:onTouchView(view)
	end)

	local cityNode = self.m_mapLayer[tostring(index)]
	cityNode:addChild(city)
	cityNode:setLocalZOrder(MapZorder.kCityViewZorder + index)
	self.m_cityView[index] = city
	local cy = WorldMapManager:getCity(index)
	cityNode:setVisible(not cy:isHide())
end

function This:createCityView(id)
	local config = CityConfig[id]
	if config.type == CityType.kThief then
		if WorldMapManager:isHanXianDi(id) then
			return CityHanXianDiView:create(id)
		end
		return CityHidedView:create(id)
	else
		return CityView:create(id)
	end
end

function This:getCityNode(index)
	if not self.m_mapLayer then
		return
	end
	return self.m_mapLayer[tostring(index)]
end

function This:getCityView(cityId)
	return self.m_cityView[cityId]
end

function This:getShowMode()
	return self.m_mode
end

function This:getUi()
	return self.m_worldUI
end

function This:focuseToCity(info)
	local cityId = info.cityId
	self.m_mapLayer:stopAllActions()

	local node = self.m_mapLayer[tostring(cityId)]
	local x , y = node:convertToWorldSpace(0,0)
	local dx , dy = cc.visible.center.x - x , cc.visible.center.y - y
	local lx , ly = self.m_mapLayer:getPosition()
	local boundRect = self.m_mapLayer:getBoundingBox()

	local maxx = 0
	local minx = cc.visible.width - boundRect.width

	if lx + dx > maxx then
		dx = maxx - lx
	elseif lx + dx < minx then
		dx = minx - lx
	end

	local maxy = 0
	local miny = cc.visible.height - boundRect.height

	if ly + dy > maxy then
		dy = maxy - ly
	elseif ly + dy < miny then
		dy = miny - ly
	end

	local x , y = self.m_mapLayer:getPosition()
	
	if not info.bAction then
		self.m_mapLayer:setPosition(x + dx, y + dy)
		if info.handler then
			info.handler()
		end
		local rx , ry = self:getPositionRatio(cityId)
		self.m_worldUI:updateMiniMap(rx, ry)
	else
		self.m_mapLayer:runAction(cc.Sequence(
			cc.MoveTo(info.time or 0.3, x + dx, y + dy, info.actionName or "SineIn"),
			cc.CallFunc(function()
				if info.handler then
					info.handler()
				end
				local rx , ry = self:getPositionRatio(cityId)
				self.m_worldUI:updateMiniMap(rx, ry)
			end))
		)
	end	
end

function This:focuseCity(cityId,handler,bAction)
	self:focuseToCity({
		cityId = cityId,
		bAction = bAction,
		handler = handler
	})
end

function This:focusePoint(ratiox,ratioy)
	local w , h = self.m_mapLayer:getContentSize()
	local x , y = self.m_mapLayer:getPosition()
	local scale = self.m_mapLayer:getScale()
	w = w * scale 
	h = h * scale

	local dx , dy = cc.visible.center.x - (w * ratiox+x) , cc.visible.center.y - (h * ratioy+y)
	x = math.min(0,math.max(cc.visible.width - w,dx + x))
	y = math.min(0,math.max(cc.visible.height - h,dy + y))
	self.m_mapLayer:setPosition(x,y)
	self.m_worldUI:updateMiniMap(ratiox, ratioy)
end

function This:onTouchView(view)
	if self.m_mode == ShowMode.kNormal then
		if view then
			local city = view:getModel()
			if GuideManager:isInGuide() and not city:isVisibleInGuide() then
				return
			end

			if city:getState() == CityState.kInFighting and city:getReportId() > 0 then
				cc.SceneManager:switchTo("World.WorldLoadingScene",nil,city:getCityId())
			else
				if self.m_curCity then
					self.m_curCity:setSelect(false)
				end
				view:setSelect(true)
				self.m_curCity = view
				self.m_isTouchOnView = true
			end
		else
			if not self.m_isTouchOnView and self.m_curCity then
				self.m_curCity:setSelect(false)
				self.m_curCity = nil
			end
			self.m_isTouchOnView = false
		end
	elseif view and self.m_mode == ShowMode.kSelect then
		local toCity = view:getModel()
		if GuideManager:isInGuide() and not toCity:isVisibleInGuide() then
			return
		end

		if self.m_selectCity[toCity:getCityId()] then
			local info = {fromCity = self.m_fromCity, toCity = toCity,army = self.m_armyGobattle}
			if self.m_isGotoFight then
				if self.m_fromCity:isMy() then
					self:openDialog("World.TroopEmbattlePanel",info)
				else
					self:openDialog("World.ArmyEmbattlePanel",info)
				end
			else
				if not toCity:isMy() then
					g_scene:showTips(Serialize[64962])
					return
				end
				self:openDialog("World.TroopHpTransPanel",info)
			end
		else
			if toCity:isProtected() then
				g_scene:showTips(Serialize[64963])
			else
				g_scene:showTips(Serialize[61801])
			end
		end
	end
end

function This:selectCity(cityId)
	if self.m_curCity then
		self.m_curCity:setSelect(false)
	end
	local view = self:getCityView(cityId)
	view:setSelect(true)
	self.m_curCity = view
end

function This:getMapLayer()
	return self.m_mapLayer
end

function This:getPositionRatio(id)
	local cityNode = self:getCityNode(id)
	local x ,y = cityNode:getPosition()
	local w , h = self.m_mapLayer:getContentSize()
	return x / w , y / h
end

function This:getViewportCenterRatio()
	local x , y = self.m_mapLayer:getPosition()
	local fx , fy = cc.visible.center.x - x , cc.visible.center.y - y
	local w , h = self.m_mapLayer:getContentSize()
	local scale = self.m_mapLayer:getScale()
	w = w * scale 
	h = h * scale
	return fx / w, fy / h
end

function This:addMenuAtMapLayer(node)
	if node then
		self.m_mapLayer:addChild(node,MapZorder.kMenuZorder)
		self.m_menu = node
	else
		self.m_menu = nil
	end
end

function This:enterSelectMode(city,isGoFight,armyGobattle)
	self.m_mode = ShowMode.kSelect
	self.m_fromCity = city
	self.m_armyGobattle = armyGobattle
	self.m_worldUI:refreshModelVisible()
	self.m_isGotoFight = isGoFight
	self.m_selectCity = Path:getAroundCity(city,isGoFight)
	for i , city in pairs(self.m_selectCity) do
		local view = self.m_cityView[city:getCityId()]
		view:showSelectAnimation(true)
	end
end

function This:exitSelectMode()
	if self.m_mode == ShowMode.kSelect then
		for i , city in pairs(self.m_selectCity) do
			local view = self.m_cityView[city:getCityId()]
			view:showSelectAnimation(false)
		end
		self.m_mode = ShowMode.kNormal
		self.m_fromCity = nil
		self.m_isGotoFight = nil
		self.m_worldUI:refreshModelVisible()
	end
end

function This:addMarchArmyPath(army)
	if not self.m_mapLayer or not army:isVisible() then
		return
	end
	local view = MarchArmyPathView:create(army)
	local cityView = self:getCityNode(army:getFromCity())
	local x , y = cityView:getPosition()
	view:setPosition(x,y)
	self.m_mapLayer:addChild(view)
	self.m_marchPath[army:getId()] = view
	view:setLocalZOrder(MapZorder.kMarchArmyZorder)
end

function This:removeMarchArmyPath(army)
	if army:isVisible() then
		local view = self.m_marchPath[army:getId()]
		if view then
			view:stopUpdate()
			view:removeFromParent()
			self:removeMarchPaoMaEffect(army)
			self.m_marchPath[army:getId()] = nil
		end
	end
end

function This:addMarchPaoMaEffect(effect,army)
	self.m_mapLayer:addChild(effect,MapZorder.kPaoMa)
	self.m_paomaEffects[army:getId()] = effect
end

function This:removeMarchPaoMaEffect(army)
	local id = army:getId()
	local view = self.m_paomaEffects[id]
	if view then
		view:removeFromParent()
		self.m_paomaEffects[id] = nil
	end
end

function This:getMarchPaoMaEffect(army)
	return self.m_paomaEffects[army:getId()]
end

function This:enterBuildMode(city)
	self.m_mode = ShowMode.kBuild
	self.m_slideScaleContaner:setTouchEnable(false)
	self.m_worldUI:showCityUI(city)
end

function This:exitBuildMode()
	self.m_mode = ShowMode.kNormal
	self.m_slideScaleContaner:setTouchEnable(true)
	self.m_worldUI:showCityUI(nil)
end

function This:refreshCityView(cityId)
	local view = self.m_cityView[cityId]
	if view then
		view:refresh()
	end
end

function This:setUIVisible(isVisible)
	if self.m_worldUI then
		self.m_worldUI:setUIVisible(isVisible)
	end
end

function This:stopMove()
	self.m_mapLayer:stopAllActions()
end

-----------------------------------------------------

function This:onInvestigateCity(city)
	self:refreshCityView(city:getCityId())
end

function This:onGetCityInfo(city)
	self:enterBuildMode(city)
end

function This:onResChanged(msg)
	for i , cityId in ipairs(msg.city_id) do
		self:refreshCityView(cityId)
	end
end

function This:onCityInfoChanged(city)
	print( string.format("onCityInfoChanged:%d",city:getCityId()))
	self:refreshCityView(city:getCityId())
end

function This:onAddMarchArmy(army)
	if self.m_initState < InitState.kInitMarchArmyPath or not army:isVisible() then
		return
	end

	self:addMarchArmyPath(army)
	local cityId = army:getFromCity()
	self:refreshCityView(cityId)

	if army:getOwnerId() == GamePlayer:getPlayerID() and self.m_mode == ShowMode.kSelect then
		self:exitSelectMode()
	end
end

function This:onUpdateMarchArmy(army)
	local id = army:getId()
	if not self.m_marchPath[id] then
		self:addMarchArmyPath(army)
	else
		self.m_marchPath[id]:refresh()
	end
end

function This:onRemoveMarchArmy(army)
	if self.m_initState >= InitState.kInitMarchArmyPath then
		self:removeMarchArmyPath(army)
		local toCity = army:getToCity()
		self:refreshCityView(toCity)
	end
end

function This:onAddHeroHp(city)
	self:refreshCityView(city:getCityId())
end

function This:onResChanged(city)
	self:refreshCityView(city:getCityId())
end

function This:onFightTimeStart()
	for i , view in pairs(self.m_cityView) do
		view:refreshState()
	end
end

function This:onRelationChanged(targetId,sourceId)
	local roleId = (GamePlayer:getPlayerID() == targetId) and sourceId or targetId
	local role = WorldMapManager:getRole(roleId)

	local cityList = role:getCitys()
	for i , cityId in ipairs(cityList) do
		self:refreshCityView(cityId)
	end
end

function This:onCityLvChanged(city)
	self:refreshCityView(city:getCityId())
end

function This:onMapRoleEnter(role)
	local cityList = role:getCitys()
	for i , cityId in ipairs(cityList) do
		self:refreshCityView(cityId)
	end
end

function This:onJiCeUseTimeChanged(stg)
	local cityList = stg:getCityList()
	for i , cityId in ipairs(cityList) do
		local cityView = self:getCityView(cityId)
		if cityView then
			cityView:refreshStgHoldTime()
		end
	end
end

function This:onMapRoleChanged(role)
	local citys = role:getCitys()
	for i , cityId in pairs(citys) do
		local cityView = self:getCityView(cityId)
		if cityView then
			cityView:refreshMainCityEffect()
		end
	end
end

function This:onWorldBoxUpdateEnd(box)
	local view = self.m_cityView[box:getCityId()]
	if view then
		view:showWorldBox(true)
	end
end

function This:onRewardWorldBox(box)
	local view = self.m_cityView[box:getCityId()]
	if view then
		view:showWorldBox(false)
	end
end

function This:onGuideStepFinish(step)
	if not GuideManager:isInGuide() and self.m_cloudLayer then
		self.m_cloudLayer:removeFromParent()
		self.m_cloudLayer = nil
		for i = 1 , kMaxCityNum do
			self:getCityNode(i):setVisible(true)
		end
	end
end

function This:onCityAppear(city)
	local cityId = city:getId()
	local node = self:getCityNode(cityId)
	node:setVisible(true)
end

function This:onCityDisappear(city)
	local cityId = city:getId()
	local node = self:getCityNode(cityId)
	node:setVisible(false)
end

function This:refreshBtnHelp()
	if self.m_worldUI then
		self.m_worldUI:refreshBtnHelp()
	end
end

function This:onKillHanXianDiInfo()
	local allRolesList = WorldMapManager:getAllRole()
	for _,roleData in pairs(allRolesList) do
		local mainCity = roleData:getMainCity()
		self:refreshCityView(mainCity)
	end
	self:refreshCityView(kHanXianDi)
end

function This:onOpenTreasureBox(box)
	local cityId = box:getCityId()
	self:refreshCityView(cityId)
end

function This:update(dt)
	super.update(self,dt)
	if self.m_isInit then
		self.m_slideScaleContaner:update(dt)
	end
end


--endregion
