--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local This, super = class(...,"Home.HomeUI")
local WorldMapManager = require("World.WorldMapManager")
local CityUI = require("World.CityUI")
local MarchArmyView = require("World.MarchArmyView")
local GamePlayer = require("Player.GamePlayer")
local BattleDataManager = require("Battle.BattleDataManager")
local GameUtil = require("Util.GameUtil")
local MarchDangerView = require("World.MarchDangerView")
local ReportManager = require("Report.ReportManager")
local GuideManager = require("Guide.GuideManager")
local AchieveManager = require("Achieve.AchieveManager")
local MatchManager = require("Match.MatchManager")
local EventDispatcher = require("EventDispatcher")
local ViewUtil = require("UI.ViewUtil")
local ChapterGuideView = require("World.ChapterGuideView")
local MenuBtnHelper = require("Home.MenuBtnHelper")
local PrivilegeManager = require("Vip.PrivilegeManager")
local ItemUtil = require("Bag.ItemUtil")
local VoiceChatManager = require("VoiceChat")
local TerrBuildingJiaoChang = require("Territory.TerrBuildingJiaoChang")

function This:initUI()
	self.m_scene = g_scene
	self.m_csNode = cc.Node:createFromCSFile("GameScene/NodeUI/BulidMain.csb")
	self:fixScreen()

	self.m_btnHelper = MenuBtnHelper:create(self)
	self:addChild(self.m_csNode)

	self.m_csNode.cityres:setVisible(false)
	self.m_csNode.selectcity:setVisible(false)
	self.m_csNode.res_info.foodtxt:setVisible(false)
	self.m_csNode.res_info.coppertxt:setVisible(false)
	self.m_csNode.smallmap.voice.icon2:setVisible(false)
	self.m_btnHelper:refresh(true)

	self.m_cityNodes = {}
	self.m_cityEffect = {}
	self.m_isInVoiceRoom = false
end

function This:refreshBtnHelp()
	if self.m_btnHelper then
		self.m_btnHelper:refresh()
	end
end

function This:fixScreen()
	if self.m_csNode.huodong then
		self.m_csNode.huodong:recoveryToFixedWidth("right","top")
	end
	self.m_csNode.panel_btns:recoveryToFixedWidth("right","bottom")
	self.m_csNode.smallmap:recoveryToFixedWidth("right","top")
	self.m_csNode.dingbg:recoveryToFixedWidth("left","top")
	self.m_csNode.player_info:recoveryToFixedWidth("left","top")
	self.m_csNode.res_info:recoveryToFixedWidth("left","top")
	self.m_csNode.chat_node:recoveryToFixedWidth("left","bottom")
	self.m_csNode.Dangerous:recoveryToFixedWidth("right","top")
	self.m_csNode.close_bg:recoveryToFixedWidth("right","bottom")
	self.m_csNode.selectcity.close:recoveryToFixedWidth("right","top")
	if self.m_csNode.huodong_button then
		self.m_csNode.huodong_button:recoveryToFixedWidth("right","top")
	end
	self.m_csNode.uieffect:recoveryToFixedWidth("right","top")
	self.m_csNode.goto:recoveryToFixedWidth("right","bottom")
	self:fixUniqueNodes()
end

function This:fixUniqueNodes()
	self.m_csNode.cityres.close:recoveryToFixedWidth("right","top")
	self.m_csNode.cityres:recoveryToFixedWidth("left","top")
	self.m_csNode.BattleBox:recoveryToFixedWidth("right","top")
	self.m_csNode.task:recoveryToFixedWidth("right","bottom")
	self.m_csNode.people:recoveryToFixedWidth("right","top")
	self.m_csNode.Recommend:recoveryToFixedWidth("left","top")
	if GamePlayer:isIPhioneX() then
		self.m_csNode.task:setPositionX(50)
		self.m_csNode.Recommend:setPositionX(50)
		self.m_csNode.march:setPositionX(50)
	end
end

function This:onEnter()
	super.onEnter(self)
	self:initMarchArmy()
	self:initMiniMap()
	self:refreshTime()
	self:refreshHanXianDiBuff()
	self:initWorldBox()
	self:refreshReportEffect()
	self:refreshModelVisible()
	self:initChapterGuideView()
	self:initAction()
	WorldMapManager:addObserver(self)
	local box = WorldMapManager:getBox()
	box:addObserver(self)
	ReportManager:addObserver(self)
	EventDispatcher:addListener(self,"guide_start",self.onGuideStart)
	VoiceChatManager:setJoinRoomCallback(function(memeberId)
		if memeberId > 0 then
			self.m_scene:showTips(Serialize["world_WorldUI_1"])
			self.m_isInVoiceRoom = true
			self.m_csNode.smallmap.voice.icon2:setVisible(true)
		else
			self.m_scene:showTips(Serialize["world_WorldUI_2"])
			self.m_isInVoiceRoom = false
			self.m_csNode.smallmap.voice.icon2:setVisible(false)
		end
	end)
	TerrBuildingJiaoChang:onGetWarfareInfoRequest()
end

function This:onExit()
	super.onExit(self)
	WorldMapManager:removeObserver(self)
	local box = WorldMapManager:getBox()
	box:removeObserver(self)
	ReportManager:removeObserver(self)
	EventDispatcher:removeListener(self,"guide_start")
	VoiceChatManager:setJoinRoomCallback(nil)
	VoiceChatManager:exitRoom()
end

function This:initTouchEvent()
	super.initTouchEvent(self)
	if self.m_csNode.cityres then
		self.m_csNode.cityres.close:setTouchEnded(function ()
			self.m_scene:exitBuildMode()
		end)
		self.m_csNode.cityres.BulidAuto.automatic1.automatictroops.selected:setVisible(false)
		self.m_csNode.cityres.BulidAuto.automatic1.diban1:setTouch({
			onEnded = function()
				local node = self.m_csNode.cityres.BulidAuto.automatic1.automatictroops.selected
				local isVisible = node:isVisible()
				node:setVisible(not isVisible)
				local city = self.m_cityUI:getModel()
				WorldMapManager:onAutoAddHpRequest(not isVisible,city:getCityId())
			end,
			isScale = false,
			name = "diban1"
		})

		local autoNode = self.m_csNode.cityres.BulidAuto
		autoNode.automatic2.listbutton:setTouch({
			onEnded = function()
				if not self.m_city then
					return
				end
				
				if self.m_city:getAutoUpgradeTimes() > 0 then
					WorldMapManager:onAutoUpgradeBuildRequest(self.m_city:getCityId(),0)	
				end
				local isVisible = autoNode.automatic2list:isVisible()
				autoNode.automatic2list:setVisible(not isVisible)
				self.m_isSelectAutoUpTime = true
			end,
			isScale = false,
			name = "listbutton"
		})

		local t = {30,50,80}
		for i = 1, 3 do
			local listNode = self.m_csNode.cityres.BulidAuto.automatic2list
			listNode["select"..i]:setTouchEnded(function()
				self.m_isSelectAutoUpTime = false
				WorldMapManager:onAutoUpgradeBuildRequest(self.m_city:getCityId(),t[i])
			end)
		end		
	end

	if self.m_csNode.panel_btns.diplomatic then
		self.m_csNode.panel_btns.diplomatic:setTouch({
		    isScale = false, 
			isDynamic = true, 
			onEnded = function()
				self.m_scene:openDialog("Foreign.ForeignRelationPanel")
		    end,
		})
	end

	self.m_csNode.selectcity.close:setTouchEnded(function()
		self.m_scene:exitSelectMode()
	end)

	self.m_csNode.smallmap.battlelog:setTouchEnded(function()
		local reportList = ReportManager:getReportList(function(report)
			if report:getType() ~= ReportType.kArena and report:isMy() and not report:isInFighting() and report:getType() ~= ReportType.kPeakContest then
				return true
			end
			return false
		end)
		self.m_scene:openDialog("Report.ArenaReportPanel",{reportList = reportList})
	end)

	self.m_csNode.smallmap.cityinformation:setTouchEnded(function()
		self.m_scene:openDialog("Statistics.CityStatisticPanel")
	end)

	self.m_csNode.goto:setTouch({
	    isScale = false, 
		isDynamic = true, 
		onEnded = function()
			if WorldMapManager:getMapType() <= 0 then
				self.m_scene:showTips(Serialize["world_WorldUI_3"])
			else
				cc.SceneManager:switchTo("Home.MenuScene")
			end
	    end,
	})

	self.m_csNode.smallmap.map_bg:setTouch({
		onEnded = function()
			self.m_scene:openDialog("World.WorldMiniMapPanel")
		end,
		isScale = false
	})

	local bp = cc.Vec()
	self.m_csNode.march.bg:setTouch({
		onBegan = function(_,touch)
			bp.x = touch.x
			bp.y = touch.y
			local boundbox = self.m_csNode.march.bg:getBoundingBox()
			return boundbox:isContainsPoint({x = touch.x , y = touch.y})
		end,
		onEnded = function(_,touch)
			local ep = cc.Vec(touch.x - bp.x,touch.y - bp.y)
			if ep:length() < 10 then
				self.m_scene:openDialog("World.MarchArmyListPanel")
			end
		end,
		isScale = false,
		name = "march.bg"
	})
	self.m_csNode.march.ScrollView:setTouchEnabled(true)
	self.m_csNode.march.ScrollView:setSwallowTouch(false)

	local function showProduct()
		local copper = WorldMapManager:getCopperProduct()
		self.m_csNode.res_info.coppertxt:setVisible(true)
		self.m_csNode.res_info.coppertxt.des:setString(string.format(Serialize["world_WorldUI_4_c"],copper))
		self.m_csNode.res_info.coppertxt:runAction(cc.Sequence(cc.DelayTime(2),cc.CallFunc(function()
			self.m_csNode.res_info.coppertxt:setVisible(false)
		end)))

		local food = WorldMapManager:getFoodProduct()
		self.m_csNode.res_info.foodtxt:setVisible(true)
		self.m_csNode.res_info.foodtxt.des:setString(string.format(Serialize["world_WorldUI_4_c"],food))
		self.m_csNode.res_info.foodtxt:runAction(cc.Sequence(cc.DelayTime(2),cc.CallFunc(function()
			self.m_csNode.res_info.foodtxt:setVisible(false)
		end)))
	end

	self.m_csNode.res_info.copper:setTouch({
		onEnded = function()
			showProduct()
		end,
		isScale = false,
		isDynamic = true
	})
	self.m_csNode.res_info.food:setTouch({
		onEnded = function()
			showProduct()
		end,
		isScale = false,
		isDynamic = true
	})
	self.m_csNode.smallmap.search:setTouchEnded(function()
		self.m_scene:openDialog("World.SearchCityPanel")
	end)
	
	self.m_csNode.smallmap.voice:setTouchEnded(function()
		if not self.m_isInVoiceRoom then
			local mapId = GamePlayer:getMapId()
			if mapId > 0 then
				local key = "map_" .. GameUtil:int64ToString(GamePlayer:getMapId())
				VoiceChatManager:joinTeamRoom(key)
			end
		else
			VoiceChatManager:exitRoom()
		end
	end)

	self.m_csNode.buff.bg:setTouchEnded(function ()
		g_scene:openDialog("Map.HanXianDiSkillPanel",{})
	end)
end

function This:addCityToMarchList(city)
	local view = MarchArmyView:create(city,false)
	self.m_csNode.march.ScrollView:pushBackCustomItem(view,151,31,0)
	self:refreshModelVisible()
end

function This:removeCityToMarchList(city)
	local itemList = self.m_csNode.march.ScrollView:getItemList()
	for i , view in ipairs(itemList) do
		local model , isArmy = view:getModel()
		if not isArmy and city == model then
			self.m_csNode.march.ScrollView:removeItem(i)
			break
		end
	end
end

function This:setUIVisible(bVisible)
	self.m_csNode:setVisible(bVisible)
end

function This:initAction()
	local ret = false
	if WorldMapManager:isInProtected() then
		if WorldMapManager:isShowNextFightTimeTipRecord() then
			ret = true
			local panel = self.m_scene:addDelayDialog({name = "Match.MatchFightTimeTipPanel", arg = {
				time = WorldMapManager:getNextFightTime(),
				callback = function()
					-- self:showFightTimeAction()
					local node = self.m_csNode.smallmap.timetips.time
					if node then node:setVisible(true) end
					self.m_csNode:playCSAnimation(nil, false)
				end
			}})
		end
	end

	if not ret then
		local node = self.m_csNode.smallmap.timetips.time
		if node then
			node:setVisible(true)
		end
	end
end

-- function This:showFightTimeAction()
-- 	if WorldMapManager:isInProtected() then
-- 		local node = self.m_csNode.smallmap.timetips
-- 		local tx, ty = node:getPosition()
-- 		local x , y = self.m_csNode.smallmap:convertToNodeSpace(cc.visible.center.x,cc.visible.center.y)
-- 		node:setPosition(cc.visible.center.x,cc.visible.center.y)

-- 		local scalex , scaley = node:getScaleX() , node:getScaleY() 
-- 		node:setScale(3*scalex,3*scaley)
-- 		node:runAction(cc.Spawn(
-- 			cc.ScaleXYTo(1,scalex,scaley,"SineOut"),
-- 			cc.MoveTo(1,tx,ty,"SineOut")
-- 		)) 
-- 	end
-- end

function This:initMarchArmy()
	local armyList = WorldMapManager:getAllMarchArmy()
	for i , army in pairs(armyList) do
		if army:getOwnerId() == GamePlayer:getPlayerID() then
			self:onAddMarchArmy(army)
		end
	end

	local fightCitys = WorldMapManager:getFightCitys()
	for cityId , city in pairs(fightCitys) do
		local armyList = city:getMyAttackArmy()
		print("-----------armyList-----------",#armyList)
		if #armyList > 0 then
			self:addCityToMarchList(city)
		end
	end
	self.m_csNode.march:setVisible(#armyList > 0)
end


function This:initMiniMap()
	self.m_csNode.smallmap.map:setCascadeOpacityEnabled(false)
	self.m_csNode.smallmap.map:setOpacity(0)
	local citys = WorldMapManager:getAllCity()
	for id, city in pairs(citys) do
		local node = cc.Sprite:create("WarScene/town_0.png")
		node:setScale(0.2)
		local rx, ry = self.m_scene:getPositionRatio(id)
		local w , h = self.m_csNode.smallmap.map:getContentSize()
		node:setPosition(rx * w , ry * h)
		self.m_csNode.smallmap.map:addChild(node)
		self.m_cityNodes[city:getCityId()] = node
		self:refreshMapCityNode(city)
	end
	self.m_rectW , self.m_rectH = 35, 25
	self.m_rectNode = cc.DrawNode:create()
	self.m_rectNode:drawRect(cc.Rect(0,0,self.m_rectW,self.m_rectH),cc.Color(255,255,0,255))
	self.m_csNode.smallmap.map:addChild(self.m_rectNode)

	local rx , ry = self.m_scene:getViewportCenterRatio()
	local w , h = self.m_csNode.smallmap.map:getContentSize()
	self.m_rectNode:setPosition(rx * w - self.m_rectW/2, ry * h - self.m_rectH / 2)
end

function This:initWorldBox()
	self:refreshWorldBox()
	self.m_csNode.BattleBox.box:setTouchEnded(function()
		local box = WorldMapManager:getBox()
		if not box:isExist() then
			self.m_scene:handleErrorCode("world_box_has_rewarded")
		elseif box:isUpdating() then
			self.m_scene:showTips(Serialize["world_WorldUI_5"])
		elseif box:isCanReward() then
			WorldMapManager:onRecieveBoxRewardRequest()
		else
			self.m_scene:focuseCity(box:getCityId())
		end
	end)
end

function This:initDangerous()
	local armyList = WorldMapManager:getEnemyMarchArmyToMyCity()
	table.sort(armyList,function(a,b)
		return a:getStartTime() < b:getStartTime()
	end)
	local cityList = {}
	local citys = {}
	for i , army in ipairs(armyList) do
		local toCityId = army:getToCity()
		if not citys[toCityId] then
			table.insert(cityList,toCityId)
			citys[toCityId] = {army}
		else
			table.insert(citys[toCityId],army)
		end
	end

	self.m_dangerViewList = {}
	local total = #self.m_dangerViewList 
	local fromIndex = total >= MaxDangerNum and total - MaxDangerNum + 1 or 1

	for i = fromIndex , #cityList  do
		local cityId = cityList[i]
		self:addDangerView(citys[cityId],cityId)
	end
end

function This:initChapterGuideView()
	if GuideManager:isInGuide() then
		self.m_chapterGuideView = ChapterGuideView:create()
		self.m_csNode:addChild(self.m_chapterGuideView)
		self.m_chapterGuideView:setLocalZOrder(MapZorder.kGuideZorder)
	end
end

function This:refreshGongXunAchieve()
	if not self.m_csNode.Recommend then
		return 
	end
	local isVisible = WorldMapManager:getMapType() > 0
	self.m_csNode.Recommend.gongxun:setVisible(isVisible)
	if isVisible then
		super.refreshGongXunAchieve(self)
	end
end

function This:addDangerView(armyList,cityId,isInit)
	local function refreshContent()
		local w = 0
		for i , view in ipairs(self.m_dangerViewList) do
			view:setPositionX(w)
			w = w - view:getContentWidth()
		end
	end
	local function removeHandler(cityId)
		for i , view in ipairs(self.m_dangerViewList) do
			if view:getCityId() == cityId then
				view:removeFromParent()
				table.remove(self.m_dangerViewList,i)
				refreshContent()
				self:refreshModelVisible()
				break
			end
		end
	end

	local view = MarchDangerView:create({armyList = armyList,cityId = cityId })
	view:setAnchorPoint(1.0,0.5)
	view:setRemoveHandler(removeHandler)
	view:setLookedHandler(refreshContent)
	view:setTouchHandler(function(id)
		self.m_scene:focuseCity(id)
	end)
	self.m_csNode.Dangerous:addChild(view)

	if #self.m_dangerViewList >= MaxDangerNum then
		local tmpView = self.m_dangerViewList[1]
		tmpView:removeFromParent()
		table.remove(self.m_dangerViewList,1)
	else
		table.insert(self.m_dangerViewList,view)
	end

	refreshContent()
	return view
end

function This:refreshWorldBox()
	local box = WorldMapManager:getBox()
	self.m_csNode.BattleBox.boxnumber:setString(string.format("(%d/%d)",box:getId(),kMaxBoxNum))

	if not box:isExist() then
		self.m_csNode.BattleBox.time:setString(Serialize["world_WorldUI_6"])
		self.m_csNode.BattleBox.time:setColor(253,235,190,255)	
	elseif box:isCanReward() then
		self.m_csNode.BattleBox.time:setString(Serialize["world_WorldUI_7"])
		self.m_csNode.BattleBox.time:setColor(253,235,190,255)	
	elseif box:isUpdating() then
		local leftTime = box:getLeftTime()
		self.m_csNode.BattleBox.time:setString(string.format(Serialize["world_WorldUI_8_c"],GameUtil:formatTime(Serialize["H_M_S"],leftTime)))	
		self.m_csNode.BattleBox.time:setColor(253,235,190,255)	
	else
		local city = WorldMapManager:getCity(box:getCityId())
		local str = string.format(Serialize["world_WorldUI_9"],city:getName())
		self.m_csNode.BattleBox.time:setString(str,280)
	end
end

function This:updateMiniMap(rx,ry)
	local w , h = self.m_csNode.smallmap.map:getContentSize()
	local x = rx * w - self.m_rectW/2
	local y = ry * h - self.m_rectH / 2
	x = math.min(w - self.m_rectW, math.max(0,x))
	y = math.min(h - self.m_rectH, math.max(0,y))
	self.m_rectNode:setPosition(x,y)
end

function This:refreshMapCityNode(city)
	local ownerId = city:getOwnerId()
	local index = 0
	if ownerId > 0 then
		local role = WorldMapManager:getRole(ownerId)
		index = role:getIndex()
	end
	if city:getType() == CityType.kThief then
		self.m_cityNodes[city:getCityId()]:setImage("WarScene/town_0.png")
	else
		self.m_cityNodes[city:getCityId()]:setImage(string.format("WarScene/town_%d.png",index))
	end
	local cityId = city:getId()
	if cityId == 9 then
		assert(true)
	end
	if city:hasTreasureBox() and not self.m_cityEffect[cityId] then
		self.m_cityEffect[cityId] = GameUtil:createEffect("LiangDian",true)
		self.m_cityNodes[cityId]:addChild(self.m_cityEffect[cityId])
	elseif not city:hasTreasureBox() and self.m_cityEffect[cityId] then
		self.m_cityEffect[cityId]:removeFromParent()
		self.m_cityEffect[cityId] = nil
	end
end

function This:refresh()
	super.refresh(self)
	self:onResChanged()
	if WorldMapManager:getMapType() <= 0 then
		-- self.m_csNode.goto:setGrayShader()
		self.m_csNode.goto.icon:setGrayShader()
		self.m_csNode.goto.text:setGrayShader()
	else
		self.m_csNode.goto:clearShader()
		self.m_csNode.goto.icon:clearShader()
		self.m_csNode.goto.text:clearShader()
	end
end

function This:refreshModelVisible()
    local sceneType = self.m_scene:getType()
    if sceneType ~= SceneType.kWorldScene then
		return    
    end

	local showMode = self.m_scene:getShowMode()
	self.m_csNode.uieffect:setVisible(showMode == ShowMode.kNormal)
	self.m_csNode.player_info:setVisible(showMode == ShowMode.kNormal)
	self.m_csNode.smallmap:setVisible(showMode == ShowMode.kNormal)
	self.m_csNode.res_info:setVisible(showMode == ShowMode.kNormal or showMode == ShowMode.kBuild)
	self.m_csNode.huodong_button:setVisible(showMode == ShowMode.kNormal)
	self.m_csNode.huodong:setVisible(showMode == ShowMode.kNormal and self.m_csNode.huodong_button:getSwitchState())
	self.m_refreshModelVisible_count = (self.m_refreshModelVisible_count or 0) + 1
	local width = cc.visible.width
	if showMode ~= ShowMode.kBuild then
		self.m_csNode.res_info:setPositionX(0)
		self.m_csNode.res_info.email:setVisible(true)
		self.m_csNode.res_info.setting:setVisible(true)
		self.m_csNode.res_info.help:setVisible(true)
	else
		self.m_csNode.res_info.email:setVisible(false)
		self.m_csNode.res_info.setting:setVisible(false)
		self.m_csNode.res_info.help:setVisible(false)
		local offset = self.m_csNode.res_info.email:getPositionX() - self.m_csNode.res_info.help:getPositionX()
		offset = math.abs(offset)
		offset = offset + self.m_csNode.res_info.email:getContentWidth()
		self.m_csNode.res_info:setPositionX(0 + offset)
	end
	self.m_csNode.chat_node:setVisible(showMode == ShowMode.kNormal)
	self.m_csNode.close_bg:setVisible(showMode == ShowMode.kNormal)
	self.m_csNode.goto:setVisible(showMode == ShowMode.kNormal)
	self.m_csNode.panel_btns:setVisible(showMode == ShowMode.kNormal)

	self.m_csNode.cityres:setVisible(showMode == ShowMode.kBuild)

	local itemList = self.m_csNode.march.ScrollView:getItemList()
	self.m_csNode.march:setVisible(showMode == ShowMode.kNormal and #itemList > 0)
	self.m_csNode.selectcity:setVisible(showMode == ShowMode.kSelect)
	
	if self.m_csNode.stage then
		self.m_csNode.stage:setVisible(showMode == ShowMode.kNormal)
	end
	if not self.m_dangerViewList then
		assert(false)
	end
	self.m_csNode.Dangerous:setVisible(showMode == ShowMode.kNormal and #self.m_dangerViewList > 0)
	
	local mapType = WorldMapManager:getMapType()
	self.m_csNode.BattleBox:setVisible(mapType > 0 and showMode == ShowMode.kNormal and GuideManager:getGuideStep() >= GuideNodeVisible.WorldBattleBox)
	if self.m_csNode.people:isVisible() then
		self.m_csNode.people:setVisible(showMode == ShowMode.kNormal)
	else
		self:refreshGirlGuide()
	end
	self.m_csNode.Recommend:setVisible(showMode == ShowMode.kNormal)
end

function This:getCityUI()
	return self.m_cityUI
end

function This:getTaskNode()
	return self.m_csNode.Recommend.main
end

function This:showCityUI(city)
	if city then
		self.m_city = city
		self.m_cityUI = CityUI:create(city)
		self:addChild(self.m_cityUI,-1)
		self:refreshCityInfo(city)
		self:refreshModelVisible()
		EventDispatcher:dispatcher("enter_city")
	else
		self.m_city = nil
		self.m_cityUI:removeFromParent()
		self.m_cityUI = nil
		self:refreshModelVisible()
		EventDispatcher:dispatcher("exit_city")
	end
end

function This:refreshCityInfo(city)
	self.m_csNode.cityres.cityname:setString(city:getName())
	self.m_csNode.cityres.res.troops:setString(math.floor(city:getReserveHp()))
	self.m_csNode.cityres.res.troopsoutput:setString(math.floor(city:getReserveHpProduct())..Serialize[64350])
	self.m_csNode.cityres.res.moneyoutput:setString(math.floor(city:getCopperProduct())..Serialize[64350])
	self.m_csNode.cityres.res.foodoutput:setString(math.floor(city:getFoodProduct())..Serialize[64350])
	
	local autoNode = self.m_csNode.cityres.BulidAuto
	local times = city:getAutoUpgradeTimes()
	self:refreshAutoUpgradeTimes(true,times)
	autoNode.automatic1.automatictroops.selected:setVisible(city:isAutoAddHp())
end

function This:refreshAutoUpgradeTimes(isInit,times)
	local autoNode = self.m_csNode.cityres.BulidAuto

	if times == 0 then
		autoNode.automatic2.selected:setVisible(false)
		autoNode.automatic2.autoleveluptext:setString(Serialize["world_WorldUI_10_c"])
		if isInit then
			autoNode.automatic2list:setVisible(self.m_isSelectAutoUpTime)
			--self.m_isSelectAutoUpTime = false
		end
	else
		autoNode.automatic2.selected:setVisible(true)
		autoNode.automatic2list:setVisible(self.m_isSelectAutoUpTime)
		autoNode.automatic2.autoleveluptext:setString(string.format("%s%d",Serialize["world_WorldUI_10_c"],times))
	end

	local visible = PrivilegeManager:getPrivilegeNumBy(Privilege.kSupplyTroops) > 0
	autoNode.automatic1:setVisible(visible)
	visible = PrivilegeManager:getPrivilegeNumBy(Privilege.kAutoBuild) > 0
	autoNode.automatic2:setVisible(visible)
	autoNode.automatic2list:setVisible(visible and self.m_isSelectAutoUpTime)
end

function This:refreshTime()
	local time = WorldMapManager:getNextFightTime()
	if GamePlayer:getServerTime() < time then
		local fightData = os.serverdate("*t",time)
		local curData = os.serverdate("*t",GamePlayer:getServerTime())
		if fightData.day ~= curData.day then
			local str = Serialize[64457] .. os.serverdate("%X ",time) .. Serialize[64966]
			self.m_csNode.smallmap.timetips.time:setString(str)
		else
			local str = os.serverdate("%X ",time) .. Serialize[64966]
			self.m_csNode.smallmap.timetips.time:setString(str)
		end
	else
		local diff = GamePlayer:getServerTime() - WorldMapManager:getWorldStartTime()
		local year = 184 + math.floor(diff / 900)
		self.m_csNode.smallmap.timetips.time:setString(string.format(Serialize["world_WorldUI_11"],year))
	end
end

function This:refreshReportEffect()
	local isShow = ReportManager:hasNoRead()
	if isShow and not self.m_reportEffect then
		self.m_reportEffect = GameUtil:createEffect("BulletHit22",true)
		self.m_reportEffect:setAngle(45)
		self.m_csNode.smallmap.battlelog.icon:addChild(self.m_reportEffect)
	elseif not isShow and self.m_reportEffect then
		self.m_reportEffect:removeFromParent()
		self.m_reportEffect = nil
	end
end

function This:refreshGirlGuide(isRandom)
	if not self.m_csNode.people then
		return
	end
	super.refreshGirlGuide(self,isRandom)
	local model = self.m_scene:getShowMode()
	if model ~= ShowMode.kNormal then
		self.m_csNode.people:setVisible(false)
	end
end

function This:refreshMatchArmyEffect()
	local isShow = false
	local armyList = WorldMapManager:getMarchArmyList(GamePlayer:getPlayerID())
	for i , army in ipairs(armyList) do
		if army:getSpeedUpTime() < kMaxSpeedUpTime then
			isShow = true
			break
		end
	end
	if isShow and not self.m_armyEffect then
		self.m_armyEffect = GameUtil:createEffect("XingJun",true)
		local x , y = self.m_csNode.march.bg:getPosition()
		self.m_armyEffect:setPosition(x,y)
		self.m_csNode.march:addChild(self.m_armyEffect)
	elseif not isShow and self.m_armyEffect then
		self.m_armyEffect:removeFromParent()
		self.m_armyEffect = nil
	end
end

function This:refreshHanXianDiBuff()
	WorldMapManager:addHanXianDiSkillInfo(self.m_csNode.buff,GamePlayer:getPlayerID())
end

------------------------------------------------------
function This:onAddBuild(city,buildList)
	if self.m_cityUI and self.m_cityUI:getModel() == city then
		self:refreshCityInfo(city)
	end
end

function This:onRemoveBuild(city,build)
	if self.m_cityUI and self.m_cityUI:getModel() == city then
		self:refreshCityInfo(city)
	end	
end

function This:onBuildUpgrade(city,build)
	if self.m_cityUI and self.m_cityUI:getModel() == city then
		self:refreshCityInfo(city)
	end	
end

function This:onAutoUpgrade(cityId,times)
	if self.m_city:getCityId() == cityId then
		self:refreshAutoUpgradeTimes(false,times)
	end
end

function This:onBuildStateChanged(city)
	if self.m_city == city then
		local times = city:getAutoUpgradeTimes()
		self:refreshAutoUpgradeTimes(false,times)
	end
end

function This:onResChanged()
	local copper, food = math.floor(WorldMapManager:getCopper()), math.floor(WorldMapManager:getFood())
	local maxCopper, maxFood = math.floor(WorldMapManager:getMaxCopper()), math.floor(WorldMapManager:getMaxFood())
	local maxFoodDesc = ItemUtil.customFormatCount(maxFood, 100000)
	local maxCopperDesc = ItemUtil.customFormatCount(maxCopper, 100000)
	if food < maxFood then
		food = ItemUtil.customFormatCount(food, 100000)
		self.m_csNode.res_info.food:setString(food .. "/" .. maxFoodDesc)
	else
		self.m_csNode.res_info.food:setStringWithColor("<R0>" .. maxFoodDesc .. "/" .. maxFoodDesc)
	end

	if copper < maxCopper then
		copper = ItemUtil.customFormatCount(copper, 100000)
		self.m_csNode.res_info.copper:setString(copper .. "/" .. maxCopperDesc)
	else
		self.m_csNode.res_info.copper:setStringWithColor("<R0>" .. maxCopperDesc .. "/" .. maxCopperDesc)
	end
end
function This:onAddMarchArmy(model)
	if model:isMy() then
		local view = MarchArmyView:create(model,true)
		self.m_csNode.march.ScrollView:pushBackCustomItem(view,151,31,0)
		self:refreshModelVisible()	
		self:refreshMatchArmyEffect()
	end
	if not model:isOur() then
		local city = WorldMapManager:getCity(model:getToCity())
		if city:isMy() then
			for i , view in ipairs(self.m_dangerViewList) do
				if view:getCityId() == city:getCityId() then
					view:addArmy(model)
					return
				end
			end
			self:addDangerView({model},city:getCityId())
			self:refreshModelVisible()
		end
	end
end

function This:onUpdateMarchArmy(model)
	if not model:isOur() then
		local city = WorldMapManager:getCity(model:getToCity())
		if city:isMy() then
			for i , view in ipairs(self.m_dangerViewList) do
				if view:getCityId() == city:getCityId() then
					view:addArmy(model)
					return
				end
			end
			self:addDangerView({model},city:getCityId())
			self:refreshModelVisible()
		end
	end
end

function This:onRemoveMarchArmy(army)
	if army:isMy() then
		local itemList = self.m_csNode.march.ScrollView:getItemList()
		for i , view in ipairs(itemList) do
			local model , isArmy = view:getModel()
			if isArmy and model:getId() == army:getId() then
				self.m_csNode.march.ScrollView:removeItem(i)
				self:refreshMatchArmyEffect()
				break
			end
		end
		if #itemList <= 0 then
			self.m_csNode.march:setVisible(false)
		end	
	end
end

function This:onMarchArmyChanged(army)
	if army:isMy() then
		self:refreshMatchArmyEffect()
	end
end

function This:onCityInfoChanged(city)
	local itemList = self.m_csNode.march.ScrollView:getItemList()
	if city:getState() == CityState.kInFighting then
		local armyList = city:getMyAttackArmy()
		print(string.format("城市%d处于战斗状态,我的部队数量为:%d",city:getCityId(),#armyList))
		if #armyList <= 0 then
			return
		end
		local isIn = false
		for i , view in ipairs(itemList) do
			local model , isArmy = view:getModel()
			if not isArmy and model == city then
				isIn = true
				break
			end
		end
		if not isIn then
			self:addCityToMarchList(city)
			self:refreshModelVisible()
		end
	else
		for i , view in ipairs(itemList) do
			local model , isArmy = view:getModel()
			if not isArmy and model == city then
				self:removeCityToMarchList(city)
				self:refreshModelVisible()
				break
			end
		end
	end
	self:refreshWorldBox()
	self:refreshMapCityNode(city)
end

function This:onUpdateWorldTime()
	self:refreshTime()
end

function This:onAutoAddHp(cityId,auto)
	if self.m_cityUI and self.m_cityUI:getModel():getCityId() == cityId then
		print(string.format("city = %d , auto_add_hp = %s" ,cityId,auto))
	end
end

function This:onWorldBoxAppear()
	self:refreshWorldBox()
end

function This:onWorldBoxUpdateEnd()
	self:refreshWorldBox()
end

function This:onWorldBoxUpdateTime()
	local box = WorldMapManager:getBox()
	local leftTime = box:getLeftTime()
	self.m_csNode.BattleBox.time:setString(string.format(Serialize["world_WorldUI_8_c"],GameUtil:formatTime(Serialize["H_M_S"],leftTime)))
end

function This:onReportReaded(id)
	self:refreshReportEffect()
end

function This:onNewReport()
	self:refreshReportEffect()
end

function This:onFightEnded()
	self:refreshReportEffect()
end

function This:onGuideStepFinish(step)
	self:refreshModelVisible()
end

function This:onGuideFinish()
	self:refreshGirlGuide()
	if self.m_chapterGuideView then
		self.m_chapterGuideView:removeFromParent()
		self.m_chapterGuideView = nil
	end
end

function This:onBuildAddValue()
	self:refresh()
end


function This:onOpenTreasureBox(box)
	local cityId = box:getCityId()
	local city = WorldMapManager:getCity(cityId)
	self:refreshMapCityNode(city)
end

function This:onKillHanXianDiInfo()
	self:refreshHanXianDiBuff()
end

--endregion
