-- @Author: superm
-- @Date:   2018-08-21 16:57:32
-- @Last Modified by:   superm
-- @Last Modified time: 2018-09-07 15:12:59
-- @File Name: WorldBossBoxRewardPanel.lua
-- @Description: 

local This , super = class(..., "Hero.SaintBoxRewardPanel")
local RewardItemView, superView = class(This._NAME .. ".RewardItemView", super._NAME .. ".RewardItemView")

local TerrBuildManager = require("Territory.TerrBuildManager")
local WorldBossBoxConfig = require("Metadatas.WorldBossBoxConfig")
local WorldMonsterManager = require("WorldBoss.WorldMonsterManager")

function This:initNode(info)
    self.m_boxList = {}
    self.m_boss = {}
    self.m_boss = info.boss
    
    self.m_itemViews = {}
    local csNode = cc.Node:createFromCSFile("MenuScene/NodeUI/WorldBossBox.csb")
    self.m_csNode = csNode
    self:addChild(csNode)
    csNode:setToCenter()
    self:onPickupWarBoxReward()
end

function This:addCustomListener()
   WorldMonsterManager:addObserver(self)
end

function This:removeCustomListener()
    WorldMonsterManager:removeObserver(self)
end

function This:getNewItemView( ... )
    return RewardItemView:create(self, ...)
end

function This:onPickupWarBoxReward()
     self:refreshData()
    self.m_itemDataList = self.m_boxList
    self:refreshRewardList()
end

function This:onPickUpBtnClick( boxId )

end


function This:refreshData()
    local boxIdList = self.m_boss.m_config.boss_box_id


    for i, id in pairs(boxIdList) do
        self.m_boxList[i] = WorldBossBoxConfig[id]
        self.m_boxList[i].boss_id = self.m_boss.m_id
        if self.m_boss.m_weekRewardInfos[id] then
            self.m_boxList[i].state = SaintBoxState.kClose
        elseif self.m_boss.m_weekchallengeTimes >= WorldBossBoxConfig[id].weekly_times then
            self.m_boxList[i].state = SaintBoxState.kOpen
        else
            self.m_boxList[i].state = SaintBoxState.kLock
        end

    end
end

function This:sortDataList()
    table.sort(self.m_itemDataList, function( a, b )
        if a.state ~= b.state then
            return a.state > b.state
        else
            return a.id < b.id
        end
    end)
end

------------------------------------------------------------------
function RewardItemView:initNode()
    superView.initNode(self)
    local csNode = self.m_csNode
    csNode.beijing.wusheng:setImage("MenuScene/wordcishu.png")
end

function RewardItemView:onPickUpBtnClick()
    if self:isOpening()then
    	WorldMonsterManager:onWorldBossWeekRewardRequest(self.m_config.boss_id,self.m_config.id)
    end
end

function RewardItemView:refresh()
    local csNode = self.m_csNode
    csNode.beijing.level:setString(self.m_config.weekly_times)
    self:setItemEnable(self:isOpening())
end
