-- @Author: superm
-- @Date:   2018-07-24 19:33:55
-- @Last Modified by:   zheng
-- @Last Modified time: 2020-07-03 18:34:13
-- @File Name: WorldBossRewardItemView.lua
-- @Description: 


local This, super = class(..., "NodeView")
This.fileName = "MenuScene/NodeUI/WorldBossRewardList.csb"

local ItemNode = require("UI.ItemNode")

function This:init(info, index)
	self.m_id = info.id
	self.m_rankMax = info.max
	self.m_rankMin = info.min
	self.m_rewardlist = info.rewardlist

	self.m_index = index or 0

	local w , h = self.bg:getContentSize()
	self:setContentSize(w,h)
	self:setCascadeOpacityEnabled(true)
	self.scrollview:setDirection("horizontal")
	self.scrollview.m_direction = "right"
end

function This:initNode()
    self:refresh()
end

function This:setModel( info, index )
	if self.m_index ~= index or self.m_id ~= info.id then
		self.m_id = info.id
		self.m_rankMax = info.max
		self.m_rankMin = info.min
		self.m_rewardlist = info.rewardlist

		self.m_index = index or 0
		self:refresh()
	end
end

function This:refresh()
	self:refreshIndexNode()
	self:refreshReward()
end

function This:initTouchEvent()
	if not self.m_inited then
		self.scrollview:setSwallowTouch(false)
		self.m_inited = true
	end
end

function This:refreshIndexNode()
	local rank = 0
	if self.m_rankMax == self.m_rankMin then
		rank = self.m_rankMax
	end
	local topVisible = rank < 4 and rank > 0
	self.rank:setVisible(not topVisible)
	self.top:setVisible(topVisible)
	if topVisible then
		self.top:setImage("MenuScene/top" .. rank .. ".png")
	else
		if rank > 0 then
			self.rank:setString(string.format(Serialize[60698], rank))
		else
			self.rank:setString(string.format(Serialize[60699], self.m_rankMax, self.m_rankMin))
		end
	end 
end

function This:refreshReward()
	self.scrollview:removeAllItems()
	local itemList = self.m_rewardlist
	for i , info in ipairs(itemList) do
		local item = ItemNode:create(info[1],info[2])
		local w , h = item:getContentSize()
		item:setAnchorPoint(0.5,0.5)
		self.scrollview:pushBackCustomItem(item,w,h,0.5)
	end
end