b2 = b2 or {}
local ffi = require("ffi")
ffi.cdef[[
typedef struct Vec b2Vec2;
typedef signed char int8;
typedef signed short int16;
typedef signed int int32;
typedef unsigned char uint8;
typedef unsigned short uint16;
typedef unsigned int uint32;
typedef float float32;
typedef double float64;
]]

local categoryList = {}
local categoryCount = 0
local function getCategory(typeName)
    local b = categoryList[typeName]
    if not b then
        assert(categoryCount <= 16)
        b = bit.lshift(1, categoryCount)
        categoryList[typeName] = b
        categoryCount = categoryCount + 1
    end
    return b
end

local bitor = bit.bor
local function getMaskBitOr(...)
    local args = {...}
    local maskBit = 0
    for i = 1, #args do
        if args[i] then
            maskBit = bitor(maskBit, getCategory(args[i]))
        end
    end
    return maskBit
end

local bitxor = bit.bxor
local function getMaskBitXOr(maskBit, ...)
    local args = {...}
    for i = 1, #args do
        if args[i] then
            maskBit = bitxor(maskBit, getCategory(args[i]))
        end
    end
    return maskBit
end

local groupBitList = {}
local groupCount = 0
local function getGroupBit(typeName)
    local b = groupBitList[typeName]
    if not b then
        b = -1 - groupCount
        groupBitList[typeName] = b
        groupCount = groupCount + 1
    end
    return b
end

local xgroupBitList = {}
local xgroupCount = 0
-- 获取总是碰撞的组bit
local function getXGroupBit(typeName)
    local b = xgroupBitList[typeName]
    if not b then
        b = 1 + xgroupCount
        xgroupBitList[typeName] = b
        xgroupCount = xgroupCount + 1
    end
    return b
end

b2.getCategory = getCategory
b2.categoryList = categoryList
b2.getMaskBitOr = getMaskBitOr
b2.getMaskBitXOr = getMaskBitXOr
b2.getGroupBit = getGroupBit
b2.getXGroupBit = getXGroupBit

require("b2.Shape")
require("b2.Body")
require("b2.Contact")
require("b2.Physics")