local ffi = require("ffi")
ffi.cdef[[
typedef struct b2WorldManifold
{
    b2Vec2 normal;
    b2Vec2 points[2];
    float32 separations[2];
}b2WorldManifold;
]]
local This = class(...)
b2.Contact = This
local b2WorldManifold = ffi.typeof("b2WorldManifold")
local lib_contact = lib2d.b2Contact

local lib_setRestitution = lib_contact.setRestitution
function This:setRestitution(restitution)
    lib_setRestitution(self[0], restitution)
end

local lib_getRestitution = lib_contact.getRestitution
function This:getRestitution()
    return lib_getRestitution(self[0])
end

local lib_resetRestitution = lib_contact.resetRestitution
function This:resetRestitution()
    lib_resetRestitution(self[0])
end

local lib_setFriction = lib_contact.setFriction
function This:setFriction(friction)
    lib_setFriction(self[0], friction)
end

local lib_getFriction = lib_contact.getFriction
function This:getFriction()
    return lib_getFriction(self[0])
end

local lib_setTangentSpeed = lib_contact.setTangentSpeed
function This:setTangentSpeed(tangentSpeed)
    lib_setTangentSpeed(self[0], tangentSpeed)
end

local lib_getTangentSpeed = lib_contact.getTangentSpeed
function This:getTangentSpeed()
    return lib_getTangentSpeed(self[0])
end

local lib_setIsEnabled = lib_contact.setIsEnabled
function This:setIsEnabled(isEnabled)
    lib_setIsEnabled(self[0], isEnabled)
end

local lib_isEnabled = lib_contact.isEnabled
function This:isEnabled()
    return lib_isEnabled(self[0])
end

local lib_isTouching = lib_contact.isTouching
function This:isTouching()
    return lib_isTouching(self[0])
end

local lib_getNext = lib_contact.getNext
function This:getNext()
    return lib_getNext(self[0])
end

local lib_getManifold = lib_contact.getManifold
function This:getManifold()
    return lib_getManifold(self[0])
end

local worldManifold = b2WorldManifold()
local lib_getWorldManifold = lib_contact.getWorldManifold
function This:getPoint()
    lib_getWorldManifold(self[0], worldManifold)
    local p = worldManifold.points[0]
    p.x = p.x * 64
    p.y = p.y * 64
    return p.x, p.y
end

local lib_getNormal = lib_contact.getNormal
function This:getNormal(body)
    return lib_getNormal(self[0], body[0])
end