local registry = debug.getregistry()
local initLuaID = lib2d.initLuaID
local setmetatable = setmetatable
cc.objectRegistry = registry
function cc.registerObject(ptrRef, classObj, obj)
    obj = obj or {}
    obj[0] = ptrRef
    registry[ptrRef] = obj
    initLuaID(ptrRef)
    if classObj then
        setmetatable(obj, classObj)
    end
    return obj
end

local cppNodeClassList = {}
cc.cppNodeClassList = cppNodeClassList
function cc.addCppNodeClass(classObj)
    local fullName = ""
    string.gsub(classObj._MNAME, "([^%.]+)" , function (name)
        fullName = fullName .. name
    end)
    classObj.classID = lib2d[fullName]["getClassID"]()
    classObj.className = lib2d[fullName]["getClassName"]()
    assert(cppNodeClassList[classObj.classID] == nil, "must not be register")
    cppNodeClassList[classObj.classID] = classObj
end

local type = type
lib2d.setRefGC(function (ptrRef)
    local t = registry[ptrRef]
    if t and type(t) == "table" then
        t[0]=0
        if t._schedule then
            t._schedule[ptrRef] = nil
            t._schedule = nil
        end
        if t._actions then
            for i = 1, #t._actions do
                lib_ref.release(t._actions[i])
            end
            t._actions = nil
        end
    end
    registry[ptrRef] = nil
end)

require("cc.Director")
require("cc.FileUtils")
require("cc.SpriteFrameCache")
require("cc.TextureCache")
require("cc.Color")
require("cc.Action")
require("cc.GLProgramState")
require("cc.TouchListener")
require("cc.TouchAllListener")
require("cc.Node")
require("cc.Scene")
require("cc.Sprite")
require("cc.FrameSprite")
require("cc.MotionStreak")
require("cc.Particle")
require("cc.SkeletonNode")
require("cc.UI")
require("cc.ListView")
require("cc.ScrollView")
require("cc.Label")
require("cc.LabelFrame")
require("cc.UtilityNode")
require("cc.PhysicsDrawNode")
require("cc.ProgressTimer")
require("cc.Http")
require("cc.RenderTexture")
require("cc.DynamicScreenshot")
require("cc.RichText")
require("cc.Scale9Sprite")
require("cc.SceneManager")
require("cc.Audio")
if os.isWin32 then
	require("cc.SpriteBatchNode")
end
