local ffi = require("ffi")
ffi.cdef[[
typedef unsigned char GLubyte;
typedef struct ccColor{GLubyte r, g, b, a;}ccColor;
]]

local Color = ffi.typeof("ccColor")
local ColorClass = {
    WHITE   = Color(255, 255, 255, 255),
    YELLOW  = Color(255, 255,   0, 255),
    GREEN   = Color(184,228,97),
    BLUE    = Color(69,191,255),
    RED     = Color(254,0,0),
    MAGENTA = Color(255,   0, 255, 255),
    BLACK   = Color(  0,   0,   0, 255),
    ORANGE  = Color(250,194,83),
    GRAY    = Color(166, 166, 166, 255),
}
cc.Color = ffi.metaclass("ccColor", ColorClass)

--[[local ColorList = {
    ["A0"] = "#ffffff",--白色
    ["A1"] = "#b8e461",--绿色
    ["A2"] = "#22f222",--绿色
    ["A3"] = "#ff481a",--规则描述
    ["A4"] = "#9000ff",--仓库分页
    ["A5"] = "#8898be",--蓝色
    ["A6"] = "#ff481a",--紫色
    ["B1"] = "#ACD3FF",
    ["B2"] = "#3f5a9f", --未激活 灰色
    ["Gray"] = "#5d5d5d", --未激活 灰色
    ["B3"] = "#2ae037",--符文有效绿
    ["Q1"] = "#ffffff",--品质1
    ["Q2"] = "#00ef0b",--w
    ["Q3"] = "#03a9e7",--品质3
    ["Q4"] = "#aa52dd",--品质4
    ["Q5"] = "#FAC253",--品质5
    ["R0"] = "#fe0000",--红色
    ["R1"] = "#FA3232",
    ["C0"] = "#1A9BFF",--符文描述蓝
    ["C1"] = "#FFE500",--A级枪共鸣
    ["C2"] = "#FF20FC",
    ["C3"] = "#893C2F",
    ["C4"] = "#FF00FC",
    ["C5"] = "#FCF2DF",
    ["D1"] = "#577187",
    ["D2"] = "#71440D",--装备碎片数量
    ["G1"] = "#4D4D4D",--字体灰化
    ["G2"] = "#23720F",--按钮绿色字体
    ["G3"] = "#1EFF00",--招财猫名字绿色字体 
    ["G4"] = "#71440d", --技能描述正文
    ["G5"] = "#fe7c00", --技能描述数值
    ["G6"] = "#1C8A19", --装备强化下一等级
    ["G7"] = "#1C8A19", --世界聊天其他人
    ["G8"] = "#FE7C00", --世界聊天自己
    ["G9"] = "#7A4736", --世界聊天内容
    ["G10"] = "#1C8A19",
    ["G11"] = "#7A4736",
    ["G12"] = "#AE846C",
    ["G13"] = "#F8EAD0", --金币
    ["H1"] = "#AE846C", -- 宠物技能描述
    ["Red0"] = "#FF0000",
    ["Red1"] = "#D9231F", -- 数量不足
    ["Red2"] = "#FF3333",
    ["Gray0"] = "#737272",
    ["Nor1"] = "#71440D", -- Serialize[60544]
    ["Nor2"] = "#fac253", -- 正常颜色，浅黄色2, 珍宝阁钥匙数
    ["Nor3"] = "#683A2C", -- 正常颜色，浅黄色2, 敲蛋数
    ["Nor4"] = "#AB967C", -- 灰色
    ["PetPhase1"] = "#B09C89", -- 凡品
    ["PetPhase2"] = "#4EB425", -- 黄品
    ["PetPhase3"] = "#417DE1", -- 玄品
    ["PetPhase4"] = "#D52BDB", -- 地品
    ["PetPhase5"] = "#FF7200", -- 天品
    ["Attr"] = "#DC6C02", -- 天品
    ["QQ1"] = "#ffffff",
    ["QQ2"] = "#00ef0b",
    ["QQ3"] = "#03a9e7",
    ["QQ4"] = "#aa52dd",
    ["QQ5"] = "#ff9204",
    ["QQ6"] = "#909baa",
}]]

local ColorList = {
    A0 = 0xffffff,--白色
    A1 = 0xb8e461,--绿色
    A2 = 0x22f222,--绿色
    A3 = 0xff481a,--规则描述
    A4 = 0x9000ff,--仓库分页
    A5 = 0x8898be,--蓝色
    A6 = 0xff481a,--紫色
    A7 = 0x557516,--绿色
    B1 = 0xACD3FF,
    B2 = 0x3f5a9f, --未激活 灰色
    Gray = 0x5d5d5d, --未激活 灰色
    B3 = 0x2ae037,--符文有效绿
    Q1 = 0xffffff,--品质1
    Q2 = 0x00ef0b,--w
    Q3 = 0x03a9e7,--品质3
    Q4 = 0xaa52dd,--品质4
    Q5 = 0xFAC253,--品质5
    Q6 = 0xfe0000,--品质6
    R0 = 0xfe0000,--红色
    R1 = 0xFA3232,
    C0 = 0x1A9BFF,--符文描述蓝
    C1 = 0xFFE500,--A级枪共鸣
    C2 = 0xFF20FC,
    C3 = 0x893C2F,
    C4 = 0xFF00FC,
    C5 = 0xFCF2DF,
    D1 = 0x577187,
    D2 = 0x71440D,--装备碎片数量
    G1 = 0x4D4D4D,--字体灰化
    G2 = 0x23720F,--按钮绿色字体
    G3 = 0x1EFF00,--招财猫名字绿色字体 
    G4 = 0x71440d, --技能描述正文
    G5 = 0xfe7c00, --技能描述数值
    G6 = 0x1C8A19, --装备强化下一等级
    G7 = 0x1C8A19, --世界聊天其他人
    G8 = 0xFE7C00, --世界聊天自己
    G9 = 0x7A4736, --世界聊天内容
    G10 = 0x1C8A19,
    G11 = 0x7A4736,
    G12 = 0xAE846C,
    G13 = 0xF8EAD0, --金币
    H1 = 0xAE846C, -- 宠物技能描述
    Red0 = 0xFF0000,
    Red1 = 0xD9231F, -- 数量不足
    Red2 = 0xFF3333,
    Gray0 = 0x737272,
    Nor1 = 0x71440D, -- Serialize[60544]
    Nor2 = 0xfac253, -- 正常颜色，浅黄色2, 珍宝阁钥匙数
    Nor3 = 0x683A2C, -- 正常颜色，浅黄色2, 敲蛋数
    Nor4 = 0xAB967C, -- 灰色
    PetPhase1 = 0xB09C89, -- 凡品
    PetPhase2 = 0x4EB425, -- 黄品
    PetPhase3 = 0x417DE1, -- 玄品
    PetPhase4 = 0xD52BDB, -- 地品
    PetPhase5 = 0xFF7200, -- 天品
    Attr = 0xDC6C02, -- 天品
    QQ1 = 0xffffff,
    QQ2 = 0x00ef0b,
    QQ3 = 0x03a9e7,
    QQ4 = 0xaa52dd,
    QQ5 = 0xff9204,
    QQ6 = 0xfe0000,
    New1 = 0x99ccff, --浅蓝色
    New2 = 0x45bfff, --天空蓝
    New3 = 0x8898be, --亮灰色
    New4 = 0x394354, --深色
    New5 = 0xffff99, --黄色
    New6 = 0xffefd1, --亮黄色
    New7 = 0xfac253,--橙色
    New8 = 0x9098be, --灰色
    New9 = 0xb8e461, --绿色
    New10 = 0xff481a, --橙红色
    New11 = 0xfe0000, --红色
    New12 = 0xffc0f2, --粉红色
    New13 = 0xffffff, --白色
    New14 = 0x8dadea, --新增
    New15 = 0x7088A4, --淡蓝色
    New16 = 0x805D4B, --酒红色
    New17 = 0xa3c859, --绿色
    New18 = 0xc9cfd1, --灰色
    New19 = 0xf1d797, --浅黄色
    New20 = 0xB8CDF5, 
    New21 = 0xafa58c,
    Peak1 = 0xFFEFD1, 
    Peak2 = 0xB1CBFF, 
    Study1 = 0x9098A6,
    FabaoStar = 0xFFFF99, -- 法宝星级色值
    FabaoRefine = 0xFFEFD1, -- 法宝精炼程度色值
    FabaoLevel = 0xFFFFFF, -- 法宝等级色值
    GreenAttr = 0xB8E461, -- 绿色属性
}

if lib2d.ccLabel.setColorMap then
	lib2d.ccLabel.setColorMap(ColorList)
end

local function hexToRGB(rbg)
    local r = math.floor(rbg / 256 / 256)
    local g = math.floor(rbg / 256) % 256
    local b = rbg % 256
    return r, g, b
end
ColorClass.hexToRGB = hexToRGB

local function convertToColor(rgbStr)
    local r, g, b = hexToRGB(rgbStr)
    return Color(r, g, b, 255)
end

for k,v in pairs(ColorList) do
    ColorList[k] = convertToColor(v)
end

cc.ColorList = ColorList
cc.hexToRGB = hexToRGB



return Color