local This = class(...)
cc.Director = This
local lib_director = lib2d.ccDirector

function This:init()
    This[0] = lib_director.getInstance()
end

function This:getTextureCache()
    return lib_director.getTextureCache()
end

function This:getOpenGLView()
    local glView = lib_director.getOpenGLView(self[0])
    if glView then
        glView = {[0] = glView}
        setmetatable(glView, require("cc.GLView"))
    end
    return glView
end

function This:setOpenGLView(glView)
    lib_director.setOpenGLView(self[0], glView[0])
end


function This:setAnimationInterval(interval)
    lib_director.setAnimationInterval(self[0], interval)
end

function This:setDisplayStats(isShow)
    lib_director.setDisplayStats(self[0], isShow)
end

function This:stopAnimation()
    lib_director.stopAnimation(self[0])
end

function This:startAnimation()
    lib_director.startAnimation(self[0])
end

function This:runWithScene(scene)
    lib_director.runWithScene(self[0], scene[0])
end

function This:hasRunningScene()
    return lib_director.getRunningScene(self[0]) ~= nil
end

function This:replaceScene(scene)
    lib_director.replaceScene(self[0], scene[0])
end

function This:exit()
    lib_director.exit(self[0])
end

function This:mainLoop()
    lib_director.mainLoop(self[0])
end

function This:popScene()
    lib_director.popScene(self[0])
end

function This:getWinSize()
    return lib_director.getWinSize(self[0])
end

function This:setProjection(projection)
    if projection == "2d" then
        lib_director.setProjection(self[0], 0)
    elseif projection == "3d" then
        lib_director.setProjection(self[0], 1)
    end
end

function This:captureScreen(fileName)
    lib_director.captureScreen(self[0], fileName)
end

function This:restImageScaleList()
    lib_director.restImageScaleList(self[0])
end

This:init()