local This = class(...)
cc.FileUtils = This
local lib_fileUtils = lib2d.ccFileUtils
function This:init()
    self[0] = lib_fileUtils.getInstance()
    self.m_writablePath = lib_fileUtils.getWritablePath(self[0])
end

function This:getWritablePath()
    return self.m_writablePath
end

-- function This:addSearchPath(path)
function This:addSearchPath(path, isFront)
    if isFront == nil then
        isFront = false
    end
    lib_fileUtils.addSearchPath(self[0], path, isFront)
end

function This:createDirectory(dir)
	if not self:isDirectoryExist(dir) then
		lib_fileUtils.createDirectory(self[0], dir)
	end    
end

function This:isDirectoryExist(dir)
    return lib_fileUtils.isDirectoryExist(self[0], dir)
end

function This:isFileExist(fileName)
    return lib_fileUtils.isFileExist(self[0], fileName)
end

function This:removeFile(filePath)
    lib_fileUtils.removeFile(self[0], filePath)
end

function This:saveDataToFile(fileData, isEncrypt, filePath, backupPath)
    if isEncrypt == nil then
        isEncrypt = false
    end
    lib_fileUtils.saveDataToFile(self[0], fileData, isEncrypt, filePath, backupPath)
end

function This:saveToLua(t, fileName)
    local fullPath = self:getWritablePath() .. "Data/" .. fileName
    self:saveDataToFile(table.tostring(t), nil, fullPath, nil)
end

function This:loadLuaFile(fileName)
    local fullPath = self:getWritablePath() .. "Data/" .. fileName
    return self:loadLuaDataFromFile(fullPath, nil)
end

function This:loadLuaDataFromFile(filePath, isEncrypt)
    if isEncrypt == nil then
        isEncrypt = false
    end
    return lib_fileUtils.loadLuaDataFromFile(self[0], filePath, isEncrypt)
end

function This:removeDirectory(dir)
    lib_fileUtils.removeDirectory(self[0], dir)
end

function This:checkAndRemoveFile(filePath)
    if self:isFileExist(filePath) then
        self:removeFile(filePath)
    end
end

function This:checkAndRemoveDirectory(dir)
    if self:isDirectoryExist(dir) then
        self:removeDirectory(dir)
    end
end

function This:getFileData(fileName)
    return lib_fileUtils.getFileData(self[0], fileName)
end

function This:execLuaFile(fileName)
    return lib_fileUtils.loadLuaFile(self[0], fileName)()
end

function This:getFileSize(fileName)
    return lib_fileUtils.getFileSize(self[0], fileName)
end

function This:clearCache()
    return lib_fileUtils.clearCache(self[0])
end

function This:clearSearchPath()
    lib_fileUtils.clearSearchPath(self[0])
end

This:init()