local This, super = class(..., "cc.Sprite")
cc.FrameSprite = This

local SpriteFrameCache = require("cc.SpriteFrameCache")
local TextureCache = require("cc.TextureCache")
local lib_createWithSpriteFrame = lib2d.ccSprite.createWithSpriteFrame
local ccRegister = cc.registerObject

function This:create(frameList, unitTime, playCount)
    return ccRegister(lib_createWithSpriteFrame(frameList[1]), self, {
        [0] = 0,
        m_frameList = frameList,
        m_frameIndex = 1,
        m_delayTime = unitTime,
        m_unitTime = unitTime,
        m_playCount = playCount,
    })
end

function This:update(deltaTime)
    self.m_delayTime = self.m_delayTime - deltaTime
    if self.m_delayTime <= 0 then
        self.m_delayTime = self.m_unitTime
        self.m_frameIndex = self.m_frameIndex + 1
        local count = #self.m_frameList
        if self.m_frameIndex > count then
            if self.m_playCount > 0 then
                self.m_playCount = self.m_playCount - 1
                if self.m_playCount == 0 then
                    self:removeFromParent()
                else
                    self.m_frameIndex = 1
                end
            else
                self.m_frameIndex = 1
            end
        end
        if self.m_frameIndex <= count then
            self:setSpriteFrame(self.m_frameList[self.m_frameIndex])
        end
    end
end