local This = class(...)
cc.Http = This
local Json = require("Json")
local lib_http = lib2d.ccHttp
local RequestTypeList = {
    ["get"] = 0,
    ["post"] = 1,
    ["put"] = 2,
    ["delete"] = 3,
}

local urlTemplates = {

}

local ccHttpResponse = class("cc.HttpResponse")
local lib_response_isSucceed = lib_http.response_isSucceed
function ccHttpResponse:isSucceed()
    return self[0] ~= nil and lib_response_isSucceed(self[0])
end
local lib_response_getErrorBuffer = lib_http.response_getErrorBuffer
function ccHttpResponse:getErrorBuffer()
    return self[0] ~= nil and lib_response_getErrorBuffer(self[0])
end
local lib_response_getResponseData = lib_http.response_getResponseData
function ccHttpResponse:getData()
    if self:isSucceed() then
        return lib_response_getResponseData(self[0])
    else
        return nil
    end
end
local lib_response_getResponseHeader = lib_http.response_getResponseHeader
function ccHttpResponse:getHeader()
    return self[0] ~= nil and lib_response_getResponseHeader(self[0])
end
function ccHttpResponse:getJsonData()
    local data = self:getData()
    if not data then
        return nil
    end
    return Json.decode(data)
end

lib2d.ccHttp.setCallback("OnResponse", function (onResponse, response)
    if onResponse then
        local obj = {[0] = response}
        setmetatable(obj, ccHttpResponse)
        onResponse(obj)
    end
end)

local function dumpParamList(param)
    local list = {}
    for k,v in pairs(param) do
        table.insert(list, k .. "=" .. v)
    end
    return list
end

function This:sendRequest(urlID, onResponse, requestType, param, headers)
    local url = urlTemplates[urlID]
    if url then
    else
        url = urlID
    end
    --print("SendRequest:", url)
    requestType = requestType or "post"
    local paramStr = nil
    if param then
        paramStr = table.concat(dumpParamList(param), "&")
        if requestType == "get" then
            url = url .. "?" .. paramStr
            paramStr = nil
        end
    end
    requestType = RequestTypeList[requestType]
    return lib_http.request_send(url, onResponse, requestType, paramStr, headers)
end

function This:sendDownloadRequest(setting)
    return lib_http.download(setting)
end

function This:setTimeoutForRead(time)
    lib_http.setTimeoutForRead(time)
end

function This:setTimeoutForConnect(time)
    lib_http.setTimeoutForConnect(time)
end

local registry = cc.objectRegistry
function This:closeRequest(request)
    registry[request] = nil
end

-- lib2d.ccHttp_download({
--     url = "http://hotupdate.51gamer.cn/patch_1_1.rar",
--     fileName = g_writablePath .. "Resources1.zip",
--     onDownloadProgressUpdate = function (self, totalToDownload, nowDownloaded)
--         print(nowDownloaded / totalToDownload * 100)
--     end,
--     onDownloadFinish = function (self)
    
--     end,
--     onDownloadError = function (self)
        
--     end
-- })
