local This, super = class(..., "cc.Node")
This.IsContainer = true
cc.addCppNodeClass(This)
cc.ListView = This

local lib_listView = lib2d.ccListView
local castNode = cc.Node.castNode

function This:createNode()
    return lib_listView.create()
end

function This:getDirection()
    return lib_listView.getDirection(self[0])
end

function This:setDirection(direction)
    if direction == "vertical" then
        direction = 1
    elseif direction == "horizontal" then
        direction = 2
    elseif direction == "both" then
        direction = 3
    else
        direction = 0
    end
    lib_listView.setDirection(self[0], direction)
end

function This:setGravity(gravity)
    if gravity == "left" then
        gravity = 0
    elseif gravity == "right" then
        gravity = 1
    elseif gravity == "centerHorizontal" then
        gravity = 2
    elseif gravity == "top" then
        gravity = 3
    elseif gravity == "bottom" then
        gravity = 4
    elseif gravity == "centerVertical" then
        gravity = 5
    end
    lib_listView.setGravity(self[0], gravity)
end

function This:setItemsMargin(margin)
    lib_listView.setItemsMargin(self[0], margin)
end

function This:setInnerContainerSize(width, height)
    lib_listView.setInnerContainerSize(self[0], width, height)
end

function This:getInnerContainerSize()
    return lib_listView.getInnerContainerSize(self[0])
end

function This:removeAllItems()
    lib_listView.removeAllItems(self[0])
end

function This:hasItems()
    return lib_listView.hasItems(self[0])
end

function This:removeLastItem()
    return lib_listView.removeLastItem(self[0])
end

function This:removeItem(index)
    lib_listView.removeItem(self[0], index)
end

function This:pushBackCustomItem(item, width, height, anchoY)
    anchoY = anchoY or 0.5
    self.m_itemWidth        = width
    self.m_itemHeight       = height
    local widget            = cc.Widget:create()
    widget:setCascadeOpacityEnabled(true)
    widget:addChild(item)
    item:setPosition(width / 2, height * anchoY)
    widget:setContentSize(width, height)
    lib_listView.pushBackCustomItem(self[0], widget[0])
    if not rawget(item, "notRunInitAction") then
        self:runInitAction(item)
    end
    return widget
end

function This:getInnerContainer()
    return castNode(lib_listView.getInnerContainer(self[0]))
end

function This:getInnerContainerSize()
    return lib_listView.getInnerContainerSize(self[0])
end

function This:jumpToTop()
    lib_listView.jumpToTop(self[0])
end

function This:jumpToBottom()
    lib_listView.jumpToBottom(self[0])
end

function This:scrollToBottom(time, attenuated)
    lib_listView.scrollToBottom(self[0], time, attenuated)
end

function This:scrollToTop(time, attenuated)
    lib_listView.scrollToTop(self[0], time, attenuated)
end

function This:addEventListener(listener)
    self.m_eventListener = listener
    lib_listView.addEventListener(self[0])
end

function This:getItemsMargin()
    return lib_listView.getItemsMargin(self[0])
end

function This:setBounceEnabled(isEnabled)
    return lib_listView.setBounceEnabled(self[0], isEnabled)
end

function This:setTouchEnabled(isEnabled)
    lib_listView.setTouchEnabled(self[0], isEnabled)
end

function This:isTouchEnabled()
    return lib_listView.isTouchEnabled(self[0])
end

function This:getItem(index)
    return castNode(lib_listView.getItem(self[0], index))
end

function This:getItemCount()
    return lib_listView.getItemCount(self[0])
end

function This:doLayout()
    lib_listView.doLayout(self[0])
end

function This:setShowIndex(index, direction)
    local innerContainer                = self:getInnerContainer()
    local innerWidth, innerHeight       = innerContainer:getContentSize()
    local width, height                 = self:getContentSize()
    local margin                        = self:getItemsMargin()

     if self:getDirection() == 1 then
        local startPos      = -innerHeight + height
        local desPos        = startPos + (index - 1) * (self.m_itemHeight + margin)
        if height >= innerHeight then
            return
        elseif desPos >= 0 then
            self:jumpToBottom()
        else
            innerContainer:setPosition(0, desPos)
        end
    else
        local startPos      = -innerWidth + width
        local desPos        = startPos + (index - 1) * (self.m_itemWidth + margin)
        if width >= innerWidth then
            return
        elseif desPos >= 0 then
            self:jumpToBottom()
        else
            innerContainer:setPosition(0, desPos)
        end
    end
end

function This:runInitAction(node)
    node:runActionByID("ListAppear", self:getItemCount() * 0.1)
    -- local index         = self:getItemCount()
    -- local dt            = 0.1
    -- local width, height = node:getContentSize()
    -- width               = width <= 0 and 50 or width
    -- height              = height <= 0 and 50 or height
    -- if self:getDirection() == 1 then
    --     width = 0
    -- else
    --     height = 0
    -- end
    -- local move_by1      = cc.MoveBy( dt * 0.25, -width* 0.25,  -height* 0.25)
    -- local move_by2      = cc.MoveBy( dt * 0.5, width * 0.5,  height* 0.5)
    -- local move_by3      = cc.MoveBy( dt * 0.25, -width* 0.25,  -height* 0.25)
    
    -- node:setOpacity(0)
    -- node:runAction(cc.Sequence(
    --                     cc.DelayTime(dt * index),
    --                     cc.Spawn(
    --                         cc.Sequence(
    --                             move_by1,
    --                             move_by2,
    --                             move_by3
    --                             ),
    --                          cc.FadeIn(dt * 3)
    --                         )
    --                     ))
end