local This, super = class(..., "cc.Node")
cc.LoopScrollMap = This

function This:init(templateNode, width)
    self.m_templateNode = templateNode
    self.m_visibleWidth = width or cc.visible.width
end

function This:onEnter()
    super.onEnter(self)
    self.m_count = 0
    local maxX = 0
    local nextX = 0
    local rect = self.m_templateNode:getWorldRect()
    self.m_worldScale = self:getWorldScale()
    local function addItemNode()
        local node =  self.m_templateNode
        if self.m_count > 0 then
            node = node:clone()
        end
        node.m_rect = cc.Rect(rect)
        maxX = rect:getMaxX() + nextX
        node:setPositionX(nextX)
        self:addChild(node)
        table.addNode(self, node)
        nextX = nextX + rect.width
    end
    while maxX < self.m_visibleWidth / self.m_worldScale and self.m_count < 20 do
        addItemNode()
    end
    addItemNode()
    self.m_createItemNode = nil
end

function This:update(deltaTime)
    local node = self.m_head
    if node then
        local leftX = node.m_rect.x + self:getPositionX() + node:getPositionX()
        local rightX = leftX + node.m_rect.width
        
        if rightX < 0 then
            local width = 0
            local nextNode = node
            while nextNode do
                width = width + nextNode.m_rect.width
                nextNode = nextNode.m_next
            end
            node:setPositionX(node:getPositionX() + width)
            table.moveToTail(self, node)
        end
    end
end
