local This = class(..., "cc.Node")
local lib_motionStreak = lib2d.ccMotionStreak
cc.MotionStreak = This

local WHITE = cc.Color.WHITE
local streakList = {
    [1] = {0.25, 5, 20, WHITE, "Images/BulletStreak.png"},
    [2] = {0.4, 10, 50, WHITE, "Images/BulletStreak.png"},
    [3] = {0.3, 15, 60, WHITE, "Images/BulletStreak.png"},
    [4] = {0.3, 10, 10, WHITE, "Images/BulletStreak2.png"},
    [5] = {0.8, 15, 40, WHITE, "Images/BulletStreak2.png"},
    [6] = {0.2, 20, 150, WHITE, "Images/BulletStreak2.png"},
    [7] = {0.25, 15, 80, WHITE, "Images/BulletStreak2.png"},
    [8] = {0.15, 10, 60, WHITE, "Images/BulletStreak2.png"},
    [9] = {0.15, 10, 30, WHITE, "Images/BulletStreak2.png"},
    [10] = {0.2, 15, 80, WHITE, "Images/BulletStreak3.png"},
    [11] = {0.4, 15, 80, WHITE, "Images/BulletStreak3.png"},
    [12] = {0.8, 30, 150, WHITE, "Images/BulletStreak3.png"},
    [13] = {0.3, 15, 60, WHITE, "Images/BulletStreak.png"},
    [14] = {0.5, 15, 40, WHITE, "Images/BulletStreak3.png"},
    [15] = {0.8, 20, 100, WHITE, "Images/BulletStreak3.png"},
    [101] = {0.3, 15, 60, WHITE, "Images/BulletStreak.png"},
    [102] = {0.3, 15, 60, WHITE, "Images/BulletStreak.png"},
    [103] = {0.3, 15, 60, WHITE, "Images/BulletStreak.png"},
    [104] = {0.3, 15, 60, WHITE, "Images/BulletStreak.png"},
}

local ccTextureCache = cc.TextureCache
function This:createNode(id, scale)
    scale = scale or 1
    local info = streakList[id]
    local color = info[4]
    local node = lib_motionStreak.create(info[1], info[2], info[3] * scale, color.r, color.g, color.b, ccTextureCache.m_images[info[5]])
    return node
end

function This:tintWithColor(color)
    lib_motionStreak.tintWithColor(self[0], color.r, color.g, color.b)
end

function This:setBlendFunc(src, dst)
    lib_motionStreak.setBlendFunc(self[0], src, dst)
end

local lib_reset = lib_motionStreak.reset
function This:reset()
    lib_reset(self[0])
end

function This:update(deltaTime)
    if deltaTime < 0.008 then
        deltaTime = 0.008
    end
    local lifeTime = self.m_lifeTime
    if lifeTime then
        lifeTime = lifeTime - deltaTime
        if lifeTime < 0 then
            lifeTime = 0
            self:removeFromParent()
            return
        end
        self.m_lifeTime = lifeTime
    end
    lib_motionStreak.update(self[0], deltaTime)
end