local This, super = class(..., "cc.Node")
cc.RenderTexture = This

local lib_RenderTexture = lib2d.ccRenderTexture

local lib_create = lib_RenderTexture.create
function This:createNode(width, height, stencil)
    return lib_create(width or cc.visible.width, height or cc.visible.height, 2, stencil)
end

function This:init(width, height)

end


local lib_beginRender = lib_RenderTexture.beginRender
function This:beginRender()
    lib_beginRender(self[0])
end

local lib_endRender = lib_RenderTexture.endRender
function This:endRender()
    lib_endRender(self[0])
end

function This:clear()
    lib_RenderTexture.clear(self[0],0,0,0,0)
end

local lib_getSprite = lib_RenderTexture.getSprite
function This:getSprite()
    return cc.Node.castNode(lib_getSprite(self[0]))
end

local lib_saveToFile = lib_RenderTexture.saveToFile
function This:saveToFile(name)
    lib_saveToFile(self[0], name)
end

function This:setShaderByID(shaderID)
    local sprite = self:getSprite()
    sprite:setShaderByID(shaderID)
    return sprite.m_shader
end