local This, super = class(..., "cc.Node")
cc.Scale9Sprite = This
local spriteFrameCache = require("cc.SpriteFrameCache")
local textureCache = require("cc.TextureCache")
local lib_scale9Sprite = lib2d.ccScale9Sprite
local Rect = cc.Rect
local lib_create = lib_scale9Sprite.create
local lib_createWithSpriteFrame = lib_scale9Sprite.createWithSpriteFrame

local ZERO_RECT = Rect()
function This:createNode(fileName, capInsets)    
    capInsets = capInsets or ZERO_RECT
    local frame = spriteFrameCache.m_frames[fileName]
    if frame then
        return lib_createWithSpriteFrame(frame, capInsets.x, capInsets.y, capInsets.width, capInsets.height)
    else
        local image = textureCache.m_images[fileName]
        return lib_create(fileName, capInsets.x, capInsets.y, capInsets.width, capInsets.height)
    end
end

function This:setCapInsets(x, y, width, height)
    lib_scale9Sprite.setCapInsets(self[0], x, y, width, height)
end

local lib_setFlippedX = lib_scale9Sprite.setFlippedX
function This:setFlippedX(isFlippedX)
    lib_setFlippedX(self[0], isFlippedX)
end