local This = class(...)
cc.SpriteFrameCache = This
local lib_spriteFrameCache = lib2d.ccSpriteFrameCache

function This:init()
    self[0] = lib_spriteFrameCache.getInstance()
    self.m_frames = {}
    setmetatable(self.m_frames, {
        __index = function (s, k)
            local frame = lib_spriteFrameCache.getSpriteFrame(self[0], k) or false
            s[k] = frame
            return frame
        end
    })
    self.m_plistFileList = {}
end

function This:addPlist(fileName)
    if self.m_plistFileList[fileName] then
        return
    end
    self.m_plistFileList[fileName] = true

    path = "Plist/" .. fileName .. ".plist"

    lib_spriteFrameCache.addSpriteFrames(self[0], path)
end

function This:addSpriteFrames(fileName)
    lib_spriteFrameCache.addSpriteFrames(self[0], fileName)
end

function This:removePlist(fileName)
    self.m_plistFileList[fileName] = nil

    path = "Plist/" .. fileName .. ".plist"
    
    local frameKeyList = lib_spriteFrameCache.removeSpriteFrames(self[0], path)
    if frameKeyList then
        for i = 1, #frameKeyList do
            self.m_frames[frameKeyList[i]] = nil
        end
    end
end

function This:removeAllPlist()
    for fileName,v in pairs(self.m_plistFileList) do
        self:removePlist(fileName)
    end
end

This:init()