local This = class(...)
cc.TextureCache = This
local lib_textureCache = lib2d.ccTextureCache

function This:init()
    self[0] = lib2d.ccDirector.getTextureCache(lib2d.ccDirector.getInstance())
    self.m_images = {}
    setmetatable(self.m_images, {
        __index = function (s, k)
            local image = lib_textureCache.addImage(self[0], k)
            -- print("addImage", k)
            s[k] = image
            return image
        end
    })
end

function This:removeUnusedTextures(unremoveList)
    local removeList = nil
    if unremoveList then
        local unremoves = {}
        for i = 1, #unremoveList do
            unremoves[unremoveList[i]] = 1
        end
        removeList = lib_textureCache.removeUnusedTextures(self[0], unremoves)
    else
        removeList = lib_textureCache.removeUnusedTextures(self[0])
    end
    
    if removeList then
        for i = 1, #removeList do
            self.m_images[removeList[i]] = nil
        end
    end
end

function This:getCachedInfo()
    return lib_textureCache.getCachedInfo(self[0])
end

function This:releaseImage(fileName)
    self.m_images[fileName] = nil
    lib_textureCache.releaseImage(self[0], fileName)
end

function This:releaseAllTextures()
    for k,v in pairs(self.m_images) do
        self.m_images[k] = nil
    end
    lib_textureCache.releaseAllTextures(self[0])
end

function This:addImage(key)
    return self.m_images[key]
end

This:init()