local This = class(...)
cc.TouchAllListener = This
local lib_touchAllListener = lib2d.ccTouchAllListener
local Vec = cc.Vec
local registry = cc.objectRegistry
local ccRegister = cc.registerObject


lib_touchAllListener.setCallback("OnBegan", function (this, touchList)
    local self = registry[this]
	local touchs = {}
	for key, var in ipairs(touchList) do
	    touchs[key] = {id = var[1], x = var[2], y=var[3],deltaX = var[4], deltaY=var[5]}
	end

    if g_scene.m_lockGuide <=0 and self.onBegan then
        self:onBegan(touchs)
    end
end)

lib_touchAllListener.setCallback("OnEnded", function (this, touchList)
    local self = registry[this]
	local touchs = {}
	for key, var in ipairs(touchList) do
	    touchs[key] = {id = var[1], x = var[2], y=var[3],deltaX = var[4], deltaY=var[5]}
	end
    if g_scene.m_lockGuide <=0 and self.onEnded then
        self:onEnded(touchs)
    end
end)

lib_touchAllListener.setCallback("OnMoved", function (this, touchList)
    local self = registry[this]
	local touchs = {}
	for key, var in ipairs(touchList) do
	    touchs[key] = {id = var[1], x = var[2], y=var[3],deltaX = var[4], deltaY=var[5]}
	end
    if g_scene.m_lockGuide <=0 and self.onMoved then
        self:onMoved(touchs)
    end
end)

function This:create(touch)
    local listener = lib_touchAllListener.create()
    listener = ccRegister(listener, nil, touch)
    return listener
end