local ccClippingNode = class("cc.ClippingNode", "cc.Node")
cc.ClippingNode = ccClippingNode

local lib_clippingNode_create = lib2d.ccClippingNode.create
function ccClippingNode:createNode(stencil)
    return lib_clippingNode_create(stencil[0])
end
local lib_clippingNode_setInverted = lib2d.ccClippingNode.setInverted
function ccClippingNode:setInverted(inverted)
    lib_clippingNode_setInverted(self[0], inverted)
end
local lib_clippingNode_setAlphaThreshold = lib2d.ccClippingNode.setAlphaThreshold
function ccClippingNode:setAlphaThreshold(clippingNode)
    lib_clippingNode_setAlphaThreshold(self[0], clippingNode)
end


local ccDrawNode = class("ccDrawNode", "cc.Node")
cc.DrawNode = ccDrawNode
local lib_drawNode_create = lib2d.ccDrawNode.create
function ccDrawNode:createNode()
    return lib_drawNode_create()
end
local lib_drawNode_drawSolidRect = lib2d.ccDrawNode.drawSolidRect
function ccDrawNode:drawSolidRect(rect, color)
    if not rect then
        return
    end
    color = color or cc.Color.WHITE
    lib_drawNode_drawSolidRect(self[0], rect.x, rect.y, rect.width, rect.height, color.r, color.g, color.b, color.a)
end

local lib_drawNode_drawLine = lib2d.ccDrawNode.drawLine
function ccDrawNode:drawLine(p1, p2, color)
    color = color or cc.Color.WHITE
    -- lib_drawNode_drawLine(self[0], p1.x, p1.y, p2.x, p2.y, color)
    lib_drawNode_drawLine(self[0], p1.x, p1.y, p2.x, p2.y, color.r,color.g,color.b,color.a)
end

local lib_drawNode_drawRect = lib2d.ccDrawNode.drawRect
function ccDrawNode:drawRect(rect, color)
    if not rect then
        return
    end
    color = color or cc.Color.WHITE
    lib_drawNode_drawRect(self[0], rect.x, rect.y, rect.width, rect.height, color.r, color.g, color.b, color.a)
end

local lib_drawNode_drawPoint = lib2d.ccDrawNode.drawPoint
function ccDrawNode:drawPoint(x, y, size, color)
    color = color or cc.Color.WHITE
    size = size or 5
    lib_drawNode_drawPoint(self[0], x, y, size, color.r, color.g, color.b, color.a)
end

local lib_drawNode_clear = lib2d.ccDrawNode.clear
function ccDrawNode:clear()
    lib_drawNode_clear(self[0])
end